<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205902825" sizeMeasure="13">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#xA;&#x9;public Tweet(TwitterAccount account, String string) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205940872" sizeMeasure="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public String getText() {&#xA;&#x9;&#x9;//returnerer teksten til en tweet&#xA;&#x9;&#x9;return &quot; &quot;;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="173" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206020127" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//en ny original tweet&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;//en retweet av tweet-argumentet &#xA;&#x9;&#x9;//utløser passende unntak hvis originaltweeten er fra samme konto" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="106" end="-91"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206069423" sizeMeasure="23" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;//returnerer kontoen som tweeten kom fra" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="378" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206144018" sizeMeasure="30" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;//returnerer originaltweeten hvis den er en retweet, ellers null&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="462" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206185059" sizeMeasure="35" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int getRetweetCount() {&#xA;&#x9;&#x9;//returnerer antall ganger tweeten har blitt retweetet&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="570" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206649780" sizeMeasure="37" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="664" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206741738" sizeMeasure="39" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private String tweetText;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="48" end="-673"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206761887" sizeMeasure="40" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetText) {&#xA;&#x9;&#x9;//en ny original tweet&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="123" end="-592"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206794244" sizeMeasure="40" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweetText = tweetTExt;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="163" end="-592"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206797012" sizeMeasure="40" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="e" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="186" end="-595"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206862740" sizeMeasure="40" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetText" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="430" end="-349"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206907428" sizeMeasure="41" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private int reTweetCount;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="77" end="-711"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206953255" sizeMeasure="42" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return reTweetCount;" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="755" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209164095" sizeMeasure="43" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;TwitterAccount(account)" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="220" end="-622"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209182828" sizeMeasure="42" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="220" end="-622"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209230200" sizeMeasure="42" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;//en retweet av tweet-argumentet &#xA;&#x9;&#x9;//utløser passende unntak hvis originaltweeten er fra samme konto&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;//returnerer teksten til en tweet&#xA;&#x9;&#x9;return tweetText;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;//returnerer kontoen som tweeten kom fra&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;//returnerer originaltweeten hvis den er en retweet, ellers null&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;//returnerer antall ganger tweeten har blitt retweetet&#xA;&#x9;&#x9;return reTweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Tweet tweet = new Tweet(Kari, &quot;hei&quot;);" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="220" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209234199" sizeMeasure="42" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="875" end="-876"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209303158" sizeMeasure="42" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Kari&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="850" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209346712" sizeMeasure="43" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="itterAccount account = new TwitterAccount(&quot;Kari&quot;);&#xA;&#x9;&#x9;Tweet tweet = new Tweet(account" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="828" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209382557" sizeMeasure="45" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(account);&#xA;&#x9;&#x9;System.out.println(tweet" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="923" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209468208" sizeMeasure="49" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String toString() {&#xA;&#x9;&#x9;return account.tweetTex" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="797" end="-220"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209496795" sizeMeasure="49" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="826" end="-228"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209519432" sizeMeasure="49" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="790" end="-260"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209549679" sizeMeasure="49" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String toString() {&#xA;&#x9;&#x9;return tweetText;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount account = new TwitterAccount(&quot;Kari&quot;);&#xA;&#x9;&#x9;Tweet tweet = new Tweet(account, &quot;hei&quot;);&#xA;&#x9;&#x9;System.out.println(account.getText()" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="790" end="-44"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209568138" sizeMeasure="49" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=");&#xA;&#x9;&#x9;System.out.println(tweet.getText()" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1003" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209606430" sizeMeasure="50" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;hei på du&quot; + tweet.getText());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1027" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209619458" sizeMeasure="50" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet1: " edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1028" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209639809" sizeMeasure="53" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount account = new TwitterAccount(&quot;per&quot;);&#xA;&#x9;&#x9;Tweet tweet = new Tweet(account, &quot;hei på du&quot;);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1060" end="-16"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209647273" sizeMeasure="53" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2 = new TwitterAccount(&quot;per&quot;);&#xA;&#x9;&#x9;Tweet tweet2" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1082" end="-54"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209681481" sizeMeasure="53" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;Tweet2: &quot; + tweet2.getText());" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1165" end="-16"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209752858" sizeMeasure="55" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount = null;&#xA;&#x9;private String tweetText;&#xA;&#x9;private int reTweetCount;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String tweetText) {&#xA;&#x9;&#x9;//en ny original tweet&#xA;&#x9;&#x9;this.tweetText = tweetText;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;//en retweet av tweet-argumentet &#xA;&#x9;&#x9;//utløser passende unntak hvis originaltweeten er fra samme konto&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;//returnerer teksten til en tweet&#xA;&#x9;&#x9;return tweetText;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;//returnerer kontoen som tweeten kom fra&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="59" end="-679"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209759093" sizeMeasure="55" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="74" end="-1206"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209842617" sizeMeasure="56" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String reTweetText," edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="126" end="-1165"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209844067" sizeMeasure="56" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="144" end="-1165"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209960698" sizeMeasure="58" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (tweet.getRetweetCount )&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;//returnerer antall ganger tweeten har blitt retweetet&#xA;&#x9;&#x9;return reTweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return tweetText;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount account = new TwitterAccount(&quot;Kari&quot;);&#xA;&#x9;&#x9;Tweet tweet = new Tweet(account, &quot;hei&quot;);&#xA;&#x9;&#x9;System.out.println(account);&#xA;&#x9;&#x9;System.out.println(&quot;Tweet1: &quot; + tweet.getText());&#xA;&#x9;&#x9;TwitterAccount account2 = new TwitterAccount(&quot;P" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="740" end="-124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210015315" sizeMeasure="58" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="631" end="-712"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210144327" sizeMeasure="58" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Owner" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1320" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210173619" sizeMeasure="59" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet tweet" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="99" end="-1257"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210227589" sizeMeasure="61" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="() > 2) {&#xA;&#x9;&#x9;&#x9;return tweet.getOwner();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="789" end="-576"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210236547" sizeMeasure="61" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return null;" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="833" end="-573"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210263329" sizeMeasure="61" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="81" end="-1330"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210271873" sizeMeasure="61" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="646" end="-765"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210443251" sizeMeasure="61" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="133" end="-1285"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210859559" sizeMeasure="61" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="648" end="-772"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210867157" sizeMeasure="61" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his." edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="545" end="-881"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210940257" sizeMeasure="62" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.account = accoun" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="306" end="-1128"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211037078" sizeMeasure="64" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if ()&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;//returnerer teksten til en tweet&#xA;&#x9;&#x9;return this.tweetText;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;//returnerer kontoen som tweeten kom fra&#xA;&#x9;&#x9;return this.account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;//returnerer originaltweeten hvis den er en retweet, ellers null&#xA;&#x9;&#x9;if (tweet.getRetweetCount() > 2) {&#xA;&#x9;&#x9;&#x9;return tweetTex" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="494" end="-605"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211242446" sizeMeasure="64" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="1470" end="-1471"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211269093" sizeMeasure="65" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(this.account)," edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="683" end="-791"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211271000" sizeMeasure="65" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="715" end="-791"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211324564" sizeMeasure="65" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner();" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="1494" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211344807" sizeMeasure="65" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="683" end="-841"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211405973" sizeMeasure="66" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(ccount.getUserName()" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="1515" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211410866" sizeMeasure="66" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="1535" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211429744" sizeMeasure="68" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(account2.getUserName());&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="1560" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211779212" sizeMeasure="68" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getText" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="901" end="-704"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211836634" sizeMeasure="68" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="133" end="-1478"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211854640" sizeMeasure="68" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="133" end="-1478"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212276845" sizeMeasure="70" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner == account) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="499" end="-1113"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212435811" sizeMeasure="70" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new IllegalArgumentException(&quot;It's your own tweet!&quot;);" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="531" end="-1117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212557311" sizeMeasure="70" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="accoun" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="499" end="-1204"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212592951" sizeMeasure="70" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="twee" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="499" end="-1204"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212635358" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="()" edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="513" end="-1194"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212700635" sizeMeasure="70" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.63/@edit" start="133" end="-1574"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212740217" sizeMeasure="70" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="reTweetText = this.tweet.getText();" edit="/1/@proposals.0/@proposals.0/@attempts.64/@edit" start="597" end="-1110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212915271" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//private String reTweetText;&#xA;&#x9;private int reTweetCount;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String tweetText) {&#xA;&#x9;&#x9;//en ny original tweet&#xA;&#x9;&#x9;this.tweetText = tweetText;&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;//en retweet av tweet-argumentet &#xA;&#x9;&#x9;//utløser passende unntak hvis originaltweeten er fra samme konto&#xA;&#x9;&#x9;if (tweet.getOwner() == account) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;It's your own tweet!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;t" edit="/1/@proposals.0/@proposals.0/@attempts.65/@edit" start="133" end="-1142"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212954812" sizeMeasure="71" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="reTweet;&#xA;&#x9;private String tweetText;&#xA;&#x9;//private String reTweetText;&#xA;&#x9;private int reTweetCount;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String tweetText) {&#xA;&#x9;&#x9;//en ny original tweet&#xA;&#x9;&#x9;this.tweetText = tweetText;&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;//en retweet av tweet-argumentet &#xA;&#x9;&#x9;//utløser passende unntak hvis originaltweeten er fra samme konto&#xA;&#x9;&#x9;if (tweet.getOwner() == account) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;It's your own tweet!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;tweetText = this.tweet.getText();&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.66/@edit" start="98" end="-1110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212961328" sizeMeasure="71" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="reT" edit="/1/@proposals.0/@proposals.0/@attempts.67/@edit" start="618" end="-1128"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212979512" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="reTweet.getRetweetCount() > 2) {&#xA;&#x9;&#x9;&#x9;return reT" edit="/1/@proposals.0/@proposals.0/@attempts.68/@edit" start="991" end="-716"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213022439" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.account = account;" edit="/1/@proposals.0/@proposals.0/@attempts.69/@edit" start="639" end="-1114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213209138" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.reTweet = twee" edit="/1/@proposals.0/@proposals.0/@attempts.70/@edit" start="664" end="-1116"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213284875" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.reTweet = tweet;&#xA;&#x9;&#x9;tweetText = this.reTweet.getText();&#xA;&#x9;&#x9;this.account = accoun" edit="/1/@proposals.0/@proposals.0/@attempts.71/@edit" start="602" end="-1116"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213330978" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;//returnerer teksten til en tweet&#xA;&#x9;&#x9;return this.tweetText;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;//returnerer kontoen som tweeten kom fra&#xA;&#x9;&#x9;//System.out.println(this.account);&#xA;&#x9;&#x9;return this.account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;//returnerer originaltweeten hvis den er en retweet, ellers null&#xA;&#x9;&#x9;if (reTweet.getRetweetCount() > 2) {&#xA;&#x9;&#x9;&#x9;return reTweet.getText();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;//returnerer antall ganger tweeten har blitt retweetet&#xA;&#x9;&#x9;return reTweetCount + 1" edit="/1/@proposals.0/@proposals.0/@attempts.72/@edit" start="688" end="-566"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213354271" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 1;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String tweetText) {&#xA;&#x9;&#x9;//en ny original tweet&#xA;&#x9;&#x9;this.tweetText = tweetText;&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;//en retweet av tweet-argumentet &#xA;&#x9;&#x9;//utløser passende unntak hvis originaltweeten er fra samme konto&#xA;&#x9;&#x9;if (tweet.getOwner() == account) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;It's your own tweet!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.reTweet = tweet;&#xA;&#x9;&#x9;tweetText = this.reTweet.getText();&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.73/@edit" start="190" end="-1121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213422631" sizeMeasure="74" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.reTweet.getReTweetCount();" edit="/1/@proposals.0/@proposals.0/@attempts.74/@edit" start="693" end="-1121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213430809" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="t" edit="/1/@proposals.0/@proposals.0/@attempts.75/@edit" start="711" end="-1133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213448294" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.76/@edit" start="726" end="-1118"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213513990" sizeMeasure="73" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="reTweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;//returnerer teksten til en tweet&#xA;&#x9;&#x9;return this.tweetText;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;//returnerer kontoen som tweeten kom fra&#xA;&#x9;&#x9;//System.out.println(this.account);&#xA;&#x9;&#x9;return this.account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;//returnerer originaltweeten hvis den er en retweet, ellers null&#xA;&#x9;&#x9;if (reTweet.getRetweetCount() > 2) {&#xA;&#x9;&#x9;&#x9;return reTweet.getText();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;//returnerer antall ganger tweeten har blitt retweetet&#xA;&#x9;&#x9;return reTweetCount" edit="/1/@proposals.0/@proposals.0/@attempts.77/@edit" start="706" end="-566"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213536324" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" += 1" edit="/1/@proposals.0/@proposals.0/@attempts.78/@edit" start="718" end="-1115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213540412" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.79/@edit" start="190" end="-1644"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213593216" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.80/@edit" start="1115" end="-702"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213615853" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.reTweet" edit="/1/@proposals.0/@proposals.0/@attempts.81/@edit" start="1115" end="-702"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213710786" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.reTweet" edit="/1/@proposals.0/@proposals.0/@attempts.82/@edit" start="1068" end="-683"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213758298" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.83/@edit" start="135" end="-1615"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229432981" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#x9;&#xA;&#x9;private TwitterAccount account;&#xA;&#x9;private Tweet reTweet;&#xA;&#x9;private String t" edit="/1/@proposals.0/@proposals.0/@attempts.84/@edit" end="-1615"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286389240" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0" edit="/1/@proposals.0/@proposals.0/@attempts.85/@edit" start="160" end="-1580"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488287707483" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.86/@edit" start="160" end="-1580"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206410679" sizeMeasure="9">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206556087" sizeMeasure="11" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate String username;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="60" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206588449" sizeMeasure="11" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.username = name;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="126" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488209288206" sizeMeasure="14" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount account = new TwitterAccount(&quot;Kari&quot;);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="153" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211181433" sizeMeasure="18" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String getUserName() {&#xA;&#x9;&#x9;return user" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="161" end="-114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214625214" sizeMeasure="34" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// slutt å følge account&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om denne kontoen følger account&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om account følger denne kontoen" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="216" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214657890" sizeMeasure="39" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void tweet(Strig string) {&#xA;&#x9;&#x9;// lager en ny tweet for denne kontoen&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="612" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214755083" sizeMeasure="42" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;// retweet tweet fra denne kontoen&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="686" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214761799" sizeMeasure="42" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="n" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="627" end="-239"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214843420" sizeMeasure="48" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet getTweet(int i) {&#xA;&#x9;&#x9;// returnerer tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, rekke følge teller&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="772" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214882223" sizeMeasure="50" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int getTweetCount() {&#xA;&#x9;&#x9;// returner antall tweets til kontoen&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="893" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214921494" sizeMeasure="54" errorCount="5" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int getRetweetCount() {&#xA;&#x9;&#x9;// returner antall retweets av tweets fra denne" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="975" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488228191700" sizeMeasure="59" errorCount="5" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Collection:&#xA;&#x9;// int size() - returns the number of elements in the collection&#xA;&#x9;// boolean contains(Objekt obj) - true if the object is an element of the collection&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="59" end="-1108"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488228594819" sizeMeasure="61" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;private List&lt;> follow = new ArrayList&lt;>();" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="226" end="-1110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488228626617" sizeMeasure="61" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount> follow = new ArrayList&lt;TwitterAccount" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="243" end="-1114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488228642566" sizeMeasure="64" errorCount="6" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="27" end="-1386"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488228682959" sizeMeasure="64" errorCount="6" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// liste med hvem som følger en konto" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="280" end="-1182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488228696761" sizeMeasure="64" errorCount="6" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", size() gir antall følgere" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="317" end="-1182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488228740073" sizeMeasure="64" errorCount="6" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ers" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="381" end="-1145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488228804339" sizeMeasure="66" errorCount="6" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;followers.add(account);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="669" end="-862"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229004777" sizeMeasure="67" errorCount="6" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;followers.remove(account);" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="778" end="-782"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229144156" sizeMeasure="68" errorCount="5" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return followers.contains(account);" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="914" end="-675"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229196336" sizeMeasure="71" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// liste med hvilke kontoer en account følger&#xA;&#x9;private List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="421" end="-1206"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229199810" sizeMeasure="71" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="503" end="-1242"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229423958" sizeMeasure="71" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="1744" end="-1745"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229428751" sizeMeasure="71" errorCount="8" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//private List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;// liste med hvilke kontoer en account følger&#xA;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="346" end="-1277"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229441144" sizeMeasure="71" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="346" end="-1401"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229445039" sizeMeasure="71" errorCount="4" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="468" end="-1277"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229493296" sizeMeasure="71" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="804" end="-941"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229502445" sizeMeasure="71" errorCount="4" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="808" end="-934"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488229543396" sizeMeasure="71" errorCount="4" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // legger til kontoen i followers-listen" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="810" end="-932"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488230054951" sizeMeasure="72" errorCount="4" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int tweetCount ;&#xA;&#x9;private String username;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;followers.add(this); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// slutt å følge account&#xA;&#x9;&#x9;followers.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om denne kontoen følger account&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om account følger denne kontoen&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String string) {&#xA;&#x9;&#x9;// lager en ny tweet for denne kontoen&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="541" end="-485"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488230112946" sizeMeasure="72" errorCount="5" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweet.tweetCount += 1;" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="1325" end="-485"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488230137793" sizeMeasure="72" errorCount="5" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="accoun" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1330" end="-503"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488230203713" sizeMeasure="72" errorCount="5" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getOwner()" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1330" end="-502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488230221741" sizeMeasure="72" errorCount="4" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="1330" end="-502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488230268668" sizeMeasure="73" errorCount="4" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private TwitterAccount account;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;followers.add(this); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// slutt å følge account&#xA;&#x9;&#x9;followers.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om denne kontoen følger account&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om account følger denne kontoen&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String string) {&#xA;&#x9;&#x9;// lager en ny tweet for denne kontoen&#xA;&#x9;&#x9;this" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="593" end="-502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282375643" sizeMeasure="73" errorCount="4" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="mainA" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="616" end="-1247"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282489016" sizeMeasure="76" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private List&lt;TwitterAccount> tweets = new ArrayList&lt;TwitterAccount>();&#xA;&#xA;&#xA;&#x9;private int tweetCount ;&#xA;&#x9;private String username;&#xA;&#x9;private TwitterAccount mainAccount;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;followers.add(this); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// slutt å følge account&#xA;&#x9;&#x9;followers.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om denne kontoen følger account&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om account følger denne kontoen&#xA;&#x9;&#x9;return follow.mainAccount" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="539" end="-591"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282512670" sizeMeasure="76" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="540" end="-1429"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282575429" sizeMeasure="76" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="1362" end="-591"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282735430" sizeMeasure="76" errorCount="3" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="follow.contains(account);" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="1362" end="-591"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282829609" sizeMeasure="76" errorCount="3" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ers" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="1368" end="-610"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282837802" sizeMeasure="76" errorCount="3" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="468" end="-1513"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282918957" sizeMeasure="77" errorCount="4" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweet.Tweet(account, tweet);" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="1578" end="-407"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282934465" sizeMeasure="77" errorCount="4" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="mainA" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="1591" end="-422"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282997259" sizeMeasure="77" errorCount="3" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new " edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="1579" end="-433"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283189469" sizeMeasure="78" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return mainAccount.tweetCount;" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="1814" end="-204"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283263263" sizeMeasure="79" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Tweet twee" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="707" end="-1346"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283272428" sizeMeasure="79" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet = " edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="1601" end="-470"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283298271" sizeMeasure="79" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="542" end="-1535"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283333189" sizeMeasure="80" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweet = new Tweet(mainAccount, tweet)" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="1520" end="-560"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283365071" sizeMeasure="80" errorCount="3" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="1557" end="-561"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283370372" sizeMeasure="80" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;tweetString&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="1552" end="-561"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283416109" sizeMeasure="81" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweets.add(tweet" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="1569" end="-561"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283617594" sizeMeasure="81" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="eets> tweets = new ArrayList&lt;Tweets" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="557" end="-1539"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283626971" sizeMeasure="81" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="> tweets = new ArrayList&lt;Tweet" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="560" end="-1539"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283706661" sizeMeasure="82" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return tweets.get(i);" edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="1819" end="-312"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283788781" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return tweet.getRetweetCount();" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="2046" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283870288" sizeMeasure="84" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.mainAccount = use" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="773" end="-1421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283875725" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="773" end="-1416"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283877060" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="773" end="-1416"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283942168" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= 0;&#xA;&#x9;private String username;&#xA;&#x9;private TwitterAccount mainAccount;&#xA;&#x9;private Tweet tweet;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="621" end="-1416"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283978138" sizeMeasure="83" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tww" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="1929" end="-246"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283987868" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="e" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="1931" end="-246"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283997856" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his." edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="1930" end="-249"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284039977" sizeMeasure="83" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="follow.add(this);" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="997" end="-1186"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284053339" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="468" end="-1730"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284068083" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;follow" edit="/1/@proposals.0/@proposals.1/@attempts.67/@edit" start="1123" end="-1094"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284117211" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.68/@edit" start="1882" end="-342"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284124352" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.69/@edit" start="1882" end="-342"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284167364" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(1/i)" edit="/1/@proposals.0/@proposals.1/@attempts.70/@edit" start="1882" end="-341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284186052" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="i" edit="/1/@proposals.0/@proposals.1/@attempts.71/@edit" start="1882" end="-341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284277598" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!" edit="/1/@proposals.0/@proposals.1/@attempts.72/@edit" start="1861" end="-363"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284501558" sizeMeasure="85" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweets.reverse();" edit="/1/@proposals.0/@proposals.1/@attempts.73/@edit" start="1865" end="-363"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284594812" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.74/@edit" start="1865" end="-363"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284802407" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweets.size() - 1" edit="/1/@proposals.0/@proposals.1/@attempts.75/@edit" start="1886" end="-341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284823507" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="i" edit="/1/@proposals.0/@proposals.1/@attempts.76/@edit" start="1902" end="-341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284860674" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.77/@edit" start="1865" end="-379"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284921204" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="string);&#xA;&#x9;&#x9;tweets.add(tweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;// retweet tweet fra denne kontoen&#xA;&#x9;&#x9;tweet = new Tweet(mainAccount, tweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;// returnerer tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, rekke følge teller!" edit="/1/@proposals.0/@proposals.1/@attempts.78/@edit" start="1578" end="-379"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488284931771" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetString) {&#xA;&#x9;&#x9;// lager en ny tweet for denne kontoen&#xA;&#x9;&#x9;this.tweetCount += 1;&#xA;&#x9;&#x9;tweet = new Tweet(mainAccount, tweetS" edit="/1/@proposals.0/@proposals.1/@attempts.79/@edit" start="1470" end="-655"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285037384" sizeMeasure="84" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="username" edit="/1/@proposals.0/@proposals.1/@attempts.80/@edit" start="1570" end="-663"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285104989" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.1/@attempts.81/@edit" start="1570" end="-663"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285518001" sizeMeasure="90" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tCount = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; tweets.size(); i++) {&#xA;&#x9;&#x9;&#x9;if ()&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.82/@edit" start="2098" end="-143"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285521993" sizeMeasure="90" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int " edit="/1/@proposals.0/@proposals.1/@attempts.83/@edit" start="2097" end="-217"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285584468" sizeMeasure="90" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweets.get(i)." edit="/1/@proposals.0/@proposals.1/@attempts.84/@edit" start="2164" end="-154"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285656196" sizeMeasure="92" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getRetweetCount() > 0) {&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.85/@edit" start="2178" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285679287" sizeMeasure="92" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rtCount += tweets.get(i).getRetweetCount();" edit="/1/@proposals.0/@proposals.1/@attempts.86/@edit" start="2207" end="-158"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285701417" sizeMeasure="90" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return rtCount" edit="/1/@proposals.0/@proposals.1/@attempts.87/@edit" start="2262" end="-110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285836234" sizeMeasure="90" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weets.size()" edit="/1/@proposals.0/@proposals.1/@attempts.88/@edit" start="1984" end="-388"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285919186" sizeMeasure="91" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(tweets.get(tweets.size() - i));" edit="/1/@proposals.0/@proposals.1/@attempts.89/@edit" start="1861" end="-526"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285965689" sizeMeasure="92" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Tweet tweet = new Tweet(account, &quot;heihe" edit="/1/@proposals.0/@proposals.1/@attempts.90/@edit" start="2432" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285989058" sizeMeasure="93" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;account.getTweet(i" edit="/1/@proposals.0/@proposals.1/@attempts.91/@edit" start="2478" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488285993142" sizeMeasure="93" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.92/@edit" start="2496" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286035252" sizeMeasure="93" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(i + 1)" edit="/1/@proposals.0/@proposals.1/@attempts.93/@edit" start="1948" end="-557"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286070916" sizeMeasure="93" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(i + 1" edit="/1/@proposals.0/@proposals.1/@attempts.94/@edit" start="1907" end="-604"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286077804" sizeMeasure="93" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.95/@edit" start="1915" end="-604"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286095141" sizeMeasure="93" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="- 1" edit="/1/@proposals.0/@proposals.1/@attempts.96/@edit" start="1910" end="-605"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286097242" sizeMeasure="93" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.97/@edit" start="1957" end="-560"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286159971" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.tweet(&quot;heihei&quot;);&#xA;&#x9;&#x9;account.tweet(&quot;pånigjen" edit="/1/@proposals.0/@proposals.1/@attempts.98/@edit" start="2445" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286192130" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.99/@edit" start="1909" end="-615"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286228500" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.100/@edit" start="1952" end="-568"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488286286061" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.101/@edit" start="2510" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488350362403" sizeMeasure="95" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(followers.contains(account));" edit="/1/@proposals.0/@proposals.1/@attempts.102/@edit" start="1257" end="-1266"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488350403802" sizeMeasure="96" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount account2 = new TwitterAccount(&quot;Per" edit="/1/@proposals.0/@proposals.1/@attempts.103/@edit" start="2488" end="-89"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488350434347" sizeMeasure="97" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;account.follow(&quot;Per&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.104/@edit" start="2621" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488350452828" sizeMeasure="97" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account2" edit="/1/@proposals.0/@proposals.1/@attempts.105/@edit" start="2637" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488350476697" sizeMeasure="98" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;account2.isFollowing(account" edit="/1/@proposals.0/@proposals.1/@attempts.106/@edit" start="2649" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488350710550" sizeMeasure="98" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.1/@attempts.107/@edit" start="1760" end="-916"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351146797" sizeMeasure="102" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="try {&#xA;&#x9;&#x9;&#x9;account.tweet(&quot;pånigjen&quot;);&#xA;&#x9;&#x9;} catch (Excetion e) {&#xA;&#x9;&#x9;&#x9;System.out.println(e);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.108/@edit" start="2563" end="-91"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351161495" sizeMeasure="102" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p" edit="/1/@proposals.0/@proposals.1/@attempts.109/@edit" start="2614" end="-130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351476769" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.tweet(&quot;pånigjen&quot;);&#xA;&#x9;&#x9;account2.tweet(&quot;nigjen" edit="/1/@proposals.0/@proposals.1/@attempts.110/@edit" start="2563" end="-188"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351617514" sizeMeasure="121" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="try {&#xA;&#x9;&#x9;&#x9;account.getTweet(2);&#xA;&#x9;&#x9;} catch (Exception e) {&#xA;&#x9;&#x9;&#x9;System.out.println(e);&#xA;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;try {&#xA;&#x9;&#x9;&#x9;account.follow(account2);&#xA;&#x9;&#x9;} catch (Exception e) {&#xA;&#x9;&#x9;&#x9;System.out.println(e);&#xA;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;try {&#xA;&#x9;&#x9;&#x9;account2.isFollowing(account);&#xA;&#x9;&#x9;} catch (Exception e) {&#xA;&#x9;&#x9;&#x9;System.out.println(e);&#xA;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.111/@edit" start="2714" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351638343" sizeMeasure="121" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.112/@edit" start="651" end="-2410"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351674503" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.113/@edit" start="2622" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351719068" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(account);&#xA;&#x9;&#x9;System.out.println(account2" edit="/1/@proposals.0/@proposals.1/@attempts.114/@edit" start="2622" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351734728" sizeMeasure="101" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Account1: &quot;account);&#xA;&#x9;&#x9;System.out.println(&quot;Account2: " edit="/1/@proposals.0/@proposals.1/@attempts.115/@edit" start="2641" end="-81"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351739885" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + account);&#xA;&#x9;&#x9;System.out.println(&quot;Account2: &quot; +" edit="/1/@proposals.0/@proposals.1/@attempts.116/@edit" start="2653" end="-82"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488351853004" sizeMeasure="104" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;System.out.println(tweets);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.117/@edit" start="2778" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352029154" sizeMeasure="104" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.118/@edit" start="2818" end="-2819"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352053031" sizeMeasure="104" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ublic List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;// liste med hvilke kontoer en account følger&#xA;&#x9;public List&lt;TwitterAccount> follow = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;public List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#xA;&#xA;&#x9;private int tweetCount = 0;&#xA;&#x9;private String username;&#xA;&#x9;//private TwitterAccount mainAccount;&#xA;&#x9;private Tweet tweet;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;followers.add(this); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;follow.add(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// slutt å følge account&#xA;&#x9;&#x9;followers.remove(account);&#xA;&#x9;&#x9;follow.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om denne kontoen følger account&#xA;&#x9;&#x9;System.out.println(followers.contains(account));&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om account følger denne kontoen&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String tweetString) {&#xA;&#x9;&#x9;// lager en ny tweet for denne kontoen&#xA;&#x9;&#x9;this.tweetCount += 1;&#xA;&#x9;&#x9;tweet = new Tweet(this, tweetString);&#xA;&#x9;&#x9;tweets.add(tweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;// retweet tweet fra denne kontoen&#xA;&#x9;&#x9;tweet = new Tweet(this, tweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;// returnerer tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, rekke følge teller!&#xA;&#x9;&#x9;System.out.println(tweets.get(tweets.size() - (i)));&#xA;&#x9;&#x9;return tweets.get(tweets.size() - (i));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;// returner antall tweets til kontoen&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;// returner antall retweets av tweets fra denne kontoen&#xA;&#x9;&#x9;int rtCount = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; tweets.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (tweets.get(i).getRetweetCount() > 0) {&#xA;&#x9;&#x9;&#x9;&#x9;rtCount += tweets.get(i).getRetweetCount();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return rtCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount account = new TwitterAccount(&quot;Kari&quot;);&#xA;&#x9;&#x9;TwitterAccount account2 = new TwitterAccount(&quot;Per&quot;);&#xA;&#x9;&#x9;account.tweet(&quot;heihei&quot;);&#xA;&#x9;&#x9;account.tweet(&quot;pånigjen&quot;);&#xA;&#x9;&#x9;account2.tweet(&quot;nigjen&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Account1: &quot; + account);&#xA;&#x9;&#x9;System.out.println(&quot;Account2: &quot; + account2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;account.follow(account2);&#xA;&#x9;&#x9;account2.isFollowing(account);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(follow" edit="/1/@proposals.0/@proposals.1/@attempts.119/@edit" start="347" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352076558" sizeMeasure="104" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;// liste med hvilke kontoer en account følger&#xA;&#x9;private List&lt;TwitterAccount> follow = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private" edit="/1/@proposals.0/@proposals.1/@attempts.120/@edit" start="347" end="-2272"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352094579" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.121/@edit" start="2782" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352117647" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//account.follow(account2);&#xA;&#x9;&#x9;//account2.isFollowing(account);" edit="/1/@proposals.0/@proposals.1/@attempts.122/@edit" start="2718" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352124753" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.123/@edit" start="2718" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352132574" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.124/@edit" start="2746" end="-43"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352135507" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.125/@edit" start="2718" end="-71"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352163558" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this));&#xA;&#x9;&#x9;return followers.contains(this" edit="/1/@proposals.0/@proposals.1/@attempts.126/@edit" start="1297" end="-1448"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352181033" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account));&#xA;&#x9;&#x9;return followers.contains(account" edit="/1/@proposals.0/@proposals.1/@attempts.127/@edit" start="1297" end="-1448"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352219568" sizeMeasure="103" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="static List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;// liste med hvilke kontoer en account følger&#xA;&#x9;private List&lt;TwitterAccount> follow = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#xA;&#xA;&#x9;private int tweetCount = 0;&#xA;&#x9;private String username;&#xA;&#x9;//private TwitterAccount mainAccount;&#xA;&#x9;private Tweet tweet;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;followers.add(this); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;follow.add(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// slutt å følge account&#xA;&#x9;&#x9;followers.remove(account);&#xA;&#x9;&#x9;follow.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om denne kontoen følger account&#xA;&#x9;&#x9;System.out.println(followers.contains(account));&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om account følger denne kontoen&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String tweetString) {&#xA;&#x9;&#x9;// lager en ny tweet for denne kontoen&#xA;&#x9;&#x9;this.tweetCount += 1;&#xA;&#x9;&#x9;tweet = new Tweet(this, tweetString);&#xA;&#x9;&#x9;tweets.add(tweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;// retweet tweet fra denne kontoen&#xA;&#x9;&#x9;tweet = new Tweet(this, tweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;// returnerer tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, rekke følge teller!&#xA;&#x9;&#x9;System.out.println(tweets.get(tweets.size() - (i)));&#xA;&#x9;&#x9;return tweets.get(tweets.size() - (i));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;// returner antall tweets til kontoen&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;// returner antall retweets av tweets fra denne kontoen&#xA;&#x9;&#x9;int rtCount = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; tweets.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (tweets.get(i).getRetweetCount() > 0) {&#xA;&#x9;&#x9;&#x9;&#x9;rtCount += tweets.get(i).getRetweetCount();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return rtCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount account = new TwitterAccount(&quot;Kari&quot;);&#xA;&#x9;&#x9;TwitterAccount account2 = new TwitterAccount(&quot;Per&quot;);&#xA;&#x9;&#x9;account.tweet(&quot;heihei&quot;);&#xA;&#x9;&#x9;account.tweet(&quot;pånigjen&quot;);&#xA;&#x9;&#x9;account2.tweet(&quot;nigjen&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Account1: &quot; + account);&#xA;&#x9;&#x9;System.out.println(&quot;Account2: &quot; + account2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//account.follow(account2);&#xA;&#x9;&#x9;account2.isFollowing(account);&#xA;&#x9;&#x9;followers.add(&quot;Mia&quot;);" edit="/1/@proposals.0/@proposals.1/@attempts.128/@edit" start="354" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352232784" sizeMeasure="103" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.129/@edit" start="354" end="-2459"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352268584" sizeMeasure="103" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;// liste med hvilke kontoer en account følger&#xA;&#x9;private List&lt;TwitterAccount> follow = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#xA;&#xA;&#x9;private int tweetCount = 0;&#xA;&#x9;private String username;&#xA;&#x9;//private TwitterAccount mainAccount;&#xA;&#x9;private Tweet tweet;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;followers.add(account); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;follow.add(account" edit="/1/@proposals.0/@proposals.1/@attempts.130/@edit" start="354" end="-1800"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352438864" sizeMeasure="103" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account" edit="/1/@proposals.0/@proposals.1/@attempts.131/@edit" start="2787" end="-31"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352456146" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".followers.add(account2" edit="/1/@proposals.0/@proposals.1/@attempts.132/@edit" start="2794" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352470040" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(account.followers.add(account2)" edit="/1/@proposals.0/@proposals.1/@attempts.133/@edit" start="2787" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352543734" sizeMeasure="105" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount account3 = new TwitterAccount(&quot;Mia&quot;);&#xA;&#x9;&#x9;TwitterAccount account4 = new TwitterAccount(&quot;Lea" edit="/1/@proposals.0/@proposals.1/@attempts.134/@edit" start="2544" end="-311"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352575808" sizeMeasure="109" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(account.followers.add(account3));&#xA;&#x9;&#x9;System.out.println(account.followers.add(account4));&#xA;&#x9;&#x9;System.out.println(account2.followers.add(account4));&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.135/@edit" start="2952" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352600996" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;account2.isFollowing(account);&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.136/@edit" start="3116" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352615416" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.137/@edit" start="3111" end="-48"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352653954" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.followers.add(this); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;account.follow.add(this" edit="/1/@proposals.0/@proposals.1/@attempts.138/@edit" start="933" end="-2141"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352671472" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.followers.remove(this);&#xA;&#x9;&#x9;account.follow.remove(this" edit="/1/@proposals.0/@proposals.1/@attempts.139/@edit" start="1113" end="-2006"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352933877" sizeMeasure="113" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.follow(account2);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.140/@edit" start="2917" end="-265"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352954507" sizeMeasure="115" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account2.isFollowing(account);&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.141/@edit" start="2945" end="-268"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352972330" sizeMeasure="115" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.142/@edit" start="2884" end="-360"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488352996755" sizeMeasure="115" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;System.out.println(account.followers.add(account2));&#xA;//&#x9;&#x9;System.out.println(account.followers.add(account3));&#xA;//&#x9;&#x9;System.out.println(account.followers.add(account4));&#xA;//&#x9;&#x9;System.out.println(account2.followers.add(account));&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.143/@edit" start="2982" end="-44"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353007898" sizeMeasure="115" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.144/@edit" start="2947" end="-309"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353014659" sizeMeasure="115" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.145/@edit" start="2947" end="-309"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353031952" sizeMeasure="116" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;account.unfollow(account2" edit="/1/@proposals.0/@proposals.1/@attempts.146/@edit" start="2978" end="-281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353039371" sizeMeasure="117" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;account2.isFollowing(account" edit="/1/@proposals.0/@proposals.1/@attempts.147/@edit" start="3008" end="-281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353067897" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="isFollowing(account2" edit="/1/@proposals.0/@proposals.1/@attempts.148/@edit" start="2988" end="-344"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353146464" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.followers.add(account); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;this.follow.add(account" edit="/1/@proposals.0/@proposals.1/@attempts.149/@edit" start="933" end="-2324"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353201879" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.followers.add(this); // legger til kontoen i followers-listen&#xA;&#x9;&#x9;account.follow.add(this" edit="/1/@proposals.0/@proposals.1/@attempts.150/@edit" start="933" end="-2324"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353218516" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(account) i followers-listen til this" edit="/1/@proposals.0/@proposals.1/@attempts.151/@edit" start="984" end="-2350"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353250041" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this) i followers-listen til account" edit="/1/@proposals.0/@proposals.1/@attempts.152/@edit" start="985" end="-2350"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353341262" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.153/@edit" start="1368" end="-2000"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353360665" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.154/@edit" start="1329" end="-2036"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353609998" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.155/@edit" start="1024" end="-2341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353613196" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.156/@edit" start="1168" end="-2199"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353623085" sizeMeasure="118" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.157/@edit" start="468" end="-2901"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353637750" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ers.contains(account));&#xA;&#x9;&#x9;return followers" edit="/1/@proposals.0/@proposals.1/@attempts.158/@edit" start="1335" end="-2000"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353684523" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.1/@attempts.159/@edit" start="1514" end="-1863"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353707708" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.followers.contains(account));&#xA;&#x9;&#x9;return this." edit="/1/@proposals.0/@proposals.1/@attempts.160/@edit" start="1329" end="-2014"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353763395" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;account.tweet(&quot;heihei&quot;);&#xA;//&#x9;&#x9;account.tweet(&quot;pånigjen&quot;);&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.161/@edit" start="2712" end="-624"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353777310" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;System.out.println(&quot;Account1: &quot; + account);&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.162/@edit" start="2802" end="-550"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353797433" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.follow(account2);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.163/@edit" start="2904" end="-466"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354119320" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private List&lt;TwitterAccount> follow = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#xA;&#xA;&#x9;private int tweetCount = 0;&#xA;&#x9;private String username;&#xA;&#x9;//private TwitterAccount mainAccount;&#xA;&#x9;private Tweet tweet;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;account.followers.add(this); // legger til kontoen (this) i followers-listen til account&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.164/@edit" start="468" end="-2370"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354209017" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.follow.add(account" edit="/1/@proposals.0/@proposals.1/@attempts.165/@edit" start="1024" end="-2347"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354248158" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="  //legger til account i follow-listen til (this)" edit="/1/@proposals.0/@proposals.1/@attempts.166/@edit" start="1049" end="-2345"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354269027" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.follow.remove(account" edit="/1/@proposals.0/@proposals.1/@attempts.167/@edit" start="1215" end="-2200"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354347124" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="  //" edit="/1/@proposals.0/@proposals.1/@attempts.168/@edit" start="1212" end="-2229"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354407643" sizeMeasure="118" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" fjerner (this) fra account sin followers-liste&#xA;&#x9;&#x9;this.follow.remove(account);  // fjerner account fra (this) sin follow-liste" edit="/1/@proposals.0/@proposals.1/@attempts.169/@edit" start="1216" end="-2198"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354491060" sizeMeasure="119" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// er account i this sin follow-liste?" edit="/1/@proposals.0/@proposals.1/@attempts.170/@edit" start="1508" end="-2035"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354529611" sizeMeasure="119" errorCount="8" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;// liste med hvilke kontoer en account følger&#xA;&#x9;private List&lt;TwitterAccount> followList = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#xA;&#xA;&#x9;private int tweetCount = 0;&#xA;&#x9;private String username;&#xA;&#x9;//private TwitterAccount mainAccount;&#xA;&#x9;private Tweet tweet;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.username = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;// denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;account.followers.add(this); // legger til kontoen (this) i followers-listen til account&#xA;&#x9;&#x9;this.follow.add(account);  //legger til account i follow-listen til (this)&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// slutt å følge account&#xA;&#x9;&#x9;account.followers.remove(this);  // fjerner (this) fra account sin followers-liste&#xA;&#x9;&#x9;this.follow.remove(account);  // fjerner account fra (this) sin follow-liste&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om denne kontoen følger account&#xA;&#x9;&#x9;System.out.println(this.followers.contains(account));&#xA;&#x9;&#x9;// er account i this sin follow-liste?&#xA;&#x9;&#x9;return this.follow." edit="/1/@proposals.0/@proposals.1/@attempts.171/@edit" start="384" end="-1992"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354546462" sizeMeasure="119" errorCount="4" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List.add(this); // legger til kontoen (this) i followers-listen til account&#xA;&#x9;&#x9;this.followList.add(account);  //legger til account i follow-listen til (this)&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// slutt å følge account&#xA;&#x9;&#x9;account.followersList.remove(this);  // fjerner (this) fra account sin followers-liste&#xA;&#x9;&#x9;this.followList" edit="/1/@proposals.0/@proposals.1/@attempts.172/@edit" start="958" end="-2283"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354562235" sizeMeasure="119" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List.contains(account));&#xA;&#x9;&#x9;// er account i this sin follow-liste?&#xA;&#x9;&#x9;return this.followList.&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;// returnerer om account følger denne kontoen&#xA;&#x9;&#x9;return this.followersList" edit="/1/@proposals.0/@proposals.1/@attempts.173/@edit" start="1509" end="-1860"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354574893" sizeMeasure="119" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="contains(account);" edit="/1/@proposals.0/@proposals.1/@attempts.174/@edit" start="1600" end="-1996"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354619737" sizeMeasure="119" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.175/@edit" start="1476" end="-2138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354721911" sizeMeasure="119" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.176/@edit" start="626" end="-2986"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354781653" sizeMeasure="119" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.177/@edit" start="1505" end="-2105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354784794" sizeMeasure="119" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.178/@edit" start="1472" end="-2136"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354798009" sizeMeasure="119" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.179/@edit" start="1502" end="-2105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354842191" sizeMeasure="119" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".isFollowing(account2" edit="/1/@proposals.0/@proposals.1/@attempts.180/@edit" start="3209" end="-377"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488355031486" sizeMeasure="122" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;if (!account.followersList.contains(this))&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.181/@edit" start="1112" end="-2497"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488355050897" sizeMeasure="122" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; !this.followList.contains(account" edit="/1/@proposals.0/@proposals.1/@attempts.182/@edit" start="1157" end="-2502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488355069166" sizeMeasure="125" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#x9;&#x9;&#x9;account.followersList.add(this);&#xA;&#x9;&#x9;&#x9;this.followList.add(account);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.183/@edit" start="1196" end="-2500"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488355075564" sizeMeasure="125" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;account.followersList.add(this); // legger til kontoen (this) i followers-listen til account&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.184/@edit" start="935" end="-2741"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488355116492" sizeMeasure="128" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;if (account.followersList.contains(this) &amp;&amp; this.followList.contains(account))&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.185/@edit" start="1532" end="-2245"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488355131254" sizeMeasure="131" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#x9;&#x9;&#x9;account.followersList.remove(this);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.186/@edit" start="1614" end="-2248"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488355137862" sizeMeasure="131" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;account.followersList.remove(this);  // fjerner (this) fra account sin followers-liste&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.187/@edit" start="1359" end="-2463"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488209392500" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488209524967" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488209574682" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488209684836" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488210148996" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488211274065" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488211328648" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488211414277" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488211437396" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488286000943" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488286045303" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488286083658" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488286101226" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488286164820" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488286202147" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488286233036" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488286290908" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488350484332" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488350603969" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488350640026" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488350739729" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488350848374" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488351165047" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488351393187" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488351399090" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488351488380" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488351621440" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488351679581" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352096815" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352119497" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352127921" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352138625" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352166829" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352271309" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352473963" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352580444" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352603393" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352618507" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352673848" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352733381" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352956284" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488352976697" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353000493" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353009903" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353042945" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353071448" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353149585" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353272416" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353344041" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353362747" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353402546" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353460871" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353556116" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353645150" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353689892" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354211387" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354577755" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354623330" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354724230" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354786383" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354799747" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354844120" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354924802" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488355080201" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488355141103" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488355163120" mode="debug"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488209979278" completion="0.0" failureCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210020511" completion="0.0" failureCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488212765459" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488213143257" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488213234545" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488213300584" completion="0.5" successCount="2" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488213573014" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488213656079" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488213720589" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488350144908" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="0.5">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488229748370" completion="0.0" failureCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282314193" completion="0.0" failureCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282743271" completion="0.0" failureCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282844823" completion="0.0" failureCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488283103401" completion="0.0" failureCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488283377523" completion="0.0" failureCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488283793737" completion="0.16666666666666666" successCount="1" failureCount="2" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488283947662" completion="0.16666666666666666" successCount="1" failureCount="2" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488283992439" completion="0.3333333333333333" successCount="2" failureCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488284002158" completion="0.3333333333333333" successCount="2" failureCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488284074762" completion="0.3333333333333333" successCount="2" failureCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488284174741" completion="0.16666666666666666" successCount="1" failureCount="3" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488284194597" completion="0.3333333333333333" successCount="2" failureCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488284810952" completion="0.16666666666666666" successCount="1" failureCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488284838261" completion="0.3333333333333333" successCount="2" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488284937175" completion="0.5" successCount="3" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488285135747" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488285705413" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488285841270" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488286297769" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488286394952" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488287713467" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488350240561" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488353718855" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488353767193" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488353781029" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488353809231" completion="0.5" successCount="3" failureCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="7">
        <attempts timestamp="1488350656319"/>
        <attempts timestamp="1488351291890"/>
        <attempts timestamp="1488351299879"/>
        <attempts timestamp="1488351308045"/>
        <attempts timestamp="1488351310531"/>
        <attempts timestamp="1488351373858"/>
        <attempts timestamp="1488351375425"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="8">
        <attempts timestamp="1488351228073"/>
        <attempts timestamp="1488351251517"/>
        <attempts timestamp="1488351255051"/>
        <attempts timestamp="1488351257528"/>
        <attempts timestamp="1488351259462"/>
        <attempts timestamp="1488351266250"/>
        <attempts timestamp="1488351279579"/>
        <attempts timestamp="1488351380631"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="16">
        <attempts timestamp="1488350558212"/>
        <attempts timestamp="1488350576737"/>
        <attempts timestamp="1488350662611"/>
        <attempts timestamp="1488350758999"/>
        <attempts timestamp="1488350772878"/>
        <attempts timestamp="1488351314500"/>
        <attempts timestamp="1488351407057"/>
        <attempts timestamp="1488352738408"/>
        <attempts timestamp="1488352759072"/>
        <attempts timestamp="1488352858356"/>
        <attempts timestamp="1488353416444"/>
        <attempts timestamp="1488353439539"/>
        <attempts timestamp="1488353471524"/>
        <attempts timestamp="1488353569373"/>
        <attempts timestamp="1488354943763"/>
        <attempts timestamp="1488355182367"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
