<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487418597331" sizeMeasure="67">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;&#xA;public class Person {&#xA;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person father;&#xA;&#x9;private Person mother;&#xA;&#x9;private ArrayList&lt;Person> children = new ArrayList&lt;Person>();&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9; public char getGender() {&#xA;&#x9;&#x9;return gender;&#xA;&#x9;}&#xA;&#x9; public Person getMother() {&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#x9; public Person getFather() {&#xA;&#x9;&#x9;return father;&#xA;&#x9;}&#xA;&#x9;public int getChildCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if(n &lt; 0 || n> children.size()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index out of range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;if(!children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.add(person);&#xA;&#x9;&#x9;&#x9;if(person.gender == 'f'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}else if(person.gender == 'm'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487418632909" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.father = person;&#xA;&#x9;&#x9;person.addChild(this);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="1152" end="-57"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487418833134" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(person.getGender() != 'f'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person.getGender() != 'm'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1061" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487418907647" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}else if(person.gender == 'M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(person.getGender() != 'F'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person.getGender() != 'F" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="863" end="-154"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487418916877" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="M" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1256" end="-154"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487419096650" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.gender == 'F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}else if(this" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="845" end="-497"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487419168461" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person.getGender() != 'M' || this == person" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1085" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487419312112" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="children.remove(children.lastIndexOf(person));" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1010" end="-433"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487419451618" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if(this.gender == 'M'){&#xA;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;}else if(this.gender == 'F'){&#xA;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(person.getGender() != 'F' || this == person || person == null){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person.getGender() != 'M' || this == person || person == null" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1058" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487419491911" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null){&#xA;&#x9;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(person.getGender() != 'F' || this == person || person == null){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person == null){&#xA;&#x9;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1228" end="-220"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420511508" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="897" end="-846"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420830087" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="897" end="-846"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420844962" sizeMeasure="85" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}else if(this.gender == 'M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;children.remove(children.lastIndexOf(person));&#xA;&#x9;&#x9;if(this.gender == 'M'){&#xA;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;}else if(this.gender == 'F'){&#xA;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(person == null){&#xA;&#x9;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(person.getGender() != 'F' || this == person || person == null){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person == null){&#xA;&#x9;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(person.getGender() != 'M' || this == person" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="897" end="-152"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1634" charEnd="1640" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420879015" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=")" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1568" end="-152"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420887335" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1314" end="-389"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420944550" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if(person == null){&#xA;//&#x9;&#x9;&#x9;this.father = null;&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1453" end="-205"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421002910" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getGender() != 'F' || this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1228" end="-202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421061767" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.father != null){&#xA;&#x9;&#x9;&#x9;person.removeChild(this);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1409" end="-202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421246650" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if(this.father != null){&#xA;//&#x9;&#x9;&#x9;person.removeChild(this);&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1404" end="-205"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421255283" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if(this.father != null){&#xA;&#x9;&#x9;&#x9;person.removeChild(this);&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1404" end="-205"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421304360" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.father" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1434" end="-225"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421455752" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(person!=null){&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="1591" end="-57"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421503899" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person.addChild(this);" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1591" end="-57"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421519102" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(person!=null){&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1591" end="-57"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487421647930" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if(this.father != null){&#xA;//&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1404" end="-233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487422313533" sizeMeasure="88" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if(person!=null){&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;//this.father.removeChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//this.father = person;" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1573" end="-60"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1702" charEnd="1745" severity="1" problemCategory="90" problemType="536871061"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423872327" sizeMeasure="82" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&amp;&amp; person != null || this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person.getGender() != 'M' &amp;&amp; person != null || this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(person==null){&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;&#x9;this.father = person;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1248" end="-60"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1629" charEnd="1635" severity="1" problemCategory="90" problemType="536871363"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423925120" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else{&#xA;&#x9;&#x9;&#x9;this.father = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this)" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1610" end="-65"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1629" charEnd="1635" severity="1" problemCategory="90" problemType="536871363"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424053000" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; this.father != null){&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.father = null" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1553" end="-125"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424610978" sizeMeasure="89" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;Person jens = new Person(&quot;jens&quot;, 'M');&#xA;&#x9;&#x9;Person ole = new Person(&quot;ole&quot;, 'M');&#xA;&#x9;&#x9;Person kari = new Person(&quot;kari&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1750" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="81" charStart="1839" charEnd="1843" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="82" charStart="1881" charEnd="1884" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1921" charEnd="1925" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424644331" sizeMeasure="90" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ole.setMother(kari);&#xA;&#x9;&#x9;System.out.println(kari.getChildCount());" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1876" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="81" charStart="1839" charEnd="1843" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424667787" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ole.setMother(null" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1899" end="-55"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="81" charStart="1839" charEnd="1843" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424728770" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Father(jens);&#xA;&#x9;&#x9;ole.setFather(null);&#xA;&#x9;&#x9;System.out.println(jens" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1883" end="-27"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1921" charEnd="1925" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424736077" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="1899" end="-73"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1921" charEnd="1925" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424900209" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" != null &amp;&amp; person.getGender() != 'M'  " edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1433" end="-504"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1923" charEnd="1927" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424937851" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" != null &amp;&amp; person.getGender() != 'F' || this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person != null &amp;&amp; person.getGender() != 'M'   || this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(person==null &amp;&amp; this.father != null){&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;this.father = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person jens = new Person(&quot;jens&quot;, 'M');&#xA;&#x9;&#x9;Person ole = new Person(&quot;ole&quot;, 'M');&#xA;&#x9;&#x9;Person kari = new Person(&quot;kari&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;ole.setFather(jens);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1228" end="-73"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1923" charEnd="1927" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424960928" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="1901" end="-73"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1923" charEnd="1927" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424987207" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1901" end="-73"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1923" charEnd="1927" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487425430213" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Person temp = this.father;&#xA;&#x9;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;&#x9;temp.removeChild(this);&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="1584" end="-337"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1952" charEnd="1956" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487425463012" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if(this.gender == 'M'){&#xA;//&#x9;&#x9;&#x9;person.setFather(null);&#xA;//&#x9;&#x9;}else if(this.gender == 'F'){&#xA;//&#x9;&#x9;&#x9;person.setMother(null);&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="1057" end="-832"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1962" charEnd="1966" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487426113338" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if(this.gender == 'M' &amp;&amp; person.getFather() != null){&#xA;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;}else if(this.gender == 'F' &amp;&amp; person.getMother() != null){&#xA;&#x9;&#x9;&#x9;person.setMother(null);&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="1057" end="-832"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="2012" charEnd="2016" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487426534511" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="per = new Person(&quot;per&quot;, 'M');&#xA;&#x9;&#x9;Person kari = new Person(&quot;kari&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;ole.setFather(jens);&#xA;&#x9;&#x9;ole.setFather(per" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="1928" end="-55"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="2052" charEnd="2056" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487426558150" sizeMeasure="95" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ole.getFather()" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="2068" end="-55"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="2052" charEnd="2056" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487426566210" sizeMeasure="95" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getName" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="2083" end="-57"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="2052" charEnd="2056" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487426605462" sizeMeasure="95" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot;  &quot;+ per.getChildCount" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="2093" end="-57"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="2052" charEnd="2056" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487426616615" sizeMeasure="95" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="jens" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="2102" end="-71"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="2052" charEnd="2056" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487426849723" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" if(this.father != null){&#xA;&#x9;&#x9;&#x9;Person temp = this.father;&#xA;&#x9;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;&#x9;temp.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.father = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="1732" end="-453"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="2222" charEnd="2226" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487427167001" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.setFather(null" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="1761" end="-506"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="2165" charEnd="2169" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487427301932" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" if(this.father != person)" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="1841" end="-445"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="2191" charEnd="2195" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487429460072" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="1841" end="-445"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="2165" charEnd="2169" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487431918014" sizeMeasure="102" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="children.contains(person)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;children.add(person);&#xA;&#x9;&#x9;if(this.gender == 'F'){&#xA;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;}else if(this.gender == 'M'){&#xA;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="785" end="-1323"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="93" charStart="2209" charEnd="2213" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487431953036" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="857" end="-1467"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="2205" charEnd="2209" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487432061560" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="816" end="-1472"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="2175" charEnd="2179" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487432202359" sizeMeasure="107" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(this.mother != null){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;}else if(this.gender == 'M'){&#xA;&#x9;&#x9;&#x9;if(this.father != null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="882" end="-1357"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="2317" charEnd="2321" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487432471256" sizeMeasure="110" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(!children.contains(person)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="1154" end="-1279"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="101" charStart="2369" charEnd="2373" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487432550727" sizeMeasure="110" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="1749" end="-694"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="101" charStart="2339" charEnd="2343" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487432621286" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.father == person){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="1749" end="-689"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="105" charStart="2420" charEnd="2424" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487432736800" sizeMeasure="129" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="  || this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.mother == person){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(person==null &amp;&amp; this.mother != null){&#xA;&#x9;&#x9;&#x9;Person temp = this.mother;&#xA;&#x9;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;&#x9;temp.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}else if(this.mother != null){&#xA;&#x9;&#x9;&#x9;this.setMother(null);&#xA;&#x9;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="1519" end="-894"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="120" charStart="2735" charEnd="2739" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487424644290" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487424671572" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487424728718" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487424736017" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487424900142" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487424953570" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487424960875" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487424987141" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487425448012" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487425465096" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487426128869" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487426535793" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487426537807" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487426559470" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487426566156" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487426605407" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487426616562" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487426731355" mode="debug"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487418514111" completion="0.0" failureCount="7" errorCount="6">
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487418597595" completion="0.15384615384615385" successCount="2" failureCount="11">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testMorskapAddChild</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapAddChild</failureTests>
          <failureTests>testFarskapSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487418635346" completion="0.23076923076923078" successCount="3" failureCount="10">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testMorskapAddChild</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapAddChild</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487418834581" completion="0.38461538461538464" successCount="5" failureCount="4" errorCount="4">
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorskapAddChild</failureTests>
          <failureTests>testFarskapAddChild</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487418907904" completion="0.23076923076923078" successCount="3" failureCount="6" errorCount="4">
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorskapSetMother</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapAddChild</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487418917133" completion="0.23076923076923078" successCount="3" failureCount="2" errorCount="8">
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487419096896" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487419170597" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487419494184" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487420830324" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487420845210" completion="0.38461538461538464" successCount="5" failureCount="2" errorCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testSelvfarskapIllegalArgumentException</errorTests>
          <errorTests>testFarskapIllegalArgumentException</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487420879273" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487420887586" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487420946282" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421003154" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421062035" completion="0.6153846153846154" successCount="8" failureCount="2" errorCount="3">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421246878" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421255525" completion="0.6153846153846154" successCount="8" failureCount="2" errorCount="3">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421304613" completion="0.6153846153846154" successCount="8" failureCount="2" errorCount="3">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421455987" completion="0.6153846153846154" successCount="8" failureCount="2" errorCount="3">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421504212" completion="0.6153846153846154" successCount="8" failureCount="2" errorCount="3">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421519344" completion="0.6153846153846154" successCount="8" failureCount="2" errorCount="3">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487421648173" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487423873984" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testFarskapAddChild</failureTests>
          <failureTests>testFarskapSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487423925389" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487424054348" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487425433575" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487425440587" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487425472442" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487426115218" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487426123093" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487426857284" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487427167295" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487427302238" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487431986052" completion="0.38461538461538464" successCount="5" errorCount="8">
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487432061826" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487432204360" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487432471538" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487432551012" completion="0.5384615384615384" successCount="7" failureCount="4" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487432621548" completion="0.8461538461538461" successCount="11" failureCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarbytteSetFather</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487432737063" completion="1.0" successCount="13">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorbytteSetFather</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarbytteSetFather</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a" performedCount="2">
        <attempts timestamp="1487424987763"/>
        <attempts timestamp="1487426731580"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="7">
        <attempts timestamp="1487424996497"/>
        <attempts timestamp="1487425067969"/>
        <attempts timestamp="1487425086014"/>
        <attempts timestamp="1487425093765"/>
        <attempts timestamp="1487425118622"/>
        <attempts timestamp="1487425124606"/>
        <attempts timestamp="1487426744483"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="6">
        <attempts timestamp="1487424992821"/>
        <attempts timestamp="1487425014228"/>
        <attempts timestamp="1487425054766"/>
        <attempts timestamp="1487425078883"/>
        <attempts timestamp="1487426739609"/>
        <attempts timestamp="1487426748716"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1487425028489"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
