<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Partner">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Partner class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Partner class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PartnerTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PartnerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Partner" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875877873" sizeMeasure="37">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Partner {&#xA;&#xA;private String name;&#xA;private Partner connectedPartner;&#xA;&#x9;&#xA;public Partner(String name){&#xA;&#x9;this.name = name;&#xA;}&#xA;&#xA;public String getName(){&#xA;&#x9;return name;&#xA;}&#xA;&#xA;public Partner getPartner(){&#xA;&#x9;return connectedPartner;&#xA;}&#xA;&#xA;public void setPartner(Partner nyPartner){&#xA;&#x9;if (nyPartner == null){&#xA;&#x9;&#x9;this.connectedPartner = null;&#xA;&#x9;}&#xA;&#x9;else if (!(this.connectedPartner == nyPartner)) {&#xA;&#x9;&#x9;this.connectedPartner = null;&#xA;&#x9;&#x9;connectedPartner = nyPartner;&#xA;&#x9;&#x9;nyPartner.connectedPartner = this;&#xA;&#x9;}&#xA;&#x9;else {&#xA;&#x9;&#x9;connectedPartner = nyPartner;&#xA;&#x9;&#x9;nyPartner.connectedPartner = this;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876026214" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getPartner().connectedPartner = null;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="334" end="-280"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876325358" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if ((connectedPartner== null) &amp;&amp; nyPartner.connectedPartner == null )" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="568" end="-83"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876448860" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(connectedPartner== null) &amp;&amp; nyPartner.connectedPartner == null ){&#xA;&#x9;&#x9;connectedPartner = nyPartner;&#xA;&#x9;&#x9;nyPartner.connectedPartner = this;&#xA;&#x9;}&#xA;&#x9;else if (!(this.connectedPartner == nyPartner)) {&#xA;&#x9;&#x9;this.connectedPartner = null;&#xA;&#x9;&#x9;connectedPartner = nyPartner;&#xA;&#x9;&#x9;nyPartner.connectedPartner = this;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="417" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877912602" sizeMeasure="43">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(nyPartner != this) &amp;&amp; (connectedPartner != nyPartner)){  // sjekker først at argumentet ikke er seg selv eller eksisterende partner&#xA;&#x9;&#x9;if ((nyPartner == null)&amp;&amp;(connectedPartner != null)){       //  slår opp eksisterende parnterskap gjensidig&#xA;&#x9;&#x9;this.getPartner().connectedPartner = null;&#xA;&#x9;&#x9;this.connectedPartner = null;&#xA;&#x9;}&#xA;&#x9;else if ((connectedPartner== null) &amp;&amp; (nyPartner.connectedPartner == null )){ // hvis begge partnere allerede er single skal de bli sammen NORMALT TILFELLE&#xA;&#x9;&#x9;connectedPartner = nyPartner;&#xA;&#x9;&#x9;nyPartner.connectedPartner = this;&#xA;&#x9;}&#xA;&#x9;else if (connectedPartner != nyPartner) {   //  p1 er allerede i et forhold men skal slå opp med gjeldende partnerskap og innlede nytt partnerskap&#xA;&#x9;&#x9;this.getPartner().connectedPartner = null;&#xA;&#x9;&#x9;connectedPartner = null;&#xA;&#x9;&#x9;connectedPartner = nyPartner;&#xA;&#x9;&#x9;nyPartner.connectedPartner = this;&#xA;&#x9;}&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="307" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878419520" sizeMeasure="43">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="connectedPartner.connectedPartner = null;&#xA;&#x9;&#x9;connectedPartner = null;&#xA;&#x9;}&#xA;&#x9;else if ((connectedPartner== null) &amp;&amp; (nyPartner.connectedPartner == null )){ // hvis begge partnere allerede er single skal de bli sammen NORMALT TILFELLE&#xA;&#x9;&#x9;connectedPartner = nyPartner;&#xA;&#x9;&#x9;nyPartner.connectedPartner = this;&#xA;&#x9;}&#xA;&#x9;else if ((connectedPartner != nyPartner)&amp;&amp; (connectedPartner != null)) {   //  p1 er allerede i et forhold men skal slå opp med gjeldende partnerskap og innlede nytt partnerskap&#xA;&#x9;&#x9;connectedPartner" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="552" end="-141"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487879559422" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//  p1 er allerede i et forhold men skal slå opp med gjeldende partnerskap og innlede nytt partnerskap&#xA;&#x9;&#x9;if (nyPartner.connectedPartner != null){&#xA;&#x9;&#x9;nyPartner.connectedPartner.connectedPartner = null;&#xA;&#x9;&#x9;nyPartner.connectedPartner=null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="927" end="-160"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487875881558" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487876027020" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487876326016" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487876449566" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877913383" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487878420288" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487879560189" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
