<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StopWatch and StopWatchManager">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StopWatch class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.StopWatch"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StopWatchManager class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.StopWatchManager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StopWatch class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.StopWatch"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StopWatchManager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.StopWatchManager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StopWatchTest."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.StopWatchTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StopWatchManagerTest."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.StopWatchManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.StopWatch*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488314324237" sizeMeasure="99">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;&#xA;public class StopWatch {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;int time = 0;&#xA;&#x9;int tick = 0;&#xA;&#x9;int counter = 0;&#xA;&#x9;int lastLap = -1;&#xA;&#x9;boolean started = false;&#xA;&#x9;boolean stopped = false;&#xA;&#x9;&#xA;&#x9;boolean isStarted() {&#xA;&#x9;&#x9;return started == true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;boolean isStopped() {&#xA;&#x9;&#x9;return stopped == true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getTicks() {&#xA;&#x9;&#x9;return tick;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getTime() {&#xA;&#x9;&#x9;if (started == false) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return time;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getLapTime() {&#xA;&#x9;&#x9;if (started == false) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return counter;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getLastLapTime() {&#xA;&#x9;&#x9;if (lastLap == 0) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return lastLap;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;tick += ticks;&#xA;&#x9;&#x9;if (started == true &amp;&amp; stopped == false) {&#xA;&#x9;&#x9;&#x9;time += ticks;&#xA;&#x9;&#x9;&#x9;counter += ticks;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void start() {&#xA;&#x9;&#x9;time = 0;&#xA;&#x9;&#x9;counter = 0;&#xA;&#x9;&#x9;started = true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void lap() {&#xA;&#x9;&#x9;lastLap = counter;&#xA;&#x9;&#x9;counter = 0;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void stop() {&#xA;&#x9;&#x9;lastLap = counter;&#xA;&#x9;&#x9;counter = 0;&#xA;&#x9;&#x9;stopped = true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;Laptime: %i, Time: %i&quot;, counter, time);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StopWatch stopwatch = new StopWatch();&#xA;&#x9;&#x9;System.out.println(stopwatch.isStarted());&#xA;&#x9;&#x9;System.out.println(stopwatch.isStopped());&#xA;&#x9;&#x9;stopwatch.tick(50);&#xA;&#x9;&#x9;stopwatch.start();&#xA;&#x9;&#x9;System.out.println(stopwatch.getLapTime());&#xA;&#x9;&#x9;System.out.println(stopwatch.isStarted());&#xA;&#x9;&#x9;stopwatch.tick(100);&#xA;&#x9;&#x9;stopwatch.lap();&#xA;&#x9;&#x9;stopwatch.tick(200);&#xA;&#x9;&#x9;System.out.println(stopwatch.getLastLapTime());&#xA;&#x9;&#x9;System.out.println(stopwatch.getLapTime());&#xA;&#x9;&#x9;stopwatch.stop();&#xA;&#x9;&#x9;System.out.println(stopwatch.isStopped());&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316934899" sizeMeasure="99">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;public String toString() {&#xA;//&#x9;&#x9;return String.format(&quot;Laptime: %i, Time: %i&quot;, counter, time);&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="953" end="-544"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317120882" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int time = 0;&#xA;&#x9;int tick = 0;&#xA;&#x9;int counter = 0;&#xA;&#x9;int lastLap = -1;&#xA;&#x9;boolean started = false;&#xA;&#x9;boolean stopped = false;&#xA;&#x9;&#xA;&#x9;boolean isStarted() {&#xA;&#x9;&#x9;return started == true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;boolean isStopped() {&#xA;&#x9;&#x9;return stopped == true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getTicks() {&#xA;&#x9;&#x9;return tick;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getTime() {&#xA;&#x9;&#x9;if (started == false) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return time;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getLapTime() {&#xA;&#x9;&#x9;if (started == false) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return counter;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getLastLapTime() {&#xA;&#x9;&#x9;if (lastLap == 0) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return lastLap;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;tick += ticks;&#xA;&#x9;&#x9;if (started == true &amp;&amp; stopped == false) {&#xA;&#x9;&#x9;&#x9;time += ticks;&#xA;&#x9;&#x9;&#x9;counter += ticks;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void start() {&#xA;&#x9;&#x9;time = 0;&#xA;&#x9;&#x9;counter = 0;&#xA;&#x9;&#x9;started = true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void lap() {&#xA;&#x9;&#x9;lastLap = counter;&#xA;&#x9;&#x9;counter = 0;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void stop() {&#xA;&#x9;&#x9;lastLap = counter;&#xA;&#x9;&#x9;counter = 0;&#xA;&#x9;&#x9;stopped = true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;Laptime: %i, Time: %i&quot;, counter, time);&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="56" end="-544"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318340744" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="d, Time: %d" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1013" end="-563"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488314303648" sizeMeasure="61">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.Collection;&#xA;import java.util.HashMap;&#xA;import java.util.Map;&#xA;&#xA;public class StopWatchManager {&#xA;&#x9;&#xA;&#x9;private Collection&lt;StopWatch> watchCollection;&#xA;&#x9;private Collection&lt;StopWatch> startedCollection;&#xA;&#x9;private Collection&lt;StopWatch> stoppedCollection;&#xA;&#x9;Map&lt;String, StopWatch> WatchMap = new HashMap&lt;>();&#xA;&#x9;&#xA;&#x9;public StopWatch newStopWatch(String name) {&#xA;&#x9;&#x9;if (getStopWatch(name) != null) {&#xA;&#x9;&#x9;WatchMap.put(name, new StopWatch());&#xA;&#x9;&#x9;watchCollection.add(WatchMap.get(name));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return WatchMap.get(name);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;if (watchCollection.contains(name)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;temp.tick(ticks);&#xA;&#x9;&#x9;});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllWatches() {&#xA;&#x9;return watchCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllStarted() {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;startedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return startedCollection;&#xA;&#x9;}&#xA;&#xA;&#x9;Collection&lt;StopWatch> getAllStopped() {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStopped()) {&#xA;&#x9;&#x9;&#x9;&#x9;stoppedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return stoppedCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315206146" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Map&lt;String, StopWatch> WatchMap = new HashMap&lt;>();&#xA;&#x9;&#xA;&#x9;public StopWatch newStopWatch(String name) {&#xA;&#x9;&#x9;if (getStopWatch(name) != null) {&#xA;&#x9;&#x9;WatchMap.put(name, new StopWatch());&#xA;&#x9;&#x9;watchCollection.add(WatchMap.get(name));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return WatchMap.get(name);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;if (watchCollection.contains(name)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;temp.tick(ticks);&#xA;&#x9;&#x9;});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllWatches() {&#xA;&#x9;return watchCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllStarted() {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;startedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return startedCollection;&#xA;&#x9;}&#xA;&#xA;&#x9;Collection&lt;StopWatch> getAllStopped() {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStopped()) {&#xA;&#x9;&#x9;&#x9;&#x9;stoppedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return stoppedCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StopWatchManager manager = new StopWatchManager();&#xA;&#x9;&#x9;manager.newStopWatch(&quot;Rolex&quot;);&#xA;&#x9;&#x9;manager.newStopWatch(&quot;Tissot&quot;);&#xA;&#x9;&#x9;manager.getStopWatch(&quot;Rolex&quot;).start();&#xA;&#x9;&#x9;manager.tick(100);&#xA;&#x9;&#x9;manager.getAllWatches();&#xA;&#x9;&#x9;manager.getAllStarted();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="288" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315223612" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(manager.getAllStarted()" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="1513" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315291360" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(name);&#xA;&#x9;&#x9;System.out.println(watchCollection.contains(name));" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="635" end="-934"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315295122" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1647" end="-1648"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315676628" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;dass&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="707" end="-937"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315686819" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="name" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="707" end="-937"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315780216" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="717" end="-934"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316108140" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (watchCollection.contains(name)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(watchCollection.contains(name));" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="663" end="-857"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316132894" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="740" end="-857"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316391415" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="newStopWatch(&quot;mentalt&quot;);&#xA;&#x9;&#x9;if (watchCollection.contains(mentalt)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="663" end="-857"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316398262" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;mentalt&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="719" end="-898"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316445713" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (watchCollection.contains(name" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="663" end="-898"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316503561" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="WatchMap.put(name, new StopWatch());&#xA;&#x9;&#x9;watchCollection.add(WatchMap.get(name));" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="397" end="-1078"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316546276" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(watchCollection.add(WatchMap.get(name)" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="436" end="-1124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316581879" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="WatchMap.get(name" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="455" end="-1124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316700241" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1595" end="-1596"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317036886" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="436" end="-1163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317235653" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(WatchMap.get(name));&#xA;&#x9;&#x9;watchCollection.add(name" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="436" end="-1080"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317254144" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="WatchMap.get(name)" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="498" end="-1080"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317482982" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (watchCollection.contains(navn)) {&#xA;&#x9;&#x9;&#x9;watchCollection.remove(navn);&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="592" end="-1004"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318378167" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="name" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="498" end="-1180"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318921816" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="WatchMap.get(name));&#xA;&#x9;&#x9;return WatchMap.get(name);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;if (watchCollection.contains(navn)) {&#xA;&#x9;&#x9;&#x9;watchCollection.remove(navn);&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;System.out.println(name);&#xA;&#x9;&#x9;if (watchMap.containsKey" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="498" end="-903"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318930252" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="W" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="769" end="-922"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319340667" sizeMeasure="70" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="startedCollection;&#xA;&#x9;private Collection&lt;StopWatch> stoppedCollection;&#xA;&#x9;private Map&lt;String, StopWatch> WatchMap = new HashMap&lt;>();&#xA;&#x9;&#xA;&#x9;public StopWatch newStopWatch(String name) {&#xA;&#x9;&#x9;WatchMap.put(name, new StopWatch());&#xA;&#x9;&#x9;System.out.println(WatchMap.get(name));&#xA;&#x9;&#x9;return WatchMap.get(name);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(navn)) {&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;System.out.println(name);&#xA;&#x9;&#x9;if (WatchMap.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;for (String name : WatchMap.keySet()) {&#xA;&#x9;&#x9;&#x9;WatchMap.get(name).tick(ticks);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="170" end="-748"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319403740" sizeMeasure="70" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (String temp : WatchMap.keySet()) {&#xA;&#x9;&#x9;&#x9;if (WatchMap.get(temp).isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;startedCollection.add(WatchMap.get(temp)" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="952" end="-535"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319676690" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.HashMap;&#xA;import java.util.Map;&#xA;&#xA;public class StopWatchManager {&#xA;&#x9;&#xA;&#x9;private Collection&lt;StopWatch> watchCollection = new ArrayList&lt;StopWatch>();&#xA;&#x9;private Collection&lt;StopWatch> startedCollection = new ArrayList&lt;StopWatch>();&#xA;&#x9;private Collection&lt;StopWatch> stoppedCollection = new ArrayList&lt;StopWatch>();&#xA;&#x9;private Map&lt;String, StopWatch> WatchMap = new HashMap&lt;>();&#xA;&#x9;&#xA;&#x9;public StopWatch newStopWatch(String name) {&#xA;&#x9;&#x9;StopWatch watch = new StopWatch();&#xA;&#x9;&#x9;WatchMap.put(name, watch);&#xA;&#x9;&#x9;System.out.println(WatchMap.get(name));&#xA;&#x9;&#x9;watchCollection.add(watch);&#xA;&#x9;&#x9;return watch;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(navn)) {&#xA;&#x9;&#x9;&#x9;watchCollection.remove(WatchMap.get(navn));&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;System.out.println(name);&#xA;&#x9;&#x9;if (WatchMap.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;temp.tick(ticks);&#xA;&#x9;&#x9;});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllWatches() {&#xA;&#x9;return watchCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllStarted() {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;startedCollection.add(temp" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="44" end="-535"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319755040" sizeMeasure="76" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (String temp : WatchMap.keySet()) {&#xA;&#x9;&#x9;&#x9;if (WatchMap.get(temp).isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;startedCollection.add(WatchMap.get(temp)" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="1192" end="-535"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319770004" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="1328" end="-523"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319821170" sizeMeasure="76" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (String temp : WatchMap.keySet()) {&#xA;&#x9;&#x9;&#x9;if (WatchMap.get(temp).isStopped()) {&#xA;&#x9;&#x9;&#x9;&#x9;startedCollection.add(WatchMap.get(temp));&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;};&#xA;&#x9;&#x9;return start" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="1405" end="-325"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319867221" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="watchCollection.add(watch);&#xA;&#x9;&#x9;return watch;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(navn)) {&#xA;&#x9;&#x9;&#x9;watchCollection.remove(WatchMap.get(navn));&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;StopWatch getStopWatch(String name) {" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="578" end="-992"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319948549" sizeMeasure="74" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StartedWatches() {&#xA;&#x9;&#x9;for (String temp : WatchMap.keySet()) {&#xA;&#x9;&#x9;&#x9;if (WatchMap.get(temp).isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;startedCollection.add(WatchMap.get(temp));&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;};&#xA;&#x9;&#x9;return startedCollection;&#xA;&#x9;}&#xA;&#xA;&#x9;Collection&lt;StopWatch> getStoppedWatches" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="1105" end="-484"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319978826" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StartedWatches" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="1797" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488320037918" sizeMeasure="76" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(WatchMap.get(name));&#xA;&#x9;&#x9;watchCollection.add(watch);&#xA;&#x9;&#x9;return watch;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(navn)) {&#xA;&#x9;&#x9;&#x9;watchCollection.remove(WatchMap.get(navn));&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;System.out.println(name);&#xA;&#x9;&#x9;if (WatchMap.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;temp.tick(ticks);&#xA;&#x9;&#x9;});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllWatches() {&#xA;&#x9;return watchCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getStartedWatches() {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;stoppedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return stoppedCollection;&#xA;&#x9;}&#xA;&#xA;&#x9;Collection&lt;StopWatch> getStoppedWatches() {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStopped()) {&#xA;&#x9;&#x9;&#x9;&#x9;stoppedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return stoppedCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StopWatchManager manager = new StopWatchManager();&#xA;&#x9;&#x9;manager.newStopWatch(&quot;Rolex&quot;);&#xA;&#x9;&#x9;manager.newStopWatch(&quot;Tissot&quot;);&#xA;&#x9;&#x9;manager.getStopWatch(&quot;Rolex&quot;).start();&#xA;&#x9;&#x9;manager.tick(100);&#xA;&#x9;&#x9;manager.getAllWatches();&#xA;&#x9;&#x9;System.out.println(manager.getAllStarted" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="578" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488320049565" sizeMeasure="76" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StartedWatches" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1805" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488320084846" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="watchCollection.add(watch);&#xA;&#x9;&#x9;return watch;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(navn)) {&#xA;&#x9;&#x9;&#x9;watchCollection.remove(WatchMap.get(navn));&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;StopWatch getStopWatch(String name) {" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="578" end="-942"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488320343821" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1761" end="-1762"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488320388118" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public Collection&lt;StopWatch> getStartedWatches() {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;stoppedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return stoppedCollection;&#xA;&#x9;}&#xA;&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="1080" end="-496"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488320413747" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="oppedCollection = new ArrayList&lt;StopWatch>();&#xA;&#x9;private Map&lt;String, StopWatch> WatchMap = new HashMap&lt;>();&#xA;&#x9;&#xA;&#x9;public StopWatch newStopWatch(String name) {&#xA;&#x9;&#x9;StopWatch watch = new StopWatch();&#xA;&#x9;&#x9;WatchMap.put(name, watch);&#xA;&#x9;&#x9;watchCollection.add(watch);&#xA;&#x9;&#x9;return watch;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(navn)) {&#xA;&#x9;&#x9;&#x9;watchCollection.remove(WatchMap.get(navn));&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;temp.tick(ticks);&#xA;&#x9;&#x9;});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllWatches() {&#xA;&#x9;return watchCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Collection&lt;StopWatch> getStartedWatches() {&#xA;&#x9;&#x9;private Collection&lt;StopWatch> startedCollection = new ArrayList&lt;StopWatch>();" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="277" end="-646"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488320429353" sizeMeasure="74" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Map&lt;String, StopWatch> WatchMap = new HashMap&lt;>();&#xA;&#x9;&#xA;&#x9;public StopWatch newStopWatch(String name) {&#xA;&#x9;&#x9;StopWatch watch = new StopWatch();&#xA;&#x9;&#x9;WatchMap.put(name, watch);&#xA;&#x9;&#x9;watchCollection.add(watch);&#xA;&#x9;&#x9;return watch;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStopWatch(String navn) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(navn)) {&#xA;&#x9;&#x9;&#x9;watchCollection.remove(WatchMap.get(navn));&#xA;&#x9;&#x9;&#x9;WatchMap.remove(navn);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;if (WatchMap.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;return WatchMap.get(name);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void tick(int ticks) {&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;temp.tick(ticks);&#xA;&#x9;&#x9;});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllWatches() {&#xA;&#x9;return watchCollection;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Collection&lt;StopWatch> getStartedWatches() {&#xA;&#x9;&#x9;Collection&lt;StopWatch> startedCollection = new ArrayList&lt;StopWatch>();&#xA;&#x9;&#x9;watchCollection.forEach((temp) -> {&#xA;&#x9;&#x9;&#x9;if (temp.isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;stoppedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return stoppedCollection;&#xA;&#x9;}&#xA;&#xA;&#x9;public Collection&lt;StopWatch> getStoppedWatches() {&#xA;&#x9;&#x9;Collection&lt;StopWatch> stoppedCollection = new ArrayList&lt;StopWatch>();" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="253" end="-453"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488320473186" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="artedCollection.add(temp);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;});&#xA;&#x9;&#x9;return start" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="1116" end="-594"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316945781" mode="debug"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488315227395" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488315295904" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488315679906" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488315687832" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488315781157" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316109410" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316130976" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316392317" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316399179" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316478386" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316504603" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316547046" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316582627" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316701277" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316724255" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316777388" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316812903" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488316951208" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317035954" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317139724" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317236473" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317236891" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317254829" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317255246" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317258192" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317483805" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317484336" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488318342285" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488318379952" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488318932171" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488319695233" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488319756141" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488319770773" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488319792738" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488319822027" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488319867918" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488319979851" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488320038587" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488320051128" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488320087344" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488320389897" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488320430168" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488320473929" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488320112219" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="0.6666666666666666">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488314325364" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488319730261" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488319777005" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488319827148" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488319837290" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488319853633" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488319873368" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488319953409" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488319985190" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488320056581" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488320065710" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488320093965" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488320119530" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488320397354" completion="0.6666666666666666" successCount="2" failureCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="39">
        <attempts timestamp="1488316800839"/>
        <attempts timestamp="1488316803736"/>
        <attempts timestamp="1488316818589"/>
        <attempts timestamp="1488316822221"/>
        <attempts timestamp="1488316825701"/>
        <attempts timestamp="1488316826886"/>
        <attempts timestamp="1488316833361"/>
        <attempts timestamp="1488316839722"/>
        <attempts timestamp="1488316855918"/>
        <attempts timestamp="1488316870237"/>
        <attempts timestamp="1488316888869"/>
        <attempts timestamp="1488316890171"/>
        <attempts timestamp="1488316890871"/>
        <attempts timestamp="1488316891470"/>
        <attempts timestamp="1488316892003"/>
        <attempts timestamp="1488316893190"/>
        <attempts timestamp="1488316894449"/>
        <attempts timestamp="1488316897289"/>
        <attempts timestamp="1488316900396"/>
        <attempts timestamp="1488316926046"/>
        <attempts timestamp="1488316954958"/>
        <attempts timestamp="1488316956390"/>
        <attempts timestamp="1488316956812"/>
        <attempts timestamp="1488316957243"/>
        <attempts timestamp="1488316957743"/>
        <attempts timestamp="1488316958228"/>
        <attempts timestamp="1488316958560"/>
        <attempts timestamp="1488316959545"/>
        <attempts timestamp="1488316960217"/>
        <attempts timestamp="1488316960680"/>
        <attempts timestamp="1488316961112"/>
        <attempts timestamp="1488316961597"/>
        <attempts timestamp="1488316962135"/>
        <attempts timestamp="1488316962745"/>
        <attempts timestamp="1488316965124"/>
        <attempts timestamp="1488316967413"/>
        <attempts timestamp="1488316973260"/>
        <attempts timestamp="1488316978553"/>
        <attempts timestamp="1488316980158"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1488316858805"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
