<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Card">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardDeck class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardHand class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardDeck class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardHand class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardDeckTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardDeckTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardHandTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardHandTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957955169" sizeMeasure="43">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Card {&#xA;&#x9;char cardType;&#xA;&#x9;int cardNumber;&#xA;&#x9;String cardNumberString;&#xA;&#x9;&#xA;&#x9;public Card(char cardType, int cardNumber){&#xA;&#x9;&#x9;setCardType(cardType);&#xA;&#x9;&#x9;setCardNumber(cardNumber);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCardType(char cardType){&#xA;&#x9;&#x9;if (cardType=='S' || cardType == 'H' || cardType == 'D' || cardType == 'C'){&#xA;&#x9;&#x9;&#x9;this.cardType = cardType;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Choose valid type&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCardNumber (int cardNumber){&#xA;&#x9;&#x9;if ( cardNumber &lt; 1 || cardNumber > 13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Choose a number between 1 and 13&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.cardNumber = cardNumber;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return cardType;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return cardNumber;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;cardNumberString = Integer.toString(cardNumber);&#xA;&#x9;&#x9;return cardType+cardNumberString;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957230698" sizeMeasure="84" warningCount="6">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;&#x9;&#xA;import objectstructures.Card;&#xA;import objectstructures.CardDeck;&#xA;import objectstructures.CardHand;&#xA;&#xA;public class CardDeck {&#xA;&#x9;ArrayList&lt;Card> deckOfCards;&#xA;&#x9;&#xA;&#x9;public CardDeck(int n){&#xA;&#x9;&#x9;ArrayList&lt;Card> deckOfCards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;for (int i = 1; i &lt; n+1; i++) {&#xA;&#x9;&#x9;&#x9;Card kort = CardMaker('S',i);&#xA;&#x9;&#x9;&#x9;deckOfCards.add(kort);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = 1; i &lt; n+1; i++) {&#xA;&#x9;&#x9;&#x9;Card kort = CardMaker('H',i);&#xA;&#x9;&#x9;&#x9;deckOfCards.add(kort);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = 1; i &lt; n+1; i++) {&#xA;&#x9;&#x9;&#x9;Card kort = CardMaker('D',i);&#xA;&#x9;&#x9;&#x9;deckOfCards.add(kort);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = 1; i &lt; n+1; i++) {&#xA;&#x9;&#x9;&#x9;Card kort = CardMaker('C',i);&#xA;&#x9;&#x9;&#x9;deckOfCards.add(kort);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.deckOfCards = deckOfCards;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Card CardMaker(char a, int n){&#xA;&#x9;&#x9;Card card = new Card(a,n);&#xA;&#x9;return card;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount(){&#xA;&#x9;&#x9;return deckOfCards.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n > getCardCount() -1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are outside the deck of cards&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return deckOfCards.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void shufflePerfectly(){&#xA;&#x9;&#x9;int cardCount = getCardCount();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;ArrayList&lt;Card> halvStokk =  new ArrayList&lt;>(deckOfCards.subList(0, cardCount/2));&#xA;&#x9;&#x9;ArrayList&lt;Card> AnnenHalvStokk =  new ArrayList&lt;>(deckOfCards.subList(cardCount/2, cardCount));&#xA;&#x9;&#x9;ArrayList&lt;Card> nyStokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;for (int i = 0; i &lt; cardCount/2; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;nyStokk.add(halvStokk.get(i));&#xA;&#x9;&#x9;&#x9;&#x9;nyStokk.add(AnnenHalvStokk.get(i));&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;deckOfCards = nyStokk;&#xA;&#x9;}&#xA;&#x9;public void deal (CardHand cardHand, int n){&#xA;&#x9;&#x9;ArrayList&lt;Card> newDeckOfCards = new ArrayList (deckOfCards.subList(deckOfCards.size() - n, deckOfCards.size()));&#xA;&#x9;&#x9;cardHand.handOfCards = newDeckOfCards;&#xA;&#x9;&#x9;deckOfCards = new ArrayList (deckOfCards.subList(0, deckOfCards.size() - n));&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck deck1 = new CardDeck(6);&#xA;&#x9;&#x9;CardHand hand1 = new CardHand();&#xA;&#x9;&#x9;deck1.deal(hand1, 10);&#xA;&#x9;&#x9;System.out.println(hand1.handOfCards);&#xA;&#x9;&#x9;System.out.println(deck1.deckOfCards);&#xA;&#x9;&#x9;System.out.println(deck1.getCardCount());&#xA;&#x9;&#x9;System.out.println(deck1.getCard(1));&#xA;&#x9;&#x9;deck1.shufflePerfectly();&#xA;&#x9;&#x9;System.out.println(deck1.deckOfCards);&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957239308" sizeMeasure="84" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="1944" end="-244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957250242" sizeMeasure="84" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="10" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="1944" end="-244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957274495" sizeMeasure="85" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deck1.deckOfCards" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="1970" end="-244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957295564" sizeMeasure="85" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(deck1.deckOfCards);&#xA;&#x9;&#x9;deck1.deal(hand1, 10" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1926" end="-244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957433253" sizeMeasure="86" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="hand1.play(5)" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="2052" end="-203"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957716753" sizeMeasure="82" errorCount="1" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="hand1.addCard(" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="2070" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958588543" sizeMeasure="86" errorCount="1" warningCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Card> newestDeck = new ArrayList();&#xA;&#x9;&#x9;for (int i = newDeckOfCards.size(); i > 0; i--) {&#xA;&#x9;&#x9;&#x9;newestDeck.add(newDeckOfCards.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;cardHand.handOfCards = newestDeck" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1683" end="-373"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958609199" sizeMeasure="85" warningCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="2211" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958675213" sizeMeasure="85" warningCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;cardHand.handOfCards = newestDeck;&#xA;&#x9;&#x9;deckOfCards = new ArrayList (deckOfCards.subList(0, deckOfCards.size() - n));&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck deck1 = new CardDeck(6);&#xA;&#x9;&#x9;CardHand hand1 = new CardHand();&#xA;&#x9;&#x9;System.out.println(deck1.deckOfCards);&#xA;&#x9;&#x9;deck1.deal(hand1, 10);&#xA;&#x9;&#x9;System.out.println(hand1.handOfCards);&#xA;&#x9;&#x9;System.out.println(hand1.play(5)" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1819" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487956880652" sizeMeasure="39">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;&#xA;import objectstructures.Card;&#xA;&#xA;public class CardHand {&#xA;&#x9;ArrayList&lt;Card> handOfCards;&#xA;&#x9;&#xA;&#x9;public CardHand(){&#xA;&#x9;&#x9;this.handOfCards = new ArrayList&lt;Card>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addCard(Card newCard){&#xA;&#x9;&#x9;handOfCards.add(newCard);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card play (int n){&#xA;&#x9;&#x9;Card newCard = getCard(n);&#xA;&#x9;&#x9;handOfCards.remove(n);&#xA;&#x9;&#x9;return newCard;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount(){&#xA;&#x9;&#x9;return handOfCards.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n > getCardCount() -1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are outside the deck of cards&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return handOfCards.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487957955184" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardHand cardHand = new CardHand();&#xA;&#x9;&#x9;CardDeck cardDeck = new CardDeck(13);&#xA;&#x9;&#x9;cardDeck.deal(cardHand, 5);" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="644" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958016418" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(cardHand.getCardCount()" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="795" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958027631" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(4" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="831" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958076118" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;cardHand.play(3" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="838" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958103971" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(cardHand.handOfCards" edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="858" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958131246" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+1" edit="/1/@proposals.0/@proposals.2/@attempts.5/@edit" start="361" end="-549"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958147953" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=");&#xA;&#x9;&#x9;return newCard;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount(){&#xA;&#x9;&#x9;return handOfCards.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n > getCardCount() -1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are outside the deck of cards&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return handOfCards.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardHand cardHand = new CardHand();&#xA;&#x9;&#x9;CardDeck cardDeck = new CardDeck(13);&#xA;&#x9;&#x9;cardDeck.deal(cardHand, 5);&#xA;&#x9;&#x9;System.out.println(cardHand.getCard(3" edit="/1/@proposals.0/@proposals.2/@attempts.6/@edit" start="361" end="-77"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487958173487" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="handOfCards" edit="/1/@proposals.0/@proposals.2/@attempts.7/@edit" start="824" end="-119"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487957142165" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487957230604" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487957239214" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487957250132" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487957274401" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487957295454" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487957433155" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958588464" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958609105" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958675133" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487957955020" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958016340" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958027584" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958075993" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958103877" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958131183" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958147854" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487958173404" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487957765776" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488285243840" completion="1.0" successCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487956882138" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487958720990" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488283653102" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488285222681" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487956887255" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487957718085" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487958205377" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487958725173" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488285237048" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
