<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Partner">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Partner class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Partner class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PartnerTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PartnerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Partner" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488275611578" sizeMeasure="86">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Partner {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private Partner partner;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Partner(String name) &#xA;&#x9;{&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName() &#xA;&#x9;{&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Partner getPartner() &#xA;&#x9;{&#xA;&#x9;&#x9;if (partner != null) {&#xA;&#x9;&#x9;&#x9;return partner;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPartner(Partner partner) {&#xA;&#x9;&#x9;if (this.partner == partner) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;if (oldPartner != null &amp;&amp; oldPartner.getPartner() == this) {&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner(null);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.partner != null) {&#xA;&#x9;&#x9;&#x9;this.partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(){&#xA;&#x9;&#x9;Partner p1 = new Partner(&quot;aksel&quot;);&#xA;&#x9;&#x9;Partner p2 = new Partner(&quot;Stine&quot;);&#xA;&#x9;&#x9;Partner p3 = new Partner(&quot;Sofie&quot;);&#xA;&#x9;       &#xA;&#x9;&#x9;System.out.println(p1.getName() + &quot; has been added...&quot;);&#xA;&#x9;&#x9;System.out.println(p2.getName() + &quot; has been added...&quot;);&#xA;&#x9;&#x9;System.out.println(p3.getName() + &quot; has been added...&quot;);&#xA;&#x9;&#x9;System.out.println();&#xA;&#x9;&#x9;&#x9;       &#xA;&#x9;&#x9;System.out.println(p1.getName() + &quot;'s partner: null&quot;);&#xA;&#x9;&#x9;System.out.println(p2.getName() + &quot;'s partner: null&quot;);&#xA;&#x9;&#x9;System.out.println(p3.getName() + &quot;'s partner: null&quot;);&#xA;&#x9;&#x9;System.out.println();&#xA;&#x9;&#x9;&#x9; &#xA;&#x9;&#x9;System.out.println(&quot;** Connecting &quot; + p1.getName() + &quot; to &quot; + p2.getName() + &quot;...&quot;);&#xA;&#x9;&#x9;p1.setPartner(p2);&#xA;&#x9;&#x9;&#x9;       &#xA;&#x9;&#x9;System.out.println(p1.getName() + &quot;'s partner: &quot; + p1.getPartner().getName());&#xA;&#x9;&#x9;System.out.println(p2.getName() + &quot;'s partner: &quot; + p2.getPartner().getName());&#xA;&#x9;&#x9;System.out.println(p3.getName() + &quot;'s partner: null&quot;);&#xA;&#x9;&#x9;System.out.println();&#xA;&#x9;&#x9;&#x9;       &#xA;&#x9;&#x9;System.out.println(&quot;** Connecting &quot; + p1.getName() + &quot; to &quot; + p3.getName() + &quot; instead...&quot;);&#xA;&#x9;&#x9;p1.setPartner(p3);&#xA;&#x9;&#x9;&#x9;       &#xA;&#x9;&#x9;System.out.println(p1.getName() + &quot;'s partner: &quot; + p1.getPartner().getName());&#xA;&#x9;&#x9;System.out.println(p2.getName() + &quot;'s partner: null&quot;);&#xA;&#x9;&#x9;System.out.println(p3.getName() + &quot;'s partner: &quot; + p3.getPartner().getName());&#xA;&#x9;&#x9;System.out.println();&#xA;&#x9;&#x9;&#x9;       &#xA;&#x9;&#x9;System.out.println(&quot;** Separating &quot; + p1.getName() + &quot; from his partner...&quot;);&#xA;&#x9;&#x9;p1.setPartner(null);&#xA;&#x9;&#x9;&#x9;       &#xA;&#x9;&#x9;&#x9;        &#xA;&#x9;&#x9;System.out.println(p1.getName() + &quot;'s partner: null&quot;);&#x9;        &#xA;&#x9;&#x9;System.out.println(p2.getName() + &quot;'s partner: null&quot;);&#xA;&#x9;&#x9;&#x9;        &#xA;&#x9;&#x9;System.out.println(p3.getName() + &quot;'s partner: null&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println();&#xA;&#x9;&#x9;&#x9;    }&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488275748963" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String[] args" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="680" end="-1646"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488353575384" sizeMeasure="50" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="817" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354807147" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Anna&quot;);&#xA;&#x9;&#x9;Partner p2 = new Partner(&quot;Peter&quot;);&#xA;&#x9;&#x9;Partner p3 = new Partner(&quot;Odd&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println();" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="724" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488354831720" sizeMeasure="50" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="808" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488275754243" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488275785960" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353572965" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488353587053" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488354983226" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488275935216" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488353598917" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488354809526" completion="0.0" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488354834046" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488354921815" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
