<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053199837" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053239001" sizeMeasure="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="48" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053401279" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public Tweet (TwitterAccount name, String string) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="52" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053499084" sizeMeasure="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String text;&#xA;&#x9;TwitterAccount owner;&#xA;&#x9;int retweets;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="51" end="-126"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053641134" sizeMeasure="41" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Count;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String string) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#xA;&#x9;private void setText(String text) {&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#xA;&#x9;private void setOwner(TwitterAccount owner) {&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#xA;} // end class" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="99" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053726377" sizeMeasure="39" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) {&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;private void setText(String text) {&#xA;&#x9;&#x9;this.text = text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#x9;}&#xA;&#xA;&#x9;private void setOwner(TwitterAccount owner) {&#xA;&#x9;&#x9;this.owner = owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="167" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053794717" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="text) {&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;retweetCount = 0;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) {&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="153" end="-91"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053820868" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.owner = name" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="183" end="-271"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053855922" sizeMeasure="36" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (this.owner == name) {&#xA;&#x9;&#x9;&#x9;throw IllegalArgumentException&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="281" end="-190"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488054042433" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new IllegalArgumentException (&quot;You Can't retweet from yourself!&quot;) ;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="317" end="-193"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488054257943" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="352" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488055243418" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public Tweet (TwitterAccount name, String text) {&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;retweetCount = 0;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) {&#xA;&#x9;&#x9;if (this.owner == name) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;retweetCount++ ;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.retweetCount != 0) {&#xA;&#x9;&#x9;&#x9;return null;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return this.Tweet;&#xA;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="111" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488055815546" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;retweetCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retwwting&#xA;&#x9;&#x9;if (this.owner == name) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;retweetCount++ ;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.retweetCount != 0) {&#xA;&#x9;&#x9;&#x9;return null;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return this;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="111" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488055947958" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="747" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056366296" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" name.getUserName() == tweet.getOwner().getUserName() " edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="311" end="-486"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056438037" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.owner = tweet.getOwner" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="482" end="-375"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056448799" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="883" end="-884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056592352" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ee" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="299" end="-584"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056738676" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="786" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057029937" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;retweetCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equalsIgnoreCase(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = tweet.getOwner();&#xA;&#x9;&#x9;retweetCount++ ;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.retweetCount != 0) {&#xA;&#x9;&#x9;&#x9;return null;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="109" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057179458" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="336" end="-550"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057297375" sizeMeasure="45" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="IgnoreCase(tweet.getOwner().getUserName()) ==" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="336" end="-518"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057326481" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.retweetCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equalsIgnoreCase(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = tweet.getOwner();&#xA;&#x9;&#x9;this." edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="218" end="-366"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059298163" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="341" end="-555"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488061967404" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String text;&#xA;&#x9;private TwitterAccount owner;&#xA;&#x9;private " edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="51" end="-808"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068295046" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Tweet [text =&quot; + text + &quot;, owner =&quot; + owner + &quot;, retweetCount =&quot; + retweetCount + &quot;]&quot;;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="855" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068553207" sizeMeasure="52" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int retweetCount;&#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;this.retweetCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = tweet.getOwner();&#xA;&#x9;&#x9;int n = tweet.getRetweetCount();&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="104" end="-492"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068591788" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.setRetweetCount(n+1);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="576" end="-486"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068602404" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#xA;&#x9;&#xA;&#x9;public void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="605" end="-489"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068695911" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="974" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068753352" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Tweet [text=&quot; + text + &quot;]&quot;;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="974" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068837104" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="916" end="-206"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488069089256" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.retweetCount == 0 ) {&#xA;&#x9;&#x9;&#x9;return null; &#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;Tweet e = null;&#xA;&#x9;&#x9;&#x9;return e;&#x9;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="607" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488069198378" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this;&#x9;&#x9;} // AAARGH" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="955" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488069289024" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet e = new Tweet( this.getOwner(), this.getText() ) ;&#xA;&#x9;&#x9;&#x9;return e;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="955" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488069819665" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1032" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070085469" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int retweetCount;&#xA;&#x9;private Tweet originalTweet; " edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="104" end="-981"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070150648" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="riginalTweet; &#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;this.retweetCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = tweet.getOwner();&#xA;&#x9;&#x9;int n = tweet.getRetweetCount();&#xA;&#x9;&#x9;tweet.setRetweetCount(n+1);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.retweetCount == 0 ) {&#xA;&#x9;&#x9;&#x9;return null; &#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;Tweet e = new Tweet( this.getOwner(), this.getText() ) ;&#xA;&#x9;&#x9;&#x9;return e;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;*/" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="145" end="-71"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070174232" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="145" end="-1005"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070239355" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = tweet.getOwner();&#xA;&#x9;&#x9;int n = tweet.getRetweetCount();&#xA;&#x9;&#x9;tweet.setRetweetCount(n+1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setOriginalTweet(Tweet originalTweet) {&#xA;&#x9;&#x9;this.originalTweet = originalTweet;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="297" end="-258"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070566560" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.originalTweet = new Tweet (name,tweet.getText());&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="645" end="-326"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070609050" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" tweet.getText());&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return this." edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="682" end="-277"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070643815" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner()" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="677" end="-616"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070754469" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//private Tweet originalTweet; &#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;this.retweetCount = 0;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = tweet.getOwner();&#xA;&#x9;&#x9;int n = tweet.getRetweetCount();&#xA;&#x9;&#x9;tweet.setRetweetCount(n+1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.retweetCount == 0 ) {&#xA;&#x9;&#x9;&#x9;return null; &#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;Tweet e = new Tweet( this.getOwner(), this.getText() ) ;&#xA;&#x9;&#x9;&#x9;return e;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="131" end="-71"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070801864" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="1012" end="-154"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070886660" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.setRetweetCount(tweet.getRetweetCount()" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="582" end="-527"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070898152" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" ( tweet.getRetweetCount() + 1 " edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="603" end="-525"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488070914697" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getRetweetCount() + 1" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="605" end="-525"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071111233" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private boolean isRetweet;&#xA;&#x9;//private Tweet originalTweet; &#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;this.retweetCount = 0;&#xA;&#x9;&#x9;this.isRetweet = false;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = tweet.getOwner();&#xA;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;tweet.setRetweetCount (tweet.getRetweetCount() + 1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.text;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.isRetweet" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="131" end="-184"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071138085" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet e = new Tweet( this.getOwner(), this.getText() ) ;&#xA;&#x9;&#x9;&#x9;return e;&#x9; &#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="1050" end="-78"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071187183" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="661" end="-568"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071233626" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = tweet.getOwner();&#xA;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;tweet.setRetweetCount (tweet.getRetweetCount() + 1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.text;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.isRetweet) {&#xA;&#x9;&#x9;&#x9;Tweet e = new Tweet( this.getOwner(), this.getText() ) ;&#xA;&#x9;&#x9;&#x9;return e;&#x9; &#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="568" end="-78"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071405258" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount Ole = new TwitterAccount (&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount (&quot;Per&quot;);&#xA;&#x9;&#x9;Tweet t = new Tweet (Ole, &quot;her her&quot;);&#xA;&#x9;&#x9;Tweet r = new Tweet (Per, t);&#xA;&#x9;&#x9;System.out.println(t);&#xA;&#x9;&#x9;System.out.println(r);" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="1228" end="-28"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071431719" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="1183" end="-297"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071444620" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Tweet [text=&quot; + text + &quot;, owner=&quot; + owner + &quot;]&quot;;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="1183" end="-295"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071460349" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = &quot; + text + &quot;, owner = " edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="1246" end="-314"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071589959" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="name; //" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="620" end="-965"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071632361" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="1473" end="-119"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071751520" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//tweet.getOwner();&#xA;&#x9;&#x9;&#x9;Tweet e = new Tweet( this.getOwner(), this.getText() ) ;&#xA;&#x9;&#x9;&#x9;return e;&#x9; &#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Tweet [text = &quot; + text + &quot;, owner = &quot; + owner + &quot;]&quot;;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Ole = new TwitterAccount (&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount (&quot;Per&quot;);&#xA;&#x9;&#x9;Tweet t = new Tweet (Ole, &quot;Her her&quot;);&#xA;&#x9;&#x9;Tweet r = new Tweet (Per, t);&#xA;&#x9;&#x9;System.out.println(t);&#xA;&#x9;&#x9;System.out.println(r);&#xA;&#x9;&#x9;Tweet s = r.getOriginalTweet();&#xA;&#x9;&#x9;System.out.println(s" edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="1077" end="-30"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071768500" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="620" end="-1047"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071790317" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="1048" end="-619"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071797245" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="1048" end="-619"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071876012" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private TwitterAccount n;&#xA;&#x9;//private Tweet originalTweet; &#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;this.retweetCount = 0;&#xA;&#x9;&#x9;this.isRetweet = false;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;this.n = tweet.getOwner();&#xA;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;tweet.setRetweetCount (tweet.getRetweetCount() + 1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.text;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.isRetweet) {&#xA;&#x9;&#x9;&#x9;//tweet.getOwner();&#xA;&#x9;&#x9;&#x9;Tweet e = new Tweet( this.n" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="159" end="-539"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071957323" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="355" end="-1325"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488072005971" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;private boolean isRetweet;&#xA;&#x9;private TwitterAccount n;&#xA;&#x9;//private Tweet originalTweet; &#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name" edit="/1/@proposals.0/@proposals.0/@attempts.63/@edit" start="128" end="-1325"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125448139" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(s==t);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.64/@edit" start="1630" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125478362" sizeMeasure="77" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.65/@edit" start="1089" end="-529"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125495975" sizeMeasure="76" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.66/@edit" start="163" end="-1431"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125528049" sizeMeasure="75" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = name" edit="/1/@proposals.0/@proposals.0/@attempts.67/@edit" start="163" end="-985"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125540728" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.68/@edit" start="574" end="-956"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125588386" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.setRetweetCount (tweet.getRetweetCount() + 1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.text;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.isRetweet) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.69/@edit" start="574" end="-527"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125690182" sizeMeasure="70" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate boolean isRetweet() {&#xA;&#x9;&#x9;return isRetweet;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.isRetweet) {&#xA;&#x9;&#x9;&#x9;this.getOwner()&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;" edit="/1/@proposals.0/@proposals.0/@attempts.70/@edit" start="843" end="-494"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125901533" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner(); //name&#xA;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;tweet.setRetweetCount (tweet.getRetweetCount() + 1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private Tweet getTweet() {&#xA;&#x9;&#x9;return this;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.text;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.isRetweet) {&#xA;&#x9;&#x9;&#x9;return this;" edit="/1/@proposals.0/@proposals.0/@attempts.71/@edit" start="541" end="-524"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488125994314" sizeMeasure="76" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Tweet t;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;tweet.setRetweetCount (tweet.getRetweetCount() + 1);&#xA;&#x9;&#x9;this.t = tweet" edit="/1/@proposals.0/@proposals.0/@attempts.72/@edit" start="163" end="-931"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126007416" sizeMeasure="76" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".t" edit="/1/@proposals.0/@proposals.0/@attempts.73/@edit" start="1067" end="-525"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126042366" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.74/@edit" start="759" end="-785"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126057564" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.75/@edit" start="1021" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126098735" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.isRetweet) {&#xA;&#x9;&#x9;&#x9;return this.t;" edit="/1/@proposals.0/@proposals.0/@attempts.76/@edit" start="872" end="-518"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126112114" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;" edit="/1/@proposals.0/@proposals.0/@attempts.77/@edit" start="809" end="-664"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126118631" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.78/@edit" start="755" end="-777"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126546077" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public Tweet (TwitterAccount name, String text) { //orginal tweet&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount name, Tweet tweet) { //retweeting&#xA;&#x9;&#x9;if ( name.getUserName().equals(tweet.getOwner().getUserName())  ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't retweet from yourself!&quot;) ;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = name;&#xA;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;tweet.setRetweetCount (tweet.getRetweetCount() + 1);&#xA;&#x9;&#x9;this.t = tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;&#x9;}&#x9;&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.text;&#x9;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#x9;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.isRetweet) {&#xA;&#x9;&#x9;&#x9;return this.t;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Tweet [text = &quot; + text + &quot;, owner = &quot; + owner + &quot;]&quot;;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Ole = new TwitterAccount (&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount (&quot;Per&quot;);&#xA;&#x9;&#x9;Tweet t = new Tweet (Ole, &quot;Her her&quot;);&#xA;&#x9;&#x9;Tweet r = new Tweet (Per, t);&#xA;&#x9;&#x9;System.out.println(t);&#xA;&#x9;&#x9;System.out.println(r);&#xA;&#x9;&#x9;Tweet s = r.getOriginalTweet();&#xA;&#x9;&#x9;System.out.println(s);&#xA;&#x9;&#x9;System.out.println(s == " edit="/1/@proposals.0/@proposals.0/@attempts.79/@edit" start="183" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127112403" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.80/@edit" start="1049" end="-473"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127243353" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public String toString() {&#xA;&#x9;&#x9;return &quot;Tweet :&quot; + text + &quot;|" edit="/1/@proposals.0/@proposals.0/@attempts.81/@edit" start="1049" end="-406"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127289487" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" | " edit="/1/@proposals.0/@proposals.0/@attempts.82/@edit" start="1105" end="-406"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127323336" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.83/@edit" start="1102" end="-383"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127336620" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=": " edit="/1/@proposals.0/@proposals.0/@attempts.84/@edit" start="1091" end="-392"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488195590893" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public Tweet getT() {&#xA;&#x9;&#x9;return this.t;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.85/@edit" start="755" end="-729"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488195846970" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.t = this" edit="/1/@proposals.0/@proposals.0/@attempts.86/@edit" start="292" end="-1241"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196114626" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="itterAccount Lyu = new TwitterAccount (&quot;Lyu&quot;);&#xA;&#x9;&#x9;Tweet t = new Tweet (Ole, &quot;Her her&quot;);&#xA;&#x9;&#x9;Tweet r = new Tweet (Per, t);&#xA;&#x9;&#x9;Tweet w = new Tweet (Lyu, t);&#xA;&#x9;&#x9;System.out.println(t);&#xA;&#x9;&#x9;System.out.println(r);&#xA;&#x9;&#x9;Tweet s = r.getOriginalTweet();&#xA;&#x9;&#x9;System.out.println(s);&#xA;&#x9;&#x9;System.out.println(w" edit="/1/@proposals.0/@proposals.0/@attempts.87/@edit" start="1317" end="-30"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196162953" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="r);&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.88/@edit" start="1464" end="-53"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196226382" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="v = new Tweet (Lyu, r);&#xA;&#x9;&#x9;Tweet w = v.getOriginalTweet(" edit="/1/@proposals.0/@proposals.0/@attempts.89/@edit" start="1444" end="-56"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196259562" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(w);&#xA;&#x9;&#x9;System.out.println(t" edit="/1/@proposals.0/@proposals.0/@attempts.90/@edit" start="1502" end="-56"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196266551" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.91/@edit" start="1110" end="-441"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196309564" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="r);" edit="/1/@proposals.0/@proposals.0/@attempts.92/@edit" start="1469" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196335899" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getT()" edit="/1/@proposals.0/@proposals.0/@attempts.93/@edit" start="676" end="-900"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196388583" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; t == r" edit="/1/@proposals.0/@proposals.0/@attempts.94/@edit" start="1558" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488196437034" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet q = r.getOriginalTweet();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(r);&#xA;&#x9;&#x9;System.out.println(w);&#xA;&#x9;&#x9;System.out.println(t);&#xA;&#xA;&#x9;&#x9;System.out.println(w == t &amp;&amp; t == q" edit="/1/@proposals.0/@proposals.0/@attempts.95/@edit" start="1454" end="-25"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053315796" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488055536916" sizeMeasure="16" errorCount="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;String getUserName();  //- returnerer brukernavnet&#xA;&#x9;void follow(TwitterAccount account); //- denne (this) kontoen starter å følge account&#xA;&#x9;void unfollow(TwitterAccount account); //- slutt å følge account&#xA;&#x9;boolean isFollowing(TwitterAccount account); //- returnerer om denne kontoen følger account&#xA;&#x9;boolean isFollowedBy(TwitterAccount account); //- returnerer om account følger denne kontoen&#xA;&#x9;void tweet(String); // - lager en ny tweet for denne kontoen&#xA;&#x9;void retweet(Tweet tweet); //- retweeter tweet fra denne kontoen&#xA;&#x9;Tweet getTweet(int i); //- returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;&#x9;int getTweetCount(); //- returner antall tweets til kontoen&#xA;&#x9;int getRetweetCount(); //- returner antall retweets av tweets fra denne kontoen" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="57" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488055552736" sizeMeasure="20" errorCount="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="836" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056043984" sizeMeasure="23" errorCount="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public TwitterAccount(String string) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="60" end="-832"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056054608" sizeMeasure="27" errorCount="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="60" end="-877"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056115868" sizeMeasure="28" errorCount="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String name;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.name = string;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="60" end="-883"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056170314" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="138" end="-55"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056247776" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="userName;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#x9;&#x9;}&#xA;&#xA;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="67" end="-53"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057861285" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;String userName;&#xA;&#x9;boolean follows;&#xA;&#x9;boolean followed;&#xA;&#x9;TwitterAccount &#xA;&#x9;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;void follow (TwitterAccount account) {&#xA;&#x9;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="27" end="-59"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058119828" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collection;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;String userName;&#xA;&#x9;boolean follows;&#xA;&#x9;boolean followed;&#xA;&#x9;&#xA;&#x9;public Collection &lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;public Collection &lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;void follow (TwitterAccount account) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;public Collection&lt;TwitterAccount> getFollowers() {&#xA;&#x9;&#x9;return followers;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;public void setFollowers(Collection&lt;TwitterAccount> followers) {&#xA;&#x9;&#x9;this.followers = followers;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;public Collection&lt;TwitterAccount> getFollowing() {&#xA;&#x9;&#x9;return following;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;public void setFollowing(Collection&lt;TwitterAccount> following) {&#xA;&#x9;&#x9;this.following = following;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="55" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058173966" sizeMeasure="55" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;String userName;&#xA;&#x9;boolean follows;&#xA;&#x9;boolean followed;&#xA;&#x9;&#xA;&#x9;public List &lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;public List" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="84" end="-657"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059557054" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection &lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;public Collection &lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;&#xA;&#x9;public List &lt;Tweet> tweets = new ArrayList&lt;Tweet> () ;&#xA;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;void follow (TwitterAccount account) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void unfollow" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="205" end="-445"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059581143" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;import java.util.Collection;&#x9;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;String userName;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="54" end="-868"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059589160" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1026" end="-1027"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059638869" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;import java.util.Collection; &#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="55" end="-944"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060163817" sizeMeasure="58" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="*;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;String userName;&#xA;&#x9;&#x9;&#xA;&#x9;public Set &lt;TwitterAccount> following = new HashSet &lt;TwitterAccount> () ;&#xA;&#x9;public Set &lt;TwitterAccount> followers = new HashSet " edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="44" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060352295" sizeMeasure="58" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#x9;&#x9;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;String userName;&#xA;&#x9;&#x9;&#xA;&#x9;public List &lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;public List &lt;TwitterAccount> followers = new ArrayList" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="44" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488061897583" sizeMeasure="58" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="481" end="-458"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488061969686" sizeMeasure="58" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String userName;&#xA;&#x9;&#x9;&#xA;&#x9;private List &lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;private" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="113" end="-784"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488065629275" sizeMeasure="58" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;private List &lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;&#xA;&#x9;public List &lt;Tweet> tweets = new ArrayList&lt;Tweet> () ;&#xA;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;List &lt;this>" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="142" end="-472"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488065656387" sizeMeasure="58" errorCount="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="182" end="-763"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488065707029" sizeMeasure="58" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;&#xA;&#x9;public List &lt;Tweet> tweets = new ArrayList&lt;Tweet> () ;&#xA;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;this.follow.add(account);" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="180" end="-472"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488065843508" sizeMeasure="60" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.follow.remove(account);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="541" end="-419"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488065918881" sizeMeasure="61" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if ( this.getUserName().equals(account.getUserName()) || )" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="460" end="-534"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488065926409" sizeMeasure="62" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="517" end="-535"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488065998969" sizeMeasure="62" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=") {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="514" end="-534"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066214425" sizeMeasure="64" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; " edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="594" end="-536"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066459391" sizeMeasure="66" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (! this.follow.contains(account)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't unfollow someone you're not following!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="796" end="-421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066464918" sizeMeasure="66" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="1383" end="-1384"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066476399" sizeMeasure="64" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="963" end="-416"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066555506" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#xA;&#xA;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;} // end class" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="963" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066564862" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //end main" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="1016" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066575622" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (! this.follow.contains(account)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't unfollow someone you're not following!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;} // end unfollow" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="743" end="-82"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066781736" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public String getUserName() {&#xA;&#x9;&#x9;return userName;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private List&lt;TwitterAccount> getFollow() {&#xA;&#x9;&#x9;return this.follow;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if ( this.getUserName().equals(account.getUserName()) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; &#x9;}&#xA;&#x9;&#x9;this.follow.add(account);&#xA;&#x9;} // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (! this.follow.contains(account)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't unfollow someone you're not following!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;} // end unfollow&#xA;&#x9;&#xA;&#x9;boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;} //end main&#xA;&#xA;&#xA;&#x9;&#xA;&#xA;&#xA;} // end class&#xA;&#xA;&#xA;&#xA;&#xA;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="355" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066803049" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String userName;&#xA;&#x9;&#x9;&#xA;&#x9;private List &lt;TwitterAccount> follow = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;&#xA;&#x9;public List &lt;Tweet> tweets = new ArrayList&lt;Tweet> () ;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="54" end="-1070"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066815441" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="1062" end="-187"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066871783" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private List &lt;TwitterAccount> follow = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;private" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="138" end="-1133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488066921867" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate List&lt;Tweet> getTweets() {&#xA;&#x9;&#x9;return this.tweets;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if ( this.getUserName().equals(account.getUserName()) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; &#x9;}&#xA;&#x9;&#x9;this.follow.add(account);&#xA;&#x9;} // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (! this.follow.contains(account)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't unfollow someone you're not following!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;} // end unfollow&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;} //end main&#xA;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="473" end="-30"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067001307" sizeMeasure="64" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if ( this.getUserName().equals(account.getUserName()) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; &#x9;}&#xA;&#x9;&#x9;this.follow.add(account);&#xA;&#x9;} // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (! this.follow.contains(account)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't unfollow someone you're not following!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;} // end unfollow&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="527" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067011405" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="339" end="-1081"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067118798" sizeMeasure="68" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void tweet (String text) {&#xA;&#x9;&#x9;Tweet t = new Tweet(this,text);&#xA;&#x9;&#x9;tweets.add(t);&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="1328" end="-97"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067158677" sizeMeasure="71" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private List&lt;TwitterAccount> getFollow() {&#xA;&#x9;&#x9;return this.follow;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private List&lt;Tweet> getTweets() {&#xA;&#x9;&#x9;return this.tweets;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if ( this.getUserName().equals(account.getUserName()) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; &#x9;}&#xA;&#x9;&#x9;this.follow.add(account);&#xA;&#x9;&#x9;} // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (! this.follow.contains(account)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't unfollow someone you're not following!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="339" end="-414"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067171757" sizeMeasure="73" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="1221" end="-189"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067213301" sizeMeasure="73" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his." edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="1408" end="-112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067239992" sizeMeasure="73" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" (this , " edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="1392" end="-126"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067319508" sizeMeasure="77" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet t = new Tweet (this , twee" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="1434" end="-101"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067332562" sizeMeasure="78" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="r = new Tweet (this , tweet);&#xA;&#x9;&#x9;this.tweets.add(r" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="1481" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067449767" sizeMeasure="82" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;List&lt;Tweet> liste = this.getTweets();&#xA;&#x9;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="1537" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067655532" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0,t);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this , tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r);&#xA;&#x9;&#x9;}&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;List&lt;Tweet> liste = this.getTweets();&#xA;&#x9;&#x9;return liste.get(i" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="1426" end="-102"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067694323" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.getTweets().get(i);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="1576" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067763473" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // the new thing is first in line&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this , tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r); // the new thing is first in line" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="1431" end="-169"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067803811" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="1610" end="-165"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067860469" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private List &lt;Tweet> re" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="269" end="-1541"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067938201" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int t,r;&#xA;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;&#x9;t = 0;&#xA;&#x9;&#x9;r = 0" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="270" end="-1437"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067944954" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;r = 0;" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="358" end="-1435"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488067985795" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.r++;" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="1633" end="-171"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068010691" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.t++;" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="1494" end="-322"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068065105" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weetCount,retweetCount;&#xA;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;&#x9;tweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;retweetCount = 0;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private List&lt;TwitterAccount> getFollow() {&#xA;&#x9;&#x9;return this.follow;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private List&lt;Tweet> getTweets() {&#xA;&#x9;&#x9;return this.tweets;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if ( this.getUserName().equals(account.getUserName()) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; &#x9;}&#xA;&#x9;&#x9;this.follow.add(account);&#xA;&#x9;&#x9;} // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (! this.follow.contains(account)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't unfollow someone you're not following!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;&#x9;} // end unfollow&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet (String text) {&#xA;&#x9;&#x9;Tweet t = new Tweet (this , text);&#xA;&#x9;&#x9;this.tweets.add(0,t); // the new thing is first in line&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this , tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r); // the new thing is first in line&#xA;&#x9;&#x9;this.retweetCount" edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="275" end="-174"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068114397" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="1796" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068127876" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="1913" end="-32"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068275449" sizeMeasure="99">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;TwitterAccount [userName =&quot; + userName + &quot;, follow =&quot; + follow + &quot;, tweets =&quot; + tweets &#xA;&#x9;&#x9;&#x9;&#x9;+ &quot;, tweetCount =&quot; + tweetCount + &quot;, retweetCount =&quot; + retweetCount + &quot;]&quot;;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="1916" end="-77"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488068287534" sizeMeasure="99">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="2130" end="-80"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488069397876" sizeMeasure="99">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//if (! this.follow.contains(account)) {&#xA;&#x9;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="1007" end="-1164"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488069679815" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="1007" end="-1072"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071504204" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.follow.remove(account);&#xA;&#x9;&#x9;} // end unfollow&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet (String text) {&#xA;&#x9;&#x9;Tweet t = new Tweet (this , text);&#xA;&#x9;&#x9;this.tweets.add(0,t); // the new thing is first in line&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this , tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r); // the new thing is first in line&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;return this.getTweets().get(i);&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;TwitterAccount [userName = &quot; + userName + &quot;]&quot;;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="1007" end="-77"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488071619726" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot; + userName + &quot;" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="1842" end="-87"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126470545" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="1864" end="-79"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126754981" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.tweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;this.retweetCount = 0;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private List&lt;TwitterAccount> getFollow() {&#xA;&#x9;&#x9;return this.follow;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private List&lt;Tweet> getTweets() {&#xA;&#x9;&#x9;return this.tweets;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if ( this.getUserName().equals(account.getUserName()) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; &#x9;}&#xA;&#x9;&#x9;this.follow.add(account);&#xA;&#x9;&#x9;} // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;&#x9;} // end unfollow&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet (String text) {&#xA;&#x9;&#x9;Tweet t = new Tweet (this , text);&#xA;&#x9;&#x9;this.tweets.add(0,t); // the new thing is first in line&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this , tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r); // the new thing is first in line&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;return this.getTweets().get(i);&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;TwitterAccount &quot; + userName + &quot;&quot;;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="373" end="-79"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126767202" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.67/@edit" start="1665" end="-226"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126793408" sizeMeasure="97" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount Ole = new TwitterAccount (&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount (&quot;Per&quot;);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.68/@edit" start="1916" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127000227" sizeMeasure="100">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Ole = new TwitterAccount (&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount (&quot;Per&quot;);&#xA;&#x9;&#x9;Ole.tweet(&quot;Her er noe&quot;);&#xA;&#x9;&#x9;Per.tweet(&quot;EEERjr&quot;);&#xA;&#x9;&#x9;Tweet t = Ole.getTweet(0);&#xA;&#x9;&#x9;Per.retweet(t);&#xA;&#x9;&#x9;System.out.println(Ole.getTweets());&#xA;&#x9;&#x9;System.out.println(Per.getTweets()" edit="/1/@proposals.0/@proposals.1/@attempts.69/@edit" start="1785" end="-40"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127061601" sizeMeasure="106">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;TwitterAccount &quot; + userName + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;\n follow =&quot; + follow + &quot;\n tweets =&quot; + tweets + &quot;]&quot;;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.70/@edit" start="1789" end="-357"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127093460" sizeMeasure="99">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.71/@edit" start="1787" end="-357"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127136723" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;TwitterAccount [userName=&quot; + userName + &quot;, follow=&quot; + follow + &quot;]&quot;;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.72/@edit" start="1789" end="-357"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127187542" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;TwitterAccount &quot; + userName + &quot;\n tweets = &quot; + tweets + &quot;]&quot;;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Ole = new TwitterAccount (&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount (&quot;Per&quot;);&#xA;&#x9;&#x9;Ole.tweet(&quot;Her er noe&quot;);&#xA;&#x9;&#x9;Per.tweet(&quot;EEERjr&quot;);&#xA;&#x9;&#x9;Tweet t = Ole.getTweet(0);&#xA;&#x9;&#x9;Per.retweet(t);&#xA;&#x9;&#x9;System.out.println(Ole.getTweets());&#xA;&#x9;&#x9;System.out.println(Per.getTweets());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.73/@edit" start="1785" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127205258" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.74/@edit" start="1860" end="-365"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127294182" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" som skal retweetes!&quot;);&#xA;&#x9;&#x9;Per.tweet(&quot;Egen tweet!" edit="/1/@proposals.0/@proposals.1/@attempts.75/@edit" start="2034" end="-168"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127447567" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweets.add(0,tweet" edit="/1/@proposals.0/@proposals.1/@attempts.76/@edit" start="1474" end="-719"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127515536" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.77/@edit" start="1492" end="-724"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127702571" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="t); // the new thing is first in line&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(tweet); // the new thing is first in line&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;int l = this.getTweets().size();&#xA;&#x9;&#x9;return this.getTweets().get(l-i) " edit="/1/@proposals.0/@proposals.1/@attempts.78/@edit" start="1368" end="-588"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127848069" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this." edit="/1/@proposals.0/@proposals.1/@attempts.79/@edit" start="1709" end="-485"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127894177" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0,t); // the new thing is first in line&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(0,tweet); // the new thing is first in line&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;//int l = this.getTweets().size();&#xA;&#x9;&#x9;return this.getTweets().get(" edit="/1/@proposals.0/@proposals.1/@attempts.80/@edit" start="1368" end="-601"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488127919519" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//System.out.println(Ole.getTweets());&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.81/@edit" start="2149" end="-76"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128048133" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="t); &#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(tweet); &#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;int l = this.getTweets().size()-1;&#xA;&#x9;&#x9;return this.getTweets().get(l-" edit="/1/@proposals.0/@proposals.1/@attempts.82/@edit" start="1368" end="-605"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128077393" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0,tweet); &#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;int l = this.getTweets().size()" edit="/1/@proposals.0/@proposals.1/@attempts.83/@edit" start="1455" end="-639"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128117129" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0,t); &#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(0,tweet); &#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;//int l = this.getTweets().size();&#xA;&#x9;&#x9;return this.getTweets().get(" edit="/1/@proposals.0/@proposals.1/@attempts.84/@edit" start="1368" end="-605"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128226367" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.85/@edit" start="1532" end="-636"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128609391" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", text);&#xA;&#x9;&#x9;this.tweets.add(0,t); &#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this, tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r); &#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {" edit="/1/@proposals.0/@proposals.1/@attempts.86/@edit" start="1340" end="-636"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128664125" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="} // end class&#xA;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.87/@edit" start="2168" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128709384" sizeMeasure="100">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private List&lt;Tweet> getTweets() {&#xA;&#x9;&#x9;return this.tweets;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.88/@edit" start="546" end="-1583"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128860021" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList &lt;TwitterAccount> follow = new ArrayList&lt;TwitterAccount> () ;&#xA;&#x9;private ArrayList &lt;Tweet> tweets = new ArrayList&lt;Tweet> () ;&#xA;&#x9;int tweetCount,retweetCount;&#xA;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;&#x9;this.tweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;this.retweetCount = 0;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;TwitterAccount> getFollow() {&#xA;&#x9;&#x9;return this.follow;&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private Array" edit="/1/@proposals.0/@proposals.1/@attempts.89/@edit" start="146" end="-1631"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128935660" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.90/@edit" start="2212" end="-2213"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128974602" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.91/@edit" start="1512" end="-699"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488128989526" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.92/@edit" start="1386" end="-823"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129015862" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0,t); &#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this, tweet);&#xA;&#x9;&#x9;this.tweets.add(0," edit="/1/@proposals.0/@proposals.1/@attempts.93/@edit" start="1386" end="-699"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129069645" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Tweet> l = this.getTweets();&#xA;&#x9;&#x9;return l" edit="/1/@proposals.0/@proposals.1/@attempts.94/@edit" start="1583" end="-607"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129092549" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+1" edit="/1/@proposals.0/@proposals.1/@attempts.95/@edit" start="1638" end="-601"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129110945" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.96/@edit" start="1638" end="-601"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129146169" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.1/@attempts.97/@edit" start="1638" end="-601"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129188197" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.getTweets()" edit="/1/@proposals.0/@proposals.1/@attempts.98/@edit" start="1583" end="-609"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129202657" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &lt;TwitterAccount> getFollow() {&#xA;&#x9;&#x9;return this.follow;&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private ArrayList " edit="/1/@proposals.0/@proposals.1/@attempts.99/@edit" start="509" end="-1629"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129214773" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &lt;TwitterAccount> () ;&#xA;&#x9;private ArrayList &lt;Tweet> tweets = new ArrayList " edit="/1/@proposals.0/@proposals.1/@attempts.100/@edit" start="195" end="-1951"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129440237" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount Nils = new TwitterAccount (&quot;Nils&quot;);&#xA;&#x9;&#x9;Ole.tweet(&quot;Her er noe som skal retweetes!&quot;);&#xA;&#x9;&#x9;Per.tweet(&quot;Egen tweet!&quot;);&#xA;&#x9;&#x9;Nils.tweet(&quot;Kvitre kvitre!&quot;);&#xA;&#x9;&#x9;Tweet t = Ole.getTweet(0);&#xA;&#x9;&#x9;Per.retweet(t);&#xA;&#x9;&#x9;//System.out.println(Ole.getTweets());&#xA;&#x9;&#x9;//System.out.println(Per.getTweets());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.101/@edit" start="1981" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129464233" sizeMeasure="104" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;int " edit="/1/@proposals.0/@proposals.1/@attempts.102/@edit" start="296" end="-2010"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129484995" sizeMeasure="104" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int tweetCount;&#xA;&#x9;private " edit="/1/@proposals.0/@proposals.1/@attempts.103/@edit" start="282" end="-2014"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129697628" sizeMeasure="110" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate void setTweetCount(int tweetCount) {&#xA;&#x9;&#x9;this.tweetCount = tweetCount;&#x9;&#x9;}&#xA;&#xA;&#x9;private void setRetweetCount(int retweetCount) {&#xA;&#x9;&#x9;this.retweetCount = retweetCount;&#x9;&#x9;}&#xA;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if ( this.getUserName().equals(account.getUserName()) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; &#x9;}&#xA;&#x9;&#x9;this.follow.add(account);&#xA;&#x9;&#x9;} // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;&#x9;} // end unfollow&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet (String text) {&#xA;&#x9;&#x9;Tweet t = new Tweet (this, text);&#xA;&#x9;&#x9;this.tweets.add(0,t); &#xA;&#x9;&#x9;this.setRetweetCount(this.getRetweetCount()+1)" edit="/1/@proposals.0/@proposals.1/@attempts.104/@edit" start="664" end="-891"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129722310" sizeMeasure="110" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TweetCount(this.getTweetCount()+1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this, tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r); &#xA;&#x9;&#x9;this.setRetweetCount(this.getRetweetCount()+1)" edit="/1/@proposals.0/@proposals.1/@attempts.105/@edit" start="1601" end="-763"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129784118" sizeMeasure="112" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetCount++;&#xA;&#x9;&#x9;//this.setTweetCount(this.getTweetCount()+1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this, tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r); &#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.106/@edit" start="1598" end="-809"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129834670" sizeMeasure="113" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//this.tweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;//this.retweetCount = 0;&#x9;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.107/@edit" start="406" end="-2148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129857878" sizeMeasure="113" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.108/@edit" start="2465" end="-142"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129909462" sizeMeasure="114" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Ole.getTweets(" edit="/1/@proposals.0/@proposals.1/@attempts.109/@edit" start="2489" end="-124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129943868" sizeMeasure="115" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(Ole.getTweetCount()" edit="/1/@proposals.0/@proposals.1/@attempts.110/@edit" start="2508" end="-124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129963124" sizeMeasure="115" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Per" edit="/1/@proposals.0/@proposals.1/@attempts.111/@edit" start="2527" end="-140"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129973260" sizeMeasure="115" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Re" edit="/1/@proposals.0/@proposals.1/@attempts.112/@edit" start="2534" end="-135"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488129991021" sizeMeasure="115" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="t" edit="/1/@proposals.0/@proposals.1/@attempts.113/@edit" start="2536" end="-135"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488130011041" sizeMeasure="115" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.114/@edit" start="2671" end="-2672"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488130071869" sizeMeasure="116" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet w = Nils.getTweet(1);&#xA;&#x9;&#x9;Per.retweet(t);&#xA;&#x9;&#x9;Per.retweet(w" edit="/1/@proposals.0/@proposals.1/@attempts.115/@edit" start="2471" end="-169"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488130092233" sizeMeasure="116" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.116/@edit" start="2623" end="-76"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488130114472" sizeMeasure="117" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(Per.getT" edit="/1/@proposals.0/@proposals.1/@attempts.117/@edit" start="2582" end="-133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488130247145" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.118/@edit" start="671" end="-1902"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488130268642" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;this.retweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private ArrayList &lt;TwitterAccount> getFollow() {&#xA;&#x9;&#x9;return this.follow;&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private ArrayList &lt;Tweet> getTweets() {&#xA;&#x9;&#x9;return this.tweets;&#x9;&#x9;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.119/@edit" start="406" end="-1902"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488130309014" sizeMeasure="111" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.120/@edit" start="2343" end="-223"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488130317637" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.121/@edit" start="2343" end="-223"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488131827681" sizeMeasure="111" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList &lt;Tweet> retweets = new ArrayList &lt;Tweet> () ;&#xA;&#x9;//private int tweetCount;&#xA;&#x9;//private int retweetCount;&#xA;&#xA;&#x9;public TwitterAccount(String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;&#x9;this.tweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;this.retweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private ArrayList &lt;TwitterAccount> getFollow() {&#xA;&#x9;&#x9;return this.follow;&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;private ArrayList &lt;Tweet> getTweets() {&#xA;&#x9;&#x9;return this.tweets;&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if ( this.getUserName().equals(account.getUserName()) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You can't follow yourself!&quot;) ;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ( this.follow.contains(account) ) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;You're already a follower!&quot;) ;&#x9; &#x9;}&#xA;&#x9;&#x9;this.follow.add(account);&#xA;&#x9;&#x9;} // end follow&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;this.follow.remove(account);&#xA;&#x9;&#x9;} // end unfollow&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return (this.follow.contains(account));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return (account.getFollow().contains(this));&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet (String text) {&#xA;&#x9;&#x9;Tweet t = new Tweet (this, text);&#xA;&#x9;&#x9;this.tweets.add(0,t); &#xA;&#x9;&#x9;//this.tweetCount++;&#xA;&#x9;&#x9;//this.setTweetCount(this.getTweetCount()+1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet (Tweet tweet) {&#xA;&#x9;&#x9;Tweet r = new Tweet (this, tweet);&#xA;&#x9;&#x9;this.tweets.add(0,r); &#xA;&#x9;&#x9;this.retweets.add(0,r);&#xA;&#x9;&#x9;//this.retweetCount++;&#xA;&#x9;&#x9;//this.setRetweetCount(this.getRetweetCount()+1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet (int i) {&#xA;&#x9;&#x9;return this.getTweets().get(i-1) ;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;TwitterAccount &quot; + userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Ole = new TwitterAccount (&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount (&quot;Per&quot;);&#xA;&#x9;&#x9;TwitterAccount Nils = new TwitterAccount (&quot;Nils&quot;);&#xA;&#x9;&#x9;Ole.tweet(&quot;Her er noe som skal retweetes!&quot;);&#xA;&#x9;&#x9;Per.tweet(&quot;Egen tweet!&quot;);&#xA;&#x9;&#x9;Nils.tweet(&quot;Kvitre kvitre!&quot;);&#xA;&#x9;&#x9;Tweet t = Ole.getTweet(1);&#xA;&#x9;&#x9;Tweet w = Nils.getTweet(1);&#xA;&#x9;&#x9;Per.retweet(t);&#xA;&#x9;&#x9;Per.retweet(w);&#xA;&#x9;&#x9;System.out.println(Per.getRetweetCount());&#xA;&#x9;&#x9;System.out.println(Per.getTweetCount());&#xA;&#x9;&#x9;//System.out.println(Ole.getTweets());&#xA;&#x9;&#x9;System.out.println(Per.getTweets());" edit="/1/@proposals.0/@proposals.1/@attempts.122/@edit" start="290" end="-34"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488131856609" sizeMeasure="111" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s.size();&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweets.size()" edit="/1/@proposals.0/@proposals.1/@attempts.123/@edit" start="1900" end="-690"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488131890723" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//this.tweetCount = 0;&#x9;&#x9;&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.124/@edit" start="475" end="-2165"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488131912238" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.125/@edit" start="2558" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488131938698" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="w);&#xA;&#x9;&#x9;Per.retweet(t" edit="/1/@proposals.0/@proposals.1/@attempts.126/@edit" start="2446" end="-202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488132100934" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;Ole.tweet(&quot;Her er noe som skal retweetes!&quot;);&#xA;&#x9;&#x9;Per.tweet(&quot;Egen tweet!&quot;);&#xA;&#x9;&#x9;Nils.tweet(&quot;Kvitre kvitre!&quot;);&#xA;&#x9;&#x9;Nils.tweet(&quot;Tweet tweet!&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet t = Ole.getTweet(1);&#xA;&#x9;&#x9;Tweet w = Nils.getTweet(1);&#xA;&#x9;&#x9;Per.retweet(w);&#xA;&#x9;&#x9;Per.retweet(t);&#xA;&#x9;&#x9;System.out.println(Per.getRetweetCount());&#xA;&#x9;&#x9;System.out.println(Per.getTweetCount());&#xA;&#x9;&#x9;System.out.println(Ole.getTweets());&#xA;&#x9;&#x9;System.out.println(Per.getTweets());&#xA;&#x9;&#x9;&#xA;&#x9;} //end main" edit="/1/@proposals.0/@proposals.1/@attempts.127/@edit" start="2268" end="-28"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488132216504" sizeMeasure="116" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet t = Ole.getTweet(1);&#xA;&#x9;&#x9;Tweet w = Nils.getTweet(1);&#xA;&#x9;&#x9;Per.retweet(w);&#xA;&#x9;&#x9;Per.retweet(t);&#xA;&#x9;&#x9;Ole.retweet(Nils.getTweet(1));&#xA;&#x9;&#x9;System.out.println(Per.getRetweetCount());&#xA;&#x9;&#x9;System.out.println(Per.getTweetCount());&#xA;&#x9;&#x9;System.out.println(Per.getTweets());&#xA;&#x9;&#x9;System.out.println(Ole.getTweets());&#xA;&#x9;&#x9;System.out.println(Ole.getRetweetCount());&#xA;&#x9;&#x9;System.out.println(Ole.getTweetCount" edit="/1/@proposals.0/@proposals.1/@attempts.128/@edit" start="2408" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488132253256" sizeMeasure="118" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Per:&quot;);&#xA;&#x9;&#x9;System.out.println(Per.getRetweetCount());&#xA;&#x9;&#x9;System.out.println(Per.getTweetCount());&#xA;&#x9;&#x9;System.out.println(Per.getTweets());&#xA;&#x9;&#x9;System.out.println(&quot;Ole:&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.129/@edit" start="2555" end="-174"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488132269219" sizeMeasure="118" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="RetweetCount());&#xA;&#x9;&#x9;System.out.println(Ole.getTweetCount());&#xA;&#x9;&#x9;System.out.println(Ole.getTweets" edit="/1/@proposals.0/@proposals.1/@attempts.130/@edit" start="2749" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488132362436" sizeMeasure="117" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;Per.retweet(Ole.getTweet(1));&#xA;&#x9;&#x9;Per.retweet(Nils.getTweet(1)" edit="/1/@proposals.0/@proposals.1/@attempts.131/@edit" start="2408" end="-394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488132370551" sizeMeasure="118" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.132/@edit" start="2509" end="-359"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488132393856" sizeMeasure="118" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tom = new TwitterAccount (&quot;Tom&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Ole.tweet(&quot;Her er noe som skal retweetes!&quot;);&#xA;&#x9;&#x9;Per.tweet(&quot;Egen tweet!&quot;);&#xA;&#x9;&#x9;Tom.tweet(&quot;Kvitre kvitre!&quot;);&#xA;&#x9;&#x9;Tom.tweet(&quot;Tweet tweet!&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Per.retweet(Ole.getTweet(1));&#xA;&#x9;&#x9;Per.retweet(Tom.getTweet(1));&#xA;&#x9;&#x9;Ole.retweet(Tom" edit="/1/@proposals.0/@proposals.1/@attempts.133/@edit" start="2230" end="-376"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488132699235" sizeMeasure="119" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.134/@edit" start="2663" end="-202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488195277351" sizeMeasure="120" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount e = tweet.getOwner(" edit="/1/@proposals.0/@proposals.1/@attempts.135/@edit" start="1699" end="-1171"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488195409696" sizeMeasure="121" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//this.retweets.add(0,r);&#xA;&#x9;&#x9;TwitterAccount e = tweet.getOwner();&#xA;&#x9;&#x9;e.retweets.add(0,r" edit="/1/@proposals.0/@proposals.1/@attempts.136/@edit" start="1673" end="-1171"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488195800885" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//TwitterAccount e = tweet.getOwner();&#xA;&#x9;&#x9;TwitterAccount o = tweet.getT().getOwner();&#xA;&#x9;&#x9;o" edit="/1/@proposals.0/@proposals.1/@attempts.137/@edit" start="1701" end="-1188"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488055949930" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488068166039" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488068298059" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488068837016" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488070758585" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071143612" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071444528" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071460199" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071509203" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071591545" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071599186" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071605455" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071619562" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071632209" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071751356" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071768339" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071790161" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071797073" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071875832" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488071957219" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488072005767" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488124369113" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488125447829" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488125907201" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488126007261" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127323210" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127336498" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196024955" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196114485" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196162829" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196226240" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196259437" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196266395" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196309423" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196335758" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196388443" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488196439143" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488068172803" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488068294897" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488069397742" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488069745690" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488126754887" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127061466" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127093312" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127136465" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127187376" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127205135" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127245290" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127295468" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127344532" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127447440" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127847982" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127894019" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488127919380" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488128048049" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488128077289" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488128116993" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488128612079" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488128879301" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488128935563" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488128949551" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129092474" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129146090" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129838065" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129857482" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129909084" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129943716" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129962996" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129972803" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488129990879" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488130013068" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488130071585" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488130091970" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488130114311" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488130268520" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488130308947" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488130317516" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488131874859" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488131890567" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488131912072" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488131938549" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488132216420" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488132253104" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488132269045" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488132399014" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488194072846" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488194386472" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488195412289" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488055992944" completion="0.0" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488056135505" completion="0.0" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488068334594" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488068617838" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488068697244" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488068846384" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488069297176" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488070673091" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488070767638" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488071152577" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488071886377" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488071947068" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488072015588" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488072454496" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488124226633" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488124361277" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488126027025" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488196488937" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488196639017" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488069311091" completion="0.5" successCount="3" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488069407959" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488126600154" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488127394190" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488127466429" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488127800352" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488127933260" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488128059382" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488128628523" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488128958734" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488128975921" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488128991043" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488129103273" completion="0.5" successCount="3" failureCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488129164196" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488129493068" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488129739842" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488130277844" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488131970104" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194017369" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194077845" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194180716" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488195051456" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488195121007" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488195424712" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488195866195" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488196454479" completion="1.0" successCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488196645252" completion="1.0" successCount="6"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="8">
        <attempts timestamp="1488194935847"/>
        <attempts timestamp="1488194938511"/>
        <attempts timestamp="1488194939247"/>
        <attempts timestamp="1488194940075"/>
        <attempts timestamp="1488194940826"/>
        <attempts timestamp="1488194941763"/>
        <attempts timestamp="1488194942311"/>
        <attempts timestamp="1488194985834"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="12">
        <attempts timestamp="1488194921668"/>
        <attempts timestamp="1488194923372"/>
        <attempts timestamp="1488194925235"/>
        <attempts timestamp="1488194926299"/>
        <attempts timestamp="1488194928694"/>
        <attempts timestamp="1488194930152"/>
        <attempts timestamp="1488194931073"/>
        <attempts timestamp="1488194932230"/>
        <attempts timestamp="1488194934186"/>
        <attempts timestamp="1488194958287"/>
        <attempts timestamp="1488195035090"/>
        <attempts timestamp="1488195042029"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="2">
        <attempts timestamp="1488194817888"/>
        <attempts timestamp="1488195098474"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
