<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Card">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardDeck class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardHand class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardDeck class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardHand class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardDeckTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardDeckTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardHandTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardHandTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487717175500" sizeMeasure="56">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;import encapsulation.Card;&#xA;&#xA;public class CardDeck{&#xA;&#x9;&#xA;&#x9;private int cardCount=0;&#xA;&#x9;private String validSuit = &quot;SHDC&quot;;&#xA;&#x9;private List&lt;Card> cardList = new ArrayList&lt;Card>();&#xA;&#x9;&#xA;&#x9;public CardDeck(int n){&#xA;&#x9;&#x9;for (int suit=0; suit&lt;=3;suit++){&#xA;&#x9;&#x9;&#x9;for (int face=1;face&lt;=n;face++){&#xA;&#x9;&#x9;&#x9;&#x9;Card card = new Card(validSuit.charAt(suit),face);&#xA;&#x9;&#x9;&#x9;&#x9;cardList.add(card);&#xA;&#x9;&#x9;&#x9;&#x9;cardCount+=1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deal(CardHand hand, int n){&#xA;&#x9;&#x9;for(int i = 0; i &lt; n; i++){&#xA;&#x9;&#x9;&#x9;hand.addCard(cardList.get(i));&#xA;&#x9;&#x9;&#x9;cardList.remove(i);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount(){&#xA;&#x9;&#x9;return cardCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n>cardCount || n&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;We don´t have that card.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return cardList.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void shufflePerfectly(){&#xA;&#x9;&#x9;List&lt;Card> newDeck =  new ArrayList&lt;Card>(); &#xA;&#x9;&#x9;List&lt;Card> top = cardList.subList(0, cardCount/2);&#xA;&#x9;&#x9;List&lt;Card> bottom = cardList.subList(cardCount/2,cardCount);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(int j=0; j &lt; top.size();j++){&#xA;&#x9;&#x9;&#x9;newDeck.add(j*2, top.get(j));&#xA;&#x9;&#x9;&#x9;newDeck.add(j*2+1, bottom.get(j));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardList=newDeck;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487717310481" sizeMeasure="56" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="objectstructures" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="86" end="-1066"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="540" charEnd="547" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487717523187" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cardCount-1));&#xA;&#x9;&#x9;&#x9;cardList.remove(cardCount-1);&#xA;&#x9;&#x9;&#x9;cardCount-=1" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="561" end="-581"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487716666388" sizeMeasure="26">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;import encapsulation.Card;&#xA;&#xA;public class CardHand {&#xA;&#x9;&#xA;&#x9;private int cardCount=0;&#xA;&#x9;private List&lt;Card> cardList = new ArrayList&lt;Card>();&#xA;&#x9;&#xA;&#x9;public int getCardCount(){&#xA;&#x9;&#x9;return cardCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n>cardCount || n&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;We don´t have that card.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return cardList.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487716818257" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void addCard(Card card){&#xA;&#x9;&#x9;cardList.add(card);&#xA;&#x9;&#x9;cardCount+=1;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="439" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487716965717" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public Card play(int index){&#xA;&#x9;&#x9;Card usedCard = cardList.get(index);&#xA;&#x9;&#x9;cardList.remove(index);&#xA;&#x9;&#x9;cardCount-=1;&#xA;&#x9;&#x9;return usedCard" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="513" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487717347846" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="objectstructures" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="86" end="-552"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487717252097" completion="1.0" successCount="2">
          <successTests>testToString</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487717369239" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487717533915" completion="1.0" successCount="3">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487717356748" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
          <failureTests>testDealPlay</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487717440866" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
          <failureTests>testDealPlay</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487717528504" completion="1.0" successCount="3">
          <successTests>testDeal</successTests>
          <successTests>testDealPlay</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
