<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487248440288" sizeMeasure="8">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#x9;//TODO&#xA;&#x9;// Tweet(TwitterAccount, String) - En ny original-tweet&#xA;&#x9;// Tweet(TwitterAccount, Tweet) - En retweet av Tweet-argumentet. Utløser et passende unntak, &#xA;&#x9;// &#x9;&#x9;hvis original-tweeten er fra samme konto.&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487248516809" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="* TODO Constructor&#xA;&#x9; * Tweet(TwitterAccount, String) - En ny original-tweet&#xA;&#x9; * Tweet(TwitterAccount, Tweet) - En retweet av Tweet-argumentet. Utløser et passende unntak, &#xA;&#x9; * &#x9;&#x9;hvis original-tweeten er fra samme konto.&#xA;&#x9; */&#xA;&#x9;&#xA;&#x9;/* TODO methods:&#xA;&#x9; * String getText() - returnerer teksten til en tweet&#xA;&#x9; * TwitterAccount getOwner() - returnerer kontoen som tweeten kom fra&#xA;&#x9; * Tweet getOriginalTweet() - returnerer original-tweeten, hvis den er en retweet, ellers null&#xA;&#x9; * int getRetweetCount() - returnerer antall ganger denne tweeten har blitt retweetet&#xA;&#x9; */" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="50" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487248520526" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=":" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="68" end="-544"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487248599718" sizeMeasure="17">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="49" end="-566"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487249498840" sizeMeasure="47" errorCount="3" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String message;&#xA;&#x9;private TwitterAccount owner;&#xA;&#x9;private Tweet originalTweet;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;// Tweet(TwitterAccount, String) - En ny original-tweet&#xA;&#x9;public Tweet(TwitterAccount account, String s) {&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;this.message = s;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet(TwitterAccount, Tweet) - En retweet av Tweet-argumentet. Utløser et passende unntak, &#xA;&#x9;// hvis original-tweeten er fra samme konto.&#xA;&#x9;public Tweet(TwitterAccount account, Tweet t) {&#xA;&#x9;&#x9;if(account == t.getOwner())&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You cannot retweet your own tweets.&quot;);&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;this.originalTweet = t;&#xA;&#x9;&#x9;this.message = t.getText();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// String getText() - returnerer teksten til en tweet&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.message;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TwitterAccount getOwner() - returnerer kontoen som tweeten kom fra&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet getOriginalTweet() - returnerer original-tweeten, hvis den er en retweet, ellers null&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returnerer antall ganger denne tweeten har blitt retweetet&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="51" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487249550871" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet getOriginalTweet() - returnerer original-tweeten, hvis den er en retweet, ellers null&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returnerer antall ganger denne tweeten har blitt retweetet&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="940" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591068993" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;t.retweetCount++" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="698" end="-562"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591122677" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1272" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591643444" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;Tweet [message=%s, owner=%s, originalTweet=%s, retweetCount=%s]&quot;, message, owner,&#xA;&#x9;&#x9;&#x9;&#x9;originalTweet, retweetCount);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1273" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592500231" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="514" end="-842"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592513707" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(account == t.getOwner())&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You cannot retweet your own tweets.&quot;);" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="514" end="-842"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592821366" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;// void increaseCounter()&#xA;&#x9;public int increaseCounter() {&#xA;&#x9;&#x9;retweetCount++" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1272" end="-191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592826310" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1309" end="-228"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592833493" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="increaseCounter();" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="701" end="-826"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592835167" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="719" end="-826"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593010644" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;&#xA;&#x9;// Tweet(TwitterAccount, String) - En ny original-tweet&#xA;&#x9;public Tweet(TwitterAccount account, String s) {&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;this.message = s;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet(TwitterAccount, Tweet) - En retweet av Tweet-argumentet. Utløser et passende unntak, &#xA;&#x9;// hvis original-tweeten er fra samme konto.&#xA;&#x9;public Tweet(TwitterAccount account, Tweet t) {&#xA;&#x9;&#x9;if(account == t.getOwner())&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You cannot retweet your own tweets.&quot;);&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;this.originalTweet = t;&#xA;&#x9;&#x9;this.message = t.getText();&#xA;&#x9;&#x9;t.increaseCounter()" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="161" end="-826"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593393222" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="message" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1445" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593401853" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1443" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593433917" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", owner=%s, retweetCount=%s]&quot;, message, owner, retweetCount" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1443" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593458830" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweetCount=%s]&quot;, message" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1445" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593871069" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".retweetCount++;&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;this.originalTweet = t;&#xA;&#x9;&#x9;this.message = t.getText" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="624" end="-774"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593913531" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="increaseCounter();" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="625" end="-852"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593915029" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="643" end="-852"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594093558" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.originalTweet = this;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet(TwitterAccount, Tweet) - En retweet av Tweet-argumentet. Utløser et passende unntak, &#xA;&#x9;// hvis original-tweeten er fra samme konto.&#xA;&#x9;public Tweet(TwitterAccount account, Tweet t) {&#xA;&#x9;&#x9;if(account == t.getOwner())&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You cannot retweet your own tweets.&quot;);&#xA;&#x9;&#x9;t.increaseCounter();&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;this.originalTweet = t.originalTwee" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="321" end="-803"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594107645" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="343" end="-1190"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594162462" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (t.originalTweet != null)&#xA;&#x9;&#x9;&#x9;this.originalTweet = t.originalTweet;&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;this.originalTweet = " edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="699" end="-803"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594238717" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.owner = account;&#xA;&#x9;&#x9;if (t.originalTweet != null) {&#xA;&#x9;&#x9;&#x9;this.originalTweet = t.originalTweet;&#xA;&#x9;&#x9;&#x9;t.originalTweet.retweetCount++;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.originalTweet = t;&#xA;&#x9;&#x9;&#x9;t.retweetCount++;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="653" end="-801"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594244359" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1431" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594313228" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1431" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594392112" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (originalTweet != null)&#xA;&#x9;&#x9;&#x9;return this.originalTweet.retweetCount;&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;return this.retweetCount" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1407" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594409750" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1411" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594438548" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getRetweetCount()" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1468" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594565548" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.getRetweetCount()" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1637" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594588348" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="1407" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594634957" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;t.retweetCount++;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.originalTweet = t;&#xA;&#x9;&#x9;&#x9;t.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.message = t.getText();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// String getText() - returnerer teksten til en tweet&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.message;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TwitterAccount getOwner() - returnerer kontoen som tweeten kom fra&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet getOriginalTweet() - returnerer original-tweeten, hvis den er en retweet, ellers null&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returnerer antall ganger denne tweeten har blitt retweetet&#xA;&#x9;public int getRetweetCount() {&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="785" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595353780" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.originalTweet != null)&#xA;&#x9;&#x9;&#x9;return this.originalTweet.getRetweetCount();&#xA;&#x9;&#x9;else&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1428" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595410281" sizeMeasure="62" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// public int getRetweetCount() {&#xA;&#x9;//&#x9;if (this.originalTweet != null)&#xA;&#x9;//&#x9;&#x9;return this.originalTweet.getRetweetCount();&#xA;&#x9;//&#x9;else&#xA;&#x9;//&#x9;&#x9;return this.retweetCount;&#xA;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="1395" end="-144"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595431374" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int getRetweetCount() {&#xA;&#x9;&#x9;if (this.originalTweet != null)&#xA;&#x9;&#x9;&#x9;return this.originalTweet.getRetweetCount();&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1395" end="-144"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595458173" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="865" end="-843"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595475389" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="164" end="-1548"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595489365" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="161" end="-1548"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595500205" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="861" end="-843"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595527469" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;this.message = t.getText();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// String getText() - returnerer teksten til en tweet&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.message;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TwitterAccount getOwner() - returnerer kontoen som tweeten kom fra&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet getOriginalTweet() - returnerer original-tweeten, hvis den er en retweet, ellers null&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returnerer antall ganger denne tweeten har blitt retweetet&#xA;&#x9;public int getRetweetCount() {&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="861" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595577301" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 1" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="161" end="-1434"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595988212" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="844" end="-738"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595991557" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="} else {&#xA;&#x9;&#x9;&#x9;this.originalTweet = t" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="785" end="-738"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487596046399" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="161" end="-1392"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604535800" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;&#xA;&#x9;// Tweet(TwitterAccount, String) - En ny original-tweet&#xA;&#x9;public Tweet(TwitterAccount account, String s) {&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;this.message = s;&#xA;&#x9;&#x9;this.originalTweet = null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet(TwitterAccount, Tweet) - En retweet av Tweet-argumentet. Utløser et passende unntak, &#xA;&#x9;// hvis original-tweeten er fra samme konto.&#xA;&#x9;public Tweet(TwitterAccount account, Tweet t) {&#xA;&#x9;&#x9;if(account == t.getOwner())&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You cannot retweet your own tweets.&quot;);&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;if (t.originalTweet != null) {&#xA;&#x9;&#x9;&#x9;this.originalTweet = t.originalTweet;&#xA;&#x9;&#x9;&#x9;t.originalTweet.retweetCount++;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.originalTweet = t;&#xA;&#x9;&#x9;&#x9;t.retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.message = t.getText();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// String getText() - returnerer teksten til en tweet&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.message;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TwitterAccount getOwner() - returnerer kontoen som tweeten kom fra&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet getOriginalTweet() - returnerer original-tweeten, hvis den er en retweet, ellers null&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;Tweet [message=%s, retweetCount=%s]&quot;, message, retweetCount" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="161" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604560482" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;// int getRetweetCount() - returnerer antall ganger denne tweeten har blitt retweetet&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="1286" end="-133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604587272" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="161" end="-1403"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487248596936" sizeMeasure="22">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;/* TODO Constructor:&#xA;&#x9; * TwitterAccount(String) - som tar inn brukernavnet&#xA;&#x9; */&#xA;&#x9;&#xA;&#x9;/* TODO Methods:&#xA;&#x9; * String getUserName() - returnerer brukernavnet&#xA;&#x9; * void follow(TwitterAccount account) - denne (this) kontoen starter å følge account&#xA;&#x9; * void unfollow(TwitterAccount account) - slutt å følge account&#xA;&#x9; * boolean isFollowing(TwitterAccount account) - returnerer om denne kontoen følger account&#xA;&#x9; * boolean isFollowedBy(TwitterAccount account) - returnerer om account følger denne kontoen&#xA;&#x9; * void tweet(String) - lager en ny tweet for denne kontoen&#xA;&#x9; * void retweet(Tweet tweet) - retweeter tweet fra denne kontoen&#xA;&#x9; * Tweet getTweet(int i) - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;&#x9; * int getTweetCount() - returner antall tweets til kontoen&#xA;&#x9; * int getRetweetCount() - returner antall retweets av tweets fra denne kontoen&#xA;&#x9; */&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588229744" sizeMeasure="49" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String userName;&#xA;&#x9;private Collection&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;private int tweetCount;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// Constructor: TwitterAccount(String) - som tar inn brukernavnet&#xA;&#x9;public TwitterAccount(String s) {&#xA;&#x9;&#x9;this.userName = s;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// String getUserName() - returnerer brukernavnet&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TODO&#xA;&#x9;// Tweet getTweet(int i) - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getTweetCount() - returner antall tweets til kontoen&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returner antall retweets av tweets fra denne kontoen&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/* TODO Methods:&#xA;&#x9; * void follow(TwitterAccount account) - denne (this) kontoen starter å følge account&#xA;&#x9; * void unfollow(TwitterAccount account) - slutt å følge account&#xA;&#x9; * boolean isFollowing(TwitterAccount account) - returnerer om denne kontoen følger account&#xA;&#x9; * boolean isFollowedBy(TwitterAccount account) - returnerer om account følger denne kontoen&#xA;&#x9; * void tweet(String) - lager en ny tweet for denne kontoen&#xA;&#x9; * void retweet(Tweet tweet) - retweeter tweet" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="27" end="-28"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588953554" sizeMeasure="73" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// private Collection&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;// Burde denne vaere et array istedet?&#xA;&#x9;private Collection&lt;TwitterAccount> followAccounts = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private int tweetCount;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// Constructor: TwitterAccount(String) - som tar inn brukernavnet&#xA;&#x9;public TwitterAccount(String s) {&#xA;&#x9;&#x9;this.userName = s;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// String getUserName() - returnerer brukernavnet&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TODO&#xA;&#x9;// Tweet getTweet(int i) - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getTweetCount() - returner antall tweets til kontoen&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returner antall retweets av tweets fra denne kontoen&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void follow(TwitterAccount account) - denne (this) kontoen starter å følge account&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account)) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.add(account);&#xA;&#x9;    // opprett koblingen tilbake, om nødvendig&#xA;&#x9;    if (account.isFollowedBy() != this) {&#xA;&#x9;        account.follow(this);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowing(TwitterAccount account) - returnerer om denne kontoen følger account&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;if this.followAccounts.contains(account) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;/* TODO Methods:" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="144" end="-390"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589095649" sizeMeasure="82" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void unfollow(TwitterAccount account) - slutt å følge account&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowing(TwitterAccount account) - returnerer om denne kontoen følger account&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;if (this.followAccounts.contains(account))&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;else &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowedBy(TwitterAccount account) - returnerer om account følger denne kontoen&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;if (account.isFollowing(this))&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;/* TODO Methods:" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="1476" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589103615" sizeMeasure="82" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1416" end="-799"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589113321" sizeMeasure="82" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rue" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1426" end="-790"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589359888" sizeMeasure="90" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.isFollowedBy(account) != true) {&#xA;&#x9;        account.follow(this);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void unfollow(TwitterAccount account) - slutt å følge account&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account) != true) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.remove(account);&#xA;&#x9;    // fjern koblingen tilbake, om nødvendig&#xA;&#x9;    if (this.isFollowedBy(account)) {&#xA;&#x9;        account.unfollow(this);&#xA;&#x9;    }" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1395" end="-627"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589422727" sizeMeasure="93" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// void tweet(String) - lager en ny tweet for denne kontoen&#xA;&#x9;public void tweet(String s) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/* TODO Methods:" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="2344" end="-76"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589762244" sizeMeasure="97" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TODO&#xA;&#x9;// void tweet(String) - lager en ny tweet for denne kontoen&#xA;&#x9;public void tweet(String s) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TODO&#xA;&#x9;// void retweet(Tweet tweet) - retweeter tweet fra denne kontoen&#xA;&#x9;public  void retweet(Tweet tweet) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="2347" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590085090" sizeMeasure="96" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Collection&lt;Tweet> tweets = new ArrayList&lt;Tweet>();" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="144" end="-2330"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590475273" sizeMeasure="97" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// private Collection&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;private Stack tweets = new Stack();&#xA;&#x9;private Collection&lt;TwitterAccount> followAccounts = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private int tweetCount;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// Constructor: TwitterAccount(String) - som tar inn brukernavnet&#xA;&#x9;public TwitterAccount(String s) {&#xA;&#x9;&#x9;this.userName = s;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// String getUserName() - returnerer brukernavnet&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TODO&#xA;&#x9;// Tweet getTweet(int i) - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="144" end="-1792"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590688480" sizeMeasure="96" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;Tweet> tweets = new ArrayList&lt;Tweet>" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="144" end="-2334"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590847783" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.tweets.get(this.tweets.size() + 1 - i);" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="741" end="-1791"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590863438" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="783" end="-1797"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590905572" sizeMeasure="96" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="- i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getTweetCount() - returner antall tweets til kontoen&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returner antall retweets av tweets fra denne kontoen&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void follow(TwitterAccount account) - denne (this) kontoen starter å følge account&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account)) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.add(account);&#xA;&#x9;    // opprett koblingen tilbake, om nødvendig&#xA;&#x9;    if (this.isFollowedBy(account) != true) {&#xA;&#x9;        account.follow(this);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void unfollow(TwitterAccount account) - slutt å følge account&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account) != true) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.remove(account);&#xA;&#x9;    // fjern koblingen tilbake, om nødvendig&#xA;&#x9;    if (this.isFollowedBy(account)) {&#xA;&#x9;        account.unfollow(this);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowing(TwitterAccount account) - returnerer om denne kontoen følger account&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;if (this.followAccounts.contains(account))&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;else &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowedBy(TwitterAccount account) - returnerer om account følger denne kontoen&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;if (account.isFollowing(this))&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// TODO&#xA;&#x9;// void tweet(String) - lager en ny tweet for denne kontoen&#xA;&#x9;public void tweet(String s) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(s))" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="783" end="-129"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590907998" sizeMeasure="96" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="2479" end="-129"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590921150" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this, " edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="2476" end="-133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590929998" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="588" end="-2024"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590934327" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weet getTweet(int i) - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return this.tweets.get(this.tweets.size() - i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getTweetCount() - returner antall tweets til kontoen&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returner antall retweets av tweets fra denne kontoen&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void follow(TwitterAccount account) - denne (this) kontoen starter å følge account&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account)) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.add(account);&#xA;&#x9;    // opprett koblingen tilbake, om nødvendig&#xA;&#x9;    if (this.isFollowedBy(account) != true) {&#xA;&#x9;        account.follow(this);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void unfollow(TwitterAccount account) - slutt å følge account&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account) != true) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.remove(account);&#xA;&#x9;    // fjern koblingen tilbake, om nødvendig&#xA;&#x9;    if (this.isFollowedBy(account)) {&#xA;&#x9;        account.unfollow(this);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowing(TwitterAccount account) - returnerer om denne kontoen følger account&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;if (this.followAccounts.contains(account))&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;else &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowedBy(TwitterAccount account) - returnerer om account følger denne kontoen&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;if (account.isFollowing(this))&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="588" end="-260"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590936430" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="2475" end="-115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590937631" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="2475" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590958813" sizeMeasure="93" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// void retweet(Tweet tweet) - retweeter tweet fra denne kontoen&#xA;&#x9;public  void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(e)" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="2475" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591000037" sizeMeasure="93" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Tweet(tweet.getOwner(), tweet)" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="2595" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591002286" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="2630" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591013142" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="2635" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591208278" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.tweetCount++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void retweet(Tweet tweet) - retweeter tweet fra denne kontoen&#xA;&#x9;public  void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(tweet.getOwner(), tweet));&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="2470" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591235813" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.isFollowing(account" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="2266" end="-392"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591257303" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.isFollowing(this" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="2266" end="-392"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591580284" sizeMeasure="98" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount erik = new TwitterAccount(&quot;erik&quot;);&#xA;&#x9;&#x9;TwitterAccount mikkel = new TwitterAccount(&quot;mikkel&quot;)" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="2679" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591621868" sizeMeasure="109">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;System.out.println(erik);&#xA;&#x9;&#x9;System.out.println(mikkel);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&#xA;&#x9;&#x9;&#x9;&#x9;&quot;TwitterAccount [userName=%s, tweets=%s, followAccounts=%s, tweetCount=%s, retweetCount=%s]&quot;, userName,&#xA;&#x9;&#x9;&#x9;&#x9;tweets, followAccounts, tweetCount, retweetCount" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="2832" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591671575" sizeMeasure="111" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;erik.isFollowing(mikkel)" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="2896" end="-240"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591682038" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;&#x9;mikkel.isFollowing(erik);" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="2921" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591708047" sizeMeasure="112" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(erik.isFollowing(mikkel));&#xA;&#x9;&#x9;System.out.println(mikkel.isFollowing(erik););&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="2897" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591712017" sizeMeasure="112" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="2989" end="-242"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591714983" sizeMeasure="112">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="2988" end="-242"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591728286" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;erik.follow(mikkel" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="2995" end="-242"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591736565" sizeMeasure="119">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(erik);&#xA;&#x9;&#x9;System.out.println(mikkel);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(erik.isFollowing(mikkel));&#xA;&#x9;&#x9;System.out.println(mikkel.isFollowing(erik));" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="3021" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592212566" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;// void unfollow(TwitterAccount account) - slutt å følge account&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account) != true) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.remove(account);" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="1334" end="-1546"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592240211" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="2421" end="-238"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592309414" sizeMeasure="94" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.getOwner() == this)&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot retweet your own tweets&quot;)&#xA;&#x9;&#x9;this.tweets.add(new Tweet(tweet.getOwner(), tweet));&#xA;&#x9;&#x9;this.retweetCount++" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="2342" end="-238"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592313135" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="2447" end="-315"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592336959" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="2392" end="-363"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592544825" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweets.add(new Tweet(this" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="2342" end="-270"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592625487" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(tweet.getRetweetCount())" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="2407" end="-238"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592663292" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="2407" end="-238"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593274039" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount a = new TwitterAccount(&quot;a&quot;);&#xA;&#x9;&#x9;TwitterAccount b = new TwitterAccount(&quot;b&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;a.tweet(&quot;yo&quot;);&#xA;&#x9;&#x9;b.retweet(a.getTweet(1));&#xA;&#x9;&#x9;System.out.println(a.getTweet(1));&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="2407" end="-233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593296460" sizeMeasure="101" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//b.retweet(a.getTweet(1));&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="2566" end="-272"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593302969" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="2566" end="-302"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593333213" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ublic ArrayList&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;private Collection&lt;TwitterAccount> followAccounts = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private int tweetCount;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// Constructor: TwitterAccount(String) - som tar inn brukernavnet&#xA;&#x9;public TwitterAccount(String s) {&#xA;&#x9;&#x9;this.userName = s;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// String getUserName() - returnerer brukernavnet&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Tweet getTweet(int i) - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return this.tweets.get(this.tweets.size() - i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getTweetCount() - returner antall tweets til kontoen&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// int getRetweetCount() - returner antall retweets av tweets fra denne kontoen&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void follow(TwitterAccount account) - denne (this) kontoen starter å følge account&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account)) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void unfollow(TwitterAccount account) - slutt å følge account&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;    // sjekk om koblingen er riktig allerede&#xA;&#x9;    if (this.isFollowing(account) != true) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.followAccounts.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowing(TwitterAccount account) - returnerer om denne kontoen følger account&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;if (this.followAccounts.contains(account))&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;else &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// boolean isFollowedBy(TwitterAccount account) - returnerer om account følger denne kontoen&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;if (account.isFollowing(this))&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void tweet(String) - lager en ny tweet for denne kontoen&#xA;&#x9;public void tweet(String s) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, s));&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void retweet(Tweet tweet) - retweeter tweet fra denne kontoen&#xA;&#x9;public  void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount a = new TwitterAccount(&quot;a&quot;);&#xA;&#x9;&#x9;TwitterAccount b = new TwitterAccount(&quot;b&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;a.tweet(&quot;yo&quot;);&#xA;&#x9;&#x9;b.retweet(a.getTweet(1));&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="145" end="-272"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593344606" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweets.size(" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="2614" end="-241"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593358608" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="get(0" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="2621" end="-241"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593481199" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="145" end="-2717"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593500846" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getTweet(1" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="2615" end="-241"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593513633" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a.tweet(&quot;yo2" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="2566" end="-306"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593523071" sizeMeasure="103">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(a.getTweet(2" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="2648" end="-241"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593536988" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="2612" end="-342"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593557108" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="b.tweet(&quot;yob&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="2612" end="-342"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593577063" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="hei&quot;);&#xA;&#x9;&#x9;a.tweet(&quot;hei2&quot;);&#xA;&#x9;&#x9;b.retweet(a.getTweet(1));&#xA;&#x9;&#x9;b.tweet(&quot;hei " edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="2558" end="-344"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593638925" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Count=%s, retweetCount=%s]&quot;, userName" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="2841" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593647446" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(a" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="2735" end="-182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593658701" sizeMeasure="106">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(b" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="2760" end="-182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593816406" sizeMeasure="107">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" a&quot;);&#xA;&#x9;&#x9;a.tweet(&quot;hei a2&quot;);&#xA;&#x9;&#x9;b.tweet(&quot;hei b&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;b.retweet(a.getTweet(1));&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="2561" end="-304"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593830149" sizeMeasure="108">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="b.getTweet(1" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="2737" end="-233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593947347" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount c = new TwitterAccount(&quot;c&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;a.tweet(&quot;hei a&quot;);&#xA;&#x9;&#x9;a.tweet(&quot;hei a2&quot;);&#xA;&#x9;&#x9;b.tweet(&quot;hei b&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;b.retweet(a.getTweet(1));&#xA;&#x9;&#x9;c.retweet(b" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="2546" end="-358"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593966877" sizeMeasure="109">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="b.tweet(&quot;hei b&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;b.retweet(a.getTweet(1));&#xA;&#x9;&#x9;c.retweet(b.getTweet(1));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(a.getTweet(1));&#xA;&#x9;&#x9;System.out.println(b.getTweet(1));&#xA;&#x9;&#x9;System.out.println(c" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="2615" end="-244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593989949" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(c" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="2857" end="-182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594007148" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="3059" end="-3060"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595544603" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweetCount++;&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, tweet))" edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="2347" end="-656"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595551029" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Count++;&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, s))" edit="/1/@proposals.0/@proposals.1/@attempts.67/@edit" start="2184" end="-830"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595644043" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s.add(new Tweet(this, s));&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// void retweet(Tweet tweet) - retweeter tweet fra denne kontoen&#xA;&#x9;public  void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;this.retweetCount++" edit="/1/@proposals.0/@proposals.1/@attempts.68/@edit" start="2184" end="-656"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595652309" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 1" edit="/1/@proposals.0/@proposals.1/@attempts.69/@edit" start="338" end="-2722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595667462" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.70/@edit" start="338" end="-2722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595680709" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this." edit="/1/@proposals.0/@proposals.1/@attempts.71/@edit" start="2407" end="-668"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595700501" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 1" edit="/1/@proposals.0/@proposals.1/@attempts.72/@edit" start="338" end="-2743"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595714342" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.73/@edit" start="338" end="-2743"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595764428" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weet.getOwner()" edit="/1/@proposals.0/@proposals.1/@attempts.74/@edit" start="2386" end="-692"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595812684" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="riginalTweet()" edit="/1/@proposals.0/@proposals.1/@attempts.75/@edit" start="2395" end="-703"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595858644" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.getOriginalTweet().getOwner() != null)&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().getOwner().retweetCount++;&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;tweet" edit="/1/@proposals.0/@proposals.1/@attempts.76/@edit" start="2385" end="-703"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595903925" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.77/@edit" start="2385" end="-710"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487596053341" sizeMeasure="111">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, tweet));&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.78/@edit" start="2311" end="-710"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487596094805" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.getOriginalTweet().getOwner() != null) {&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().getOwner().retweetCount++;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.79/@edit" start="2419" end="-676"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487596109821" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.80/@edit" start="2447" end="-748"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487596138849" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//tweet.getOwner().retweetCount++;&#xA;&#x9;&#x9;if (tweet.getOriginalTweet" edit="/1/@proposals.0/@proposals.1/@attempts.81/@edit" start="2384" end="-748"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487596157942" sizeMeasure="115">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="wner().retweetCount++;" edit="/1/@proposals.0/@proposals.1/@attempts.82/@edit" start="2474" end="-735"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487603884101" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="riginalTweet().getOwner().retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;tweet.getOwner().retweetCount++;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.83/@edit" start="2474" end="-676"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604262511" sizeMeasure="118">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else {&#xA;&#x9;&#x9;&#x9;tweet.getOwner().retweetCount++;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.84/@edit" start="2522" end="-679"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604275992" sizeMeasure="117">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.85/@edit" start="2571" end="-676"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604377291" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.getOriginalTweet() != null) {&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().getOwner().retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;tweet.getOwner().retweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.tweetCount++" edit="/1/@proposals.0/@proposals.1/@attempts.86/@edit" start="2384" end="-181"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487591625409" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487591648468" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487591685269" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487591718628" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487591739823" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487592216011" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593278649" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593299671" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593306107" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593347961" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593362285" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593409885" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593439438" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593464387" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593526031" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593540589" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593560297" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593581174" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593650571" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593661872" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593833384" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593888060" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593919023" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593969620" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593992909" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594172780" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594257865" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594293262" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594454436" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594572669" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594595806" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594640135" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594658620" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487595358213" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487596029204" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487596910623" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591035718" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591141047" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592507956" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592519769" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592841454" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487593016200" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594098845" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594114730" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594167379" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594252519" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594266088" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594423163" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604457161" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604541887" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604566359" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604593182" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591149136" completion="0.3333333333333333" successCount="2" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591242137" completion="0.5" successCount="3" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591526145" completion="0.5" successCount="3" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592227153" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592320853" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592549738" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592639024" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592847396" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487593022000" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487593592034" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487593876835" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594274637" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594399931" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594415440" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594449724" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594646165" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595380173" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595418067" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595463772" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595481017" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595557148" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595587228" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595615750" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595658675" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595687163" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595706467" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595784847" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595818194" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595864671" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595910912" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487596011886" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487596101240" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487596116274" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487596144453" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487596166159" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487596898793" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487603890307" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604268764" completion="1.0" successCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604383319" completion="1.0" successCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604449892" completion="1.0" successCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604581390" completion="1.0" successCount="6"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
