<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488821505291" sizeMeasure="26" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable {&#xA;&#x9;&#xA;&#x9;private char color;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char color, int number) {&#xA;&#x9;&#x9;if (!(color == 'H' || color == 'S' || color == 'D' || color == 'C' ) || (number &lt; 1 || number > 13)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The color needs to be S, H, D or C but was &quot; + color + &quot; and the number&quot;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;+ &quot; must be between 1 and 13, but was &quot; + number);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;this.value = number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.color;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return (this.color + Integer.toString(this.value));&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488821549852" sizeMeasure="32" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char color;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char color, int number) {&#xA;&#x9;&#x9;if (!(color == 'H' || color == 'S' || color == 'D' || color == 'C' ) || (number &lt; 1 || number > 13)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The color needs to be S, H, D or C but was &quot; + color + &quot; and the number&quot;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;+ &quot; must be between 1 and 13, but was &quot; + number);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;this.value = number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.color;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return (this.color + Integer.toString(this.value));&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Object o) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="60" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488821557474" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="691" end="-61"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488822498360" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="702" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488822687148" sizeMeasure="34" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;char colorC = o.getSuit();&#xA;&#x9;&#x9;int valueC = o.getFace();&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="702" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488824103392" sizeMeasure="40" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card c1 = new Card('C', '1');&#xA;&#x9;&#x9;Card s2 = new Card('S', '2')" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="763" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488824114563" sizeMeasure="41" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;c1.compareTo(s2" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="888" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488824447601" sizeMeasure="42" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="760" end="-156"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825098224" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int thisC;&#xA;&#x9;&#x9;if (this.getSuit() == 'S') {&#xA;&#x9;&#x9;&#x9;thisC = 39;&#xA;&#x9;&#x9;} else if (this.getSuit() == 'H') {&#xA;&#x9;&#x9;&#x9;thisC = 26;&#xA;&#x9;&#x9;} else if (this.getSuit() == 'D') {&#xA;&#x9;&#x9;&#x9;thisC = 13;&#xA;&#x9;&#x9;} else if (this.getSuit() == 'C') {&#xA;&#x9;&#x9;&#x9;thisC = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="760" end="-138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825188686" sizeMeasure="52" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int typeNumber(char s) {&#xA;&#x9;&#x9;int thisC;&#xA;&#x9;&#x9;if (this.getSuit() == 'S') {&#xA;&#x9;&#x9;&#x9;return thisC = 39;&#xA;&#x9;&#x9;} else if (this.getSuit() == 'H') {&#xA;&#x9;&#x9;&#x9;return thisC = 26;&#xA;&#x9;&#x9;} else if (this.getSuit() == 'D') {&#xA;&#x9;&#x9;&#x9;return thisC = 13;&#xA;&#x9;&#x9;} else if (this.getSuit() == 'C') {&#xA;&#x9;&#x9;&#x9;return thisC = 0;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="760" end="-138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825215493" sizeMeasure="53" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return 0;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1049" end="-138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825247075" sizeMeasure="53" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s == 'S') {&#xA;&#x9;&#x9;&#x9;return thisC = 39;&#xA;&#x9;&#x9;} else if (s == 'H') {&#xA;&#x9;&#x9;&#x9;return thisC = 26;&#xA;&#x9;&#x9;} else if (s == 'D') {&#xA;&#x9;&#x9;&#x9;return thisC = 13;&#xA;&#x9;&#x9;} else if (s" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="818" end="-185"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825255315" sizeMeasure="53" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;&#x9;if (s == 'S') {&#xA;&#x9;&#x9;&#x9;return thisC = 39;&#xA;&#x9;&#x9;} else if (s == 'H') {&#xA;&#x9;&#x9;&#x9;return thisC = 26;&#xA;&#x9;&#x9;} else if (s == 'D') {&#xA;&#x9;&#x9;&#x9;return thisC = 13;&#xA;&#x9;&#x9;} else if (s == 'C') {&#xA;&#x9;&#x9;&#x9;return thisC = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return thisC" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="810" end="-139"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825275456" sizeMeasure="53" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int colorC = typeNumber(o.getSuit()" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="703" end="-426"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825294751" sizeMeasure="54" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int thisC = typeNumber(this.getSuit()" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="771" end="-398"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825307217" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int thisV = this.getFace(" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="813" end="-398"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825320492" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1235" end="-1236"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488825633095" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (thisC + thisV > colorC + valueC) {&#xA;&#x9;&#x9;&#x9;return thisC + thisV;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return colorC + valueC;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="843" end="-396"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488827185796" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1213" end="-135"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829246933" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public static void main(String[] args) {&#xA;&#x9;&#x9;Card c1 = new Card('C', '1');&#xA;&#x9;&#x9;Card s2 = new Card('S', '2');&#xA;&#x9;&#x9;System.out.println(c1.compareTo(s2)" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1215" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829267368" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1);&#xA;&#x9;&#x9;Card s2 = new Card('S', 2" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1282" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829585816" sizeMeasure="64" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char color;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char color, int number) {&#xA;&#x9;&#x9;if (!(color == 'H' || color == 'S' || color == 'D' || color == 'C' ) || (number &lt; 1 || number > 13)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The color needs to be S, H, D or C but was &quot; + color + &quot; and the number&quot;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;+ &quot; must be between 1 and 13, but was &quot; + number);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;this.value = number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.color;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return (this.color + Integer.toString(this.value));&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int colorC = typeNumber(o.getSuit());&#xA;&#x9;&#x9;int valueC = o.getFace();&#xA;&#x9;&#x9;int thisC = typeNumber(this.getSuit());&#xA;&#x9;&#x9;int thisV = this.getFace();&#xA;&#x9;&#x9;if (thisC + thisV > colorC + valueC) {&#xA;&#x9;&#x9;&#x9;return thisC + thisV;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return colorC + valueC;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int typeNumber(char s) {&#xA;&#x9;&#x9;int thisC = 0;&#xA;&#x9;&#x9;if (s == 'S') {&#xA;&#x9;&#x9;&#x9;return thisC = 39;&#xA;&#x9;&#x9;} else if (s == 'H') {&#xA;&#x9;&#x9;&#x9;return thisC = 26;&#xA;&#x9;&#x9;} else if (s == 'D') {&#xA;&#x9;&#x9;&#x9;return thisC = 13;&#xA;&#x9;&#x9;} else if (s == 'C') {&#xA;&#x9;&#x9;&#x9;return thisC = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return thisC;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card c1 = new Card('C', 1);&#xA;&#x9;&#x9;Card s2 = new Card('S', 2);&#xA;&#x9;&#x9;System.out.println(c1.compareTo(s2));&#xA;&#x9;&#x9;List&lt;Card> lol = new List[&quot;S1&quot;]" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="21" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829606648" sizeMeasure="64" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card&lt;&quot;S1&quot;>;" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1403" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829617236" sizeMeasure="64" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="[&quot;S1&quot;]" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1407" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829707873" sizeMeasure="64" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;Card> lol = new ArrayList&lt;Card>()" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1382" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829713738" sizeMeasure="64" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Array" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="38" end="-1403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829723095" sizeMeasure="64" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1387" end="-51"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829730456" sizeMeasure="64" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;s1&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1429" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829736179" sizeMeasure="64" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1429" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829798953" sizeMeasure="66" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String[] loll = new String[];&#xA;&#x9;&#x9;ArrayList&lt;Card> lol = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;lol.add" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1387" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829812573" sizeMeasure="66" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;S1&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1414" end="-66"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829833037" sizeMeasure="66" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1483" end="-1484"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829933396" sizeMeasure="64" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = {&quot;S1&quot;, &quot;H2&quot;, &quot;H1&quot;, &quot;C9&quot;};" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1399" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829971886" sizeMeasure="66" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collections;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char color;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char color, int number) {&#xA;&#x9;&#x9;if (!(color == 'H' || color == 'S' || color == 'D' || color == 'C' ) || (number &lt; 1 || number > 13)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The color needs to be S, H, D or C but was &quot; + color + &quot; and the number&quot;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;+ &quot; must be between 1 and 13, but was &quot; + number);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;this.value = number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.color;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return (this.color + Integer.toString(this.value));&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int colorC = typeNumber(o.getSuit());&#xA;&#x9;&#x9;int valueC = o.getFace();&#xA;&#x9;&#x9;int thisC = typeNumber(this.getSuit());&#xA;&#x9;&#x9;int thisV = this.getFace();&#xA;&#x9;&#x9;if (thisC + thisV > colorC + valueC) {&#xA;&#x9;&#x9;&#x9;return thisC + thisV;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return colorC + valueC;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int typeNumber(char s) {&#xA;&#x9;&#x9;int thisC = 0;&#xA;&#x9;&#x9;if (s == 'S') {&#xA;&#x9;&#x9;&#x9;return thisC = 39;&#xA;&#x9;&#x9;} else if (s == 'H') {&#xA;&#x9;&#x9;&#x9;return thisC = 26;&#xA;&#x9;&#x9;} else if (s == 'D') {&#xA;&#x9;&#x9;&#x9;return thisC = 13;&#xA;&#x9;&#x9;} else if (s == 'C') {&#xA;&#x9;&#x9;&#x9;return thisC = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return thisC;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card c1 = new Card('C', 1);&#xA;&#x9;&#x9;Card s2 = new Card('S', 2);&#xA;&#x9;&#x9;System.out.println(c1.compareTo(s2));&#xA;&#x9;&#x9;String[] lol = {&quot;S1&quot;, &quot;H2&quot;, &quot;H1&quot;, &quot;C9&quot;};&#xA;&#x9;&#x9;Collections.sort(lol)" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="49" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830001191" sizeMeasure="67" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List list = new ArrayList(Arrays.asList(init))" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1460" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830006576" sizeMeasure="68" errorCount="3" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="79" end="-1462"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830010396" sizeMeasure="69" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Arrays" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="66" end="-1515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830023920" sizeMeasure="69" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lol" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1548" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830040371" sizeMeasure="69" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ist" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="1575" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830049629" sizeMeasure="70" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="1582" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830262358" sizeMeasure="73" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public static &lt;T extends Comparable&lt;Card>> void sort(List&lt;T> list) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="1318" end="-302"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830280974" sizeMeasure="71" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="1318" end="-299"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830283952" sizeMeasure="70" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="1317" end="-297"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830415817" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830453778" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparator&lt;>" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="49" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830473807" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="71" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830482808" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830538087" sizeMeasure="17">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public CardComparator(boolean ace, char colorT) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="213" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830596227" sizeMeasure="20" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private boolean ace;&#xA;&#x9;private char colorT;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="109" end="-168"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830610075" sizeMeasure="21" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.ace = ace;&#xA;&#x9;&#x9;this.colorT = colorT;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="314" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830719726" sizeMeasure="23" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (colorT != 'S' || colorT != 'C' || colorT != 'D' || colorT != 'H');&#xA;&#x9;&#x9;throw new IllegalArgumentException(&quot;Trump card has to be either S, C, D or H, but it was &quot; + colorT)" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="355" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830729172" sizeMeasure="23" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="429" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830777941" sizeMeasure="23" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || colorT != '');&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="424" end="-112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830783970" sizeMeasure="23" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="554" end="-555"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830792622" sizeMeasure="23" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="\0" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="439" end="-116"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830803395" sizeMeasure="23" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", H or empty" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="519" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488830989245" sizeMeasure="27" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="561" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831061855" sizeMeasure="27" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card compare(Card o1, Card o2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return o1" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="175" end="-360"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831066482" sizeMeasure="27" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="175" end="-403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831076498" sizeMeasure="27" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="219" end="-361"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831112090" sizeMeasure="27" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="220" end="-360"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831217383" sizeMeasure="28" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.ace == true) {&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="209" end="-371"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831497535" sizeMeasure="28" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card card;&#xA;&#x9;private boolean ace;&#xA;&#x9;private char colorT;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;int o1Color = Card.typeNumber(o1.getSuit());" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="120" end="-371"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831501940" sizeMeasure="28" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="243" end="-400"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831536447" sizeMeasure="31" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int o2Color = card.typeNumber(o2.getSuit());&#xA;&#x9;&#x9;int o1Value = card.getFace();&#xA;&#x9;&#x9;int o2Value = card.getFace(" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="276" end="-373"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831622574" sizeMeasure="34" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="387" end="-371"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831656543" sizeMeasure="37" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="450" end="-386"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831878524" sizeMeasure="43" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char[] colorValues = {'S', 'H', 'C', 'D'};&#xA;&#x9;&#x9;int o1Color = card.typeNumber(o1.getSuit());&#xA;&#x9;&#x9;int o2Color = card.typeNumber(o2.getSuit());&#xA;&#x9;&#x9;int o1Value = card.getFace();&#xA;&#x9;&#x9;int o2Value = card.getFace();&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1Color + o1Value > o2Color + o2Value) {&#xA;&#x9;&#x9;&#x9;return o1Color + o1Value;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return o2Color + o2Value;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="229" end="-359"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831922029" sizeMeasure="43" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="862" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831966830" sizeMeasure="43" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardComparator cc = new CardComparator(true, 'S');" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="1029" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831981724" sizeMeasure="43" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".equals('S')" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="789" end="-290"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488831987684" sizeMeasure="43" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" != 'S'" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="789" end="-290"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832013369" sizeMeasure="43" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!(colorT == 'S' || colorT == 'C' || colorT == 'D' || colorT == 'H' || colorT == ' ')" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="783" end="-222"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832052461" sizeMeasure="43" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Trump card has to be either S, C, D, H or empty, but it was &quot; + colorT);&#xA;&#x9;}&#xA;}" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="868" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832055987" sizeMeasure="43" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="984" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832088491" sizeMeasure="44" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" ');&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="1082" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832110553" sizeMeasure="44" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cc.compare(&quot;S2&quot;, &quot;S3&quot;);" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1089" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832119808" sizeMeasure="44" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(cc.compare(&quot;S2&quot;, &quot;S3&quot;)" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1089" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832156449" sizeMeasure="44" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Card ('S', 1), new card('S', 3)" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="1119" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832162263" sizeMeasure="44" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1142" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832304066" sizeMeasure="45" errorCount="4" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o2C;&#xA;&#x9;private Card o1C" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="125" end="-1035"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832335721" sizeMeasure="47" errorCount="4" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="292" end="-894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832351112" sizeMeasure="47" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o1C.typeNumber(o1.getSuit());&#xA;&#x9;&#x9;int o2Color = o2C.typeNumber(o2.getSuit());&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="340" end="-746"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832482132" sizeMeasure="48" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char[] temporaryValues" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="292" end="-924"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832535003" sizeMeasure="51" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = null;&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[0] = colorT;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="314" end="-923"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832634431" sizeMeasure="56" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i+1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="380" end="-927"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832667037" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(colorValues);&#xA;&#x9;&#x9;System.out.println(temporaryValues);&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[0] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i+1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(colorValues);&#xA;&#x9;&#x9;System.out.println(temporaryValues);" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="325" end="-923"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832689479" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="360" end="-1216"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832707080" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="1496" end="-81"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832737579" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{'0', '0', '0', '0'}" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="317" end="-1257"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832748251" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="376" end="-1216"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832772203" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[0] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i+1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="341" end="-923"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832805002" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="1414" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832813282" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="1362" end="-81"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832821359" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="1410" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832845128" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="1410" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832848985" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="1362" end="-81"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488832852126" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="1414" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833008243" sizeMeasure="64" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collections;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;private Card o2C;&#xA;&#x9;private Card o1C;&#xA;&#x9;private boolean ace;&#xA;&#x9;private char colorT;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;char[] colorValues = {'S', 'H', 'C', 'D'};&#xA;&#x9;&#x9;char[] temporaryValues = {'0', '0', '0', '0'};&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[0] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i+1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = o1C.typeNumber(o1.getSuit());&#xA;&#x9;&#x9;int o2Color = o2C.typeNumber(o2.getSuit());&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1Color + o1Value > o2Color + o2Value) {&#xA;&#x9;&#x9;&#x9;return o1Color + o1Value;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return o2Color + o2Value;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char colorT) {&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.colorT = colorT;&#xA;&#x9;&#x9;if (!(colorT == 'S' || colorT == 'C' || colorT == 'D' || colorT == 'H' || colorT == ' ')) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Trump card has to be either S, C, D, H or empty, but it was &quot; + colorT);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardComparator cc = new CardComparator(true, 'D');&#xA;&#x9;&#x9;System.out.println(cc.compare(new Card ('S', 1), new Card('S', 3)));&#xA;&#x9;&#x9;String[] lol = {&quot;S1&quot;, &quot;H2&quot;, &quot;H1&quot;, &quot;C9&quot;};&#xA;&#x9;&#x9;List list = new ArrayList(Arrays.asList(lol));&#xA;&#x9;&#x9;Collections.sort(list);&#xA;&#x9;&#x9;System.out.println(list" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="38" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833019619" sizeMeasure="64" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", CardComparator" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="1659" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833023930" sizeMeasure="64" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="()" edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="1675" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833044135" sizeMeasure="64" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="compare" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="1661" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833055587" sizeMeasure="64" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(o1C, o1C)" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="1668" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833060812" sizeMeasure="64" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="1659" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833112511" sizeMeasure="64" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", new Card()" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="1659" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833147495" sizeMeasure="61" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="1546" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833198229" sizeMeasure="67" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Card> list = new ArrayList&lt;Card>();&#xA;&#xA;&#x9;      list.add(new Card('S', 3));&#xA;&#x9;      list.add(new Card('D', 2));&#xA;&#x9;      list.add(new Card('C', 10));&#xA;&#x9;      list.add(new Card('H', 4));&#xA;&#x9;      list.add(new Card('H', 1));" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="1546" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833227982" sizeMeasure="66" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;    list.add(new Card('S', 3));&#xA;&#x9;    list.add(new Card('D', 2));&#xA;&#x9;    list.add(new Card('C', 10));&#xA;&#x9;    list.add(new Card('H', 4));&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="1587" end="-38"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833251658" sizeMeasure="68" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    &#xA;&#x9;    Collections.sort(list, new Card(" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="1754" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833346199" sizeMeasure="68" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="compare" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="1787" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833373348" sizeMeasure="68" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", Comparable" edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="212" end="-1599"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833384943" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.1/@attempts.67/@edit" start="1805" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833391886" sizeMeasure="74" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new" edit="/1/@proposals.0/@proposals.1/@attempts.68/@edit" start="1805" end="-112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833408037" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="compare" edit="/1/@proposals.0/@proposals.1/@attempts.69/@edit" start="1805" end="-107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833478427" sizeMeasure="74" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new CardComparator" edit="/1/@proposals.0/@proposals.1/@attempts.70/@edit" start="1805" end="-107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833495491" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cc" edit="/1/@proposals.0/@proposals.1/@attempts.71/@edit" start="1805" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833511867" sizeMeasure="75" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(list);&#xA;&#x9;    Collections.sort(list, cc);&#xA;&#x9;    System.out.println(list" edit="/1/@proposals.0/@proposals.1/@attempts.72/@edit" start="1776" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833622727" sizeMeasure="75" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.73/@edit" start="1967" end="-1968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833695213" sizeMeasure="79" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(o1Color);&#xA;&#x9;&#x9;System.out.println(o1Value);&#xA;&#x9;&#x9;System.out.println(o2Color);&#xA;&#x9;&#x9;System.out.println(o2Value" edit="/1/@proposals.0/@proposals.1/@attempts.74/@edit" start="836" end="-1137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833797568" sizeMeasure="77" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int o1Sum = o1Color + o1Value;&#xA;&#x9;&#x9;int o2Sum = o2Color + o2Value;&#xA;&#x9;&#x9;System.out.println(o1Color);&#xA;&#x9;&#x9;System.out.println(o1Value);&#xA;&#x9;&#x9;System.out.println(o2Color);&#xA;&#x9;&#x9;System.out.println(o2Value);&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return  o1Sum - o2sum;" edit="/1/@proposals.0/@proposals.1/@attempts.75/@edit" start="836" end="-886"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833801599" sizeMeasure="77" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S" edit="/1/@proposals.0/@proposals.1/@attempts.76/@edit" start="1173" end="-889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833817898" sizeMeasure="76" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.77/@edit" start="1152" end="-911"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488833869814" sizeMeasure="77" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(o1Color);&#xA;&#x9;&#x9;System.out.println(o1Value);&#xA;&#x9;&#x9;System.out.println(o2Color);&#xA;&#x9;&#x9;System.out.println(o2Value);&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int o1Sum = o1Color + o1Value;&#xA;&#x9;&#x9;int o2Sum = o2Color + o2Value;" edit="/1/@proposals.0/@proposals.1/@attempts.78/@edit" start="836" end="-914"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834012833" sizeMeasure="81" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D', 'C', 'H', 'S'};&#xA;&#x9;&#x9;char[] temporaryValues = {'0', '0', '0', '0'};&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[0] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i+1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = o1C.typeNumber(o1.getSuit());&#xA;&#x9;&#x9;int o2Color = o2C.typeNumber(o2.getSuit());&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.79/@edit" start="394" end="-1230"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834035703" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(colorValues);&#xA;&#x9;&#x9;System.out.println(temporaryValues);&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[0] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i+1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(colorValues);&#xA;&#x9;&#x9;System.out.println(temporaryValues);" edit="/1/@proposals.0/@proposals.1/@attempts.80/@edit" start="465" end="-1461"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834045695" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.0/@proposals.1/@attempts.81/@edit" start="579" end="-1674"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834060360" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.82/@edit" start="683" end="-1569"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834196399" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.83/@edit" start="579" end="-1672"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834217417" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+1" edit="/1/@proposals.0/@proposals.1/@attempts.84/@edit" start="646" end="-1606"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834220489" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.0/@proposals.1/@attempts.85/@edit" start="579" end="-1674"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834235659" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i-" edit="/1/@proposals.0/@proposals.1/@attempts.86/@edit" start="608" end="-1607"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834254401" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5" edit="/1/@proposals.0/@proposals.1/@attempts.87/@edit" start="615" end="-1638"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834259182" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4" edit="/1/@proposals.0/@proposals.1/@attempts.88/@edit" start="615" end="-1638"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834266144" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.1/@attempts.89/@edit" start="702" end="-1552"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834273591" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.90/@edit" start="702" end="-1552"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834283535" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1] = colorValues[i-1" edit="/1/@proposals.0/@proposals.1/@attempts.91/@edit" start="685" end="-1552"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834313542" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.92/@edit" start="646" end="-1610"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834325959" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.93/@edit" start="683" end="-1571"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834332125" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1] = colorValues[i" edit="/1/@proposals.0/@proposals.1/@attempts.94/@edit" start="683" end="-1552"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834386612" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.0/@proposals.1/@attempts.95/@edit" start="816" end="-1437"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834482264" sizeMeasure="88" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = o1C.typeNumber(o1.getSuit());&#xA;&#x9;&#x9;int o2Color = o2C.typeNumber(o2.getSuit());&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; 3; i++) {&#xA;&#x9;&#x9;&#x9;if (o1.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.96/@edit" start="796" end="-1233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834515009" sizeMeasure="88" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;&#x9;int o2Color" edit="/1/@proposals.0/@proposals.1/@attempts.97/@edit" start="841" end="-1390"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834584893" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;&#x9;int o2Color = 0;&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; 3; i++) {&#xA;&#x9;&#x9;&#x9;if (o1.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o1Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o2Color = i*13;" edit="/1/@proposals.0/@proposals.1/@attempts.98/@edit" start="841" end="-1242"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834622787" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*&#xA;&#x9;&#x9;System.out.println(o1Color);&#xA;&#x9;&#x9;System.out.println(o1Value);&#xA;&#x9;&#x9;System.out.println(o2Color);&#xA;&#x9;&#x9;System.out.println(o2Value);&#xA;&#x9;&#x9;*/" edit="/1/@proposals.0/@proposals.1/@attempts.99/@edit" start="1109" end="-1106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834654220" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//System.out.println(colorValues);&#xA;&#x9;&#x9;//System.out.println(temporaryValues);&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[3] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i-1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//System.out.println(colorValues);&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.100/@edit" start="465" end="-1589"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834682081" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(colorValues);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.101/@edit" start="726" end="-1589"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834746019" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.102/@edit" start="1868" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834753232" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fals" edit="/1/@proposals.0/@proposals.1/@attempts.103/@edit" start="1861" end="-486"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834778532" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D', 'C', 'H', 'S" edit="/1/@proposals.0/@proposals.1/@attempts.104/@edit" start="443" end="-1892"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834814965" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5" edit="/1/@proposals.0/@proposals.1/@attempts.105/@edit" start="619" end="-1731"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834832619" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4" edit="/1/@proposals.0/@proposals.1/@attempts.106/@edit" start="619" end="-1731"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834835821" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4" edit="/1/@proposals.0/@proposals.1/@attempts.107/@edit" start="957" end="-1393"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834868156" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(o1.getSuit());&#xA;&#x9;&#x9;&#x9;System.out.println(o2.getSuit());" edit="/1/@proposals.0/@proposals.1/@attempts.108/@edit" start="970" end="-1385"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834896188" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(o1Color);&#xA;&#x9;&#x9;//System.out.println(o1Value);&#xA;&#x9;&#x9;System.out.println(o2Color);&#xA;&#x9;&#x9;//System.out.println(o2Value);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.109/@edit" start="1187" end="-1107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488834984136" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//System.out.println(o1Color);&#xA;&#x9;&#x9;//System.out.println(o1Value);&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.110/@edit" start="1187" end="-1171"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835000046" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//System.out.println(colorValues);&#xA;&#x9;&#x9;//System.out.println(temporaryValues);&#xA;&#x9;&#x9;this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = 0;&#xA;&#x9;&#x9;int o2Color = 0;&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;//&#x9;System.out.println(o1.getSuit());&#xA;&#x9;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.111/@edit" start="726" end="-1419"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835014438" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.112/@edit" start="66" end="-2362"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835091317" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>, Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private Card o2C;&#xA;&#x9;private Card o1C;&#xA;&#x9;private boolean ace;&#xA;&#x9;private char colorT;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;char[] colorValues = {'D', 'C', 'H', 'S'};&#xA;&#x9;&#x9;char[] temporaryValues = {'D', 'C', 'H', 'S'};&#xA;&#x9;&#x9;//System.out.println(colorValues);&#xA;&#x9;&#x9;//System.out.println(temporaryValues);&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[3] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i-1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//System.out.println(colorValues);&#xA;&#x9;&#x9;//System.out.println(temporaryValues);&#xA;&#x9;&#x9;this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = 0;&#xA;&#x9;&#x9;int o2Color = 0;&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;//&#x9;System.out.println(o1.getSuit());&#xA;&#x9;&#x9;&#x9;//System.out.println(o2.getSuit());&#xA;&#x9;&#x9;&#x9;if (o1.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o1Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o2Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//System.out.println(o1Color);&#xA;&#x9;&#x9;//System.out.println(o1Value);&#xA;&#x9;&#x9;//System.out.println(o2Color);&#xA;&#x9;&#x9;//System.out.println(o2Value);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int o1Sum = o1Color + o1Value;&#xA;&#x9;&#x9;int o2Sum = o2Color + o2Value;&#xA;&#x9;&#x9;System.out.println(o1Sum);&#xA;&#x9;&#x9;System.out.println(o2Sum)" edit="/1/@proposals.0/@proposals.1/@attempts.113/@edit" start="66" end="-916"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835129074" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getFace());&#xA;&#x9;&#x9;System.out.println(o1Sum);&#xA;&#x9;&#x9;System.out.println(o2.getFace());&#xA;&#x9;&#x9;System.out.println(o2Sum);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.114/@edit" start="1518" end="-915"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835139567" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Suit" edit="/1/@proposals.0/@proposals.1/@attempts.115/@edit" start="1522" end="-1016"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835146194" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Suit" edit="/1/@proposals.0/@proposals.1/@attempts.116/@edit" start="1587" end="-951"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835172393" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.117/@edit" start="2067" end="-475"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835282709" sizeMeasure="98" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;o1 - o2 = &quot;+ o1Sum - " edit="/1/@proposals.0/@proposals.1/@attempts.118/@edit" start="1627" end="-927"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835297924" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(o1Sum - o2Sum)" edit="/1/@proposals.0/@proposals.1/@attempts.119/@edit" start="1660" end="-922"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835371035" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot; &quot; + o1Sum);&#xA;&#x9;&#x9;System.out.println(o2.getSuit() + &quot; &quot; + " edit="/1/@proposals.0/@proposals.1/@attempts.120/@edit" start="1528" end="-980"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835399031" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2Sum - o1" edit="/1/@proposals.0/@proposals.1/@attempts.121/@edit" start="1665" end="-893"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835419754" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(colorValues);&#xA;&#x9;&#x9;System.out.println(temporaryValues" edit="/1/@proposals.0/@proposals.1/@attempts.122/@edit" start="913" end="-1659"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835434303" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D" edit="/1/@proposals.0/@proposals.1/@attempts.123/@edit" start="2157" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835536811" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S', 'H', 'C', 'D'};&#xA;&#x9;&#x9;char[] temporaryValues = {'S', 'H', 'C', 'D" edit="/1/@proposals.0/@proposals.1/@attempts.124/@edit" start="369" end="-2207"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835550388" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.125/@edit" start="558" end="-2082"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835563924" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.0/@proposals.1/@attempts.126/@edit" start="558" end="-2082"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835597099" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.127/@edit" start="558" end="-2082"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835625925" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D', 'C', 'H', 'S'};&#xA;&#x9;&#x9;char[] temporaryValues = {'D', 'C', 'H', 'S'};&#xA;&#x9;&#x9;//System.out.println(colorValues);&#xA;&#x9;&#x9;//System.out.println(temporaryValues);&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[3] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i-1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//System.out.println(colorValues);&#xA;&#x9;&#x9;//System.out.println(temporaryValues);&#xA;&#x9;&#x9;this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = 0;&#xA;&#x9;&#x9;int o2Color = 0;&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;System.out.println(colorValues);&#xA;&#x9;&#x9;System.out.println(temporaryValues);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;//&#x9;System.out.println(o1.getSuit());&#xA;&#x9;&#x9;&#x9;//System.out.println(o2.getSuit());&#xA;&#x9;&#x9;&#x9;if (o1.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o1Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o2Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//System.out.println(o1Color);&#xA;&#x9;&#x9;//System.out.println(o1Value);&#xA;&#x9;&#x9;//System.out.println(o2Color);&#xA;&#x9;&#x9;//System.out.println(o2Value);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int o1Sum = o1Color + o1Value;&#xA;&#x9;&#x9;int o2Sum = o2Color + o2Value;&#xA;&#x9;&#x9;System.out.println(o1.getSuit() + &quot; &quot; + o1Sum);&#xA;&#x9;&#x9;System.out.println(o2.getSuit() + &quot; &quot; + o2Sum);&#xA;&#x9;&#x9;System.out.println(&quot;o1 - o2 = &quot;+ (o1Sum - o2Sum));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return  o2Sum - o1Sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char colorT) {&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.colorT = colorT;&#xA;&#x9;&#x9;if (!(colorT == 'S' || colorT == 'C' || colorT == 'D' || colorT == 'H' || colorT == ' ')) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Trump card has to be either S, C, D, H or empty, but it was &quot; + colorT);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardComparator cc = new CardComparator(false, ' " edit="/1/@proposals.0/@proposals.1/@attempts.128/@edit" start="369" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835636090" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D" edit="/1/@proposals.0/@proposals.1/@attempts.129/@edit" start="2157" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835643694" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.1/@attempts.130/@edit" start="2149" end="-488"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835664000" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1Sum - o2" edit="/1/@proposals.0/@proposals.1/@attempts.131/@edit" start="1739" end="-892"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835701349" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="false, ' " edit="/1/@proposals.0/@proposals.1/@attempts.132/@edit" start="2149" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835789092" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.133/@edit" start="1022" end="-1616"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835804642" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.1/@attempts.134/@edit" start="2149" end="-488"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835810978" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fals" edit="/1/@proposals.0/@proposals.1/@attempts.135/@edit" start="2149" end="-488"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835816427" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.136/@edit" start="2640" end="-2641"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835820002" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.1/@attempts.137/@edit" start="2149" end="-488"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835933392" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#x9;&#xA;&#x9;private Card o2C;&#xA;&#x9;private Card o1C;&#xA;&#x9;private boolean ace;&#xA;&#x9;private char colorT;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;char[] colorValues = {'D', 'C', 'H', 'S'};&#xA;&#x9;&#x9;char[] temporaryValues = {'D', 'C', 'H', 'S'};&#xA;&#x9;&#x9;//System.out.println(colorValues);&#xA;&#x9;&#x9;//System.out.println(temporaryValues);&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[3] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i-1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//System.out.println(colorValues);&#xA;&#x9;&#x9;//System.out.println(temporaryValues);&#xA;&#x9;&#x9;this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = 0;&#xA;&#x9;&#x9;int o2Color = 0;&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;System.out.println(colorValues);&#xA;&#x9;&#x9;System.out.println(temporaryValues);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;//System.out.println(o1.getSuit());&#xA;&#x9;&#x9;&#x9;//System.out.println(o2.getSuit());&#xA;&#x9;&#x9;&#x9;if (o1.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o1Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o2Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//System.out.println(o1Color);&#xA;&#x9;&#x9;//System.out.println(o1Value);&#xA;&#x9;&#x9;//System.out.println(o2Color);&#xA;&#x9;&#x9;//System.out.println(o2Value);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int o1Sum = o1Color + o1Value;&#xA;&#x9;&#x9;int o2Sum = o2Color + o2Value;&#xA;&#x9;&#x9;System.out.println(o1.getSuit() + &quot; &quot; + o1Sum);&#xA;&#x9;&#x9;System.out.println(o2.getSuit() + &quot; &quot; + o2Sum);&#xA;&#x9;&#x9;System.out.println(&quot;o1 - o2 = &quot;+ (o1Sum - o2Sum));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return  o1Sum - o2Sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char colorT) {&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.colorT = colorT;&#xA;&#x9;&#x9;if (!(colorT == 'S' || colorT == 'C' || colorT == 'D' || colorT == 'H' || colorT == ' ')) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Trump card has to be either S, C, D, H or empty, but it was &quot; + colorT);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardComparator cc = new CardComparator(true, ' ');&#xA;&#x9;&#x9;//System.out.println(cc.compare(new Card ('S', 1), new Card('S', 3)));&#xA;&#x9;&#x9;List&lt;Card> list = new ArrayList&lt;Card>();&#xA;&#x9;    list.add(new Card('S', 3));&#xA;&#x9;    list.add(new Card('D', 2));&#xA;&#x9;    list.add(new Card('C', 10));&#xA;&#x9;    list.add(new Card('H', 4));&#xA;&#x9;    list.add(new Card('H', 1));&#xA;&#x9;    System.out.println(list);&#xA;&#x9;    Collections.sort(list, cc);&#xA;&#x9;    System.out.println(list);&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.138/@edit" start="187" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488835981748" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C', 'D', 'H', 'S'};&#xA;&#x9;&#x9;char[] temporaryValues = {'C', 'D" edit="/1/@proposals.0/@proposals.1/@attempts.139/@edit" start="351" end="-2121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488836044322" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[3] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i-1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = 0;&#xA;&#x9;&#x9;int o2Color = 0;&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;if (o1.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o1Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o2Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int o1Sum = o1Color + o1Value;&#xA;&#x9;&#x9;int o2Sum = o2Color + o2Value;&#xA;&#x9;//&#x9;System.out.println(o1.getSuit() + &quot; &quot; + o1Sum);&#xA;&#x9;//&#x9;System.out.println(o2.getSuit() + &quot; &quot; + o2Sum);&#xA;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.140/@edit" start="422" end="-875"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488836882278" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // making two lists, and if there is a trump card the temporaryValues will be changed accordingly&#xA;&#x9;&#x9;if (colorT != ' ') {&#xA;&#x9;&#x9;&#x9;temporaryValues[3] = colorT;&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colorValues[i] != colorT) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temporaryValues[i-1] = colorValues[i];&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.o1C = o1;&#xA;&#x9;&#x9;this.o2C = o2;&#xA;&#x9;&#x9;int o1Color = 0;&#xA;&#x9;&#x9;int o2Color = 0;&#xA;&#x9;&#x9;int o1Value = o1C.getFace();&#xA;&#x9;&#x9;int o2Value = o2C.getFace();&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;if (o1.getSuit() == temporaryValues[i]) { // gives the colors a value based on the index&#xA;&#x9;&#x9;&#x9;&#x9;o1Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2.getSuit() == temporaryValues[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;o2Color = i*13;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o1Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2Value == 1 &amp;&amp; this.ace == true) {&#xA;&#x9;&#x9;&#x9;o2Value = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int o1Sum = o1Color + o1Value;&#xA;&#x9;&#x9;int o2Sum = o2Color + o2Value;&#xA;&#x9;//&#x9;System.out.println(o1.getSuit() + &quot; &quot; + o1Sum);&#xA;&#x9;//&#x9;System.out.println(o2.getSuit() + &quot; &quot; + o2Sum);&#xA;&#x9;//&#x9;System.out.println(&quot;o1 - o2 = &quot;+ (o1Sum - o2Sum));" edit="/1/@proposals.0/@proposals.1/@attempts.141/@edit" start="419" end="-818"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488829249844" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488829268781" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488830050882" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488831969625" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832014622" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832057475" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832089658" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832163848" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832352463" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832357475" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832670497" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832690844" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832708410" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832739010" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832752122" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832806329" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832814488" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832822703" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832846590" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832850163" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488832853379" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488833062497" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488833497486" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488833513478" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488833697623" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488833803097" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488833870862" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834036491" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834049034" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834062854" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834201004" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834221489" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834236768" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834256092" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834267466" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834274962" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834284827" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834314983" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834327442" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834333382" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834588984" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834642962" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834655056" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834661696" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834683157" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834747164" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834754832" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834782428" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834816059" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834837128" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834870417" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834897724" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488834989138" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835001180" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835048463" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835092543" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835130714" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835140437" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835147314" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835175089" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835299154" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835372181" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835400088" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835420770" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835441225" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835538164" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835552179" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835565075" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835600515" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835627965" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835637690" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835645463" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835664919" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835677151" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835704215" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835800321" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835806067" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835812690" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835821303" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488835934684" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488822498878" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488831115343" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488831886689" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488831930202" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488832062420" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488832359895" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488832869574" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488833623327" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488833812732" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488833872593" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834173495" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834182841" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834358187" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834594807" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834658157" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834659133" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834780461" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834960508" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834974855" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488834975732" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835051325" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835427663" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835571714" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835598982" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835668131" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835792332" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835834760" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835886118" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835913676" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488835983460" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488838135731" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="50">
        <attempts timestamp="1488838475769"/>
        <attempts timestamp="1488838623175"/>
        <attempts timestamp="1488838640323"/>
        <attempts timestamp="1488838651197"/>
        <attempts timestamp="1488838695944"/>
        <attempts timestamp="1488838707861"/>
        <attempts timestamp="1488838710304"/>
        <attempts timestamp="1488838790305"/>
        <attempts timestamp="1488838797818"/>
        <attempts timestamp="1488838987486"/>
        <attempts timestamp="1488838992963"/>
        <attempts timestamp="1488838997977"/>
        <attempts timestamp="1488839001926"/>
        <attempts timestamp="1488839059774"/>
        <attempts timestamp="1488839068558"/>
        <attempts timestamp="1488839079377"/>
        <attempts timestamp="1488839082359"/>
        <attempts timestamp="1488839232760"/>
        <attempts timestamp="1488839284134"/>
        <attempts timestamp="1488839458481"/>
        <attempts timestamp="1488839560397"/>
        <attempts timestamp="1488839563066"/>
        <attempts timestamp="1488839582808"/>
        <attempts timestamp="1488839662557"/>
        <attempts timestamp="1488840009593"/>
        <attempts timestamp="1488840012278"/>
        <attempts timestamp="1488840391387"/>
        <attempts timestamp="1488840427160"/>
        <attempts timestamp="1488840453660"/>
        <attempts timestamp="1488840458927"/>
        <attempts timestamp="1488840523092"/>
        <attempts timestamp="1488840612168"/>
        <attempts timestamp="1488840666552"/>
        <attempts timestamp="1488840701471"/>
        <attempts timestamp="1488840791255"/>
        <attempts timestamp="1488840895799"/>
        <attempts timestamp="1488841035603"/>
        <attempts timestamp="1488841056447"/>
        <attempts timestamp="1488841129753"/>
        <attempts timestamp="1488841153483"/>
        <attempts timestamp="1488841198209"/>
        <attempts timestamp="1488841389974"/>
        <attempts timestamp="1488841459027"/>
        <attempts timestamp="1488841536029"/>
        <attempts timestamp="1488841785146"/>
        <attempts timestamp="1488841815533"/>
        <attempts timestamp="1488841893739"/>
        <attempts timestamp="1488841956329"/>
        <attempts timestamp="1488842033889"/>
        <attempts timestamp="1488842037025"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
