<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488885277208" sizeMeasure="36">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;private int face = -1;&#xA;&#x9;&#xA;&#x9;//kortfargene i synkende rekkefølge&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;//konstruktøren, initialisere kortfarge og tallverdi&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889254887" sizeMeasure="45" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable &lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;private int face = -1;&#xA;&#x9;&#xA;&#x9;//kortfargene i synkende rekkefølge&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;//konstruktøren, initialisere kortfarge og tallverdi&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compareTo(Card o){&#xA;&#x9;&#x9;if (this.getSuit() != o.getSuit()){&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return SUITS.indexOf(o.getSuit()) - SUITS.indexOf(this.getSuit()) - o.getSuit();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() != o.getFace()){&#xA;&#x9;&#x9;&#x9;return this.getFace() - o.getFace();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="39" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889427370" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="954" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889507889" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return this.getSuit(); " edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="953" end="-56"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889717485" sizeMeasure="51" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card vinner = new Card(&quot;S&quot;, 13)&#xA;&#x9;&#x9;Card taper = new Card(&quot;C&quot;, 1)&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1025" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889739341" sizeMeasure="51" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="'S', 13);&#xA;&#x9;&#x9;Card taper = new Card('C', 1);" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1048" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889836423" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;System.out.println(vinner.compareTo(taper)" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1093" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889877130" sizeMeasure="54" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="sparkong = new Card('S', 13);&#xA;&#x9;&#x9;Card ruteress = new Card('C', 1);&#xA;&#x9;&#x9;Card " edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1030" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889905996" sizeMeasure="54" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kloverti = new Card('D', 10);" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1103" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889921372" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ruteress.compareTo(kloverti" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1157" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889936351" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="sparkong" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1176" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890334386" sizeMeasure="54" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="sparkong" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1157" end="-34"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890768341" sizeMeasure="54" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="845" end="-341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890792307" sizeMeasure="54" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() != o.getFace()){&#xA;&#x9;&#x9;&#x9;return this.getFace() - o.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return SUITS.indexOf(this.getSuit()" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="845" end="-225"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890807926" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ruteress" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1177" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890819688" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kloverti" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1158" end="-34"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891788113" sizeMeasure="69" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Arrays;&#xA;&#xA;public class Card implements Comparable &lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;private int face = -1;&#xA;&#x9;&#xA;&#x9;//kortfargene i synkende rekkefølge&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;//konstruktøren, initialisere kortfarge og tallverdi&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compareTo(Card o){&#xA;&#x9;&#x9;if (this.getSuit() != o.getSuit()){&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return SUITS.indexOf(o.getSuit()) - SUITS.indexOf(this.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() != o.getFace()){&#xA;&#x9;&#x9;&#x9;return this.getFace() - o.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return SUITS.indexOf(this.getSuit()); &#xA;&#x9;}&#x9;&#xA;public static void main(String[] args) {&#xA;&#x9;&#x9;Card sparkong = new Card('S', 13);&#xA;&#x9;&#x9;Card ruteress = new Card('C', 1);&#xA;&#x9;&#x9;Card kloverti = new Card('D', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(kloverti.compareTo(ruteress));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> kort = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 2),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 12),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 12),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 6),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 2),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D', 10),&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;System.out.println(kort" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="21" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891818442" sizeMeasure="69" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1473" end="-48"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891931375" sizeMeasure="71" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.Arrays;&#xA;import java.util.List" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="43" end="-1477"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891949342" sizeMeasure="71" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="\n" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1554" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891961653" sizeMeasure="71" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;\n&quot; + " edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1554" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892013576" sizeMeasure="77" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable &lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;private int face = -1;&#xA;&#x9;&#xA;&#x9;//kortfargene i synkende rekkefølge&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;//konstruktøren, initialisere kortfarge og tallverdi&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compareTo(Card o){&#xA;&#x9;&#x9;if (this.getSuit() != o.getSuit()){&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return SUITS.indexOf(o.getSuit()) - SUITS.indexOf(this.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() != o.getFace()){&#xA;&#x9;&#x9;&#x9;return this.getFace() - o.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return SUITS.indexOf(this.getSuit()); &#xA;&#x9;}&#x9;&#xA;public static void main(String[] args) {&#xA;&#x9;&#x9;Card sparkong = new Card('S', 13);&#xA;&#x9;&#x9;Card ruteress = new Card('C', 1);&#xA;&#x9;&#x9;Card kloverti = new Card('D', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(kloverti.compareTo(ruteress));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> kort = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 2),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 12),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 12),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 6),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 2),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D', 10)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;System.out.println(&quot;\n&quot; + kort);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(kort);&#xA;&#x9;&#x9;System.out.println(&quot;\n&quot; + kort);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="91" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892226660" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1661" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892660716" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488895688845" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488895695307" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;public int compareTo(Card c1){&#xA;&#x9;&#x9;int check = SUITS.indexOf(this.getSuit()) - SUITS.indexOf(c1.getSuit());&#xA;&#x9;&#x9;if(check == 0){&#xA;&#x9;&#x9;&#x9;check = this.getFace() - c1.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 13)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;System.out.println(&quot;Før sortering: &quot; + cards);&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;System.out.println(&quot;Etter sort: &quot; + cards);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="21" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892726492" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892922212" sizeMeasure="53" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator &lt;CardComparator> {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;private int face = -1;&#xA;&#x9;&#xA;&#x9;//kortfargene i synkende rekkefølge&#xA;&#x9;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;//konstruktøren, initialisere kortfarge og tallverdi&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(CardComparator arg0, CardComparator arg1) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893110131" sizeMeasure="53" errorCount="6" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean ess;&#xA;&#x9;&#xA;&#x9;private int face = -1;&#xA;&#x9;&#xA;&#x9;//kortfargene i synkende rekkefølge&#xA;&#x9;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;//konstruktøren, initialisere kortfarge og tallverdi&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="133" end="-643"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488894390801" sizeMeasure="76" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ace;&#xA;&#x9;&#xA;&#x9;private char trumph;&#xA;&#x9;&#xA;&#x9;//kortfargene i synkende rekkefølge&#xA;&#x9;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;//konstruktøren, initialisere kortfarge og tallverdi&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;if(!(trumph == ' ')){&#xA;&#x9;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index) +&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;SUITS.substring(index + 1);&#xA;&#x9;&#x9;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int compare(Card c1, Card c2){&#xA;&#x9;&#x9;int check = SUITS.indexOf(c2.getSuit()) - SUITS.indexOf(c1.getSuit());&#xA;&#x9;&#x9;if((check == 0)){&#xA;&#x9;&#x9;&#x9;if(ace){&#xA;&#x9;&#x9;&#x9;&#x9;if(c1.getFace() == 1 &amp;&amp; c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if(c1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="141" end="-392"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488894661446" sizeMeasure="101" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#xA;import java.util.ArrayList;&#xA;&#xA;import java.util.Arrays;&#xA;&#xA;import java.util.Collections;&#xA;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;boolean ace;&#xA;&#xA;&#x9;char trumph;&#xA;&#xA;&#x9;public String SUITS = &quot;SHDC&quot;;&#xA;&#xA;//konstruktør&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#xA;&#x9;&#x9;if(!(trumph == ' ')){&#xA;&#xA;&#x9;&#x9;&#x9;if(trumph == 'C'){&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index);&#xA;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index) + SUITS.substring(index + 1);&#xA; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;SUITS = newSuits;&#xA;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2){&#xA;&#xA;&#x9;&#x9;int check = SUITS.indexOf(c2.getSuit()) - SUITS.indexOf(c1.getSuit());&#xA;&#xA;&#x9;&#x9;if((check == 0)){&#xA;&#xA;&#x9;&#x9;&#x9;if(ace){&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;if(c1.getFace() == 1 &amp;&amp; c2.getFace() == 1){&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c1.getFace() == 1){&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;&#x9;check = (c1.getFace() - c2.getFace());&#xA;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 4),&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 1),&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 3)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;CardComparator C1 = new CardComparator(true, 'C');&#xA;&#xA;&#x9;&#x9;System.out.println(&quot;Før sortering: &quot; + cards);&#xA;&#xA;&#x9;&#x9;Collections.sort(cards, C1);&#xA;&#xA;&#x9;&#x9;System.out.println(&quot;Etter sort: &quot; + cards);&#xA;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="21" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488895317279" sizeMeasure="85" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;import encapsulation.Card;&#xA;&#xA;public class CardComparator implements Comparable &lt;CardComparator> {&#xA;&#x9;&#xA;&#x9;private boolean ace;&#xA;&#x9;&#xA;&#x9;private char trumph;&#xA;&#x9;&#xA;&#x9;//kortfargene i synkende rekkefølge&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;//konstruktøren&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;if(!(trumph == ' ')){&#xA;&#x9;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index) + SUITS.substring(index + 1);&#xA; &#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="21" end="-761"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488895343567" sizeMeasure="80" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 3)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;CardComparator C1 = new CardComparator(true, 'C');&#xA;&#xA;&#x9;&#x9;System.out.println(&quot;Før sortering: &quot; + cards);&#xA;&#xA;&#x9;&#x9;Collections.sort(cards, C1);" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1191" end="-54"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488895478327" sizeMeasure="80" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1507" end="-1508"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488895735394" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Comparator;&#xA;import java.util.List;&#xA;&#xA;//Comparable,comarartor, iterator, iterable&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;&#xA;&#x9;boolean ace;&#xA;&#x9;char trumph;&#xA;&#x9;public String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;if(!(trumph == ' ')){&#xA;&#x9;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index);&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index) + SUITS.substring(index + 1); &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2){&#xA;&#x9;&#x9;int check = SUITS.indexOf(c2.getSuit()) - SUITS.indexOf(c1.getSuit());&#xA;&#x9;&#x9;if((check == 0)){&#xA;&#x9;&#x9;&#x9;if(ace){&#xA;&#x9;&#x9;&#x9;&#x9;if(c1.getFace() == 1 &amp;&amp; c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;check = (c1.getFace() - c2.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 3)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;CardComparator C1 = new CardComparator(true, 'C');&#xA;&#x9;&#x9;System.out.println(&quot;Før sortering: &quot; + cards);&#xA;&#x9;&#x9;Collections.sort(cards, C1);&#xA;&#x9;&#x9;System.out.println(&quot;Etter sort: &quot; + cards);" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="121" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488889839923" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488889924665" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488889938567" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488889951374" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890336295" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890793925" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890809880" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890820981" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891789872" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891821318" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891936603" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891950606" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891962612" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488892017337" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488894659981" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488894671743" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488895319026" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488895342102" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488895346635" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488895479179" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488895737402" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
