<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802891650" sizeMeasure="62">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card(char c, int i) {&#xA;&#x9;if ( c =='S' || c == 'H' || c == 'D' || c == 'C') {&#xA;&#x9;&#x9;if (i>0 &amp;&amp; i&lt;14) {&#xA;&#x9;&#x9;&#x9;suit = c;&#xA;&#x9;&#x9;&#x9;face = i;&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;For lavt/høyt tall input.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;} else {&#xA;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig input.&quot;);&#xA;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return this.getSuit() + Integer.toString(this.getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int[] verdier = {5,4,3,2};&#xA;&#x9;&#x9;String bokstaver = &quot;SHDC&quot;;&#xA;&#x9;&#x9;int tall = verdier[bokstaver.indexOf(this.suit)];&#xA;&#x9;&#x9;int tall2 = verdier[bokstaver.indexOf(o.suit)];&#xA;&#x9;&#x9;if (tall > tall2) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (tall &lt; tall2){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (this.face > o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face &lt; o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0;&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803077328" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if ( c =='S' || c == 'H' || c == 'D' || c == 'C') {&#xA;&#x9;&#x9;&#x9;if (i>0 &amp;&amp; i&lt;14) {&#xA;&#x9;&#x9;&#x9;&#x9;suit = c;&#xA;&#x9;&#x9;&#x9;&#x9;face = i;&#xA;&#x9;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;For lavt/høyt tall input.&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig input.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return this.getSuit() + Integer.toString(this.getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int[] verdier = {5,4,3,2};&#xA;&#x9;&#x9;String bokstaver = &quot;SHDC&quot;;&#xA;&#x9;&#x9;int tall = verdier[bokstaver.indexOf(this.suit)];&#xA;&#x9;&#x9;int tall2 = verdier[bokstaver.indexOf(o.suit)];&#xA;&#x9;&#x9;if (tall > tall2) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (tall &lt; tall2){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (this.face > o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face &lt; o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="142" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803325260" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="hisNumber= verdier[bokstaver.indexOf(this.suit)];&#xA;&#x9;&#x9;int otherNumber = verdier[bokstaver.indexOf(o.suit)];&#xA;&#x9;&#x9;if (thisNumber > otherNumber) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (thisNumber &lt; otherNumber" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="709" end="-207"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803354950" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3,2,1,0" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="663" end="-439"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805183593" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" char suit;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="71" end="-1011"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806145915" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (thisNumber &lt; otherNumber){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (this.face > o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face &lt; o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="845" end="-84"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803687196" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804097996" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;boolean ess;&#xA;&#x9;char trumf;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean essStørst, char letter) {&#xA;&#x9;&#x9;this.ess = essStørst;&#xA;&#x9;&#x9;this.trumf = letter;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804352898" sizeMeasure="21" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int[] verdier = {3,2,1,0};&#xA;&#x9;&#x9;String bokstaver = &quot;SHDC&quot;;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="300" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804778360" sizeMeasure="30" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (this.trumf == 'H'){&#xA;&#x9;&#x9;&#x9;String bokstaver = &quot;HSDC&quot;;&#xA;&#x9;&#x9;} else if (this.trumf == 'D'){&#xA;&#x9;&#x9;&#x9;String bokstaver = &quot;DSHC&quot;;&#xA;&#x9;&#x9;} else if (this.trumf == 'C'){&#xA;&#x9;&#x9;&#x9;String bokstaver = &quot;CSHD&quot;;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;String bokstaver = &quot;SHDC&quot;;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="329" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804838251" sizeMeasure="31" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="559" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805062233" sizeMeasure="53" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String bokstaver;&#xA;&#x9;&#x9;if (this.trumf == 'H'){&#xA;&#x9;&#x9;&#x9;bokstaver = &quot;HSDC&quot;;&#xA;&#x9;&#x9;} else if (this.trumf == 'D'){&#xA;&#x9;&#x9;&#x9;bokstaver = &quot;DSHC&quot;;&#xA;&#x9;&#x9;} else if (this.trumf == 'C'){&#xA;&#x9;&#x9;&#x9;bokstaver = &quot;CSHD&quot;;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;bokstaver = &quot;SHDC&quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (!this.ess){&#xA;&#x9;&#x9;&#x9;int thisNumber= verdier[bokstaver.indexOf(this.suit)];&#xA;&#x9;&#x9;&#x9;int otherNumber = verdier[bokstaver.indexOf(o.suit)];&#xA;&#x9;&#x9;&#x9;if (thisNumber > otherNumber) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (thisNumber &lt; otherNumber){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (this.face > o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if (this.face &lt; o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if (this.face == o.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="329" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805172303" sizeMeasure="53" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o1.face > o2" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="813" end="-185"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805354007" sizeMeasure="54" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o1Number= verdier[bokstaver.indexOf(o1.suit)];&#xA;&#x9;&#x9;&#x9;int o2Number = verdier[bokstaver.indexOf(o2.suit)];&#xA;&#x9;&#x9;&#x9;if (o1Number > o2Number) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (o1Number &lt; o2Number){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (o1.face > o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if (o1.face &lt; o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if (o1.face == o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="574" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805657375" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else if (o1Number &lt; o2Number){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;if (o1.face > o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face &lt; o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face == o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;} else { // ess er størst&#xA;&#x9;&#x9;&#x9;int o1Number= verdier[bokstaver.indexOf(o1.suit)];&#xA;&#x9;&#x9;&#x9;int o2Number = verdier[bokstaver.indexOf(o2.suit)];&#xA;&#x9;&#x9;&#x9;if (o1Number > o2Number) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (o1Number &lt; o2Number){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (o1.face == 1 &amp;&amp; o2.face == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o2.face == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face > o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face &lt; o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face == o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="725" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805698489" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 0;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1510" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805976820" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; o2.face != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face != 1 &amp;&amp; o2.face == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1286" end="-194"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806006404" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (o1Number &lt; o2Number){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (o1.face == 1 &amp;&amp; o2.face == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face == 1 &amp;&amp; o2.face != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face != 1 &amp;&amp; o2.face == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face > o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face &lt; o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1133" end="-91"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806103295" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;&#x9;} else if (o1Number &lt; o2Number){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;if (o1.face > o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (o1.face &lt; o2.face) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="717" end="-697"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805708876" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805978987" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488806006765" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488806103677" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488809016993" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="10">
        <attempts timestamp="1488806903227"/>
        <attempts timestamp="1488806903948"/>
        <attempts timestamp="1488806904705"/>
        <attempts timestamp="1488807010922"/>
        <attempts timestamp="1488807927336"/>
        <attempts timestamp="1488807948413"/>
        <attempts timestamp="1488807948614"/>
        <attempts timestamp="1488807950367"/>
        <attempts timestamp="1488807956400"/>
        <attempts timestamp="1488808067763"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
