<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802635300" sizeMeasure="47" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable {&#xA;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;if(this.getSuit()=='S'){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 3;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803394333" sizeMeasure="62" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nt tall1=this.getFace();&#xA;&#x9;&#x9;int tall2=card.getFace();&#xA;&#x9;&#x9;char type1=this.getSuit();&#xA;&#x9;&#x9;char type2=card.getSuit();&#xA;&#x9;&#x9;if(SUITS.indexOf(type1)&lt;SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(SUITS.indexOf(type1)>SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if(tall1&lt;tall2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if(tall1>tall2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="977" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803504284" sizeMeasure="70" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card a=new Card('S',12);&#xA;&#x9;&#x9;Card b=new Card('S',5);&#xA;&#x9;&#x9;System.out.println(a.compareTo(b));&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1345" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803545222" sizeMeasure="70" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1408" end="-83"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803652359" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Card> {&#xA;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;int tall1=this.getFace();&#xA;&#x9;&#x9;int tall2=card.getFace();&#xA;&#x9;&#x9;char type1=this.getSuit();&#xA;&#x9;&#x9;char type2=card.getSuit();&#xA;&#x9;&#x9;if(SUITS.indexOf(type1)&lt;SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(SUITS.indexOf(type1)>SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if(tall1&lt;tall2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if(tall1>tall2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card a=new Card('D',12);&#xA;&#x9;&#x9;Card b=new Card('S',5);&#xA;&#x9;&#x9;System.out.println(a.compareTo(b));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="60" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804262501" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804418853" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card arg0, Card arg1) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804460938" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;boolean ess;&#xA;&#x9;char trumf;&#xA;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="109" end="-101"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804603408" sizeMeasure="23" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private boolean ess;&#xA;&#x9;private char trumf;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf){&#xA;&#x9;&#x9;this.ess=ess;&#xA;&#x9;&#x9;this.trumf=trumf;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="112" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804959105" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kort1, Card kort2) {&#xA;&#x9;&#x9;int tall1=kort1.getFace();&#xA;&#x9;&#x9;int tall2=kort2.getFace();&#xA;&#x9;&#x9;char type1=kort1.getSuit();&#xA;&#x9;&#x9;char type2=kort2.getSuit();&#xA;&#x9;&#x9;if(this.ess==false&amp;&amp;(this.trumf==' '||this.trumf=='S')){&#xA;&#x9;&#x9;&#x9;if(SUITS.indexOf(type1)&lt;SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(SUITS.indexOf(type1)>SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;if(tall1&lt;tall2){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(tall1>tall2){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="317" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805112139" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.ess==false&amp;&amp;(this.trumf==' '||this.trumf=='S')){&#xA;&#x9;&#x9;&#x9;if(SUITS.indexOf(type1)&lt;SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(SUITS.indexOf(type1)>SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;if(tall1&lt;tall2){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(tall1>tall2){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="458" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805122713" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 4;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="789" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805456001" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.ess==false&amp;&amp;(this.trumf=='H'||this.trumf=='D'||this.trumf=='C')){&#xA;&#x9;&#x9;&#x9;if(SUITS.indexOf(type1)&lt;SUITS.indexOf(type2)||(type1==trumf&amp;&amp;type2!=trumf)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(SUITS.indexOf(type1)>SUITS.indexOf(type2)||(type1!=trumf&amp;&amp;type2==trumf)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;if(tall1&lt;tall2){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(tall1>tall2){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 3;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="789" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805946063" sizeMeasure="88" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.ess==true&amp;&amp;(this.trumf=='H'||this.trumf=='D'||this.trumf=='C')){&#xA;&#x9;&#x9;&#x9;if(SUITS.indexOf(type1)&lt;SUITS.indexOf(type2)||(type1==trumf&amp;&amp;type2!=trumf)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(SUITS.indexOf(type1)>SUITS.indexOf(type2)||(type1!=trumf&amp;&amp;type2==trumf)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;if(tall1&lt;tall2&amp;&amp;tall2!=1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(tall1>tall2&amp;&amp;tall1!=1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1209" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805957898" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 6;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1648" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806186426" sizeMeasure="120" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tall1==1){&#xA;&#x9;&#x9;&#x9;&#x9;tall1=14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(tall2==1){&#xA;&#x9;&#x9;&#x9;&#x9;tall2=14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(SUITS.indexOf(type1)&lt;SUITS.indexOf(type2)||(type1==trumf&amp;&amp;type2!=trumf)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(SUITS.indexOf(type1)>SUITS.indexOf(type2)||(type1!=trumf&amp;&amp;type2==trumf)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;if(tall1&lt;tall2&amp;&amp;tall2!=1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(tall1>tall2&amp;&amp;tall1!=1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.ess==true&amp;&amp;(this.trumf==' '||this.trumf=='S')){&#xA;&#x9;&#x9;&#x9;if(tall1==1){&#xA;&#x9;&#x9;&#x9;&#x9;tall1=14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(tall2==1){&#xA;&#x9;&#x9;&#x9;&#x9;tall2=14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(SUITS.indexOf(type1)&lt;SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(SUITS.indexOf(type1)>SUITS.indexOf(type2)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;if(tall1&lt;tall2&amp;&amp;tall2!=1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(tall1>tall2&amp;&amp;tall1!=1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1303" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806196438" sizeMeasure="120">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 8;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="2148" end="-20"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803503199" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803542637" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488802638087" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488803396565" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488803657589" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488804421176" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488804463349" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488804605596" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488804961135" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805114373" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805124950" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805458007" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805948308" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805960592" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488806188696" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488806198281" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
