<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488912868603" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488912883180" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collections;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if(suit!='S' &amp;&amp; suit!='H' &amp;&amp; suit!='D' &amp;&amp; suit!='C'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;not valid suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(face&lt;1||face>13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;not valid face&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit=suit;&#xA;&#x9;&#x9;this.face=face;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return suit+&quot;&quot;+face;&#xA;&#x9;}&#xA;&#x9;public int faceToNum(char suit){&#xA;&#x9;&#x9;if(suit=='C'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='D'){&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='H'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='S'){&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;dafuq is this suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if(this.getSuit()!=o.getSuit()){&#xA;&#x9;&#x9;return this.faceToNum(this.getSuit())-o.faceToNum(o.getSuit());&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return this.getFace()-o.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card o1=new Card('S',10);&#xA;&#x9;&#x9;Card o2=new Card('S',9);&#xA;&#x9;&#x9;Card o3=new Card('H',11);&#xA;&#x9;&#x9;Card o4=new Card('C',4);&#xA;&#x9;&#x9;ArrayList&lt;Card> cards= new ArrayList&lt;>(4);&#xA;&#x9;&#x9;cards.add(o1);&#xA;&#x9;&#x9;cards.add(o2);&#xA;&#x9;&#x9;cards.add(o3);&#xA;&#x9;&#x9;cards.add(o4);&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488913206515" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s(char suit, char trumf){&#xA;&#x9;&#x9;if(suit==trumf){&#xA;&#x9;&#x9;&#x9;return 10;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(suit=='C'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='D'){&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='H'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='S'){&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;dafuq is this suit&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="603" end="-795"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488911497501" sizeMeasure="7">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;T> {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488912661551" sizeMeasure="56" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import encapsulation.Card;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;private boolean aceBiggest;&#xA;&#x9;private char trumf;&#xA;&#x9;public int faceToNum(char suit, char trumf){&#xA;&#x9;&#x9;if(suit==trumf){&#xA;&#x9;&#x9;&#x9;return 10;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(suit=='C'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='D'){&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='H'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(suit=='S'){&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;dafuq is this suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public CardComparator(boolean aceBiggest, char trumf){&#xA;&#x9;&#x9;this.trumf=trumf;&#xA;&#x9;&#x9;this.aceBiggest=aceBiggest;&#xA;&#x9;}&#xA;&#xA;@Override&#xA;public int compare(Card o1, Card o2) {&#xA;&#x9;int o1Suit=o1.faceToNum(o1.getSuit());&#xA;&#x9;int o2Suit=o2.faceToNum(o2.getSuit());&#xA;&#x9;int o1face=o1.getFace();&#xA;&#x9;int o2face=o2.getFace();&#xA;&#x9;if(aceBiggest &amp;&amp; o1face==1){&#xA;&#x9;&#x9;o1face=14;&#xA;&#x9;}&#xA;&#x9;if(aceBiggest&amp;&amp; o2face==1){&#xA;&#x9;&#x9;o2face=14;&#xA;&#x9;}&#xA;&#x9;if(o2Suit!=o1Suit){&#xA;&#x9;&#x9;return o1Suit-o2Suit;&#xA;&#x9;}&#xA;&#x9;else{&#xA;&#x9;&#x9;return o1face-o2face;&#xA;&#x9;}&#xA;}&#xA;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="51" end="-2"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="180" charEnd="185" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488912800870" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char getTrumf() {&#xA;&#x9;&#x9;return trumf;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="195" end="-784"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488912883171" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="51" end="-940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488913206508" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;private boolean aceBiggest;&#xA;&#x9;private char trumf;&#xA;&#x9;public char getTrumf() {&#xA;&#x9;&#x9;return trumf;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public CardComparator(boolean aceBiggest, char trumf){&#xA;&#x9;&#x9;this.trumf=trumf;&#xA;&#x9;&#x9;this.aceBiggest=aceBiggest;&#xA;&#x9;}&#xA;&#xA;@Override&#xA;public int compare(Card o1, Card o2) {&#xA;&#x9;int o1Suit=o1.faceToNums(o1.getSuit(), getTrumf());&#xA;&#x9;int o2Suit=o2.faceToNums(o2.getSuit(), getTrumf" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="51" end="-236"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488909171027" completion="0.0" errorCount="1">
          <errorTests>initializationError</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488910362798" completion="0.0" errorCount="1">
          <errorTests>initializationError</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488912801817" completion="0.0" errorCount="1">
          <errorTests>initializationError</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488912883878" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testAceIsHighest</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488912930311" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testAceIsHighest</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488913207133" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488913224022" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
