<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Named interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Named interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Named"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Person1 and Person2">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person1 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Person1"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Person2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person1 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Person1"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Person2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Person1Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.Person1Test"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Person2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.Person2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="NamedComparator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the NamedComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.NamedComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the NamedComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.NamedComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the NamedComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.NamedComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Person classes."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Person*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the NamedComparator class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Named*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488383927496" sizeMeasure="48" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Person2 implements Named {&#xA;&#x9;&#xA;&#x9;private String fullName;&#xA;&#x9;private String[] splitStr;&#xA;&#x9;&#xA;&#x9;public Person2(String fullName) {&#xA;&#x9;&#x9;this.fullName=fullName;&#xA;&#x9;&#x9;String[] splitStr = fullName.split(&quot; &quot;);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setGivenName(String givenName) {&#xA;&#x9;&#x9;splitStr[0]=givenName;&#xA;&#x9;&#x9;this.fullName=splitStr[0]+ &quot; &quot; + splitStr[1];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getGivenName() {&#xA;&#x9;&#x9;return splitStr[0];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setFamilyName(String lastname) {&#xA;&#x9;&#x9;splitStr[1]=lastname;&#xA;&#x9;&#x9;this.fullName=splitStr[0]+ &quot; &quot; + splitStr[1];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getFamilyName() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return splitStr[1];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setFullName(String fullName) {&#xA;&#x9;&#x9;this.fullName=fullName;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getFullName() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return fullName;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488383972626" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.1/@proposals.1/@attempts.0/@edit" start="182" end="-604"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488384546578" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488383929505" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488383974614" completion="1.0" successCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488384239099" sizeMeasure="40">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.Comparator;&#xA;&#xA;public class NamedComparator implements Comparator&lt;Named> {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Named name1, Named name2) {&#xA;&#x9;&#x9;if(name1.getFamilyName().compareTo(name2.getFamilyName())>0) {&#xA;&#x9;&#x9;&#x9;return name1.getFamilyName().compareTo(name2.getFamilyName());&#xA;&#x9;&#x9;} else if (name1.getFamilyName().compareTo(name2.getFamilyName())&lt;0){&#xA;&#x9;&#x9;&#x9;return name1.getFamilyName().compareTo(name2.getFamilyName());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (name1.getGivenName().compareTo(name2.getGivenName())==0) {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} &#xA;&#x9;&#x9;else if (name1.getGivenName().compareTo(name2.getFamilyName())>0) {&#xA;&#x9;&#x9;&#x9;return (name1.getGivenName().compareTo(name2.getFamilyName()));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { &#xA;&#x9;&#x9;&#x9;return name1.getGivenName().compareTo(name2.getFamilyName());&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person1 person4 = new Person1(&quot;Johanne&quot;, &quot;Skjetne&quot;);&#xA;&#x9;&#x9;Person1 person5 = new Person1(&quot;Andrea&quot;, &quot;Bressand&quot;);&#xA;&#x9;&#x9;System.out.println(person4.getGivenName().compareTo(person5.getGivenName()));&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;/* Dersom etternavnene er ulike skal metoden&#xA;returnere et negativt heltall om det første etternavnet er alfabetisk ordnet før det andre,&#xA;eller et positivt heltall i motsatt tilfelle.&#xA;Dersom etternavnene er like skal metoden gjøre det samme på fornavnene. Dersom også fornavnene er like skal metoden returnere 0.&#xA;&#xA;Hint: For å sammenlikne to String-objekter kan man bruke String-klassens innebygde Comparable-metode int compareTo(String streng2). &#xA;Denne metoden sammenlikner en String med en annen alfabetisk.&#xA;*/&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488384444294" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" != 0) {&#xA;&#x9;&#x9;&#x9;return name1.getFamilyName().compareTo(name2.getFamilyName());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;/*} else if (name1.getFamilyName().compareTo(name2.getFamilyName())&lt;0){&#xA;&#x9;&#x9;&#x9;return name1.getFamilyName().compareTo(name2.getFamilyName());&#xA;&#x9;&#x9;}*/&#xA;&#x9;&#x9;else if (name1.getGivenName().compareTo(name2.getGivenName())!=0) {&#xA;&#x9;&#x9;&#x9;return name1.getGivenName().compareTo(name2.getGivenName());&#xA;&#x9;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return 0" edit="/1/@proposals.2/@proposals.0/@attempts.0/@edit" start="230" end="-765"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488384519080" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if (name1.getGivenName().compareTo(name2.getGivenName())!=0) {&#xA;&#x9;&#x9;&#x9;return name1.getGivenName().compareTo(name2.getGivenName());&#xA;&#x9;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.2/@proposals.0/@attempts.1/@edit" start="311" end="-515"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488384238167" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488383987488" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488384446210" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488384521364" completion="1.0" successCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.4/@q" answer="/0/@parts.3/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
