<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377454433" sizeMeasure="47" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private int face;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if (isLegal(suit, face)){&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private boolean isLegal(char suit, int face){&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal card number&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (!(suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal card character&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return String.valueOf(this.suit) + String.valueOf(this.face);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;if (card.getSuit() != this.suit) {&#xA;&#x9;&#x9;&#x9;if (card.getSuit()>this.suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1:&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return card.getFace()-this.face;&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="919" charEnd="920" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377463045" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="878" end="-51"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377674901" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="927" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377782398" sizeMeasure="63" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int getSuitNum(char suit) {&#xA;&#x9;&#x9;if (suit == 'S') {&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (suit == 'H') {&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (suit == 'D') {&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (suit == 'C') {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="930" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="989" charEnd="1010" severity="1" problemCategory="120" problemType="603979894"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="989" charEnd="1010" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377807029" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 1;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1082" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="989" charEnd="1010" severity="1" problemCategory="120" problemType="603979894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377874247" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return card.getSuitNum()-this.getSuitNum();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return card.getFace()-this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private int getSuitNum(" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="803" end="-138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377977315" sizeMeasure="65" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collections;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private int face;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck deck = new CardDeck(2);&#xA;&#x9;&#x9;Collections.sort(deck);&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="21" end="-947"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="241" charEnd="245" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378279098" sizeMeasure="67" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.ArrayList;&#xA;import java.util.Collections;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private int face;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> = new ArrayList&lt;>();&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="38" end="-953"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="255" charEnd="256" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378297191" sizeMeasure="66" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="38" end="-1179"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="235" charEnd="252" severity="2" problemCategory="40" problemType="16778094"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="222" charEnd="226" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="231" charEnd="232" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378316404" sizeMeasure="67" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collections;&#xA;import java.util.List" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="38" end="-1122"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="255" charEnd="256" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378379949" sizeMeasure="70" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards= new ArrayList&lt;>();&#xA;&#x9;&#x9;cards.add(new Card('S', 3));&#xA;&#x9;&#x9;cards.add(new Card('S', 2));&#xA;&#x9;&#x9;cards.add(new Card('H', 13));&#xA;&#x9;&#x9;cards.add(new Card('C', 1));" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="246" end="-953"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378439906" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections.sort(cards);&#xA;&#x9;&#x9;for (Card i: cards) {&#xA;&#x9;&#x9;&#x9;System.out.println(i);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="399" end="-953"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379301275" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1098" end="-326"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379399137" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int compareTo(Card card) {&#xA;&#x9;&#x9;if (card.getSuit() != this.suit) {&#xA;&#x9;&#x9;&#x9;return card.getSuitNum()-this.getSuitNum();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return card.getFace()-this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;protected" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1098" end="-154"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379406047" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1261" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379421337" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private " edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1261" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380088580" sizeMeasure="77" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Comparator;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private int face;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck deck = new CardDeck(2);&#xA;&#x9;&#x9;Collections.sort(deck);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards= new ArrayList&lt;>();&#xA;&#x9;&#x9;cards.add(new Card('S', 3));&#xA;&#x9;&#x9;cards.add(new Card('S', 2));&#xA;&#x9;&#x9;cards.add(new Card('H', 13));&#xA;&#x9;&#x9;cards.add(new Card('C', 1));&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;for (Card i: cards) {&#xA;&#x9;&#x9;&#x9;System.out.println(i);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="96" end="-939"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="324" charEnd="328" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380291378" sizeMeasure="68" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Card> cards= new ArrayList&lt;>();&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(true, ' ');&#xA;&#x9;&#x9;cards.sort(comparator);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="264" end="-939"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380314543" sizeMeasure="75" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards.add(new Card('S', 3));&#xA;&#x9;&#x9;cards.add(new Card('S', 2));&#xA;&#x9;&#x9;cards.add(new Card('H', 13));&#xA;&#x9;&#x9;cards.add(new Card('C', 1));&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(true, ' ');&#xA;&#x9;&#x9;for (Card i: cards) {&#xA;&#x9;&#x9;&#x9;System.out.println(i);&#xA;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="303" end="-942"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="460" charEnd="470" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380331873" sizeMeasure="75" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fals" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="475" end="-1005"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="460" charEnd="470" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380338376" sizeMeasure="75" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="475" end="-1005"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="460" charEnd="470" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380346682" sizeMeasure="75" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="482" end="-1000"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="460" charEnd="470" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380362273" sizeMeasure="76" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards.sort(comparator" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="489" end="-999"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380378354" sizeMeasure="76" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="482" end="-1026"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380390103" sizeMeasure="76" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fals" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="475" end="-1031"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380443220" sizeMeasure="76" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="483" end="-1026"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380449287" sizeMeasure="76" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="483" end="-1026"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380470431" sizeMeasure="76" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="475" end="-1031"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="110" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380495500" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="66" end="-1403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380604693" sizeMeasure="75" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private int face;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards= new ArrayList&lt;>();&#xA;&#x9;&#x9;cards.add(new Card('S', 3));&#xA;&#x9;&#x9;cards.add(new Card('S', 2));&#xA;&#x9;&#x9;cards.add(new Card('H', 13));&#xA;&#x9;&#x9;cards.add(new Card('C', 1));&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(true, ' ');&#xA;&#x9;&#x9;Collection" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="66" end="-1016"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="489" charEnd="493" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381175282" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ards, " edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="478" end="-1009"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381190545" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fals" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="446" end="-1044"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381196366" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="454" end="-1039"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381249515" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1));&#xA;&#x9;&#x9;cards.add(new Card('S', 13));&#xA;&#x9;&#x9;cards.add(new Card('C', 1));&#xA;&#x9;&#x9;cards.add(new Card('C', 13));&#xA;&#x9;&#x9;cards.add(new Card('D', 1));&#xA;&#x9;&#x9;cards.add(new Card('D', 13));&#xA;&#x9;&#x9;cards.add(new Card('H', 1));&#xA;&#x9;&#x9;cards.add(new Card('H', 13" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="298" end="-1101"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381329775" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(cards);" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="627" end="-943"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381340009" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="573" end="-1019"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381342193" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="580" end="-1014"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381828911" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="false, 'D" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="573" end="-1014"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379016656" sizeMeasure="13">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card arg0, Card arg1) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379037427" sizeMeasure="11" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int compare(Card card1, Card card2) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="111" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="128" charEnd="159" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379220422" sizeMeasure="18" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private boolean aHighest;&#xA;&#x9;private char trumf;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean aHighest, char trumf) {&#xA;&#x9;&#x9;this.aHighest = aHighest;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="109" end="-57"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="294" charEnd="325" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="131" charEnd="139" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="156" charEnd="161" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379380661" sizeMeasure="18" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="324" end="-325"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="131" charEnd="139" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="156" charEnd="161" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="294" charEnd="325" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379439373" sizeMeasure="34" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (card1.getSuit() != card2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return card1.getSuitNum() - card2.getSuitNum();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return card1.getFace() - card2.getFace()&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;private int getSuitNum(char suit) {&#xA;&#x9;&#x9;if (suit == 'S') {&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (suit == 'H') {&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (suit == 'D') {&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="317" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="390" charEnd="400" severity="2" problemCategory="50" problemType="67108965"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="411" charEnd="421" severity="2" problemCategory="50" problemType="67108965"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="472" charEnd="473" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379458565" sizeMeasure="34" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getSuitNum(card1.getSuit()) - getSuitNum(card2.getSuit()" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="369" end="-225"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="490" charEnd="491" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379481720" sizeMeasure="37" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;private int getSuitNum(char suit) {&#xA;&#x9;&#x9;if (suit == trumf) {&#xA;&#x9;&#x9;&#x9;return 5;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="474" end="-133"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="131" charEnd="139" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379578460" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (aHighest) {&#xA;&#x9;&#x9;&#x9;return card2.getFace() - card1.getFace(" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="434" end="-266"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380420296" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1.getFace() - card2" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="464" end="-275"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380428579" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.getSuit()) - getSuitNum(card1.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (aHighest) {&#xA;&#x9;&#x9;&#x9;return card2.getFace() - card1" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="384" end="-275"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380481912" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1.getFace() - card2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return card2.getFace() - card1" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="464" end="-227"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381435984" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="369" end="-389"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381461016" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="369" end="-389"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381743645" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (suit == 'H') {&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (suit == 'D') {&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 4" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="657" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381797075" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="438" end="-320"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488381868991" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="620" end="-138"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488378443590" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488378451572" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380318172" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380334165" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380342313" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380348226" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380366659" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380380638" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380391868" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380438459" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380444790" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380450751" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488380483882" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381178328" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381192283" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381198232" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381253981" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381331882" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381343706" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381442245" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381464606" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381746577" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381798962" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381830475" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488381871737" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488380510067" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488381381173" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488381803316" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testAceIsHighest</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488381877733" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
