<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Logger">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the ILogger Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.ILogger"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Implementations">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StreamLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StreamLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StreamLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.StreamLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the FilteringLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the FilteringLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the FilteringLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.FilteringLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the DistributingLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DistributingLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DistributingLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.DistributingLoggerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.*Logger" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195836760" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public interface ILogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195917076" sizeMeasure="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9; &#xA;    public String ERROR = &quot;error&quot;, WARNING = &quot;warning&quot;, INFO = &quot;info&quot;;&#xA;    public void log(String severity, String message, Exception exception);&#xA;     " edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="57" end="-4"/>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195872485" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class StreamLogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195917057" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA;import java.io.OutputStream;&#xA;import java.io.PrintStream;&#xA; &#xA;public class StreamLogger implements ILogger{&#xA; &#xA;    private PrintStream stream;&#xA;    private String formatString = &quot;%s: %s (%s)&quot;; // eks. &quot;INFO, &quot;detter er en info-streng&quot;, null&quot;&#xA;     &#xA;    public StreamLogger(OutputStream stream){&#xA;        super();&#xA;        this.stream = new PrintStream(stream);&#xA;    }&#xA;     &#xA;    public void setFormatString(String format){&#xA;        this.formatString = format;&#xA;    }&#xA; &#xA;    @Override&#xA;    public void log(String severity, String message, Exception exception) {&#xA;        stream.format(formatString, severity, message, exception); // formaterer steamen&#xA;        stream.println(); // linjeskift&#xA;        stream.flush(); &#xA;    }" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="29" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490195918076" completion="1.0" successCount="3">
          <successTests>testLog</successTests>
          <successTests>testLogException</successTests>
          <successTests>testLogWithFormat</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195977964" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class FilteringLogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195996808" sizeMeasure="39" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA;import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collection;&#xA; &#xA;public class FilteringLogger implements ILogger{&#xA;     &#xA;    private ILogger logger;&#xA;    private final Collection&lt;String> severeties; &#xA;     &#xA;    public FilteringLogger(ILogger logger, String... severeties){&#xA;        //this.severeties = new ArrayList&lt;String>(Arrays.asList(severeties)); // gjør om &#xA;        this.logger = logger; &#xA;    }&#xA;     &#xA;    public boolean isLogging(String severity){&#xA;        return this.severeties.contains(severity); // skjekker om logging er tillatt ved å se om severity logger i listen&#xA;    }&#xA;     &#xA;    public void setIsLogging(String severity, boolean value){&#xA;        // trekker fra severity hvis den ikke skal være en del av listen&#xA;        // legger den til hvis en nødvendig severity ikke ligger i listen&#xA;        if (!value){&#xA;            severeties.remove(severity);&#xA;        } else if(! isLogging(severity)){&#xA;            severeties.add(severity);&#xA;        }&#xA;    }&#xA;     &#xA; &#xA;    @Override&#xA;    public void log(String severity, String message, Exception exception) {&#xA;        if (isLogging(severity)){&#xA;            logger.log(severity, message, exception);&#xA;        }&#xA;    }&#xA; " edit="/1/@proposals.1/@proposals.3/@attempts.0/@edit" start="29" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="40" charEnd="59" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="69" charEnd="85" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="276" charEnd="329" severity="2" problemCategory="50" problemType="33554513"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490196007351" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.severeties = new ArrayList&lt;String>(Arrays.asList(severeties)); // gjør om &#xA;        this.logger = logger; &#xA;    }&#xA;     &#xA;    public boolean isLogging(String severity){&#xA;        return this.severeties.contains(severity); // skjekker om logging er tillatt ved å se om severity logger i listen&#xA;    }&#xA;     &#xA;    public void setIsLogging(String severity, boolean value){&#xA;        // trekker fra severity hvis den ikke skal være en del av listen&#xA;        // legger den til hvis en nødvendig severity ikke ligger i listen&#xA;        if (" edit="/1/@proposals.1/@proposals.3/@attempts.1/@edit" start="328" end="-352"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490196033257" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!" edit="/1/@proposals.1/@proposals.3/@attempts.2/@edit" start="853" end="-352"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490195997241" completion="0.0" errorCount="5">
          <errorTests>testInfoToErrorLogger</errorTests>
          <errorTests>testFilteringLoggerErrorAndInfo</errorTests>
          <errorTests>testFilteringLoggerWarningSetIsLoggingError</errorTests>
          <errorTests>testFilteringLoggerNoSeverities</errorTests>
          <errorTests>testErrorLogging</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490196007792" completion="0.8" successCount="4" failureCount="1">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerErrorAndInfo</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <successTests>testErrorLogging</successTests>
          <failureTests>testFilteringLoggerWarningSetIsLoggingError</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490196033666" completion="1.0" successCount="5">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerErrorAndInfo</successTests>
          <successTests>testFilteringLoggerWarningSetIsLoggingError</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <successTests>testErrorLogging</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.6/@q" answer="/0/@parts.1/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490196054942" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class DistributingLogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490196073768" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA;import java.util.HashMap;&#xA;import java.util.Map;&#xA; &#xA;public class DistributingLogger implements ILogger{&#xA; &#xA;    private Map&lt;String, ILogger> loggers = new HashMap&lt;String, ILogger>();&#xA;     &#xA;    public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger){&#xA;        setLogger(ILogger.ERROR, errorLogger);&#xA;        setLogger(ILogger.WARNING, warningLogger);&#xA;        setLogger(ILogger.INFO, infoLogger);&#xA;    }&#xA;     &#xA;    void setLogger(String severity, ILogger logger){&#xA;        loggers.put(severity, logger);&#xA;    }&#xA; &#xA;    @Override&#xA;    public void log(String severity, String message, Exception exception) {&#xA;        ILogger logger = loggers.get(severity);&#xA;        if(logger != null){&#xA;            logger.log(severity, message, exception);&#xA;        }&#xA;    }" edit="/1/@proposals.1/@proposals.6/@attempts.0/@edit" start="29" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.7/@q" answer="/0/@parts.1/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.8/@q" answer="/0/@parts.1/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490196074155" completion="1.0" successCount="4">
          <successTests>testLogToInfo</successTests>
          <successTests>testLogToWarn</successTests>
          <successTests>testChangeInfoLogger</successTests>
          <successTests>testLogToError</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
