<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490186335014" sizeMeasure="8">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double price1, double price2);&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490381009406" sizeMeasure="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="oldPrice, double newPrice);&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="118" end="-6"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490186337930" sizeMeasure="42">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;String ticker;&#xA;&#x9;double price;&#xA;&#x9;ArrayList&lt;StockListener> listeners;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price) {&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double newPrice) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (newPrice &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Price can't be negative or zero&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;this.price = newPrice;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getTicker() {&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double getPrice() {&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener listener) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187741046" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;listeners = new ArrayList&lt;>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double newPrice) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (newPrice &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Price can't be negative or zero&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;// si ifra til alle listeners at prisen er endret&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; listeners.size(); i++) {&#xA;&#x9;&#x9;&#x9;&#x9;listeners.get(i).stockPriceChanged(this, this.price, newPrice);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.price = newPrice;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getTicker() {&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double getPrice() {&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(Observer listener) {&#xA;&#x9;&#x9;if (! listeners.contains(listener)) {&#xA;&#x9;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="246" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187879494" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener listener) {&#xA;&#x9;&#x9;if (! listeners.contains(listener)) {&#xA;&#x9;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener listener) {&#xA;&#x9;&#x9;if (listeners.contains(listener)) {&#xA;&#x9;&#x9;&#x9;listeners.remove" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="765" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490383951497" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StockListener listener : listeners) {&#xA;&#x9;&#x9;&#x9;&#x9;listener" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="498" end="-485"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490187741466" completion="0.5" successCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <errorTests>testStockListener</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490187879941" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490381009859" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187926522" sizeMeasure="11">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double price1, double price2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490381009401" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#xA;&#x9;double value;&#xA;&#x9;String name;&#xA;&#x9;ArrayList&lt;Stock> following;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.value = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock stock1) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.value = stock1.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock) {&#xA;&#x9;&#x9;following.add(stock);&#xA;&#x9;&#x9;this.value += stock.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (following.contains(stock)) {&#xA;&#x9;&#x9;&#x9;following.remove(stock);&#xA;&#x9;&#x9;&#x9;this.value -= stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double getIndex() {&#xA;&#x9;&#x9;return this.value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// siden prisen allerede er validert når denne metoden kalles, bare gjennomfører vi&#xA;&#x9;&#x9;this.value += (newPrice - oldPrice);" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490381302784" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="following.add(stock1);&#xA;&#x9;&#x9;this.value = stock1.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, ArrayList&lt;Stock> stocks) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;// iterer over alle aksjene i stocks&#xA;&#x9;&#x9;for (int i = 0; i &lt; stocks.size(); i++) {&#xA;&#x9;&#x9;&#x9;following.add(stocks.get(i));&#xA;&#x9;&#x9;&#x9;this.value += stocks.get(i).getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock) {&#xA;&#x9;&#x9;// sjekk at denne aksjen ikke fins i indeksen fra før&#xA;&#x9;&#x9;if (! following.contains(stock)) {&#xA;&#x9;&#x9;&#x9;following.add(stock);&#xA;&#x9;&#x9;&#x9;this.value += stock.getPrice();&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="322" end="-431"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490381686035" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Arrays;&#xA;import java.util.List;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#xA;&#x9;double value;&#xA;&#x9;String name;&#xA;&#x9;ArrayList&lt;Stock> following;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.value = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock stock1) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;following.add(stock1);&#xA;&#x9;&#x9;this.value = stock1.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, List&lt;Stock> stocks) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;// iterer over alle aksjene i stocks&#xA;&#x9;&#x9;for (int i = 0; i &lt; stocks.size(); i++) {&#xA;&#x9;&#x9;&#x9;following.add(stocks.get(i));&#xA;&#x9;&#x9;&#x9;this.value += stocks.get(i).getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock) {&#xA;&#x9;&#x9;// sjekk at denne aksjen ikke fins i indeksen fra før&#xA;&#x9;&#x9;if (! following.contains(stock)) {&#xA;&#x9;&#x9;&#x9;following.add(stock);&#xA;&#x9;&#x9;&#x9;this.value += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (following.contains(stock)) {&#xA;&#x9;&#x9;&#x9;following.remove(stock);&#xA;&#x9;&#x9;&#x9;this.value -= stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double getIndex() {&#xA;&#x9;&#x9;return this.value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// siden prisen allerede er validert når denne metoden kalles, bare gjennomfører vi&#xA;&#x9;&#x9;this.value += (newPrice - oldPrice);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Stock Apple = new Stock(&quot;AAPL&quot;, 110);&#xA;&#x9;&#x9;Stock Statoil = new Stock(&quot;STL&quot;, 320);&#xA;&#x9;&#x9;Stock Nanovector = new Stock(&quot;NANO&quot;, 97.2);&#xA;&#x9;&#x9;StockIndex SP500 = new StockIndex(&quot;S&amp;P500&quot;, Arrays.asList(Apple, Statoil, Nanovector));&#xA;&#x9;&#x9;System.out.println(SP500.getIndex()" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="58" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490381903213" sizeMeasure="79" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Arrays.as" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="1606" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1614" charEnd="1616" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1614" charEnd="1616" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1614" charEnd="1616" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490381915088" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="1606" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490382521074" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" ) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;// iterer over alle aksjene i stocks&#xA;&#x9;&#x9;for (Stock stock : stocks) {&#xA;&#x9;&#x9;&#x9;following.add(stock);&#xA;&#x9;&#x9;&#x9;this.value += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock) {&#xA;&#x9;&#x9;// sjekk at denne aksjen ikke fins i indeksen fra før&#xA;&#x9;&#x9;if (! following.contains(stock)) {&#xA;&#x9;&#x9;&#x9;following.add(stock);&#xA;&#x9;&#x9;&#x9;this.value += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (following.contains(stock)) {&#xA;&#x9;&#x9;&#x9;following.remove(stock);&#xA;&#x9;&#x9;&#x9;this.value -= stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double getIndex() {&#xA;&#x9;&#x9;return this.value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// siden prisen allerede er validert når denne metoden kalles, bare gjennomfører vi&#xA;&#x9;&#x9;this.value += (newPrice - oldPrice);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Stock Apple = new Stock(&quot;AAPL&quot;, 110);&#xA;&#x9;&#x9;Stock Statoil = new Stock(&quot;STL&quot;, 320);&#xA;&#x9;&#x9;Stock Nanovector = new Stock(&quot;NANO&quot;, 97.2);&#xA;&#x9;&#x9;StockIndex SP500 = new StockIndex(&quot;S&amp;P500&quot;, Arrays.asList(Apple, Statoil, Nanovector));&#xA;&#x9;&#x9;System.out.println(SP500.getIndex());" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="486" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490382610300" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = new ArrayList&lt;>()" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="215" end="-1369"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490382880040" sizeMeasure="78" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Stock..." edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="488" end="-1105"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1485" charEnd="1552" severity="2" problemCategory="50" problemType="134217858"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490383775512" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class StockIndex implements StockListener {&#xA;&#xA;&#x9;double value;&#xA;&#x9;String name;&#xA;&#x9;ArrayList&lt;Stock> following = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public StockIndex(String name) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.value = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock stock1) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;following.add(stock1);&#xA;&#x9;&#x9;this.value = stock1.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks ) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;// iterer over alle aksjene i stocks&#xA;&#x9;&#x9;for (Stock stock : stocks) {&#xA;&#x9;&#x9;&#x9;following.add(stock);&#xA;&#x9;&#x9;&#x9;this.value += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock) {&#xA;&#x9;&#x9;// sjekk at denne aksjen ikke fins i indeksen fra før&#xA;&#x9;&#x9;if (! following.contains(stock)) {&#xA;&#x9;&#x9;&#x9;following.add(stock);&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;this.value += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (following.contains(stock)) {&#xA;&#x9;&#x9;&#x9;following.remove(stock);&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;this.value -= stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double getIndex() {&#xA;&#x9;&#x9;return this.value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// siden prisen allerede er validert når denne metoden kalles, bare gjennomfører vi&#xA;&#x9;&#x9;this.value += (newPrice - oldPrice);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;/*public static void main(String[] args) {&#xA;&#x9;}*/" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="58" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490384753049" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="stock1.addStockListener(this);&#xA;&#x9;&#x9;this.value = stock1.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks ) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;// iterer over alle aksjene i stocks&#xA;&#x9;&#x9;for (Stock stock : stocks) {&#xA;&#x9;&#x9;&#x9;following.add(stock);&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="367" end="-797"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490381684755" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490381695679" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490381740929" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490381901714" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490381913706" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490381917561" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490382519774" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490382539036" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490382608947" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490382883079" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490383779331" mode="debug"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490381013731" completion="0.0" errorCount="4">
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
          <errorTests>testChangePrice</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490381303177" completion="0.0" errorCount="4">
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
          <errorTests>testChangePrice</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490382619080" completion="0.0" errorCount="4">
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
          <errorTests>testChangePrice</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490382881073" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490383776022" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490383787831" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490383952254" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490383959468" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490384004852" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490384010932" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490384514118" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490384753535" completion="1.0" successCount="4">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a" performedCount="31">
        <attempts timestamp="1490381696008"/>
        <attempts timestamp="1490381728944"/>
        <attempts timestamp="1490381741226"/>
        <attempts timestamp="1490381800151"/>
        <attempts timestamp="1490381903839"/>
        <attempts timestamp="1490381915662"/>
        <attempts timestamp="1490381918015"/>
        <attempts timestamp="1490382047720"/>
        <attempts timestamp="1490382521649"/>
        <attempts timestamp="1490382525582"/>
        <attempts timestamp="1490382539384"/>
        <attempts timestamp="1490382545644"/>
        <attempts timestamp="1490382883437"/>
        <attempts timestamp="1490384060167"/>
        <attempts timestamp="1490384116677"/>
        <attempts timestamp="1490384140302"/>
        <attempts timestamp="1490384157094"/>
        <attempts timestamp="1490384176116"/>
        <attempts timestamp="1490384207398"/>
        <attempts timestamp="1490384228485"/>
        <attempts timestamp="1490384252430"/>
        <attempts timestamp="1490384267846"/>
        <attempts timestamp="1490384359679"/>
        <attempts timestamp="1490384382567"/>
        <attempts timestamp="1490384395439"/>
        <attempts timestamp="1490384500366"/>
        <attempts timestamp="1490384507275"/>
        <attempts timestamp="1490384512201"/>
        <attempts timestamp="1490384530375"/>
        <attempts timestamp="1490384536770"/>
        <attempts timestamp="1490384539872"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a" performedCount="203">
        <attempts timestamp="1490381724917"/>
        <attempts timestamp="1490381727091"/>
        <attempts timestamp="1490381727852"/>
        <attempts timestamp="1490381728940"/>
        <attempts timestamp="1490381732516"/>
        <attempts timestamp="1490381744035"/>
        <attempts timestamp="1490381744755"/>
        <attempts timestamp="1490381745820"/>
        <attempts timestamp="1490381753908"/>
        <attempts timestamp="1490381772299"/>
        <attempts timestamp="1490381776068"/>
        <attempts timestamp="1490381784404"/>
        <attempts timestamp="1490381800148"/>
        <attempts timestamp="1490381920509"/>
        <attempts timestamp="1490381921178"/>
        <attempts timestamp="1490381922172"/>
        <attempts timestamp="1490381961637"/>
        <attempts timestamp="1490381985229"/>
        <attempts timestamp="1490381986301"/>
        <attempts timestamp="1490381998293"/>
        <attempts timestamp="1490382007157"/>
        <attempts timestamp="1490382051485"/>
        <attempts timestamp="1490382054126"/>
        <attempts timestamp="1490382523146"/>
        <attempts timestamp="1490382523635"/>
        <attempts timestamp="1490382524347"/>
        <attempts timestamp="1490382525578"/>
        <attempts timestamp="1490382556371"/>
        <attempts timestamp="1490382557611"/>
        <attempts timestamp="1490382558722"/>
        <attempts timestamp="1490382560466"/>
        <attempts timestamp="1490382561058"/>
        <attempts timestamp="1490382562427"/>
        <attempts timestamp="1490382572746"/>
        <attempts timestamp="1490382574011"/>
        <attempts timestamp="1490382575322"/>
        <attempts timestamp="1490384081235"/>
        <attempts timestamp="1490384088587"/>
        <attempts timestamp="1490384090131"/>
        <attempts timestamp="1490384109611"/>
        <attempts timestamp="1490384112131"/>
        <attempts timestamp="1490384114571"/>
        <attempts timestamp="1490384116675"/>
        <attempts timestamp="1490384118475"/>
        <attempts timestamp="1490384133452"/>
        <attempts timestamp="1490384135892"/>
        <attempts timestamp="1490384137403"/>
        <attempts timestamp="1490384140300"/>
        <attempts timestamp="1490384142044"/>
        <attempts timestamp="1490384145404"/>
        <attempts timestamp="1490384146459"/>
        <attempts timestamp="1490384147412"/>
        <attempts timestamp="1490384148947"/>
        <attempts timestamp="1490384149819"/>
        <attempts timestamp="1490384151755"/>
        <attempts timestamp="1490384152716"/>
        <attempts timestamp="1490384157092"/>
        <attempts timestamp="1490384158684"/>
        <attempts timestamp="1490384162988"/>
        <attempts timestamp="1490384164060"/>
        <attempts timestamp="1490384170276"/>
        <attempts timestamp="1490384171628"/>
        <attempts timestamp="1490384173980"/>
        <attempts timestamp="1490384174700"/>
        <attempts timestamp="1490384175452"/>
        <attempts timestamp="1490384176114"/>
        <attempts timestamp="1490384177699"/>
        <attempts timestamp="1490384182508"/>
        <attempts timestamp="1490384183260"/>
        <attempts timestamp="1490384184940"/>
        <attempts timestamp="1490384186268"/>
        <attempts timestamp="1490384189532"/>
        <attempts timestamp="1490384190252"/>
        <attempts timestamp="1490384192723"/>
        <attempts timestamp="1490384193620"/>
        <attempts timestamp="1490384195611"/>
        <attempts timestamp="1490384196859"/>
        <attempts timestamp="1490384197604"/>
        <attempts timestamp="1490384198235"/>
        <attempts timestamp="1490384199156"/>
        <attempts timestamp="1490384199884"/>
        <attempts timestamp="1490384200436"/>
        <attempts timestamp="1490384200900"/>
        <attempts timestamp="1490384201740"/>
        <attempts timestamp="1490384202228"/>
        <attempts timestamp="1490384202836"/>
        <attempts timestamp="1490384203396"/>
        <attempts timestamp="1490384203876"/>
        <attempts timestamp="1490384204756"/>
        <attempts timestamp="1490384205484"/>
        <attempts timestamp="1490384206004"/>
        <attempts timestamp="1490384206459"/>
        <attempts timestamp="1490384206931"/>
        <attempts timestamp="1490384207396"/>
        <attempts timestamp="1490384209452"/>
        <attempts timestamp="1490384220588"/>
        <attempts timestamp="1490384221443"/>
        <attempts timestamp="1490384224748"/>
        <attempts timestamp="1490384225852"/>
        <attempts timestamp="1490384227340"/>
        <attempts timestamp="1490384228483"/>
        <attempts timestamp="1490384231004"/>
        <attempts timestamp="1490384245501"/>
        <attempts timestamp="1490384249316"/>
        <attempts timestamp="1490384250924"/>
        <attempts timestamp="1490384252428"/>
        <attempts timestamp="1490384254372"/>
        <attempts timestamp="1490384256372"/>
        <attempts timestamp="1490384257308"/>
        <attempts timestamp="1490384258260"/>
        <attempts timestamp="1490384261756"/>
        <attempts timestamp="1490384264236"/>
        <attempts timestamp="1490384265444"/>
        <attempts timestamp="1490384266700"/>
        <attempts timestamp="1490384267844"/>
        <attempts timestamp="1490384269172"/>
        <attempts timestamp="1490384271476"/>
        <attempts timestamp="1490384273092"/>
        <attempts timestamp="1490384275140"/>
        <attempts timestamp="1490384275956"/>
        <attempts timestamp="1490384339645"/>
        <attempts timestamp="1490384340828"/>
        <attempts timestamp="1490384342133"/>
        <attempts timestamp="1490384343277"/>
        <attempts timestamp="1490384344517"/>
        <attempts timestamp="1490384345901"/>
        <attempts timestamp="1490384347485"/>
        <attempts timestamp="1490384348645"/>
        <attempts timestamp="1490384349589"/>
        <attempts timestamp="1490384350229"/>
        <attempts timestamp="1490384350820"/>
        <attempts timestamp="1490384351501"/>
        <attempts timestamp="1490384352053"/>
        <attempts timestamp="1490384352581"/>
        <attempts timestamp="1490384353525"/>
        <attempts timestamp="1490384354205"/>
        <attempts timestamp="1490384354741"/>
        <attempts timestamp="1490384355396"/>
        <attempts timestamp="1490384356204"/>
        <attempts timestamp="1490384356997"/>
        <attempts timestamp="1490384357732"/>
        <attempts timestamp="1490384358301"/>
        <attempts timestamp="1490384358789"/>
        <attempts timestamp="1490384359220"/>
        <attempts timestamp="1490384359676"/>
        <attempts timestamp="1490384360804"/>
        <attempts timestamp="1490384375485"/>
        <attempts timestamp="1490384376420"/>
        <attempts timestamp="1490384379189"/>
        <attempts timestamp="1490384380549"/>
        <attempts timestamp="1490384381925"/>
        <attempts timestamp="1490384382565"/>
        <attempts timestamp="1490384384181"/>
        <attempts timestamp="1490384391709"/>
        <attempts timestamp="1490384393126"/>
        <attempts timestamp="1490384394621"/>
        <attempts timestamp="1490384395437"/>
        <attempts timestamp="1490384397013"/>
        <attempts timestamp="1490384400645"/>
        <attempts timestamp="1490384401997"/>
        <attempts timestamp="1490384403277"/>
        <attempts timestamp="1490384405756"/>
        <attempts timestamp="1490384406541"/>
        <attempts timestamp="1490384408413"/>
        <attempts timestamp="1490384409189"/>
        <attempts timestamp="1490384410542"/>
        <attempts timestamp="1490384411773"/>
        <attempts timestamp="1490384412413"/>
        <attempts timestamp="1490384413069"/>
        <attempts timestamp="1490384414509"/>
        <attempts timestamp="1490384416229"/>
        <attempts timestamp="1490384425333"/>
        <attempts timestamp="1490384558237"/>
        <attempts timestamp="1490384562990"/>
        <attempts timestamp="1490384603526"/>
        <attempts timestamp="1490384605759"/>
        <attempts timestamp="1490384608838"/>
        <attempts timestamp="1490384610694"/>
        <attempts timestamp="1490384612238"/>
        <attempts timestamp="1490384613894"/>
        <attempts timestamp="1490384616030"/>
        <attempts timestamp="1490384617150"/>
        <attempts timestamp="1490384618078"/>
        <attempts timestamp="1490384618959"/>
        <attempts timestamp="1490384619630"/>
        <attempts timestamp="1490384620206"/>
        <attempts timestamp="1490384621559"/>
        <attempts timestamp="1490384622262"/>
        <attempts timestamp="1490384623278"/>
        <attempts timestamp="1490384625245"/>
        <attempts timestamp="1490384626918"/>
        <attempts timestamp="1490384627702"/>
        <attempts timestamp="1490384629062"/>
        <attempts timestamp="1490384630062"/>
        <attempts timestamp="1490384630678"/>
        <attempts timestamp="1490384631294"/>
        <attempts timestamp="1490384631823"/>
        <attempts timestamp="1490384632350"/>
        <attempts timestamp="1490384632862"/>
        <attempts timestamp="1490384633526"/>
        <attempts timestamp="1490384633959"/>
        <attempts timestamp="1490384634253"/>
        <attempts timestamp="1490384634830"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a" performedCount="12">
        <attempts timestamp="1490381748107"/>
        <attempts timestamp="1490381759636"/>
        <attempts timestamp="1490381923661"/>
        <attempts timestamp="1490381971580"/>
        <attempts timestamp="1490381992565"/>
        <attempts timestamp="1490382024262"/>
        <attempts timestamp="1490382041102"/>
        <attempts timestamp="1490382047717"/>
        <attempts timestamp="1490382548619"/>
        <attempts timestamp="1490382551666"/>
        <attempts timestamp="1490382554138"/>
        <attempts timestamp="1490382564419"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a" performedCount="6">
        <attempts timestamp="1490381779244"/>
        <attempts timestamp="1490381954843"/>
        <attempts timestamp="1490382029179"/>
        <attempts timestamp="1490382568898"/>
        <attempts timestamp="1490384066082"/>
        <attempts timestamp="1490384546034"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
