<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="HighscoreListListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the HighscoreListListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.HighscoreListListener"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="HighScoreList">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the HighScoreList class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.HighscoreList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the HighscoreList class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.HighscoreList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the HighscoreListTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.HighscoreListTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="HighscoreListProgram">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the HighscoreListProgram class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.HighscoreListProgram"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the HighscoreListProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.HighscoreListProgram"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.HighscoreList*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490217150466" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface HighscoreListListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490217313335" sizeMeasure="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void listChanged(HighscoreList list, int position);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="72" end="-4"/>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490213112374" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class HighscoreList {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490218640514" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class HighscoreList implements HighscoreListListener{&#xA;&#x9;&#xA;&#x9;private int maxSize;&#xA;&#x9;private List&lt;Integer> results = new ArrayList&lt;>();&#xA;&#x9;private List&lt;HighscoreListListener> listeners = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public HighscoreList(int maxSize){&#xA;&#x9;&#x9;this.maxSize = maxSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int size(){&#xA;&#x9;&#x9;return results.size();&#xA;&#x9;}&#xA;&#xA;&#x9;public int getElement(int index){&#xA;&#x9;&#x9;if (index &lt;= results.size() || index &lt; maxSize || !(index &lt; 0)){&#xA;&#x9;&#x9;&#x9;return results.get(index); &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid index.&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addResult(int result){&#xA;&#x9;&#x9;// If the result is smaller than the largest element:&#xA;&#x9;&#x9;// Add the result to the list and sort it (from smallest to largest)&#xA;&#x9;&#x9;if (result &lt; results.get(results.size())){&#xA;&#x9;&#x9;&#x9;results.add(result);&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;Collections.sort(results,new ResultsComparator());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Checking if the list is to long. In that case, removing the largest element (last in the list)&#xA;&#x9;&#x9;if (results.size() > maxSize){&#xA;&#x9;&#x9;&#x9;results.remove(results.size());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addHighscoreListListener(HighscoreListListener listener){&#xA;&#x9;&#x9;if (!listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeHighscoreListListener(HighscoreListListener listener){&#xA;&#x9;&#x9;if (listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;listeners.remove(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void listChanged(HighscoreList list, int position) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219531022" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(results.size() &lt; maxSize || result &lt; results.get(results.size()-1)){&#xA;&#x9;&#x9;&#x9;results.add(result);&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;Collections.sort(results, new ResultsComparator());&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// Checking if the list is to long. In that case, removing the largest element (last in the list)&#xA;&#x9;&#x9;&#x9;if (results.size() > maxSize){&#xA;&#x9;&#x9;&#x9;&#x9;results.remove(results.size()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// Sending a notification to the listeners about the change&#xA;&#x9;&#x9;&#x9;listChanged(this, results.indexOf(result));&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="812" end="-439"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219875105" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public void listChanged(HighscoreList list, int position) {&#xA;&#x9;&#x9;for (HighscoreListListener listener : listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(list, position);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;HighscoreList highscore = new HighscoreList(3);&#xA;&#x9;&#x9;highscore.addResult(1);&#xA;&#x9;&#x9;highscore.addResult(4);&#xA;&#x9;&#x9;highscore.addResult(2);&#xA;&#x9;&#x9;System.out.println(&quot;Listen er: &quot; + highscore.results);&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="1568" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219903381" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5);&#xA;&#x9;&#x9;highscore.addResult(1);&#xA;&#x9;&#x9;highscore.addResult(4);&#xA;&#x9;&#x9;highscore.addResult(2);&#xA;&#x9;&#x9;highscore.addResult(6" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="1831" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219945937" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="highscore.addResult(3" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="1967" end="-72"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490264578535" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lastI" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="1241" end="-818"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490266388941" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Integer> getResults(){&#xA;&#x9;&#x9;return results" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="653" end="-1426"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490266402155" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getResults()" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="2101" end="-15"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490219878635" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490219905351" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490219947840" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490266404639" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490220028704" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490264585363" completion="1.0" successCount="7"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490264797299" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class HighscoreListProgram {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490266140176" sizeMeasure="40" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Scanner;&#xA;&#xA;public class HighscoreListProgram implements HighscoreListListener {&#xA;&#xA;&#x9;HighscoreList highscoreList;&#xA;&#x9;&#xA;&#x9;public void init(){&#xA;&#x9;&#x9;System.out.println(&quot;What is the desired maximum size of the highscore list? &quot;);&#xA;&#x9;&#x9;Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#x9;int maxSize = scanner.nextInt();&#xA;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;highscoreList = new HighscoreList(maxSize);&#xA;&#x9;&#xA;&#x9;&#x9;// Adding HighscoreListProgram (this) as a listener&#xA;&#x9;&#x9;HighscoreListListener listener = new HighscoreListProgram();&#xA;&#x9;&#x9;highscoreList.addHighscoreListListener(listener);&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void run(){&#xA;&#x9;&#x9;System.out.println(&quot;Add a result (as an int): &quot;);&#xA;&#x9;&#x9;Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#x9;int result = scanner.nextInt();&#xA;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void listChanged(HighscoreList list, int position) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.2/@proposals.0/@attempts.0/@edit" start="30" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490266408366" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=": &quot;);&#xA;&#x9;&#x9;Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#x9;int result = scanner.nextInt();&#xA;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;highscoreList.addResult(result);&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void listChanged(HighscoreList list, int position) {&#xA;&#x9;&#x9;System.out.println(&quot;Listen er: &quot; + list.getResults());" edit="/1/@proposals.2/@proposals.0/@attempts.1/@edit" start="643" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490266527009" sizeMeasure="43">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="It has been a change in the highscore list in position &quot; + position + &quot;! &quot; +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;The list is now: &quot;);&#xA;&#x9;&#x9;System.out.println(" edit="/1/@proposals.2/@proposals.0/@attempts.2/@edit" start="889" end="-30"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267249317" sizeMeasure="50" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//HighscoreList highscoreList;&#xA;&#x9;&#xA;&#x9;public void init(){&#xA;&#x9;&#x9;System.out.println(&quot;What is the desired maximum size of the highscore list? &quot;);&#xA;&#x9;&#x9;Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#x9;int maxSize = scanner.nextInt();&#xA;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;HighscoreList highscoreList = new HighscoreList(maxSize);&#xA;&#x9;&#xA;&#x9;&#x9;// Adding HighscoreListProgram (this) as a listener&#xA;&#x9;&#x9;HighscoreListListener listener = new HighscoreListProgram();&#xA;&#x9;&#x9;highscoreList.addHighscoreListListener(listener);&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void run(){&#xA;&#x9;&#x9;System.out.println(&quot;Add a result: &quot;);&#xA;&#x9;&#x9;Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#x9;int result = scanner.nextInt();&#xA;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;HighscoreList highscoreList;&#xA;&#x9;&#x9;highscoreList.addResult(result);&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void listChanged(HighscoreList list, int position) {&#xA;&#x9;&#x9;System.out.println(&quot;It has been a change in the highscore list in position &quot; + position + &quot;! &quot; +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;The list is now: &quot;);&#xA;&#x9;&#x9;System.out.println(list.getResults());&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;init();&#xA;&#x9;&#x9;run();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.2/@proposals.0/@attempts.3/@edit" start="128" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267383384" sizeMeasure="49" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HighscoreList highscoreList;&#xA;&#x9;&#xA;&#x9;public void init(){&#xA;&#x9;&#x9;System.out.println(&quot;What is the desired maximum size of the highscore list? &quot;);&#xA;&#x9;&#x9;Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#x9;int maxSize = scanner.nextInt();&#xA;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;highscoreList = new HighscoreList(maxSize);&#xA;&#x9;&#xA;&#x9;&#x9;// Adding HighscoreListProgram (this) as a listener&#xA;&#x9;&#x9;HighscoreListListener listener = new HighscoreListProgram();&#xA;&#x9;&#x9;highscoreList.addHighscoreListListener(listener);&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void run(){&#xA;&#x9;&#x9;System.out.println(&quot;Add a result: &quot;);&#xA;&#x9;&#x9;Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#x9;int result = scanner.nextInt();&#xA;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;" edit="/1/@proposals.2/@proposals.0/@attempts.4/@edit" start="128" end="-366"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267459556" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HighscoreListProgram program = new HighscoreListProgram();&#xA;&#x9;&#x9;program.init();&#xA;&#x9;&#x9;program." edit="/1/@proposals.2/@proposals.0/@attempts.5/@edit" start="1082" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267562897" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#xA;&#x9;public void init(){&#xA;&#x9;&#x9;System.out.println(&quot;What is the desired maximum size of the highscore list? &quot;);&#x9;&#xA;&#x9;&#x9;int maxSize = scanner.nextInt();" edit="/1/@proposals.2/@proposals.0/@attempts.6/@edit" start="158" end="-828"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267794749" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="while (true){&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Add a result: (press 0 if you are finised adding)&quot;);&#xA;&#x9;&#x9;&#x9;Scanner scanner = new Scanner(System.in);&#xA;&#x9;&#x9;&#x9;int result = scanner.nextInt();&#xA;&#x9;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (result == 0)&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;highscoreList.addResult(result);&#xA;&#x9;&#x9;}" edit="/1/@proposals.2/@proposals.0/@attempts.7/@edit" start="588" end="-407"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267805004" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.2/@proposals.0/@attempts.8/@edit" start="856" end="-405"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267845270" sizeMeasure="52" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;if (result == 0)&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;highscoreList.addResult(result);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;scanner.close();" edit="/1/@proposals.2/@proposals.0/@attempts.9/@edit" start="761" end="-404"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267977268" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;&#x9;System.out.println(&quot;Done adding numbers!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.2/@proposals.0/@attempts.10/@edit" start="781" end="-467"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490267998051" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="scanner.close();&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;highscoreList.addResult(result);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.2/@proposals.0/@attempts.11/@edit" start="835" end="-404"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490268066882" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return" edit="/1/@proposals.2/@proposals.0/@attempts.12/@edit" start="856" end="-457"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490267461391" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490267565463" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490267806701" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490267847167" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490268068477" mode="run"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
