<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488975506279" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488976312539" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488975448096" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488976202351" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;private List&lt;StockListener> listeners = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price) {&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double price) {&#xA;&#x9;&#x9;if (0 >= price) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Stocks can not have negative or zero value&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice() {&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker() {&#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListeners(StockListener listener) {&#xA;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListeners(StockListener listener) {&#xA;&#x9;&#x9;listeners.remove(listeners.indexOf(listener));&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="30" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488976241681" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(StockListener listener) {&#xA;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="613" end="-82"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488977677649" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (StockListener listener : listeners) {&#xA;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this.price, price" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="459" end="-336"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488980156468" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!listeners.contains(listener)) {&#xA;&#x9;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener listener) {&#xA;&#x9;&#x9;if (listeners.contains(listener)) {&#xA;&#x9;&#x9;&#x9;listeners.remove(listeners.indexOf(listener));&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="747" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488980798947" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="price, this." edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="538" end="-428"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488980939461" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.price, price);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice() {&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker() {&#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener listener) {&#xA;&#x9;&#x9;if (true) {&#xA;&#x9;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener listener) {&#xA;&#x9;&#x9;if (true" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="538" end="-64"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488980951874" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="listeners.contains(listener)" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="861" end="-64"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488981299838" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!listeners.contains(listener)" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="751" end="-198"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488976222607" completion="0.5" successCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <errorTests>testStockListener</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488976246034" completion="0.5" successCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <errorTests>testStockListener</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488976315457" completion="0.5" successCount="1" failureCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testStockListener</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488977249306" completion="0.5" successCount="1" failureCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testStockListener</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488979201405" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488975467827" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488977242678" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.List;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#xA;&#x9;private String name;&#xA;&#x9;private double index;&#xA;&#x9;private List&lt;Stock> stocks = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.stocks = Arrays.asList(stocks);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex() {&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock) {&#xA;&#x9;&#x9;stocks.add(stock);&#xA;&#x9;&#x9;stockPriceChanged(stock, 0, stock.getPrice());&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock) {&#xA;&#x9;&#x9;stocks.remove(stock);&#xA;&#x9;&#x9;stockPriceChanged(stock, stock.getPrice(), 0);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;index += newPrice - oldPrice;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488977356065" sizeMeasure="41" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;for(Stock stock : stocks) {&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, 0, stock.getPrice());&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="366" end="-417"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488977743696" sizeMeasure="43" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.add(stock);&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, 0, stock.getPrice());&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="542" end="-256"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488977787739" sizeMeasure="43" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s.indexOf(stock)" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="715" end="-189"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488977846561" sizeMeasure="43" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Array" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="213" end="-707"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="361" charEnd="382" severity="2" problemCategory="40" problemType="16777233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488977943737" sizeMeasure="44" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Stock> stockstemp = Arrays.asList(stocks);&#xA;&#x9;&#x9;this.stocks = new ArrayList&lt;Stock>(stockstemp" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="333" end="-558"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488977999930" sizeMeasure="46" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stocks.indexOf(stock));&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, stock.getPrice(), 0);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;index += newPrice - oldPrice;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="762" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488978017341" sizeMeasure="45" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="891" end="-134"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488979391936" sizeMeasure="48" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (stocks.length == 0) {&#xA;&#x9;&#x9;&#x9;index = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex() {&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock) {&#xA;&#x9;&#x9;if (!stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.add(stock);&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, 0, stock.getPrice());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stocks.indexOf(stock));&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, stock.getPrice(), 0);&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="516" end="-134"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488979813134" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".addStockListener(this);&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, 0, stock.getPrice());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stocks.indexOf(stock));&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="715" end="-193"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488980156437" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="1137" end="-1138"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488981299807" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="236" end="-882"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488982576936" sizeMeasure="49" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="1110" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489051695716" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".addStockListener(this);&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, 0, stock.getPrice());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (stocks.length == 0) {&#xA;&#x9;&#x9;&#x9;index = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex() {&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock) {&#xA;&#x9;&#x9;if (!stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.add(stock);&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, 0, stock.getPrice());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stocks.indexOf(stock));&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;stockPriceChanged(stock, stock.getPrice(), 0);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;index += newPrice - oldPrice;" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="449" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489052130231" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="1147" end="-1148"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="187" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488977257427" completion="0.0" failureCount="3" errorCount="1">
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testChangePrice</failureTests>
          <failureTests>testConstructor</failureTests>
          <errorTests>testAddStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488977356851" completion="0.25" successCount="1" failureCount="1" errorCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488977680551" completion="0.25" successCount="1" failureCount="1" errorCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488977744460" completion="0.25" successCount="1" failureCount="1" errorCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488977788542" completion="0.25" successCount="1" failureCount="1" errorCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488977849895" completion="0.0" errorCount="4">
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
          <errorTests>testChangePrice</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488977944485" completion="0.5" successCount="2" failureCount="1" errorCount="1">
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
          <errorTests>testRemoveStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488978000647" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488979194304" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488979208959" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488979395117" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488979567838" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488979833138" completion="0.5" successCount="2" failureCount="1" errorCount="1">
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
          <errorTests>testRemoveStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488980157226" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488980318133" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488980799763" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488980940285" completion="0.5" successCount="2" failureCount="1" errorCount="1">
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
          <errorTests>testRemoveStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488980952544" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488981300793" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488982691875" completion="0.5" successCount="1" failureCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488982715962" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488982947715" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489050866187" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489051713098" completion="1.0" successCount="4">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489051928977" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class SmartStock extends Stock {&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="45" charEnd="55" severity="2" problemCategory="50" problemType="134217868"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489052014523" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public SmartStock(String ticker, double price) {&#xA;&#x9;&#x9;super(ticker, price);&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;public void addStockListener(StockListener _function, double d, double e) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public void addStockListener(StockListener _function, double d) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.2/@proposals.0/@attempts.0/@edit" start="71" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489052134247" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.2/@proposals.0/@attempts.1/@edit" start="425" end="-426"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a" performedCount="17">
        <attempts timestamp="1488979481217"/>
        <attempts timestamp="1488979612984"/>
        <attempts timestamp="1488979722554"/>
        <attempts timestamp="1488979813983"/>
        <attempts timestamp="1488980205160"/>
        <attempts timestamp="1488982578223"/>
        <attempts timestamp="1488982660932"/>
        <attempts timestamp="1488982672282"/>
        <attempts timestamp="1488982675496"/>
        <attempts timestamp="1488982727297"/>
        <attempts timestamp="1488982745496"/>
        <attempts timestamp="1488982748500"/>
        <attempts timestamp="1488982751862"/>
        <attempts timestamp="1488982763310"/>
        <attempts timestamp="1488982793058"/>
        <attempts timestamp="1488982813329"/>
        <attempts timestamp="1488983067008"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a" performedCount="7">
        <attempts timestamp="1488979687794"/>
        <attempts timestamp="1488979691194"/>
        <attempts timestamp="1488979693078"/>
        <attempts timestamp="1488979694678"/>
        <attempts timestamp="1488982654192"/>
        <attempts timestamp="1488982654645"/>
        <attempts timestamp="1488982655092"/>
        <attempts timestamp="1488982655461"/>
        <attempts timestamp="1488982656030"/>
        <attempts timestamp="1488982656645"/>
        <attempts timestamp="1488982657130"/>
        <attempts timestamp="1488982657646"/>
        <attempts timestamp="1488982658147"/>
        <attempts timestamp="1488982658715"/>
        <attempts timestamp="1488982659232"/>
        <attempts timestamp="1488982659760"/>
        <attempts timestamp="1488982660364"/>
        <attempts timestamp="1488982660932"/>
        <attempts timestamp="1488982661333"/>
        <attempts timestamp="1488982663781"/>
        <attempts timestamp="1488982665652"/>
        <attempts timestamp="1488982669581"/>
        <attempts timestamp="1488982672282"/>
        <attempts timestamp="1488982673696"/>
        <attempts timestamp="1488982674165"/>
        <attempts timestamp="1488982674750"/>
        <attempts timestamp="1488982675066"/>
        <attempts timestamp="1488982675496"/>
        <attempts timestamp="1488982675942"/>
        <attempts timestamp="1488982676365"/>
        <attempts timestamp="1488982676817"/>
        <attempts timestamp="1488982677218"/>
        <attempts timestamp="1488982677681"/>
        <attempts timestamp="1488982678466"/>
        <attempts timestamp="1488982680137"/>
        <attempts timestamp="1488982680785"/>
        <attempts timestamp="1488982681386"/>
        <attempts timestamp="1488982682586"/>
        <attempts timestamp="1488982683401"/>
        <attempts timestamp="1488982683986"/>
        <attempts timestamp="1488982684424"/>
        <attempts timestamp="1488982697230"/>
        <attempts timestamp="1488982697745"/>
        <attempts timestamp="1488982735555"/>
        <attempts timestamp="1488982736603"/>
        <attempts timestamp="1488982740476"/>
        <attempts timestamp="1488982741240"/>
        <attempts timestamp="1488982741957"/>
        <attempts timestamp="1488982744348"/>
        <attempts timestamp="1488982745494"/>
        <attempts timestamp="1488982746062"/>
        <attempts timestamp="1488982746446"/>
        <attempts timestamp="1488982746865"/>
        <attempts timestamp="1488982747244"/>
        <attempts timestamp="1488982747767"/>
        <attempts timestamp="1488982748068"/>
        <attempts timestamp="1488982748500"/>
        <attempts timestamp="1488982748823"/>
        <attempts timestamp="1488982749221"/>
        <attempts timestamp="1488982749706"/>
        <attempts timestamp="1488982750104"/>
        <attempts timestamp="1488982750544"/>
        <attempts timestamp="1488982751544"/>
        <attempts timestamp="1488982751860"/>
        <attempts timestamp="1488982752322"/>
        <attempts timestamp="1488982752676"/>
        <attempts timestamp="1488982753054"/>
        <attempts timestamp="1488982753495"/>
        <attempts timestamp="1488982754049"/>
        <attempts timestamp="1488982754925"/>
        <attempts timestamp="1488982756704"/>
        <attempts timestamp="1488982757341"/>
        <attempts timestamp="1488982757857"/>
        <attempts timestamp="1488982758989"/>
        <attempts timestamp="1488982759673"/>
        <attempts timestamp="1488982760158"/>
        <attempts timestamp="1488982760420"/>
        <attempts timestamp="1488982760589"/>
        <attempts timestamp="1488982760773"/>
        <attempts timestamp="1488982760920"/>
        <attempts timestamp="1488982761105"/>
        <attempts timestamp="1488982761290"/>
        <attempts timestamp="1488982761458"/>
        <attempts timestamp="1488982761620"/>
        <attempts timestamp="1488982761792"/>
        <attempts timestamp="1488982761936"/>
        <attempts timestamp="1488982762110"/>
        <attempts timestamp="1488982762279"/>
        <attempts timestamp="1488982762679"/>
        <attempts timestamp="1488982763079"/>
        <attempts timestamp="1488982763310"/>
        <attempts timestamp="1488982763548"/>
        <attempts timestamp="1488982763648"/>
        <attempts timestamp="1488982763827"/>
        <attempts timestamp="1488982764396"/>
        <attempts timestamp="1488982764649"/>
        <attempts timestamp="1488982764865"/>
        <attempts timestamp="1488982798610"/>
        <attempts timestamp="1488982799125"/>
        <attempts timestamp="1488982799510"/>
        <attempts timestamp="1488982799894"/>
        <attempts timestamp="1488982800257"/>
        <attempts timestamp="1488982800810"/>
        <attempts timestamp="1488982801347"/>
        <attempts timestamp="1488982801563"/>
        <attempts timestamp="1488982801817"/>
        <attempts timestamp="1488982801933"/>
        <attempts timestamp="1488982831484"/>
        <attempts timestamp="1488982832268"/>
        <attempts timestamp="1488982941279"/>
        <attempts timestamp="1488982941780"/>
        <attempts timestamp="1488982942047"/>
        <attempts timestamp="1488982942527"/>
        <attempts timestamp="1488982942928"/>
        <attempts timestamp="1488982943244"/>
        <attempts timestamp="1488982943544"/>
        <attempts timestamp="1488982943743"/>
        <attempts timestamp="1488982943912"/>
        <attempts timestamp="1488982944044"/>
        <attempts timestamp="1488982944213"/>
        <attempts timestamp="1488982944359"/>
        <attempts timestamp="1488982944497"/>
        <attempts timestamp="1488982944660"/>
        <attempts timestamp="1488982944813"/>
        <attempts timestamp="1488982944979"/>
        <attempts timestamp="1488982945122"/>
        <attempts timestamp="1488982945280"/>
        <attempts timestamp="1488982945429"/>
        <attempts timestamp="1488982945782"/>
        <attempts timestamp="1488982945960"/>
        <attempts timestamp="1488982946145"/>
        <attempts timestamp="1488982946298"/>
        <attempts timestamp="1488982946498"/>
        <attempts timestamp="1488982946645"/>
        <attempts timestamp="1488982946814"/>
        <attempts timestamp="1488982946998"/>
        <attempts timestamp="1488982947199"/>
        <attempts timestamp="1488982947383"/>
        <attempts timestamp="1488982947545"/>
        <attempts timestamp="1488982947715"/>
        <attempts timestamp="1488982947883"/>
        <attempts timestamp="1488982948083"/>
        <attempts timestamp="1488982948245"/>
        <attempts timestamp="1488982948782"/>
        <attempts timestamp="1488982949397"/>
        <attempts timestamp="1488982949797"/>
        <attempts timestamp="1488982950281"/>
        <attempts timestamp="1488983071062"/>
        <attempts timestamp="1488983072624"/>
        <attempts timestamp="1489059362853"/>
        <attempts timestamp="1489059365956"/>
        <attempts timestamp="1489059370542"/>
        <attempts timestamp="1489059372021"/>
        <attempts timestamp="1489059374945"/>
        <attempts timestamp="1489059375729"/>
        <attempts timestamp="1489059378176"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a" performedCount="21">
        <attempts timestamp="1488979486909"/>
        <attempts timestamp="1488979489071"/>
        <attempts timestamp="1488979490781"/>
        <attempts timestamp="1488979506182"/>
        <attempts timestamp="1488979509403"/>
        <attempts timestamp="1488979512875"/>
        <attempts timestamp="1488979514122"/>
        <attempts timestamp="1488979514807"/>
        <attempts timestamp="1488979515491"/>
        <attempts timestamp="1488979642986"/>
        <attempts timestamp="1488979644501"/>
        <attempts timestamp="1488979647847"/>
        <attempts timestamp="1488979650201"/>
        <attempts timestamp="1488979650870"/>
        <attempts timestamp="1488979652368"/>
        <attempts timestamp="1488979663666"/>
        <attempts timestamp="1488979668029"/>
        <attempts timestamp="1488979675474"/>
        <attempts timestamp="1488979680359"/>
        <attempts timestamp="1488979722554"/>
        <attempts timestamp="1488979724507"/>
        <attempts timestamp="1488979727523"/>
        <attempts timestamp="1488979729596"/>
        <attempts timestamp="1488979749318"/>
        <attempts timestamp="1488979750350"/>
        <attempts timestamp="1488979751986"/>
        <attempts timestamp="1488979752686"/>
        <attempts timestamp="1488979753202"/>
        <attempts timestamp="1488979753633"/>
        <attempts timestamp="1488979754502"/>
        <attempts timestamp="1488980244677"/>
        <attempts timestamp="1488980246446"/>
        <attempts timestamp="1488980247446"/>
        <attempts timestamp="1488980249491"/>
        <attempts timestamp="1488980250545"/>
        <attempts timestamp="1488980251578"/>
        <attempts timestamp="1488980253692"/>
        <attempts timestamp="1488980256460"/>
        <attempts timestamp="1488980262191"/>
        <attempts timestamp="1488980264044"/>
        <attempts timestamp="1488980272636"/>
        <attempts timestamp="1488980275214"/>
        <attempts timestamp="1488980277454"/>
        <attempts timestamp="1488980278637"/>
        <attempts timestamp="1488980288605"/>
        <attempts timestamp="1488980291221"/>
        <attempts timestamp="1488980294205"/>
        <attempts timestamp="1488980296506"/>
        <attempts timestamp="1488980300738"/>
        <attempts timestamp="1488980302219"/>
        <attempts timestamp="1488980305216"/>
        <attempts timestamp="1488980306468"/>
        <attempts timestamp="1488982582956"/>
        <attempts timestamp="1488982585755"/>
        <attempts timestamp="1488982630759"/>
        <attempts timestamp="1488982633947"/>
        <attempts timestamp="1488982634827"/>
        <attempts timestamp="1488982635596"/>
        <attempts timestamp="1488982638151"/>
        <attempts timestamp="1488982638667"/>
        <attempts timestamp="1488982640252"/>
        <attempts timestamp="1488982641053"/>
        <attempts timestamp="1488982641588"/>
        <attempts timestamp="1488982642054"/>
        <attempts timestamp="1488982642502"/>
        <attempts timestamp="1488982642918"/>
        <attempts timestamp="1488982643576"/>
        <attempts timestamp="1488982644292"/>
        <attempts timestamp="1488982644938"/>
        <attempts timestamp="1488982645473"/>
        <attempts timestamp="1488982645955"/>
        <attempts timestamp="1488982646577"/>
        <attempts timestamp="1488982647477"/>
        <attempts timestamp="1488982648140"/>
        <attempts timestamp="1488982648824"/>
        <attempts timestamp="1488982649509"/>
        <attempts timestamp="1488982650110"/>
        <attempts timestamp="1488982650742"/>
        <attempts timestamp="1488982651409"/>
        <attempts timestamp="1488982651975"/>
        <attempts timestamp="1488982652459"/>
        <attempts timestamp="1488982652827"/>
        <attempts timestamp="1488982653290"/>
        <attempts timestamp="1488982839933"/>
        <attempts timestamp="1488982840871"/>
        <attempts timestamp="1488982841972"/>
        <attempts timestamp="1488982842919"/>
        <attempts timestamp="1488982844172"/>
        <attempts timestamp="1488982846119"/>
        <attempts timestamp="1488982851809"/>
        <attempts timestamp="1488982853678"/>
        <attempts timestamp="1488982857458"/>
        <attempts timestamp="1488982886767"/>
        <attempts timestamp="1488982913212"/>
        <attempts timestamp="1488982914511"/>
        <attempts timestamp="1488982922609"/>
        <attempts timestamp="1488982931438"/>
        <attempts timestamp="1488982933507"/>
        <attempts timestamp="1488982933975"/>
        <attempts timestamp="1488982934423"/>
        <attempts timestamp="1488982934878"/>
        <attempts timestamp="1488982937374"/>
        <attempts timestamp="1488982938780"/>
        <attempts timestamp="1488983074094"/>
        <attempts timestamp="1488983182294"/>
        <attempts timestamp="1488983183411"/>
        <attempts timestamp="1489059415093"/>
        <attempts timestamp="1489059417741"/>
        <attempts timestamp="1489059418303"/>
        <attempts timestamp="1489059419624"/>
        <attempts timestamp="1489059494687"/>
        <attempts timestamp="1489059505095"/>
        <attempts timestamp="1489059520930"/>
        <attempts timestamp="1489059571155"/>
        <attempts timestamp="1489059579602"/>
        <attempts timestamp="1489059585431"/>
        <attempts timestamp="1489059587952"/>
        <attempts timestamp="1489059591589"/>
        <attempts timestamp="1489059593004"/>
        <attempts timestamp="1489059595434"/>
        <attempts timestamp="1489059597601"/>
        <attempts timestamp="1489059598864"/>
        <attempts timestamp="1489059600386"/>
        <attempts timestamp="1489059602685"/>
        <attempts timestamp="1489059607030"/>
        <attempts timestamp="1489059614283"/>
        <attempts timestamp="1489059623238"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1488979496214"/>
        <attempts timestamp="1488979617972"/>
        <attempts timestamp="1488979814067"/>
        <attempts timestamp="1488980208888"/>
        <attempts timestamp="1488982588525"/>
        <attempts timestamp="1488982820599"/>
        <attempts timestamp="1488983079594"/>
        <attempts timestamp="1489059337680"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
