<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607366461" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607407583" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;void stockPriceChanged(Stock stock, double oldPrice, double newPrice);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607409724" sizeMeasure="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="137" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607179257" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607263338" sizeMeasure="15" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, int price) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="51" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="157" charEnd="158" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="185" charEnd="191" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="204" charEnd="205" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607352601" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.ticker = ticker;&#xA;&#x9;&#x9;setPrice(price);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double newPrice) {&#xA;&#x9;&#x9;if (newPrice &lt;= 0) throw new IllegalArgumentException(&quot;Price must be positive + non-zero&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice() {&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker() {&#xA;&#x9;&#x9;return ticker;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="146" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607513520" sizeMeasure="31" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;private ArrayList&lt;StockListener> listeners = new ArrayList&lt;StockListener>();&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, int price) {&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;setPrice(price);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double newPrice) {&#xA;&#x9;&#x9;if (newPrice &lt;= 0) throw new IllegalArgumentException(&quot;Price must be positive + non-zero&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice() {&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker() {&#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStockListener() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="30" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="171" charEnd="180" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607635799" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StockListener sl) {&#xA;&#x9;&#x9;listeners.add(sl);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStockListener(StockListener sl) {&#xA;&#x9;&#x9;if (listeners.contains(sl)) listeners.remove(sl);" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="562" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489608831104" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;for (StockListener sl : listeners) sl.stockPriceChanged(this, price, newPrice);&#xA;&#x9;&#x9;price = newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice() {&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker() {&#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStockListener(StockListener sl) {&#xA;&#x9;&#x9;listeners.add(sl);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStockListener(StockListener sl) {&#xA;&#x9;&#x9;if (listeners.contains(sl)) listeners.remove(sl);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;[Ticker: %s | Price: %f]&quot;, ticker, price" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="435" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489608851869" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="238" end="-673"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489608878657" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607649453" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607792134" sizeMeasure="10" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements StockListener{&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;Stock> = new ArrayList&lt;Stock>();&#xA;&#x9;private String name;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks)&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="54" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="45" charEnd="55" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="110" charEnd="111" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="159" charEnd="160" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="212" charEnd="213" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607841255" sizeMeasure="14" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;Stock> stockList = new ArrayList&lt;Stock>();&#xA;&#x9;private String name;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks) {&#xA;&#x9;&#x9;for (stock : stocks) stockList.add(stock);&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="30" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="265" charEnd="270" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="265" charEnd="270" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="273" charEnd="279" severity="2" problemCategory="40" problemType="16777796"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="295" charEnd="300" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="76" charEnd="86" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489607942482" sizeMeasure="14" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s = new ArrayList&lt;Stock>();&#xA;&#x9;private String name;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... inputStocks) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; inputStocks.length; i++) this.stocks.add(inputStocks[i]" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="142" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="76" charEnd="86" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="193" charEnd="197" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489608607446" sizeMeasure="32" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Arrays;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;Stock> stocks;&#xA;&#x9;private String name;&#xA;&#x9;private double index = 0;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... inputStocks) {&#xA;&#x9;&#x9;stocks = new ArrayList&lt;Stock>(Arrays.asList(inputStocks));&#xA;&#x9;&#x9;for (Stock stock : stocks) index += stock.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStock(Stock stock) {&#xA;&#x9;&#x9;if (!stocks.contains(stock)) stocks.add(stock);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) stocks.remove(stock);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;double getIndex() {&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;index += (newPrice - oldPrice);&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="58" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609103069" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;stocks.add(stock);&#xA;&#x9;&#x9;&#x9;index += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="460" end="-167"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609170498" sizeMeasure="40" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;throw IllegalArgumentException(&quot;Stock is already there&quot;" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="517" end="-302"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="555" charEnd="579" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609177330" sizeMeasure="40" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ne" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="534" end="-353"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609207101" sizeMeasure="42" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Stock does not exist&quot;" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="722" end="-173"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609365542" sizeMeasure="42" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//throw new IllegalArgumentException(&quot;Stock is already there&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;//" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="528" end="-230"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609370115" sizeMeasure="42" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" throw new IllegalArgumentException(&quot;Stock is already there&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;// " edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="530" end="-230"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609430193" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;index -= stock.getPrice(" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="517" end="-173"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609728543" sizeMeasure="39" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;Old index: &quot; + index + &quot; | New index: &quot; + (index + newPrice - oldPrice));" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="775" end="-41"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609788306" sizeMeasure="44" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;index += stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStock(Stock stock) {&#xA;&#x9;&#x9;if (!stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.add(stock);&#xA;&#x9;&#x9;&#x9;index += stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock stock) {&#xA;&#x9;&#x9;if (stocks.contains(stock)) {&#xA;&#x9;&#x9;&#x9;stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="367" end="-269"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609823068" sizeMeasure="43" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="886" end="-41"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="194" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609981349" sizeMeasure="48" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index += (newPrice - oldPrice);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String outStr = &quot;StockIndex name: &quot; + name + &quot;\n&quot;;&#xA;&#x9;&#x9;outStr" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="886" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1051" charEnd="1057" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1051" charEnd="1057" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489609999277" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" += stocks.toString();" edit="/1/@proposals.1/@proposals.0/@attempts.15/@edit" start="1012" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="981" charEnd="991" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489610008232" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return outStr" edit="/1/@proposals.1/@proposals.0/@attempts.16/@edit" start="1036" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489610288312" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s.asList(inputStocks" edit="/1/@proposals.1/@proposals.0/@attempts.17/@edit" start="297" end="-723"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="304" charEnd="317" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489610297370" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Stock>(Arrays.asList(inputStocks)" edit="/1/@proposals.1/@proposals.0/@attempts.18/@edit" start="297" end="-723"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489608888439" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489609106235" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489609209828" completion="0.25" successCount="1" failureCount="1" errorCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489609373320" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489609735199" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489609816616" completion="1.0" successCount="4">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489653718725" sizeMeasure="41" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.HashMap;&#xA;import java.util.Map;&#xA;&#xA;public class SmartStock extends Stock {&#xA;&#xA;&#x9;private HashMap&lt;StockListener, Double[]> intervalListeners, differenceListeners;&#xA;&#x9;private Double[] temp;&#xA;&#x9;&#xA;&#x9;public SmartStock(String ticker, double price) {&#xA;&#x9;&#x9;super(ticker, price);&#xA;&#x9;&#x9;intervalListeners = new HashMap&lt;StockListener, Double[]>();&#xA;&#x9;&#x9;differenceListeners = new HashMap&lt;StockListener, Double[]>();&#xA;&#x9;}&#xA;&#xA;&#x9;public void addStockListener(StockListener sl, double min, double max) {&#xA;&#x9;&#x9;intervalListeners.put(sl, new Double[] {min, max, price});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener sl, double difference) {&#xA;&#x9;&#x9;differenceListeners.put(sl, new Double[] {difference, price});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void setPrice(double newPrice) {&#xA;&#x9;&#x9;if (!intervalListeners.isEmpty()) {&#xA;&#x9;&#x9;&#x9;for (StockListener sl : intervalListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;temp = intervalListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;if (newPrice &lt; temp[0] || newPrice > temp[1]) sl.stockPriceChanged(this, temp[2], newPrice);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (!differenceListeners.isEmpty()) {&#xA;&#x9;&#x9;&#x9;for (StockListener sl : differenceListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;temp = differenceListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;if (Math.abs(newPrice - temp[1]) > Math.abs(temp[0])) sl.stockPriceChanged(this, temp[1], newPrice);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;price = newPrice;&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489653852833" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.ticker = ticker;&#xA;&#x9;&#x9;setPrice(" edit="/1/@proposals.2/@proposals.0/@attempts.0/@edit" start="280" end="-987"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="246" charEnd="285" severity="2" problemCategory="50" problemType="134217871"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489653954866" sizeMeasure="43" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super(ticker, price);" edit="/1/@proposals.2/@proposals.0/@attempts.1/@edit" start="280" end="-1023"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654001054" sizeMeasure="43" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = new HashMap&lt;StockListener, Double[]>(), differenceListeners= new HashMap&lt;StockListener, Double[]>();&#xA;&#x9;private Double[] temp;&#xA;&#x9;&#xA;&#x9;public SmartStock(String ticker, double price) {&#xA;&#x9;&#x9;super(ticker, price);&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;setPrice(price);&#xA;&#x9;&#x9;intervalListeners &#xA;&#x9;&#x9;differenceListeners " edit="/1/@proposals.2/@proposals.0/@attempts.2/@edit" start="179" end="-854"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="464" charEnd="483" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="442" charEnd="459" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654004050" sizeMeasure="41" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.2/@proposals.0/@attempts.3/@edit" start="427" end="-854"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654041854" sizeMeasure="41" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#xA;&#x9;public void addStockListener(StockListener sl, double min, double max) {&#xA;&#x9;&#x9;intervalListeners.put(sl, new Double[] {min, max, price});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener sl, double difference) {&#xA;&#x9;&#x9;differenceListeners.put(sl, new Double[] {difference, price});&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void setPrice(double newPrice) {&#xA;&#x9;&#x9;if (!intervalListeners.isEmpty()) {&#xA;&#x9;&#x9;&#x9;for (StockListener sl : intervalListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;temp = intervalListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;if (newPrice &lt; temp[0] || newPrice > temp[1]) sl.stockPriceChanged(this, temp[2], newPrice);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (!differenceListeners.isEmpty()) {&#xA;&#x9;&#x9;&#x9;for (StockListener sl : differenceListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;temp = differenceListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;if (Math.abs(newPrice - temp[1]) > Math.abs(temp[0])) sl.stockPriceChanged(this, temp[1], newPrice);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.setPrice(newPrice)" edit="/1/@proposals.2/@proposals.0/@attempts.4/@edit" start="427" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654190964" sizeMeasure="46" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="try {&#xA;&#x9;&#x9;&#x9;if (!intervalListeners.isEmpty()) {&#xA;&#x9;&#x9;&#x9;&#x9;for (StockListener sl : intervalListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temp = intervalListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (newPrice &lt; temp[0] || newPrice > temp[1]) sl.stockPriceChanged(this, temp[2], newPrice);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!differenceListeners.isEmpty()) {&#xA;&#x9;&#x9;&#x9;&#x9;for (StockListener sl : differenceListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temp = differenceListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (Math.abs(newPrice - temp[1]) > Math.abs(temp[0])) sl.stockPriceChanged(this, temp[1], newPrice);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} catch (NullPointerException e) {&#xA;&#x9;&#x9;&#x9;intervalListeners = new HashMap&lt;StockListener, Double[]>();&#xA;&#x9;&#x9;&#x9;differenceListeners= new HashMap&lt;StockListener, Double[]>();" edit="/1/@proposals.2/@proposals.0/@attempts.5/@edit" start="763" end="-39"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654322637" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;sl.stockPriceChanged(this, temp[2], newPrice);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;temp[2] = newPrice;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;intervalListeners.put(sl, temp);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!differenceListeners.isEmpty()) {&#xA;&#x9;&#x9;&#x9;&#x9;for (StockListener sl : differenceListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temp = differenceListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (Math.abs(newPrice - temp[1]) > Math.abs(temp[0])) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;sl.stockPriceChanged(this, temp[1], newPrice);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;temp[1] = newPrice;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;differenceListeners.put(sl, temp);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.2/@proposals.0/@attempts.6/@edit" start="956" end="-214"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654361759" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= temp[0] || newPrice >=" edit="/1/@proposals.2/@proposals.0/@attempts.7/@edit" start="924" end="-691"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654375275" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" temp[0] || newPrice >" edit="/1/@proposals.2/@proposals.0/@attempts.8/@edit" start="924" end="-691"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654392933" sizeMeasure="52" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.2/@proposals.0/@attempts.9/@edit" start="384" end="-1219"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="66" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654401366" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class SmartStock extends Stock {&#xA;&#xA;&#x9;private HashMap&lt;StockListener, Double[]> intervalListeners = new HashMap&lt;StockListener, Double[]>(), differenceListeners= new HashMap&lt;StockListener, Double[]>();&#xA;&#x9;private Double[] temp;&#xA;&#x9;&#xA;&#x9;public SmartStock(String ticker, double price) {&#xA;&#x9;&#x9;super(ticker, " edit="/1/@proposals.2/@proposals.0/@attempts.10/@edit" start="56" end="-1219"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654418257" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", differenceListeners" edit="/1/@proposals.2/@proposals.0/@attempts.11/@edit" start="157" end="-1313"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654478108" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (StockListener sl : intervalListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;temp = intervalListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;if (newPrice &lt; temp[0] || newPrice > temp[1]) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;sl.stockPriceChanged(this, temp[2], newPrice);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temp[2] = newPrice;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;intervalListeners.put(sl, temp);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (StockListener sl : differenceListeners.keySet()) {&#xA;&#x9;&#x9;&#x9;&#x9;temp = differenceListeners.get(sl);&#xA;&#x9;&#x9;&#x9;&#x9;if (Math.abs(newPrice - temp[1]) > Math.abs(temp[0])) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;sl.stockPriceChanged(this, temp[1], newPrice);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;temp[1] = newPrice;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;differenceListeners.put(sl, temp);" edit="/1/@proposals.2/@proposals.0/@attempts.12/@edit" start="626" end="-214"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654831311" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;&#x9;&#x9;temp[2] = newPrice;&#xA;&#x9;&#x9;&#x9;&#x9;intervalListeners.put(sl, temp);" edit="/1/@proposals.2/@proposals.0/@attempts.13/@edit" start="826" end="-495"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654854715" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;&#x9;&#x9;temp[1] = newPrice;&#xA;&#x9;&#x9;&#x9;&#x9;differenceListeners.put(sl, temp);" edit="/1/@proposals.2/@proposals.0/@attempts.14/@edit" start="1109" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654862826" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;temp[1] = newPrice;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;differenceListeners.put(sl, temp);&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.2/@proposals.0/@attempts.15/@edit" start="1109" end="-208"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489653614251" completion="0.0" errorCount="6">
          <errorTests>testIntervalListener1</errorTests>
          <errorTests>testIntervalListener2</errorTests>
          <errorTests>testDifferenceListener1</errorTests>
          <errorTests>testDifferenceListener2</errorTests>
          <errorTests>testStockListener</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489653722715" completion="0.0" errorCount="6">
          <errorTests>testIntervalListener1</errorTests>
          <errorTests>testIntervalListener2</errorTests>
          <errorTests>testDifferenceListener1</errorTests>
          <errorTests>testDifferenceListener2</errorTests>
          <errorTests>testStockListener</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489653968610" completion="0.0" errorCount="6">
          <errorTests>testIntervalListener1</errorTests>
          <errorTests>testIntervalListener2</errorTests>
          <errorTests>testDifferenceListener1</errorTests>
          <errorTests>testDifferenceListener2</errorTests>
          <errorTests>testStockListener</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654009195" completion="0.0" errorCount="6">
          <errorTests>testIntervalListener1</errorTests>
          <errorTests>testIntervalListener2</errorTests>
          <errorTests>testDifferenceListener1</errorTests>
          <errorTests>testDifferenceListener2</errorTests>
          <errorTests>testStockListener</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654045374" completion="0.0" errorCount="6">
          <errorTests>testIntervalListener1</errorTests>
          <errorTests>testIntervalListener2</errorTests>
          <errorTests>testDifferenceListener1</errorTests>
          <errorTests>testDifferenceListener2</errorTests>
          <errorTests>testStockListener</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654195609" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testIntervalListener2</successTests>
          <successTests>testDifferenceListener1</successTests>
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testIntervalListener1</failureTests>
          <failureTests>testDifferenceListener2</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654326555" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testIntervalListener2</successTests>
          <successTests>testDifferenceListener1</successTests>
          <successTests>testDifferenceListener2</successTests>
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testIntervalListener1</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654365156" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testIntervalListener2</successTests>
          <successTests>testDifferenceListener1</successTests>
          <successTests>testDifferenceListener2</successTests>
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testIntervalListener1</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654397053" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testIntervalListener2</successTests>
          <successTests>testDifferenceListener1</successTests>
          <successTests>testDifferenceListener2</successTests>
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testIntervalListener1</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654836379" completion="1.0" successCount="6">
          <successTests>testIntervalListener1</successTests>
          <successTests>testIntervalListener2</successTests>
          <successTests>testDifferenceListener1</successTests>
          <successTests>testDifferenceListener2</successTests>
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654857668" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testIntervalListener1</successTests>
          <successTests>testIntervalListener2</successTests>
          <successTests>testDifferenceListener2</successTests>
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDifferenceListener1</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654886409" completion="1.0" successCount="6">
          <successTests>testIntervalListener1</successTests>
          <successTests>testIntervalListener2</successTests>
          <successTests>testDifferenceListener1</successTests>
          <successTests>testDifferenceListener2</successTests>
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
