<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694453064" sizeMeasure="47" errorCount="11">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockListener {&#xA;&#xA;&#x9;public String tick;&#xA;&#x9;public Integer price;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#x9;&#xA;&#x9;Stock(tick, price){ &#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, &#xA;//&#x9;skal metoden utløse en IllegalArgumentException.&#xA;&#x9;void setPrice(double){ &#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;&#xA;&#x9;void stockPriceChanged(Stock, double, double){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;metode for å legge til nye observatører.&#xA;&#x9;void addStockListener(StockListener){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;metode for å fjerne observatører.&#xA;&#x9;void removeStockListener(StockListener){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694833672" sizeMeasure="47" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="er;&#xA;&#x9;public double price;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#x9;&#xA;&#x9;public void Stock(String ticker, double price){ &#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, &#xA;//&#x9;skal metoden utløse en IllegalArgumentException.&#xA;&#x9;void setPrice(double price){ &#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return price;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="79" end="-420"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490695479002" sizeMeasure="50" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StockListener(String ticker, double price){ &#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, &#xA;//&#x9;skal metoden utløse en IllegalArgumentException.&#xA;&#x9;void setPrice(double price){ //throws IllegalArgumentException{ &#xA;&#x9;&#x9;if(price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;pris er null eller negativ&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="186" end="-583"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490695504553" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703541866" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703559402" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="63" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706031132" sizeMeasure="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void stockPriceChanged(Stock stock, double price, double oldPrice);&#xA;//&#x9;void addStockListener(StockListener listener);&#xA;//&#x9;void removeStockListener(StockListener listener);" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="64" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706423264" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="132" end="-6"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490695504558" sizeMeasure="50" errorCount="7">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;&#x9;public String ticker;&#xA;&#x9;public double price;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#x9;&#xA;&#x9;public Stock(String ticker, double price){ &#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, &#xA;//&#x9;skal metoden utløse en IllegalArgumentException.&#xA;&#x9;void setPrice(double price){ //throws IllegalArgumentException{ &#xA;&#x9;&#x9;if(price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;pris er null eller negativ&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;&#xA;&#x9;void stockPriceChanged(Stock, double, double){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;metode for å legge til nye observatører.&#xA;&#x9;void addStockListener(StockListener){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;metode for å fjerne observatører.&#xA;&#x9;void removeStockListener(StockListener){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490702998176" sizeMeasure="51" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate String ticker;&#xA;&#x9;private double price;&#xA;&#x9;private double oldPrice;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#x9;&#xA;&#x9;public Stock(String ticker, double price){ &#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, &#xA;//&#x9;skal metoden utløse en IllegalArgumentException.&#xA;&#x9;void setPrice(double price){ //throws IllegalArgumentException{ &#xA;&#x9;&#x9;if(price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;pris er null eller negativ&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;void stockPriceChanged(Stock stock, double price, double oldPrice){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;metode for å legge til nye observatører.&#xA;&#x9;void addStockListener(StockListener listener){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;metode for å fjerne observatører.&#xA;&#x9;void removeStockListener(StockListener l" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="54" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703943224" sizeMeasure="53" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="oldPrice &#xA;&#x9;&#x9;setPrice(price);" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="980" end="-206"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490704121326" sizeMeasure="53" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="980" end="-225"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706028511" sizeMeasure="55" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Stock stock;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#x9;&#xA;&#x9;public Stock(String ticker, double price){ &#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, &#xA;//&#x9;skal metoden utløse en IllegalArgumentException.&#xA;&#x9;void setPrice(double price){ //throws IllegalArgumentException{ &#xA;&#x9;&#x9;if(price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;pris er null eller negativ&quot;);&#xA;&#x9;&#x9;}&#xA;//&#x9;&#x9;stockPriceChanged(stock, price, oldPrice);&#xA;&#x9;&#x9;oldPrice = getPrice();&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;void stockPriceChanged(Stock stock, double price, double oldPrice){&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="126" end="-206"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706413697" sizeMeasure="64" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;//&#x9;Du skal videre definere et lyttergrensesnitt kalt StockListener, &#xA;//&#x9;som observatørene må implementere. Grensesnittet skal inneholde én metode:&#xA;&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;void stockPriceChanged(Stock stock, double price, double oldPrice){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;Foreløpig er Stock ikke observerbar. For at observatører skal kunne holdes &#xA;//&#x9;oppdatert, må Stock-objekter administrere en liste med lyttere. &#xA;//&#x9;Derfor må Stock-klassen i tillegg ha følgende metoder:&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="827" end="-199"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490712287977" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;oldPrice = getPrice();&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, oldPrice);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="565" end="-981"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490712523523" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private double[] ArrayList;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#x9;&#xA;&#x9;public Stock(String ticker, double price){ &#x9;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;this.ticker = ticker;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="148" end="-1370"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713084550" sizeMeasure="70" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Map;&#xA;&#xA;public class Stock {&#xA;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;private double oldPrice;&#xA;&#x9;private Stock stock;&#xA;&#x9;private Map&lt;StockListener, ArrayList&lt;Double>> listeners" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="30" end="-1538"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713092022" sizeMeasure="71" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;listeners = new HashMap&lt;StockListener,ArrayList&lt;Double>>()" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="424" end="-1371"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713094734" sizeMeasure="71" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="463" end="-1391"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713100331" sizeMeasure="72" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HashMap" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="75" end="-1799"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713181438" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (listeners.containsKey(listener)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Object is already an observer&quot;);&#x9;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1777" end="-103"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713194433" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1894" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713302915" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Allerede eksisterende lytter&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;listeners.put(listener,null);&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;//&#x9;metode for å fjerne observatører.&#xA;&#x9;void removeStockListener(StockListener listener){&#xA;&#x9;&#x9;if (!listeners.containsKey(listener)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ingen lytter&quot;);&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1855" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713312532" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Ingen eksisterende" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="2098" end="-27"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713320851" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="2142" end="-2143"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713356178" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="listeners.remove(listener);" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="2134" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713361836" sizeMeasure="78" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="2160" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713364285" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="2160" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713373316" sizeMeasure="78" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="2160" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713378092" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="2160" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713535371" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return this." edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="976" end="-1113"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713602581" sizeMeasure="78" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="176" end="-2004"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713648484" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private double oldPrice;&#xA;&#x9;private Stock stock;&#xA;&#x9;private Map&lt;StockListener, ArrayList&lt;Double>> listeners;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#x9;&#xA;&#x9;public Stock(String ticker, double price){ &#x9;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;listeners = new HashMap&lt;StockListener, ArrayList&lt;Double>>();&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, &#xA;//&#x9;skal metoden utløse en IllegalArgumentException.&#xA;&#x9;void setPrice(double price){ //throws IllegalArgumentException{ &#xA;&#x9;&#x9;if(price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;pris er null eller negativ&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;oldPrice =" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="176" end="-1350"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713722678" sizeMeasure="80" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, oldPrice);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;//&#x9;Du skal videre definere et lyttergrensesnitt kalt StockListener, &#xA;//&#x9;som observatørene må implementere. Grensesnittet skal inneholde én metode:&#xA;&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;void stockPriceChanged(Stock stock, double price, double oldPrice){&#xA;&#x9;&#x9;for (StockListener listener : listeners.keySet()) { &#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="808" end="-702"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713735905" sizeMeasure="80" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (listeners.get(listener) == null) {" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="1512" end="-706"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713738810" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="1553" end="-706"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713757838" sizeMeasure="82" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="449" end="-1817"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713764571" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="449" end="-1817"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713770259" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="403" end="-1863"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713775973" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="403" end="-1863"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713821073" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="listener.stockPriceChanged(this, oldPrice, price);" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="1555" end="-711"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713881169" sizeMeasure="85" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;else if (newPrice &lt; listeners.get(listener).get(0) || newPrice > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this.price, newP" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1613" end="-717"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713887325" sizeMeasure="85" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1623" end="-856"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713892149" sizeMeasure="85" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="1665" end="-811"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713897171" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1756" end="-717"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713908233" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="oldP" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="1744" end="-724"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714002119" sizeMeasure="90" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public void addStockListener(StockListener listener, double min, double max) {&#xA;&#x9;&#x9;if (min >= max) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal interval range&quot;);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="2229" end="-247"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714015614" sizeMeasure="94" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Double> interval = new ArrayList&lt;Double>();&#xA;&#x9;&#x9;interval.add(min); interval.add(max);&#xA;&#x9;&#x9;listeners.put(listener, interval);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="2401" end="-245"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714020302" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="2536" end="-245"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714042549" sizeMeasure="98" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public void removeStockListener(StockListener listener) {&#xA;&#x9;&#x9;if (!listeners.containsKey(listener)) {" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="2539" end="-245"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714071291" sizeMeasure="102" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ute av range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;ArrayList&lt;Double> interval = new ArrayList&lt;Double>();&#xA;&#x9;&#x9;interval.add(min); interval.add(max);&#xA;&#x9;&#x9;listeners.put(listener, interval);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener listener) {&#xA;&#x9;&#x9;if (!listeners.containsKey(listener)) {&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ikke en observatør&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;listeners.remove(listener);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="2369" end="-245"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714105283" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="2530" end="-245"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714107122" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="2530" end="-245"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714259852" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="price ,oldPrice );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this,price, oldPrice );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;Foreløpig er Stock ikke observerbar. For at observatører skal kunne holdes &#xA;//&#x9;oppdatert, må Stock-objekter administrere en liste med lyttere. &#xA;//&#x9;Derfor må Stock-klassen i tillegg ha følgende metoder:&#xA;&#x9;&#xA;//&#x9;metode for å legge til nye observatører.&#xA;&#x9;void addStockListener(StockListener listener){&#xA;&#x9;&#x9;if (listeners.containsKey(listener)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Allerede eksisterende lytter&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;listeners.put(listener,null);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener listener, double min, double max) {&#xA;&#x9;&#x9;if (min >= max) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ute av range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;ArrayList&lt;Double> interval = new ArrayList&lt;Double>();&#xA;&#x9;&#x9;interval.add(min); interval.add(max);&#xA;&#x9;&#x9;listeners.put(listener, interval);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="1587" end="-245"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714277646" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" this.price ,oldPrice );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this." edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="1587" end="-1031"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714316442" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="oldPrice, this.price );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, oldPrice,this.p" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="1588" end="-1020"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714329577" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.oldPrice, this.price );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this." edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="1588" end="-1035"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714377138" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.price,  oldPrice );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this,this.price , oldP" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="1587" end="-1020"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714407638" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="stockPriceChanged(stock, price, oldPrice);&#xA;&#x9;&#x9;this.price = price" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="811" end="-1912"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714476370" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="oldPrice = price;" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="808" end="-1978"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714641554" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getPrice()" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="819" end="-1979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714661898" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="price" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="819" end="-1979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714666746" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="871" end="-1932"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714773019" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="newPrice;&#xA;&#x9;private Stock stock;&#xA;&#x9;private Map&lt;StockListener, ArrayList&lt;Double>> listeners;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#x9;&#xA;&#x9;public Stock(String ticker, double price){ &#x9;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;listeners = new HashMap&lt;StockListener, ArrayList&lt;Double>>();&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, &#xA;//&#x9;skal metoden utløse en IllegalArgumentException.&#xA;&#x9;void setPrice(double price){ //throws IllegalArgumentException{ &#xA;&#x9;&#x9;if(price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;pris er null eller negativ&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;newPrice = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, newPrice);&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;//&#x9;Du skal videre definere et lyttergrensesnitt kalt StockListener, &#xA;//&#x9;som observatørene må implementere. Grensesnittet skal inneholde én metode:&#xA;&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;void stockPriceChanged(Stock stock, double price, double newPrice){&#xA;&#x9;&#x9;for (StockListener listener : listeners.keySet()) { &#xA;&#x9;&#x9;&#x9;if (listeners.get(listener) == null) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this.price,  newPrice );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this.price , new" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="192" end="-1021"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714821740" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="894" end="-1910"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714929278" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;//&#x9;Du skal videre definere et lyttergrensesnitt kalt StockListener, &#xA;//&#x9;som observatørene må implementere. Grensesnittet skal inneholde én metode:&#xA;&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;void stockPriceChanged(Stock stock, double price, double newPrice){&#xA;&#x9;&#x9;for (StockListener listener : listeners.keySet()) { &#xA;&#x9;&#x9;&#x9;if (listeners.get(listener) == null) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, price,  newPrice );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, " edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="871" end="-1032"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714939608" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;newPrice = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, newPrice);&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="806" end="-1921"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714945522" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="873" end="-1921"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714973327" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;newPrice = getPrice();&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, newPrice)" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="806" end="-1901"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714998124" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="stockPriceChanged(stock, price, newPrice);&#xA;&#x9;&#x9;this.price = price" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="833" end="-1901"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715015436" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.price, newPrice);&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="858" end="-1921"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715022753" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="price, newPrice);&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="858" end="-1921"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715093794" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="price = this.price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, newPrice);&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;//&#x9;Du skal videre definere et lyttergrensesnitt kalt StockListener, &#xA;//&#x9;som observatørene må implementere. Grensesnittet skal inneholde én metode:&#xA;&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;void stockPriceChanged(Stock stock, double price, double newPrice){&#xA;&#x9;&#x9;for (StockListener listener : listeners.keySet()) { &#xA;&#x9;&#x9;&#x9;if (listeners.get(listener) == null) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(stock, price,  newPrice );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(stock" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="833" end="-1034"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715105819" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="833" end="-1970"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715120209" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="price" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="819" end="-1970"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715141824" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.price = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, newPrice);&#xA;&#x9;&#x9;newP" edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="808" end="-1915"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715340402" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.1/@attempts.67/@edit" start="855" end="-1939"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715349793" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.68/@edit" start="855" end="-1939"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715359781" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, this." edit="/1/@proposals.0/@proposals.1/@attempts.69/@edit" start="806" end="-1939"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715377962" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, newPrice);&#xA;&#x9;&#x9;newPrice = price;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjekoden.&#xA;&#x9;String getTicker(){  &#x9;  &#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å hente aksjeprisen.&#xA;&#x9;double getPrice(){     &#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;//&#x9;Du skal videre definere et lyttergrensesnitt kalt StockListener, &#xA;//&#x9;som observatørene må implementere. Grensesnittet skal inneholde én metode:&#xA;&#xA;&#x9;&#xA;//&#x9;Lyttermetode for å holde lytteren oppdatert på aksjeprisen. &#xA;//&#x9;Metoden skal ta inn et Stock-objekt, samt gammel og ny pris. &#xA;//&#x9;Alle lyttere må implementere denne metoden.&#xA;&#x9;void stockPriceChanged(Stock stock, double price, double newPrice){&#xA;&#x9;&#x9;for (StockListener listener : listeners.keySet()) { &#xA;&#x9;&#x9;&#x9;if (listeners.get(listener) == null) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(stock, this.price,  newPrice );&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (price &lt; listeners.get(listener).get(0) || price > listeners.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(stock, this." edit="/1/@proposals.0/@proposals.1/@attempts.70/@edit" start="806" end="-1032"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715390494" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="newPrice = price;&#xA;&#x9;&#x9;stockPriceChanged(stock, price, newPrice);&#xA;&#x9;&#x9;this.p" edit="/1/@proposals.0/@proposals.1/@attempts.71/@edit" start="808" end="-1925"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715433605" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;void addStockListener(StockListener listener){&#xA;//&#x9;&#x9;if (listeners.containsKey(listener)) {&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Allerede eksisterende lytter&quot;);&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;listeners.put(listener,null);&#xA;//&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener listener, double min, double max) {&#xA;&#x9;&#x9;if (min >= max) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ute av range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;ArrayList&lt;Double> interval = new ArrayList&lt;Double>();&#xA;&#x9;&#x9;interval.add(min); interval.add(max);&#xA;&#x9;&#x9;listeners.put(listener, interval);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;metode for å fjerne observatører.&#xA;&#x9;void removeStockListener(StockListener listener){&#xA;&#x9;&#x9;if (!listeners.containsKey(listener)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ingen eksisterende lytter&quot;);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;listeners.remove(listener);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.72/@edit" start="2059" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715452066" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;void addStockListener(StockListener listener){&#xA;&#x9;&#x9;if (listeners.containsKey(listener)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Allerede eksisterende lytter&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;listeners.put(listener,null);&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;public void addStockListener(StockListener listener, double min, double max) {&#xA;//&#x9;&#x9;if (min >= max) {&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ute av range&quot;);&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;ArrayList&lt;Double> interval = new ArrayList&lt;Double>();&#xA;//&#x9;&#x9;interval.add(min); interval.add(max);&#xA;//&#x9;&#x9;listeners.put(listener, interval);&#xA;//&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.73/@edit" start="2059" end="-246"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715918858" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void addStockListener(StockListener listener, double min, double max) {&#xA;&#x9;&#x9;if (min >= max) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ute av range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;ArrayList&lt;Double> interval = new ArrayList&lt;Double>();&#xA;&#x9;&#x9;interval.add(min); interval.add(max);&#xA;&#x9;&#x9;listeners.put(listener, interval);&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.74/@edit" start="2260" end="-249"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715924712" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;public void addStockListener(StockListener listener, double min, double max) {&#xA;//&#x9;&#x9;if (min >= max) {&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ute av range&quot;);&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;ArrayList&lt;Double> interval = new ArrayList&lt;Double>();&#xA;//&#x9;&#x9;interval.add(min); interval.add(max);&#xA;//&#x9;&#x9;listeners.put(listener, interval);&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.75/@edit" start="2260" end="-249"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490703002946" completion="0.0" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490706032019" completion="0.0" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490706423989" completion="0.0" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490712302398" completion="0.0" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490712524486" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713087480" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713322815" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713359414" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713367395" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713374257" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713536085" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713744172" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713758813" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713765677" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713771140" completion="0.0" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713778483" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713824280" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713918333" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714023732" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714109560" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714263206" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714279854" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714319919" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714331339" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714379430" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714409780" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714478520" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714644785" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714662633" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714667441" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714822501" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714931950" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714940343" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714946220" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714975296" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714999819" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715016251" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715024588" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715094590" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715122108" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715132465" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715143926" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715343877" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715360660" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715380027" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715392518" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715434538" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715453513" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715943493" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715959300" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="0.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715906515" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715920589" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715926344" completion="0.0" errorCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a" completion="0.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715933874" completion="0.0" errorCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
