<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490729426844" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public interface Employee {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490729725393" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);&#xA;&#x9;&#xA;&#x9;void printDocument(String document);&#xA;&#x9;&#xA;&#x9;int getTaskCount();&#xA;&#x9;&#xA;&#x9;int getResourceCount();&#xA;&#xA;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="37" end="-2"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490729744559" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Clerk {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490729948228" sizeMeasure="46" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#x9;&#xA;&#x9;Printer printer;&#xA;&#x9;int taskCOunt;&#xA;&#x9;&#xA;&#x9;Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;&#x9;taskCount = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="37" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="123" charEnd="130" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="165" charEnd="172" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="186" charEnd="198" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="212" charEnd="221" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="383" charEnd="392" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="504" charEnd="513" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="519" charEnd="526" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730213259" sizeMeasure="52" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount;;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;printer b = new Printer(); &#xA;&#x9;&#x9;Clerk a = new Clerk(b);&#xA;&#x9;&#x9;System.out.println(a.printer.getPrintHistory(a))" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="691" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="212" charEnd="221" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="383" charEnd="392" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="504" charEnd="513" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="691" charEnd="700" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="849" charEnd="856" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730394347" sizeMeasure="52" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ount;&#xA;&#x9;&#xA;&#x9;Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;&#x9;taskCount = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return taskCount;;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;P" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="150" end="-112"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="701" charEnd="702" severity="2" problemCategory="60" problemType="536871073"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730433743" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="701" end="-261"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490731474249" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="346" end="-174"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490730394155" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490730433614" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490731118943" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490730259554" completion="0.0" errorCount="4">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490730399736" completion="0.25" successCount="1" errorCount="3">
          <successTests>testResourceCount</successTests>
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490730444399" completion="1.0" successCount="4">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490731125228" completion="1.0" successCount="4">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730059423" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730213249" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;Map&lt;Employee, List&lt;String>> employeesPrintingJobs;&#xA;&#x9;&#xA;&#x9;public Printer() {&#xA;&#x9;&#x9;employeesPrintingJobs = new HashMap&lt;Employee, List &lt;String>>();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (document.trim().length() == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The document is emtpy&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;String> employeesList;&#xA;&#x9;&#xA;&#x9;&#x9;if (employeesPrintingJobs.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;employeesList = employeesPrintingJobs.get(employee);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;employeesList = new ArrayList&lt;String>();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;employeesList.add(document); &#xA;&#x9;&#x9;employeesPrintingJobs.put(employee, employeesList);&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return employeesPrintingJobs.get(employee);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="0.3333333333333333">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490730248296" completion="0.0" errorCount="3">
          <errorTests>testPrintHistoryModification</errorTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490730465512" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testPrintHistoryModification</successTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490730574408" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testPrintHistoryModification</successTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490730911675" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testPrintHistoryModification</successTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490731187151" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testPrintHistoryModification</successTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730619390" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Manager {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730910474" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;import java.util.Collection;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> ansatte;&#xA;&#x9;int antallAnsatte;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;if(employees.isEmpty()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;En manager må ha minst 1 ansatt.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ansatte = employees;&#xA;&#x9;&#x9;this.antallAnsatte = employees.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Clerk employee = (Clerk) chooseEmployee();&#xA;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int a = 0;&#xA;&#x9;&#x9;for(Employee employee : this.ansatte){&#xA;&#x9;&#x9;&#x9;a+=employee.getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return a;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return antallAnsatte+1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Employee chooseEmployee(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee ansatt1 = null;&#xA;&#x9;&#x9;Employee ansatt2 = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Employee employee : this.ansatte){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(ansatt1 == null){&#xA;&#x9;&#x9;&#x9;&#x9;ansatt1 = employee;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(ansatt2 == null){&#xA;&#x9;&#x9;&#x9;&#x9;ansatt2 = employee;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(ansatt2 != null &amp;&amp; employee.getTaskCount() &lt; ansatt2.getTaskCount()){&#xA;&#x9;&#x9;&#x9;&#x9;return employee;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return ansatt1;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490731105747" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="1371" end="-1372"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490731474259" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="724" end="-613"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="0.42857142857142855">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490731131114" completion="0.42857142857142855" successCount="3" failureCount="3" errorCount="1">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <failureTests>testSeveralClerks</failureTests>
          <failureTests>testMiddleManagementResourceCounts</failureTests>
          <failureTests>testTaskCount</failureTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490731180883" completion="0.42857142857142855" successCount="3" failureCount="3" errorCount="1">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <failureTests>testSeveralClerks</failureTests>
          <failureTests>testMiddleManagementResourceCounts</failureTests>
          <failureTests>testTaskCount</failureTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
