<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489652134192" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489652298018" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="interface StockListener {&#xA;&#x9;void stockPriceChanged(Stock name, double oldPrice , double newPrice);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489651963692" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489652320880" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;String name;&#xA;&#x9;Double price;&#xA;&#x9;public Stock(String name, double price){&#xA;&#x9;&#x9;this.name=name;&#xA;&#x9;&#x9;this.price=price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void setPrice(double price){&#xA;&#x9;&#x9;this.price=price;&#xA;&#x9;}&#xA;&#x9;String getTicker() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;double getPrice(){&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA; " edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="51" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489652985604" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;&#xA;public class Stock {&#xA;&#x9;Collection&lt;StockListener> listners= new ArrayList&lt;>();&#xA;&#x9;String name;&#xA;&#x9;Double price;&#xA;&#x9;public Stock(String name, double price){&#xA;&#x9;&#x9;this.name=name;&#xA;&#x9;&#x9;this.price=price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void setPrice(double price){&#xA;&#x9;&#x9;for (StockListener temp:listners){&#xA;&#x9;&#x9;&#x9;temp.stockPriceChanged(this, this.price, price);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price=price;&#xA;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;String getTicker() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;double getPrice(){&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;void addStockListener(StockListener stockListener){&#xA;&#x9;&#x9;this.listners.add(stockListener);&#xA;&#x9;}&#xA;&#x9;void removeStockListener(StockListener stockListener){&#xA;&#x9;&#x9;this.listners.remove(stockListener);&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="30" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654045766" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(price&lt;=0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;  we got a problem&quot;);&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="311" end="-399"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655823751" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;-------------------------&quot;);&#xA;&#x9;&#x9;&#x9;System.out.println(listners.size());" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="429" end="-362"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655907213" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else{&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;njwghjkghjksghsfgjshgkjh&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (StockListener temp:listners){&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;-------------------------&quot;);&#xA;&#x9;&#x9;&#x9;System.out.println(listners.size());&#xA;&#x9;&#x9;&#x9;temp.stockPriceChanged(this, this.price, price);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price=price;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="391" end="-285"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655937547" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(listners.size());&#xA;&#xA;&#x9;&#x9;for (StockListener temp:listners){&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;-------------------------&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="450" end="-367"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489656528712" sizeMeasure="45" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;double oldprice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void setPrice(double price){&#xA;&#x9;&#x9;if(price&lt;=0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;  we got a problem&quot;);&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;njwghjkghjksghsfgjshgkjh&quot;);&#xA;&#x9;&#x9;&#x9;this.oldprice=this.price;&#xA;&#x9;&#x9;&#x9;this.price=price;&#xA;&#xA;&#x9;&#x9;for (StockListener temp:listners){&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;-------------------------&quot;);&#xA;&#x9;&#x9;&#x9;temp.stockPriceChanged(this, oldprice, price);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="275" end="-289"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489656539855" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double oldprice;&#xA;&#xA;&#x9;public Stock(String name, double price){&#xA;&#x9;&#x9;this.name=name;&#xA;&#x9;&#x9;this.price=" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="195" end="-663"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489656564279" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.oldprice=this.price;&#xA;&#x9;&#x9;&#x9;this.price=price;&#xA;&#xA;&#x9;&#x9;for (StockListener temp:listners){" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="419" end="-343"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489652995519" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489656547641" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489653369565" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654048843" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#x9;double index=0;&#xA;&#x9;Collection&lt;Stock> list=new ArrayList&lt;>();&#xA;&#x9;public StockIndex(String name, Stock... stocks ){&#xA;&#x9;&#x9;for(Stock ting:stocks){&#xA;&#x9;&#x9;&#x9;index+=ting.getPrice();&#xA;&#x9;&#x9;&#x9;list.add(ting);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock name, double oldPrice, double newPrice) {&#xA;index+=(newPrice-oldPrice);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStock(Stock s) {&#xA;&#x9;&#x9;list.add(s);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;void removeStock(Stock  s){&#xA;&#x9;&#x9;list.remove(s);&#xA;&#x9;}&#xA;&#x9;double getIndex(){&#xA;&#x9;&#x9;return index;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654269591" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index+=s.getPrice();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;void removeStock(Stock  s){&#xA;&#x9;&#x9;list.remove(s);&#xA;&#x9;&#x9;index-=s.getPrice(" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="504" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654309893" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="152" end="-493"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654394695" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(!list.contains(s)){&#xA;&#x9;&#x9;&#x9;list.add(s);&#xA;&#x9;&#x9;&#x9;index+=s.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="487" end="-123"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654604872" sizeMeasure="52" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9; double facebookPrice = 67.80;&#xA;&#x9;&#x9;&#x9;&#x9;double applePrice = 534.98;&#xA;&#x9;&#x9;&#x9;&#x9; Stock facebook = new Stock(&quot;FB&quot;, facebookPrice);&#xA;&#x9;&#x9;&#x9;&#x9; Stock apple = new Stock(&quot;AAPL&quot;, applePrice);&#xA;&#x9;&#x9;&#x9;&#x9; StockIndex index0 = new StockIndex(&quot;OSEBX&quot;);&#xA;&#x9;&#x9;&#x9;&#x9; StockIndex index1 = new StockIndex(&quot;OSEBX&quot;, facebook);&#xA;&#x9;&#x9;&#x9;&#x9; StockIndex indexN = new StockIndex(&quot;OSEBX&quot;, facebook, apple);&#xA;&#x9;&#x9;&#x9;&#x9; System.out.println(index0.index);&#xA;&#x9;&#x9;&#x9;&#x9; index0.addStock(facebook);&#xA;&#x9;&#x9;&#x9;&#x9; System.out.println(index0.index)" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="675" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654633195" sizeMeasure="52" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="721" end="-460"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654664304" sizeMeasure="55" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#x9; index0.addStock(facebook);&#xA;&#x9;&#x9;&#x9;&#x9; System.out.println(index0.index);&#xA;" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="1177" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489654764520" sizeMeasure="53" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="indexN.removeStock(apple);&#xA;&#x9;&#x9;&#x9;&#x9; System.out.println(indexN.index);&#xA;" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="1071" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655048832" sizeMeasure="58" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=CalIndex();&#x9;&#x9;}}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private double CalIndex(){&#xA;&#x9;&#x9;double tall=0;&#xA;&#x9;&#x9;for(Stock temp:list){&#xA;&#x9;&#x9;&#x9;tall+=temp.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return tall;&#xA;&#x9;}&#xA;&#x9;void removeStock(Stock  s){&#xA;&#x9;&#x9;list.remove(s);&#xA;&#x9;&#x9;index=CalIndex" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="534" end="-517"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655132354" sizeMeasure="58" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;index=CalIndex(" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="426" end="-801"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655285459" sizeMeasure="61" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" double facebookPrice2 = 67.0;&#xA;&#x9;&#x9;&#x9; double facebookPrice3 = 69.0;&#xA;&#x9;&#x9;&#x9; facebook.setPrice(facebookPrice2);&#xA;&#x9;&#x9;&#x9; System.out.println(index1.index);&#xA;" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="1167" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655630177" sizeMeasure="62" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;njdfgkfhgjk&quot;);" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="428" end="-931"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655823681" sizeMeasure="61" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="428" end="-931"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489655912557" sizeMeasure="60" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index=CalIndex();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStock(Stock s) {&#xA;&#x9;&#x9;if(!list.contains(s)){&#xA;&#x9;&#x9;&#x9;list.add(s);&#xA;&#x9;&#x9;&#x9;index=CalIndex();&#x9;&#x9;}}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private double CalIndex(){&#xA;&#x9;&#x9;double tall=0;&#xA;&#x9;&#x9;for(Stock temp:list){&#xA;&#x9;&#x9;&#x9;tall+=temp.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return tall;&#xA;&#x9;}&#xA;&#x9;void removeStock(Stock  s){&#xA;&#x9;&#x9;list.remove(s);&#xA;&#x9;&#x9;index=CalIndex();&#xA;&#x9;}&#xA;&#x9;double getIndex(){&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#x9;&#x9;double facebookPrice = 67.80;&#xA;&#x9;&#x9;&#x9;&#x9;double applePrice = 534.98;&#xA;&#x9;&#x9;&#x9;&#x9; Stock facebook = new Stock(&quot;FB&quot;, facebookPrice);&#xA;&#x9;&#x9;&#x9;&#x9; Stock apple = new Stock(&quot;AAPL&quot;, applePrice);&#xA;&#x9;&#x9;&#x9;&#x9; StockIndex index0 = new StockIndex(&quot;OSEBX&quot;);&#xA;&#x9;&#x9;&#x9;&#x9; StockIndex index1 = new StockIndex(&quot;OSEBX&quot;, facebook);&#xA;&#x9;&#x9;&#x9;&#x9; StockIndex indexN = new StockIndex(&quot;OSEBX&quot;, facebook, apple);&#xA;&#x9;&#x9;&#x9; double facebookPrice2 = 67.0;&#xA;&#x9;&#x9;&#x9; double facebookPrice3 = 69.0;&#xA;&#x9;&#x9;&#x9; facebook.setPrice(facebookPrice2);&#xA;&#x9;&#x9;&#x9; " edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="428" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489656349726" sizeMeasure="64" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ting.addStockListener(this);&#xA;&#x9;&#x9;&#x9;list.add(ting);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock name, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;index=CalIndex();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStock(Stock s) {&#xA;&#x9;&#x9;if(!list.contains(s)){&#xA;&#x9;&#x9;&#x9;list.add(s);&#xA;&#x9;&#x9;&#x9;s.addStockListener(this);&#xA;&#x9;&#x9;&#x9;index=CalIndex();&#x9;&#x9;}}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private double CalIndex(){&#xA;&#x9;&#x9;double tall=0;&#xA;&#x9;&#x9;for(Stock temp:list){&#xA;&#x9;&#x9;&#x9;tall+=temp.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return tall;&#xA;&#x9;}&#xA;&#x9;void removeStock(Stock  s){&#xA;&#x9;&#x9;list.remove(s);&#xA;&#x9;&#x9;s.removeStockListener(this);&#xA;&#x9;&#x9;index=CalIndex();&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="304" end="-555"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489656405850" sizeMeasure="67" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(index1 .index);&#xA;&#x9;&#x9;&#x9; System.out.println(indexN .index);&#xA;" edit="/1/@proposals.1/@proposals.0/@attempts.15/@edit" start="1370" end="-15"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654603878" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654632301" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654634875" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654663459" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654666055" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654667569" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654763302" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654766369" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489654774191" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655284971" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655287420" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655296432" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655298203" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655581194" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655629162" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655631584" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655633260" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655634145" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655822760" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655825442" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655826883" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655828307" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655829175" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655829736" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655830216" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655830790" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655841347" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655905832" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655911516" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655917792" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655919198" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655920022" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655936695" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655938960" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489655940708" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489656405114" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489656407662" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654061055" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654270379" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654314861" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654395421" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489654685567" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489655049648" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489655132996" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489655150163" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489656357082" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489656365014" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489656555714" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
