<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489858537577" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489858605244" sizeMeasure="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;void stockPriceChanged(Stock stock, double currentPrice, double newPrice);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489858140812" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489858512538" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price; &#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setprice(double newPrice){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(newPrice>0)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke ha en ikke-positiv aksje pris!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.price = newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="51" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489858962646" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price; &#xA;&#x9;private ArrayList&lt;StockListener> listeners;&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double newPrice){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(newPrice>0)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke ha en ikke-positiv aksje pris!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.price = newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener stockListener){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(listeners.contains(stockListener))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.listeners.add(stockListener);&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener stockListener){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((listeners.contains(stockListener))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.listeners.remove(stockListener);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="30" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489860230567" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;private ArrayList&lt;StockListener> listeners;&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double newPrice){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(newPrice>0)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke ha en ikke-positiv aksje pris!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt;listeners.size();i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;listeners.get(i).stockPriceChanged(this, this.price, newPrice);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.price = newPrice;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="127" end="-459"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861964055" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = new ArrayList&lt;StockListener>()" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="171" end="-866"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489864087989" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener stockListener){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(listeners.contains(stockListener))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.listeners.add(stockListener);&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener stockListener){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((listeners.contains(stockListener))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.listeners.remove(stockListener);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="610" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489862531990" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489858971618" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489860387527" sizeMeasure="66" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private ArrayList&lt;Stock> stockList;&#xA;&#x9;private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock...stocks){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stocks.length; i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (!(this.stockList.contains(stocks[i]))){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;this.stockList.add(stocks[i]);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stockList.size(); i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;sum += stockList.get(i).getPrice();&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stock);&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.remove(stock);&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double currentPrice, double newPrice){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = this.index - currentPrice + newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489860784793" sizeMeasure="80" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String name;&#xA;&#x9;private ArrayList&lt;Stock> stockList;&#xA;&#x9;private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock...stocks){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stocks.length; i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (!(this.stockList.contains(stocks[i]))){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;this.stockList.add(stocks[i]);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stockList.size(); i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;sum += stockList.get(i).getPrice();&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stock);&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.remove(stock);&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double currentPrice, double newPrice){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = this.index - currentPrice + newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock s1 = new Stock(&quot;A&quot;,100.0);&#xA;&#x9;&#x9;Stock s2 = new Stock(&quot;B&quot;,120.01);&#xA;&#x9;&#x9;Stock s3 = new Stock(&quot;C&quot;,132.21);&#xA;&#x9;&#x9;Stock s4 = new Stock(&quot;D&quot;,144.43);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,s1,s2,s3,s4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="112" end="-17"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489860928126" sizeMeasure="80" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="1252" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861024733" sizeMeasure="82" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(String.valueOf(stockIndex.index));&#xA;" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="1260" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861108813" sizeMeasure="83" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Stock> stockList = new ArrayList&lt;Stock>()" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="269" end="-1078"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861169761" sizeMeasure="84" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" stocks){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;ArrayList&lt;Stock> stockList = new ArrayList&lt;Stock>();&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="235" end="-1077"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861190605" sizeMeasure="82" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.stockList.add(stocks[i]);&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="375" end="-939"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861394509" sizeMeasure="80" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ystem.out.println(String.valueOf(s1.getPrice()" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="1199" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861412762" sizeMeasure="84" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,s1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(stockIndex.index" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="1250" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861439015" sizeMeasure="84" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="1309" end="-91"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861517810" sizeMeasure="86" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="[] stocks = {s1,s2,s3,s4};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,stocks" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="1259" end="-91"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861633375" sizeMeasure="87" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collection;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private ArrayList&lt;Stock> stockList = new ArrayList&lt;Stock>();&#xA;&#x9;private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="58" end="-1122"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861650178" sizeMeasure="85" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (int i = 0; i&lt; stocks.length; i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stocks[i]);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stockList.size(); i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;sum += stockList.get(i).getPrice();&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stock);&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.remove(stock);&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double currentPrice, double newPrice){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = this.index - currentPrice + newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock s1 = new Stock(&quot;A&quot;,100.0);&#xA;&#x9;&#x9;Stock s2 = new Stock(&quot;B&quot;,120.01);&#xA;&#x9;&#x9;Stock s3 = new Stock(&quot;C&quot;,132.21);&#xA;&#x9;&#x9;Stock s4 = new Stock(&quot;D&quot;,144.43);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(s1.getPrice()));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock[] stocks = {s1,s2" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="326" end="-161"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861663402" sizeMeasure="85" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=",s3" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="1272" end="-161"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861688852" sizeMeasure="85" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=",s4" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="1275" end="-161"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861763423" sizeMeasure="87" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock[] stocks = {s1,s2,s3,s4};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,stocks);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;Indexen er nå: &quot; + String.valueOf(stockIndex.index));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.15/@edit" start="1227" end="-30"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861782782" sizeMeasure="89" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,stocks);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + String.valueOf(stockIndex.index));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.16/@edit" start="1313" end="-36"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861819648" sizeMeasure="92" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s1.setPrice(130.00);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + String.valueOf(stockIndex.index));" edit="/1/@proposals.1/@proposals.0/@attempts.17/@edit" start="1471" end="-36"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861886007" sizeMeasure="96" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s1.setPrice(130.00);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock[] stocks = {s1};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,stocks);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + String.valueOf(stockIndex.index));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.18/@edit" start="1293" end="-213"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489861996735" sizeMeasure="92" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Stock[] stocks = {s1};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,stocks);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + String.valueOf(stockIndex.index));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;s1.setPrice(130.00);" edit="/1/@proposals.1/@proposals.0/@attempts.19/@edit" start="1293" end="-213"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489862051208" sizeMeasure="92" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" +&quot;\n&quot;" edit="/1/@proposals.1/@proposals.0/@attempts.20/@edit" start="1463" end="-241"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489862115179" sizeMeasure="94" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double diff = currentPrice - newPrice;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index += diff" edit="/1/@proposals.1/@proposals.0/@attempts.21/@edit" start="942" end="-719"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489862319856" sizeMeasure="94" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.22/@edit" start="968" end="-749"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489862451675" sizeMeasure="99" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;stockList.get(i).addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stock);&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.remove(stock);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double currentPrice, double newPrice){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double diff = current" edit="/1/@proposals.1/@proposals.0/@attempts.23/@edit" start="520" end="-749"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489862500911" sizeMeasure="98" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = this.index - currentPrice + newPrice" edit="/1/@proposals.1/@proposals.0/@attempts.24/@edit" start="1058" end="-719"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489862511204" sizeMeasure="98" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=",s2" edit="/1/@proposals.1/@proposals.0/@attempts.25/@edit" start="1435" end="-397"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489862926878" sizeMeasure="97" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.26/@edit" start="58" end="-1750"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489862947502" sizeMeasure="99" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private ArrayList&lt;Stock> stockList = new ArrayList&lt;Stock>();&#xA;&#x9;private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stocks.length; i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stocks[i]);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stockList.size(); i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;sum += stockList.get(i).getPrice();&#x9;&#xA;&#x9;&#x9;&#x9;stockList.get(i).addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stock);&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.remove(stock);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double currentPrice, double newPrice){&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = this.index - currentPrice + newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock s1 = new Stock(&quot;A&quot;,100.0);&#xA;&#x9;&#x9;Stock s2 = new Stock(&quot;B&quot;,120.01);&#xA;&#x9;&#x9;Stock s3 = new Stock(&quot;C&quot;,132.21);&#xA;&#x9;&#x9;Stock s4 = new Stock(&quot;D&quot;,144.43);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den andre aksjen er: &quot; + s2" edit="/1/@proposals.1/@proposals.0/@attempts.27/@edit" start="58" end="-447"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863009584" sizeMeasure="99" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="format(&quot;%.2f&quot;,String.valueOf(stockIndex.index) +&quot;\n&quot;)" edit="/1/@proposals.1/@proposals.0/@attempts.28/@edit" start="1633" end="-241"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863258305" sizeMeasure="102" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="text.DecimalFormat;&#xA;import java.util.ArrayList;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private ArrayList&lt;Stock> stockList = new ArrayList&lt;Stock>();&#xA;&#x9;private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stocks.length; i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stocks[i]);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stockList.size(); i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;sum += stockList.get(i).getPrice();&#x9;&#xA;&#x9;&#x9;&#x9;stockList.get(i).addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stock);&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.remove(stock);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double currentPrice, double newPrice){&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = this.index - currentPrice + newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock s1 = new Stock(&quot;A&quot;,100.0);&#xA;&#x9;&#x9;Stock s2 = new Stock(&quot;B&quot;,120.01);&#xA;&#x9;&#x9;Stock s3 = new Stock(&quot;C&quot;,132.21);&#xA;&#x9;&#x9;Stock s4 = new Stock(&quot;D&quot;,144.43);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;DecimalFormat formatter = new DecimalFormat (&quot;###.00&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den andre aksjen er: &quot; + s2.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock[] stocks = {s1,s2};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,stocks);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + formatter.format(stockIndex.index" edit="/1/@proposals.1/@proposals.0/@attempts.29/@edit" start="42" end="-242"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863280527" sizeMeasure="102" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.30/@edit" start="1202" end="-793"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863365143" sizeMeasure="102" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,s1" edit="/1/@proposals.1/@proposals.0/@attempts.31/@edit" start="1599" end="-323"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863476473" sizeMeasure="97" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=",s2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + formatter.format(stockIndex.index));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;s1.setPrice(130.00);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + String.valueOf(stockIndex.index));" edit="/1/@proposals.1/@proposals.0/@attempts.32/@edit" start="1665" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863485048" sizeMeasure="97" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=",s3" edit="/1/@proposals.1/@proposals.0/@attempts.33/@edit" start="1668" end="-309"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863513114" sizeMeasure="96" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den andre aksjen er: &quot; + s2.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock[] stocks = {s1};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,s1,s2,s3);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + String.valueOf((stockIndex.index)" edit="/1/@proposals.1/@proposals.0/@attempts.34/@edit" start="1317" end="-228"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863651426" sizeMeasure="96" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="." edit="/1/@proposals.1/@proposals.0/@attempts.35/@edit" start="1693" end="-225"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863672896" sizeMeasure="96" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=");" edit="/1/@proposals.1/@proposals.0/@attempts.36/@edit" start="1693" end="-225"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863709496" sizeMeasure="96" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double" edit="/1/@proposals.1/@proposals.0/@attempts.37/@edit" start="416" end="-1501"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863922268" sizeMeasure="98" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;&#x9;this.index += stock.getPrice(" edit="/1/@proposals.1/@proposals.0/@attempts.38/@edit" start="749" end="-1179"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863945321" sizeMeasure="100" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;&#x9;this.index -= stock.getPrice(" edit="/1/@proposals.1/@proposals.0/@attempts.39/@edit" start="952" end="-1015"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489863991968" sizeMeasure="99" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.40/@edit" start="42" end="-1940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489864034526" sizeMeasure="89" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="util.ArrayList;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private ArrayList&lt;Stock> stockList = new ArrayList&lt;Stock>();&#xA;&#x9;private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stocks.length; i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stocks[i]);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double sum = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt; stockList.size(); i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;sum += stockList.get(i).getPrice();&#x9;&#xA;&#x9;&#x9;&#x9;stockList.get(i).addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.index = sum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.add(stock);&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.index += stock.getPrice();&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((stockList.contains(stock))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.stockList.remove(stock);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.index -= stock.getPrice();&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.index;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double currentPrice, double newPrice){&#xA;&#x9;&#xA;&#x9;&#x9;this.index = this.index - currentPrice + newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock s1 = new Stock(&quot;A&quot;,100.00);&#xA;&#x9;&#x9;Stock s2 = new Stock(&quot;B&quot;,120.01);&#xA;&#x9;&#x9;Stock s3 = new Stock(&quot;C&quot;,132.21);&#xA;&#x9;&#x9;Stock s4 = new Stock(&quot;D&quot;,144.43);&#xA;&#x9;&#x9;&#xA;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den andre aksjen er: &quot; + s2.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock[] stocks = {s1};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex stockIndex = new StockIndex (&quot;Aksjemarkedet&quot;,s1,s2,s3);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + String.valueOf((stockIndex.index)));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;s1.setPrice(130.00);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(&quot;Prisen av den første aksjen er: &quot; + s1.getPrice()) + &quot;\n&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Indeksen er nå: &quot; + String.valueOf(stockIndex.index));&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.41/@edit" start="42" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489860784754" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489860928079" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861024662" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861108750" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861169703" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861190559" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861241285" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861394443" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861412706" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861438972" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861517751" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861633300" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861650100" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861663342" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861688805" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861763373" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861782727" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861819546" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861885960" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861964005" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489861996673" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489862051164" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489862115129" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489862319809" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489862451630" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489862500847" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489862511120" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489862926448" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489862947452" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863009518" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863258228" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863280477" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863365097" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863476425" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863485000" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863513057" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863651374" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863672814" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489863709406" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489862537876" completion="0.0" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489863293122" completion="0.0" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489863713169" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489863922952" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489863945673" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
