<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525361365" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);&#xA;&#x9;void printDocument(String document);&#xA;&#x9;int getTaskCount();&#xA;&#x9;int getResourceCount();&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525373953" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Clerk {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525393196" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="37" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525409153" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public Clerk(Printer printer)&#xA;&#x9;{&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="120" end="-412"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525415989" sizeMeasure="31" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Printer printer;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="121" end="-452"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525422602" sizeMeasure="31" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.printer=printer;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="182" end="-415"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525900515" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="printer.printDocument(document, this);" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="404" end="-180"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525990309" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return operation.apply(value1, value2)" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="305" end="-272"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526011998" sizeMeasure="32" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate int operations;&#xA;&#x9;public Clerk(Printer printer)&#xA;&#x9;{&#xA;&#x9;&#x9;operations=0;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="148" end="-436"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526016851" sizeMeasure="33" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="operations++;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="438" end="-221"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526021405" sizeMeasure="34" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="operations++;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="346" end="-329"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526027710" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return operations" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="547" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526119301" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#x9;private Printer printer;&#xA;&#x9;private int operations;&#xA;&#x9;List&lt;Employee> employees;&#xA;&#x9;public Clerk(Printer printer)&#xA;&#x9;{&#xA;&#x9;&#x9;operations=0;&#xA;&#x9;&#x9;employees=new ArrayList&lt;Employee>()" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="54" end="-441"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526133033" sizeMeasure="37" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="resources=1;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="694" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526154310" sizeMeasure="38" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for(Employee e:employees)&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="709" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526157600" sizeMeasure="38" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int " edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="694" end="-65"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526170344" sizeMeasure="38" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="resources+=e.getResourceCount();" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="742" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526173916" sizeMeasure="38" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return resources" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="784" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526187057" sizeMeasure="38" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="786" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526225164" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#x9;private Printer printer;&#xA;&#x9;private int operations;&#xA;&#x9;List&lt;Employee> employees;&#xA;&#x9;public Clerk(Printer printer)&#xA;&#x9;{&#xA;&#x9;&#x9;operations=0;&#xA;&#x9;&#x9;employees=new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;this.printer=printer;&#xA;&#x9;}&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;operations++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;operations++;&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return operations;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resources=1;&#xA;&#x9;&#x9;for(Employee e:employees)&#xA;&#x9;&#x9;&#x9;resources+=e.getResourceCount();&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="54" end="-26"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526214422" completion="0.0" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526230511" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526309846" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526389583" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526403462" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526429656" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526459022" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526495177" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526834934" completion="0.5" successCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526920648" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489534541445" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525429150" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525459380" sizeMeasure="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;void printDocument(String document, Employee employee)&#xA;&#x9;{&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="60" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525475098" sizeMeasure="13" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;List&lt;String> getPrintHistory(" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="127" end="-31"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525576526" sizeMeasure="15" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;Map&lt;Employee, String>" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="37" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525588802" sizeMeasure="15" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" documents;" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="106" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525627370" sizeMeasure="20" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#x9;Map&lt;Employee, String> documents;&#xA;&#x9;public Printer()&#xA;&#x9;{&#xA;&#x9;&#x9;documents = new HashMap&lt;Employee, String>();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="60" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525651898" sizeMeasure="21" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HashMap;&#xA;import java.util.List;&#xA;import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#x9;Map&lt;Employee, String> documents;&#xA;&#x9;public Printer()&#xA;&#x9;{&#xA;&#x9;&#x9;documents = new HashMap&lt;Employee, String>();&#xA;&#x9;}&#xA;&#x9;void printDocument(String document, Employee employee)&#xA;&#x9;{&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;List&lt;String> getPrintHistory(Employee employee)&#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;String> retList = new ArrayList&lt;String>();" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="54" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525728341" sizeMeasure="23" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#x9;Map&lt;Employee, String> documents;&#xA;&#x9;public Printer()&#xA;&#x9;{&#xA;&#x9;&#x9;documents = new HashMap&lt;Employee, String>();&#xA;&#x9;}&#xA;&#x9;void printDocument(String document, Employee employee)&#xA;&#x9;{&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;List&lt;String> getPrintHistory(Employee employee)&#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;String> retList = new ArrayList&lt;String>();&#xA;&#x9;&#x9;for(Map.Entry&lt;Employee, String> elem:documents.entrySet())" edit="/1/@proposals.0/@proposals.4/@attempts.6/@edit" start="54" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525762036" sizeMeasure="27" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;{&#xA;&#x9;&#x9;&#x9;if(elem.getKey()==employee)&#xA;&#x9;&#x9;&#x9;&#x9;retList.add(string);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.7/@edit" start="494" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525769448" sizeMeasure="27" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="elem.getValue()" edit="/1/@proposals.0/@proposals.4/@attempts.8/@edit" start="544" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525775490" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return retList;" edit="/1/@proposals.0/@proposals.4/@attempts.9/@edit" start="567" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489525876850" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(document);&#xA;&#x9;&#x9;documents.put(employee, document);" edit="/1/@proposals.0/@proposals.4/@attempts.10/@edit" start="326" end="-264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526374104" sizeMeasure="29" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*List&lt;String> retList = new ArrayList&lt;String>();&#xA;&#x9;&#x9;for(Map.Entry&lt;Employee, String> elem:documents.entrySet())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if(elem.getKey()==employee)&#xA;&#x9;&#x9;&#x9;&#x9;retList.add(elem.getValue());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return retList;*/" edit="/1/@proposals.0/@proposals.4/@attempts.11/@edit" start="450" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526396363" sizeMeasure="30" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return new ArrayList();" edit="/1/@proposals.0/@proposals.4/@attempts.12/@edit" start="655" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526398340" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;String>" edit="/1/@proposals.0/@proposals.4/@attempts.13/@edit" start="676" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526415288" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;String> retList = new ArrayList&lt;String>();&#xA;&#x9;&#x9;for(Map.Entry&lt;Employee, String> elem:documents.entrySet())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if(elem.getKey()==employee)&#xA;&#x9;&#x9;&#x9;&#x9;retList.add(elem.getValue());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return retList;" edit="/1/@proposals.0/@proposals.4/@attempts.14/@edit" start="450" end="-41"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526419675" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.4/@attempts.15/@edit" start="651" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526439794" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retList.add(&quot;EEEE&quot;):&#xA;&#x9;&#x9;for(Map.Entry&lt;Employee, String> elem:documents.entrySet())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if(elem.getKey()==employee)&#xA;&#x9;&#x9;&#x9;&#x9;retList.add(elem.getValue());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return retList" edit="/1/@proposals.0/@proposals.4/@attempts.16/@edit" start="500" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526442400" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.4/@attempts.17/@edit" start="519" end="-159"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526454590" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for(int i =0; i &lt; 30; i++)&#xA;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.18/@edit" start="500" end="-181"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526489368" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(retList.size());" edit="/1/@proposals.0/@proposals.4/@attempts.19/@edit" start="687" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526766831" sizeMeasure="32" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;String>" edit="/1/@proposals.0/@proposals.4/@attempts.20/@edit" start="175" end="-566"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526773960" sizeMeasure="32" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;String>" edit="/1/@proposals.0/@proposals.4/@attempts.21/@edit" start="257" end="-490"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526811612" sizeMeasure="32" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="get(employee).add(" edit="/1/@proposals.0/@proposals.4/@attempts.22/@edit" start="380" end="-365"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526826879" sizeMeasure="23" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return documents.get(employee)" edit="/1/@proposals.0/@proposals.4/@attempts.23/@edit" start="466" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526884648" sizeMeasure="25" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(documents.get(employee)==null)&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.24/@edit" start="370" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526902676" sizeMeasure="25" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="documents.put(employee, List&lt;String>)" edit="/1/@proposals.0/@proposals.4/@attempts.25/@edit" start="407" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526904150" sizeMeasure="25" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.4/@attempts.26/@edit" start="444" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489526913373" sizeMeasure="25" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new ArrayList()" edit="/1/@proposals.0/@proposals.4/@attempts.27/@edit" start="431" end="-139"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527080483" sizeMeasure="27" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(documents.get(employee)==null)&#xA;&#x9;&#x9;&#x9;return new ArrayList&lt;String>();" edit="/1/@proposals.0/@proposals.4/@attempts.28/@edit" start="547" end="-41"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526928467" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489526965118" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489527084758" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489534527517" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527103958" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Manager {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527120811" sizeMeasure="5" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Employee" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="58" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527138018" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#x9;public Manager(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="37" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527183065" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;if(employees.size()==0)&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du må ha noen ansatte&quot;);" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="54" end="-459"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527195829" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection&lt;Employee> employees;&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;if(employees.size()==0)&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du må ha noen ansatte&quot;);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="152" end="-459"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527213255" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.employees=employees;" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="325" end="-459"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527248112" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int getResourceCount() {&#xA;&#x9;&#x9;int resources=1;&#xA;&#x9;&#x9;for(Employee e:employees)&#xA;&#x9;&#x9;&#x9;resources+=e.getResourceCount();&#xA;&#x9;&#x9;return resources" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="709" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527256847" sizeMeasure="35" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;operations++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;operations++;&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return operations" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="355" end="-150"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527268067" sizeMeasure="36" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate int operations, index" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="186" end="-638"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527277944" sizeMeasure="38" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;index=0;&#xA;&#x9;&#x9;operations=0" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="384" end="-471"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527333477" sizeMeasure="39" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="635" end="-247"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527365884" sizeMeasure="38" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employees.get(index++%employees.size())" edit="/1/@proposals.0/@proposals.7/@attempts.10/@edit" start="635" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527443568" sizeMeasure="38" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List" edit="/1/@proposals.0/@proposals.7/@attempts.11/@edit" start="152" end="-749"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527459413" sizeMeasure="38" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Employee>(employees)" edit="/1/@proposals.0/@proposals.7/@attempts.12/@edit" start="366" end="-530"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527491405" sizeMeasure="38" errorCount="6" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(List&lt;Employee>)" edit="/1/@proposals.0/@proposals.7/@attempts.13/@edit" start="366" end="-541"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527501315" sizeMeasure="39" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List" edit="/1/@proposals.0/@proposals.7/@attempts.14/@edit" start="83" end="-859"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527528662" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.15/@edit" start="732" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527546763" sizeMeasure="39" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employees.get(index++%employees.size()).printDocument(document" edit="/1/@proposals.0/@proposals.7/@attempts.16/@edit" start="569" end="-341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527567924" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="doCalculations(operation, value1, value2" edit="/1/@proposals.0/@proposals.7/@attempts.17/@edit" start="609" end="-341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527741775" sizeMeasure="43">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public static void main(String args[])&#xA;&#x9;{&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.18/@edit" start="986" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527759552" sizeMeasure="43" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee manager= new Manager();" edit="/1/@proposals.0/@proposals.7/@attempts.19/@edit" start="1030" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527785125" sizeMeasure="45" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Printer printer = new Printer();&#xA;&#x9;&#x9;Employee clerk1 = new Clerk(printer);" edit="/1/@proposals.0/@proposals.7/@attempts.20/@edit" start="1030" end="-44"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527796280" sizeMeasure="46" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="clerk2" edit="/1/@proposals.0/@proposals.7/@attempts.21/@edit" start="1114" end="-66"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527821661" sizeMeasure="48" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Employee> employees= new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;Employee clerk1 = new Clerk(printer);&#xA;&#x9;&#x9;Employee clerk2 = new Clerk(printer);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.22/@edit" start="1065" end="-44"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527856796" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#x9;List&lt;Employee> employees;&#xA;&#x9;private int operations, index;&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;if(employees.size()==0)&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du må ha noen ansatte&quot;);&#xA;&#x9;&#x9;this.employees=(List&lt;Employee>)(employees);&#xA;&#x9;&#x9;index=0;&#xA;&#x9;&#x9;operations=0;&#xA;&#x9;}&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;operations++;&#xA;&#x9;&#x9;return employees.get(index++%employees.size()).doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;operations++;&#xA;&#x9;&#x9;employees.get(index++%employees.size()).printDocument(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return operations;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resources=1;&#xA;&#x9;&#x9;for(Employee e:employees)&#xA;&#x9;&#x9;&#x9;resources+=e.getResourceCount();&#xA;&#x9;&#x9;return resources;&#xA;&#x9;}&#xA;&#x9;public static void main(String args[])&#xA;&#x9;{&#xA;&#x9;&#x9;Printer printer = new Printer();&#xA;&#x9;&#x9;List&lt;Employee> employees= new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;Employee manager= new Manager(employees" edit="/1/@proposals.0/@proposals.7/@attempts.23/@edit" start="54" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527896628" sizeMeasure="51" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;manager.printDocument(manager.getTaskCount()/manager.getResourceCount()" edit="/1/@proposals.0/@proposals.7/@attempts.24/@edit" start="1339" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527910960" sizeMeasure="54" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(Int)manager.getTaskCount()/manager.getResourceCount());&#xA;&#x9;&#x9;manager.printDocument(manager.getTaskCount()/manager.getResourceCount());&#xA;&#x9;&#x9;manager.printDocument(manager.getTaskCount()/manager.getResourceCount()" edit="/1/@proposals.0/@proposals.7/@attempts.25/@edit" start="1362" end="-87"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527919665" sizeMeasure="54" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String" edit="/1/@proposals.0/@proposals.7/@attempts.26/@edit" start="1363" end="-289"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527962475" sizeMeasure="54" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String.valueOf(manager.getTaskCount()/manager.getResourceCount()" edit="/1/@proposals.0/@proposals.7/@attempts.27/@edit" start="1362" end="-240"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489527972917" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String.valueOf(manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf(manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf(manager.getTaskCount()/manager.getResourceCount()" edit="/1/@proposals.0/@proposals.7/@attempts.28/@edit" start="1454" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528030151" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(manager.getTaskCount()/manager.getResourceCount(" edit="/1/@proposals.0/@proposals.7/@attempts.29/@edit" start="1707" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528045083" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.30/@edit" start="1749" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528058983" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Resource" edit="/1/@proposals.0/@proposals.7/@attempts.31/@edit" start="1738" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528106741" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(double)" edit="/1/@proposals.0/@proposals.7/@attempts.32/@edit" start="1377" end="-387"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528119026" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)" edit="/1/@proposals.0/@proposals.7/@attempts.33/@edit" start="1477" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528130314" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount())" edit="/1/@proposals.0/@proposals.7/@attempts.34/@edit" start="1640" end="-361"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528166227" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Employee> manager1 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;Employee manager= new Manager(employees);&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()));&#xA;&#x9;&#x9;manager.printDocument(String.valueOf((double)manager.getTaskCount()/manager.getResourceCount()" edit="/1/@proposals.0/@proposals.7/@attempts.35/@edit" start="1296" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528186034" sizeMeasure="63" errorCount="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager1.add(new Manager(employees)" edit="/1/@proposals.0/@proposals.7/@attempts.36/@edit" start="1351" end="-1211"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528208148" sizeMeasure="63" errorCount="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1.get(0).printDocument(String.valueOf((double)manager1.get(0).getTaskCount()/manager1.get(0)" edit="/1/@proposals.0/@proposals.7/@attempts.37/@edit" start="1398" end="-1131"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528231874" sizeMeasure="65" errorCount="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employees= new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;List&lt;Employee> manager1 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;manager1.add(new Manager(employees)" edit="/1/@proposals.0/@proposals.7/@attempts.38/@edit" start="1296" end="-1275"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528236209" sizeMeasure="69" errorCount="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer)" edit="/1/@proposals.0/@proposals.7/@attempts.39/@edit" start="1336" end="-1370"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528261625" sizeMeasure="69" errorCount="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Employee> manager1 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;manager1.add(new Manager(employees));&#xA;&#x9;&#x9;employees= new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer" edit="/1/@proposals.0/@proposals.7/@attempts.40/@edit" start="1296" end="-1276"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528287774" sizeMeasure="70" errorCount="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Manager bigMan = new Manager(manager1" edit="/1/@proposals.0/@proposals.7/@attempts.41/@edit" start="1579" end="-1275"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528301317" sizeMeasure="70" errorCount="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager1.add(new Manager(employees));&#xA;&#x9;&#x9;Manager bigMan = new Manager(manager1" edit="/1/@proposals.0/@proposals.7/@attempts.42/@edit" start="1579" end="-1235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528306915" sizeMeasure="70" errorCount="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="bigMan" edit="/1/@proposals.0/@proposals.7/@attempts.43/@edit" start="1661" end="-1222"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528317201" sizeMeasure="70" errorCount="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="printDocument(String.valueOf((double)bigMan" edit="/1/@proposals.0/@proposals.7/@attempts.44/@edit" start="1668" end="-1162"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528321916" sizeMeasure="70" errorCount="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="bigMan" edit="/1/@proposals.0/@proposals.7/@attempts.45/@edit" start="1727" end="-1131"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489528329538" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="bigMan.printDocument(String.valueOf((double)bigMan.getTaskCount()/bigMan.getResourceCount()));&#xA;&#x9;&#x9;bigMan.printDocument(String.valueOf((double)bigMan.getTaskCount()/bigMan.getResourceCount()));&#xA;&#x9;&#x9;bigMan.printDocument(String.valueOf((double)bigMan.getTaskCount()/bigMan.getResourceCount()));&#xA;&#x9;&#x9;bigMan.printDocument(String.valueOf((double)bigMan.getTaskCount()/bigMan.getResourceCount()));&#xA;&#x9;&#x9;bigMan.printDocument(String.valueOf((double)bigMan.getTaskCount()/bigMan" edit="/1/@proposals.0/@proposals.7/@attempts.46/@edit" start="1758" end="-31"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489527976033" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489528033635" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489528046605" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489528061434" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489528109250" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489528120574" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489528131696" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489528330715" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489527595331" completion="1.0" successCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489534550946" completion="1.0" successCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489534759417" completion="1.0" successCount="7"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
