<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703389129" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee{&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);&#xA;&#x9;void printDocument(String document);&#xA;&#x9;int getTaskCount();&#xA;&#x9;int getResourceCount(); &#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703389274" sizeMeasure="52">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;import javafx.print.Printer;&#xA;import java.util.List;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#x9;int tasks;&#xA;&#x9;int resourceCount;&#xA;&#x9;Printer printing;&#xA;&#x9;List&lt;String> printHistory;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer){&#xA;&#x9;&#x9;this.tasks = 0;&#xA;&#x9;&#x9;this.resourceCount = 1;&#xA;&#x9;&#x9;this.printing = printer;&#xA;&#x9;&#x9;this.printHistory = new ArrayList&lt;String>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;tasks ++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;printing.&#xA;&#x9;&#x9;tasks ++;&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getTaskCount(){&#xA;&#x9;&#x9;return tasks;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BinaryOperator&lt;Double> adder = (n1, n2) -> n1 + n2;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Clerk employee1 = new Clerk();&#xA;&#x9;&#x9;employee1.doCalculations(adder, 0, 1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(employee1.getTaskCount());&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;x&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703599439" sizeMeasure="51" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tasks ++;&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return tasks;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BinaryOperator&lt;Double> adder = (n1, n2) -> n1 + n2;&#xA;&#x9;&#x9;Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(Printer " edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="641" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703623680" sizeMeasure="51" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="923" end="-147"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703845072" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#x9;int tasks;&#xA;&#x9;int resourceCount;&#xA;&#x9;Printer printing;&#xA;&#x9;List&lt;String> printHistory;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer){&#xA;&#x9;&#x9;this.tasks = 0;&#xA;&#x9;&#x9;this.resourceCount = 1;&#xA;&#x9;&#x9;this.printing = printer;&#xA;&#x9;&#x9;this.printHistory = new ArrayList&lt;String>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;tasks ++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;tasks ++;&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return tasks;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BinaryOperator&lt;Double> adder = (n1, n2) -> n1 + n2;&#xA;&#x9;&#x9;Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(print1);&#xA;&#x9;&#x9;employee1.doCalculations(adder, 0, 1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(employee1.getTaskCount());&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="108" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490705662051" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public List&lt;String> printHistory;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer){&#xA;&#x9;&#x9;this.tasks = 0;&#xA;&#x9;&#x9;this.resourceCount = 1;&#xA;&#x9;&#x9;this.printing = printer;&#xA;&#x9;&#x9;this.printHistory = new ArrayList&lt;String>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;tasks ++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;printing.printDocument(document, this);" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="224" end="-428"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490705754463" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="659" end="-386"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706125200" sizeMeasure="46" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public Clerk(Printer printer){&#xA;&#x9;&#x9;this.tasks = 0;&#xA;&#x9;&#x9;this.resourceCount = 1;&#xA;&#x9;&#x9;this.printing = printer;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;tasks ++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;printing.printDocument(document, this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return tasks;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BinaryOperator&lt;Double> adder = (n1, n2) -> n1 + n2;&#xA;&#x9;&#x9;Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(print1);&#xA;&#x9;&#x9;employee1.doCalculations(adder, 0, 1);&#xA;&#x9;&#x9;employee1.printing.getPrintHistory(employee" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="224" end="-64"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706149553" sizeMeasure="47" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Document(&quot;halla&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="916" end="-112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706165088" sizeMeasure="47" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(employee1.printing.getPrintHistory(employee1)" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="937" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706182602" sizeMeasure="48" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tasks ++" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="577" end="-490"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490703599350" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490703623554" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490703658554" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490703665174" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490703844975" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490706125071" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490706149435" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490706164974" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490706182501" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490703393054" completion="0.0" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490703864463" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490705664459" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703389331" sizeMeasure="15" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;&#x9;&#xA;&#x9;void printDocument(String document, Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703599464" sizeMeasure="17" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Employee employee;&#xA;&#x9;&#xA;&#x9;public Printer(Employee employee){&#xA;&#x9;&#x9;this.employee = employee;&#xA;&#xA;&#x9;}&#xA;&#x9;void printDocument(String document, Employee employee){&#xA;&#x9;&#x9;System.out.println(document);" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="60" end="-74"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703658643" sizeMeasure="17" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;public List&lt;String> getPrintHistory(Employee employee){&#xA;//&#x9;&#xA;//" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="246" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703845101" sizeMeasure="17">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String hei;&#xA;&#x9;&#xA;&#x9;public Printer(){&#xA;&#x9;&#x9;this.hei = &quot;hALLA&quot;;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="61" end="-166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490705662077" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#x9;Map&lt;Employee,List&lt;String>> map;&#xA; &#x9;&#xA;&#x9;&#xA;&#x9;public Printer(){&#xA;&#x9;&#x9;this.map = new HashMap&lt;Employee,List&lt;String>>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document, Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(map.containsKey(employee)){&#xA;&#x9;&#x9;&#x9;List&lt;String> employeeList = map.get(employee);&#xA;&#x9;&#x9;&#x9;employeeList.add(document);&#xA;&#x9;&#x9;&#x9;map.replace(employee, employeeList);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;List&lt;String> employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;&#x9;employeeList.add(document);&#xA;&#x9;&#x9;&#x9;map.put(employee, employeeList);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee){&#xA;&#x9;&#x9;return map.get(employee);&#xA;" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="37" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706319912" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (map.get(employee) != null){&#xA;&#x9;&#x9;&#x9;return map.get(employee);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return new ArrayList&lt;>();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="723" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490703400663" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490705693303" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490705755734" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490706186791" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490706321357" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490707412374" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490706347183" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Manager {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490707410771" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#x9;Collection&lt;Employee> employees;&#xA;&#x9;List&lt;Employee> employeesList;&#xA;&#x9;int employeesSize;&#xA;&#x9;int employeesTurn;&#xA;&#x9;int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employeesList = new ArrayList&lt;>(employees);&#xA;&#x9;&#x9;this.employeesSize = employees.size();&#xA;&#x9;&#x9;this.employeesTurn = 0;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return employeesSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;double number = employeesList.get(employeesTurn).doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;employeesList.get(employeesTurn).printDocument(document);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="37" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490707528812" sizeMeasure="60" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;Collection&lt;Employee> employees;&#xA;&#x9;List&lt;Employee> employeesList;&#xA;&#x9;int employeesSize;&#xA;&#x9;int employeesTurn;&#xA;&#x9;int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(List&lt;Employee> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employeesList = employees;&#xA;&#x9;&#x9;}&#xA;//" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="202" end="-819"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490707690656" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Collection&lt;Employee> employees;&#xA;&#x9;List&lt;Employee> employeesList;&#xA;&#x9;int employeesSize;&#xA;&#x9;int employeesTurn;&#xA;&#x9;int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;//&#x9;&#x9;if (employees.size() == 0){&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;else{&#xA;//&#x9;&#x9;&#x9;this.employees = employees;&#xA;//&#x9;&#x9;}&#xA;&#x9;&#x9;this.employees = employees;&#xA;" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="202" end="-819"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490707757944" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Clerk" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="340" end="-1046"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490707781978" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="203" end="-1183"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490707795437" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="339" end="-1046"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490707884902" sizeMeasure="63" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection&lt;Employee> employees;&#xA;&#x9;List&lt;Employee> employeesList;&#xA;&#x9;int employeesSize;&#xA;&#x9;int employeesTurn;&#xA;&#x9;int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employeesList = new ArrayList&lt;>(employees);&#xA;&#x9;&#x9;this.employeesSize = employees.size();&#xA;&#x9;&#x9;this.employeesTurn = 0;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return employeesSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;double number = employeesList.get(employeesTurn).doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;employeesList.get(employeesTurn).printDocument(document);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Manager manager1 = new Manager();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="203" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490707994637" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(print1);&#xA;&#x9;&#x9;List&lt;Employee> employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(employee1);&#xA;&#x9;&#x9;Manager manager1 = new Manager(employeeList" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="1402" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490708025117" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(manager1.employees" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="1604" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490708272976" sizeMeasure="68" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Employee> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employeesList = new ArrayList&lt;>(employees);&#xA;&#x9;&#x9;this.employeesSize = employees.size();&#xA;&#x9;&#x9;this.employeesTurn = 0;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return employeesSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;double number = employeesList.get(employeesTurn).doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;employeesList.get(employeesTurn).printDocument(document);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(print1);&#xA;&#x9;&#x9;List&lt;Clerk" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="340" end="-163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490708836300" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection&lt;Employee> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employeesList = new ArrayList&lt;>(employees);&#xA;&#x9;&#x9;this.employeesSize = employees.size();&#xA;&#x9;&#x9;this.employeesTurn = 0;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return employeesSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;double number = employeesList.get(employeesTurn).doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;employeesList.get(employeesTurn).printDocument(document);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(print1);&#xA;&#x9;&#x9;List&lt;Employee" edit="/1/@proposals.0/@proposals.7/@attempts.10/@edit" start="340" end="-163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490709202833" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Clerk> employees;&#xA;&#x9;int employeesSize;&#xA;&#x9;int employeesTurn;&#xA;&#x9;int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(List&lt;Clerk> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employeesSize = employees.size();&#xA;&#x9;&#x9;this.employeesTurn = 0;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return employeesSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;double number = employees.get(employeesTurn).doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;employees.get(employeesTurn).printDocument(document);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(print1);&#xA;&#x9;&#x9;List&lt;Clerk" edit="/1/@proposals.0/@proposals.7/@attempts.11/@edit" start="203" end="-163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490709273219" sizeMeasure="68" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int resourceCount;&#xA;&#x9;&#xA;&#x9;public Manager(List&lt;Clerk> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employeesSize = employees.size();&#xA;&#x9;&#x9;this.resourceCount = employeesSize +1;&#xA;&#x9;&#x9;this.employeesTurn = 0;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.12/@edit" start="283" end="-846"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490709438591" sizeMeasure="68" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee> employees;&#xA;&#x9;int employeesSize;&#xA;&#x9;int employeesTurn;&#xA;&#x9;int taskCount;&#xA;&#x9;int resourceCount;&#xA;&#x9;&#xA;&#x9;public Manager(List&lt;Employee> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employeesSize = employees.size();&#xA;&#x9;&#x9;this.resourceCount = employeesSize +1;&#xA;&#x9;&#x9;this.employeesTurn = 0;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;double number = employees.get(employeesTurn).doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;employees.get(employeesTurn).printDocument(document);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(print1);&#xA;&#x9;&#x9;List&lt;Employee" edit="/1/@proposals.0/@proposals.7/@attempts.13/@edit" start="208" end="-163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490712447440" sizeMeasure="68" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Clerk> employees;&#xA;&#x9;int employeesSize;&#xA;&#x9;int employeesTurn;&#xA;&#x9;int taskCount;&#xA;&#x9;int resourceCount;&#xA;&#x9;&#xA;&#x9;public Manager(List&lt;Clerk> employees){&#xA;&#x9;&#x9;if (employees.size() == 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha en manager uten kontorarbeidere&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employeesSize = employees.size();&#xA;&#x9;&#x9;this.resourceCount = employeesSize + " edit="/1/@proposals.0/@proposals.7/@attempts.14/@edit" start="208" end="-1012"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490712477116" sizeMeasure="68" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee> employees;&#xA;&#x9;int employeesSize;&#xA;&#x9;int employeesTurn;&#xA;&#x9;int taskCount;&#xA;&#x9;int resourceCount;&#xA;&#x9;&#xA;&#x9;public Manager(List&lt;Employee" edit="/1/@proposals.0/@proposals.7/@attempts.15/@edit" start="208" end="-1275"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490712599497" sizeMeasure="73" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2 = new Manager(employeeList);&#xA;&#x9;&#x9;Clerk employee2 = new Clerk(print1);&#xA;&#x9;&#x9;employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(manager2);&#xA;&#x9;&#x9;employeeList.add(employee2" edit="/1/@proposals.0/@proposals.7/@attempts.16/@edit" start="1532" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713198064" sizeMeasure="79" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0;&#xA;&#x9;&#x9;this.employeesTurn = 0;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTaskCount(){&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getResourceCount(){&#xA;&#x9;&#x9;int totalResourceCount = 0;&#xA;&#x9;&#x9;for (int i = 0; i &lt; employeesSize; i++) {&#xA;&#x9;&#x9;&#x9;totalResourceCount += employees.get(i).getResourceCount();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;totalResourceCount ++;&#xA;&#x9;&#x9;return totalResourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;double number = employees.get(employeesTurn).doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document){&#xA;&#x9;&#x9;taskCount ++;&#x9;&#xA;&#x9;&#x9;employees.get(employeesTurn).printDocument(document);&#xA;&#x9;&#x9;if(employeesTurn + 1 == employeesSize){&#xA;&#x9;&#x9;&#x9;employeesTurn = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;employeesTurn ++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer print1 = new Printer();&#xA;&#x9;&#x9;Clerk employee1 = new Clerk(print1);&#xA;&#x9;&#x9;List&lt;Employee> employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(employee1);&#xA;&#x9;&#x9;Manager manager2 = new Manager(employeeList);&#xA;&#x9;&#x9;Clerk employee2 = new Clerk(print1);&#xA;&#x9;&#x9;employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(manager2);&#xA;&#x9;&#x9;employeeList.add(employee2);&#xA;&#x9;&#x9;Manager manager1 = new Manager(employeeList);&#xA;&#x9;&#x9;System.out.println(manager1.employees);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.17/@edit" start="583" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713298713" sizeMeasure="80" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(manager1.getResourceCount()" edit="/1/@proposals.0/@proposals.7/@attempts.18/@edit" start="1946" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713346919" sizeMeasure="81" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.19/@edit" start="1856" end="-151"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713732034" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Clerk employee2 = new Clerk(print1);&#xA;&#x9;&#x9;List&lt;Employee> employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(employee1);&#xA;&#x9;&#x9;employeeList.add(employee2);&#xA;&#x9;&#x9;Manager manager2 = new Manager(employeeList);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(manager2.getResourceCount());&#xA;&#x9;&#x9;System.out.println(manager2.getTaskCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Clerk employee3 = new Clerk(print1);&#xA;&#x9;&#x9;employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(manager2);&#xA;&#x9;&#x9;employeeList.add(employee3" edit="/1/@proposals.0/@proposals.7/@attempts.20/@edit" start="1590" end="-156"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713788293" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getResourceCount());&#xA;&#x9;&#x9;System.out.println(manager1.getTask" edit="/1/@proposals.0/@proposals.7/@attempts.21/@edit" start="2109" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713963328" sizeMeasure="98" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employee1.printDocument(&quot;hei&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Clerk employee2 = new Clerk(print1);&#xA;&#x9;&#x9;List&lt;Employee> employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(employee1);&#xA;&#x9;&#x9;employeeList.add(employee2);&#xA;&#x9;&#x9;Manager manager2 = new Manager(employeeList);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(manager2.getResourceCount());&#xA;&#x9;&#x9;System.out.println(manager2.getTaskCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Clerk employee3 = new Clerk(print1);&#xA;&#x9;&#x9;employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(manager2);&#xA;&#x9;&#x9;employeeList.add(employee3);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Manager manager1 = new Manager(employeeList);&#xA;&#x9;&#x9;System.out.println(manager1.getResourceCount());&#xA;&#x9;&#x9;System.out.println(manager1.getTaskCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Clerk employee4 = new Clerk(print1);&#xA;&#x9;&#x9;employeeList = new ArrayList&lt;>();&#xA;&#x9;&#x9;employeeList.add(employee4);&#xA;&#x9;&#x9;employeeList.add(manager1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Manager manager3 = new Manager(employeeList);&#xA;&#x9;&#x9;System.out.println(manager3.getResourceCount());&#xA;&#x9;&#x9;System.out.println(manager3" edit="/1/@proposals.0/@proposals.7/@attempts.22/@edit" start="1590" end="-27"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490713988527" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager3.printDocument(&quot;hei&quot;);&#xA;&#x9;&#x9;System.out.println(manager3.getResourceCount());&#xA;&#x9;&#x9;System.out.println(manager3.getTaskCount());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.23/@edit" start="2406" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714052407" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.24/@edit" start="1590" end="-928"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490707884759" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490707994544" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490708025028" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490708272869" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490708836198" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490712476999" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490712599313" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713197943" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713298633" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713346785" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713731925" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713788198" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713963231" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713988443" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713988761" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490713989845" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490714041362" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490714052287" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490707429155" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490707530135" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490707692151" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490707759624" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490707783622" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490707797560" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490708038494" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490708042290" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490709204357" completion="0.5714285714285714" successCount="4" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490709274746" completion="0.8571428571428571" successCount="6" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490709440352" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490709462541" completion="0.5714285714285714" successCount="4" failureCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490709488837" completion="0.7142857142857143" successCount="5" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490709506820" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490712449149" completion="0.8571428571428571" successCount="6" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490713519984" completion="1.0" successCount="7"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
