<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195278784" sizeMeasure="16">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);&#xA;&#x9;void printDocument(String dokument);&#xA;&#x9;int getTaskCount();&#xA;&#x9;int getResourceCount();&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195278814" sizeMeasure="41">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#x9;&#xA;&#x9;int taskCount=0;&#xA;&#x9;Printer printer = new Printer();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer=printer;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;printer.printDocument(document, this);&#x9;&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195345142" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="353" end="-256"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490202043543" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#x9;&#xA;&#x9;int taskCount=0;&#xA;&#x9;Printer printer = new Printer();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer=printer;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;printer.printDocument(document, this);&#x9;&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="38" end="-8"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490195281685" completion="0.25" successCount="1" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490195346193" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490195397863" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490199800438" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195278837" sizeMeasure="27" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;List&lt;Employee> employees = new ArrayList&lt;>();&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;public void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;if(!employees.contains(employee)) {&#xA;&#x9;&#x9;&#x9;employees.add(employee);&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;employee&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490195394462" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return null;" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="406" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490199914731" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HashMap;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;HashMap&lt;Employee, ArrayList&lt;String>> employeePrint; &#xA;&#x9;&#xA;&#x9;public Printer() {&#xA;&#x9;&#x9;employeePrint = new HashMap&lt;Employee,ArrayList&lt;String>>();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;public void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;if(!employeePrint.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;employeePrint.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;&#x9;employeePrint.get(employee).add(document);&#x9;&#x9;&#x9; &#xA;&#x9;&#x9;}  else {&#xA;&#x9;&#x9;&#x9;employeePrint.get(employee).add(document);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;if(!employeePrint.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return &#x9;employeePrint.get(employee);" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="82" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490200086076" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;HashMap&lt;Employee, ArrayList&lt;String>> employeePrint; &#xA;&#x9;&#xA;&#x9;public Printer() {&#xA;&#x9;&#x9;employeePrint = new HashMap&lt;Employee,ArrayList&lt;String>>();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;public void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;if(!employeePrint.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;employeePrint.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;&#x9;employeePrint.get(employee).add(document);&#x9;&#x9;&#x9; &#xA;&#x9;&#x9;}  else {&#xA;&#x9;&#x9;&#x9;employeePrint.get(employee).add(document);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;if(!employeePrint.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;return Collections.emptyList()" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="82" end="-52"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490199837653" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490199915557" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490200087277" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490200668460" sizeMeasure="47">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.Collection;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#x9;&#xA;&#x9;int taskCount;&#xA;&#x9;Collection&lt;Employee> employees;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Employee er tom.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employees=employees;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String dokument) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount=0;&#xA;&#x9;&#x9;for(Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490201064319" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#x9;&#xA;&#x9;int taskCount=0;&#xA;&#x9;ArrayList&lt;Employee> employees;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Manager(ArrayList&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Employee er tom.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employees=employees;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;Employee employee1 = employees.get((int) (Math.random()*employees.size()));&#xA;&#x9;&#x9;return employee1.doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;Employee employee1 = employees.get((int) (Math.random()*employees.size()));&#xA;&#x9;&#x9;employee1.printDocument(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="54" end="-196"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490202036401" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection&lt;Employee> employees;&#xA;&#x9;ArrayList&lt;Employee> employees1;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Employee er tom.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//this.employees=employees;&#xA;&#x9;&#x9;this.employees1 = new ArrayList&lt;Employee>(employees);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;Employee employee2 = employees1.get((int) (Math.random()*employees.size()));&#xA;&#x9;&#x9;return employee2.doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;Employee employee2 = employees1.get((int) (Math.random()*employees.size()));&#xA;&#x9;&#x9;employee2" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="200" end="-287"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490202090699" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1.size()));&#xA;&#x9;&#x9;return employee2.doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;Employee employee2 = employees1.get((int) (Math.random()*employees1" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="695" end="-309"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490202109999" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="1135" end="-88"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490202224104" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + employees1.size()" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="1215" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490202588929" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employees1.size();&#xA;&#x9;&#x9;for(Employee employee : employees1) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="1097" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490615748245" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Employee> employees1;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Employee er tom.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//this.employees=employees;&#xA;&#x9;&#x9;this.employees1 = new ArrayList&lt;Employee>(employees);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;Employee employee2 = employees1.get((int) (Math.random()*employees1.size()));&#xA;&#x9;&#x9;return employee2.doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;Employee employee2 = employees1.get((int) (Math.random()*employees1.size()));&#xA;&#x9;&#x9;employee2.printDocument(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount=0" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="200" end="-126"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490615867712" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employees1.size()" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="1064" end="-126"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490615920279" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="1064" end="-126"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490202044540" completion="0.14285714285714285" successCount="1" errorCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490202091552" completion="0.5714285714285714" successCount="4" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490202110844" completion="0.5714285714285714" successCount="4" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490202225035" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490202589702" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490615251639" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490615751700" completion="0.5714285714285714" successCount="4" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490615868882" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490615924368" completion="1.0" successCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490615971881" completion="1.0" successCount="7"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
