<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614614493" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614658562" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614186047" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614535565" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private String stock;&#xA;&#x9;private double price;&#xA;&#x9;&#xA;&#x9;public Stock(String stock, double price){&#xA;&#x9;&#x9;stock = this.stock;&#xA;&#x9;&#x9;price = this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double StockPrice){&#xA;&#x9;&#x9;if(StockPrice &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ERROR, Invalid stock price&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;price = StockPrice;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="51" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614600995" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public String getTicker(){&#xA;&#x9;&#x9;return stock;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;return price;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="370" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614775776" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void addStockListener(StockListener observator){&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="464" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614917494" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="er){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener observe" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="516" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490621329548" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String stock;&#xA;&#x9;private double price;&#xA;&#x9;List&lt;StockListener> listeners;&#xA;&#x9;&#xA;&#x9;public Stock(String stock, double price){&#xA;&#x9;&#x9;this.stock = stock;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;listeners = new ArrayList&lt;>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double price){&#xA;&#x9;&#x9;if(this.price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;ERROR, Invalid stock price&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.price != price){&#xA;&#x9;&#x9;&#x9;for(StockListener listener : listeners) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this.price, price);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;return stock;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener observer){&#xA;&#x9;&#x9;listeners.add(observer);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener observer){&#xA;&#x9;&#x9;listeners.remove(observer);" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="30" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490636888286" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return getTicker() + getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;Stock stock = new Stock(&quot;AS123&quot;, 2.4);&#xA;&#x9;&#x9;stock.getPrice();&#xA;&#x9;&#x9;stock.getTicker();&#xA;&#x9;&#x9;System.out.println(stock.toString());&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="884" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490636907257" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot; &quot;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="936" end="-191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490636991442" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;stock.setPrice(3.9" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1123" end="-51"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490636895220" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490636995649" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490615859332" completion="0.0" failureCount="2">
          <failureTests>testStockListener</failureTests>
          <failureTests>testConstructor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490621337574" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490635611308" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490636553115" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;import java.util.ArrayList;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#x9;private String name;&#xA;&#x9;private double index;&#xA;&#x9;private List&lt;Stock>stocks;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, double index, Stock...stocks){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;index = 0;&#xA;&#x9;&#x9;this.stocks = new ArrayList&lt;>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Stock stock: stocks){&#xA;&#x9;&#x9;&#x9;if(!this.stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;&#x9;index += stock.getPrice();&#xA;&#x9;&#x9;&#x9;&#x9;this.stocks.add(stock);&#xA;&#x9;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;if(!this.stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;index += stock.getPrice();&#xA;&#x9;&#x9;&#x9;this.stocks.add(stock);&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;this.stocks.remove(stock);&#xA;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice){&#xA;&#x9;&#x9;index += newPrice - oldPrice;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490636645359" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="240" end="-780"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490636675820" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="stocks.add(stock);&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="700" end="-179"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490636739979" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="f(this.stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;&#x9;stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="803" end="-123"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490637458120" sizeMeasure="66" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;Stock: &quot; + this.getName() + &quot; ,&quot; + &quot;Price: &quot; + this.getIndex(); &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;Stock stock1 = new Stock(&quot;Statoil&quot;, 23.2);&#xA;&#x9;&#x9;Stock stock2 = new Stock(&quot;Nintendo&quot;, 99.1);&#xA;&#x9;&#x9;Stock stock3 = new Stock(&quot;YARA&quot;, 12);&#xA;&#x9;&#x9;Stock stock4 = new Stock(&quot;MILA&quot;, 12.99);&#xA;&#x9;&#x9;Stock stock5 = new Stock(&quot;Riot Games&quot;, 420);&#xA;&#x9;&#x9;StockIndex myIndex = new StockIndex(&quot;Oslo børs&quot;, stock1, stock2, stock3);&#xA;&#x9;&#x9;System.out.println(myIndex.toString())" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="1049" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="61" charStart="1407" charEnd="1413" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1451" charEnd="1457" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490637580267" sizeMeasure="69" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Market: &quot; + this.getName() + &quot; ,&quot; + &quot;Price: &quot; + this.getIndex(); &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;Stock stock1 = new Stock(&quot;Statoil&quot;, 23.2);&#xA;&#x9;&#x9;Stock stock2 = new Stock(&quot;Nintendo&quot;, 99.1);&#xA;&#x9;&#x9;Stock stock3 = new Stock(&quot;YARA&quot;, 12);&#xA;&#x9;&#x9;Stock stock4 = new Stock(&quot;MILA&quot;, 12.99);&#xA;&#x9;&#x9;Stock stock5 = new Stock(&quot;Riot Games&quot;, 420);&#xA;&#x9;&#x9;StockIndex myIndex = new StockIndex(&quot;Oslo børs&quot;, stock1, stock2, stock3);&#xA;&#x9;&#x9;System.out.println(myIndex.toString());&#xA;&#x9;&#x9;myIndex.addStock(stock4);&#xA;&#x9;&#x9;myIndex.removeStock(stock1" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="1102" end="-51"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1457" charEnd="1463" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490637457279" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490637578890" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490636583704" completion="0.0" errorCount="4">
          <errorTests>testRemoveStock</errorTests>
          <errorTests>testAddStock</errorTests>
          <errorTests>testChangePrice</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490636649031" completion="0.75" successCount="3" failureCount="1">
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490636679226" completion="0.75" successCount="3" failureCount="1">
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490636743640" completion="1.0" successCount="4">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
