<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Logger">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the ILogger Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.ILogger"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Implementations">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StreamLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StreamLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StreamLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.StreamLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the FilteringLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the FilteringLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the FilteringLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.FilteringLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the DistributingLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DistributingLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DistributingLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.DistributingLoggerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.*Logger" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219053046" sizeMeasure="8">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public interface ILogger {&#xA;&#xA;&#x9;public String ERROR = &quot;error&quot;, WARNING = &quot;warning&quot;, INFO = &quot;info&quot;;&#xA;    public void log(String severity, String message, Exception exception);&#xA;    &#xA;}&#xA;"/>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219101303" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class StreamLogger implements ILogger {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219349850" sizeMeasure="25" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.io.OutputStream;&#xA;&#xA;public class StreamLogger implements ILogger {&#xA;&#xA;&#x9;private OutputStream outStream;&#xA;&#x9;private String formatString;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StreamLogger(OutputStream outStream) {&#xA;&#x9;&#x9;this.outStream = outStream;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFormatString(String formatString) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-129"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490220597600" sizeMeasure="30" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.io.OutputStreamWriter;&#xA;&#xA;public class StreamLogger implements ILogger {&#xA;&#xA;&#x9;private OutputStream stream;&#xA;&#x9;private String format;&#xA;&#xA;&#x9;public StreamLogger(OutputStream stream) {&#xA;&#x9;&#x9;this.stream = stream;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFormatString(String formatString) {&#xA;&#x9;&#x9;this.format = formatString;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;OutputStreamWriter writer = new OutputStreamWriter(stream);&#xA;&#x9;&#x9;if (formatString != null) {&#xA;&#x9;&#x9;&#x9;writer.write(String.format(format, args));&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;stream.flush();" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="59" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490220755937" sizeMeasure="26" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.format = &quot;%s: %s (%s)&quot;;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFormatString(String formatString) {&#xA;&#x9;&#x9;this.format = formatString;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;OutputStreamWriter writer = new OutputStreamWriter(stream);&#xA;&#x9;&#x9;writer.write(String.format(format, severity, message, exception));" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="267" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221202435" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="IOException;&#xA;import java.io.OutputStream;&#xA;import java.io.OutputStreamWriter;&#xA;&#xA;public class StreamLogger implements ILogger {&#xA;&#xA;&#x9;private OutputStream stream;&#xA;&#x9;private String format;&#xA;&#xA;&#x9;public StreamLogger(OutputStream stream) {&#xA;&#x9;&#x9;this.stream = stream;&#xA;&#x9;&#x9;this.format = &quot;%s: %s (%s)&quot;;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFormatString(String formatString) {&#xA;&#x9;&#x9;this.format = formatString;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;OutputStreamWriter writer = new OutputStreamWriter(stream);&#xA;&#x9;&#x9;try {&#xA;&#x9;&#x9;&#x9;writer.write(String.format(format, severity, message, exception));&#xA;&#x9;&#x9;&#x9;stream.flush();&#xA;&#x9;&#x9;} catch (IOException e) {&#xA;&#x9;&#x9;&#x9;System.out.println(e);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="45" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221210662" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="717" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221282638" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="} catch (IOException e) {&#xA;&#x9;&#x9;&#x9;System.out.println(e);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="641" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221378048" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="702" end="-703"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221477224" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot;\n&quot;" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="636" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490633655920" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.io.Writer;&#xA;&#xA;public class StreamLogger implements ILogger {&#xA;&#xA;&#x9;private Writer writer;&#xA;&#x9;private String format;&#xA;&#xA;&#x9;public StreamLogger(OutputStream stream) {&#xA;&#x9;&#x9;this.writer = new OutputStreamWriter(stream);&#xA;&#x9;&#x9;this.format = &quot;%s: %s (%s)&quot;;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFormatString(String formatString) {&#xA;&#x9;&#x9;this.format = formatString;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;String logMessage = String.format(format, severity, message, exception);&#xA;&#x9;&#x9;try {&#xA;&#x9;&#x9;&#x9;writer.write(logMessage);&#xA;&#x9;&#x9;} catch (IOException e) {&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Skriving til fil feilet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;finally {&#xA;&#x9;&#x9;&#x9;try {&#xA;&#x9;&#x9;&#x9;&#x9;writer.flush();&#xA;&#x9;&#x9;&#x9;} catch (IOException e) {&#xA;&#x9;&#x9;&#x9;&#x9;System.out.println(&quot;Fikk ikke lukket filen&quot;);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="122" end="-11"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490221224168" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490221480705" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490633670178" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219058856" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class FilteringLogger implements ILogger {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221550774" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ILogger logger;&#xA;&#x9;" edit="/1/@proposals.1/@proposals.3/@attempts.0/@edit" start="82" end="-129"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221634141" sizeMeasure="16" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ILogger logger;&#xA;&#x9;&#xA;&#x9;public FilteringLogger(ILogger logger, String... severities) {&#xA;&#x9;&#x9;this.logger = logger;&#xA;&#x9;}&#xA;" edit="/1/@proposals.1/@proposals.3/@attempts.1/@edit" start="82" end="-129"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221649219" sizeMeasure="16" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.3/@attempts.2/@edit" start="327" end="-328"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490221678936" sizeMeasure="18" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public boolean isLogging(String severity) " edit="/1/@proposals.1/@proposals.3/@attempts.3/@edit" start="199" end="-130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490222024532" sizeMeasure="29" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class FilteringLogger implements ILogger {&#xA;&#xA;&#x9;private ILogger logger;&#xA;&#x9;private List&lt;String> severities;&#xA;&#x9;&#xA;&#x9;public FilteringLogger(ILogger logger, String... severities) {&#xA;&#x9;&#x9;this.logger = logger;&#xA;&#x9;&#x9;this.severities = new ArrayList&lt;>();&#xA;&#x9;&#x9;for (String severity : severities) {&#xA;&#x9;&#x9;&#x9;this.severities.add(severity);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isLogging(String severity) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.4/@edit" start="30" end="-130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490222029020" sizeMeasure="28" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.3/@attempts.5/@edit" start="399" end="-186"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490222233999" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public boolean isLogging(String severity) {&#xA;&#x9;&#x9;return severities.contains(severity);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void setIsLogging(String severity, boolean value) {&#xA;&#x9;&#x9;if (value &amp;&amp; !severities.contains(severity)) {&#xA;&#x9;&#x9;&#x9;severities.add(severity);&#xA;&#x9;&#x9;} else if (!value &amp;&amp; severities.contains(severity)){&#xA;&#x9;&#x9;&#x9;severities.remove(severity);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.6/@edit" start="399" end="-133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490222342710" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (severities.contains(severity)) {&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.7/@edit" start="805" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490633784296" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public " edit="/1/@proposals.1/@proposals.3/@attempts.8/@edit" start="494" end="-403"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490222351101" completion="0.8" successCount="4" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490633735772" completion="1.0" successCount="5"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.6/@q" answer="/0/@parts.1/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219064154" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class DistributingLogger implements ILogger {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490219098240" sizeMeasure="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.6/@attempts.0/@edit" start="211" end="-212"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490222783600" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ILogger errorLogger;&#xA;&#x9;private ILogger warningLogger;&#xA;&#x9;private ILogger infoLogger;&#xA;&#x9;&#xA;&#x9;public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;this.errorLogger = errorLogger;&#xA;&#x9;&#x9;this.warningLogger = warningLogger;&#xA;&#x9;&#x9;this.infoLogger = infoLogger;&#xA;&#x9;}&#xA;&#xA;&#x9;void setLogger(String severity, ILogger logger) {&#xA;&#x9;&#x9;if (severity.toLowerCase().equals(&quot;error&quot;)) {&#xA;&#x9;&#x9;&#x9;errorLogger = logger;&#xA;&#x9;&#x9;} else if (severity.toLowerCase().equals(&quot;warning&quot;)) {&#xA;&#x9;&#x9;&#x9;warningLogger = logger;&#xA;&#x9;&#x9;} else if (severity.toLowerCase().equals(&quot;info&quot;)) {&#xA;&#x9;&#x9;&#x9;infoLogger = logger;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;if (severity.toLowerCase().equals(&quot;error&quot;)) {&#xA;&#x9;&#x9;&#x9;errorLogger.log(severity, message, exception);&#xA;&#x9;&#x9;} else if (severity.toLowerCase().equals(&quot;warning&quot;)) {&#xA;&#x9;&#x9;&#x9;warningLogger.log(severity, message, exception);&#xA;&#x9;&#x9;} else if (severity.toLowerCase().equals(&quot;info&quot;)) {&#xA;&#x9;&#x9;&#x9;infoLogger.log(severity, message, exception);&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.6/@attempts.1/@edit" start="85" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490634341272" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Bruker .toLowerCase() for å hjelpe folk" edit="/1/@proposals.1/@proposals.6/@attempts.2/@edit" start="476" end="-600"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490634365983" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.6/@attempts.3/@edit" start="476" end="-600"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.7/@q" answer="/0/@parts.1/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.8/@q" answer="/0/@parts.1/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490222800122" completion="0.0" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490633940660" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
