<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491211696426" sizeMeasure="35">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public abstract class AbstractAccount {&#xA;&#xA;&#x9;private double balance;&#xA;&#x9;&#xA;&#x9;AbstractAccount(){&#xA;&#x9;&#x9;this.balance = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void deposit(double amount){&#xA;&#x9;&#x9;if (amount > 0){&#xA;&#x9;&#x9;&#x9;this.balance += amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid deposit amount.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void withdraw(double amount){&#xA;&#x9;&#x9;if (amount > 0 &amp;&amp; amount &lt;= this.balance){&#xA;&#x9;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid withdraw amount.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;abstract void internalWithdraw(double amount);&#xA;&#x9;&#xA;&#x9;double getBalance(){&#xA;&#x9;&#x9;return this.balance;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491214438937" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="346" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491214591226" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="66" end="-499"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491214473985" sizeMeasure="11">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount extends AbstractAccount {&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491214716829" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (super.balance >= amount){&#xA;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not enough money in account.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="128" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491214793939" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="219" end="-54"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215171125" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Withdrawal amount exceeds balance" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="235" end="-16"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491214828616" sizeMeasure="11">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount extends AbstractAccount {&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215172705" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private double creditLine;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;double credit = super.balance + this.creditLine;&#xA;&#x9;&#x9;if (credit >= amount){&#xA;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Withdrawal amount exceeds credit line.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;double getCreditLine(){&#xA;&#x9;&#x9;return this.creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void setCreditLine(double amount){&#xA;&#x9;&#x9;if (amount >= 0){&#xA;&#x9;&#x9;&#x9;this.creditLine = amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid credit line amount.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="77" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215434972" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid credit line.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (super.balance &lt; 0 &amp;&amp; this.creditLine &lt; -super.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Negative balance exceeds credit line.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.creditLine = amount" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="466" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215443983" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Debt" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="642" end="-77"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215485139" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CreditAccount(double amount){&#xA;&#x9;&#x9;setCreditLine(amount);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="107" end="-620"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215547434" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(-super.balance)" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="650" end="-120"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215584168" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount &lt; -super.balance" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="632" end="-120"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215592440" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="774" end="-775"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491215634549" sizeMeasure="11">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 extends AbstractAccount {&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491216131265" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int withdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;SavingsAccount2(int times, double amount){&#xA;&#x9;&#x9;if (times &lt; 0 || amount &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Fee and amount of withdrawals allowed cannot be negative.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;this.withdrawals = times;&#xA;&#x9;&#x9;&#x9;this.fee = amount;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > super.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Withdrawal amount exceeds&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.withdrawals > 0){&#xA;&#x9;&#x9;&#x9;withdrawals--;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;super.balance -= fee;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.balance -= amount;" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="79" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491216544743" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double total = amount;&#xA;&#x9;&#x9;if (total > super.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Withdrawal amount exceeds balance.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.withdrawals > 0){&#xA;&#x9;&#x9;&#x9;withdrawals--;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;total += fee;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (total > super.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Withdrawal amount including fee exceeds balance.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.balance -= total" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="430" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491216598005" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StateException(&quot;Withdrawal amount exceeds balance.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.withdrawals > 0){&#xA;&#x9;&#x9;&#x9;withdrawals--;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;total += fee;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (total > super.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalState" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="503" end="-100"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491214753388" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491214795939" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491214746237" completion="0.0" errorCount="1">
          <errorTests>initializationError</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491215494675" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491215551793" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491215586813" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="0.5">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491216563537" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
