<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490545742675" sizeMeasure="32">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public abstract class AbstractAccount {&#xA;&#xA;&#x9;private double balance;&#xA;&#x9;&#xA;&#x9;public AbstractAccount(){&#xA;&#x9;&#x9;this.balance = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deposit(double amount){&#xA;&#x9;&#x9;if (amount > 0){&#xA;&#x9;&#x9;&#x9;this.balance += amount;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You can only deposit a positive amount.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount){&#xA;&#x9;&#x9;if (amount > 0){&#xA;&#x9;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You can only withdraw a positive amount.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public abstract void internalWithdraw(double amount);&#xA;&#x9;&#xA;&#x9;public double getBalance(){&#xA;&#x9;&#x9;return this.balance;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490546223209" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="66" end="-560"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490545742692" sizeMeasure="15">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount extends AbstractAccount{&#xA;&#x9;&#xA;&#x9;protected double balance;&#xA;&#x9;&#xA;&#x9;protected DebitAccount(double balance){&#xA;&#x9;&#x9;this.balance = balance;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;this.balance -= amount;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490545934751" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ublic DebitAccount(double balance){&#xA;&#x9;&#x9;this.balance = balance;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="106" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490546223197" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > getBalance()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot withdraw more than you have on your account.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;super" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="76" end="-27"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490550312367" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="185" end="-109"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490546161004" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490546223180" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490547229516" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private double creditLine; &#xA;&#x9;&#xA;&#x9;public CreditAccount(double creditLine){&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;if (creditLine &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Creditline must be 0 or positive.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (super.balance &lt; 0 &amp;&amp; (creditLine + super.balance) &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Creditline must cover the negative balance.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="76" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490547266285" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount > getBalance()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot withdraw more than you have on your account.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;super.balance -= amount;" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="644" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490547382450" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CreditLine()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot withdraw more than your credit line" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="660" end="-48"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490547579882" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super();" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="150" end="-661"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490547833528" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="667" end="-152"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490548857170" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.balance - amount > -creditLine){&#xA;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot withdraw more than your credit line.&quot;)" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="659" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490548882521" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance - amount > -creditLine){&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="659" end="-124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490548894803" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.3/@attempts.8/@edit" start="677" end="-142"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490548915701" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot withdraw more than your credit line.&quot;);&#xA;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.9/@edit" start="719" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490548956195" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount > getCreditLine()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot withdraw more than your credit line.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;super.balance -= amount;" edit="/1/@proposals.0/@proposals.3/@attempts.10/@edit" start="659" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490548975524" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance - amount >= - creditLine) {&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}&#xA;//&#x9;&#x9;if (amount > getCreditLine()){&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot withdraw more than your credit line.&quot;);&#xA;//&#x9;&#x9;} &#xA;//" edit="/1/@proposals.0/@proposals.3/@attempts.11/@edit" start="659" end="-38"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490548988808" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.12/@edit" start="680" end="-281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490549040841" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if (balance - amount >= - creditLine) {&#xA;//&#x9;&#x9;&#x9;balance -= amount;&#xA;//&#x9;&#x9;} else {&#xA;//&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;//&#x9;&#x9;}&#xA;&#x9;&#x9;if (amount > getCreditLine()){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;} &#xA;" edit="/1/@proposals.0/@proposals.3/@attempts.13/@edit" start="653" end="-38"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490549249457" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;// balansen kan ikke gå under -(kretiddgrensen)&#xA;&#x9;&#x9;if (balance - amount >= - getCreditLine()){&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.14/@edit" start="650" end="-12"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490549297032" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490549629756" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#xA;&#x9;private int withdrawls;&#xA;&#x9;private double fee; &#xA;&#x9;private int count;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawls, double fee){&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;this.withdrawls = withdrawls;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;count++;&#xA;&#x9;&#x9;if (count > withdrawls){&#xA;&#x9;&#x9;&#x9;balance -= fee;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= amount;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="51" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490549712985" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance - amount &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Savings account cannot have negative funds.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="342" end="-83"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490549974453" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount > balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="342" end="-199"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490550128707" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (withdrawls > 0){&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;&#x9;withdrawls -= 1;&#xA;&#x9;&#x9;} else if (balance >= amount + fee){&#xA;&#x9;&#x9;&#x9;balance -= fee;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="423" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="143" charEnd="148" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490550182732" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public SavingsAccount2(int withdrawls, double fee){&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;this.withdrawls = withdrawls;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (withdrawls > 0){&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;&#x9;withdrawls -= 1;&#xA;&#x9;&#x9;} else if (balance >= amount + fee){&#xA;&#x9;&#x9;&#x9;balance -= amount + fee " edit="/1/@proposals.0/@proposals.5/@attempts.4/@edit" start="125" end="-87"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490545901686" completion="0.0" errorCount="2">
          <errorTests>testWithdraw</errorTests>
          <errorTests>testDeposit</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490545935139" completion="0.0" errorCount="2">
          <errorTests>testWithdraw</errorTests>
          <errorTests>testDeposit</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490550216156" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490550312731" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490547229917" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
          <failureTests>testSetCreditLine</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490547266666" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490547382833" completion="0.6666666666666666" successCount="2" errorCount="1">
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490547580232" completion="0.6666666666666666" successCount="2" errorCount="1">
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490547833900" completion="0.6666666666666666" successCount="2" errorCount="1">
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490548857543" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490548882885" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490548895192" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490548916083" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490548956568" completion="0.6666666666666666" successCount="2" errorCount="1">
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490548975901" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490548989190" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490549041221" completion="0.6666666666666666" successCount="2" errorCount="1">
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490549249814" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490549630152" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490549713378" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490549974802" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490550129086" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490550183143" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490550391896" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
