<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491158444148" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class AbstractAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491158819809" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="abstract class AbstractAccount {&#xA;&#xA;&#x9;protected double balance;&#xA;&#x9;&#xA;&#x9;public AbstractAccount() {&#xA;&#x9;&#x9;balance = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if (amount &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Må være positivt beløp&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance += amount;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw (double amount) {&#xA;&#x9;&#x9;if (amount &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Må være positivt beløp&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public abstract void internalWithdraw(double amount);&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="29" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491158837946" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public double getBalance() {&#xA;&#x9;&#x9;return this.balance;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="538" end="-6"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491158901789" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159055360" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if ((balance -amount) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Kan ikke få negativ balanse&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="48" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159140750" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159159087" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="50" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159203204" sizeMeasure="13" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private double creditLine;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="75" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="95" charEnd="105" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159262641" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return this.creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;this.creditLine = creditLine;" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="206" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159323086" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (creditLine &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kreditt må være positiv&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="322" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159405471" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public CreditAccount(double creditLine) {&#xA;&#x9;&#x9;setCreditLine(creditLine);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="106" end="-363"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159434642" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if () {&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="496" end="-56"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="522" charEnd="523" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159651173" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance &lt; 0 &amp;&amp; balance &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Ny kredittlinje dekker ikke balanse&quot;);" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="500" end="-56"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159739313" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if ((balance-amount) &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException (&quot;Kan ikke ta ut beløpet&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="242" end="-390"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159869476" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="*-1) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException (&quot;Kan ikke ta ut beløpet&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return this.creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;if (creditLine &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kreditt må være positiv&quot;);&#xA;&#x9;&#x9;} else if (balance &lt; 0 &amp;&amp; balance &lt; creditLine*-1" edit="/1/@proposals.0/@proposals.3/@attempts.8/@edit" start="275" end="-134"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159909430" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159934023" sizeMeasure="7" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount {&#xA;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="51" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="52" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491159939069" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="79" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491160039422" sizeMeasure="21" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int withdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawals, double fee) {&#xA;&#x9;&#x9;this.withdrawals = withdrawals;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="79" end="-110"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="95" charEnd="106" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="125" charEnd="128" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491160291991" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (withdrawals > 0) {&#xA;&#x9;&#x9;&#x9;if ((balance-amount) &lt; 0) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException (&quot;Kan ikke ta ut beløpet&quot;);&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;&#x9;&#x9;withdrawals -= 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (balance -(amount + fee) &lt; 0) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException (&quot;Kan ikke ta ut beløpet&quot;);&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;balance -= amount + fee;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="299" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491160317424" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.4/@edit" start="652" end="-653"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491159072083" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491159752173" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
          <errorTests>testWithdraw</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491159875705" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491160331178" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
