<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Train">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TrainCar superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.TrainCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TrainCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.TrainCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CargoCar class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CargoCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CargoCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CargoCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the PassengerCar class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.PassengerCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the PassengerCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.PassengerCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the Train class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.Train"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Train class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.Train"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TrainCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.TrainCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PassengerCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.PassengerCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CargoCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CargoCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TrainTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.TrainTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in *Car classes."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Car" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the Train class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.Train" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491224338760" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class TrainCar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491224624951" sizeMeasure="30" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private int emptyCarW; &#xA;&#x9;&#xA;&#x9;&#xA;//&#x9;en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;TrainCar(int emptyCarW){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta toil vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;void setDeadWeight(int emptyCarW){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;//&#x9;- returnerer hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last&#xA;&#x9;int getDeadWeight(){&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="46" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491224854833" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;void setDeadWeight(int emptyCarW){&#xA;&#x9;&#x9;this.emptyCarW = emptyCarW;&#xA;&#x9;}&#xA;&#xA;//&#x9;- returnerer hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last&#xA;&#x9;int getDeadWeight(){&#xA;&#x9;&#x9;return emptyCarW;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="357" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225103470" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="il vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="292" end="-330"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225535109" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="totalCarW;&#xA;&#x9;private int deadW;&#xA;&#x9;&#xA;//&#x9;en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;TrainCar(int deadW){&#xA;//&#x9;&#x9;this.deadW = deadW;&#xA;//&#x9;&#x9;this.totalCarW = totalCarW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta til vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;int getTotalWeight(int emptyCarW){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return totalCarW;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;//&#x9;- setter hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;void setDeadWeight(int deadW){&#xA;&#x9;&#x9;this.deadW = deadW;&#xA;&#x9;}&#xA;&#xA;//&#x9;- returnerer hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last&#xA;&#x9;int getDeadWeight(){&#xA;&#x9;&#x9;return dead" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="59" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225710295" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="totalCarW){&#xA;&#x9;&#x9;this.deadW = totalCarW -" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="589" end="-163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225763122" sizeMeasure="34" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="totalCarW){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return totalCarW;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;//&#x9;- setter hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;void setDeadWeight(int deadW){&#xA;&#x9;&#x9;this.deadW =" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="421" end="-163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225984403" sizeMeasure="35" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int loadW;&#xA;&#x9;&#xA;//&#x9;en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;TrainCar(int deadW){&#xA;//&#x9;&#x9;this.deadW = deadW;&#xA;//&#x9;&#x9;this.totalCarW = totalCarW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta til vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;int getTotalWeight(int deadW, int loadW){&#xA;&#x9;&#x9;totalCarW = deadW + loadW;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="91" end="-339"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226239260" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="192" end="-633"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226295848" sizeMeasure="34" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.deadW = deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta til vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;int getTotalWeight(int totalCarW){&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="194" end="-367"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226824140" sizeMeasure="33" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="91" end="-683"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227166167" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected int totalCarW;&#xA;&#x9;protected int de" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="49" end="-683"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227664367" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="static " edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="368" end="-404"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227718375" sizeMeasure="33" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="410" end="-367"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227730103" sizeMeasure="33" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", int load" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="407" end="-371"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227743746" sizeMeasure="33" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="dead" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="398" end="-382"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227757098" sizeMeasure="33" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="static int totalCarW;&#xA;&#x9;protected static" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="57" end="-702"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227770397" sizeMeasure="33" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="totalCarW){&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="412" end="-367"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227793366" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="90" end="-697"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227832122" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int deadW;&#xA;&#x9;&#xA;//&#x9;en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;TrainCar(int deadW){&#xA;&#x9;&#x9;this.deadW = deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta til vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;protected" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="90" end="-405"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227935207" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="static" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="375" end="-405"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228024639" sizeMeasure="33" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int totalCarW;&#xA;&#x9;protected int deadW;&#xA;&#x9;&#xA;//&#x9;en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;TrainCar(int deadW){&#xA;&#x9;&#x9;this.deadW = deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta til vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;static int getTotalWeight(){&#xA;//&#x9;&#x9;totalCarW = deadW + loadW;&#xA;&#x9;&#x9;return this.dead" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="57" end="-321"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228061382" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="368" end="-392"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228096128" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otalCar" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="431" end="-321"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228103876" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.dead" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="431" end="-321"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228143360" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="totalCar" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="435" end="-321"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228192148" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deadW;&#xA;&#x9;&#xA;//&#x9;en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;TrainCar(int deadW){&#xA;&#x9;&#x9;this.deadW = deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta til vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return this.dead" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="61" end="-321"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228868491" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="390" end="-314"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309284454" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="static int deadW;&#xA;&#x9;&#xA;//&#x9;en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;TrainCar(int deadW){&#xA;&#x9;&#x9;TrainCar.deadW = deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta til vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return TrainCar.deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;void setDeadWeight(int deadW){&#xA;&#x9;&#x9;TrainCar" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="57" end="-171"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491316147391" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int deadW;&#xA;&#x9;&#xA;//&#x9;en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;TrainCar(int deadW){&#xA;&#x9;&#x9;this.deadW = deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer vognas totale vekt. Merk at denne også skal kunne kalles &#xA;//&#x9;på subklasser og fortsatt returnere totalvekta til vogna &#xA;//&#x9;(stikkord: redefinering).&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter hvor mye en tom vogn veier. &#xA;//&#x9;Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;void setDeadWeight(int deadW){&#xA;&#x9;&#x9;this" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="57" end="-171"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226321359" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CargoCar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227170405" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends TrainCar{&#xA;&#xA;&#x9;private int cargoWeight;&#xA;//&#x9;private int deadW;&#xA;//&#x9;private int totalCarW;&#xA;&#xA;&#x9;&#xA;//&#x9;her tas inn hvor mye en tom vogn veier (som i TrainCar), &#xA;//&#x9;og hvor mye vogna sin last veier.&#xA;&#x9;CargoCar(int deadW, int totalCarW){&#xA;&#x9;&#x9;super(deadW);&#xA;&#x9;&#x9;this.deadW = deadW;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer hvor mye lasten veier.&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter en ny verdi for vekten til lasten.&#xA;&#x9;void setCargoWeight(int cargoWeight){&#xA;&#x9;&#x9;this.cargoWeight = cargoWeight;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="44" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227320047" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cargoWeight" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="263" end="-266"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227596835" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;int x = deadW+cargoWeight;&#xA;&#x9;&#x9;return x" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="537" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227685115" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;int getTotalWeight(){&#xA;//&#x9;&#x9;int x = deadW+cargoWeight;&#xA;//&#x9;&#x9;return x;&#xA;//" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="537" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227834272" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="537" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227940164" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.5/@edit" start="537" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228221943" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;//&#x9;- returnerer hvor mye lasten veier.&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter en ny verdi for vekten til lasten.&#xA;&#x9;void setCargoWeight(int cargoWeight){&#xA;&#x9;&#x9;this.cargoWeight = cargoWeight;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.6/@edit" start="316" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228549197" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+deadW" edit="/1/@proposals.0/@proposals.2/@attempts.7/@edit" start="402" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228607613" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter en ny verdi for vekten til lasten.&#xA;&#x9;void setCargoWeight(int cargoWeight){&#xA;&#x9;&#x9;this.cargoWeight = cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return cargoWeight;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.8/@edit" start="402" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228636987" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.9/@edit" start="534" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228684547" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer hvor mye lasten veier.&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter en ny verdi for vekten til lasten.&#xA;&#x9;void setCargoWeight(int cargoWeight){&#xA;&#x9;&#x9;this.cargoWeight =" edit="/1/@proposals.0/@proposals.2/@attempts.10/@edit" start="313" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228707862" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.11/@edit" start="313" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228865798" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return cargoWeight + deadW;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.12/@edit" start="534" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228909570" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int x = cargoWeight + deadW;&#xA;&#x9;&#x9;return x" edit="/1/@proposals.0/@proposals.2/@attempts.13/@edit" start="559" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228975809" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cargoWeight = cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returnerer hvor mye lasten veier.&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter en ny verdi for vekten til lasten.&#xA;&#x9;void setCargoWeight(int cargoWeight){&#xA;&#x9;&#x9;this.cargoWeight = cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return cargoWeight + deadW" edit="/1/@proposals.0/@proposals.2/@attempts.14/@edit" start="300" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491316207242" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.getTotalWeight()" edit="/1/@proposals.0/@proposals.2/@attempts.15/@edit" start="592" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491316243230" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="setCargoWeight()" edit="/1/@proposals.0/@proposals.2/@attempts.16/@edit" start="295" end="-297"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491316254694" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cargoWeight" edit="/1/@proposals.0/@proposals.2/@attempts.17/@edit" start="310" end="-298"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226576201" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class PassengerCar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226595866" sizeMeasure="20" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="PassengerCar extends TrainCar:&#xA;&#x9;&#xA;//&#x9;Denne klassen gjenspeiler en passasjervogn. Legg til følgende metoder (se også diagrammet til høyre):&#xA;&#x9;&#xA;//&#x9;- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mange passasjerer det er i vogna. &#xA;&#x9;PassengerCar(int, int){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returner antall passasjerer.&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter en ny verdi for antall passasjerer.&#xA;&#x9;setPassengerCount(int){&#xA;&#x9;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="22" end="-3"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226607155" sizeMeasure="21" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#xA;//&#x9;Denne klassen gjenspeiler en passasjervogn. Legg til følgende metoder (se også diagrammet til høyre):&#xA;&#x9;&#xA;//&#x9;- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mange passasjerer det er i vogna. &#xA;&#x9;PassengerCar(int, int){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returner antall passasjerer.&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter en ny verdi for antall passasjerer.&#xA;&#x9;setPassengerCount(int){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="51" end="-3"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227170399" sizeMeasure="21" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class " edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="22" end="-428"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227443333" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private int passangers;&#xA;//&#x9;Denne klassen gjenspeiler en passasjervogn. Legg til følgende metoder (se også diagrammet til høyre):&#xA;&#x9;&#xA;//&#x9;- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mange passasjerer det er i vogna. &#xA;&#x9;PassengerCar(int deadW , int passangers){&#xA;&#x9;&#x9;super(deadW);&#xA;&#x9;&#x9;this.deadW = deadW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- returner antall passasjerer.&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;return passangers;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;- setter en ny verdi for antall passasjerer.&#xA;&#x9;void setPassengerCount(int passangers){&#xA;&#x9;&#x9;this.passangers = passangers;" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="68" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229050374" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="passangers = passangers" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="371" end="-220"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229254582" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return passangers*80+deadW" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="611" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491318826061" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.getTotalWeight()" edit="/1/@proposals.0/@proposals.4/@attempts.6/@edit" start="659" end="-8"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229283350" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class Train {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229449893" sizeMeasure="34" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;//&#x9;denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;addTrainCar(TrainCar){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;boolean contains(TrainCar){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende PassengerCar sin metode, men returnerer antallet for alle vognene.&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;toString-metoden skal sette sammen en String med oversikt over alle vognene som er knyttet til den. For hver vogn skal vogntype og totalvekt være med. Passasjervogner skal i tillegg ha med antall passasjerer og lastevogner skal ha med hvor mye lasten veier.&#xA;&#x9;String toString(){&#xA;&#x9;&#x9;return &quot; &quot;;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.6/@attempts.0/@edit" start="43" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307802371" sizeMeasure="42" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;Train(TrainCar car){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//&#x9;denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;void addTrainCar(TrainCar car){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;boolean contains(TrainCar car){&#xA;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende PassengerCar sin metode, men returnerer antallet for alle vognene.&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;return passangers;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return cargoWeight;" edit="/1/@proposals.0/@proposals.6/@attempts.1/@edit" start="45" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309284405" sizeMeasure="41" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends TrainCar {&#xA;&#x9;protected int crazyTrain;&#xA;&#x9;&#xA;&#x9;Train(TrainCar car){&#xA;&#x9;&#x9;super(deadW);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//&#x9;denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;void addTrainCar(TrainCar car){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;boolean contains(TrainCar car){&#xA;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende PassengerCar sin metode, men returnerer antallet for alle vognene.&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;return passangers;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return cargoWeight;" edit="/1/@proposals.0/@proposals.6/@attempts.2/@edit" start="41" end="-307"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309871598" sizeMeasure="42" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.6/@attempts.3/@edit" start="128" end="-944"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311546219" sizeMeasure="42" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.6/@attempts.4/@edit" start="41" end="-1016"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311610646" sizeMeasure="43" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.*;&#xA;&#xA;public class Train {&#xA;&#x9;protected int crazyTrain;&#xA;&#x9;&#xA;&#x9;Train(TrainCar car){&#xA;&#x9;&#x9;cars = new ArrayList&lt;TrainCar>" edit="/1/@proposals.0/@proposals.6/@attempts.5/@edit" start="21" end="-948"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312568433" sizeMeasure="50" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private List&lt;TrainCar>cars;&#xA;&#x9;&#xA;&#x9;Train(TrainCar car){&#xA;&#x9;&#x9;cars = new ArrayList&lt;TrainCar>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//&#x9;denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;void addTrainCar(TrainCar car){&#xA;&#x9;&#x9;this.cars.add(car);&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;boolean contains(TrainCar car){&#xA;&#x9;&#x9;if(cars.contains(car)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;int totalW = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; cars.size(); i++){&#xA;&#x9;&#x9;&#x9;totalW += this.cars.get(i).getTotalWeight();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalW;" edit="/1/@proposals.0/@proposals.6/@attempts.6/@edit" start="93" end="-575"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312624255" sizeMeasure="50" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public Train(TrainCar car){&#xA;&#x9;&#x9;cars = new ArrayList&lt;TrainCar>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//&#x9;denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;public void addTrainCar(TrainCar car){&#xA;&#x9;&#x9;this.cars.add(car);&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;public boolean contains(TrainCar car){&#xA;&#x9;&#x9;if(cars.contains(car)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;public int getTotalWeight(){&#xA;&#x9;&#x9;int totalW = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; cars.size(); i++){&#xA;&#x9;&#x9;&#x9;totalW += this.cars.get(i).getTotalWeight();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende PassengerCar sin metode, men returnerer antallet for alle vognene.&#xA;&#x9;public int getPassengerCount(){&#xA;&#x9;&#x9;return passangers;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;public int getCargoWeight(){&#xA;&#x9;&#x9;return cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;toString-metoden skal sette sammen en String med oversikt over alle vognene som er knyttet til den. For hver vogn skal vogntype og totalvekt være med. Passasjervogner skal i tillegg ha med antall passasjerer og lastevogner skal ha med hvor mye lasten veier.&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.6/@attempts.7/@edit" start="124" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312651709" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;public int getCargoWeight(){&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.6/@attempts.8/@edit" start="893" end="-315"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312712463" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.6/@attempts.9/@edit" start="137" end="-1191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313052403" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int totalP = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; cars.size(); i++){&#xA;&#x9;&#x9;&#x9;if(this.cars.get(i) instanceof PassengerCar){&#xA;&#x9;&#x9;&#x9;&#x9;totalP += ((PassengerCar) this.cars.get(i)).getPassengerCount();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalP;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;public int getCargoWeight(){&#xA;&#x9;&#x9;int totalC = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; cars.size(); i++){&#xA;&#x9;&#x9;&#x9;if(this.cars.get(i) instanceof CargoCar){&#xA;&#x9;&#x9;&#x9;&#x9;totalC += ((CargoCar) this.cars.get(i)).getCargoWeight();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalC" edit="/1/@proposals.0/@proposals.6/@attempts.10/@edit" start="874" end="-315"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491315880341" sizeMeasure="68" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String s = &quot;&quot;;&#xA;&#x9;&#x9;for(TrainCar vogn: cars){&#xA;&#x9;&#x9;&#x9;s+= vogn.toString() + &quot;\n&quot;;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return myString" edit="/1/@proposals.0/@proposals.6/@attempts.11/@edit" start="1676" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491315942793" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s" edit="/1/@proposals.0/@proposals.6/@attempts.12/@edit" start="1773" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491316055252" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TrainCar vogn: cars){&#xA;&#x9;&#x9;&#x9;totalW += vogn.getTotalWeight();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalW;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende PassengerCar sin metode, men returnerer antallet for alle vognene.&#xA;&#x9;public int getPassengerCount(){&#xA;&#x9;&#x9;int totalP = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; cars.size(); i++){&#xA;&#x9;&#x9;&#x9;if(this.cars.get(i) instanceof PassengerCar){&#xA;&#x9;&#x9;&#x9;&#x9;totalP += ((PassengerCar) this.cars.get(i)).getPassengerCount();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalP;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;public int getCargoWeight(){&#xA;&#x9;&#x9;int totalC = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; cars.size(); i++){&#xA;&#x9;&#x9;&#x9;if(this.cars.get(i) instanceof CargoCar){&#xA;&#x9;&#x9;&#x9;&#x9;totalC += ((CargoCar) this.cars.get(i)).getCargoWeight();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalC;&#xA;&#x9;}&#xA;&#x9;&#xA;//&#x9;toString-metoden skal sette sammen en String med oversikt over alle vognene som er knyttet til den. For hver vogn skal vogntype og totalvekt være med. Passasjervogner skal i tillegg ha med antall passasjerer og lastevogner skal ha med hvor mye lasten veier.&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;String s = &quot;&quot;;&#xA;&#x9;&#x9;for(TrainCar vogn: cars){&#xA;&#x9;&#x9;&#x9;s+= vogn.toString() + &quot;\n&quot;;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.6/@attempts.13/@edit" start="649" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491316294252" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.6/@attempts.14/@edit" start="301" end="-1444"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491316310714" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.6/@attempts.15/@edit" start="1225" end="-515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491316315908" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.6/@attempts.16/@edit" start="907" end="-828"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491318905965" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.6/@attempts.17/@edit" start="975" end="-755"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491321923367" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.6/@attempts.18/@edit" start="1275" end="-450"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491225107189" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491225117759" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491225537207" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491225712454" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491225768577" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491225985331" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491226240327" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491226297727" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227171100" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227802584" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228195300" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491307803276" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309286020" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311547000" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227482414" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227665262" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227685963" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227806943" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228204084" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229120866" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229256141" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311550741" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491318834437" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.10/@q" answer="/0/@parts.0/@tasks.10/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227488693" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227601645" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227689222" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227745023" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227758843" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227772925" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227794421" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227811117" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227834933" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227942253" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228062980" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228098679" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228106198" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228145528" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228201511" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228222636" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228551592" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228609173" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228663443" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228686958" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228869152" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228911731" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228978173" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311553785" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312582022" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.11/@q" answer="/0/@parts.0/@tasks.11/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227192001" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227445092" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312589931" completion="0.0" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312626009" completion="0.0" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312654254" completion="0.0" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312715008" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313054581" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491315883244" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491315945400" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491316057631" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491316153502" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491316297013" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491316317950" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491316344674" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491318910606" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
