<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491299887771" sizeMeasure="13">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount extends AbstractAccount{&#xA;&#xA;&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Can not withdraw an amount bigger than balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= amount;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491299922764" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491303463969" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#xA;&#x9;private double creditLine;&#xA;&#x9;&#xA;&#x9;public CreditAccount(double creditLine) {&#xA;&#x9;&#x9;setCreditLine(creditLine);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;double balanceWithCreditLine = balance + creditLine;&#xA;&#x9;&#x9;if (amount > balanceWithCreditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can not withdraw amount bigger than balance + creditLine&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= amount;&#xA;&#x9;}&#xA;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;if (! (creditLine > 0)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;creditLine must be a positive number but was &quot; + creditLine);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (balance &lt; 0 &amp;&amp; creditLine &lt; Math.abs(balance)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;creditLine must be bigger than the negative balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491303515269" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="358" end="-528"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491303551196" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491303844929" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#xA;&#x9;private int withdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawals, double fee) {&#xA;&#x9;&#x9;this.withdrawals = withdrawals;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (withdrawals &lt; 1) {&#xA;&#x9;&#x9;&#x9;balance -= withdrawals + fee;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance -= withdrawals;&#xA;&#x9;&#x9;&#x9;withdrawals -= 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="51" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491303957625" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;SavingsAccount2 a = new SavingsAccount2(3, 100);&#xA;&#x9;&#x9;a.deposit(2000);&#xA;&#x9;&#x9;a.withdraw(500);&#xA;&#x9;&#x9;System.out.println(a.getBalance());" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="425" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491303983752" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount + fee;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance -= amount" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="340" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491304233428" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance &lt; amount) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Can not withdraw an amount bigger than balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (withdrawals &lt; 1 &amp;&amp; (amount + fee > balance)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Can not withdraw an amount bigger than balance&quot;);&#xA;&#x9;&#x9;} else if (withdrawals &lt; 1) {&#xA;&#x9;&#x9;&#x9;balance -= amount + fee;&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;withdrawals -= 1;" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="307" end="-182"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1491303957009" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1491303983260" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491299888845" completion="1.0" successCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491303465147" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491303516094" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491303846076" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491303989216" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491304234209" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
