<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="SavingsAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Get the source code for the Account interface from the wiki."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.Account"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the BSU class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.BSU"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the BSU class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.BSU"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ForeldreSpar class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.ForeldreSpar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the ForeldreSpar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.ForeldreSpar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the BSU JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.BSUTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the ForeldreSpar JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.ForeldreSparTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the SavingsAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.SavingsAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the BSU class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.BSU" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the ForeldreSpar class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.ForeldreSpar" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490951311791" sizeMeasure="48">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount implements Account{&#xA;&#x9;&#xA;&#x9;private double balance;&#xA;&#x9;private double interestRate;&#xA;&#x9;&#xA;&#x9;public SavingsAccount(double interestRate) {&#xA;&#x9;&#x9;this.interestRate = interestRate;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Must deposit positive amount, but amount was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance += amount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Must withdrawal positive amount, but amount was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (balance - amount &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Withdrawal bigger than current balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;balance -= amount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return balance;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;double renter = balance * interestRate;&#xA;&#x9;&#x9;balance += renter;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;SavingsAccount a = new SavingsAccount(0.04);&#xA;&#x9;&#x9;a.deposit(1000);&#xA;&#x9;&#x9;a.endYearUpdate();&#xA;&#x9;&#x9;System.out.println(a.getBalance());&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490962518234" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected double balance;&#xA;&#x9;protected double interestRate;&#xA;&#x9;&#xA;&#x9;public SavingsAccount(double interestRate) {&#xA;&#x9;&#x9;this.interestRate = interestRate;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;protected void checkDeposit(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Must deposit positive amount, but amount was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;checkDeposit(amount);&#xA;&#x9;&#x9;balance += amount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;protected void checkWithdrawal(double amount, double balance) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Must withdrawal positive amount, but amount was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (balance - amount &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Withdrawal bigger than current balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;checkWithdrawal(amount, balance);" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="75" end="-362"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490951137880" sizeMeasure="16" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class BSU extends SavingsAccount{&#xA;&#xA;&#x9;private double maxDeposit;&#xA;&#x9;&#xA;&#x9;public BSU(double interestRate, double maxDeposit) {&#xA;&#x9;&#x9;super(interestRate);&#xA;&#x9;&#x9;this.maxDeposit = maxDeposit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490951408651" sizeMeasure="24" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int year;&#xA;&#x9;&#xA;&#x9;public BSU(double interestRate, double maxDeposit) {&#xA;&#x9;&#x9;super(interestRate);&#xA;&#x9;&#x9;this.maxDeposit = maxDeposit;&#xA;&#x9;&#x9;this.year = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;year += 1;" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="93" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490954949428" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;package inheritance;&#xA;&#xA;public class BSU extends SavingsAccount{&#xA;&#xA;&#x9;private double maxDeposit;&#xA;&#x9;private int yearBalance;&#xA;&#x9;&#xA;&#x9;public BSU(double interestRate, double maxDeposit) {&#xA;&#x9;&#x9;super(interestRate);&#xA;&#x9;&#x9;this.maxDeposit = maxDeposit;&#xA;&#x9;&#x9;this.yearBalance = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;return yearBalance * 0.2;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if ((yearBalance + amount) > maxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can not deposit more money than the yearly max&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;yearBalance += amount;&#xA;&#x9;&#x9;super.deposit(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;yearBalance = 0" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490954979370" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="withdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;super.withdraw(amount)" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="351" end="-342"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490955154970" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Must withdrawal positive amount, but amount was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (yearBalance - amount &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Withdrawal bigger than current balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="379" end="-367"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490958837683" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="620" end="-367"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490958892991" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.withdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if ((yearBalance + amount) >=" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="620" end="-256"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490958956229" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" maxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalState" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="728" end="-213"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490959045555" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArgumentException(&quot;Can not deposit more money than the yearly max&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;yearBalance += amount;&#xA;&#x9;&#x9;super.deposit(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;yearBalance = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BSU bsu = new BSU(0.05, 2000);&#xA;&#x9;&#x9;bsu.deposit(2000)" edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="763" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490959057869" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.8/@edit" start="1074" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490959109863" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0);&#xA;&#x9;&#x9;bsu.endYearUpdate();&#xA;&#x9;&#x9;bsu.deposit(1000);&#xA;&#x9;&#x9;System.out.println(bsu.getBalance());" edit="/1/@proposals.0/@proposals.3/@attempts.9/@edit" start="1074" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490959123731" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.10/@edit" start="982" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490959351444" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BSU bsu = new BSU(0.05, 2000);&#xA;&#x9;&#x9;bsu.deposit(2000);&#xA;&#x9;&#x9;bsu.deposit(2000);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.11/@edit" start="982" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490959365724" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="." edit="/1/@proposals.0/@proposals.3/@attempts.12/@edit" start="1075" end="-31"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490959810099" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="yearlyMaxDeposit;&#xA;&#x9;private int yearBalance;&#xA;&#x9;&#xA;&#x9;public BSU(double interestRate, double yearlyMax) {&#xA;&#x9;&#x9;super(interestRate);&#xA;&#x9;&#x9;this.yearlyMaxDeposit = yearlyMax;&#xA;&#x9;&#x9;this.yearBalance = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;return yearBalance * 0.2;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Must withdrawal positive amount, but amount was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (yearBalance - amount &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Withdrawal bigger than current balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.withdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if ((yearBalance + amount) > yearlyMaxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Deposit bigger than yearlyM" edit="/1/@proposals.0/@proposals.3/@attempts.13/@edit" start="81" end="-281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490959932493" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5000);&#xA;&#x9;&#x9;bsu.deposit(10000.0);&#xA;&#x9;&#x9;bsu.deposit(20000." edit="/1/@proposals.0/@proposals.3/@attempts.14/@edit" start="1047" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490960207714" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="." edit="/1/@proposals.0/@proposals.3/@attempts.15/@edit" start="1051" end="-58"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490961973679" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="15" edit="/1/@proposals.0/@proposals.3/@attempts.16/@edit" start="1094" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490961983289" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="6" edit="/1/@proposals.0/@proposals.3/@attempts.17/@edit" start="1095" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490962612882" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="checkWithdrawal(amount, yearBalance);&#xA;&#x9;&#x9;yearBalance -= amount;&#xA;&#x9;&#x9;balance -= amount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;checkDeposit(amount);&#xA;&#x9;&#x9;if ((yearBalance + amount) > yearlyMaxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Deposit bigger than yearlyMax&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;yearBalance += amount;&#xA;&#x9;&#x9;balance += amount" edit="/1/@proposals.0/@proposals.3/@attempts.18/@edit" start="389" end="-230"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490959044867" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490959057150" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490959109082" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490959125340" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490959350741" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490959365239" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490959931946" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490960206995" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490961973148" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490961982726" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490951035548" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class ForeldreSpar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490951137887" sizeMeasure="13" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends SavingsAccount{&#xA;&#xA;&#x9;public ForeldreSpar(double interestRate) {&#xA;&#x9;&#x9;super(interestRate);&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRemainingWithdrawals() {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="48" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490965513828" sizeMeasure="12" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="141" end="-54"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="164" charEnd="189" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490966141826" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate int withdrawals;&#xA;&#x9;private int maxWithdrawals;&#xA;&#x9;&#xA;&#x9;public ForeldreSpar(double interestRate, int maxWithdrawals) {&#xA;&#x9;&#x9;super(interestRate);&#xA;&#x9;&#x9;this.maxWithdrawals = maxWithdrawals;&#xA;&#x9;&#x9;this.withdrawals = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;if (withdrawals > maxWithdrawals) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You don't have any more withdrawals to make this year.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.withdraw(amount);&#xA;&#x9;&#x9;withdrawals++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRemainingWithdrawals() {&#xA;&#x9;&#x9;return maxWithdrawals - withdrawals;" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="75" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490958839562" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testGetTaxDeduction</successTests>
          <successTests>testWithdraw</successTests>
          <failureTests>testDeposit</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490958893955" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testGetTaxDeduction</successTests>
          <successTests>testWithdraw</successTests>
          <failureTests>testDeposit</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490958957393" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testGetTaxDeduction</successTests>
          <successTests>testWithdraw</successTests>
          <failureTests>testDeposit</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490959133863" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testGetTaxDeduction</successTests>
          <successTests>testWithdraw</successTests>
          <failureTests>testDeposit</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490959811516" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testGetTaxDeduction</successTests>
          <successTests>testWithdraw</successTests>
          <failureTests>testDeposit</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490964042291" completion="1.0" successCount="3">
          <successTests>testGetTaxDeduction</successTests>
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="0.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490966147743" completion="0.0" failureCount="2">
          <failureTests>testWithdraw</failureTests>
          <failureTests>testGetRemainingWithdrawals</failureTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
