<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Train">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TrainCar superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.TrainCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TrainCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.TrainCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CargoCar class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CargoCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CargoCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CargoCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the PassengerCar class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.PassengerCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the PassengerCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.PassengerCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the Train class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.Train"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Train class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.Train"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TrainCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.TrainCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PassengerCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.PassengerCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CargoCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CargoCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TrainTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.TrainTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in *Car classes."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Car" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the Train class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.Train" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225842851" sizeMeasure="22" errorCount="1" warningCount="4">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class TrainCar {&#xA;&#x9;private int trainCar;&#xA;&#x9;private int totalWeight;&#xA;&#x9;private int deadWeight;&#xA;&#x9;&#xA;&#x9;TrainCar(int totalWeight) {&#xA;&#x9;&#x9;return totalWeight;&#xA;&#x9;}&#xA;&#x9;private int getTotalWeight(){&#xA;&#x9;&#x9;return totalWeight;&#xA;&#x9;}&#xA;&#x9; private void setDeadWeight(int deadWeight) {&#xA;&#x9;&#x9; this.deadWeight = deadWeight;&#xA;&#x9; }&#xA;&#x9; &#xA;&#x9; private int getDeadWeight(){&#xA;&#x9;&#x9; return deadWeight;&#xA;&#x9; }&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225928127" sizeMeasure="22" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deadWeight) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="136" end="-209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225985768" sizeMeasure="22" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int getTotalWeight(){&#xA;&#x9;&#x9;return totalWeight;&#xA;&#x9;}&#xA;&#x9;void setDeadWeight(int deadWeight) {&#xA;&#x9;&#x9; this.deadWeight = deadWeight;&#xA;&#x9;}&#xA;&#x9; &#xA;&#x9; int getDeadWeight(){&#xA;&#x9;&#x9; return deadWeight;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="157" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226005162" sizeMeasure="22" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="333" end="-334"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226274219" sizeMeasure="22" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.deadWeight = deadWeight;&#xA;&#x9;}&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return totalWeight;&#xA;&#x9;}&#xA;&#x9;void setDeadWeight(int deadWeight) {&#xA;&#x9;&#x9; this.deadWeight = deadWeight;&#xA;&#x9;}&#xA;&#x9; &#xA;&#x9;int getDeadWeight(){&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="152" end="-27"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227167731" sizeMeasure="22" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected static int deadWeight;&#xA;&#x9;&#xA;&#x9;TrainCar(int deadWeight) {&#xA;&#x9;&#x9;TrainCar.deadWeight = deadWeight;&#xA;&#x9;}&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return totalWeight;&#xA;&#x9;}&#xA;&#x9;void setDeadWeight(int deadWeight) {&#xA;&#x9;&#x9; TrainCar" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="98" end="-83"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228195556" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected static int deadWeight;&#xA;&#x9;&#xA;&#x9;TrainCar(int deadWeight) {&#xA;&#x9;&#x9;TrainCar.deadWeight = deadWeight;&#xA;&#x9;}&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return dead" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="49" end="-143"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228307640" sizeMeasure="20" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="181" end="-147"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228382846" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int deadWeight;&#xA;&#x9;&#xA;&#x9;TrainCar(int deadWeight) {&#xA;&#x9;&#x9;this.deadWeight = deadWeight;&#xA;&#x9;}&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;return this.deadWeight;&#xA;&#x9;}&#xA;&#x9;void setDeadWeight(int deadWeight) {&#xA;&#x9;&#x9; this" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="57" end="-83"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225472286" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CargoCar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225842863" sizeMeasure="11" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends TrainCar {&#xA;&#x9;private int cargoWeight;&#xA;&#x9;&#xA;&#x9;CargoCar(int deadWeight, int cargoWeight){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="44" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227167747" sizeMeasure="12" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cargoWeight, int totalWeight){&#xA;&#x9;&#x9;super(deadWeight);&#xA;&#x9;&#x9;this.cargoWeight = cargoWeight;" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="105" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228215666" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deadweight, int cargoWeight){&#xA;&#x9;&#x9;super(deadWeight);&#xA;&#x9;&#x9;this.cargoWeight = cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return cargoWeight;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void setCargoWeight(int cargoWeight){" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="105" end="-45"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228382863" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="W" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="109" end="-218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228506762" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+= dead" edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="303" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228647279" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.5/@edit" start="286" end="-37"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228762826" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int getTotalWeight(){&#xA;&#x9;&#x9;return cargoWeight + deadWeight;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.6/@edit" start="319" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228800641" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.cargoWeight = cargo" edit="/1/@proposals.0/@proposals.2/@attempts.7/@edit" start="286" end="-83"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491225485662" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class PassengerCar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228215681" sizeMeasure="21" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends TrainCar {&#xA;&#x9;private int passengers;&#xA;&#x9;private int passengerWeight;&#xA;&#x9;&#xA;&#x9;PassengerCar(int deadweight, int passengers){&#xA;&#x9;&#x9;super(deadWeight);&#xA;&#x9;&#x9;this.passengers = passengers;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;return passengers;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void setPassengerCount(int passengers){&#xA;&#x9;&#x9;this.passengers = passengers;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="48" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229119262" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;PassengerCar(int deadW" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="93" end="-217"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229233025" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;int getTotalWeight() {&#xA;&#x9;&#x9;return deadWeight + (80 * this.passengers);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="327" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229245141" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="9" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="376" end="-27"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229254283" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="376" end="-26"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229335320" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class Train {&#xA;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491225845744" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491225929274" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491226013730" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491226275081" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227169302" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228217616" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229120445" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229234180" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229246202" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229255313" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.10/@q" answer="/0/@parts.0/@tasks.10/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228247332" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228264296" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228310912" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228384538" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228405311" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228509511" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228648443" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228765528" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228803436" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491228941438" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.11/@q" answer="/0/@parts.0/@tasks.11/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
