<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="ObservableList">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract ObservableList superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableListListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableListListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableHighscoreList class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableHighscoreList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the ObservableHighscoreList class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.ObservableHighscoreList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableHighscoreListProgram class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableHighscoreListProgram"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the ObservableHighscoreListProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.ObservableHighscoreListProgram"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the ObservableHighscoreList JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.ObservableHighscoreListTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the ObservableList JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.ObservableListTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.Observable*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183573194" sizeMeasure="43" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;&#xA;public abstract class ObservableList {&#xA;&#x9;&#xA;&#xA;&#x9;private List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;&#x9;private Collection&lt;Object> elements;&#xA;&#x9;&#xA;&#x9;public int size(){&#xA;&#x9;&#x9;return this.elements.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Object getElement(int index){ return this.elements.get(index); }&#xA;&#x9;&#xA;&#x9;public abstract boolean acceptsElement(Object object){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;protected void addElement(int index, Object i){&#xA;&#x9;&#x9;/*legger til et element på posisjonen angitt av argumentet, men bare dersom det aksepteres som element. &#xA;&#x9;&#x9; * Dersom elementet ikke aksepteres, så skal IllegalArgumentException utløses. &#xA;&#x9;&#x9; * Dersom posisjonen er ulovlig så skal IndexOutOfBoundsException utløses.&#xA;&#x9;&#x9; */&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object i){&#xA;&#x9;&#x9;/*legger til et element bakerst i lista, men bare dersom det aksepteres som element.&#xA;&#x9;&#x9; *  Dersom elementet ikke aksepteres, så skal IllegalArgumentException utløses.&#xA;&#x9;&#x9; */&#xA;&#x9;}&#xA;&#x9;protected void removeElemet(int index) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void addObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;this.listeners.add(listener);&#xA;&#x9;}&#xA;&#x9;public void removeObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;this.listeners.remove(listener);&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="393" charEnd="396" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="436" charEnd="465" severity="2" problemCategory="50" problemType="603979889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183591263" sizeMeasure="41" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="447" end="-816"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="464" charEnd="465" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="393" charEnd="396" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="436" charEnd="465" severity="2" problemCategory="50" problemType="603979889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183734591" sizeMeasure="41" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="447" end="-816"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="393" charEnd="396" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490185269004" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Object> elements = new ArrayList&lt;Object>();&#xA;&#x9;&#xA;&#x9;public int size(){&#xA;&#x9;&#x9;return this.elements.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Object getElement(int index){ return elements.get(index); }&#xA;&#x9;&#xA;&#x9;public abstract boolean acceptsElement(Object object);&#xA;&#x9;&#xA;&#x9;protected void addElement(int index, Object i){&#xA;&#x9;&#x9;/*legger til et element på posisjonen angitt av argumentet, men bare dersom det aksepteres som element. &#xA;&#x9;&#x9; * Dersom elementet ikke aksepteres, så skal IllegalArgumentException utløses. &#xA;&#x9;&#x9; * Dersom posisjonen er ulovlig så skal IndexOutOfBoundsException utløses.&#xA;&#x9;&#x9; */&#xA;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(this, index);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object i){&#xA;&#x9;&#x9;/*legger til et element bakerst i lista, men bare dersom det aksepteres som element.&#xA;&#x9;&#x9; *  Dersom elementet ikke aksepteres, så skal IllegalArgumentException utløses.&#xA;&#x9;&#x9; */&#xA;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(this, this.size());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;protected void removeElement(int index) {&#xA;&#x9;&#x9;if (this.size()&lt;index){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.remove(index);" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="231" end="-229"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="68" charEnd="88" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490185731122" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;&#xA;public abstract class ObservableList {&#xA;&#x9;&#xA;&#xA;&#x9;private List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;&#x9;private List&lt;Object> elements = new ArrayList&lt;Object>();&#xA;&#x9;&#xA;&#x9;public int size(){&#xA;&#x9;&#x9;return this.elements.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Object getElement(int index){ return elements.get(index); }&#xA;&#x9;&#xA;&#x9;public abstract boolean acceptsElement(Object object);&#xA;&#x9;&#xA;&#x9;protected void addElement(int index, Object object){&#xA;&#x9;&#x9;/*legger til et element på posisjonen angitt av argumentet, men bare dersom det aksepteres som element. &#xA;&#x9;&#x9; * Dersom elementet ikke aksepteres, så skal IllegalArgumentException utløses. &#xA;&#x9;&#x9; * Dersom posisjonen er ulovlig så skal IndexOutOfBoundsException utløses.&#xA;&#x9;&#x9; */&#xA;&#x9;&#x9;if (!this.acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(index, object);&#xA;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(this, index);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;/*legger til et element bakerst i lista, men bare dersom det aksepteres som element.&#xA;&#x9;&#x9; *  Dersom elementet ikke aksepteres, så skal IllegalArgumentException utløses.&#xA;&#x9;&#x9; */&#xA;&#x9;&#x9;if (!this.acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="75" end="-473"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490185882145" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else if (index > (this.size()-1)) {&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBounds" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="844" end="-941"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490186546248" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index + &quot; &quot; + object" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="920" end="-931"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490186619282" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//} else if (index > (this.size())) {&#xA;&#x9;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="843" end="-987"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187422843" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/} else if (index > (this.size())) {&#xA;&#x9;&#x9;&#x9;//throw new IndexOutOfBoundsException(index + &quot; &quot; + object);&#xA;&#x9;&#x9;elements.add(index, object);&#xA;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(this, index);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="494" end="-497"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187538348" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!this.acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="493" end="-772"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187564409" sizeMeasure="52" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!this.acceptsElement(objec)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="850" end="-497"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="906" charEnd="911" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187579185" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="t" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="880" end="-545"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490188267102" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(elements);&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!this.acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(this, this.size());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(elements);" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="803" end="-373"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490188703254" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="823" end="-659"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189449622" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//System.out.println(index);&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!this.acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(this, this.size());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="804" end="-402"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189475056" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(index);&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!this.acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(this, this.size());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="804" end="-402"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490190389145" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!this.acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(this, this.size());&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="803" end="-373"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490190484004" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1047" end="-379"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490177428368" sizeMeasure="7">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface ObservableListListener {&#xA;&#xA;&#x9;public void listChanged(ObservableList observableHighscoreList, int indexChange);&#xA;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490178514108" sizeMeasure="48">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class ObservableHighscoreList extends ObservableList {&#xA;&#xA;&#xA;&#x9;private List&lt;Integer> liste;&#xA;&#x9;private List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;&#x9;private int maxSize;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public ObservableHighscoreList(int maxSize){&#xA;&#x9;&#x9;this.liste = new ArrayList&lt;Integer>(maxSize);&#xA;&#x9;&#x9;this.maxSize = maxSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addResult(int result){&#xA;&#x9;&#x9;boolean changed = false;&#xA;&#x9;&#x9;int indexChange = 0;&#xA;&#x9;&#x9;if (this.liste.size()&lt;this.maxSize){&#xA;&#x9;&#x9;&#x9;this.liste.add(result);&#xA;&#x9;&#x9;&#x9;Collections.sort(liste);&#xA;&#x9;&#x9;&#x9;indexChange = this.liste.indexOf(result);&#xA;&#x9;&#x9;&#x9;changed = true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;for (int i= 0; i&lt;this.liste.size();i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (result&lt;this.liste.get(i)&amp;&amp;!changed){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.liste.add(i,result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;changed = true;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;indexChange = i;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.liste.remove(this.liste.size()-1);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (changed){&#xA;&#x9;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;&#x9;listener.listChanged(this, indexChange);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;}&#xA;&#xA;&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490182628906" sizeMeasure="45" errorCount="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="175" end="-763"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="266" charEnd="271" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="442" charEnd="447" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="479" charEnd="484" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="519" charEnd="524" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="550" charEnd="555" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="633" charEnd="638" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="673" charEnd="678" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="709" charEnd="714" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="786" charEnd="791" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="804" charEnd="809" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="898" charEnd="907" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183531440" sizeMeasure="50" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class ObservableHighscoreList extends ObservableList {&#xA;&#xA;&#x9;private int maxSize;&#xA;&#x9;private List&lt;Integer> liste;&#xA;&#x9;&#xA;&#x9;public ObservableHighscoreList(int maxSize){&#xA;&#x9;&#x9;this.maxSize = maxSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addResult(int result){&#xA;&#x9;&#x9;boolean changed = false;&#xA;&#x9;&#x9;int indexChange = 0;&#xA;&#x9;&#x9;if (this.liste.size()&lt;this.maxSize){&#xA;&#x9;&#x9;&#x9;this.liste.add(result);&#xA;&#x9;&#x9;&#x9;Collections.sort(liste);&#xA;&#x9;&#x9;&#x9;indexChange = this.liste.indexOf(result);&#xA;&#x9;&#x9;&#x9;changed = true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;for (int i= 0; i&lt;this.liste.size();i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (result&lt;this.liste.get(i)&amp;&amp;!changed){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.liste.add(i,result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;changed = true;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;indexChange = i;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.liste.remove(this.liste.size()-1);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (changed){&#xA;&#x9;&#x9;&#x9;for (ObservableListListener listener: listeners){&#xA;&#x9;&#x9;&#x9;&#x9;listener.listChanged(this, indexChange);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean acceptsElement(Object object) {&#xA;&#x9;&#x9;return (object instanceof Integer);" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="85" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1011" charEnd="1040" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="907" charEnd="916" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183581070" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="1046" end="-1047"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="907" charEnd="916" severity="2" problemCategory="50" problemType="33554503"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183864138" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="415" end="-628"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="903" charEnd="912" severity="2" problemCategory="50" problemType="33554503"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490185215919" sizeMeasure="44" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public ObservableHighscoreList(int maxSize){&#xA;&#x9;&#x9;this.maxSize = maxSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addResult(int result){&#xA;&#x9;&#x9;boolean changed = false;&#xA;&#x9;&#x9;int indexChange;&#xA;&#x9;&#x9;for (int i= 0; i&lt;this.maxSize;i++){&#xA;&#x9;&#x9;&#x9;if ((super.size()&lt;this.maxSize) &amp;&amp; !changed){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;&#x9;indexChange = i;&#xA;&#x9;&#x9;&#x9;&#x9;changed = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if ((result&lt;(int)super.getElement(i)) &amp;&amp; !changed){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;changed = true;&#xA;&#x9;&#x9;&#x9;&#x9;indexChange = i;&#xA;&#x9;&#x9;&#x9;&#x9;super.removeElement(super.size()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="227" end="-120"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="722" charEnd="735" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="775" charEnd="776" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="804" charEnd="811" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="827" charEnd="833" severity="2" problemCategory="20" problemType="1610612972"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="840" charEnd="841" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="890" charEnd="891" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490185252450" sizeMeasure="44" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.5/@edit" start="853" end="-854"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="775" charEnd="776" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="804" charEnd="811" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="827" charEnd="833" severity="2" problemCategory="20" problemType="1610612972"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="840" charEnd="841" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="890" charEnd="891" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490185376402" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class ObservableHighscoreList extends ObservableList {&#xA;&#xA;&#x9;private int maxSize;&#xA;&#x9;&#xA;&#x9;public ObservableHighscoreList(int maxSize){&#xA;&#x9;&#x9;this.maxSize = maxSize;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addResult(int result){&#xA;&#x9;&#x9;boolean changed = false;&#xA;&#x9;&#x9;for (int i= 0; i&lt;this.maxSize;i++){&#xA;&#x9;&#x9;&#x9;if ((super.size()&lt;this.maxSize) &amp;&amp; !changed){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if ((result&lt;(int)super.getElement(i)) &amp;&amp; !changed){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;changed = true;&#xA;&#x9;&#x9;&#x9;&#x9;super.removeElement(super.size()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.6/@edit" start="30" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490185501428" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (int i= 0; i&lt;this.maxSize;i++){&#xA;&#x9;&#x9;&#x9;if (super.size()&lt;this.maxSize){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (result&lt;(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;super.removeElement(super.size()-1);&#xA;&#x9;&#x9;&#x9;&#x9;break" edit="/1/@proposals.0/@proposals.2/@attempts.7/@edit" start="232" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490186329124" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(i&lt;this.maxSize) &amp;&amp; ((int)super.size()-1==i)" edit="/1/@proposals.0/@proposals.2/@attempts.8/@edit" start="275" end="-287"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490186808760" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (super.size()==0){&#xA;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i= 0; i&lt;this.maxSize;i++){&#xA;&#x9;&#x9;&#x9;if ((i&lt;this.maxSize) &amp;&amp; ((int)super.size()" edit="/1/@proposals.0/@proposals.2/@attempts.9/@edit" start="232" end="-291"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187422827" sizeMeasure="36" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!this.acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;if (super.size()==0){&#xA;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i= 0; i&lt;this.maxSize;i++){&#xA;&#x9;&#x9;&#x9;if ((i&lt;this.maxSize) &amp;&amp; ((int)super.size()==i)){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (result&lt;(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;super.removeElement(super.size()-1);&#xA;&#x9;&#x9;&#x9;&#x9;return" edit="/1/@proposals.0/@proposals.2/@attempts.10/@edit" start="236" end="-109"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="268" charEnd="274" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="679" charEnd="680" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187465566" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="resul" edit="/1/@proposals.0/@proposals.2/@attempts.11/@edit" start="257" end="-490"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="679" charEnd="680" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187495278" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}" edit="/1/@proposals.0/@proposals.2/@attempts.12/@edit" start="310" end="-445"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490187564378" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.13/@edit" start="236" end="-445"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490188702085" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.size()==0){&#xA;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i= 0; i&lt;this.maxSize;i++){&#xA;&#x9;&#x9;&#x9;if (((int)super.size()==i)){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (result&lt;(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if ((int)super.size()==maxSize)&#xA;&#x9;&#x9;super.removeElement(super.size()-1);" edit="/1/@proposals.0/@proposals.2/@attempts.14/@edit" start="236" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490188884527" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="result&lt;(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if ((int)super.size()==i){&#xA;&#x9;&#x9;&#x9;&#x9;super.addElement(" edit="/1/@proposals.0/@proposals.2/@attempts.15/@edit" start="343" end="-200"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189384183" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="} else if (maxSize>super.size()){&#xA;&#x9;&#x9;&#x9;for (int i=0; i&lt;super.size();i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (result&lt;(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (i==(int)super.size()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.16/@edit" start="285" end="-176"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189449605" sizeMeasure="39" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (int i=0; i&lt;super.size();i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (result&lt;(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;" edit="/1/@proposals.0/@proposals.2/@attempts.17/@edit" start="553" end="-176"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="781" charEnd="782" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="781" charEnd="782" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="781" charEnd="782" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189464035" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.18/@edit" start="678" end="-176"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189495413" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;super.removeElement(super.size()-1);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.19/@edit" start="724" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189771759" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (i==(int)super.size()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;for (int i=0; i&lt;super.size();i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (result&lt;(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if ((int)super.size()==maxSize){&#xA;&#x9;&#x9;super.removeElement(super.size()-1);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.20/@edit" start="372" end="-99"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="796" charEnd="797" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189858687" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}" edit="/1/@proposals.0/@proposals.2/@attempts.21/@edit" start="768" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490189912496" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (i==(int)super.size()" edit="/1/@proposals.0/@proposals.2/@attempts.22/@edit" start="372" end="-385"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490190101688" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;for (int i=0; i&lt;super.size();i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (result&lt;(int)super.getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.addElement(i, result);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if ((int)super.size()>" edit="/1/@proposals.0/@proposals.2/@attempts.23/@edit" start="480" end="-151"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490190389129" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.24/@edit" start="727" end="-141"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490177449493" sizeMeasure="41" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.Scanner;&#xA;&#xA;public class ObservableHighscoreListProgram implements ObservableListListener{&#xA;&#xA;&#x9;private ObservableHighscoreList highscoreList;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void init(){&#xA;&#x9;highscoreList = new ObservableHighscoreList(5);&#xA;&#x9;highscoreList.addObservableListListener(this);&#xA;&#x9;}&#xA;&#x9;public void run(){&#xA;&#x9;&#x9;Scanner result = new Scanner(System.in);&#xA;&#x9;&#x9;System.out.print(&quot;Give result: &quot;);&#xA;&#x9;&#x9;while (result.hasNextInt()) {&#xA;&#x9;&#x9;&#x9;highscoreList.addResult(result.nextInt());&#xA;&#x9;&#x9;&#x9;System.out.println();&#xA;&#x9;&#x9;&#x9;System.out.print(&quot;Give result: &quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;result.close();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;HighscoreListProgram ez = new HighscoreListProgram();&#xA;&#x9;&#x9;ez.init();&#xA;&#x9;&#x9;ez.run();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void listChanged(ObservableList list, int index) {&#xA;&#x9;&#x9;System.out.println(&quot;ny på &quot; + Integer.valueOf(index+1) + &quot;. plass, listen ser nå slik ut: &quot;);&#xA;&#x9;&#x9;for (int i = 0; i&lt;list.size(); i++){&#xA;&#x9;&#x9;&#x9;System.out.print(list.getElement(i) + &quot; &quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="930" charEnd="934" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="35" charStart="970" charEnd="980" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490177818518" sizeMeasure="41" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="observableHighscoreList, int index) {&#xA;&#x9;&#x9;System.out.println(&quot;ny på &quot; + Integer.valueOf(index+1) + &quot;. plass, listen ser nå slik ut: &quot;);&#xA;&#x9;&#x9;for (int i = 0; i&lt;observableHighscoreList.size(); i++){&#xA;&#x9;&#x9;&#x9;System.out.print(observableHighscoreL" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="757" end="-64"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="968" charEnd="972" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="35" charStart="1027" charEnd="1037" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490190064594" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ObservableHighscoreListProgram ez = new Observable" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="622" end="-401"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490190568661" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="program = new ObservableHighscoreListProgram();&#xA;&#x9;&#x9;program.init();&#xA;&#x9;&#x9;program" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="653" end="-360"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490186837602" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490189609052" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490189664426" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490189771743" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490189859650" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490189912449" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490190152189" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490190389107" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490190514036" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490177861556" completion="1.0" successCount="7">
          <successTests>testAddElementSimple</successTests>
          <successTests>testAddElementDuplicate</successTests>
          <successTests>testListListenerSimple</successTests>
          <successTests>testListListenerDuplicate</successTests>
          <successTests>testAddElementMoreThanMax</successTests>
          <successTests>testListListenerMoreThanMax</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490186683794" completion="0.14285714285714285" successCount="1" errorCount="6">
          <successTests>testConstructor</successTests>
          <errorTests>testAddElementSimple</errorTests>
          <errorTests>testAddElementDuplicate</errorTests>
          <errorTests>testListListenerSimple</errorTests>
          <errorTests>testListListenerDuplicate</errorTests>
          <errorTests>testAddElementMoreThanMax</errorTests>
          <errorTests>testListListenerMoreThanMax</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490186809076" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490186909078" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490188271581" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490188703570" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490188884849" completion="0.14285714285714285" successCount="1" failureCount="1" errorCount="5">
          <successTests>testConstructor</successTests>
          <failureTests>testListListenerSimple</failureTests>
          <errorTests>testAddElementSimple</errorTests>
          <errorTests>testAddElementDuplicate</errorTests>
          <errorTests>testListListenerDuplicate</errorTests>
          <errorTests>testAddElementMoreThanMax</errorTests>
          <errorTests>testListListenerMoreThanMax</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490189384467" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490189449959" completion="0.14285714285714285" successCount="1" errorCount="6">
          <successTests>testConstructor</successTests>
          <errorTests>testAddElementSimple</errorTests>
          <errorTests>testAddElementDuplicate</errorTests>
          <errorTests>testListListenerSimple</errorTests>
          <errorTests>testListListenerDuplicate</errorTests>
          <errorTests>testAddElementMoreThanMax</errorTests>
          <errorTests>testListListenerMoreThanMax</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490189464382" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490189475380" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490189495745" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490189921343" completion="0.14285714285714285" successCount="1" failureCount="6">
          <successTests>testConstructor</successTests>
          <failureTests>testAddElementSimple</failureTests>
          <failureTests>testAddElementDuplicate</failureTests>
          <failureTests>testListListenerSimple</failureTests>
          <failureTests>testListListenerDuplicate</failureTests>
          <failureTests>testAddElementMoreThanMax</failureTests>
          <failureTests>testListListenerMoreThanMax</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490190102088" completion="0.8571428571428571" successCount="6" failureCount="1">
          <successTests>testAddElementSimple</successTests>
          <successTests>testAddElementDuplicate</successTests>
          <successTests>testListListenerDuplicate</successTests>
          <successTests>testAddElementMoreThanMax</successTests>
          <successTests>testListListenerMoreThanMax</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testListListenerSimple</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490190491033" completion="1.0" successCount="7">
          <successTests>testAddElementSimple</successTests>
          <successTests>testAddElementDuplicate</successTests>
          <successTests>testListListenerSimple</successTests>
          <successTests>testListListenerDuplicate</successTests>
          <successTests>testAddElementMoreThanMax</successTests>
          <successTests>testListListenerMoreThanMax</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490186382872" completion="0.75" successCount="3" errorCount="1">
          <successTests>testAddElement</successTests>
          <successTests>testAcceptsElement</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testListListener</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490186546571" completion="0.75" successCount="3" errorCount="1">
          <successTests>testAddElement</successTests>
          <successTests>testAcceptsElement</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testListListener</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490186619598" completion="1.0" successCount="4">
          <successTests>testListListener</successTests>
          <successTests>testAddElement</successTests>
          <successTests>testAcceptsElement</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490186824776" completion="1.0" successCount="4">
          <successTests>testListListener</successTests>
          <successTests>testAddElement</successTests>
          <successTests>testAcceptsElement</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490187423240" completion="0.75" successCount="3" failureCount="1">
          <successTests>testListListener</successTests>
          <successTests>testAddElement</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testAcceptsElement</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490187465898" completion="0.75" successCount="3" failureCount="1">
          <successTests>testListListener</successTests>
          <successTests>testAddElement</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testAcceptsElement</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490187538649" completion="0.75" successCount="3" failureCount="1">
          <successTests>testListListener</successTests>
          <successTests>testAddElement</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testAcceptsElement</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490187564726" completion="0.5" successCount="2" errorCount="2">
          <successTests>testListListener</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testAddElement</errorTests>
          <errorTests>testAcceptsElement</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490187579502" completion="1.0" successCount="4">
          <successTests>testListListener</successTests>
          <successTests>testAddElement</successTests>
          <successTests>testAcceptsElement</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490190495735" completion="1.0" successCount="4">
          <successTests>testListListener</successTests>
          <successTests>testAddElement</successTests>
          <successTests>testAcceptsElement</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
