<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309020242" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class AbstractAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309025057" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="abstract class AbstractAccount {&#xA;    private double balance;&#xA;&#xA;    public AbstractAccount() {&#xA;        this.balance = 0;&#xA;    }&#xA;&#xA;    public void deposit(double amount) {&#xA;        if (amount > 0)&#xA;            this.balance += amount;&#xA;        else&#xA;            throw new IllegalArgumentException(&quot;Illegal amount&quot;);&#xA;    }&#xA;&#xA;    public void withdraw(double amount) {&#xA;        if (amount &lt; 0)&#xA;            throw new IllegalArgumentException(&quot;Illegal amount&quot;);&#xA;        else {&#xA;            internalWithdraw(amount);&#xA;            this.balance -= amount;&#xA;        }&#xA;    }&#xA;&#xA;    abstract void internalWithdraw(double amount);&#xA;&#xA;    public double getBalance() {&#xA;        return this.balance;&#xA;    }" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="29" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309759179" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="68" end="-630"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310476987" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="66" end="-630"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373370305" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double balance;&#xA;&#xA;    public AbstractAccount() {&#xA;        this.balance " edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="66" end="-559"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="133" charEnd="140" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373373606" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="135" end="-559"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373379548" sizeMeasure="31" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="603" end="-92"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="629" charEnd="647" severity="2" problemCategory="40" problemType="16777327"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="629" charEnd="647" severity="2" problemCategory="50" problemType="603979883"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="513" charEnd="529" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="615" charEnd="628" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="615" charEnd="628" severity="2" problemCategory="50" problemType="33554774"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="615" charEnd="628" severity="2" problemCategory="60" problemType="536870964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373381314" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="603" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373382910" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="602" end="-92"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="513" charEnd="529" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373384376" sizeMeasure="31" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="d " edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="602" end="-92"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="629" charEnd="647" severity="2" problemCategory="40" problemType="16777327"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="629" charEnd="647" severity="2" problemCategory="50" problemType="603979883"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="513" charEnd="529" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="615" charEnd="628" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="615" charEnd="628" severity="2" problemCategory="50" problemType="33554774"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="615" charEnd="628" severity="2" problemCategory="60" problemType="536870964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373394837" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="603" end="-92"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309122496" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309125809" sizeMeasure="31" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CreditAccount extends AbstractAccount {&#xA;    private double creditLine;&#xA;&#xA;    public CreditAccount(double limit) {&#xA;        super();&#xA;        if (limit &lt; 0)&#xA;            throw new IllegalArgumentException(&quot;Creditline cannot be less than 0&quot;);&#xA;        else&#xA;            this.creditLine = limit;&#xA;    }&#xA;&#xA;    public double getCreditLine() {&#xA;        return creditLine;&#xA;    }&#xA;&#xA;    public void setCreditLine(double creditLine) {&#xA;        if (creditLine &lt; 0)&#xA;            throw new IllegalArgumentException(&quot;Creditline cannot be less than 0&quot;);&#xA;        else if (creditLine &lt; super.getBalance()*-1)&#xA;            throw new IllegalStateException(&quot;Cannot set limit lower than current credit&quot;);&#xA;        else&#xA;            this.creditLine = creditLine;&#xA;    }&#xA;&#xA;    protected void internalWithdraw(double amount) {&#xA;        if (amount > (this.creditLine + super.getBalance()))&#xA;            throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;    }" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="35" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="50" severity="2" problemCategory="40" problemType="16777541"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="-1" charStart="37" charEnd="50" severity="2" problemCategory="-1" problemType="-1"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309168806" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="DebitAccount extends AbstractAccount {&#xA;&#xA;    public DebitAccount() {&#xA;        super();&#xA;    }&#xA;&#xA;    protected void internalWithdraw(double amount) {&#xA;        if (super.getBalance()&lt;amount" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="35" end="-76"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310222324" sizeMeasure="13" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="292" end="-293"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="49" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373499941" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="262" end="-31"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373501866" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="262" end="-31"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309051323" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309093445" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount {&#xA;    private double creditLine;&#xA;&#xA;    public CreditAccount(double limit) {&#xA;        super();&#xA;        if (limit &lt; 0)&#xA;            throw new IllegalArgumentException(&quot;Creditline cannot be less than 0&quot;);&#xA;        else&#xA;            this.creditLine = limit;&#xA;    }&#xA;&#xA;    public double getCreditLine() {&#xA;        return creditLine;&#xA;    }&#xA;&#xA;    public void setCreditLine(double creditLine) {&#xA;        if (creditLine &lt; 0)&#xA;            throw new IllegalArgumentException(&quot;Creditline cannot be less than 0&quot;);&#xA;        else if (creditLine &lt; super.getBalance()*-1)&#xA;            throw new IllegalStateException(&quot;Cannot set limit lower than current credit&quot;);&#xA;        else&#xA;            this.creditLine = creditLine;&#xA;    }&#xA;&#xA;    protected void internalWithdraw(double amount) {&#xA;        if (amount > (this.creditLine + super.getBalance()))&#xA;            throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;    }" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310205657" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="955" end="-956"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="50" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373493131" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="234" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373494944" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="234" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373509449" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="234" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373510329" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="234" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373511221" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="234" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373513011" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="956" end="-957"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373513834" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.8/@edit" start="234" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373514741" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.3/@attempts.9/@edit" start="234" end="-722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373515600" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.10/@edit" start="234" end="-722"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309260535" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309280056" sizeMeasure="20" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount {&#xA;    private int withdrawalLimit, currentWithdrawals;&#xA;    private double fee;&#xA;&#xA;    public SavingsAccount2(int limit, double fee) {&#xA;        super();&#xA;        this.withdrawalLimit = limit;&#xA;        this.fee = fee;&#xA;        this.currentWithdrawals = 0;&#xA;    }&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;        if (amount > super.getBalance())&#xA;            throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;        else if (currentWithdrawals >= withdrawalLimit)&#xA;            System.out.println(&quot;Remove fee from balance&quot;); //@todo&#xA;    }" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="51" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="153" charEnd="156" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309732119" sizeMeasure="20" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="617" end="-618"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="153" charEnd="156" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309764776" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;        &#x9;this.balance -= fee;" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="600" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309886735" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;            throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;        }&#xA;        else if (currentWithdrawals >= withdrawalLimit) {&#xA;        &#x9;this.balance -= fee;&#xA;        }" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="420" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310629269" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + currentWithdrawals" edit="/1/@proposals.0/@proposals.5/@attempts.4/@edit" start="584" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310668929" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;        &#x9;this.balance -=" edit="/1/@proposals.0/@proposals.5/@attempts.5/@edit" start="584" end="-40"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310712051" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(fee + currentWithdrawals)" edit="/1/@proposals.0/@proposals.5/@attempts.6/@edit" start="581" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310786975" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fee" edit="/1/@proposals.0/@proposals.5/@attempts.7/@edit" start="581" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310795632" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= balance -" edit="/1/@proposals.0/@proposals.5/@attempts.8/@edit" start="578" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310823965" sizeMeasure="22" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="50" edit="/1/@proposals.0/@proposals.5/@attempts.9/@edit" start="283" end="-331"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="290" charEnd="295" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310828413" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="50" edit="/1/@proposals.0/@proposals.5/@attempts.10/@edit" start="281" end="-330"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310846492" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fee" edit="/1/@proposals.0/@proposals.5/@attempts.11/@edit" start="281" end="-330"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310886099" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.12/@edit" start="535" end="-78"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311120555" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.5/@attempts.13/@edit" start="579" end="-34"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311561265" sizeMeasure="31" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (getBalance() &lt; amount) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Du kan ikke ta ut mer enn du har pÃ¥ denne typen konto.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (allowedWithdrawals > 0){&#xA;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;allowedWithdrawals -= 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ((amount + fee) &lt; getBalance()) {&#xA;&#x9;&#x9;&#x9;super.balance -= (amount+fee);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Gebyret knyttet til ditt uttak gjÃ¸r at du ikke har nok penger til Ã¥ ta ut denne mengden.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.5/@attempts.14/@edit" start="330" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="96" charEnd="111" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="113" charEnd="131" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="549" charEnd="567" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="607" charEnd="625" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311577328" sizeMeasure="31" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="withdrawalLimit > 0){&#xA;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;withdrawalLimit" edit="/1/@proposals.0/@proposals.5/@attempts.15/@edit" start="532" end="-243"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="113" charEnd="131" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311712407" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;    private double fee;&#xA;&#xA;    public SavingsAccount2(int limit, double fee) {&#xA;        super();&#xA;        this.withdrawalLimit = limit;&#xA;        this.fee = fee" edit="/1/@proposals.0/@proposals.5/@attempts.16/@edit" start="108" end="-522"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311785037" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private int allowedWithdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int aW, double fee) {&#xA;&#x9;&#x9;allowedWithdrawals = aW;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (getBalance() &lt; amount) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Du kan ikke ta ut mer enn du har pÃ¥ denne typen konto.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (allowedWithdrawals > 0){&#xA;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;allowedWithdrawals" edit="/1/@proposals.0/@proposals.5/@attempts.17/@edit" start="77" end="-243"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311875412" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    private int withdrawalLimit, currentWithdrawals;&#xA;    private double fee;&#xA;&#xA;    public SavingsAccount2(int limit, double fee) {&#xA;        super();&#xA;        this.withdrawalLimit = limit;&#xA;        this.fee = fee;&#xA;        this.currentWithdrawals = 0;&#xA;    }&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;        if (amount > super.getBalance())&#xA;            throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;        else if (currentWithdrawals >= withdrawalLimit)&#xA;            super.balance -= (amount + fee);&#xA;    }" edit="/1/@proposals.0/@proposals.5/@attempts.18/@edit" start="77" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311944168" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    else if ((amount + fee) &lt; getBalance()) {&#xA;&#x9;&#x9;&#x9;super.balance -= (amount+fee);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Gebyret knyttet til ditt uttak gjÃ¸r at du ikke har nok penger til Ã¥ ta ut denne mengden.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.19/@edit" start="591" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311966736" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private int allowedWithdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int aW, double fee) {&#xA;&#x9;&#x9;allowedWithdrawals = aW;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (getBalance() &lt; amount) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Du kan ikke ta ut mer enn du har pÃ¥ denne typen konto.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (allowedWithdrawals > 0){&#xA;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;allowedWithdrawals -= 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if ((amount + fee) &lt; getBalance()) {&#xA;&#x9;&#x9;&#x9;super.balance -= (amount+fee);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Gebyret knyttet til ditt uttak gjÃ¸r at du ikke har nok penger til Ã¥ ta ut denne mengden.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.5/@attempts.20/@edit" start="77" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491311978369" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    private int withdrawalLimit, currentWithdrawals;&#xA;    private double fee;&#xA;&#xA;    public SavingsAccount2(int limit, double fee) {&#xA;        super();&#xA;        this.withdrawalLimit = limit;&#xA;        this.fee = fee;&#xA;        this.currentWithdrawals = 0;&#xA;    }&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;        if (amount > super.getBalance())&#xA;            throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;        else if (currentWithdrawals >= withdrawalLimit)&#xA;            super.balance -= (amount + fee);&#xA;        else if ((amount + fee) &lt; getBalance()) {&#xA;&#x9;&#x9;&#x9;super.balance -= (amount+fee);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Gebyret knyttet til ditt uttak gjÃ¸r at du ikke har nok penger til Ã¥ ta ut denne mengden.&quot;);&#xA;&#x9;&#x9;}&#xA;    }" edit="/1/@proposals.0/@proposals.5/@attempts.21/@edit" start="77" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312023287" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Not enough funds" edit="/1/@proposals.0/@proposals.5/@attempts.22/@edit" start="720" end="-17"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312037624" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + " edit="/1/@proposals.0/@proposals.5/@attempts.23/@edit" start="664" end="-88"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312080415" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(currentWithdrawals >= withdrawalLimit) &amp;&amp; ((amount + fee) &lt; getBalance())" edit="/1/@proposals.0/@proposals.5/@attempts.24/@edit" start="503" end="-215"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312101202" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount" edit="/1/@proposals.0/@proposals.5/@attempts.25/@edit" start="547" end="-231"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312156245" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(amount + fee) &lt; getBalance()))&#xA;            super.balance -= (amount + fee);&#xA;        else if ((currentWithdrawals &lt; withdrawalLimit) &amp;&amp; (amount &lt; getBalance())) {&#xA;&#x9;&#x9;&#x9;super.balance -= amount" edit="/1/@proposals.0/@proposals.5/@attempts.26/@edit" start="547" end="-84"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312204460" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.getBalance()))&#xA;            super.balance -= (amount + fee);&#xA;        else if ((currentWithdrawals &lt; withdrawalLimit) &amp;&amp; (amount &lt; super." edit="/1/@proposals.0/@proposals.5/@attempts.27/@edit" start="564" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312250834" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="currentWithdrawals &lt; withdrawalLimit" edit="/1/@proposals.0/@proposals.5/@attempts.28/@edit" start="647" end="-114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312272147" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" withdrawalLimit) &amp;&amp; ((amount + fee) &lt; super.getBalance()))&#xA;            super.balance -= (amount + fee);&#xA;        else if (currentWithdrawals &lt;=" edit="/1/@proposals.0/@proposals.5/@attempts.29/@edit" start="524" end="-130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312463398" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= withdrawalLimit) &amp;&amp; ((amount + fee) &lt; super.getBalance()))&#xA;            super.balance -= (amount + fee);&#xA;        else if (currentWithdrawals &lt;" edit="/1/@proposals.0/@proposals.5/@attempts.30/@edit" start="524" end="-130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491373314595" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;            super.balance -= (amount + fee);&#xA;        &#x9;currentWithdrawals += 1;&#xA;        }&#xA;        else if (currentWithdrawals &lt; withdrawalLimit) {&#xA;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;currentWithdrawals += 1" edit="/1/@proposals.0/@proposals.5/@attempts.31/@edit" start="584" end="-84"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309175097" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309499246" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309149307" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309491325" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="0.5">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309291979" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309334664" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309387302" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309533068" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309594952" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309769068" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309905796" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310178945" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310546128" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310633995" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310673226" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310819120" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310832756" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310897862" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311124180" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311600283" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311716565" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311788743" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311881056" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311948538" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311970289" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491311981620" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312160617" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312207569" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312275277" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491373089866" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491373323266" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
