<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491331909061" sizeMeasure="23" errorCount="4">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class AbstractAccount {&#xA;&#x9;private double balance;&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Depositing a non-positive amount is not allowed&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance += amount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private abstract void internalWithdraw(double amount) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return balance;&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="52" severity="2" problemCategory="40" problemType="16777549"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="367" charEnd="398" severity="2" problemCategory="50" problemType="67109226"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="367" charEnd="398" severity="2" problemCategory="50" problemType="67109227"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="367" charEnd="398" severity="2" problemCategory="50" problemType="603979889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332056341" sizeMeasure="25" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Can not withdraw more than current balance&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="388" end="-60"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="52" severity="2" problemCategory="40" problemType="16777549"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="367" charEnd="398" severity="2" problemCategory="50" problemType="67109226"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="367" charEnd="398" severity="2" problemCategory="50" problemType="67109227"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="367" charEnd="398" severity="2" problemCategory="50" problemType="603979889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332464268" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="abstract class AbstractAccount {&#xA;&#x9;private double balance;&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Depositing a non-positive amount is not allowed&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance += amount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;protected abstract void internalWithdraw(double amount);" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="29" end="-57"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332586853" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected double balance;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="65" end="-366"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332739171" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" throws IllegalArgumentException" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="398" end="-58"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332819262" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", IllegalState" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="430" end="-67"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332521010" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332532354" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends Abstrac" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="48" end="-15"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="49" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332638577" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Can not withdraw amount larger than current balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="75" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332825900" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can not withdraw non-positive amount&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= amount;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="259" end="-8"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491332893060" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333023317" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount {&#xA;&#x9;private double creditLine;&#xA;&#x9;&#xA;&#x9;public CreditAccount(double creditLine) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) throws IllegalArgumentException, IllegalStateException {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333382929" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="setCreditLine(creditLine);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;if (creditLine &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Credit Line must be >= 0&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) throws IllegalArgumentException, IllegalStateException {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Withdrawal amount must be > 0&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// Checks that the potential balance is covered by the creditLine&#xA;&#x9;&#x9;if (-(balance - amount) > creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;New balance must be covered by the credit line&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= amount;" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="150" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333587219" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="line must be >= 0&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (-(balance) > creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;New credit line must cover balance&quot;)" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="359" end="-483"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="506" charEnd="507" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333594127" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="489" end="-483"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333629981" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333764121" sizeMeasure="19" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount {&#xA;&#xA;&#x9;private int withdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawals, double fee) {&#xA;&#x9;&#x9;this.withdrawals = withdrawals;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;protected void internalWithdraw(double amount) throws IllegalArgumentException, IllegalStateException {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="51" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="95" charEnd="106" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="125" charEnd="128" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333873146" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Can not withdraw amount larger than current balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can not withdraw non-positive amount&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// Charge fee if no remaining withdrawals&#xA;&#x9;&#x9;if (withdrawals &lt;= 0) {&#xA;&#x9;&#x9;&#x9;balance -= fee;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;withdrawals--;" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="357" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491334087709" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Add fee to amount if no remaining withdrawals&#xA;&#x9;&#x9;if (withdrawals &lt;= 0) {&#xA;&#x9;&#x9;&#x9;amount += fee;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Check for exceptions&#xA;&#x9;&#x9;if (amount > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Can not withdraw amount larger than current balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can not withdraw non-positive amount&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Excecute the withdrawal" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="357" end="-46"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491332843229" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491333400825" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491333598386" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="0.5">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491333883731" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a" performedCount="1">
        <attempts timestamp="1491333966872"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="2">
        <attempts timestamp="1491333977715"/>
        <attempts timestamp="1491333984305"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1491333988103"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
