<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491074955084" sizeMeasure="34">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public abstract class AbstractAccount {&#xA;&#xA;&#x9;protected double balance;&#xA;&#x9;&#xA;&#x9;public AbstractAccount(){ // Constructor&#xA;&#x9;&#x9;balance=0;&#xA;&#x9;} // End constructor&#xA;&#x9;&#xA;&#x9;public void deposit(double amount){&#xA;&#x9;&#x9;if (amount&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The deposit must be positiv&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance+=amount;&#xA;&#x9;} // End deposit&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount){&#xA;&#x9;&#x9;if(amount&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The withdrawal must be positiv&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;} // End withdraw&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public abstract void internalWithdraw(double amount); // Abstract method&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public double getBalance(){&#xA;&#x9;&#x9;return balance;&#xA;&#x9;} // End getBalance&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491074944682" sizeMeasure="14" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount extends AbstractAccount{&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount){&#xA;&#x9;&#x9;if(balance-amount&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can't do that.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance-=amount;&#xA;&#x9;} // End internalWithdraw&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="146" charEnd="153" severity="2" problemCategory="50" problemType="33554503"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="232" charEnd="239" severity="2" problemCategory="50" problemType="33554503"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491074989342" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491075028998" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="37" charEnd="50" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491075947783" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private double creditLine;&#xA;&#x9;&#xA;&#x9;public CreditAccount(double creditLine){&#xA;&#x9;&#x9;setCreditLine(creditLine);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if(balance-amount&lt;0 &amp;&amp; Math.abs(balance-amount)>this.creditLine){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The withdrawal is too big.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance-=amount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCreditLine(double creditLine){&#xA;&#x9;&#x9;if(creditLine&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The credit line can't be negativ&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(balance&lt;0 &amp;&amp; creditLine-Math.abs(balance)&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;The balance can't be negativ&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine=creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getCreditLine(){&#xA;&#x9;&#x9;return this.creditLine;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="74" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491076701513" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="328" end="-438"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491075973277" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491076544880" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#x9;&#xA;&#x9;private int withdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawals, double fee){&#xA;&#x9;&#x9;this.withdrawals=withdrawals;&#xA;&#x9;&#x9;this.fee=fee;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if(balance-amount&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The amount is too big!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.withdrawals&lt;=0){&#xA;&#x9;&#x9;&#x9;if(balance-(amount+this.fee)&lt;0){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The amount + fee is too big.&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;balance-=(amount+this.fee);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;balance-=amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.withdrawals--;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="51" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491076748850" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StateException(&quot;The amount is too big!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.withdrawals&lt;=0){&#xA;&#x9;&#x9;&#x9;if(balance-(amount+this.fee)&lt;0){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalState" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="336" end="-147"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491076577949" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491076570517" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491076665807" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491076702054" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491076586790" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491076715416" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491076749316" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
