<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="ObservableList">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract ObservableList superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableListListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableListListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableHighscoreList class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableHighscoreList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the ObservableHighscoreList class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.ObservableHighscoreList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableHighscoreListProgram class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableHighscoreListProgram"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the ObservableHighscoreListProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.ObservableHighscoreListProgram"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the ObservableHighscoreList JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.ObservableHighscoreListTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the ObservableList JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.ObservableListTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.Observable*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490726522131" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class ObservableList {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730306116" sizeMeasure="54" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class ObservableList {&#xA;&#x9;private List&lt;Object> elements = new ArrayList&lt;>();&#xA;&#x9;private List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public int size(){&#xA;&#x9;&#x9;return elements.size();&#xA;&#x9;}&#xA;&#x9;public Object getElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= elements.size()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig elementindex, må være 0-&quot; + (size()-1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return elements.get(n);&#xA;&#x9;}&#xA;&#x9;public abstract boolean acceptsElement(Object ocject){&#xA;&#x9;&#x9;return true ; //TODO er det sånn den settes opp?&#xA;&#x9;}&#xA;&#x9;protected void addElement(int n, Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Elementet aksepteres ikke.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Indeksen må være mellom 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(n, object);&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig element.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;}&#xA;&#x9;protected void removeElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Index ugyldig. Gyldig index: 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.remove(n);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void addObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void removeObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public coid listChanged(){&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="30" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730664482" sizeMeasure="54" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1436" end="-1437"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730705007" sizeMeasure="56" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void listChanged(ObservableList list, int n){&#xA;&#x9;&#x9;for (ObservableListListener listener : listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(list, n);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1407" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730951927" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="abstract class ObservableList {&#xA;&#x9;private List&lt;Object> elements = new ArrayList&lt;>();&#xA;&#x9;private List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public int size(){&#xA;&#x9;&#x9;return elements.size();&#xA;&#x9;}&#xA;&#x9;public Object getElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= elements.size()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig elementindex, må være 0-&quot; + (size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return elements.get(n);&#xA;&#x9;}&#xA;&#x9;public abstract boolean acceptsElement(Object obcject);&#xA;&#x9;&#xA;&#x9;protected void addElement(int n, Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Elementet aksepteres ikke.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Indeksen må være mellom 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(n, object);&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig element.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;}&#xA;&#x9;protected void removeElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Index ugyldig. Gyldig index: 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.remove(n);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void addObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;if (!elements.contains(listener)){&#xA;&#x9;&#x9;&#x9;elements.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void removeObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;if (elements.contains(listener)){&#xA;&#x9;&#x9;&#x9;elements.remove(listener);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="89" end="-156"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490731207637" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1641" end="-1642"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490732449189" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1641" end="-1642"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490732919316" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean isEmpty(){&#xA;&#x9;&#x9;return elements.isEmpty();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="252" end="-1399"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490733244147" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Object> getList(){&#xA;&#x9;&#x9;return elements " edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="252" end="-1403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490733772472" sizeMeasure="66" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ObservableList list = new ObservableList() ;&#xA;&#x9;&#x9;System.out.println(list.size());" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1693" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490733825753" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1693" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490733914832" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;private List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public ObservableList(int maxLenght){&#xA;&#x9;&#x9;elements = new ArrayList&lt;>(maxLenght) ;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;Object> getList(){&#xA;&#x9;&#x9;return elements ;&#xA;&#x9;}&#xA;&#x9;public int size(){&#xA;&#x9;&#x9;return elements.size();&#xA;&#x9;}&#xA;&#x9;public Object getElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= elements.size()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig elementindex, må være 0-&quot; + (size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return elements.get(n);&#xA;&#x9;}&#xA;&#x9;public abstract boolean acceptsElement(Object obcject);&#xA;&#x9;&#xA;&#x9;protected void addElement(int n, Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Elementet aksepteres ikke.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Indeksen må være mellom 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(n, object);&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig element.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;}&#xA;&#x9;protected void removeElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Index ugyldig. Gyldig index: 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.remove(n);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void addObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;if (!elements.contains(listener)){&#xA;&#x9;&#x9;&#x9;elements.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void removeObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;if (elements.contains(listener)){&#xA;&#x9;&#x9;&#x9;elements.remove(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void listChanged(ObservableList list, int n){&#xA;&#x9;&#x9;for (ObservableListListener listener : listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(list, n);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="151" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490734070413" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="232" end="-1456"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490734367355" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = new ArrayList&lt;>();&#xA;&#x9;private List&lt;ObservableListListener> listeners = new ArrayList&lt;>();" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="151" end="-1456"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490734694694" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int size(){&#xA;&#x9;&#x9;return elements.size();&#xA;&#x9;}&#xA;&#x9;public Object getElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= elements.size()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig elementindex, må være 0-&quot; + (size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return elements.get(n);&#xA;&#x9;}&#xA;&#x9;public abstract boolean acceptsElement(Object obcject);&#xA;&#x9;&#xA;&#x9;protected void addElement(int n, Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Elementet aksepteres ikke.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Indeksen må være mellom 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(n, object);&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig element.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;}&#xA;&#x9;protected void removeElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Index ugyldig. Gyldig index: 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.remove(n);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void addObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;if (!listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void removeObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;if (listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;listener" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="252" end="-179"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490735061680" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="702" end="-839"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490735320969" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="elements.add(n, object);&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;protected void addElement(Object object){&#xA;&#x9;&#x9;if (!acceptsElement(object)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig element.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.add(object);&#xA;&#x9;}&#xA;&#x9;protected void removeElement(int n){&#xA;&#x9;&#x9;if (n &lt; 0 || n >= size()){&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Index ugyldig. Gyldig index: 0-&quot;+(size()-1));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;elements.remove(n);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void addObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;if (!listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void removeObservableListListener(ObservableListListener listener){&#xA;&#x9;&#x9;if (listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;listeners.remove(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void listChanged(ObservableList list, int n){&#xA;&#x9;&#x9;for (ObservableListListener listener : listeners){&#xA;&#x9;&#x9;&#x9;listener.listChanged(list, n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ObservableList ob = new ObservableHighScoreList(5);&#xA;&#x9;&#x9;ob.addElement(0,5);&#xA;&#x9;&#x9;System.out.println(ob);" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="702" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490735334641" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getElement(0)" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1669" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490735356438" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(ob.size(" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1687" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490735409486" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1528" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490876016774" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ObservableList list = new ObservableHighscoreList(10) ;&#xA;&#x9;&#x9;list.addElement(0, 5);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1528" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490876113761" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="1528" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490725425501" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface ObservableListListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490725936656" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;void listChanged(ObservableList list, int n);" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="72" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730371133" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HighScor" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="100" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730689083" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="100" end="-23"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490735449076" sizeMeasure="72">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;&#xA;public class ObservableHighscoreList extends ObservableList{&#xA;&#x9;private int maxSize;&#xA;&#x9;&#xA;&#x9;public ObservableHighscoreList(int maxLenght){&#xA;&#x9;&#x9;this.maxSize = maxLenght;&#xA;&#x9;}&#xA;&#x9;public void addResult(int score){&#xA;&#x9;&#x9;if (score &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Scoren må være positiv.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (super.size() == 0 ){ //hvis lista er tom legges den på første plass&#xA;&#x9;&#x9;&#x9;super.addElement(score) ;&#xA;&#x9;&#x9;&#x9;listChanged(this, 0);&#xA;&#x9;&#x9;&#x9;return ;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = 0; i &lt; size(); i++){&#xA;&#x9;&#x9;&#x9;if (score &lt;= (int) getElement(i)){&#xA;&#x9;&#x9;&#x9;&#x9;if (size() &lt; maxSize){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;addElement(i, score);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;listChanged(this, i);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return ;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else{ //Legger til resultatet på plassen, og fjerner deretter dårligste måling&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;addElement(i,score);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;removeElement(maxSize);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;listChanged(this, i);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return ;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Dersom resultater ikke er bedre enn de andre, men det fortsatt er plass legges den til slutt&#xA;&#x9;&#x9;if (size() &lt; maxSize){ &#xA;&#x9;&#x9;&#x9;int plassering = size() ;&#xA;&#x9;&#x9;&#x9;addElement(plassering, score) ;&#xA;&#x9;&#x9;&#x9;listChanged(this, plassering);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;//&#x9;&#x9;int i = 0 ;&#xA;//&#x9;&#x9;for (int value : results){&#xA;//&#x9;&#x9;&#x9;if (score &lt;= value){&#xA;//&#x9;&#x9;&#x9;&#x9;if (results.size() &lt; maxSize){ //sjekker om lista har plass&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;results.add(i, score);&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;listChanged(this, i);&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;return ;&#xA;//&#x9;&#x9;&#x9;&#x9;}&#xA;//&#x9;&#x9;&#x9;&#x9;else{ //Legger til resultatet på plassen, og fjerner deretter dårligste måling&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;results.add(i,score);&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;results.remove(maxSize);&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;listChanged(this, i);&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;return ;&#xA;//&#x9;&#x9;&#x9;&#x9;}&#xA;//&#x9;&#x9;&#x9;}else {i++; }&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;//Dersom resultater ikke er bedre enn de andre, men det fortsatt er plass legges den til slutt&#xA;//&#x9;&#x9;if (results.size() &lt; maxSize){ &#xA;//&#x9;&#x9;&#x9;int plassering = results.size() ;&#xA;//&#x9;&#x9;&#x9;results.add(plassering, score) ;&#xA;//&#x9;&#x9;&#x9;listChanged(this, plassering);&#xA;//&#x9;&#x9;}&#xA;//&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public boolean acceptsElement(Object object) {&#xA;&#x9;&#x9;if (object instanceof Integer){&#xA;&#x9;&#x9;&#x9;return true ;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490875954674" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="1900" end="-1901"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490876534613" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="512" end="-1388"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490876711764" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="1058" end="-140"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490726047886" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class ObservableHighscoreListProgram {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490726245619" sizeMeasure="50" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Scanner;&#xA;&#xA;public class ObservableHighscoreListProgram implements ObservableListListener{&#xA;&#x9;&#xA;&#x9;private ObservableHighScoreList hscore ;&#xA;&#x9;&#xA;&#x9;&#x9;public void init() {&#xA;&#x9;&#x9;&#x9;hscore = new ObservableHighScoreList(5) ;&#xA;&#x9;&#x9;&#x9;hscore.addObservableListListener(this);&#xA;&#x9;}&#xA;&#x9;public void run() {&#xA;&#x9;&#x9;Scanner scanner = new Scanner(System.in) ;&#xA;&#x9;&#x9;String str = &quot;&quot; ;&#xA;&#x9;&#x9;int score ;&#xA;&#x9;&#x9;do{&#xA;&#x9;&#x9;&#x9;System.out.print(&quot;Legg inn resultat: &quot;);&#xA;&#x9;&#x9;&#x9;str = scanner.next() ;&#xA;&#x9;&#x9;&#x9;int size = str.length() ;&#xA;&#x9;&#x9;&#x9;if (str.matches(&quot;[\\d{&quot; + size + &quot;}]&quot;)){&#xA;&#x9;&#x9;&#x9;&#x9;score = Integer.valueOf(str);&#xA;&#x9;&#x9;&#x9;&#x9;hscore.addResult(score);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;System.out.print(&quot;For å avslutte oppgi \&quot;Lukk\&quot;\n&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} while (!str.contains(&quot;Lukk&quot;));&#xA;&#x9;&#x9;scanner.close();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void listChanged(ObservableList list, int n) {&#xA;&#x9;&#x9;int size = list.size() ;&#xA;&#x9;&#x9;String str = &quot;&quot; ;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; size; i++){&#xA;&#x9;&#x9;&#x9;str += String.valueOf(i+1) + &quot;. plass &quot; + String.valueOf(list.getElement(i)) + &quot;\n&quot; ;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(str);&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;HighscoreListProgram pro = new HighscoreListProgram();&#xA;&#x9;&#x9;pro.init();&#xA;&#x9;&#x9;pro.run();&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="30" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490726380617" sizeMeasure="49" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}&#xA;&#x9;&#x9;public void run() {&#xA;&#x9;&#x9;&#x9;Scanner scanner = new Scanner(System.in) ;&#xA;&#x9;&#x9;&#x9;String str = &quot;&quot; ;&#xA;&#x9;&#x9;&#x9;int score ;&#xA;&#x9;&#x9;&#x9;do{&#xA;&#x9;&#x9;&#x9;&#x9;System.out.print(&quot;Legg inn resultat: &quot;);&#xA;&#x9;&#x9;&#x9;&#x9;str = scanner.next() ;&#xA;&#x9;&#x9;&#x9;&#x9;int size = str.length() ;&#xA;&#x9;&#x9;&#x9;&#x9;if (str.matches(&quot;[\\d{&quot; + size + &quot;}]&quot;)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;score = Integer.valueOf(str);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;hscore.addResult(score);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;System.out.print(&quot;For å avslutte oppgi \&quot;Lukk\&quot;\n&quot;);&#xA;&#x9;&#x9;&#x9;} while (!str.contains(&quot;Lukk&quot;));&#xA;&#x9;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;@Override&#xA;&#x9;&#x9;public void listChanged(ObservableList list, int n) {&#xA;&#x9;&#x9;&#x9;int size = list.size() ;&#xA;&#x9;&#x9;&#x9;String str = &quot;&quot; ;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; size; i++){&#xA;&#x9;&#x9;&#x9;&#x9;str += String.valueOf(i+1) + &quot;. plass &quot; + String.valueOf(list.getElement(i)) + &quot;\n&quot; ;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;System.out.println(str);&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#x9;ObservableHighscoreListProgram pro = new ObservableHighscoreListProgram();&#xA;&#x9;&#x9;&#x9;pro.init();&#xA;&#x9;&#x9;&#x9;pro.run();&#x9;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="294" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730416272" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HighScor" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="792" end="-403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490730705177" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="792" end="-403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490735002422" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;Størrelsen på elements er: &quot; + hscore.size());&#xA;&#x9;&#x9;&#x9;&#x9;if (str.matches(&quot;[\\d{&quot; + size + &quot;}]&quot;)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;score = Integer.valueOf(str);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;hscore.addResult(score);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;System.out.print(&quot;For å avslutte oppgi \&quot;Lukk\&quot;\n&quot;);&#xA;&#x9;&#x9;&#x9;} while (!str.contains(&quot;Lukk&quot;));&#xA;&#x9;&#x9;&#x9;scanner.close();&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;@Override&#xA;&#x9;&#x9;public void listChanged(Observabl" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="514" end="-403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490735448761" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="scoreList hscore ;&#xA;&#x9;&#xA;&#x9;&#x9;public void init() {&#xA;&#x9;&#x9;&#x9;hscore = new ObservableHighs" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="161" end="-1029"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490730303915" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490730368870" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490730415483" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490732447744" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490732674808" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490732733683" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490732800135" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490732918685" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490732954084" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490733243213" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490733260750" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490733264255" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490733513020" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490733600657" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490733824605" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490733913975" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490733925365" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490734069191" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490734693040" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490734804526" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490734884709" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490735001657" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490735060766" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490735125249" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490735411092" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490735460751" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490876115140" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490876423519" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490876535481" completion="1.0" successCount="7"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="0.75">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490735183770" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490875756174" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490875844766" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490875859602" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490876544456" completion="0.75" successCount="3" failureCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="2">
        <attempts timestamp="1490733056927"/>
        <attempts timestamp="1490733057706"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="21">
        <attempts timestamp="1490732817863"/>
        <attempts timestamp="1490732821234"/>
        <attempts timestamp="1490732825032"/>
        <attempts timestamp="1490732827590"/>
        <attempts timestamp="1490732968423"/>
        <attempts timestamp="1490732977897"/>
        <attempts timestamp="1490732980055"/>
        <attempts timestamp="1490732982324"/>
        <attempts timestamp="1490733008049"/>
        <attempts timestamp="1490733009274"/>
        <attempts timestamp="1490733012298"/>
        <attempts timestamp="1490733014603"/>
        <attempts timestamp="1490733017004"/>
        <attempts timestamp="1490733020858"/>
        <attempts timestamp="1490733039419"/>
        <attempts timestamp="1490733051183"/>
        <attempts timestamp="1490733053942"/>
        <attempts timestamp="1490733274202"/>
        <attempts timestamp="1490733276080"/>
        <attempts timestamp="1490733280593"/>
        <attempts timestamp="1490733285262"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1490732829786"/>
        <attempts timestamp="1490732962357"/>
        <attempts timestamp="1490733025854"/>
        <attempts timestamp="1490733041114"/>
        <attempts timestamp="1490875494983"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
