<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="SavingsAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Get the source code for the Account interface from the wiki."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.Account"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the BSU class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.BSU"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the BSU class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.BSU"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ForeldreSpar class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.ForeldreSpar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the ForeldreSpar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.ForeldreSpar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the BSU JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.BSUTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the ForeldreSpar JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.ForeldreSparTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the SavingsAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.SavingsAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the BSU class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.BSU" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the ForeldreSpar class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.ForeldreSpar" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490007252749" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490007260854" sizeMeasure="5" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Account" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="50" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490007575331" sizeMeasure="25" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private int balance;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Deposit (must be positive) is: &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.balance += amount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="71" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490007629038" sizeMeasure="28" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Withdrawal (must be positive) is: &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.balance += amount;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="334" end="-65"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490007633475" sizeMeasure="28" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="458" end="-74"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490007780078" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="523" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008076466" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="535" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008114949" sizeMeasure="37" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private double interest;&#xA;&#x9;&#xA;&#x9;public SavingsAccount(double interest) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="94" end="-486"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008120049" sizeMeasure="37" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.interest = interest;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="165" end="-489"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008146565" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance = 0;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="170" end="-517"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008238363" sizeMeasure="38" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance += (balance*)" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="691" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008262665" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1+(interest/100))*balance;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="703" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008281713" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="*= (1+(interest/100))" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="699" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008375039" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="728" end="-729"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008459159" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else if (amount &lt; balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You don't have enough money.&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="563" end="-172"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008481383" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=">" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="580" end="-249"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008548410" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+= balance*(interest/4" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="800" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008552880" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="100" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="821" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008595560" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="820" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008605503" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="*= interest" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="800" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008670523" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;SavingsAccount j = new SavingsAccount(0.04);&#xA;&#x9;&#x9;j.deposit(2000);&#xA;&#x9;&#x9;j.endYearUpdate();&#xA;&#x9;&#x9;System.out.println(j.getBalance());&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="817" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008678658" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+= balance*" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="800" end="-187"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008696746" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="824" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009151047" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected int balance;&#xA;&#x9;private double interest;&#xA;&#x9;&#xA;&#x9;public SavingsAccount(double interest) {&#xA;&#x9;&#x9;this.balance = 0;&#xA;&#x9;&#x9;this.interest = interest;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Deposit (must be positive) is: &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.balance += amount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Withdrawal (must be positive) is: &quot; + amount);&#xA;&#x9;&#x9;} else if (amount > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You don't have enough money.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.balance -= amount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return balance;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;balance += balance*interest" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="74" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009160136" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ivate" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="74" end="-748"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009944377" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected int balance;&#xA;&#x9;protected" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="74" end="-726"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490008671454" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490008679377" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008719621" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class BSU {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008723688" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="42" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490008783884" sizeMeasure="6" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends SavingsAccount" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="39" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009075794" sizeMeasure="11" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private double maxDeposit;&#xA;&#xA;&#x9;public BSU(double interest, double maxDeposit) {&#xA;&#x9;&#x9;super(interest);&#xA;&#x9;&#x9;this.maxDeposit = maxDeposit;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="64" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009113621" sizeMeasure="15" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="199" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009269032" sizeMeasure="19" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;deposit(amount);" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="249" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009290280" sizeMeasure="20" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="291" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009357500" sizeMeasure="22" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount > maxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Maximum deposit is &quot; + maxDeposit + &quot;, but was &quot; + amount);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="291" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009422367" sizeMeasure="26" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private double lastDeposit;&#xA;&#xA;&#x9;public BSU(double interest, double maxDeposit) {&#xA;&#x9;&#x9;super(interest);&#xA;&#x9;&#x9;this.maxDeposit = maxDeposit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;return &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;if (amount > maxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Maximum deposit is &quot; + maxDeposit + &quot;, but was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;deposit(amount);&#xA;&#x9;&#x9;lastDeposit = amount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="94" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009450671" sizeMeasure="26" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lastDeposit*0.2;" edit="/1/@proposals.0/@proposals.3/@attempts.8/@edit" start="274" end="-236"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009555979" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void withdraw(double amount) {&#xA;&#x9;&#x9;if (amount > lastDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Maximum withdrawal is &quot; + lastDeposit + &quot;, but was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.9/@edit" start="522" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009573597" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;withdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.10/@edit" start="691" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009605213" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;lastDeposit -= amount" edit="/1/@proposals.0/@proposals.3/@attempts.11/@edit" start="711" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009673615" sizeMeasure="38" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int getBalance() {&#xA;&#x9;&#x9;return getBalance()" edit="/1/@proposals.0/@proposals.3/@attempts.12/@edit" start="741" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009685549" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double" edit="/1/@proposals.0/@proposals.3/@attempts.13/@edit" start="748" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009737626" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void endYearUpdate() {&#xA;&#x9;&#x9;endYearUpdate();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.14/@edit" start="799" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490009799411" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lastDeposit = amount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;if (amount > lastDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Maximum withdrawal is &quot; + lastDeposit + &quot;, but was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;lastDeposit -= amount;&#xA;&#x9;}&#xA;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.3/@attempts.15/@edit" start="468" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010025832" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Deposit (must be positive) is: &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.balance += amount;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.16/@edit" start="468" end="-240"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010029580" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.17/@edit" start="602" end="-240"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010094272" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StateException(&quot;Maximum deposit is &quot; + maxDeposit + &quot;, but was &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Deposit (must be positive) is: &quot; + amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.balance += amount;" edit="/1/@proposals.0/@proposals.3/@attempts.18/@edit" start="383" end="-240"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010102651" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Argument" edit="/1/@proposals.0/@proposals.3/@attempts.19/@edit" start="383" end="-448"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010130828" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Withdrawal (must be positive) is: &quot; + amount);&#xA;&#x9;&#x9;} else if (amount > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You don't have enough money.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.balance -= amount;" edit="/1/@proposals.0/@proposals.3/@attempts.20/@edit" start="807" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010147655" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lastDeposit = amount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;if (amount > lastDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Maximum withdrawal is &quot; + lastDeposit + &quot;, but was &quot; + amount);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.21/@edit" start="468" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010392022" sizeMeasure="33" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private List&lt;Double> depositHistory = new ArrayList&lt;Double>()" edit="/1/@proposals.0/@proposals.3/@attempts.22/@edit" start="123" end="-584"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010407348" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List" edit="/1/@proposals.0/@proposals.3/@attempts.23/@edit" start="22" end="-750"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010423287" sizeMeasure="35" errorCount="5" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.24/@edit" start="155" end="-655"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010505451" sizeMeasure="35" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Double> depositHistory = new ArrayList&lt;Double>();&#xA;&#xA;&#x9;public BSU(double interest, double maxDeposit) {&#xA;&#x9;&#x9;super(interest);&#xA;&#x9;&#x9;this.maxDeposit = maxDeposit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;return depositHistory.get(depositHistory.size())" edit="/1/@proposals.0/@proposals.3/@attempts.25/@edit" start="155" end="-420"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010520030" sizeMeasure="29" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.26/@edit" start="453" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010561575" sizeMeasure="29" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.3/@attempts.27/@edit" start="401" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010569993" sizeMeasure="29" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.28/@edit" start="401" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010619688" sizeMeasure="29" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.29/@edit" start="509" end="-510"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010702543" sizeMeasure="28" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.30/@edit" start="146" end="-302"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010707107" sizeMeasure="28" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public BSU(double interest, double maxDeposit) {&#xA;&#x9;&#x9;super(interest);&#xA;&#x9;&#x9;this.maxDeposit = maxDeposit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.31/@edit" start="146" end="-103"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010713143" sizeMeasure="28" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.deposit(amount);" edit="/1/@proposals.0/@proposals.3/@attempts.32/@edit" start="336" end="-57"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010770394" sizeMeasure="32" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount > maxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Maximum deposit is &quot; + maxDeposit + &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&quot;, but was &quot; + amount);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.33/@edit" start="336" end="-82"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010796324" sizeMeasure="33" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private double last" edit="/1/@proposals.0/@proposals.3/@attempts.34/@edit" start="146" end="-416"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010805937" sizeMeasure="34" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;lastDeposit = 0" edit="/1/@proposals.0/@proposals.3/@attempts.35/@edit" start="278" end="-307"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490010932829" sizeMeasure="38" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if ((amount + lastDeposit) > maxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can only deposit &quot; + maxDeposit + &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&quot; per year&quot;)" edit="/1/@proposals.0/@proposals.3/@attempts.36/@edit" start="522" end="-86"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011035922" sizeMeasure="39" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=". Your max deposit is &quot; + maxDeposit-lastDeposit + &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&quot;, but was &quot; + amount);" edit="/1/@proposals.0/@proposals.3/@attempts.37/@edit" start="655" end="-86"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011043269" sizeMeasure="39" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(maxDeposit-lastDeposit)" edit="/1/@proposals.0/@proposals.3/@attempts.38/@edit" start="681" end="-118"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011089534" sizeMeasure="44" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;lastDeposit = 0;" edit="/1/@proposals.0/@proposals.3/@attempts.39/@edit" start="819" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011115082" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.40/@edit" start="22" end="-831"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011128420" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class BSU extends SavingsAccount {&#xA;&#x9;&#xA;&#x9;private double maxDeposit;&#xA;&#x9;private double lastDeposit;&#xA;&#xA;&#x9;public BSU(double interest, double maxDeposit) {&#xA;&#x9;&#x9;super(interest);&#xA;&#x9;&#x9;this.maxDeposit = maxDeposit;&#xA;&#x9;&#x9;lastDeposit = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getTaxDeduction() {&#xA;&#x9;&#x9;return lastDeposit*0.2;" edit="/1/@proposals.0/@proposals.3/@attempts.41/@edit" start="23" end="-565"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011191238" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount > lastDeposit || amount > maxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;lol&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.withdraw(amount);" edit="/1/@proposals.0/@proposals.3/@attempts.42/@edit" start="785" end="-90"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011259872" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public int getBalance() {&#xA;&#x9;&#x9;return super.balance;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.43/@edit" start="997" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011267872" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double" edit="/1/@proposals.0/@proposals.3/@attempts.44/@edit" start="1005" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011277390" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.45/@edit" start="1055" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011310177" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="BSU j = new BSU(0.032, 25000);&#xA;&#x9;&#x9;System.out.println(j.getBalance());" edit="/1/@proposals.0/@proposals.3/@attempts.46/@edit" start="1099" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011322161" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="j.deposit(10" edit="/1/@proposals.0/@proposals.3/@attempts.47/@edit" start="1132" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011328595" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="25" edit="/1/@proposals.0/@proposals.3/@attempts.48/@edit" start="1142" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011331860" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.3/@attempts.49/@edit" start="1146" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011341472" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0000" edit="/1/@proposals.0/@proposals.3/@attempts.50/@edit" start="1143" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011349364" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="j.deposit(51" edit="/1/@proposals.0/@proposals.3/@attempts.51/@edit" start="1152" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011366437" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;lastDeposit = amount" edit="/1/@proposals.0/@proposals.3/@attempts.52/@edit" start="740" end="-476"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011372289" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.3/@attempts.53/@edit" start="1187" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011376536" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.3/@attempts.54/@edit" start="1189" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011388387" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.55/@edit" start="1176" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011441370" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (lastDeposit == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;rofl&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.withdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;lastDeposit = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return super.balance;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BSU j = new BSU(0.032, 25000);&#xA;&#x9;&#x9;j.deposit(20000" edit="/1/@proposals.0/@proposals.3/@attempts.56/@edit" start="912" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011474782" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="j.endYearUpdate();&#xA;&#x9;&#x9;System.out.println(j.getBalance());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.57/@edit" start="1250" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011507396" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lastDeposit" edit="/1/@proposals.0/@proposals.3/@attempts.58/@edit" start="1292" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011511529" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getBalance()" edit="/1/@proposals.0/@proposals.3/@attempts.59/@edit" start="1292" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011523682" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="j.withdraw(5000" edit="/1/@proposals.0/@proposals.3/@attempts.60/@edit" start="1271" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011532532" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.61/@edit" start="912" end="-361"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011549832" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.withdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;lastDeposit = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return super.balance;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BSU j = new BSU(0.032, 25000);&#xA;&#x9;&#x9;j.deposit(20000);&#xA;&#x9;&#x9;j.endYearUpdate();&#xA;&#x9;&#x9;j.withdraw(2" edit="/1/@proposals.0/@proposals.3/@attempts.62/@edit" start="912" end="-53"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011564149" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;j.endYearUpdate(" edit="/1/@proposals.0/@proposals.3/@attempts.63/@edit" start="1174" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011573491" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="j.withdraw(10000" edit="/1/@proposals.0/@proposals.3/@attempts.64/@edit" start="1199" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011579526" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.3/@attempts.65/@edit" start="1210" end="-54"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011582203" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.3/@attempts.66/@edit" start="1214" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011589424" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.67/@edit" start="1199" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011668067" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if (amount > lastDeposit || amount > maxDeposit) {&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;lol&quot;);&#xA;//&#x9;&#x9;}&#xA;&#x9;&#x9;super.withdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;lastDeposit = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return super.balance;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;BSU j = new BSU(0.032, 25000);&#xA;&#x9;&#x9;j.deposit(20000);&#xA;//&#x9;&#x9;j.endYearUpdate(" edit="/1/@proposals.0/@proposals.3/@attempts.68/@edit" start="807" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011676203" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if (amount > lastDeposit || amount > maxDeposit) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;lol&quot;);&#xA;" edit="/1/@proposals.0/@proposals.3/@attempts.69/@edit" start="807" end="-338"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011751410" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lastDeposit == 0" edit="/1/@proposals.0/@proposals.3/@attempts.70/@edit" start="837" end="-388"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011792707" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.3/@attempts.71/@edit" start="877" end="-356"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011814930" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.72/@edit" start="1072" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011893679" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="It's a new year maaan.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.withdraw(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;lastDeposit = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return super.balance;" edit="/1/@proposals.0/@proposals.3/@attempts.73/@edit" start="893" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011310905" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011323538" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011327996" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011332668" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011350304" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011367669" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011372937" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011377360" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011473957" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011508233" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011512212" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011524332" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011539766" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011550528" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011563055" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011574320" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011578865" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011582889" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490011754294" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011926265" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class ForeldreSpar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490011939332" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends SavingsAccount" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="48" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012029346" sizeMeasure="6" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public ForeldreSpar(double interest, int maxWithdrawals)" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="73" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012039678" sizeMeasure="8" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate int maxWithdrawals;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="75" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012053213" sizeMeasure="11" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#x9;&#x9;super(interest);&#xA;&#x9;&#x9;this.maxWithdrawals = maxWithdrawals;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="161" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012134964" sizeMeasure="15" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public int getRemainingWithdrawals() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.4/@edit" start="226" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012162927" sizeMeasure="16" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int remaingingWithdrawals;&#xA;&#x9;&#xA;&#x9;public ForeldreSpar(double interest, int maxWithdrawals) {&#xA;&#x9;&#x9;super(interest);&#xA;&#x9;&#x9;this.maxWithdrawals = maxWithdrawals;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRemainingWithdrawals() {&#xA;&#x9;&#x9;return remaingingWithdrawals;" edit="/1/@proposals.0/@proposals.5/@attempts.5/@edit" start="103" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012689828" sizeMeasure="26" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;super.deposit(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;if (remaingingWithdrawals &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You have no withdrawals left.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.6/@edit" start="339" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012704216" sizeMeasure="27" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;super.withdraw(amount);" edit="/1/@proposals.0/@proposals.5/@attempts.7/@edit" start="558" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012744488" sizeMeasure="31" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return balance" edit="/1/@proposals.0/@proposals.5/@attempts.8/@edit" start="586" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490012774641" sizeMeasure="35" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.balance;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate()" edit="/1/@proposals.0/@proposals.5/@attempts.9/@edit" start="627" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490013011400" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;remaingingWithdrawals++" edit="/1/@proposals.0/@proposals.5/@attempts.10/@edit" start="584" end="-128"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490013070569" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="--" edit="/1/@proposals.0/@proposals.5/@attempts.11/@edit" start="606" end="-128"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490013115255" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;remaingingWithdrawals = maxWithdrawals" edit="/1/@proposals.0/@proposals.5/@attempts.12/@edit" start="731" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490013542240" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;remaingingWithdrawals = maxWithdrawals;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRemainingWithdrawals() {&#xA;&#x9;&#x9;return remaingingWithdrawals;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;super.deposit(amount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;if (remaingingWithdrawals &lt;= 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You have no withdrawals left.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;super.withdraw(amount);&#xA;&#x9;&#x9;remaingingWithdrawals--;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return super.balance;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate() {&#xA;&#x9;&#x9;super.endYearUpdate();&#xA;&#x9;&#x9;remaingingWithdrawals = maxWithdrawals;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.13/@edit" start="260" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490008323889" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490008462460" completion="0.25" successCount="1" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490008483819" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490008555482" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490008608931" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490008684073" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490009751072" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490009898966" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490009947773" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490009950370" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490010033711" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490010096726" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490010134039" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490010523653" completion="0.0" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490010564248" completion="0.0" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490010572749" completion="0.0" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490010772093" completion="0.0" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011048672" completion="0.0" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011195633" completion="0.0" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011392703" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011445569" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011668605" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011692907" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011757915" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011795221" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490011894870" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490013137067" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490013545208" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
