<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397209631" sizeMeasure="22">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public abstract class AbstractAccount {&#xA;&#xA;    private int balance;&#xA;&#xA;    public void deposit(double amount) {&#xA;&#x9;if (amount > 0){&#xA;&#x9;    this.balance += amount;&#xA;&#x9;}&#xA;    }&#xA;&#xA;    public void withdraw(double amount) {&#xA;&#x9;this.balance -= amount;&#xA;    }&#xA;&#xA;    public abstract void internalWithdraw(double amount);&#xA;&#xA;    public double getBalance() {&#xA;&#x9;return balance;&#xA;    }&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397228920" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;throw new IllegalArgumentException();" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="180" end="-200"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397250890" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="143" end="-275"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397269614" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="181" end="-238"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397293463" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" 0){&#xA;&#x9;    this.balance += amount;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="143" end="-238"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397305288" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    return " edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="178" end="-243"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397357405" sizeMeasure="24" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="245" end="-182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397367048" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ublic" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="245" end="-182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397371079" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rotected" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="245" end="-182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397648173" sizeMeasure="27" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount >= 0) {&#xA;&#x9;    this.balance -= amount;&#xA;&#x9;}&#xA;&#x9;throw new IllegalArgumentExcetion()" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="286" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397705849" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double balance;&#xA;&#xA;    public AbstractAccount() {&#xA;&#x9;balance = 0;&#xA;    }&#xA;    public void deposit(double amount) {&#xA;&#x9;if (amount > 0){&#xA;&#x9;    this.balance += amount;&#xA;&#x9;    return ;&#xA;&#x9;}&#xA;&#x9;throw new IllegalArgumentException();&#xA;    }&#xA;&#xA;    protected void withdraw(double amount) {&#xA;&#x9;if (amount >= 0) {&#xA;&#x9;    internalWithdraw(amount);&#xA;&#x9;}&#xA;&#x9;throw new IllegalArgumentExcep" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="75" end="-133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397772087" sizeMeasure="30" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="69" end="-482"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397772799" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="76" end="-482"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397857485" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    return " edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="393" end="-169"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397117829" sizeMeasure="12">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount extends AbstractAccount {&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;&#x9;if (getBalance() - amount >= 0) {&#xA;&#x9;    withdraw(amount);&#xA;&#x9;}&#xA;&#x9;throw new IllegalArgumentException();&#xA;    }&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397266079" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="186" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397317860" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    return ;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="184" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397333032" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; amount >" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="156" end="-95"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397410059" sizeMeasure="17" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;    public withdraw(double amount) {&#xA;&#x9;&#xA;    }" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="79" end="-189"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397567941" sizeMeasure="15" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="75" end="-197"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397726965" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="75" end="-189"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398096461" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    public void internalWithdraw(double amount) {&#xA;&#x9;if (getBalance() - amount >= 0 &amp;&amp; amount > 0) {&#xA;&#x9;    balance -= amount" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="75" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398100185" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="233" end="-23"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397107164" sizeMeasure="25">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount extends AbstractAccount {&#xA;&#xA;    private int creditLine;&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;&#x9;if (getBalance() + creditLine - amount >= 0) {&#xA;&#x9;    withdraw(amount);&#xA;&#x9;}&#xA;&#x9;throw new IllegalArgumentException();&#xA;    }&#xA;&#xA;    public void setCreditLine(int creditLine) {&#xA;&#x9;if (getBalance() + creditLine > 0) {&#xA;&#x9;    this.creditLine = creditLine;&#xA;&#x9;}&#xA;&#x9;throw new IllegalArgumentException();&#xA;    }&#xA;&#xA;    public int getCreditLine() {&#xA;&#x9;return creditLine;&#xA;    }&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397476691" sizeMeasure="29" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    &#xA;    public CreditAccount(double creditLine) {&#xA;&#x9;this.creditLine = creditLine;&#xA;    }" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="104" end="-405"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397479366" sizeMeasure="29" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="88" end="-505"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397483568" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="547" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397507466" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="396" end="-203"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397552952" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="604" end="-605"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398128428" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;    public CreditAccount(double creditLine) {&#xA;&#x9;this.creditLine = creditLine;&#xA;    }&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;&#x9;if (getBalance() + creditLine - amount >= 0) {&#xA;&#x9;    withdraw(amount);&#xA;&#x9;}&#xA;&#x9;throw new IllegalState" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="107" end="-259"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398143579" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance -= amount" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="295" end="-287"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398161422" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(getBalance() + creditLine)" edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="247" end="-327"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398187288" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.3/@attempts.8/@edit" start="445" end="-156"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398195196" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.3/@attempts.9/@edit" start="508" end="-86"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398208625" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    return ;&#xA;&#x9;}&#xA;&#x9;throw new IllegalStateException();&#xA;    }&#xA;&#xA;    public void setCreditLine(double creditLine) {&#xA;&#x9;if (getBalance() + creditLine >= 0) {&#xA;&#x9;    this.creditLine = creditLine;&#xA;&#x9;    return " edit="/1/@proposals.0/@proposals.3/@attempts.10/@edit" start="317" end="-114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398220780" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Argument" edit="/1/@proposals.0/@proposals.3/@attempts.11/@edit" start="536" end="-86"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398230502" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.3/@attempts.12/@edit" start="536" end="-86"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398285399" sizeMeasure="34" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="creditLine &lt; 0  {&#xA;&#x9;    throw new IllegalArgumentException();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.13/@edit" start="432" end="-201"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398288314" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=")" edit="/1/@proposals.0/@proposals.3/@attempts.14/@edit" start="446" end="-250"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397137570" sizeMeasure="21" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 extends AbstractAccount{&#xA;&#xA;    private int withdrawls;&#xA;    private double fee;&#xA;    public SavingsAccount2(int withdrawls, double fee) {&#xA;&#x9;this.withdrawls = withdrawls;&#xA;&#x9;this.fee = fee;&#xA;    }&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;&#x9;if (withdrawls > 0 &amp;&amp; getBalance() - amount >= 0) {&#xA;&#x9;    withdraw(amount);&#xA;&#x9;}&#xA;&#x9;else if () {&#xA;&#x9;    withdraw(amount + fee);&#xA;&#x9;}&#xA;&#x9;throw new IllegalArgumentException();&#xA;    }&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397169258" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getBalance() - amount >= 0" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="380" end="-84"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397801928" sizeMeasure="22" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#xA;    private int withdrawls;&#xA;    private double fee;&#xA;&#xA;    public SavingsAccount2(int withdrawls, double fee) {&#xA;&#x9;this.withdrawls = withdrawls;&#xA;&#x9;this.fee = fee;&#xA;    }&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;&#x9;if (withdrawls > 0 &amp;&amp; getBalance() - amount >= 0) {&#xA;&#x9;    balance - amount;&#xA;&#x9;}&#xA;&#x9;else if (getBalance() - amount >= 0) {&#xA;&#x9;    balande - " edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="74" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397829757" sizeMeasure="23" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super()" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="189" end="-307"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397876438" sizeMeasure="23" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= amount;&#xA;&#x9;}&#xA;&#x9;else if (getBalance() - amount >= 0) {&#xA;&#x9;    balance -=" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="369" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397884889" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.5/@attempts.4/@edit" start="196" end="-309"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397902207" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    return ;&#xA;&#x9;}&#xA;&#x9;else if (getBalance() - amount >= 0) {&#xA;&#x9;    balance -= (amount + fee);&#xA;&#x9;    return " edit="/1/@proposals.0/@proposals.5/@attempts.5/@edit" start="381" end="-53"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397925465" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.5/@attempts.6/@edit" start="504" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490397982767" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(balance);" edit="/1/@proposals.0/@proposals.5/@attempts.7/@edit" start="304" end="-229"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398028910" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="withdrawls--;" edit="/1/@proposals.0/@proposals.5/@attempts.8/@edit" start="391" end="-176"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398074837" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fee" edit="/1/@proposals.0/@proposals.5/@attempts.9/@edit" start="471" end="-112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490398080143" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.10/@edit" start="304" end="-254"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397174394" completion="0.0" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397211159" completion="0.0" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397230402" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397252455" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397266345" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397269896" completion="0.0" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397293731" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397305556" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397319402" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397333290" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397341922" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397373331" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398106967" completion="1.0" successCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397445096" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397486303" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397509555" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398134444" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398146703" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398173073" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398189283" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398196820" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398210583" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398221041" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398230780" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398291710" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397553331" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397730445" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397878797" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397886130" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397903606" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397925751" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490397984146" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398030316" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398076542" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490398082070" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
