<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643012825" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class AbstractAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643294110" sizeMeasure="23" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="abstract class AbstractAccount {&#xA;&#x9;private double balance;&#xA;&#x9;&#xA;&#x9;void deposit(double amount){&#xA;&#x9;&#x9;if(amount > 0){&#xA;&#x9;&#x9;&#x9;this.balance += amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void withdraw(amount){&#xA;&#x9;&#x9;if(amount > 0){&#xA;&#x9;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="29" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643301005" sizeMeasure="23" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double " edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="241" end="-119"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643434057" sizeMeasure="32" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void deposit(double amount){&#xA;&#x9;&#x9;if(amount > 0){&#xA;&#x9;&#x9;&#x9;this.balance += amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount){&#xA;&#x9;&#x9;if(amount > 0){&#xA;&#x9;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;abstract void internalWithdraw(double amount){&#xA;&#x9;&#x9;if(amount &lt;= this.balance){&#xA;&#x9;&#x9;&#x9;this.balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalState" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="90" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643457910" sizeMeasure="25" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="426" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643483726" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public double getBalance(){&#xA;&#x9;&#x9;return this.balance;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="428" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643521960" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="AbstractAccount() {&#xA;&#x9;&#x9;this.balance = 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="97" end="-402"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643751314" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="65" end="-471"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643930758" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rotected" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="487" end="-51"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643552755" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643612732" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="48" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643622085" sizeMeasure="15" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if(amount &lt;= this.balance){&#xA;&#x9;&#x9;&#x9;this.balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="74" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643652270" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.getBalance()){&#xA;&#x9;&#x9;&#x9;super.deposit(amount)" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="140" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643707329" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="74" end="-164"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643770515" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if(amount &lt;= super.getBalance()){&#xA;&#x9;&#x9;&#x9;super.balance -= amount" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="74" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643853601" sizeMeasure="16" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="75" end="-166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643897460" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount){&#xA;&#x9;&#x9;super.withdraw(amount);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="75" end="-168"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490643915681" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void deposit(double amount){&#xA;&#x9;&#x9;super.deposit(amount);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="75" end="-237"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644013619" sizeMeasure="9">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;&#x9;public CreditAccount() {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644031287" sizeMeasure="9" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-78"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644039850" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="147" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644116931" sizeMeasure="15" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private double creditLine;&#xA;&#xA;&#x9;public CreditAccount(double creditLine){&#xA;&#x9;&#x9;this.creditLine = creditLine;" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="74" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644164191" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;//Getter&#xA;&#x9;public double getCreditLine(){&#xA;&#x9;&#x9;return this.creditLine;&#xA;&#x9;}&#xA;&#x9;//Getter&#xA;&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if(amount &lt;= this.balance){&#xA;&#x9;&#x9;&#x9;this.balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="180" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644224333" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="setCreditLine(creditLine);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//Getter&#xA;&#x9;public double getCreditLine(){&#xA;&#x9;&#x9;return this.creditLine;&#xA;&#x9;}&#xA;&#x9;//Getter&#xA;&#x9;&#xA;&#x9;//Setter&#xA;&#x9;public void setCreditLine(double creditLine){&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}&#xA;&#x9;//S" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="152" end="-165"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644380757" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if((this.getCreditLine() + super.getBalance()) &lt; 0)&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="326" end="-205"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644413975" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="> 0){&#xA;&#x9;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="373" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644643045" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.creditLine >= 0){&#xA;&#x9;&#x9;&#x9;if(amount &lt;= this.balance + this.creditLine){&#xA;&#x9;&#x9;&#x9;&#x9;this.balance -= amount;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgument" edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="525" end="-24"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644662081" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(this.balance + this.creditLine)" edit="/1/@proposals.0/@proposals.3/@attempts.8/@edit" start="564" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644726482" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="creditLine = creditLine" edit="/1/@proposals.0/@proposals.3/@attempts.9/@edit" start="152" end="-572"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644741382" sizeMeasure="41" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(creditLine);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//Getter&#xA;&#x9;public double getCreditLine(){&#xA;&#x9;&#x9;return this.creditLine;&#xA;&#x9;}&#xA;&#x9;//Getter&#xA;&#x9;&#xA;&#x9;//Setter&#xA;&#x9;public void setCreditLine(double creditLine){&#xA;&#x9;&#x9;if((this.getCreditLine() + super.getBalance()) >=" edit="/1/@proposals.0/@proposals.3/@attempts.10/@edit" start="162" end="-375"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644764128" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="setC" edit="/1/@proposals.0/@proposals.3/@attempts.11/@edit" start="152" end="-594"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644820477" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="creditLine >= 0){&#xA;&#x9;&#x9;&#x9;if((this.getCreditLine() + super.getBalance()) >= 0){&#xA;&#x9;&#x9;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.12/@edit" start="329" end="-284"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644836105" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.3/@attempts.13/@edit" start="528" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644850721" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Argument" edit="/1/@proposals.0/@proposals.3/@attempts.14/@edit" start="528" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644913718" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.15/@edit" start="838" end="-839"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490644984154" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="creditLine" edit="/1/@proposals.0/@proposals.3/@attempts.16/@edit" start="354" end="-465"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645240547" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public " edit="/1/@proposals.0/@proposals.3/@attempts.17/@edit" start="561" end="-268"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645011703" sizeMeasure="9">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;&#x9;public SavingsAccount2() {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645015522" sizeMeasure="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="84" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645026193" sizeMeasure="9" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="51" end="-41"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645044614" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;void internalWithdraw(double amount" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="112" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645156033" sizeMeasure="17" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private int withdrawals;&#xA;&#x9;private int maxWithdrawals;&#xA;&#x9;private double fee;&#xA;&#xA;&#x9;public SavingsAccount2(int maxWithdrawals, double fee){&#xA;&#x9;&#x9;this.maxWithdrawals = maxWithdrawals;&#xA;&#x9;&#x9;this.fee = fee;" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="76" end="-55"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645246252" sizeMeasure="30" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if(amount > 0){&#xA;&#x9;&#x9;&#x9;if(this.getRemainingWithdrawals() > 0){&#xA;&#x9;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;&#x9;this.withdrawals += 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.4/@edit" start="273" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645270155" sizeMeasure="32" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int getRemainingWithdrawals(){&#xA;&#x9;&#x9;return this.maxWithdrawals - this.withdrawals;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.5/@edit" start="556" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645310436" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super.balance -= amount + this.fee" edit="/1/@proposals.0/@proposals.5/@attempts.6/@edit" start="454" end="-164"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645395327" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount &lt; super.getBalance()){&#xA;&#x9;&#x9;&#x9;&#x9;if(this.getRemainingWithdrawals() > 0){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.withdrawals += 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount + this.fee;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.5/@attempts.7/@edit" start="343" end="-158"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645398627" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.8/@edit" start="596" end="-158"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645423674" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= super.getBalance()){&#xA;&#x9;&#x9;&#x9;&#x9;if(this.getRemainingWithdrawals() > 0){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.withdrawals += 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount + this.fee;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.9/@edit" start="351" end="-158"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645556790" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//super.balance -= amount + this.fee;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException()" edit="/1/@proposals.0/@proposals.5/@attempts.10/@edit" start="497" end="-223"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645571102" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.11/@edit" start="497" end="-297"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645589316" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.12/@edit" start="537" end="-223"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490645805980" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" super.getBalance()){&#xA;&#x9;&#x9;&#x9;&#x9;if(this.getRemainingWithdrawals() > 0){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.withdrawals += 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount + this.fee" edit="/1/@proposals.0/@proposals.5/@attempts.13/@edit" start="351" end="-223"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490648022427" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if(amount > 0){&#xA;&#x9;&#x9;&#x9;if(amount &lt; super.getBalance()){&#xA;&#x9;&#x9;&#x9;&#x9;if(this.getRemainingWithdrawals() > 0){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.withdrawals += 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if(this.getBalance() + this.fee > 0){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount + this.fee;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.14/@edit" start="273" end="-222"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490648031035" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.5/@attempts.15/@edit" start="533" end="-334"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490648148288" sizeMeasure="58" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (withdrawls > 0){&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;&#x9;withdrawls -= 1;&#xA;&#x9;&#x9;} else if (balance >= amount + fee){&#xA;&#x9;&#x9;&#x9;balance -= amount + fee ;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if(amount > 0){&#xA;&#x9;&#x9;&#x9;if(amount &lt; super.getBalance()){&#xA;&#x9;&#x9;&#x9;&#x9;if(this.getRemainingWithdrawals() > 0){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;super.balance -= amount;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.withdrawals += 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if(amount + this.fee &lt;= super.getBalance()" edit="/1/@proposals.0/@proposals.5/@attempts.16/@edit" start="273" end="-332"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490648154697" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.17/@edit" start="272" end="-601"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490643965127" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490648271077" completion="1.0" successCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490644676215" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490644747166" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490644770195" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490644826150" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490644840607" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490644856443" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490644990945" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490648266629" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490645323585" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490645405203" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490645428452" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490645564141" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490645623578" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490645810956" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490648037950" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490648159403" completion="1.0" successCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490648280806" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
