<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardContainerImpl superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CardContainerImpl"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardContainerImpl class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CardContainerImpl"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Update the source code for the CardDeck class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardDeck class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Update the source code for the CardHand class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardHand class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Update the source code for the CardContainer interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CardContainer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardDeckTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CardDeckTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardHandTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CardHandTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490812126847" sizeMeasure="39">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Iterator;&#xA;&#xA;public class CardContainerImpl implements CardContainer {&#xA;&#xA;&#x9;protected ArrayList&lt;Card> cards;&#xA;&#x9;private int maxCardCount;&#xA;&#x9;&#xA;&#x9;public CardContainerImpl(int maxCardCount) {&#xA;&#x9;&#x9;cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;cards.ensureCapacity(maxCardCount);&#xA;&#x9;&#x9;this.maxCardCount = maxCardCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getMaxCardCount() {&#xA;&#x9;&#x9;return maxCardCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return cards.size();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public Card getCard(int n) throws IllegalArgumentException {&#xA;&#x9;&#x9;if (n >= 0 &amp;&amp; n &lt; cards.size()) {&#xA;&#x9;&#x9;&#x9;return cards.get(n);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public Iterator&lt;Card> iterator() {&#xA;&#x9;&#x9;return new CardContainerIterator(this);&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490812176476" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="453" end="-317"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490812178127" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="453" end="-317"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490812154145" sizeMeasure="32">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;import java.util.ArrayList;&#xA;&#xA;public class CardDeck extends CardContainerImpl {&#xA;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;super(52);&#xA;&#x9;&#x9;char[] suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#x9;for (char suit : suits) {&#xA;&#x9;&#x9;&#x9;for (int face = 1; face &lt;= n; face++) {&#xA;&#x9;&#x9;&#x9;&#x9;cards.add(new Card(suit, face));&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void shufflePerfectly() {&#xA;&#x9;&#x9;ArrayList&lt;Card> shuffledDeck = new ArrayList&lt;>(cards.size());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; (cards.size() / 2); i++) {&#xA;&#x9;&#x9;&#x9;shuffledDeck.add(cards.get(i));&#xA;&#x9;&#x9;&#x9;shuffledDeck.add(cards.get((cards.size() / 2) + i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;cards = shuffledDeck;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deal(CardHand hand, int n) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; n; i++) {&#xA;&#x9;&#x9;&#x9;hand.addCard(cards.remove(this.getCardCount() - 1));&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490812010003" sizeMeasure="19">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CardHand extends CardContainerImpl {&#xA;&#x9;&#xA;&#x9;public CardHand(int maxCardCount) {&#xA;&#x9;&#x9;super(maxCardCount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addCard(Card card) throws IllegalStateException {&#xA;&#x9;&#x9;if (getCardCount() == getMaxCardCount()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;cards.add(card);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card play(int n) {&#xA;&#x9;&#x9;return cards.remove(n);&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490812200483" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490812166582" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
