package list.printer;

import java.util.ArrayList;

public class ListOfSolutionsGenerator {

	public ArrayList<String> assignmentFiveTasks = new ArrayList<String>();
	public ArrayList<String> assignmentSixTasks = new ArrayList<String>();
	public ArrayList<String> assignmentEightTasks = new ArrayList<String>();
	public ArrayList<String> assignmentNineTasks = new ArrayList<String>();
	public ArrayList<String> easyAssignmentTasks = new ArrayList<String>();
	public ArrayList<String> intermediateAssignmentTasks = new ArrayList<String>();
	public ArrayList<String> hardAssignmentTasks = new ArrayList<String>();
	public ArrayList<String> fullAssignments = new ArrayList<String>();
	
	
	public ListOfSolutionsGenerator(){
		generateAssignmentFive();
		generateAssignmentSix();
		generateAssignmentEight();
		generateAssignmentNine();
		
		generateFullAssignments();
		//generateEasyAssignmentTasks();
		//generateMediumAssignmentTasks();
		//generateHardAssignmentTasks();
	}
	
	private void generateFullAssignments() {
		//TheEntireAssignment Five
		fullAssignments.add("/objectstructures/");
		//TheEntireAssignment Six    
		fullAssignments.add("/interfaces/");
		//TheEntireAssignment Eight
		fullAssignments.add("/patterns/");
		//TheEntireAssignment Nine
		fullAssignments.add("/inheritance/");
	}
	
	
	private void generateAssignmentFive() {
            assignmentFiveTasks.add("/objectstructures/easyCardPart2");
            assignmentFiveTasks.add("/objectstructures/easy2Partner");
        
            assignmentFiveTasks.add("/objectstructures/medium2Twitter");
            assignmentFiveTasks.add("/objectstructures/mediumStopWatch");
            
            assignmentFiveTasks.add("/objectstructures/hardPerson");
	}
	
	private void generateAssignmentSix() {
		assignmentSixTasks.add("/interfaces/easyCardContainer");
		assignmentSixTasks.add("/interfaces/easyCardComparator");
		
		assignmentSixTasks.add("/interfaces/mediumTwitter");
		assignmentSixTasks.add("/interfaces/mediumNamed");
		
		assignmentSixTasks.add("/interfaces/hardStringGrid");
		assignmentSixTasks.add("/interfaces/hardBinaryComputingIterator");
	}
	
	private void generateAssignmentEight() {
		assignmentEightTasks.add("/patterns/easyStockListener");
		assignmentEightTasks.add("/patterns/mediumOffice");
		assignmentEightTasks.add("/patterns/hardLogger");
	}
	
	private void generateAssignmentNine() {
		assignmentNineTasks.add("/inheritance/easyAbstractAccount");
		assignmentNineTasks.add("/inheritance/easyCardContainer");

		assignmentNineTasks.add("/inheritance/mediumAbstractCalculator");
		assignmentNineTasks.add("/inheritance/mediumTrain");

		assignmentNineTasks.add("/inheritance/hardObservableList");
		assignmentNineTasks.add("/inheritance/hardSavingsAccount");
	}
	
	private void generateEasyAssignmentTasks(){
	      assignmentFiveTasks.add("/objectstructures/easyCardPart2");
          assignmentFiveTasks.add("/objectstructures/easy2Partner");
          assignmentNineTasks.add("/inheritance/easyAbstractAccount");
          assignmentNineTasks.add("/inheritance/easyCardContainer");
          assignmentEightTasks.add("/patterns/easyStockListener");
          assignmentSixTasks.add("/interfaces/easyCardContainer");
          assignmentSixTasks.add("/interfaces/easyCardComparator");
          assignmentFiveTasks.add("/objectstructures/easyCardPart2");
          assignmentFiveTasks.add("/objectstructures/easy2Partner");
	}
	
	private void generateMediumAssignmentTasks() {
		assignmentNineTasks.add("/inheritance/mediumAbstractCalculator");
		assignmentNineTasks.add("/inheritance/mediumTrain");
		assignmentEightTasks.add("/patterns/mediumOffice");
		assignmentSixTasks.add("/interfaces/mediumTwitter");
		assignmentSixTasks.add("/interfaces/mediumNamed");
        assignmentFiveTasks.add("/objectstructures/medium2Twitter");
        assignmentFiveTasks.add("/objectstructures/mediumStopWatch");

		
	}
	
	private void generateHardAssignmentTasks() {
		assignmentNineTasks.add("/inheritance/hardObservableList");
		assignmentNineTasks.add("/inheritance/hardSavingsAccount");
        assignmentFiveTasks.add("/objectstructures/hardPerson");
		assignmentEightTasks.add("/patterns/hardLogger");
		assignmentSixTasks.add("/interfaces/hardStringGrid");
		assignmentSixTasks.add("/interfaces/hardBinaryComputingIterator");
	}
}
