<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487871374628" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Person {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487873373620" sizeMeasure="63" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;&#xA;public class Person {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#x9;private Person child;&#xA;&#x9;private ArrayList&lt;Person> children = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender){&#xA;&#x9;&#x9;this.name=name;&#xA;&#x9;&#x9;this.gender=gender;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;if(!this.children.contains(person)){&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeChildren(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.getFather();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;public int getChildrenCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Heidi&quot;,'F');&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Frank&quot;,'M');&#xA;&#x9;&#x9;Person p3 = new Person(&quot;Dennis&quot;,'M');&#xA;&#x9;&#x9;p1.addChild(p3);&#xA;&#x9;&#x9;System.out.println(p1.getChildrenCount());&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="27" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487873385434" sizeMeasure="64" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p1.addChild(p2" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1125" end="-56"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487873966603" sizeMeasure="90" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildrenCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.father=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.getFather();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Heidi&quot;,'F');//mamma&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Frank&quot;,'M');//pappa&#xA;&#x9;&#x9;Person p3 = new Person(&quot;Dennis&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p4 = new Person(&quot;Ole&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p5 = new Person(&quot;Peter&quot;,'M');//bestefar&#xA;&#x9;&#x9;Person p6 = new Person(&quot;Olga&quot;,'M');//bestemor&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="609" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874483581" sizeMeasure="101" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;}&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;if(!this.children.contains(person)){&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChildren(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildrenCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.father=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.getFather();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Heidi&quot;,'F');//mamma&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Frank&quot;,'M');//pappa&#xA;&#x9;&#x9;Person p3 = new Person(&quot;Dennis&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p4 = new Person(&quot;Ole&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p5 = new Person(&quot;Peter&quot;,'M');//bestefar&#xA;&#x9;&#x9;Person p6 = new Person(&quot;Olga&quot;,'M');//bestemor&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;p1.addChild(p3);&#xA;&#x9;&#x9;p1.addChild(p2);&#xA;&#x9;&#x9;System.out.println(p3.getMother" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="372" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874534147" sizeMeasure="105" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return this.getName();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1374" end="-413"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874572831" sizeMeasure="105" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="name" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1463" end="-417"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874581785" sizeMeasure="105" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;hei&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1458" end="-417"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874603416" sizeMeasure="105" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.getName();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Heidi&quot;,'F');//mamma&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Frank&quot;,'M');//pappa&#xA;&#x9;&#x9;Person p3 = new Person(&quot;Dennis&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p4 = new Person(&quot;Ole&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p5 = new Person(&quot;Peter&quot;,'M');//bestefar&#xA;&#x9;&#x9;Person p6 = new Person(&quot;Olga&quot;,'M');//bestemor&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;p1.addChild(p3);&#xA;&#x9;&#x9;p1.addChild(p2);&#xA;&#x9;&#x9;System.out.println(p1.getChild(0" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1458" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874619437" sizeMeasure="106" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1866" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874634313" sizeMeasure="106" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="374" end="-1540"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874648761" sizeMeasure="106" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3.getMother(" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1890" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874669249" sizeMeasure="106" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1844" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874699570" sizeMeasure="106" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p1.removeChildren(p3);" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1844" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874756019" sizeMeasure="112" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="731" end="-1182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487874877380" sizeMeasure="112" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1942" end="-93"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875099881" sizeMeasure="116" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.children.contains(person)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(this.gender=='F' &amp;&amp; person.getMother()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChildren(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildrenCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.father=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.getFather();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return this.getName();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Heidi&quot;,'F');//mamma&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Frank&quot;,'M');//pappa&#xA;&#x9;&#x9;Person p3 = new Person(&quot;Dennis&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p4 = new Person(&quot;Ole&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p5 = new Person(&quot;Peter&quot;,'M');//bestefar&#xA;&#x9;&#x9;Person p6 = new Person(&quot;Olga&quot;,'M');//bestemor&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;p1.addChild(p3" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="418" end="-93"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875126461" sizeMeasure="117" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(p1.getChildrenCount" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="2106" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875183290" sizeMeasure="117" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Navn: &quot; + this.getName() + &quot;Barn:&quot; + children.toString" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1657" end="-489"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875257736" sizeMeasure="117" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" Foreldre: &quot; + this.getFather() + &quot; og &quot; + this.getMother" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1686" end="-489"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875298705" sizeMeasure="117" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=null;&#xA;&#x9;private Person father=null;&#xA;&#x9;private Person child=null" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="175" end="-2010"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875312260" sizeMeasure="117" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";//" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="1697" end="-550"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875456325" sizeMeasure="118" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Fa" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="2224" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875857836" sizeMeasure="122" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;private Person father;&#xA;&#x9;private Person child;&#xA;&#x9;private ArrayList&lt;Person> children = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender){&#xA;&#x9;&#x9;this.name=name;&#xA;&#x9;&#x9;this.gender=gender;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;if(this.children.contains(person)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(this.gender=='F' &amp;&amp; person.getMother()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChildren(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildrenCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.mother!=null){&#xA;&#x9;&#x9;this.mother=null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="175" end="-1062"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875868152" sizeMeasure="121" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="2259" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875884057" sizeMeasure="123" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3);&#xA;&#x9;&#x9;p1.addChild(p3);&#xA;&#x9;&#x9;p1.addChild(p2);&#xA;&#x9;&#x9;p1.removeChildren(p3);&#xA;&#x9;&#x9;System.out.println(p3.getMo" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="2165" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875923800" sizeMeasure="120" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return &quot;Navn: &quot; + this.getName();// + &quot; Foreldre: &quot; + this.getFather() + &quot; og &quot; + this.getMother();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Heidi&quot;,'F');//mamma&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Frank&quot;,'M');//pappa&#xA;&#x9;&#x9;Person p3 = new Person(&quot;Dennis&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p4 = new Person(&quot;Ole&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p5 = new Person(&quot;Peter&quot;,'M');//bestefar&#xA;&#x9;&#x9;Person p6 = new Person(&quot;Olga&quot;,'M');//bestemor&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1663" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487875977291" sizeMeasure="120" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="2247" end="-2248"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876258854" sizeMeasure="121" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3.getFa" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="2217" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876288069" sizeMeasure="121" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildrenCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.mother!=null){&#xA;&#x9;&#x9;this.mother=null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.father=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.getFather();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Navn: &quot; + this.getName();// + &quot; Foreldre: &quot; + this.getFather() + &quot; og &quot; + this.getMother();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Heidi&quot;,'F');//mamma&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Frank&quot;,'M');//pappa&#xA;&#x9;&#x9;Person p3 = new Person(&quot;Dennis&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p4 = new Person(&quot;Ole&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p5 = new Person(&quot;Peter&quot;,'M');//bestefar&#xA;&#x9;&#x9;Person p6 = new Person(&quot;Olga&quot;,'M');//bestemor&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;p1.addChild(p3);&#xA;&#x9;&#x9;p1.addChild(p2);&#xA;&#x9;&#x9;p1.removeChild" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="723" end="-135"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876391480" sizeMeasure="122" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3.addChild(p5);&#xA;&#x9;&#x9;p1.addChild(p2);&#xA;&#x9;&#x9;p1.removeChild(p3);&#xA;&#x9;&#x9;System.out.println(p3.getMother());&#xA;&#x9;&#x9;System.out.println(p5" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="2113" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876425620" sizeMeasure="121" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;System.out.println(p3.getMother());&#xA;&#x9;&#x9;System.out.println(p5.getFather());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="2131" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876434005" sizeMeasure="121" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="2172" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876472519" sizeMeasure="121" warningCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="2112" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876535496" sizeMeasure="121" warningCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="F');//bestemor&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//p1.addChild(p3);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="2070" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876543025" sizeMeasure="121" warningCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="2136" end="-87"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876588147" sizeMeasure="120" warningCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="2135" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876599284" sizeMeasure="120" errorCount="1" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*public Person getFather(){&#xA;&#x9;&#x9;return this.getFather();&#xA;&#x9;}*/" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1560" end="-531"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876618222" sizeMeasure="120" warningCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;//person.setFather(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="592" end="-1462"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876688175" sizeMeasure="120" warningCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=null;&#xA;&#x9;private Person child;&#xA;&#x9;private ArrayList&lt;Person> children = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender){&#xA;&#x9;&#x9;this.name=name;&#xA;&#x9;&#x9;this.gender=gender;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;if(this.children.contains(person)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(this.gender=='F' &amp;&amp; person.getMother()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildrenCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.mother!=null){&#xA;&#x9;&#x9;this.mother=null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.father=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.getFather();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="199" end="-531"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876771984" sizeMeasure="120" warningCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;private Person child;&#xA;&#x9;private ArrayList&lt;Person> children = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender){&#xA;&#x9;&#x9;this.name=name;&#xA;&#x9;&#x9;this.gender=gender;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;if(this.children.contains(person)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(this.gender=='F' &amp;&amp; person.getMother()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' ){//" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="199" end="-1530"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876795974" sizeMeasure="120" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildrenCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.mother!=null){&#xA;&#x9;&#x9;this.mother=null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.father=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.father" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="617" end="-535"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876842061" sizeMeasure="120" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="1023" end="-1116"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876898891" sizeMeasure="120" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new IllegalArgumentException()" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="1144" end="-989"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876915363" sizeMeasure="120" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new IllegalArgumentException()" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="1363" end="-800"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487876975734" sizeMeasure="123" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(person.getFather()!=null){&#xA;&#x9;&#x9;&#x9;person.setFather(null" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="1407" end="-801"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877278452" sizeMeasure="123" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//if(person==)&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(this.gender=='F' &amp;&amp; person.getMother()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null || person.getGender()=='M'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.mother!=null){&#xA;&#x9;&#x9;this.mother=null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null || person.getGender()=='F'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="471" end="-795"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877515616" sizeMeasure="124" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(this.gender=='F' &amp;&amp; person.getMother()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;person.getMother().removeChild(person);" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="471" end="-1701"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877529215" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getFather().removeChild(person);" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="708" end="-1610"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877538427" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="701" end="-1649"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877626137" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="566" end="-1786"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877641272" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="566" end="-1786"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877649967" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="701" end="-1649"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877667908" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//person.getMother().removeChild(person);&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="566" end="-1649"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877709299" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new IllegalArgumentException()" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="454" end="-1894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877737255" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="452" end="-1932"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877751863" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;return" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="452" end="-1894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877816792" sizeMeasure="125" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="==null" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="553" end="-1795"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487877901694" sizeMeasure="129" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(person.getMother()!=null){&#xA;&#x9;&#x9;&#x9;person.getMother().removeChild(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(person.getFather()!=null){&#xA;&#x9;&#x9;&#x9;person.getFather().removeChild(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(this.gender=='F' &amp;&amp; person.getMother()==null){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;//person.getFather().removeChild(person);&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="471" end="-1566"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878174726" sizeMeasure="124" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;person.setMother(null" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="471" end="-1804"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878184563" sizeMeasure="123" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="502" end="-1802"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487933766586" sizeMeasure="130" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Person> children = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender){&#xA;&#x9;&#x9;this.name=name;&#xA;&#x9;&#x9;this.gender=gender;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;if(this.children.contains(person)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;//if(person.getMother()!=null){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//person.getMother().removeChild(person);&#xA;&#x9;&#x9;&#x9;&#x9;//}&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;//person.getFather().removeChild(person);&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;return children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getChildCount(){&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null || person.getGender()=='M'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.mother!=null){&#xA;&#x9;&#x9;this.mother=null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(this==person|| person==null || person.getGender()=='F'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.father=person;&#xA;&#x9;&#x9;person.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.father;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Navn: &quot; + this.getName();// + &quot; Foreldre: &quot; + this.getFather() + &quot; og &quot; + this.getMother();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Heidi&quot;,'F');//mamma&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Frank&quot;,'M');//pappa&#xA;&#x9;&#x9;Person p3 = new Person(&quot;Dennis&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p4 = new Person(&quot;Ole&quot;,'M');//sønn&#xA;&#x9;&#x9;Person p5 = new Person(&quot;Peter&quot;,'M');//bestefar&#xA;&#x9;&#x9;Person p6 = new Person(&quot;Olga&quot;,'F');//bestemor&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//p1.addChild(p3);&#xA;&#x9;&#x9;p3.setMother(p1); //setter Heidi som mor til Dennis&#xA;&#x9;&#x9;p4.addChild(p1); // heidi er barn av ole&#xA;&#x9;&#x9;p6.addChild(p3); //Olga er moren til Dennis, ikke Heidi&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(p3.getMother());&#xA;&#x9;&#x9;System.out.println(p1.getChildCount()" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="210" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487933864071" sizeMeasure="130" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(person.getMother()!=null){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;person.getMother().removeChild(person);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M' &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;//person.getFather().removeChild(person);&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;if(children.contains(person)){&#xA;&#x9;&#x9;&#x9;children.remove(person);&#xA;&#x9;&#x9;&#x9;/*if(this.gender=='F'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;person.setFather(null);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;*/&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="513" end="-1547"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487933898812" sizeMeasure="132" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;person.getMother().removeChild(person);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.gender=='M'){&#xA;&#x9;&#x9;&#x9;&#x9;if( &amp;&amp; person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;person.getMother().removeChild(person);&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="536" end="-1825"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487933917527" sizeMeasure="132" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person.getFather()!=this){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;person.getFa" edit="/1/@proposals.0/@proposals.0/@attempts.63/@edit" start="669" end="-1858"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487933925159" sizeMeasure="132" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null" edit="/1/@proposals.0/@proposals.0/@attempts.64/@edit" start="689" end="-1878"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487933933439" sizeMeasure="132" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null" edit="/1/@proposals.0/@proposals.0/@attempts.65/@edit" start="536" end="-2031"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487934022808" sizeMeasure="132" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person.getFather().removeChild(person);" edit="/1/@proposals.0/@proposals.0/@attempts.66/@edit" start="1557" end="-1014"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487934044197" sizeMeasure="134" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(person.getFather()!=null){&#xA;&#x9;&#x9;person.getFather().removeChild(person);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.67/@edit" start="1557" end="-1014"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487934216601" sizeMeasure="135" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.getFather()!=null){&#xA;&#x9;&#x9;this.getFather().removeChild(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.68/@edit" start="1560" end="-1014"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487934250298" sizeMeasure="135" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.0/@attempts.69/@edit" start="1616" end="-1023"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487934433716" sizeMeasure="135" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".removeChild(this)" edit="/1/@proposals.0/@proposals.0/@attempts.70/@edit" start="1347" end="-1291"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487873373317" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487873385284" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487873966465" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874483435" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874534015" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874572701" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874581652" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874603287" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874618982" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874634189" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874648028" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874699342" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874755929" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874836101" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487874877286" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875099748" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875126366" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875183158" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875257641" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875298606" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875312116" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875456193" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875857733" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875868007" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875883964" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875923704" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487875977202" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876258720" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876287964" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876391348" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876425517" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876433905" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876472414" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876535383" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876542873" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876588049" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876599155" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876618124" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876688068" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876771836" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487876795882" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487878174383" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="0.6923076923076923">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487874002975" completion="0.0" failureCount="5" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487874671026" completion="0.0" failureCount="4" errorCount="9"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487875891092" completion="0.0" failureCount="3" errorCount="10"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487876800876" completion="0.0" failureCount="4" errorCount="9"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487876843599" completion="0.38461538461538464" successCount="5" failureCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487876900293" completion="0.46153846153846156" successCount="6" failureCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487876916941" completion="0.5384615384615384" successCount="7" failureCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487876977304" completion="0.5384615384615384" successCount="7" failureCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877279901" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877517926" completion="0.6153846153846154" successCount="8" failureCount="3" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877530798" completion="0.5384615384615384" successCount="7" failureCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877539825" completion="0.6153846153846154" successCount="8" failureCount="3" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877627567" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877642916" completion="0.6153846153846154" successCount="8" failureCount="3" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877651508" completion="0.5384615384615384" successCount="7" failureCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877669445" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877710788" completion="0.5384615384615384" successCount="7" failureCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877738820" completion="0.5384615384615384" successCount="7" failureCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877753619" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877818353" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487877903157" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487878179452" completion="0.38461538461538464" successCount="5" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487878186190" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487933768227" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487933866446" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487933900372" completion="0.38461538461538464" successCount="5" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487933919155" completion="0.5384615384615384" successCount="7" failureCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487933926598" completion="0.6153846153846154" successCount="8" failureCount="1" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487933934925" completion="0.6923076923076923" successCount="9" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487934024318" completion="0.5384615384615384" successCount="7" errorCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487934045417" completion="0.6923076923076923" successCount="9" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487934218292" completion="0.6923076923076923" successCount="9" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487934251997" completion="0.6923076923076923" successCount="9" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487934435878" completion="0.6923076923076923" successCount="9" errorCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
