<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StopWatch and StopWatchManager">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StopWatch class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.StopWatch"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StopWatchManager class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.StopWatchManager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StopWatch class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.StopWatch"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StopWatchManager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.StopWatchManager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StopWatchTest."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.StopWatchTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StopWatchManagerTest."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.StopWatchManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.StopWatch*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487189734040" sizeMeasure="66" warningCount="16">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.HashMap;&#xA;import java.util.Iterator;&#xA;import java.util.Map;&#xA;import java.util.Set;&#xA;&#xA;public class StopWatchManager {&#xA;&#x9;private HashMap&lt;String, StopWatch> stopWatches = new HashMap&lt;String, StopWatch>();&#xA;&#x9;public StopWatch newStopWatch(String name){&#xA;&#x9;&#x9;StopWatch newWatch = new StopWatch();&#xA;&#x9;&#x9;stopWatches.put(name, newWatch);&#xA;&#x9;&#x9;return newWatch;&#xA;&#x9;}&#xA;&#x9;public void removeStopWatch(String name){&#xA;&#x9;&#x9;stopWatches.remove(name);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void tick(int ticks){&#xA;&#x9;&#x9;Set set = stopWatches.entrySet();&#xA;&#x9;&#x9;Iterator iterator = set.iterator();&#xA;&#x9;&#x9;while(iterator.hasNext()){&#xA;&#x9;&#x9;&#x9;Map.Entry pair = (Map.Entry)iterator.next();&#xA;&#x9;&#x9;&#x9;((StopWatch) pair.getValue()).tick(ticks);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public StopWatch getStopWatch(String name){&#xA;&#x9;&#x9;return stopWatches.get(name);&#xA;&#x9;}&#xA;&#x9;public Collection&lt;StopWatch> getAllWatches(){&#xA;&#x9;&#x9;ArrayList&lt;StopWatch> watches = new ArrayList&lt;StopWatch>();&#xA;&#x9;&#x9;Set set = stopWatches.entrySet();&#xA;&#x9;&#x9;Iterator iterator = set.iterator();&#xA;&#x9;&#x9;while(iterator.hasNext()){&#xA;&#x9;&#x9;&#x9;Map.Entry pair = (Map.Entry)iterator.next();&#xA;&#x9;&#x9;&#x9;watches.add((StopWatch) pair.getValue());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return watches;&#xA;&#x9;}&#xA;&#x9;public Collection&lt;StopWatch> getStartedWatches(){&#xA;&#x9;&#x9;ArrayList&lt;StopWatch> started = new ArrayList&lt;StopWatch>();&#xA;&#x9;&#x9;Set set = stopWatches.entrySet();&#xA;&#x9;&#x9;Iterator iterator = set.iterator();&#xA;&#x9;&#x9;while(iterator.hasNext()){&#xA;&#x9;&#x9;&#x9;Map.Entry pair = (Map.Entry)iterator.next();&#xA;&#x9;&#x9;&#x9;if(((StopWatch) pair.getValue()).isStarted()){&#xA;&#x9;&#x9;&#x9;&#x9;started.add((StopWatch) pair.getValue());&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return started;&#xA;&#x9;}&#xA;&#x9;public Collection&lt;StopWatch> getStoppedWatches(){&#xA;&#x9;&#x9;ArrayList&lt;StopWatch> stopped = new ArrayList&lt;StopWatch>();&#xA;&#x9;&#x9;Set set = stopWatches.entrySet();&#xA;&#x9;&#x9;Iterator iterator = set.iterator();&#xA;&#x9;&#x9;while(iterator.hasNext()){&#xA;&#x9;&#x9;&#x9;Map.Entry pair = (Map.Entry)iterator.next();&#xA;&#x9;&#x9;&#x9;if(((StopWatch) pair.getValue()).isStopped()){&#xA;&#x9;&#x9;&#x9;&#x9;stopped.add((StopWatch) pair.getValue());&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return stopped;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487189735603" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
