<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312804640" sizeMeasure="52">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#xA;&#x9;&#xA;&#x9;private TwitterAccount myAcc;&#xA;&#x9;private String myString;&#xA;&#x9;private Tweet myTweet;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, String str)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myString = str;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, Tweet twt)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myTweet = twt;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.myAcc;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getPrevTweet() {&#xA;&#x9;&#x9;return myTweet;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;if(myTweet.getPrevTweet() == null)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return 1 + myTweet.getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;if(myTweet.getPrevTweet() == null)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return myTweet.myString;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return myTweet.getText();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312835345" sizeMeasure="56" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="OriginalTweet()&#xA;&#x9;{&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;private" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="404" end="-347"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312846748" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="430" end="-347"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312893439" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(myTweet.getPrevTweet == null)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return myTweet;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="425" end="-360"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312898370" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="()" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="448" end="-396"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312963645" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = null;&#xA;&#x9;private String myString = null;&#xA;&#x9;private Tweet myTweet = null;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, String str)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myString = str;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, Tweet twt)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myTweet = twt;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.myAcc;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet()&#xA;&#x9;{&#xA;&#x9;&#x9;if(myTweet.getPrevTweet() == null)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return myTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return myTweet.getOriginalTweet()" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="80" end="-365"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315062035" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="702" end="-217"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315422875" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.myTweet == null)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return 1 + this." edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="656" end="-186"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488359668281" sizeMeasure="64" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public Tweet(TwitterAccount acc, String str)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myString = str;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, Tweet twt)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myTweet = twt;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//twt.addReetweet();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.myAcc;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet()&#xA;&#x9;{&#xA;&#x9;&#x9;if(myTweet.getPrevTweet() == null)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return myTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return myTweet.getOriginalTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="156" end="-298"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488359722176" sizeMeasure="65" errorCount="9" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="original_tweet = null;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, String str)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myString = str;&#xA;&#x9;&#x9;this.original_tweet = this" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="137" end="-644"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488359750998" sizeMeasure="65" errorCount="8" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="original_tweet = twt.getOriginalTweet()" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="366" end="-549"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488367867165" sizeMeasure="58" errorCount="5" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.original_tweet;" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="537" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368129474" sizeMeasure="65" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;private String myString;&#xA;&#x9;private Tweet original_tweet;&#xA;&#x9;private int retweets;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, String str)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myString = str;&#xA;&#x9;&#x9;this.original_tweet = this;&#xA;&#x9;&#x9;this.retweets = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, Tweet twt)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.original_tweet = twt.getOriginalTweet();&#xA;&#x9;&#x9;this.myString = original_tweet.getText();&#xA;&#x9;&#x9;original_tweet.add_retweet();&#xA;&#x9;&#x9;this.retweets = original_tweet.getRetweetCount();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void add_retweet()&#xA;&#x9;{&#xA;&#x9;&#x9;this.retweets++" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="80" end="-436"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368197113" sizeMeasure="58" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.retweets;" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="782" end="-156"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368218676" sizeMeasure="51" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.myString" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="837" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368276658" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="857" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368419216" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(twt.getOwner() == acc)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentExcetion();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="362" end="-507"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368423571" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="425" end="-517"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368430927" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="pt" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="424" end="-517"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368474434" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || twt.getOriginalTweet()" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="386" end="-575"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368573524" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(this.original_tweet == this)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="835" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368590482" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="835" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368662974" sizeMeasure="58" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private boolean isOriginal;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, String str)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myString = str;&#xA;&#x9;&#x9;this.original_tweet = this;&#xA;&#x9;&#x9;this.retweets = 0;&#xA;&#x9;&#x9;this.isOriginal = true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, Tweet twt)&#xA;&#x9;{&#xA;&#x9;&#x9;if(twt.getOwner() == acc || twt.getOriginalTweet().getOwner() == acc)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.original_tweet = twt.getOriginalTweet();&#xA;&#x9;&#x9;this.myString = original_tweet.getText();&#xA;&#x9;&#x9;original_tweet.add_retweet();&#xA;&#x9;&#x9;this.retweets = original_tweet.getRetweetCount();&#xA;&#x9;&#x9;this.isOriginal = false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void add_retweet()&#xA;&#x9;{&#xA;&#x9;&#x9;this.retweets++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.myAcc;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet()&#xA;&#x9;{" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="163" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368692358" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(this.isOriginal)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="917" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368703760" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == true" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="935" end="-180"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368715059" sizeMeasure="58" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="917" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368723877" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public Tweet(TwitterAccount acc, String str)&#xA;&#x9;{&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.myString = str;&#xA;&#x9;&#x9;this.original_tweet = this;&#xA;&#x9;&#x9;this.retweets = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount acc, Tweet twt)&#xA;&#x9;{&#xA;&#x9;&#x9;if(twt.getOwner() == acc || twt.getOriginalTweet().getOwner() == acc)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.myAcc = acc;&#xA;&#x9;&#x9;this.original_tweet = twt.getOriginalTweet();&#xA;&#x9;&#x9;this.myString = original_tweet.getText();&#xA;&#x9;&#x9;original_tweet.add_retweet();&#xA;&#x9;&#x9;this.retweets = original_tweet.getRetweetCount();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void add_retweet()&#xA;&#x9;{&#xA;&#x9;&#x9;this.retweets++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.myAcc;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet()&#xA;&#x9;{" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="163" end="-155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488368930936" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="986" end="-987"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369024601" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="986" end="-987"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311334278" sizeMeasure="61">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount ole) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount ole) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount ole) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public void unfollow(TwitterAccount ole) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String string) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#xA;&#x9;public void retweet(Tweet _tweet) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311413005" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private String myName;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.myName = string;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public String getUserName() {" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="58" end="-829"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311423067" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.myName" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="194" end="-815"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311539951" sizeMeasure="64" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;&#x9;private String myName;&#xA;&#x9;private int tweetCount;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.myName = string;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.myName;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() &#xA;&#x9;{&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount user) &#xA;&#x9;{" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="26" end="-648"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311612268" sizeMeasure="66" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;TwitterAccount> followers;&#xA;&#x9;private ArrayList&lt;TwitterAccount> following" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="136" end="-887"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311675796" sizeMeasure="70" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="followers.add(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(followers.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="467" end="-554"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311751654" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ing.add(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(following.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(followers.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="473" end="-446"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311803972" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="user) &#xA;&#x9;{&#xA;&#x9;&#x9;followers.remove(user);" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="786" end="-342"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312396946" sizeMeasure="75" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;Tweet> Tweets;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.myName = string;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.myName;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() &#xA;&#x9;{&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;following.add(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(following.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(followers.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public void unfollow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;followers.remove(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String string) &#xA;&#x9;{" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="228" end="-265"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312532957" sizeMeasure="76" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet temp = new Tweet(this,string);&#xA;&#x9;&#x9;this.Tweets.add();" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="900" end="-262"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312537461" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="temp" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="955" end="-264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312553916" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return Tweets.get(i)" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1000" end="-175"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312624119" sizeMeasure="75" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int myReTweets = 0;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.myName = string;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.myName;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() &#xA;&#x9;{&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;following.add(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(following.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(followers.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public void unfollow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;followers.remove(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String string) &#xA;&#x9;{&#xA;&#x9;&#x9;Tweet temp = new Tweet(this,string);&#xA;&#x9;&#x9;this.Tweets.add(temp);&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return Tweets.get(i);&#xA;&#x9;}&#xA;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.Tweets.add(tweet);" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="262" end="-93"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312655807" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.myReTweets++;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.myReTweets" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1118" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369383329" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if(!user.isFollowedBy(this))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;user.follow(this);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="552" end="-657"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369456645" sizeMeasure="78" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="202" end="-1043"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369612298" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ing;&#xA;&#x9;private ArrayList&lt;Tweet> Tweets;&#xA;&#x9;private int myReTweets = 0;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.myName = string;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.myName;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() &#xA;&#x9;{&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;following.add(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(following.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(user.isFollowing(this" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="176" end="-442"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369619251" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ing" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="819" end="-337"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369701243" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.Tweets.add(new Tweet(this,string)" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="881" end="-219"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369708482" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="881" end="-259"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369751930" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.Tweets.add(new Tweet(this,string));&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return Tweets.get(i);&#xA;&#x9;}&#xA;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.Tweets.add(new Tweet(this, tweet)" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="881" end="-93"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369824460" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-(i-Tweets.size())" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="978" end="-176"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369851661" sizeMeasure="73" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="math.abs(" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="978" end="-193"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369859876" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Math.abs" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="978" end="-193"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369952534" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+1" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="1003" end="-176"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370435634" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="1003" end="-176"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370474226" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int index = Math.abs(i-Tweets.size());&#xA;&#x9;&#x9;return Tweets.get(index" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="960" end="-176"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370590226" sizeMeasure="78" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.myName = string;&#xA;&#x9;&#x9;this.myReTweets = 0;&#xA;&#x9;&#x9;this.tweetCount = 0;&#xA;&#x9;&#x9;this.following = new ArrayList&lt;TwitterAccount>;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="238" end="-889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370643588" sizeMeasure="78" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.Tweets = new ArrayList&lt;Tweet>;" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="406" end="-889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370701744" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="();&#xA;&#x9;&#x9;this.Tweets = new ArrayList&lt;Tweet>()" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="402" end="-890"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370755174" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.tweetCount++" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="1057" end="-280"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371045814" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="1354" end="-1355"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371143173" sizeMeasure="78" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Tweet> reTweets;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.myName = string;&#xA;&#x9;&#x9;this.tweetCount = 0;&#xA;&#x9;&#x9;this.following = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;this.Tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;&#x9;this.reTweets = new ArrayList&lt;Tweet>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.myName;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() &#xA;&#x9;{&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;following.add(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(following.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(user.isFollowing(this))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public void unfollow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;following.remove(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String string) &#xA;&#x9;{&#xA;&#x9;&#x9;this.Tweets.add(new Tweet(this,string));&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;int index = Math.abs(i-Tweets.size());&#xA;&#x9;&#x9;return Tweets.get(index);&#xA;&#x9;}&#xA;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.Tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;this.myReTweets++;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="224" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371233480" sizeMeasure="81" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="reTweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;int retweet_count = 0;&#xA;&#x9;&#x9;for(Tweet tweet : Tweets)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;retweet_count += tweet.getRetweetCount();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1257" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371242134" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return retweet_count;" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1438" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371458523" sizeMeasure="82" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="1257" end="-209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371467119" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="re" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1257" end="-209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371615900" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="OriginalTweet()" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="1417" end="-55"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371645222" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="1417" end="-55"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375783594" sizeMeasure="82" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="z&#xA;&#x9;public TwitterAccount(String string) {&#xA;&#x9;&#x9;this.myName = string;&#xA;&#x9;&#x9;this.tweetCount = 0;&#xA;&#x9;&#x9;this.following = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;this.Tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;&#x9;this.reTweets = new ArrayList&lt;Tweet>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.myName;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() &#xA;&#x9;{&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;following.add(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(following.contains(user))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;if(user.isFollowing(this))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public void unfollow(TwitterAccount user) &#xA;&#x9;{&#xA;&#x9;&#x9;following.remove(user);&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String string) &#xA;&#x9;{&#xA;&#x9;&#x9;this.Tweets.add(new Tweet(this,string));&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;int index = Math.abs(i-Tweets.size());&#xA;&#x9;&#x9;return Tweets.get(index);&#xA;&#x9;}&#xA;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.reTweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;int retweet_count = 0;&#xA;&#x9;&#x9;for(Tweet tweet : Tweets)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;retweet_count += twe" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="252" end="-57"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375785529" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="251" end="-1216"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="0.75">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312697109" completion="0.0" failureCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312973563" completion="0.0" failureCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312988541" completion="0.0" failureCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488315064236" completion="0.0" failureCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488315425731" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488368233520" completion="0.0" failureCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488368280939" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488368479948" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488368578888" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488368594364" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488368696348" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488368707378" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488368728349" completion="0.75" successCount="3" failureCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="0.8333333333333334">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312682697" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313033097" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488369163473" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488369393984" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488369627828" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488369712208" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488369757450" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488369828927" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488369866417" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488369955182" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488370446571" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488370480531" completion="0.16666666666666666" successCount="1" errorCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488370707832" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488370775795" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488371246033" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488371463365" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488371621907" completion="0.8333333333333334" successCount="5" failureCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
