<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423104321" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Person {&#xA;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#x9;private ArrayList&lt;Person> childList;&#xA;&#x9;&#xA;&#x9;Person(String Name, char Gender){&#xA;&#x9;&#x9;this.name = Name;&#xA;&#x9;&#x9;this.gender = Gender;&#xA;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;this.childList = new ArrayList&lt;Person>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getGender() {&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getFather() {&#xA;&#x9;&#x9;return this.father;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int number){&#xA;&#x9;&#x9;if(number>=childList.size() || number&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;There is no child number&quot; + number);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return childList.get(number);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int ChildCount(){&#xA;&#x9;&#x9;return childList.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addChild(Person child){&#xA;&#x9;&#x9;this.childList.add(child);&#xA;&#x9;&#x9;if(this.gender == 'M'){&#xA;&#x9;&#x9;&#x9;child.father = this;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.gender == 'F'){&#xA;&#x9;&#x9;&#x9;child.mother = this;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeChild(Person child){&#xA;&#x9;&#x9;this.childList.remove(child);&#xA;&#x9;&#x9;if(this.gender == 'M'){&#xA;&#x9;&#x9;&#x9;child.father = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.gender == 'F'){&#xA;&#x9;&#x9;&#x9;child.mother = null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFather(Person Father){&#xA;&#x9;&#x9;if (Father.gender == 'M'){&#xA;&#x9;&#x9;&#x9;&#x9;this.father = Father;&#xA;&#x9;&#x9;&#x9;&#x9;Father.childList.add(this);&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Father cannot be a woman&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setMother(Person Mother){&#xA;&#x9;&#x9;if (Mother.gender == 'F'){&#xA;&#x9;&#x9;this.mother = Mother;&#xA;&#x9;&#x9;Mother.childList.add(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423142123" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Get" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="848" end="-769"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423146920" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="g" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="848" end="-769"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423148514" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="et" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="849" end="-769"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423266991" sizeMeasure="95" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="try{&#xA;&#x9;&#x9;&#x9;if (Mother.gender == 'F'){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = Mother;&#xA;&#x9;&#x9;&#x9;&#x9;Mother.childList.add(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1527" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="91" charStart="1717" charEnd="1718" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423280694" sizeMeasure="96" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1630" end="-14"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="91" charStart="1717" charEnd="1718" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="1735" charEnd="1736" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423285549" sizeMeasure="94" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1627" end="-15"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1720" charEnd="1721" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="1726" charEnd="1727" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423297737" sizeMeasure="94" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1627" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="91" charStart="1717" charEnd="1718" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423405223" sizeMeasure="97" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;catch (Exception e) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Mother cannot be male #Heteronormative&quot;);" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1630" end="-13"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423437741" sizeMeasure="95" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (Mother.gender == 'F'){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = Mother;&#xA;&#x9;&#x9;&#x9;&#x9;Mother.childList.add(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1527" end="-93"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423678887" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;Person(String Name, char Gender) {&#xA;&#x9;&#x9;this.name = Name;&#xA;&#x9;&#x9;this.gender = Gender;&#xA;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;this.childList = new ArrayList&lt;Person>();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getGender() {&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getFather() {&#xA;&#x9;&#x9;return this.father;&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getChild(int number) {&#xA;&#x9;&#x9;if (number >= childList.size() || number &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;There is no child number&quot; + number);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return childList.get(number);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getChildCount() {&#xA;&#x9;&#x9;return childList.size();&#xA;&#x9;}&#xA;&#xA;&#x9;public void addChild(Person child) {&#xA;&#x9;&#x9;if (this == child){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot be your own child&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.childList.add(child);&#xA;&#x9;&#x9;if (this.gender == 'M') {&#xA;&#x9;&#x9;&#x9;child.father = this;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.gender == 'F') {&#xA;&#x9;&#x9;&#x9;child.mother = this;&#xA;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void removeChild(Person child) {&#xA;&#x9;&#x9;this.childList.remove(child);&#xA;&#x9;&#x9;if (this.gender == 'M') {&#xA;&#x9;&#x9;&#x9;child.father = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.gender == 'F') {&#xA;&#x9;&#x9;&#x9;child.mother = null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person Father) {&#xA;&#x9;&#x9;if (Father.gender == 'M') {&#xA;&#x9;&#x9;&#x9;this.father = Father;&#xA;&#x9;&#x9;&#x9;Father.childList.add(this);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Father cannot be a woman&quot;);&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person Mother) {&#xA;&#x9;&#x9;if (Mother.gender == 'F') {&#xA;&#x9;&#x9;&#x9;this.mother = Mother;&#xA;&#x9;&#x9;&#x9;Mother.childList.add(this);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Mother cannot be male #Heteronormative&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="232" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487423743651" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(this == Father){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot be your own father&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (Father.gender == 'M') {&#xA;&#x9;&#x9;&#x9;this.father = Father;&#xA;&#x9;&#x9;&#x9;Father.childList.add(this);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Father cannot be a woman&quot;);&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person Mother) {&#xA;&#x9;&#x9;if(this == Mother){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot be your own mother&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1410" end="-190"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424062228" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || this.father == child || this.mother == child){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot be your own child, nor can your child be your parent" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="953" end="-981"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424316137" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="890" end="-1197"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424328061" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="890" end="-1197"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424496461" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || this.father == Father || this.mother" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1508" end="-589"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424515888" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || this.father == Mother || this.mother" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1869" end="-278"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424740212" sizeMeasure="105" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(!(this.father == null)){&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (Father.gender == 'M') {&#xA;&#x9;&#x9;&#x9;this.father = Father;&#xA;&#x9;&#x9;&#x9;Father.childList.add(this);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Father cannot be a woman&quot;);&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person Mother) {&#xA;&#x9;&#x9;if(this == Mother || this.father == Mother || this.mother == Mother){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot be your own mother&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(!(this.mother == null)){&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1641" end="-196"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424788566" sizeMeasure="107" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".removeChild(child);&#xA;&#x9;&#x9;&#x9;child.father = this;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.gender == 'F') {&#xA;&#x9;&#x9;&#x9;child.mother.removeChild(child);" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1186" end="-1097"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487424835030" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(!(child.father == null)){&#xA;&#x9;&#x9;&#x9;&#x9;child.father.removeChild(child);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;child.father = this;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.gender == 'F') {&#xA;&#x9;&#x9;&#x9;if(!(child.mother == null)){&#xA;&#x9;&#x9;&#x9;&#x9;child.mother.removeChild(child);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1174" end="-1097"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487347338035" completion="0.0" failureCount="4" errorCount="9">
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487422957235" completion="0.07692307692307693" successCount="1" failureCount="3" errorCount="9">
          <successTests>testFarskapIllegalArgumentException</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487423108138" completion="0.07692307692307693" successCount="1" failureCount="3" errorCount="9">
          <successTests>testFarskapIllegalArgumentException</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487423152048" completion="0.46153846153846156" successCount="6" failureCount="7">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487423457012" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487423747013" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487423774141" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487423964108" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487424064795" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487424319691" completion="0.3076923076923077" successCount="4" failureCount="9">
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <failureTests>testMorskapSetMother</failureTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testMorskapAddChild</failureTests>
          <failureTests>testFarskapAddChild</failureTests>
          <failureTests>testFarskapSetFather</failureTests>
          <failureTests>testConstructor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487424331989" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487424519675" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487424743777" completion="0.8461538461538461" successCount="11" failureCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testMorbytteSetFather</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarbytteSetFather</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487424791383" completion="0.6923076923076923" successCount="9" errorCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testMorbytteSetFather</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarbytteSetFather</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487424911556" completion="1.0" successCount="13">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorbytteSetFather</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarbytteSetFather</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="16">
        <attempts timestamp="1487423804434"/>
        <attempts timestamp="1487423915036"/>
        <attempts timestamp="1487423919770"/>
        <attempts timestamp="1487423921958"/>
        <attempts timestamp="1487423923419"/>
        <attempts timestamp="1487423924279"/>
        <attempts timestamp="1487423924997"/>
        <attempts timestamp="1487423925841"/>
        <attempts timestamp="1487423929341"/>
        <attempts timestamp="1487423931622"/>
        <attempts timestamp="1487423936763"/>
        <attempts timestamp="1487423938919"/>
        <attempts timestamp="1487423940857"/>
        <attempts timestamp="1487423941654"/>
        <attempts timestamp="1487423942998"/>
        <attempts timestamp="1487423950045"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1487423810168"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
