<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Card">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardDeck class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardHand class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardDeck class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardHand class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardDeckTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardDeckTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardHandTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardHandTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707734239" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707917351" sizeMeasure="7" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import objectstructures.CardDeck" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="27" end="-27"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="61" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707964741" sizeMeasure="53" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private char suit;&#x9;&#x9;// S, H, D, or C for spades, hearts, diamonds, and clubs&#xA;&#x9;private int face;&#x9;&#x9;// integer 1-13 for ace (1) through king (13)&#xA;&#x9;private CardDeck cardDeck;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid suit.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (!(face > 0 &amp;&amp; face &lt; 14)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid face.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public CardDeck getCardDeck() {&#xA;&#x9;&#x9;return cardDeck;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setCardDeck(CardDeck cardDeck) {&#xA;&#x9;    // check if connection is already correct&#xA;&#x9;    if (this.cardDeck == cardDeck) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    // remove old connection if necessary&#xA;&#x9;    if (this.cardDeck != null) {&#xA;&#x9;        this.cardDeck.removeCard(this);&#xA;&#x9;    }&#xA;&#x9;    this.cardDeck = cardDeck;&#xA;&#x9;    // initiate new connection if necessary&#xA;&#x9;    if (this.cardDeck != null) {&#xA;&#x9;        this.cardDeck.addCard(this);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + String.valueOf(face);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="82" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="906" charEnd="916" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1069" charEnd="1076" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707743269" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class CardDeck {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707875832" sizeMeasure="8" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import objectstructures.Card;&#xA;import objectstructures.CardHand" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="27" end="-31"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="57" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="67" charEnd="92" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707966140" sizeMeasure="65" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="java.util.ArrayList;&#xA;import objectstructures.Card;&#xA;import objectstructures.CardHand;&#xA;&#xA;public class CardDeck {&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;Card> cardDeck = new ArrayList&lt;Card>();&#xA;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if (!(n > 0)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Number of cards has to be bigger than 0.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;char[] suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#x9;for (char suit: suits) {&#xA;&#x9;&#x9;&#x9;for (int i=0; i&lt;n; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;addCard(new Card(suit, (i%13)+1));&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addCard(Card card) {&#xA;&#x9;&#x9;// check if connection is already correct&#xA;&#x9;    if (this.cardDeck.contains(card)) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.cardDeck.add(card);&#xA;&#x9;    // remove connection if necessary&#xA;&#x9;    if (card.getCardDeck() != this) {&#xA;&#x9;        card.setCardDeck(this);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9; &#xA;&#x9;public void removeCard(Card card) {&#xA;&#x9;    // check if connection is already correct&#xA;&#x9;    if (! this.cardDeck.contains(card)) {&#xA;&#x9;        return;&#xA;&#x9;    }&#xA;&#x9;    this.cardDeck.remove(card);&#xA;&#x9;    // remove connection if necessary&#xA;&#x9;    if (card.getCardDeck() == this) {&#xA;&#x9;        card.setCardDeck(null);&#xA;&#x9;    }&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return cardDeck.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (!(n &lt; getCardCount() &amp;&amp; n >= 0)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Card number out of bounds.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return cardDeck.get(n);&#xA;&#x9;}&#xA;&#xA;&#x9;public void shufflePerfectly() { &#xA;&#x9;&#x9;ArrayList&lt;Card> deckCopy = new ArrayList&lt;Card>(cardDeck);&#xA;&#x9;&#x9;for (int i=0; i&lt;getCardCount()/2; i++) {&#xA;&#x9;&#x9;&#x9;cardDeck.set(i*2, deckCopy.get(i));&#xA;&#x9;&#x9;&#x9;cardDeck.set(i*2+1, deckCopy.get(i+getCardCount()/2));&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="34" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="96" charEnd="121" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708091945" sizeMeasure="65" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="243" end="-1325"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="96" charEnd="121" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708216664" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void deal(CardHand hand, int n) {&#xA;&#x9;&#x9;if (!(n &lt;= getCardCount())) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = getCardCount(); i &lt; (getCardCount() - n); i--) {&#xA;&#x9;&#x9;&#x9;Card card  = getCard(n);&#xA;&#x9;&#x9;&#x9;hand.addCard(card);&#xA;&#x9;&#x9;&#x9;removeCard(card" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1566" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708366571" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1; i &lt; (getCardCount() - 1" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1716" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708480309" sizeMeasure="81" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck deck = new CardDeck(12);&#xA;&#x9;&#x9;CardHand hand = new CardHand();&#xA;&#x9;&#x9;System.out.println(deck.getCardCount());" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1836" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="2002" charEnd="2006" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708534661" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Deck: &quot; + deck.getCardCount());&#xA;&#x9;&#x9;System.out.println(&quot;Hand: &quot; + hand" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1969" end="-24"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708560980" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;deck.deal(hand, 6" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="2057" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708640101" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.getCardCount())) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = this.getCardCount() - 1; i &lt; (this.getCardCount() - 1 - n); i--) {&#xA;&#x9;&#x9;&#x9;Card card  = this.getCard(n);&#xA;&#x9;&#x9;&#x9;hand.addCard(card);&#xA;&#x9;&#x9;&#x9;this." edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1623" end="-381"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708716408" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=">" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1734" end="-484"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708726099" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1734" end="-484"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708853520" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="41" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1736" end="-454"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708911649" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deck.removeCard(deck.getCard(47)" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="2080" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708957021" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(this.getCardCount() - 1 - n); i--) {&#xA;&#x9;&#x9;&#x9;Card card  = this.getCard(i" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1736" end="-452"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708979785" sizeMeasure="86" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.getCard(i));&#xA;&#x9;&#x9;&#x9;this.removeCard(this.getCard(i)" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1823" end="-403"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1852" charEnd="1856" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708992089" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1777" end="-472"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709014601" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="hand.addCard(this.getCard(i));&#xA;&#x9;&#x9;&#x9;this.removeCard(this.getCard(i));&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck deck = new CardDeck(12);&#xA;&#x9;&#x9;CardHand hand = new CardHand();&#xA;&#x9;&#x9;System.out.println(&quot;Deck: &quot; + deck.getCardCount());&#xA;&#x9;&#x9;System.out.println(&quot;Hand: &quot; + hand.getCardCount());&#xA;&#x9;&#x9;deck.deal(hand, 48" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1777" end="-154"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709018198" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="9" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="2091" end="-154"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709071902" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Cannot deal more cards than the number of cards in deck.&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="1685" end="-561"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709086522" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="8" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="2149" end="-154"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709122139" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getCardCount())) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot deal more cards than the number of cards in deck.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = getCardCount() - 1; i &lt; (getCardCount() - 1 - n); i--) {&#xA;&#x9;&#x9;&#x9;hand.addCard(getCard(i));&#xA;&#x9;&#x9;&#x9;removeCard(" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="1623" end="-414"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709171535" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="1802" end="-471"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709272260" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*for (int i = getCardCount() - 1; i &lt; (getCardCount() - n); i--) {&#xA;&#x9;&#x9;&#x9;hand.addCard(getCard(i));&#xA;&#x9;&#x9;&#x9;removeCard(getCard(i));&#xA;&#x9;&#x9;}*/&#xA;&#x9;&#x9;for (int i = getCardCount() - 1; i &lt; 1; i --) {" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="1747" end="-429"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709344498" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0 - 1; i &lt; getCardCount(); i ++" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="1892" end="-432"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709356005" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="1917" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709368824" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="; i &lt; getCardCount()" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="1893" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709402687" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="1913" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709421340" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="1913" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709439202" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="2202" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709481817" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="2202" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709502589" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="96" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="2195" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709508308" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="2195" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709546170" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="48" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1899" end="-400"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709571066" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="2019" end="-281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709575793" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="2019" end="-281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709581799" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="2184" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709595088" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="2167" end="-115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709599377" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deck.deal(hand, 12);" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="2167" end="-115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709610005" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="7" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="1900" end="-401"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709616391" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="1899" end="-401"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709628343" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="1900" end="-401"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709633480" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="1900" end="-401"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709712642" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int initCardCount = getCardCount();&#xA;&#x9;&#x9;for (int i = initCardCount - 1; i &lt; (initCardCount - n); i--) {&#xA;&#x9;&#x9;&#x9;hand.addCard(getCard(i));" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="1747" end="-392"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709743208" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" - 1" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="1839" end="-430"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709854623" sizeMeasure="90" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*deck.deal(hand, 12);*/&#xA;&#x9;&#x9;int initCardCount = deck.getCardCount();&#xA;&#x9;&#x9;for (int i = initCardCount - 1; i &lt; (initCardCount - n - 1); i--) {&#xA;&#x9;&#x9;&#x9;hand.addCard(getCard(i));&#xA;&#x9;&#x9;&#x9;removeCard(getCard(i));&#xA;&#x9;&#x9;} " edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="2138" end="-115"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="2392" charEnd="2402" severity="2" problemCategory="50" problemType="603979977"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="2403" charEnd="2410" severity="2" problemCategory="50" problemType="603979977"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="2343" charEnd="2344" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="84" charStart="2375" charEnd="2382" severity="2" problemCategory="50" problemType="603979977"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709900746" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="12 - 1); i--) {&#xA;&#x9;&#x9;&#x9;hand.addCard(deck.getCard(i));&#xA;&#x9;&#x9;&#x9;deck.removeCard(deck." edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="2261" end="-132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709947268" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (int i = 47; i &lt; 0" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="2165" end="-199"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710027271" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0; i &lt; 48; i++" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="2178" end="-194"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710187486" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Card> toRemove = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;for (int i = getCardCount() - 1; i &lt; (getCardCount() - 1 - n); i--) {&#xA;&#x9;&#x9;&#x9;Card card = getCard(i);&#xA;&#x9;&#x9;&#x9;hand.addCard(card);&#xA;&#x9;&#x9;&#x9;toRemove.add(card" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="1747" end="-480"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710232083" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;for (Card card: toRemove) {&#xA;&#x9;&#x9;&#x9;removeCar" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="1947" end="-486"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710240205" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deck.deal(hand, 12);" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="2226" end="-115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710301587" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*deck.deal(hand, 12);*/&#xA;&#x9;&#x9;ArrayList&lt;Card> toRemove = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;for (int i = deck.getCardCount() - 1; i &lt; (deck.getCardCount() - 1 - 12); i--) {&#xA;&#x9;&#x9;&#x9;Card card = deck.getCard(i);&#xA;&#x9;&#x9;&#x9;hand.addCard(card);&#xA;&#x9;&#x9;&#x9;toRemove.add(card);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (Card card: toRemove) {&#xA;&#x9;&#x9;&#x9;deck.removeCard(card);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="2226" end="-115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710401964" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (int i = deck.getCardCount() - 1; i &lt; (deck.getCardCount() - 1 - 12); i--) {&#xA;&#x9;&#x9;&#x9;Card card = deck.getCard(i);&#xA;&#x9;&#x9;&#x9;hand.add" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="2253" end="-130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710427338" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="47; i &lt; 42" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="2266" end="-182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710453386" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deck.removeCard(deck.getCard(i)" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="2288" end="-121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710554393" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0; i > 5; i++" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="2266" end="-159"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710571071" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;" edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="2271" end="-166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710587839" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="47; i > 5; i--" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="2266" end="-159"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710603816" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=">" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="1834" end="-604"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710615222" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deck.deal(hand, 12);&#xA;&#x9;&#x9;/*for (int i = 47; i > 5; i--) {&#xA;&#x9;&#x9;&#x9;deck.removeCard(deck.getCard(i));&#xA;&#x9;&#x9;}*/" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="2226" end="-115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710627041" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="1946" end="-439"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710757521" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="1829" end="-555"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710765192" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="1829" end="-555"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710791369" sizeMeasure="90" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int initCardCount = getCardCount();&#xA;&#x9;&#x9;for (int i = initCardCount - 1; i > (initCardCount" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="1747" end="-534"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1979" charEnd="1987" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710797959" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="1905" end="-452"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710821165" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="hand.addCard(getCard(i)" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="1856" end="-446"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710866869" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="1890" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707751540" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class CardHand {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708047152" sizeMeasure="14" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public CardHand() {&#xA;&#x9;&#x9;super(0);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card play(int n) {&#xA;&#x9;&#x9;Card card = getCard(n);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="52" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="80" charEnd="89" severity="2" problemCategory="50" problemType="134217858"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="140" charEnd="147" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708058374" sizeMeasure="15" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="removeCard(card);&#xA;&#x9;&#x9;return card;" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="145" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="80" charEnd="89" severity="2" problemCategory="50" problemType="134217858"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="140" charEnd="147" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="155" charEnd="165" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708076773" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends CardDeck" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="49" end="-138"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708482028" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708535872" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708562901" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708641518" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708717897" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708727803" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708854978" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708914761" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708960798" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708981335" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709012284" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709019096" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709074337" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709087961" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709128017" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709177162" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709178039" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709178182" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709178441" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709178555" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709178586" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709273831" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709347007" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709357308" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709370020" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709404607" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709440315" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709503992" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709509808" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709547713" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709572226" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709582847" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709595941" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709611167" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709617107" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709629098" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709634352" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709716429" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709745577" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709903613" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709948928" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710029067" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710242940" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710302873" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710403017" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710429815" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710430743" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710455247" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710556138" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710572445" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710589421" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710615971" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710641060" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710679970" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710682046" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710682881" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710749328" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710758679" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487710799645" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487710842835" completion="1.0" successCount="2">
          <successTests>testToString</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708285413" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708376293" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487710829780" completion="1.0" successCount="3">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708257089" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
          <failureTests>testDealPlay</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487710835998" completion="1.0" successCount="3">
          <successTests>testDeal</successTests>
          <successTests>testDealPlay</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
