<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StopWatch and StopWatchManager">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StopWatch class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.StopWatch"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StopWatchManager class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.StopWatchManager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StopWatch class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.StopWatch"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StopWatchManager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.StopWatchManager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StopWatchTest."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.StopWatchTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StopWatchManagerTest."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.StopWatchManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.StopWatch*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487794717351" sizeMeasure="66">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.HashMap;&#xA;import java.util.Map;&#xA;&#xA;public class StopWatchManager {&#xA;&#xA;&#x9;Map&lt;String, StopWatch> manager = new HashMap&lt;>();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StopWatch newStopWatch(String name) {&#xA;&#x9;&#x9;StopWatch sw = new StopWatch();&#xA;&#x9;&#x9;if (manager.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Name already exists&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;manager.put(name, sw);&#xA;&#x9;&#x9;return sw;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStopWatch(String name) {&#xA;&#x9;&#x9;if (!manager.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;System.err.println(&quot;Name not found in map&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;manager.remove(name);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tick(int ticks) {&#xA;&#x9;&#x9;for (StopWatch sw : manager.values()) {&#xA;&#x9;&#x9;&#x9;sw.tick(ticks);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;if (!manager.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Name not found in map&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;return manager.get(name);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getAllWatches() {&#xA;&#x9;&#x9;return manager.values();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getStartedWatches() {&#xA;&#x9;&#x9;ArrayList&lt;StopWatch> watches = new ArrayList&lt;StopWatch>();&#xA;&#x9;&#x9;for (StopWatch sw : manager.values()) {&#xA;&#x9;&#x9;&#x9;if (sw.isStarted()) {&#xA;&#x9;&#x9;&#x9;&#x9;watches.add(sw);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return watches;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Collection&lt;StopWatch> getStoppedWatches() {&#xA;&#x9;&#x9;ArrayList&lt;StopWatch> watches = new ArrayList&lt;StopWatch>();&#xA;&#x9;&#x9;for (StopWatch sw : manager.values()) {&#xA;&#x9;&#x9;&#x9;if (sw.isStopped()) {&#xA;&#x9;&#x9;&#x9;&#x9;watches.add(sw);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return watches;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487794786469" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="797" end="-625"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487795115980" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.err.println(&quot;Name already exists&quot;);&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;manager.put(name, sw);&#xA;&#x9;&#x9;return sw;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStopWatch(String name) {&#xA;&#x9;&#x9;if (!manager.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;System.err.println(&quot;Name not found in map&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;manager.remove(name);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tick(int ticks) {&#xA;&#x9;&#x9;for (StopWatch sw : manager.values()) {&#xA;&#x9;&#x9;&#x9;sw.tick(ticks);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;StopWatch getStopWatch(String name) {&#xA;&#x9;&#x9;if (!manager.containsKey(name)) {&#xA;&#x9;&#x9;&#x9;System.err.println(&quot;Name not found in map&quot;);&#xA;&#x9;&#x9;&#x9;return null" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="339" end="-566"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487794748287" completion="1.0" successCount="4">
          <successTests>testTicks</successTests>
          <successTests>testStartTickStop</successTests>
          <successTests>testStartLapStop</successTests>
          <successTests>testTickStartStopTick</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487794756311" completion="0.6666666666666666" successCount="2" errorCount="1">
          <successTests>testTicks</successTests>
          <successTests>testStartedStoppedWatches</successTests>
          <errorTests>testNewRemoveStopWatches</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487794793065" completion="1.0" successCount="3">
          <successTests>testTicks</successTests>
          <successTests>testNewRemoveStopWatches</successTests>
          <successTests>testStartedStoppedWatches</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487795134080" completion="1.0" successCount="3">
          <successTests>testTicks</successTests>
          <successTests>testNewRemoveStopWatches</successTests>
          <successTests>testStartedStoppedWatches</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="47">
        <attempts timestamp="1487796664957"/>
        <attempts timestamp="1487796693071"/>
        <attempts timestamp="1487796694866"/>
        <attempts timestamp="1487796703501"/>
        <attempts timestamp="1487796714034"/>
        <attempts timestamp="1487796715752"/>
        <attempts timestamp="1487796754679"/>
        <attempts timestamp="1487796755177"/>
        <attempts timestamp="1487796758185"/>
        <attempts timestamp="1487796760055"/>
        <attempts timestamp="1487796765160"/>
        <attempts timestamp="1487796806312"/>
        <attempts timestamp="1487796806703"/>
        <attempts timestamp="1487796809538"/>
        <attempts timestamp="1487796817914"/>
        <attempts timestamp="1487796822401"/>
        <attempts timestamp="1487796862796"/>
        <attempts timestamp="1487796863021"/>
        <attempts timestamp="1487796865584"/>
        <attempts timestamp="1487796883053"/>
        <attempts timestamp="1487796891662"/>
        <attempts timestamp="1487796895431"/>
        <attempts timestamp="1487796920746"/>
        <attempts timestamp="1487796921326"/>
        <attempts timestamp="1487796923769"/>
        <attempts timestamp="1487796929544"/>
        <attempts timestamp="1487796932062"/>
        <attempts timestamp="1487796938311"/>
        <attempts timestamp="1487796940595"/>
        <attempts timestamp="1487796948224"/>
        <attempts timestamp="1487796949552"/>
        <attempts timestamp="1487796950019"/>
        <attempts timestamp="1487796950381"/>
        <attempts timestamp="1487796950728"/>
        <attempts timestamp="1487796951023"/>
        <attempts timestamp="1487796951324"/>
        <attempts timestamp="1487796951588"/>
        <attempts timestamp="1487796951852"/>
        <attempts timestamp="1487796952153"/>
        <attempts timestamp="1487796952394"/>
        <attempts timestamp="1487796952650"/>
        <attempts timestamp="1487797237765"/>
        <attempts timestamp="1487797249299"/>
        <attempts timestamp="1487797251380"/>
        <attempts timestamp="1487797276305"/>
        <attempts timestamp="1487797278927"/>
        <attempts timestamp="1487797285705"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="8">
        <attempts timestamp="1487796698494"/>
        <attempts timestamp="1487796756067"/>
        <attempts timestamp="1487796807661"/>
        <attempts timestamp="1487796813829"/>
        <attempts timestamp="1487796864213"/>
        <attempts timestamp="1487796875008"/>
        <attempts timestamp="1487796922201"/>
        <attempts timestamp="1487797265243"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="4">
        <attempts timestamp="1487796653480"/>
        <attempts timestamp="1487796771306"/>
        <attempts timestamp="1487796877537"/>
        <attempts timestamp="1487797241578"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
