<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936507364" sizeMeasure="12" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Person {&#xA;&#x9;private char gender;&#xA;&#x9;private String name;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#x9;private Person[] children;&#xA;&#x9;&#xA;&#x9;public &#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936532101" sizeMeasure="15" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="179" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936571303" sizeMeasure="21" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getName() { return name; }&#xA;&#x9;public char getGender() { return gender; " edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="261" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936696082" sizeMeasure="29" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public Person getMother() { return mother; }&#xA;&#x9;public Person getFather() { return father; }&#xA;&#x9;&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if (this.children == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="355" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936740478" sizeMeasure="32" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Person> children = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getName() { return name; }&#xA;&#x9;public char getGender() { return gender; }&#xA;&#x9;public Person getMother() { return mother; }&#xA;&#x9;public Person getFather() { return father; }&#xA;&#x9;&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if (this.children == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (n &lt; 0 || n > this.children.si)&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="150" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936767179" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class Person {&#xA;&#x9;private char gender;&#xA;&#x9;private String name;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#x9;private ArrayList&lt;Person> children = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getName() { return name; }&#xA;&#x9;public char getGender() { return gender; }&#xA;&#x9;public Person getMother() { return mother; }&#xA;&#x9;public Person getFather() { return father; }&#xA;&#x9;&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if (n &lt; 0 || n > this.children.size()" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="27" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936782459" sizeMeasure="32" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" -1 ) {&#xA;&#x9;&#x9;&#x9;throw new NullPointerException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="579" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936794052" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return this.children.get(n);" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="632" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936796056" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="663" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936801644" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.children.get(n);" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="590" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936808118" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // Eventuelt sok" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="602" end="-46"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937488214" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (gender != 'F' || gender != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="294" end="-374"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937501993" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Gender can only be 'F' or 'M'" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="374" end="-384"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937675012" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Kast evt. Exception&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getChildCount() {&#xA;&#x9;&#x9;return this.children.size(" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="728" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942756242" sizeMeasure="50" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Petter&quot;, 'M');&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Gunnhild&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Person c1 = new Person(&quot;Gina&quot;, 'F'" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="855" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942761088" sizeMeasure="52" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1028" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942784599" sizeMeasure="52" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&amp;&amp;" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="315" end="-723"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942801659" sizeMeasure="52" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(c1.getGender());" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1032" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942816101" sizeMeasure="52" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1031" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942818142" sizeMeasure="52" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1031" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942882447" sizeMeasure="51" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="448" end="-598"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942883638" sizeMeasure="51" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="445" end="-592"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942884218" sizeMeasure="50" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="445" end="-592"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943054727" sizeMeasure="50" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public String getName() { return name; }&#xA;&#x9;public char getGender() { return gender; }&#xA;&#x9;public Person getMother() { return mother; }&#xA;&#x9;public Person getFather() { return father; }&#xA;&#x9;&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if (n &lt; 0 || n > this.children.size() -1 ) {&#xA;&#x9;&#x9;&#x9;throw new NullPointerException(&quot;'n' must be in range [0, &quot;+this.children.size()+&quot;]&quot;);" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="445" end="-293"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943058893" sizeMeasure="50" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="787" end="-299"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943064715" sizeMeasure="50" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(this.children.size()-1)" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="767" end="-299"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943078291" sizeMeasure="50" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(c1.getChild(2));" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1082" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943111413" sizeMeasure="50" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="788" end="-335"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943118161" sizeMeasure="50" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="698" end="-423"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943130730" sizeMeasure="49" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=") {&#xA;&#x9;&#x9;&#x9;throw new NullPointerException(&quot;'n' must be in range [0, &quot;+(this.children.size())+&quot;]&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getChildCount() {&#xA;&#x9;&#x9;return this.children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Petter&quot;, 'M');&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Gunnhild&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Person c1 = new Person(&quot;Gina&quot;, 'F');&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="698" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943215233" sizeMeasure="54" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" return this.children.size(); }&#xA;&#x9;&#xA;&#x9;public void setMother(Person mother) {&#xA;&#x9;&#x9;if (mother.getGender() != 'F') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Mother must have gender 'F'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Petter&quot;, 'M');&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Gunnhild&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Person c1 = new Person(&quot;Gina&quot;, 'F');&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="865" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943443035" sizeMeasure="58" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;if (this.mother != null) {&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1049" end="-195"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943459595" sizeMeasure="59" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// If mother has already been registered, reset the relation" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1053" end="-256"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949308171" sizeMeasure="62" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//if (this.mother != null) {&#xA;&#x9;&#x9;//&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;//}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;this.mother.addChild(Person);" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="1116" end="-189"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949326081" sizeMeasure="67" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.mother = mother) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1192" end="-248"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949328352" sizeMeasure="68" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1192" end="-299"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949331123" sizeMeasure="68" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.mother =" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="1195" end="-277"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949337853" sizeMeasure="68" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// No need to do any more operatoins" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1192" end="-297"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949339840" sizeMeasure="68" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ions here" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="1224" end="-297"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949341876" sizeMeasure="68" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="1284" end="-246"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949345665" sizeMeasure="67" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.mother = mother;&#xA;&#x9;&#x9;this.mother.addChild(this" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="1285" end="-191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487949473115" sizeMeasure="74" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void addChild(Person child) {&#xA;&#x9;&#x9;if (this == child) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(name + &quot; cannot be it's own child&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="1352" end="-189"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487950246802" sizeMeasure="80" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;switch(this.gender){&#xA;&#x9;&#x9;&#x9;case '':&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;break" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="1485" end="-194"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487950276491" sizeMeasure="78" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.gender == 'F') {&#xA;&#x9;&#x9;&#x9;child.setMother(this)" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="1489" end="-194"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487950317587" sizeMeasure="80" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;child.setFa" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="1544" end="-204"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487950357684" sizeMeasure="86" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void setFather(Person father) {&#xA;&#x9;&#x9;if (father.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Father must have gender 'M'&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="1343" end="-434"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487950370284" sizeMeasure="90" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;if (this.father == father) {&#xA;&#x9;&#x9;&#x9;return" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="1492" end="-439"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487950379079" sizeMeasure="92" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;this.father = father;" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="1541" end="-434"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976098249" sizeMeasure="93" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.father.addChild(this)" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="1568" end="-435"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976120669" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p1.addChild(c1);" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="2019" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976156723" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(c1.getFather());" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="2038" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976168097" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getName" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="2071" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976186461" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p2" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="2038" end="-70"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976195849" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(c1.getMo" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="2104" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976296628" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c1.setFather(p1);&#xA;&#x9;&#x9;c1.setMother(p2);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="2019" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976297490" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="2058" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976298631" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="2059" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976311528" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="2058" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487976333149" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(p1.getChildCount" edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="2157" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487977842140" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;if (!this.children.contains(child)) {&#xA;&#x9;&#x9;&#x9;this.children.add(child" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="1843" end="-370"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487978300552" sizeMeasure="107">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void removeChild(Person child) {&#xA;&#x9;&#x9;if (child == null) {&#xA;&#x9;&#x9;&#x9;return" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="1924" end="-369"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487978311732" sizeMeasure="109">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;this.children.remove(child);" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="2003" end="-364"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487978325944" sizeMeasure="112">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="child.setFather(null);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="2007" end="-398"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487978326584" sizeMeasure="112">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="2031" end="-399"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487978360935" sizeMeasure="115">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.gender == 'F') {&#xA;&#x9;&#x9;&#x9;child.setFather(null);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;child.setMother(null);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.63/@edit" start="2007" end="-398"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487978373947" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.64/@edit" start="2005" end="-493"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487978375302" sizeMeasure="115">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.65/@edit" start="2005" end="-493"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487978406513" sizeMeasure="115">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if (this.gender == 'F') {&#xA;&#x9;&#x9;&#x9;child.setFather(null);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;child.setMother(null);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.children.remove(child);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person p1 = new Person(&quot;Petter&quot;, 'M');&#xA;&#x9;&#x9;Person p2 = new Person(&quot;Gunnhild&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Person c1 = new Person(&quot;Gina&quot;, 'F');&#xA;&#x9;&#x9;c1.setFather(p1);&#xA;&#x9;&#x9;c1.setMother(p2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(c1.getFather().getName());&#xA;&#x9;&#x9;System.out.println(c1.getMother().getName());&#xA;&#x9;&#x9;System.out.println(p2" edit="/1/@proposals.0/@proposals.0/@attempts.66/@edit" start="2005" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979620591" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.67/@edit" start="2311" end="-149"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979621444" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.68/@edit" start="2313" end="-147"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979627720" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p1.addChild(c1);&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.69/@edit" start="2311" end="-147"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979651916" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.70/@edit" start="2329" end="-147"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979654975" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//System.out.println(c1.getFather().getName());&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.71/@edit" start="2333" end="-95"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979780663" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(c1.getFather().getName());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.72/@edit" start="2333" end="-95"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979785331" sizeMeasure="114" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p2.addChild(child);" edit="/1/@proposals.0/@proposals.0/@attempts.73/@edit" start="2330" end="-146"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979786659" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.74/@edit" start="2343" end="-148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487979818293" sizeMeasure="115">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c1.setMother(p2" edit="/1/@proposals.0/@proposals.0/@attempts.75/@edit" start="2349" end="-148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487980113057" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p2.addChild(c1" edit="/1/@proposals.0/@proposals.0/@attempts.76/@edit" start="2369" end="-148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487980252537" sizeMeasure="113" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.77/@edit" start="2311" end="-146"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487980288712" sizeMeasure="113" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=");&#xA;&#x9;&#x9;System.out.println(c1.getMother" edit="/1/@proposals.0/@proposals.0/@attempts.78/@edit" start="2347" end="-54"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487980310814" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public String toString() { return name; }" edit="/1/@proposals.0/@proposals.0/@attempts.79/@edit" start="444" end="-1995"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487982840866" sizeMeasure="116" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Person c2 = new Person(&quot;Carla&quot;, 'F');&#xA;&#x9;&#x9;Person c3 = new Person(&quot;Olaf&quot;, 'M" edit="/1/@proposals.0/@proposals.0/@attempts.80/@edit" start="2354" end="-132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487982853696" sizeMeasure="120" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;p1.addChild(c1);&#xA;&#x9;&#x9;p2.addChild(c1" edit="/1/@proposals.0/@proposals.0/@attempts.81/@edit" start="2436" end="-131"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487982867339" sizeMeasure="123" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c2.setFather(p1);&#xA;&#x9;&#x9;c2.setMother(p2" edit="/1/@proposals.0/@proposals.0/@attempts.82/@edit" start="2480" end="-131"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487982887827" sizeMeasure="126">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c3.setFather(p1);&#xA;&#x9;&#x9;p2.addChild(c3" edit="/1/@proposals.0/@proposals.0/@attempts.83/@edit" start="2523" end="-131"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487982908132" sizeMeasure="127">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(p1" edit="/1/@proposals.0/@proposals.0/@attempts.84/@edit" start="2682" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487984782196" sizeMeasure="127">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" -1" edit="/1/@proposals.0/@proposals.0/@attempts.85/@edit" start="936" end="-1794"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487984782829" sizeMeasure="127">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.86/@edit" start="938" end="-1795"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487984810213" sizeMeasure="127">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.87/@edit" start="936" end="-1794"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487985029309" sizeMeasure="126">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.88/@edit" start="1235" end="-1454"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487985083196" sizeMeasure="130" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (mother == null) {&#xA;&#x9;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.89/@edit" start="1235" end="-1457"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487985102093" sizeMeasure="131" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".removeChild(this);" edit="/1/@proposals.0/@proposals.0/@attempts.90/@edit" start="1271" end="-1484"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487985129462" sizeMeasure="131" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.91/@edit" start="1294" end="-1461"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487985479041" sizeMeasure="131" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.mother = null;" edit="/1/@proposals.0/@proposals.0/@attempts.92/@edit" start="1294" end="-1461"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020809736" sizeMeasure="136" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="mother == null) {&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.mother = null" edit="/1/@proposals.0/@proposals.0/@attempts.93/@edit" start="1587" end="-1202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020820837" sizeMeasure="136" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="father == null) {&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.fa" edit="/1/@proposals.0/@proposals.0/@attempts.94/@edit" start="1587" end="-1213"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020843183" sizeMeasure="131" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.95/@edit" start="1587" end="-1202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020852227" sizeMeasure="133" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.father == father) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.father.removeChild(this);&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.96/@edit" start="1587" end="-1146"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020853415" sizeMeasure="132" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.97/@edit" start="1664" end="-1145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020860311" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (this.mother == mother) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;this.mother.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;if (father.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Father must have gender 'M'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.father == father) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.father.removeChild(this);" edit="/1/@proposals.0/@proposals.0/@attempts.98/@edit" start="1235" end="-1145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020867468" sizeMeasure="129">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".removeChild(this);" edit="/1/@proposals.0/@proposals.0/@attempts.99/@edit" start="1298" end="-1438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020915513" sizeMeasure="133">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.mother != null) {&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.100/@edit" start="1287" end="-1438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020917452" sizeMeasure="132">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.101/@edit" start="1358" end="-1441"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020938835" sizeMeasure="136">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.mother = mother;&#xA;&#x9;&#x9;this.mother.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;if (father.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Father must have gender 'M'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.father == father) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.father != null) {&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.102/@edit" start="1358" end="-1145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020940047" sizeMeasure="136">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.103/@edit" start="1685" end="-1149"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020941019" sizeMeasure="136">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.104/@edit" start="1684" end="-1148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488020942197" sizeMeasure="135">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.105/@edit" start="1684" end="-1148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021012730" sizeMeasure="137">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (mother.getGender() != 'F') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Mother must have gender 'F'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// If mother has already been registered, reset the relation&#xA;&#x9;&#x9;//if (this.mother != null) {&#xA;&#x9;&#x9;//&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;//}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.mother == mother) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.mother != null) {&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;this.mother.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;if (father.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Father must have gender 'M'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.father == father) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.father != null) {&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.106/@edit" start="982" end="-1148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021014490" sizeMeasure="136">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.107/@edit" start="982" end="-1851"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021015502" sizeMeasure="135">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.108/@edit" start="983" end="-1850"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021024914" sizeMeasure="135">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (mother != null &amp;&amp; " edit="/1/@proposals.0/@proposals.0/@attempts.109/@edit" start="983" end="-1843"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021039425" sizeMeasure="135">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" != null &amp;&amp; " edit="/1/@proposals.0/@proposals.0/@attempts.110/@edit" start="1485" end="-1370"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021085723" sizeMeasure="137">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// No need to do any operation if&#xA;&#x9;&#x9;// we set our current father to our father" edit="/1/@proposals.0/@proposals.0/@attempts.111/@edit" start="1605" end="-1265"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021217250" sizeMeasure="138">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="the persons father, to it's current father&#xA;&#x9;&#x9;if (this.father == father) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Must remove child from the current father" edit="/1/@proposals.0/@proposals.0/@attempts.112/@edit" start="1651" end="-1216"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021228296" sizeMeasure="132">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.113/@edit" start="1108" end="-1756"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021253727" sizeMeasure="108">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.114/@edit" start="2316" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021255290" sizeMeasure="107">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.115/@edit" start="2316" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021296825" sizeMeasure="108">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;this.children.remove(child);&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.116/@edit" start="2282" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488021298064" sizeMeasure="107">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.117/@edit" start="2282" end="-43"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487942766380" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487942789574" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487942806636" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487943102406" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487943125701" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487976136457" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487976161365" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487976172415" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487976202710" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487976303805" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487976342879" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487978399041" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487978410186" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487979634614" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487979661491" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487979797763" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487979824544" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487980117250" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487980211615" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487980318050" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487982894397" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487982913018" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487978420388" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487980329014" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487984789859" completion="0.3076923076923077" successCount="4" failureCount="9"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487984815732" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488020874855" completion="0.23076923076923078" successCount="3" failureCount="2" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488020947297" completion="0.6923076923076923" successCount="9" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488021029973" completion="0.8461538461538461" successCount="11" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488021051950" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488021261211" completion="1.0" successCount="13"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
