<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487586253296" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593402408" sizeMeasure="35" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private String tweet;&#xA;&#x9;private Tweet refTweet;&#xA;&#x9;private final TwitterAccount twitterAccount;&#xA;&#x9;private int reTweets;&#xA;&#x9;private boolean reTweet;&#xA;&#xA;&#x9;public Tweet(TwitterAccount konto, String tweet) {&#xA;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;this.twitterAccount = konto;&#xA;&#x9;&#x9;reTweet = false;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount konto, Tweet tweet) {&#xA;&#x9;&#x9;refTweet = tweet;&#xA;&#x9;&#x9;this.twitterAccount = konto;&#xA;&#x9;&#x9;reTweet = true;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return tweet;&#xA;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return twitterAccount;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="49" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="92" charEnd="100" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="163" charEnd="171" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="191" charEnd="198" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="601" charEnd="619" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593479413" sizeMeasure="39" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if (reTweet) {&#xA;&#x9;&#x9;&#x9;return refTweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="592" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="163" charEnd="171" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594065879" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean reTweet;&#xA;&#x9;private int reTweetCount;&#xA;&#xA;&#x9;public Tweet(TwitterAccount konto, String tweet) {&#xA;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;this.twitterAccount = konto;&#xA;&#x9;&#x9;reTweet = false;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount konto, Tweet tweet) {&#xA;&#x9;&#x9;refTweet = tweet;&#xA;&#x9;&#x9;this.twitterAccount = konto;&#xA;&#x9;&#x9;reTweet = true;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return tweet;&#xA;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return twitterAccount;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (reTweet) {&#xA;&#x9;&#x9;&#x9;return refTweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void isReTweeted() {&#xA;&#x9;&#x9;reTweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getReTweetCount() {&#xA;&#x9;&#x9;return reTweetCount;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="152" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599113629" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetCount;&#xA;&#xA;&#x9;public Tweet(TwitterAccount konto, String tweet) {&#xA;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;refTweet = this;&#xA;&#x9;&#x9;this.twitterAccount = konto;&#xA;&#x9;&#x9;reTweet = false;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet(TwitterAccount konto, Tweet tweet) {&#xA;&#x9;&#x9;this.tweet = tweet.getText();&#xA;&#x9;&#x9;if (tweet.getOriginalTweet() == null) {&#xA;&#x9;&#x9;&#x9;refTweet = tweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;refTweet = getOriginalTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.twitterAccount = konto;&#xA;&#x9;&#x9;reTweet = true;&#xA;&#x9;&#x9;refTweet.isRetweeted();&#xA;&#x9;&#x9;if (konto == tweet.getOwner()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return tweet;&#xA;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return twitterAccount;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (reTweet) {&#xA;&#x9;&#x9;&#x9;return refTweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void isReTweeted() {&#xA;&#x9;&#x9;retweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return ret" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="184" end="-18"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="625" charEnd="636" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599128347" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="t" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="968" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599148128" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="982" end="-85"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599175733" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.getOwner().isRetweeted()" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1007" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599402858" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1007" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599578207" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.getOwner().isRetweeted()" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1007" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599611580" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1007" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487601457160" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="refTweet.getOwner().isRetweeted();&#xA;&#x9;&#x9;if (konto == tweet.getOwner()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return tweet;&#xA;&#x9;}&#xA;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return twitterAccount;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (reTweet) {&#xA;&#x9;&#x9;&#x9;return refTweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void isRetweeted() {&#xA;&#x9;&#x9;this.retweetCount += 1" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="616" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487601852535" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if(getOriginalTweet()==null){&#xA;&#x9;&#x9;&#x9;refTweet=this;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="493" end="-615"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487601911856" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;refTweet = tweet." edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="493" end="-594"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487586238401" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588546709" sizeMeasure="45" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;import spillelisteeksempel.Track;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;&#x9;private final String userName;&#xA;&#x9;private List&lt;TwitterAccount> follows;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String name){&#xA;&#x9;&#x9;this.userName=name;&#xA;&#x9;&#x9;this.follows = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;follows.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unFollow(TwitterAccount account){&#xA;&#x9;&#x9;// finner posisjonen til PlaylistTrack-objektet som er koblet til track&#xA;&#x9;&#x9;int pos = indexOfTwitterAccount(account);&#xA;&#x9;&#x9;if (pos >= 0) {&#xA;&#x9;&#x9;&#x9;// fjerner PlaylistTrack-objektet pÃ¥ posisjon vi fant&#xA;&#x9;&#x9;&#x9;follows.remove(pos);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int indexOfTwitterAccount(Track track) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; tracks.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (tracks.get(i).getTrack() == track) {&#xA;&#x9;&#x9;&#x9;&#x9;return i;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// fant ikke noe PlaylistTrack-objekt koblet til track&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="27" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="91" charEnd="110" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="620" charEnd="641" severity="2" problemCategory="50" problemType="67108984"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="35" charStart="802" charEnd="807" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="840" charEnd="846" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="870" charEnd="876" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591438381" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class TwitterAccount {&#xA;&#xA;&#x9;private final String userName;&#xA;&#x9;private List&lt;TwitterAccount> follows;&#xA;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.userName = name;&#xA;&#x9;&#x9;this.follows = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;follows.add(account);&#xA;&#x9;}&#xA;&#xA;&#x9;public void unFollow(TwitterAccount account) {&#xA;&#x9;&#x9;int pos = indexOfTwitterAccount(account);&#xA;&#x9;&#x9;if (pos >= 0) {&#xA;&#x9;&#x9;&#x9;follows.remove(pos);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int indexOfTwitterAccount(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return i;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="79" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591669646" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate int indexOfTwitterAccount(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return i;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="570" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594296003" sizeMeasure="76" errorCount="3" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private List&lt;Tweet> tweets;&#xA;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.userName = name;&#xA;&#x9;&#x9;this.follows = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;this.tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;follows.add(account);&#xA;&#x9;}&#xA;&#xA;&#x9;public void unFollow(TwitterAccount account) {&#xA;&#x9;&#x9;int pos = indexOfTwitterAccount(account);&#xA;&#x9;&#x9;if (pos >= 0) {&#xA;&#x9;&#x9;&#x9;follows.remove(pos);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;private int indexOfTwitterAccount(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return i;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String tweet) {&#xA;&#x9;&#x9;Tweet newTweet = new Tweet(this, tweet);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public void reTweet(Tweet tweet) {&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getReTweetCount() {&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="181" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="211" charEnd="217" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1193" charEnd="1201" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="64" charStart="1296" charEnd="1315" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="68" charStart="1339" charEnd="1354" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1378" charEnd="1395" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595896121" sizeMeasure="80" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private int tweetCount;&#xA;&#x9;private int reTweetCount;&#xA;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.userName = name;&#xA;&#x9;&#x9;this.follows = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;this.tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;follows.add(account);&#xA;&#x9;}&#xA;&#xA;&#x9;public void unFollow(TwitterAccount account) {&#xA;&#x9;&#x9;int pos = indexOfTwitterAccount(account);&#xA;&#x9;&#x9;if (pos >= 0) {&#xA;&#x9;&#x9;&#x9;follows.remove(pos);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;private int indexOfTwitterAccount(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return i;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;tweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public void reTweet(Tweet tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;reTweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="210" end="-80"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="233" charEnd="243" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="259" charEnd="271" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1532" charEnd="1547" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1571" charEnd="1588" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595951068" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getReTweetCount() {&#xA;&#x9;&#x9;return reTweetCount;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1479" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598038601" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetCount;&#xA;&#xA;&#x9;public TwitterAccount(String name) {&#xA;&#x9;&#x9;this.userName = name;&#xA;&#x9;&#x9;this.follows = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;this.tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;follows.add(account);&#xA;&#x9;}&#xA;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;int pos = indexOfTwitterAccount(account);&#xA;&#x9;&#x9;if (pos >= 0) {&#xA;&#x9;&#x9;&#x9;follows.remove(pos);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;private int indexOfTwitterAccount(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return i;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; follows.size(); i++) {&#xA;&#x9;&#x9;&#x9;if (follows.get(i) == account) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;tweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void isRetweeted(Tweet tweet) {&#xA;&#x9;&#x9;retweetCount += 1" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="250" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598114051" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner().isRetweeted();&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void isRetweeted(" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1319" end="-32"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598174888" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweetCount += 1" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1352" end="-284"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598247880" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweetCount += 1;&#xA;&#x9;&#x9;tweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1319" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598300704" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner().isRetweeted();&#xA;&#x9;&#x9;tweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void isRetweeted() {&#xA;&#x9;&#x9;retweetCount += 1" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1319" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598463753" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweetCount += 1;&#xA;&#x9;&#x9;tweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1319" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598808740" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1584" end="-1585"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598922446" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner().isRetweeted();&#xA;&#x9;&#x9;tweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void isRetweeted() {&#xA;&#x9;&#x9;retweetCount += 1" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1319" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599024600" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweeted();&#xA;&#x9;&#x9;tweetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void isReT" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1340" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599120021" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Count += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void isRet" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1324" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599461371" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweetCount += 1" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1319" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599644166" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1319" end="-320"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599663353" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="1587" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599812440" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + 1);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="1466" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487599820836" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="1466" end="-124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487601439185" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weetCount += 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public Tweet getTweet(int integ) {&#xA;&#x9;&#x9;int length = tweets.size();&#xA;&#x9;&#x9;return tweets.get(length - integ);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void isRetweeted() {&#xA;&#x9;&#x9;retweetCount += 1" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="1320" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598814565" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599403402" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598039244" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598041988" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598130338" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598176721" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598250497" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598314935" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598466474" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598536098" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598539653" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598637598" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487598923013" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599036027" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599186046" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599468432" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599580416" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599617877" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599665023" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599814247" completion="0.5" successCount="3" failureCount="1" errorCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487599822951" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487600785489" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601457970" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601854320" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601940945" completion="1.0" successCount="6">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
