<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488926081408" sizeMeasure="33" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card  implements Comparable&lt;Card>{&#xA;&#xA;&#x9;char suit;&#xA;&#x9;int face;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if( (suit == 'H' || suit == 'S' || suit == 'D' || suit == 'C' ) &amp;&amp; (face &lt; 14 &amp;&amp; face > 0)) {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Make sure that you juse a number between 1 and 13 and only H, D, S or C as suits&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return suit + Integer.toString(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;Card card = new Card('C',13);&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488926108494" sizeMeasure="33" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="495" end="-180"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488926254894" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public int compareTo(Card compareCard){&#xA;&#x9;&#x9;char thisSuit = this.getSuit();&#xA;&#x9;&#x9;int compareSuit = this.getSuit();&#xA;&#x9;&#x9;if (thisSuit != compareSuit){&#xA;&#x9;&#x9;&#x9;return thisSuit - compareSuit;&#xA;&#x9;&#x9;}else if (thisSuit == compareSuit){&#xA;&#x9;&#x9;&#x9;return this.getFace() -compareCard.getFace();&#xA;&#x9;&#x9;}return false" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="681" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488926264940" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="957" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928422144" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;if( (suit == 'H' || suit == 'S' || suit == 'D' || suit == 'C' ) &amp;&amp; (face &lt; 14 &amp;&amp; face > 0)) {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Make sure that you juse a number between 1 and 13 and only H, D, S or C as suits&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return suit + Integer.toString(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;Card card = new Card('C',13);&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#x9;public int compareTo(Card compareCard){&#xA;&#x9;&#x9;int differance = SUITS.indexOf(compareCard.suit) - SUITS.indexOf(suit);&#xA;&#x9;&#x9;if (differance == 0){&#xA;&#x9;&#x9;&#x9;differance = face - compareCard.face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return differance;&#xA;&#x9;&#x9;/*char thisSuit = this.getSuit();&#xA;&#x9;&#x9;int compareSuit = this.getSuit();&#xA;&#x9;&#x9;if (thisSuit != compareSuit){&#xA;&#x9;&#x9;&#x9;return thisSuit - compareSuit;&#xA;&#x9;&#x9;}else if (thisSuit == compareSuit){&#xA;&#x9;&#x9;&#x9;return this.getFace() -compareCard.getFace();&#xA;&#x9;&#x9;}return face;*/" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="94" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928941109" sizeMeasure="46" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;Card card1 = new Card('C', 3);" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="932" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929024217" sizeMeasure="46" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Card card2 = new Card ('C',13);&#xA;&#x9;&#x9;card.compareTo(card2);&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#x9;public int compareTo(Card compareCard){&#xA;&#x9;&#x9;int differance = SUITS.indexOf(compareCard.suit) - SUITS.indexOf(suit);&#xA;&#x9;&#x9;if (differance == 0){&#xA;&#x9;&#x9;&#x9;differance = face - compareCard.face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return differance;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="723" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929043019" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1023" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929095069" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".compareTo(card2)" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="806" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929105414" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="9" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="751" end="-294"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929118231" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="748" end="-297"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488926934746" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488926970737" sizeMeasure="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Cards> {&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488927327448" sizeMeasure="46" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;boolean bool;&#xA;&#x9;char c = 'S';&#xA;&#x9;&#xA;&#x9;CardComparator(boolean bool, char c){&#xA;&#x9;&#x9;this.bool = bool;&#xA;&#x9;&#x9;if (c == 'H' || c =='S' || c == 'C' || c=='D'){&#xA;&#x9;&#x9;&#x9;this.c = c;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private int bigAce(Card nr1, Card nr2){&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card nr1, Card nr2){&#xA;&#x9;&#x9;if(c!='S'){&#xA;&#x9;&#x9;&#x9;char nr1Suit = nr1.getSuit();&#xA;&#x9;&#x9;&#x9;char nr2Suit = nr2.getSuit();&#xA;&#x9;&#x9;&#x9;if(nr1Suit == c){&#xA;&#x9;&#x9;&#x9;&#x9;if (nr2Suit == c){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(nr2Suit != c){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;&#x9;int nr1face= nr1.getFace();&#xA;&#x9;&#x9;&#x9;    int nr2face= nr2.getFace();&#xA;&#x9;&#x9;&#x9;    if (nr1face == 1){&#xA;&#x9;&#x9;&#x9;    &#x9;return 0;&#xA;&#x9;&#x9;&#x9;    &#x9;}else if(nr2face != 1){&#xA;&#x9;&#x9;&#x9;    &#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;    &#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;    }&#xA;&#x9;&#x9;return nr1.compareTo(nr2);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="112" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488927462854" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="> {&#xA;&#x9;&#xA;&#x9;boolean bool;&#xA;&#x9;char c = 'S';&#xA;&#x9;&#xA;&#x9;CardComparator(boolean bool, char c){&#xA;&#x9;&#x9;this.bool = bool;&#xA;&#x9;&#x9;if (c == 'H' || c =='S' || c == 'C' || c=='D'){&#xA;&#x9;&#x9;&#x9;this.c = c;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private int bigAce(Card card1, Card card2){&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card card1, Card card2){&#xA;&#x9;&#x9;if(c!='S'){&#xA;&#x9;&#x9;&#x9;char Suit1 = card1.getSuit();&#xA;&#x9;&#x9;&#x9;char Suit2 = card2.getSuit();&#xA;&#x9;&#x9;&#x9;if(Suit1 == c){&#xA;&#x9;&#x9;&#x9;&#x9;if (Suit2 == c){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(Suit2 != c){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;&#x9;int face1= card1.getFace();&#xA;&#x9;&#x9;&#x9;    int face2= card2.getFace();&#xA;&#x9;&#x9;&#x9;    if (face1 == 1){&#xA;&#x9;&#x9;&#x9;    &#x9;return 0;&#xA;&#x9;&#x9;&#x9;    &#x9;}else if(face2 != 1){&#xA;&#x9;&#x9;&#x9;    &#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;    &#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;    }&#xA;&#x9;&#x9;return card1.compareTo(card2);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="105" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488927813142" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String suitOrder = &quot;CSHD&quot;;&#xA;&#x9;boolean bool;&#xA;&#x9;char c = 'S';&#xA;&#x9;&#xA;&#x9;CardComparator(boolean bool, char c){&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;this.bool = bool;&#xA;&#x9;&#x9;if (c == 'H' || c =='S' || c == 'C' || c=='D'){&#xA;&#x9;&#x9;&#x9;this.c = c;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="112" end="-478"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928157751" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nt suit1 = suitOrder.indexOf(card1.getSuit());&#xA;&#x9;&#x9;int suit2 = suitOrder.indexOf(card2.getSuit());&#xA;&#x9;&#x9;if (card1.getSuit() == c){&#xA;&#x9;&#x9;&#x9;suit1 = suitOrder.length();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (card2.getSuit() == c){&#xA;&#x9;&#x9;&#x9;suit2 = suitOrder.length();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int differance = suit1 - suit2;&#xA;&#x9;&#x9;if(differance == 0){&#xA;&#x9;&#x9;&#x9;int face1 = card1.getFace();&#xA;&#x9;&#x9;&#x9;int face2 = card2.getFace();&#xA;&#x9;&#x9;&#x9;if(bool){&#xA;&#x9;&#x9;&#x9;&#x9;if(face1==1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;face1=14;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;if(face2 == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;face2= 14;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;differance = face1 - face2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return differance;&#xA;&#x9;&#x9;/*if(c!='S'){&#xA;&#x9;&#x9;&#x9;char Suit1 = card1.getSuit();&#xA;&#x9;&#x9;&#x9;char Suit2 = card2.getSuit();&#xA;&#x9;&#x9;&#x9;if(Suit1 == c){&#xA;&#x9;&#x9;&#x9;&#x9;if (Suit2 == c){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(Suit2 != c){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;&#x9;int face1= card1.getFace();&#xA;&#x9;&#x9;&#x9;    int face2= card2.getFace();&#xA;&#x9;&#x9;&#x9;    if (face1 == 1){&#xA;&#x9;&#x9;&#x9;    &#x9;return 0;&#xA;&#x9;&#x9;&#x9;    &#x9;}else if(face2 != 1){&#xA;&#x9;&#x9;&#x9;    &#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;    &#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;    }&#xA;&#x9;&#x9;return card1.compareTo(card2);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0;*/" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="375" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928515589" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="DHS" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="141" end="-1166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928726916" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;CardComparator card = new CardComparator(true, ' ');&#xA;&#x9;&#x9;System.out.println(card);" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="878" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928766657" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S');&#xA;&#x9;&#x9;System.out.println(&quot;Card er&quot; + " edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="978" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928942811" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1012" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929268662" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="220" end="-804"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929614372" sizeMeasure="54" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;private String suitOrder = &quot;CDHS&quot;;&#xA;&#x9;boolean bool;&#xA;&#x9;char c = 'S';&#xA;&#x9;&#xA;&#x9;CardComparator(boolean bool, char c){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.bool = bool;&#xA;&#x9;&#x9;if (c == 'H' || c =='S' || c == 'C' || c=='D'){&#xA;&#x9;&#x9;&#x9;this.c = c;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int compare(Card card1, Card card2){&#xA;&#x9;&#x9;int suit1 = suitOrder.indexOf(card1.getSuit());&#xA;&#x9;&#x9;int suit2 = suitOrder.indexOf(card2.getSuit());&#xA;&#x9;&#x9;if (card1.getSuit() == c){&#xA;&#x9;&#x9;&#x9;suit1 = suitOrder.length();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (card2.getSuit() == c){&#xA;&#x9;&#x9;&#x9;suit2 = suitOrder.length();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int differance = suit1 - suit2;&#xA;&#x9;&#x9;if(differance == 0){&#xA;&#x9;&#x9;&#x9;int face1 = card1.getFace();&#xA;&#x9;&#x9;&#x9;int face2 = card2.getFace();&#xA;&#x9;&#x9;&#x9;if(bool){&#xA;&#x9;&#x9;&#x9;&#x9;if(face1==1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;face1=14;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;if(face2 == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;face2= 14;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;differance = face1 - face2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return differance;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="38" end="-6"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488928942776" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488929025262" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488929043794" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488929096115" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488929106247" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488929119010" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488928729958" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488928771404" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488926434740" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488927475707" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488927816071" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488928160028" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488928426940" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488928517665" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488929269005" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
