<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardContainer interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardContainer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Copy/write the source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Modify the source code for the CardHand class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Modify the source code for the CardDeck class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CardContainerIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardContainerIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardHand class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardDeck class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardContainerIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardContainerIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardDeckTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardDeckTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardHandTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardHandTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardContainerIteratorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardContainerIteratorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488460233010" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public interface CardContainer {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488460963222" sizeMeasure="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends Iterable&lt;Card> {&#xA;&#x9;&#xA;&#x9;public int getCardCount();&#xA;&#x9;public Card getCard(int n) throws IllegalArgumentException;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="52" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488460136240" sizeMeasure="49">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(checkCard(suit,face))) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig sort eller nummer!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean checkCard(char suit, int face) {&#xA;&#x9;&#x9;if ((suit == 'S' || suit == 'H' || suit == 'C' || suit == 'D') &amp;&amp; (face >=1 &amp;&amp; face &lt;=13)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return suit + String.valueOf(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('H',12);&#xA;&#x9;&#x9;card.checkCard('H', 12);&#xA;&#x9;&#x9;card.getFace();&#xA;&#x9;&#x9;card.getSuit();&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488534104409" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class Card implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(checkCard(suit,face))) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig sort eller nummer!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean checkCard(char suit, int face) {&#xA;&#x9;&#x9;if ((suit == 'S' || suit == 'H' || suit == 'C' || suit == 'D') &amp;&amp; (face >=1 &amp;&amp; face &lt;=13)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;/*&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return (int) (this.getFace() - o.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return (int) (this.getSuit() - o.getSuit());&#xA;&#x9;}*/&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return suit + String.valueOf(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('H',12);&#xA;&#x9;&#x9;card.checkCard('H', 12);&#xA;&#x9;&#x9;card.getFace();&#xA;&#x9;&#x9;card.getSuit();&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488796699490" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(checkCard(suit,face))) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig sort eller nummer!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean checkCard(char suit, int face) {&#xA;&#x9;&#x9;if ((suit == 'S' || suit == 'H' || suit == 'C' || suit == 'D') &amp;&amp; (face >=1 &amp;&amp; face &lt;=13)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;/*&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return (int) (this.getFace() - o.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return (int) (this.getSuit() - o.getSuit());&#xA;&#x9;}*/&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return suit + String.valueOf(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('H',12);&#xA;&#x9;&#x9;card.checkCard('H', 12);&#xA;&#x9;&#x9;card.getFace();&#xA;&#x9;&#x9;card.getSuit();&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;if (this.getSuit() != card.getSuit()) {&#xA;&#x9;&#x9;&#x9;return this.getSuit() - card.getSuit();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() != card.getFace()) {&#xA;&#x9;&#x9;&#x9;return this.getFace() - card.getFace();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="21" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488799239219" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;private char[] suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(checkCard(suit,face))) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig sort eller nummer!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean checkCard(char suit, int face) {&#xA;&#x9;&#x9;if ((suit == 'S' || suit == 'H' || suit == 'C' || suit == 'D') &amp;&amp; (face >=1 &amp;&amp; face &lt;=13)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;/*&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return (int) (this.getFace() - o.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return (int) (this.getSuit() - o.getSuit());&#xA;&#x9;}*/&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return suit + String.valueOf(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('H',12);&#xA;&#x9;&#x9;card.checkCard('H', 12);&#xA;&#x9;&#x9;card.getFace();&#xA;&#x9;&#x9;card.getSuit();&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;if (this.getSuit() != card.getSuit()) {&#xA;&#x9;&#x9;&#x9;for (char i : suits) {&#xA;&#x9;&#x9;&#x9;&#x9;if (i == card.getSuit()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if (i == this.getSuit()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() != card.getFace()) {&#xA;&#x9;&#x9;&#x9;return - (this.getFace() - card.getFace()" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="21" end="-32"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801331589" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="630" end="-598"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488460151828" sizeMeasure="36">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class CardHand {&#xA;&#x9;&#xA;&#x9;List&lt;Card> hand = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public CardHand() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= getCardCount() || n &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig input&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return hand.get(n);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return hand.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addCard(Card card) {&#xA;&#x9;&#x9;this.hand.add(card);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card play(int n) {&#xA;&#x9;&#x9;Card pick = hand.get(n);&#xA;&#x9;&#x9;this.hand.remove(n);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return pick;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488460662604" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Iterator;&#xA;import java.util.List;&#xA;&#xA;public class CardHand implements CardContainer {&#xA;&#x9;&#xA;&#x9;List&lt;Card> hand = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public CardHand() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= getCardCount() || n &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig input&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return hand.get(n);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return hand.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addCard(Card card) {&#xA;&#x9;&#x9;this.hand.add(card);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card play(int n) {&#xA;&#x9;&#x9;Card pick = hand.get(n);&#xA;&#x9;&#x9;this.hand.remove(n);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return pick;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Iterator&lt;Card> iterator() {&#xA;&#x9;&#x9;return hand.iterator()" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="66" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488460142419" sizeMeasure="69" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.ArrayList;&#xA;&#xA;import java.util.List;&#xA;&#xA;public class CardDeck {&#xA;&#x9; &#xA;&#x9;private List&lt;Card> deck = new ArrayList&lt;>();&#xA;&#x9;private char suits[] = new char[] {'S','H','D','C'};&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if (n &lt; 1 || n > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig input&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;for (int j = 0; j &lt; n; j++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card card = new Card(suits[i],j+1);&#xA;&#x9;&#x9;&#x9;&#x9;deck.add(card);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= getCardCount() || n &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig input&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return deck.get(n);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return deck.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public List&lt;Card> shufflePerfectly() {&#xA;&#x9;&#x9;List&lt;Card> newDeck = new ArrayList&lt;Card>();&#xA;&#xA;        for (int i = 0, j = getCardCount()/2; i &lt; getCardCount()/2; i++, j++) {&#xA;            newDeck.add(deck.get(i));&#xA;            newDeck.add(deck.get(j));&#xA;        }&#xA;&#xA;        deck = newDeck;&#xA;&#xA;        return newDeck;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;/*&#xA;&#x9;&#x9;int half = (deck.size())/2;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; half; i++) {&#xA;&#x9;&#x9;&#x9;Card card = deck.remove(half+i);&#xA;&#x9;&#x9;&#x9;deck.add(i*2+1 , card);&#xA;&#x9;&#x9;}*/&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deal(CardHand hand, int n) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; n; i++) {&#xA;&#x9;&#x9;&#x9;hand.addCard(deck.get(getCardCount() - 1));&#xA;&#x9;&#x9;&#x9;deck.remove(getCardCount() - 1);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="59" charStart="1139" charEnd="1147" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488460660863" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;import java.util.List;&#xA;&#xA;public class CardDeck implements CardContainer {&#xA;&#x9; &#xA;&#x9;private List&lt;Card> deck = new ArrayList&lt;>();&#xA;&#x9;private char suits[] = new char[] {'S','H','D','C'};&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if (n &lt; 1 || n > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig input&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = 0; i &lt; 4; i++) {&#xA;&#x9;&#x9;&#x9;for (int j = 0; j &lt; n; j++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card card = new Card(suits[i],j+1);&#xA;&#x9;&#x9;&#x9;&#x9;deck.add(card);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= getCardCount() || n &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig input&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return deck.get(n);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return deck.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public List&lt;Card> shufflePerfectly() {&#xA;&#x9;&#x9;List&lt;Card> newDeck = new ArrayList&lt;Card>();&#xA;&#xA;        for (int i = 0, j = getCardCount()/2; i &lt; getCardCount()/2; i++, j++) {&#xA;            newDeck.add(deck.get(i));&#xA;            newDeck.add(deck.get(j));&#xA;        }&#xA;&#xA;        deck = newDeck;&#xA;&#xA;        return newDeck;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deal(CardHand hand, int n) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; n; i++) {&#xA;&#x9;&#x9;&#x9;hand.addCard(deck.get(getCardCount() - 1));&#xA;&#x9;&#x9;&#x9;deck.remove(getCardCount() - 1);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Iterator&lt;Card> iterator() {&#xA;&#x9;&#x9;return deck.iterator();&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488460701480" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardContainerIterator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488463126855" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;&#xA;public class CardContainerIterator implements Iterator&lt;Card> {&#xA;&#x9;private CardContainer cardContainer;&#xA;&#x9;private int position;&#xA;&#x9;&#xA;&#x9;public CardContainerIterator(CardContainer cardContainer) {&#xA;&#x9;&#x9;this.cardContainer = cardContainer;&#xA;&#x9;&#x9;this.position = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return position &lt; cardContainer.getCardCount();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public Card next() {&#xA;&#x9;&#x9;return cardContainer.getCard(position++);&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488463171197" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public void remove() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="474" end="-10"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488463243374" completion="1.0" successCount="2">
          <successTests>testCardContainer</successTests>
          <successTests>testDeckIterator</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488799590568" completion="1.0" successCount="2">
          <successTests>testCardContainer</successTests>
          <successTests>testDeckIterator</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.10/@q" answer="/0/@parts.0/@tasks.10/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488463237324" completion="1.0" successCount="2">
          <successTests>testCardContainer</successTests>
          <successTests>testHandIterator</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488799537646" completion="1.0" successCount="2">
          <successTests>testCardContainer</successTests>
          <successTests>testHandIterator</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.11/@q" answer="/0/@parts.0/@tasks.11/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488463250391" completion="1.0" successCount="1">
          <successTests>testCardContainerIterator</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488799549824" completion="1.0" successCount="1">
          <successTests>testCardContainerIterator</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="24">
        <attempts timestamp="1488799778120"/>
        <attempts timestamp="1488799783862"/>
        <attempts timestamp="1488799789350"/>
        <attempts timestamp="1488799792376"/>
        <attempts timestamp="1488799794972"/>
        <attempts timestamp="1488799943940"/>
        <attempts timestamp="1488800008434"/>
        <attempts timestamp="1488800011099"/>
        <attempts timestamp="1488800012952"/>
        <attempts timestamp="1488800013799"/>
        <attempts timestamp="1488800014355"/>
        <attempts timestamp="1488800022103"/>
        <attempts timestamp="1488800022873"/>
        <attempts timestamp="1488800023467"/>
        <attempts timestamp="1488800026837"/>
        <attempts timestamp="1488800034253"/>
        <attempts timestamp="1488800035284"/>
        <attempts timestamp="1488800036294"/>
        <attempts timestamp="1488800037219"/>
        <attempts timestamp="1488800038074"/>
        <attempts timestamp="1488800051271"/>
        <attempts timestamp="1488800057155"/>
        <attempts timestamp="1488800167298"/>
        <attempts timestamp="1488800522748"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="6">
        <attempts timestamp="1488799889681"/>
        <attempts timestamp="1488799898194"/>
        <attempts timestamp="1488799899497"/>
        <attempts timestamp="1488799900100"/>
        <attempts timestamp="1488800165243"/>
        <attempts timestamp="1488800431505"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="9">
        <attempts timestamp="1488799742553"/>
        <attempts timestamp="1488799838587"/>
        <attempts timestamp="1488799918803"/>
        <attempts timestamp="1488800075467"/>
        <attempts timestamp="1488800104166"/>
        <attempts timestamp="1488800138521"/>
        <attempts timestamp="1488800212618"/>
        <attempts timestamp="1488800434568"/>
        <attempts timestamp="1488800509515"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
