<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488198871678" sizeMeasure="51">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;//tilstand&#xA;&#x9;private char cardColor; //farge på kortet som betegnes enten 'H', 'C', 'S', 'D'&#xA;&#x9;private int cardNo; //nummer på kortet mellom 1-13&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;&#xA;&#x9;public Card(char cardColor, int cardNo){&#xA;&#x9;&#x9;if (cardColor !='H' &amp;&amp; cardColor !='C' &amp;&amp; cardColor != 'S' &amp;&amp; cardColor !='D'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNo&lt;1 || cardNo>13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColor=cardColor;&#xA;&#x9;&#x9;this.cardNo=cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main &#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card1 = new Card('S',2);&#xA;&#x9;&#x9;card1.toString();&#xA;&#x9;&#x9;System.out.println(&quot;Nå printes&quot;+card1.toString());&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;//metode&#xA;&#x9;&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return this.cardColor;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return this.cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;//String s1 = new StringBuilder().append(this.cardColor).append(this.cardNo).toString();&#xA;&#x9;&#x9;//String s2= this.cardColor.toString();&#xA;&#x9;&#x9;//String s3 = String.valueOf(this.cardColor);&#xA;&#x9;&#x9;//String s4= Character.toString(this.cardColor);&#xA;&#x9;&#x9;String s3=&quot;&quot;+this.cardColor+&quot;&quot;+this.cardNo;&#xA;&#x9;&#x9;return s3;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488198938600" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488198948527" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488198980600" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import encapsulation.Card;&#xA;&#xA;public class Card {&#xA;&#x9;//tilstand&#xA;&#x9;&#x9;private char cardColor; //farge på kortet som betegnes enten 'H', 'C', 'S', 'D'&#xA;&#x9;&#x9;private int cardNo; //nummer på kortet mellom 1-13&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//konstruktør&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public Card(char cardColor, int cardNo){&#xA;&#x9;&#x9;&#x9;if (cardColor !='H' &amp;&amp; cardColor !='C' &amp;&amp; cardColor != 'S' &amp;&amp; cardColor !='D'){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (cardNo&lt;1 || cardNo>13){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.cardColor=cardColor;&#xA;&#x9;&#x9;&#x9;this.cardNo=cardNo;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//main &#xA;&#x9;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#x9;Card card1 = new Card('S',2);&#xA;&#x9;&#x9;&#x9;card1.toString();&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Nå printes&quot;+card1.toString());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//metode&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public char getSuit(){&#xA;&#x9;&#x9;&#x9;return this.cardColor;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public int getFace(){&#xA;&#x9;&#x9;&#x9;return this.cardNo;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public String toString(){&#xA;&#x9;&#x9;&#x9;//String s1 = new StringBuilder().append(this.cardColor).append(this.cardNo).toString();&#xA;&#x9;&#x9;&#x9;//String s2= this.cardColor.toString();&#xA;&#x9;&#x9;&#x9;//String s3 = String.valueOf(this.cardColor);&#xA;&#x9;&#x9;&#x9;//String s4= Character.toString(this.cardColor);&#xA;&#x9;&#x9;&#x9;String s3=&quot;&quot;+this.cardColor+&quot;&quot;+this.cardNo;&#xA;&#x9;&#x9;&#x9;return s3;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="21" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488199007065" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488199022359" sizeMeasure="51">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;//tilstand&#xA;&#x9;private char cardColor; //farge på kortet som betegnes enten 'H', 'C', 'S', 'D'&#xA;&#x9;private int cardNo; //nummer på kortet mellom 1-13&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;&#xA;&#x9;public Card(char cardColor, int cardNo){&#xA;&#x9;&#x9;if (cardColor !='H' &amp;&amp; cardColor !='C' &amp;&amp; cardColor != 'S' &amp;&amp; cardColor !='D'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNo&lt;1 || cardNo>13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColor=cardColor;&#xA;&#x9;&#x9;this.cardNo=cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main &#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card1 = new Card('S',2);&#xA;&#x9;&#x9;card1.toString();&#xA;&#x9;&#x9;System.out.println(&quot;Nå printes&quot;+card1.toString());&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;//metode&#xA;&#x9;&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return this.cardColor;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return this.cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;//String s1 = new StringBuilder().append(this.cardColor).append(this.cardNo).toString();&#xA;&#x9;&#x9;//String s2= this.cardColor.toString();&#xA;&#x9;&#x9;//String s3 = String.valueOf(this.cardColor);&#xA;&#x9;&#x9;//String s4= Character.toString(this.cardColor);&#xA;&#x9;&#x9;String s3=&quot;&quot;+this.cardColor+&quot;&quot;+this.cardNo;&#xA;&#x9;&#x9;return s3;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488199537739" sizeMeasure="51" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparable;&#xA;&#xA;public class Card {&#xA;&#x9;//tilstand&#xA;&#x9;private char cardColor; //farge på kortet som betegnes enten 'H', 'C', 'S', 'D'&#xA;&#x9;private int cardNo; //nummer på kortet mellom 1-13&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;&#xA;&#x9;public Card(char cardColor, int cardNo){&#xA;&#x9;&#x9;if (cardColor !='H' &amp;&amp; cardColor !='C' &amp;&amp; cardColor != 'S' &amp;&amp; cardColor !='D'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNo&lt;1 || cardNo>13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColor=cardColor;&#xA;&#x9;&#x9;this.cardNo=cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main &#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card1 = new Card('S',2);&#xA;&#x9;&#x9;card1.toString();&#xA;&#x9;&#x9;System.out.println(&quot;Nå printes&quot;+card1.toString());&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="21" end="-447"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488199871532" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class Card implements Comparable&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="21" end="-1075"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488200180401" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;//tilstand&#xA;&#x9;private char cardColor; //farge på kortet som betegnes enten 'H', 'C', 'S', 'D'&#xA;&#x9;private int cardNo; //nummer på kortet mellom 1-13&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;&#xA;&#x9;public Card(char cardColor, int cardNo){&#xA;&#x9;&#x9;if (cardColor !='H' &amp;&amp; cardColor !='C' &amp;&amp; cardColor != 'S' &amp;&amp; cardColor !='D'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNo&lt;1 || cardNo>13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColor=cardColor;&#xA;&#x9;&#x9;this.cardNo=cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main &#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card1 = new Card('S',2);&#xA;&#x9;&#x9;card1.toString();&#xA;&#x9;&#x9;System.out.println(&quot;Nå printes&quot;+card1.toString());&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//metode&#xA;&#x9;&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return this.cardColor;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return this.cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;//String s1 = new StringBuilder().append(this.cardColor).append(this.cardNo).toString();&#xA;&#x9;&#x9;//String s2= this.cardColor.toString();&#xA;&#x9;&#x9;//String s3 = String.valueOf(this.cardColor);&#xA;&#x9;&#x9;//String s4= Character.toString(this.cardColor);&#xA;&#x9;&#x9;String s3=&quot;&quot;+this.cardColor+&quot;&quot;+this.cardNo;&#xA;&#x9;&#x9;return s3;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="67" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488201929532" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int colorToNum(){&#xA;&#x9;&#x9;if(cardColor=='H'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='S'){&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='D'){&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;} else{&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;//String s1 = new StringBuilder().append(this.cardColor).append(this.cardNo).toString();&#xA;&#x9;&#x9;//String s2= this.cardColor.toString();&#xA;&#x9;&#x9;//String s3 = String.valueOf(this.cardColor);&#xA;&#x9;&#x9;//String s4= Character.toString(this.cardColor);&#xA;&#x9;&#x9;String s3=&quot;&quot;+this.cardColor+&quot;&quot;+this.cardNo;&#xA;&#x9;&#x9;return s3;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.cardColor!=o.cardColor){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="821" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488201992810" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char color){&#xA;&#x9;&#x9;if(cardColor=='H'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='S'){&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='D'){&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;} else{&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;//String s1 = new StringBuilder().append(this.cardColor).append(this.cardNo).toString();&#xA;&#x9;&#x9;//String s2= this.cardColor.toString();&#xA;&#x9;&#x9;//String s3 = String.valueOf(this.cardColor);&#xA;&#x9;&#x9;//String s4= Character.toString(this.cardColor);&#xA;&#x9;&#x9;String s3=&quot;&quot;+this.cardColor+&quot;&quot;+this.cardNo;&#xA;&#x9;&#x9;return s3;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.cardToNum()" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="836" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488202167262" sizeMeasure="77" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int cardNo; //nummer på kortet mellom 1-13&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;&#xA;&#x9;public Card(char cardColor, int cardNo){&#xA;&#x9;&#x9;if (cardColor !='H' &amp;&amp; cardColor !='C' &amp;&amp; cardColor != 'S' &amp;&amp; cardColor !='D'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNo&lt;1 || cardNo>13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColor=cardColor;&#xA;&#x9;&#x9;this.cardNo=cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main &#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card1 = new Card('S',2);&#xA;&#x9;&#x9;card1.toString();&#xA;&#x9;&#x9;System.out.println(&quot;Nå printes&quot;+card1.toString());&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//metode&#xA;&#x9;&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return this.cardColor;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return this.cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int colorToNum(char color){&#xA;&#x9;&#x9;if(cardColor=='H'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='S'){&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='D'){&#xA;&#x9;&#x9;&#x9;return 2;&#xA;&#x9;&#x9;} else{&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;//String s1 = new StringBuilder().append(this.cardColor).append(this.cardNo).toString();&#xA;&#x9;&#x9;//String s2= this.cardColor.toString();&#xA;&#x9;&#x9;//String s3 = String.valueOf(this.cardColor);&#xA;&#x9;&#x9;//String s4= Character.toString(this.cardColor);&#xA;&#x9;&#x9;String s3=&quot;&quot;+this.cardColor+&quot;&quot;+this.cardNo;&#xA;&#x9;&#x9;return s3;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.colorToNum(cardColor)!=o.colorToNum(cardColor)){&#xA;&#x9;&#x9;&#x9;return this.colorToNum(cardColor)-o.colorToNum(cardColor);&#xA;&#x9;&#x9;if (this.cardNo != o.cardNo){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="163" end="-34"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488202259943" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.colorToNum(cardColor)!=o.colorToNum(cardColor)){&#xA;&#x9;&#x9;&#x9;return this.colorToNum(cardColor)-o.colorToNum(cardColor);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.cardNo != o.cardNo){&#xA;&#x9;&#x9;&#x9;return this.cardNo-o.cardNo;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1309" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488202742745" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;//tilstand&#xA;&#x9;private char cardColor; //farge på kortet som betegnes enten 'H', 'C', 'S', 'D'&#xA;&#x9;int cardNo; //nummer på kortet mellom 1-13&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;&#xA;&#x9;public Card(char cardColor, int cardNo){&#xA;&#x9;&#x9;if (cardColor !='H' &amp;&amp; cardColor !='C' &amp;&amp; cardColor != 'S' &amp;&amp; cardColor !='D'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNo&lt;1 || cardNo>13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColor=cardColor;&#xA;&#x9;&#x9;this.cardNo=cardNo;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main &#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',2),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',3),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',9),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',6),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C',3))); &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="21" end="-892"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488202758527" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="880" end="-898"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203447332" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1796" end="-1797"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205008473" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char cardColor; //farge på kortet som betegnes enten 'H', 'C', 'S', 'D'&#xA;&#x9;int cardNo; //nummer på kortet mellom 1-13&#xA;&#x9;int colorNum;&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;&#xA;&#x9;public Card(char cardColor, int cardNo){&#xA;&#x9;&#x9;if (cardColor !='H' &amp;&amp; cardColor !='C' &amp;&amp; cardColor != 'S' &amp;&amp; cardColor !='D'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNo&lt;1 || cardNo>13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColor=cardColor;&#xA;&#x9;&#x9;this.cardNo=cardNo;&#xA;&#x9;&#x9;this.colorNum=colorToNum(cardColor)" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="188" end="-1170"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205075675" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Num!=o.colorNum){&#xA;&#x9;&#x9;&#x9;return this.colorNum-o.colorNum" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1626" end="-113"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488221747342" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1790" end="-1791"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298544156" sizeMeasure="89" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="){&#xA;&#x9;&#x9;if(this.cardColor=='H'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.cardColor=='S'){&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this." edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1098" end="-597"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298563476" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char cardColor){&#xA;&#x9;&#x9;if(cardColor=='H'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='S'){&#xA;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1098" end="-597"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299637433" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='S'){&#xA;&#x9;&#x9;&#x9;return 3;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cardColor=='D'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else{&#xA;&#x9;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="1147" end="-546"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299644366" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1147" end="-647"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302354415" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //burde ikke tatt inn char cardColor, men heller skrive this.cardColor" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1114" end="-681"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203644448" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203756912" sizeMeasure="6" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator; &#xA;&#xA;public class CardComparator implements Comparator&lt;Card>" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="20" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203770294" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="109" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203951739" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //samme metoden som compareTo men tar inn to argumenter og ikke this&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="164" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203996371" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="109" end="-148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204262454" sizeMeasure="19" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private boolean descending;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean descending, char trumf){&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="111" end="-146"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204312086" sizeMeasure="21" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private char trumf;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean descending, char trumf){&#xA;&#x9;&#x9;this.descending=descending;&#xA;&#x9;&#x9;this.trumf=trumf;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="140" end="-149"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204816235" sizeMeasure="31" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card a = (descending ? o2 :o1);&#xA;&#x9;&#x9;Card b= (descending ? o1:o2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (a.colorToNum(cardColor)!=b.colorToNum(cardColor)){&#xA;&#x9;&#x9;&#x9;return a.colorToNum(cardColor)-b.colorToNum(cardColor);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (a.cardNo != b.cardNo){&#xA;&#x9;&#x9;&#x9;return a.cardNo-b.cardNo;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="396" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204866859" sizeMeasure="30" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean descending, char trumf){&#xA;&#x9;&#x9;this.descending=descending" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="140" end="-411"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204923556" sizeMeasure="30" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="637" end="-638"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205197631" sizeMeasure="29" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) { //samme metoden som compareTo men tar inn to argumenter og ikke this&#xA;&#x9;&#x9;Card a = (descending ? o2 :o1);&#xA;&#x9;&#x9;Card b= (descending ? o1:o2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (a.colorToNum(colorNum" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="234" end="-186"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205232391" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Num!=b.colorNum){&#xA;&#x9;&#x9;&#x9;return a.colorNum-b.colorNum" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="436" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205313534" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//tilstander&#xA;&#x9;private boolean descending;&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;public CardComparator(boolean descending, char trumf){&#xA;&#x9;&#x9;this.descending=descending;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;//metoder" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="111" end="-341"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205437063" sizeMeasure="45" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collections;&#xA;import java.util.Comparator;&#xA;import java.util.List; &#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#xA;&#x9;//tilstander&#xA;&#x9;private boolean descending;&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;public CardComparator(boolean descending, char trumf){&#xA;&#x9;&#x9;this.descending=descending;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main&#xA;&#x9;public static void main (String [] args){&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',2),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',3),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',9),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',6),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C',3))); &#xA;&#x9;&#x9;Collections.sort(cards, new CardComperator(true));&#xA;&#x9;} " edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="37" end="-354"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205469970" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="){&#xA;&#x9;&#x9;this.descending=descending;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main&#xA;&#x9;public static void main (String [] args){&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',2),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',3),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',9),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',6),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C',3))); &#xA;&#x9;&#x9;Collections.sort(cards, new CardCompa" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="317" end="-371"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205489997" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(cards" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="624" end="-360"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205677890" sizeMeasure="47" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private char trumf;&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;public CardComparator(boolean descending, char trumf" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="260" end="-692"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205701742" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", 'S'" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="652" end="-390"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205711519" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="655" end="-391"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488206018657" sizeMeasure="48" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.trumf=trumf" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="384" end="-666"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488207165450" sizeMeasure="53" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;if (trumf=='C'){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="404" end="-665"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488221702328" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main&#xA;&#x9;public static void main (String [] args){&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',2),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',3),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',9),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',6),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C',3))); &#xA;&#x9;&#x9;Collections.sort(cards, new CardComparator(true, ' '));&#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;} &#xA;&#x9;&#xA;&#x9;//metoder&#xA;&#x9;public int compare(Card o1, Card o2) { //samme metoden som compareTo men tar inn to argumenter og ikke this&#xA;&#x9;&#x9;Card a = (descending ? o2 :o1);&#xA;&#x9;&#x9;Card b= (descending ? o1:o2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(o1.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;o1.colorNum+=7;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="408" end="-166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488221726062" sizeMeasure="59" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(o2.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;o2" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="973" end="-183"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488221733559" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="403" end="-771"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488221742716" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="676" end="-497"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488221927796" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;a.colorNum+=7;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;b" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="911" end="-183"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488222472508" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=",&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',5),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C',11),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',2" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="619" end="-552"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488222729785" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*if(a.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;a.colorNum+=7;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;b.colorNum+=7;&#xA;&#x9;&#x9;} */" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="972" end="-166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488222783213" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(a.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;a.colorNum+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;b.colorNum+=4;&#xA;&#x9;&#x9;} " edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="972" end="-166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488222818552" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.trumf){&#xA;&#x9;&#x9;&#x9;a.colorNum+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this." edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="989" end="-196"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488222853095" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rumf){&#xA;&#x9;&#x9;&#x9;a.colorNum+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="989" end="-196"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223053625" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="7;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;b.colorNum+=7" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="1011" end="-172"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223099434" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==trumf){&#xA;&#x9;&#x9;&#x9;b.colorNum+=4" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="1011" end="-172"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223209398" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.trumf){&#xA;&#x9;&#x9;&#x9;a.colorNum+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this." edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="989" end="-196"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223342642" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*if(a.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;a.colorNum+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;b.colorNum+=4;&#xA;&#x9;&#x9;} */" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="972" end="-166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223495277" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(a.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;a.colorNum+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;b.colorNum+=4;&#xA;&#x9;&#x9;} " edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="972" end="-166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223623507" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',13))); &#xA;&#x9;&#x9;Collections.sort(cards, new CardComparator(false, 'D" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="530" end="-504"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223920881" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="530" end="-589"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223949013" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',1" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="534" end="-564"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488223987324" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=",&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('C',5),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('C',8" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="557" end="-564"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224006138" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('C',13" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="577" end="-564"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224059459" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('S" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="574" end="-568"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224077361" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('H" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="574" end="-568"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224116677" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=",&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('S',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('S',1" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="602" end="-564"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224134519" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('D',13" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="534" end="-654"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224165875" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="551" end="-679"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224363112" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('D',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('D',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('C',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('C',13" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="530" end="-564"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224431512" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1 :o2);&#xA;&#x9;&#x9;Card b= (descending ? o2:o1" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="935" end="-281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224449134" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2 :o1" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="935" end="-313"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224457623" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1:o2" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="968" end="-281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224679687" sizeMeasure="62" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int aVar=0;&#xA;&#x9;&#x9;private int bVar=0;&#xA;&#x9;&#x9;if(a.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;aVar=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;bVar=4;&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ((a.colorNum+aVar)!=(b.colorNum+bVar)){&#xA;&#x9;&#x9;&#x9;return (a.colorNum+aVar)-(b.colorNum+bVar)" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="980" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488224690164" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int aVar=0;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="980" end="-301"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298241267" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="1294" end="-1295"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299308260" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //hvis descending er true er a=o2//hvis ikke er a=o1" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="942" end="-353"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299329756" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="740" end="-604"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299767248" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(descending) {&#xA;&#x9;&#x9;&#x9;aVar = -aVar;&#xA;&#x9;&#x9;&#x9;bVar = -bVar;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="1152" end="-194"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299795882" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4-aVar;&#xA;&#x9;&#x9;&#x9;bVar = 4" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="1185" end="-204"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299921090" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" (aVar != bVar){&#xA;&#x9;&#x9;&#x9;return aVar-bVar;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else " edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="1160" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299930533" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="bVar-a" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="1187" end="-108"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299997515" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a.getFace();&#xA;&#x9;&#x9;int bVar=;&#xA;&#x9;&#x9;if(a.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;aVar=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;bVar=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ((a.colorNum+aVar)!=(b.colorNum+bVar)){&#xA;&#x9;&#x9;&#x9;return (a.colorNum+aVar)-(b.colorNum+bVar);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="1041" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488300004635" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0;&#xA;&#x9;&#x9;int bVar=0" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="1041" end="-290"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488300146852" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="1240" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488300208923" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a.colorNum;&#xA;&#x9;&#x9;int bVar=b.colorNum;&#xA;&#x9;&#x9;if(a.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;aVar+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;bVar+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (aVar!=bVar){&#xA;&#x9;&#x9;&#x9;return aVar-bVar" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="1041" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488300236041" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="bVar-a" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="1205" end="-103"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488300270854" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="aVar-b" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="1205" end="-103"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488300315049" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(descending) {&#xA;&#x9;&#x9;&#x9;&#x9;return bVar-aVar;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return aVar-bVar;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="1198" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488301793606" sizeMeasure="70" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(descending == true){&#xA;&#x9;&#x9;&#x9;Card a= o2;&#xA;&#x9;&#x9;&#x9;Card b= o1;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="910" end="-467"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488301800817" sizeMeasure="70" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Card a = (descending ? o2 :o1); //hvis descending er true er a=o2//hvis ikke er a=o1&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="970" end="-377"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488301825995" sizeMeasure="73" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else {&#xA;&#x9;&#x9;&#x9;Card a = o1;&#xA;&#x9;&#x9;&#x9;Card b=o2" edit="/1/@proposals.0/@proposals.1/@attempts.67/@edit" start="967" end="-476"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488301852169" sizeMeasure="73" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.descending == fals" edit="/1/@proposals.0/@proposals.1/@attempts.68/@edit" start="913" end="-548"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488301856302" sizeMeasure="73" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.1/@attempts.69/@edit" start="932" end="-548"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488301889142" sizeMeasure="73" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;&#x9;Card b= o2;&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;Card a = o2;&#xA;&#x9;&#x9;&#x9;Card b=o1" edit="/1/@proposals.0/@proposals.1/@attempts.70/@edit" start="951" end="-476"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488301924467" sizeMeasure="75" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card a;&#xA;&#x9;&#x9;Card b;&#xA;&#x9;&#x9;if(this.descending == true){&#xA;&#x9;&#x9;&#x9;Card a= o1;&#xA;&#x9;&#x9;&#x9;Card b= o2;&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;Card a = o2;&#xA;&#x9;&#x9;&#x9;Card " edit="/1/@proposals.0/@proposals.1/@attempts.71/@edit" start="910" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488301943726" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a= o2;&#xA;&#x9;&#x9;&#x9;b= o1;&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;a= o1;&#xA;&#x9;&#x9;&#x9;b=o2" edit="/1/@proposals.0/@proposals.1/@attempts.72/@edit" start="962" end="-476"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302164858" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //forteller bare om tall, ikke noe om suits&#xA;&#x9;private char trumf;&#xA;&#x9;&#xA;&#x9;//konstruktør&#xA;&#x9;public CardComparator(boolean descending, char trumf){&#xA;&#x9;&#x9;this.descending=descending;&#xA;&#x9;&#x9;this.trumf=trumf;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//main&#xA;&#x9;public static void main (String [] args){&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('D',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('D',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('C',1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('C',13))); &#xA;&#x9;&#x9;Collections.sort(cards, new CardComparator(true, 'D'));&#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;} &#xA;&#x9;&#xA;&#x9;//metoder&#xA;&#x9;public int compare(Card o1, Card o2) { //samme metoden som compareTo men tar inn to argumenter og ikke this&#xA;&#x9;&#x9;Card a;&#xA;&#x9;&#x9;Card b;&#xA;&#x9;&#x9;if(this.descending == true){&#xA;&#x9;&#x9;&#x9;a= o2;&#xA;&#x9;&#x9;&#x9;b= o1;&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;a= o1;&#xA;&#x9;&#x9;&#x9;b=o2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Card a = (descending ? o2 :o1); //hvis descending er true er a=o2//hvis ikke er a=o1&#xA;&#x9;&#x9;//Card b= (descending ? o1:o2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int aVar=a.colorNum;&#xA;&#x9;&#x9;int bVar=b.colorNum;&#xA;&#x9;&#x9;if(a.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;aVar+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;bVar+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (aVar!=bVar){ &#xA;&#x9;&#x9;&#x9;if(descending) { //denne snur suits tilbake hvis descending = true og ess skal være størst" edit="/1/@proposals.0/@proposals.1/@attempts.73/@edit" start="258" end="-160"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302188953" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", rekkefølgen på suits skal ikke endres" edit="/1/@proposals.0/@proposals.1/@attempts.74/@edit" start="1441" end="-160"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302292721" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //her snues det om både på suits og på number, men vil egentlig bare snu om number&#xA;&#x9;&#x9;&#x9;a= o2;&#xA;&#x9;&#x9;&#x9;b= o1;&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;a= o1;&#xA;&#x9;&#x9;&#x9;b=o2;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Card a = (descending ? o2 :o1); //hvis descending er true er a=o2//hvis ikke er a=o1&#xA;&#x9;&#x9;//Card b= (descending ? o1:o2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int aVar=a.colorNum;&#xA;&#x9;&#x9;int bVar=b.colorNum;&#xA;&#x9;&#x9;if(a.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;aVar+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(b.getSuit()==this.trumf){&#xA;&#x9;&#x9;&#x9;bVar+=4;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (aVar!=bVar){ //håndterer sortering av suits&#xA;&#x9;&#x9;&#x9;if(descending) { //denne snur suits tilbake hvis descending = true og ess skal være størst, rekkefølgen på suits skal ikke endres&#xA;&#x9;&#x9;&#x9;&#x9;return bVar-aVar;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return aVar-bVar;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (a.cardNo != b.cardNo){ //håndterer sortering av tall" edit="/1/@proposals.0/@proposals.1/@attempts.75/@edit" start="1002" end="-66"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488202766030" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203994460" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488205195554" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488205241718" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488205502336" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488221093658" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488221746660" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488221932653" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488222476013" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488222727558" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488223344023" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488223521095" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488223630511" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488223926650" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488223951534" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488223990068" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224008754" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224062895" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224080840" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224124686" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224138491" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224170391" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224366983" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224434774" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224452522" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224703206" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488224710506" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488299306746" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488299333741" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488202943285" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488203174140" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488205518858" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488221762191" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488221946561" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488222748166" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488222786908" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488222823055" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488222859571" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488223061052" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488223103308" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488223215537" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488223353178" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488224023086" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488224185231" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488224717342" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488297921762" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488299652897" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488299773805" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488299801228" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488299924359" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488299933605" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488300152903" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488300214755" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488300239219" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488300273947" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488300318065" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488301803799" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488301830892" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488301882141" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488301894530" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488301950093" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="14">
        <attempts timestamp="1488223784458"/>
        <attempts timestamp="1488223789533"/>
        <attempts timestamp="1488223790543"/>
        <attempts timestamp="1488223791160"/>
        <attempts timestamp="1488223792258"/>
        <attempts timestamp="1488223793067"/>
        <attempts timestamp="1488223794517"/>
        <attempts timestamp="1488223796118"/>
        <attempts timestamp="1488223800182"/>
        <attempts timestamp="1488223801175"/>
        <attempts timestamp="1488223881019"/>
        <attempts timestamp="1488223884634"/>
        <attempts timestamp="1488223885379"/>
        <attempts timestamp="1488223886140"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="25">
        <attempts timestamp="1488223703525"/>
        <attempts timestamp="1488223707035"/>
        <attempts timestamp="1488223729732"/>
        <attempts timestamp="1488223734372"/>
        <attempts timestamp="1488223738019"/>
        <attempts timestamp="1488223740407"/>
        <attempts timestamp="1488223743572"/>
        <attempts timestamp="1488223752477"/>
        <attempts timestamp="1488223754689"/>
        <attempts timestamp="1488223756508"/>
        <attempts timestamp="1488223761283"/>
        <attempts timestamp="1488223763810"/>
        <attempts timestamp="1488223764563"/>
        <attempts timestamp="1488223766293"/>
        <attempts timestamp="1488223812630"/>
        <attempts timestamp="1488223820176"/>
        <attempts timestamp="1488223825815"/>
        <attempts timestamp="1488223828805"/>
        <attempts timestamp="1488223832187"/>
        <attempts timestamp="1488223839107"/>
        <attempts timestamp="1488223844420"/>
        <attempts timestamp="1488223846659"/>
        <attempts timestamp="1488223868157"/>
        <attempts timestamp="1488223875922"/>
        <attempts timestamp="1488223878463"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="2">
        <attempts timestamp="1488223533580"/>
        <attempts timestamp="1488223637578"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
