<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringGridImpl">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Copy the source code for the StringGrid interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGrid"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridImpl class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridImpl class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StringGridIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StringGridTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.StringGridTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.StringGrid*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144328050" sizeMeasure="19">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA; &#xA;/*&#xA;An interface with methods for managing the content of a String grid.&#xA;The grid has a number of rows (the grid's height) and columns (the grid's width).&#xA;In each cell in the grid there is a String that can be set with the setElement method and read with the getElement method.&#xA;*/&#xA; public interface StringGrid {&#xA;&#xA;    // Returns the number of rows in this StringGrid&#xA;    public int getRowCount();&#xA;    // Returns the number of columns in this StringGrid&#xA;    public int getColumnCount();&#xA; &#xA;    // Returns the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public String getElement(int row, int column);&#xA;    // Sets the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public void setElement(int row, int column, String element);&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144341900" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;/*&#xA;An interface with methods for managing the content of a String grid.&#xA;The grid has a number of rows (the grid's height) and columns (the grid's width).&#xA;In each cell in the grid there is a String that can be set with the setElement method and read with the getElement method.&#xA;*/&#xA;public interface StringGrid {&#xA;&#xA;&#x9;// Returns the number of rows in this StringGrid&#xA;&#x9;public int getRowCount();&#xA;&#xA;&#x9;// Returns the number of columns in this StringGrid&#xA;&#x9;public int getColumnCount();&#xA;&#xA;&#x9;// Returns the String at the given row and column. Throws an&#xA;&#x9;// IllegalArgumentException if the row or column is out of range&#xA;&#x9;public String getElement(int row, int column);&#xA;&#xA;&#x9;// Sets the String at the given row and column. Throws an&#xA;&#x9;// IllegalArgumentException if the row or column is out of range&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="20" end="-64"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150040521" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends Iterable&lt;String>" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="329" end="-533"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144383911" sizeMeasure="9">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class StringGridImpl {&#xA;&#xA;&#x9;public StringGridImpl() {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144418953" sizeMeasure="9" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements StringGrid" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="49" end="-80"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="50" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="50" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="50" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="50" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144438740" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int rows, int columnCount) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="97" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144486455" sizeMeasure="35" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private rows&#xA;&#xA;&#x9;public StringGridImpl(int rows, int cols" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="73" end="-474"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="97" charEnd="103" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="104" charEnd="138" severity="2" problemCategory="50" problemType="67109224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144510837" sizeMeasure="37" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="final int rows;&#xA;&#x9;private final int cols;&#xA;&#xA;&#x9;public StringGridImpl(int rows, int cols) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.cols = cols;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="84" end="-429"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="98" charEnd="102" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="124" charEnd="128" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144528751" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.rows;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return this.cols" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="256" end="-243"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144546690" sizeMeasure="36" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private final String[][]" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="125" end="-458"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="155" charEnd="156" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="155" charEnd="156" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="169" charEnd="203" severity="2" problemCategory="50" problemType="67109233"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="169" charEnd="203" severity="2" problemCategory="50" problemType="67109224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144557144" sizeMeasure="37" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" stringGrid[][];&#xA;&#xA;&#x9;public StringGridImpl(int rows, int cols) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.cols = cols;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="146" end="-371"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="180" charEnd="214" severity="2" problemCategory="50" problemType="33554513"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="153" charEnd="163" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144589670" sizeMeasure="37" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.stringGrid[][] = new String[rows][cols];" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="251" end="-371"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="277" charEnd="281" severity="2" problemCategory="20" problemType="1610612972"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="278" charEnd="279" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144609908" sizeMeasure="37" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="266" end="-397"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="153" charEnd="163" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144673342" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.stringGrid[row][column]" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="488" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144687548" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.stringGrid[row][column] = element;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="605" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150088139" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;&#xA;public class StringGridImpl implements StringGrid {&#xA;&#x9;&#xA;&#x9;private final int rows;&#xA;&#x9;private final int cols;&#xA;&#x9;private final String stringGrid[][];&#xA;&#xA;&#x9;public StringGridImpl(int rows, int cols) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.cols = cols;&#xA;&#x9;&#x9;this.stringGrid = new String[rows][cols];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;return this.rows;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return this.cols;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;return this.stringGrid[row][column];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;this.stringGrid[row][column] = element;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public Iterator&lt;String> iterator() {&#xA;&#x9;&#x9;return new StringGridIterator(this, false)" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="21" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150177092" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;/**&#xA;&#x9; * Test code for iterator&#xA;&#x9; * @param args&#xA;&#x9; */&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="775" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150194221" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StringGridImpl stringGrid = new StringGridImpl(3, 2);" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="874" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="935" charEnd="945" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150257275" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (int rows = 0; rows &lt; 3; rows++) {&#xA;&#x9;&#x9;&#x9;for (int cols = 0; cols &lt; 2; cols++) {&#xA;&#x9;&#x9;&#x9;&#x9;stringGrid.setElement(rows, cols, &quot;&quot;+rows+&quot;,&quot;+cols);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="930" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150274558" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;for (String s : stringGrid) {&#xA;&#x9;&#x9;&#x9;System.out.println(s);" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1078" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150318099" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(stringGrid.getElement(0, 0));" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1082" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150324178" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;First&quot;+" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1101" end="-102"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150325506" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=":" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="1107" end="-104"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488150277027" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488150326756" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488150370323" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488150485620" mode="run"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144801477" sizeMeasure="9">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class StringGridIterator {&#xA;&#xA;&#x9;public StringGridIterator() {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144817946" sizeMeasure="11" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;&#xA;public class StringGridIterator implements Iterator&lt;StringGridImpl>" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="21" end="-84"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="66" charEnd="84" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="66" charEnd="84" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144850728" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public StringGridImpl next() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="147" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144854467" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="184" end="-203"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144903043" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void remove() {&#xA;&#x9;&#x9;throw new UnsupportedOperationException()" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="383" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144963409" sizeMeasure="32" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private final StringGrid sg;&#xA;&#x9;private final boolean rowMajor;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="119" end="-288"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="153" charEnd="155" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488144986771" sizeMeasure="32" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="577" end="-578"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="153" charEnd="155" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145034209" sizeMeasure="36" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private final int rows;&#xA;&#x9;private final int cols;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;this.rows = this.sg.getRowCount();&#xA;&#x9;&#x9;this.cols = this.sg.getColumnCount()" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="184" end="-289"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="211" charEnd="215" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="237" charEnd="241" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145063335" sizeMeasure="38" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private int rowIndex;&#xA;&#x9;private int colIndex" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="234" end="-473"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="211" charEnd="215" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="237" charEnd="241" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="257" charEnd="265" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="281" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145080931" sizeMeasure="40" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.rowIndex = 0;&#xA;&#x9;&#x9;this.colIndex = 0" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="465" end="-289"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="211" charEnd="215" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="237" charEnd="241" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="257" charEnd="265" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="281" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145204055" sizeMeasure="42" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.rowMajor) {&#xA;&#x9;&#x9;&#x9;return this.sg.getElement(rowIndex, colIndex);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="551" end="-208"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="607" charEnd="645" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="211" charEnd="215" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="237" charEnd="241" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145264321" sizeMeasure="43" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="247" end="-601"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="211" charEnd="215" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="237" charEnd="241" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="257" charEnd="262" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="628" charEnd="666" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145365653" sizeMeasure="44" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index &lt; this.sg.)" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="580" end="-285"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="658" charEnd="696" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="620" charEnd="621" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145457805" sizeMeasure="45" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nt totalCells = (this.rows * this.cols);" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="572" end="-314"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="665" charEnd="666" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="703" charEnd="741" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145477085" sizeMeasure="41" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return (this.index &lt; totalCells)" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="615" end="-193"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="278" charEnd="286" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="302" charEnd="310" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145493451" sizeMeasure="41" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="N = (this.rows * this.cols);&#xA;&#x9;&#x9;return (this.index &lt; totalCellsN" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="585" end="-194"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="278" charEnd="286" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="302" charEnd="310" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145544175" sizeMeasure="43" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="final int totalCells;&#xA;&#x9;private int index;&#xA;&#x9;private int rowIndex;&#xA;&#x9;private int colIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;this.rows = this.sg.getRowCount();&#xA;&#x9;&#x9;this.cols = this.sg.getColumnCount();&#xA;&#x9;&#x9;this.totalCells = this.rows * this.cols" edit="/1/@proposals.1/@proposals.0/@attempts.15/@edit" start="243" end="-360"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="263" charEnd="273" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="310" charEnd="318" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="334" charEnd="342" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145554287" sizeMeasure="42" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return (this.index &lt; this.totalCells" edit="/1/@proposals.1/@proposals.0/@attempts.16/@edit" start="645" end="-194"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="181" charEnd="189" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="310" charEnd="318" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="334" charEnd="342" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145573992" sizeMeasure="44" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.rowMajor) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.17/@edit" start="733" end="-108"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="310" charEnd="318" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="334" charEnd="342" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488145632907" sizeMeasure="45" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String string;&#xA;&#x9;&#x9;if (this.rowMajor) {&#xA;&#x9;&#x9;&#x9;string = this.sg.getElement(index % rows, index % cols);" edit="/1/@proposals.1/@proposals.0/@attempts.18/@edit" start="733" end="-112"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="310" charEnd="318" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="334" charEnd="342" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="772" charEnd="778" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488148159207" sizeMeasure="46" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.i" edit="/1/@proposals.1/@proposals.0/@attempts.19/@edit" start="601" end="-352"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="334" charEnd="342" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="791" charEnd="797" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="310" charEnd="318" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488148255516" sizeMeasure="48" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rowIndex, colIndex);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;index++" edit="/1/@proposals.1/@proposals.0/@attempts.20/@edit" start="820" end="-113"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="791" charEnd="797" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488148522847" sizeMeasure="49" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="++, colIndex);&#xA;&#x9;&#x9;&#x9;colIndex = (rowIndex == rows) ? colIndex + 1 : colIndex;&#xA;&#x9;&#x9;&#x9;rowIndex = (rowIndex == rows) ? rowIndex - rows : rowIndex;" edit="/1/@proposals.1/@proposals.0/@attempts.21/@edit" start="828" end="-124"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="791" charEnd="797" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488148563314" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="string" edit="/1/@proposals.1/@proposals.0/@attempts.22/@edit" start="991" end="-94"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="41" charStart="1031" charEnd="1037" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488148761442" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean advanceCol = (rowIndex == rows);&#xA;&#x9;&#x9;&#x9;colIndex = advanceCol ? colIndex + 1 : colIndex;&#xA;&#x9;&#x9;&#x9;rowIndex = advanceCol" edit="/1/@proposals.1/@proposals.0/@attempts.23/@edit" start="846" end="-156"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="1060" charEnd="1066" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488148999223" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="> {&#xA;&#x9;&#xA;&#x9;private final StringGrid sg;&#xA;&#x9;private final boolean rowMajor;&#xA;&#x9;private final int rows;&#xA;&#x9;private final int cols;&#xA;&#x9;private final int totalCells;&#xA;&#x9;private int index;&#xA;&#x9;private int rowIndex;&#xA;&#x9;private int colIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;this.rows = this.sg.getRowCount();&#xA;&#x9;&#x9;this.cols = this.sg.getColumnCount();&#xA;&#x9;&#x9;this.totalCells = this.rows * this.cols;&#xA;&#x9;&#x9;this.rowIndex = 0;&#xA;&#x9;&#x9;this.colIndex = 0;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return (this.index &lt; this.totalCells);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String" edit="/1/@proposals.1/@proposals.0/@attempts.24/@edit" start="107" end="-380"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="1044" charEnd="1050" severity="2" problemCategory="60" problemType="536870963"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149019718" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = null" edit="/1/@proposals.1/@proposals.0/@attempts.25/@edit" start="748" end="-355"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149038415" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(rows - 1)" edit="/1/@proposals.1/@proposals.0/@attempts.26/@edit" start="871" end="-235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149237977" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rows" edit="/1/@proposals.1/@proposals.0/@attempts.27/@edit" start="871" end="-234"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="907" charEnd="911" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149246031" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=")" edit="/1/@proposals.1/@proposals.0/@attempts.28/@edit" start="875" end="-234"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149336743" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.29/@edit" start="1109" end="-1110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149491425" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="primaryIncrement;&#xA;&#x9;private final int cols;&#xA;&#x9;private final int totalCells;&#xA;&#x9;private int index;&#xA;&#x9;private int rowIndex;&#xA;&#x9;private int colIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;this.primaryIncrement = this.sg.getRowCount();&#xA;&#x9;&#x9;this.cols = this.sg.getColumnCount();&#xA;&#x9;&#x9;this.totalCells = this.primaryIncrement * this.cols;&#xA;&#x9;&#x9;this.rowIndex = 0;&#xA;&#x9;&#x9;this.colIndex = 0;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return (this.index &lt; this.totalCells);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;String string = null;&#xA;&#x9;&#x9;if (this.rowMajor) {&#xA;&#x9;&#x9;&#x9;string = this.sg.getElement(rowIndex++, colIndex);&#xA;&#x9;&#x9;&#x9;boolean advanceCol = (rowIndex == primaryIncrement);&#xA;&#x9;&#x9;&#x9;colIndex = advanceCol ? colIndex + 1 : colIndex;&#xA;&#x9;&#x9;&#x9;rowIndex = advanceCol ? rowIndex - primaryIncrement" edit="/1/@proposals.1/@proposals.0/@attempts.30/@edit" start="195" end="-138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149499502" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="secondaryIncrement;&#xA;&#x9;private final int totalCells;&#xA;&#x9;private int index;&#xA;&#x9;private int rowIndex;&#xA;&#x9;private int colIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;this.primaryIncrement = this.sg.getRowCount();&#xA;&#x9;&#x9;this.secondaryIncrement = this.sg.getColumnCount();&#xA;&#x9;&#x9;this.totalCells = this.primaryIncrement * this.secondaryIncrement" edit="/1/@proposals.1/@proposals.0/@attempts.31/@edit" start="232" end="-586"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149507558" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="primIndex;&#xA;&#x9;private int colIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;this.primaryIncrement = this.sg.getRowCount();&#xA;&#x9;&#x9;this.secondaryIncrement = this.sg.getColumnCount();&#xA;&#x9;&#x9;this.totalCells = this.primaryIncrement * this.secondaryIncrement;&#xA;&#x9;&#x9;this.primIndex = 0;&#xA;&#x9;&#x9;this.colIndex = 0;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return (this.index &lt; this.totalCells);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;String string = null;&#xA;&#x9;&#x9;if (this.rowMajor) {&#xA;&#x9;&#x9;&#x9;string = this.sg.getElement(primIndex++, colIndex);&#xA;&#x9;&#x9;&#x9;boolean advanceCol = (primIndex == primaryIncrement);&#xA;&#x9;&#x9;&#x9;colIndex = advanceCol ? colIndex + 1 : colIndex;&#xA;&#x9;&#x9;&#x9;primIndex = advanceCol ? primIndex - primaryIncrement : prim" edit="/1/@proposals.1/@proposals.0/@attempts.32/@edit" start="316" end="-132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149511389" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="secIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;this.primaryIncrement = this.sg.getRowCount();&#xA;&#x9;&#x9;this.secondaryIncrement = this.sg.getColumnCount();&#xA;&#x9;&#x9;this.totalCells = this.primaryIncrement * this.secondaryIncrement;&#xA;&#x9;&#x9;this.primIndex = 0;&#xA;&#x9;&#x9;this.secIndex = 0;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return (this.index &lt; this.totalCells);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;String string = null;&#xA;&#x9;&#x9;if (this.rowMajor) {&#xA;&#x9;&#x9;&#x9;string = this.sg.getElement(primIndex++, secIndex);&#xA;&#x9;&#x9;&#x9;boolean advanceCol = (primIndex == primaryIncrement);&#xA;&#x9;&#x9;&#x9;secIndex = advanceCol ? secIndex + 1 : sec" edit="/1/@proposals.1/@proposals.0/@attempts.33/@edit" start="340" end="-202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149580739" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int primaryIncrement;&#xA;&#x9;private final int secondaryIncrement;&#xA;&#x9;private final int totalCells;&#xA;&#x9;private int index;&#xA;&#x9;private int primIndex;&#xA;&#x9;private int secIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;if (rowMajor) {&#xA;&#x9;&#x9;&#x9;this.primaryIncrement = this.sg.getRowCount();&#xA;&#x9;&#x9;&#x9;this.secondaryIncrement = this.sg.getColumnCount();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.primaryIncrement = this.sg.getColumnCount();&#xA;&#x9;&#x9;&#x9;this.secondaryIncrement = this.sg.getRowCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.totalCells = this.primaryIncrement * this.secondaryIncrement;&#xA;&#x9;&#x9;this.primIndex = 0;&#xA;&#x9;&#x9;this.secIndex = 0;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return (this.index &lt; this.totalCells);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;String string = this.sg.getElement(primIndex++, secIndex);&#xA;&#x9;&#x9;boolean advanceCol = (primIndex == primaryIncrement);&#xA;&#x9;&#x9;secIndex = advanceCol ? secIndex + 1 : secIndex;&#xA;&#x9;&#x9;primIndex = advanceCol ? primIndex - primaryIncrement : primIndex;&#xA;&#x9;&#x9;index++;" edit="/1/@proposals.1/@proposals.0/@attempts.34/@edit" start="158" end="-110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149663741" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Count;&#xA;&#x9;private final int secCount;&#xA;&#x9;private final int totalCells;&#xA;&#x9;private int index;&#xA;&#x9;private int primIndex;&#xA;&#x9;private int secIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;if (rowMajor) {&#xA;&#x9;&#x9;&#x9;this.primCount = this.sg.getRowCount();&#xA;&#x9;&#x9;&#x9;this.secCount = this.sg.getColumnCount();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.primCount = this.sg.getColumnCount();&#xA;&#x9;&#x9;&#x9;this.secCount = this.sg.getRowCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.totalCells = this.primCount * this.secCount;&#xA;&#x9;&#x9;this.primIndex = 0;&#xA;&#x9;&#x9;this.secIndex = 0;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return (this.index &lt; this.totalCells);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;String string = this.sg.getElement(primIndex++, secIndex);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Is the index out of bounds?&#xA;&#x9;&#x9;boolean advanceCol = (primIndex == primCount);&#xA;&#x9;&#x9;secIndex = advanceCol ? secIndex + 1 : secIndex;&#xA;&#x9;&#x9;primIndex = advanceCol ? primIndex - primCou" edit="/1/@proposals.1/@proposals.0/@attempts.35/@edit" start="166" end="-136"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149716137" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;row&quot; out of bounds?&#xA;&#x9;&#x9;boolean advanceCol = (primIndex == primCount);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// If so, rebound the indices back" edit="/1/@proposals.1/@proposals.0/@attempts.36/@edit" start="900" end="-234"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149721434" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="into the grid" edit="/1/@proposals.1/@proposals.0/@attempts.37/@edit" start="1005" end="-234"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149746093" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Fetch string at current indices position, and advance primary index" edit="/1/@proposals.1/@proposals.0/@attempts.38/@edit" start="826" end="-429"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149755589" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="primary index" edit="/1/@proposals.1/@proposals.0/@attempts.39/@edit" start="973" end="-347"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149774397" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;// Seperate index used for hasNext()" edit="/1/@proposals.1/@proposals.0/@attempts.40/@edit" start="1215" end="-121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149785727" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a" edit="/1/@proposals.1/@proposals.0/@attempts.41/@edit" start="1224" end="-150"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488149918545" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean rowMajor;&#xA;&#x9;private final int primCount;&#xA;&#x9;private final int secCount;&#xA;&#x9;private final int totalCells;&#xA;&#x9;private int index;&#xA;&#x9;private int primIndex;&#xA;&#x9;private int secIndex;&#xA;&#xA;&#x9;public StringGridIterator(StringGrid sg, boolean rowMajor) {&#xA;&#x9;&#x9;this.sg = sg;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;if (rowMajor) {&#xA;&#x9;&#x9;&#x9;this.primCount = this.sg.getRowCount();&#xA;&#x9;&#x9;&#x9;this.secCount = this.sg.getColumnCount();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.primCount = this.sg.getColumnCount();&#xA;&#x9;&#x9;&#x9;this.secCount = this.sg.getRowCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.totalCells = this.primCount * this.secCount;&#xA;&#x9;&#x9;this.primIndex = 0;&#xA;&#x9;&#x9;this.secIndex = 0;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return (this.index &lt; this.totalCells);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;// Fetch string at current indices position, and advance primary index&#xA;&#x9;&#x9;String string = null;&#xA;&#x9;&#x9;if (this.rowMajor) {&#xA;&#x9;&#x9;&#x9;string = this.sg.getElement(primIndex++, secIndex);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.sg.getElement(secIndex, primIndex++);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.42/@edit" start="158" end="-418"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150481708" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="string = " edit="/1/@proposals.1/@proposals.0/@attempts.43/@edit" start="1074" end="-464"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488150591261" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ColumnCount();&#xA;&#x9;&#x9;&#x9;this.secCount = this.sg.getRowCount();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.primCount = this.sg.getRowCount();&#xA;&#x9;&#x9;&#x9;this.secCount = this.sg.getColumnCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.totalCells = this.primCount * this.secCount;&#xA;&#x9;&#x9;this.primIndex = 0;&#xA;&#x9;&#x9;this.secIndex = 0;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return (this.index &lt; this.totalCells);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;// Fetch string at current indices position, and advance primary index&#xA;&#x9;&#x9;String string = null;&#xA;&#x9;&#x9;if (this.rowMajor) {&#xA;&#x9;&#x9;&#x9;string = this.sg.getElement(secIndex, primIndex++);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;string = this.sg.getElement(primIndex++, secIndex" edit="/1/@proposals.1/@proposals.0/@attempts.44/@edit" start="489" end="-424"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488144708213" completion="0.0" errorCount="1">
          <errorTests>initializationError</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488150115082" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488150505527" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488150597030" completion="1.0" successCount="3">
          <successTests>testGrid</successTests>
          <successTests>testGridIteratorColumnMajor</successTests>
          <successTests>testGridIteratorRowMajor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a" performedCount="4">
        <attempts timestamp="1488150371115"/>
        <attempts timestamp="1488150422364"/>
        <attempts timestamp="1488150428568"/>
        <attempts timestamp="1488150481942"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a" performedCount="1">
        <attempts timestamp="1488150457221"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a" performedCount="1">
        <attempts timestamp="1488150448061"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a" performedCount="3">
        <attempts timestamp="1488150374071"/>
        <attempts timestamp="1488150434725"/>
        <attempts timestamp="1488150466159"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
