<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringMergingIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Modify the code for the StringMergingIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIteratorProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIteratorProgram"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="debugging.StringMergingIterator*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890412127" sizeMeasure="52">
          <edit xsi:type="exercise:StringEdit" storedString="package debugging;&#xA;&#xA;import java.util.Iterator;&#xA;import java.util.NoSuchElementException;&#xA;&#xA;public class StringMergingIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;private Iterator&lt;String> first;&#xA;&#x9;private Iterator&lt;String> second;&#xA;&#x9;private boolean turnSwitch;&#xA;&#xA;&#x9;public StringMergingIterator(Iterator&lt;String> first, Iterator&lt;String> second){&#xA;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;this.turnSwitch = true;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! hasNext()){ throw new NoSuchElementException(); }&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! first.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if(turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(!turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return result;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891395490" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="hasNext()){ throw new NoSuchElementException(); }&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="541" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892614377" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="655" end="-212"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893387833" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if(!turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return result;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="824" end="-6"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="28">
        <attempts timestamp="1488890596305"/>
        <attempts timestamp="1488890644760"/>
        <attempts timestamp="1488890652530"/>
        <attempts timestamp="1488890655585"/>
        <attempts timestamp="1488890657813"/>
        <attempts timestamp="1488890666216"/>
        <attempts timestamp="1488890670045"/>
        <attempts timestamp="1488890672394"/>
        <attempts timestamp="1488890673812"/>
        <attempts timestamp="1488890679454"/>
        <attempts timestamp="1488890683910"/>
        <attempts timestamp="1488890698695"/>
        <attempts timestamp="1488890789708"/>
        <attempts timestamp="1488890909280"/>
        <attempts timestamp="1488891142525"/>
        <attempts timestamp="1488891201207"/>
        <attempts timestamp="1488891399831"/>
        <attempts timestamp="1488892751836"/>
        <attempts timestamp="1488892808682"/>
        <attempts timestamp="1488892839444"/>
        <attempts timestamp="1488892879818"/>
        <attempts timestamp="1488892883908"/>
        <attempts timestamp="1488892894402"/>
        <attempts timestamp="1488892897634"/>
        <attempts timestamp="1488892901856"/>
        <attempts timestamp="1488892909543"/>
        <attempts timestamp="1488892926889"/>
        <attempts timestamp="1488893393495"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="308">
        <attempts timestamp="1488890604929"/>
        <attempts timestamp="1488890606427"/>
        <attempts timestamp="1488890637119"/>
        <attempts timestamp="1488890638133"/>
        <attempts timestamp="1488890639441"/>
        <attempts timestamp="1488890640607"/>
        <attempts timestamp="1488890643907"/>
        <attempts timestamp="1488890644757"/>
        <attempts timestamp="1488890647548"/>
        <attempts timestamp="1488890648927"/>
        <attempts timestamp="1488890650543"/>
        <attempts timestamp="1488890651555"/>
        <attempts timestamp="1488890652527"/>
        <attempts timestamp="1488890653502"/>
        <attempts timestamp="1488890654365"/>
        <attempts timestamp="1488890655081"/>
        <attempts timestamp="1488890655583"/>
        <attempts timestamp="1488890656253"/>
        <attempts timestamp="1488890656785"/>
        <attempts timestamp="1488890657276"/>
        <attempts timestamp="1488890657811"/>
        <attempts timestamp="1488890658363"/>
        <attempts timestamp="1488890658875"/>
        <attempts timestamp="1488890659356"/>
        <attempts timestamp="1488890659790"/>
        <attempts timestamp="1488890660172"/>
        <attempts timestamp="1488890660505"/>
        <attempts timestamp="1488890660852"/>
        <attempts timestamp="1488890661413"/>
        <attempts timestamp="1488890662058"/>
        <attempts timestamp="1488890662339"/>
        <attempts timestamp="1488890662524"/>
        <attempts timestamp="1488890663246"/>
        <attempts timestamp="1488890663413"/>
        <attempts timestamp="1488890663603"/>
        <attempts timestamp="1488890663801"/>
        <attempts timestamp="1488890664102"/>
        <attempts timestamp="1488890664275"/>
        <attempts timestamp="1488890664378"/>
        <attempts timestamp="1488890664533"/>
        <attempts timestamp="1488890664749"/>
        <attempts timestamp="1488890664910"/>
        <attempts timestamp="1488890665249"/>
        <attempts timestamp="1488890665532"/>
        <attempts timestamp="1488890665748"/>
        <attempts timestamp="1488890665837"/>
        <attempts timestamp="1488890666025"/>
        <attempts timestamp="1488890666214"/>
        <attempts timestamp="1488890666529"/>
        <attempts timestamp="1488890667132"/>
        <attempts timestamp="1488890667523"/>
        <attempts timestamp="1488890667785"/>
        <attempts timestamp="1488890668504"/>
        <attempts timestamp="1488890669233"/>
        <attempts timestamp="1488890669550"/>
        <attempts timestamp="1488890670043"/>
        <attempts timestamp="1488890670368"/>
        <attempts timestamp="1488890670916"/>
        <attempts timestamp="1488890671296"/>
        <attempts timestamp="1488890671850"/>
        <attempts timestamp="1488890672392"/>
        <attempts timestamp="1488890672667"/>
        <attempts timestamp="1488890673006"/>
        <attempts timestamp="1488890673452"/>
        <attempts timestamp="1488890673808"/>
        <attempts timestamp="1488890674321"/>
        <attempts timestamp="1488890674602"/>
        <attempts timestamp="1488890675005"/>
        <attempts timestamp="1488890675367"/>
        <attempts timestamp="1488890675958"/>
        <attempts timestamp="1488890676181"/>
        <attempts timestamp="1488890676318"/>
        <attempts timestamp="1488890676523"/>
        <attempts timestamp="1488890676736"/>
        <attempts timestamp="1488890676964"/>
        <attempts timestamp="1488890677254"/>
        <attempts timestamp="1488890677399"/>
        <attempts timestamp="1488890677557"/>
        <attempts timestamp="1488890677756"/>
        <attempts timestamp="1488890677946"/>
        <attempts timestamp="1488890678178"/>
        <attempts timestamp="1488890678562"/>
        <attempts timestamp="1488890678757"/>
        <attempts timestamp="1488890678964"/>
        <attempts timestamp="1488890679204"/>
        <attempts timestamp="1488890679451"/>
        <attempts timestamp="1488890679925"/>
        <attempts timestamp="1488890680360"/>
        <attempts timestamp="1488890681045"/>
        <attempts timestamp="1488890681420"/>
        <attempts timestamp="1488890681927"/>
        <attempts timestamp="1488890682741"/>
        <attempts timestamp="1488890683386"/>
        <attempts timestamp="1488890683908"/>
        <attempts timestamp="1488890684481"/>
        <attempts timestamp="1488890736063"/>
        <attempts timestamp="1488890738840"/>
        <attempts timestamp="1488890739395"/>
        <attempts timestamp="1488890739937"/>
        <attempts timestamp="1488890745188"/>
        <attempts timestamp="1488890745790"/>
        <attempts timestamp="1488890895934"/>
        <attempts timestamp="1488890896986"/>
        <attempts timestamp="1488890897672"/>
        <attempts timestamp="1488890899546"/>
        <attempts timestamp="1488890900461"/>
        <attempts timestamp="1488890901026"/>
        <attempts timestamp="1488890901466"/>
        <attempts timestamp="1488890901962"/>
        <attempts timestamp="1488890902398"/>
        <attempts timestamp="1488890902822"/>
        <attempts timestamp="1488890903292"/>
        <attempts timestamp="1488890904303"/>
        <attempts timestamp="1488890904987"/>
        <attempts timestamp="1488890905426"/>
        <attempts timestamp="1488890905686"/>
        <attempts timestamp="1488890905876"/>
        <attempts timestamp="1488890906112"/>
        <attempts timestamp="1488890906258"/>
        <attempts timestamp="1488890906451"/>
        <attempts timestamp="1488890906668"/>
        <attempts timestamp="1488890906939"/>
        <attempts timestamp="1488890907085"/>
        <attempts timestamp="1488890907208"/>
        <attempts timestamp="1488890907402"/>
        <attempts timestamp="1488890907588"/>
        <attempts timestamp="1488890907787"/>
        <attempts timestamp="1488890908155"/>
        <attempts timestamp="1488890908418"/>
        <attempts timestamp="1488890908728"/>
        <attempts timestamp="1488890908880"/>
        <attempts timestamp="1488890909077"/>
        <attempts timestamp="1488890909278"/>
        <attempts timestamp="1488890909738"/>
        <attempts timestamp="1488890910184"/>
        <attempts timestamp="1488890910954"/>
        <attempts timestamp="1488890911848"/>
        <attempts timestamp="1488890912241"/>
        <attempts timestamp="1488891178999"/>
        <attempts timestamp="1488891244530"/>
        <attempts timestamp="1488891246078"/>
        <attempts timestamp="1488891253484"/>
        <attempts timestamp="1488891255984"/>
        <attempts timestamp="1488891256914"/>
        <attempts timestamp="1488891291512"/>
        <attempts timestamp="1488891292791"/>
        <attempts timestamp="1488891293675"/>
        <attempts timestamp="1488891320853"/>
        <attempts timestamp="1488891322552"/>
        <attempts timestamp="1488891323273"/>
        <attempts timestamp="1488891324141"/>
        <attempts timestamp="1488891324598"/>
        <attempts timestamp="1488891325883"/>
        <attempts timestamp="1488891326567"/>
        <attempts timestamp="1488891327435"/>
        <attempts timestamp="1488891327991"/>
        <attempts timestamp="1488891328755"/>
        <attempts timestamp="1488891330013"/>
        <attempts timestamp="1488891336109"/>
        <attempts timestamp="1488891337288"/>
        <attempts timestamp="1488891345675"/>
        <attempts timestamp="1488891346846"/>
        <attempts timestamp="1488891347740"/>
        <attempts timestamp="1488891348210"/>
        <attempts timestamp="1488891348472"/>
        <attempts timestamp="1488891348771"/>
        <attempts timestamp="1488891349397"/>
        <attempts timestamp="1488891349674"/>
        <attempts timestamp="1488891354770"/>
        <attempts timestamp="1488891355472"/>
        <attempts timestamp="1488891356038"/>
        <attempts timestamp="1488891356602"/>
        <attempts timestamp="1488891357112"/>
        <attempts timestamp="1488891357628"/>
        <attempts timestamp="1488891358192"/>
        <attempts timestamp="1488891358664"/>
        <attempts timestamp="1488891359116"/>
        <attempts timestamp="1488891359610"/>
        <attempts timestamp="1488891360034"/>
        <attempts timestamp="1488891360398"/>
        <attempts timestamp="1488892804183"/>
        <attempts timestamp="1488892806640"/>
        <attempts timestamp="1488892807644"/>
        <attempts timestamp="1488892808679"/>
        <attempts timestamp="1488892809797"/>
        <attempts timestamp="1488892810790"/>
        <attempts timestamp="1488892811719"/>
        <attempts timestamp="1488892812531"/>
        <attempts timestamp="1488892814678"/>
        <attempts timestamp="1488892817349"/>
        <attempts timestamp="1488892818561"/>
        <attempts timestamp="1488892846855"/>
        <attempts timestamp="1488892849051"/>
        <attempts timestamp="1488892851158"/>
        <attempts timestamp="1488892869449"/>
        <attempts timestamp="1488892870655"/>
        <attempts timestamp="1488892872995"/>
        <attempts timestamp="1488892873829"/>
        <attempts timestamp="1488892874361"/>
        <attempts timestamp="1488892874826"/>
        <attempts timestamp="1488892875351"/>
        <attempts timestamp="1488892875811"/>
        <attempts timestamp="1488892876349"/>
        <attempts timestamp="1488892876790"/>
        <attempts timestamp="1488892877331"/>
        <attempts timestamp="1488892877853"/>
        <attempts timestamp="1488892878367"/>
        <attempts timestamp="1488892878832"/>
        <attempts timestamp="1488892879066"/>
        <attempts timestamp="1488892879443"/>
        <attempts timestamp="1488892879641"/>
        <attempts timestamp="1488892879816"/>
        <attempts timestamp="1488892880171"/>
        <attempts timestamp="1488892881142"/>
        <attempts timestamp="1488892881934"/>
        <attempts timestamp="1488892882616"/>
        <attempts timestamp="1488892883906"/>
        <attempts timestamp="1488892884780"/>
        <attempts timestamp="1488892886280"/>
        <attempts timestamp="1488892887052"/>
        <attempts timestamp="1488892887755"/>
        <attempts timestamp="1488892888638"/>
        <attempts timestamp="1488892889267"/>
        <attempts timestamp="1488892889865"/>
        <attempts timestamp="1488892890782"/>
        <attempts timestamp="1488892891577"/>
        <attempts timestamp="1488892892227"/>
        <attempts timestamp="1488892892888"/>
        <attempts timestamp="1488892894400"/>
        <attempts timestamp="1488892895144"/>
        <attempts timestamp="1488892895693"/>
        <attempts timestamp="1488892896428"/>
        <attempts timestamp="1488892897033"/>
        <attempts timestamp="1488892897632"/>
        <attempts timestamp="1488892898412"/>
        <attempts timestamp="1488892899093"/>
        <attempts timestamp="1488892899789"/>
        <attempts timestamp="1488892901017"/>
        <attempts timestamp="1488892901854"/>
        <attempts timestamp="1488892902568"/>
        <attempts timestamp="1488892903294"/>
        <attempts timestamp="1488892904030"/>
        <attempts timestamp="1488892904604"/>
        <attempts timestamp="1488892905217"/>
        <attempts timestamp="1488892905788"/>
        <attempts timestamp="1488892906351"/>
        <attempts timestamp="1488892906991"/>
        <attempts timestamp="1488892907680"/>
        <attempts timestamp="1488892908245"/>
        <attempts timestamp="1488892908799"/>
        <attempts timestamp="1488892909540"/>
        <attempts timestamp="1488892910266"/>
        <attempts timestamp="1488892910778"/>
        <attempts timestamp="1488892911404"/>
        <attempts timestamp="1488892912097"/>
        <attempts timestamp="1488892912876"/>
        <attempts timestamp="1488892913529"/>
        <attempts timestamp="1488892914157"/>
        <attempts timestamp="1488892914954"/>
        <attempts timestamp="1488892915667"/>
        <attempts timestamp="1488892916280"/>
        <attempts timestamp="1488892916924"/>
        <attempts timestamp="1488892917553"/>
        <attempts timestamp="1488892917999"/>
        <attempts timestamp="1488892918477"/>
        <attempts timestamp="1488892918957"/>
        <attempts timestamp="1488892926870"/>
        <attempts timestamp="1488892928137"/>
        <attempts timestamp="1488892928801"/>
        <attempts timestamp="1488892929545"/>
        <attempts timestamp="1488892930324"/>
        <attempts timestamp="1488892931002"/>
        <attempts timestamp="1488892931351"/>
        <attempts timestamp="1488892932102"/>
        <attempts timestamp="1488892932834"/>
        <attempts timestamp="1488892933231"/>
        <attempts timestamp="1488892934126"/>
        <attempts timestamp="1488892934675"/>
        <attempts timestamp="1488892934976"/>
        <attempts timestamp="1488892935584"/>
        <attempts timestamp="1488892936398"/>
        <attempts timestamp="1488892936662"/>
        <attempts timestamp="1488892936956"/>
        <attempts timestamp="1488892937320"/>
        <attempts timestamp="1488892937554"/>
        <attempts timestamp="1488892938120"/>
        <attempts timestamp="1488892938670"/>
        <attempts timestamp="1488892939220"/>
        <attempts timestamp="1488892939804"/>
        <attempts timestamp="1488892940222"/>
        <attempts timestamp="1488892940740"/>
        <attempts timestamp="1488892941256"/>
        <attempts timestamp="1488892941758"/>
        <attempts timestamp="1488892942274"/>
        <attempts timestamp="1488892942794"/>
        <attempts timestamp="1488892943344"/>
        <attempts timestamp="1488892943870"/>
        <attempts timestamp="1488892944404"/>
        <attempts timestamp="1488892944920"/>
        <attempts timestamp="1488892945444"/>
        <attempts timestamp="1488892945936"/>
        <attempts timestamp="1488892946446"/>
        <attempts timestamp="1488892946908"/>
        <attempts timestamp="1488892947338"/>
        <attempts timestamp="1488892947806"/>
        <attempts timestamp="1488892948261"/>
        <attempts timestamp="1488892948682"/>
        <attempts timestamp="1488892949088"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1488891340661"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="8">
        <attempts timestamp="1488891172950"/>
        <attempts timestamp="1488891176401"/>
        <attempts timestamp="1488891204113"/>
        <attempts timestamp="1488891275276"/>
        <attempts timestamp="1488892626603"/>
        <attempts timestamp="1488892717158"/>
        <attempts timestamp="1488892755432"/>
        <attempts timestamp="1488892852524"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
