<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399234228" sizeMeasure="41" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable&lt;T> {&#xA;&#xA;&#x9;private char suit; // Valør&#xA;&#x9;private int face; // Verdi&#xA;&#xA;&#x9;public static char[] suits = { 'S', 'H', 'D', 'C' };&#xA;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (checkSuit(suit) &amp;&amp; face > 0 &amp;&amp; face &lt; 14) {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldige kortverdier.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + suit + face;&#xA;&#x9;}&#xA;&#xA;&#x9;// Hjelpemetode&#xA;&#xA;&#x9;private boolean checkSuit(char suit) {&#xA;&#x9;&#x9;for (char suitElement : suits) {&#xA;&#x9;&#x9;&#x9;if (suitElement == suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399250942" sizeMeasure="41" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="61" end="-646"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399274668" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="708" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399446334" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int suitValue = suits.indexOf(suit);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="754" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399466166" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="781" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399535805" sizeMeasure="48" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Character> suits = new ArrayList&lt;>({ 'S', 'H', 'D', 'C' });&#xA;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (checkSuit(suit) &amp;&amp; face > 0 &amp;&amp; face &lt; 14) {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldige kortverdier.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + suit + face;&#xA;&#x9;}&#xA;&#xA;&#x9;// Hjelpemetode&#xA;&#xA;&#x9;private boolean checkSuit(char suit) {&#xA;&#x9;&#x9;for (char suitElement : suits) {&#xA;&#x9;&#x9;&#x9;if (suitElement == suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int suitValue = suits." edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="143" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399546644" sizeMeasure="48" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="'S', 'H', 'D', 'C'" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="188" end="-620"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399550874" sizeMeasure="50" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="21" end="-808"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399658887" sizeMeasure="51" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Arrays;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit; // Valør&#xA;&#x9;private int face; // Verdi&#xA;&#xA;&#x9;public static List&lt;Character> suits = Arrays.asList" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="49" end="-639"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399722916" sizeMeasure="52" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="74" end="-801"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399767122" sizeMeasure="52" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3 - suits.indexOf(suit)" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="867" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399794876" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="43" end="-865"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399912804" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit; // Valør&#xA;&#x9;private int face; // Verdi&#xA;&#xA;&#x9;public static List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C');&#xA;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (checkSuit(suit) &amp;&amp; face > 0 &amp;&amp; face &lt; 14) {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldige kortverdier.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + suit + face;&#xA;&#x9;}&#xA;&#xA;&#x9;// Hjelpemetode&#xA;&#xA;&#x9;private boolean checkSuit(char suit) {&#xA;&#x9;&#x9;for (char suitElement : suits) {&#xA;&#x9;&#x9;&#x9;if (suitElement == suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int mySuitValue = 3 - suits.indexOf(suit);&#xA;&#x9;&#x9;int otherSuitValue = 3 - suits.indexOf(o.getSuit())" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="43" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399914365" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="919" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399964770" sizeMeasure="52" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;return (face + mySuitValue) - ()" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="922" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399966980" sizeMeasure="52" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="958" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399981498" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o.getFace() + otherSuitValue" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="957" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400059695" sizeMeasure="56" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Collection&lt;Cards> hey = new Collection(" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="991" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400075487" sizeMeasure="57" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="63" end="-1041"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400077926" sizeMeasure="57" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1081" end="-32"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400094380" sizeMeasure="58" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.Arrays;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit; // Valør&#xA;&#x9;private int face; // Verdi&#xA;&#xA;&#x9;public static List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C');&#xA;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (checkSuit(suit) &amp;&amp; face > 0 &amp;&amp; face &lt; 14) {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldige kortverdier.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + suit + face;&#xA;&#x9;}&#xA;&#xA;&#x9;// Hjelpemetode&#xA;&#xA;&#x9;private boolean checkSuit(char suit) {&#xA;&#x9;&#x9;for (char suitElement : suits) {&#xA;&#x9;&#x9;&#x9;if (suitElement == suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int mySuitValue = 3 - suits.indexOf(suit);&#xA;&#x9;&#x9;int otherSuitValue = 3 - suits.indexOf(o.getSuit());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (face + mySuitValue) - (o.getFace() + otherSuitValue);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Collection&lt;Card> hey = new ArrayList&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="43" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400108097" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit; // Valør&#xA;&#x9;private int face; // Verdi&#xA;&#xA;&#x9;public static List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C');&#xA;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (checkSuit(suit) &amp;&amp; face > 0 &amp;&amp; face &lt; 14) {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldige kortverdier.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + suit + face;&#xA;&#x9;}&#xA;&#xA;&#x9;// Hjelpemetode&#xA;&#xA;&#x9;private boolean checkSuit(char suit) {&#xA;&#x9;&#x9;for (char suitElement : suits) {&#xA;&#x9;&#x9;&#x9;if (suitElement == suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int mySuitValue = 3 - suits.indexOf(suit);&#xA;&#x9;&#x9;int otherSuitValue = 3 - suits.indexOf(o.getSuit());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (face + mySuitValue) - (o.getFace() + otherSuitValue);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Collection&lt;Card> hey = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;Collections.sort(hey);&#xA;&#x9;&#x9;System.out.println(hey" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="120" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400141571" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(List&lt;Card>) " edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1189" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400168107" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1190" end="-41"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400178435" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1190" end="-41"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400198282" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1124" end="-107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400201841" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1160" end="-76"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400206500" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="101" end="-1135"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400279624" sizeMeasure="65" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit; // Valør&#xA;&#x9;private int face; // Verdi&#xA;&#xA;&#x9;public static List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C');&#xA;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (checkSuit(suit) &amp;&amp; face > 0 &amp;&amp; face &lt; 14) {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldige kortverdier.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + suit + face;&#xA;&#x9;}&#xA;&#xA;&#x9;// Hjelpemetode&#xA;&#xA;&#x9;private boolean checkSuit(char suit) {&#xA;&#x9;&#x9;for (char suitElement : suits) {&#xA;&#x9;&#x9;&#x9;if (suitElement == suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;int mySuitValue = 3 - suits.indexOf(suit);&#xA;&#x9;&#x9;int otherSuitValue = 3 - suits.indexOf(o.getSuit());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (face + mySuitValue) - (o.getFace() + otherSuitValue);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> hey = new ArrayList&lt;>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;hey.add(new Card('S', 5));&#xA;&#x9;&#x9;hey.add('D', 3);&#xA;&#x9;&#x9;hey.add('C', 5)&#xA;&#x9;&#x9;Collections.sort((List&lt;Card>) hey);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="101" end="-34"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400281767" sizeMeasure="65" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1204" end="-75"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400292009" sizeMeasure="67" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(hey);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1208" end="-75"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400311725" sizeMeasure="67" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Card('D', 3)" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1178" end="-126"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400321556" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Card('C', 5)" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1207" end="-107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402235910" sizeMeasure="71" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (mySuitValue == otherSuitValue) {&#xA;&#x9;&#x9;&#x9;return &#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="984" end="-352"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402269102" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(face + mySuitValue) - (o.getFace() + otherSuitValue);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return mySuitValue - otherSuitValue" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1031" end="-286"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402289582" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="hey.add(new Card('C', 8))" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1314" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402300884" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="1339" end="-105"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400398600" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400427514" sizeMeasure="7" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400868697" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="106" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488400939342" sizeMeasure="17">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public CardComparator(boolean ace, char trumph) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="111" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401038346" sizeMeasure="21" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private boolean ace;&#xA;&#x9;private char trumph;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph) {&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="109" end="-114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401235708" sizeMeasure="23" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int face;&#xA;&#x9;&#x9;if (ace) {&#xA;&#x9;&#x9;&#x9;if (o1.getFace()) = &#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="308" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401295899" sizeMeasure="24" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o1face = o1.getFace();&#xA;&#x9;&#x9;int o2face = o2.getFace()" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="312" end="-51"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401312417" sizeMeasure="26" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="396" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401337303" sizeMeasure="26" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o1face = 14;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="386" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401354655" sizeMeasure="29" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (o2face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o2" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="423" end="-28"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401441697" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nt o2suit = o2.getSuit();&#xA;&#x9;&#x9;if (ace) {&#xA;&#x9;&#x9;&#x9;if (o1face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o1face = 14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o2face = 14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;if" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="367" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401460512" sizeMeasure="32" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1suit = o1.getSuit" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="371" end="-150"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401555503" sizeMeasure="35" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Value = 3 - Card.suits.indexOf(o1.getSuit());&#xA;&#x9;&#x9;int o2suitValue = o2.getSuit();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o)&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="376" end="-118"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401564735" sizeMeasure="35" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="461" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401571622" sizeMeasure="35" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="442" end="-136"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401575134" sizeMeasure="35" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="578" end="-579"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401580959" sizeMeasure="34" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="568" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401600221" sizeMeasure="34" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3 - Card.suits.indexOf(o2.getSuit());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//if (o)&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (ace) {&#xA;&#x9;&#x9;&#x9;if (o1face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o1face = 14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o2face = 14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="442" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401638744" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (o1.getSuit() == trumph) {&#xA;&#x9;&#x9;&#x9;o1suitValue = 15;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="485" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401647260" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="7" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="533" end="-122"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401655036" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="8" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="533" end="-122"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401657205" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="655" end="-656"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401691452" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="  // En mer enn maks verdi og maks valør (spar ess = 17)" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="535" end="-121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401708379" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="med ess høyest" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="586" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401747291" sizeMeasure="39" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (o2.getSuit() == trumph) {&#xA;&#x9;&#x9;&#x9;o2suitValue = 18;" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="613" end="-121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401800878" sizeMeasure="41" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="SuitValue = 3 - Card.suits.indexOf(o1.getSuit());&#xA;&#x9;&#x9;int o2SuitValue = 3 - Card.suits.indexOf(o2.getSuit());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1.getSuit() == trumph) {&#xA;&#x9;&#x9;&#x9;o1SuitValue = 18;  // En mer enn maks verdi og maks valør (spar ess med ess høyest = 17)&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2.getSuit() == trumph) {&#xA;&#x9;&#x9;&#x9;o2SuitValue = 18;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (ace) {&#xA;&#x9;&#x9;&#x9;if (o1face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o1face = 14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o2face = 14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (o1)" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="372" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401825533" sizeMeasure="41" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Face = o1.getFace();&#xA;&#x9;&#x9;int o2Face = o2.getFace();&#xA;&#x9;&#x9;int o1SuitValue = 3 - Card.suits.indexOf(o1.getSuit());&#xA;&#x9;&#x9;int o2SuitValue = 3 - Card.suits.indexOf(o2.getSuit());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (o1.getSuit() == trumph) {&#xA;&#x9;&#x9;&#x9;o1SuitValue = 18;  // En mer enn maks verdi og maks valør (spar ess med ess høyest = 17)&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2.getSuit() == trumph) {&#xA;&#x9;&#x9;&#x9;o2SuitValue = 18;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (ace) {&#xA;&#x9;&#x9;&#x9;if (o1Face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o1Face = 14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2Face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o2F" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="314" end="-44"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401864537" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Face + o1SuitValue) - (o2Face + o2SuitValue);" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="791" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401893844" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="843" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401896035" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;}" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="839" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401897651" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="843" end="-844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401927441" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-((o1Face + o1SuitValue) - (o2Face + o2SuitValue)" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="788" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488401936826" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(o1Face + o1SuitValue) - (o2Face + o2SuitValue" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="788" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402360609" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="763" end="-80"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402362210" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="719" end="-123"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402371569" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (o2Face == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;o2Face = 1" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="719" end="-80"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402377273" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4;  // En mer enn maks verdi og maks valør (spar ess med ess høyest = 17)&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (o2.getSuit() == trumph) {&#xA;&#x9;&#x9;&#x9;o2SuitValue = 4" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="532" end="-182"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402395025" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="vanlig maksverdi" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="550" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402458119" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (o1SuitValue == o2SuitValue) {&#xA;&#x9;&#x9;&#x9;return (o1Face + o1SuitValue) - (o2Face + o2SuitValue);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return o1SuitValue - o2SuitValue" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="740" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402483957" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="879" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488402488693" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="878" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488400292721" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488400322234" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488400353022" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488402270428" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488402294561" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488402301044" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488400337385" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488401908304" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488401931043" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488402464411" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
