<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488958308004" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488961832867" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card>{&#xA;&#x9;&#x9;private char color;&#xA;&#x9;&#x9;private int value;&#xA;&#x9;&#x9;private char[] suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public Card(char color, int value){&#xA;&#x9;&#x9;&#x9;if (color == 'S' || color == 'H' || color == 'D' || color == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;color must be S,H,D or C&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (value &lt; 1 || value > 13){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Value must be between 1 and 13&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.value= value;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;public char getSuit(){&#xA;&#x9;&#x9;&#x9;&#x9;return this.color;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;public int getFace(){&#xA;&#x9;&#x9;&#x9;&#x9;return this.value;&#xA;&#x9;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;@Override&#xA;&#x9;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;&#x9;if (color != card.getSuit()){&#xA;&#x9;&#x9;&#x9;&#x9; &#xA;&#x9;&#x9;&#x9;&#x9;int verdiThis = 0;&#xA;&#x9;&#x9;&#x9;&#x9;int verdiCard = 0;&#xA;&#x9;&#x9;&#x9;&#x9;for (int i = 0; i&lt; suits.length; i ++){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (color == suits[i]){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;verdiThis = i;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;if (card.getSuit() == suits[i])&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;verdiCard = i;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (verdiThis > verdiCard){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;if (card.getFace() > this.value){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (card.getFace() &lt; this.value){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;}&#xA;&#x9;&#x9;public String toString(){&#xA;&#x9;&#x9;&#x9;return String.format(&quot;%s&quot;, getSuit()) + String.format(&quot;%s)&quot;, getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;&#x9;Card card = new Card('S', 5);&#xA;&#x9;&#x9;&#x9;Card card1= new Card('S', 2);&#xA;&#x9;&#x9;&#x9;System.out.println(card.compareTo(card1));&#xA;&#x9;&#x9;}&#xA;}&#xA;&#x9;&#x9;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="39" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488962065026" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1461" end="-1462"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488960342469" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488961832888" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;private char[] suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;private boolean ess;&#xA;&#x9;private char trumf;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf){&#xA;&#x9;&#x9;this.trumf =trumf;&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card card1, Card card2) {&#xA;&#x9;&#x9;if (card1.getSuit() != card2.getSuit()){&#xA;&#x9;&#x9;&#x9;if (card1.getSuit() == this.trumf){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (card2.getSuit() == this.trumf){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;int verdiCard1 = 0;&#xA;&#x9;&#x9;&#x9;int verdiCard2 =0;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; suits.length; i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (card1.getSuit() == suits[i]){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;verdiCard1 = i;&#xA;&#x9;&#x9;&#x9;&#x9;}if (card2.getSuit() == suits[i]){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;verdiCard2 = i;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}if (verdiCard2 > verdiCard2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}else if (ess){ if (card1.getFace() ==1 &amp;&amp; card2.getFace() !=1){&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}else {&#xA;&#x9;&#x9;if (card2.getFac() > card1.getFace()){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else if (card2.getFace() &lt;card1.getFace()){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;}else{&#xA;&#x9;if(card1.getFace() > card1.getFace()){&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}else if (card2.getFace() &lt; card1.getFace()){&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}else{&#xA;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="897" charEnd="903" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488961852295" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="1045" end="-136"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="897" charEnd="903" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488961861047" sizeMeasure="57" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="e" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="903" end="-279"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="515" charEnd="525" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488961891374" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="738" end="-444"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488962612907" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}else {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}else if (ess){ &#xA;&#x9;&#x9;if (card1.getFace() == 1 &amp;&amp; card2.getFace() !=1){&#xA;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}else if (card1.getFace() != 1 &amp;&amp; card2.getFace() ==1){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if(card2.getFace() > card1.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if (card2.getFace() &lt; card1.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}else {&#xA;&#x9;&#x9;if(card2.getFace() > card1.getFace()){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else if (card2.getFace() &lt; card1.getFace()){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="772" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488961935226" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488961945450" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488962041646" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488962059947" mode="debug"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488961834440" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488961853353" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488961862277" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488961870543" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488961892810" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488962613757" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
