<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881663531" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881667931" sizeMeasure="39">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882500978" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card>{&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card c1) {&#xA;&#x9;&#x9;if(this.getSuit() == c1.getSuit()){&#xA;&#x9;&#x9;&#x9;if(this.getFace() &lt;= c1.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;return c1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="39" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1118" charEnd="1120" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882714856" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nt check = (SUITS.indexOf(this.getSuit()) - SUITS.indexOf(c1.getSuit()));&#xA;&#x9;&#x9;if (check == 0){&#xA;&#x9;&#x9;&#x9;&#x9;check = this.getFace() - c1.getFace();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;return check" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="990" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882921296" sizeMeasure="57" errorCount="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Arrays;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card c1) {&#xA;&#x9;&#x9;int check = (SUITS.indexOf(this.getSuit()) - SUITS.indexOf(c1.getSuit()));&#xA;&#x9;&#x9;if (check == 0){&#xA;&#x9;&#x9;&#x9;&#x9;check = this.getFace() - c1.getFace();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new card = ('H',13);&#xA;&#x9;&#x9;&#x9;&#x9;new card = ('S', 10);&#xA;&#x9;&#x9;&#x9;&#x9;new card = ('C',4);&#xA;&#x9;&#x9;&#x9;&#x9;))" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="21" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1269" charEnd="1273" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1292" charEnd="1301" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1332" charEnd="1336" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1337" charEnd="1338" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1346" charEnd="1347" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1346" charEnd="1347" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1358" charEnd="1362" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1363" charEnd="1364" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1385" charEnd="1389" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1390" charEnd="1391" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1398" charEnd="1399" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883033569" sizeMeasure="59" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.Arrays;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card c1) {&#xA;&#x9;&#x9;int check = (SUITS.indexOf(this.getSuit()) - SUITS.indexOf(c1.getSuit()));&#xA;&#x9;&#x9;if (check == 0){&#xA;&#x9;&#x9;&#x9;&#x9;check = this.getFace() - c1.getFace();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('H',13),&#xA;&#x9;&#x9;&#x9;&#x9;new card ('S',10),&#xA;&#x9;&#x9;&#x9;&#x9;new card ('C',4)&#xA;&#x9;&#x9;&#x9;&#x9;));" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="43" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="55" charStart="1409" charEnd="1413" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1433" charEnd="1437" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883130413" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card c1) {&#xA;&#x9;&#x9;int check = (SUITS.indexOf(this.getSuit()) - SUITS.indexOf(c1.getSuit()));&#xA;&#x9;&#x9;if (check == 0){&#xA;&#x9;&#x9;&#x9;&#x9;check = this.getFace() - c1.getFace();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('H',13),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('S',10),&#xA;&#x9;&#x9;&#x9;&#x9;new Card ('C',4)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;System.out.println(&quot;Før sortering: &quot; + cards);&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;System.out.println(&quot;Etter sortering: &quot; + cards" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="91" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883382339" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883936728" sizeMeasure="48" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#xA;&#x9;&#x9;boolean ace;&#xA;&#x9;&#x9;char trumph;&#xA;&#x9;&#x9;public String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public CardComparator(boolean ace, char trumph) {&#xA;&#x9;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;/*&#xA;&#x9;&#x9; * Returns suit and face as a string&#xA;&#x9;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9;&#x9; */&#xA;&#x9;&#x9;public String toString() {&#xA;&#x9;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;public char getSuit() {&#xA;&#x9;&#x9;&#x9;return this.suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public int getFace() {&#xA;&#x9;&#x9;&#x9;return this.face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;@Override&#xA;&#x9;&#x9;public int compare(Card arg0, Card arg1) {&#xA;&#x9;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-2"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="330" charEnd="334" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="351" charEnd="355" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="363" charEnd="367" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="435" charEnd="439" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="627" charEnd="631" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="635" charEnd="639" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="691" charEnd="695" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="748" charEnd="752" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="258" charEnd="262" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884268655" sizeMeasure="53" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.ace = ace;&#xA;&#x9;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;&#x9;if (!(trumph == ' ')){&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="229" end="-671"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="439" charEnd="443" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="460" charEnd="464" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="472" charEnd="476" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="544" charEnd="548" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="736" charEnd="740" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="744" charEnd="748" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="35" charStart="800" charEnd="804" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="39" charStart="857" charEnd="861" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884429426" sizeMeasure="57" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.subString(0,index);&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0,index) + SUITS.substring(index+1);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;SUITS = newSuits" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="363" end="-607"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="430" charEnd="439" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="585" charEnd="589" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="597" charEnd="601" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="669" charEnd="673" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="35" charStart="861" charEnd="865" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="35" charStart="869" charEnd="873" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="39" charStart="925" charEnd="929" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="982" charEnd="986" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884462055" sizeMeasure="53" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="557" end="-495"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="430" charEnd="439" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="751" charEnd="755" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="759" charEnd="763" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="35" charStart="815" charEnd="819" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="39" charStart="872" charEnd="876" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488885316136" sizeMeasure="63" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;&#x9;int check = SUITS.indexOf(c2.getSuit()) - SUITS.indexOf(c1.getSuit()); &#xA;&#x9;&#x9;&#x9;if(check == 0){&#xA;&#x9;&#x9;&#x9;&#x9;if(ace){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (c1.getFace()== 1 &amp;&amp; c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}else if(c1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;check = (c1.getFace()- c2.getFace());&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;/*&#xA;&#x9;&#x9; * Returns suit and face as a string&#xA;&#x9;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9;&#x9; */&#xA;&#x9;&#x9;public String toString() {&#xA;&#x9;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;public char getSuit() {&#xA;&#x9;&#x9;&#x9;return this.suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public int getFace() {&#xA;&#x9;&#x9;&#x9;return this.face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="557" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1150" charEnd="1154" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1206" charEnd="1210" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1263" charEnd="1267" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="430" charEnd="439" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="596" charEnd="621" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1142" charEnd="1146" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488885350726" sizeMeasure="64" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return check;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="937" end="-383"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="430" charEnd="439" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1160" charEnd="1164" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1168" charEnd="1172" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1224" charEnd="1228" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1281" charEnd="1285" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488885576048" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#xA;&#x9;&#x9;boolean ace;&#xA;&#x9;&#x9;char trumph;&#xA;&#x9;&#x9;public String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public CardComparator(boolean ace, char trumph) {&#xA;&#x9;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;&#x9;if (!(trumph == ' ')){&#xA;&#x9;&#x9;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.subString(0,index);&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0,index) + SUITS.substring(index+1);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;&#x9;int check = SUITS.indexOf(c2.getSuit()) - SUITS.indexOf(c1.getSuit()); &#xA;&#x9;&#x9;&#x9;if(check == 0){&#xA;&#x9;&#x9;&#x9;&#x9;if(ace){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (c1.getFace()== 1 &amp;&amp; c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}else if(c1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;check = (c1.getFace()- c2.getFace());&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return check;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;new Card ('H',13),&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;new Card ('S',10),&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;new Card ('C',4)&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;)); &#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Før sortering&quot; + cards);&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="38" end="-15"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="509" charEnd="518" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488885863046" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="llections;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#xA;&#x9;&#x9;boolean ace;&#xA;&#x9;&#x9;char trumph;&#xA;&#x9;&#x9;public String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public CardComparator(boolean ace, char trumph) {&#xA;&#x9;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;&#x9;if (!(trumph == ' ')){&#xA;&#x9;&#x9;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.subString(0,index);&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0,index) + SUITS.substring(index+1);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;&#x9;int check = SUITS.indexOf(c2.getSuit()) - SUITS.indexOf(c1.getSuit()); &#xA;&#x9;&#x9;&#x9;if(check == 0){&#xA;&#x9;&#x9;&#x9;&#x9;if(ace){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (c1.getFace()== 1 &amp;&amp; c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}else if(c1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;check = (c1.getFace()- c2.getFace());&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return check;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;new Card ('H',13),&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;new Card ('S',10),&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;new Card ('C',4)&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;&#x9;CardComparator C1 = new CardComparator(true, 'C');&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Før sortering&quot; + cards);&#xA;&#x9;&#x9;&#x9;Collections.sort(cards,C1);&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Etter sortering&quot; + cards);" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="93" end="-15"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="540" charEnd="549" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488885893456" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="522" end="-915"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488883130284" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488885865338" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488885896048" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488883172384" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488885914420" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488888046696" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488889782643" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
