<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804829652" sizeMeasure="38" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;import java.util.Comparable;&#xA;&#xA;public class Card implements Comparable{&#xA;&#x9;private char colour;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char colour, int value) {&#xA;&#x9;&#x9;if (colour != 'S' &amp;&amp;  colour != 'H' &amp;&amp; colour != 'D' &amp;&amp; colour != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfarge må være S, H, D eller C&quot;);&#xA;&#x9;&#x9;}if (value &lt; 1 || value > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortets verdi må være fra og med 1 til og med 13&quot;);&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;this.colour = colour;&#xA;&#x9;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return colour;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(getSuit()) + getFace();&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card1, Card card2) {&#xA;&#x9;&#x9;char suitCard1 = card1.getSuit();&#xA;&#x9;&#x9;char suitCard2 = card2.getSuit();&#xA;&#x9;&#x9;int valCard1 = card1.getFace();&#xA;&#x9;&#x9;int valCard2 = card2.getFace();&#xA;&#x9;&#x9;if(card1.getSuit() == card2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return card1.getFace()-card2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="2" charStart="27" charEnd="47" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="705" charEnd="738" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805201948" sizeMeasure="40" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;System.out.println(&quot;S = &quot; + (int) 'C');&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="974" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="2" charStart="27" charEnd="47" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="705" charEnd="738" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805234654" sizeMeasure="43" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S');&#xA;&#x9;&#x9;System.out.println(&quot;H = &quot; + (int) 'H');&#xA;&#x9;&#x9;System.out.println(&quot;D = &quot; + (int) 'D');&#xA;&#x9;&#x9;System.out.println(&quot;C" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1053" end="-25"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="2" charStart="27" charEnd="47" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="705" charEnd="738" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805421033" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class Card implements Comparable{&#xA;&#x9;private char colour;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char colour, int value) {&#xA;&#x9;&#x9;if (colour != 'S' &amp;&amp;  colour != 'H' &amp;&amp; colour != 'D' &amp;&amp; colour != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfarge må være S, H, D eller C&quot;);&#xA;&#x9;&#x9;}if (value &lt; 1 || value > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortets verdi må være fra og med 1 til og med 13&quot;);&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;this.colour = colour;&#xA;&#x9;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return colour;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(getSuit()) + getFace();&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card1, Card card2) {&#xA;&#x9;&#x9;/*char suitCard1 = card1.getSuit();&#xA;&#x9;&#x9;char suitCard2 = card2.getSuit();&#xA;&#x9;&#x9;int valCard1 = card1.getFace();&#xA;&#x9;&#x9;int valCard2 = card2.getFace();*/&#xA;&#x9;&#x9;if(card1.getSuit() == card2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return card1.getFace()-card2.getFace();&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;return ((int) card1.getSuit()) - ((int) card2.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;}/*&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;System.out.println(&quot;S = &quot; + (int) 'S');&#xA;&#x9;&#x9;System.out.println(&quot;H = &quot; + (int) 'H');&#xA;&#x9;&#x9;System.out.println(&quot;D = &quot; + (int) 'D');&#xA;&#x9;&#x9;System.out.println(&quot;C = &quot; + (int) 'C');&#xA;&#x9;}*/" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="20" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806289355" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collections;&#xA;&#xA;public class Card implements Comparable{&#xA;&#x9;private char colour;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char colour, int value) {&#xA;&#x9;&#x9;if (colour != 'S' &amp;&amp;  colour != 'H' &amp;&amp; colour != 'D' &amp;&amp; colour != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfarge må være S, H, D eller C&quot;);&#xA;&#x9;&#x9;}if (value &lt; 1 || value > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortets verdi må være fra og med 1 til og med 13&quot;);&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;this.colour = colour;&#xA;&#x9;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return colour;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(getSuit()) + getFace();&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card1, Card card2) {&#xA;&#x9;&#x9;/*char suitCard1 = card1.getSuit();&#xA;&#x9;&#x9;char suitCard2 = card2.getSuit();&#xA;&#x9;&#x9;int valCard1 = card1.getFace();&#xA;&#x9;&#x9;int valCard2 = card2.getFace();*/&#xA;&#x9;&#x9;if(card1.getSuit() == card2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return card1.getFace()-card2.getFace();&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;return ((int) card1.getSuit()) - ((int) card2.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;System.out.println(&quot;S = &quot; + (int) 'S');&#xA;&#x9;&#x9;System.out.println(&quot;H = &quot; + (int) 'H');&#xA;&#x9;&#x9;System.out.println(&quot;D = &quot; + (int) 'D');&#xA;&#x9;&#x9;System.out.println(&quot;C = &quot; + (int) 'C');&#xA;&#x9;&#x9;CardDeck kortstokk = new CardDeck(10);&#xA;&#x9;&#x9;System.out.println(kortstokk);&#xA;&#x9;&#x9;System.out.println(compareTo(kortstokk.getCard(3), kortstokk.getCard(6)));&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="21" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1356" charEnd="1365" severity="2" problemCategory="50" problemType="603979977"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806306730" sizeMeasure="49" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1337" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806331429" sizeMeasure="49" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getCard(4)" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1332" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806342502" sizeMeasure="49" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1341" end="-13"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806839645" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Card>{&#xA;&#x9;private char colour;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char colour, int value) {&#xA;&#x9;&#x9;if (colour != 'S' &amp;&amp;  colour != 'H' &amp;&amp; colour != 'D' &amp;&amp; colour != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfarge må være S, H, D eller C&quot;);&#xA;&#x9;&#x9;}if (value &lt; 1 || value > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortets verdi må være fra og med 1 til og med 13&quot;);&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;this.colour = colour;&#xA;&#x9;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return colour;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(getSuit()) + getFace();&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return this.getFace()-o.getFace();&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return ((int) this.getSuit()) - ((int) o.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*public static void main(String[] args) {&#xA;&#x9;&#x9;System.out.println(&quot;S = &quot; + (int) 'S');&#xA;&#x9;&#x9;System.out.println(&quot;H = &quot; + (int) 'H');&#xA;&#x9;&#x9;System.out.println(&quot;D = &quot; + (int) 'D');&#xA;&#x9;&#x9;System.out.println(&quot;C = &quot; + (int) 'C');&#xA;&#x9;&#x9;CardDeck kortstokk = new CardDeck(10);&#xA;&#x9;&#x9;System.out.println(kortstokk.getCard(0));&#xA;&#x9;&#x9;&#xA;&#x9;}*/&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="91" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807481409" sizeMeasure="52" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private char colour;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char colour, int value) {&#xA;&#x9;&#x9;if (colour != 'S' &amp;&amp;  colour != 'H' &amp;&amp; colour != 'D' &amp;&amp; colour != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfarge må være S, H, D eller C&quot;);&#xA;&#x9;&#x9;}if (value &lt; 1 || value > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortets verdi må være fra og med 1 til og med 13&quot;);&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;this.colour = colour;&#xA;&#x9;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return colour;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(getSuit()) + getFace();&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return this.getFace()-o.getFace();&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return ((int) this.getSuit()) - ((int) o.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;System.out.println(&quot;S = &quot; + (int) 'S');&#xA;&#x9;&#x9;System.out.println(&quot;H = &quot; + (int) 'H');&#xA;&#x9;&#x9;System.out.println(&quot;D = &quot; + (int) 'D');&#xA;&#x9;&#x9;System.out.println(&quot;C = &quot; + (int) 'C');&#xA;&#x9;&#x9;CardDeck kortstokk = new CardDeck(10);&#xA;&#x9;&#x9;System.out.println(kortstokk.getCard(0));&#xA;&#x9;&#x9;kortstokk.shufflePerfectly();&#xA;&#x9;&#x9;for (int i = 0; i&lt;kortstokk.getCardCount(); i++) {&#xA;&#x9;&#x9;&#x9;System.out.println(kortstokk.getCard(i));&#xA;&#x9;&#x9;}//Collections.sort(kortstokk);&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="51" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="58" charEnd="72" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807496290" sizeMeasure="52" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1153" end="-222"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="58" charEnd="72" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807522329" sizeMeasure="51" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1159" end="-178"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="58" charEnd="72" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807679780" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private char colour;&#xA;&#x9;private int value;&#xA;&#x9;&#xA;&#x9;public Card(char colour, int value) {&#xA;&#x9;&#x9;if (colour != 'S' &amp;&amp;  colour != 'H' &amp;&amp; colour != 'D' &amp;&amp; colour != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfarge må være S, H, D eller C&quot;);&#xA;&#x9;&#x9;}if (value &lt; 1 || value > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortets verdi må være fra og med 1 til og med 13&quot;);&#xA;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;this.colour = colour;&#xA;&#x9;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return colour;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(getSuit()) + getFace();&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return this.getFace()-o.getFace();&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return ((int) this.getSuit()) - ((int) o.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;System.out.println(&quot;S = &quot; + (int) 'S');&#xA;&#x9;&#x9;System.out.println(&quot;H = &quot; + (int) 'H');&#xA;&#x9;&#x9;System.out.println(&quot;D = &quot; + (int) 'D');&#xA;&#x9;&#x9;System.out.println(&quot;C = &quot; + (int) 'C');&#xA;&#x9;&#x9;CardDeck kortstokk = new CardDeck(5);&#xA;&#x9;&#x9;kortstokk.shufflePerfectly();&#xA;&#x9;&#x9;List&lt;Card> carddeck = new ArrayList&lt;>();&#xA;&#x9;&#x9;for (int i = 0; i&lt;kortstokk.getCardCount(); i++) {&#xA;&#x9;&#x9;&#x9;System.out.println(kortstokk.getCard(i));&#xA;&#x9;&#x9;&#x9;carddeck.add(kortstokk.getCard(i));&#xA;&#x9;&#x9;}Collections.sort(carddec" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="38" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807764714" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;Sortert:&quot;);&#xA;&#x9;&#x9;for (int i = 0; i&lt;carddeck.size(); i++){&#xA;&#x9;&#x9;&#x9;System.out.println(carddeck.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1430" end="-12"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807858277" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808861536" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;boolean ace;&#xA;&#x9;char trumf;&#xA;&#x9;int tC = 0;&#xA;&#x9;int tD = 0;&#xA;&#x9;int tS = 0;&#xA;&#x9;int tH = 0;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumf) {&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;&#x9;/*if (trumf == 'C') {&#xA;&#x9;&#x9;&#x9;tC = 100;&#xA;&#x9;&#x9;}else if (trumf == 'D') {&#xA;&#x9;&#x9;&#x9;tD = 100;&#xA;&#x9;&#x9;}else if (trumf == 'S') {&#xA;&#x9;&#x9;&#x9;tS = 100;&#xA;&#x9;&#x9;}else if (trumf == 'H') {&#xA;&#x9;&#x9;&#x9;tH = 100;&#xA;&#x9;&#x9;}*/&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;if(o1.getSuit() == o2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return o1.getFace()-o2.getSuit();&#xA;&#x9;&#x9;}else if (trumf == o1.getSuit()){&#xA;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;}else if (trumf == o2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return ((int) o1.getSuit()) - ((int) o2.getSuit());&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808936917" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-(o1.getFace()-o2.getSuit());&#xA;&#x9;&#x9;}else if (trumf == o1.getSuit()){&#xA;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;}else if (trumf == o2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return -(((int) o1.getSuit()) - ((int) o2.getSuit()" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="546" end="-16"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808963035" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o1.getFace()-o2.getSuit();&#xA;&#x9;&#x9;}else if (trumf == o1.getSuit()){&#xA;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;}else if (trumf == o2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return ((int) o1.getSuit()) - ((int) o2.getSuit(" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="546" end="-16"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809021762" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.getFace()-o1" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="547" end="-189"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809099872" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1.getFace()-o2.getSuit();&#xA;&#x9;&#x9;}else if (trumf == o1.getSuit()){&#xA;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;}else if (trumf == o2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return ((int) o2.getSuit()) - ((int) o1" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="547" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809140107" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.getFace()-o1" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="547" end="-189"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809220961" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1.getFace()-o2.getSuit();&#xA;&#x9;&#x9;}else if (trumf == o1.getSuit()){&#xA;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;}else if (trumf == o2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return ((int) o1.getSuit()) - ((int) o2" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="547" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809378404" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*else if (trumf == o1.getSuit()){&#xA;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;}else if (trumf == o2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}*/" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="576" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809797214" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if (trumf == o1.getSuit()){&#xA;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;}else if (trumf == o2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="576" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809943124" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(o1.getFace() > o2.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (o1.getFace() &lt; o2.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;//return o1.getFace() - " edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="539" end="-191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810573216" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" (ace == true) {&#xA;&#x9;&#x9;&#x9;if (o1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;if (o1.getSuit() == trumf || (((int) o1.getFace()) > ((int) o2.getFace()))) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}else if (o2.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;if (o1.getSuit() == trumf || (int) o1.getFace() > (int) o2.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="503" end="-395"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810613754" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;}else if (o2.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;if (o1.getSuit() == trumf || (int) o1.getFace() > (int) o2.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="649" end="-412"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810724592" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (o2.getSuit() == trumf || (int) o1.getFace() > (int) o2.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}else if (o2.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;if (o2.getSuit() == trumf || (int) o2.getFace() > (int) o1.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}if ()" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="649" end="-404"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="873" charEnd="878" severity="2" problemCategory="20" problemType="1610612969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810732016" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="873" end="-409"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810776584" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.getFace() > (int) o1.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}else if (o2.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;if (o2.getSuit() == trumf || (int) o2.getFace() > (int) o1.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}if(o1.getSuit() == trumf || (((int) o1.getFace()) > ((int) o2.getFace()))){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="685" end="-404"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488805201014" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488805233888" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488806305798" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488806330161" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488806341108" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807480569" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807494962" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807521517" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807679021" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807763821" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805422388" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488806290801" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488806841055" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488808879909" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488808937708" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488808963890" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488809022802" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488809101136" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488809141354" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488809221860" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488809379379" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488809798144" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488809944222" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488810574517" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488810614728" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488810725974" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488810733405" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488810777928" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="2">
        <attempts timestamp="1488811730104"/>
        <attempts timestamp="1488811734444"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
