<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringGridImpl">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Copy the source code for the StringGrid interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGrid"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridImpl class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridImpl class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StringGridIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StringGridTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.StringGridTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.StringGrid*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488716259275" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public interface StringGrid {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488716274547" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA;/*&#xA;An interface with methods for managing the content of a String grid.&#xA;The grid has a number of rows (the grid's height) and columns (the grid's width).&#xA;In each cell in the grid there is a String that can be set with the setElement method and read with the getElement method.&#xA;*/&#xA; public interface StringGrid {&#xA; &#xA;    // Returns the number of rows in this StringGrid&#xA;    public int getRowCount();&#xA;    // Returns the number of columns in this StringGrid&#xA;    public int getColumnCount();&#xA; &#xA;    // Returns the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public String getElement(int row, int column);&#xA;    // Sets the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public void setElement(int row, int column, String element);&#xA;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="20" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488724157054" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends Iterable&lt;String>" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="331" end="-550"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488724222123" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="331" end="-550"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488730286182" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends Iterable&lt;String>" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="331" end="-550"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488716300006" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class StringGridImpl {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488716442297" sizeMeasure="13" errorCount="4" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements StringGrid{&#xA;&#x9;&#xA;&#x9;private int rows;&#xA;&#x9;private int columnCount;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows, int columnCount) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.columnCount = columnCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="49" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488719991144" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class StringGridImpl implements StringGrid{&#xA;&#x9;&#xA;&#x9;private int rows;&#xA;&#x9;private int columnCount;&#xA;&#x9;private ArrayList&lt;ArrayList&lt;String>> board;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows, int columnCount) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.columnCount = columnCount;&#xA;&#x9;&#x9;board = new ArrayList&lt;>();&#xA;&#x9;&#x9;for (int i = 0; i &lt; rows; i++) {&#xA;&#x9;&#x9;&#x9;ArrayList&lt;String> rad = new ArrayList&lt;>();&#xA;&#x9;&#x9;&#x9;for (int j = 0; j &lt; columnCount; j++) {&#xA;&#x9;&#x9;&#x9;&#x9;rad.add(&quot;&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;board.add(rad);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;return rows;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return columnCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;if (!checkArguments(row, column)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error: Out of range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return board.get(row).get(column);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;if (!checkArguments(row, column)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error: Out of range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;board.get(row).set(column, element);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private boolean checkArguments(int row, int column) {&#xA;&#x9;&#x9;if (row > this.rows || column > this.columnCount) {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="21" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488730443694" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;&#xA;public class StringGridImpl implements StringGrid{&#xA;&#x9;&#xA;&#x9;private int rows;&#xA;&#x9;private int columnCount;&#xA;&#x9;private ArrayList&lt;ArrayList&lt;String>> board;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows, int columnCount) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.columnCount = columnCount;&#xA;&#x9;&#x9;board = new ArrayList&lt;>();&#xA;&#x9;&#x9;for (int i = 0; i &lt; rows; i++) {&#xA;&#x9;&#x9;&#x9;ArrayList&lt;String> rad = new ArrayList&lt;>();&#xA;&#x9;&#x9;&#x9;for (int j = 0; j &lt; columnCount; j++) {&#xA;&#x9;&#x9;&#x9;&#x9;rad.add(&quot;&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;board.add(rad);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;return rows;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return columnCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;if (!checkArguments(row, column)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error: Out of range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return board.get(row).get(column);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;if (!checkArguments(row, column)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error: Out of range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;board.get(row).set(column, element);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private boolean checkArguments(int row, int column) {&#xA;&#x9;&#x9;if (row > this.rows || column > this.columnCount) {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public Iterator&lt;String> iterator() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="49" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893058588" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return new StringGridIterator(this, true)" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1243" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488720122086" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class StringGridIterator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488720304287" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;&#xA;public class StringGridIterator implements Iterator&lt;String>{&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488721058944" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public StringGridIterator(StringGrid grid, boolean rowMajor) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="110" end="-192"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488721766397" sizeMeasure="27" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate StringGrid grid;&#xA;&#x9;private boolean rowMajor;&#xA;&#x9;private int rowPos = 0;&#xA;&#x9;private int colPos = 0;&#xA;&#x9;&#xA;&#x9;public StringGridIterator(StringGrid grid, boolean rowMajor) {&#xA;&#x9;&#x9;this.grid = grid;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;if ()&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="114" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488721818149" sizeMeasure="27" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getRowCount() " edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="379" end="-51"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488722647612" sizeMeasure="31" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;private int colPos;&#xA;&#x9;&#xA;&#x9;public StringGridIterator(StringGrid grid, boolean rowMajor) {&#xA;&#x9;&#x9;this.grid = grid;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;rowPos = 0;&#xA;&#x9;&#x9;colPos = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return rowPos &lt; grid.getRowCount() &amp;&amp; colPos &lt; grid.getColumnCount();&#xA;&#x9;}&#xA;&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void remove() {&#xA;&#x9;&#x9;throw new UnsupportedOperationException(&quot;Kan ikke fjerne&quot;);" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="184" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488724103338" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.NoSuchElementException;&#xA;&#xA;public class StringGridIterator implements Iterator&lt;String>{&#xA;&#x9;&#xA;&#x9;private StringGrid grid;&#xA;&#x9;private boolean rowMajor;&#xA;&#x9;private int rowPos;&#xA;&#x9;private int colPos;&#xA;&#x9;&#xA;&#x9;public StringGridIterator(StringGrid grid, boolean rowMajor) {&#xA;&#x9;&#x9;this.grid = grid;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;rowPos = 0;&#xA;&#x9;&#x9;colPos = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return rowPos &lt; grid.getRowCount() &amp;&amp; colPos &lt; grid.getColumnCount();&#xA;&#x9;}&#xA;&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;if (hasNext()) {&#xA;&#x9;&#x9;&#x9;String element = grid.getElement(rowPos, colPos);&#xA;&#x9;&#x9;&#x9;if (rowMajor) {&#xA;&#x9;&#x9;&#x9;&#x9;if (colPos == grid.getColumnCount()-1) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;rowPos += 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;colPos = 0;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;colPos += 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!rowMajor) {&#xA;&#x9;&#x9;&#x9;&#x9;if (rowPos == grid.getRowCount()-1) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;rowPos = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;colPos += 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;rowPos += 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return element;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;throw new NoSuchElementException();" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="48" end="-99"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488730361848" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488893082142" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
