<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Card">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardDeck class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardHand class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardDeck class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardHand class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardDeckTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardDeckTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardHandTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardHandTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487886998459" sizeMeasure="32">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Such a suit does not exist.&quot;);&#xA;&#x9;&#x9;} else if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The face has to be between 1 and 13, you wrote &quot; + face + &quot;.&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + getSuit() + getFace();&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487886998461" sizeMeasure="73">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.Arrays;&#xA;&#xA;public class CardDeck {&#xA;&#x9;&#xA;&#x9;private Card[] spadeCards;&#xA;&#x9;private Card[] heartCards;&#xA;&#x9;private Card[] diamondCards;&#xA;&#x9;private Card[] clubCards;&#xA;&#x9;private Card[] allCards;&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if (n &lt; 1 || n > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalAccessError(&quot;There are only 13 different faces of such a card game.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;spadeCards = new Card[n];&#xA;&#x9;&#x9;heartCards = new Card[n];&#xA;&#x9;&#x9;diamondCards = new Card[n];&#xA;&#x9;&#x9;clubCards = new Card[n];&#xA;&#x9;&#x9;allCards = new Card[4 * n];&#xA;&#x9;&#x9;for (int i = 0; i &lt; n; i++) {&#xA;&#x9;&#x9;&#x9;spadeCards[i] = new Card('S', i + 1);&#xA;&#x9;&#x9;&#x9;heartCards[i] = new Card('H', i + 1);&#xA;&#x9;&#x9;&#x9;diamondCards[i] = new Card('D', i + 1);&#xA;&#x9;&#x9;&#x9;clubCards[i] = new Card('C', i + 1);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;allCards[i] = spadeCards[i];&#xA;&#x9;&#x9;&#x9;allCards[i + n] = heartCards[i];&#xA;&#x9;&#x9;&#x9;allCards[i + 2 * n] = diamondCards[i];&#xA;&#x9;&#x9;&#x9;allCards[i + 3 * n] = clubCards[i];&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return allCards.length;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n &lt; 0 || n > allCards.length) {&#xA;&#x9;&#x9;&#x9;throw new IllegalAccessError(&quot;This card does not exist&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return allCards[n];&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void shufflePerfectly() {&#xA;&#x9;&#x9;Card[] tempDeck = new Card[allCards.length];&#xA;&#x9;&#x9;for (int i = 0; i &lt; allCards.length; i++) {&#xA;&#x9;&#x9;&#x9;if (i % 2 == 0) {&#xA;&#x9;&#x9;&#x9;&#x9;tempDeck[i] = allCards[i/2];&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;tempDeck[i] = allCards[allCards.length/2 + i/2];&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;allCards = tempDeck;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;allCards=&quot; + Arrays.toString(allCards);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck cards = new CardDeck(5);&#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;&#x9;System.out.println(cards.getCard(4));&#xA;&#x9;&#x9;cards.shufflePerfectly();&#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;&#x9;System.out.println(cards.getCard(4));&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487887169631" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void deal(CardHand cardHand, int n) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="1371" end="-348"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487887992299" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (int i = allCards.length - 1; i > allCards.length - 1 - n; i--) {&#xA;&#x9;&#x9;&#x9;cardHand.addCard(getCard(i));&#xA;&#x9;&#x9;&#x9;allCards[i] = null; &#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="1418" end="-353"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487888173220" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="1474" end="-426"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487888204515" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1474" end="-426"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487888300380" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0; i &lt; allCards.length - 1; i++" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1431" end="-417"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487888318903" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="allCards.length - 1; i > allCards.length - 1 - n; i--" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1431" end="-417"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487889061064" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1646" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487889265929" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int d = allCards.length - 1;&#xA;&#x9;&#x9;int i = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;while (i &lt; n) {&#xA;&#x9;&#x9;&#x9;cardHand.addCard(getCard(d));&#xA;&#x9;&#x9;&#x9;allCards[d] = null;&#xA;&#x9;&#x9;&#x9;i++;&#xA;&#x9;&#x9;&#x9;d--;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;/*for (int i = allCards.length - 1; i > allCards.length - 1 - n; i--) {&#xA;&#x9;&#x9;&#x9;cardHand.addCard(getCard(i));&#xA;&#x9;&#x9;&#x9;allCards[i] = null; &#xA;&#x9;&#x9;}*/&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;allCards=&quot; + Arrays.toString(allCards" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1418" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487922402397" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int numNulls = 0;&#xA;&#x9;&#x9;for (int i = 0; i &lt; allCards.length; i++) {&#xA;&#x9;&#x9;&#x9;if (allCards[i] == null) {&#xA;&#x9;&#x9;&#x9;&#x9;numNulls++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return allCards.length - numNulls" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="899" end="-883"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487922419613" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1684" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487922449882" sizeMeasure="82" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || allCards[i] == null" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1124" end="-669"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1182" charEnd="1183" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487922454462" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="n" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1137" end="-678"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487887166611" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class CardHand {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487887253191" sizeMeasure="9" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class CardHand {&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;Card> hand = new ArrayList&lt;>();" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="27" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="113" charEnd="117" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487887350285" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void addCard(Card card) {&#xA;&#x9;&#x9;hand.add(card);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="133" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487887397648" sizeMeasure="17">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void play(int n) {&#xA;&#x9;&#x9;hand.remove(n" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="190" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487888077742" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int getCardCount() {&#xA;&#x9;&#x9;return hand.size();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="143" end="-112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487888151093" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card getCard(int n) {&#xA;&#x9;&#x9;return hand.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addCard(Card card) {&#xA;&#x9;&#x9;hand.add(card);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="199" end="-58"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487888173173" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487888300351" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487887044865" completion="1.0" successCount="2">
          <successTests>testToString</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888221281" completion="1.0" successCount="2">
          <successTests>testToString</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888020854" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888156690" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888182530" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888226241" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888303966" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487889065033" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487889075279" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487889267026" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487889269231" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487889289071" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487921489556" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487922403421" completion="1.0" successCount="3">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888031243" completion="0.0" errorCount="3">
          <errorTests>testDeal</errorTests>
          <errorTests>testDealPlay</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888153987" completion="1.0" successCount="3">
          <successTests>testDeal</successTests>
          <successTests>testDealPlay</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888196342" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
          <failureTests>testDealPlay</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888205008" completion="1.0" successCount="3">
          <successTests>testDeal</successTests>
          <successTests>testDealPlay</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888307989" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testConstructor</successTests>
          <failureTests>testDeal</failureTests>
          <failureTests>testDealPlay</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487888319248" completion="1.0" successCount="3">
          <successTests>testDeal</successTests>
          <successTests>testDealPlay</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487889273297" completion="1.0" successCount="3">
          <successTests>testDeal</successTests>
          <successTests>testDealPlay</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
