<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487495667659" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496334493" sizeMeasure="35" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private TwitterAccount owner;&#xA;&#x9;private String text;&#xA;&#x9;private Tweet retweet;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (getOriginalTweet().getOwner().equals(owner)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;)&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.retweet = Tweet(getOriginalTweet().getOwner(), getOriginalTweet().getText());&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return retweet&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="48" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="748" charEnd="755" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="467" charEnd="468" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="515" charEnd="520" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496355587" sizeMeasure="35" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="452" end="-280"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="749" charEnd="756" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="521" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496405613" sizeMeasure="35" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="718" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="124" charEnd="131" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="147" charEnd="159" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="521" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496415919" sizeMeasure="35" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="730" end="-731"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="124" charEnd="131" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="147" charEnd="159" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="521" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496498108" sizeMeasure="36" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if ()" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="568" end="-23"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="521" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="744" charEnd="745" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496719108" sizeMeasure="38" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet.getOwner().equals(null) || retweet.getText().equals(null)) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="714" end="-23"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="147" charEnd="159" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="521" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496761067" sizeMeasure="42" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount()" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="821" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="147" charEnd="159" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="521" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="39" charStart="902" charEnd="914" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496801617" sizeMeasure="46" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate void incrementRetweetCount() {&#xA;&#x9;&#x9;retweetCount++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="825" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="521" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="874" charEnd="897" severity="1" problemCategory="120" problemType="603979894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496822877" sizeMeasure="47" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;incrementRetweetCount(" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="566" end="-386"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="521" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496858985" sizeMeasure="47" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="497" end="-473"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="520" severity="2" problemCategory="20" problemType="1610612971"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487496907498" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="497" end="-412"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498346617" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet.getOriginalTweet()" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="780" end="-132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487499449157" sizeMeasure="47" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Tweet()" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="497" end="-434"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="527" severity="2" problemCategory="50" problemType="134217858"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487499593007" sizeMeasure="47" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="equals(null)) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return retweet.getTex" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="694" end="-135"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="774" charEnd="791" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="516" charEnd="527" severity="2" problemCategory="50" problemType="134217858"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487499656701" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet.getOwner(), retweet.getText());&#xA;&#x9;&#x9;incrementRetweetCount();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (retweet.equals(null)) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="507" end="-132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487499713490" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (retweet.equals(null)) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="549" end="-65"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487500650602" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="riginalTweet().getOwner(), retweet.getOriginalTweet()" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="519" end="-307"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487500692868" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".retweet" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="809" end="-70"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487500705030" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="805" end="-77"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487500728795" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getOriginalTweet()." edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="861" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487500754682" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getOriginalTweet()." edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="587" end="-314"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487500815176" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Tweet(retweet.getOwner(), retweet.getText())" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="824" end="-89"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487501211355" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet." edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="313" end="-648"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487581636158" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="owner, retweet.getOriginalTweet().getText());&#xA;&#x9;&#x9;getOriginalTweet().retweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (retweet.equals(null)) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;TwitterAccount tempOwner = retweet.getOwner();&#xA;&#x9;&#x9;&#x9;String tempText = retweet.getText();&#xA;&#x9;&#x9;&#x9;while (!(retweet.getOwner().equals(null) &amp;&amp; retweet.getText().equals(null))) {&#xA;&#x9;&#x9;&#x9;&#x9;tempOwner = retweet.getOwner();&#xA;&#x9;&#x9;&#x9;&#x9;tempText = retweet.getText();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return new Tweet(tempOwner, tempText);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="515" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487581666910" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == owner" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="350" end="-810"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487581831565" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet.getOriginalTweet().getOwner()" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="510" end="-654"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582048221" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="784" end="-404"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582705678" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not allowed to tweet with more than 140 characters.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="209" end="-990"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583115669" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private boolean originalOwner" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="155" end="-1179"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="179" charEnd="192" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583125566" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;originalOwner = true" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="417" end="-949"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="179" charEnd="192" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583183296" sizeMeasure="62" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="originalOwner = false" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="676" end="-715"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="179" charEnd="192" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583322845" sizeMeasure="58" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet = retweet.getOwner();&#xA;&#x9;&#x9;&#x9;while (!tempTweet.originalOwner) {&#xA;&#x9;&#x9;&#x9;&#x9;tempTweet = tempTweet.getOwner();&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1066" end="-76"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="179" charEnd="192" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1160" charEnd="1173" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1204" charEnd="1212" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583353269" sizeMeasure="58" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="eet tempTweet = retweet;&#xA;&#x9;&#x9;&#x9;while (!tempTweet.originalOwner) {&#xA;&#x9;&#x9;&#x9;&#x9;tempTweet = tempTweet.getOwner()" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="1049" end="-81"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1193" charEnd="1194" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1174" charEnd="1194" severity="2" problemCategory="40" problemType="16777233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583600583" sizeMeasure="59" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;private boolean originalOwner;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not allowed to tweet with more than 140 characters.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;originalOwner = true;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (retweet.getOriginalTweet().getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;originalOwner = false;&#xA;&#x9;&#x9;this.retweet = new Tweet(retweet.getOriginalTweet().getOwner(), retweet.getOriginalTweet().getText());&#xA;&#x9;&#x9;getOriginalTweet().retweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (retweet == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;TwitterAccount tempOwner;&#xA;&#x9;&#x9;&#x9;Tweet tempTweet = retweet;&#xA;&#x9;&#x9;&#x9;while (!tempTweet.originalOwner) {&#xA;&#x9;&#x9;&#x9;&#x9;tempOwner = tempTweet.ge" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="152" end="-81"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1218" charEnd="1220" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1218" charEnd="1220" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1218" charEnd="1220" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583628207" sizeMeasure="59" errorCount="4" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (retweet == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;TwitterAccount tempOwner;&#xA;&#x9;&#x9;&#x9;Tweet tempTweet = retweet;&#xA;&#x9;&#x9;&#x9;while (!tempTweet.originalOwner) {&#xA;&#x9;&#x9;&#x9;&#x9;tempOwner = tempTweet.ge&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;*/" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="954" end="-63"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="196" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="536" charEnd="552" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="763" charEnd="779" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="802" charEnd="818" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="836" charEnd="852" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="124" charEnd="131" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583715203" sizeMeasure="59" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet.retweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (retweet == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;TwitterAccount tempOwner;&#xA;&#x9;&#x9;&#x9;Tweet tempTweet = retweet;&#xA;&#x9;&#x9;&#x9;while (!tempTweet.originalOwner) {&#xA;&#x9;&#x9;&#x9;&#x9;tempOwner = tempTweet.ge&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="810" end="-63"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1207" charEnd="1209" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1207" charEnd="1209" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1207" charEnd="1209" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583729447" sizeMeasure="59" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="810" end="-433"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1212" charEnd="1214" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1212" charEnd="1214" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1212" charEnd="1214" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583761428" sizeMeasure="59" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="720" end="-442"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1133" charEnd="1135" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1133" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1133" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583781645" sizeMeasure="59" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="731" end="-433"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1128" charEnd="1130" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1128" charEnd="1130" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1128" charEnd="1130" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583791888" sizeMeasure="59" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="731" end="-433"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1133" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1133" charEnd="1135" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1133" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583949727" sizeMeasure="56" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return retweet;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="966" end="-72"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="183" charEnd="196" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584004147" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not allowed to tweet with more than 140 characters.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (retweet.getOriginalTweet().getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="159" end="-360"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584066532" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="r tweet cannot contain" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="282" end="-668"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590061287" sizeMeasure="54" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Your tweet cannot contain more than 140 characters.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (retweet.getOriginalTweet().getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (retweet == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return retweet;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementRetweet() {&#xA;&#x9;&#x9;retweetCount++;" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="112" end="-69"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="39" charStart="841" charEnd="848" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="775" charEnd="782" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590719387" sizeMeasure="58" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount originalOwner;&#xA;&#x9;private String text;&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Your tweet cannot contain more than 140 characters.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.originalOwner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (retweet.getOriginalTweet().getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;originalOwner = retweet.getOriginalTweet().getOwner();&#xA;&#x9;&#x9;this.text = retweet.getText()" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="90" end="-360"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="938" charEnd="945" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1004" charEnd="1011" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590858444" sizeMeasure="52" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet originalTweet;&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Your tweet cannot contain more than 140 characters.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.originalOwner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (retweet.getOriginalTweet().getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;originalOwner = retweet.getOriginalTweet().getOwner();&#xA;&#x9;&#x9;this.text = retweet.getText();&#xA;&#x9;&#x9;originalTweet = retweet;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="151" end="-132"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="164" charEnd="177" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="965" charEnd="983" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590946186" sizeMeasure="52" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="originalTweet." edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="1059" end="-21"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="965" charEnd="983" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591098218" sizeMeasure="54" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (retweet.getRetweetCount() == 0) {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="781" end="-289"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1012" charEnd="1030" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591165130" sizeMeasure="56" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet.getOriginalTweet()" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="850" end="-294"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="1072" charEnd="1090" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591235335" sizeMeasure="56" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return originalTweet;" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="1054" end="-143"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591572128" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;originalTweet.incrementRetweet();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementRetweet() {&#xA;&#x9;&#x9;retweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return originalTweet.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;[owner = &quot; + owner + " edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="910" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="58" charStart="1366" charEnd="1367" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591582945" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*public String toString() {&#xA;&#x9;&#x9;return &quot;[owner = &quot; + owner + &#xA;&#x9;}*/" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="1253" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591931921" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="531" end="-778"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592397972" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="wner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;originalOwner = retweet.getOriginalTweet().getOwner();&#xA;&#x9;&#x9;this.text = retweet.getText();&#xA;&#x9;&#x9;if (retweet.getRetweetCount() == 0) {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet.getOriginalTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;incrementRetweet();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementRetweet() {&#xA;&#x9;&#x9;retweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="531" end="-90"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="110" charEnd="123" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592489332" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String text;&#xA;&#x9;private Tweet originalTweet;&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Your tweet cannot contain more than 140 characters.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (retweet.getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = retweet.getText();" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="90" end="-387"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592588345" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="originalTweet." edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="867" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593195494" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="1033" end="-1034"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602060608" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="f (originalTweet == null) {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet.getOriginalTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;originalTweet." edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="637" end="-398"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602091948" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;originalTweet.incrementRetweet();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;originalTweet.incrementRetweet();&#xA;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="695" end="-398"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602093384" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="825" end="-405"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602102118" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="} else {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet.getOriginalTweet();" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="695" end="-405"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602293647" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="originalTweet.incrementRetweet();&#xA;&#x9;&#x9;incrementRetweet();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementRetweet() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="757" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602407925" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="incrementRetweet();&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementRetweet() {&#xA;&#x9;&#x9;originalTweet." edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="757" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602693014" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.63/@edit" start="161" end="-993"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602707583" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.0/@attempts.64/@edit" start="161" end="-993"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602757425" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;incrementRetweet();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;getOriginalTweet().incrementRetweet();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.65/@edit" start="695" end="-379"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487603037934" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount originalOwner;&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Your tweet cannot contain more than 140 characters.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (retweet.getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = retweet.getText();&#xA;&#x9;&#x9;if (originalTweet == null) {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet;&#xA;&#x9;&#x9;&#x9;originalOwner = retweet.getOwner():" edit="/1/@proposals.0/@proposals.0/@attempts.66/@edit" start="142" end="-509"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="795" charEnd="796" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487603057300" sizeMeasure="63" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="originalOwner = retweet.getOwner" edit="/1/@proposals.0/@proposals.0/@attempts.67/@edit" start="855" end="-431"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="795" charEnd="796" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487603063339" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.68/@edit" start="769" end="-548"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="164" charEnd="177" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487603103056" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, String text) {&#xA;&#x9;&#x9;if (text.length() > 140) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Your tweet cannot contain more than 140 characters.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet retweet) {&#xA;&#x9;&#x9;if (retweet.getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to retweet one of your own tweets.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = retweet.getText();&#xA;&#x9;&#x9;if (originalTweet == null) {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet;&#xA;&#x9;&#x9;&#x9;incrementRetweet();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet.getOriginalTweet" edit="/1/@proposals.0/@proposals.0/@attempts.69/@edit" start="142" end="-431"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604224538" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.70/@edit" start="1128" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487607849958" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="originalTweet.incrementRetweet();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementRetweet() {&#xA;&#x9;&#x9;originalTweet.retweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.71/@edit" start="777" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487607876249" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="originalTweet." edit="/1/@proposals.0/@proposals.0/@attempts.72/@edit" start="696" end="-431"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487607887892" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="incrementRetweet();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;originalTweet = retweet.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.73/@edit" start="696" end="-336"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487495743818" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497029190" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private String username;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="57" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497112854" sizeMeasure="20" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;private ArrayList&lt;TwitterAccount> follow = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="27" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="162" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497136692" sizeMeasure="20" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ing" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="155" end="-160"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="165" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497182071" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;following.add(account);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="313" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497215127" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;following.remove" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="389" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497216332" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="474" end="-475"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497255353" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return following.contains" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="471" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497305297" sizeMeasure="32" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;Tweet> tweets" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="181" end="-414"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="214" charEnd="220" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497369249" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.following.contains(this" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="622" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="214" charEnd="220" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497416762" sizeMeasure="39" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void tweet(String tweet) {&#xA;&#x9;&#x9;tweets.add(tweet);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="725" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="804" charEnd="807" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497457510" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Tweet(this, tweet)" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="773" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497463573" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="801" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497533145" sizeMeasure="44" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;Tweet> retweets = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;following.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;following.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return following.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.following.contains(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="235" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="269" charEnd="277" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497587267" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweets.add(new Tweet(this, tweet));" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="897" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497649926" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return tweets.get(tweets.size() - 1);" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="939" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497725108" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return retweets.size(" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1016" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497851366" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.getRetweetCount" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1118" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487497953177" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="i" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1009" end="-139"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498480012" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (i &lt; 1 || i >= tweets.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You have to refer to a tweet that exists.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="975" end="-177"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498556626" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Tweet(tweet.getOwner(), tweet.getOriginalTweet())" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="926" end="-343"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498583891" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="926" end="-343"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498595113" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="975" end="-177"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498700530" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (i >= 1 &amp;&amp; i &lt; tweets.size()) {&#xA;&#x9;&#x9;&#x9;return tweets.get(tweets.size() - i);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw IllegalArgumentException(&quot;You have to refer to a tweet that exists.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="975" end="-137"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1118" charEnd="1142" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498707501" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ne" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="1071" end="-213"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498718786" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return tweets.get(tweets.size() - i);" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="975" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498767379" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weet.getOwner()" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="921" end="-225"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498777806" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getOriginalTweet()" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="943" end="-218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498945838" sizeMeasure="64" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int followers;&#xA;&#x9;private int followees;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;following.add(account);&#xA;&#x9;&#x9;followees++;&#xA;&#x9;&#x9;account.incrementFollowers();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementFollowers() {&#xA;&#x9;&#x9;followers++" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="291" end="-688"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="313" charEnd="322" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="338" charEnd="347" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498966638" sizeMeasure="68" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void decrementFollowers() {&#xA;&#x9;&#x9;followers--" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="740" end="-606"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="313" charEnd="322" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="338" charEnd="347" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498989641" sizeMeasure="70" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;followees--;&#xA;&#x9;&#x9;account.followers--" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="728" end="-662"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="313" charEnd="322" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="338" charEnd="347" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487498994313" sizeMeasure="70" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="decrementFollowers()" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="752" end="-662"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="338" charEnd="347" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="313" charEnd="322" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487499039002" sizeMeasure="58" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;following.remove(account)" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="543" end="-606"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="313" charEnd="322" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="338" charEnd="347" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487500829082" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="291" end="-892"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487500857887" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;following.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;following.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return following.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.following.contains(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;tweet.getOwner()." edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="291" end="-283"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487580125957" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;if (account.getUserName().equals(username)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to follow yourself, try another account.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;following.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;following.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return following.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.following.contains(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;new Tweet(tweet.getOwner(), tweet);&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return tweets.get(tweets.size() - i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;int totalRetweets = 0;&#xA;&#x9;&#x9;for (Tweet tweet : tweets) {&#xA;&#x9;&#x9;&#x9;totalRetweets += tweet.getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalRetweets" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="235" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582210168" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1004" end="-320"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582904819" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweets.add(new Tweet(this, tweet)" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="993" end="-313"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582965740" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.getOwner() == this) {&#xA;&#x9;&#x9;&#x9;&#x9;totalRetweets += tweet.getRetweetCount();&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="1262" end="-36"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590161570" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.getOwner() == this) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot retweet yourself.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;tweets.add(tweet);&#xA;&#x9;&#x9;tweet.incrementRetweet();" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="993" end="-351"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591535595" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="1122" end="-353"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487591563488" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Tweet(this, tweet)" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="1113" end="-353"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592394394" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="totalRetweets += tweet.getRetweetCount();" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="1370" end="-36"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487601754201" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".equals(this)" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="1013" end="-426"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487601771440" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == this" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="1013" end="-426"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487601821498" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || tweets.contains(tweet)" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="1021" end="-426"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487601851065" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" neither retweet yourself nor retweet the same tweet more than once" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="1097" end="-356"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602035654" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweet.incrementRetweet(" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="1212" end="-312"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602041094" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="1212" end="-312"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602236962" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return tweets.get(tweets.size() - i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;int totalRetweets = 0;&#xA;&#x9;&#x9;for (Tweet tweet : tweets) {&#xA;&#x9;&#x9;&#x9;totalRetweets += tweet.getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalRetweets;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount nils = new TwitterAccount(&quot;Nils&quot;);&#xA;&#x9;&#x9;TwitterAccount ole = new TwitterAccount(&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount kari = new TwitterAccount(&quot;Kari&quot;);&#xA;&#x9;&#x9;nils.tweet(&quot;Kvitre!&quot;);&#xA;&#x9;&#x9;ole.retweet(nils.getTweet(1));&#xA;&#x9;&#x9;kari.retweet(ole.getTweet(1));&#xA;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="1212" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602251081" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;System.out.println(nils.getRetweetCount(" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="1806" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602340946" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="1852" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602363998" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(ole.getRetweetCount());" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="1854" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602631815" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(nils.getRetweetCount(" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="1775" end="-135"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602646344" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(nils.getRetweetCount()" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="1742" end="-213"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602856312" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;System.out.println(kari.getTweet(1).getOwner" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="1989" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602948697" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + username" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="1516" end="-536"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487602968051" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="riginalTweet(" edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="2088" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487603944028" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="wner" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="2088" end="-82"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487603990559" sizeMeasure="86" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s = new ArrayList&lt;>();&#xA;&#x9;private ArrayList&lt;TwitterAccount> followers = new ArrayList&lt;>();&#xA;&#x9;private ArrayList&lt;Tweet> tweets = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;if (account.getUserName().equals(username)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You are not able to follow yourself, try another account.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;follows.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;follows.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return follows.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.follows" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="155" end="-1319"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="221" charEnd="230" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604015615" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;account.followers.add(this" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="653" end="-1581"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604034300" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;account.followers.remove(this" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="764" end="-1501"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604108835" sizeMeasure="90" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nils.follow(kari);&#xA;&#x9;&#x9;System.out.println(kari.isFollowedBy(nils), nils.isFollowing(kari)" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="1920" end="-380"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="79" charStart="2030" charEnd="2037" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604111867" sizeMeasure="90" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="2386" end="-2387"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="79" charStart="2030" charEnd="2037" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604126067" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot; &quot; +" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="1983" end="-403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604147113" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot; &quot; + ole.isFollowedBy(nils" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="2014" end="-381"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604308369" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getOriginalTweet()" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="1328" end="-1097"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487604332707" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="1328" end="-1097"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602255089" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602307477" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602365196" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602408957" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602410358" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602435430" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602633164" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602647947" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602768005" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602858359" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602950017" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487602969320" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487603943995" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487603946521" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487604127566" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487604129024" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487604148661" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487604310504" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487604311880" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487604312966" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487604332661" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487604333530" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487607893744" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487496499041" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487496928254" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487497775401" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487497856550" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498010692" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498349356" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498811414" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487499661257" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487500658930" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487500693468" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487500705493" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487500730313" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487500756718" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487500859786" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487501211728" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487581643492" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487582051238" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487582390861" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487582766034" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583054255" completion="0.0" errorCount="1">
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583057879" completion="1.0" successCount="1">
          <successTests>testConstructorNewTweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583063552" completion="1.0" successCount="1">
          <successTests>testConstructorNewTweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583602464" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583628640" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583717130" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583729821" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583763377" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583782006" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583950081" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487589468412" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591240620" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591585304" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591607709" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592398317" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592593642" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592621147" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601548899" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601857529" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487603443293" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487607857662" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="0.8333333333333334">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487497744249" completion="0.5" successCount="3" failureCount="2" errorCount="1">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <failureTests>testNewTweet</failureTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487497771583" completion="0.5" successCount="3" failureCount="2" errorCount="1">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <failureTests>testNewTweet</failureTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487497870410" completion="0.5" successCount="3" failureCount="2" errorCount="1">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <failureTests>testNewTweet</failureTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487497953530" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498204403" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498373788" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498561282" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498584237" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498595451" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498708350" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498719126" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498768764" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487498779401" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487499667019" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487500653884" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487500863521" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487502610489" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487580129458" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487581639538" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487582062462" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487582213169" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487582909331" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487582967742" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583067840" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487584020251" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487589447251" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487590188455" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591235687" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487591590106" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487592173345" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601544469" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601551423" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601733554" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601756155" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601757657" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601823725" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601945287" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487601989366" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602036154" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602041585" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602063991" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602095098" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602102575" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602300558" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602695710" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602710116" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487602761494" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487603082782" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487603106133" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487603113506" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487603450828" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604039753" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487604337168" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487607853521" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487607855074" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487607860371" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487607878235" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487607889320" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487607890972" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="1">
        <attempts timestamp="1487602435784"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="16">
        <attempts timestamp="1487602442227"/>
        <attempts timestamp="1487602443213"/>
        <attempts timestamp="1487602443670"/>
        <attempts timestamp="1487602444155"/>
        <attempts timestamp="1487602444619"/>
        <attempts timestamp="1487602445149"/>
        <attempts timestamp="1487602449647"/>
        <attempts timestamp="1487602450825"/>
        <attempts timestamp="1487602452297"/>
        <attempts timestamp="1487602466209"/>
        <attempts timestamp="1487602474830"/>
        <attempts timestamp="1487602476007"/>
        <attempts timestamp="1487602476798"/>
        <attempts timestamp="1487602478018"/>
        <attempts timestamp="1487602553348"/>
        <attempts timestamp="1487602555754"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="3">
        <attempts timestamp="1487602440100"/>
        <attempts timestamp="1487602452946"/>
        <attempts timestamp="1487602471688"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="3">
        <attempts timestamp="1487602455700"/>
        <attempts timestamp="1487602558235"/>
        <attempts timestamp="1487602560789"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
