<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487749470289" sizeMeasure="45">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#x9;&#xA;&#x9;private String text;&#xA;&#x9;private Tweet tweet;&#xA;&#x9;private TwitterAccount account;&#xA;&#x9;private int retweetCounter;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String message){&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;this.text = message;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet){&#xA;&#x9;&#x9;if (tweet.getOwner() == account){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot; &quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;retweetCounter++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;if(tweet.getOwner() == this.account){&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return tweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return retweetCounter;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487749837551" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweetCounter == 0){&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(tweet.getOwner() == this.account){&#xA;&#x9;&#x9;&#x9;return tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;tweet.getOriginalTweet()" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="627" end="-70"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="596" charEnd="614" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487749941435" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String message){&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;this.text = message;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet){&#xA;&#x9;&#x9;if (tweet.getOwner() == account){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot; &quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;//this.account = account;&#xA;&#x9;&#x9;retweetCounter++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;if(tweet.retweetCounter == 0){&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(tweet.getOwner() == this.account){&#xA;&#x9;&#x9;&#x9;return tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="154" end="-94"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487750871032" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="433" end="-404"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487750917308" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Argument" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="384" end="-448"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487751017727" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".equals(account)" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="350" end="-479"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487751126555" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(account);" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="330" end="-518"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487751142479" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(twee" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="361" end="-521"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487751235604" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(account.equals(null)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;this.text = message;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet){&#xA;&#x9;&#x9;System.out.println(account);&#xA;&#x9;&#x9;if(account.equals(null)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="221" end="-518"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487751942564" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(tweet.getOriginalTweet() == null){&#xA;&#x9;&#x9;&#x9;if(account.equals(tweet.getOwner())){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; &quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(account.equals(tweet.getOriginalTweet().getOwner())){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; &quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;tweet.getOriginalTweet()." edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="373" end="-378"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752192105" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;&#x9;tweet.retweetCounter++;&#xA;&#x9;&#x9;}else if(account.equals(tweet.getOriginalTweet().getOwner())){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; &quot;);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;this.tweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().retweetCounter++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="504" end="-361"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752381571" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(tweet);&#xA;&#x9;&#x9;if(tweet.getOriginalTweet() == null){&#xA;&#x9;&#x9;&#x9;if(account.equals(tweet.getOwner())){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; &quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;&#x9;tweet.retweetCounter++;&#xA;&#x9;&#x9;}else if(account.equals(tweet.getOriginalTweet().getOwner())){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; &quot;);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;this.tweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().retweetCounter++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;if(tweet.retweetCounter == 0){&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(tweet.getOwner() == this.account){&#xA;&#x9;&#x9;&#x9;return tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return tweet.getOriginalTweet();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return retweetCounter;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return (&quot;Konto:&quot; + tweet.getOwner() + &quot;text: &quot; + tweet.getText() + &quot;Original?&quot; + tweet.getOriginalTweet())" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="373" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752411810" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.getOwner() + &quot;text: &quot; + this.getText() + &quot;Original?&quot; + this" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1255" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752477558" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return tweet" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="993" end="-209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752590436" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.text = tweet.getText();" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="847" end="-370"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752946234" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" ==null" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="231" end="-1001"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753126524" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1238" end="-1239"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753221809" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1238" end="-1239"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753801022" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(tweet.getOriginalTweet() == null){&#xA;&#x9;&#x9;&#x9;if(account.equals(tweet.getOwner())){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; &quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;&#x9;tweet.retweetCounter++;&#xA;&#x9;&#x9;}else if(account.equals(tweet.getOriginalTweet().getOwner())){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; &quot;);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;this.tweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().retweetCounter++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;return tweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return retweetCounter;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return (&quot;Konto: &quot; + this.getOwner() + &quot;text: &quot; + this.getTex" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="367" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487754159931" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weet.retweetCounter++;&#xA;&#x9;&#x9;}else if(account.equals(tweet.getOriginalTweet().getOwner())){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; &quot;);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;this.tweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().retweetCounter++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.account = account" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="523" end="-332"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487329638453" sizeMeasure="21" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;&#x9;private String owner;&#xA;&#x9;private TwitterAccount account;&#xA;&#x9;private List&lt;TwitterAccount> follow;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String owner){&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;follow.add(account);&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="129" charEnd="136" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487750447082" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;&#x9;private String userName;&#xA;&#x9;private TwitterAccount account;&#xA;&#x9;private Collection&lt;TwitterAccount> followList = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private ArrayList&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;private ArrayList&lt;Tweet> retweets = new ArrayList&lt;Tweet>();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String owner){&#xA;&#x9;&#x9;this.userName = owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;if(this.followList.contains(account)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.followList.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;if(!(this.followList.contains(account))){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.followList.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;return this.followList.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String message){&#xA;&#x9;&#x9;tweets.add(new Tweet(this.account, message));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;retweets.add(new Tweet(this.account, tweet));&#xA;&#x9;}&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;return tweets.get(tweets.size() - i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return retweets.size();&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="44" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487750803571" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//private ArrayList&lt;Tweet> retweets = new ArrayList&lt;Tweet>();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String owner){&#xA;&#x9;&#x9;this.userName = owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;if(this.followList.contains(account)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.followList.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;if(!(this.followList.contains(account))){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.followList.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;return this.followList.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String message){&#xA;&#x9;&#x9;tweets.add(new Tweet(this.account, message));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;tweets.add(new Tweet(this.account, tweet));&#xA;&#x9;}&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;return tweets.get(tweets.size() - i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;int counter = 0;&#xA;&#x9;&#x9;for (Tweet tweet : tweets ){&#xA;&#x9;&#x9;&#x9;counter += tweet.getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return counter" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="317" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752658715" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public String toString(){&#xA;&#x9;&#x9;return (&quot;UserName: &quot; + account.getUserName())" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="1438" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752695733" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="317" end="-1176"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752752226" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String owner){&#xA;&#x9;&#x9;this.userName = owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;if(this.followList.contains(account)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.followList.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;if(!(this.followList.contains(account))){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.followList.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;return this.followList.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String message){&#xA;&#x9;&#x9;if(message.endsWith(suffix))" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="317" end="-501"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="981" charEnd="987" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487752786186" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!(message.isEmpty())){&#xA;&#x9;&#x9;&#x9;tweets.add(new Tweet(this.account, message));&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="964" end="-453"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753051398" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="973" end="-509"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753221814" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(tweets);" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1160" end="-333"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753290762" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweets.add(new Tweet(this.account, message));" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="961" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753296245" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="961" end="-530"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753319178" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(message);&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="961" end="-530"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753368943" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(tweets);&#xA;&#x9;&#x9;tweets.add(new Tweet(this.account, message));&#xA;&#x9;&#x9;System.out.println(tweets);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;tweets.add(new Tweet(this.account, tweet));&#xA;&#x9;}&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="992" end="-360"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753468045" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection&lt;TwitterAccount> followList = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private ArrayList&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String owner){&#xA;&#x9;&#x9;this.userName = owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;if(this.followList.contains(account)){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.followList.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;if(!(this.followList.contains(account))){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.followList.remove(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;return this.followList.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String message){&#xA;&#x9;&#x9;System.out.println(message);&#xA;&#x9;&#x9;System.out.println(tweets);&#xA;&#x9;&#x9;tweets.add(new Tweet(this, message));&#xA;&#x9;&#x9;System.out.println(tweets);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;//System.out.println(tweets);&#xA;&#x9;&#x9;return tweets.get(tweets.size() - i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;int counter = 0;&#xA;&#x9;&#x9;for (Tweet tweet : tweets ){&#xA;&#x9;&#x9;&#x9;counter += tweet.getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return counter;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return (&quot;UserName: &quot; + this" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="151" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753810830" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweets.add(new Tweet(this, message));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#x9;public Tweet getTweet(int i){" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="928" end="-330"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753834249" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="userName){&#xA;&#x9;&#x9;this.userName = userName" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="317" end="-1059"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487753997319" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="n" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1374" end="-38"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487754188083" sizeMeasure="69" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1331" end="-82"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="64" charStart="1331" charEnd="1332" severity="2" problemCategory="20" problemType="1610612971"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487754191026" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1331" end="-82"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487750406449" completion="0.25" successCount="1" failureCount="2" errorCount="1">
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testGetRetweetCount</failureTests>
          <failureTests>testConstructorRetweet</failureTests>
          <errorTests>testGetOriginalTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487751965652" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752207878" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752382392" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752416169" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752481446" completion="0.5" successCount="2" failureCount="2">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testGetOriginalTweet</failureTests>
          <failureTests>testConstructorRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752593872" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487753811418" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487750424114" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testUnfollow</errorTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487750453096" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487750886631" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487750920259" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487751018391" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487751131495" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487751148159" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487751949729" completion="0.5" successCount="3" errorCount="3">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testGetTweetIllegal</errorTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752605080" completion="0.5" successCount="3" errorCount="3">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testGetTweetIllegal</errorTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752663446" completion="0.5" successCount="3" errorCount="3">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testGetTweetIllegal</errorTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752792710" completion="0.5" successCount="3" errorCount="3">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testGetTweetIllegal</errorTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487752950355" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRetweet</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487753054480" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRetweet</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487753222287" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRetweet</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487753299554" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRetweet</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487753322777" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRetweet</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487753369438" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRetweet</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487753472491" completion="1.0" successCount="6">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
