<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487683815856" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Twitter {&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="40" charEnd="47" severity="2" problemCategory="40" problemType="16777541"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487683826038" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="eet" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="42" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487686580858" sizeMeasure="64" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;SimpleTwitterAccount owner;&#xA;&#x9;Tweet originalTweet;&#xA;&#x9;String content;&#xA;&#x9;&#xA;&#x9;private int minLength = 0;&#xA;&#x9;private int maxLength = 140;&#xA;&#x9;private boolean isRetweet;&#xA;&#x9;&#xA;&#x9;public Tweet(SimpleTwitterAccount account, String content) {&#xA;&#x9;&#x9;isRetweet = false;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (content.length() > minLength &amp;&amp; content.length() &lt; maxLength) {&#xA;&#x9;&#x9;&#x9;this.content = content;&#xA;&#x9;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error. Tweet must be longer than &quot; + minLength + &quot; and shorter than &quot; + maxLength);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(SimpleTwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;isRetweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;originalTweet = tweet;&#xA;&#x9;&#x9;owner = account;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return content;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public SimpleTwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (isRetweet) {&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="48" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="998" charEnd="1010" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487687375240" sizeMeasure="65" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount owner;&#xA;&#x9;Tweet originalTweet;&#xA;&#x9;String content;&#xA;&#x9;&#xA;&#x9;private int minLength = 0;&#xA;&#x9;private int maxLength = 140;&#xA;&#x9;private boolean isRetweet;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String content) {&#xA;&#x9;&#x9;isRetweet = false;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (content.length() > minLength &amp;&amp; content.length() &lt; maxLength) {&#xA;&#x9;&#x9;&#x9;this.content = content;&#xA;&#x9;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error. Tweet must be longer than &quot; + minLength + &quot; and shorter than &quot; + maxLength);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;isRetweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return content;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="51" end="-245"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="63" charStart="987" charEnd="999" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487688221603" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;private int minLength = 0;&#xA;&#x9;private int maxLength = 140;&#xA;&#x9;private boolean isRetweet;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String content) {&#xA;&#x9;&#x9;isRetweet = false;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (content.length() > minLength &amp;&amp; content.length() &lt; maxLength) {&#xA;&#x9;&#x9;&#x9;this.content = content;&#xA;&#x9;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error. Tweet must be longer than &quot; + minLength + &quot; and shorter than &quot; + maxLength);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;isRetweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;tweet.increaseRetweetCount();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return content;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (isRetweet) {&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;if (! isRetweet) {&#xA;&#x9;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void increaseRetweetCount() {&#xA;&#x9;&#x9;if (! isRetweet) {&#xA;&#x9;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="112" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487688846436" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.getOwner().equals(this)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot retweet your own tweet!&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="660" end="-556"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487754942793" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (tweet.getOwner().equals(this)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot retweet your own tweet!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet originalTweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (originalTweet != null) {&#xA;&#x9;&#x9;&#x9;this.originalTweet = originalTweet;&#xA;&#x9;&#x9;&#x9;this.owner = originalTweet.getOwner();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="637" end="-502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487755149187" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1505" end="-1506"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487755993563" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="isRetweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (originalTweet != null) {&#xA;&#x9;&#x9;&#x9;this.originalTweet = originalTweet;&#xA;&#x9;&#x9;&#x9;this.owner = originalTweet.getOwner();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;tweet.increaseRetweetCount();&#x9;&#x9;&#x9;&#x9;// øker retweet-counten til både tweeten og total retweetcount for eieren&#xA;&#x9;&#x9;tweet.getOwner()" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="816" end="-491"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487756202445" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getOwner()" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="675" end="-971"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487756347104" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="riginalTweet().getOwner().equals(this.getOwner())) {&#xA;&#x9;&#x9;&#x9;// sjekker om eieren til den opprinnelige tweeten er den kommende eieren til denne tweeten" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="657" end="-967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487756513690" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="690" end="-1065"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487756605060" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1530" end="-228"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487758398851" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// antar her at eieren av en tweet er den som tweetet eller retweetet den&#xA;&#x9;&#x9;this.owner = account;&#xA;&#x9;&#x9;isRetweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet originalTweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;// hvis originaltweet er null, altså hvis du ikke prøver å retweete en retweet&#xA;&#x9;&#x9;if (originalTweet == null) {&#xA;&#x9;&#x9;&#x9;if (tweet.getOwner().equals(account)) {&#xA;&#x9;&#x9;&#x9;&#x9;// sjekker om eieren til den opprinnelige tweeten er den kommende eieren til denne tweeten&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;&#x9;this.content = tweet.getText();&#xA;&#x9;&#x9;&#x9;tweet.increaseRetweetCount();&#xA;&#x9;&#x9;&#x9;tweet.getOwner().increaseRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (originalTweet.getOwner().equals(account)) {&#xA;&#x9;&#x9;&#x9;&#x9;// sjekker om eieren til den opprinnelige tweeten er den kommende eieren til denne tweeten&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.originalTweet = originalTweet;&#xA;&#x9;&#x9;&#x9;this.content = originalTweet.getText();&#xA;&#x9;&#x9;&#x9;originalTweet.increaseRetweetCount();&#xA;&#x9;&#x9;&#x9;originalTweet.getOwner().increaseRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return content;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (isRetweet) {&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return null" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="637" end="-228"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487759009167" sizeMeasure="100">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.isRetweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet originalTweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;if (originalTweet == null) {&#xA;&#x9;&#x9;&#x9;// hvis originaltweet er null, altså hvis du ikke prøver å retweete en retweet&#xA;&#x9;&#x9;&#x9;if (tweet.getOwner().equals(account)) {&#xA;&#x9;&#x9;&#x9;&#x9;// sjekker om eieren til den opprinnelige tweeten er den kommende eieren til denne tweeten&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;&#x9;this.content = tweet.getText();&#xA;&#x9;&#x9;&#x9;tweet.increaseRetweetCount();&#xA;&#x9;&#x9;&#x9;tweet.getOwner().increaseRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;// hvis originaltweet ikke er null, altså du prøver å retweete en retweet&#xA;&#x9;&#x9;&#x9;// retweet heller den originale tweeten" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="737" end="-872"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487683847059" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487688221609" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;String username;&#xA;&#x9;private List&lt;TwitterAccount> follows = new ArrayList&lt;>();&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;>();&#xA;&#x9;// kunne laget en array med hvem som følger denne&#xA;&#x9;// TODO men prøv å implementer det ved å kalle&#xA;&#x9;// isFollowing fra den andre klassen&#xA;&#x9;int tweetCount = 0;&#xA;&#x9;int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.username;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;this.follows.add(account);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;this.follows.remove(account);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return this.follows.contains(account);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public boolean isFollowdBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void tweet(String content) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, content));&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return tweets.get(i - 1);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="27" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487688847596" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int tweetCount = 0;&#xA;&#x9;private " edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="376" end="-905"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487689297083" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (! account.equals(this)) {&#xA;&#x9;&#x9;&#x9;this.follows.add(account);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (this.isFollowing(account)) {&#xA;&#x9;&#x9;&#x9;this.follows.remove(account);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return this.follows.contains(account);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void tweet(String content) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, content));&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;tweets.add(new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;return tweets.get(i - 1);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount account = new TwitterAccount(&quot;strandlie&quot;);&#xA;&#x9;&#x9;TwitterAccount account2 = new TwitterAccount(&quot;stangjordet&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;account.tweet(&quot;Ojsann, for en forelesning!&quot;);&#xA;&#x9;&#x9;account.getTweet(1);&#xA;&#x9;&#x9;account2.follow(account);&#xA;&#x9;&#x9;System.out.println(account.isFollowedBy(account2));&#xA;&#x9;&#x9;System.out.println(account2.isFollowing(account));&#xA;&#x9;&#x9;account.follow(account2);&#xA;&#x9;&#x9;account2.tweet(&quot;Flaut!&quot;);&#xA;&#x9;&#x9;account.retweet(account2.getTweet(1));&#xA;&#x9;&#x9;System.out.println(account.getTweet(1))" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="629" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487689326937" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getText(" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1906" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487755150247" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.retweet(account.getTweet(1));&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1620" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487755184677" sizeMeasure="99">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.retweet(account2" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1654" end="-30"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487755317262" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="239" end="-1334"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487755558050" sizeMeasure="97" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int tweetCount = 0;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.username;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if (! account.equals(this)) {&#xA;&#x9;&#x9;&#x9;this.follows.add(account);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (this.isFollowing(account)) {&#xA;&#x9;&#x9;&#x9;this.follows.remove(account);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return this.follows.contains(account);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void tweet(String content) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, content));&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;this.tweetCount++" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="239" end="-522"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="81" charStart="1258" charEnd="1270" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487755994586" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.username;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account) {&#xA;&#x9;&#x9;if (! account.equals(this)) {&#xA;&#x9;&#x9;&#x9;this.follows.add(account);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;if (this.isFollowing(account)) {&#xA;&#x9;&#x9;&#x9;this.follows.remove(account);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;return this.follows.contains(account);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void tweet(String content) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, content));&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, tweet));&#xA;&#x9;&#x9;this.tweetCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void increaseRetweetCount() {&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="268" end="-517"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487758399853" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1692" end="-1693"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487759009177" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1376" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487763425463" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweets.size() - 1);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweetCount;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1233" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487763647825" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int tweetIndex = tweets.size() - 1;&#xA;&#x9;&#x9;if (tweetIndex &lt; tweets.size() &amp;&amp; tweetIndex > 0) {&#xA;&#x9;&#x9;&#x9;return tweets.get(tweets.size() - 1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IndexOutOfBoundsException(&quot;This is not an index of a tweet in this account&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1215" end="-139"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487763743257" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1299" end="-296"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487763820675" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Index" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1332" end="-252"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487764096059" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1588" end="-1589"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487764298043" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.tweets.size() - 1;&#xA;&#x9;&#x9;if (tweetIndex &lt; this." edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1233" end="-319"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487689295995" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487689325490" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487755148182" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487755184182" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487755196362" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487755316468" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487755353749" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487755557058" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487755637841" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487755992506" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487756201512" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487756227086" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487756346181" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487756376817" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487756405002" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487756512824" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487756604202" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487758397117" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487758432789" mode="debug"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487688224277" completion="0.5" successCount="2" failureCount="2">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testGetOriginalTweet</failureTests>
          <failureTests>testConstructorRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487688596312" completion="0.5" successCount="2" failureCount="2">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testGetOriginalTweet</failureTests>
          <failureTests>testConstructorRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487688849447" completion="0.5" successCount="2" failureCount="2">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testGetOriginalTweet</failureTests>
          <failureTests>testConstructorRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487689343441" completion="0.5" successCount="2" failureCount="2">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testGetOriginalTweet</failureTests>
          <failureTests>testConstructorRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487754944238" completion="0.5" successCount="2" failureCount="2">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testGetOriginalTweet</failureTests>
          <failureTests>testConstructorRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487758629269" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487762208239" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="0.6666666666666666">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487762307187" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487762704852" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487763427236" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487763649628" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487763744973" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487763833800" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a" performedCount="7">
        <attempts timestamp="1487688355267"/>
        <attempts timestamp="1487688429291"/>
        <attempts timestamp="1487756354361"/>
        <attempts timestamp="1487756459813"/>
        <attempts timestamp="1487756546567"/>
        <attempts timestamp="1487758409631"/>
        <attempts timestamp="1487758618046"/>
      </proposals>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="16">
        <attempts timestamp="1487688652904"/>
        <attempts timestamp="1487688685892"/>
        <attempts timestamp="1487688689638"/>
        <attempts timestamp="1487688691799"/>
        <attempts timestamp="1487688693792"/>
        <attempts timestamp="1487688695463"/>
        <attempts timestamp="1487688697039"/>
        <attempts timestamp="1487688699404"/>
        <attempts timestamp="1487688701145"/>
        <attempts timestamp="1487755206018"/>
        <attempts timestamp="1487755219879"/>
        <attempts timestamp="1487755229824"/>
        <attempts timestamp="1487755322685"/>
        <attempts timestamp="1487755359824"/>
        <attempts timestamp="1487755561927"/>
        <attempts timestamp="1487755643454"/>
        <attempts timestamp="1487755999680"/>
        <attempts timestamp="1487756206036"/>
        <attempts timestamp="1487756231868"/>
        <attempts timestamp="1487756350686"/>
        <attempts timestamp="1487756410066"/>
        <attempts timestamp="1487756518983"/>
        <attempts timestamp="1487756609475"/>
        <attempts timestamp="1487758447278"/>
        <attempts timestamp="1487762475049"/>
        <attempts timestamp="1487762502845"/>
        <attempts timestamp="1487762518462"/>
        <attempts timestamp="1487762528157"/>
        <attempts timestamp="1487762555467"/>
        <attempts timestamp="1487762590669"/>
        <attempts timestamp="1487762615510"/>
        <attempts timestamp="1487762633547"/>
        <attempts timestamp="1487762658444"/>
        <attempts timestamp="1487762673383"/>
        <attempts timestamp="1487762683772"/>
        <attempts timestamp="1487762694047"/>
        <attempts timestamp="1487762697463"/>
        <attempts timestamp="1487762698574"/>
        <attempts timestamp="1487762700351"/>
        <attempts timestamp="1487762947803"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="111">
        <attempts timestamp="1487688383552"/>
        <attempts timestamp="1487688388965"/>
        <attempts timestamp="1487688390716"/>
        <attempts timestamp="1487688391736"/>
        <attempts timestamp="1487688392540"/>
        <attempts timestamp="1487688395749"/>
        <attempts timestamp="1487688399758"/>
        <attempts timestamp="1487688410616"/>
        <attempts timestamp="1487688414210"/>
        <attempts timestamp="1487688417570"/>
        <attempts timestamp="1487688425274"/>
        <attempts timestamp="1487688427487"/>
        <attempts timestamp="1487688429289"/>
        <attempts timestamp="1487688429939"/>
        <attempts timestamp="1487688486781"/>
        <attempts timestamp="1487688491651"/>
        <attempts timestamp="1487688494802"/>
        <attempts timestamp="1487688499654"/>
        <attempts timestamp="1487688501198"/>
        <attempts timestamp="1487688505600"/>
        <attempts timestamp="1487688511070"/>
        <attempts timestamp="1487688513279"/>
        <attempts timestamp="1487688517498"/>
        <attempts timestamp="1487688520870"/>
        <attempts timestamp="1487688522248"/>
        <attempts timestamp="1487688523593"/>
        <attempts timestamp="1487688524520"/>
        <attempts timestamp="1487688525423"/>
        <attempts timestamp="1487688561344"/>
        <attempts timestamp="1487688562674"/>
        <attempts timestamp="1487688563790"/>
        <attempts timestamp="1487688565991"/>
        <attempts timestamp="1487688567400"/>
        <attempts timestamp="1487688569023"/>
        <attempts timestamp="1487688572146"/>
        <attempts timestamp="1487688573777"/>
        <attempts timestamp="1487688574584"/>
        <attempts timestamp="1487688580942"/>
        <attempts timestamp="1487688582502"/>
        <attempts timestamp="1487688583043"/>
        <attempts timestamp="1487688583630"/>
        <attempts timestamp="1487688584244"/>
        <attempts timestamp="1487688584988"/>
        <attempts timestamp="1487688586198"/>
        <attempts timestamp="1487688586910"/>
        <attempts timestamp="1487688587489"/>
        <attempts timestamp="1487688588028"/>
        <attempts timestamp="1487688588534"/>
        <attempts timestamp="1487688589041"/>
        <attempts timestamp="1487688589484"/>
        <attempts timestamp="1487688589998"/>
        <attempts timestamp="1487688590821"/>
        <attempts timestamp="1487688591351"/>
        <attempts timestamp="1487688591973"/>
        <attempts timestamp="1487688592527"/>
        <attempts timestamp="1487688593758"/>
        <attempts timestamp="1487688594399"/>
        <attempts timestamp="1487688673063"/>
        <attempts timestamp="1487688675954"/>
        <attempts timestamp="1487688676984"/>
        <attempts timestamp="1487688678489"/>
        <attempts timestamp="1487688679920"/>
        <attempts timestamp="1487688680802"/>
        <attempts timestamp="1487688681869"/>
        <attempts timestamp="1487755206015"/>
        <attempts timestamp="1487755211434"/>
        <attempts timestamp="1487755212423"/>
        <attempts timestamp="1487755213114"/>
        <attempts timestamp="1487755213762"/>
        <attempts timestamp="1487755214544"/>
        <attempts timestamp="1487755215176"/>
        <attempts timestamp="1487755215932"/>
        <attempts timestamp="1487755218152"/>
        <attempts timestamp="1487755219877"/>
        <attempts timestamp="1487755220742"/>
        <attempts timestamp="1487755221319"/>
        <attempts timestamp="1487755221861"/>
        <attempts timestamp="1487755222331"/>
        <attempts timestamp="1487755223262"/>
        <attempts timestamp="1487755223845"/>
        <attempts timestamp="1487755224500"/>
        <attempts timestamp="1487755226465"/>
        <attempts timestamp="1487755229822"/>
        <attempts timestamp="1487755248418"/>
        <attempts timestamp="1487755252606"/>
        <attempts timestamp="1487755340488"/>
        <attempts timestamp="1487755439263"/>
        <attempts timestamp="1487755467495"/>
        <attempts timestamp="1487755577819"/>
        <attempts timestamp="1487755582863"/>
        <attempts timestamp="1487755587917"/>
        <attempts timestamp="1487755605141"/>
        <attempts timestamp="1487755645276"/>
        <attempts timestamp="1487755647534"/>
        <attempts timestamp="1487755659303"/>
        <attempts timestamp="1487755680189"/>
        <attempts timestamp="1487755683190"/>
        <attempts timestamp="1487755686849"/>
        <attempts timestamp="1487755688282"/>
        <attempts timestamp="1487755694854"/>
        <attempts timestamp="1487755732196"/>
        <attempts timestamp="1487755733400"/>
        <attempts timestamp="1487755741781"/>
        <attempts timestamp="1487755746856"/>
        <attempts timestamp="1487756003984"/>
        <attempts timestamp="1487756009829"/>
        <attempts timestamp="1487756020829"/>
        <attempts timestamp="1487756034049"/>
        <attempts timestamp="1487756034823"/>
        <attempts timestamp="1487756035381"/>
        <attempts timestamp="1487756043544"/>
        <attempts timestamp="1487756045358"/>
        <attempts timestamp="1487756046918"/>
        <attempts timestamp="1487756048801"/>
        <attempts timestamp="1487756056836"/>
        <attempts timestamp="1487756059904"/>
        <attempts timestamp="1487756065739"/>
        <attempts timestamp="1487756067584"/>
        <attempts timestamp="1487756087799"/>
        <attempts timestamp="1487756090135"/>
        <attempts timestamp="1487756096708"/>
        <attempts timestamp="1487756098283"/>
        <attempts timestamp="1487756114059"/>
        <attempts timestamp="1487756131009"/>
        <attempts timestamp="1487756147120"/>
        <attempts timestamp="1487756148697"/>
        <attempts timestamp="1487756149237"/>
        <attempts timestamp="1487756149828"/>
        <attempts timestamp="1487756151635"/>
        <attempts timestamp="1487756208478"/>
        <attempts timestamp="1487756210068"/>
        <attempts timestamp="1487756211117"/>
        <attempts timestamp="1487756214066"/>
        <attempts timestamp="1487756218527"/>
        <attempts timestamp="1487756233952"/>
        <attempts timestamp="1487756234777"/>
        <attempts timestamp="1487756235915"/>
        <attempts timestamp="1487756238595"/>
        <attempts timestamp="1487756243491"/>
        <attempts timestamp="1487756244971"/>
        <attempts timestamp="1487756245630"/>
        <attempts timestamp="1487756246567"/>
        <attempts timestamp="1487756352750"/>
        <attempts timestamp="1487756353479"/>
        <attempts timestamp="1487756354357"/>
        <attempts timestamp="1487756360711"/>
        <attempts timestamp="1487756361758"/>
        <attempts timestamp="1487756413408"/>
        <attempts timestamp="1487756416021"/>
        <attempts timestamp="1487756421657"/>
        <attempts timestamp="1487756437358"/>
        <attempts timestamp="1487756438592"/>
        <attempts timestamp="1487756439114"/>
        <attempts timestamp="1487756439549"/>
        <attempts timestamp="1487756459810"/>
        <attempts timestamp="1487756463514"/>
        <attempts timestamp="1487756522508"/>
        <attempts timestamp="1487756524131"/>
        <attempts timestamp="1487756527349"/>
        <attempts timestamp="1487756540361"/>
        <attempts timestamp="1487756541568"/>
        <attempts timestamp="1487756542080"/>
        <attempts timestamp="1487756542784"/>
        <attempts timestamp="1487756546564"/>
        <attempts timestamp="1487756611230"/>
        <attempts timestamp="1487756612580"/>
        <attempts timestamp="1487756617090"/>
        <attempts timestamp="1487756623467"/>
        <attempts timestamp="1487756624094"/>
        <attempts timestamp="1487756624551"/>
        <attempts timestamp="1487756625565"/>
        <attempts timestamp="1487756631114"/>
        <attempts timestamp="1487756642640"/>
        <attempts timestamp="1487756650526"/>
        <attempts timestamp="1487756652560"/>
        <attempts timestamp="1487756659741"/>
        <attempts timestamp="1487756661237"/>
        <attempts timestamp="1487758415594"/>
        <attempts timestamp="1487758457458"/>
        <attempts timestamp="1487758463442"/>
        <attempts timestamp="1487758464219"/>
        <attempts timestamp="1487758464767"/>
        <attempts timestamp="1487758465362"/>
        <attempts timestamp="1487758468374"/>
        <attempts timestamp="1487758520345"/>
        <attempts timestamp="1487758522009"/>
        <attempts timestamp="1487758531560"/>
        <attempts timestamp="1487758532812"/>
        <attempts timestamp="1487758537783"/>
        <attempts timestamp="1487758539046"/>
        <attempts timestamp="1487758543600"/>
        <attempts timestamp="1487758553551"/>
        <attempts timestamp="1487758566060"/>
        <attempts timestamp="1487758567268"/>
        <attempts timestamp="1487758571792"/>
        <attempts timestamp="1487758575192"/>
        <attempts timestamp="1487758576174"/>
        <attempts timestamp="1487758581743"/>
        <attempts timestamp="1487758585609"/>
        <attempts timestamp="1487758586277"/>
        <attempts timestamp="1487758586893"/>
        <attempts timestamp="1487758592810"/>
        <attempts timestamp="1487758596947"/>
        <attempts timestamp="1487758598728"/>
        <attempts timestamp="1487758610881"/>
        <attempts timestamp="1487758614376"/>
        <attempts timestamp="1487758616491"/>
        <attempts timestamp="1487758618043"/>
        <attempts timestamp="1487762469322"/>
        <attempts timestamp="1487762470521"/>
        <attempts timestamp="1487762471721"/>
        <attempts timestamp="1487762472432"/>
        <attempts timestamp="1487762473278"/>
        <attempts timestamp="1487762475046"/>
        <attempts timestamp="1487762483796"/>
        <attempts timestamp="1487762501293"/>
        <attempts timestamp="1487762502843"/>
        <attempts timestamp="1487762510661"/>
        <attempts timestamp="1487762515807"/>
        <attempts timestamp="1487762516732"/>
        <attempts timestamp="1487762517470"/>
        <attempts timestamp="1487762518460"/>
        <attempts timestamp="1487762519927"/>
        <attempts timestamp="1487762526930"/>
        <attempts timestamp="1487762528154"/>
        <attempts timestamp="1487762529565"/>
        <attempts timestamp="1487762535403"/>
        <attempts timestamp="1487762536401"/>
        <attempts timestamp="1487762538136"/>
        <attempts timestamp="1487762539036"/>
        <attempts timestamp="1487762540650"/>
        <attempts timestamp="1487762542012"/>
        <attempts timestamp="1487762543975"/>
        <attempts timestamp="1487762545296"/>
        <attempts timestamp="1487762546375"/>
        <attempts timestamp="1487762547121"/>
        <attempts timestamp="1487762547908"/>
        <attempts timestamp="1487762548467"/>
        <attempts timestamp="1487762549409"/>
        <attempts timestamp="1487762551143"/>
        <attempts timestamp="1487762552083"/>
        <attempts timestamp="1487762552781"/>
        <attempts timestamp="1487762553632"/>
        <attempts timestamp="1487762554476"/>
        <attempts timestamp="1487762564490"/>
        <attempts timestamp="1487762570025"/>
        <attempts timestamp="1487762576346"/>
        <attempts timestamp="1487762579460"/>
        <attempts timestamp="1487762580530"/>
        <attempts timestamp="1487762582484"/>
        <attempts timestamp="1487762590667"/>
        <attempts timestamp="1487762592517"/>
        <attempts timestamp="1487762610196"/>
        <attempts timestamp="1487762611154"/>
        <attempts timestamp="1487762612394"/>
        <attempts timestamp="1487762614105"/>
        <attempts timestamp="1487762615508"/>
        <attempts timestamp="1487762617212"/>
        <attempts timestamp="1487762620553"/>
        <attempts timestamp="1487762624503"/>
        <attempts timestamp="1487762626140"/>
        <attempts timestamp="1487762633544"/>
        <attempts timestamp="1487762634299"/>
        <attempts timestamp="1487762657501"/>
        <attempts timestamp="1487762658442"/>
        <attempts timestamp="1487762660046"/>
        <attempts timestamp="1487762664695"/>
        <attempts timestamp="1487762665422"/>
        <attempts timestamp="1487762666194"/>
        <attempts timestamp="1487762667201"/>
        <attempts timestamp="1487762668499"/>
        <attempts timestamp="1487762673381"/>
        <attempts timestamp="1487762674002"/>
        <attempts timestamp="1487762676901"/>
        <attempts timestamp="1487762677752"/>
        <attempts timestamp="1487762679699"/>
        <attempts timestamp="1487762681540"/>
        <attempts timestamp="1487762991930"/>
        <attempts timestamp="1487763013043"/>
        <attempts timestamp="1487763015511"/>
        <attempts timestamp="1487763058622"/>
        <attempts timestamp="1487763060367"/>
        <attempts timestamp="1487763066563"/>
        <attempts timestamp="1487763067991"/>
        <attempts timestamp="1487763068932"/>
        <attempts timestamp="1487763070124"/>
        <attempts timestamp="1487763070879"/>
        <attempts timestamp="1487763071998"/>
        <attempts timestamp="1487763073992"/>
        <attempts timestamp="1487763075169"/>
        <attempts timestamp="1487763075825"/>
        <attempts timestamp="1487763077026"/>
        <attempts timestamp="1487763078218"/>
        <attempts timestamp="1487763273477"/>
        <attempts timestamp="1487763274227"/>
        <attempts timestamp="1487763275213"/>
        <attempts timestamp="1487764120347"/>
        <attempts timestamp="1487764129639"/>
        <attempts timestamp="1487764132797"/>
        <attempts timestamp="1487764138077"/>
        <attempts timestamp="1487764145393"/>
        <attempts timestamp="1487764153690"/>
        <attempts timestamp="1487764174024"/>
        <attempts timestamp="1487764178153"/>
        <attempts timestamp="1487764181470"/>
        <attempts timestamp="1487764199326"/>
        <attempts timestamp="1487764200258"/>
        <attempts timestamp="1487764201134"/>
        <attempts timestamp="1487764201965"/>
        <attempts timestamp="1487764202918"/>
        <attempts timestamp="1487764204094"/>
        <attempts timestamp="1487764240338"/>
        <attempts timestamp="1487764306236"/>
        <attempts timestamp="1487764306897"/>
        <attempts timestamp="1487764307610"/>
        <attempts timestamp="1487764308371"/>
        <attempts timestamp="1487764309196"/>
        <attempts timestamp="1487764310589"/>
        <attempts timestamp="1487764328450"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="6">
        <attempts timestamp="1487688474026"/>
        <attempts timestamp="1487688542469"/>
        <attempts timestamp="1487755363649"/>
        <attempts timestamp="1487755579830"/>
        <attempts timestamp="1487755649991"/>
        <attempts timestamp="1487755663974"/>
        <attempts timestamp="1487755677643"/>
        <attempts timestamp="1487756017999"/>
        <attempts timestamp="1487756021958"/>
        <attempts timestamp="1487756032026"/>
        <attempts timestamp="1487756128711"/>
        <attempts timestamp="1487756132229"/>
        <attempts timestamp="1487756139894"/>
        <attempts timestamp="1487756212851"/>
        <attempts timestamp="1487756216247"/>
        <attempts timestamp="1487756237174"/>
        <attempts timestamp="1487756240027"/>
        <attempts timestamp="1487756241737"/>
        <attempts timestamp="1487756418614"/>
        <attempts timestamp="1487756425694"/>
        <attempts timestamp="1487756434421"/>
        <attempts timestamp="1487756525607"/>
        <attempts timestamp="1487756528394"/>
        <attempts timestamp="1487756531177"/>
        <attempts timestamp="1487756614148"/>
        <attempts timestamp="1487756618186"/>
        <attempts timestamp="1487756621626"/>
        <attempts timestamp="1487758454176"/>
        <attempts timestamp="1487758458354"/>
        <attempts timestamp="1487758461515"/>
        <attempts timestamp="1487758580017"/>
        <attempts timestamp="1487758582780"/>
        <attempts timestamp="1487758584043"/>
        <attempts timestamp="1487763278003"/>
        <attempts timestamp="1487763280274"/>
        <attempts timestamp="1487764226308"/>
        <attempts timestamp="1487764236640"/>
        <attempts timestamp="1487764312787"/>
        <attempts timestamp="1487764315476"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="4">
        <attempts timestamp="1487688372064"/>
        <attempts timestamp="1487688529657"/>
        <attempts timestamp="1487755231957"/>
        <attempts timestamp="1487755326598"/>
        <attempts timestamp="1487755443653"/>
        <attempts timestamp="1487755598968"/>
        <attempts timestamp="1487755667566"/>
        <attempts timestamp="1487756011450"/>
        <attempts timestamp="1487756250637"/>
        <attempts timestamp="1487756535093"/>
        <attempts timestamp="1487756665102"/>
        <attempts timestamp="1487758470202"/>
        <attempts timestamp="1487762966826"/>
        <attempts timestamp="1487763288292"/>
        <attempts timestamp="1487764106436"/>
        <attempts timestamp="1487764210978"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
