<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488200160797" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Person {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203146172" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class Person {&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#x9;private ArrayList&lt;Person> children = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;Person(String name, char gender){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;if(gender == 'M' || gender == 'F'){&#xA;&#x9;&#x9;&#x9;this.gender = gender;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kjønn må enten være M eller F&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return this.gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return this.father;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getChildCount(){&#xA;&#x9;&#x9;return this.children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;//1-indekserer&#xA;&#x9;&#x9;if(n - 1 > this.getChildCount() || n - 1 &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Barn out of range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this.children.get(n-1);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addChild(Person child){&#xA;&#x9;&#x9;if(child.getMother() == this || child.getFather() == this){&#xA;&#x9;&#x9;&#x9;if(child.isChildOf(this) == 1){&#xA;&#x9;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.children.add(child);&#xA;&#x9;&#x9;if(this.getGender() == 'M'){&#xA;&#x9;&#x9;&#x9;child.setFather(this);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;child.setMother(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeChild(Person child){&#xA;&#x9;&#x9;int j;&#xA;&#x9;&#x9;for(j = 0; j &lt; this.getChildCount(); j++){&#xA;&#x9;&#x9;&#x9;if(this.getChild(j+1) == child){&#xA;&#x9;&#x9;&#x9;&#x9;this.children.remove(j);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setMother(Person mom){&#xA;&#x9;&#x9;this.mother = mom;&#xA;&#x9;&#x9;mom.addChild(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int isChildOf(Person mom){&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; mom.getChildCount(); i++){&#xA;&#x9;&#x9;&#x9;if(mom.getChild(i+1) == this){&#xA;&#x9;&#x9;&#x9;&#x9;count ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(count == 0){&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFather(Person dad){&#xA;&#x9;&#x9;this.father = dad;&#xA;&#x9;&#x9;dad.addChild(this);&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="27" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203650697" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;Name: &quot; + this.getName() + '\n' + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;gender: &quot; + this.getGender() + '\n'+&#xA;&#x9;&#x9;&#x9;&#x9;&quot;with &quot; + this.getChildCount() + &quot; Children&quot;; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person Homer = new Person(&quot;Homer&quot;, 'M');&#xA;&#x9;&#x9;Person Marge = new Person(&quot;Marge&quot;, 'F');&#xA;&#x9;&#x9;Person Bart = new Person(&quot;Bart&quot;, 'M');&#xA;&#x9;&#x9;Person Lisa = new Person(&quot;Lisa&quot;, 'F');&#xA;&#x9;&#x9;Person Maggie = new Person(&quot;Maggie&quot;, 'F');&#xA;&#x9;&#x9;Homer.addChild(Bart);&#xA;&#x9;&#x9;Homer.addChild(Lisa);&#xA;&#x9;&#x9;Homer.addChild(Maggie);&#xA;&#x9;&#x9;Marge.addChild(Bart);&#xA;&#x9;&#x9;Marge.addChild(Lisa);&#xA;&#x9;&#x9;Marge.addChild(Maggie);&#xA;&#x9;&#x9;System.out.println(Homer.getChild(1));" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1753" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203664067" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="2354" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203689857" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getChild(3)" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="2354" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203700415" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Marge" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="2349" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203803560" sizeMeasure="118">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="father &quot; + this.getFather() + '\n' +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;mother &quot; + this.getMother() + '\n' +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;with &quot; + this.getChildCount() + &quot; Children&quot;;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1874" end="-456"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203863413" sizeMeasure="118">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + '\n'" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="2001" end="-457"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203921175" sizeMeasure="118">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getName() + '\n' +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;mother &quot; + this.getMother().getName" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1901" end="-524"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488203958180" sizeMeasure="118">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=": &quot; + this.getFather().getName() + '\n' +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;mother:" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1880" end="-553"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204176918" sizeMeasure="122">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(this != mom){&#xA;&#x9;&#x9;&#x9;this.mother = mom;&#xA;&#x9;&#x9;&#x9;mom.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int isChildOf(Person mom){&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; mom.getChildCount(); i++){&#xA;&#x9;&#x9;&#x9;if(mom.getChild(i+1) == this){&#xA;&#x9;&#x9;&#x9;&#x9;count ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(count == 0){&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFather(Person dad){&#xA;&#x9;&#x9;if(this != dad){&#xA;&#x9;&#x9;&#x9;this.father = dad;&#xA;&#x9;&#x9;&#x9;dad.addChild(this);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1411" end="-740"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204219056" sizeMeasure="124">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int isChildOf(Person mom){&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; mom.getChildCount(); i++){&#xA;&#x9;&#x9;&#x9;if(mom.getChild(i+1) == this){&#xA;&#x9;&#x9;&#x9;&#x9;count ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(count == 0){&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFather(Person dad){&#xA;&#x9;&#x9;if(this != dad){&#xA;&#x9;&#x9;&#x9;this.father = dad;&#xA;&#x9;&#x9;&#x9;dad.addChild(this);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;&#x9;return;" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1478" end="-738"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204346161" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=");&#xA;&#x9;&#x9;System.out.println(Homer);&#xA;&#x9;&#x9;System.out.println(Bart);&#xA;&#x9;&#x9;System.out.println(Lisa);&#xA;&#x9;&#x9;System.out.println(Maggie" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="2535" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204468786" sizeMeasure="134">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(mother == null){&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this.mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;if(father == null){&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="571" end="-2036"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204891304" sizeMeasure="146">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String name, father, mother;&#xA;&#x9;&#x9;char gender;&#xA;&#x9;&#x9;name = this.getName();&#xA;&#x9;&#x9;if(this.getFather() == null){&#xA;&#x9;&#x9;&#x9;father = &quot;unknown&quot;;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;father = this.getFather().getName();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(this.getMother() == null){&#xA;&#x9;&#x9;&#x9;mother = &quot;unknown&quot;;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;mother = this.getMother().getName();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return &quot;name: &quot; + name + '\n' +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;father: &quot; + father + '\n' +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;mother: &quot; + mother + '\n' +&#xA;&#x9;&#x9;&#x9;&#x9;&quot;childre: &quot; + this.getChildCount()" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1937" end="-560"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488204907762" sizeMeasure="146" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + '\n'" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="2360" end="-560"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488205644843" sizeMeasure="146" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="> this.getChildCount() || n  &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Barn out of range&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this.children.get(n);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addChild(Person child){&#xA;&#x9;&#x9;if(child.getMother() == this || child.getFather() == this){&#xA;&#x9;&#x9;&#x9;if(child.isChildOf(this) == 1){&#xA;&#x9;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.children.add(child);&#xA;&#x9;&#x9;if(this.getGender() == 'M'){&#xA;&#x9;&#x9;&#x9;child.setFather(this);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;child.setMother(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeChild(Person child){&#xA;&#x9;&#x9;int j;&#xA;&#x9;&#x9;for(j = 0; j &lt; this.getChildCount(); j++){&#xA;&#x9;&#x9;&#x9;if(this.getChild(j) == child){&#xA;&#x9;&#x9;&#x9;&#x9;this.children.remove(j);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setMother(Person mom){&#xA;&#x9;&#x9;if(this != mom){&#xA;&#x9;&#x9;&#x9;this.mother = mom;&#xA;&#x9;&#x9;&#x9;mom.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int isChildOf(Person mom){&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; mom.getChildCount(); i++){&#xA;&#x9;&#x9;&#x9;if(mom.getChild(i" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="856" end="-1229"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203649978" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203663132" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203689077" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203699673" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203801487" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203821794" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203862750" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488203920481" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488204345434" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488204468119" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488204888738" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488204907090" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488206129750" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488267982768" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="0.38461538461538464">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488203148344" completion="0.07692307692307693" successCount="1" failureCount="4" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488203960214" completion="0.07692307692307693" successCount="1" failureCount="4" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488204178059" completion="0.07692307692307693" successCount="1" failureCount="4" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488204221189" completion="0.07692307692307693" successCount="1" failureCount="4" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488204944719" completion="0.07692307692307693" successCount="1" failureCount="4" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488205654972" completion="0.38461538461538464" successCount="5" failureCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488206123411" completion="0.38461538461538464" successCount="5" failureCount="8"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
