<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487834237752" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487837467642" sizeMeasure="63" errorCount="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private TwitterAccount tweeter;&#xA;&#x9;private TwitterAccount owner;&#xA;&#x9;private Tweet OGtweet;&#xA;&#x9;private String text;&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;private boolean retweet;&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount owner, String text){&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.tweeter = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount retweeter, Tweet tweet){&#xA;&#x9;&#x9;this.tweeter = retweeter;&#xA;&#x9;&#x9;this.retweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;while(retweet){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(isRetweet(tweet)){&#xA;&#x9;&#x9;&#x9;&#x9;tweet = this;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet = this;&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet.retweetCount++;&#xA;&#x9;&#x9;&#x9;&#x9;this.text = tweet.text;&#xA;&#x9;&#x9;&#x9;&#x9;this.owner = tweet.owner;&#xA;&#x9;&#x9;&#x9;&#x9;retweet = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isRetweet(Tweet tweet){&#xA;&#x9;&#x9;if(tweet.text == null){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;if(isRetweet(this)){&#xA;&#x9;&#x9;&#x9;return OGtweet;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="48" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487839453881" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1038" end="-1039"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487839899635" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;Tweet [owner=%s, OGtweet=%s, text=%s, retweetCount=%s]&quot;, owner, OGtweet, text,&#xA;&#x9;&#x9;&#x9;&#x9;retweetCount);&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Henrik = new TwitterAccount(&quot;henrik&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount(&quot;per&quot;);&#xA;&#x9;&#x9;TwitterAccount Pal = new TwitterAccount(&quot;pal&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet en = new Tweet(Henrik,&quot;Hei&quot;);&#xA;&#x9;&#x9;Tweet to = new Tweet(Per, en);&#xA;&#x9;&#x9;Tweet tre = new Tweet(Pal, to);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(en.toString());&#xA;&#x9;&#x9;System.out.println(to.toString());&#xA;&#x9;&#x9;System.out.println(tre.toString())" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1036" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840009981" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="owner;&#xA;&#x9;private Tweet OGtweet;&#xA;&#x9;private String text;&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;private boolean retweet;&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount owner, String text){&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.tweeter = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount retweeter, Tweet tweet){&#xA;&#x9;&#x9;this.own" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="74" end="-1238"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840031762" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="259" end="-1332"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840201663" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="xt = text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount retweeter, Tweet tweet){&#xA;&#x9;&#x9;this.owner = retweeter;&#xA;&#x9;&#x9;this.retweet = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;while(retweet){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(isRetweet(tweet)){&#xA;&#x9;&#x9;&#x9;&#x9;tweet = this;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet = this;&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet.retweetCount++;&#xA;&#x9;&#x9;&#x9;&#x9;this.text = tweet.text;&#xA;&#x9;&#x9;&#x9;&#x9;this.owner = tweet.owner;&#xA;&#x9;&#x9;&#x9;&#x9;retweet = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isRetweet(Tweet tweet){&#xA;&#x9;&#x9;if(tweet.text == null){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return OGtweet." edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="260" end="-773"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840322766" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".toString()" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1112" end="-467"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840367358" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1474" end="-116"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840472006" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".owner, text,&#xA;&#x9;&#x9;&#x9;&#x9;retweetCount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Henrik = new TwitterAccount(&quot;henrik&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount(&quot;per&quot;);&#xA;&#x9;&#x9;TwitterAccount Pal = new TwitterAccount(&quot;pal&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet en = new Tweet(Henrik,&quot;Hei&quot;);&#xA;&#x9;&#x9;Tweet to = new Tweet(Per, en);&#xA;&#x9;&#x9;Tweet tre = new Tweet(Pal, to);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1132" end="-116"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840683451" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String OGeier;&#xA;&#x9;&#x9;if(getOriginalTweet()!=null){&#xA;&#x9;&#x9;&#x9;OGeier = OGtweet.owner.toString();&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;OGeier = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return String.format(&quot;Tweet [owner=%s, OGtweet=%s, text=%s, retweetCount=%s]&quot;, owner.toString(), OGei" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1028" end="-464"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840758571" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="530" end="-1157"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487841075931" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isRetweet(Tweet tweet){&#xA;&#x9;&#x9;if(retweet" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="530" end="-1057"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487841159239" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet." edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="606" end="-1064"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487841452867" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.retweet" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="403" end="-1257"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487842632046" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weet" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="462" end="-1208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487843080053" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="searching;&#xA;&#x9;private boolean retweet;&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount owner, String text){&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;this.retweet = false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount retweeter, Tweet tweet){&#xA;&#x9;&#x9;this.owner = retweeter;&#xA;&#x9;&#x9;this.retweet = true;&#xA;&#x9;&#x9;this.searching = true;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;while(searching" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="175" end="-1284"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487843105893" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="searching" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="607" end="-1139"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878585233" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String text;&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;private boolean retweet;&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount owner, String text){&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;retweet = false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Tweet OGtweet;&#xA;&#x9;private Tweet next;&#xA;&#x9;private TwitterAccount tweeter;&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount retweeter, Tweet tweet){&#xA;&#x9;&#x9;retweet = true;&#xA;&#x9;&#x9;this.owner = retweeter;&#xA;&#x9;&#x9;this.next = tweet;&#xA;&#x9;&#x9;boolean searching = true;&#xA;&#x9;&#x9;int depth = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;while(searching){&#xA;&#x9;&#x9;&#x9;if(tweet.retweet){&#xA;&#x9;&#x9;&#x9;&#x9;tweet = tweet.next;&#xA;&#x9;&#x9;&#x9;&#x9;depth++;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet = tweet;&#xA;&#x9;&#x9;&#x9;&#x9;if(OGtweet.owner.equals(retweeter)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;retweetCount+=depth;&#xA;&#x9;&#x9;&#x9;&#x9;this.text = tweet.text;&#xA;&#x9;&#x9;&#x9;&#x9;searching = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return OGtweet.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;if(retweet" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="90" end="-839"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878628461" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(en.toString());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1836" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878794802" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;while(searching){&#xA;&#x9;&#x9;&#x9;if(tweet.retweet){&#xA;&#x9;&#x9;&#x9;&#x9;tweet = tweet.next;&#xA;&#x9;&#x9;&#x9;&#x9;depth++;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet = tweet;&#xA;&#x9;&#x9;&#x9;&#x9;if(OGtweet.owner.equals(retweeter)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet.retweetCount+=depth;&#xA;&#x9;&#x9;&#x9;&#x9;this.text = tweet.text;&#xA;&#x9;&#x9;&#x9;&#x9;searching = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return OGtweet.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;if(retweet){&#xA;&#x9;&#x9;&#x9;return OGtweet;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String OGeier;&#xA;&#x9;&#x9;if(getOriginalTweet()!=null){&#xA;&#x9;&#x9;&#x9;OGeier = OGtweet.owner.toString();&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;OGeier = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return String.format(&quot;Tweet [owner=%s, OGtweet=%s, text=%s, retweetCount=%s]&quot;, owner.toString(), OGeier, text,&#xA;&#x9;&#x9;&#x9;&#x9;retweetCount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Henrik = new TwitterAccount(&quot;henrik&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount(&quot;per&quot;);&#xA;&#x9;&#x9;TwitterAccount Pal = new TwitterAccount(&quot;pal&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet en = new Tweet(Henrik,&quot;Hei&quot;);&#xA;&#x9;&#x9;Tweet to = new Tweet(Per, en);&#xA;&#x9;&#x9;Tweet tre = new Tweet(Pal, to);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(en.toString());&#xA;&#x9;&#x9;System.out.println(to.toString());&#xA;&#x9;&#x9;System.out.println(tre" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="505" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878801508" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="505" end="-1346"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878818854" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+1" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="784" end="-1068"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487878855091" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="depth++;&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet = tweet;&#xA;&#x9;&#x9;&#x9;&#x9;if(OGtweet.owner.equals(retweeter)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet.retweetCount+=depth" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="609" end="-1068"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487879031232" sizeMeasure="94" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1864" end="-1865"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487879252849" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="317" end="-1518"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487879675627" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;Tweet(TwitterAccount retweeter, Tweet tweet){&#xA;&#x9;&#x9;retweet = true;&#xA;&#x9;&#x9;this.owner = retweeter;&#xA;&#x9;&#x9;this.next = tweet;&#xA;&#x9;&#x9;boolean searching = true;&#xA;&#x9;&#x9;int depth = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;while(searching){&#xA;&#x9;&#x9;&#x9;if(tweet.retweet){&#xA;&#x9;&#x9;&#x9;&#x9;tweet = tweet.next;&#xA;&#x9;&#x9;&#x9;&#x9;depth++;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}else{" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="317" end="-1248"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487879861012" sizeMeasure="93" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet fire = new Tweet(Henrik,en" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1697" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487880401432" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;while(searching){&#xA;&#x9;&#x9;&#x9;if(tweet.retweet){&#xA;&#x9;&#x9;&#x9;&#x9;tweet = tweet.next;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet = tweet;&#xA;&#x9;&#x9;&#x9;&#x9;if(OGtweet.owner.equals(retweeter)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;OGtweet.retweetCount++;&#xA;&#x9;&#x9;&#x9;&#x9;this.text = tweet.text;&#xA;&#x9;&#x9;&#x9;&#x9;searching = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return OGtweet.owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;if(retweet){&#xA;&#x9;&#x9;&#x9;return OGtweet;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String OGeier;&#xA;&#x9;&#x9;if(getOriginalTweet()!=null){&#xA;&#x9;&#x9;&#x9;OGeier = OGtweet.owner.toString();&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;OGeier = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return String.format(&quot;Tweet [owner=%s, OGtweet=%s, text=%s, retweetCount=%s]&quot;, owner.toString(), OGeier, text,&#xA;&#x9;&#x9;&#x9;&#x9;retweetCount);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Henrik = new TwitterAccount(&quot;henrik&quot;);&#xA;&#x9;&#x9;TwitterAccount Per = new TwitterAccount(&quot;per&quot;);&#xA;&#x9;&#x9;TwitterAccount Pal = new TwitterAccount(&quot;pal&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet en = new Tweet(Henrik,&quot;Hei&quot;);&#xA;&#x9;&#x9;Tweet to = new Tweet(Per, en);&#xA;&#x9;&#x9;Tweet tre = new Tweet(Pal, to" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="460" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487880438913" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet fire = new Tweet(Pal," edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1662" end="-129"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487880504864" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &quot;Hoi&quot;);&#xA;&#x9;&#x9;Tweet fem = new Tweet(Henrik, fire);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(en.toString());&#xA;&#x9;&#x9;System.out.println(to.toString());&#xA;&#x9;&#x9;System.out.println(tre.toString());&#xA;&#x9;&#x9;System.out.println(fire.toString());&#xA;&#x9;&#x9;System.out.println(fem.toString());&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1689" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487881470212" sizeMeasure="99">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(retweet){&#xA;&#x9;&#x9;&#x9;return OGtweet.owner;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return owner;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="869" end="-1049"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487881719424" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;return owner;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="869" end="-1049"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487881745091" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return owner;" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="869" end="-1049"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488042713328" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1930" end="-1931"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487837506129" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487839451238" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;private List&lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;&#xA;&#x9;TwitterAccount(String username){&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.following.contains(account)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du følger allerede denne kontoen.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.following.add(account);&#xA;&#x9;&#x9;account.followers.add(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!this.following.contains(account)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du følger ikke denne kontoen.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.following.remove(account);&#xA;&#x9;&#x9;account.followers.remove(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;if(this.following.contains(account)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;if(account.following.contains(this)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public void tweet(String text){&#xA;&#x9;&#x9;Tweet tweet = new Tweet(this,text);&#xA;&#x9;&#x9;this.tweets.add(0, tweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;Tweet retweet = new Tweet(this,tweet);&#xA;&#x9;&#x9;this.tweets.add(0, retweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;return this.tweets.get(i+1);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Tweet retweets : tweets){&#xA;&#x9;&#x9;&#x9;if(retweets.isRetweet(retweets)){&#xA;&#x9;&#x9;&#x9;&#x9;count++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return count;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="27" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487840322731" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return username" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="1721" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487880834063" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for(Tweet t : tweets){&#xA;&#x9;&#x9;&#x9;count+=t.getOriginalTweet().getRetweetCount();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="1605" end="-87"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487882045286" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(i&lt;1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig indeks.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.tweets.get(i-" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1463" end="-280"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487882121583" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*if(!this.following.contains(account)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du følger ikke denne kontoen.&quot;);&#xA;&#x9;&#x9;}*/" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="754" end="-976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487882788203" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1723" end="-110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059884403" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="RetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return count;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1723" end="-6"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487839899592" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487840009858" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487840031683" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487840201592" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487840322600" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487840367208" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487840471794" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487840683301" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487840758466" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487841075838" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487841159167" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487841452805" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487841978243" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487842614155" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487842631967" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487843079699" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487843105714" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487878585042" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487878628335" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487878794676" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487878801350" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487878818660" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487878855011" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487879031132" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487879068507" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487879252314" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487879675578" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487879860856" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487880401224" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487880438726" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487880504468" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487881470069" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487880834742" completion="0.5" successCount="2" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487881478254" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487881720035" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488802072605" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487881842906" completion="0.3333333333333333" successCount="2" failureCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487882045875" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487882122148" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487882789075" completion="1.0" successCount="6"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="42">
        <attempts timestamp="1487879095690"/>
        <attempts timestamp="1487879098994"/>
        <attempts timestamp="1487879099941"/>
        <attempts timestamp="1487879100687"/>
        <attempts timestamp="1487879101572"/>
        <attempts timestamp="1487879102292"/>
        <attempts timestamp="1487879115902"/>
        <attempts timestamp="1487879117711"/>
        <attempts timestamp="1487879265503"/>
        <attempts timestamp="1487879266687"/>
        <attempts timestamp="1487879268820"/>
        <attempts timestamp="1487879290349"/>
        <attempts timestamp="1487879309542"/>
        <attempts timestamp="1487879310731"/>
        <attempts timestamp="1487879312022"/>
        <attempts timestamp="1487879312930"/>
        <attempts timestamp="1487879314699"/>
        <attempts timestamp="1487879337632"/>
        <attempts timestamp="1487879450173"/>
        <attempts timestamp="1487879469169"/>
        <attempts timestamp="1487879495476"/>
        <attempts timestamp="1487879522661"/>
        <attempts timestamp="1487879523834"/>
        <attempts timestamp="1487879526307"/>
        <attempts timestamp="1487879531678"/>
        <attempts timestamp="1487879539332"/>
        <attempts timestamp="1487879561320"/>
        <attempts timestamp="1487879566730"/>
        <attempts timestamp="1487879569145"/>
        <attempts timestamp="1487879573274"/>
        <attempts timestamp="1487879592929"/>
        <attempts timestamp="1487879614417"/>
        <attempts timestamp="1487879621257"/>
        <attempts timestamp="1487879622556"/>
        <attempts timestamp="1487879623316"/>
        <attempts timestamp="1487879624667"/>
        <attempts timestamp="1487879626044"/>
        <attempts timestamp="1487879629554"/>
        <attempts timestamp="1487879631189"/>
        <attempts timestamp="1487879632270"/>
        <attempts timestamp="1487879633806"/>
        <attempts timestamp="1487879634961"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="4">
        <attempts timestamp="1487879122965"/>
        <attempts timestamp="1487879256928"/>
        <attempts timestamp="1487879339588"/>
        <attempts timestamp="1487879427584"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
