<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488051749768" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488052203327" sizeMeasure="24" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import objectstructures.TwitterAccount;&#xA;&#xA;public class Tweet {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount, String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;}&#xA;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="27" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488052270967" sizeMeasure="31" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String text;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount, String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="94" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488052330055" sizeMeasure="31" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="194" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053430466" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private TwitterAccount owner;&#xA;&#x9;private int reTweetCount;&#xA;&#x9;private Tweet originalTweet;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = post;&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.originalTweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;this.reTweetCount = tweet.getRetweetCount()+1;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.text;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;} &#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return reTweetCount;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="116" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053449334" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="171" end="-715"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053487258" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;private Tweet originalTweet;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = post;&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.reTweetCount = 0" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="171" end="-562"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053714509" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (twitterAccount.equals(tweet.getOwner())){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new RuntimeException(&quot;Cannot retweet yourself!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="431" end="-486"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053889596" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.reTweetCount==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="908" end="-102"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488054160734" sizeMeasure="106">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;TwitterAccount tw = new TwitterAccount (&quot;ole&quot;);&#xA;&#x9;&#x9;Tweet tweet1 = new Tweet(tw, &quot;Hei, jeg heter ole.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(tweet1.getText());" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1090" end="-27"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488054189956" sizeMeasure="107">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(tweet1.getRetweetCoun" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1287" end="-32"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488054274992" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1 = new TwitterAccount (&quot;ole&quot;);&#xA;&#x9;&#x9;TwitterAccount tw2 = new TwitterAccount (&quot;kari&quot;);&#xA;&#x9;&#x9;Tweet tweet1 = new Tweet(tw1, &quot;Hei, jeg heter ole.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(tweet1.getText());&#xA;&#x9;&#x9;System.out.println(tweet1.getRetweetCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet tweet2 = new Tweet (tw2,tweet1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(tweet2.getText());&#xA;&#x9;&#x9;System.out.println(tweet2" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1156" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488054336037" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(tweet2.getOwner" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1524" end="-31"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488054881549" sizeMeasure="123">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if((this.originalTweet = tweet.getOriginalTweet()) == null){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="618" end="-876"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056898351" sizeMeasure="123">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOriginalTweet().equals(null)" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="624" end="-991"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488056966032" sizeMeasure="123">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(this.originalTweet.equals(tweet.getOriginalTweet())" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="624" end="-992"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057015553" sizeMeasure="123">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = tweet.getOriginalTweet()) == null" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="643" end="-991"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057060913" sizeMeasure="123">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOriginalTweet()==" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="624" end="-995"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057103450" sizeMeasure="124">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(tweet1.getOriginalTwee" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1445" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057264215" sizeMeasure="126">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;tweet.reTweetCountUp();&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.text;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;} &#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.reTweetCount==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return reTweetCount;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void reTweetCountUp(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.reTweetCount+=1;" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="758" end="-557"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057279795" sizeMeasure="126">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="IllegalArgument" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="497" end="-1268"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488057786235" sizeMeasure="126">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="RetweetCount()==0" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="641" end="-1118"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058155165" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int orginalorRepost; // Int for å vise hvorvidt en tweet er en orginal tweet eller en retweet.&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = post;&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.reTweetCount = 0;&#xA;&#x9;&#x9;this.orginalorRepost = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (twitterAccount.equals(tweet.getOwner())){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot retweet yourself!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.orginalorRepost = 1;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(tweet.getOrginalorRepost()==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet.getOriginalTweet();&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;tweet.reTweetCountUp();&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.text;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;} &#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.reTweetCount==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return reTweetCount;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void reTweetCountUp(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.reTweetCount+=1;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getOrginalorRepost(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.orginalorRepost" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="204" end="-558"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058195378" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="OrRepost; // Int for å vise hvorvidt en tweet er en orginal tweet eller en retweet.&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = post;&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.reTweetCount = 0;&#xA;&#x9;&#x9;this.orginalOrRepost = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (twitterAccount.equals(tweet.getOwner())){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot retweet yourself!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.orginalOrRepost = 1;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(tweet.getOrginalorRepost()==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet.getOriginalTweet();&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;tweet.reTweetCountUp();&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.text;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;} &#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.reTweetCount==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return reTweetCount;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void reTweetCountUp(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.reTweetCount+=1;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getOrginalorRepost(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.orginalO" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="223" end="-565"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058259744" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="orginalOrRepos" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1152" end="-833"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058506824" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="isReTweet; // Int for å vise hvorvidt en tweet er en orginal tweet eller en retweet.&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = post;&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.reTweetCount = 0;&#xA;&#x9;&#x9;this.isReTweet = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (twitterAccount.equals(tweet.getOwner())){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot retweet yourself!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.isReTweet = 1;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(tweet.getOrginalorRepost()==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet.getOriginalTweet();&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;tweet.reTweetCountUp();&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.text;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;} &#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.isReTweet==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return reTweetCount;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void reTweetCountUp(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.reTweetCount+=1;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getOrginalorRepost(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.isReTwee" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="216" end="-559"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058527046" sizeMeasure="128" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="IsReTwee" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1366" end="-589"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058561821" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="IsReTwee" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="783" end="-1166"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064182679" sizeMeasure="131">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweet.reTweetCountUp();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().reTweetCountUp();&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet.getOriginalTweet();&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="837" end="-1022"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064327400" sizeMeasure="112">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.text = post;&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.reTweetCount = 0;&#xA;&#x9;&#x9;this.isReTweet = 0;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount twitterAccount, Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (twitterAccount.equals(tweet.getOwner())){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot retweet yourself!&quot;);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.text = tweet.getText();&#xA;&#x9;&#x9;this.owner = twitterAccount;&#xA;&#x9;&#x9;this.isReTweet = 1;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(tweet.getIsReTweet()==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;&#x9;tweet.reTweetCountUp();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;tweet.getOriginalTweet().reTweetCountUp();&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet.getOriginalTweet();&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#xA;&#x9;&#x9;return this.text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;} &#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.isReTweet==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return reTweetCount;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void reTweetCountUp(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.reTweetCount+=1;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getIsReTweet(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.isReTweet;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;TwitterAccount tw1 = new TwitterAccount (&quot;ole&quot;);&#xA;&#x9;&#x9;TwitterAccount tw2 = new TwitterAccount (&quot;kari&quot;);&#xA;&#x9;&#x9;Tweet tweet1 = new Tweet(tw1, &quot;Hei, jeg heter ole.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(tweet1.getText());&#xA;&#x9;&#x9;System.out.println(tweet1.getRetweetCount());&#xA;&#x9;&#x9;System.out.println(tweet1.getOriginalTweet());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet tweet2 = new Tweet (tw2,tweet1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(tweet2.getText());&#xA;&#x9;&#x9;System.out.println(tweet2.getRetweetCount());&#xA;&#x9;&#x9;System.out.println(tweet2.getOwner());&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="369" end="-16"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488051797496" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488053430451" sizeMeasure="23" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String username){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="57" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488058875231" sizeMeasure="37" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import objectstructures.Tweet;&#xA;import java.util.ArrayList;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;private ArrayList&lt;TwitterAccount> followerOf;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String username){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;&#x9;this.followerOf = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.username;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.followerOf.add(account);&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="27" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059064449" sizeMeasure="49" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(!(this.followerOf.contains(account))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.add(account);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.remove(account);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="454" end="-17"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059610994" sizeMeasure="80" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;Tweet> tweetCollection;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String username){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;&#x9;this.followerOf = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.username;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(this.followerOf.contains(account))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.add(account);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.remove(account);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(account.followerOf.contains(this)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return false;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet tweet = new Tweet(this,post);&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="195" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488059630166" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweetCollection.add(twee" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1138" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060124931" sizeMeasure="112">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void retweet(Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet reTweet = new Tweet(this,tweet);&#xA;&#x9;&#x9;this.tweetCollection.add(reTweet);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.tweetCollection.get(i);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.tweetCollection.size();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i&lt;this.tweetCollection.size();i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;count += this.tweetCollection.get(i).getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return count;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1180" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060217784" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweetCollection = new ArrayList&lt;Twee" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="372" end="-1302"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060259377" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+1" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1421" end="-294"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060310037" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1421" end="-294"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060452554" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweet(&quot;Tom tweet&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="421" end="-1299"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060480425" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="420" end="-1297"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060610932" sizeMeasure="121" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (i&lt;0 || i>=this.tweetCollection.size()){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Integer out of bounds!&quot;)&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.tweetCollection.get(i-1);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1390" end="-289"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060624219" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1501" end="-351"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060663118" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1403" end="-449"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488060990228" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1554" end="-298"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488061009211" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1554" end="-298"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488061220276" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collections;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;private ArrayList&lt;TwitterAccount> followerOf;&#xA;&#x9;private ArrayList&lt;Tweet> tweetCollection;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String username){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;&#x9;this.followerOf = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;this.tweetCollection = new ArrayList&lt;Tweet>();&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.username;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(this.followerOf.contains(account))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.add(account);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.remove(account);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(account.followerOf.contains(this)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return false;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet tweet = new Tweet(this,post);&#xA;&#x9;&#x9;this.tweetCollection.add(0, tweet);;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet reTweet = new Tweet(this,tweet);&#xA;&#x9;&#x9;this.tweetCollection.add(0, reTweet);" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="86" end="-508"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488063649889" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1835" end="-55"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488063663580" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="1754" end="-137"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488063732039" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="1759" end="-133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488063746301" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="1754" end="-138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488063753679" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="1754" end="-138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064036160" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweetCollection.size()+1" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="1759" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064340841" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="86" end="-1780"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064383422" sizeMeasure="106">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;private ArrayList&lt;TwitterAccount> followerOf;&#xA;&#x9;private ArrayList&lt;Tweet> tweetCollection;&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String username){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;&#x9;this.followerOf = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;this.tweetCollection = new ArrayList&lt;Tweet>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.username;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(this.followerOf.contains(account))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.add(account);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.remove(account);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(account.followerOf.contains(this)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return false;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet tweet = new Tweet(this,post);&#xA;&#x9;&#x9;this.tweetCollection.add(0, tweet);;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet reTweet = new Tweet(this,tweet);&#xA;&#x9;&#x9;this.tweetCollection.add(0, reTweet);;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i&lt;0 || i>this.tweetCollection.size()){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Integer out of bounds!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.tweetCollection.get(i-1);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.tweetCollection.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 1; i&lt;this.tweetCollection.size()+1;i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;count += this.tweetCollection.get(i-1).getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return count;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="86" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064607751" sizeMeasure="122">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Array;&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String username){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;&#x9;this.followerOf = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;this.tweetArray = new ArrayList&lt;Tweet>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.username;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(!(this.followerOf.contains(account))){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.add(account);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.followerOf.remove(account);&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.followerOf.contains(account)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(account.followerOf.contains(this)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;return false;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String post){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet tweet = new Tweet(this,post);&#xA;&#x9;&#x9;this.tweetArray.add(0, tweet);;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet reTweet = new Tweet(this,tweet);&#xA;&#x9;&#x9;this.tweetArray.add(0, reTweet);;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i&lt;0 || i>this.tweetArray.size()){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Integer out of bounds!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.tweetArray.get(i-1);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.tweetArray.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 1; i&lt;this.tweetArray.size()+1;i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;count += this.tweetArray.get(i-1).getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return count;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;TwitterAccount twA1 = new TwitterAccount(&quot;Ole&quot;);&#xA;&#x9;&#x9;TwitterAccount twA2 = new TwitterAccount(&quot;Lars&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(twA1.getUserName());&#xA;&#x9;&#x9;System.out.println(twA2.getUserName());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="223" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064667906" sizeMeasure="123">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="twA1.tweet(&quot;Swag&quot;);&#xA;&#x9;&#x9;System.out.println(twA1.getTweet(1));" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="2017" end="-24"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064762911" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getText());&#xA;&#x9;&#x9;twA1.follow(twA2);&#xA;&#x9;&#x9;if(twA1.isFollowedBy(twA2)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Lars følger Ole på twitter.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="2074" end="-24"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488064779079" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.isFollowedBy(twA1" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="2116" end="-89"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488054160697" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488054189900" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488054274952" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488054335600" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488057103411" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488064607706" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488064670407" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488064762875" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488064779027" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488053431733" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488053453650" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488053490018" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488053716854" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488053892274" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488054884019" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488056900249" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488056966337" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488057015832" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488057061203" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488057302530" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488057788935" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488058161434" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488058261860" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488064188237" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060139660" completion="0.3333333333333333" successCount="2" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060219504" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060261156" completion="0.5" successCount="3" failureCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060310300" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060454748" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060483265" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060613010" completion="0.5" successCount="3" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060626064" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060665085" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488060992309" completion="0.6666666666666666" successCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488061009490" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488061222301" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488063622045" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488063653355" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488063665726" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488063733872" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488063748134" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488063777996" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488064037711" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488064206547" completion="1.0" successCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488064214678" completion="1.0" successCount="6"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
