<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Partner">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Partner class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Partner class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PartnerTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PartnerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Partner" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487691806150" sizeMeasure="28">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Partner {&#xA;&#x9;private String name;&#xA;&#x9;private Partner partner;&#xA;&#x9;&#xA;&#x9;public Partner(String name){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;}&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;public Partner getPartner(){&#xA;&#x9;&#x9;return this.partner;&#xA;&#x9;}&#xA;&#x9;public void setPartner(Partner partner){&#xA;&#x9;&#x9;if (this.partner == partner){&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;if(oldPartner != null &amp;&amp; oldPartner.getPartner() == this){&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner(null);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.partner != null){&#xA;&#x9;&#x9;&#x9;this.partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692073440" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.partner = " edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="386" end="-179"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487694556256" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Partner [name=&quot; + name + &quot;, partner=&quot; + partner + &quot;]&quot;;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Partner partner1 = new Partner(&quot;Ola&quot;);&#xA;&#x9;&#x9;Partner partner2 = new Partner(&quot;Kari&quot;);&#xA;&#x9;&#x9;Partner partner3 = new Partner(&quot;Geir&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;partner1.setPartner(partner2);&#xA;&#x9;&#x9;partner3.setPartner(partner1);" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="577" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487754742074" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="927" end="-928"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487694554235" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487757845751" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487757851552" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487757854417" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487757869011" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487691225340" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487691809657" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692077758" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="28">
        <attempts timestamp="1487694657804"/>
        <attempts timestamp="1487694661119"/>
        <attempts timestamp="1487694677720"/>
        <attempts timestamp="1487694731145"/>
        <attempts timestamp="1487694746938"/>
        <attempts timestamp="1487694753617"/>
        <attempts timestamp="1487694758025"/>
        <attempts timestamp="1487694765807"/>
        <attempts timestamp="1487694769953"/>
        <attempts timestamp="1487694770390"/>
        <attempts timestamp="1487694770796"/>
        <attempts timestamp="1487694774403"/>
        <attempts timestamp="1487694778146"/>
        <attempts timestamp="1487694785231"/>
        <attempts timestamp="1487694789949"/>
        <attempts timestamp="1487694791511"/>
        <attempts timestamp="1487694794487"/>
        <attempts timestamp="1487694799638"/>
        <attempts timestamp="1487694801872"/>
        <attempts timestamp="1487694805140"/>
        <attempts timestamp="1487694811912"/>
        <attempts timestamp="1487694813269"/>
        <attempts timestamp="1487694825992"/>
        <attempts timestamp="1487694840433"/>
        <attempts timestamp="1487694861027"/>
        <attempts timestamp="1487694861855"/>
        <attempts timestamp="1487694863871"/>
        <attempts timestamp="1487694865027"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="3">
        <attempts timestamp="1487694570165"/>
        <attempts timestamp="1487694608258"/>
        <attempts timestamp="1487694707029"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
