<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311823093" sizeMeasure="55">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;&#xA;public class Person {&#xA;&#x9;&#xA;&#x9;private String navn;&#xA;&#x9;private char kjonn;&#xA;&#x9;&#xA;&#x9;private Person mor;&#xA;&#x9;private Person far;&#xA;&#x9;private Collection&lt;Person> barn = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return navn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return kjonn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return mor;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return far;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getChildCount(){&#xA;&#x9;&#x9;return barn.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;if(barn.isEmpty()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ingen barn&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n> barn.size()-1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return ((ArrayList&lt;Person>) barn).get(n);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;Navn: &quot; + barn;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311905684" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;//Variabler&#xA;&#x9;private String navn;&#xA;&#x9;private char kjonn;&#xA;&#x9;&#xA;&#x9;private Person mor;&#xA;&#x9;private Person far;&#xA;&#x9;private Collection&lt;Person> barn = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;//Getters&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return navn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return kjonn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return mor;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return far;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getChildCount(){&#xA;&#x9;&#x9;return barn.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;if(barn.isEmpty()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ingen barn&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n> barn.size()-1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return ((ArrayList&lt;Person>) barn).get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;//Del 1&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;//ToString-metoden" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="110" end="-60"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312087554" sizeMeasure="80" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Konstruktør&#xA;&#x9;public Person(String navn, char kjonn){&#xA;&#x9;&#x9;this.navn = navn;&#xA;&#x9;&#x9;this.kjonn = kjonn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;//Getters&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return navn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return kjonn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return mor;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return far;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getChildCount(){&#xA;&#x9;&#x9;return barn.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getChild(int n){&#xA;&#x9;&#x9;if(barn.isEmpty()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ingen barn&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n> barn.size()-1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return ((ArrayList&lt;Person>) barn).get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;//Del 1 - Children!&#xA;&#x9;&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;person.&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="274" end="-97"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312274882" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kjonn = person.getGender();&#xA;&#x9;&#x9;if(kjonn == 'F'){&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;this.far = person;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1019" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312299537" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;person.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;this.far = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this)" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1091" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312478304" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.getGender();&#xA;&#x9;&#x9;if(kjonn == 'F'){&#xA;&#x9;&#x9;&#x9;person.mor = this;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;person.far = this" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1027" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312508270" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.addChild(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;this.addChild(person)" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1089" end="-105"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312526933" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;else if(kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1089" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312632502" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1089" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312842562" sizeMeasure="100">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void removeChild(Person person){&#xA;&#x9;&#x9;kjonn = this.getGender();&#xA;&#x9;&#x9;if(kjonn == 'F'){&#xA;&#x9;&#x9;&#x9;person.mor = null;&#xA;&#x9;&#x9;&#x9;this.barn.remove(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;this.barn.remove" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1200" end="-113"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313325515" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; person.mor == null){&#xA;&#x9;&#x9;&#x9;person.mor = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(kjonn == 'F' &amp;&amp; person.mor != null){&#xA;&#x9;&#x9;&#x9;Person oldMother = this.mor;&#xA;&#x9;&#x9;&#x9;person.mor = this;&#xA;&#x9;&#x9;&#x9;oldMother.barn.remove(person);&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M' &amp;&amp; person.far == null){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M' &amp;&amp; person.far != null){&#xA;&#x9;&#x9;&#x9;Person oldFather = this.far;&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;oldFather.barn.remove(person);&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1062" end="-326"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313420541" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1898" end="-1899"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313498350" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.mor == null){&#xA;&#x9;&#x9;&#x9;person.mor = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(kjonn == 'F' &amp;&amp; this" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1066" end="-727"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313506657" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.far == null){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M' &amp;&amp; this" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1327" end="-463"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313625304" sizeMeasure="113">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person.mor == null){&#xA;&#x9;&#x9;&#x9;person.mor = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(kjonn == 'F' &amp;&amp; person.mor != null){&#xA;&#x9;&#x9;&#x9;Person oldMother = person.mor;&#xA;&#x9;&#x9;&#x9;person.mor = this;&#xA;&#x9;&#x9;&#x9;oldMother.barn.remove(person);&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M' &amp;&amp; person.far == null){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M' &amp;&amp; person.far != null){&#xA;&#x9;&#x9;&#x9;Person oldFather = person" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1066" end="-422"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488315890594" sizeMeasure="134">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Setters - foreldre&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(person.kjonn == 'F'){&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;} else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Feil kjønn.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person.kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Feil kjønn.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1814" end="-93"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316053305" sizeMeasure="137">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.mor == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke være mor til seg selv.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else " edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1881" end="-426"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316083659" sizeMeasure="137">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1885" end="-524"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316141517" sizeMeasure="140">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke være far til seg selv.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else " edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="2175" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316185605" sizeMeasure="140">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fa" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="2310" end="-202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316646998" sizeMeasure="146">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; this.mor == null){&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;} else if(person.kjonn == 'F' &amp;&amp; this.mor != null){&#xA;&#x9;&#x9;&#x9;Person oldMother = this.mor;&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;&#x9;oldMother.barn.remove(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="2005" end="-454"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316709610" sizeMeasure="152">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; this.far == null){&#xA;&#x9;&#x9;&#x9;this.far = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;} else if(person.kjonn == 'F' &amp;&amp; this.far != null){&#xA;&#x9;&#x9;&#x9;Person oldFather = this.far;&#xA;&#x9;&#x9;&#x9;this.far = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;&#x9;oldFather.barn.remove(this);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="2487" end="-160"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316770860" sizeMeasure="152">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="M" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="2587" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488316904467" sizeMeasure="158">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person == null){&#xA;&#x9;&#x9;&#x9;this.mor = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke være mor til seg selv.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(person.kjonn == 'F' &amp;&amp; this.mor == null){&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;} else if(person.kjonn == 'F' &amp;&amp; this.mor != null){&#xA;&#x9;&#x9;&#x9;Person oldMother = this.mor;&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;&#x9;oldMother.barn.remove(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Feil kjønn.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person == null){&#xA;&#x9;&#x9;&#x9;this.far = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else " edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1881" end="-531"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317048179" sizeMeasure="159">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.navn + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;\nKjønn: &quot; + this.kjon" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="2981" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317447208" sizeMeasure="187">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//ToString-metoden&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;Navn: &quot; + this.navn + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;\nKjønn: &quot; + this.kjonn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person Tone = new Person(&quot;Tone&quot;, 'F');&#xA;&#x9;&#x9;Person Kristian = new Person(&quot;Kristian&quot;, 'M');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Person Roger = new Person(&quot;Roger&quot;, 'M');&#xA;&#x9;&#x9;Person May = new Person(&quot;May&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Person Mats = new Person(&quot;Mats&quot;, 'M');&#xA;&#x9;&#x9;Person Miriam = new Person(&quot;Miriam&quot;, 'F');&#xA;&#x9;&#x9;Person Markus = new Person(&quot;Markus&quot;, 'M');&#xA;&#x9;&#x9;Person Mikkel = new Person(&quot;Mikkel&quot;, 'M');&#xA;&#x9;&#x9;Person Mia = new Person(&quot;Mia&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tone.addChild(Mats);&#xA;&#x9;&#x9;Tone.addChild(Miriam);&#xA;&#x9;&#x9;Tone.addChild(Markus);&#xA;&#x9;&#x9;Tone.addChild(Mikkel);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Mia.setMother(May);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Roger.addChild(Mats);&#xA;&#x9;&#x9;Roger.addChild(Miriam);&#xA;&#x9;&#x9;Roger.addChild(Markus);&#xA;&#x9;&#x9;Roger.addChild(Mia);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Mikkel.setFather(Kristian);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="2910" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317475599" sizeMeasure="189">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(String.valueOf(Tone.getChildCount())" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="3726" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317519963" sizeMeasure="190" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(Tone.getChild(3" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="3787" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317527431" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="3823" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317565803" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="3820" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317581382" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="765" end="-3067"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317635486" sizeMeasure="189">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return ((ArrayList&lt;Person>) barn).get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;//Del 1 - Children!&#xA;&#x9;&#xA;&#x9;public void addChild(Person person){&#xA;&#x9;&#x9;kjonn = this.getGender();&#xA;&#x9;&#x9;if(kjonn == 'F' &amp;&amp; person.mor == null){&#xA;&#x9;&#x9;&#x9;person.mor = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(kjonn == 'F' &amp;&amp; person.mor != null){&#xA;&#x9;&#x9;&#x9;Person oldMother = person.mor;&#xA;&#x9;&#x9;&#x9;person.mor = this;&#xA;&#x9;&#x9;&#x9;oldMother.barn.remove(person);&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M' &amp;&amp; person.far == null){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M' &amp;&amp; person.far != null){&#xA;&#x9;&#x9;&#x9;Person oldFather = person.far;&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;oldFather.barn.remove(person);&#xA;&#x9;&#x9;&#x9;this.barn.add(person);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void removeChild(Person person){&#xA;&#x9;&#x9;kjonn = this.getGender();&#xA;&#x9;&#x9;if(kjonn == 'F'){&#xA;&#x9;&#x9;&#x9;person.mor = null;&#xA;&#x9;&#x9;&#x9;this.barn.remove(person);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(kjonn == 'M'){&#xA;&#x9;&#x9;&#x9;person.far = this;&#xA;&#x9;&#x9;&#x9;this.barn.remove(person);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;//Setters - foreldre&#xA;&#x9;&#xA;&#x9;public void setMother(Person person){&#xA;&#x9;&#x9;if(person == null){&#xA;&#x9;&#x9;&#x9;this.mor = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke være mor til seg selv.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(person.kjonn == 'F' &amp;&amp; this.mor == null){&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;} else if(person.kjonn == 'F' &amp;&amp; this.mor != null){&#xA;&#x9;&#x9;&#x9;Person oldMother = this.mor;&#xA;&#x9;&#x9;&#x9;this.mor = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;&#x9;oldMother.barn.remove(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Feil kjønn.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void setFather(Person person){&#xA;&#x9;&#x9;if(person == null){&#xA;&#x9;&#x9;&#x9;this.far = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(this == person){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke være far til seg selv.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(person.kjonn == 'M' &amp;&amp; this.far == null){&#xA;&#x9;&#x9;&#x9;this.far = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;} else if(person.kjonn == 'M' &amp;&amp; this.far != null){&#xA;&#x9;&#x9;&#x9;Person oldFather = this.far;&#xA;&#x9;&#x9;&#x9;this.far = person;&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;&#x9;oldFather.barn.remove(this);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Feil kjønn.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;//ToString-metoden&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;Navn: &quot; + this.navn + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;\nKjønn: &quot; + this.kjonn;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person Tone = new Person(&quot;Tone&quot;, 'F');&#xA;&#x9;&#x9;Person Kristian = new Person(&quot;Kristian&quot;, 'M');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Person Roger = new Person(&quot;Roger&quot;, 'M');&#xA;&#x9;&#x9;Person May = new Person(&quot;May&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Person Mats = new Person(&quot;Mats&quot;, 'M');&#xA;&#x9;&#x9;Person Miriam = new Person(&quot;Miriam&quot;, 'F');&#xA;&#x9;&#x9;Person Markus = new Person(&quot;Markus&quot;, 'M');&#xA;&#x9;&#x9;Person Mikkel = new Person(&quot;Mikkel&quot;, 'M');&#xA;&#x9;&#x9;Person Mia = new Person(&quot;Mia&quot;, 'F');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tone.addChild(Mats);&#xA;&#x9;&#x9;Tone.addChild(Miriam);&#xA;&#x9;&#x9;Tone.addChild(Markus);&#xA;&#x9;&#x9;Tone.addChild(Mikkel);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Mia.setMother(May);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Roger.addChild(Mats);&#xA;&#x9;&#x9;Roger.addChild(Miriam);&#xA;&#x9;&#x9;Roger.addChild(Markus);&#xA;&#x9;&#x9;Roger.addChild(Mia);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Mikkel.setFather(Kristian);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(Tone.getChildCount()" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="765" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317672423" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(String.valueOf(Tone.getChild(3" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="3787" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317711690" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="3835" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317729372" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="3835" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317736271" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="3835" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317755971" sizeMeasure="190" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + 1s" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="659" end="-3191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317757553" sizeMeasure="190" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="663" end="-3191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317773138" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="){&#xA;&#x9;&#x9;if(barn.isEmpty()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ingen barn&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n> barn.size()-1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return ((ArrayList&lt;Person>) barn).get(n+1" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="659" end="-2906"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317790162" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="3837" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317804320" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="944" end="-2907"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317815156" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="3837" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317823162" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="765" end="-3085"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317831878" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="3835" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317844379" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Tones barn nummer 3 er &quot; + " edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="3806" end="-44"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317856149" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".. \n" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="3829" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317864712" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="3834" end="-48"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317884168" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="765" end="-3117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317899076" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="944" end="-2938"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317950159" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(n+1)> barn.size()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((n+1)&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return ((ArrayList&lt;Person>) barn).get(n-1" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="751" end="-2938"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317974373" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="n> barn.size()-1){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(n&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Index feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return ((ArrayList&lt;Person>) barn).get(n" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="751" end="-2938"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318001453" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="944" end="-2938"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318008222" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="944" end="-2938"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318055815" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="3825" end="-56"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318082479" sizeMeasure="190">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Nullindeksering" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="3872" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318116512" sizeMeasure="191">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;Rogers barn nummer 2 er.. \n&quot; + String.valueOf(Roger.getChild(1" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="3893" end="-32"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317481511" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317531548" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317562834" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317583339" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317649316" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317687650" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317710835" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317727519" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317734247" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317759296" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317776916" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317789052" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317805937" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317814143" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317824594" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317830880" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317846257" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317857932" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317866251" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317885807" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317953534" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488317976855" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488318066747" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488318087998" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488318125694" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312320034" completion="0.07692307692307693" successCount="1" errorCount="12"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312479026" completion="0.07692307692307693" successCount="1" failureCount="4" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312511219" completion="0.07692307692307693" successCount="1" errorCount="12"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312528847" completion="0.07692307692307693" successCount="1" failureCount="4" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312636107" completion="0.23076923076923078" successCount="3" failureCount="2" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312849152" completion="0.23076923076923078" successCount="3" failureCount="2" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313330688" completion="0.23076923076923078" successCount="3" errorCount="10"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313512041" completion="0.23076923076923078" successCount="3" failureCount="2" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313631420" completion="0.38461538461538464" successCount="5" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488315894342" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488316055592" completion="0.6923076923076923" successCount="9" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488316088468" completion="0.7692307692307693" successCount="10" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488316143562" completion="0.8461538461538461" successCount="11" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488316188217" completion="0.8461538461538461" successCount="11" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488316649403" completion="0.9230769230769231" successCount="12" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488316711867" completion="0.9230769230769231" successCount="12" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488316774212" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488316906200" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488317050707" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488317871013" completion="0.38461538461538464" successCount="5" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488317889273" completion="0.38461538461538464" successCount="5" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488317901167" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488317957982" completion="0.38461538461538464" successCount="5" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488317979238" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488318003096" completion="0.38461538461538464" successCount="5" errorCount="8"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488318010507" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488318056480" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488318058899" completion="1.0" successCount="13"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
