<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Card">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardDeck class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardHand class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardDeck class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardHand class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardDeckTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardDeckTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardHandTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardHandTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487782469815" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487782627446" sizeMeasure="34" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="encapsulation;&#xA;&#xA;public class Card {&#xA;&#x9;private char farge;&#xA;&#x9;private int verdi;&#xA;&#x9;String farger = &quot;SHCD&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char farge, int verdi) {&#xA;&#x9;&#x9;if (farger.indexOf(farge) == -1) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig farge&quot;);&#xA;&#x9;&#x9;} else if ((verdi &lt; 1) || (verdi > 13)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig verdi&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.farge = farge;&#xA;&#x9;&#x9;&#x9;this.verdi = verdi;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.farge;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.verdi;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + farge + verdi;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="8" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487782726801" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="objectstructures" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="8" end="-566"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487782505723" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class CardDeck {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487782627453" sizeMeasure="69" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="encapsulation;&#xA;&#xA;import java.util.ArrayList;&#xA;&#xA;public class CardDeck {&#xA;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;Card>();&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if ((n > 13) || (n &lt; 1)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det finnes ikke så mange kort dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;for (int i=1; i &lt; n+1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('S', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;} for (int i=1; i &lt; n+1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('H', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;} for (int i=1; i &lt; n+1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('D', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;} for (int i=1; i &lt; n+1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('C', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return kortstokk.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n > kortstokk.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det er ikke så mange kort i kortstokken!&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return kortstokk.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void shufflePerfectly() {&#xA;&#x9;&#x9;ArrayList&lt;Card> bunke1 = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;ArrayList&lt;Card> bunke2 = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;System.out.println(this);&#xA;&#x9;&#x9;for (int i=0; i&lt;(this.kortstokk.size()/2); i++) {&#xA;&#x9;&#x9;&#x9;bunke1.add(this.kortstokk.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i=this.kortstokk.size()/2; i&lt;this.kortstokk.size(); i++) {&#xA;&#x9;&#x9;&#x9;bunke2.add(this.kortstokk.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.kortstokk.clear();&#xA;&#x9;&#x9;for (int i=0; i&lt;bunke1.size(); i++) {&#xA;&#x9;&#x9;&#x9;this.kortstokk.add(bunke1.get(i));&#xA;&#x9;&#x9;&#x9;this.kortstokk.add(bunke2.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;CardDeck [kortstokk=&quot; + kortstokk + &quot;]&quot;;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck kort = new CardDeck(5);&#xA;&#x9;&#x9;System.out.println(kort);&#xA;&#x9;&#x9;kort.shufflePerfectly();&#xA;&#x9;&#x9;System.out.println(kort);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="8" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487782726817" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="objectstructures" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="8" end="-1675"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487784489687" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardHand BillyTheKid;&#xA;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if ((n > 13) || (n &lt; 1)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det finnes ikke så mange kort dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('S', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('H', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('D', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('C', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return kortstokk.size();&#xA;&#x9;}&#xA;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n > kortstokk.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det er ikke så mange kort i kortstokken!&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return kortstokk.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void deal(CardHand Cowboy, int n) {&#xA;&#x9;&#x9;int counter = 0;&#xA;&#x9;&#x9;while (counter &lt; n) {&#xA;&#x9;&#x9;&#x9;Cowboy.addCard(kortstokk.get(0));&#xA;&#x9;&#x9;&#x9;kortstokk.remove(0);&#xA;&#x9;&#x9;&#x9;counter ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public void shufflePerfectly() {&#xA;&#x9;&#x9;ArrayList&lt;Card> bunke1 = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;ArrayList&lt;Card> bunke2 = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;System.out.println(this);&#xA;&#x9;&#x9;for (int i = 0; i &lt; (this.kortstokk.size() / 2); i++) {&#xA;&#x9;&#x9;&#x9;bunke1.add(this.kortstokk.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = this.kortstokk.size() / 2; i &lt; this.kortstokk.size(); i++) {&#xA;&#x9;&#x9;&#x9;bunke2.add(this.kortstokk.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.kortstokk.clear();&#xA;&#x9;&#x9;for (int i = 0; i &lt; bunke1.size(); i++) {&#xA;&#x9;&#x9;&#x9;this.kortstokk.add(bunke1.get(i));&#xA;&#x9;&#x9;&#x9;this.kortstokk.add(bunke2.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="133" end="-262"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487784564870" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="han" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="142" end="-1783"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487784718286" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(kort.hand" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1922" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487784784587" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;kort.deal(kort.hand, 4);&#xA;&#x9;&#x9;System.out.println(kort.hand);&#xA;&#x9;&#x9;System.out.println(kort" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1955" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487784976556" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="2048" end="-2049"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785193873" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="2048" end="-2049"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785409914" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1923" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785644094" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = new CardHand();&#xA;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if ((n > 13) || (n &lt; 1)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det finnes ikke så mange kort dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('S', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('H', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('D', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('C', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return kortstokk.size();&#xA;&#x9;}&#xA;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n > kortstokk.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det er ikke så mange kort i kortstokken!&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return kortstokk.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void deal(CardHand Cowboy, int n) {&#xA;&#x9;&#x9;int counter = 0;&#xA;&#x9;&#x9;while (counter &lt; n) {&#xA;&#x9;&#x9;&#x9;Cowboy.addCard(kortstokk.get(0));&#xA;&#x9;&#x9;&#x9;kortstokk.remove(0);&#xA;&#x9;&#x9;&#x9;counter ++;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public void shufflePerfectly() {&#xA;&#x9;&#x9;ArrayList&lt;Card> bunke1 = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;ArrayList&lt;Card> bunke2 = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;System.out.println(this);&#xA;&#x9;&#x9;for (int i = 0; i &lt; (this.kortstokk.size() / 2); i++) {&#xA;&#x9;&#x9;&#x9;bunke1.add(this.kortstokk.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (int i = this.kortstokk.size() / 2; i &lt; this.kortstokk.size(); i++) {&#xA;&#x9;&#x9;&#x9;bunke2.add(this.kortstokk.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.kortstokk.clear();&#xA;&#x9;&#x9;for (int i = 0; i &lt; bunke1.size(); i++) {&#xA;&#x9;&#x9;&#x9;this.kortstokk.add(bunke1.get(i));&#xA;&#x9;&#x9;&#x9;this.kortstokk.add(bunke2.get(i));&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;CardDeck [kortstokk=&quot; + kortstokk + &quot;]&quot;;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardDeck kort = new CardDeck(5);&#xA;&#x9;&#x9;System.out.println(kort);&#xA;&#x9;&#x9;kort.shufflePerfectly();&#xA;&#x9;&#x9;System.out.println(kort" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="146" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786398403" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="2032" end="-2033"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786585113" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if ((n > 13) || (n &lt; 1)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det finnes ikke så mange kort dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('S', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('H', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('D', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('C', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return kortstokk.size();&#xA;&#x9;}&#xA;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n > kortstokk.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det er ikke så mange kort i kortstokken!&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return kortstokk.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void deal(CardHand Cowboy, int n) {&#xA;&#x9;&#x9;int counter = 0;&#xA;&#x9;&#x9;while (counter &lt; n) {&#xA;&#x9;&#x9;&#x9;Cowboy.addCard(kortstokk.get(0));&#xA;&#x9;&#x9;&#x9;kortstokk.remove(0);&#xA;&#x9;&#x9;&#x9;counter++;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="146" end="-889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786603402" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1047" end="-931"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786713188" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = new CardHand();&#xA;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;if ((n > 13) || (n &lt; 1)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det finnes ikke så mange kort dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('S', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('H', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('D', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;for (int i = 1; i &lt; n + 1; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;Card kort = new Card('C', i);&#xA;&#x9;&#x9;&#x9;&#x9;kortstokk.add(kort);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return kortstokk.size();&#xA;&#x9;}&#xA;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n > kortstokk.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Det er ikke så mange kort i kortstokken!&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return kortstokk.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void deal(CardHand Cowboy, int n) {&#xA;&#x9;&#x9;int counter = 0;&#xA;&#x9;&#x9;while (counter &lt; n) {&#xA;&#x9;&#x9;&#x9;Cowboy.addCard(kortstokk.get(0));" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="146" end="-931"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786726999" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(kort.hand" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1935" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786853595" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1989" end="-71"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786885039" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public " edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="133" end="-1928"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786944279" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardHand hand = new CardHand();&#xA;&#x9;&#x9;System.out.println(kort);&#xA;&#x9;&#x9;kort.shufflePerfectly();&#xA;&#x9;&#x9;System.out.println(kort);&#xA;&#x9;&#x9;System.out.println(hand);&#xA;&#x9;&#x9;kort.deal(hand, 3);&#xA;&#x9;&#x9;System.out.println(" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1859" end="-42"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786968015" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="132" end="-1919"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487782535323" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class CardHand {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487784489656" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class CardHand {&#xA;&#x9;private ArrayList&lt;Card> korthand = new ArrayList&lt;Card>();&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return this.korthand.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n > this.korthand.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du har ikke så mange kort på handa dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return this.korthand.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addCard(Card x) {&#xA;&#x9;&#x9;korthand.add(x);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card play(int n) {&#xA;&#x9;&#x9;if (n > this.korthand.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du har ikke så mange kort på handa dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Card placeholder = this.korthand.get(n);&#xA;&#x9;&#x9;&#x9;this.korthand.remove(n);&#xA;&#x9;&#x9;&#x9;return placeholder;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="27" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487784646496" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;CardHand [korthand=&quot; + korthand + &quot;]&quot;;" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="722" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487784976546" sizeMeasure="44" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Card> korthand = new ArrayList&lt;Card>();&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return this.korthand.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n > this.korthand.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du har ikke så mange kort på handa dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return this.korthand.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addCard(Card x) {&#xA;&#x9;&#x9;korthand.add(x);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card play(int n) {&#xA;&#x9;&#x9;if (n > this.korthand.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du har ikke så mange kort på handa dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Card placeholder = this.korthand.get(n);&#xA;&#x9;&#x9;&#x9;this.korthand.remove(n);&#xA;&#x9;&#x9;&#x9;return placeholder;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;CardHand [korthand=&quot; + korthand + &quot;]&quot;;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardHand BillyTheKid = new CardHand();&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="81" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785013814" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(BillyTheKid" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="892" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785086611" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card kort1 = new Card('S', 1);&#xA;&#x9;&#x9;BillyTheKid.addCard(kort1" edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="927" end="-48"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785833630" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.2/@attempts.5/@edit" start="490" end="-543"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785872727" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="BillyTheKid.play(0);&#xA;&#x9;&#x9;System.out.println(BI" edit="/1/@proposals.0/@proposals.2/@attempts.6/@edit" start="1026" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785943327" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card kort2 = new Card('S', 2);&#xA;&#x9;&#x9;BillyTheKid.addCard(kort1);&#xA;&#x9;&#x9;BillyTheKid.addCard(kort2);&#xA;&#x9;&#x9;System.out.println(BillyTheKid);&#xA;&#x9;&#x9;BillyTheKid.play(0);&#xA;&#x9;&#x9;System.out.println(Bi" edit="/1/@proposals.0/@proposals.2/@attempts.7/@edit" start="961" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487785979161" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.8/@edit" start="1147" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786176195" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.2/@attempts.9/@edit" start="1106" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786185488" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.2/@attempts.10/@edit" start="1164" end="-48"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487786398397" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;ArrayList&lt;Card> korthand = new ArrayList&lt;Card>();&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return this.korthand.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n > this.korthand.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du har ikke så mange kort på handa dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return this.korthand.get(n);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addCard(Card x) {&#xA;&#x9;&#x9;korthand.add(x);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card play(int n) {&#xA;&#x9;&#x9;if (n >= this.korthand.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du har ikke så mange kort på handa dumbass&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Card placeholder = this.korthand.get(n);&#xA;&#x9;&#x9;&#x9;this.korthand.remove(n);&#xA;&#x9;&#x9;&#x9;return placeholder;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;CardHand [korthand=&quot; + korthand + &quot;]&quot;;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;CardHand BillyTheKid = new CardHand();&#xA;&#x9;&#x9;System.out.println(BillyTheKid);&#xA;&#x9;&#x9;Card kort1 = new Card('S', 1);&#xA;&#x9;&#x9;Card kort2 = new Card('S', 2);&#xA;&#x9;&#x9;BillyTheKid.addCard(kort1);&#xA;&#x9;&#x9;BillyTheKid.addCard(kort2);&#xA;&#x9;&#x9;System.out.println(BillyTheKid);&#xA;&#x9;&#x9;BillyTheKid.play(1);&#xA;&#x9;&#x9;System.out.println(BillyTheKid);&#xA;&#x9;&#x9;BillyTheKid.play(0" edit="/1/@proposals.0/@proposals.2/@attempts.11/@edit" start="81" end="-48"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487784646470" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487784718271" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487784784562" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487784976516" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785193852" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785409889" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785644070" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786011859" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786398374" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786585092" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786603363" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786713157" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786726978" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786853566" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786885023" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786944258" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786968004" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786993039" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786995910" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487787192245" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785013778" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785086602" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785513095" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785833602" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785872701" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785943304" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487785979140" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786119992" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786176168" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487786185460" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487782630375" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487782728703" completion="1.0" successCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="0.6666666666666666">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487784491425" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487784518458" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487784566737" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487785655954" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487786800551" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487786977642" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487787000915" completion="0.6666666666666666" successCount="2" failureCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="0.3333333333333333">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487784501708" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487785711532" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487786048660" completion="0.3333333333333333" successCount="1" failureCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
