<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Partner">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Partner class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Partner class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PartnerTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PartnerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Partner" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487348742290" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Partner {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private Partner partner;&#xA;&#x9;&#xA;&#x9;public Partner(String name) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Partner(String name, Partner partner) throws IllegalArgumentException {&#xA;&#x9;&#x9;if (partner.equals(this)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot be your own partner&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Partner getPartner() {&#xA;&#x9;&#x9;return partner;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487348757677" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public void setPartner(Partner partner) {&#xA;&#x9;&#x9;if (partner.equals(this)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot be your own partner&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;} else if (! this.partner.equals(partner)){&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;} else if (partner.equals(null)) {&#xA;&#x9;&#x9;&#x9;partner.setPartner(null);&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="533" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487349249063" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.partner = null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Partner(String name, Partner partner) throws IllegalArgumentException {&#xA;&#x9;&#x9;if (partner.equals(this)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot be your own partner&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Partner getPartner() {&#xA;&#x9;&#x9;return partner;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setPartner(Partner partner) throws IllegalArgumentException {&#xA;&#x9;&#x9;if (partner.equals(null)) {&#xA;&#x9;&#x9;&#x9;this.partner = null;&#xA;&#x9;&#x9;&#x9;if (! this.partner.equals(null)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else if (partner.equals(this)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot be your own partner&quot;);&#xA;&#xA;&#x9;&#x9;} else if (partner.getPartner().equals(this)) {&#xA;&#x9;&#x9;&#x9;this.partner = partner" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="154" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487349724489" sizeMeasure="46" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Partner ex = this.partner;&#xA;&#x9;&#x9;&#x9;this.partner = null;&#xA;&#x9;&#x9;&#x9;if (! ex.getPartner().equals(null)) {&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else if (partner.equals(this)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot be your own partner&quot;);&#xA;&#xA;&#x9;&#x9;} else if " edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="665" end="-88"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420353459" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == this) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot be your own partner&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Partner getPartner() {&#xA;&#x9;&#x9;return partner;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setPartner(Partner partner) throws IllegalArgumentException {&#xA;&#x9;&#x9;if (partner == this) { //&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot be your own partner&quot;); &#xA;&#x9;&#x9;} else if (this.partner == partner) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;Partner ex = this.partner;&#xA;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;if (ex != null &amp;&amp; ex.getPartner() == this) {&#xA;&#x9;&#x9;&#x9;ex.setPartner(null);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.partner != null) {&#xA;&#x9;&#x9;&#x9;this.partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="274" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420361518" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="651" end="-333"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420407750" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="189" end="-538"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487420447105" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Partner getPartner() {&#xA;&#x9;&#x9;return partner;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setPartner(Partner partner) throws IllegalArgumentException {&#xA;&#x9;&#x9;if (partner == this) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot be your own partner&quot;); &#xA;&#x9;&#x9;} else if (this.partner == partner) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;Partner ex = this.partner;&#xA;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;if (ex != null &amp;&amp; ex.getPartner() == this) {&#xA;&#x9;&#x9;&#x9;ex.setPartner(null);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.partner != null) {&#xA;&#x9;&#x9;&#x9;this.partner.setPartner(this);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="189" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487348769550" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487420367229" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487420408097" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
