<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807929935" sizeMeasure="51">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit; &#xA;&#x9;private int face; &#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((suit != 'S') &amp;&amp; (suit!= 'H') &amp;&amp; (suit != 'D') &amp;&amp; (suit!= 'C')) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfargen må være S, H, D eller C.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if((face > 13) || (face &lt; 1)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Tallverdi må være mellom 1 og 13.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;this.face = face; &#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;[&quot; + suit + face + &quot;]&quot;; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.getSuit() != o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return this.getSuit() - o.getSuit();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.getFace() != o.getFace()) {&#xA;&#x9;&#x9;&#x9;return this.getFace() - o.getFace(); &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0; &#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808166858" sizeMeasure="57" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit; &#xA;&#x9;private int face; &#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((suit != 'S') &amp;&amp; (suit!= 'H') &amp;&amp; (suit != 'D') &amp;&amp; (suit!= 'C')) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfargen må være S, H, D eller C.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if((face > 13) || (face &lt; 1)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Tallverdi må være mellom 1 og 13.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;this.face = face; &#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;[&quot; + suit + face + &quot;]&quot;; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 1);&#xA;&#x9;&#x9;Card c2 = new Card('S', 3);&#xA;&#x9;&#x9;Card c3 = new Card('H', 1);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="21" end="-238"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808171914" sizeMeasure="57" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="864" end="-240"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808196043" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="869" end="-240"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809699669" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Spar (S) > Hjerter (H) > Ruter (D) > Kløver (C)&#xA;&#x9;&#x9;&#x9;if (this.getSuit() == 'S' || &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.getSuit() == 'H' &amp;&amp; o.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.getSuit() == 'D' &amp;&amp; o.getSuit() != 'H') {&#xA;&#x9;&#x9;&#x9;&#x9;return 1; //Dersom this > o&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; //Dersom this &lt; o&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1014" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809780079" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit; &#xA;&#x9;private int face; &#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if((suit != 'S') &amp;&amp; (suit!= 'H') &amp;&amp; (suit != 'D') &amp;&amp; (suit!= 'C')) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kortfargen må være S, H, D eller C.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if((face > 13) || (face &lt; 1)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Tallverdi må være mellom 1 og 13.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;this.face = face; &#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;[&quot; + suit + face + &quot;]&quot;; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 1);&#xA;&#x9;&#x9;Card c2 = new Card('S', 3);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards); " edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="66" end="-478"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809786045" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(cards);" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="984" end="-478"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809796507" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="833" end="-625"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810022057" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="reverseOrder" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="969" end="-516"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810039720" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="976" end="-516"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810052220" sizeMeasure="74" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="sort" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="969" end="-524"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810084820" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(cards, Collections.reverseOrder()" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="973" end="-510"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810244682" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;System.out.println(c2.compareTo(c1)" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1041" end="-480"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810272662" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1078" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810283093" sizeMeasure="77" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card c4" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="900" end="-684"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810292441" sizeMeasure="77" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="32.compareTo(c4" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1095" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810297090" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1095" end="-495"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810306434" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1096" end="-494"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914482528" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; (suit != ' " edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="302" end="-1291"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914510941" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="302" end="-1291"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914622531" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; (suit!= ' " edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="302" end="-1291"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914810436" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="302" end="-1291"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488961995960" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.face = face; &#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="237" end="-1034"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488962053170" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="279" end="-1031"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810540756" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811682666" sizeMeasure="43" errorCount="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean aceIsBest, char trumf) {&#xA;&#x9;&#x9;if(aceIsBest) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;if (this.getSuit() != o.getSuit()) {&#xA;&#x9;&#x9;&#x9;// Spar (S) > Hjerter (H) > Ruter (D) > Kløver (C)&#xA;&#x9;&#x9;&#x9;if (this.getSuit() == 'S' || &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.getSuit() == 'H' &amp;&amp; o.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;this.getSuit() == 'D' &amp;&amp; o.getSuit() != 'H') {&#xA;&#x9;&#x9;&#x9;&#x9;return 1; //Dersom this > o&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; //Dersom this &lt; o&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.getFace() != o.getFace()) {&#xA;&#x9;&#x9;&#x9;return this.getFace() - o.getFace(); &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0; &#xA;&#x9;}&#xA;&#xA;&#x9;private int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;private Object getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811715533" sizeMeasure="46" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate char suit;&#xA;&#x9;private int face;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="113" end="-660"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811780222" sizeMeasure="46" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c1.getSuit() != c2.getSuit()) {&#xA;&#x9;&#x9;&#x9;// Spar (S) > Hjerter (H) > Ruter (D) > Kløver (C)&#xA;&#x9;&#x9;&#x9;if (c1.getSuit() == 'S' || &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H') {&#xA;&#x9;&#x9;&#x9;&#x9;return 1; //Dersom this > o&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; //Dersom this &lt; o&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c1.getFace() != c2.getFace()) {&#xA;&#x9;&#x9;&#x9;return c1.getFace() - c2" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="294" end="-132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811807684" sizeMeasure="40" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="705" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811814428" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="111" end="-565"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811895371" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public CardComparator(boolean aceIsBest, char trumf) {&#xA;&#x9;&#x9;if(aceIsBest) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;if (c1.getSuit() != c2.getSuit()) {&#xA;&#x9;&#x9;&#x9;// Spar (S) > Hjerter (H) > Ruter (D) > Kløver (C)&#xA;&#x9;&#x9;&#x9;if (c1.getSuit() == 'S' || &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H') {&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; " edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="112" end="-122"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812379125" sizeMeasure="41" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private boolean aceIsBest;&#xA;&#x9;private char trumf; &#xA;&#x9;&#xA;&#xA;&#x9;public CardComparator(boolean aceIsBest, char trumf) {&#xA;&#x9;&#x9;this.aceIsBest = aceIsBest; &#xA;&#x9;&#x9;this.trumf = trumf; &#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;if (c1.getSuit() != c2.getSuit()) {&#xA;&#x9;&#x9;&#x9;// Spar (S) > Hjerter (H) > Ruter (D) > Kløver (C)&#xA;&#x9;&#x9;&#x9;if (c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H')" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="111" end="-169"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812610387" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (aceIsBest &amp;&amp; c1.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (aceIsBest &amp;&amp; c2.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="708" end="-71"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812664607" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="277" end="-623"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812730685" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;private boolean aceIsBest;&#xA;&#x9;private char trumf; &#xA;&#x9;&#xA;&#xA;&#x9;public CardComparator(boolean aceIsBest, char trumf) {&#xA;&#x9;&#x9;this.aceIsBest = aceIsBest; &#xA;&#x9;&#x9;this.trumf = trumf; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;Card c4 = new Card('H', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;cards.add(c4)" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="38" end="-623"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812732855" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="603" end="-623"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812753754" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="llections;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;private boolean aceIsBest;&#xA;&#x9;private char trumf; &#xA;&#x9;&#xA;&#xA;&#x9;public CardComparator(boolean aceIsBest, char trumf) {&#xA;&#x9;&#x9;this.aceIsBest = aceIsBest; &#xA;&#x9;&#x9;this.trumf = trumf; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;Card c4 = new Card('H', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;cards.add(c4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards, Collections.reverseOrder()); &#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(c3.compareTo(c4)" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="68" end="-625"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812846367" sizeMeasure="71" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;CardComparator cc = new CardComparator();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;Card c4 = new Card('H', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;cards.add(c4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards, Collections.reverseOrder()); &#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(c3.compare" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="404" end="-629"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812863690" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="true, 'D'" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="446" end="-990"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812867209" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="453" end="-991"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812878947" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cc" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="723" end="-696"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812930768" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ards" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="783" end="-625"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812949204" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="762" end="-623"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488813054936" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;Card c4 = new Card('H', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;cards.add(c4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards, cc); &#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="453" end="-624"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488813059325" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot; &quot;" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="452" end="-928"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488813063909" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="' '" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="452" end="-928"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488813073968" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;Card c4 = new Card('H', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;cards.add(c4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards, cc); &#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="453" end="-624"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488813103026" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="8" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="618" end="-765"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889919320" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trumf != ' ') {&#xA;&#x9;&#x9;&#x9;&#x9;if (c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="916" end="-243"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889980858" sizeMeasure="80" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else {&#xA;&#x9;&#x9;&#x9;&#x9;if (c1.getSuit() == 'S'  ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="1183" end="-243"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890049796" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H') {&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (c1.getSuit() == 'S'  ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="969" end="-230"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890147712" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="916" end="-230"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890214293" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="453" end="-930"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890247843" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(trumf" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="759" end="-630"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890320884" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="759" end="-624"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890443082" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;Card c4 = new Card('H', 8);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;cards.add(c4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards, cc); &#xA;&#x9;&#x9;System.out.println(cards);&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="453" end="-625"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890477561" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="453" end="-928"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890609896" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(compare(c1, c2));&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="761" end="-608"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890794669" sizeMeasure="77" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;private boolean descending; &#xA;&#x9;&#xA;&#xA;&#x9;public CardComparator(boolean aceIsBest, char trumf) {&#xA;&#x9;&#x9;this.aceIsBest = aceIsBest; &#xA;&#x9;&#x9;this.trumf = trumf; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator cc = new CardComparator(true, ' ');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;Card c4 = new Card('H', 8);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;cards.add(c4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards, cc); &#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Card a = (descending ? c2 : c1);&#xA;        Card b = (descending ? c1 : c2);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="240" end="-568"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890856167" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a.getSuit() != b.getSuit()) {&#xA;&#x9;&#x9;&#x9;// Spar (S) > Hjerter (H) > Ruter (D) > Kløver (C)&#xA;&#x9;&#x9;&#x9;if (a.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;a.getSuit() == 'S' &amp;&amp; b.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;a.getSuit() == 'H' &amp;&amp; b.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;a.getSuit() == 'D' &amp;&amp; b.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (a.getFace() != b.getFace()) {&#xA;&#x9;&#x9;&#x9;if (aceIsBest &amp;&amp; c1.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (aceIsBest &amp;&amp; b.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return a.getFace() - b" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="959" end="-43"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890877271" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1505" end="-1506"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891100990" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA;&#x9;&#xA;&#xA;&#x9;public CardComparator(boolean aceIsBest, char trumf) {&#xA;&#x9;&#x9;this.aceIsBest = aceIsBest; &#xA;&#x9;&#x9;this.trumf = trumf; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator cc = new CardComparator(true, ' ');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card c1 = new Card('S', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;Card c3 = new Card('H', 10);&#xA;&#x9;&#x9;Card c4 = new Card('H', 8);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(c1);&#xA;&#x9;&#x9;cards.add(c2);&#xA;&#x9;&#x9;cards.add(c3);&#xA;&#x9;&#x9;cards.add(c4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards, cc); &#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (c1.getSuit() != c2.getSuit()) {&#xA;&#x9;&#x9;&#x9;// Spar (S) > Hjerter (H) > Ruter (D) > Kløver (C)&#xA;&#x9;&#x9;&#x9;if (c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c1.getFace() != c2.getFace()) {&#xA;&#x9;&#x9;&#x9;if (aceIsBest &amp;&amp; c1.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (aceIsBest &amp;&amp; c2.getFace() == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return c1.getFace() - c2" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="240" end="-43"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893747128" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trumf != ' ') {&#xA;&#x9;&#x9;&#x9;&#x9;if (c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (c1.getSuit() == 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="917" end="-243"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893755074" sizeMeasure="83" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="937" end="-650"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893756288" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (c1.getSuit() == trumf || " edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="937" end="-650"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893937473" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c2.getSuit() == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (c1.getSuit() == 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c2.getSuit() == 'C" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="1118" end="-297"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893952580" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="){&#xA;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (c1.getSuit() == 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="1118" end="-297"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914410864" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H'){&#xA;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="917" end="-230"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914581821" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(c1.compareTo(c3)" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="759" end="-628"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914598929" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="523" end="-898"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914821504" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="A" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="523" end="-898"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914829924" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="523" end="-898"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914840487" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="453" end="-968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914924965" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his.trumf || &#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != this." edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="974" end="-396"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914947509" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rumf || &#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != " edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="974" end="-396"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915083596" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="453" end="-968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915449270" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" ||&#xA;&#x9;&#x9;&#x9;&#x9;c2.getSuit() == 'D" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="1131" end="-292"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915542192" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="1131" end="-292"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915611200" sizeMeasure="74" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trumf != ' ')&#xA;&#x9;&#x9;&#x9;if (c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H') ||&#xA;&#x9;&#x9;&#x9;c2.getSuit() == 'C'" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="957" end="-290"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915618767" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H') ||&#xA;&#x9;&#x9;&#x9;c2.getSuit() == 'C')" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="957" end="-290"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915622840" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="1131" end="-317"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915776913" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trumf != ' ') {&#xA;&#x9;&#x9;&#x9;&#x9;if (c1.getSuit() == 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H' || c2.getSuit() == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1; &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1; &#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H' || " edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="957" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915796434" sizeMeasure="73" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c1.getSuit() == trumf || &#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'S' &amp;&amp; c2.getSuit() != trumf ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'H' &amp;&amp; c2.getSuit() != 'S' ||&#xA;&#x9;&#x9;&#x9;&#x9;c1.getSuit() == 'D' &amp;&amp; c2.getSuit() != 'H') ||&#xA;&#x9;&#x9;&#x9;c2.getSuit() == 'C'" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="957" end="-290"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915804271" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="1133" end="-290"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488809806722" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488810042025" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488810088059" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488810246589" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488810274414" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488810294010" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488810300214" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488810308064" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488812932989" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488813065608" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488813075616" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488813104860" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488889986587" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890226893" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890326537" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890335631" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890448346" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890475943" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890878503" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914590377" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914600697" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914682461" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914743606" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914845648" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488915091728" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488962022311" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="0.6666666666666666">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488812997920" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488813239241" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488890059800" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488890220300" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488890809159" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488890811924" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488890885231" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488893829193" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488893945500" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488914428687" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488914495200" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488914933590" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488914952122" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488915519187" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488915548016" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488915628372" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488915781673" completion="0.6666666666666666" successCount="2" failureCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="43">
        <attempts timestamp="1488890346755"/>
        <attempts timestamp="1488890361194"/>
        <attempts timestamp="1488890364697"/>
        <attempts timestamp="1488890370160"/>
        <attempts timestamp="1488890371875"/>
        <attempts timestamp="1488890373569"/>
        <attempts timestamp="1488890374938"/>
        <attempts timestamp="1488890375538"/>
        <attempts timestamp="1488890376086"/>
        <attempts timestamp="1488890376657"/>
        <attempts timestamp="1488890384446"/>
        <attempts timestamp="1488890385610"/>
        <attempts timestamp="1488890392371"/>
        <attempts timestamp="1488890396352"/>
        <attempts timestamp="1488890457728"/>
        <attempts timestamp="1488890487806"/>
        <attempts timestamp="1488890505933"/>
        <attempts timestamp="1488890509682"/>
        <attempts timestamp="1488890510929"/>
        <attempts timestamp="1488890511514"/>
        <attempts timestamp="1488890512114"/>
        <attempts timestamp="1488890512699"/>
        <attempts timestamp="1488890513284"/>
        <attempts timestamp="1488890514300"/>
        <attempts timestamp="1488890514900"/>
        <attempts timestamp="1488890515753"/>
        <attempts timestamp="1488890516517"/>
        <attempts timestamp="1488890517219"/>
        <attempts timestamp="1488892062909"/>
        <attempts timestamp="1488892150761"/>
        <attempts timestamp="1488892155189"/>
        <attempts timestamp="1488892156737"/>
        <attempts timestamp="1488892159476"/>
        <attempts timestamp="1488892160657"/>
        <attempts timestamp="1488892162060"/>
        <attempts timestamp="1488892163425"/>
        <attempts timestamp="1488892164572"/>
        <attempts timestamp="1488892165820"/>
        <attempts timestamp="1488892166790"/>
        <attempts timestamp="1488892363318"/>
        <attempts timestamp="1488892377990"/>
        <attempts timestamp="1488892381987"/>
        <attempts timestamp="1488892383344"/>
        <attempts timestamp="1488892385109"/>
        <attempts timestamp="1488892386582"/>
        <attempts timestamp="1488892387898"/>
        <attempts timestamp="1488892388632"/>
        <attempts timestamp="1488892389536"/>
        <attempts timestamp="1488892390036"/>
        <attempts timestamp="1488892390537"/>
        <attempts timestamp="1488892492625"/>
        <attempts timestamp="1488892512050"/>
        <attempts timestamp="1488892517508"/>
        <attempts timestamp="1488892518740"/>
        <attempts timestamp="1488892519610"/>
        <attempts timestamp="1488892520304"/>
        <attempts timestamp="1488892521193"/>
        <attempts timestamp="1488892521917"/>
        <attempts timestamp="1488892522534"/>
        <attempts timestamp="1488892523165"/>
        <attempts timestamp="1488892527656"/>
        <attempts timestamp="1488892530474"/>
        <attempts timestamp="1488892531845"/>
        <attempts timestamp="1488892534763"/>
        <attempts timestamp="1488914748836"/>
        <attempts timestamp="1488914750127"/>
        <attempts timestamp="1488914750985"/>
        <attempts timestamp="1488914760772"/>
        <attempts timestamp="1488914762431"/>
        <attempts timestamp="1488914763733"/>
        <attempts timestamp="1488914764430"/>
        <attempts timestamp="1488914764794"/>
        <attempts timestamp="1488914765235"/>
        <attempts timestamp="1488914766174"/>
        <attempts timestamp="1488914767332"/>
        <attempts timestamp="1488914772174"/>
        <attempts timestamp="1488914780254"/>
        <attempts timestamp="1488914782447"/>
        <attempts timestamp="1488914783647"/>
        <attempts timestamp="1488914784695"/>
        <attempts timestamp="1488914850413"/>
        <attempts timestamp="1488914851148"/>
        <attempts timestamp="1488914851826"/>
        <attempts timestamp="1488914852581"/>
        <attempts timestamp="1488914853489"/>
        <attempts timestamp="1488914854690"/>
        <attempts timestamp="1488914855285"/>
        <attempts timestamp="1488914855656"/>
        <attempts timestamp="1488914855910"/>
        <attempts timestamp="1488914856605"/>
        <attempts timestamp="1488914858256"/>
        <attempts timestamp="1488914859807"/>
        <attempts timestamp="1488914860804"/>
        <attempts timestamp="1488914864767"/>
        <attempts timestamp="1488914865343"/>
        <attempts timestamp="1488914865947"/>
        <attempts timestamp="1488914867584"/>
        <attempts timestamp="1488914873967"/>
        <attempts timestamp="1488915095234"/>
        <attempts timestamp="1488915095787"/>
        <attempts timestamp="1488915096220"/>
        <attempts timestamp="1488915096817"/>
        <attempts timestamp="1488915097410"/>
        <attempts timestamp="1488915098025"/>
        <attempts timestamp="1488915098692"/>
        <attempts timestamp="1488915099174"/>
        <attempts timestamp="1488915099648"/>
        <attempts timestamp="1488915100194"/>
        <attempts timestamp="1488915100948"/>
        <attempts timestamp="1488915101290"/>
        <attempts timestamp="1488915107894"/>
        <attempts timestamp="1488915128356"/>
        <attempts timestamp="1488915134248"/>
        <attempts timestamp="1488962204865"/>
        <attempts timestamp="1488962209790"/>
        <attempts timestamp="1488962211255"/>
        <attempts timestamp="1488962211958"/>
        <attempts timestamp="1488962212591"/>
        <attempts timestamp="1488962213340"/>
        <attempts timestamp="1488962214442"/>
        <attempts timestamp="1488962219641"/>
        <attempts timestamp="1488962220976"/>
        <attempts timestamp="1488962228601"/>
        <attempts timestamp="1488962234127"/>
        <attempts timestamp="1488962236112"/>
        <attempts timestamp="1488962238035"/>
        <attempts timestamp="1488962370889"/>
        <attempts timestamp="1488962372058"/>
        <attempts timestamp="1488962373105"/>
        <attempts timestamp="1488962375744"/>
        <attempts timestamp="1488962378660"/>
        <attempts timestamp="1488962380244"/>
        <attempts timestamp="1488962385349"/>
        <attempts timestamp="1488962386700"/>
        <attempts timestamp="1488962387616"/>
        <attempts timestamp="1488962388554"/>
        <attempts timestamp="1488962389785"/>
        <attempts timestamp="1488962391618"/>
        <attempts timestamp="1488962392372"/>
        <attempts timestamp="1488962393029"/>
        <attempts timestamp="1488962398414"/>
        <attempts timestamp="1488962399563"/>
        <attempts timestamp="1488962402595"/>
        <attempts timestamp="1488962403896"/>
        <attempts timestamp="1488962407870"/>
        <attempts timestamp="1488962408551"/>
        <attempts timestamp="1488962409972"/>
        <attempts timestamp="1488962411486"/>
        <attempts timestamp="1488962412171"/>
        <attempts timestamp="1488962412871"/>
        <attempts timestamp="1488962413888"/>
        <attempts timestamp="1488962415119"/>
        <attempts timestamp="1488962416472"/>
        <attempts timestamp="1488962418340"/>
        <attempts timestamp="1488962419189"/>
        <attempts timestamp="1488962419990"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="1">
        <attempts timestamp="1488892099684"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="3">
        <attempts timestamp="1488890349590"/>
        <attempts timestamp="1488890454822"/>
        <attempts timestamp="1488890482594"/>
        <attempts timestamp="1488890488866"/>
        <attempts timestamp="1488892061208"/>
        <attempts timestamp="1488892267558"/>
        <attempts timestamp="1488892574658"/>
        <attempts timestamp="1488892578885"/>
        <attempts timestamp="1488914753857"/>
        <attempts timestamp="1488914879004"/>
        <attempts timestamp="1488915110446"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
