<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488534104411" sizeMeasure="64">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.Comparator;&#xA;&#xA;public class Card implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(checkCard(suit,face))) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig sort eller nummer!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean checkCard(char suit, int face) {&#xA;&#x9;&#x9;if ((suit == 'S' || suit == 'H' || suit == 'C' || suit == 'D') &amp;&amp; (face >=1 &amp;&amp; face &lt;=13)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;/*&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return (int) (this.getFace() - o.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return (int) (this.getSuit() - o.getSuit());&#xA;&#x9;}*/&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return suit + String.valueOf(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('H',12);&#xA;&#x9;&#x9;card.checkCard('H', 12);&#xA;&#x9;&#x9;card.getFace();&#xA;&#x9;&#x9;card.getSuit();&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488796699490" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(checkCard(suit,face))) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig sort eller nummer!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean checkCard(char suit, int face) {&#xA;&#x9;&#x9;if ((suit == 'S' || suit == 'H' || suit == 'C' || suit == 'D') &amp;&amp; (face >=1 &amp;&amp; face &lt;=13)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;/*&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return (int) (this.getFace() - o.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return (int) (this.getSuit() - o.getSuit());&#xA;&#x9;}*/&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return suit + String.valueOf(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('H',12);&#xA;&#x9;&#x9;card.checkCard('H', 12);&#xA;&#x9;&#x9;card.getFace();&#xA;&#x9;&#x9;card.getSuit();&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;if (this.getSuit() != card.getSuit()) {&#xA;&#x9;&#x9;&#x9;return this.getSuit() - card.getSuit();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() != card.getFace()) {&#xA;&#x9;&#x9;&#x9;return this.getFace() - card.getFace();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="21" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488799239219" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;private char[] suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (!(checkCard(suit,face))) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig sort eller nummer!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean checkCard(char suit, int face) {&#xA;&#x9;&#x9;if ((suit == 'S' || suit == 'H' || suit == 'C' || suit == 'D') &amp;&amp; (face >=1 &amp;&amp; face &lt;=13)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;/*&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (this.getSuit() == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return (int) (this.getFace() - o.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return (int) (this.getSuit() - o.getSuit());&#xA;&#x9;}*/&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return suit + String.valueOf(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('H',12);&#xA;&#x9;&#x9;card.checkCard('H', 12);&#xA;&#x9;&#x9;card.getFace();&#xA;&#x9;&#x9;card.getSuit();&#xA;&#x9;&#x9;System.out.println(card);&#xA;&#x9;}&#xA;&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;if (this.getSuit() != card.getSuit()) {&#xA;&#x9;&#x9;&#x9;for (char i : suits) {&#xA;&#x9;&#x9;&#x9;&#x9;if (i == card.getSuit()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if (i == this.getSuit()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() != card.getFace()) {&#xA;&#x9;&#x9;&#x9;return - (this.getFace() - card.getFace()" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="21" end="-32"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801331589" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="630" end="-598"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488532859586" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488535898535" sizeMeasure="56" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.lang.reflect.Array;&#xA;import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collections;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;private boolean ess; &#xA;&#x9;private char trumf;&#xA;&#x9;private ArrayList&lt;Character> validSuits = new ArrayList&lt;>(Arrays.asList('S','H','D','C'));&#xA;&#x9;private static List&lt;String> faces = new ArrayList&lt;>(Arrays.asList(&quot;king&quot;,&quot;queen&quot;,&quot;knight&quot;,&quot;ten&quot;,&quot;nine&quot;,&quot;eight&quot;,&quot;seven&quot;,&quot;six&quot;,&quot;five&quot;,&quot;four&quot;,&quot;three&quot;,&quot;two&quot;)); &#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;/*&#xA;&#x9;public void rangeSuits(char trumf) {&#xA;&#x9;&#x9;if (trumf == '') {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}*/&#xA;&#x9;&#xA;&#x9;public void rangeFaces(boolean ess) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (ess = true) {&#xA;&#x9;&#x9;&#x9;faces.add(0,&quot;ace&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (ess = false) {&#xA;&#x9;&#x9;&#x9;faces.add(&quot;ace&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;public int compareTo(Card card1, Card card2) {&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;System.out.println(faces);&#xA;&#x9;}&#xA;&#xA;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-2"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488536026102" sizeMeasure="57" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardComparator heiei = new CardComparator(true,'S');&#xA;&#x9;&#x9;System.out.println(heiei" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="1079" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488536035878" sizeMeasure="57" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="faces" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="1153" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1094" charEnd="1099" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488536128264" sizeMeasure="56" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;String> rangeFaces(boolean ess) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (ess = true) {&#xA;&#x9;&#x9;&#x9;faces.add(0,&quot;ace&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (ess = false) {&#xA;&#x9;&#x9;&#x9;faces.add(&quot;ace&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return faces;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="722" end="-309"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1114" charEnd="1119" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488536168274" sizeMeasure="57" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="heiei.rangeFaces(true" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1154" end="-40"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488536189585" sizeMeasure="57" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="false,'S');&#xA;&#x9;&#x9;heiei.rangeFaces(fals" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1141" end="-41"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488536207629" sizeMeasure="57" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1," edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="850" end="-367"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488536614026" sizeMeasure="57" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1219" end="-1220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488792872369" sizeMeasure="48" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//private static List&lt;String> faces = new ArrayList&lt;>(Arrays.asList(&quot;king&quot;,&quot;queen&quot;,&quot;knight&quot;,&quot;ten&quot;,&quot;nine&quot;,&quot;eight&quot;,&quot;seven&quot;,&quot;six&quot;,&quot;five&quot;,&quot;four&quot;,&quot;three&quot;,&quot;two&quot;));&#xA;&#x9;private static List&lt;Integer> faces = new ArrayList&lt;>(Arrays.asList(13,12,11,10,9,8,7,6,5,4,3,2));&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compareTo(Card c1, Card c2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public List&lt;Integer> rangeFaces(boolean ess) {&#xA;&#x9;&#x9;if (ess = true) {&#xA;&#x9;&#x9;&#x9;int ace = 14;&#xA;&#x9;&#x9;&#x9;faces.add(0,ace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (ess = false) {&#xA;&#x9;&#x9;&#x9;int ace = 1;&#xA;&#x9;&#x9;&#x9;faces.add(-1,ace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return faces" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="384" end="-169"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="202" charEnd="216" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="321" charEnd="331" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488794121365" sizeMeasure="55" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suits = new ArrayList&lt;>(Arrays.asList('S','H','D','C'));&#xA;&#x9;private static List&lt;Integer> faces = new ArrayList&lt;>(Arrays.asList(13,12,11,10,9,8,7,6,5,4,3,2));&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compareTo(Card c1, Card c2) {&#xA;&#x9;&#x9;int face1 = 0;&#xA;&#x9;&#x9;int face2 = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ((c1.getFace() = 1) &amp;&amp; (ess = true)) {&#xA;&#x9;&#x9;&#x9;face1 = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else if ()&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return pos;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="321" end="-366"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="660" charEnd="672" severity="2" problemCategory="20" problemType="1610612959"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="729" charEnd="730" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="747" charEnd="750" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="202" charEnd="216" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488794679779" sizeMeasure="55" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1119" end="-1120"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="202" charEnd="216" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="660" charEnd="672" severity="2" problemCategory="20" problemType="1610612959"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="729" charEnd="730" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="747" charEnd="750" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488796828860" sizeMeasure="59" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(Card c1, Card c2) {&#xA;&#x9;&#x9;int face1 = 0;&#xA;&#x9;&#x9;int face2 = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ((c1.getFace() == 1) &amp;&amp; (ess = true)) {&#xA;&#x9;&#x9;&#x9;face1 = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else if (c2.getFace() == 14 &amp;&amp; (ess = false)) {&#xA;&#x9;&#x9;&#x9;face2 = 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (c1.getSuit() == trumf &amp;&amp;  )&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="593" end="-370"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="817" charEnd="819" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488798941696" sizeMeasure="51" warningCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//private static List&lt;Integer> faces = new ArrayList&lt;>(Arrays.asList(13,12,11,10,9,8,7,6,5,4,3,2));&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;if (trumf == 'H' || trumf == 'D' || trumf == 'C') {&#xA;&#x9;&#x9;&#x9;suits.remove(trumf - 66);&#xA;&#x9;&#x9;&#x9;suits.add(0, trumf);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;int face1 = 0;&#xA;&#x9;&#x9;int face2 = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ((c1.getFace() == 1) &amp;&amp; (ess = true)) {&#xA;&#x9;&#x9;&#x9;face1 = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;face1 = c1.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c2.getFace() == 1 &amp;&amp; (ess = true)) {&#xA;&#x9;&#x9;&#x9;face2 = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;face2 = c2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c1.getSuit() == c2.getSuit()) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="379" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="172" charEnd="186" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="733" charEnd="738" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="750" charEnd="755" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488799239228" sizeMeasure="51" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;int face1 = 0;&#xA;&#x9;&#x9;int face2 = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ((c1.getFace() == 1) &amp;&amp; (ess = true)) {&#xA;&#x9;&#x9;&#x9;face1 = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;face1 = c1.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c2.getFace() == 1 &amp;&amp; (ess = true)) {&#xA;&#x9;&#x9;&#x9;face2 = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;face2 = c2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c1.getSuit() == c2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return (face1 - face2);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return (suits.indexOf(c2.getSuit()) - suits.indexOf(c1.getSuit()));&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="661" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="172" charEnd="186" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="284" charEnd="289" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488799433416" sizeMeasure="49" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Character> suits = new ArrayList&lt;>(Arrays.asList('S','H','D','C'));&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean a, char trumf) {&#xA;&#x9;&#x9;this.ess = a;&#xA;&#x9;&#x9;if (trumf == 'H' || trumf == 'D' || trumf == 'C') {&#xA;&#x9;&#x9;&#x9;suits.remove(trumf - 66);&#xA;&#x9;&#x9;&#x9;suits.add(0, trumf);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;int c1face = 0;&#xA;&#x9;&#x9;int c2face = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ((c1.getFace() == 1) &amp;&amp; (ess = true)) {&#xA;&#x9;&#x9;&#x9;c1face = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;c1face = c1.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c2.getFace() == 1 &amp;&amp; (ess = true)) {&#xA;&#x9;&#x9;&#x9;c2face = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;c2face = c2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c1.getSuit() == c2.getSuit()) {&#xA;&#x9;&#x9;&#x9;return (c1face - c2face" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="279" end="-102"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488799449876" sizeMeasure="49" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(c2.getFace() == 1)" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="723" end="-245"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="264" charEnd="267" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488799482455" sizeMeasure="49" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c1.getFace() == 1 &amp;&amp; ess == true) {&#xA;&#x9;&#x9;&#x9;c1face = 14;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;c1face = c1.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c2.getFace() == 1 &amp;&amp; ess == true" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="619" end="-229"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="51" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="113" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488799616308" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="util.ArrayList;&#xA;import java.util.Array" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="33" end="-848"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801554029" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="911" end="-6"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488535898415" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488536025999" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488536035780" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488536128186" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488536168188" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488536189495" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488536207544" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488536224498" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488792872297" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488799240817" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488799434950" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488799450751" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488799483557" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488799558051" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="24">
        <attempts timestamp="1488799778120"/>
        <attempts timestamp="1488799783862"/>
        <attempts timestamp="1488799789350"/>
        <attempts timestamp="1488799792376"/>
        <attempts timestamp="1488799794972"/>
        <attempts timestamp="1488799943940"/>
        <attempts timestamp="1488800008434"/>
        <attempts timestamp="1488800011099"/>
        <attempts timestamp="1488800012952"/>
        <attempts timestamp="1488800013799"/>
        <attempts timestamp="1488800014355"/>
        <attempts timestamp="1488800022103"/>
        <attempts timestamp="1488800022873"/>
        <attempts timestamp="1488800023467"/>
        <attempts timestamp="1488800026837"/>
        <attempts timestamp="1488800034253"/>
        <attempts timestamp="1488800035284"/>
        <attempts timestamp="1488800036294"/>
        <attempts timestamp="1488800037219"/>
        <attempts timestamp="1488800038074"/>
        <attempts timestamp="1488800051271"/>
        <attempts timestamp="1488800057155"/>
        <attempts timestamp="1488800167298"/>
        <attempts timestamp="1488800522748"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="6">
        <attempts timestamp="1488799889681"/>
        <attempts timestamp="1488799898194"/>
        <attempts timestamp="1488799899497"/>
        <attempts timestamp="1488799900100"/>
        <attempts timestamp="1488800165243"/>
        <attempts timestamp="1488800431505"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="9">
        <attempts timestamp="1488799742553"/>
        <attempts timestamp="1488799838587"/>
        <attempts timestamp="1488799918803"/>
        <attempts timestamp="1488800075467"/>
        <attempts timestamp="1488800104166"/>
        <attempts timestamp="1488800138521"/>
        <attempts timestamp="1488800212618"/>
        <attempts timestamp="1488800434568"/>
        <attempts timestamp="1488800509515"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
