<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringMergingIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Modify the code for the StringMergingIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIteratorProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIteratorProgram"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="debugging.StringMergingIterator*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488800870265" sizeMeasure="52">
          <edit xsi:type="exercise:StringEdit" storedString="package debugging;&#xA;&#xA;import java.util.Iterator;&#xA;import java.util.NoSuchElementException;&#xA;&#xA;public class StringMergingIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;private Iterator&lt;String> first;&#xA;&#x9;private Iterator&lt;String> second;&#xA;&#x9;private boolean turnSwitch;&#xA;&#xA;&#x9;public StringMergingIterator(Iterator&lt;String> first, Iterator&lt;String> second){&#xA;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;this.turnSwitch = true;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! hasNext()){ throw new NoSuchElementException(); }&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! first.hasNext()){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if(turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(!turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return result;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488799732714" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488799836559" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488799916585" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488800073349" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488800102240" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488800136264" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488800210586" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488800507566" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488800888125" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488800898563" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488801258519" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488801943432" mode="debug"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a" performedCount="2">
        <attempts timestamp="1488799733273"/>
        <attempts timestamp="1488799789353"/>
      </proposals>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="10">
        <attempts timestamp="1488799733273"/>
        <attempts timestamp="1488799789353"/>
        <attempts timestamp="1488799837160"/>
        <attempts timestamp="1488799917045"/>
        <attempts timestamp="1488800038078"/>
        <attempts timestamp="1488800073933"/>
        <attempts timestamp="1488800102632"/>
        <attempts timestamp="1488800136748"/>
        <attempts timestamp="1488800211036"/>
        <attempts timestamp="1488800507854"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="24">
        <attempts timestamp="1488799778120"/>
        <attempts timestamp="1488799783862"/>
        <attempts timestamp="1488799789350"/>
        <attempts timestamp="1488799792376"/>
        <attempts timestamp="1488799794972"/>
        <attempts timestamp="1488799943940"/>
        <attempts timestamp="1488800008434"/>
        <attempts timestamp="1488800011099"/>
        <attempts timestamp="1488800012952"/>
        <attempts timestamp="1488800013799"/>
        <attempts timestamp="1488800014355"/>
        <attempts timestamp="1488800022103"/>
        <attempts timestamp="1488800022873"/>
        <attempts timestamp="1488800023467"/>
        <attempts timestamp="1488800026837"/>
        <attempts timestamp="1488800034253"/>
        <attempts timestamp="1488800035284"/>
        <attempts timestamp="1488800036294"/>
        <attempts timestamp="1488800037219"/>
        <attempts timestamp="1488800038074"/>
        <attempts timestamp="1488800051271"/>
        <attempts timestamp="1488800057155"/>
        <attempts timestamp="1488800167298"/>
        <attempts timestamp="1488800522748"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="6">
        <attempts timestamp="1488799889681"/>
        <attempts timestamp="1488799898194"/>
        <attempts timestamp="1488799899497"/>
        <attempts timestamp="1488799900100"/>
        <attempts timestamp="1488800165243"/>
        <attempts timestamp="1488800431505"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="9">
        <attempts timestamp="1488799742554"/>
        <attempts timestamp="1488799838587"/>
        <attempts timestamp="1488799918803"/>
        <attempts timestamp="1488800075467"/>
        <attempts timestamp="1488800104167"/>
        <attempts timestamp="1488800138521"/>
        <attempts timestamp="1488800212618"/>
        <attempts timestamp="1488800434569"/>
        <attempts timestamp="1488800509515"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
