<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806081754" sizeMeasure="79" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.Comparator;&#xA;&#xA;public class Card implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;char color;&#xA;&#x9;int value;&#xA;&#x9;String rank = (&quot;CDHS&quot;);&#xA;&#x9;&#xA;&#x9;//Konstruktør&#xA;&#x9;public Card(char color, int value) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;validCol(color);&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;validVal(value);&#xA;&#x9;&#x9;this.value = value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//public static void main(String[] args) {&#xA;&#x9;//&#x9;Card card1 = new Card('S', 11);&#xA;&#x9;//&#x9;System.out.println(card1.toString());&#xA;&#x9;//}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void validCol(char col) {&#xA;&#x9;&#x9;if (col != 'S' &amp;&amp; col != 'H' &amp;&amp; col != 'D' &amp;&amp; col != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid color.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void validVal(int val) {&#xA;&#x9;&#x9;if (val &lt; 1 || val > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid value&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return color;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(color) + Integer.toString(value);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getColorValue(Card x) {&#xA;&#x9;&#x9;int colorValue = rank.indexOf(x.color);&#xA;&#x9;&#x9;return colorValue;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card x, Card y) {&#xA;&#x9;if (getColorValue(x) == getColorValue(y)) {&#xA;&#x9;&#x9;return Integer.compare(x.value, y.value);&#xA;&#x9;}&#xA;&#x9;else { return Integer.compare(getColorValue(x), getColorValue(y));&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (x.color == y.color) {&#xA;&#x9;&#x9;&#x9;return &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806457306" sizeMeasure="85" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new String (&quot;CDHS&quot;);&#xA;&#x9;&#xA;&#x9;//Konstruktør&#xA;&#x9;public Card(char color, int value) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;validCol(color);&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;validVal(value);&#xA;&#x9;&#x9;this.value = value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//public static void main(String[] args) {&#xA;&#x9;//&#x9;Card card1 = new Card('S', 11);&#xA;&#x9;//&#x9;System.out.println(card1.toString());&#xA;&#x9;//}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void validCol(char col) {&#xA;&#x9;&#x9;if (col != 'S' &amp;&amp; col != 'H' &amp;&amp; col != 'D' &amp;&amp; col != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid color.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void validVal(int val) {&#xA;&#x9;&#x9;if (val &lt; 1 || val > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid value&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return color;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(color) + Integer.toString(value);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getColorValue(Card x) {&#xA;&#x9;&#x9;int colorValue = rank.indexOf(x.color);&#xA;&#x9;&#x9;return colorValue;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card x, Card y) {&#xA;&#x9;&#x9;int xcolor = getColorValue(x);&#xA;&#x9;&#x9;int ycolor = getColorValue(y);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;if (getColorValue(x) == getColorValue(y)) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return Integer.x.value.compareTo(Integer.y.value);&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="141" end="-207"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806988367" sizeMeasure="79" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int colorValue;&#xA;&#x9;String rank = new String (&quot;CDHS&quot;);&#xA;&#x9;&#xA;&#x9;//Konstruktør&#xA;&#x9;public Card(char color, int value) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;validCol(color);&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;validVal(value);&#xA;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;this.colorValue = rank.indexOf(color);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//public static void main(String[] args) {&#xA;&#x9;//&#x9;Card card1 = new Card('S', 11);&#xA;&#x9;//&#x9;System.out.println(card1.toString());&#xA;&#x9;//}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void validCol(char col) {&#xA;&#x9;&#x9;if (col != 'S' &amp;&amp; col != 'H' &amp;&amp; col != 'D' &amp;&amp; col != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid color.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void validVal(int val) {&#xA;&#x9;&#x9;if (val &lt; 1 || val > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid value&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return color;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(color) + Integer.toString(value);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card x, Card y) {&#xA;&#x9;if (x.colorValue == y.colorValue) {&#xA;&#x9;&#x9;return Integer.compare(x.value, y.value);&#xA;&#x9;}&#xA;&#x9;else { return Integer.compare(x.colorValue, y.colorValue);" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="127" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807656555" sizeMeasure="77" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;char color;&#xA;&#x9;int value;&#xA;&#x9;int colorValue;&#xA;&#x9;String rank = new String (&quot;CDHS&quot;);&#xA;&#x9;&#xA;&#x9;//Konstruktør&#xA;&#x9;public Card(char color, int value) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;validCol(color);&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;validVal(value);&#xA;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;this.colorValue = rank.indexOf(color);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//public static void main(String[] args) {&#xA;&#x9;//&#x9;Card card1 = new Card('S', 11);&#xA;&#x9;//&#x9;System.out.println(card1.toString());&#xA;&#x9;//}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void validCol(char col) {&#xA;&#x9;&#x9;if (col != 'S' &amp;&amp; col != 'H' &amp;&amp; col != 'D' &amp;&amp; col != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid color.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void validVal(int val) {&#xA;&#x9;&#x9;if (val &lt; 1 || val > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid value&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return color;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(color) + Integer.toString(value);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card x, Card y) {&#xA;&#x9;if (x.colorValue == y.colorValue) {&#xA;&#x9;&#x9;return Integer.compare(x.value, y.value);&#xA;&#x9;}&#xA;&#x9;else { return Integer.compare(x.colorValue, y.colorValue);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card x) {&#xA;&#x9;&#x9;if (this.colorValue == x.colorValue) {&#xA;&#x9;&#x9;&#x9;return Integer.compare(this.value, x.value);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { return Integer.compare(this.colorValue, x.colorValue);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="96" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807669005" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="386" end="-1034"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808645528" sizeMeasure="71" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ble&lt;Card> {&#xA;&#x9;&#xA;&#x9;char color;&#xA;&#x9;int value;&#xA;&#x9;int colorValue;&#xA;&#x9;String rank = new String (&quot;CDHS&quot;);&#xA;&#x9;&#xA;&#x9;//Konstruktør&#xA;&#x9;public Card(char color, int value) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;validCol(color);&#xA;&#x9;&#x9;this.color = color;&#xA;&#x9;&#x9;validVal(value);&#xA;&#x9;&#x9;this.value = value;&#xA;&#x9;&#x9;this.colorValue = rank.indexOf(color);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;//public static void main(String[] args) {&#xA;&#x9;//&#x9;Card card1 = new Card('S', 11);&#xA;&#x9;//&#x9;System.out.println(card1.toString());&#xA;&#x9;//}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void validCol(char col) {&#xA;&#x9;&#x9;if (col != 'S' &amp;&amp; col != 'H' &amp;&amp; col != 'D' &amp;&amp; col != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid color.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void validVal(int val) {&#xA;&#x9;&#x9;if (val &lt; 1 || val > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid value&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return color;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return value;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(color) + Integer.toString(value);&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card x) {&#xA;&#x9;&#x9;if (this.colorValue == x.colorValue) {&#xA;&#x9;&#x9;&#x9;return Integer.compare(this.value, x.value);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { return Integer.compare(this.colorValue, x.colorValue);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="87" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808669898" sizeMeasure="70" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card x) {&#xA;&#x9;&#x9;if (this.colorValue == x.colorValue) {&#xA;&#x9;&#x9;&#x9;return Integer.compare(this.value, x.value);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { return Integer.compare(this.colorValue, x.colorValue);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="980" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810890962" sizeMeasure="71" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card test1 = new Card('S', 7);&#xA;&#x9;&#x9;Card test2 = new Card('C', 12);&#xA;&#x9;&#x9;System.out.println(test1.compareTo(test2));" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1237" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488814436800" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// x &lt; this = -1 &#xA;&#x9;&#x9;// x > this =  1&#xA;&#x9;&#x9;// x = this =  0" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1026" end="-334"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808470689" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809711095" sizeMeasure="43">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;boolean ace; // True om ess er størst, false om ess er minst&#xA;&#x9;char trump; // Hvilken farge er trump-sort&#xA;&#xA;&#x9;public CardComparator(boolean ace, char trump) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;if(trump == 'S' || trump == 'H' || trump == 'D' || trump == 'C') {&#xA;&#x9;&#x9;&#x9;this.trump = trump;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setAceValue(Card x) {&#xA;&#x9;&#x9;if (ace == true) {&#xA;&#x9;&#x9;&#x9;if (x.value == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;x.value = 14;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setTrumpColor(Card x) {&#xA;&#x9;&#x9;if(x.colorValue == trump) {&#xA;&#x9;&#x9;&#x9;x.colorValue = 10;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card x, Card y) {&#xA;&#x9;if (x.colorValue == y.colorValue) {&#xA;&#x9;&#x9;return Integer.compare(x.value, y.value);&#xA;&#x9;}&#xA;&#x9;else { return Integer.compare(x.colorValue, y.colorValue);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488813163542" sizeMeasure="56" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;boolean ace; // True om ess er størst, false om ess er minst&#xA;&#x9;char trump; // Hvilken farge er trump-sort&#xA;&#x9;List&lt;Integer> aceValues = new ArrayList&lt;Integer>();&#xA;&#xA;&#x9;&#xA;&#xA;&#x9;public CardComparator(boolean ace, char trump) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;if (ace == true) {&#xA;&#x9;&#x9;&#x9;List&lt;Integer> aceValues = new ArrayList&lt;Integer>(2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;List&lt;Integer> aceValues = new ArrayList&lt;Integer>(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(trump == 'S' || trump == 'H' || trump == 'D' || trump == 'C') {&#xA;&#x9;&#x9;&#x9;this.trump = trump;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setTrumpColor(Card x) {&#xA;&#x9;&#x9;if(x.colorValue == trump) {&#xA;&#x9;&#x9;&#x9;x.colorValue = 10;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card x, Card y) {&#xA;&#x9;&#x9;&#x9;&#x9;if (x.colorValue == y.colorValue) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return Integer.compare(aceValues.indexOf(x.value), aceValues.indexOf(y.value));&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if (x.color == trump){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return Integer.compare(99, y.colorValue);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else if(y.color == trump){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return Integer.compare(x.colorValue, 99);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else { return Integer.compare(x.colorValue, y.colorValue);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="38" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488814029299" sizeMeasure="57" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Arrays;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;boolean ace; // True om ess er størst, false om ess er minst&#xA;&#x9;char trump; // Hvilken farge er trump-sort&#xA;&#x9;List&lt;Integer> aceValues = new ArrayList&lt;Integer>();&#xA;&#xA;&#x9;&#xA;&#xA;&#x9;public CardComparator(boolean ace, char trump) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;if (ace == true) {&#xA;&#x9;&#x9;&#x9;aceValues.add(2); aceValues.add(3); aceValues.add(4); aceValues.add(5); aceValues.add(6);&#xA;&#x9;&#x9;&#x9;aceValues.add(7); aceValues.add(8); aceValues.add(9); aceValues.add(10); aceValues.add(11);&#xA;&#x9;&#x9;&#x9;aceValues.add(12); aceValues.add(13); aceValues.add(1);&#xA;&#x9;&#x9;&#x9;//List&lt;Integer> aceValues = new ArrayList&lt;Integer>[2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 1];&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;aceValues.add(1); aceValues.add(2); aceValues.add(3); aceValues.add(4); aceValues.add(5);&#xA;&#x9;&#x9;&#x9;aceValues.add(6); aceValues.add(7); aceValues.add(8); aceValues.add(9); aceValues.add(10);&#xA;&#x9;&#x9;&#x9;aceValues.add(11); aceValues.add(12); aceValues.add(13); &#xA;&#x9;&#x9;&#x9;//List&lt;Integer> aceValues = new ArrayList&lt;Integer>(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(trump == 'S' || trump == 'H' || trump == 'D' || trump == 'C') {&#xA;&#x9;&#x9;&#x9;this.trump = trump" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="66" end="-444"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488814063931" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;boolean ace; // True om ess er størst, false om ess er minst&#xA;&#x9;char trump; // Hvilken farge er trump-sort&#xA;&#x9;List&lt;Integer> aceValues = new ArrayList&lt;Integer>();&#xA;&#xA;&#x9;&#xA;&#xA;&#x9;public CardComparator(boolean ace, char trump) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;if (ace == true) {&#xA;&#x9;&#x9;&#x9;aceValues.add(2); aceValues.add(3); aceValues.add(4); aceValues.add(5); aceValues.add(6);&#xA;&#x9;&#x9;&#x9;aceValues.add(7); aceValues.add(8); aceValues.add(9); aceValues.add(10); aceValues.add(11);&#xA;&#x9;&#x9;&#x9;aceValues.add(12); aceValues.add(13); aceValues.add(1);&#xA;&#x9;&#x9;&#x9;//List&lt;Integer> aceValues = new ArrayList&lt;Integer>[2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 1];&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;aceValues.add(1); aceValues.add(2); aceValues.add(3); aceValues.add(4); aceValues.add(5);&#xA;&#x9;&#x9;&#x9;aceValues.add(6); aceValues.add(7); aceValues.add(8); aceValues.add(9); aceValues.add(10);&#xA;&#x9;&#x9;&#x9;aceValues.add(11); aceValues.add(12); aceValues.add(13); &#xA;&#x9;&#x9;&#x9;//List&lt;Integer> aceValues = new ArrayList&lt;Integer>(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="66" end="-538"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488814240336" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public static void main(String[] args) {&#xA;&#x9;&#x9;CardComparator test0 = new CardComparator(true, 'H');&#xA;&#x9;&#x9;Card test1 = new Card('S', 7);&#xA;&#x9;&#x9;Card test2 = new Card('H', 2);&#xA;&#x9;&#x9;System.out.println(test0.compare(test1, test2));&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1658" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488814373850" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// x &lt; y = -1 &#xA;&#x9;&#x9;// x > y =  1&#xA;&#x9;&#x9;// x = y =  0&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1282" end="-603"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488810908672" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488814242792" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488814455871" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488807934614" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488811040478" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488814071166" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
