<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="TwitterComparison">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the UserNameComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.twitter.UserNameComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the FollowersCountComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.twitter.FollowersCountComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TweetsCountComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.twitter.TweetsCountComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the UserNameComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.twitter.UserNameComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the FollowersCountComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.twitter.FollowersCountComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the UserNameComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.twitter.UserNameComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.twitter.TwitterAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the FollowersCountComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.twitter.FollowersCountComparatorTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the UserNameComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.twitter.UserNameComparatorTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetsCountComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.twitter.TweetsCountComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.twitter.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487847479508" sizeMeasure="11">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces.twitter;&#xA;&#xA;import java.util.Comparator;&#xA;&#xA;public class UserNameComparator implements Comparator&lt;TwitterAccount> {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(TwitterAccount acc1, TwitterAccount acc2) {&#x9;&#xA;&#x9;&#x9;return acc1.getUserName().compareTo(acc2.getUserName());&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487847479508" sizeMeasure="12">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces.twitter;&#xA;&#xA;import java.util.Comparator;&#xA;&#xA;public class FollowersCountComparator implements Comparator&lt;TwitterAccount> {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(TwitterAccount acc1, TwitterAccount acc2) {&#xA;&#x9;&#x9;return Integer.compare(acc1.getNumFollowers(), acc2.getNumFollowers());&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487847571635" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="FollowerCount(), acc2.getFollowerCount" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="246" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487848112822" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2, TwitterAccount acc1" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="187" end="-87"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487847527474" sizeMeasure="12">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces.twitter;&#xA;&#xA;import java.util.Comparator;&#xA;&#xA;public class TweetsCountComparator implements Comparator&lt;TwitterAccount> {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(TwitterAccount acc1, TwitterAccount acc2) {&#xA;&#x9;&#x9;return Integer.compare(acc1.getTweetCount(), acc2.getTweetCount());&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487848138468" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2, TwitterAccount acc1" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="184" end="-82"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487848352764" sizeMeasure="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="282" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487847600964" completion="1.0" successCount="6"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487847499626" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487847579738" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487848086573" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487848113539" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487847613745" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487847588245" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487848139369" completion="1.0" successCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="76">
        <attempts timestamp="1487935319113"/>
        <attempts timestamp="1487935319898"/>
        <attempts timestamp="1487935320634"/>
        <attempts timestamp="1487935321587"/>
        <attempts timestamp="1487935322953"/>
        <attempts timestamp="1487935323889"/>
        <attempts timestamp="1487935324729"/>
        <attempts timestamp="1487935328123"/>
        <attempts timestamp="1487935330774"/>
        <attempts timestamp="1487935689305"/>
        <attempts timestamp="1487935692403"/>
        <attempts timestamp="1487935692966"/>
        <attempts timestamp="1487935693436"/>
        <attempts timestamp="1487935697095"/>
        <attempts timestamp="1487935706660"/>
        <attempts timestamp="1487935708962"/>
        <attempts timestamp="1487935710464"/>
        <attempts timestamp="1487935711297"/>
        <attempts timestamp="1487935712599"/>
        <attempts timestamp="1487935713269"/>
        <attempts timestamp="1487935744954"/>
        <attempts timestamp="1487935747993"/>
        <attempts timestamp="1487935776314"/>
        <attempts timestamp="1487935779105"/>
        <attempts timestamp="1487935781639"/>
        <attempts timestamp="1487935782455"/>
        <attempts timestamp="1487935874571"/>
        <attempts timestamp="1487935875127"/>
        <attempts timestamp="1487935875554"/>
        <attempts timestamp="1487935876091"/>
        <attempts timestamp="1487935876553"/>
        <attempts timestamp="1487935876891"/>
        <attempts timestamp="1487935877269"/>
        <attempts timestamp="1487935877570"/>
        <attempts timestamp="1487935878108"/>
        <attempts timestamp="1487935885773"/>
        <attempts timestamp="1487935886905"/>
        <attempts timestamp="1487935887437"/>
        <attempts timestamp="1487935887757"/>
        <attempts timestamp="1487935887941"/>
        <attempts timestamp="1487935888157"/>
        <attempts timestamp="1487935888341"/>
        <attempts timestamp="1487935888519"/>
        <attempts timestamp="1487935888756"/>
        <attempts timestamp="1487935889772"/>
        <attempts timestamp="1487935905412"/>
        <attempts timestamp="1487935908134"/>
        <attempts timestamp="1487935908934"/>
        <attempts timestamp="1487935909766"/>
        <attempts timestamp="1487935910603"/>
        <attempts timestamp="1487935911119"/>
        <attempts timestamp="1487935911603"/>
        <attempts timestamp="1487935912019"/>
        <attempts timestamp="1487935912450"/>
        <attempts timestamp="1487935912965"/>
        <attempts timestamp="1487935916936"/>
        <attempts timestamp="1487935917420"/>
        <attempts timestamp="1487935917839"/>
        <attempts timestamp="1487935918292"/>
        <attempts timestamp="1487935919023"/>
        <attempts timestamp="1487935922812"/>
        <attempts timestamp="1487935924096"/>
        <attempts timestamp="1487935936730"/>
        <attempts timestamp="1487935941157"/>
        <attempts timestamp="1487935941858"/>
        <attempts timestamp="1487935942676"/>
        <attempts timestamp="1487935943497"/>
        <attempts timestamp="1487935944213"/>
        <attempts timestamp="1487935945028"/>
        <attempts timestamp="1487935953008"/>
        <attempts timestamp="1487935953890"/>
        <attempts timestamp="1487935957443"/>
        <attempts timestamp="1487935958258"/>
        <attempts timestamp="1487935959989"/>
        <attempts timestamp="1487935962140"/>
        <attempts timestamp="1487935963293"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="81">
        <attempts timestamp="1487935308670"/>
        <attempts timestamp="1487935312742"/>
        <attempts timestamp="1487935313907"/>
        <attempts timestamp="1487935314662"/>
        <attempts timestamp="1487935315325"/>
        <attempts timestamp="1487935315964"/>
        <attempts timestamp="1487935316526"/>
        <attempts timestamp="1487935317081"/>
        <attempts timestamp="1487935318166"/>
        <attempts timestamp="1487935337495"/>
        <attempts timestamp="1487935339211"/>
        <attempts timestamp="1487935348728"/>
        <attempts timestamp="1487935350396"/>
        <attempts timestamp="1487935352687"/>
        <attempts timestamp="1487935357558"/>
        <attempts timestamp="1487935358809"/>
        <attempts timestamp="1487935360030"/>
        <attempts timestamp="1487935364101"/>
        <attempts timestamp="1487935388765"/>
        <attempts timestamp="1487935391341"/>
        <attempts timestamp="1487935392244"/>
        <attempts timestamp="1487935394239"/>
        <attempts timestamp="1487935396009"/>
        <attempts timestamp="1487935396893"/>
        <attempts timestamp="1487935398512"/>
        <attempts timestamp="1487935401244"/>
        <attempts timestamp="1487935403890"/>
        <attempts timestamp="1487935405179"/>
        <attempts timestamp="1487935405845"/>
        <attempts timestamp="1487935406563"/>
        <attempts timestamp="1487935407666"/>
        <attempts timestamp="1487935408328"/>
        <attempts timestamp="1487935409265"/>
        <attempts timestamp="1487935410065"/>
        <attempts timestamp="1487935411222"/>
        <attempts timestamp="1487935412282"/>
        <attempts timestamp="1487935413251"/>
        <attempts timestamp="1487935414050"/>
        <attempts timestamp="1487935414528"/>
        <attempts timestamp="1487935415149"/>
        <attempts timestamp="1487935415996"/>
        <attempts timestamp="1487935416849"/>
        <attempts timestamp="1487935417611"/>
        <attempts timestamp="1487935418081"/>
        <attempts timestamp="1487935418481"/>
        <attempts timestamp="1487935418913"/>
        <attempts timestamp="1487935419433"/>
        <attempts timestamp="1487935420017"/>
        <attempts timestamp="1487935420601"/>
        <attempts timestamp="1487935421010"/>
        <attempts timestamp="1487935423956"/>
        <attempts timestamp="1487935424771"/>
        <attempts timestamp="1487935425590"/>
        <attempts timestamp="1487935426256"/>
        <attempts timestamp="1487935427393"/>
        <attempts timestamp="1487935428271"/>
        <attempts timestamp="1487935428824"/>
        <attempts timestamp="1487935429760"/>
        <attempts timestamp="1487935430716"/>
        <attempts timestamp="1487935431904"/>
        <attempts timestamp="1487935432666"/>
        <attempts timestamp="1487935436853"/>
        <attempts timestamp="1487935438007"/>
        <attempts timestamp="1487935438670"/>
        <attempts timestamp="1487935439675"/>
        <attempts timestamp="1487935742075"/>
        <attempts timestamp="1487935750408"/>
        <attempts timestamp="1487935783856"/>
        <attempts timestamp="1487935785111"/>
        <attempts timestamp="1487935785858"/>
        <attempts timestamp="1487935791897"/>
        <attempts timestamp="1487935795859"/>
        <attempts timestamp="1487935796963"/>
        <attempts timestamp="1487935797920"/>
        <attempts timestamp="1487935799019"/>
        <attempts timestamp="1487935800784"/>
        <attempts timestamp="1487935801853"/>
        <attempts timestamp="1487935803168"/>
        <attempts timestamp="1487935803752"/>
        <attempts timestamp="1487935820128"/>
        <attempts timestamp="1487935827103"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="3">
        <attempts timestamp="1487935343895"/>
        <attempts timestamp="1487935700433"/>
        <attempts timestamp="1487935882597"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
