<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488748643855" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488748698766" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private char suit;&#xA;&#x9;private int number;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int number) {&#xA;&#x9;&#x9;if (suit != 'S' &amp;&amp; suit != 'H' &amp;&amp; suit != 'D' &amp;&amp; suit != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (number &lt; 1 || number > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal color&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.number = number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(suit) + number;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="42" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488748761328" sizeMeasure="33" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card>{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int number;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int number) {&#xA;&#x9;&#x9;if (suit != 'S' &amp;&amp; suit != 'H' &amp;&amp; suit != 'D' &amp;&amp; suit != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (number &lt; 1 || number > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal color&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.number = number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="39" end="-79"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="40" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488749999610" sizeMeasure="48" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate int getSuitNum {&#xA;&#x9;&#x9;if(suit == 'S') { return 3; }&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (suit == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return number - o.getFace();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9; &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="472" end="-96"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="507" charEnd="517" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="541" charEnd="550" severity="2" problemCategory="50" problemType="67108969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750113235" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="() {&#xA;&#x9;&#x9;if (suit == 'S') { return 3; }&#xA;&#x9;&#x9;if (suit == 'H') { return 2; }&#xA;&#x9;&#x9;if (suit == 'D') { return 1; }&#xA;&#x9;&#x9;return 0;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="493" end="-282"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="507" charEnd="519" severity="1" problemCategory="120" problemType="603979894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750151522" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return getSuitNum() - o.getSuitNum();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="779" end="-95"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750520246" sizeMeasure="65" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int number;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int number) {&#xA;&#x9;&#x9;if (suit != 'S' &amp;&amp; suit != 'H' &amp;&amp; suit != 'D' &amp;&amp; suit != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (number &lt; 1 || number > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal color&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.number = number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private int getSuitNum() {&#xA;&#x9;&#x9;if (suit == 'S') { return 3; }&#xA;&#x9;&#x9;if (suit == 'H') { return 2; }&#xA;&#x9;&#x9;if (suit == 'D') { return 1; }&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (suit == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return number - o.getFace();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9; return getSuitNum() - o.getSuitNum();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(suit) + number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> list = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;list.add(new Card('C', 1));&#xA;&#x9;&#x9;list.add(new Card('C', 2));&#xA;&#x9;&#x9;list.add(new Card('S', 12));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(list);&#xA;&#x9;&#x9;System.out.println(list)" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="21" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="79" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750540737" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="76" end="-1191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750567582" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int number;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int number) {&#xA;&#x9;&#x9;if (suit != 'S' &amp;&amp; suit != 'H' &amp;&amp; suit != 'D' &amp;&amp; suit != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (number &lt; 1 || number > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal color&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.number = number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private int getSuitNum() {&#xA;&#x9;&#x9;if (suit == 'S') { return 3; }&#xA;&#x9;&#x9;if (suit == 'H') { return 2; }&#xA;&#x9;&#x9;if (suit == 'D') { return 1; }&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (suit == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return number - o.getFace();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9; return getSuitNum() - o.getSuitNum();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(suit) + number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> list = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;list.add(new Card('C', 7" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="76" end="-128"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750595454" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S', 7));&#xA;&#x9;&#x9;list.add(new Card('C', 2));&#xA;&#x9;&#x9;list.add(new Card('C" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1105" end="-72"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750611030" sizeMeasure="53" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="994" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="104" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="30" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488751193784" sizeMeasure="53" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ublic int getSuitNum() {&#xA;&#x9;&#x9;if (suit == 'S') { return 3; }&#xA;&#x9;&#x9;if (suit == 'H') { return 2; }&#xA;&#x9;&#x9;if (suit == 'D') { return 1; }&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return number;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;if (suit == o.getSuit()) {&#xA;&#x9;&#x9;&#x9;return number - o.getFace();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9; return getSuitNum() - o.getSuitNum();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(suit) + number" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="554" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="30" charEnd="49" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="104" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750721987" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488750982865" sizeMeasure="17" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;&#xA;&#x9;private boolean ess;&#xA;&#x9;private char trumf;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="68" charEnd="82" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="133" charEnd="136" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="158" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488751198686" sizeMeasure="21" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="251" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="288" charEnd="313" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="133" charEnd="136" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="158" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488751253846" sizeMeasure="21" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = '';&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;if (trumf)" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="151" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="161" charEnd="163" severity="2" problemCategory="20" problemType="1610612989"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="328" charEnd="333" severity="2" problemCategory="40" problemType="16777233"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="333" charEnd="334" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488751763294" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" ';&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;if (trumf != ' ') {&#xA;&#x9;&#x9;&#x9;return (o1.getSuit() == trumf ? 4 : o1.getSuitNum()) - (o2.getSuit() == trumf ? 4 : o2.getSuitNum());&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o1.getSuitNum() == o2.getSuitNum()) {&#xA;&#x9;&#x9;&#x9;&#x9;return (ess &amp;&amp; o1.getFace() == 1 ? 14 : o1.getFace()) - (ess &amp;&amp; o2.getFace() == 1 ? 14 : o2.getFace());&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return o1.getSuitNum() - o2.getSuitNum();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="155" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488751872752" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; o1.getSuitNum() != o2.getSuitNum()" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="325" end="-336"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488750552147" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488750573464" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488750594422" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
