<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488789669741" sizeMeasure="44" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;&#xA;&#x9;// 'S', 'H', 'D' or 'C', i.e. colour = type&#xA;&#x9;private char cardColour;&#xA;&#x9;// between 1 (ace) and 13 (king)&#xA;&#x9;private int cardNum = -1;&#xA;&#x9;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;// constructor that initialises card colour and numeric value &#xA;&#x9;public Card(char cardColour, int cardNum) {&#xA;&#x9;&#x9;if (SUITS.indexOf(cardColour) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + cardColour);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNum &lt; 1 || cardNum > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal number: &quot; + cardNum);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColour = cardColour;&#xA;&#x9;&#x9;this.cardNum = cardNum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// return cardcolour as a char &#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.cardColour;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returns card number&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.cardNum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returns a string consisting of suit and face, i.e. S1 for spade ace&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(cardColour) + cardNum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void compareTo() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="34" charEnd="38" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488789690457" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="962" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488789880310" sizeMeasure="46" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card compareCard) {&#xA;&#x9;&#x9;int compareCardColour = ((Card) compareCard).getSuit();" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="960" end="-22"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="41" charStart="1020" charEnd="1037" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790115824" sizeMeasure="50" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="f (this.cardColour == compareCard.cardColour) {&#xA;&#x9;&#x9;&#x9;return this.cardNum.compareTo(compareCard.cardNum);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1017" end="-80"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="1075" charEnd="1118" severity="2" problemCategory="50" problemType="67108978"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790206275" sizeMeasure="51" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int comparecardNum = ((Card)compareCard).getFace();&#xA;&#x9;&#x9;&#x9;return compareCardNum" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1068" end="-88"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1130" charEnd="1144" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790281669" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Rank = ((Card)compareCard).getFace();&#xA;&#x9;&#x9;&#x9;return this.cardNum - compareRank" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1079" end="-88"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1168" charEnd="1185" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790315274" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;return compareCard.cardColour - this.cardColour" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1158" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1224" charEnd="1225" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790330185" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1219" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790575879" sizeMeasure="54" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// checks if the suits are equal&#xA;&#x9;&#x9;if (this.cardColour == compareCard.cardColour) {&#xA;&#x9;&#x9;&#x9;// compares number&#xA;&#x9;&#x9;&#x9;int compareRank = ((Card)compareCard).getFace();&#xA;&#x9;&#x9;&#x9;return this.cardNum - compareRank;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return compareCard.cardColour - this.cardColour;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;String> cards = new ArrayList&lt;String>();" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1016" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1328" charEnd="1332" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1353" charEnd="1362" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790590522" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;&#xA;&#x9;// 'S', 'H', 'D' or 'C', i.e. colour = type&#xA;&#x9;private char cardColour;&#xA;&#x9;// between 1 (ace) and 13 (king)&#xA;&#x9;private int cardNum = -1;&#xA;&#x9;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;// constructor that initialises card colour and numeric value &#xA;&#x9;public Card(char cardColour, int cardNum) {&#xA;&#x9;&#x9;if (SUITS.indexOf(cardColour) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + cardColour);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNum &lt; 1 || cardNum > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal number: &quot; + cardNum);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColour = cardColour;&#xA;&#x9;&#x9;this.cardNum = cardNum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// return cardcolour as a char &#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.cardColour;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returns card number&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.cardNum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returns a string consisting of suit and face, i.e. S1 for spade ace&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(cardColour) + cardNum;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card compareCard) {&#xA;&#x9;&#x9;// checks if the suits are equal&#xA;&#x9;&#x9;if (this.cardColour == compareCard.cardColour) {&#xA;&#x9;&#x9;&#x9;// compares number&#xA;&#x9;&#x9;&#x9;int compareRank = ((Card)compareCard).getFace();&#xA;&#x9;&#x9;&#x9;return this.cardNum - compareRank;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return compareCard.cardColour - this.cardColour;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;String> cards = new ArrayList&lt;String>();&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="21" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1357" charEnd="1361" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790610970" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collections;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;&#xA;&#x9;// 'S', 'H', 'D' or 'C', i.e. colour = type&#xA;&#x9;private char cardColour;&#xA;&#x9;// between 1 (ace) and 13 (king)&#xA;&#x9;private int cardNum = -1;&#xA;&#x9;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;// constructor that initialises card colour and numeric value &#xA;&#x9;public Card(char cardColour, int cardNum) {&#xA;&#x9;&#x9;if (SUITS.indexOf(cardColour) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + cardColour);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (cardNum &lt; 1 || cardNum > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal number: &quot; + cardNum);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardColour = cardColour;&#xA;&#x9;&#x9;this.cardNum = cardNum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// return cardcolour as a char &#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.cardColour;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returns card number&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.cardNum;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returns a string consisting of suit and face, i.e. S1 for spade ace&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(cardColour) + cardNum;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card compareCard) {&#xA;&#x9;&#x9;// checks if the suits are equal&#xA;&#x9;&#x9;if (this.cardColour == compareCard.cardColour) {&#xA;&#x9;&#x9;&#x9;// compares number&#xA;&#x9;&#x9;&#x9;int compareRank = ((Card)compareCard).getFace();&#xA;&#x9;&#x9;&#x9;return this.cardNum - compareRank;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return compareCard.cardColour - this.cardColour;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;String> cards = new ArrayList&lt;String>();&#xA;&#x9;&#x9;Collections.sort(cards);" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="49" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="55" charStart="1387" charEnd="1391" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790620486" sizeMeasure="59" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.list" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="79" end="-1389"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="86" charEnd="100" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1410" charEnd="1414" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790634045" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="L" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="96" end="-1392"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488790838762" sizeMeasure="60" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;String> cards = new ArrayList&lt;String>();&#xA;&#x9;&#x9;cards.add&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;}*/" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1365" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="56" charEnd="77" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="86" charEnd="100" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875326653" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;String> cards = new ArrayList&lt;String>();&#xA;&#x9;&#x9;Card card1 = new Card();&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1365" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="58" charStart="1473" charEnd="1483" severity="2" problemCategory="50" problemType="134217858"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875371181" sizeMeasure="62" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="'S',2);&#xA;&#x9;&#x9;Card card2 = new Card('H',4);&#xA;&#x9;&#x9;card1.compareTo(card2" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1482" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="56" charEnd="77" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="57" charStart="1425" charEnd="1430" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875381506" sizeMeasure="62" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(card1.compareTo(card2)" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1524" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="56" charEnd="77" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="57" charStart="1425" charEnd="1430" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875393056" sizeMeasure="61" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1412" end="-117"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="56" charEnd="77" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="86" charEnd="100" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876020809" sizeMeasure="61" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2(Card compareCard) {&#xA;&#x9;&#x9;// checks if the suits are equal&#xA;&#x9;&#x9;if (this.cardColour == compareCard.cardColour) {&#xA;&#x9;&#x9;&#x9;// compares number&#xA;&#x9;&#x9;&#x9;int compareRank = ((Card)compareCard).getFace();&#xA;&#x9;&#x9;&#x9;return this.cardNum - compareRank;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return compareCard.cardColour - this.cardColour;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1075" end="-117"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="116" charEnd="120" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1066" charEnd="1094" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880339633" sizeMeasure="61" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1075" end="-451"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="86" charEnd="100" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="56" charEnd="77" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488789487861" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791091495" sizeMeasure="21" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;// can adjust ace to be highest card&#xA;&#x9;// can choose a trumf suit&#xA;&#x9;private boolean;&#xA;&#x9;char trumf;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean,)&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="186" charEnd="193" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="234" charEnd="235" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="234" charEnd="235" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="242" charEnd="244" severity="2" problemCategory="20" problemType="1610612969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="186" charEnd="193" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791162078" sizeMeasure="23" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// true or false depending on whether ace is smallest or largest&#xA;&#x9;private boolean ace;&#xA;&#x9;// which suit is beats the others&#xA;&#x9;char trumf;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumf" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="178" end="-104"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="363" charEnd="364" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791171320" sizeMeasure="25" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="364" end="-103"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="48" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="260" charEnd="263" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791396328" sizeMeasure="29" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trump) {&#xA;&#x9;&#x9;if (trump != '' || trump != 'S' || trump != 'H' || trump != 'D' || trump != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The trump suit has to be either left blank or be a valid suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;ace = this.ace;&#xA;&#x9;&#x9;trum = this.trump;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="310" end="-106"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="382" charEnd="384" severity="2" problemCategory="20" problemType="1610612989"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791414177" sizeMeasure="29" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.ace = ace;&#xA;&#x9;&#x9;this.trump = " edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="562" end="-112"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="382" charEnd="384" severity="2" problemCategory="20" problemType="1610612989"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791423037" sizeMeasure="29" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="383" end="-322"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="48" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="260" charEnd="263" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791853830" sizeMeasure="30" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o1, Card 02" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="607" end="-61"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="655" charEnd="657" severity="2" problemCategory="20" problemType="1610612971"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="715" charEnd="716" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="602" charEnd="603" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791920840" sizeMeasure="30" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o2) {&#xA;&#x9;&#x9;char o1Suit = 01.getSuit();" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="655" end="-21"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="631" charEnd="658" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="677" charEnd="680" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="677" charEnd="680" severity="2" problemCategory="40" problemType="16777233"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="680" charEnd="687" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488791940457" sizeMeasure="31" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char o2Suit = 02" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="693" end="-32"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="631" charEnd="658" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="677" charEnd="680" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="677" charEnd="680" severity="2" problemCategory="40" problemType="16777233"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="680" charEnd="687" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="707" charEnd="710" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="707" charEnd="710" severity="2" problemCategory="40" problemType="16777233"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="710" charEnd="717" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488792072544" sizeMeasure="31" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 'S';&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trump) {&#xA;&#x9;&#x9;if (trump != ' ' || trump != 'S' || trump != 'H' || trump != 'D' || trump != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The trump suit has to be either left blank or be a valid suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trump = trump;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o1, Card o2) {&#xA;&#x9;&#x9;char o1Suit = o1.getSuit();&#xA;&#x9;&#x9;char o2Suit = o" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="311" end="-33"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="637" charEnd="664" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="260" charEnd="263" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488792229005" sizeMeasure="39" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// checks if trump is &quot;default&quot;, i.e. spades&#xA;&#x9;&#x9;if (trump != 'S') {&#xA;&#x9;&#x9;&#x9;// gets the suit of the two cards to compare&#xA;&#x9;&#x9;&#x9;char o1Suit = o1.getSuit();&#xA;&#x9;&#x9;&#x9;char o2Suit = o2.getSuit();&#xA;&#x9;&#x9;&#x9;// check if they have same suit&#xA;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;// get number of cards&#xA;&#x9;&#x9;&#x9;int o1Face = o1.getFace();&#xA;&#x9;&#x9;&#x9;int o2Face = o2.getFace();&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="669" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="637" charEnd="664" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="39" charStart="986" charEnd="987" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488792601305" sizeMeasure="45" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trump suit&#xA;&#x9;&#x9;&#x9;if (o1Suit == trump) {&#xA;&#x9;&#x9;&#x9;&#x9;if (o2Suit == trump) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;// get number of cards&#xA;&#x9;&#x9;&#x9;int o1Face = o1.getFace();&#xA;&#x9;&#x9;&#x9;int o2Face = o2.getFace();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="871" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="637" charEnd="664" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1070" charEnd="1071" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488792800289" sizeMeasure="35" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public static Comparator&lt;Card> CardComparator = new Comparator&lt;Card>() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public int compareTo(Card card1, Card card2) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;char card1Suit = card1.getSuit();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9; {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="613" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="784" charEnd="785" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="788" charEnd="796" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488792808085" sizeMeasure="36" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;char card2Suit = card2" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="781" end="-46"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="825" charEnd="833" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="821" charEnd="822" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488872909694" sizeMeasure="44" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;// check if they have the same suit&#xA;&#x9;&#x9;&#x9;// if only one is trump then number doesn't matter&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if they have the same suit, check number&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;int card1Rank = card1.getFace();&#xA;&#x9;&#x9;&#x9;int card2Rank = card2.getFace();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="818" end="-3"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1045" charEnd="1046" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488873058643" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// don't think I need this line below?&#xA;&#x9;//public static Comparator&lt;Card> CardComparator = new Comparator&lt;Card>() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public int compareTo(Card card1, Card card2) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;char card1Suit = card1.getSuit();&#xA;&#x9;&#x9;&#x9;char card2Suit = card2.getSuit();&#xA;&#x9;&#x9;&#x9;// check if they have the same suit&#xA;&#x9;&#x9;&#x9;if (card1Suit == trump) {&#xA;&#x9;&#x9;&#x9;&#x9;if (card2Suit == trump) &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if only one is trump then number doesn't matter&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if they have the same suit, check number&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;int card1Rank = card1.getFace();&#xA;&#x9;&#x9;&#x9;int card2Rank = card2.getFace();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="613" end="-99"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="952" charEnd="953" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488873232015" sizeMeasure="54" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card2Suit) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if only one is trump then number doesn't matter&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if they have the same suit, check number&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;int card1Rank = card1.getFace();&#xA;&#x9;&#x9;&#x9;int card2Rank = card2.getFace();&#xA;&#x9;&#x9;&#x9;if (card1Rank == card2Rank) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else if (card1Rank > card2Rank) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="917" end="-111"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1245" charEnd="1246" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488873274663" sizeMeasure="56" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return card1Suit.compareTo(card2Suit);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="933" end="-428"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="260" charEnd="263" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="941" charEnd="971" severity="2" problemCategory="50" problemType="67108978"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488873295862" sizeMeasure="56" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="941" end="-434"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="48" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="260" charEnd="263" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488874571397" sizeMeasure="57" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="1137" end="-243"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="48" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="260" charEnd="263" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875842283" sizeMeasure="59" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!ace &amp;&amp; trump == 'S' || trump == ' ') {&#xA;&#x9;&#x9;&#x9;return this.card.compareTo(o);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="1328" end="-18"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1387" charEnd="1391" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875928258" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!ace &amp;&amp; trump == 'S' || trump == ' ') {&#xA;&#x9;&#x9;&#x9;&#x9;card1.compareTo(card2);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="783" end="-648"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="59" charStart="1467" charEnd="1471" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875960271" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return " edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="831" end="-676"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="59" charStart="1474" charEnd="1478" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875975962" sizeMeasure="62" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="1469" end="-35"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="48" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876392546" sizeMeasure="72" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;char card1Suit = card1.getSuit();&#xA;&#x9;&#x9;&#x9;char card2Suit = card2.getSuit();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;int card1Rank = card1.getFace();&#xA;&#x9;&#x9;&#x9;int card2Rank = card2.getFace();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if everything is same as in the already defined compareTo&#xA;&#x9;&#x9;&#x9;if (!ace &amp;&amp; trump == 'S' || trump == ' ') {&#xA;&#x9;&#x9;&#x9;&#x9;return Card.compareTo()&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// check if they have the same suit&#xA;&#x9;&#x9;&#x9;if (card1Suit == card2Suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if only one is trump then number doesn't matter&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if they have the same suit, check number&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (card1Rank == card2Rank) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else if (card1Rank > card2Rank) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// if everything is same as in the already defined compareTo&#xA;&#x9;&#x9;if (!ace &amp;&amp; trump == 'S' || trump == ' ') {&#xA;&#x9;&#x9;&#x9;return Card.compareTo(o);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="783" end="-22"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="1065" charEnd="1074" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="1075" charEnd="1076" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="61" charStart="1443" charEnd="1452" severity="2" problemCategory="40" problemType="16777838"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1465" charEnd="1474" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1474" charEnd="1475" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1481" charEnd="1482" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="68" charStart="1613" charEnd="1630" severity="2" problemCategory="50" problemType="603979977"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876420195" sizeMeasure="70" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// if everything is same as in the already defined compareTo&#xA;&#x9;&#x9;if (!ace &amp;&amp; trump == 'S' || trump == ' ') {&#xA;&#x9;&#x9;&#x9;// how do I call on this method from card?" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="1487" end="-56"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1465" charEnd="1474" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1474" charEnd="1475" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1481" charEnd="1482" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="66" charStart="1650" charEnd="1667" severity="2" problemCategory="50" problemType="603979977"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="64" charEnd="78" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="1065" charEnd="1074" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="1075" charEnd="1076" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="61" charStart="1443" charEnd="1452" severity="2" problemCategory="40" problemType="16777838"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876759061" sizeMeasure="53" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tor&lt;Card> {&#xA;&#x9;&#xA;&#x9;// can adjust ace to be highest card&#xA;&#x9;// can choose a trumf suit&#xA;&#x9;// true or false depending on whether ace is smallest or largest&#xA;&#x9;private boolean ace;&#xA;&#x9;// which suit is beats the others&#xA;&#x9;char trump = 'S';&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trump) {&#xA;&#x9;&#x9;if (trump != ' ' || trump != 'S' || trump != 'H' || trump != 'D' || trump != 'C') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The trump suit has to be either left blank or be a valid suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trump = trump;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// don't think I need this line below?&#xA;&#x9;//public static Comparator&lt;Card> CardComparator = new Comparator&lt;Card>() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public int compareTo(Card card1, Card card2) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if everything is same as in the already defined compareTo&#xA;&#x9;&#x9;&#x9;if (!ace &amp;&amp; trump == 'S' || trump == ' ') {&#xA;&#x9;&#x9;&#x9;&#x9;return Card.compareTo()&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// check if they have the same suit&#xA;&#x9;&#x9;&#x9;if (card1Suit == card2Suit) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card card1, Card card2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;char card1Suit = card1.getSuit();&#xA;&#x9;&#x9;char card2Suit = card2.getSuit();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int card1Rank = card1.getFace();&#xA;&#x9;&#x9;int card2Rank = card2.getFace();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (!ace &amp;&amp; trump == 'S' || trump == ' ') {&#xA;&#x9;&#x9;&#x9;// how do I call on this method from card?&#xA;&#x9;&#x9;&#x9;return Card.compareTo(o)" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="97" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="919" charEnd="928" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="929" charEnd="930" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="985" charEnd="994" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="998" charEnd="1007" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="1023" charEnd="1024" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="1023" charEnd="1024" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="1023" charEnd="1024" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1359" charEnd="1360" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1365" charEnd="1366" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880339625" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public int compare(Card card1, Card card2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;char card1Suit = card1.getSuit();&#xA;&#x9;&#x9;char card2Suit = card2.getSuit();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int card1Rank = card1.getFace();&#xA;&#x9;&#x9;int card2Rank = card2.getFace();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (!ace &amp;&amp; trump == 'S' || trump == ' ') {&#xA;&#x9;&#x9;&#x9;if (card1Suit == card2Suit) {&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="613" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="911" charEnd="912" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881467267" sizeMeasure="43" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (trump != 'C') {&#xA;&#x9;&#x9;&#x9;char card1Suit = card1.getSuit();&#xA;&#x9;&#x9;&#x9;char card2Suit = card2.getSuit();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (card1Suit == trump) {&#xA;&#x9;&#x9;&#x9;&#x9;if (card2Suit == trump) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="674" end="-171"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="608" charEnd="609" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1024" charEnd="1025" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1024" charEnd="1025" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881484487" sizeMeasure="45" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="851" end="-199"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1052" charEnd="1053" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="608" charEnd="609" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1052" charEnd="1053" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881763801" sizeMeasure="47" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S') {&#xA;&#x9;&#x9;&#x9;char card1Suit = card1.getSuit();&#xA;&#x9;&#x9;&#x9;char card2Suit = card2.getSuit();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (card1Suit == trump) {&#xA;&#x9;&#x9;&#x9;&#x9;if (card2Suit == trump) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;int card1Rank = card1.getFace();&#xA;&#x9;&#x9;&#x9;&#x9;int card2Rank = card2.getFace();&#xA;&#x9;&#x9;&#x9;&#x9;if (card1Rank == card2Rank) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (card1Rank > card2Rank)&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="688" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="41" charStart="1051" charEnd="1052" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1072" charEnd="1073" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883513163" sizeMeasure="51" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="1052" end="-23"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1123" charEnd="1124" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883518352" sizeMeasure="51" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1095" end="-30"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1124" charEnd="1125" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883593878" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1115" end="-3"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="260" charEnd="263" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488875397573" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="0.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488883606239" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
