<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringMergingIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Modify the code for the StringMergingIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIteratorProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIteratorProgram"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="debugging.StringMergingIterator*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488828874276" sizeMeasure="48" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package debugging;&#xA;&#xA;import java.util.Collection;&#xA;import java.util.Iterator;&#xA;import java.util.NoSuchElementException;&#xA;&#xA;public class StringMergingIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;private Iterator&lt;String> first;&#xA;&#x9;private Iterator&lt;String> second;&#xA;&#x9;private boolean turnSwitch;&#xA;&#xA;&#x9;public StringMergingIterator(Iterator&lt;String> first, Iterator&lt;String> second){&#xA;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;this.turnSwitch = true;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! hasNext()){ throw new NoSuchElementException(); }&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! first.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if(turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;}&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return result;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488829047382" sizeMeasure="48" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="686" end="-189"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488827746449" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488828155412" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488828215201" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488828749640" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488828751734" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488829084873" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488829222017" mode="run"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="39">
        <attempts timestamp="1488827747196"/>
        <attempts timestamp="1488828215473"/>
        <attempts timestamp="1488828225808"/>
        <attempts timestamp="1488828263941"/>
        <attempts timestamp="1488828273179"/>
        <attempts timestamp="1488828307518"/>
        <attempts timestamp="1488828310730"/>
        <attempts timestamp="1488828311331"/>
        <attempts timestamp="1488828752015"/>
        <attempts timestamp="1488828761879"/>
        <attempts timestamp="1488828764856"/>
        <attempts timestamp="1488828767992"/>
        <attempts timestamp="1488828880077"/>
        <attempts timestamp="1488829052320"/>
        <attempts timestamp="1488829060400"/>
        <attempts timestamp="1488829066601"/>
        <attempts timestamp="1488829069396"/>
        <attempts timestamp="1488829074682"/>
        <attempts timestamp="1488829085243"/>
        <attempts timestamp="1488829092357"/>
        <attempts timestamp="1488829096909"/>
        <attempts timestamp="1488829111128"/>
        <attempts timestamp="1488829128576"/>
        <attempts timestamp="1488829154862"/>
        <attempts timestamp="1488829158902"/>
        <attempts timestamp="1488829163698"/>
        <attempts timestamp="1488829167183"/>
        <attempts timestamp="1488829168424"/>
        <attempts timestamp="1488829171581"/>
        <attempts timestamp="1488829173783"/>
        <attempts timestamp="1488829174752"/>
        <attempts timestamp="1488829177217"/>
        <attempts timestamp="1488829178267"/>
        <attempts timestamp="1488829179070"/>
        <attempts timestamp="1488829179779"/>
        <attempts timestamp="1488829180322"/>
        <attempts timestamp="1488829181011"/>
        <attempts timestamp="1488829181623"/>
        <attempts timestamp="1488829182241"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="57">
        <attempts timestamp="1488827988822"/>
        <attempts timestamp="1488828222844"/>
        <attempts timestamp="1488828239146"/>
        <attempts timestamp="1488828263937"/>
        <attempts timestamp="1488828268360"/>
        <attempts timestamp="1488828273177"/>
        <attempts timestamp="1488828304488"/>
        <attempts timestamp="1488828307517"/>
        <attempts timestamp="1488828309693"/>
        <attempts timestamp="1488828310728"/>
        <attempts timestamp="1488828311327"/>
        <attempts timestamp="1488828316413"/>
        <attempts timestamp="1488828759016"/>
        <attempts timestamp="1488828763226"/>
        <attempts timestamp="1488828764852"/>
        <attempts timestamp="1488828766289"/>
        <attempts timestamp="1488828767989"/>
        <attempts timestamp="1488828772527"/>
        <attempts timestamp="1488828880074"/>
        <attempts timestamp="1488828882474"/>
        <attempts timestamp="1488829052319"/>
        <attempts timestamp="1488829054542"/>
        <attempts timestamp="1488829060398"/>
        <attempts timestamp="1488829062049"/>
        <attempts timestamp="1488829066599"/>
        <attempts timestamp="1488829069395"/>
        <attempts timestamp="1488829073321"/>
        <attempts timestamp="1488829074680"/>
        <attempts timestamp="1488829089448"/>
        <attempts timestamp="1488829094211"/>
        <attempts timestamp="1488829096906"/>
        <attempts timestamp="1488829100369"/>
        <attempts timestamp="1488829111127"/>
        <attempts timestamp="1488829115248"/>
        <attempts timestamp="1488829128575"/>
        <attempts timestamp="1488829130886"/>
        <attempts timestamp="1488829154860"/>
        <attempts timestamp="1488829156380"/>
        <attempts timestamp="1488829158901"/>
        <attempts timestamp="1488829159853"/>
        <attempts timestamp="1488829163696"/>
        <attempts timestamp="1488829164459"/>
        <attempts timestamp="1488829167181"/>
        <attempts timestamp="1488829168422"/>
        <attempts timestamp="1488829171580"/>
        <attempts timestamp="1488829173781"/>
        <attempts timestamp="1488829174750"/>
        <attempts timestamp="1488829175514"/>
        <attempts timestamp="1488829177215"/>
        <attempts timestamp="1488829178265"/>
        <attempts timestamp="1488829179069"/>
        <attempts timestamp="1488829179778"/>
        <attempts timestamp="1488829180320"/>
        <attempts timestamp="1488829181009"/>
        <attempts timestamp="1488829181622"/>
        <attempts timestamp="1488829182240"/>
        <attempts timestamp="1488829182996"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1488827981448"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="4">
        <attempts timestamp="1488828738286"/>
        <attempts timestamp="1488828774843"/>
        <attempts timestamp="1488829102923"/>
        <attempts timestamp="1488829117983"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
