<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555185345" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555216011" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private char cardSuit;&#xA;&#x9;private int cardValue;&#xA;&#x9;&#xA;&#x9;public Card(char cardSuit, int cardValue) throws IllegalArgumentException {&#xA;&#x9;&#x9;if (cardSuit != 'S' &amp;&amp; cardSuit != 'H' &amp;&amp; cardSuit != 'D' &amp;&amp; cardSuit != 'C'){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;cardSuit must be 'S', 'H', 'D' or 'C'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (cardValue &lt; 1 || cardValue > 13){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;cardValue must be between 1 and 13&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.cardValue = cardValue;&#xA;&#x9;&#x9;this.cardSuit = cardSuit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compareTo(Card otherCard){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Character> ranking = new ArrayList&lt;Character>();&#xA;&#x9;&#x9;ranking.add('C');&#xA;&#x9;&#x9;ranking.add('D');&#xA;&#x9;&#x9;ranking.add('H');&#xA;&#x9;&#x9;ranking.add('S');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (ranking.indexOf(this.getSuit()) > ranking.indexOf(otherCard.getSuit())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (ranking.indexOf(this.getSuit()) &lt; ranking.indexOf(otherCard.getSuit())){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() > otherCard.getFace()){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() &lt; otherCard.getFace()){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return cardValue;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return cardSuit;&#xA;&#x9;}&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;&quot; + cardSuit + cardValue;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;cards.add(new Card('S', 2));&#xA;&#x9;&#x9;cards.add(new Card('H', 3));&#xA;&#x9;&#x9;cards.add(new Card('D', 3));&#xA;&#x9;&#x9;cards.add(new Card('H', 10));&#xA;&#x9;&#x9;cards.add(new Card('C', 1));&#xA;&#x9;&#x9;cards.add(new Card('S', 10));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;}&#xA;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="21" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556002120" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="734" end="-873"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556171822" sizeMeasure="75" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card a = new Card('S', 2);&#xA;&#x9;&#x9;Card b = new Card('D', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;cards.add(new Card('S', 2));&#xA;&#x9;&#x9;cards.add(new Card('H', 3));&#xA;&#x9;&#x9;cards.add(new Card('D', 3));&#xA;&#x9;&#x9;cards.add(new Card('H', 10));&#xA;&#x9;&#x9;cards.add(new Card('C', 1));&#xA;&#x9;&#x9;cards.add(new Card('S', 10));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1311" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556181528" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="a.compareTo(b" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1373" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556196209" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(a.compareTo(b)" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1373" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556241879" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ranking.add('C');&#xA;&#x9;&#x9;ranking.add('D');&#xA;&#x9;&#x9;ranking.add('H');&#xA;&#x9;&#x9;ranking.add('S'" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="734" end="-987"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556257795" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="734" end="-985"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556271684" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ranking.add('C');&#xA;&#x9;&#x9;ranking.add('D');&#xA;&#x9;&#x9;ranking.add('H');&#xA;&#x9;&#x9;ranking.add('S');" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="734" end="-985"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488554924482" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488554966976" sizeMeasure="5" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparator&lt;Card> {&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="49" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555007201" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="70" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555118414" sizeMeasure="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="21" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555372671" sizeMeasure="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public int compare(Card card1, Card card2){&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="111" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555406463" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cardComparator(){&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="119" end="-66"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555416112" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="119" end="-88"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555487666" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="bolean aceIsBiggest, char topPriorityColor" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="134" end="-74"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555497400" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="136" end="-115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555591686" sizeMeasure="21" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Character> ranking = new ArrayList&lt;Character>();&#xA;&#x9;ranking.add('C');&#xA;&#x9;ranking.add('D');&#xA;&#x9;ranking.add('H');&#xA;&#x9;ranking.add('S');&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean aceIsBiggest, char topPriorityColor){&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="112" end="-72"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555626346" sizeMeasure="23" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;import java.util.ArrayList" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="50" end="-339"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555708832" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean aceIsBiggest, char topPriorityColor){&#xA;&#x9;&#x9;ranking.add('C');&#xA;&#x9;&#x9;ranking.add('D');&#xA;&#x9;&#x9;ranking.add('H');&#xA;&#x9;&#x9;ranking.add('S');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;ranking.remove(topPriorityColor);&#xA;&#x9;&#x9;ranking.add(topPriorityColor);" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="218" end="-72"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555777454" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean aceIsBiggest" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="218" end="-298"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555792945" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.aceIsBiggest = aceIsBiggest" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="469" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488555912321" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (topPriorityColor != ''){&#xA;&#x9;&#x9;&#x9;ranking.remove(topPriorityColor);&#xA;&#x9;&#x9;&#x9;ranking.add(topPriorityColor);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="395" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556066100" sizeMeasure="34" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (topPriorityColor != ''){&#xA;&#x9;&#x9;&#x9;ranking.remove(topPriorityColor);&#xA;&#x9;&#x9;&#x9;ranking.add(topPriorityColor);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.aceIsBiggest = aceIsBiggest;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card card1, Card card2){&#xA;&#x9;&#x9;if (aceIsBiggest){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="395" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556301833" sizeMeasure="34" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="422" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556329445" sizeMeasure="34" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="''" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="422" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556362880" sizeMeasure="34" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="631" end="-632"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556474263" sizeMeasure="34" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="== 'C' || topPriorityColor == 'D' || topPriorityColor == 'H' ||topPriorityColor == 'S" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="419" end="-209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556760120" sizeMeasure="54" errorCount="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (ranking.indexOf(this.getSuit()) > ranking.indexOf(otherCard.getSuit())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (ranking.indexOf(this.getSuit()) &lt; ranking.indexOf(otherCard.getSuit())){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() > otherCard.getFace()){&#xA;&#x9;&#x9;&#x9;if (otherCard.getface() == 1 &amp;&amp; aceIsBiggest){&#xA;&#x9;&#x9;&#x9;&#x9;return -1&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.getFace() &lt; otherCard.getFace()){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="680" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556824317" sizeMeasure="54" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card1.getSuit()) > ranking.indexOf(card2.getSuit())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (ranking.indexOf(card1.getSuit()) &lt; ranking.indexOf(card2" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="703" end="-293"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556839108" sizeMeasure="54" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card1.getFace() > card2" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="884" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556849020" sizeMeasure="54" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card2" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="927" end="-195"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556862213" sizeMeasure="54" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="F" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="936" end="-190"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556866956" sizeMeasure="54" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="979" end="-148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556949360" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card1.getFace() &lt; otherCard.getFace()){&#xA;&#x9;&#x9;&#x9;if (card1.getFace() == 1 &amp;&amp; aceIsBiggest){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="1031" end="-59"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488556958931" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card2" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="1049" end="-130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488557031662" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="1117" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488557426702" sizeMeasure="81" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collections;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#x9;&#xA;&#x9;List&lt;Character> ranking = new ArrayList&lt;Character>();&#xA;&#x9;boolean aceIsBiggest;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean aceIsBiggest, char topPriorityColor){&#xA;&#x9;&#x9;ranking.add('C');&#xA;&#x9;&#x9;ranking.add('D');&#xA;&#x9;&#x9;ranking.add('H');&#xA;&#x9;&#x9;ranking.add('S');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (topPriorityColor == 'C' || topPriorityColor == 'D' || topPriorityColor == 'H' ||topPriorityColor == 'S'){&#xA;&#x9;&#x9;&#x9;ranking.remove(topPriorityColor);&#xA;&#x9;&#x9;&#x9;ranking.add(topPriorityColor);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.aceIsBiggest = aceIsBiggest;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card card1, Card card2){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (ranking.indexOf(card1.getSuit()) > ranking.indexOf(card2.getSuit())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (ranking.indexOf(card1.getSuit()) &lt; ranking.indexOf(card2.getSuit())){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (card1.getFace() > card2.getFace()){&#xA;&#x9;&#x9;&#x9;if (card2.getFace() == 1 &amp;&amp; aceIsBiggest){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (card1.getFace() &lt; card2.getFace()){&#xA;&#x9;&#x9;&#x9;if (card1.getFace() == 1 &amp;&amp; aceIsBiggest){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card a = new Card('S', 2);&#xA;&#x9;&#x9;Card b = new Card('D', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator c = new CardComparator(false, 'D');&#xA;&#x9;&#x9;c.compare(a, b);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(Compararator());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;cards.add(new Card('S', 2));&#xA;&#x9;&#x9;cards.add(new Card('H', 3));&#xA;&#x9;&#x9;cards.add(new Card('D', 3));&#xA;&#x9;&#x9;cards.add(new Card('H', 10));&#xA;&#x9;&#x9;cards.add(new Card('C', 1));&#xA;&#x9;&#x9;cards.add(new Card('S', 10));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;System.out.println(cards);" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="101" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488557451266" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="1409" end="-307"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488557507101" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="1412" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488557696405" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Character.valueOf(topPriorityColor));&#xA;&#x9;&#x9;&#x9;ranking.add(topPriorityColor);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.aceIsBiggest = aceIsBiggest;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card card1, Card card2){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (ranking.indexOf(card1.getSuit()) > ranking.indexOf(card2.getSuit())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (ranking.indexOf(card1.getSuit()) &lt; ranking.indexOf(card2.getSuit())){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (card1.getFace() > card2.getFace()){&#xA;&#x9;&#x9;&#x9;if (card2.getFace() == 1 &amp;&amp; aceIsBiggest){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (card1.getFace() &lt; card2.getFace()){&#xA;&#x9;&#x9;&#x9;if (card1.getFace() == 1 &amp;&amp; aceIsBiggest){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card a = new Card('S', 2);&#xA;&#x9;&#x9;Card b = new Card('D', 10);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator c = new CardComparator(false, 'D');&#xA;&#x9;&#x9;c.compare(a, b);" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="556" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488557716785" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(c.compare(a, b)" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1406" end="-312"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488556064769" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488556184440" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488556198560" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488556245890" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488556260249" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488556275263" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488557432860" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488557452768" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488557510338" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488557699297" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488557719112" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488557050692" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488557137571" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488557726024" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
