<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488819409943" sizeMeasure="30">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#x9;int face;&#xA;&#x9;char suit;&#xA;&#x9;char[] accepted = {'S', 'D', 'H', 'C'};&#xA;&#x9;&#xA;&#x9;public Card(char x, int y) {&#xA;&#x9;&#x9;String xx = x+&quot;&quot;;&#xA;&#x9;&#x9;if (y&lt;1 || y>13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;too high or low face value&quot;);&#xA;&#x9;&#x9;} if (!String.valueOf(accepted).contains(xx)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;not an accepted suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = x;&#xA;&#x9;&#x9;this.face = y;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + this.suit + this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488886387276" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card> {&#xA;&#x9;int face;&#xA;&#x9;char suit;&#xA;&#x9;char[] accepted = {'S', 'D', 'H', 'C'};&#xA;&#x9;&#xA;&#x9;public Card(char x, int y) {&#xA;&#x9;&#x9;String xx = x+&quot;&quot;;&#xA;&#x9;&#x9;if (y&lt;1 || y>13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;too high or low face value&quot;);&#xA;&#x9;&#x9;} if (!String.valueOf(accepted).contains(xx)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;not an accepted suit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = x;&#xA;&#x9;&#x9;this.face = y;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + this.suit + this.face;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;if (suit != card.getSuit()) {&#xA;&#x9;&#x9;&#x9;int faceThis = 0;&#xA;&#x9;&#x9;&#x9;int faceCard = 0;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; accepted.length; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (suit == accepted[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;faceThis = i;&#xA;&#x9;&#x9;&#x9;&#x9;} if (card.getSuit() == accepted[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;faceCard = i;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;} if (faceThis > faceCard) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (card.getFace() > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} if (card.getFace() &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="39" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488888141011" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;/*the convention for compareTo() method is to return -1 for less, 0 for equal, and 1 for greater.&#xA; *  That is the same convention for the Override of compareTo(). So compareTo() has 3 possible return values. &#xA; *  The first if statement is getting the easiest one out of the way, when comparing Treets that are equal return 0.&#xA; *   Java knows what it means for two Treets to be equal because we have defined the equals() method.&#xA; */" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1120" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889037927" sizeMeasure="59" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;@Override&#xA;//&#x9;public int compareTo(Card card) {&#xA;//&#x9;&#x9;if (suit != card.getSuit()) {&#xA;//&#x9;&#x9;&#x9;int faceThis = 0;&#xA;//&#x9;&#x9;&#x9;int faceCard = 0;&#xA;//&#x9;&#x9;&#x9;for (int i = 0; i &lt; accepted.length; i++) {&#xA;//&#x9;&#x9;&#x9;&#x9;if (suit == accepted[i]) {&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;faceThis = i;&#xA;//&#x9;&#x9;&#x9;&#x9;} if (card.getSuit() == accepted[i]) {&#xA;//&#x9;&#x9;&#x9;&#x9;&#x9;faceCard = i;&#xA;//&#x9;&#x9;&#x9;&#x9;}&#xA;//&#x9;&#x9;&#x9;} if (faceThis > faceCard) {&#xA;//&#x9;&#x9;&#x9;&#x9;return -1;&#xA;//&#x9;&#x9;&#x9;} else {&#xA;//&#x9;&#x9;&#x9;&#x9;return 1;&#xA;//&#x9;&#x9;&#x9;}&#xA;//&#x9;&#x9;} else {&#xA;//&#x9;&#x9;&#x9;if (card.getFace() > this.face) {&#xA;//&#x9;&#x9;&#x9;&#x9;return -1;&#xA;//&#x9;&#x9;&#x9;} if (card.getFace() &lt; this.face) {&#xA;//&#x9;&#x9;&#x9;&#x9;return 1;&#xA;//&#x9;&#x9;&#x9;} else {&#xA;//&#x9;&#x9;&#x9;&#x9;return 0;&#xA;//&#x9;&#x9;&#x9;}&#xA;//&#x9;&#x9;}&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="603" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889059701" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;if (suit != card.getSuit()) {&#xA;&#x9;&#x9;&#x9;int faceThis = 0;&#xA;&#x9;&#x9;&#x9;int faceCard = 0;&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; accepted.length; i++) {&#xA;&#x9;&#x9;&#x9;&#x9;if (suit == accepted[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;faceThis = i;&#xA;&#x9;&#x9;&#x9;&#x9;} if (card.getSuit() == accepted[i]) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;faceCard = i;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;} if (faceThis > faceCard) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (card.getFace() > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} if (card.getFace() &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="603" end="-438"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488885479780" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1488890103920"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
