<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringMergingIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Modify the code for the StringMergingIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIteratorProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIteratorProgram"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="debugging.StringMergingIterator*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488888689407" sizeMeasure="54">
          <edit xsi:type="exercise:StringEdit" storedString="package debugging;&#xA;&#xA;import java.util.Iterator;&#xA;import java.util.NoSuchElementException;&#xA;&#xA;public class StringMergingIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;private Iterator&lt;String> first;&#xA;&#x9;private Iterator&lt;String> second;&#xA;&#x9;private boolean turnSwitch;&#xA;&#xA;&#x9;public StringMergingIterator(Iterator&lt;String> first, Iterator&lt;String> second){&#xA;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;this.turnSwitch = true;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! hasNext()){ &#xA;&#x9;&#x9;&#x9;throw new NoSuchElementException(); &#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! first.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if(turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(!turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return result;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889785709" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Etter &quot;b&quot; har ikke 'one' noe neste verdi, dermed utløses exception NoSuchElementException, fordi vi ikke har noe first.next(). hasNext() blir false." edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="677" end="-267"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889814196" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" !hasNext() ){ &#xA;&#x9;&#x9;&#x9;throw new NoSuchElementException(); &#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if( !first.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = first.next(); //Etter &quot;b&quot; har ikke 'one' noe neste verdi, dermed utløses exception NoSuchElementException, fordi vi ikke har noe first.next(). hasNext() blir false.&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if( !second.hasNext() " edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="540" end="-233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488889846537" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" ( !first.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = first.next(); //Etter &quot;b&quot; har ikke 'one' noe neste verdi, dermed utløses exception NoSuchElementException, fordi vi ikke har noe first.next(). hasNext() blir false.&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if ( !second.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (turnSwitch) {&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!turnSwitch) " edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="632" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890060624" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//returnerer true dersom iteratoren har flere verdier,&#xA;&#x9;//false dersom det ikke er flere verdier.&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;//returnerer den neste verdien fra iteratoren,&#xA;&#x9;//eller utløser et NoSuchElementException dersom iteratoren er tom.&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if( !hasNext() ){ &#xA;&#x9;&#x9;&#x9;throw new NoSuchElementException(); //om iterator er tom." edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="409" end="-509"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890392250" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import com.google.common.collect.Iterators;&#xA;&#xA;public class StringMergingIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;private Iterator&lt;String> first;&#xA;&#x9;private Iterator&lt;String> second;&#xA;&#x9;private boolean turnSwitch;&#xA;&#xA;&#x9;public StringMergingIterator(Iterator&lt;String> first, Iterator&lt;String> second){&#xA;&#x9;&#x9;if(Iterators.size(first) > Iterators.size(second)){&#xA;&#x9;&#x9;&#x9;this.first = second;&#xA;&#x9;&#x9;&#x9;this.second = first;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="89" end="-964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890667986" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if(Iterators.size(first) > Iterators.size(second)){&#xA;//&#x9;&#x9;&#x9;this.first = second;&#xA;//&#x9;&#x9;&#x9;this.second = first;&#xA;//&#x9;&#x9;} else {&#xA;//&#x9;&#x9;&#x9;this.first = first;&#xA;//&#x9;&#x9;&#x9;this.second = second;&#xA;//&#x9;&#x9;}&#xA;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="377" end="-964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="101" charEnd="136" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890775128" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="377" end="-1010"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="101" charEnd="136" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891756522" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;this.turnSwitch = true;&#xA;&#x9;}&#xA;&#xA;&#x9;//returnerer true dersom iteratoren har flere verdier,&#xA;&#x9;//false dersom det ikke er flere verdier.&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;//returnerer den neste verdien fra iteratoren,&#xA;&#x9;//eller utløser et NoSuchElementException dersom iteratoren er tom.&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if( !hasNext() ){ &#xA;&#x9;&#x9;&#x9;throw new NoSuchElementException(); //om iterator er tom.&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ( !first.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = second" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="377" end="-432"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="101" charEnd="136" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891777877" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="first" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1165" end="-216"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="101" charEnd="136" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891797075" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="second" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1165" end="-216"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="101" charEnd="136" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488891854887" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Bytte til first.next() til second.next() fungerer, men blir vel feil vis second.next ikke har noe element?" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1117" end="-273"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="101" charEnd="136" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488894145224" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="88" end="-1410"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="99" charEnd="134" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488894186682" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ListIterator" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="88" end="-1367"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="99" charEnd="121" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488894634913" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="88" end="-1367"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488908432433" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class StringMergingIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;private Iterator&lt;String> first;&#xA;&#x9;private Iterator&lt;String> second;&#xA;&#x9;private boolean turnSwitch;&#xA;&#xA;&#x9;public StringMergingIterator(Iterator&lt;String> first, Iterator&lt;String> second){&#xA;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;this.turnSwitch = true;&#xA;&#x9;}&#xA;&#xA;&#x9;//returnerer true dersom iteratoren har flere verdier,&#xA;&#x9;//false dersom det ikke er flere verdier.&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;//returnerer den neste verdien fra iteratoren,&#xA;&#x9;//eller utløser et NoSuchElementException dersom iteratoren er tom.&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if( !hasNext() ){ &#xA;&#x9;&#x9;&#x9;throw new NoSuchElementException(); //om iterator er tom.&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ( !first.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = second.next(); //Etter &quot;b&quot; har ikke 'one' noe neste verdi, dermed utløses exception NoSuchElementException, fordi vi ikke har noe first.next(). hasNext() blir false.&#xA;&#x9;&#x9;//Bytte til first.next() til second.next() fungerer, men blir vel feil vis second.next ikke har noe element?&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if ( !second.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (turnSwitch) {&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!turnSwitch) {&#xA;&#x9;&#x9;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="88" end="-90"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488909123231" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1363" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488909154472" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!turnSwitch) {&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1312" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488909607710" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if ( !first.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = second.next(); //Etter &quot;b&quot; har ikke 'one' noe neste verdi, dermed utløses exception NoSuchElementException, fordi vi ikke har noe first.next(). hasNext() blir false.&#xA;&#x9;&#x9;//Bytte til first.next() til second.next() fungerer, men blir vel feil vis second.next ikke har noe element?&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if ( !second.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (turnSwitch) {&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!turnSwitch) {&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;} turnSwitch = false;" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="837" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488909697460" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="} &#xA;&#x9;&#x9;&#x9;if (turnSwitch) {&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;} turnSwitch = tru" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1368" end="-41"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488909724216" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else {&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1421" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488909937223" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="first" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="1233" end="-255"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488910052860" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if ( !second.hasNext() ){&#xA;&#x9;&#x9;&#x9;result = first.next(); //Bytte til second.next() til first.next()" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1116" end="-247"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488910069655" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1469" end="-1470"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488910189833" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;//Hvis man setter turnSwitch = false, vil neste if-setning kjøre. Denne koden blir da ubrukelig fordi result = second.next(), vi vil ha first.next()&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!turnSwitch) {&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;} &#xA;&#x9;&#x9;&#x9;//Sjekker om turnSwitch er true if true, turnSwitch = false," edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1289" end="-124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488910192095" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1686" end="-1687"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488887242291" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488887325114" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488887588174" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488887692843" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488888767837" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488888860042" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488889011713" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488889074256" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890404257" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890404648" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890577670" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890616624" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890641892" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890671591" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890756386" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891761674" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891781393" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488893390108" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488893480088" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488893480979" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488894633953" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488895350062" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488895369376" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488895370470" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488908266164" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488908271480" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488908436149" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488908498712" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488909130840" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488909156970" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488909613398" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488909728525" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488909943399" mode="run"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a" performedCount="44">
        <attempts timestamp="1488887697100"/>
        <attempts timestamp="1488887735396"/>
        <attempts timestamp="1488887743433"/>
        <attempts timestamp="1488887748668"/>
        <attempts timestamp="1488887753403"/>
        <attempts timestamp="1488887914057"/>
        <attempts timestamp="1488887923386"/>
        <attempts timestamp="1488887926715"/>
        <attempts timestamp="1488887946470"/>
        <attempts timestamp="1488887952425"/>
        <attempts timestamp="1488887956771"/>
        <attempts timestamp="1488888770530"/>
        <attempts timestamp="1488888862693"/>
        <attempts timestamp="1488889076979"/>
        <attempts timestamp="1488889113437"/>
        <attempts timestamp="1488889115608"/>
        <attempts timestamp="1488889177051"/>
        <attempts timestamp="1488889194825"/>
        <attempts timestamp="1488889194825"/>
        <attempts timestamp="1488889348771"/>
        <attempts timestamp="1488889361046"/>
        <attempts timestamp="1488889366562"/>
        <attempts timestamp="1488889366562"/>
        <attempts timestamp="1488889421250"/>
        <attempts timestamp="1488889431879"/>
        <attempts timestamp="1488889525939"/>
        <attempts timestamp="1488889525939"/>
        <attempts timestamp="1488890408066"/>
        <attempts timestamp="1488890444748"/>
        <attempts timestamp="1488890448228"/>
        <attempts timestamp="1488890483138"/>
        <attempts timestamp="1488908282407"/>
        <attempts timestamp="1488908312638"/>
        <attempts timestamp="1488908312638"/>
        <attempts timestamp="1488908433064"/>
        <attempts timestamp="1488908433064"/>
        <attempts timestamp="1488908438953"/>
        <attempts timestamp="1488908462400"/>
        <attempts timestamp="1488908462400"/>
        <attempts timestamp="1488908466638"/>
        <attempts timestamp="1488908466638"/>
        <attempts timestamp="1488908468755"/>
        <attempts timestamp="1488908468945"/>
        <attempts timestamp="1488908469307"/>
      </proposals>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="46">
        <attempts timestamp="1488887697100"/>
        <attempts timestamp="1488887735396"/>
        <attempts timestamp="1488887743433"/>
        <attempts timestamp="1488887748668"/>
        <attempts timestamp="1488887753403"/>
        <attempts timestamp="1488887914057"/>
        <attempts timestamp="1488887923386"/>
        <attempts timestamp="1488887926715"/>
        <attempts timestamp="1488887946470"/>
        <attempts timestamp="1488887952425"/>
        <attempts timestamp="1488887956771"/>
        <attempts timestamp="1488887987811"/>
        <attempts timestamp="1488888770530"/>
        <attempts timestamp="1488888862693"/>
        <attempts timestamp="1488889076979"/>
        <attempts timestamp="1488889113437"/>
        <attempts timestamp="1488889115608"/>
        <attempts timestamp="1488889177051"/>
        <attempts timestamp="1488889194825"/>
        <attempts timestamp="1488889194825"/>
        <attempts timestamp="1488889348771"/>
        <attempts timestamp="1488889361046"/>
        <attempts timestamp="1488889366562"/>
        <attempts timestamp="1488889366562"/>
        <attempts timestamp="1488889421250"/>
        <attempts timestamp="1488889431879"/>
        <attempts timestamp="1488889525939"/>
        <attempts timestamp="1488889525939"/>
        <attempts timestamp="1488889545696"/>
        <attempts timestamp="1488890408066"/>
        <attempts timestamp="1488890444748"/>
        <attempts timestamp="1488890448228"/>
        <attempts timestamp="1488890483138"/>
        <attempts timestamp="1488908282407"/>
        <attempts timestamp="1488908312642"/>
        <attempts timestamp="1488908312642"/>
        <attempts timestamp="1488908433064"/>
        <attempts timestamp="1488908433064"/>
        <attempts timestamp="1488908438953"/>
        <attempts timestamp="1488908462400"/>
        <attempts timestamp="1488908462400"/>
        <attempts timestamp="1488908466638"/>
        <attempts timestamp="1488908466638"/>
        <attempts timestamp="1488908468755"/>
        <attempts timestamp="1488908468945"/>
        <attempts timestamp="1488908469307"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="38">
        <attempts timestamp="1488889093842"/>
        <attempts timestamp="1488889106318"/>
        <attempts timestamp="1488889109805"/>
        <attempts timestamp="1488889111840"/>
        <attempts timestamp="1488889113421"/>
        <attempts timestamp="1488890424912"/>
        <attempts timestamp="1488890426838"/>
        <attempts timestamp="1488890444069"/>
        <attempts timestamp="1488890444748"/>
        <attempts timestamp="1488890462753"/>
        <attempts timestamp="1488908286086"/>
        <attempts timestamp="1488908291095"/>
        <attempts timestamp="1488908300801"/>
        <attempts timestamp="1488908304824"/>
        <attempts timestamp="1488908309252"/>
        <attempts timestamp="1488908441812"/>
        <attempts timestamp="1488908442899"/>
        <attempts timestamp="1488908443405"/>
        <attempts timestamp="1488908443926"/>
        <attempts timestamp="1488908464756"/>
        <attempts timestamp="1488908465175"/>
        <attempts timestamp="1488908466335"/>
        <attempts timestamp="1488908466638"/>
        <attempts timestamp="1488908466919"/>
        <attempts timestamp="1488908467326"/>
        <attempts timestamp="1488908467543"/>
        <attempts timestamp="1488908467751"/>
        <attempts timestamp="1488908467952"/>
        <attempts timestamp="1488908468140"/>
        <attempts timestamp="1488908468372"/>
        <attempts timestamp="1488908468575"/>
        <attempts timestamp="1488908468755"/>
        <attempts timestamp="1488908468945"/>
        <attempts timestamp="1488908469119"/>
        <attempts timestamp="1488908469291"/>
        <attempts timestamp="1488908469486"/>
        <attempts timestamp="1488908469689"/>
        <attempts timestamp="1488908469848"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="146">
        <attempts timestamp="1488887740319"/>
        <attempts timestamp="1488887743417"/>
        <attempts timestamp="1488887744597"/>
        <attempts timestamp="1488887747122"/>
        <attempts timestamp="1488887748652"/>
        <attempts timestamp="1488887753341"/>
        <attempts timestamp="1488887777366"/>
        <attempts timestamp="1488887779905"/>
        <attempts timestamp="1488887785237"/>
        <attempts timestamp="1488887787694"/>
        <attempts timestamp="1488887791047"/>
        <attempts timestamp="1488887792703"/>
        <attempts timestamp="1488887796459"/>
        <attempts timestamp="1488887797396"/>
        <attempts timestamp="1488887896276"/>
        <attempts timestamp="1488887897542"/>
        <attempts timestamp="1488887901199"/>
        <attempts timestamp="1488887903934"/>
        <attempts timestamp="1488887906095"/>
        <attempts timestamp="1488887914041"/>
        <attempts timestamp="1488887917588"/>
        <attempts timestamp="1488887918900"/>
        <attempts timestamp="1488887923370"/>
        <attempts timestamp="1488887926699"/>
        <attempts timestamp="1488887930922"/>
        <attempts timestamp="1488887932924"/>
        <attempts timestamp="1488887934689"/>
        <attempts timestamp="1488887935880"/>
        <attempts timestamp="1488887936771"/>
        <attempts timestamp="1488887937731"/>
        <attempts timestamp="1488887939356"/>
        <attempts timestamp="1488887941325"/>
        <attempts timestamp="1488887942940"/>
        <attempts timestamp="1488887943893"/>
        <attempts timestamp="1488887945127"/>
        <attempts timestamp="1488887945726"/>
        <attempts timestamp="1488887946132"/>
        <attempts timestamp="1488887946439"/>
        <attempts timestamp="1488887946611"/>
        <attempts timestamp="1488887948830"/>
        <attempts timestamp="1488887952409"/>
        <attempts timestamp="1488887956771"/>
        <attempts timestamp="1488887959171"/>
        <attempts timestamp="1488887963507"/>
        <attempts timestamp="1488887983474"/>
        <attempts timestamp="1488887984943"/>
        <attempts timestamp="1488887986667"/>
        <attempts timestamp="1488887987795"/>
        <attempts timestamp="1488888823432"/>
        <attempts timestamp="1488888829066"/>
        <attempts timestamp="1488888837091"/>
        <attempts timestamp="1488888839563"/>
        <attempts timestamp="1488888865115"/>
        <attempts timestamp="1488889089687"/>
        <attempts timestamp="1488889115608"/>
        <attempts timestamp="1488889116921"/>
        <attempts timestamp="1488889150308"/>
        <attempts timestamp="1488889177035"/>
        <attempts timestamp="1488889194809"/>
        <attempts timestamp="1488889203657"/>
        <attempts timestamp="1488889212641"/>
        <attempts timestamp="1488889222765"/>
        <attempts timestamp="1488889227155"/>
        <attempts timestamp="1488889233992"/>
        <attempts timestamp="1488889240065"/>
        <attempts timestamp="1488889246759"/>
        <attempts timestamp="1488889276538"/>
        <attempts timestamp="1488889300108"/>
        <attempts timestamp="1488889305858"/>
        <attempts timestamp="1488889310231"/>
        <attempts timestamp="1488889317065"/>
        <attempts timestamp="1488889323547"/>
        <attempts timestamp="1488889348771"/>
        <attempts timestamp="1488889353538"/>
        <attempts timestamp="1488889358464"/>
        <attempts timestamp="1488889361046"/>
        <attempts timestamp="1488889366546"/>
        <attempts timestamp="1488889370565"/>
        <attempts timestamp="1488889373697"/>
        <attempts timestamp="1488889375648"/>
        <attempts timestamp="1488889377683"/>
        <attempts timestamp="1488889381839"/>
        <attempts timestamp="1488889386775"/>
        <attempts timestamp="1488889388213"/>
        <attempts timestamp="1488889389323"/>
        <attempts timestamp="1488889392139"/>
        <attempts timestamp="1488889395657"/>
        <attempts timestamp="1488889397824"/>
        <attempts timestamp="1488889414365"/>
        <attempts timestamp="1488889418797"/>
        <attempts timestamp="1488889421250"/>
        <attempts timestamp="1488889422831"/>
        <attempts timestamp="1488889430076"/>
        <attempts timestamp="1488889431879"/>
        <attempts timestamp="1488889525927"/>
        <attempts timestamp="1488889529231"/>
        <attempts timestamp="1488889533335"/>
        <attempts timestamp="1488889537099"/>
        <attempts timestamp="1488889538333"/>
        <attempts timestamp="1488889541037"/>
        <attempts timestamp="1488889545685"/>
        <attempts timestamp="1488890411736"/>
        <attempts timestamp="1488890428533"/>
        <attempts timestamp="1488890435329"/>
        <attempts timestamp="1488890436861"/>
        <attempts timestamp="1488890448213"/>
        <attempts timestamp="1488890451093"/>
        <attempts timestamp="1488890453582"/>
        <attempts timestamp="1488890456692"/>
        <attempts timestamp="1488890458524"/>
        <attempts timestamp="1488890477364"/>
        <attempts timestamp="1488890483122"/>
        <attempts timestamp="1488890490100"/>
        <attempts timestamp="1488908312559"/>
        <attempts timestamp="1488908323404"/>
        <attempts timestamp="1488908325824"/>
        <attempts timestamp="1488908327466"/>
        <attempts timestamp="1488908328623"/>
        <attempts timestamp="1488908329151"/>
        <attempts timestamp="1488908330536"/>
        <attempts timestamp="1488908331633"/>
        <attempts timestamp="1488908332410"/>
        <attempts timestamp="1488908399817"/>
        <attempts timestamp="1488908401742"/>
        <attempts timestamp="1488908406937"/>
        <attempts timestamp="1488908412039"/>
        <attempts timestamp="1488908445827"/>
        <attempts timestamp="1488908447256"/>
        <attempts timestamp="1488908449564"/>
        <attempts timestamp="1488908450487"/>
        <attempts timestamp="1488908452638"/>
        <attempts timestamp="1488908457137"/>
        <attempts timestamp="1488908457874"/>
        <attempts timestamp="1488908458913"/>
        <attempts timestamp="1488908460770"/>
        <attempts timestamp="1488908461677"/>
        <attempts timestamp="1488908462166"/>
        <attempts timestamp="1488908462384"/>
        <attempts timestamp="1488908462577"/>
        <attempts timestamp="1488908462749"/>
        <attempts timestamp="1488908462916"/>
        <attempts timestamp="1488908463111"/>
        <attempts timestamp="1488908463262"/>
        <attempts timestamp="1488908463413"/>
        <attempts timestamp="1488908463582"/>
        <attempts timestamp="1488908463739"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="21">
        <attempts timestamp="1488887710885"/>
        <attempts timestamp="1488887711276"/>
        <attempts timestamp="1488887711354"/>
        <attempts timestamp="1488887711401"/>
        <attempts timestamp="1488887711464"/>
        <attempts timestamp="1488887713544"/>
        <attempts timestamp="1488887713544"/>
        <attempts timestamp="1488887718882"/>
        <attempts timestamp="1488887727725"/>
        <attempts timestamp="1488887763464"/>
        <attempts timestamp="1488888797344"/>
        <attempts timestamp="1488888800127"/>
        <attempts timestamp="1488888807747"/>
        <attempts timestamp="1488889129925"/>
        <attempts timestamp="1488889344628"/>
        <attempts timestamp="1488889765235"/>
        <attempts timestamp="1488889776171"/>
        <attempts timestamp="1488890432831"/>
        <attempts timestamp="1488890516650"/>
        <attempts timestamp="1488907907090"/>
        <attempts timestamp="1488908295373"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
