<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488878035857" sizeMeasure="59" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private char value;&#xA;&#x9;private int number;&#xA;&#x9;ArrayList&lt;Character> colors = new ArrayList&lt;Character>();&#xA;&#x9;public Card(char color, int number){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;if (!checkColor(color) || !(checkNumber(number))){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Noen av verdiene er ugyldige&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.value = color;&#xA;&#x9;&#x9;this.number = number;&#xA;&#x9;}&#xA;&#x9;public boolean checkColor(char color){&#xA;&#x9;&#x9;for (int i = 0; i &lt; colors.size(); i++){&#xA;&#x9;&#x9;&#x9;if (color == colors.get(i)){&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;public boolean checkNumber(int number){&#xA;&#x9;&#x9;if((number &lt;1) || (number>13)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return this.value;&#xA;&#x9;}&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return this.number;&#xA;&#x9;}&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;&quot; + this.value + this.number;&#xA;&#x9;}&#xA;&#xA;&#x9;public int compareTo(Card card){&#xA;&#x9;&#x9;int value1 = colors.indexOf(this.value);&#xA;&#x9;&#x9;int value2 = colors.indexOf(card.getSuit());&#xA;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((value1 == value2)&amp;&amp;(this.number == card.getFace())){&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((value1 == value2)&amp;&amp;(this.number &lt; card.getFace())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="75" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488878064589" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488878086931" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488878197905" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;import objectstructures.Card;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private char value;&#xA;&#x9;private int number;&#xA;&#x9;ArrayList&lt;Character> colors = new ArrayList&lt;Character>();&#xA;&#x9;public Card(char color, int number){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;if (!checkColor(color) || !(checkNumber(number))){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Noen av verdiene er ugyldige&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.value = color;&#xA;&#x9;&#x9;this.number = number;&#xA;&#x9;}&#xA;&#x9;public boolean checkColor(char color){&#xA;&#x9;&#x9;for (int i = 0; i &lt; colors.size(); i++){&#xA;&#x9;&#x9;&#x9;if (color == colors.get(i)){&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;public boolean checkNumber(int number){&#xA;&#x9;&#x9;if((number &lt;1) || (number>13)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return this.value;&#xA;&#x9;}&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return this.number;&#xA;&#x9;}&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;&quot; + this.value + this.number;&#xA;&#x9;}&#xA;&#xA;&#x9;public int compareTo(Card card){&#xA;&#x9;&#x9;int value1 = colors.indexOf(this.value);&#xA;&#x9;&#x9;int value2 = colors.indexOf(card.getSuit());&#xA;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((value1 == value2)&amp;&amp;(this.number == card.getFace())){&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((value1 == value2)&amp;&amp;(this.number &lt; card.getFace())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="21" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="61" charEnd="82" severity="2" problemCategory="30" problemType="268435841"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488878236850" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="50" end="-1265"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488878309421" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="50" end="-1265"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881709510" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class Card implements Comparable&lt;Card>{&#xA;&#x9;private char value;&#xA;&#x9;private int number;&#xA;&#x9;ArrayList&lt;Character> colors = new ArrayList&lt;Character>();&#xA;&#x9;public Card(char color, int number){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;if (!checkColor(color) || !(checkNumber(number))){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Noen av verdiene er ugyldige&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.value = color;&#xA;&#x9;&#x9;this.number = number;&#xA;&#x9;}&#xA;&#x9;public boolean checkColor(char color){&#xA;&#x9;&#x9;for (int i = 0; i &lt; colors.size(); i++){&#xA;&#x9;&#x9;&#x9;if (color == colors.get(i)){&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;public boolean checkNumber(int number){&#xA;&#x9;&#x9;if((number &lt;1) || (number>13)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return this.value;&#xA;&#x9;}&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return this.number;&#xA;&#x9;}&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;&quot; + this.value + this.number;&#xA;&#x9;}&#xA;&#xA;&#x9;public int compareTo(Card card){&#xA;&#x9;&#x9;int value1 = colors.indexOf(this.value);&#xA;&#x9;&#x9;int value2 = colors.indexOf(card.getSuit());&#xA;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((value1 == value2)&amp;&amp;(this.number == card.getFace())){&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((value1 == value2)&amp;&amp;(this.number &lt; card.getFace())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="50" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882053963" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>{&#xA;&#x9;private char value;&#xA;&#x9;private int number;&#xA;&#x9;ArrayList&lt;Character> colors = new ArrayList&lt;Character>();&#xA;&#x9;public Card(char color, int number){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;if (!checkColor(color) || !(checkNumber(number))){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Noen av verdiene er ugyldige&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.value = color;&#xA;&#x9;&#x9;this.number = number;&#xA;&#x9;}&#xA;&#x9;public boolean checkColor(char color){&#xA;&#x9;&#x9;for (int i = 0; i &lt; colors.size(); i++){&#xA;&#x9;&#x9;&#x9;if (color == colors.get(i)){&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;public boolean checkNumber(int number){&#xA;&#x9;&#x9;if((number &lt;1) || (number>13)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#x9;public char getSuit(){&#xA;&#x9;&#x9;return this.value;&#xA;&#x9;}&#xA;&#x9;public int getFace(){&#xA;&#x9;&#x9;return this.number;&#xA;&#x9;}&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;&quot; + this.value + this.number;&#xA;&#x9;}&#xA;&#x9;public int compareTo(Card card){&#xA;&#x9;&#x9;int value1 = colors.indexOf(this.value);&#xA;&#x9;&#x9;int value2 = colors.indexOf(card.getSuit());&#xA;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((value1 == value2)&amp;&amp;(this.number == card.getFace())){&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if((value1 == value2)&amp;&amp;(this.number &lt; card.getFace())){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> banan = new ArrayList&lt;>();&#xA;&#x9;&#x9;banan.add(new Card('S',4));&#xA;&#x9;&#x9;banan.add(new Card('D',1));&#xA;&#x9;&#x9;banan.add(new Card('C',2));&#xA;&#x9;&#x9;banan.add(new Card('H',5));&#xA;&#x9;&#x9;banan.add(new Card('S',4));&#xA;&#x9;&#x9;banan.add(new Card('S',7));&#xA;&#x9;&#x9;banan.add(new Card('S',9));&#xA;&#x9;&#x9;Collections.sort(banan);&#xA;&#x9;&#x9;System.out.println(banan);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="49" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882116215" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="121" end="-1570"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="69" charStart="1711" charEnd="1715" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882171618" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="121" end="-1570"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882194434" sizeMeasure="60" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1364" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="104" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882225607" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> banan = new ArrayList&lt;>();&#xA;&#x9;&#x9;banan.add(new Card('S',4));&#xA;&#x9;&#x9;banan.add(new Card('D',1));&#xA;&#x9;&#x9;banan.add(new Card('C',2));&#xA;&#x9;&#x9;banan.add(new Card('H',5));&#xA;&#x9;&#x9;banan.add(new Card('S',4));&#xA;&#x9;&#x9;banan.add(new Card('S',7));&#xA;&#x9;&#x9;banan.add(new Card('S',9));&#xA;&#x9;&#x9;Collections.sort(banan);&#xA;&#x9;&#x9;System.out.println(banan);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1364" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882332040" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1339" end="-362"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488958283131" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kort = new ArrayList&lt;>();&#xA;&#x9;&#x9;kort.add(new Card('S',4));&#xA;&#x9;&#x9;kort.add(new Card('D',1));&#xA;&#x9;&#x9;kort.add(new Card('C',2));&#xA;&#x9;&#x9;kort.add(new Card('H',5));&#xA;&#x9;&#x9;kort.add(new Card('S',4));&#xA;&#x9;&#x9;kort.add(new Card('S',7));&#xA;&#x9;&#x9;kort.add(new Card('S',9));&#xA;&#x9;&#x9;Collections.sort(kort);&#xA;&#x9;&#x9;System.out.println(kort" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1419" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488899602164" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488899934590" sizeMeasure="21" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator{&#xA;&#x9;boolean aceHighest;&#xA;&#x9;boolean valueHighest;&#xA;&#x9;List&lt;Character> colors = new ArrayList&lt;Character>();&#xA;&#x9;public CardComparator(boolean aceHighest, char valueHighest){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int compare(Object arg0, Object arg1) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="147" charEnd="157" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488900107356" sizeMeasure="22" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char trumf;&#xA;&#x9;List&lt;Character> colors = new ArrayList&lt;Character>();&#xA;&#x9;public CardComparator(boolean aceHighest, char trumf){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;this.aceHighest = aceHighest;&#xA;&#x9;&#x9;this.trumf = trumf;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="175" end="-120"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="147" charEnd="157" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488900259913" sizeMeasure="18" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="422" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="121" charEnd="135" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="147" charEnd="157" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488911570484" sizeMeasure="51" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public int compare(Card card1,Card card2){&#xA;&#x9;&#x9;if (colors.contains(trumf)){&#xA;&#x9;&#x9;&#x9;int trumfValue = colors.indexOf(trumf);&#xA;&#x9;&#x9;&#x9;char color = colors.get(trumfValue);&#xA;&#x9;&#x9;&#x9;colors.remove(trumfValue);&#xA;&#x9;&#x9;&#x9;colors.add(0, color);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int value1 = colors.indexOf(card1.getSuit());&#xA;&#x9;&#x9;int value2 = colors.indexOf(card2.getSuit());&#xA;&#x9;&#x9;if (!aceHighest){&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() &lt; card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == 1) &amp;&amp; (card2.getFace()!= 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2) &amp;&amp; (card1.getFace() != 1) &amp;&amp; (card2.getFace() == 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="422" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="147" charEnd="157" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="121" charEnd="135" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488912006370" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Card>" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="151" end="-1279"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488913559830" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="llections;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;boolean aceHighest;&#xA;&#x9;char trumf;&#xA;&#x9;List&lt;Character> colors = new ArrayList&lt;Character>();&#xA;&#x9;public CardComparator(boolean aceHighest, char trumf){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;this.aceHighest = aceHighest;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;public int compare(Card card1,Card card2){&#xA;&#x9;&#x9;if (colors.contains(trumf)){&#xA;&#x9;&#x9;&#x9;int trumfValue = colors.indexOf(trumf);&#xA;&#x9;&#x9;&#x9;char color = colors.get(trumfValue);&#xA;&#x9;&#x9;&#x9;colors.remove(trumfValue);&#xA;&#x9;&#x9;&#x9;colors.add(0, color);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int value1 = colors.indexOf(card1.getSuit());&#xA;&#x9;&#x9;int value2 = colors.indexOf(card2.getSuit());&#xA;&#x9;&#x9;if (!aceHighest){&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() &lt; card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == 1) &amp;&amp; (card2.getFace()!= 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2) &amp;&amp; (card1.getFace()!= 1) &amp;&amp; (card2.getFace() == 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> banan = new ArrayList&lt;>();&#xA;&#x9;&#x9;banan.add(new Card('S',4));&#xA;&#x9;&#x9;banan.add(new Card('D',1));&#xA;&#x9;&#x9;banan.add(new Card('C',2));&#xA;&#x9;&#x9;banan.add(new Card('H',5));&#xA;&#x9;&#x9;banan.add(new Card('S',4));&#xA;&#x9;&#x9;banan.add(new Card('S',7));&#xA;&#x9;&#x9;banan.add(new Card('S',9));&#xA;&#x9;&#x9;Collections.sort(banan);&#xA;&#x9;&#x9;System.out.println(banan);" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="68" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914351497" sizeMeasure="66" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;cards.add(new Card('S',4));&#xA;&#x9;&#x9;cards.add(new Card('D',1));&#xA;&#x9;&#x9;cards.add(new Card('C',2));&#xA;&#x9;&#x9;cards.add(new Card('H',5));&#xA;&#x9;&#x9;cards.add(new Card('S',4));&#xA;&#x9;&#x9;cards.add(new Card('S',7));&#xA;&#x9;&#x9;cards.add(new Card('S',9));&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;System.out.println(cards);&#xA;&#x9;&#x9;cards.sort(new CardComparator(false, ''));&#xA;&#x9;&#x9;System.out.println(cards" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1517" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="63" charStart="1911" charEnd="1913" severity="2" problemCategory="20" problemType="1610612989"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914377793" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1850" end="-40"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914398383" sizeMeasure="65" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1756" end="-113"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914577550" sizeMeasure="66" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public CardComparator(boolean aceHighest, char trumf){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;this.aceHighest = aceHighest;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;public int compare(Card card1,Card card2){&#xA;&#x9;&#x9;if (colors.contains(trumf)){&#xA;&#x9;&#x9;&#x9;int trumfValue = colors.indexOf(trumf);&#xA;&#x9;&#x9;&#x9;char color = colors.get(trumfValue);&#xA;&#x9;&#x9;&#x9;colors.remove(trumfValue);&#xA;&#x9;&#x9;&#x9;colors.add(0, color);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int value1 = colors.indexOf(card1.getSuit());&#xA;&#x9;&#x9;int value2 = colors.indexOf(card2.getSuit());&#xA;&#x9;&#x9;if (!aceHighest){&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() &lt; card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == 1) &amp;&amp; (card2.getFace()!= 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2) &amp;&amp; (card1.getFace()!= 1) &amp;&amp; (card2.getFace() == 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;>();&#xA;&#x9;&#x9;cards.add(new Card('S',4));&#xA;&#x9;&#x9;cards.add(new Card('D',1));&#xA;&#x9;&#x9;cards.add(new Card('C',2));&#xA;&#x9;&#x9;cards.add(new Card('H',5));&#xA;&#x9;&#x9;cards.add(new Card('S',4));&#xA;&#x9;&#x9;cards.add(new Card('S',7));&#xA;&#x9;&#x9;cards.add(new Card('S',9)" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="278" end="-113"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914686635" sizeMeasure="66" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1817" end="-45"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488914710549" sizeMeasure="68" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="false, ' '" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1817" end="-113"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="59" charEnd="80" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488915175562" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="68" end="-1863"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928362842" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="mparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;boolean aceHighest;&#xA;&#x9;char trumf;&#xA;&#x9;List&lt;Character> colors = new ArrayList&lt;Character>();&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean aceHighest, char trumf){&#xA;&#x9;&#x9;colors.add('S');colors.add('H');colors.add('D');colors.add('C');&#xA;&#x9;&#x9;this.aceHighest = aceHighest;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;public int compare(Card card1,Card card2){&#xA;&#x9;&#x9;if (colors.contains(trumf)){&#xA;&#x9;&#x9;&#x9;int trumfValue = colors.indexOf(trumf);&#xA;&#x9;&#x9;&#x9;char color = colors.get(trumfValue);&#xA;&#x9;&#x9;&#x9;colors.remove(trumfValue);&#xA;&#x9;&#x9;&#x9;colors.add(0, color);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int value1 = colors.indexOf(card1.getSuit());&#xA;&#x9;&#x9;int value2 = colors.indexOf(card2.getSuit());&#xA;&#x9;&#x9;if (!aceHighest){&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() &lt; card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == 1) &amp;&amp; (card2.getFace()!= 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2) &amp;&amp; (card1.getFace()!= 1) &amp;&amp; (card2.getFace() == 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() &lt; card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="68" end="-486"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928423189" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1776" end="-218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928508886" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if (value1 &lt; value2){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if (value1 > value2){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() == 1) &amp;&amp; (card2.getFace()!= 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2) &amp;&amp; (card1.getFace()!= 1) &amp;&amp; (card2.getFace() == 1)){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}else if((value1 == value2)&amp;&amp;(card1.getFace() &lt; card2.getFace())){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1013" end="-486"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488882053853" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488882116168" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488882233718" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488882341911" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488883240812" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914351328" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914377607" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914398151" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914667871" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914686450" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488914710395" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488916050839" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488928404374" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488928423040" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488928510534" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488958584223" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488914801723" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488915176861" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488922957987" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488928366682" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488958634381" completion="0.0" errorCount="3">
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testDiamondIsTrumph</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488958781287" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="3">
        <attempts timestamp="1488883288838"/>
        <attempts timestamp="1488883296040"/>
        <attempts timestamp="1488883296150"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="2">
        <attempts timestamp="1488883303649"/>
        <attempts timestamp="1488883304703"/>
        <attempts timestamp="1488883306625"/>
        <attempts timestamp="1488883308805"/>
        <attempts timestamp="1488883309447"/>
        <attempts timestamp="1488883310418"/>
        <attempts timestamp="1488883312096"/>
        <attempts timestamp="1488883314070"/>
        <attempts timestamp="1488883314601"/>
        <attempts timestamp="1488883316177"/>
        <attempts timestamp="1488883316882"/>
        <attempts timestamp="1488883317476"/>
        <attempts timestamp="1488883318199"/>
        <attempts timestamp="1488883319253"/>
        <attempts timestamp="1488883320428"/>
        <attempts timestamp="1488883320897"/>
        <attempts timestamp="1488883321319"/>
        <attempts timestamp="1488883321913"/>
        <attempts timestamp="1488883322272"/>
        <attempts timestamp="1488883322569"/>
        <attempts timestamp="1488883322975"/>
        <attempts timestamp="1488883323303"/>
        <attempts timestamp="1488883323475"/>
        <attempts timestamp="1488883323647"/>
        <attempts timestamp="1488883323850"/>
        <attempts timestamp="1488883324975"/>
        <attempts timestamp="1488883325194"/>
        <attempts timestamp="1488883325522"/>
        <attempts timestamp="1488883325725"/>
        <attempts timestamp="1488898899117"/>
        <attempts timestamp="1488898900339"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1488883285803"/>
        <attempts timestamp="1488898804837"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
