<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407014054" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public interface Employee {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407018002" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="65" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407069919" sizeMeasure="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407113495" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;void printDocument(String document);&#xA;&#x9;int getTaskCount();&#xA;&#x9;int getResourceCount(" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="198" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407156930" sizeMeasure="31">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407194560" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return operation.apply(value1, value2)" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="231" end="-298"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407252941" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="121" end="-447"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407416833" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate Printer printer;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="125" end="-450"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="153" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407449253" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="printer.printDocument(document, this);" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="426" end="-198"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407481998" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int taskCount;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="150" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407493378" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 1" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="618" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407679558" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.taskCount = 0" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="235" end="-403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408288326" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount++;&#xA;&#x9;&#x9;printer.printDocument(document, this)" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="472" end="-133"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408339223" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his." edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="473" end="-185"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408378045" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.taskCount++;" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="369" end="-296"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489408129050" completion="0.5" successCount="2" failureCount="2">
          <successTests>testResourceCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <failureTests>testDoCalculations</failureTests>
          <failureTests>testTaskCount</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489408253078" completion="0.5" successCount="2" failureCount="2">
          <successTests>testResourceCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <failureTests>testDoCalculations</failureTests>
          <failureTests>testTaskCount</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489408273678" completion="0.5" successCount="2" failureCount="2">
          <successTests>testResourceCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <failureTests>testDoCalculations</failureTests>
          <failureTests>testTaskCount</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489408290548" completion="0.5" successCount="2" failureCount="2">
          <successTests>testResourceCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <failureTests>testDoCalculations</failureTests>
          <failureTests>testTaskCount</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489408343818" completion="0.5" successCount="2" failureCount="2">
          <successTests>testResourceCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <failureTests>testDoCalculations</failureTests>
          <failureTests>testTaskCount</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489408378513" completion="1.0" successCount="4">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407243413" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407294959" sizeMeasure="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="60" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407342914" sizeMeasure="13" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="133" end="-31"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="151" charEnd="155" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407525330" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(document);" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="129" end="-77"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="184" charEnd="188" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489407760895" sizeMeasure="22" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;private Map&lt;Employee, List&lt;String>> printHistory = new HashMap&lt;Employee, List&lt;String>>();&#xA;&#x9;&#xA;&#x9;public void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;printHistory.add(arg0)" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="37" end="-77"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="384" charEnd="388" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="388" charEnd="389" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="423" charEnd="457" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408036275" sizeMeasure="26" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (printHistory.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;List&lt;String> printHistoryList = printHistory.get(employee);&#xA;&#x9;&#x9;&#x9;printHistoryList.add(document);&#xA;&#x9;&#x9;&#x9;printHistory.put(employee, printHistoryList);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="354" end="-77"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="46" charEnd="65" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="597" charEnd="631" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408083753" sizeMeasure="29" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;List&lt;String> printHistoryList = new ArrayList&lt;>();&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="546" end="-81"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="588" charEnd="604" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="669" charEnd="703" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408095985" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="printHistoryList.add(document" edit="/1/@proposals.0/@proposals.4/@attempts.6/@edit" start="611" end="-87"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="705" charEnd="739" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408105967" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="printHistory.put(employee, printHistoryList);" edit="/1/@proposals.0/@proposals.4/@attempts.7/@edit" start="646" end="-81"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="750" charEnd="784" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408122765" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return printHistory.get(employee);" edit="/1/@proposals.0/@proposals.4/@attempts.8/@edit" start="764" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408232989" sizeMeasure="32" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (printHistory.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;return printHistory.get(employee);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.9/@edit" start="764" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="750" charEnd="784" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408248667" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;return new ArrayList&lt;>(" edit="/1/@proposals.0/@proposals.4/@attempts.10/@edit" start="847" end="-14"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489408146341" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testPrintHistoryModification</successTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489408255860" completion="1.0" successCount="3">
          <successTests>testPrintHistoryModification</successTests>
          <successTests>testPrintSingleClerk</successTests>
          <successTests>testPrintMulipleClerks</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408399696" sizeMeasure="31">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408508723" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;private Collection&lt;Employee> employees;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;)&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="54" end="-454"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="356" charEnd="357" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408513002" sizeMeasure="42" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="346" end="-503"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="191" charEnd="200" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408558902" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return employees.size()" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="796" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408633138" sizeMeasure="43" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;&#x9;this.taskCount = 0" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="196" end="-440"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="216" charEnd="225" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408715184" sizeMeasure="47" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private Employee getClerk() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="871" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="933" charEnd="943" severity="1" problemCategory="120" problemType="603979894"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="933" charEnd="943" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="216" charEnd="225" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408843874" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Iterator;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;private Collection&lt;Employee> employees;&#xA;&#x9;private int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return employees.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee getClerk() {&#xA;&#x9;&#x9;Iterator&lt;Employee> it = employees.iterator();&#xA;&#x9;&#x9;if " edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="83" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1026" charEnd="1028" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408861881" sizeMeasure="51" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(it.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it.next()&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="984" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1065" charEnd="1066" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489408946106" sizeMeasure="54" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1 = employees.iterator();&#xA;&#x9;&#x9;if (it1.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it1.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Iterator&lt;Employee> it2 = it1;&#xA;&#x9;&#x9;&#x9;return it2.next();" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="954" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="244" charEnd="253" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="961" charEnd="971" severity="1" problemCategory="120" problemType="603979894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409003088" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount++;&#xA;&#x9;&#x9;return getClerk().doCalculations(operation, value1, value2)" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="581" end="-476"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="244" charEnd="253" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409028486" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount++;&#xA;&#x9;&#x9;return getClerk().printDocument(document);" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="720" end="-377"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="764" charEnd="806" severity="2" problemCategory="50" problemType="67108969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409045170" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getClerk().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount" edit="/1/@proposals.0/@proposals.7/@attempts.10/@edit" start="735" end="-284"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409110768" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;" edit="/1/@proposals.0/@proposals.7/@attempts.11/@edit" start="403" end="-651"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409155858" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int resourceCount = 1;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.12/@edit" start="877" end="-208"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="893" charEnd="911" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409191244" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;" edit="/1/@proposals.0/@proposals.7/@attempts.13/@edit" start="902" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409240757" sizeMeasure="59" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Random" edit="/1/@proposals.0/@proposals.7/@attempts.14/@edit" start="1046" end="-181"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="755" charEnd="763" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1091" charEnd="1107" severity="1" problemCategory="120" problemType="603979894"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="617" charEnd="625" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409278833" sizeMeasure="59" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="delegate" edit="/1/@proposals.0/@proposals.7/@attempts.15/@edit" start="1043" end="-176"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="617" charEnd="625" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="755" charEnd="763" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1091" charEnd="1101" severity="1" problemCategory="120" problemType="603979894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409323080" sizeMeasure="59" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = employees.iterator();&#xA;&#x9;&#x9;if (it.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Iterator&lt;Employee> it = employees.iterator();&#xA;&#x9;&#x9;&#x9;return it" edit="/1/@proposals.0/@proposals.7/@attempts.16/@edit" start="1079" end="-20"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="617" charEnd="625" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="755" charEnd="763" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1233" charEnd="1235" severity="2" problemCategory="60" problemType="536870967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409369357" sizeMeasure="60" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Iterator&lt;Employee> it = employees.iterator();&#xA;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return getClerk().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;getClerk().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee delegate() {&#xA;&#x9;&#x9;if (it.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this." edit="/1/@proposals.0/@proposals.7/@attempts.17/@edit" start="247" end="-59"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1149" charEnd="1159" severity="1" problemCategory="120" problemType="603979894"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="675" charEnd="683" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="813" charEnd="821" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409387574" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="delegate().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;delegate" edit="/1/@proposals.0/@proposals.7/@attempts.18/@edit" start="650" end="-443"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409413963" sizeMeasure="59" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return getClerk().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;getClerk().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee delegate() {&#xA;&#x9;&#x9;Iterator&lt;Employee> it1 = employees.iterator();&#xA;&#x9;&#x9;if (it1.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it1.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Iterator&lt;Employee> it2 = it1;&#xA;&#x9;&#x9;&#x9;return it2" edit="/1/@proposals.0/@proposals.7/@attempts.19/@edit" start="247" end="-20"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="617" charEnd="625" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="755" charEnd="763" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1091" charEnd="1101" severity="1" problemCategory="120" problemType="603979894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409427057" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="delegate().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;delegate" edit="/1/@proposals.0/@proposals.7/@attempts.20/@edit" start="594" end="-493"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409775704" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Iterator&lt;Employee> it = employees.iterator();&#xA;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return delegate().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;delegate().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee delegate() {&#xA;&#x9;&#x9;if (it.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Iterator&lt;Employee> it = employees.iterator();;&#xA;&#x9;&#x9;&#x9;return it" edit="/1/@proposals.0/@proposals.7/@attempts.21/@edit" start="247" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409792455" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return delegate().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;delegate().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee delegate() {&#xA;&#x9;&#x9;Iterator&lt;Employee> it1 = employees.iterator();&#xA;&#x9;&#x9;if (it1.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it1.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Iterator&lt;Employee> it2 = it1;&#xA;&#x9;&#x9;&#x9;return it2" edit="/1/@proposals.0/@proposals.7/@attempts.22/@edit" start="247" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409901015" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Iterator&lt;Employee> it;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return delegate().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;delegate().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee delegate() {&#xA;&#x9;&#x9;if (it.hasNext()) {&#xA;&#x9;&#x9;&#x9;return this.it.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.it = employees.iterator();&#xA;&#x9;&#x9;&#x9;return this.it" edit="/1/@proposals.0/@proposals.7/@attempts.23/@edit" start="247" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489409939694" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return delegate().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;delegate().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee delegate() {&#xA;&#x9;&#x9;Iterator&lt;Employee> it1 = employees.iterator();&#xA;&#x9;&#x9;if (it1.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it1.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;Iterator&lt;Employee> it = employees.iterator();&#xA;&#x9;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.7/@attempts.24/@edit" start="247" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489494687620" sizeMeasure="64" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private Iterator&lt;Employee> it;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;&#x9;this.it = employees.iterator();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return delegate().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;delegate().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee delegate() {&#xA;&#x9;&#x9;if (it.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;it = employees.iterator();&#xA;&#x9;&#x9;&#x9;return it.next();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Manager boss = " edit="/1/@proposals.0/@proposals.7/@attempts.25/@edit" start="247" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="61" charStart="1353" charEnd="1354" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489494841216" sizeMeasure="71" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Printer printer1 = new Printer();&#xA;&#x9;&#x9;Printer printer2 = new Printer();&#xA;&#x9;&#x9;Clerk c1 = new Clerk(printer1);&#xA;&#x9;&#x9;Clerk c2 = new Clerk(printer2);&#xA;&#x9;&#x9;Clerk c3 = new Clerk(printer2);&#xA;&#x9;&#x9;Clerk c4 = new Clerk(printer2);&#xA;&#x9;&#x9;Clerk c5 = new Clerk(printer1);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.26/@edit" start="1280" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="63" charStart="1420" charEnd="1422" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="64" charStart="1455" charEnd="1457" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1490" charEnd="1492" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="66" charStart="1525" charEnd="1527" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="67" charStart="1560" charEnd="1562" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489495233949" sizeMeasure="87">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.Iterator;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;private Collection&lt;Employee> employees;&#xA;&#x9;private int taskCount;&#xA;&#x9;private Iterator&lt;Employee> it;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot have no employees.&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;this.taskCount = 0;&#xA;&#x9;&#x9;this.it = employees.iterator();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return delegate().doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;delegate().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee delegate() {&#xA;&#x9;&#x9;if (it.hasNext()) {&#xA;&#x9;&#x9;&#x9;return it.next();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;it = employees.iterator();&#xA;&#x9;&#x9;&#x9;return it.next();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Collection&lt;Employee> employees = new ArrayList&lt;>();&#xA;&#x9;&#x9;Printer printer1 = new Printer();&#xA;&#x9;&#x9;Printer printer2 = new Printer();&#xA;&#x9;&#x9;Clerk c1 = new Clerk(printer1);&#xA;&#x9;&#x9;Clerk c2 = new Clerk(printer2);&#xA;&#x9;&#x9;Clerk c3 = new Clerk(printer2);&#xA;&#x9;&#x9;Clerk c4 = new Clerk(printer2);&#xA;&#x9;&#x9;Clerk c5 = new Clerk(printer1);&#xA;&#x9;&#x9;employees.add(c1);&#xA;&#x9;&#x9;employees.add(c2);&#xA;&#x9;&#x9;employees.add(c3);&#xA;&#x9;&#x9;employees.add(c4);&#xA;&#x9;&#x9;employees.add(c5);&#xA;&#x9;&#x9;Manager boss = new Manager(employees);&#xA;&#x9;&#x9;boss.printDocument(&quot;Dokument1&quot;);&#xA;&#x9;&#x9;boss.printDocument(&quot;Dokument2&quot;);&#xA;&#x9;&#x9;boss.getResourceCount();&#xA;&#x9;&#x9;boss.getTaskCount();&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;System.out.println(employee.getTaskCount());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;boss.doCalculations((n1, n2) -> n1 * n2, 4.5, 2" edit="/1/@proposals.0/@proposals.7/@attempts.27/@edit" start="54" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489495288083" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boss.getTaskCount(" edit="/1/@proposals.0/@proposals.7/@attempts.28/@edit" start="2014" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489495353151" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(boss.getResourceCount());&#xA;&#x9;&#x9;System.out.println(boss.getTaskCount());&#xA;&#x9;&#x9;for (Employee employee : employees) {&#xA;&#x9;&#x9;&#x9;System.out.println(employee.getTaskCount());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(boss.doCalculations((n1, n2) -> n1 * n2, 4.5, 2));&#xA;&#x9;&#x9;System.out.println(boss.getTaskCount()" edit="/1/@proposals.0/@proposals.7/@attempts.29/@edit" start="1820" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489495452692" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="supervisor = new Manager(employees);&#xA;&#x9;&#x9;Collection&lt;Employee> e = new ArrayList&lt;>();&#xA;&#x9;&#x9;e.add(supervisor);&#xA;&#x9;&#x9;Manager boss = new Manager(e" edit="/1/@proposals.0/@proposals.7/@attempts.30/@edit" start="1717" end="-380"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489495466093" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.31/@edit" start="2230" end="-2231"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489495474948" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.32/@edit" start="2230" end="-2231"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495275616" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495290867" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495291978" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495292917" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495293749" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495353106" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495354035" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495458798" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489495460046" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409053674" completion="0.5714285714285714" successCount="4" failureCount="3">
          <successTests>testDoCalculations</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <failureTests>testResourceCount</failureTests>
          <failureTests>testSeveralClerks</failureTests>
          <failureTests>testMiddleManagementResourceCounts</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409194221" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409393362" completion="0.0" errorCount="7">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testMiddleManagementResourceCounts</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
          <errorTests>testNoEmployeesConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409395167" completion="0.0" errorCount="7">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testMiddleManagementResourceCounts</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
          <errorTests>testNoEmployeesConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409431236" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409779959" completion="0.0" errorCount="7">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testMiddleManagementResourceCounts</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
          <errorTests>testNoEmployeesConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409792885" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409904868" completion="0.42857142857142855" successCount="3" errorCount="4">
          <successTests>testResourceCount</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489409940085" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
