<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722561961" sizeMeasure="15">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;//import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);&#xA;&#x9;void printDocument(String documentet);&#xA;&#x9;int getTaskCount();&#xA;&#x9;int getResourceCount();&#xA;&#x9;//List&lt;String> getDocuments();&#xA;&#x9;//void setDocuments(String document);&#xA;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722572872" sizeMeasure="57">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#x9;private Printer printer;&#xA;&#x9;private int counterCalculations;&#xA;&#x9;private List&lt;String> documents= new ArrayList&lt;>();&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;double calculation= operation.apply(value1,value2);&#xA;&#x9;&#x9;counterCalculations++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return calculation;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String documentet) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;printer.printDocument(documentet, this);&#xA;&#x9;&#x9;counterCalculations++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return counterCalculations;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#xA;&#x9;public List&lt;String> getDocuments() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return documents;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setDocuments(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;documents.add(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722699576" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount;&#xA;&#x9;private List&lt;String> documents= new ArrayList&lt;>();&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;double calculation= operation.apply(value1,value2);&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return calculation;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String documentet) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;printer.printDocument(documentet, this);&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return taskCount" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="210" end="-321"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722746640" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;taskCount=0;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="350" end="-827"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722798455" sizeMeasure="58" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="860" end="-321"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="218" charEnd="227" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722848494" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="860" end="-321"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490727715960" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="816" end="-340"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490728007301" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.printer= printer;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;double calculation= operation.apply(value1,value2);&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return calculation;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String documentet) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;printer.printDocument(documentet, this);&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="365" end="-340"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722443193" completion="0.25" successCount="1" errorCount="3">
          <successTests>testResourceCount</successTests>
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722665782" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722707684" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722754539" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722882671" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490727398830" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490727478989" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490727675533" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490727719939" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490727899817" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490728012061" completion="1.0" successCount="4">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490727668904" sizeMeasure="21">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#xA;&#x9;public Printer() {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#x9;void printDocument(String document, Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;if (employee instanceof Clerk){&#xA;&#x9;&#x9;((Clerk)employee).setDocuments(document);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;List&lt;String> getPrintHistory(Employee employee){&#xA;&#x9;&#x9;return ((Clerk) employee).getDocuments();&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490727872691" sizeMeasure="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="86" end="-279"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490727889957" sizeMeasure="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void printDocument(String document, Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;if (employee instanceof Clerk){&#xA;&#x9;&#x9;((Clerk)employee).setDocuments(document);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="86" end="-100"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722453167" completion="1.0" successCount="3">
          <successTests>testPrintHistoryModification</successTests>
          <successTests>testPrintSingleClerk</successTests>
          <successTests>testPrintMulipleClerks</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722868841" completion="1.0" successCount="3">
          <successTests>testPrintHistoryModification</successTests>
          <successTests>testPrintSingleClerk</successTests>
          <successTests>testPrintMulipleClerks</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490727468101" completion="1.0" successCount="3">
          <successTests>testPrintHistoryModification</successTests>
          <successTests>testPrintSingleClerk</successTests>
          <successTests>testPrintMulipleClerks</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490721892547" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;import java.util.Random;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;private List&lt;Employee> employees;&#xA;&#x9;private Random random;&#xA;&#x9;private int workCount;&#xA;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;&#x9;if (employees.isEmpty()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;there are no employees!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;random = new Random();&#xA;&#x9;&#x9;this.employees = new ArrayList&lt;>(employees);&#xA;&#x9;&#x9;workCount = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double DoCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;workCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.employees.get(random.nextInt(employees.size())).doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String documentet) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public List&lt;String> getDocuments() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setDocuments(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="855" charEnd="869" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722078531" sizeMeasure="64" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="DoCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String documentet) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;workCount++;&#xA;&#x9;&#x9;this.employees.get(random.nextInt(employees.size())).printDocument(documents);" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="825" end="-384"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1089" charEnd="1098" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722432663" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="et);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return workCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;int total = 1;&#xA;&#x9;&#x9;for (Employee employee : employees){&#xA;&#x9;&#x9;&#x9;total+= employee.getResourceCount();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return total;&#xA;&#x9;}&#xA;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="1060" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722570409" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="d" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="627" end="-756"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="855" charEnd="869" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722579475" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="d" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="825" end="-558"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722632147" sizeMeasure="61" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.employees.get(random.nextInt(employees.size())).doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;this.employees.get(random.nextInt(employees.size())).printDocument(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return tas" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="576" end="-223"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1198" charEnd="1207" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="311" charEnd="320" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="596" charEnd="605" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="775" charEnd="784" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="1004" charEnd="1013" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490722642605" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tas" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="300" end="-1077"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490728337298" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Clerk clerk1 = new Clerk(new Printer());&#xA;&#x9;&#x9;Clerk clerk2 = new Clerk(new Printer());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection &lt;Employee> col1 = new ArrayList&lt;>();&#xA;&#x9;&#x9;col1.add(clerk1);&#xA;&#x9;&#x9;col1.add(clerk2);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="1373" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490728356823" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Manager leader = new Manager(col" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="1596" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1689" charEnd="1692" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490728552436" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Employee> col1 = new ArrayList&lt;>();&#xA;&#x9;&#x9;col1.add(clerk1);&#xA;&#x9;&#x9;col1.add(clerk2);&#xA;&#x9;&#x9;Manager leader = new Manager(col1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> col2 = new ArrayList&lt;>();&#xA;&#x9;&#x9;col2.add(leader);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;leader.printDocument(&quot;hello&quot;);&#xA;&#x9;&#x9;System.out.println( (double) leader.getTaskCount() / leader.getResourceCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Manager leader2 = new Manager(col2);&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println( (double) leader2.getTaskCount() / leader2.getResourceCount());" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="1516" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490729563921" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;leader.printDocument(&quot;hello&quot;);&#xA;&#x9;&#x9;System.out.println( (double) leader.getTaskCount() / leader.getResourceCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> col2 = new ArrayList&lt;>();&#xA;&#x9;&#x9;col2.add(leader);" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="1632" end="-140"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490728558205" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490728702743" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490729566328" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722583756" completion="0.5714285714285714" successCount="4" errorCount="3">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722648137" completion="0.5714285714285714" successCount="4" errorCount="3">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490722874096" completion="0.5714285714285714" successCount="4" errorCount="3">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490728017211" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490728675812" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
