<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490815973279" sizeMeasure="61">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private double stock_price;&#xA;&#x9;private String ticker;&#xA;&#x9;private List&lt;StockListener> my_listeners = new ArrayList&lt;StockListener>();;&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#xA;&#x9;public Stock(String ticker, double stock_price){&#xA;&#x9;&#x9;this.stock_price = stock_price;&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;}&#xA;&#xA;&#x9;// endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, skal metoden utløse en IllegalArgumentException&#xA;&#x9;public void setPrice(double new_price){&#xA;&#x9;&#x9;if(new_price > 0){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;for(StockListener listener : my_listeners){&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this,this.stock_price,new_price);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.stock_price = new_price;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;// metode for å hente aksjekoden.&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#xA;&#x9;// metode for å hente aksjeprisen.&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;return this.stock_price;&#xA;&#x9;}&#xA;&#xA;&#x9;public void addStockListener(StockListener listener) {&#xA;&#x9;&#x9;if(!my_listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;this.my_listeners.add(listener);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener listener){&#xA;&#x9;&#x9;if(my_listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;this.my_listeners.remove(listener);&#x9;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Error: listener not in my_listeners&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;Stock stock1 = new Stock(&quot;YAHOO&quot;, 100);&#xA;&#x9;&#x9;System.out.println(stock1.getPrice());&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490815996650" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(stock1.getTicker" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="1489" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490816702882" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="233" end="-1304"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490816950510" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;// en konstruktør som tar inn en aksjekode (ticker) og en aksjepris.&#xA;&#x9;public Stock(String ticker, double stock_price){&#xA;&#x9;&#x9;this.stock_price = stock_price;&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;}&#xA;&#xA;&#x9;// endringsmetode for aksjeprisen. Dersom aksjepris er negativ eller lik null, skal metoden utløse en IllegalArgumentException&#xA;&#x9;public void setPrice(double new_price){&#xA;&#x9;&#x9;if(new_price > 0){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;for(StockListener listener : my_listeners){&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this,this.stock_price,new_price);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.stock_price = new_price;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;new_price must be above 0&quot;);" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="233" end="-764"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490817143167" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ublic" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="160" end="-1422"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490815976005" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490815998807" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490815895878" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490816192195" sizeMeasure="61">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#xA;&#x9;String name;&#xA;&#x9;double index;&#xA;&#x9;List&lt;Stock> my_stocks = new ArrayList&lt;Stock>();&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock...stocks){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.index = 0;&#xA;&#x9;&#x9;for(Stock s1 : stocks){&#xA;&#x9;&#x9;&#x9;this.my_stocks.add(s1);&#xA;&#x9;&#x9;&#x9;this.index += s1.getPrice();&#xA;&#x9;&#x9;&#x9;s1.addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;}&#xA;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;if(!my_stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;this.my_stocks.add(stock);&#xA;&#x9;&#x9;&#x9;this.index += stock.getPrice();&#xA;&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;if(my_stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;this.index -= stock.getPrice();&#xA;&#x9;&#x9;&#x9;this.my_stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double old_price, double new_price){&#xA;&#x9;&#x9;this.index -= old_price;&#xA;&#x9;&#x9;this.index += new_price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;Stock stock1 = new Stock(&quot;YAHOO&quot;, 100);&#xA;&#x9;&#x9;Stock stock2 = new Stock(&quot;GOOG&quot;, 200);&#xA;&#x9;&#x9;Stock stock3 = new Stock(&quot;FB&quot;, 150);&#xA;&#x9;&#x9;StockIndex index1 = new StockIndex(&quot;oslobors&quot;, stock1, stock2, stock3);&#xA;&#x9;&#x9;System.out.println(index1);&#xA;&#x9;&#x9;System.out.println(index1.getIndex());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Stock stock4 = new Stock(&quot;AAPL&quot;, 400);&#xA;&#x9;&#x9;index1.addStock(stock4);&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490816244774" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(index1.getIndex()" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="1368" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490816396857" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;for(Stock st : index1.my_stocks){&#xA;&#x9;&#x9;&#x9;System.out.println(String.valueOf(st.getTicker()) +&quot; &quot;+ st.getPrice());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="1409" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490816543819" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;index1.my_stocks.get(2).setPrice(500);&#xA;&#x9;&#x9;System.out.println(index1.getIndex());" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="1530" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490817143130" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot; &quot; + String.valueOf(st.my_listeners" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="1519" end="-103"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490817202206" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(String.valueOf(st.getTicker()) +&quot; &quot;+ st.getPrice() + &quot; &quot;);&#xA;&#x9;&#x9;&#x9;System.out.println(st.my_listeners" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="1466" end="-102"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490817274215" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for(StockListener sl : st.my_listeners){&#xA;&#x9;&#x9;&#x9;&#x9;System.out.println(sl);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="1529" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490817856845" sizeMeasure="76" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StockIndex index2 = new StockIndex(&quot;nybors&quot;, stock1, stock2" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="1413" end="-301"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490817947418" sizeMeasure="75" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="1672" end="-100"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490816190647" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490816243879" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490816395387" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490816542132" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490817141921" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490817199486" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490817272503" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490817856107" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490815884513" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490817949783" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a" completion="0.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490815909604" completion="0.0" errorCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
