<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490615447224" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490616364853" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;void stockPriceChanged (Stock ticker, double oldPrice, double newPrice);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617426500" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;// Lyttermetode for å holde lytteren oppdatert på aksjeprisen" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="137" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614733738" sizeMeasure="6">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490614950376" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private String Ticker;&#xA;&#x9;private double Price;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Stock (String ticker, double price) {&#xA;&#x9;&#x9;// Konstruktør&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice (double price) {&#xA;&#x9;&#x9;// Endringsmetode for aksjeprisen&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker () {&#xA;&#x9;&#x9;return this.Ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice () {&#xA;&#x9;&#x9;return this.Price;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="53" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490615304276" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (price &lt; 0 || price == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Price must be a positive double&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.Ticker = ticker;&#xA;&#x9;&#x9;&#x9;this.Price = price;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice (double price) {&#xA;&#x9;&#x9;if (price &lt; 0 || price == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Price must be a positive double&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.Price = price;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="152" end="-120"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490615358704" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ticker;&#xA;&#x9;private double price;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Stock (String ticker, double price) {&#xA;&#x9;&#x9;if (price &lt; 0 || price == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Price must be a positive double&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;&#x9;this.price = price;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice (double price) {&#xA;&#x9;&#x9;if (price &lt; 0 || price == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Price must be a positive double&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker () {&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice () {&#xA;&#x9;&#x9;return this.p" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="69" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617355015" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;private List&lt;StockListener> listeners = new ArrayList&lt;> ();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Stock (String ticker, double price) {&#xA;&#x9;&#x9;if (price &lt; 0 || price == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Price must be a positive double&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;&#x9;this.price = price;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice (double price) {&#xA;&#x9;&#x9;if (price &lt; 0 || price == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Price must be a positive double&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker () {&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice () {&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener (StockListener listener) {&#xA;&#x9;&#x9;this.listeners.add(listener);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener (StockListener listener) {&#xA;&#x9;&#x9;this.listeners.remove(listener)" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="30" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490623025207" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;// Oppdatere lytterne" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="625" end="-318"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490624966814" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Oppdatere lytterne&#xA;&#x9;&#x9;&#x9;for (StockListener stockListener : listeners) {&#xA;&#x9;&#x9;&#x9;&#x9;stockListener.stockPriceChanged(this, this.price, price);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.price = price;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="603" end="-318"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490625089245" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice (double price) {&#xA;&#x9;&#x9;if (price &lt; 0 || price == 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Price must be a positive double&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// Oppdatere lytterne&#xA;&#x9;&#x9;for (StockListener stockListener : listeners) {&#xA;&#x9;&#x9;&#x9;stockListener.stockPriceChanged(this, this.price, price);&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker () {&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice () {&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener (StockListener listener) {&#xA;&#x9;&#x9;// + sjekk at den ikke finnes i listen allerede&#xA;&#x9;&#x9;this.listeners.add(listener);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener (StockListener listener) {&#xA;&#x9;&#x9;// + sjekk at den finnes i listen" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="374" end="-43"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490625575386" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="r lytterne&#xA;&#x9;&#x9;for (StockListener stockListener : listeners) {&#xA;&#x9;&#x9;&#x9;stockListener.stockPriceChanged(this, this.price, price);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="594" end="-400"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490625755326" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (! listeners.contains(listener)) {&#xA;&#x9;&#x9;&#x9;this.listeners.add(listener);&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener (StockListener listener) {&#xA;&#x9;&#x9;if (listeners.contains(listener)) {&#xA;&#x9;&#x9;&#x9;this.listeners.remove(listener);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="918" end="-8"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490615397090" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490626619209" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490618200351" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490622197670" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#x9;&#xA;&#x9;private String indexName;&#xA;&#x9;private double index;&#xA;&#x9;private List&lt;Stock> stocks = new ArrayList &lt;> ();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// Konstruktør&#xA;&#x9;public StockIndex (String indexName, Stock... tickers) {&#xA;&#x9;&#x9;this.indexName = indexName;&#xA;&#x9;&#x9;for (int i = 0; i &lt; tickers.length; i++) {&#xA;&#x9;&#x9;&#x9;this.stocks.add(tickers[i]);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void updateIndex () {&#xA;&#x9;&#x9;if (stocks.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.index = 0;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;for (Stock ticker : this.stocks) {&#xA;&#x9;&#x9;&#x9;&#x9;this.index += ticker.getPrice();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock (Stock ticker) {&#xA;&#x9;&#x9;this.stocks.add(ticker);&#xA;&#x9;&#x9;updateIndex ();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock (Stock ticker) {&#xA;&#x9;&#x9;this.stocks.remove(ticker);&#xA;&#x9;&#x9;updateIndex ();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex () {&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock ticker, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490622447489" sizeMeasure="52" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;updateIndex ();" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="426" end="-553"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490625041082" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;for (Stock ticker : this.stocks) {&#xA;&#x9;&#x9;&#x9;&#x9;this.index += ticker.getPrice();" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="526" end="-382"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490625120747" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="567" end="-417"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490626518668" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.index += ticker.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock (Stock ticker) {&#xA;&#x9;&#x9;this.stocks.add(ticker);&#xA;&#x9;&#x9;updateIndex ();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock (Stock ticker) {&#xA;&#x9;&#x9;this.stocks.remove(ticker);&#xA;&#x9;&#x9;updateIndex ();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex () {&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock ticker, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// OPPDATER INDEKSEN&#xA;&#x9;&#x9;this.index += (newPrice - oldPrice);" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="567" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490626957160" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (! this.stocks.contains(ticker)) {&#xA;&#x9;&#x9;&#x9;this.stocks.add(ticker);&#xA;&#x9;&#x9;&#x9;updateIndex ();&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock (Stock ticker) {&#xA;&#x9;&#x9;if (this.stocks.contains(ticker)) {&#xA;&#x9;&#x9;&#x9;this.stocks.remove(ticker);&#xA;&#x9;&#x9;&#x9;updateIndex ();&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="650" end="-216"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490627153748" sizeMeasure="56" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;for (Stock ticker : this.stocks) {&#xA;&#x9;&#x9;&#x9;&#x9;this.index += ticker.getPrice();&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="526" end="-500"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490627285195" sizeMeasure="57" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// this.index += (newPrice - oldPrice);&#xA;&#x9;&#x9;updateIndex (" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="1069" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490627308350" sizeMeasure="57" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.index += (newPrice - oldPrice);&#xA;&#x9;&#x9;// " edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="1069" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490697735923" sizeMeasure="59" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ticker.addStockListener(this);&#xA;&#x9;&#x9;&#x9;updateIndex ();&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock (Stock ticker) {&#xA;&#x9;&#x9;if (this.stocks.contains(ticker)) {&#xA;&#x9;&#x9;&#x9;this.stocks.remove(ticker);&#xA;&#x9;&#x9;&#x9;ticker.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;updateIndex ();" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="733" end="-241"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490697859326" sizeMeasure="60" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.index = 0;" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="537" end="-669"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698101971" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="updateIndex ();" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="1021" end="-203"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698273132" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.stocks.contains(ticker)) {&#xA;&#x9;&#x9;&#x9;this.index += (newPrice - oldPrice);&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// OPPDATER INDEKSEN" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="1151" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698282880" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// " edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="1021" end="-264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698441849" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="updateIndex ();&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock ticker, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// OPPDATER INDEKSEN&#xA;&#x9;&#x9;this.index += (newPrice - oldPrice);" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="1021" end="-29"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490626631420" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490626987778" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490627170685" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490627291238" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490696941072" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490697745675" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490697867703" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490698111515" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490698292056" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490698461034" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
