<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Logger">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the ILogger Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.ILogger"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Implementations">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StreamLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StreamLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StreamLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.StreamLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the FilteringLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the FilteringLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the FilteringLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.FilteringLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the DistributingLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DistributingLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DistributingLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.DistributingLoggerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.*Logger" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488954612092" sizeMeasure="6">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public interface ILogger {&#xA;    public String ERROR = &quot;error&quot;, WARNING = &quot;warning&quot;, INFO = &quot;info&quot;;&#xA;    public void log(String severity, String message, Exception exception);&#xA;}&#xA;"/>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488954614962" sizeMeasure="32" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;import java.io.OutputStream;&#xA;import java.io.PrintStream;&#xA;import java.io.PrintWriter;&#xA;&#xA;import øving1.Account;&#xA;&#xA;public class StreamLogger implements ILogger{&#xA;&#x9;&#xA;&#x9;private PrintStream stream;&#xA;&#x9;private String formatString = &quot;%s: %s (%s)&quot;;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public StreamLogger(OutputStream stream) {&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;this.stream = new PrintStream(stream);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFormatString(String formatString){&#xA;&#x9;&#x9;this.formatString = formatString;&#xA;&#x9;}&#xA;&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;stream.format(formatString, severity, message, exception);&#xA;&#x9;&#x9;stream.println();&#xA;&#x9;&#x9;stream.flush();&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="129" charEnd="135" severity="2" problemCategory="30" problemType="268435846"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488954629182" sizeMeasure="31" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="116" end="-547"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="98" charEnd="117" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488954639661" completion="1.0" successCount="3">
          <successTests>testLog</successTests>
          <successTests>testLogException</successTests>
          <successTests>testLogWithFormat</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490705477749" completion="1.0" successCount="3">
          <successTests>testLog</successTests>
          <successTests>testLogException</successTests>
          <successTests>testLogWithFormat</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490714094540" sizeMeasure="36">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collection;&#xA;&#xA;public class FilteringLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private final Collection&lt;String> severeties;&#xA;&#x9;private ILogger logger;&#xA;&#x9;&#xA;&#x9;public FilteringLogger(ILogger logger, String... severities) {&#xA;&#x9;&#x9;this.severeties = new ArrayList&lt;String>(Arrays.asList(severities));&#xA;&#x9;&#x9;this.logger = logger;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isLogging(String severity){&#xA;&#x9;&#x9;return severeties.contains(severity);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setIsLogging(String severity, boolean value){&#xA;&#x9;&#x9;if(!value){&#xA;&#x9;&#x9;&#x9;severeties.remove(severity);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(!isLogging(severity)){&#xA;&#x9;&#x9;&#x9;severeties.add(severity);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;if(isLogging(severity)){&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490714098277" completion="1.0" successCount="5">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerErrorAndInfo</successTests>
          <successTests>testFilteringLoggerWarningSetIsLoggingError</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <successTests>testErrorLogging</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.6/@q" answer="/0/@parts.1/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715013835" sizeMeasure="29" warningCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;import java.util.HashMap;&#xA;&#xA;import com.sun.javafx.collections.MappingChange.Map;&#xA;&#xA;public class DistributingLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private HashMap&lt;String, ILogger> loggers;&#xA;&#x9;&#xA;&#x9;public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;loggers = new HashMap&lt;String, ILogger>();&#xA;&#x9;&#x9;setLogger(ILogger.ERROR, errorLogger);&#xA;&#x9;&#x9;setLogger(ILogger.WARNING, warningLogger);&#xA;&#x9;&#x9;setLogger(ILogger.INFO, infoLogger);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setLogger(String severity, ILogger logger){&#xA;&#x9;&#x9;loggers.put(severity, logger); // key, value&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;ILogger logger = loggers.get(severity);&#xA;&#x9;&#x9;if (logger !=null){&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="68" charEnd="112" severity="1" problemCategory="150" problemType="16777496"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="68" charEnd="112" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715038767" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490715042689" sizeMeasure="27">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;import java.util.HashMap;&#xA;&#xA;public class DistributingLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private HashMap&lt;String, ILogger> loggers;&#xA;&#x9;&#xA;&#x9;public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;loggers = new HashMap&lt;String, ILogger>();&#xA;&#x9;&#x9;setLogger(ILogger.ERROR, errorLogger);&#xA;&#x9;&#x9;setLogger(ILogger.WARNING, warningLogger);&#xA;&#x9;&#x9;setLogger(ILogger.INFO, infoLogger);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setLogger(String severity, ILogger logger){&#xA;&#x9;&#x9;loggers.put(severity, logger); // key, value&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;ILogger logger = loggers.get(severity);&#xA;&#x9;&#x9;if (logger !=null){&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.7/@q" answer="/0/@parts.1/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.8/@q" answer="/0/@parts.1/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715017662" completion="1.0" successCount="4">
          <successTests>testLogToInfo</successTests>
          <successTests>testLogToWarn</successTests>
          <successTests>testChangeInfoLogger</successTests>
          <successTests>testLogToError</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490715045831" completion="1.0" successCount="4">
          <successTests>testLogToInfo</successTests>
          <successTests>testLogToWarn</successTests>
          <successTests>testChangeInfoLogger</successTests>
          <successTests>testLogToError</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
