<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490104189678" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490105382666" sizeMeasure="14">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public interface Clerk {&#xA;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1,double value2);&#xA;&#x9;&#xA;&#x9;void printDocument(String document);&#xA;&#x9;&#xA;&#x9;int getTaskCount();&#xA;&#x9;&#xA;&#x9;int getResourseCount();&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490105719466" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490105738639" sizeMeasure="14">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1,double value2);&#xA;&#x9;&#xA;&#x9;void printDocument(String document);&#xA;&#x9;&#xA;&#x9;int getTaskCount();&#xA;&#x9;&#xA;&#x9;int getResourseCount();&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490341727783" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="275" end="-13"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490104202838" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public interface Clerk {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490105382666" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public interface Clerk {&#xA;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1,double value2);&#xA;&#x9;&#xA;&#x9;void printDocument(String document);&#xA;&#x9;&#xA;&#x9;int getTaskCount();&#xA;&#x9;&#xA;&#x9;int getResourseCount();" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="37" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490105738655" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490106106624" sizeMeasure="36">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourseCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490106913224" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private Printer printer;&#xA;&#x9;private int taskCount;&#xA;&#x9;public Clerk(Printer printer){&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return operation.apply(value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourseCount() {&#xA;&#x9;&#x9;return 1;//Denne arbeideren har bare seg selv altid." edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="121" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490341727783" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="c" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="615" end="-157"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490106919329" completion="0.0" errorCount="4">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490107032566" completion="0.0" errorCount="4">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490174852694" completion="0.0" errorCount="4">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490175202621" completion="0.0" errorCount="1">
          <errorTests>testTaskCount</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490340972763" completion="0.0" errorCount="4">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490341737559" completion="1.0" successCount="4">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490344804468" completion="1.0" successCount="4">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490104420177" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490106913067" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#xA;&#x9;&#xA;&#x9;private Map&lt;Employee,List&lt;String>> log;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Printer(){&#xA;&#x9;&#x9;log = new HashMap&lt;Employee,List&lt;String>>();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document,Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(log.containsKey(employee)){&#xA;&#x9;&#x9;&#x9;log.get(employee).add(document);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;log.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;&#x9;log.get(employee).add(document);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee){&#xA;&#x9;&#x9;return log.get(employee);" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="37" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342016362" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Printer p1 = new Printer();&#xA;&#x9;&#x9;Clerk c1 = new Clerk(p1);&#xA;&#x9;&#x9;c1.printDocument(&quot;test&quot;);" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="248" end="-443"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342068617" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;Clerk c1 = new Clerk(p1);&#xA;&#x9;&#x9;c1.printDocument(&quot;test&quot;);&#xA;&#x9;&#x9;Clerk c2 = new Clerk(p1);&#xA;&#x9;&#x9;c2.printDocument(&quot;test2&quot;);&#xA;&#x9;&#x9;p1.getPrintHistory(c2" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="278" end="-445"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342127544" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Manager m1 = new Manager(c1,c2);&#xA;&#x9;&#x9;m1.printDocument(&quot;test3&quot;);&#xA;&#x9;&#x9;m1.printDocument(&quot;test4&quot;);&#xA;&#x9;&#x9;m1.printDocument(&quot;test5" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="394" end="-472"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342156068" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println( p1.getPrintHistory(c2)" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="516" end="-445"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342169079" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="m1" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="555" end="-446"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342357186" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="p1.getPrintHistory(c" edit="/1/@proposals.0/@proposals.4/@attempts.6/@edit" start="309" end="-700"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342373071" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println( p1.getPrintHistory(c1)" edit="/1/@proposals.0/@proposals.4/@attempts.7/@edit" start="309" end="-699"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342489447" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private Map&lt;Employee,List&lt;String>> log;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer p1 = new Printer();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Clerk c1 = new Clerk(p1);&#xA;&#x9;&#x9;System.out.println( p1.getPrintHistory(c1));&#xA;&#x9;&#x9;c1.printDocument(&quot;test&quot;);&#xA;&#x9;&#x9;Clerk c2 = new Clerk(p1);&#xA;&#x9;&#x9;c2.printDocument(&quot;test2&quot;);&#xA;&#x9;&#x9;Manager m1 = new Manager(c1,c2);&#xA;&#x9;&#x9;m1.printDocument(&quot;test3&quot;);&#xA;&#x9;&#x9;m1.printDocument(&quot;test4&quot;);&#xA;&#x9;&#x9;m1.printDocument(&quot;test5&quot;);&#xA;&#x9;&#x9;System.out.println( p1.getPrintHistory(m1));" edit="/1/@proposals.0/@proposals.4/@attempts.8/@edit" start="160" end="-442"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342575129" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".size(" edit="/1/@proposals.0/@proposals.4/@attempts.9/@edit" start="602" end="-445"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342587486" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.4/@attempts.10/@edit" start="602" end="-445"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342870792" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Printer(){&#xA;&#x9;&#x9;log = new HashMap&lt;Employee,List&lt;String>>();&#xA;&#x9;&#x9;log.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document,Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(log.containsKey(employee)){&#xA;&#x9;&#x9;&#x9;log.get(employee).add(document);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;log.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;&#x9;log.get(employee).add(document);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee){&#xA;&#x9;&#x9;return log.get(employee);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.11/@edit" start="603" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342886563" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println( log.size()" edit="/1/@proposals.0/@proposals.4/@attempts.12/@edit" start="677" end="-370"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490342985101" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".size());&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Printer(){&#xA;&#x9;&#x9;log = new HashMap&lt;Employee,List&lt;String>>();&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printDocument(String document,Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(log.containsKey(employee)){&#xA;&#x9;&#x9;&#x9;log.get(employee).add(document);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;log.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;&#x9;log.get(employee).add(document);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee){&#xA;&#x9;&#x9;if(!log.containsKey(employee)){&#xA;&#x9;&#x9;&#x9;return new ArrayList&lt;String>();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.13/@edit" start="602" end="-35"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342016081" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342068273" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342127216" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342155849" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342168736" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342356936" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342372711" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342574926" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342587251" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342870464" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342886344" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490342984772" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490175209182" completion="0.0" errorCount="3">
          <errorTests>testPrintHistoryModification</errorTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490341936321" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testPrintHistoryModification</successTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490342492313" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testPrintHistoryModification</successTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490342994200" completion="1.0" successCount="3">
          <successTests>testPrintHistoryModification</successTests>
          <successTests>testPrintSingleClerk</successTests>
          <successTests>testPrintMulipleClerks</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490344823746" completion="1.0" successCount="3">
          <successTests>testPrintHistoryModification</successTests>
          <successTests>testPrintSingleClerk</successTests>
          <successTests>testPrintMulipleClerks</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490106913661" sizeMeasure="53" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#xA;&#x9;&#xA;&#x9;private List&lt;Employee> employees;&#xA;&#x9;private int employeeOfTheDay;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;employeeOfTheDay = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;employeeOfTheDay++;&#xA;&#x9;&#x9;return employees.get(employeeOfTheDay).doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;employeeOfTheDay++;&#xA;&#x9;&#x9;employees.get(employeeOfTheDay).printDocument(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int res = 0;&#xA;&#x9;&#x9;for(Employee e:employees){&#xA;&#x9;&#x9;&#x9;res += e.getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return res;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourseCount() {&#xA;&#x9;&#x9;int res = 0;&#xA;&#x9;&#x9;for(Employee e:employees){&#xA;&#x9;&#x9;&#x9;res += e.getResourseCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return res;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="413" charEnd="422" severity="2" problemCategory="40" problemType="16777233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490107029476" sizeMeasure="54" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#xA;&#x9;&#xA;&#x9;private List&lt;Employee> employees;&#xA;&#x9;private int employeeOfTheDay;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;this.employees = new ArrayList( employees)" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="54" end="-671"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="467" charEnd="467" severity="2" problemCategory="40" problemType="16777233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490107994720" sizeMeasure="60" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Printer p1 = new Printer();&#xA;&#x9;&#x9;Employee e1 = new Clerk(p1);&#xA;&#x9;&#x9;Employee e2 = new Clerk(p1);&#xA;&#x9;&#x9;Manager m1 = new Manager(e1,e2);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees){&#xA;&#x9;&#x9;this.employees = new ArrayList( employees);&#xA;&#x9;&#x9;employeeOfTheDay = 0;&#xA;&#x9;}&#xA;&#x9;public Manager(Employee... employees){&#xA;&#x9;&#x9;for(Employee i:employees)this.employees.add(i);&#xA;&#x9;&#x9;employeeOfTheDay = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;employeeOfTheDay++;&#xA;&#x9;&#x9;return employees.get(employeeOfTheDay).doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;employeeOfTheDay++;&#xA;&#x9;&#x9;employees.get(employeeOfTheDay).printDocument(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int res = 0;&#xA;&#x9;&#x9;for(Employee e:employees){&#xA;&#x9;&#x9;&#x9;res += e.getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return res;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourseCount() {&#xA;&#x9;&#x9;int res = 0;&#xA;&#x9;&#x9;for(Employee e:employees){&#xA;&#x9;&#x9;&#x9;res += e.getResourseCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return res+1;//+1 fordi vi teller med seg selv." edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="315" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="533" charEnd="558" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="537" charEnd="546" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="533" charEnd="558" severity="1" problemCategory="130" problemType="16777746"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490108048249" sizeMeasure="60" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="634" end="-728"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="431" charEnd="433" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="533" charEnd="558" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="533" charEnd="558" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="537" charEnd="546" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490173821618" sizeMeasure="60" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="527" end="-835"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="431" charEnd="433" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="533" charEnd="557" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="533" charEnd="557" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="537" charEnd="546" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490174532329" sizeMeasure="62" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;this.employees.add(i);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="633" end="-706"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="431" charEnd="433" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="533" charEnd="557" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="533" charEnd="557" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="537" charEnd="546" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490174624371" sizeMeasure="64" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;this.employees = new ArrayList(employees);&#xA;&#x9;&#x9;employeeOfTheDay = 0;&#xA;&#x9;}&#xA;&#x9;public Manager(Employee... employees){&#xA;&#x9;&#x9;this.employees = new ArrayList();" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="496" end="-765"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="431" charEnd="433" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="537" charEnd="561" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="537" charEnd="561" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="541" charEnd="550" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490174729244" sizeMeasure="68" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;m1.printDocument(&quot;test2&quot;);&#xA;&#x9;&#x9;m1.printDocument(&quot;liksom&quot;);&#xA;&#x9;&#x9;m1.getTaskCount();&#xA;&#x9;&#x9;e2.printDocument(p1.getPrintHistory(e1).get(0)" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="441" end="-972"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="672" charEnd="696" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="672" charEnd="696" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="676" charEnd="685" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="788" charEnd="803" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="792" charEnd="801" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="431" charEnd="433" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490174805028" sizeMeasure="68" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="%employees.size()).doCalculations(operation, value1, value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;employeeOfTheDay++;&#xA;&#x9;&#x9;employees.get(employeeOfTheDay%employees.size()" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="1031" end="-349"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="672" charEnd="696" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="672" charEnd="696" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="676" charEnd="685" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="788" charEnd="803" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="792" charEnd="801" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490175199809" sizeMeasure="69" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Employee e3 = new Clerk(p1" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="572" end="-1006"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="704" charEnd="728" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="704" charEnd="728" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="708" charEnd="717" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="820" charEnd="835" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="824" charEnd="833" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490341727783" sizeMeasure="69" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ceCount() {&#xA;&#x9;&#x9;int res = 0;&#xA;&#x9;&#x9;for(Employee e:employees){&#xA;&#x9;&#x9;&#x9;res += e.getResourc" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="1456" end="-71"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="603" charEnd="605" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="704" charEnd="728" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="704" charEnd="728" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="708" charEnd="717" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="820" charEnd="835" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="824" charEnd="833" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490341880651" sizeMeasure="71" warningCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(employees.size() == 0 || employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke ha ingen arbeidere.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.10/@edit" start="658" end="-947"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="603" charEnd="605" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="834" charEnd="858" severity="1" problemCategory="130" problemType="16777746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="834" charEnd="858" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="29" charStart="838" charEnd="847" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="950" charEnd="965" severity="1" problemCategory="130" problemType="16777748"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="954" charEnd="963" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490107994455" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490108047952" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490173820586" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490174383411" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490174460594" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490174531735" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490174554302" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490174623480" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490174729009" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490174804762" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490107081662" completion="0.0" errorCount="7">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testMiddleManagementResourceCounts</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
          <errorTests>testNoEmployeesConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490341298081" completion="0.0" errorCount="7">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testMiddleManagementResourceCounts</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
          <errorTests>testNoEmployeesConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490341800669" completion="0.8571428571428571" successCount="6" failureCount="1">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <failureTests>testNoEmployeesConstructor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490341883508" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490344813369" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a" performedCount="10">
        <attempts timestamp="1490108049656"/>
        <attempts timestamp="1490108076760"/>
        <attempts timestamp="1490173825051"/>
        <attempts timestamp="1490173832145"/>
        <attempts timestamp="1490174386035"/>
        <attempts timestamp="1490174391801"/>
        <attempts timestamp="1490174462016"/>
        <attempts timestamp="1490174512456"/>
        <attempts timestamp="1490174534782"/>
        <attempts timestamp="1490174542907"/>
        <attempts timestamp="1490174556102"/>
        <attempts timestamp="1490174582775"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="31">
        <attempts timestamp="1490108076760"/>
        <attempts timestamp="1490108085479"/>
        <attempts timestamp="1490174407333"/>
        <attempts timestamp="1490174512440"/>
        <attempts timestamp="1490174513925"/>
        <attempts timestamp="1490174541704"/>
        <attempts timestamp="1490174542892"/>
        <attempts timestamp="1490174544814"/>
        <attempts timestamp="1490174581541"/>
        <attempts timestamp="1490174582775"/>
        <attempts timestamp="1490343877009"/>
        <attempts timestamp="1490343887155"/>
        <attempts timestamp="1490343889280"/>
        <attempts timestamp="1490343890389"/>
        <attempts timestamp="1490343899831"/>
        <attempts timestamp="1490343904284"/>
        <attempts timestamp="1490343904894"/>
        <attempts timestamp="1490343907394"/>
        <attempts timestamp="1490344045215"/>
        <attempts timestamp="1490344046512"/>
        <attempts timestamp="1490344047590"/>
        <attempts timestamp="1490344049887"/>
        <attempts timestamp="1490344050387"/>
        <attempts timestamp="1490344050958"/>
        <attempts timestamp="1490344051568"/>
        <attempts timestamp="1490344053130"/>
        <attempts timestamp="1490344053618"/>
        <attempts timestamp="1490344093952"/>
        <attempts timestamp="1490344094765"/>
        <attempts timestamp="1490344095234"/>
        <attempts timestamp="1490344095734"/>
        <attempts timestamp="1490344096249"/>
        <attempts timestamp="1490344096718"/>
        <attempts timestamp="1490344097218"/>
        <attempts timestamp="1490344097718"/>
        <attempts timestamp="1490344098421"/>
        <attempts timestamp="1490344100234"/>
        <attempts timestamp="1490344102594"/>
        <attempts timestamp="1490344104612"/>
        <attempts timestamp="1490344106831"/>
        <attempts timestamp="1490344667835"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="3">
        <attempts timestamp="1490343874181"/>
        <attempts timestamp="1490344044121"/>
        <attempts timestamp="1490344087396"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="3">
        <attempts timestamp="1490108063884"/>
        <attempts timestamp="1490173834083"/>
        <attempts timestamp="1490174394238"/>
        <attempts timestamp="1490174504065"/>
        <attempts timestamp="1490174574087"/>
        <attempts timestamp="1490343882920"/>
        <attempts timestamp="1490344089224"/>
        <attempts timestamp="1490344657964"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
