<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489243666508" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489243711128" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;void stockPriceChanged(Stock s, double oldPrice, double newPrice);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489243306695" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489243626056" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price){&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double price){&#xA;&#x9;&#x9;if(price &lt; 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Price cannot be negative or zero&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="51" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489243806566" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void addStockListener(StockListener listener){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="456" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489244049919" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.HashSet;&#xA;import java.util.Set;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;private Set&lt;StockListener> listeners;&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price){&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;listeners = new HashSet&lt;StockListener>()" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="30" end="-334"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="186" charEnd="195" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489244088050" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="listeners.add(listener);" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="644" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489244156773" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void removeStockListener(StockListener listener){&#xA;&#x9;&#x9;listeners.remove(listener);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="674" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489244396128" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;for(StockListener listener : listeners){&#xA;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this.price, price);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="464" end="-307"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489325570007" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Oppdaterer prisen på denne stocken&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener listener){&#xA;&#x9;&#x9;//Legger til observatører til stocken &quot;Subscribe&quot;&#xA;&#x9;&#x9;listeners.add(listener);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener listener){&#xA;&#x9;&#x9;//Fjerner observatører fra stocken &quot;Unsubscribe&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="563" end="-37"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489243631840" completion="0.5" successCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <errorTests>testStockListener</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489244174685" completion="0.5" successCount="1" failureCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testStockListener</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489244401847" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489244581414" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489244584706" sizeMeasure="5" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="59" end="-60"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="45" charEnd="55" severity="2" problemCategory="40" problemType="16777539"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489244755521" sizeMeasure="16" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements StockListener{&#xA;&#xA;&#x9;String name;&#xA;&#x9;Stock stock;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock stock){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock s, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="54" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="-1" charStart="45" charEnd="55" severity="2" problemCategory="-1" problemType="-1"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489244759886" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245040106" sizeMeasure="24" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.HashSet;&#xA;import java.util.Set;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#xA;&#x9;private String name;&#xA;&#x9;private Set&lt;Stock> stocks;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.stocks = new HashSet&lt;Stock>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt;stocks.length; i++){&#xA;&#x9;&#x9;&#x9;this.stocks.add(stocks[i]);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void stockPriceChanged(Stock s, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245277331" sizeMeasure="27" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.stocks = new HashSet&lt;Stock>();&#xA;&#x9;&#x9;index = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt;stocks.length; i++){&#xA;&#x9;&#x9;&#x9;this.stocks.add(stocks[i]);&#xA;&#x9;&#x9;&#x9;index += stocks[i].getPrice(" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="181" end="-98"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="205" charEnd="210" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245436201" sizeMeasure="28" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;stocks[i].addStockListener(this" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="438" end="-98"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="205" charEnd="210" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245518061" sizeMeasure="30" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="483" end="-89"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="205" charEnd="210" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245776013" sizeMeasure="33" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void stockPriceChanged(Stock s, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;index -= oldPrice;&#xA;&#x9;&#x9;index += newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock s){&#xA;&#x9;&#x9;index += s.getPrice();" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="483" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="205" charEnd="210" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245816082" sizeMeasure="34" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;s.addStockListener(this" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="663" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="205" charEnd="210" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245859931" sizeMeasure="35" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.stocks.add(s);" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="639" end="-61"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="205" charEnd="210" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245894975" sizeMeasure="33" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="addStock(stocks[i]" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="374" end="-249"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="205" charEnd="210" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245931732" sizeMeasure="39" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void removeStock(Stock s){&#xA;&#x9;&#x9;this.stocks.remove(s);&#xA;&#x9;&#x9;index -= s.getPrice();&#xA;&#x9;&#x9;s.remove" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="637" end="-28"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="205" charEnd="210" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489245947793" sizeMeasure="43" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return index" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="758" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489246162994" sizeMeasure="43" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s.addStockListener(this);&#xA;&#x9;&#x9;this.stocks.add(s);&#xA;&#x9;&#x9;index += s.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock s){&#xA;&#x9;&#x9;s.removeStockListener(this);&#xA;&#x9;&#x9;this.stocks.remove(s);&#xA;&#x9;&#x9;index -= s.getPrice(" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="561" end="-58"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489246179803" sizeMeasure="45" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index += s.getPrice();&#xA;&#x9;&#x9;s.addStockListener(this);&#xA;&#x9;&#x9;this.stocks.add(s);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock s){&#xA;&#x9;&#x9;index -= s.getPrice();&#xA;&#x9;&#x9;s.removeStockListener(this);&#xA;&#x9;&#x9;this.stocks.remove(s);&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="561" end="-56"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489246267481" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;this.stocks.add(s);&#xA;&#x9;&#x9;s.addStockListener(this);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock s){&#xA;&#x9;&#x9;index -= s.getPrice();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.stocks.remove(s);&#xA;&#x9;&#x9;s.removeStockListener(thi" edit="/1/@proposals.1/@proposals.0/@attempts.15/@edit" start="586" end="-62"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489246448174" sizeMeasure="48" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(this.stocks.add(s)){&#xA;&#x9;&#x9;&#x9;s.addStockListener(this);&#xA;&#x9;&#x9;}&#xA;" edit="/1/@proposals.1/@proposals.0/@attempts.16/@edit" start="589" end="-184"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489246474955" sizeMeasure="48" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if(this.stocks.add(s)){&#xA;&#x9;&#x9;&#x9;s.addStockListener(this);&#xA;&#x9;&#x9;&#x9;index += s.getPrice(" edit="/1/@proposals.1/@proposals.0/@attempts.17/@edit" start="560" end="-191"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489246513596" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock s){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.stocks.remove(s)){&#xA;&#x9;&#x9;&#x9;s.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;index -= s.getPrice();&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.18/@edit" start="647" end="-56"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="153" charEnd="157" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489246786732" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String getName(){&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock s){&#xA;&#x9;&#x9;if(this.stocks.add(s)){&#xA;&#x9;&#x9;&#x9;s.addStockListener(this);&#xA;&#x9;&#x9;&#x9;index += s.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock s){" edit="/1/@proposals.1/@proposals.0/@attempts.19/@edit" start="535" end="-147"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489325270137" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Metoden holder indexen oppdatert, trekker fra gamle pris og legger på den nye&#xA;&#x9;&#x9;index -= oldPrice;&#xA;&#x9;&#x9;index += newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock s){&#xA;&#x9;&#x9;//Hvis Stocken s ikke ligger i settet blir den lagt til.&#xA;&#x9;&#x9;if(this.stocks.add(s)){&#xA;&#x9;&#x9;&#x9;s.addStockListener(this);&#xA;&#x9;&#x9;&#x9;index += s.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock s){&#xA;&#x9;&#x9;//Hvis Stocken s ligger i settet blir den fjernet&#xA;&#x9;&#x9;if(this.stocks.remove(s)){&#xA;&#x9;&#x9;&#x9;s.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;index -= s.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return index;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.20/@edit" start="482" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489325322220" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.21/@edit" start="1067" end="-1068"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489325370675" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //&quot;Set&quot; brukes for å unngå at det er flere av samme stock&#xA;&#x9;private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock... stocks){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.stocks = new HashSet&lt;Stock>();&#xA;&#x9;&#x9;index = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Fyller opp settet med stocks" edit="/1/@proposals.1/@proposals.0/@attempts.22/@edit" start="179" end="-740"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489325424168" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Legger prisen til i indexen&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock s){&#xA;&#x9;&#x9;//Hvis Stocken s ligger i settet blir den fjernet&#xA;&#x9;&#x9;if(this.stocks.remove(s)){&#xA;&#x9;&#x9;&#x9;s.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;index -= s.getPrice();//Trekker prisen fra indexen" edit="/1/@proposals.1/@proposals.0/@attempts.23/@edit" start="917" end="-59"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489245969396" completion="0.5" successCount="2" failureCount="2">
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489246167159" completion="0.5" successCount="2" failureCount="2">
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489246184555" completion="0.5" successCount="2" failureCount="2">
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489246272175" completion="0.5" successCount="2" failureCount="2">
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489246519453" completion="1.0" successCount="4">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
