<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489657636692" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public interface Employee {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489658341189" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> op, double d, double e);&#xA;&#xA;&#x9;public int getTaskCount();&#xA;&#xA;&#x9;public void printDocument(String document);&#xA;&#xA;&#x9;public int getResourceCount();" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489657108481" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Clerk {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489657371507" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk {&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> op, double d, double e) {&#xA;&#x9;&#x9;return op.apply(d, e);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;|&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489657379763" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="548" end="-549"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489657403708" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="document" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="405" end="-138"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489657629512" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Employee{&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> op, double d, double e) {&#xA;&#x9;&#x9;return op.apply(d, e);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="99" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659215109" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Printer printer;&#xA;&#x9;int taskCount=0;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> op, double d, double e) {&#xA;&#x9;&#x9;return op.apply(d, e);&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#x9;&#x9;taskCount+=1;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="120" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659375410" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="532" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659597754" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;taskCount+=1" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="324" end="-221"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659616044" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount+=1;&#xA;&#x9;&#x9;return op.apply(d, e)" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="300" end="-221"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489661017490" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="538" end="-20"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489659388252" completion="0.25" successCount="1" failureCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489659577678" completion="0.25" successCount="1" failureCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489659617580" completion="0.5" successCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489659687461" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489657139847" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489657374474" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collection;&#xA;&#xA;public class Printer {&#xA;&#xA;&#x9;public Collection&lt;String> getPrintHistory(Clerk clerk) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489658702977" sizeMeasure="17" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#x9;Map&lt;String, List&lt;String>> history = new HashMap&lt;String, List&lt;String>>();&#xA;&#x9;public Collection&lt;String> getPrintHistory(Clerk clerk) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;public void printDocument(String document, Employee employee){&#xA;&#x9;&#x9;System.out.println(document)" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="66" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489658718212" sizeMeasure="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HashMap" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="83" end="-361"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489658809501" sizeMeasure="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee employee) {&#xA;&#x9;&#x9;return history.get(employee);&#xA;&#x9;}&#xA;&#x9;public void printDocument(String document, Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;history.get(employee).add" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="278" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489658861046" sizeMeasure="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee, List&lt;String>> history = new HashMap&lt;Employee" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="166" end="-260"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659496130" sizeMeasure="19" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(!history.containsKey(employee)) history.put(employee, new List&lt;String>()" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="436" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659551955" sizeMeasure="19" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;String>() []" edit="/1/@proposals.0/@proposals.4/@attempts.6/@edit" start="493" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659574485" sizeMeasure="19" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new List&lt;String>()" edit="/1/@proposals.0/@proposals.4/@attempts.7/@edit" start="493" end="-49"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659641897" sizeMeasure="19" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.4/@attempts.8/@edit" start="559" end="-560"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659685556" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;import java.util.Map;&#xA;&#xA;public class Printer {&#xA;&#x9;Map&lt;Employee, List&lt;String>> history = new HashMap&lt;Employee, List&lt;String>>();&#xA;&#x9;public Collection&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return history.get(employee);&#xA;&#x9;}&#xA;&#x9;public void printDocument(String document, Employee employee){&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;if(!history.containsKey(employee)) history.put(employee, new Array" edit="/1/@proposals.0/@proposals.4/@attempts.9/@edit" start="54" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659763832" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(history.containsKey(employee)) return history.get(employee);&#xA;&#x9;&#x9;else return new ArrayList&lt;String>(" edit="/1/@proposals.0/@proposals.4/@attempts.10/@edit" start="333" end="-233"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489659707063" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489659765460" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489660594915" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489660792887" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489659994527" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Manager {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660125808" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collection;&#xA;import java.util.List;&#xA;&#xA;public class Manager {&#xA;&#xA;&#x9;Collection&lt;Employee> minions = new Collection&lt;Employee>();&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) throw new IllegalArgumentException();&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660166900" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="297" end="-298"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660185828" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.minions = employees;" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="290" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660191093" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="150" end="-163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660199033" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Array" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="150" end="-167"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660276865" sizeMeasure="15" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;&#xA;public class Manager {&#xA;&#xA;&#x9;Collection&lt;Employee> minions = new ArrayList&lt;Employee>();&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) throw new IllegalArgumentException();&#xA;&#x9;&#x9;this.minions = employees;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="54" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660567467" sizeMeasure="26" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Iterator;&#xA;import java.util.List;&#xA;&#xA;public class Manager {&#xA;&#xA;&#x9;Collection&lt;Employee> minions = new ArrayList&lt;Employee>();&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) throw new IllegalArgumentException();&#xA;&#x9;&#x9;this.minions = employees;&#xA;&#x9;}&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return minions.size();&#xA;&#x9;}&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int taskCount=0;&#xA;&#x9;&#x9;for(Iterator&lt;E> it = minions.iterator(); it.hasNext();){&#xA;&#x9;&#x9;&#x9;taskCount+=it.next().getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="111" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660570753" sizeMeasure="26" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="594" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660585605" sizeMeasure="26" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="496" end="-114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660591257" sizeMeasure="26" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Employee>" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="496" end="-114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660713066" sizeMeasure="34" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager {&#xA;&#xA;&#x9;Collection&lt;Employee> minions = new ArrayList&lt;Employee>();&#xA;&#x9;Iterator&lt;Employee> emp_it = minions.iterator();&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) throw new IllegalArgumentException();&#xA;&#x9;&#x9;this.minions = employees;&#xA;&#x9;}&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return minions.size();&#xA;&#x9;}&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int taskCount=0;&#xA;&#x9;&#x9;for(Iterator&lt;Employee> it = minions.iterator(); it.hasNext();){&#xA;&#x9;&#x9;&#x9;taskCount+=it.next().getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;if(!emp_it.hasNext()){&#xA;&#x9;&#x9;&#x9;emp_it = minions.iterator();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;emp_it.next().doCalculations" edit="/1/@proposals.0/@proposals.7/@attempts.10/@edit" start="144" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660725962" sizeMeasure="34" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="op, double d, double e) {&#xA;&#x9;&#x9;if(!emp_it.hasNext()){&#xA;&#x9;&#x9;&#x9;emp_it = minions.iterator();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;emp_it.next().doCalculations(op,d,e)" edit="/1/@proposals.0/@proposals.7/@attempts.11/@edit" start="759" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660730588" sizeMeasure="34" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.7/@attempts.12/@edit" start="884" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660744610" sizeMeasure="34" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return " edit="/1/@proposals.0/@proposals.7/@attempts.13/@edit" start="848" end="-46"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660776003" sizeMeasure="40" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void printDocument(String string) {&#xA;&#x9;&#x9;if(!emp_it.hasNext()){&#xA;&#x9;&#x9;&#x9;emp_it = minions.iterator();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return emp_it.next().printDocument(document" edit="/1/@proposals.0/@proposals.7/@attempts.14/@edit" start="897" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660782368" sizeMeasure="40" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="document" edit="/1/@proposals.0/@proposals.7/@attempts.15/@edit" start="930" end="-121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660790212" sizeMeasure="40" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.16/@edit" start="1005" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660912961" sizeMeasure="44" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int resourceCount=0;&#xA;&#x9;&#x9;for(Iterator&lt;Employee> it = minions.iterator(); it.hasNext();){&#xA;&#x9;&#x9;&#x9;resourceCount+=it.next().getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.17/@edit" start="499" end="-532"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489660960066" sizeMeasure="40" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return minions.size()" edit="/1/@proposals.0/@proposals.7/@attempts.18/@edit" start="499" end="-532"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489661071230" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;int taskCount=0;&#xA;&#x9;Collection&lt;Employee> minions = new ArrayList&lt;Employee>();&#xA;&#x9;Iterator&lt;Employee> emp_it = minions.iterator();&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if(employees.isEmpty()) throw new IllegalArgumentException();&#xA;&#x9;&#x9;this.minions = employees;&#xA;&#x9;}&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return minions.size();&#xA;&#x9;}&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> op, double d, double e) {&#xA;&#x9;&#x9;taskCount+=1;&#xA;&#x9;&#x9;if(!emp_it.hasNext()){&#xA;&#x9;&#x9;&#x9;emp_it = minions.iterator();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return emp_it.next().doCalculations(op,d,e);&#xA;&#x9;}&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount+=1;" edit="/1/@proposals.0/@proposals.7/@attempts.19/@edit" start="210" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489661295508" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+1" edit="/1/@proposals.0/@proposals.7/@attempts.20/@edit" start="537" end="-435"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489661355720" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.7/@attempts.21/@edit" start="591" end="-383"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489661366123" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.22/@edit" start="591" end="-383"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489661530736" sizeMeasure="42" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int resourceCount=1;&#xA;&#x9;&#x9;for(Iterator&lt;Employee> it = minions.iterator(); it.hasNext();){&#xA;&#x9;&#x9;&#x9;resourceCount+=it.next().getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.23/@edit" start="516" end="-435"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489662118055" sizeMeasure="42" errorCount="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implement Employee" edit="/1/@proposals.0/@proposals.7/@attempts.24/@edit" start="208" end="-904"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489662120346" sizeMeasure="42" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s" edit="/1/@proposals.0/@proposals.7/@attempts.25/@edit" start="217" end="-913"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700348533" sizeMeasure="56" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String args[]){&#xA;&#x9;&#x9;Collection&lt;Employee> emps = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;Printer printer = new Printer();&#xA;&#x9;&#x9;for(int i=0; i&lt;10; i++){&#xA;&#x9;&#x9;&#x9;Employee emp = new Clerk(printer);&#xA;&#x9;&#x9;&#x9;emps.add(emp);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;Manager man = new Manager(emps);&#xA;&#x9;&#x9;System.out.println(man.getTaskCount()/man.getResourceCount());&#xA;&#x9;&#x9;Collection&lt;Employee> man_coll = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;man_coll.add(man);&#xA;&#x9;&#x9;Manager manman = new Manager(man_coll);&#xA;&#x9;&#x9;System.out.println(man.getTaskCount()/man.getResourceCount());&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.26/@edit" start="1128" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700407688" sizeMeasure="59" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for(int i=0; i&lt;10; i++){&#xA;&#x9;&#x9;&#x9;man.printDocument(&quot;Document &quot;+i);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.27/@edit" start="1385" end="-261"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700512365" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;man.printDocument(&quot;Document &quot;+i);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(man.getTaskCount());&#xA;&#x9;&#x9;System.out.println()/man.getResourceCount());" edit="/1/@proposals.0/@proposals.7/@attempts.28/@edit" start="1413" end="-261"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700515313" sizeMeasure="62" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.29/@edit" start="1518" end="-285"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700541176" sizeMeasure="62" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5" edit="/1/@proposals.0/@proposals.7/@attempts.30/@edit" start="1278" end="-523"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700667011" sizeMeasure="72" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="man.getTaskCount()/manman.getResourceCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> man_coll = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;man_coll.add(manman);&#xA;&#x9;&#x9;Manager manmanman = new Manager(man_coll);&#xA;&#x9;&#x9;System.out.println(manmanman.getTaskCount()/manmanman.getResourceCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> man_coll = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;man_coll.add(manmanman);&#xA;&#x9;&#x9;Manager manmanmanman = new Manager(man_coll);&#xA;&#x9;&#x9;System.out.println(manmanmanman.getTaskCount()/manmanman" edit="/1/@proposals.0/@proposals.7/@attempts.31/@edit" start="1755" end="-31"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700679336" sizeMeasure="72" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="man_coll = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;man_coll.add(manman);&#xA;&#x9;&#x9;Manager manmanman = new Manager(man_coll);&#xA;&#x9;&#x9;System.out.println(manmanman.getTaskCount()/manmanman.getResourceCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.32/@edit" start="1807" end="-202"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490700346542" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490700404942" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490700517180" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490700539451" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490700677394" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489660813458" completion="0.42857142857142855" successCount="3" failureCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489660915880" completion="0.42857142857142855" successCount="3" failureCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661082076" completion="0.42857142857142855" successCount="3" failureCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661153976" completion="0.42857142857142855" successCount="3" failureCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661296995" completion="0.2857142857142857" successCount="2" failureCount="4" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661357459" completion="0.2857142857142857" successCount="2" failureCount="4" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661370836" completion="0.2857142857142857" successCount="2" failureCount="4" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661532316" completion="0.2857142857142857" successCount="2" failureCount="4" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661771090" completion="0.42857142857142855" successCount="3" failureCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661784973" completion="0.42857142857142855" successCount="3" failureCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661797947" completion="0.5714285714285714" successCount="4" failureCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661815641" completion="0.7142857142857143" successCount="5" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489661824718" completion="0.8571428571428571" successCount="6" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489662126513" completion="1.0" successCount="7"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
