<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490354647419" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public interface Employee {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490354766445" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);&#xA;&#x9;void printDocument(String document);&#xA;&#x9;int getTaskCount();&#xA;&#x9;int getResourceCount();" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490354814027" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Clerk {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490354902398" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490357031121" sizeMeasure="43" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#x9;&#xA;&#x9;private int taskCount = 0;&#xA;&#x9;private int resourceCount = 0;&#xA;&#x9;//private List&lt;String> history = new ArrayList&lt;String>();&#xA;&#x9;&#xA;&#x9;private Printer printerDelegate;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printerDelegate = printer;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;return (operation.apply(value1, value2));&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;printerDelegate&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return  taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount + 1" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="54" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490357122728" sizeMeasure="43" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".printDocument(document, this);&#xA;&#x9;&#x9;taskCount++;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="634" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490357255034" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#x9;&#xA;&#x9;private int taskCount = 0;&#xA;&#x9;private int resourceCount = 0;&#xA;&#x9;//private List&lt;String> history = new ArrayList&lt;String>();&#xA;&#x9;&#xA;&#x9;private Printer printerDelegate;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printerDelegate = printer;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;return (operation.apply(value1, value2));&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;printerDelegate.printDocument(document, this);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return  taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount + 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void doTask() {&#xA;&#x9;&#x9;taskCount++" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="54" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490360151316" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;//private List&lt;String> history = new ArrayList&lt;String>();&#xA;&#x9;&#xA;&#x9;private Printer printerDelegate;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printerDelegate = printer;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;return (operation.apply(value1, value2));&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;printerDelegate.printDocument(document, this);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return  taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="180" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490360276800" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0;&#xA;&#x9;//private List&lt;String> history = new ArrayList&lt;String>();&#xA;&#x9;&#xA;&#x9;private Printer printerDelegate;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printerDelegate = printer;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;return (operation.apply(value1, value2));&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;printerDelegate.printDocument(document, this);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return  taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount+1" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="180" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490360617420" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;//private List&lt;String> history = new ArrayList&lt;String>();&#xA;&#x9;&#xA;&#x9;private Printer printerDelegate;&#xA;&#x9;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printerDelegate = printer;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;return (operation.apply(value1, value2));&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;printerDelegate.printDocument(document, this);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return  taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="180" end="-50"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490357293295" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490354898546" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490357031104" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;HashMap&lt;Employee, List&lt;String>> history = new HashMap&lt;Employee, List&lt;String>>();&#xA;&#x9;&#xA;&#x9;public Printer() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;addToPrintHistory(document, employee);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addToPrintHistory(String document, Employee employee) {&#xA;&#x9;&#x9;if (!history.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;history.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;String> newHistory = getPrintHistory(employee);&#xA;&#x9;&#x9;newHistory.add(document);&#xA;&#x9;&#x9;history.remove(employee); // Trenger jeg dette?&#xA;&#x9;&#x9;history.put(employee, newHistory);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return (history.get(employee));&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490357505385" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (history.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;return (history.get(employee));&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="789" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490357551417" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;return (new ArrayList&lt;String>(" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="868" end="-19"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490357305999" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490357560633" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490357777504" sizeMeasure="31">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490358419967" sizeMeasure="47" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection;&#xA;import java.util.function.BinaryOperator;&#xA;import java.util.Iterator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;private int taskCount = 0;&#xA;&#x9;private int resourceCount = 0;&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employeesDelegate;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;this.employeesDelegate = employees;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Employee callClerk() {&#xA;&#x9;&#x9;if (employeesDelegate.hasnext())" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="54" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490359577794" sizeMeasure="64" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Iterator;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;private int taskCount = 0;&#xA;&#x9;private int resourceCount = 0;&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employeesDelegate;&#xA;&#x9;Iterator&lt;Employee> employeesDelegateIterator;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employeesDelegate = employees;&#xA;&#x9;&#x9;&#x9;this.employeesDelegateIterator = employeesDelegate.iterator();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error; Manager must have employees to function!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Employee callClerk() {&#xA;&#x9;&#x9;if (employeesDelegateIterator.hasNext()) {&#xA;&#x9;&#x9;&#x9;return employeesDelegateIterator.next();&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;employeesDelegateIterator = employeesDelegate.iterator(); // Reset?&#xA;&#x9;&#x9;&#x9;callClerk();&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Probe: Iterator was reset&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="83" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490359699990" sizeMeasure="66" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="resourceCount = employees.size();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.employeesDelegateIterator = employeesDelegate.iterator();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error; Manager must have employees to function!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Employee callClerk() {&#xA;&#x9;&#x9;if (employeesDelegateIterator.hasNext()) {&#xA;&#x9;&#x9;&#x9;return employeesDelegateIterator.next();&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;employeesDelegateIterator = employeesDelegate.iterator(); // Reset?&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Probe: Iterator was reset&quot;);&#xA;&#x9;&#x9;&#x9;return callClerk(" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="461" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490359877743" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="doTask();&#xA;&#x9;&#x9;return callClerk().doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;callClerk().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Employee callClerk() {&#xA;&#x9;&#x9;if (employeesDelegateIterator.hasNext()) {&#xA;&#x9;&#x9;&#x9;return employeesDelegateIterator.next();&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;employeesDelegateIterator = employeesDelegate.iterator(); // Reset?&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Probe: Iterator was reset&quot;);&#xA;&#x9;&#x9;&#x9;return callClerk();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void doTask() {&#xA;&#x9;&#x9;taskCount++;" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="794" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490359932677" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+1" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="1118" end="-334"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490360151279" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employeesDelegate;&#xA;&#x9;Iterator&lt;Employee> employeesDelegateIterator;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employeesDelegate = employees;&#xA;&#x9;&#x9;&#x9;this.resourceCount = employees.size();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.employeesDelegateIterator = employeesDelegate.iterator();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error; Manager must have employees to function!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;return callClerk().doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;callClerk().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="239" end="-334"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490360276793" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0;&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employeesDelegate;&#xA;&#x9;Iterator&lt;Employee> employeesDelegateIterator;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employeesDelegate = employees;&#xA;&#x9;&#x9;&#x9;this.resourceCount = employees.size();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.employeesDelegateIterator = employeesDelegate.iterator();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error; Manager must have employees to function!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;return callClerk().doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;callClerk().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount+1" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="239" end="-334"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490360480370" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employeesDelegateIterator = employeesDelegate.iterator();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.resourceCount = employees.size();&#xA;&#x9;&#x9;&#x9;for (Employee employee : employeesDelegate) {&#xA;&#x9;&#x9;&#x9;&#x9;this.resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="461" end="-890"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490360617373" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employeesDelegate;&#xA;&#x9;Iterator&lt;Employee> employeesDelegateIterator;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employeesDelegate = employees;&#xA;&#x9;&#x9;&#x9;this.employeesDelegateIterator = employeesDelegate.iterator();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;//this.resourceCount = employees.size();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;for (Employee employee : employeesDelegate) {&#xA;&#x9;&#x9;&#x9;&#x9;this.resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error; Manager must have employees to function!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;return callClerk().doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;callClerk().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="239" end="-334"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490360635857" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="1443" end="-124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490362438794" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Arrays;&#xA;import java.util.Collection;&#xA;import java.util.Iterator;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;private int taskCount = 0;&#xA;&#x9;private int resourceCount = 1;&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employeesDelegate;&#xA;&#x9;Iterator&lt;Employee> employeesDelegateIterator;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employeesDelegate = employees;&#xA;&#x9;&#x9;&#x9;this.employeesDelegateIterator = employeesDelegate.iterator();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;//this.resourceCount = employees.size();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;for (Employee employee : employeesDelegate) {&#xA;&#x9;&#x9;&#x9;&#x9;this.resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error; Manager must have employees to function!&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;return callClerk().doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;doTask();&#xA;&#x9;&#x9;callClerk().printDocument(document);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Employee callClerk() {&#xA;&#x9;&#x9;if (employeesDelegateIterator.hasNext()) {&#xA;&#x9;&#x9;&#x9;return employeesDelegateIterator.next();&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;employeesDelegateIterator = employeesDelegate.iterator(); // Reset?&#xA;&#x9;&#x9;&#x9;//System.out.println(&quot;Probe: Iterator was reset&quot;);&#xA;&#x9;&#x9;&#x9;return callClerk();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void doTask() {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Printer destroyingTheRainforests3000 = new Printer();&#xA;&#x9;&#x9;Printer iGotMyOwnPrinterAndImProudOfIt = new Printer();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//---&#xA;&#x9;&#x9;Employee david = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee susan = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee michael = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee geralt = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee max = new Clerk(iGotMyOwnPrinterAndImProudOfIt);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> jeffsEmployees = Arrays.asList(david, susan, michael, geralt, max);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee jeff = new Manager(jeffsEmployees);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double tasks1 = jeff.getTaskCount();&#xA;&#x9;&#x9;double resources1 = jeff.getResourceCount();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double effect1 = tasks1/resources1;&#xA;&#x9;&#x9;System.out.println(&quot;Tasks per resource in Team Jeff : &quot; + effect1);&#xA;&#x9;&#x9;//---&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee bob = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee melissa = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee torbjorn = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee torbjornJr = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee donald = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> stevesEmployees = Arrays.asList(bob, melissa, torbjorn);&#xA;&#x9;&#x9;Collection&lt;Employee> waltersEmployees = Arrays.asList(torbjornJr, donald);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee steveCarell = new Manager(stevesEmployees);&#xA;&#x9;&#x9;Employee walter = new Manager(waltersEmployees);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> CEOsEmployees = Arrays.asList(steveCarell, walter);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee CEO = new Manager(CEOsEmployees);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double tasks2 = CEO.getTaskCount();&#xA;&#x9;&#x9;double resources2 = CEO.getResourceCount();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double effect2 = tasks2/resources2;&#xA;&#x9;&#x9;System.out.println(&quot;Tasks per resource in Team Jeff : &quot; + effect2);&#xA;&#x9;&#x9;//---&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.10/@edit" start="54" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490362798404" sizeMeasure="140" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee elizabeth = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee leliana = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee max = new Clerk(iGotMyOwnPrinterAndImProudOfIt);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> jeffsEmployees = Arrays.asList(david, susan, michael, geralt, max);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee jeff = new Manager(jeffsEmployees);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//---&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee bob = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee melissa = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee torbjorn = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee torbjornJr = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;Employee donald = new Clerk(destroyingTheRainforests3000);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> stevesEmployees = Arrays.asList(bob, melissa, torbjorn);&#xA;&#x9;&#x9;Collection&lt;Employee> waltersEmployees = Arrays.asList(torbjornJr, donald);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee steveCarell = new Manager(stevesEmployees);&#xA;&#x9;&#x9;Employee walter = new Manager(waltersEmployees);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collection&lt;Employee> CEOsEmployees = Arrays.asList(steveCarell, walter);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Employee CEO = new Manager(CEOsEmployees);&#xA;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i=0; i&lt;8; i++) {&#xA;&#x9;&#x9;&#x9;jeff.printDocument(&quot;A document&quot;);&#xA;&#x9;&#x9;&#x9;CEO.printDocument(&quot;Another document&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;double tasks1 = jeff.getTaskCount();&#xA;&#x9;&#x9;double resources1 = jeff.getResourceCount();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double effect1 = tasks1/resources1;&#xA;&#x9;&#x9;System.out.println(&quot;Tasks per resource in Team Jeff : &quot; + effect1);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;double tasks2 = CEO.getTaskCount();&#xA;&#x9;&#x9;double resources2 = CEO.getResourceCount();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double effect2 = tasks2/resources2;&#xA;&#x9;&#x9;System.out.println(&quot;Tasks per resource in Team CEO" edit="/1/@proposals.0/@proposals.7/@attempts.11/@edit" start="2007" end="-41"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490362436539" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490362797672" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490359889246" completion="0.5714285714285714" successCount="4" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490359933731" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490360172059" completion="0.5714285714285714" successCount="4" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490360282810" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490360481849" completion="0.5714285714285714" successCount="4" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490360618966" completion="1.0" successCount="7"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
