<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Logger">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the ILogger Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.ILogger"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Implementations">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StreamLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StreamLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StreamLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.StreamLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the FilteringLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the FilteringLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the FilteringLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.FilteringLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the DistributingLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DistributingLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DistributingLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.DistributingLoggerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.*Logger" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612836782" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public interface ILogger {&#xA;&#x9;&#xA;&#xA;&#x9;&#xA;&#x9;public String ERROR = &quot;error&quot;, WARNING = &quot;warning&quot;, INFO = &quot;info&quot;;&#xA;&#x9;public void log(String severity, String message, Exception exception);&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613283254" sizeMeasure="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", dsad = &quot;RIP" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="128" end="-79"/>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490552848421" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;import java.io.IOException;&#xA;import java.io.OutputStream;&#xA;import java.io.PrintStream;&#xA;&#xA;public class StreamLogger  implements ILogger{&#xA;&#x9;&#xA;&#x9;private static final Exception IOException = null;&#xA;&#x9;private PrintStream stream;&#xA;&#x9;private String format = &quot;%s: %s (%s)&quot;;&#xA;&#x9;&#xA;&#x9;public StreamLogger(OutputStream outputstream) {&#xA;&#x9;&#x9;this.stream = new PrintStream(outputstream);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFormatString(String logFormat) {&#xA;&#x9;&#x9;this.format = logFormat;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;stream.format(format, severity, message, exception);&#xA;&#x9;&#x9;stream.println();&#xA;&#x9;&#x9;stream.flush();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public static void main(String [] args){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StreamLogger qp = new StreamLogger(System.out);&#xA;&#x9;&#x9;&#x9;qp.log(ILogger.WARNING, &quot;Denne melding er til informasjon&quot;, IOException);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490609426521" sizeMeasure="38" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="843" end="-844"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552848324" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552849906" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552850553" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552850759" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552850925" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552851068" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552851242" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552851343" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552851344" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552851370" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552851381" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552854845" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490552933556" mode="debug"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490609372268" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class FilteringLogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490609387100" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490609409961" sizeMeasure="40" warningCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;&#xA;public class FilteringLogger implements ILogger{&#xA;&#xA;&#x9;private ILogger logger;&#xA;&#x9;private final List&lt;String> severities;&#xA;&#x9;&#xA;&#x9;public FilteringLogger(ILogger logger, String... severities){&#xA;&#x9;&#x9;this.logger  = logger;&#xA;&#x9;&#x9;this.severities = new ArrayList&lt;String>(Arrays.asList(severities));&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isLogging(String severity){&#xA;&#x9;&#x9;return severities.contains(severity);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setIsLogging(String severity, boolean value){&#xA;&#x9;&#x9;if( value == false){&#xA;&#x9;&#x9;&#x9;severities.remove(severity);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(isLogging(severity) == false){&#xA;&#x9;&#x9;&#x9;severities.add(severity);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490609576926" sizeMeasure="42" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(isLogging(severity)){&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.2/@edit" start="792" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490609811264" sizeMeasure="48" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String [] args){&#xA;&#x9;&#x9;ILogger syserrLogger = new StreamLogger(System.err);&#xA;&#x9;&#x9;FilteringLogger qp = new FilteringLogger(syserrLogger, ILogger.ERROR);" edit="/1/@proposals.1/@proposals.3/@attempts.3/@edit" start="872" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610153078" sizeMeasure="53" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="logger = new FilteringLogger(syserrLogger, ILogger.ERROR);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;logger.log(ILogger.ERROR, &quot;Denne meldingen er alvorlig og skrives til System.err&quot;, null);&#xA;&#x9;&#x9;logger.log(ILogger.WARNING, &quot;Denne meldingen er en advarsel og blir filtrert bort&quot;, null);&#xA;&#x9;&#x9;logger.log(ILogger.INFO, &quot;Denne meldingen er til informasjon og blir filtrert bort&quot;, null);&#xA;&#x9;&#x9;logger.setIsLogging(ILogger.WARNING, true);&#xA;&#x9;&#x9;logger.log(ILogger.WARNING, &quot;Denne meldingen er en advarsel og blir nå skrevet til System.err&quot;, null);" edit="/1/@proposals.1/@proposals.3/@attempts.4/@edit" start="989" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610198366" sizeMeasure="53" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection" edit="/1/@proposals.1/@proposals.3/@attempts.5/@edit" start="226" end="-1258"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610284962" sizeMeasure="53" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.1/@proposals.3/@attempts.6/@edit" start="1384" end="-110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610311385" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="logger.setIsLogging(ILogger.ERROR, false);&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.3/@attempts.7/@edit" start="1384" end="-110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610324114" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="logger.setIsLogging(ILogger.ERROR, false);" edit="/1/@proposals.1/@proposals.3/@attempts.8/@edit" start="1056" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610354761" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="WARNING);&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.3/@attempts.9/@edit" start="1046" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610405220" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ERROR);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;logger.log(ILogger.ERROR, &quot;Denne meldingen er alvorlig og skrives til System.err&quot;, null);&#xA;&#x9;&#x9;logger.log(ILogger.WARNING, &quot;Denne meldingen er en advarsel og blir filtrert bort&quot;, null);&#xA;&#x9;&#x9;logger.log(ILogger.INFO, &quot;Denne meldingen er til informasjon og blir filtrert bort&quot;, null);&#xA;&#x9;&#x9;logger.setIsLogging(ILogger.WARNING, true);&#xA;&#x9;&#x9;logger.setIsLogging(ILogger.INFO, tru" edit="/1/@proposals.1/@proposals.3/@attempts.10/@edit" start="1046" end="-116"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610431734" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;logger.log(ILogger.INFO, &quot;Denne meldingen er til informasjon og blir filtrert bort" edit="/1/@proposals.1/@proposals.3/@attempts.11/@edit" start="1531" end="-17"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612186732" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.3/@attempts.12/@edit" start="1630" end="-1631"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490609811177" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490609818377" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490610153023" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490610198306" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490610284875" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490610311294" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490610324055" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490610354699" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490610405163" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490610431676" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490609427286" completion="0.8" successCount="4" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490609577407" completion="1.0" successCount="5"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.6/@q" answer="/0/@parts.1/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490610547703" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class DistributingLogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612082694" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements ILogger{&#xA;&#x9;&#xA;&#x9;public  DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setLogger(String severity, ILogger logger){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;ILogger syserrLogger = new StreamLogger(System.err);&#xA;&#x9;&#x9;ILogger sysoutLogger = new StreamLogger(System.out);&#xA;&#x9;&#x9;DistributingLogger logger = new DistributingLogger(syserrLogger, syserrLogger, sysoutLogger);&#xA;&#x9;&#x9;logger.log(ILogger.ERROR, &quot;Denne meldingen er alvorlig og skrives til System.err&quot;, null);&#xA;&#x9;&#x9;logger.log(ILogger.WARNING, &quot;Denne meldingen er en advarsel og skrives til System.err&quot;, null);&#xA;&#x9;&#x9;logger.log(ILogger.INFO, &quot;Denne meldingen er til informasjon og skrives til System.out&quot;, null);&#xA;&#x9;&#x9;logger.setLogger(ILogger.WARNING, sysoutLogger);&#xA;&#x9;&#x9;logger.log(ILogger.WARNING, &quot;Denne meldingen er en advarsel, men nå skrives den til System.out&quot;, null);&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.6/@attempts.0/@edit" start="62" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612555061" sizeMeasure="46" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collection;&#xA;import java.util.HashMap;&#xA;&#xA;import com.sun.javafx.collections.MappingChange.Map;&#xA;&#xA;public class DistributingLogger implements ILogger{&#xA;&#x9;&#xA;&#x9;private HashMap&lt;String, ILogger> loggers = new HashMap&lt;String, ILogger>();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public  DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;setLogger(ILogger.ERROR, errorLogger);&#xA;&#x9;&#x9;setLogger(ILogger.WARNING, warningLogger);&#xA;&#x9;&#x9;setLogger(ILogger.INFO, infoLogger);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setLogger(String severity, ILogger logger){&#xA;&#x9;&#x9;loggers.put(severity , logger);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;ILogger syserrLogger = new StreamLogger(System.err);&#xA;&#x9;&#x9;ILogger sysoutLogger = new StreamLogger(System.out);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;DistributingLogger logger = new DistributingLogger(syserrLogger, syserrLogger, sysoutLogger);&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.6/@attempts.1/@edit" start="30" end="-455"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612676792" sizeMeasure="49" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", logger);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;ILogger logger = loggers.get(severity);&#xA;&#x9;&#x9;if(logger != null){&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.6/@attempts.2/@edit" start="582" end="-719"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613138965" sizeMeasure="50" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;logger.log(&quot;dsadas&quot;, &quot;ATOMBOMBE&quot;, null);" edit="/1/@proposals.1/@proposals.6/@attempts.3/@edit" start="1506" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613168931" sizeMeasure="51" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;logger.setLogger(&quot;dsadas&quot;, sysoutLogger" edit="/1/@proposals.1/@proposals.6/@attempts.4/@edit" start="1549" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613283234" sizeMeasure="51" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ILogger.dsad" edit="/1/@proposals.1/@proposals.6/@attempts.5/@edit" start="1518" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613348480" sizeMeasure="53" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;logger.log(ILogger.dsad, &quot;ATOMBOMBE&quot;, null);&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.6/@attempts.6/@edit" start="1597" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613386061" sizeMeasure="54" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="setLogger(ILogger.dsad" edit="/1/@proposals.1/@proposals.6/@attempts.7/@edit" start="497" end="-1173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613397870" sizeMeasure="54" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="err" edit="/1/@proposals.1/@proposals.6/@attempts.8/@edit" start="1623" end="-66"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613432092" sizeMeasure="54" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.6/@attempts.9/@edit" start="1691" end="-1692"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613455683" sizeMeasure="54" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="dsad" edit="/1/@proposals.1/@proposals.6/@attempts.10/@edit" start="1610" end="-74"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613571757" sizeMeasure="54" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", ILogger qplogger) {&#xA;&#x9;&#x9;setLogger(ILogger.ERROR, errorLogger);&#xA;&#x9;&#x9;setLogger(ILogger.WARNING, warningLogger);&#xA;&#x9;&#x9;setLogger(ILogger.INFO, infoLogger);&#xA;&#x9;&#x9;setLogger(ILogger.dsad, qplogger);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setLogger(String severity, ILogger logger){&#xA;&#x9;&#x9;loggers.put(severity, logger);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;ILogger logger = loggers.get(severity);&#xA;&#x9;&#x9;if(logger != null){&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;ILogger syserrLogger = new StreamLogger(System.err);&#xA;&#x9;&#x9;ILogger sysoutLogger = new StreamLogger(System.out);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;DistributingLogger logger = new DistributingLogger(syserrLogger, syserrLogger, sysout" edit="/1/@proposals.1/@proposals.6/@attempts.11/@edit" start="366" end="-617"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.7/@q" answer="/0/@parts.1/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490612082570" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490612676732" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490612836721" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613138910" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613168879" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613283187" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613348430" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613386012" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613397821" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613432027" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613455630" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490613571698" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.8/@q" answer="/0/@parts.1/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490612556196" completion="0.0" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490612685502" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a" performedCount="3">
        <attempts timestamp="1490552941016"/>
        <attempts timestamp="1490552942456"/>
        <attempts timestamp="1490552943049"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
