<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489698809535" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public interface Employee {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489698967916" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#xA;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);&#xA;&#x9;&#xA;&#x9;void printDocument(String document);&#xA;&#x9;&#xA;&#x9;int getTaskCount();&#xA;&#x9;&#xA;&#x9;int getResourceCount();&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="37" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489698988636" sizeMeasure="31">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489699242689" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;Printer printer;&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="121" end="-453"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489699956652" sizeMeasure="37" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="operation { (value1)}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="359" end="-298"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="374" charEnd="383" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="374" charEnd="383" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="393" charEnd="394" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="393" charEnd="394" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489845726939" sizeMeasure="37" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="677" end="-678"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="374" charEnd="383" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="374" charEnd="383" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="393" charEnd="394" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="393" charEnd="394" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846132831" sizeMeasure="43" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#x9;&#xA;&#x9;List&lt;Employee> resources;&#xA;&#x9;Printer printer;&#xA;&#x9;int taskCount;&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;&#x9;taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return operation { (value1)};&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;taskCount++;&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return taskCount" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="54" end="-106"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="480" charEnd="481" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="480" charEnd="481" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="461" charEnd="470" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="461" charEnd="470" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846349063" sizeMeasure="43" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private List&lt;Employee> resources;&#xA;&#x9;private Printer printer;&#xA;&#x9;private " edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="147" end="-607"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="485" charEnd="494" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="485" charEnd="494" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="504" charEnd="505" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="504" charEnd="505" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846406161" sizeMeasure="43" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="resources.add(this);&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;&#x9;taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return operation { (value1)};&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;taskCount++;&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="267" end="-125"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="509" charEnd="518" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="509" charEnd="518" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="528" charEnd="529" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="528" charEnd="529" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846566039" sizeMeasure="42" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="printer.printDocument(document, this);&#xA;&#x9;&#x9;taskCount++;&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resources.size()" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="590" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="509" charEnd="518" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="509" charEnd="518" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="528" charEnd="529" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="528" charEnd="529" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846961081" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="taskCount++;&#xA;&#x9;&#x9;return operation.apply(value1,  value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;printer.printDocument(document, this)" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="445" end="-149"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489847166578" sizeMeasure="41" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int resourceCount;&#xA;&#x9;private Printer printer;&#xA;&#x9;private int taskCount;&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;resourceCount = 1;&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;&#x9;taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return operation.apply(value1,  value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="155" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="46" charEnd="60" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489847301763" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="54" end="-694"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489847501679" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee {&#xA;&#x9;&#xA;&#x9;private int resourceCount;&#xA;&#x9;private Printer printer;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="54" end="-544"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489847595510" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private " edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="178" end="-544"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489847992550" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Clerk clerk = new Clerk(new Printer()) ;&#xA;&#x9;&#x9;System.out.println(clerk.taskCount);&#xA;&#x9;&#x9;System.out.println(clerk.resourceCount);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="727" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848016650" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;clerk.printDocument(&quot;lolol&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="897" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848453645" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="727" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489852371538" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Printer printer;&#xA;&#x9;private int taskCount;&#xA;&#x9;private int resourceCount;&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;resourceCount = 1;&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;&#x9;taskCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;return operation.apply(value1,  value2);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="132" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489847994489" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489848018251" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489848091574" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489848161019" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489848446395" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489846971634" completion="0.0" errorCount="4">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489847060894" completion="0.0" errorCount="4">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489847171136" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489847506666" completion="0.5" successCount="2" errorCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489848458084" completion="1.0" successCount="4">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489875500607" completion="1.0" successCount="4">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489699064666" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489699120637" sizeMeasure="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="61" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489699169500" sizeMeasure="13" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return;" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="127" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="189" charEnd="196" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="136" charEnd="140" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489699958443" sizeMeasure="13" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="195" end="-196"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="189" charEnd="196" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="136" charEnd="140" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846118247" sizeMeasure="22" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;List&lt;String> printHistory;&#xA;&#x9;&#xA;&#x9;public Printer() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return printHistory;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="37" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="313" charEnd="314" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846129832" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="284" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846312604" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HashMap;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;HashMap&lt;Employee, List&lt;String>> printHistory;&#xA;&#x9;&#xA;&#x9;public Printer() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;printHistory.get(employee).add(document);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return printHistory.get(employee);" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="54" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489846329366" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private " edit="/1/@proposals.0/@proposals.4/@attempts.6/@edit" start="113" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848089380" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.4/@attempts.7/@edit" start="170" end="-236"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848151510" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public Printer() {&#xA;&#x9;&#x9;printHistory = new HashMap&lt;Employee, List&lt;String>>();&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.4/@attempts.8/@edit" start="170" end="-236"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848441982" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.HashMap;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;private HashMap&lt;Employee, List&lt;String>> printHistory;&#xA;&#x9;&#xA;&#x9;public Printer() {&#xA;&#x9;&#x9;printHistory = new HashMap&lt;Employee, List&lt;String>>();&#xA;&#x9;}&#xA;&#xA;&#x9;void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;System.out.println(document);&#xA;&#x9;&#x9;if (!printHistory.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;printHistory.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.9/@edit" start="54" end="-146"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848605833" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!printHistory.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;printHistory.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.10/@edit" start="574" end="-46"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848637559" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!printHistory.containsKey(employee)) {&#xA;&#x9;&#x9;&#x9;printHistory.put(employee, new ArrayList&lt;String>());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;printHistory.get(employee).add(document);&#xA;&#x9;&#x9;System.out.println" edit="/1/@proposals.0/@proposals.4/@attempts.11/@edit" start="337" end="-218"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489846998504" completion="0.0" errorCount="3">
          <errorTests>testPrintHistoryModification</errorTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489847023563" completion="0.0" errorCount="3">
          <errorTests>testPrintHistoryModification</errorTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489847205171" completion="0.0" errorCount="3">
          <errorTests>testPrintHistoryModification</errorTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489848465498" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testPrintHistoryModification</successTests>
          <errorTests>testPrintSingleClerk</errorTests>
          <errorTests>testPrintMulipleClerks</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489848610097" completion="1.0" successCount="3">
          <successTests>testPrintHistoryModification</successTests>
          <successTests>testPrintSingleClerk</successTests>
          <successTests>testPrintMulipleClerks</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489875511811" completion="1.0" successCount="3">
          <successTests>testPrintHistoryModification</successTests>
          <successTests>testPrintSingleClerk</successTests>
          <successTests>testPrintMulipleClerks</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848705771" sizeMeasure="31">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848783837" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employees;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;employees.add(this);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="54" end="-454"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489848899037" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!(employees.size() > 0)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="241" end="-510"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849078706" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int taskCount = 0;&#xA;&#x9;&#x9;if (!(employees.size() > 0)) {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;taskCount += employee.getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return employees.size()" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="675" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849103792" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="929" end="-930"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849111475" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="f (!(employees.size() > 0)) {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int taskCount = 0;" edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="676" end="-187"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849236948" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="676" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849300496" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt;= getTaskCount()/getResourceCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;employee.printDocument(document);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="593" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849305722" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;break" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="742" end="-263"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849410381" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="1010" end="-1011"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849490262" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" (getTaskCount()/getResourceCount() + 1" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="662" end="-315"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489849575145" sizeMeasure="52" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount()/getResourceCount() + 1)) {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.10/@edit" start="483" end="-487"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="418" charEnd="496" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489850115490" sizeMeasure="58" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Iterator;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employees;&#xA;&#x9;Iterator employeeIterator;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!(employees.size() > 0)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;employees.add(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private Employee nextEmployee() {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.11/@edit" start="83" end="-785"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="467" charEnd="481" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="522" charEnd="600" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="224" charEnd="232" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="467" charEnd="481" severity="1" problemCategory="120" problemType="603979894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489850154879" sizeMeasure="59" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;employeeIterator = employees.iterator(" edit="/1/@proposals.0/@proposals.7/@attempts.12/@edit" start="426" end="-830"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="224" charEnd="232" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="511" charEnd="525" severity="1" problemCategory="120" problemType="603979894"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="511" charEnd="525" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="566" charEnd="644" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489850343850" sizeMeasure="52" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employees;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!(employees.size() > 0)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;employees.add(this);" edit="/1/@proposals.0/@proposals.7/@attempts.13/@edit" start="83" end="-785"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="418" charEnd="496" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489850519312" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return 0.0d;" edit="/1/@proposals.0/@proposals.7/@attempts.14/@edit" start="669" end="-487"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489850557115" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.7/@attempts.15/@edit" start="349" end="-820"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489850607095" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount()/getResourceCount() + 1)) {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0.0d;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount()/getResourceCount() + 1)) {&#xA;&#x9;&#x9;&#x9;&#x9;employee.printDocument(document);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int taskCount = 0;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;taskCount += employee.getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return employees.size() + 1" edit="/1/@proposals.0/@proposals.7/@attempts.16/@edit" start="348" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489850864816" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.17/@edit" start="1149" end="-1150"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489852158970" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int resourceCount = 0;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.18/@edit" start="1114" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489852180368" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return resourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.19/@edit" start="1134" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489852363039" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!(employees.size() > 0)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount()/getResourceCount() + 1)) {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0.0d;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount()/getResourceCount() + 1)) {&#xA;&#x9;&#x9;&#x9;&#x9;employee.printDocument(document);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {" edit="/1/@proposals.0/@proposals.7/@attempts.20/@edit" start="188" end="-217"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489852571794" sizeMeasure="65" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee {&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employees;&#xA;&#x9;private int taskCount;&#xA;&#x9;&#xA;&#x9;public Manager(Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!(employees.size() > 0)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.employees = employees;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount()/getResourceCount() + 1)) {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0.0d;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount()/getResourceCount() + 1)) {&#xA;&#x9;&#x9;&#x9;&#x9;employee.printDocument(document);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Employee> employees = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;Printer printer = new Printer();&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;employees.add(new Clerk(printer));&#xA;&#x9;&#x9;Manager manager = new Manager(employees)" edit="/1/@proposals.0/@proposals.7/@attempts.21/@edit" start="54" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="62" charStart="1555" charEnd="1562" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489852742390" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1 = new Manager(employees);&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with one Manager layer: &quot; + String.valueOf((double) manager1.getTaskCount() / manager1.getResourceCount())" edit="/1/@proposals.0/@proposals.7/@attempts.22/@edit" start="1501" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489853079448" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager1.printDocument(&quot;lol&quot;" edit="/1/@proposals.0/@proposals.7/@attempts.23/@edit" start="1531" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489853886970" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager1.doCalculations((d1, d2) -> (d1 + d2), 0.25, 1.5" edit="/1/@proposals.0/@proposals.7/@attempts.24/@edit" start="1564" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854004293" sizeMeasure="71" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;Printer printer = new Printer();&#xA;&#x9;&#x9;employees1.add(new Clerk(printer));&#xA;&#x9;&#x9;employees1.add(new Clerk(printer));&#xA;&#x9;&#x9;employees1.add(new Clerk(printer));&#xA;&#x9;&#x9;Manager manager1 = new Manager(employees1);&#xA;&#x9;&#x9;manager1.printDocument(&quot;lol&quot;);&#xA;&#x9;&#x9;manager1.doCalculations((d1, d2) -> (d1 + d2), 0.25, 1.5);&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with one Manager layer: &quot; + String.valueOf((double) manager1.getTaskCount() / manager1.getResourceCount()));&#xA;&#x9;&#x9;ArrayList&lt;Employee> employees2 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;employees2.add(manager1);&#xA;&#x9;&#x9;Manager manager2 = new Manager(employees2" edit="/1/@proposals.0/@proposals.7/@attempts.25/@edit" start="1308" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="68" charStart="1938" charEnd="1946" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854018436" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(&quot;Effectivity with one Manager layer: &quot; + String.valueOf((double) manager2.getTaskCount() / manager2.getResourceCount())" edit="/1/@proposals.0/@proposals.7/@attempts.26/@edit" start="1908" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854214963" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;// add second level of management&#xA;&#x9;&#x9;ArrayList&lt;Employee> employees2 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;employees2.add(manager1);&#xA;&#x9;&#x9;Manager manager2 = new Manager(employees2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// complete two tasks using the second manager&#xA;&#x9;&#x9;manager1.printDocument(&quot;lol&quot;);&#xA;&#x9;&#x9;manager1.doCalculations((d1, d2) -> (d1 + d2), 0.25, 1.5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// print out the ratio between tasks and resources for each management level&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with one Manager layer: &quot; + String.valueOf((double) manager1.getTaskCount() / manager1.getResourceCount()));&#xA;" edit="/1/@proposals.0/@proposals.7/@attempts.27/@edit" start="1536" end="-151"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854223036" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.28/@edit" start="2080" end="-151"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854234241" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.printDocument(&quot;lol&quot;);&#xA;&#x9;&#x9;manager2.doCalculations((d1, d2) -> (d1 + d2), 0.25, 1.5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// print out the ratio between tasks and resources for each management level&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with one Manager layer: &quot; + String.valueOf((double) manager1.getTaskCount() / manager1.getResourceCount()));" edit="/1/@proposals.0/@proposals.7/@attempts.29/@edit" start="1770" end="-151"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854248377" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="two" edit="/1/@proposals.0/@proposals.7/@attempts.30/@edit" start="2119" end="-108"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854291091" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s" edit="/1/@proposals.0/@proposals.7/@attempts.31/@edit" start="2136" end="-94"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854293611" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.32/@edit" start="1995" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854366495" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.33/@edit" start="2180" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854380502" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Task" edit="/1/@proposals.0/@proposals.7/@attempts.34/@edit" start="2180" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854392506" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" / manager2.getResource" edit="/1/@proposals.0/@proposals.7/@attempts.35/@edit" start="2191" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854457932" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// add first level of management" edit="/1/@proposals.0/@proposals.7/@attempts.36/@edit" start="1279" end="-956"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854564660" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double)" edit="/1/@proposals.0/@proposals.7/@attempts.37/@edit" start="2071" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854595326" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2 / manager1.getResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) 2 /" edit="/1/@proposals.0/@proposals.7/@attempts.38/@edit" start="2059" end="-39"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854643511" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager1.getTaskCount() / manager1.getResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) manager2.getTaskCount()" edit="/1/@proposals.0/@proposals.7/@attempts.39/@edit" start="2059" end="-41"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854655487" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2 / manager1.getResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) 2" edit="/1/@proposals.0/@proposals.7/@attempts.40/@edit" start="2059" end="-41"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854687720" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager1.getTaskCount() / manager1.getResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) manager2.getTaskCount()" edit="/1/@proposals.0/@proposals.7/@attempts.41/@edit" start="2059" end="-41"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854702397" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.42/@edit" start="2082" end="-162"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854828124" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" / manager1.getResource" edit="/1/@proposals.0/@proposals.7/@attempts.43/@edit" start="2082" end="-162"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854835756" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) manager2.getTask" edit="/1/@proposals.0/@proposals.7/@attempts.44/@edit" start="2082" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854861014" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*manager2.printDocument(&quot;lol&quot;);*/" edit="/1/@proposals.0/@proposals.7/@attempts.45/@edit" start="1798" end="-379"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854875598" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager2.printDocument(&quot;lol&quot;);&#xA;&#x9;&#x9;/*manager2.doCalculations((d1, d2) -> (d1 + d2), 0.25, 1.5);*/" edit="/1/@proposals.0/@proposals.7/@attempts.46/@edit" start="1798" end="-318"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854893208" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager2.printDocument(&quot;lol2" edit="/1/@proposals.0/@proposals.7/@attempts.47/@edit" start="1831" end="-386"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489854932565" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager2.doCalculations((d1, d2) -> (d1 + d2), 0.25, 1.5);" edit="/1/@proposals.0/@proposals.7/@attempts.48/@edit" start="1865" end="-318"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489855108300" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(getTaskCount() + getResourceCount() - 1)/getResourceCount())) {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0.0d;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; ((getTaskCount() + getResourceCount() - 1)/getResourceCount()" edit="/1/@proposals.0/@proposals.7/@attempts.49/@edit" start="598" end="-1328"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489855195535" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/manager1.getResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) manager2.getTaskCount()/manager2.getResource" edit="/1/@proposals.0/@proposals.7/@attempts.50/@edit" start="2162" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489855209600" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getTaskCount() + getResourceCount()/getResourceCount())) {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0.0d;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount() + getResourceCount(" edit="/1/@proposals.0/@proposals.7/@attempts.51/@edit" start="598" end="-1404"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489855224598" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// MÅ FIKSE!&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (getTaskCount() + getResourceCount()/getResourceCount())) {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0.0d;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;// MÅ FIKSE!" edit="/1/@proposals.0/@proposals.7/@attempts.52/@edit" start="567" end="-1473"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489873461093" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int maxTaskCount = 0;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() > maxTaskCount) {&#xA;&#x9;&#x9;&#x9;&#x9;maxTaskCount = employee.getTaskCount();&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0.0d;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;int maxTaskCount = 0;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() > maxTaskCount) {&#xA;&#x9;&#x9;&#x9;&#x9;maxTaskCount = employee.getTaskCount();&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;employee.printDocument(document);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int resourceCount = 1;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;resourceCount += employee.getResourceCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return resourceCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// add first level of management&#xA;&#x9;&#x9;ArrayList&lt;Employee> employees1 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;Printer printer = new Printer();&#xA;&#x9;&#x9;employees1.add(new Clerk(printer));&#xA;&#x9;&#x9;employees1.add(new Clerk(printer));&#xA;&#x9;&#x9;employees1.add(new Clerk(printer));&#xA;&#x9;&#x9;Manager manager1 = new Manager(employees1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// add second level of management&#xA;&#x9;&#x9;ArrayList&lt;Employee> employees2 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;employees2.add(manager1);&#xA;&#x9;&#x9;Manager manager2 = new Manager(employees2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// complete two tasks using the second manager&#xA;&#x9;&#x9;manager2.printDocument(&quot;lol&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;lol2&quot;);&#xA;&#x9;&#x9;manager2.doCalculations((d1, d2) -> (d1 + d2), 0.25, 1.5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// print out the ratio between tasks and resources for each management level&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with one Manager layer:  &quot; + String.valueOf((double) manager1.getTaskCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) manager2.getTask" edit="/1/@proposals.0/@proposals.7/@attempts.53/@edit" start="527" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489873510641" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/manager1.getResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) manager2.getTaskCount()/manager2.getResource" edit="/1/@proposals.0/@proposals.7/@attempts.54/@edit" start="2221" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489873583862" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="o" edit="/1/@proposals.0/@proposals.7/@attempts.55/@edit" start="1930" end="-472"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875001064" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (taskCount/employees.size() + 1)) {&#xA;&#x9;&#x9;&#x9;&#x9;return employee.doCalculations(operation, value1, value2);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0.0d;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;taskCount++;&#xA;&#x9;&#x9;int maxTaskCount = 0;&#xA;&#x9;&#x9;for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() > maxTaskCount) {&#xA;&#x9;&#x9;&#x9;&#x9;maxTaskCount = employee.getTaskCount();&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;employee.printDocument(document);&#xA;&#x9;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.7/@attempts.56/@edit" start="527" end="-1322"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875021485" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) manager2.getTask" edit="/1/@proposals.0/@proposals.7/@attempts.57/@edit" start="2165" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875096693" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Employee employee: employees) {&#xA;&#x9;&#x9;&#x9;if (employee.getTaskCount() &lt; (taskCount/employees.size() + 1))" edit="/1/@proposals.0/@proposals.7/@attempts.58/@edit" start="798" end="-1329"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875121848" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/manager1.getResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers: &quot; + String.valueOf((double) manager2.getTaskCount()/manager2.getResource" edit="/1/@proposals.0/@proposals.7/@attempts.59/@edit" start="2105" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875156176" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.60/@edit" start="1829" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875185980" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="doCalculations((d1, d2) -> (d1 + d2), 0.25, 1.5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// print out the ratio between tasks and resources for each management level&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with one Manager layer (tasks/resources):  &quot; + String.valueOf((double) manager1.getTaskCount()/manager1.getResourceCount()));&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers (tasks/resources)" edit="/1/@proposals.0/@proposals.7/@attempts.61/@edit" start="1829" end="-92"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875216181" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="add third level of management&#xA;&#x9;&#x9;ArrayList&lt;Employee> employees3 = new ArrayList&lt;Employee>();&#xA;&#x9;&#x9;employees3.add(manager2);&#xA;&#x9;&#x9;Manager manager3 = new Manager(employees3);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// complete two tasks using the second manager&#xA;&#x9;&#x9;manager3.printDocument(&quot;lolo&quot;);&#xA;&#x9;&#x9;manager3" edit="/1/@proposals.0/@proposals.7/@attempts.62/@edit" start="1740" end="-460"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875304813" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=":    &quot; + String.valueOf((double) manager1.getTaskCount()/manager1.getResourceCount()) + &quot; tasks/resources&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two Manager layers:   &quot; + String.valueOf((double) manager2.getTaskCount()/manager2.getResourceCount()) + &quot; tasks/resources&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with three Manager layers: &quot; + String.valueOf((double) manager2.getTaskCount()/manager2.getResourceCount()) + &quot; tasks/resources&quot;" edit="/1/@proposals.0/@proposals.7/@attempts.63/@edit" start="2191" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875316202" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3.getTaskCount()/manager3" edit="/1/@proposals.0/@proposals.7/@attempts.64/@edit" start="2561" end="-51"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875422142" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="management layer:    &quot; + String.valueOf((double) manager1.getTaskCount()/manager1.getResourceCount()) + &quot; tasks/resources&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two management layers:   &quot; + String.valueOf((double) manager2.getTaskCount()/manager2.getResourceCount()) + &quot; tasks/resources&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with three management" edit="/1/@proposals.0/@proposals.7/@attempts.65/@edit" start="2178" end="-120"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875441210" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with two management layers:   &quot; + String.valueOf((double) manager2.getTaskCount()/manager2.getResourceCount()) + &quot; tasks/resource&quot;);&#xA;&#x9;&#x9;System.out.println(&quot;Effectivity with three management layers: &quot; + String.valueOf((double) manager3.getTaskCount()/manager3.getResourceCount()) + &quot; tasks/resource" edit="/1/@proposals.0/@proposals.7/@attempts.66/@edit" start="2298" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875462159" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="level of management" edit="/1/@proposals.0/@proposals.7/@attempts.67/@edit" start="2118" end="-509"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489875478509" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="thir" edit="/1/@proposals.0/@proposals.7/@attempts.68/@edit" start="1943" end="-698"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489853029737" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489853083237" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489853891928" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854019961" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854224747" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854235490" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854250442" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854294674" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854367746" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854381526" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854394103" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854566411" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854596984" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854644867" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854656439" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854688841" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854703625" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854837229" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854862057" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854876793" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854878917" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854893889" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489854933797" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489855110416" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489873419472" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489873462466" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489873579100" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489873584473" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875007937" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875022385" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875098651" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875123017" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875217176" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875305926" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875317200" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875423395" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1489875442183" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489850530115" completion="0.0" errorCount="7">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testMiddleManagementResourceCounts</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
          <errorTests>testNoEmployeesConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489850563908" completion="0.0" errorCount="7">
          <errorTests>testDoCalculations</errorTests>
          <errorTests>testResourceCount</errorTests>
          <errorTests>testSeveralClerks</errorTests>
          <errorTests>testMiddleManagementResourceCounts</errorTests>
          <errorTests>testTaskCount</errorTests>
          <errorTests>testPrintDocuments</errorTests>
          <errorTests>testNoEmployeesConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489850619203" completion="0.7142857142857143" successCount="5" failureCount="2">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <failureTests>testMiddleManagementResourceCounts</failureTests>
          <failureTests>testTaskCount</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489852165611" completion="0.8571428571428571" successCount="6" failureCount="1">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <failureTests>testTaskCount</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489852187751" completion="0.8571428571428571" successCount="6" failureCount="1">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
          <failureTests>testTaskCount</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489852374171" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1489875506936" completion="1.0" successCount="7">
          <successTests>testDoCalculations</successTests>
          <successTests>testResourceCount</successTests>
          <successTests>testSeveralClerks</successTests>
          <successTests>testMiddleManagementResourceCounts</successTests>
          <successTests>testTaskCount</successTests>
          <successTests>testPrintDocuments</successTests>
          <successTests>testNoEmployeesConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
