<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490199501125" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490200776465" sizeMeasure="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;void stockPriceChanged(Stock object, double oldPrice, double newPrice);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490199249870" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490200768644" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;private ArrayList&lt;StockListener> listeners = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price){&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double price){&#xA;&#x9;&#x9;if(price > 0){&#xA;&#x9;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The price must be positive&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener observer){&#xA;&#x9;&#x9;this.listeners.add(observer);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener observer){&#xA;&#x9;&#x9;this.listeners.remove(observer);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="30" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490201540122" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double oldPrice = this.price;&#xA;&#x9;&#x9;if(price > 0){&#xA;&#x9;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The price must be positive&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;for (StockListener lister : listeners){&#xA;&#x9;&#x9;&#x9;lister.stockPriceChanged(this, oldPrice, price" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="330" end="-312"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490201603413" sizeMeasure="43">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The price must be positive&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.price = price;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="371" end="-404"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611459677" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public ArrayList&lt;StockListener> getListeners(){&#xA;&#x9;&#x9;return listeners" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="872" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611733239" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.price);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener observer){&#xA;&#x9;&#x9;this.listeners.add(observer);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener observer){&#xA;&#x9;&#x9;this.listeners.remove(observer);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public ArrayList&lt;StockListener> getListeners(){&#xA;&#x9;&#x9;return listeners;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return ticker" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="559" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490200825606" completion="0.5" successCount="1" failureCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testStockListener</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490201725056" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490530259842" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490610185890" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490610962956" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490199812887" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490200766522" sizeMeasure="41" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private double index = 0;&#xA;&#x9;ArrayList&lt;Stock> stocks = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock...stocks){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;for (int i = 0; i &lt; stocks.length; i++){&#xA;&#x9;&#x9;&#x9;this.stocks.add(stocks[i]);&#xA;&#x9;&#x9;&#x9;index += stocks[i].getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;this.stocks.add(stock);&#xA;&#x9;&#x9;index += stock.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;this.stocks.remove(stock);&#xA;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock object, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="476" charEnd="484" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="578" charEnd="586" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="35" charStart="671" charEnd="736" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="127" charEnd="131" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="373" charEnd="381" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490200951435" sizeMeasure="41" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index += oldPrice-newPrice;" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="741" end="-13"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="127" charEnd="131" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490201371458" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private double index = 0;&#xA;&#x9;private List&lt;Stock> stocks;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock...stocks){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.stocks = new ArrayList&lt;>();&#xA;&#x9;&#x9;if (stocks.length == 0){&#xA;&#x9;&#x9;&#x9;this.index = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; stocks.length; i++){&#xA;&#x9;&#x9;&#x9;&#x9;this.stocks.add(stocks[i]);&#xA;&#x9;&#x9;&#x9;&#x9;this.index += stocks[i].getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;if (!stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;this.stocks.add(stock);&#xA;&#x9;&#x9;&#x9;index += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;if(stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;this.stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;if (stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;index += oldPrice-newPrice;&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="58" end="-13"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="150" charEnd="154" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490451126179" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; oldPrice != newPrice" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="952" end="-50"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="150" charEnd="154" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490451152913" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="newPrice - old" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="991" end="-23"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="150" charEnd="154" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611316406" sizeMeasure="65" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StockIndex si = new StockIndex(&quot;hei&quot;);&#xA;&#x9;&#x9;Stock stock = new Stock(&quot;SE&quot;, 120);&#xA;&#x9;&#x9;Stock stock2 = new Stock(&quot;ER&quot;, 214);&#xA;&#x9;&#x9;Stock stock3 = new Stock(&quot;KR&quot;, 241);&#xA;&#x9;&#x9;si.addStock(stock3);&#xA;&#x9;&#x9;si.addStock(stock);&#xA;&#x9;&#x9;si.addStock(stock2);&#xA;&#x9;&#x9;System.out.println(si.getIndex());" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="1024" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="150" charEnd="154" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611353912" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;stock.setPrice(5235" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="1329" end="-49"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="150" charEnd="154" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611475218" sizeMeasure="68" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(stock2.getListeners" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="1390" end="-14"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="150" charEnd="154" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611562501" sizeMeasure="70" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;if(stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;this.stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;index -= stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="636" end="-674"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="150" charEnd="154" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611774894" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String toString(){&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StockIndex si = new StockIndex(&quot;hei&quot;);&#xA;&#x9;&#x9;Stock stock = new Stock(&quot;SE&quot;, 120);&#xA;&#x9;&#x9;Stock stock2 = new Stock(&quot;ER&quot;, 214);&#xA;&#x9;&#x9;Stock stock3 = new Stock(&quot;KR&quot;, 241);&#xA;&#x9;&#x9;si.addStock(stock3);&#xA;&#x9;&#x9;si.addStock(stock);&#xA;&#x9;&#x9;si.addStock(stock2);&#xA;&#x9;&#x9;System.out.println(si.getIndex());&#xA;&#x9;&#x9;stock.setPrice(5235);&#xA;&#x9;&#x9;System.out.println(si.getIndex());&#xA;&#x9;&#x9;System.out.println(stock2.getListeners());&#xA;&#x9;&#x9;System.out.println(" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="1101" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611786448" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="1551" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611820858" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(si.stocks" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="1551" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611859990" sizeMeasure="76" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;stock.addStockListener(this" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="495" end="-1102"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="497" charEnd="502" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490611874386" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s[i]" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="502" end="-1124"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490611314699" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490611357441" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490611499814" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490611565639" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490611590010" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490611785638" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490611823468" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490200778817" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490200953095" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490201378341" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490201547860" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490201734994" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490451076769" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490451130615" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490451154427" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490610192380" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490610970215" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490611575465" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490611878781" completion="1.0" successCount="4">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
