<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612608470" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface StockListener {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612678509" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612316924" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class Stock {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490612802579" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Stock {&#xA;&#x9;String ticker; double price;&#xA;&#x9;List&lt;StockListener> listeners = new ArrayList&lt;StockListener>();&#xA;&#x9;&#xA;&#x9;public Stock(String inTicker, double inPrice) {&#xA;&#x9;&#x9;ticker = inTicker; price = inPrice; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void setPrice(double newPrice){&#xA;&#x9;&#x9;price = newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;String getTicker(){&#xA;&#x9;&#x9;return ticker; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;double getPrice(){&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStockListener(StockListener newListener){&#xA;&#x9;&#x9;listeners.add(newListener);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStockListener(StockListener listener){&#xA;&#x9;&#x9;if(listeners.contains(listener)){&#xA;&#x9;&#x9;&#x9;listeners.remove(listeners.indexOf(listener));&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="30" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490613869537" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (StockListener s: listeners){&#xA;&#x9;&#x9;&#x9;s.stockPriceChanged(this, price, newPrice);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;price = newPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;String getTicker() { return ticker;}&#xA;&#x9;&#xA;&#x9;double getPrice() { return price; }&#xA;&#x9;&#xA;&#x9;void addStockListener(StockListener newListener){&#xA;&#x9;&#x9;if(! listeners.contains(newListener)){&#xA;&#x9;&#x9;&#x9;listeners.add(newListener);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="328" end="-153"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490616975742" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="764" end="-13"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490616222343" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490767652884" completion="1.0" successCount="2">
          <successTests>testStockListener</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490616376932" sizeMeasure="11">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490616979817" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class StockIndex implements StockListener {&#xA;&#x9;String name;&#xA;&#x9;double index;&#xA;&#x9;List&lt;Stock> stocks;&#xA;&#x9;&#xA;&#x9;public StockIndex(String inName, Stock...inStocks ) {&#xA;&#x9;&#x9;stocks = new ArrayList&lt;Stock>();&#xA;&#x9;&#x9;name = inName; &#xA;&#x9;&#x9;for (Stock s: inStocks){&#xA;&#x9;&#x9;&#x9;stocks.add(s);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStock(Stock newStock){&#xA;&#x9;&#x9;if(! stocks.contains(newStock)){&#xA;&#x9;&#x9;&#x9;stocks.add(newStock);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock delStock){&#xA;&#x9;&#x9;if(stocks.contains(stocks)){&#xA;&#x9;&#x9;&#x9;stocks.remove(delStock);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617273289" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.setIndex();&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStock(Stock newStock){&#xA;&#x9;&#x9;if(! stocks.contains(newStock)){&#xA;&#x9;&#x9;&#x9;stocks.add(newStock);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock delStock){&#xA;&#x9;&#x9;if(stocks.contains(stocks)){&#xA;&#x9;&#x9;&#x9;stocks.remove(delStock);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;double getIndex(){&#xA;&#x9;&#x9;return index;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;this.setIndex();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setIndex(){&#xA;&#x9;&#x9;double sumStocks = 0; &#xA;&#x9;&#x9;for (Stock s: stocks){&#xA;&#x9;&#x9;&#x9;sumStocks += s.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;double average = sumStocks/stocks.size();&#xA;&#x9;&#x9;index = average;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="344" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617408116" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="index = 0;" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="242" end="-668"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617436576" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="897" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617582261" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.index = sumStocks" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="853" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617614528" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="delStock" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="538" end="-339"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617694232" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.stocks = new ArrayList&lt;Stock>();&#xA;&#x9;&#x9;this." edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="255" end="-595"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617732078" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="stocks = new ArrayList&lt;Stock>();&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="255" end="-595"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490617983254" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.setIndex();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void removeStock(Stock delStock){&#xA;&#x9;&#x9;if(stocks.contains(delStock)){&#xA;&#x9;&#x9;&#x9;stocks.remove(delStock);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.setIndex();" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="478" end="-304"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490618142524" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double sumStocks = 0; &#xA;&#x9;&#x9;for (Stock s: stocks){&#xA;&#x9;&#x9;&#x9;if(s == stock){&#xA;&#x9;&#x9;&#x9;&#x9;sumStocks += newPrice;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;sumStocks += s.getPrice();&#xA;&#x9;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.index = sumStocks" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="759" end="-149"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490618473600" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;s.addStockListener(thi" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="353" end="-734"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490637297270" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="932" end="-178"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490617281762" completion="0.0" failureCount="4">
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
          <failureTests>testConstructor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490617408319" completion="0.0" failureCount="4">
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
          <failureTests>testConstructor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490617439187" completion="0.0" failureCount="4">
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
          <failureTests>testConstructor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490617587617" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490617619192" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490617695938" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490617732279" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490617889579" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructor</successTests>
          <failureTests>testRemoveStock</failureTests>
          <failureTests>testAddStock</failureTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490618013887" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490618019588" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490618144829" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490618336583" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490618440019" completion="0.75" successCount="3" failureCount="1">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testChangePrice</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490618593871" completion="1.0" successCount="4">
          <successTests>testRemoveStock</successTests>
          <successTests>testAddStock</successTests>
          <successTests>testChangePrice</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a" performedCount="23">
        <attempts timestamp="1490617764102"/>
        <attempts timestamp="1490617764102"/>
        <attempts timestamp="1490617801733"/>
        <attempts timestamp="1490617895176"/>
        <attempts timestamp="1490617895176"/>
        <attempts timestamp="1490617908194"/>
        <attempts timestamp="1490617908194"/>
        <attempts timestamp="1490617909047"/>
        <attempts timestamp="1490617983477"/>
        <attempts timestamp="1490617991474"/>
        <attempts timestamp="1490618278347"/>
        <attempts timestamp="1490618308980"/>
        <attempts timestamp="1490618311551"/>
        <attempts timestamp="1490618314136"/>
        <attempts timestamp="1490618316199"/>
        <attempts timestamp="1490618316884"/>
        <attempts timestamp="1490618347017"/>
        <attempts timestamp="1490618349336"/>
        <attempts timestamp="1490618354883"/>
        <attempts timestamp="1490618382164"/>
        <attempts timestamp="1490618382936"/>
        <attempts timestamp="1490618489029"/>
        <attempts timestamp="1490618503538"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a" performedCount="38">
        <attempts timestamp="1490618349332"/>
        <attempts timestamp="1490618349972"/>
        <attempts timestamp="1490618350810"/>
        <attempts timestamp="1490618351547"/>
        <attempts timestamp="1490618352722"/>
        <attempts timestamp="1490618353292"/>
        <attempts timestamp="1490618354386"/>
        <attempts timestamp="1490618354882"/>
        <attempts timestamp="1490618356752"/>
        <attempts timestamp="1490618357211"/>
        <attempts timestamp="1490618357669"/>
        <attempts timestamp="1490618392536"/>
        <attempts timestamp="1490618394216"/>
        <attempts timestamp="1490618394895"/>
        <attempts timestamp="1490618396132"/>
        <attempts timestamp="1490618396587"/>
        <attempts timestamp="1490618397431"/>
        <attempts timestamp="1490618397856"/>
        <attempts timestamp="1490618398261"/>
        <attempts timestamp="1490618398941"/>
        <attempts timestamp="1490618399463"/>
        <attempts timestamp="1490618410195"/>
        <attempts timestamp="1490618410568"/>
        <attempts timestamp="1490618410870"/>
        <attempts timestamp="1490618411421"/>
        <attempts timestamp="1490618411871"/>
        <attempts timestamp="1490618412540"/>
        <attempts timestamp="1490618413137"/>
        <attempts timestamp="1490618413617"/>
        <attempts timestamp="1490618414447"/>
        <attempts timestamp="1490618415073"/>
        <attempts timestamp="1490618415508"/>
        <attempts timestamp="1490618415989"/>
        <attempts timestamp="1490618416510"/>
        <attempts timestamp="1490618417054"/>
        <attempts timestamp="1490618417501"/>
        <attempts timestamp="1490618417981"/>
        <attempts timestamp="1490618419150"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a" performedCount="95">
        <attempts timestamp="1490617801728"/>
        <attempts timestamp="1490617809616"/>
        <attempts timestamp="1490617816736"/>
        <attempts timestamp="1490617819927"/>
        <attempts timestamp="1490617821237"/>
        <attempts timestamp="1490617823077"/>
        <attempts timestamp="1490617825360"/>
        <attempts timestamp="1490617826106"/>
        <attempts timestamp="1490617860958"/>
        <attempts timestamp="1490617862200"/>
        <attempts timestamp="1490617866165"/>
        <attempts timestamp="1490617867592"/>
        <attempts timestamp="1490617868044"/>
        <attempts timestamp="1490617868613"/>
        <attempts timestamp="1490617869726"/>
        <attempts timestamp="1490617871742"/>
        <attempts timestamp="1490617872814"/>
        <attempts timestamp="1490617873640"/>
        <attempts timestamp="1490617874078"/>
        <attempts timestamp="1490617874463"/>
        <attempts timestamp="1490617874799"/>
        <attempts timestamp="1490617875291"/>
        <attempts timestamp="1490617875655"/>
        <attempts timestamp="1490617875991"/>
        <attempts timestamp="1490617876353"/>
        <attempts timestamp="1490617876833"/>
        <attempts timestamp="1490617877887"/>
        <attempts timestamp="1490617878473"/>
        <attempts timestamp="1490617879026"/>
        <attempts timestamp="1490617879626"/>
        <attempts timestamp="1490617880075"/>
        <attempts timestamp="1490617880456"/>
        <attempts timestamp="1490617898640"/>
        <attempts timestamp="1490617899168"/>
        <attempts timestamp="1490617909045"/>
        <attempts timestamp="1490617910381"/>
        <attempts timestamp="1490617911982"/>
        <attempts timestamp="1490617919863"/>
        <attempts timestamp="1490617924165"/>
        <attempts timestamp="1490617925940"/>
        <attempts timestamp="1490617927074"/>
        <attempts timestamp="1490617951428"/>
        <attempts timestamp="1490617953007"/>
        <attempts timestamp="1490617955405"/>
        <attempts timestamp="1490617957374"/>
        <attempts timestamp="1490618361145"/>
        <attempts timestamp="1490618363091"/>
        <attempts timestamp="1490618365981"/>
        <attempts timestamp="1490618366633"/>
        <attempts timestamp="1490618367018"/>
        <attempts timestamp="1490618367605"/>
        <attempts timestamp="1490618368340"/>
        <attempts timestamp="1490618368727"/>
        <attempts timestamp="1490618370932"/>
        <attempts timestamp="1490618371298"/>
        <attempts timestamp="1490618371963"/>
        <attempts timestamp="1490618372360"/>
        <attempts timestamp="1490618376558"/>
        <attempts timestamp="1490618376956"/>
        <attempts timestamp="1490618377584"/>
        <attempts timestamp="1490618377919"/>
        <attempts timestamp="1490618378191"/>
        <attempts timestamp="1490618378391"/>
        <attempts timestamp="1490618380409"/>
        <attempts timestamp="1490618381276"/>
        <attempts timestamp="1490618382162"/>
        <attempts timestamp="1490618382934"/>
        <attempts timestamp="1490618383333"/>
        <attempts timestamp="1490618383743"/>
        <attempts timestamp="1490618387916"/>
        <attempts timestamp="1490618388633"/>
        <attempts timestamp="1490618389142"/>
        <attempts timestamp="1490618389653"/>
        <attempts timestamp="1490618400229"/>
        <attempts timestamp="1490618400669"/>
        <attempts timestamp="1490618401013"/>
        <attempts timestamp="1490618401341"/>
        <attempts timestamp="1490618401855"/>
        <attempts timestamp="1490618402362"/>
        <attempts timestamp="1490618403182"/>
        <attempts timestamp="1490618403673"/>
        <attempts timestamp="1490618404203"/>
        <attempts timestamp="1490618404782"/>
        <attempts timestamp="1490618405303"/>
        <attempts timestamp="1490618405804"/>
        <attempts timestamp="1490618406303"/>
        <attempts timestamp="1490618406768"/>
        <attempts timestamp="1490618407215"/>
        <attempts timestamp="1490618407605"/>
        <attempts timestamp="1490618408672"/>
        <attempts timestamp="1490618409007"/>
        <attempts timestamp="1490618409270"/>
        <attempts timestamp="1490618409516"/>
        <attempts timestamp="1490618409753"/>
        <attempts timestamp="1490618409979"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a" performedCount="6">
        <attempts timestamp="1490617771184"/>
        <attempts timestamp="1490617850966"/>
        <attempts timestamp="1490617932549"/>
        <attempts timestamp="1490618544080"/>
        <attempts timestamp="1490618566689"/>
        <attempts timestamp="1490618578770"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
