<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Employee">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Employee Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Employee"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Clerk Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Clerk class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Clerk"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Clerk JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ClerkTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Printer Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Printer class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Printer"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Printer JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.PrinterTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Manager Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Manager class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.office.Manager"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Manager JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.office.ManagerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.office.*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490621709080" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public interface Employee {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490622433526" sizeMeasure="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#xA;&#x9;&#x9;double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2);&#xA;&#x9;&#x9;void printDocument(String document);&#xA;&#x9;&#x9;int getTaskCount();&#xA;&#x9;&#x9;int getResourceCount();" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="37" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694355098" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;List&lt;String> history = new ArrayList&lt;String>();" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="54" end="-181"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694574214" sizeMeasure="14" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="162" end="-181"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694578049" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="54" end="-181"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694618521" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public interface Employee {&#xA;&#x9;&#x9;&#xA;&#xA;&#x9;&#x9;List&lt;String> history = null;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="54" end="-180"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694730299" sizeMeasure="12" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="134" end="-180"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694752491" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;String> history = null;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="137" end="-180"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694779056" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;List&lt;String> getHistory" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="342" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490621644060" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Clerk {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490622432666" sizeMeasure="33" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void printDocument(String document) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490693499894" sizeMeasure="39" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private Printer printer;&#xA;&#x9;private Manager sjef;&#xA;&#x9;private int taskCounter;&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCounter;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> operation, double value1, double value2) {&#xA;&#x9;&#x9;double svar = 0;&#xA;&#x9;&#x9;svar = operation.apply(value1, value2);&#xA;&#x9;&#x9;taskCounter++;&#xA;&#x9;&#x9;return svar;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public&#xA;&#x9;void printDocument(String document) {&#xA;&#x9;&#x9;printer.printDocument(document, this);&#xA;&#x9;&#x9;taskCounter++;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="120" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694572317" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Clerk implements Employee{&#xA;&#x9;&#xA;&#x9;private Printer printer;&#xA;&#x9;private Manager sjef;&#xA;&#x9;private int taskCounter;&#xA;&#x9;private List&lt;String> history = new ArrayList&lt;String>();&#xA;&#xA;&#x9;public Clerk(Printer printer) {&#xA;&#x9;&#x9;this.printer = printer;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;return taskCounter;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getHistory() {&#xA;&#x9;&#x9;return this.history" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="54" end="-336"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694783484" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="869" end="-870"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720763168" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="869" end="-870"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490693514021" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490694830144" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490700122814" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720666224" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490621738630" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Printer {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490622431497" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collection;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#xA;&#x9;public Collection&lt;String> getPrintHistory(Clerk clerk) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;void printDocument(String document, Employee employee) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return null;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490693397910" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;List&lt;String> history = new ArrayList&lt;String>();&#xA;&#x9;&#xA;&#x9;void printDocument(String document, Employee employee) {&#xA;&#x9;System.out.println(document);&#xA;&#x9;history.add(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return history" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="54" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694349989" sizeMeasure="19" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;&#xA;public class Printer {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;void printDocument(String document, Employee employee) {&#xA;&#x9;System.out.println(document);&#xA;&#x9;Employee.history.add(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return Employee." edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="54" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694700906" sizeMeasure="19" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employee.history.add(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return e" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="178" end="-27"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694719389" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee.history.add(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return E" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="178" end="-27"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490694814518" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employee.getHistory().add(document);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public List&lt;String> getPrintHistory(Employee employee) {&#xA;&#x9;&#x9;return employee.getHistory()" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="178" end="-12"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490693544762" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490694356071" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490694703338" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490694721035" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490694816779" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490700128624" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720675839" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490621749019" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation.office;&#xA;&#xA;public class Manager {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490622441402" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager {&#xA;&#xA;&#x9;public Manager(List&lt;Employee> _asList) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.0/@edit" start="37" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490695258702" sizeMeasure="40" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager {&#xA;&#x9;&#xA;&#x9;Collection&lt;Employee> employees = new ArrayList&lt;>();&#xA;&#xA;&#x9;public Manager (Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Listen er tom og det oppstod derfor en feil&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.1/@edit" start="54" end="-403"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490695812851" sizeMeasure="38" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.employees.size();&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;return employees. .doCalculations" edit="/1/@proposals.0/@proposals.7/@attempts.2/@edit" start="491" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490696078440" sizeMeasure="40" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int sum  = 1;&#xA;&#x9;&#x9;sum += this.employees.size();&#xA;&#x9;&#x9;return sum" edit="/1/@proposals.0/@proposals.7/@attempts.3/@edit" start="491" end="-305"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490697635483" sizeMeasure="48" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Iterator;&#xA;import java.util.List;&#xA;import java.util.Random;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager {&#xA;&#x9;&#xA;&#x9;Object[] employees;&#xA;&#xA;&#x9;public Manager (Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employees = employees.toArray();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Listen er tom og det oppstod derfor en feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int sum  = 1;&#xA;&#x9;&#x9;sum += this.employees.length;&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;for (Object ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (instance)&#xA;&#x9;&#x9;&#x9;sum += ansatt.getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;if (hei.hasNext()) {&#xA;&#x9;&#x9;&#x9;hei.next().printDocument(string);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.7/@attempts.4/@edit" start="111" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490697876110" sizeMeasure="49" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;int teller = 0;&#xA;&#x9;int max;&#xA;&#xA;&#x9;public Manager (Collection&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employees = employees.toArray();&#xA;&#x9;&#x9;&#x9;max = this.employees.length;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Listen er tom og det oppstod derfor en feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int sum  = 1;&#xA;&#x9;&#x9;sum += this.employees.length;&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;for (Object ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Clerk)&#xA;&#x9;&#x9;&#x9;sum += ((Clerk) ansatt).getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;&#x9;((Employee) employees[teller]).printDocument(string);" edit="/1/@proposals.0/@proposals.7/@attempts.5/@edit" start="258" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490697911216" sizeMeasure="49" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee" edit="/1/@proposals.0/@proposals.7/@attempts.6/@edit" start="768" end="-259"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698101335" sizeMeasure="54" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" - 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Listen er tom og det oppstod derfor en feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int sum  = 1;&#xA;&#x9;&#x9;sum += this.employees.length;&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;for (Object ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Clerk)&#xA;&#x9;&#x9;&#x9;sum += ((Clerk) ansatt).getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;&#x9;((Clerk) employees[teller]).printDocument(string);&#xA;&#x9;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;if (teller >= max) {&#xA;&#x9;&#x9;&#x9;teller = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return ((Clerk) employees[teller]).doCalculations(_function, d, e);" edit="/1/@proposals.0/@proposals.7/@attempts.7/@edit" start="438" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698291331" sizeMeasure="54" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List" edit="/1/@proposals.0/@proposals.7/@attempts.8/@edit" start="303" end="-847"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698784065" sizeMeasure="54" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Employee> employees;&#xA;&#x9;int teller = 0;&#xA;&#x9;int max;&#xA;&#xA;&#x9;public Manager(List&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;&#x9;max = this.employees.size() - 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Listen er tom og det oppstod derfor en feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int sum  = 1;&#xA;&#x9;&#x9;sum += this.employees.size();&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;for (Object ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Clerk)&#xA;&#x9;&#x9;&#x9;sum += ((Clerk) ansatt).getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;&#x9;((Clerk) employees.toArray()[teller]).printDocument(string);&#xA;&#x9;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;if (teller >= max) {&#xA;&#x9;&#x9;&#x9;teller = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return ((Clerk) employees.toArray()" edit="/1/@proposals.0/@proposals.7/@attempts.9/@edit" start="238" end="-50"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698813679" sizeMeasure="54" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collection" edit="/1/@proposals.0/@proposals.7/@attempts.10/@edit" start="308" end="-857"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490698995723" sizeMeasure="54" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List" edit="/1/@proposals.0/@proposals.7/@attempts.11/@edit" start="308" end="-857"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490699569295" sizeMeasure="59" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#x9;&#xA;&#x9;List&lt;Employee> employees;&#xA;&#x9;int teller = 0;&#xA;&#x9;int max;&#xA;&#xA;&#x9;public Manager(List&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;&#x9;max = this.employees.size() - 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Listen er tom og det oppstod derfor en feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int sum  = 1;&#xA;&#x9;&#x9;sum += this.employees.size();&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;for (Object ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Clerk)&#xA;&#x9;&#x9;&#x9;sum += ((Clerk) ansatt).getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;&#x9;((Clerk) employees.toArray()[teller]).printDocument(string);&#xA;&#x9;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;if (teller >= max) {&#xA;&#x9;&#x9;&#x9;teller = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return ((Clerk) employees.toArray()[teller]).doCalculations(_function, d, e);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public List&lt;String> getHistory() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null" edit="/1/@proposals.0/@proposals.7/@attempts.12/@edit" start="161" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490699671942" sizeMeasure="64" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Employee ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Manager) {&#xA;&#x9;&#x9;&#x9;&#x9;sum += ansatt.getResourceCount();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.7/@attempts.13/@edit" start="615" end="-654"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490699735868" sizeMeasure="65" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Employee ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Manager) {&#xA;&#x9;&#x9;&#x9;&#x9;sum += ansatt.getResourceCount();&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;sum += this.employees.size" edit="/1/@proposals.0/@proposals.7/@attempts.14/@edit" start="583" end="-666"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490699882062" sizeMeasure="63" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.7/@attempts.15/@edit" start="697" end="-666"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490699896101" sizeMeasure="64" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="sum += this.employees.size();&#xA;&#x9;&#x9;for (Employee ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Manager) {&#xA;&#x9;&#x9;&#x9;&#x9;sum += ansatt.getResourceCount" edit="/1/@proposals.0/@proposals.7/@attempts.16/@edit" start="583" end="-666"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490699918316" sizeMeasure="64" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.7/@attempts.17/@edit" start="578" end="-808"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490699937749" sizeMeasure="64" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.7/@attempts.18/@edit" start="578" end="-808"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700075382" sizeMeasure="64" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="employees.size" edit="/1/@proposals.0/@proposals.7/@attempts.19/@edit" start="705" end="-666"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490700101748" sizeMeasure="64" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="((Manager)ansatt)" edit="/1/@proposals.0/@proposals.7/@attempts.20/@edit" start="698" end="-681"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490703063303" sizeMeasure="64" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.7/@attempts.21/@edit" start="733" end="-663"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490712553848" sizeMeasure="76" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lang.reflect.Array;&#xA;import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Collection;&#xA;import java.util.Iterator;&#xA;import java.util.List;&#xA;import java.util.function.BinaryOperator;&#xA;&#xA;public class Manager implements Employee{&#xA;&#x9;&#xA;&#x9;List&lt;Employee> employees;&#xA;&#x9;int teller = 0;&#xA;&#x9;int max;&#xA;&#xA;&#x9;public Manager(List&lt;Employee> employees) {&#xA;&#x9;&#x9;if (!employees.isEmpty()) {&#xA;&#x9;&#x9;&#x9;this.employees = employees;&#xA;&#x9;&#x9;&#x9;max = this.employees.size() - 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Listen er tom og det oppstod derfor en feil&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getResourceCount() {&#xA;&#x9;&#x9;int sum  = 1;&#xA;&#x9;&#x9;sum += this.employees.size();&#xA;&#x9;&#x9;for (Employee ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Manager) {&#xA;&#x9;&#x9;&#x9;&#x9;sum += ((Manager)ansatt).employees.size(); &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public int getTaskCount() {&#xA;&#x9;&#x9;int sum = 0;&#xA;&#x9;&#x9;for (Object ansatt : employees) {&#xA;&#x9;&#x9;&#x9;if (ansatt instanceof Clerk)&#xA;&#x9;&#x9;&#x9;sum += ((Clerk) ansatt).getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;&#x9;((Clerk) employees.toArray()[teller]).printDocument(string);&#xA;&#x9;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;if (teller >= max) {&#xA;&#x9;&#x9;&#x9;teller = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return ((Clerk) employees.toArray()[teller]).doCalculations(_function, d, e);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public List&lt;String> getHistory() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer printer = new Printer();&#xA;&#x9;&#x9;Clerk clerk1 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk2 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk3 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk4 = new Clerk(printer);&#xA;&#x9;&#x9;List&lt;Employee> heisann = Arrays.asList(clerk1, clerk2,clerk3,clerk4);&#xA;&#x9;&#x9;Manager manager1 = new Manager(heisann);&#xA;&#x9;&#x9;System.out.println(manager1.getResourceCount() + &quot; &quot; + manager1.getTaskCount())" edit="/1/@proposals.0/@proposals.7/@attempts.22/@edit" start="49" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720515059" sizeMeasure="86" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer printer = new Printer();&#xA;&#x9;&#x9;Clerk clerk1 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk2 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk3 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk4 = new Clerk(printer);&#xA;&#x9;&#x9;List&lt;Employee> asdasd1 = Arrays.asList(clerk1, clerk2,clerk3,clerk4);&#xA;&#x9;&#x9;Manager manager1 = new Manager(asdasd1);&#xA;&#x9;&#x9;Clerk clerk5 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk6 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk7 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk8 = new Clerk(printer);&#xA;&#x9;&#x9;List&lt;Employee> asdasd2 = Arrays.asList(clerk5, clerk6,clerk7,clerk8);&#xA;&#x9;&#x9;Manager manager2 = new Manager(asdasd2);&#xA;&#x9;&#x9;System.out.println(manager1.getResourceCount() + &quot; &quot; + manager1.getTaskCount());&#xA;&#x9;&#x9;System.out.println(manager2.getResourceCount() + &quot; &quot; + manager2.getTaskCount());&#xA;&#x9;&#x9;Manager managerTOP = new Manager(Arrays.asList(manager1, manager2));&#xA;&#x9;&#x9;System.out.println(managerTOP.getResourceCount() + &quot; &quot; + managerTOP" edit="/1/@proposals.0/@proposals.7/@attempts.23/@edit" start="1451" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720638043" sizeMeasure="94" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="manager1.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager1.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager1.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager1.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;Hei&quot;" edit="/1/@proposals.0/@proposals.7/@attempts.24/@edit" start="2294" end="-97"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720936879" sizeMeasure="94" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="clerk1" edit="/1/@proposals.0/@proposals.7/@attempts.25/@edit" start="2615" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490724480251" sizeMeasure="94" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Employee) ansatt).getTaskCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return sum;&#xA;&#x9;}&#xA;&#xA;&#x9;public void printDocument(String string) {&#xA;&#x9;&#x9;&#x9;((Employee) employees.toArray()[teller]).printDocument(string);&#xA;&#x9;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double doCalculations(BinaryOperator&lt;Double> _function, double d, double e) {&#xA;&#x9;&#x9;teller++;&#xA;&#x9;&#x9;if (teller >= max) {&#xA;&#x9;&#x9;&#x9;teller = 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return ((Employee) employees.toArray()[teller]).doCalculations(_function, d, e);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public List&lt;String> getHistory() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Printer printer = new Printer();&#xA;&#x9;&#x9;Clerk clerk1 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk2 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk3 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk4 = new Clerk(printer);&#xA;&#x9;&#x9;List&lt;Employee> asdasd1 = Arrays.asList(clerk1, clerk2,clerk3,clerk4);&#xA;&#x9;&#x9;Manager manager1 = new Manager(asdasd1);&#xA;&#x9;&#x9;Clerk clerk5 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk6 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk7 = new Clerk(printer);&#xA;&#x9;&#x9;Clerk clerk8 = new Clerk(printer);&#xA;&#x9;&#x9;List&lt;Employee> asdasd2 = Arrays.asList(clerk5, clerk6,clerk7,clerk8);&#xA;&#x9;&#x9;Manager manager2 = new Manager(asdasd2);&#xA;&#x9;&#x9;System.out.println(manager1.getResourceCount() + &quot; &quot; + manager1.getTaskCount());&#xA;&#x9;&#x9;System.out.println(manager2.getResourceCount() + &quot; &quot; + manager2.getTaskCount());&#xA;&#x9;&#x9;Manager managerTOP = new Manager(Arrays.asList(manager1, manager2));&#xA;&#x9;&#x9;manager1.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager1.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager1.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager1.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;manager2.printDocument(&quot;Hei&quot;);&#xA;&#x9;&#x9;System.out.println(managerTOP.getResourceCount() + &quot; &quot; + managerTOP" edit="/1/@proposals.0/@proposals.7/@attempts.26/@edit" start="943" end="-25"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490712552256" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490720518018" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490720640207" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490720914428" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490720939275" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490727405686" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490695260055" completion="0.14285714285714285" successCount="1" failureCount="4" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490695815089" completion="0.14285714285714285" successCount="1" failureCount="3" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490696081154" completion="0.2857142857142857" successCount="2" failureCount="2" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490697882482" completion="0.42857142857142855" successCount="3" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490697917266" completion="0.42857142857142855" successCount="3" errorCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490698103791" completion="0.8571428571428571" successCount="6" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490698293516" completion="0.8571428571428571" successCount="6" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490698785142" completion="0.8571428571428571" successCount="6" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490698814893" completion="0.0" errorCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490698997194" completion="0.8571428571428571" successCount="6" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490699570685" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490699674493" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490699745233" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490699884735" completion="0.5714285714285714" successCount="4" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490699899089" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490699919369" completion="0.5714285714285714" successCount="4" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490699938765" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490700115798" completion="1.0" successCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720671625" completion="1.0" successCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490724486642" completion="1.0" successCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490726515692" completion="1.0" successCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490726520881" completion="1.0" successCount="7"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490727398197" completion="1.0" successCount="7"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
