<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Logger">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the ILogger Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.ILogger"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Implementations">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StreamLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StreamLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StreamLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.StreamLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the FilteringLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the FilteringLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the FilteringLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.FilteringLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the DistributingLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DistributingLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DistributingLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.DistributingLoggerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.*Logger" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1489401822538" sizeMeasure="7">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public interface ILogger {&#xA;&#x9;public String ERROR = &quot;error&quot;, WARNING = &quot;warning&quot;, INFO = &quot;info&quot;;&#xA;&#xA;&#x9;public void log(String severity, String message, Exception exception);&#xA;}&#xA;"/>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490452759770" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class StreamLogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490455073880" sizeMeasure="22" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.io.OutputStream;&#xA;&#xA;public class StreamLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private OutputStream stream;&#xA;&#x9;&#xA;&#x9;public StreamLogger(OutputStream stream){&#xA;&#x9;&#x9;this.stream=stream;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;stream.&#xA;&#x9;&#x9;stream.flush();&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="30" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="359" charEnd="365" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490458403557" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.io.OutputStreamWriter;&#xA;import java.io.PrintWriter;&#xA;import java.io.Writer;&#xA;&#xA;public class StreamLogger implements ILogger {&#xA;&#xA;&#x9;private OutputStream stream;&#xA;&#x9;private Writer writer = new OutputStreamWriter(stream);&#xA;&#x9;private PrintWriter printWriter = new PrintWriter(writer);&#xA;&#x9;private String formatString = &quot;%s: %s (%s)&quot;;&#xA;&#xA;&#x9;public StreamLogger(OutputStream stream) {&#xA;&#x9;&#x9;this.stream = stream;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFormatString(String formatString) {&#xA;&#x9;&#x9;this.formatString = formatString;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;printWriter.format(formatString, severity, message, exception);&#xA;&#x9;&#x9;printWriter.flush();&#xA;&#xA;&#x9;}&#xA;" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="59" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490462412358" sizeMeasure="34" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;private PrintWriter printWriter;&#xA;&#x9;private String formatString;&#xA;&#xA;&#x9;public StreamLogger(OutputStream stream) {&#xA;&#x9;&#x9;this.stream = stream;&#xA;&#x9;&#x9;writer = new OutputStreamWriter(stream);&#xA;&#x9;&#x9;printWriter = new PrintWriter(writer);&#xA;&#x9;&#x9;formatString = &quot;%s: %s (%s)&quot;" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="246" end="-316"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="225" charEnd="231" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490458515880" completion="0.0" errorCount="3">
          <errorTests>testLog</errorTests>
          <errorTests>testLogException</errorTests>
          <errorTests>testLogWithFormat</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490458640431" completion="0.0" errorCount="3">
          <errorTests>testLog</errorTests>
          <errorTests>testLogException</errorTests>
          <errorTests>testLogWithFormat</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490461836504" completion="0.0" errorCount="3">
          <errorTests>testLog</errorTests>
          <errorTests>testLogException</errorTests>
          <errorTests>testLogWithFormat</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490462746156" completion="1.0" successCount="3">
          <successTests>testLog</successTests>
          <successTests>testLogException</successTests>
          <successTests>testLogWithFormat</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490452749541" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class FilteringLogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490463758499" sizeMeasure="46" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements ILogger {&#xA;&#xA;&#x9;private ILogger logger;&#xA;&#x9;private boolean ERROR = false;&#xA;&#x9;private boolean WARNING = false;&#xA;&#x9;private boolean INFO = false;&#xA;&#xA;&#x9;public FilteringLogger(ILogger logger, String severities) {&#xA;&#x9;&#x9;if (severities == &quot;ILogger.ERROR&quot;) {&#xA;&#x9;&#x9;&#x9;ERROR = true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severities == &quot;ILogger.WARNING&quot;) {&#xA;&#x9;&#x9;&#x9;WARNING = true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severities == &quot;ILogger.INFO&quot;) {&#xA;&#x9;&#x9;&#x9;INFO = true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.logger = logger;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isLogging(String severity) {&#xA;&#x9;&#x9;if (severity == &quot;ILogger.ERROR&quot;) {&#xA;&#x9;&#x9;&#x9;return ERROR;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;ILogger.WARNING&quot;) {&#xA;&#x9;&#x9;&#x9;return WARNING;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;ILogger.INFO&quot;) {&#xA;&#x9;&#x9;&#x9;return INFO;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setIsLogging(String severity, boolean value) {&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.0/@edit" start="59" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="102" charEnd="108" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490463827073" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if (severity == &quot;ILogger.ERROR&quot;) {&#xA;&#x9;&#x9;&#x9;ERROR = value;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;ILogger.WARNING&quot;) {&#xA;&#x9;&#x9;&#x9;WARNING = value;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;ILogger.INFO&quot;) {&#xA;&#x9;&#x9;&#x9;INFO = value;&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.1/@edit" start="776" end="-134"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="102" charEnd="108" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490464122769" sizeMeasure="56" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if (severity == &quot;ILogger.ERROR&quot; || severity == &quot;ILogger.WARNING&quot; || severity == &quot;ILogger.INFO&quot;) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.2/@edit" start="1080" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="102" charEnd="108" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490464393699" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean log = false;&#xA;&#x9;&#x9;if ((severity == &quot;ILogger.ERROR&quot; &amp;&amp; ERROR == true) || (severity == &quot;ILogger.WARNING&quot; &amp;&amp; WARNING == true)&#xA;&#x9;&#x9;&#x9;&#x9;|| (severity == &quot;ILogger.INFO&quot; &amp;&amp; INFO == true)) {&#xA;&#x9;&#x9;&#x9;log = true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (log == true) {&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);" edit="/1/@proposals.1/@proposals.3/@attempts.3/@edit" start="1082" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490476708485" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="... severities) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; severities.length; i++) {&#xA;&#x9;&#x9;&#x9;if (severities[i] == &quot;ILogger.ERROR&quot;) {&#xA;&#x9;&#x9;&#x9;&#x9;ERROR = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (severities[i] == &quot;ILogger.WARNING&quot;) {&#xA;&#x9;&#x9;&#x9;&#x9;WARNING = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (severities[i] == &quot;ILogger.INFO&quot;) {&#xA;&#x9;&#x9;&#x9;&#x9;INFO = true;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.4/@edit" start="250" end="-919"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490477610487" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;System.out.println(ILogger.ERROR);" edit="/1/@proposals.1/@proposals.3/@attempts.5/@edit" start="1430" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490477630272" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="WARNING" edit="/1/@proposals.1/@proposals.3/@attempts.6/@edit" start="1502" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490478021579" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="error = false;&#xA;&#x9;private boolean warning = false;&#xA;&#x9;private boolean info = false;&#xA;&#xA;&#x9;public FilteringLogger(ILogger logger, String... severities) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; severities.length; i++) {&#xA;&#x9;&#x9;&#x9;if (severities[i] == &quot;error&quot;) {&#xA;&#x9;&#x9;&#x9;&#x9;error = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (severities[i] == &quot;warning&quot;) {&#xA;&#x9;&#x9;&#x9;&#x9;warning = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (severities[i] == &quot;info&quot;) {&#xA;&#x9;&#x9;&#x9;&#x9;info = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.logger = logger;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean isLogging(String severity) {&#xA;&#x9;&#x9;if (severity == &quot;error&quot;) {&#xA;&#x9;&#x9;&#x9;return error;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;warning&quot;) {&#xA;&#x9;&#x9;&#x9;return warning;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;info&quot;) {&#xA;&#x9;&#x9;&#x9;return info;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setIsLogging(String severity, boolean value) {&#xA;&#x9;&#x9;if (severity == &quot;error&quot;) {&#xA;&#x9;&#x9;&#x9;error = value;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;warning&quot;) {&#xA;&#x9;&#x9;&#x9;warning = value;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;info&quot;) {&#xA;&#x9;&#x9;&#x9;info = value;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;boolean log = false;&#xA;&#x9;&#x9;if ((severity == &quot;error&quot; &amp;&amp; error == true) || (severity == &quot;warning&quot; &amp;&amp; warning == true)&#xA;&#x9;&#x9;&#x9;&#x9;|| (severity == &quot;info&quot; &amp;&amp; info == true)) {&#xA;&#x9;&#x9;&#x9;log = true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (log == true) {&#xA;&#x9;&#x9;&#x9;logger.log(severity, message, exception);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) " edit="/1/@proposals.1/@proposals.3/@attempts.7/@edit" start="123" end="-48"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490477612055" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490477615204" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490477616023" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490477616641" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490477617282" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490477617487" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490477630210" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490464406465" completion="0.2" successCount="1" failureCount="2" errorCount="2">
          <successTests>testInfoToErrorLogger</successTests>
          <failureTests>testFilteringLoggerWarningSetIsLoggingError</failureTests>
          <failureTests>testErrorLogging</failureTests>
          <errorTests>testFilteringLoggerErrorAndInfo</errorTests>
          <errorTests>testFilteringLoggerNoSeverities</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490475315865" completion="0.2" successCount="1" failureCount="2" errorCount="2">
          <successTests>testInfoToErrorLogger</successTests>
          <failureTests>testFilteringLoggerWarningSetIsLoggingError</failureTests>
          <failureTests>testErrorLogging</failureTests>
          <errorTests>testFilteringLoggerErrorAndInfo</errorTests>
          <errorTests>testFilteringLoggerNoSeverities</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490476772661" completion="0.4" successCount="2" failureCount="3">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <failureTests>testFilteringLoggerErrorAndInfo</failureTests>
          <failureTests>testFilteringLoggerWarningSetIsLoggingError</failureTests>
          <failureTests>testErrorLogging</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490477078170" completion="0.4" successCount="2" failureCount="3">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <failureTests>testFilteringLoggerErrorAndInfo</failureTests>
          <failureTests>testFilteringLoggerWarningSetIsLoggingError</failureTests>
          <failureTests>testErrorLogging</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490477451449" completion="0.4" successCount="2" failureCount="3">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <failureTests>testFilteringLoggerErrorAndInfo</failureTests>
          <failureTests>testFilteringLoggerWarningSetIsLoggingError</failureTests>
          <failureTests>testErrorLogging</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490477462130" completion="0.4" successCount="2" failureCount="3">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <failureTests>testFilteringLoggerErrorAndInfo</failureTests>
          <failureTests>testFilteringLoggerWarningSetIsLoggingError</failureTests>
          <failureTests>testErrorLogging</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490477486296" completion="0.4" successCount="2" failureCount="3">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <failureTests>testFilteringLoggerErrorAndInfo</failureTests>
          <failureTests>testFilteringLoggerWarningSetIsLoggingError</failureTests>
          <failureTests>testErrorLogging</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490477496332" completion="1.0" successCount="1">
          <successTests>testInfoToErrorLogger</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490478025794" completion="1.0" successCount="5">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerErrorAndInfo</successTests>
          <successTests>testFilteringLoggerWarningSetIsLoggingError</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <successTests>testErrorLogging</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490478041604" completion="1.0" successCount="5">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerErrorAndInfo</successTests>
          <successTests>testFilteringLoggerWarningSetIsLoggingError</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <successTests>testErrorLogging</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490478904147" completion="1.0" successCount="5">
          <successTests>testInfoToErrorLogger</successTests>
          <successTests>testFilteringLoggerErrorAndInfo</successTests>
          <successTests>testFilteringLoggerWarningSetIsLoggingError</successTests>
          <successTests>testFilteringLoggerNoSeverities</successTests>
          <successTests>testErrorLogging</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.6/@q" answer="/0/@parts.1/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490452730799" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class DistributingLogger {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490478476183" sizeMeasure="15" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private ILogger errorLogger;&#xA;&#x9;private ILogger warningLogger;&#xA;&#x9;private ILogger infoLogger;&#xA;&#xA;&#x9;public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;this.errorLogger = errorLogger;&#xA;&#x9;&#x9;this.warningLogger = warningLogger;&#xA;&#x9;&#x9;this.infoLogger = infoLogger;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.6/@attempts.0/@edit" start="65" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="117" charEnd="130" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="150" charEnd="160" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="86" charEnd="97" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490478681281" sizeMeasure="33" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements ILogger {&#xA;&#xA;&#x9;private ILogger errorLogger;&#xA;&#x9;private ILogger warningLogger;&#xA;&#x9;private ILogger infoLogger;&#xA;&#xA;&#x9;public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;this.errorLogger = errorLogger;&#xA;&#x9;&#x9;this.warningLogger = warningLogger;&#xA;&#x9;&#x9;this.infoLogger = infoLogger;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setLogger(String severity, ILogger logger) {&#xA;&#x9;&#x9;if (severity == &quot;error&quot;) {&#xA;&#x9;&#x9;&#x9;this.errorLogger = logger;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;warning&quot;) {&#xA;&#x9;&#x9;&#x9;this.warningLogger = logger;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;info&quot;) {&#xA;&#x9;&#x9;&#x9;this.infoLogger = logger;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;" edit="/1/@proposals.1/@proposals.6/@attempts.1/@edit" start="62" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="169" charEnd="179" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="105" charEnd="116" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="136" charEnd="149" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490478902429" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if (severity == &quot;error&quot;) {&#xA;&#x9;&#x9;&#x9;errorLogger.log(severity, message, exception);&#xA;&#x9;&#x9;&#x9;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;warning&quot;) {&#xA;&#x9;&#x9;&#x9;warningLogger.log(severity, message, exception);&#xA;&#x9;&#x9;&#x9;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (severity == &quot;info&quot;) {&#xA;&#x9;&#x9;&#x9;infoLogger.log(severity, message, exception);&#xA;&#x9;&#x9;&#x9;;&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.6/@attempts.2/@edit" start="751" end="-8"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.7/@q" answer="/0/@parts.1/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.8/@q" answer="/0/@parts.1/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490478915659" completion="1.0" successCount="4">
          <successTests>testLogToInfo</successTests>
          <successTests>testLogToWarn</successTests>
          <successTests>testChangeInfoLogger</successTests>
          <successTests>testLogToError</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a" performedCount="12">
        <attempts timestamp="1490477081789"/>
        <attempts timestamp="1490477133280"/>
        <attempts timestamp="1490477315840"/>
        <attempts timestamp="1490477332151"/>
        <attempts timestamp="1490477413790"/>
        <attempts timestamp="1490477445681"/>
        <attempts timestamp="1490477448877"/>
        <attempts timestamp="1490477450048"/>
        <attempts timestamp="1490477450582"/>
        <attempts timestamp="1490477451013"/>
        <attempts timestamp="1490477499138"/>
        <attempts timestamp="1490477507766"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a" performedCount="1">
        <attempts timestamp="1490477311907"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a" performedCount="52">
        <attempts timestamp="1490477114750"/>
        <attempts timestamp="1490477117293"/>
        <attempts timestamp="1490477132756"/>
        <attempts timestamp="1490477133276"/>
        <attempts timestamp="1490477135332"/>
        <attempts timestamp="1490477135716"/>
        <attempts timestamp="1490477162164"/>
        <attempts timestamp="1490477252060"/>
        <attempts timestamp="1490477259804"/>
        <attempts timestamp="1490477266460"/>
        <attempts timestamp="1490477274948"/>
        <attempts timestamp="1490477298916"/>
        <attempts timestamp="1490477302188"/>
        <attempts timestamp="1490477304555"/>
        <attempts timestamp="1490477306851"/>
        <attempts timestamp="1490477307972"/>
        <attempts timestamp="1490477325700"/>
        <attempts timestamp="1490477330131"/>
        <attempts timestamp="1490477331611"/>
        <attempts timestamp="1490477332148"/>
        <attempts timestamp="1490477412459"/>
        <attempts timestamp="1490477412755"/>
        <attempts timestamp="1490477413011"/>
        <attempts timestamp="1490477413787"/>
        <attempts timestamp="1490477414155"/>
        <attempts timestamp="1490477414412"/>
        <attempts timestamp="1490477414620"/>
        <attempts timestamp="1490477419091"/>
        <attempts timestamp="1490477419963"/>
        <attempts timestamp="1490477420995"/>
        <attempts timestamp="1490477422628"/>
        <attempts timestamp="1490477424028"/>
        <attempts timestamp="1490477425843"/>
        <attempts timestamp="1490477428987"/>
        <attempts timestamp="1490477429748"/>
        <attempts timestamp="1490477432411"/>
        <attempts timestamp="1490477434827"/>
        <attempts timestamp="1490477438595"/>
        <attempts timestamp="1490477439819"/>
        <attempts timestamp="1490477443355"/>
        <attempts timestamp="1490477444091"/>
        <attempts timestamp="1490477505835"/>
        <attempts timestamp="1490477506835"/>
        <attempts timestamp="1490477507371"/>
        <attempts timestamp="1490477507764"/>
        <attempts timestamp="1490477508195"/>
        <attempts timestamp="1490477508595"/>
        <attempts timestamp="1490477508979"/>
        <attempts timestamp="1490477509411"/>
        <attempts timestamp="1490477537387"/>
        <attempts timestamp="1490477540019"/>
        <attempts timestamp="1490477540619"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a" performedCount="2">
        <attempts timestamp="1490477088967"/>
        <attempts timestamp="1490477491644"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
