<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491344717954" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public abstract class AbstractAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491345182940" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;// Instanse-variabel til balansen&#xA;&#x9;private double balance;&#xA;&#x9;&#xA;&#x9;// Konstruktør som setter defaultverdier på balansen&#xA;&#x9;public AbstractAccount() {&#xA;&#x9;&#x9;this.balance = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Øker kontobalansen med innskutt beløp som argument&#xA;&#x9;public void deposit(double amount) {&#xA;&#x9;&#x9;// Innskuttet beløpet må være positivt&#xA;&#x9;&#x9;if (amount > 0) {&#xA;&#x9;&#x9;&#x9;this.balance += amount;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal amount&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Kaller uttaksbeløp-metoden (internatWithdraw under) implimert i hver klasse&#xA;&#x9;public void withdraw(double amount) {&#xA;&#x9;&#x9;// Hvis uttaksbeløpet er negativt&#xA;&#x9;&#x9;if (amount &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal amount&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;// Utløser uttaksmetoden&#xA;&#x9;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;&#x9;&#x9;// Trekker fra balansen&#xA;&#x9;&#x9;&#x9;this.balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Minsker kontobalansen med beløpet som blir tatt inn som argument&#xA;&#x9;// Denne metoden er implementeres i subklassene&#xA;&#x9;abstract void internalWithdraw(double amount);&#xA;&#x9;&#xA;&#x9;// Returnerer kontobalansen&#xA;&#x9;public double getBalance() {&#xA;&#x9;&#x9;return this.balance;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="62" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491345216664" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" lik 0" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="179" end="-931"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491345284823" sizeMeasure="9">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount {&#xA;&#xA;&#x9;public DebitAccount() {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491345763284" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Arver fra AbstractAccount&#xA;public class DebitAccount extends AbstractAccount{&#xA;&#x9;&#xA;&#x9;public DebitAccount() {&#xA;&#x9;&#x9;// Konstrurerer superklassen (AbstractAccount) konstruktøren&#xA;&#x9;&#x9;super();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Saldoen må til enhver til være større eller lik 0&#xA;&#x9;// Sjekker om balansen er større en defaultverien (altså 0)&#xA;&#x9;// Ellers blir det kastet en exception&#xA;&#x9;/* Protected er tilgjengelig for alle subklasser og&#xA;&#x9; * alle klasser i dets package */&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (super.getBalance() &lt; amount) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="22" end="-8"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491345846035" sizeMeasure="9">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;&#x9;public CreditAccount() {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491346400111" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#x9;&#xA;&#x9;// Tilgjenglig kreditt på kontoen&#xA;&#x9;private double creditLine;&#xA;&#x9;&#xA;&#x9;// Konstruktøren settes kredittlinjen&#xA;&#x9;public CreditAccount(double limit) {&#xA;&#x9;&#x9;// Konstrurerer superklassen (AbstractAccount) konstruktøren&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;// Hvis kredittlinjen er negativ&#xA;&#x9;&#x9;if (limit &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Creditline cannot be less than 0&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.creditLine = limit;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Returnerer kredittlinjen&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Setter kredittlinjen&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;// Hvis kredittlinjen er negativ&#xA;&#x9;&#x9;if (creditLine &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Creditline connot be less than 0&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;// Hvis kredittlinjen er mindre enn det eksisterende balansen&#xA;&#x9;&#x9;else if (creditLine &lt; super.getBalance()*-1) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot set limit lower than current credit&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Bruker metoden fra DebitAccout for å sjekke om saldoen er gyldig&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > (this.creditLine + super.getBalance())) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491346544422" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;    private double creditLine;&#xA;&#xA;    public CreditAccount(double limit) {&#xA;        super();&#xA;        if (limit &lt; 0)&#xA;            throw new IllegalArgumentException(&quot;Creditline cannot be less than 0&quot;);&#xA;        else&#xA;            this.creditLine = limit;&#xA;    }&#xA;&#xA;    public double getCreditLine() {&#xA;        return creditLine;&#xA;    }&#xA;&#xA;    public void setCreditLine(double creditLine) {&#xA;        if (creditLine &lt; 0)&#xA;            throw new IllegalArgumentException(&quot;Creditline cannot be less than 0&quot;);&#xA;        else if (creditLine &lt; super.getBalance()*-1)&#xA;            throw new IllegalStateException(&quot;Cannot set limit lower than current credit&quot;);&#xA;        else&#xA;            this.creditLine = creditLine;&#xA;    }&#xA;&#xA;    protected void internalWithdraw(double amount) {&#xA;        if (amount > (this.creditLine + super.getBalance()))&#xA;            throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;    }" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="72" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491346644907" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;// Tilgjenglig kreditt på kontoen&#xA;&#x9;private double creditLine;&#xA;&#x9;&#xA;&#x9;// Konstruktøren settes kredittlinjen&#xA;&#x9;public CreditAccount(double limit) {&#xA;&#x9;&#x9;// Konstrurerer superklassen (AbstractAccount) konstruktøren&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;// Hvis kredittlinjen er negativ&#xA;&#x9;&#x9;if (limit &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Creditline cannot be less than 0&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.creditLine = limit;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Returnerer kredittlinjen&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Setter kredittlinjen&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;// Hvis kredittlinjen er negativ&#xA;&#x9;&#x9;if (creditLine &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Creditline connot be less than 0&quot;);&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;// Hvis kredittlinjen er mindre enn det eksisterende balansen&#xA;&#x9;&#x9;else if (creditLine &lt; super.getBalance()*-1) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Cannot set limit lower than current credit&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Bruker metoden fra DebitAccout for å sjekke om saldoen er gyldig&#xA;&#x9;protected void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > (this.creditLine + super.getBalance())) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="75" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491346730887" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Arver fra AbstractAccount" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="22" end="-1240"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491346701199" sizeMeasure="9">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;&#x9;public SavingsAccount2() {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347139295" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Arver fra AbstractAccount&#xA;public class SavingsAccount2 extends AbstractAccount {&#xA;&#x9;&#xA;&#x9;private int withdrawalLimit;&#xA;&#x9;private int currentWithdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;// Konstruktør som legger til uttak og gebyr&#xA;&#x9;public SavingsAccount2(int limit, double fee) {&#xA;&#x9;&#x9;// Konstrurerer superklassen (AbstractAccount) konstruktøren&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;this.withdrawalLimit = limit;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;&#x9;this.currentWithdrawals = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Sjekker om det er gyldig argument for saldobeløpet&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > super.getBalance()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// Om det eksisterende uttaket er større eller lik antall uttak&#xA;&#x9;&#x9;else if (currentWithdrawals >= withdrawalLimit) {&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Remove fee from balance&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="22" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347177520" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class SavingsAccount2 extends AbstractAccount {&#xA;    private int withdrawalLimit, currentWithdrawals;&#xA;    private double fee;&#xA;&#xA;    public SavingsAccount2(int limit, double fee) {&#xA;        super();&#xA;        this.withdrawalLimit = limit;&#xA;        this.fee = fee;&#xA;        this.currentWithdrawals = 0;&#xA;    }&#xA;&#xA;    public void internalWithdraw(double amount) {&#xA;        if (amount > super.getBalance())&#xA;            throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;        else if (currentWithdrawals >= withdrawalLimit)&#xA;            System.out.println(&quot;Remove fee from balance&quot;); //@todo&#xA;    }" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="22" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347241197" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Arver fra AbstractAccount&#xA;public class SavingsAccount2 extends AbstractAccount {&#xA;&#x9;&#xA;&#x9;private int withdrawalLimit;&#xA;&#x9;private int currentWithdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;// Konstruktør som legger til uttak og gebyr&#xA;&#x9;public SavingsAccount2(int limit, double fee) {&#xA;&#x9;&#x9;// Konstrurerer superklassen (AbstractAccount) konstruktøren&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;this.withdrawalLimit = limit;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;&#x9;this.currentWithdrawals = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Sjekker om det er gyldig argument for saldobeløpet&#xA;&#x9;public void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (amount > super.getBalance()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Not enough funds&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// Om det eksisterende uttaket er større eller lik antall uttak&#xA;&#x9;&#x9;else if (currentWithdrawals >= withdrawalLimit) {&#xA;&#x9;&#x9;&#x9;// Legger til &#xA;&#x9;&#x9;&#x9;System.out.println(&quot;Remove fee from balance&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="22" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347298258" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="* Om pengene etter alle uttak er brukt opp skal&#xA;&#x9;&#x9;&#x9;saldoen belastes med et gebyr*/" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="770" end="-62"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491345773628" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491346412402" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <failureTests>testSetCreditLine</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491346550491" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491346650548" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="0.5">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491347154513" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491347184827" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
