<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="ObservableList">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract ObservableList superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableListListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableListListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableHighscoreList class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableHighscoreList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the ObservableHighscoreList class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.ObservableHighscoreList"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the ObservableHighscoreListProgram class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.ObservableHighscoreListProgram"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the ObservableHighscoreListProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.ObservableHighscoreListProgram"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the ObservableHighscoreList JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.ObservableHighscoreListTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the ObservableList JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.ObservableListTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.Observable*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490867503403" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public abstract class ObservableList {&#xA;&#x9;&#xA;&#x9;int maxSize;&#xA;&#x9;List&lt;Integer> results = new ArrayList&lt;>();&#xA;    List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;    &#xA;    public ObservableList(int maxSize){&#xA;    &#x9;this.maxSize = maxSize;&#xA;    }&#xA;    public int size(){&#xA;    &#x9;return results.size();&#xA;    &#x9;&#xA;    }&#xA;    public int getElement(int position){&#xA;    &#x9;return results.get(position);&#xA;    }&#xA;    &#xA;    public void addResult(int result){&#xA;    &#x9;int index=0;&#xA;    &#x9;&#x9;&#xA;    &#x9;while  (results.size()>index &amp;&amp; result>=results.get(index)){&#xA;    &#x9;&#x9;&#x9; &#xA;    &#x9;&#x9;index++;&#xA;    &#x9;&#x9;&#x9;&#x9;&#xA;    &#x9;&#x9;} &#xA;    &#x9;&#x9;&#x9;results.add(index,result);&#xA;    &#x9;&#x9;&#x9;&#x9;&#xA;    &#x9;&#x9;if (results.size()>maxSize){&#xA;    &#x9;&#x9;&#x9;&#x9;results.remove(results.size()-1);&#xA;    &#x9;&#x9;}&#xA;    &#x9;for(ObservableListListener lytter : listeners){&#xA;    &#x9;&#x9;&#x9;&#x9;&#x9;lytter.listChanged(this,index);&#xA;    &#x9;}&#xA;    &#xA;    }&#xA;    &#xA;    public void addObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if (!listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.add(lytter);&#xA;    &#x9;}else{&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke legge til en lytter som allerede finnes i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    public void removeObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if(listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.remove(lytter);&#xA;    &#x9;}else {&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke fjerne en lytter som ikke ligger i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    &#xA;    &#xA;    &#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490867642909" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226278840" sizeMeasure="43">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public abstract class ObservableList {&#xA;&#x9;&#xA;&#x9;List &lt;Object> results = new ArrayList&lt;>();&#xA;&#x9;List &lt;Object> listeners = new ArrayList&lt;>();&#xA;&#x9;int maxSize;&#xA;&#x9;&#xA;&#x9;public abstract boolean acceptsElement(Object element);&#xA;&#xA;    public int size(){ &#xA;    return &#x9;results.size();&#xA;    }&#xA;    &#xA;    &#xA;    public Object getElement(int position){ &#xA;    &#x9;return results.get(position);&#xA;    }&#xA;    &#xA;    &#xA;    public void addElement(int position, Object result){&#xA;    &#x9;if(!this.acceptsElement(result)){&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke legge til ugyldig element.&quot;);&#xA;    &#x9;}&#xA;    &#x9;if (position>maxSize || position&lt;0){&#xA;    &#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Kan ikke legge til resultat på ugylig posisjon&quot;);&#xA;    &#x9;}&#xA;    &#x9;results.add(position,result);&#xA;    }&#xA;    &#xA;    &#xA;    public void removeElement(int position){&#xA;    &#x9;if(position>maxSize || position &lt;0){&#xA;    &#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Ugyldig posisjon&quot;);&#xA;    &#x9;}&#xA;&#x9;&#xA;    &#x9;results.remove(position);&#xA;&#x9;&#xA;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227395217" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void addElement(Object result){&#xA;    &#x9;if(this.acceptsElement(result)){&#xA;    &#x9;&#x9;results.add(result);&#xA;    &#x9;&#x9;&#xA;    &#x9;}else{&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig element&quot;);&#xA;    &#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="822" end="-214"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227510437" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rotected void addElement(int position, Object result){&#xA;    &#x9;if(!this.acceptsElement(result)){&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke legge til ugyldig element.&quot;);&#xA;    &#x9;}&#xA;    &#x9;if (position>maxSize || position&lt;0){&#xA;    &#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Kan ikke legge til resultat på ugylig posisjon&quot;);&#xA;    &#x9;}&#xA;    &#x9;results.add(position,result);&#xA;    }&#xA;    protected" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="456" end="-398"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227558502" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="    public void addObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if (!listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.add(lytter);&#xA;    &#x9;}else{&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke legge til en lytter som allerede finnes i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    public void removeObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if(listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.remove(lytter);&#xA;    &#x9;}else {&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke fjerne en lytter som ikke ligger i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    " edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1229" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491227600746" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rotected" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1040" end="-728"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228839751" sizeMeasure="68" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;for(Object lytter : listeners){&#xA;&#x9;&#x9;&#x9;((ObservableListListener) lytter).listChanged(this,position" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="819" end="-964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228993464" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="921" end="-962"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229165947" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1230" end="-655"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229203620" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="){//|| position&lt;0){&#xA;    &#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Kan ikke legge til resultat på ugylig posisjon&quot;);&#xA;    &#x9;}&#xA;    &#x9;results.add(position,result);&#xA;    &#x9;for(Object lytter : listeners){&#xA;&#x9;&#x9;&#x9;((ObservableListListener) lytter).listChanged(this,position);&#xA;    &#x9;}&#xA;    }&#xA;    protected void addElement(Object result){&#xA;    &#x9;if(this.acceptsElement(result)){&#xA;    &#x9;&#x9;results.add(result);&#xA;    &#x9;&#x9;&#xA;    &#x9;}else{&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig element&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    &#xA;    &#xA;    protected void removeElement(int position){&#xA;    &#x9;if(position>maxSize){// || position &lt;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="664" end="-655"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229300576" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="643" end="-1110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229332487" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="637" end="-1112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229580480" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;    &#x9;if (position>results.size() ){//|| position&lt;0){&#xA;    &#x9;&#x9;throw new IndexOutOfBoundsException(&quot;Kan ikke legge til resultat på ugylig posisjon&quot;);&#xA;    &#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="637" end="-1110"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228839746" sizeMeasure="8">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;public interface ObservableListListener {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void listChanged(ObservableList list, int position);&#xA;&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490867493697" sizeMeasure="-1" errorCount="-1" warningCount="-1"/>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490867642910" sizeMeasure="60">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public  class ObservableHighscoreList {&#xA;&#x9;&#xA;&#x9;int maxSize;&#xA;&#x9;List&lt;Integer> results = new ArrayList&lt;>();&#xA;    List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;    &#xA;    public ObservableHighscoreList(int maxSize){&#xA;    &#x9;this.maxSize = maxSize;&#xA;    }&#xA;    public int size(){&#xA;    &#x9;return results.size();&#xA;    &#x9;&#xA;    }&#xA;    public int getElement(int position){&#xA;    &#x9;return results.get(position);&#xA;    }&#xA;    &#xA;    public void addResult(int result){&#xA;    &#x9;int index=0;&#xA;    &#x9;&#x9;&#xA;    &#x9;while  (results.size()>index &amp;&amp; result>=results.get(index)){&#xA;    &#x9;&#x9;&#x9; &#xA;    &#x9;&#x9;index++;&#xA;    &#x9;&#x9;&#x9;&#x9;&#xA;    &#x9;&#x9;} &#xA;    &#x9;&#x9;&#x9;results.add(index,result);&#xA;    &#x9;&#x9;&#x9;&#x9;&#xA;    &#x9;&#x9;if (results.size()>maxSize){&#xA;    &#x9;&#x9;&#x9;&#x9;results.remove(results.size()-1);&#xA;    &#x9;&#x9;}&#xA;    &#x9;for(ObservableListListener lytter : listeners){&#xA;    &#x9;&#x9;&#x9;&#x9;&#x9;lytter.listChanged(this,index);&#xA;    &#x9;}&#xA;    &#xA;    }&#xA;    &#xA;    public void addObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if (!listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.add(lytter);&#xA;    &#x9;}else{&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke legge til en lytter som allerede finnes i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    public void removeObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if(listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.remove(lytter);&#xA;    &#x9;}else {&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke fjerne en lytter som ikke ligger i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    &#xA;    &#xA;    &#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491226191857" sizeMeasure="60" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="1457" end="-1458"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228953782" sizeMeasure="65" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends ObservableList{&#xA;&#x9;&#xA;&#x9;int maxSize;&#xA;&#x9;List&lt;Integer> results = new ArrayList&lt;>();&#xA;    List&lt;ObservableListListener> listeners = new ArrayList&lt;>();&#xA;    &#xA;    public ObservableHighscoreList(int maxSize){&#xA;    &#x9;this.maxSize = maxSize;&#xA;    }&#xA;    public int size(){&#xA;    &#x9;return results.size();&#xA;    &#x9;&#xA;    }&#xA;    public int getElement(int position){&#xA;    &#x9;return results.get(position);&#xA;    }&#xA;    &#xA;    public void addResult(int result){&#xA;    &#x9;int index=0;&#xA;    &#x9;&#x9;&#xA;    &#x9;while  (results.size()>index &amp;&amp; result>=results.get(index)){&#xA;    &#x9;&#x9;&#x9; &#xA;    &#x9;&#x9;index++;&#xA;    &#x9;&#x9;&#x9;&#x9;&#xA;    &#x9;&#x9;} &#xA;    &#x9;&#x9;&#x9;results.add(index,result);&#xA;    &#x9;&#x9;&#x9;&#x9;&#xA;    &#x9;&#x9;if (results.size()>maxSize){&#xA;    &#x9;&#x9;&#x9;&#x9;results.remove(results.size()-1);&#xA;    &#x9;&#x9;}&#xA;    &#x9;for(ObservableListListener lytter : listeners){&#xA;    &#x9;&#x9;&#x9;&#x9;&#x9;lytter.listChanged(this,index);&#xA;    &#x9;}&#xA;    &#xA;    }&#xA;    &#xA;    public void addObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if (!listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.add(lytter);&#xA;    &#x9;}else{&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke legge til en lytter som allerede finnes i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    public void removeObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if(listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.remove(lytter);&#xA;    &#x9;}else {&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke fjerne en lytter som ikke ligger i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;&#x9;@Override&#xA;&#x9;public boolean acceptsElement(Object element) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return (element instanceof Integer);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="120" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491228981399" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Integer" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="431" end="-1185"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491229868825" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="results.add(index,result);&#xA;&#xA;    &#x9;&#x9;if (results.size()>maxSize){&#xA;    &#x9;&#x9;&#x9;&#x9;results.remove(results.size()-1);&#xA;    &#x9;&#x9;}&#xA;    &#x9;for(ObservableListListener lytter : listeners){&#xA;    " edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="689" end="-752"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491230262227" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.5/@edit" start="1514" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491288240889" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;    &#x9;&#x9;if (results.size()>maxSize){&#xA;    &#x9;&#x9;&#x9;&#x9;results.remove(results.size()-1);&#xA;    &#x9;&#x9;}&#xA;    &#x9;&#x9;if(index == maxSize){&#xA;&#x9;&#x9;&#x9;&#x9;index=-1;&#xA;&#x9;&#x9;&#x9;}&#xA;    &#x9;for(ObservableListListener lytter : listeners){&#xA;    &#x9;&#x9;lytter.listChanged(this,index);&#xA;    &#x9;}&#xA;    &#xA;    }&#xA;    &#xA;    public void addObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if (!listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.add(lytter);&#xA;    &#x9;}else{&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke legge til en lytter som allerede finnes i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;    public void removeObservableListListener(ObservableListListener lytter){&#xA;    &#x9;if(listeners.contains(lytter)){&#xA;    &#x9;&#x9;listeners.remove(lytter);&#xA;    &#x9;}else {&#xA;    &#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke fjerne en lytter som ikke ligger i lista&quot;);&#xA;    &#x9;}&#xA;    }&#xA;&#x9;@Override&#xA;&#x9;public boolean acceptsElement(Object element) {" edit="/1/@proposals.0/@proposals.2/@attempts.6/@edit" start="723" end="-63"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491072313641" sizeMeasure="45" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.Scanner;&#xA;&#xA;public class ObservableHighscoreListProgram implements ObservableListListener {&#xA;&#x9;&#xA;ObservableHighscoreList listen = new ObservableHighscoreList(10);&#xA;&#x9;&#xA;&#x9;public ObservableHighscoreListProgram(){&#xA;&#x9;&#x9;init();&#xA;&#x9;    run();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void init(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;listen.addObservableListListener((ObservableListListener) this);&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;public void run(){&#xA;&#x9;&#x9;Scanner sc =new Scanner(System.in);&#xA;&#x9;&#x9;while(sc.hasNextInt()){&#xA;&#x9;&#x9;&#x9;int resultat = sc.nextInt();&#xA;&#x9;&#x9;&#x9;listen.addResult(resultat);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;sc.close();&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public void listChanged(ObservableHighscoreList listen, int position) {&#xA;&#x9;&#x9;for (int i = 0; i&lt;listen.size();i++){&#xA;&#x9;&#x9;&#x9;int verdi = listen.getElement(i);&#xA;&#x9;&#x9;&#x9;System.out.println(verdi);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;System.out.println(position);&#xA;    }&#xA;&#x9;&#xA;&#x9;public static void main(String[]args){&#xA;&#x9;&#x9;ObservableHighscoreListProgram list = new ObservableHighscoreListProgram();&#xA;&#x9;&#x9;list.&#xA;&#x9;}&#xA;}&#xA;&#xA;&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490867354373" completion="0.5714285714285714" successCount="4" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491226279639" completion="0.5714285714285714" successCount="4" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227081353" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227742664" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229005095" completion="0.5714285714285714" successCount="4" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229079362" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229601544" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229628812" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491287339486" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491288118774" completion="0.8571428571428571" successCount="6" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491288245238" completion="1.0" successCount="7"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227151849" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227395919" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227511118" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227559229" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227601476" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491227949295" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229016143" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229093189" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229166675" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229204342" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229306581" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229333242" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229584392" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491229610230" completion="1.0" successCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491287344559" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
