<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308019562" sizeMeasure="37" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount extends AbstractAccount {&#xA;&#x9;&#xA;&#x9;private double creditLine;&#xA;&#x9;&#xA;&#x9;public CreditAccount(double creditLine) {&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (n &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The creditline must be above zero&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setCreditLine(double newCreditLine) {&#xA;&#x9;&#x9;if (creditLine != newCreditLine) {&#xA;&#x9;&#x9;&#x9;if (balance &lt; 0) {&#xA;&#x9;&#x9;&#x9;&#x9;if(newCreditLine &lt; Math.abs(balance)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;The new creditline must cover your negative balance&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine = newCreditLine;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308044931" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="creditLine" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="170" end="-581"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308098773" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance -= amount;" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="357" end="-370"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308233065" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if ((balance -= amount) &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException (&quot;You can not overdraw your creditline&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="357" end="-391"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308469644" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="newCreditLine >= 0) {&#xA;&#x9;&#x9;&#x9;if (creditLine != newCreditLine) {&#xA;&#x9;&#x9;&#x9;&#x9;if (balance &lt; 0) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if(newCreditLine &lt; Math.abs(balance)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;The new creditline must cover your negative balance&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.creditLine = newCreditLine;&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;throw new IllegalArgumentException (&quot;The creditline must be above zero&quot;)" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="624" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308534782" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;private double creditLine;&#xA;&#xA;&#x9;public CreditAccount(double creditLine) {&#xA;&#x9;&#x9;super();&#xA;&#xA;&#x9;&#x9;if (creditLine &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The creditline must be above zero&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#xA;&#x9;&#x9;if ((balance -= amount) &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can not overdraw your creditline&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= amount;&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setCreditLine(double newCreditLine) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (newCreditLine &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The creditline must be above zero&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (creditLine != newCreditLine) {&#xA;&#x9;&#x9;&#x9;if (balance &lt; 0) {&#xA;&#x9;&#x9;&#x9;&#x9;if (newCreditLine &lt; Math.abs(balance)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;The new creditline must cover your negative balance&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine = newCreditLine" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="75" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308574455" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="474" end="-502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308580520" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="474" end="-502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308819939" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" amount) &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can not overdraw your creditline&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= amount;" edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="368" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308829144" sizeMeasure="45">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.3/@attempts.8/@edit" start="368" end="-606"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308949083" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount > creditLine) {&#xA;&#x9;&#x9;&#x9;if (amount > balance) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can not overdraw your creditline&quot;);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.9/@edit" start="358" end="-506"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309046817" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(balance -= amount) &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can not overdraw your creditline&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.10/@edit" start="358" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309083828" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9; balance -= amount;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.11/@edit" start="475" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309243754" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+" edit="/1/@proposals.0/@proposals.3/@attempts.12/@edit" start="485" end="-493"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309357637" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;double diff = balance - amount;&#xA;&#xA;&#x9;&#x9;if ((diff) &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can not overdraw your creditline&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9; balance -" edit="/1/@proposals.0/@proposals.3/@attempts.13/@edit" start="299" end="-493"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309367797" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#xA;&#x9;&#x9;if ((balance -= amount" edit="/1/@proposals.0/@proposals.3/@attempts.14/@edit" start="299" end="-603"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309502498" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if ((balance -= amount) &lt; creditLine) {&#xA;//&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can not overdraw your creditline&quot;);&#xA;//" edit="/1/@proposals.0/@proposals.3/@attempts.15/@edit" start="352" end="-509"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309691968" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if ((balance -= amount) &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can not overdraw your creditline&quot;);&#xA;" edit="/1/@proposals.0/@proposals.3/@attempts.16/@edit" start="352" end="-509"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309744526" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.17/@edit" start="368" end="-610"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309802218" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9; &#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#xA;&#x9;&#x9;if ((balance -=" edit="/1/@proposals.0/@proposals.3/@attempts.18/@edit" start="299" end="-610"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309812845" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return" edit="/1/@proposals.0/@proposals.3/@attempts.19/@edit" start="480" end="-485"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309849653" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" amount) &lt; creditLine) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;You can not overdraw your creditline&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9; balance -= amount" edit="/1/@proposals.0/@proposals.3/@attempts.20/@edit" start="371" end="-485"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309890120" sizeMeasure="47" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount >" edit="/1/@proposals.0/@proposals.3/@attempts.21/@edit" start="362" end="-600"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309901553" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="balance -= amount) &lt;" edit="/1/@proposals.0/@proposals.3/@attempts.22/@edit" start="362" end="-600"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309944831" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="8" edit="/1/@proposals.0/@proposals.3/@attempts.23/@edit" start="373" end="-603"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309986488" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" amount" edit="/1/@proposals.0/@proposals.3/@attempts.24/@edit" start="371" end="-603"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491309997395" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.3/@attempts.25/@edit" start="371" end="-610"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310057834" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#xA;&#x9;&#x9;double diff = balance - amount;&#xA;&#xA;&#x9;&#x9;if (diff" edit="/1/@proposals.0/@proposals.3/@attempts.26/@edit" start="354" end="-602"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310077651" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (balance - amount" edit="/1/@proposals.0/@proposals.3/@attempts.27/@edit" start="354" end="-602"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310121388" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(balance - amount)" edit="/1/@proposals.0/@proposals.3/@attempts.28/@edit" start="361" end="-602"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312298281" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-balance > newCreditLine) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;The new creditline must cover your negative balance&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.29/@edit" start="794" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491312383181" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;creditLine = newCreditLine;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.30/@edit" start="928" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313512528" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-=" edit="/1/@proposals.0/@proposals.3/@attempts.31/@edit" start="369" end="-597"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313734615" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + amount) >" edit="/1/@proposals.0/@proposals.3/@attempts.32/@edit" start="369" end="-587"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313765333" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-=" edit="/1/@proposals.0/@proposals.3/@attempts.33/@edit" start="370" end="-597"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313776332" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;" edit="/1/@proposals.0/@proposals.3/@attempts.34/@edit" start="381" end="-587"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313813798" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= balance" edit="/1/@proposals.0/@proposals.3/@attempts.35/@edit" start="488" end="-472"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313824453" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.36/@edit" start="371" end="-597"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313837969" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.3/@attempts.37/@edit" start="487" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491313901342" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="amount" edit="/1/@proposals.0/@proposals.3/@attempts.38/@edit" start="490" end="-472"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491314014075" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0) {&#xA;&#x9;&#x9;&#x9;if (-(balance-amount) > creditLine)&#xA;&#x9;" edit="/1/@proposals.0/@proposals.3/@attempts.39/@edit" start="382" end="-572"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310470204" sizeMeasure="24">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 extends AbstractAccount{&#xA;&#xA;&#x9;private int x;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int x, double fee) {&#xA;&#x9;&#x9;this.x = x;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount) {&#xA;&#x9;&#x9;if (x &lt;= 0) {&#xA;&#x9;&#x9;&#x9;balance -= amount + fee;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;&#x9;x -= 1;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310567330" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount > balance) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException (&quot;You only have &quot; + balance + &quot; left in your account&quot;);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="307" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310683941" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if ((amount + fee) > balance) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException (&quot;You only have &quot; + balance + &quot; left in your account&quot;);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="268" end="-210"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491310789568" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=". Because you&quot;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;+ &quot;have reached your limit of withdrawals, an additional fee is added" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="388" end="-218"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491307386156" completion="1.0" successCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308045350" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308099208" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308233438" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308469966" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308535131" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308574801" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308580869" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308820335" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308824148" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308829512" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308949417" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309047219" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309084182" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309244092" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309357992" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309368169" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309502865" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309692291" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309744875" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309802631" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309813191" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309850002" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309890557" completion="0.3333333333333333" successCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309901921" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309945225" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309986836" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491309997741" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310058220" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310078003" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310121748" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310814457" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312298650" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491312383604" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313354521" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313512905" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313734992" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313765683" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313776674" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313814141" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313824810" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313838349" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491313901716" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491314014444" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310470575" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310567670" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491310684349" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
