<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490785462457" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public abstract class AbstractAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490785681605" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;protected double balance;&#xA;&#x9;&#xA;&#x9;public void deposit(double value) {&#xA;&#x9;&#x9;if (value &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal deposit&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance += value;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="63" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490785927248" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void withdraw(double value) {&#xA;&#x9;&#x9;if (value &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal withdraw&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;internalWithdraw(value);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public abstract void internalWithdraw(double value); " edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="235" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490785988235" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public double getBalance() {&#xA;&#x9;return balance;&#xA;}&#xA;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="444" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490786091884" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="AbstractAccount() {&#xA;&#x9;&#x9;balance = 0; &#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="100" end="-410"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490786187883" sizeMeasure="11">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount extends AbstractAccount {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double value) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490786331284" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (value > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Too big withdraw&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="134" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490787511558" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;AbstractAccount account = new DebitAccount();&#xA;&#x9;&#x9;account.deposit(50000);&#xA;&#x9;&#x9;System.out.println(account.getBalance());&#xA;&#x9;&#x9;account.deposit(10000);&#xA;&#x9;&#x9;System.out.println(account.getBalance());&#xA;&#x9;&#x9;account.withdraw(2000);&#xA;&#x9;&#x9;System.out.println(account.getBalance());&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="222" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490787545072" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;balance -= value;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="217" end="-314"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490787661549" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="245" end="-309"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490787513159" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490787545950" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490787816699" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490789044786" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#xA;&#x9;public double creditLine; // tilgjengelig kreditt på kontoen&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double value) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getCreditLine() {&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setCreditLine(double creditLine) {&#xA;&#x9;&#x9;if (creditLine &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal creditline&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490789299589" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" line&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (creditLine &lt; (-getBalance())) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;The credit line has to cover the negative balanc" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="424" end="-47"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490789741365" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (value > (balance + creditLine)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Too big withdraw&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= value;" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="198" end="-374"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490789876413" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate double creditLine; // tilgjengelig kreditt på kontoen&#xA;&#x9;&#xA;&#x9;public CreditAccount(double creditLine) {&#xA;&#x9;&#x9;setCreditLine(creditLine);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="77" end="-553"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490790038386" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;AbstractAccount a = new CreditAccount(1000);&#xA;&#x9;&#x9;a.deposit(600);&#xA;&#x9;&#x9;System.out.println(a.getBalance());&#xA;&#x9;&#x9;a.withdraw(800);&#xA;&#x9;&#x9;System.out.println(a.getBalance())" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="764" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490790067604" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;a.withdraw(-900" edit="/1/@proposals.0/@proposals.3/@attempts.5/@edit" start="969" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490790072230" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.3/@attempts.6/@edit" start="981" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490790089355" sizeMeasure="43">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deposit(900);&#xA;&#x9;&#x9;System.out.println(a.getBalance()" edit="/1/@proposals.0/@proposals.3/@attempts.7/@edit" start="972" end="-9"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490790044376" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490790068471" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490790073018" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490790090688" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490790671052" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490790699880" sizeMeasure="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="54" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490790849009" sizeMeasure="7" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="51" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="35" charEnd="50" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490791109614" sizeMeasure="17">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public void internalWithdraw(double value) {&#xA;&#x9;&#x9;if (value > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Too big withdraw&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;balance -= value;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="78" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490791699745" sizeMeasure="25" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int withdrawals;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawals, double fee) {&#xA;&#x9;&#x9;this.withdrawals = withdrawals;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="78" end="-181"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="119" charEnd="122" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="90" charEnd="101" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490792364538" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Limit;&#xA;&#x9;private int withdrawalsNr;&#xA;&#x9;private double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawalsLimit, double fee) {&#xA;&#x9;&#x9;this.withdrawalsLimit = withdrawalsLimit;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;&#x9;this.withdrawalsNr = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void internalWithdraw(double value) {&#xA;&#x9;&#x9;if (value > balance) {&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Too big withdraw&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (withdrawalsNr >= withdrawalsLimit) {&#xA;&#x9;&#x9;&#x9;balance -= fee;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance -= value;&#xA;&#x9;&#x9;&#x9;withdrawalsNr ++;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.4/@edit" start="101" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490792426279" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.5/@edit" start="571" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490792609071" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;AbstractAccount acc = new SavingsAccount2(5, 100);&#xA;&#x9;acc.deposit(2000);&#xA;&#x9;System.out.println(acc.getBalance());&#xA;&#x9;acc.withdraw(100);&#xA;&#x9;acc.withdraw(100);&#xA;&#x9;acc.withdraw(200);&#xA;&#x9;acc.withdraw(100);&#xA;&#x9;System.out.println(acc.getBalance());&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.6/@edit" start="572" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490792639184" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="acc.withdraw(2" edit="/1/@proposals.0/@proposals.5/@attempts.7/@edit" start="854" end="-58"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490792660631" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.5/@attempts.8/@edit" start="913" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490793139276" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" withdrawalsLimit) {&#xA;&#x9;&#x9;&#x9;balance -= fee;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;balance -= value;&#xA;&#x9;&#x9;&#x9;withdrawalsNr ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;AbstractAccount acc = new SavingsAccount2(5, 100);&#xA;&#x9;acc.deposit(2000);&#xA;&#x9;System.out.println(acc.getBalance());&#xA;&#x9;acc.withdraw(100);&#xA;&#x9;acc.withdraw(100);&#xA;&#x9;acc.withdraw(200);&#xA;&#x9;acc.withdraw(100);&#xA;&#x9;System.out.println(acc.getBalance());&#xA;&#x9;acc.withdraw(2" edit="/1/@proposals.0/@proposals.5/@attempts.9/@edit" start="475" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490793185747" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= withdrawalsLimit) {&#xA;&#x9;&#x9;&#x9;balance -= value;" edit="/1/@proposals.0/@proposals.5/@attempts.10/@edit" start="475" end="-489"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490793245237" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if ((fee + value) > balance) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Too big withdraw&quot;);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.11/@edit" start="500" end="-510"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490792610038" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490792640061" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490792661460" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490793140178" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490793246444" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490787177357" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490787559723" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490793298159" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490790122842" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490793294458" completion="1.0" successCount="3">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
          <successTests>testSetCreditLine</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490792753039" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490793146902" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490793193356" completion="0.5" successCount="1" failureCount="1">
          <successTests>testDeposit</successTests>
          <failureTests>testWithdraw</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490793252384" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490793310375" completion="1.0" successCount="2">
          <successTests>testWithdraw</successTests>
          <successTests>testDeposit</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
