<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Train">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TrainCar superclass."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.TrainCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TrainCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.TrainCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CargoCar class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CargoCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CargoCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CargoCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the PassengerCar class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.PassengerCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the PassengerCar class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.PassengerCar"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the Train class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.Train"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Train class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.Train"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TrainCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.TrainCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PassengerCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.PassengerCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CargoCarTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CargoCarTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TrainTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.TrainTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in *Car classes."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Car" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code in the Train class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.Train" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333404415" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class TrainCar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491335811349" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;private int deadweight;&#xA;&#x9;private int cargoweight;&#xA;&#x9;&#xA;&#x9;public TrainCar(int weight){&#xA;&#x9;&#x9;//- en konstruktør som tar inn hvor mye en tom vogn veier.&#xA;&#x9;&#x9;if(weight > 0){&#xA;&#x9;&#x9;&#x9;this.deadweight = weight;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;weight must be bigger than 0, was &quot;+ weight);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getTotalWeight(){&#xA;&#x9;&#x9;return deadweight+cargoweight;&#xA;&#x9;&#x9;//- returnerer vognas totale vekt. Merk at denne også skal kunne kalles på subklasser og fortsatt returnere totalvekta toil vogna (stikkord: redefinering).&#xA;&#x9;}&#xA;&#x9;public void setDeadWeight(int weight){&#xA;&#x9;&#x9;//- setter hvor mye en tom vogn veier. Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;&#x9;if(weight > 0){&#xA;&#x9;&#x9;&#x9;this.deadweight = weight;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getDeadWeight(){&#xA;&#x9;&#x9;return this.deadweight;&#xA;&#x9;&#x9;//- returnerer hvor mye en tom vogn veier. Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="46" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491344006627" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="otected int deadweight;&#xA;&#x9;protected" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="51" end="-840"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347337119" sizeMeasure="26" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if(weight > 0){&#xA;//&#x9;&#x9;&#x9;this.deadweight = weight;&#xA;//&#x9;&#x9;}else{&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;weight must be bigger than 0, was &quot;+ weight);&#xA;//&#x9;&#x9;}&#xA;&#x9;&#x9;setDeadWeight(weight);&#xA;&#x9;}&#xA;&#x9;public int getTotalWeight(){&#xA;&#x9;&#x9;return deadweight+cargoweight;&#xA;&#x9;&#x9;//- returnerer vognas totale vekt. Merk at denne også skal kunne kalles på subklasser og fortsatt returnere totalvekta toil vogna (stikkord: redefinering).&#xA;&#x9;}&#xA;&#x9;public abstract void setDeadWeight(int weight);" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="196" end="-165"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347365580" sizeMeasure="30" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if(weight > 0){&#xA;&#x9;&#x9;&#x9;this.deadweight = weight;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;weight must be bigger than 0, was &quot;+ weight);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getTotalWeight(){&#xA;&#x9;&#x9;return deadweight+cargoweight+passengercount*80;&#xA;&#x9;&#x9;//- returnerer vognas totale vekt. Merk at denne også skal kunne kalles på subklasser og fortsatt returnere totalvekta toil vogna (stikkord: redefinering).&#xA;&#x9;}&#xA;&#x9;public void setDeadWeight(int weight){&#xA;&#x9;&#x9;//- setter hvor mye en tom vogn veier. Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;&#x9;if(weight > 0){&#xA;&#x9;&#x9;&#x9;this.deadweight = weight;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="196" end="-165"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347374117" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="405" end="-520"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347755255" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if(weight > 0){&#xA;//&#x9;&#x9;&#x9;this.deadweight = weight;&#xA;//&#x9;&#x9;}else{&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;weight must be bigger than 0, was &quot;+ weight);&#xA;//&#x9;&#x9;}&#xA;&#x9;&#x9;setDeadWeight(weight);" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="196" end="-585"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491350752147" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;&#x9;//- returnerer vognas totale vekt. Merk at denne også skal kunne kalles på subklasser og fortsatt returnere totalvekta toil vogna (stikkord: redefinering).&#xA;&#x9;}&#xA;&#x9;public void setDeadWeight(int weight){&#xA;&#x9;&#x9;//- setter hvor mye en tom vogn veier. Altså vekten til kun vognen, uten passasjerer eller last.&#xA;&#x9;&#x9;if(!(weight > 0)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;weight can not be negative&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.deadweight = weight;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="428" end="-168"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491381233622" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public String getTrainCarType(){&#xA;&#x9;&#x9;return &quot;traincar&quot;;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1016" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491381434611" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Dette er en &quot; + getTrainCarType() + &quot;, og den veier &quot; + getTotalWeight() + &quot; kg." edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1074" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491381445083" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1065" end="-136"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333436759" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CargoCar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491335826782" sizeMeasure="7" errorCount="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;CargoCar(int, int) - her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;int getCargoWeight() - returnerer hvor mye lasten veier.&#xA;&#x9;setCargoWeight(int)  - setter en ny verdi for vekten til lasten." edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="46" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491336147626" sizeMeasure="28" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;public class CargoCar{&#xA;&#x9;&#xA;&#x9;private int deadweight;&#xA;&#x9;private int cargoweight;&#xA;&#x9;&#xA;&#x9;CargoCar(int deadweight, int cargoweight){&#xA;&#x9;&#x9;//- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;&#x9;if(deadweight > 0){&#xA;&#x9;&#x9;&#x9;this.deadweight = deadweight;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cargoweight > 0){&#xA;&#x9;&#x9;&#x9;this.cargoweight = cargoweight;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return cargoweight;&#xA;&#x9;&#x9;//- returnerer hvor mye lasten veier.&#xA;&#x9;}&#xA;&#x9;void setCargoWeight(int cargo){&#xA;&#x9;&#x9;//- setter en ny verdi for vekten til lasten.&#xA;&#x9;&#x9;if(cargo > 0){&#xA;&#x9;&#x9;&#x9;this.cargoweight = cargo;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="22" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491343714306" sizeMeasure="26" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" extends TrainCar{&#xA;&#x9;&#xA;&#x9;private int deadweight;&#xA;&#x9;private int cargoweight;&#xA;&#x9;&#xA;&#x9;CargoCar(int deadweight, int cargoweight){&#xA;&#x9;&#x9;//- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;&#x9;super(deadweight);" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="45" end="-291"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347284341" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="79" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347636620" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cargoweight;&#xA;&#x9;&#xA;&#x9;public CargoCar(int deadweight, int cargoweight){&#xA;&#x9;&#x9;//- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;&#x9;super(deadweight);&#xA;&#x9;&#x9;if(cargoweight > 0){&#xA;&#x9;&#x9;&#x9;this.cargoweight = cargoweight;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getCargoWeight(){&#xA;&#x9;&#x9;return cargoweight;&#xA;&#x9;&#x9;//- returnerer hvor mye lasten veier.&#xA;&#x9;}&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="79" end="-136"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491350749042" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int getTotalWeight(){&#xA;&#x9;&#x9;return deadweight+cargoweight;&#xA;&#x9;&#x9;//- returnerer vognas totale vekt. Merk at denne også skal kunne kalles på subklasser og fortsatt returnere totalvekta toil vogna (stikkord: redefinering)." edit="/1/@proposals.0/@proposals.2/@attempts.5/@edit" start="562" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491381431004" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public String getTrainCarType(){&#xA;&#x9;&#x9;return &quot;cargo car&quot;;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Dette er en &quot; + getTrainCarType() + &quot;, og den veier &quot; + getTotalWeight() + &quot; kg.&quot;+&quot;\n&quot;+&quot;lasten veier &quot;+getCargoWeight();" edit="/1/@proposals.0/@proposals.2/@attempts.6/@edit" start="802" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491333469777" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class PassengerCar {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491335826770" sizeMeasure="7" errorCount="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;PassengerCar(int, int) - her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mange passasjerer det er i vogna. &#xA;&#x9;int getPassengerCount() - returner antall passasjerer.&#xA;&#x9;setPassengerCount(int) - setter en ny verdi for antall passasjerer." edit="/1/@proposals.0/@proposals.4/@attempts.0/@edit" start="50" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491336608337" sizeMeasure="27" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#xA;&#x9;private int deadweight;&#xA;&#x9;private int passengercount;&#xA;&#x9;&#xA;&#x9;PassengerCar(int deadweight, int cargoweight){&#xA;&#x9;&#x9;//- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;&#x9;if(deadweight > 0){&#xA;&#x9;&#x9;&#x9;this.deadweight = deadweight;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(cargoweight > 0){&#xA;&#x9;&#x9;&#x9;this.passengercount = cargoweight;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;return passengercount*80;&#xA;&#x9;&#x9;//- returnerer hvor mye lasten veier.&#xA;&#x9;}&#xA;&#x9;void setCargoWeight(int cargo){&#xA;&#x9;&#x9;//- setter en ny verdi for vekten til lasten.&#xA;&#x9;&#x9;if(cargo > 0){&#xA;&#x9;&#x9;&#x9;this.passengercount = cargo;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.4/@attempts.1/@edit" start="47" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491343717821" sizeMeasure="25" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" extends TrainCar{&#xA;&#x9;&#xA;&#x9;private int deadweight;&#xA;&#x9;private int passengercount;&#xA;&#x9;&#xA;&#x9;PassengerCar(int deadweight, int cargoweight){&#xA;&#x9;&#x9;//- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;&#x9;super(deadweight);" edit="/1/@proposals.0/@proposals.4/@attempts.2/@edit" start="47" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491343925515" sizeMeasure="25" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="*80" edit="/1/@proposals.0/@proposals.4/@attempts.3/@edit" start="580" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491345342876" sizeMeasure="25" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="passengers){&#xA;&#x9;&#x9;//- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;&#x9;super(deadweight);&#xA;&#x9;&#x9;if(passengers > 0){&#xA;&#x9;&#x9;&#x9;this.passengercount = passengers" edit="/1/@proposals.0/@proposals.4/@attempts.4/@edit" start="158" end="-246"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347280950" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="passengercount;&#xA;&#x9;&#xA;&#x9;PassengerCar(int deadweight, int passengers){&#xA;&#x9;&#x9;//- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;&#x9;super(deadweight);&#xA;&#x9;&#x9;if(passengers > 0){&#xA;&#x9;&#x9;&#x9;this.passengercount = passengers;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;return passengercount;&#xA;&#x9;&#x9;//- returnerer hvor mye lasten veier.&#xA;&#x9;}&#xA;&#x9;void setPassengerCount(int passengers){&#xA;&#x9;&#x9;//- setter en ny verdi for vekten til lasten.&#xA;&#x9;&#x9;if(passengers >= 0){&#xA;&#x9;&#x9;&#x9;this.passengercount = passengers" edit="/1/@proposals.0/@proposals.4/@attempts.5/@edit" start="81" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347639398" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public PassengerCar(int deadweight, int passengers){&#xA;&#x9;&#x9;//- her tas inn hvor mye en tom vogn veier (som i TrainCar), og hvor mye vogna sin last veier.&#xA;&#x9;&#x9;super(deadweight);&#xA;&#x9;&#x9;if(passengers > 0){&#xA;&#x9;&#x9;&#x9;this.passengercount = passengers;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getPassengerCount(){&#xA;&#x9;&#x9;return passengercount;&#xA;&#x9;&#x9;//- returnerer hvor mye lasten veier.&#xA;&#x9;}&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.4/@attempts.6/@edit" start="100" end="-158"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491347662644" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.4/@attempts.7/@edit" start="288" end="-316"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491350785984" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public int getTotalWeight(){&#xA;&#x9;&#x9;return deadweight+passengercount*80;&#xA;&#x9;&#x9;//- returnerer vognas totale vekt. Merk at denne også skal kunne kalles på subklasser og fortsatt returnere totalvekta toil vogna (stikkord: redefinering)." edit="/1/@proposals.0/@proposals.4/@attempts.8/@edit" start="602" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491381547684" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public String getTrainCarType(){&#xA;&#x9;&#x9;return &quot;passenger car&quot;;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Dette er en &quot; + getTrainCarType() + &quot;, og den veier &quot; + getTotalWeight() + &quot; kg.&quot;+&quot;\n&quot;+&quot;den har &quot;+getPassengerCount()+&quot; passasjerer&quot;;" edit="/1/@proposals.0/@proposals.4/@attempts.9/@edit" start="843" end="-7"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491334768021" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class Train {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491335826797" sizeMeasure="24" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;addTrainCar(TrainCar car){&#xA;&#x9;&#x9;//- denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;}&#xA;&#x9;boolean contains(TrainCar car){&#xA;&#x9;&#x9;//- Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;}&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;//- returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;}&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;//- tilsvarende PassengerCar sin metode, men returnerer antallet for alle vognene.&#xA;&#x9;}&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;//- tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;}&#xA;&#x9;String toString(){ &#xA;&#x9;&#x9;/*- toString-metoden skal sette sammen en String med oversikt over alle vognene som er knyttet til den. &#xA;&#x9;&#x9;For hver vogn skal vogntype og totalvekt være med. &#xA;&#x9;&#x9;Passasjervogner skal i tillegg ha med antall passasjerer og lastevogner skal ha med hvor mye lasten veier.*/&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.6/@attempts.0/@edit" start="43" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491350799022" sizeMeasure="38" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class Train {&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;TrainCar> train = new ArrayList();&#xA;&#x9;&#xA;&#x9;addTrainCar(TrainCar car){&#xA;&#x9;&#x9;//- denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;&#x9;if(!train.contains(car)){&#xA;&#x9;&#x9;&#x9;train.add(car);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;boolean contains(TrainCar car){&#xA;&#x9;&#x9;//- Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;&#x9;if(train.contains(car)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.6/@attempts.1/@edit" start="22" end="-653"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491378762500" sizeMeasure="52" errorCount="7" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void addTrainCar(TrainCar car){&#xA;&#x9;&#x9;//- denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;&#x9;if(!train.contains(car)){&#xA;&#x9;&#x9;&#x9;train.add(car);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;boolean contains(TrainCar car){&#xA;&#x9;&#x9;//- Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;&#x9;if(train.contains(car)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;int getTotalWeight(){&#xA;&#x9;&#x9;//- returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;&#x9;int totalweight;&#xA;&#x9;&#x9;for(int i; i &lt; train.length(); i++){&#xA;&#x9;&#x9;&#x9;train[i].getTotalWeight();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;int getPassengerCount(){&#xA;&#x9;&#x9;//- tilsvarende PassengerCar sin metode, men returnerer antallet for alle vognene.&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int passengers;&#xA;&#x9;&#x9;for(int i; i &lt; train.length(); i++){&#xA;&#x9;&#x9;&#x9;train[i].getPassengerCount();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;int getCargoWeight(){&#xA;&#x9;&#x9;//- tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int cargoweight;&#xA;&#x9;&#x9;for(int i; i &lt; train.length(); i++){&#xA;&#x9;&#x9;&#x9;train[i].getCargoWeight();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.6/@attempts.2/@edit" start="131" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491378859634" sizeMeasure="52" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;TrainCar>" edit="/1/@proposals.0/@proposals.6/@attempts.3/@edit" start="124" end="-1286"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491384131618" sizeMeasure="56" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void addTrainCar(TrainCar ... car){&#xA;&#x9;&#x9;//- denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;&#x9;if(!train.contains(car)){&#xA;&#x9;&#x9;&#x9;train.add(car);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public boolean contains(TrainCar car){&#xA;&#x9;&#x9;//- Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;&#x9;if(train.contains(car)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getTotalWeight(){&#xA;&#x9;&#x9;//- returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;&#x9;int totalweight;&#xA;&#x9;&#x9;for(int i; i &lt; train.length(); i++){&#xA;&#x9;&#x9;&#x9;totalweight += train[i].getTotalWeight();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return totalweight;&#xA;&#x9;}&#xA;&#x9;public int getPassengerCount(){&#xA;&#x9;&#x9;//- tilsvarende PassengerCar sin metode, men returnerer antallet for alle vognene.&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int passengers;&#xA;&#x9;&#x9;for(int j; j &lt; train.length(); j++){&#xA;&#x9;&#x9;&#x9;passengers += train[j].getPassengerCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return passengers;&#xA;&#x9;}&#xA;&#x9;public int getCargoWeight(){&#xA;&#x9;&#x9;//- tilsvarende CargoCar sin metode, men returnerer lastevekten for alle vognene.&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int cargoweight;&#xA;&#x9;&#x9;for(int k; k &lt; train.length(); k++){&#xA;&#x9;&#x9;&#x9;cargoweight += train[k].getCargoWeight();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return cargoweight;&#xA;&#x9;}&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return null;" edit="/1/@proposals.0/@proposals.6/@attempts.4/@edit" start="141" end="-280"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491401726322" sizeMeasure="56" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.6/@attempts.5/@edit" start="174" end="-1413"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491404206086" sizeMeasure="56" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="car){&#xA;&#x9;&#x9;//- denne metoden skal ta inn en togvogn og knytte den til dette lokomotivet.&#xA;&#x9;&#x9;if(!train.contains(car)){&#xA;&#x9;&#x9;&#x9;train.add(car);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public boolean contains(TrainCar car){&#xA;&#x9;&#x9;//- Sjekker om lokomotivet har TrainCar-argument knyttet til seg.&#xA;&#x9;&#x9;if(train.contains(car)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getTotalWeight(){&#xA;&#x9;&#x9;//- returner alle vognene sin totale vekt. Vi tar ikke høyde for lokomotivet sin eventuelle vekt.&#xA;&#x9;&#x9;int totalweight = 0;&#xA;&#x9;&#x9;for(int i; i &lt; train.size(); i++){&#xA;&#x9;&#x9;&#x9;totalweight += train.get(i)" edit="/1/@proposals.0/@proposals.6/@attempts.6/@edit" start="174" end="-871"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491404226745" sizeMeasure="56" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0" edit="/1/@proposals.0/@proposals.6/@attempts.7/@edit" start="665" end="-927"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491404509013" sizeMeasure="58" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;&#x9;for(int j = 0; j &lt; train.size(); j++){&#xA;&#x9;&#x9;&#x9;if(train.get(i) instanceof PassengerCar){&#xA;&#x9;&#x9;&#x9;&#x9;passengers += ((PassengerCar) train.get(j)).getPassengerCount();&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.6/@attempts.8/@edit" start="910" end="-599"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491404531227" sizeMeasure="58" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="j" edit="/1/@proposals.0/@proposals.6/@attempts.9/@edit" start="973" end="-700"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491404684061" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = 0;&#xA;&#x9;&#x9;for(int k = 0; k &lt; train.size(); k++){&#xA;&#x9;&#x9;&#x9;if(train.get(k) instanceof CargoCar){&#xA;&#x9;&#x9;&#x9;&#x9;cargoweight += ((CargoCar) train.get(k)).getCargoWeight();&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.6/@attempts.10/@edit" start="1238" end="-351"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491335827660" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491347771032" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491404083378" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491404089061" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491343875496" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491343929848" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491344012471" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491350809957" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491404101896" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.10/@q" answer="/0/@parts.0/@tasks.10/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491336165374" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491343731801" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491345343390" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491347779721" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491350799513" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491404092586" completion="1.0" successCount="1"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.11/@q" answer="/0/@parts.0/@tasks.11/@a" completion="0.75">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491401846782" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491402624350" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491404211175" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491404230585" completion="0.5" successCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491404511293" completion="0.5" successCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491404533150" completion="0.75" successCount="3" errorCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
