<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490717320548" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class AbstractAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718360436" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="abstract class AbstractAccount {&#xA;&#x9;double balance; &#xA;&#x9;&#xA;&#x9;public AbstractAccount(){&#xA;&#x9;&#x9;this.balance=0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deposit(double deposit){&#xA;&#x9;&#x9;if (deposit>=0){&#xA;&#x9;&#x9;&#x9;this.balance+=deposit;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(); &#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void withdraw(double amount){&#xA;&#x9;&#x9;internalWithdraw(amount); //implementeres i subkasser&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;abstract void internalWithdraw(double withdraw); //skal implementeres i hver subklasse&#xA;&#x9;&#xA;&#x9;public double getbalance(){&#xA;&#x9;&#x9;return balance;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="22" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718800163" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;abstract void internalWithdraw(double withdraw); " edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="336" end="-56"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718906624" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="B" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="413" end="-34"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490717352766" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718724527" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public DebitAccount(){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double withdraw) {&#xA;&#x9;&#x9;if (withdraw>balance){&#xA;&#x9;&#x9;&#x9;balance -= withdraw; &#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(); &#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="48" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718800128" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="177" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718819264" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(&quot;hei&quot;);" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="215" end="-65"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718839522" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this." edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="178" end="-129"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718948829" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=">" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="177" end="-134"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490718962236" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="177" end="-134"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719001242" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.balance -= withdraw; &#xA;&#x9;&#x9;&#x9;System.out.println(balance" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="196" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719026745" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.balance);&#xA;&#x9;&#x9;&#x9;System.out.println(withdraw" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="245" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719084434" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(withdraw);&#xA;&#x9;&#x9;&#x9;System.out.println(this.balance);&#xA;&#x9;&#x9;&#x9;this.balance -= withdraw; &#xA;&#x9;&#x9;&#x9;System.out.println(this.balance" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="196" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719144049" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; withdraw>0" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="190" end="-204"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719162514" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="203" end="-205"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719371729" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="376" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719390665" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Argument" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="376" end="-25"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719496316" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="super();" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="104" end="-305"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719656851" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;} else if(withdraw>=0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(); &#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;System.out.println(withdraw);&#xA;&#x9;&#x9;&#x9;System.out.println(this.balance);&#xA;&#x9;&#x9;&#x9;this.balance -= withdraw; &#xA;&#x9;&#x9;&#x9;System.out.println(this.balance);" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="198" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719719411" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=">=0) {&#xA;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;} else if (withdraw&lt;this.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalState" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="185" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719757075" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;} else if (withdraw>" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="185" end="-213"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490719770524" sizeMeasure="21">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.balance -= withdraw; " edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="322" end="-12"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490717338634" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720207292" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount{&#xA;&#x9;double creditLine;&#xA;&#x9;&#xA;&#x9;public CreditAccount(double creditLine){&#xA;&#x9;&#x9;if (creditLine&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.creditLine=creditLine;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double withdraw) {&#xA;&#x9;&#x9;if (withdraw&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;} else if (withdraw>(this.balance+this.creditLine)){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.balance -= withdraw;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="49" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720246472" sizeMeasure="30">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void setCreditLine(double creditLine){&#xA;&#x9;&#x9;this.creditLine=creditLine;" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="507" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720273219" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (creditLine&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.creditLine=creditLine;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="558" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720326140" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public double getCreditLine(){&#xA;&#x9;&#x9;return this.creditLine;" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="667" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720465470" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(balance+creditLine&lt;0){&#xA;&#x9;&#x9;&#x9;throw new IllegalState" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="627" end="-129"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490717375376" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490720805857" sizeMeasure="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends AbstractAccount {&#xA;&#x9;int withdrawls;&#xA;&#x9;double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawls, double fee){&#xA;&#x9;&#x9;this.withdrawls=withdrawls;&#xA;&#x9;&#x9;this.fee=fee; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double withdraw) {&#xA;&#x9;&#x9;if (withdraw&lt;0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;} else if (withdraw>this.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(); &#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.balance -= withdraw; &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="51" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490721136686" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int counter;&#xA;&#x9;double fee;&#xA;&#x9;&#xA;&#x9;public SavingsAccount2(int withdrawls, double fee){&#xA;&#x9;&#x9;this.withdrawls=withdrawls;&#xA;&#x9;&#x9;this.fee=fee; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double withdraw) {&#xA;&#x9;&#x9;if (withdraw&lt;0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;} else if (withdraw>this.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(); &#xA;&#x9;&#x9;} else if(counter>=withdrawls &amp;&amp; (withdraw+fee)>this.balance){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(); &#xA;&#x9;&#x9;} else if(counter>=withdrawls) {&#xA;&#x9;&#x9;&#x9;this.balance -= fee;&#xA;&#x9;&#x9;&#x9;this.balance -= withdraw;&#xA;&#x9;&#x9;&#x9;this.counter ++; &#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.balance -= withdraw;&#xA;&#x9;&#x9;&#x9;this.counter ++" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="95" end="-17"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490718725859" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490718801308" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490718820328" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490718840685" completion="0.0" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490718907774" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490718949924" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490718963273" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719002365" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719027972" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719085553" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719145167" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719163575" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719372897" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719391757" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719497459" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719657971" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719722501" completion="0.5" successCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490719758217" completion="1.0" successCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720208614" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720248190" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720274293" completion="0.6666666666666666" successCount="2" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720327350" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720466599" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490720807289" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490721137831" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
