<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="AbstractAccount">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the abstract AbstractAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.AbstractAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the DebitAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DebitAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.DebitAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the CreditAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CreditAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.CreditAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write the source code for the SavingsAccount2 class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SavingsAccount2 class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="inheritance.SavingsAccount2"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DebitAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.DebitAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CreditAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.CreditAccountTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SavingsAccount2Test JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="inheritance.SavingsAccount2Test"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="inheritance.*Account*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307462224" sizeMeasure="12">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class AbstractAccount&#xA;{&#xA;&#xA;&#x9;public static void main(String[] args)&#xA;&#x9;{&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307667595" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="abstract class AbstractAccount&#xA;{&#xA;&#x9;protected double balance;&#xA;&#x9;protected double rent;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void deposit(double amount)&#xA;&#x9;{&#xA;&#x9;&#x9;if (amount >= 0)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;balance += amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public void withdraw(double amount)&#xA;&#x9;{&#xA;&#x9;&#x9;if (amount >= 0)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;internalWithdraw(amount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;abstract void internalWithdraw(double amount);&#xA;&#xA;&#x9;public double getBalance()&#xA;&#x9;{&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return balance;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void endYearUpdate()&#xA;&#x9;{&#xA;&#x9;&#x9;balance = balance * (1 + rent);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="29" end="-89"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307686812" sizeMeasure="19">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class DebitAccount extends AbstractAccount&#xA;{&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount)&#xA;&#x9;{&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args)&#xA;&#x9;{&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307812024" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#x9;DebitAccount()&#xA;&#x9;{&#xA;&#x9;&#x9;balance = 0;&#xA;&#x9;&#x9;rent = 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount)&#xA;&#x9;{&#xA;&#x9;&#x9;if (amount &lt;= balance)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;balance += amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="74" end="-94"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307835708" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="220" end="-163"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307854939" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="State" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="266" end="-110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307862390" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="380" end="-381"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1491307831790" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1491307861145" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307891514" sizeMeasure="12">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class CreditAccount&#xA;{&#xA;&#xA;&#x9;public static void main(String[] args)&#xA;&#x9;{&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307942663" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" extends AbstractAccount&#xA;{&#xA;&#x9;&#xA;&#x9;CreditAccount()&#xA;&#x9;{&#xA;&#x9;&#x9;balance = 0;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount)&#xA;&#x9;{&#xA;&#x9;&#x9;if (amount &lt;= balance)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.3/@attempts.0/@edit" start="48" end="-90"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491307985514" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="double creditLine;&#xA;&#x9;&#xA;&#x9;CreditAccount(double creditLine)&#xA;&#x9;{&#xA;&#x9;&#x9;balance = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.creditLine = creditLine;" edit="/1/@proposals.0/@proposals.3/@attempts.1/@edit" start="78" end="-259"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308094076" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public double getCreditLine()&#xA;&#x9;{&#x9;&#xA;&#x9;&#x9;return creditLine;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setCreditLine(double creditLine)&#xA;&#x9;{&#xA;&#x9;&#x9;if (creditLine &lt; 0)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.creditLine = creditLine;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.3/@attempts.2/@edit" start="78" end="-368"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308228210" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (balance &lt; 0 &amp;&amp; creditLine &lt; Math.abs(balance))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalState" edit="/1/@proposals.0/@proposals.3/@attempts.3/@edit" start="259" end="-423"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308251819" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + creditLin" edit="/1/@proposals.0/@proposals.3/@attempts.4/@edit" start="584" end="-179"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308331464" sizeMeasure="19">
          <edit xsi:type="exercise:StringEdit" storedString="package inheritance;&#xA;&#xA;public class SavingsAccount2 extends AbstractAccount&#xA;{&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount)&#xA;&#x9;{&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args)&#xA;&#x9;{&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308348959" sizeMeasure="25">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;SavingsAccount2()&#xA;&#x9;{&#xA;&#x9;&#x9;balance = 0;&#xA;&#x9;&#x9;rent = 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.0/@edit" start="77" end="-184"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308363728" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount &lt;= balance)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.5/@attempts.1/@edit" start="186" end="-94"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308444295" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int uttak;&#xA;&#x9;double fee;&#xA;&#x9;&#xA;&#x9;SavingsAccount2(int uttak, double fee)&#xA;&#x9;{&#xA;&#x9;&#x9;balance = 0;&#xA;&#x9;&#x9;rent = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.uttak = uttak;&#xA;&#x9;&#x9;this.fee = fee" edit="/1/@proposals.0/@proposals.5/@attempts.2/@edit" start="80" end="-259"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308544035" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int cuttak;&#xA;&#x9;double fee;&#xA;&#x9;&#xA;&#x9;SavingsAccount2(int uttak, double fee)&#xA;&#x9;{&#xA;&#x9;&#x9;balance = 0;&#xA;&#x9;&#x9;rent = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.uttak = uttak;&#xA;&#x9;&#x9;cuttak = 0;&#xA;&#x9;&#x9;this.fee = fee;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;void internalWithdraw(double amount)&#xA;&#x9;{&#xA;&#x9;&#x9;if (amount &lt;= balance)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (cuttak &lt; uttak)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;balance -= amount;&#xA;&#x9;&#x9;&#x9;&#x9;cuttak++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;balance -= (amount + fee);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.3/@edit" start="92" end="-151"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1491308753095" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (amount + fee &lt;= balance)&#xA;&#x9;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;balance -= (amount + fee);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalStateException();&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.5/@attempts.4/@edit" start="418" end="-164"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491307819624" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491307838585" completion="0.5" successCount="1" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491307866505" completion="1.0" successCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.8/@q" answer="/0/@parts.0/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308260751" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.9/@q" answer="/0/@parts.0/@tasks.9/@a" completion="0.5">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1491308558483" completion="0.5" successCount="1" failureCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
