<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310192180" sizeMeasure="18" errorCount="4">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;&#x9;public class Tweet{&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public Tweet(TwitterAccount accName, String newTweet){&#xA;&#x9;&#x9;&#x9;this.name = accName;&#xA;&#x9;&#x9;&#x9;this.tweetText = newTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public Tweet(TwitterAccount accName, Tweet tweetRe){&#xA;&#x9;&#x9;&#x9;if(!tweetRe.isRetweet){&#xA;&#x9;&#x9;&#x9;&#x9;orginal = tweetRe;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="121" charEnd="125" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="155" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="257" charEnd="266" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="274" charEnd="281" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310290033" sizeMeasure="27" errorCount="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweetRe.retweets += 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;this.orginal = tweetRe.oriTweet;&#xA;&#x9;&#x9;&#x9;&#x9;this.oriTweet.retwweets += 1;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(accName == tweetRe.getOwner()){&#xA;&#x9;&#x9;&#x9;&#x9;theow new IllegalArgumentException(&quot;Can retweet your own tweet!&quot;)" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="283" end="-17"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="121" charEnd="125" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="155" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="257" charEnd="266" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="274" charEnd="281" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="306" charEnd="314" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="348" charEnd="355" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="366" charEnd="374" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="386" charEnd="394" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="421" charEnd="430" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="441" charEnd="450" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="484" charEnd="492" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="502" charEnd="507" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="502" charEnd="507" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="502" charEnd="507" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310299433" sizeMeasure="28" errorCount="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this." edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="550" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="348" charEnd="355" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="366" charEnd="374" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="386" charEnd="394" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="421" charEnd="430" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="441" charEnd="450" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="502" charEnd="507" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="502" charEnd="507" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="502" charEnd="507" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="574" charEnd="578" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="574" charEnd="578" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="574" charEnd="578" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="121" charEnd="125" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="155" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="257" charEnd="266" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="274" charEnd="281" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="306" charEnd="314" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310306452" sizeMeasure="28" errorCount="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="row new IllegalArgumentException(&quot;Can retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;this.isRe" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="482" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="441" charEnd="450" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="484" charEnd="492" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="579" charEnd="583" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="579" charEnd="583" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="579" charEnd="583" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="121" charEnd="125" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="155" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="257" charEnd="266" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="274" charEnd="281" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="306" charEnd="314" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="348" charEnd="355" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="366" charEnd="374" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="386" charEnd="394" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="421" charEnd="430" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310322770" sizeMeasure="28" errorCount="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ginal;&#xA;&#x9;&#x9;&#x9;&#x9;this.orginal" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="351" end="-200"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="121" charEnd="125" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="155" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="257" charEnd="266" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="274" charEnd="281" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="306" charEnd="314" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="348" charEnd="355" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="366" charEnd="373" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="385" charEnd="392" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="419" charEnd="428" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="439" charEnd="448" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="482" charEnd="490" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="577" charEnd="581" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="577" charEnd="581" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="577" charEnd="581" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310338763" sizeMeasure="28" errorCount="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="549" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="155" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="257" charEnd="266" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="274" charEnd="281" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="306" charEnd="314" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="348" charEnd="355" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="366" charEnd="373" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="385" charEnd="392" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="419" charEnd="428" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="439" charEnd="448" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="482" charEnd="490" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="121" charEnd="125" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310346446" sizeMeasure="34" errorCount="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweetRe.getOriginalTweet() != null &amp;&amp; oriTweet.getOwner()==accName)&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;&#x9;&#x9;this.name = accName;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="549" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="121" charEnd="125" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="155" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="257" charEnd="266" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="274" charEnd="281" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="306" charEnd="314" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="348" charEnd="355" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="366" charEnd="373" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="385" charEnd="392" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="419" charEnd="428" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="439" charEnd="448" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="482" charEnd="490" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="584" charEnd="600" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="614" charEnd="622" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="729" charEnd="738" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="757" charEnd="761" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="783" charEnd="792" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="803" charEnd="812" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="839" charEnd="840" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310360760" sizeMeasure="34" errorCount="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ginal" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="593" end="-210"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="614" charEnd="621" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="728" charEnd="737" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="756" charEnd="760" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="782" charEnd="791" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="802" charEnd="811" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="838" charEnd="839" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="121" charEnd="125" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="146" charEnd="155" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="257" charEnd="266" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="274" charEnd="281" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="306" charEnd="314" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="348" charEnd="355" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="366" charEnd="373" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="385" charEnd="392" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="419" charEnd="428" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="439" charEnd="448" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="482" charEnd="490" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="584" charEnd="600" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310412628" sizeMeasure="38" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private TwitterAccount name;&#xA;&#x9;&#x9;private boolean isRetweet;&#xA;&#x9;&#x9;private int retweets;&#xA;&#x9;&#x9;private Tweet orignial;&#xA;&#x9;&#x9;private String tweetText;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="171" end="-637"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="413" charEnd="420" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="487" charEnd="494" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="505" charEnd="512" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="524" charEnd="531" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="621" charEnd="629" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="723" charEnd="739" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="753" charEnd="760" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="977" charEnd="978" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310418554" sizeMeasure="38" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="in" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="273" end="-668"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="413" charEnd="420" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="487" charEnd="494" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="505" charEnd="512" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="524" charEnd="531" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="621" charEnd="629" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="723" charEnd="739" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="753" charEnd="760" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="977" charEnd="978" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310430971" sizeMeasure="38" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="iginal = tweetRe;&#xA;&#x9;&#x9;&#x9;&#x9;tweetRe.retweets += 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;this.original = tweetRe.original;&#xA;&#x9;&#x9;&#x9;&#x9;this.original.retwweets += 1;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(accName == tweetRe.getOwner()){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;if (tweetRe.getOriginalTweet() != null &amp;&amp; ori" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="398" end="-215"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="536" charEnd="545" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="625" charEnd="633" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="727" charEnd="743" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="766" charEnd="774" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="982" charEnd="983" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310441339" sizeMeasure="37" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="932" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="536" charEnd="545" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="625" charEnd="633" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="727" charEnd="743" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="766" charEnd="774" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="980" charEnd="981" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310444771" sizeMeasure="35" errorCount="4" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="932" end="-3"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="203" charEnd="207" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="536" charEnd="545" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="625" charEnd="633" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="727" charEnd="743" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="766" charEnd="774" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310456473" sizeMeasure="35" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="518" end="-424"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="203" charEnd="207" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="624" charEnd="632" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="726" charEnd="742" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="765" charEnd="773" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310470527" sizeMeasure="36" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="eets += 1;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(accName == tweetRe.getOwner()){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;if (tweetRe.getOriginalTweet() != null &amp;&amp; original.getOwner()==accName)&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;&#x9;&#x9;this.name = accName;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;public String" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="518" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="726" charEnd="742" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="765" charEnd="773" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="974" charEnd="980" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="974" charEnd="980" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="624" charEnd="632" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310496797" sizeMeasure="40" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" getText(){&#xA;&#x9;&#x9;&#x9;&#x9;if(this.isRetweet){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.original.tweetText;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="947" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="989" charEnd="990" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="1023" charEnd="1054" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="624" charEnd="632" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="726" charEnd="742" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="765" charEnd="773" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="981" charEnd="988" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="981" charEnd="988" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="989" charEnd="990" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310513103" sizeMeasure="42" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.name" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1025" end="-23"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="624" charEnd="632" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="726" charEnd="742" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="765" charEnd="773" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="981" charEnd="988" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="981" charEnd="988" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="989" charEnd="990" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="989" charEnd="990" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="1023" charEnd="1054" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1073" charEnd="1090" severity="2" problemCategory="50" problemType="67108969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310543216" sizeMeasure="43" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public TwitterAccount getOwner(){" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1063" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="726" charEnd="742" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="954" charEnd="955" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1080" charEnd="1089" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1089" charEnd="1090" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1152" charEnd="1153" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310557104" sizeMeasure="46" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;public Tweet getOriginalTweet" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1101" end="-19"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="954" charEnd="955" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1080" charEnd="1089" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1089" charEnd="1090" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1221" charEnd="1222" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310563503" sizeMeasure="48" errorCount="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;return this.original;&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1167" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="624" charEnd="632" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="726" charEnd="742" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="765" charEnd="773" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="981" charEnd="988" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="981" charEnd="988" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="989" charEnd="990" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="989" charEnd="990" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="1023" charEnd="1054" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1073" charEnd="1090" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1125" charEnd="1133" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1125" charEnd="1133" severity="2" problemCategory="50" problemType="67109260"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1134" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1134" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="41" charStart="1143" charEnd="1160" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1186" charEnd="1202" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1186" charEnd="1202" severity="2" problemCategory="50" problemType="67109260"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1203" charEnd="1204" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1203" charEnd="1204" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1212" charEnd="1233" severity="2" problemCategory="50" problemType="67108969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310576694" sizeMeasure="51" errorCount="24">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.retweets" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1200" end="-23"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="624" charEnd="632" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="726" charEnd="742" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="765" charEnd="773" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="981" charEnd="988" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="981" charEnd="988" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="989" charEnd="990" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="989" charEnd="990" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="1023" charEnd="1054" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="1073" charEnd="1090" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1125" charEnd="1133" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1125" charEnd="1133" severity="2" problemCategory="50" problemType="67109260"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1134" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1134" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="41" charStart="1143" charEnd="1160" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1186" charEnd="1202" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1186" charEnd="1202" severity="2" problemCategory="50" problemType="67109260"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1203" charEnd="1204" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1203" charEnd="1204" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1212" charEnd="1233" severity="2" problemCategory="50" problemType="67108969"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1257" charEnd="1272" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1257" charEnd="1272" severity="2" problemCategory="50" problemType="67109260"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1273" charEnd="1274" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1273" charEnd="1274" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1282" charEnd="1303" severity="2" problemCategory="50" problemType="67108969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311230656" sizeMeasure="56" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;public Tweet(TwitterAccount accName, Tweet tweetRe){&#xA;&#x9;&#x9;&#x9;if(!tweetRe.isRetweet){&#xA;&#x9;&#x9;&#x9;&#x9;original = tweetRe;&#xA;&#x9;&#x9;&#x9;&#x9;tweetRe.retweets += 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;this.original = tweetRe.original;&#xA;&#x9;&#x9;&#x9;&#x9;this.original.retweets += 1;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(accName == tweetRe.getOwner()){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;if (tweetRe.getOriginalTweet() != null &amp;&amp; original.getOwner()==accName)&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;&#x9;&#x9;this.name = accName;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;private TwitterAccount name;&#xA;&#x9;&#x9;&#x9;private boolean isRetweet;&#xA;&#x9;&#x9;&#x9;private int retweets;&#xA;&#x9;&#x9;&#x9;private Tweet original;&#xA;&#x9;&#x9;&#x9;private String tweetText;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="170" end="-349"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1108" charEnd="1117" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1117" charEnd="1118" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1343" charEnd="1344" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311252588" sizeMeasure="55" errorCount="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1294" end="-15"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1178" charEnd="1187" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1214" charEnd="1230" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1214" charEnd="1230" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1231" charEnd="1232" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1231" charEnd="1232" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1247" charEnd="1260" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1285" charEnd="1300" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1285" charEnd="1300" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1301" charEnd="1302" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1301" charEnd="1302" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1317" charEnd="1330" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="484" charEnd="492" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="586" charEnd="602" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="625" charEnd="633" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1108" charEnd="1117" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1153" charEnd="1161" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1153" charEnd="1161" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1162" charEnd="1163" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1162" charEnd="1163" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311291017" sizeMeasure="56" errorCount="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;private TwitterAccount name;&#xA;&#x9;&#x9;&#x9;private boolean isRetweet;&#xA;&#x9;&#x9;&#x9;private int retweets;&#xA;&#x9;&#x9;&#x9;private Tweet original;&#xA;&#x9;&#x9;&#x9;private String tweetText;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;public String getText(){&#xA;&#x9;&#x9;&#x9;&#x9;if(this.isRetweet){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.original.tweetText;&#xA;&#x9;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.original;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.retweets;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="800" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1288" charEnd="1303" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1288" charEnd="1303" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1304" charEnd="1305" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1304" charEnd="1305" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1320" charEnd="1333" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="484" charEnd="492" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="586" charEnd="602" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="625" charEnd="633" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1111" charEnd="1120" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1156" charEnd="1164" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1156" charEnd="1164" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1165" charEnd="1166" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1165" charEnd="1166" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1181" charEnd="1190" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1217" charEnd="1233" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1217" charEnd="1233" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1234" charEnd="1235" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1234" charEnd="1235" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1250" charEnd="1263" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311417430" sizeMeasure="57" errorCount="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;&#x9;&#x9;this.name = accName;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="622" end="-508"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="484" charEnd="492" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="586" charEnd="602" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="625" charEnd="633" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1117" charEnd="1126" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1162" charEnd="1170" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1162" charEnd="1170" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1171" charEnd="1172" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1171" charEnd="1172" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1187" charEnd="1196" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1223" charEnd="1239" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1223" charEnd="1239" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1240" charEnd="1241" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1240" charEnd="1241" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1256" charEnd="1269" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1294" charEnd="1309" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1294" charEnd="1309" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1310" charEnd="1311" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1310" charEnd="1311" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1326" charEnd="1339" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311588906" sizeMeasure="57" errorCount="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetText" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1078" end="-222"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1299" charEnd="1314" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1315" charEnd="1316" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1315" charEnd="1316" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="54" charStart="1331" charEnd="1344" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="484" charEnd="492" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="586" charEnd="602" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="625" charEnd="633" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1167" charEnd="1175" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1167" charEnd="1175" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1176" charEnd="1177" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1176" charEnd="1177" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1192" charEnd="1201" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1228" charEnd="1244" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1228" charEnd="1244" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1245" charEnd="1246" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1245" charEnd="1246" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1261" charEnd="1274" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1299" charEnd="1314" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312005308" sizeMeasure="56" errorCount="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;if (tweetRe.getOriginalTweet() != null &amp;&amp; original.getOwner()==accName)&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;this.isRetweet = true;&#xA;&#x9;&#x9;&#x9;&#x9;this.name = accName;&#xA;&#x9;&#x9;&#x9;&#x9;this.tweetText = tweetRe.tweetText;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="474" end="-506"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="484" charEnd="492" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="585" charEnd="601" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="624" charEnd="632" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1157" charEnd="1165" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1157" charEnd="1165" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1166" charEnd="1167" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1166" charEnd="1167" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1182" charEnd="1191" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1218" charEnd="1234" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1218" charEnd="1234" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1235" charEnd="1236" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1235" charEnd="1236" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1251" charEnd="1264" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1289" charEnd="1304" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1289" charEnd="1304" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1305" charEnd="1306" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1305" charEnd="1306" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1321" charEnd="1334" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312164006" sizeMeasure="56" errorCount="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="580" end="-719"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="22" charStart="484" charEnd="492" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="585" charEnd="601" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="623" charEnd="631" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1156" charEnd="1164" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1156" charEnd="1164" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1165" charEnd="1166" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1165" charEnd="1166" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1181" charEnd="1190" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1217" charEnd="1233" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1217" charEnd="1233" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1234" charEnd="1235" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1234" charEnd="1235" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1250" charEnd="1263" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1288" charEnd="1303" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1288" charEnd="1303" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1304" charEnd="1305" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1304" charEnd="1305" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1320" charEnd="1333" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313219669" sizeMeasure="57" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1295" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="55" charStart="1346" charEnd="1347" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1120" charEnd="1121" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313225329" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;&#x9;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.original;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return this.retweets;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1089" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1353" charEnd="1354" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313441046" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="t" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="518" end="-790"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1354" charEnd="1355" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313455875" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="'t retweet your own tweet!&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;if (tweetRe.getOriginalTweet()!= null &amp;&amp; original.getOwner()==accName)&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can't retweet your ow" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="518" end="-625"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1355" charEnd="1356" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313495301" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1298" end="-13"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="57" charStart="1358" charEnd="1359" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313501980" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="1300" end="-13"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1355" charEnd="1356" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488313552302" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1300" end="-5"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310603462" sizeMeasure="5" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;import java.util.ArrayList;&#xA;public class TwitterAccount {&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="2" charStart="34" charEnd="53" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310605631" sizeMeasure="7" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;import java.util.ArrayList;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="26" end="-35"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="55" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310621675" sizeMeasure="11" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public TwitterAccount(String userName){&#xA;&#x9;&#x9;this.name = userName;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="87" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="142" charEnd="146" severity="2" problemCategory="50" problemType="33554502"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310636680" sizeMeasure="14" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private ArrayList&lt;Tweet>&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="157" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="142" charEnd="146" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="191" charEnd="192" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="191" charEnd="192" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="191" charEnd="192" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310666964" sizeMeasure="15" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;private String name;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="182" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="243" charEnd="247" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310669277" sizeMeasure="16" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private " edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="239" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="251" charEnd="258" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="251" charEnd="258" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310695085" sizeMeasure="16" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="247" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="243" charEnd="247" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="285" charEnd="294" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310696907" sizeMeasure="17" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="322" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="243" charEnd="247" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="285" charEnd="294" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310702506" sizeMeasure="17" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private " edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="319" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="332" charEnd="339" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="332" charEnd="339" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310728901" sizeMeasure="17" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;TwitterAccount> following= new ArrayList&lt;TwitterAccount>();" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="327" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="243" charEnd="247" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="285" charEnd="294" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="366" charEnd="375" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310748376" sizeMeasure="20" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public String getUserName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="400" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="285" charEnd="294" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="366" charEnd="375" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310755935" sizeMeasure="20" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void follow(TwitterAccount)" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="453" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="489" charEnd="490" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="489" charEnd="490" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="467" charEnd="468" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310765317" sizeMeasure="22" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" account){&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="486" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="285" charEnd="294" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="366" charEnd="375" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310776113" sizeMeasure="22" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.followers.add(this));" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="499" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="545" charEnd="546" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310779109" sizeMeasure="22" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="526" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="366" charEnd="375" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310787192" sizeMeasure="23" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="526" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="14" charStart="366" charEnd="375" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310794550" sizeMeasure="23" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.following.add(account);" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="530" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310806275" sizeMeasure="24" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void unfollow(TwitterAccount account){" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="562" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="632" charEnd="633" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310820879" sizeMeasure="27" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;account.followers.reomve(this);&#xA;&#x9;&#x9;this.following.remove(account);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="609" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="652" charEnd="658" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310824589" sizeMeasure="28" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.following.remove(account);&#xA;&#x9;&#x9;account.followers.reomve(this);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="611" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="687" charEnd="693" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310827385" sizeMeasure="27" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="678" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="687" charEnd="693" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310829553" sizeMeasure="27" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="move(this);" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="665" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310856116" sizeMeasure="30" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="680" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="27" charStart="722" charEnd="757" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310864177" sizeMeasure="30" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.following.contains(account);" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="735" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310885724" sizeMeasure="31" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public boolean isFollowedBy(TwitterAccount account){" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="779" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="31" charStart="863" charEnd="864" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310905313" sizeMeasure="36" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;return account.following.contains(this);&#xA;&#x9;}&#xA;&#x9;public void tweet(String twee){&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="833" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="193" charEnd="199" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310927218" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweets.add(new Tweet(this, twee));" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="914" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310939833" sizeMeasure="39" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;return this." edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="957" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="1033" charEnd="1037" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="1037" charEnd="1038" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310962235" sizeMeasure="40" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweets.get(tweets.size()-1);&#xA;&#x9;}&#xA;&#x9;public int getTweetCount" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="1002" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="39" charStart="1084" charEnd="1097" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310971358" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(){&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="1059" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="39" charStart="1084" charEnd="1099" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310975963" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return tweets.size();" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="1065" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488310991190" sizeMeasure="45" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="1090" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="1143" charEnd="1160" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311012870" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int retweetCount = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; tweets.size(); i++){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="1123" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="1143" charEnd="1160" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311040908" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweetCount += tweets.get(i).getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return retweetCount;" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1190" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1264" charEnd="1279" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311047495" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1271" end="-1272"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1264" charEnd="1279" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311062253" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="156" end="-1116"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1261" charEnd="1276" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311136825" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="156" end="-1116"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1261" charEnd="1276" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311318638" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="156" end="-1116"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1261" charEnd="1276" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488311360497" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;private String name;&#xA;&#x9;private ArrayList&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private ArrayList&lt;TwitterAccount> following= new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;account.followers.add(this);&#xA;&#x9;&#x9;this.following.add(account);&#xA;&#x9;}&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;this.following.remove(account);&#xA;&#x9;&#x9;account.followers.remove(this);&#xA;&#x9;}&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;return this.following.contains(account);&#xA;&#x9;}&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;return account.following.contains(this);&#xA;&#x9;}&#xA;&#x9;public void tweet(String twee){&#xA;&#x9;&#x9;this.tweets.add(new Tweet(this, twee));&#xA;&#x9;}&#xA;&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;return this.tweets.get(tweets.size()-1);&#xA;&#x9;}&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;for(int i = 0; i &lt; tweets.size(); i++){&#xA;&#x9;&#x9;&#x9;count += tweets.get(i).getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return c" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="156" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1247" charEnd="1262" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312366030" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.followers.remove(this);&#xA;&#x9;&#x9;this.following.remove(account);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="609" end="-575"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1251" charEnd="1266" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312458170" sizeMeasure="53" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void retweet(Tweet tweet) { &#xA;&#x9;&#x9;this.tweets.add(new Tweet(this,tweet));&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="966" end="-295"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1338" charEnd="1353" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312561294" sizeMeasure="53" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="i" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="1111" end="-223"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1338" charEnd="1353" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488312603551" sizeMeasure="53" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="1334" end="-1335"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1338" charEnd="1353" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310142794" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310471091" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310637091" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310641129" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310641962" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310642661" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310643524" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310645847" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310779569" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310780105" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310780953" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310781841" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310782964" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310783981" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310962768" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310963645" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310964477" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310965385" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311049137" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311102449" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311103524" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311319087" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311513841" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311529118" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311531737" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311615466" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312820067" completion="0.0" errorCount="4">
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorNewTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313562478" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488310136417" completion="0.0" errorCount="6">
          <errorTests>testGetTweetIllegal</errorTests>
          <errorTests>testUnfollow</errorTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testFollow</errorTests>
          <errorTests>testConstructor</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311521030" completion="0.5" successCount="3" failureCount="1" errorCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311522070" completion="0.5" successCount="3" failureCount="1" errorCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488311611681" completion="0.5" successCount="3" failureCount="1" errorCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312859998" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488312976672" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313228956" completion="0.5" successCount="3" errorCount="3">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testGetTweetIllegal</errorTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313474046" completion="0.5" successCount="3" errorCount="3">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testGetTweetIllegal</errorTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313554589" completion="1.0" successCount="6">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488313559988" completion="1.0" successCount="6">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
