<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Partner">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Partner class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Partner class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Partner"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PartnerTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PartnerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Partner" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583819897" sizeMeasure="33" warningCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;&#xA;/**&#xA; * The Partner class creates an object Partner which has a name&#xA; * and can be linked to another partner (Marriage)&#xA; * &#xA; * The public class setPartner(Partner x) operation that links two Partners together.&#xA; * setPartner() divorce the two partners (nothing happens if the partner object don't have a partner&#xA; * &#xA; * The public class getPartner() that returns this partner's partner. If this partner do not have a partner it returns a null reference&#xA; * &#xA; * The public class toString() returns the name of this partner and if (s)he has a partner, the partner's name&#xA; * &#xA; * @author Sebastian&#xA; *&#xA; */&#xA;public class Partner {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;&#xA;&#x9;private Partner partner = null;&#xA;&#x9;&#xA;&#x9;/**&#xA;&#x9; * Creates a partner object with no &#xA;&#x9; * @param name&#xA;&#x9; */&#xA;&#x9;public Partner(String name){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584032553" sizeMeasure="49" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="partner&#xA;&#x9; * @param name, the name of this partner&#xA;&#x9; */&#xA;&#x9;public Partner(String name){&#xA;&#x9;&#x9;if (isValid(name)){&#xA;&#x9;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if the input is a valid name&#xA;&#x9; * only letters [a-zA-Z]+ is valid&#xA;&#x9; * @param name&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(String name) {&#xA;&#x9;&#x9;if(name.matches(&quot;[a-zA-Z]+&quot;)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="751" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584566459" sizeMeasure="62" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = null;&#xA;&#x9;&#xA;&#x9;private Partner partner = null;&#xA;&#x9;&#xA;&#x9;/**&#xA;&#x9; * Creates a partner object with no partner&#xA;&#x9; * A invalid name will return a null object&#xA;&#x9; * @param name, the name of this partner&#xA;&#x9; */&#xA;&#x9;public Partner(String name){&#xA;&#x9;&#x9;if (isValid(name)){&#xA;&#x9;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if the input is a valid name&#xA;&#x9; * only letters [a-zA-Z]+ is valid&#xA;&#x9; * @param name&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(String name) {&#xA;&#x9;&#x9;if(name.matches(&quot;[a-zA-Z]+&quot;)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Creates a link between two Partner objects for both Partner objects.&#xA;&#x9; * If this partner, or the input partner are not valid objects, no link is created.&#xA;&#x9; * if the current or input partner is married to someone else, these links will be erased from all relevant Partner objects&#xA;&#x9; * @param A valid partner object (! null).&#xA;&#x9; */&#xA;&#x9;public void setPartner(Partner partner){&#xA;&#x9;&#x9;if (isValid(partner, this.partner)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="670" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584733937" sizeMeasure="80" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=")){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if partner and this partner != null reference. &#xA;&#x9; * @param partner2&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(Partner partner2) {&#xA;&#x9;&#x9;if(this.partner == null || partner2.getPartner() == null){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return ture;&#xA;&#x9;}&#xA;&#xA;&#x9;private Object getPartner() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1572" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584840597" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rue;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * returns this partner's partner. Returns null if this partner partner is not set. &#xA;&#x9; * @return a partner object&#xA;&#x9; */&#xA;&#x9;public Object getPartner() {&#xA;&#x9;&#x9;return this.partner;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1866" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584931962" sizeMeasure="86" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.partner = partner;&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1579" end="-487"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487585824663" sizeMeasure="100" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if partner and this partner != null reference. &#xA;&#x9; * @param partner2&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(Partner partner2) {&#xA;&#x9;&#x9;// if this.name == null this partner object has not been set&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.name.equals(null) || partner2.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * returns this partner's partner. Returns null if this partner partner is not set. &#xA;&#x9; * @return a partner object&#xA;&#x9; */&#xA;&#x9;public Object getPartner() {&#xA;&#x9;&#x9;if (this.name.equals(null)){&#xA;&#x9;&#x9;&#x9;//this name is null, hence not set properly&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;/**&#xA;&#x9; * toString method returns this partner object's name and, if (s)he has partner, the partners name. &#xA;&#x9; * @return A string representation of this object&#xA;&#x9; */&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;return &quot;&quot;;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1609" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487587534262" sizeMeasure="132" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;//none of partners have prevoius partners&#xA;&#x9;&#x9;&#x9;if (this.partner.equals(null) &amp;&amp; partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if this partner has a previous partner we need to reset this and this.partner&#xA;&#x9;&#x9;&#x9;else if (! this.partner.equals(null) &amp;&amp; partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if the input object Partner has this Partner object as partner this partner is Partner.&#xA;&#x9;&#x9;&#x9;else if(partner.getPartner().equals(this)){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if both partners has previous partners&#xA;&#x9;&#x9;&#x9;else if(! this.partner.equals(null) &amp;&amp; ! partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner1 = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner1.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner2 = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setPartner() {&#xA;&#x9;&#x9;this.partner = null;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if partner and this partner != null reference. &#xA;&#x9; * @param partner2&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(Partner partner2) {&#xA;&#x9;&#x9;// if this.name == null this partner object has not been set&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.name.equals(null) || partner2.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * returns this partner's partner. Returns null if this partner partner is not set. &#xA;&#x9; * @return a partner object&#xA;&#x9; */&#xA;&#x9;public Partner" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1579" end="-346"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588013550" sizeMeasure="137">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" oldPartner 1 and 2 is set to null&#xA;&#x9;&#x9;&#x9;//this.partner is set to partner, and partner's partner is set to this&#xA;&#x9;&#x9;&#x9;else if(! this.partner.equals(null) &amp;&amp; ! partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner1 = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner1.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner2 = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner2.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if this has no partner, but the partner has a partner&#xA;&#x9;&#x9;&#x9;// partner's prevously partner is set to null and this partner and partner is linked&#xA;&#x9;&#x9;&#x9;else if (this.partner.equals(null) &amp;&amp; ! partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="2282" end="-880"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588450927" sizeMeasure="152">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="iously partner is set to null and this partner and partner is linked&#xA;&#x9;&#x9;&#x9;else if (this.partner.equals(null) &amp;&amp; ! partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;//throw illegal argument exception if something went wrond&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Something went wrong&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setPartner() {&#xA;&#x9;&#x9;this.partner = null;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if partner and this partner != null reference. &#xA;&#x9; * @param partner2&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(Partner partner2) {&#xA;&#x9;&#x9;// if this.name == null this partner object has not been set&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.name.equals(null) || partner2.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * returns this partner's partner. Returns null if this partner partner is not set. &#xA;&#x9; * @return a partner object&#xA;&#x9; */&#xA;&#x9;public Partner getPartner() {&#xA;&#x9;&#x9;if (this.name.equals(null)){&#xA;&#x9;&#x9;&#x9;//this name is null, hence not set properly&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;/**&#xA;&#x9; * toString method returns this partner object's name and, if (s)he has partner, the partners name. &#xA;&#x9; * @return A string representation of this object&#xA;&#x9; */&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;if (this.partner.equals(null)){&#xA;&#x9;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.name + &quot; &quot; + this.partner.toString(this);&#xA;&#x9;}&#xA;&#x9;public String toString (Partner partner){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="2762" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588600280" sizeMeasure="163" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;/**&#xA; * The Partner class creates an object Partner which has a name&#xA; * and can be linked to another partner (Marriage)&#xA; * &#xA; * The public class setPartner(Partner x) operation that links two Partners together.&#xA; * setPartner() divorce the two partners (nothing happens if the partner object don't have a partner&#xA; * &#xA; * The public class getPartner() that returns this partner's partner. If this partner do not have a partner it returns a null reference&#xA; * &#xA; * The public class toString() returns the name of this partner and if (s)he has a partner, the partner's name&#xA; * &#xA; * @author Sebastian&#xA; *&#xA; */&#xA;public class Partner {&#xA;&#x9;&#xA;&#x9;private String name = null;&#xA;&#x9;&#xA;&#x9;private Partner partner = null;&#xA;&#x9;&#xA;&#x9;/**&#xA;&#x9; * Creates a partner object with no partner&#xA;&#x9; * A invalid name will return a null object&#xA;&#x9; * @param name, the name of this partner&#xA;&#x9; */&#xA;&#x9;public Partner(String name){&#xA;&#x9;&#x9;if (isValid(name)){&#xA;&#x9;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if the input is a valid name&#xA;&#x9; * only letters [a-zA-Z]+ is valid&#xA;&#x9; * @param name&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(String name) {&#xA;&#x9;&#x9;if(name.matches(&quot;[a-zA-Z]+&quot;)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Creates a link between two Partner objects for both Partner objects.&#xA;&#x9; * If this partner, or the input partner are not valid objects, no link is created.&#xA;&#x9; * if the current or input partner is married to someone else, these links will be erased from all relevant Partner objects&#xA;&#x9; * @param A valid partner object (! null).&#xA;&#x9; */&#xA;&#x9;public void setPartner(Partner partner){&#xA;&#x9;&#x9;if (isValid(partner)){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;//none of partners have prevoius partners&#xA;&#x9;&#x9;&#x9;if (this.partner.equals(null) &amp;&amp; partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if this partner has a previous partner we need to reset this and this.partner&#xA;&#x9;&#x9;&#x9;else if (! this.partner.equals(null) &amp;&amp; partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if the input object Partner has this Partner object as partner this partner is Partner.&#xA;&#x9;&#x9;&#x9;else if(partner.getPartner().equals(this)){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if both partners has previous partners oldPartner 1 and 2 is set to null&#xA;&#x9;&#x9;&#x9;//this.partner is set to partner, and partner's partner is set to this&#xA;&#x9;&#x9;&#x9;else if(! this.partner.equals(null) &amp;&amp; ! partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner1 = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner1.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner2 = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner2.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if this has no partner, but the partner has a partner&#xA;&#x9;&#x9;&#x9;// partner's previously partner is set to null and this partner and partner is linked&#xA;&#x9;&#x9;&#x9;else if (this.partner.equals(null) &amp;&amp; ! partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;//throw illegal argument exception if something went wrond&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Something went wrong&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setPartner() {&#xA;&#x9;&#x9;this.partner = null;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if partner and this partner != null reference. &#xA;&#x9; * @param partner2&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(Partner partner2) {&#xA;&#x9;&#x9;// if this.name == null this partner object has not been set&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.name.equals(null) || partner2.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * returns this partner's partner. Returns null if this partner partner is not set. &#xA;&#x9; * @return a partner object&#xA;&#x9; */&#xA;&#x9;public Partner getPartner() {&#xA;&#x9;&#x9;if (this.name.equals(null)){&#xA;&#x9;&#x9;&#x9;//this name is null, hence not set properly&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;/**&#xA;&#x9; * toString method returns this partner object's name and, if (s)he has partner, the partners name. &#xA;&#x9; * @return A string representation of this object&#xA;&#x9; */&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;if (this.partner.equals(null)){&#xA;&#x9;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.name + &quot; &quot; + this.partner.toString(this);&#xA;&#x9;}&#xA;&#x9;public String toString (Partner partner){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//ArrayList&lt;Partner> partners = new ArrayList&lt;Partner>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="27" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588689179" sizeMeasure="167" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Partner partner1 = new Partner(&quot;sebbe&quot;);&#xA;&#x9;&#x9;Partner partner2 = new Partner(&quot;sofie&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner2.toString());" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="4383" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588886211" sizeMeasure="167" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="4100" end="-455"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588906514" sizeMeasure="167" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="3786" end="-764"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588938310" sizeMeasure="167" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null || partner2.getPartner() == null" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="3518" end="-989"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487588965718" sizeMeasure="170" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="partner1.setPartner(partner2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner2.toString());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="4452" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589006483" sizeMeasure="170" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null &amp;&amp; partner.getPartner() == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if this partner has a previous partner we need to reset this and this.partner&#xA;&#x9;&#x9;&#x9;else if (! this.partner == null &amp;&amp; partner.getPartner() == null" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1672" end="-2638"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589050565" sizeMeasure="170" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(this.partner == null)" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1877" end="-2670"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589082571" sizeMeasure="170" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(this.partner == null) &amp;&amp; ! partner.getPartner() == null" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="2414" end="-2091"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589092781" sizeMeasure="170" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(partner.getPartner() == null)" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="2442" end="-2091"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589113222" sizeMeasure="170" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null &amp;&amp; ! partner.getPartner() == null" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="2859" end="-1652"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589123496" sizeMeasure="170" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(partner.getPartner() == null)" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="2873" end="-1652"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589174402" sizeMeasure="170" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == this" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="2194" end="-2348"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589363362" sizeMeasure="166" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.partner" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="3726" end="-720"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589489686" sizeMeasure="162" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;&#x9;//none of partners have prevoius partners&#xA;&#x9;&#x9;&#x9;if (this.partner == null &amp;&amp; partner.getPartner() == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if this partner has a previous partner we need to reset this and this.partner&#xA;&#x9;&#x9;&#x9;else if (! (this.partner == null) &amp;&amp; partner.getPartner() == null){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if the input object Partner has this Partner object as partner this partner is Partner.&#xA;&#x9;&#x9;&#x9;else if(partner.getPartner() == this){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if both partners has previous partners oldPartner 1 and 2 is set to null&#xA;&#x9;&#x9;&#x9;//this.partner is set to partner, and partner's partner is set to this&#xA;&#x9;&#x9;&#x9;else if(! (this.partner == null) &amp;&amp; ! (partner.getPartner() == null)){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner1 = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner1.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner2 = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner2.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// if this has no partner, but the partner has a partner&#xA;&#x9;&#x9;&#x9;// partner's previously partner is set to null and this partner and partner is linked&#xA;&#x9;&#x9;&#x9;else if (this.partner == null &amp;&amp; ! (partner.getPartner() == null)){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;//throw illegal argument exception if something went wrond&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Something went wrong&quot;);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1581" end="-1276"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589711993" sizeMeasure="131" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;oldPartner = partner.getPartner();&#xA;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;partner.setPartner(this);" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1581" end="-1273"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487589991360" sizeMeasure="142" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.partner.equals(null)){&#xA;&#x9;&#x9;&#x9;if (partner.getPartner().equals(null)){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1584" end="-1273"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590055659" sizeMeasure="142" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == null){&#xA;&#x9;&#x9;&#x9;if (partner.getPartner() == null" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1600" end="-1592"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590278490" sizeMeasure="149" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Partner partner3 = new Partner(&quot;Algemannen&quot;);&#xA;&#x9;&#x9;partner3.setPartner(partner1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner2.toString());&#xA;&#x9;&#x9;System.out.println(partner3" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="3228" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590394225" sizeMeasure="151" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;partner.getPartner().setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this)" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1748" end="-1711"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487590435993" sizeMeasure="152" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Partner oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1749" end="-1754"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592618152" sizeMeasure="160" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.partner == null &amp;&amp; partner.getPartner() == null){&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(this.partner == null){&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(partner.getPartner() == null){&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else if (this.partner != partner &amp;&amp; partner.getPartner() != this){&#xA;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.partner != partner){&#xA;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;}else if (partner.getPartner() != this){&#xA;&#x9;&#x9;&#x9;Partner oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1581" end="-1496"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592835770" sizeMeasure="162" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Partner oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner()" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1762" end="-2125"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592945806" sizeMeasure="162" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="1917" end="-2035"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487592983931" sizeMeasure="160" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1762" end="-2120"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593035268" sizeMeasure="164" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;else if(partner.getPartner() == null){&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.partner != partner &amp;&amp; partner.getPartner() != this){&#xA;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (this.partner != partner){&#xA;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;}else if (partner.getPartner() != this){&#xA;&#x9;&#x9;&#x9;Partner oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setPartner() {&#xA;&#x9;&#x9;this.partner = null;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * Checks if partner and this partner != null reference. &#xA;&#x9; * @param partner2&#xA;&#x9; * @return&#xA;&#x9; */&#xA;&#x9;private boolean isValid(Partner partner2) {&#xA;&#x9;&#x9;// if this.name == null this partner object has not been set&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(this.name == null || partner2.getPartner() == null){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#xA;&#x9;/**&#xA;&#x9; * returns this partner's partner. Returns null if this partner partner is not set. &#xA;&#x9; * @return a partner object&#xA;&#x9; */&#xA;&#x9;public Partner getPartner() {&#xA;&#x9;&#x9;return this.partner;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;/**&#xA;&#x9; * toString method returns this partner object's name and, if (s)he has partner, the partners name. &#xA;&#x9; * @return A string representation of this object&#xA;&#x9; */&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;if (this.partner == null){&#xA;&#x9;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return this.name + &quot; &quot; + this.partner.toString(this);&#xA;&#x9;}&#xA;&#x9;public String toString (Partner partner){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;public static void main(String[] args){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//ArrayList&lt;Partner> partners = new ArrayList&lt;Partner>();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Partner partner1 = new Partner(&quot;sebbe&quot;);&#xA;&#x9;&#x9;Partner partner2 = new Partner(&quot;sofie&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;partner1.setPartner(partner2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner2.toString());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Partner partner3 = new Partner(&quot;Algemannen&quot;);&#xA;&#x9;&#x9;partner3.setPartner(partner1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner2.toString());&#xA;&#x9;&#x9;System.out.println(partner3.toString());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;partner2.setPartner();&#xA;&#x9;&#x9;System.out.println(partner2.toString());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1762" end="-16"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593054880" sizeMeasure="165" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1.setPartner();&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner3" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="3875" end="-32"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593221241" sizeMeasure="168" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.partner != null){&#xA;&#x9;&#x9;&#x9;this.partner = null;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.partner.setPartner();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="2427" end="-1548"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593521433" sizeMeasure="169" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;this.partner = null;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;oldP" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="2457" end="-1572"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593816056" sizeMeasure="169" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="4097" end="-4098"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593841185" sizeMeasure="176" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="partner2.setPartner(partner3);&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner3.toString());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;partner2.setPartner(partner1);&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner3.toString());" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="4085" end="-16"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593881856" sizeMeasure="177" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.toString())" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="4065" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593891598" sizeMeasure="177" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="4078" end="-303"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487593950900" sizeMeasure="179" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2.toString());&#xA;&#x9;&#x9;System.out.println(partner3.toString());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;partner2.setPartner(partner1);&#xA;&#x9;&#x9;System.out.println(partner1.toString());&#xA;&#x9;&#x9;System.out.println(partner2" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="4230" end="-72"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594287954" sizeMeasure="182" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="partner == null){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Not a valid partner&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="1585" end="-2890"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594474241" sizeMeasure="189" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public boolean isValidPartner(Partner x){&#xA;&#x9;&#x9;if (partner.name != null){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="3520" end="-1042"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594527460" sizeMeasure="189" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="isValidPartner(partner)" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="1585" end="-3071"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594698777" sizeMeasure="189" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="! " edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="1585" end="-3094"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594790181" sizeMeasure="193" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String getName(){&#xA;&#x9;&#x9;return this.name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private boolean isValidPartner(Partner x){&#xA;&#x9;&#x9;if (x.getName()" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="3540" end="-1088"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594854700" sizeMeasure="198" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="partner2.setPartner(null" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="4722" end="-147"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487594955418" sizeMeasure="198" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="3634" end="-1249"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595218668" sizeMeasure="199" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return true;&#xA;&#x9;&#x9;/*if(name.matches(&quot;[a-zA-Z]+&quot;)){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;*/" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="1129" end="-3688"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595672242" sizeMeasure="199" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="partner == null){&#xA;&#x9;&#x9;&#x9;this.partner = null" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="1604" end="-3210"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595785801" sizeMeasure="203" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (this.partner == null &amp;&amp; partner.getPartner() == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(this.partner == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if(partner.getPartner() == null){&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (this.partner != partner &amp;&amp; partner.getPartner() != this){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.partner != partner){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = this.partner;&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;this.partner = partner;&#xA;&#x9;&#x9;&#x9;}else if (partner.getPartner() != this){&#xA;&#x9;&#x9;&#x9;&#x9;Partner oldPartner = partner.getPartner();&#xA;&#x9;&#x9;&#x9;&#x9;oldPartner.setPartner();&#xA;&#x9;&#x9;&#x9;&#x9;partner.setPartner(this);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="1648" end="-2401"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487595940480" sizeMeasure="203" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="setPartner()" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="1630" end="-3260"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487588689133" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487588739989" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487588888860" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487588938099" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487588965534" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589006286" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589055510" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589082373" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589092601" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589113031" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589123306" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589174194" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589209123" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589229453" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589363159" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589711966" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589759985" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589991175" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487589995582" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590056757" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590064162" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590278264" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590284134" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590393744" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590435799" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590438119" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590449044" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487590458271" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487592617871" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487592642104" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487592835527" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487592945579" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487592983702" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593035061" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593054680" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593221044" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593328939" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593523890" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593840976" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593881655" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593891400" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487593950696" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594655394" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594660244" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594698429" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594790052" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594811753" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594854608" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594870642" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594881455" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487594955312" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487595145165" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487595888498" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594008205" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594475213" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594645273" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487594802031" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595219658" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595594243" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595605015" completion="0.75" successCount="3" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595678905" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595786723" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487595941419" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="59">
        <attempts timestamp="1487589244262"/>
        <attempts timestamp="1487589246398"/>
        <attempts timestamp="1487589369845"/>
        <attempts timestamp="1487589370813"/>
        <attempts timestamp="1487589371621"/>
        <attempts timestamp="1487589372433"/>
        <attempts timestamp="1487589373009"/>
        <attempts timestamp="1487589373601"/>
        <attempts timestamp="1487589375029"/>
        <attempts timestamp="1487589376141"/>
        <attempts timestamp="1487589407985"/>
        <attempts timestamp="1487589408401"/>
        <attempts timestamp="1487589410281"/>
        <attempts timestamp="1487589411157"/>
        <attempts timestamp="1487589771469"/>
        <attempts timestamp="1487590000702"/>
        <attempts timestamp="1487590001714"/>
        <attempts timestamp="1487590066969"/>
        <attempts timestamp="1487590067346"/>
        <attempts timestamp="1487590178380"/>
        <attempts timestamp="1487590178884"/>
        <attempts timestamp="1487590179324"/>
        <attempts timestamp="1487590179644"/>
        <attempts timestamp="1487590442077"/>
        <attempts timestamp="1487590442542"/>
        <attempts timestamp="1487590443122"/>
        <attempts timestamp="1487590446254"/>
        <attempts timestamp="1487590468061"/>
        <attempts timestamp="1487590471285"/>
        <attempts timestamp="1487592647989"/>
        <attempts timestamp="1487592648493"/>
        <attempts timestamp="1487592658517"/>
        <attempts timestamp="1487592723348"/>
        <attempts timestamp="1487592724512"/>
        <attempts timestamp="1487592729120"/>
        <attempts timestamp="1487592839795"/>
        <attempts timestamp="1487592840283"/>
        <attempts timestamp="1487592841147"/>
        <attempts timestamp="1487592842663"/>
        <attempts timestamp="1487592843551"/>
        <attempts timestamp="1487593335474"/>
        <attempts timestamp="1487593337194"/>
        <attempts timestamp="1487593352222"/>
        <attempts timestamp="1487593370633"/>
        <attempts timestamp="1487593373234"/>
        <attempts timestamp="1487593377305"/>
        <attempts timestamp="1487593531020"/>
        <attempts timestamp="1487593531380"/>
        <attempts timestamp="1487593532532"/>
        <attempts timestamp="1487593533311"/>
        <attempts timestamp="1487593541252"/>
        <attempts timestamp="1487593542612"/>
        <attempts timestamp="1487593593372"/>
        <attempts timestamp="1487593598475"/>
        <attempts timestamp="1487593675818"/>
        <attempts timestamp="1487593677422"/>
        <attempts timestamp="1487593679866"/>
        <attempts timestamp="1487593763605"/>
        <attempts timestamp="1487593765282"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="4">
        <attempts timestamp="1487588780941"/>
        <attempts timestamp="1487588783072"/>
        <attempts timestamp="1487588785299"/>
        <attempts timestamp="1487588785891"/>
        <attempts timestamp="1487588786992"/>
        <attempts timestamp="1487588788256"/>
        <attempts timestamp="1487588789035"/>
        <attempts timestamp="1487588790843"/>
        <attempts timestamp="1487588792063"/>
        <attempts timestamp="1487588794811"/>
        <attempts timestamp="1487588796335"/>
        <attempts timestamp="1487588797055"/>
        <attempts timestamp="1487588797507"/>
        <attempts timestamp="1487588797683"/>
        <attempts timestamp="1487588798332"/>
        <attempts timestamp="1487588798979"/>
        <attempts timestamp="1487588799611"/>
        <attempts timestamp="1487588800191"/>
        <attempts timestamp="1487588802031"/>
        <attempts timestamp="1487588802691"/>
        <attempts timestamp="1487588803387"/>
        <attempts timestamp="1487588804999"/>
        <attempts timestamp="1487588805983"/>
        <attempts timestamp="1487588819035"/>
        <attempts timestamp="1487588823975"/>
        <attempts timestamp="1487589220126"/>
        <attempts timestamp="1487589234307"/>
        <attempts timestamp="1487589235351"/>
        <attempts timestamp="1487589236582"/>
        <attempts timestamp="1487589238035"/>
        <attempts timestamp="1487589238746"/>
        <attempts timestamp="1487589240391"/>
        <attempts timestamp="1487589240854"/>
        <attempts timestamp="1487589241531"/>
        <attempts timestamp="1487589242066"/>
        <attempts timestamp="1487589242874"/>
        <attempts timestamp="1487589249950"/>
        <attempts timestamp="1487589251674"/>
        <attempts timestamp="1487589257910"/>
        <attempts timestamp="1487589269718"/>
        <attempts timestamp="1487589271478"/>
        <attempts timestamp="1487589273814"/>
        <attempts timestamp="1487589276578"/>
        <attempts timestamp="1487589280194"/>
        <attempts timestamp="1487589300818"/>
        <attempts timestamp="1487589304074"/>
        <attempts timestamp="1487589309278"/>
        <attempts timestamp="1487589368257"/>
        <attempts timestamp="1487589387765"/>
        <attempts timestamp="1487589389329"/>
        <attempts timestamp="1487589392149"/>
        <attempts timestamp="1487589395421"/>
        <attempts timestamp="1487589399341"/>
        <attempts timestamp="1487589401829"/>
        <attempts timestamp="1487589402981"/>
        <attempts timestamp="1487589404072"/>
        <attempts timestamp="1487589406124"/>
        <attempts timestamp="1487589762977"/>
        <attempts timestamp="1487589764349"/>
        <attempts timestamp="1487589764741"/>
        <attempts timestamp="1487589765565"/>
        <attempts timestamp="1487589766293"/>
        <attempts timestamp="1487589766825"/>
        <attempts timestamp="1487589767353"/>
        <attempts timestamp="1487589767977"/>
        <attempts timestamp="1487589768433"/>
        <attempts timestamp="1487589769041"/>
        <attempts timestamp="1487589770093"/>
        <attempts timestamp="1487589772993"/>
        <attempts timestamp="1487589786457"/>
        <attempts timestamp="1487589795341"/>
        <attempts timestamp="1487589798869"/>
        <attempts timestamp="1487590002906"/>
        <attempts timestamp="1487590009590"/>
        <attempts timestamp="1487590026951"/>
        <attempts timestamp="1487590068377"/>
        <attempts timestamp="1487590071201"/>
        <attempts timestamp="1487590073325"/>
        <attempts timestamp="1487590076049"/>
        <attempts timestamp="1487590086270"/>
        <attempts timestamp="1487590089557"/>
        <attempts timestamp="1487590099761"/>
        <attempts timestamp="1487590103057"/>
        <attempts timestamp="1487590104361"/>
        <attempts timestamp="1487590108877"/>
        <attempts timestamp="1487590110705"/>
        <attempts timestamp="1487590117921"/>
        <attempts timestamp="1487590119205"/>
        <attempts timestamp="1487590120189"/>
        <attempts timestamp="1487590147301"/>
        <attempts timestamp="1487590148209"/>
        <attempts timestamp="1487590150332"/>
        <attempts timestamp="1487590162240"/>
        <attempts timestamp="1487590165393"/>
        <attempts timestamp="1487590170540"/>
        <attempts timestamp="1487590173160"/>
        <attempts timestamp="1487590175525"/>
        <attempts timestamp="1487590176841"/>
        <attempts timestamp="1487590461566"/>
        <attempts timestamp="1487590462501"/>
        <attempts timestamp="1487590474661"/>
        <attempts timestamp="1487590477417"/>
        <attempts timestamp="1487590478830"/>
        <attempts timestamp="1487590489329"/>
        <attempts timestamp="1487590492037"/>
        <attempts timestamp="1487590499065"/>
        <attempts timestamp="1487590520997"/>
        <attempts timestamp="1487590525844"/>
        <attempts timestamp="1487590527441"/>
        <attempts timestamp="1487590529453"/>
        <attempts timestamp="1487590551632"/>
        <attempts timestamp="1487590557196"/>
        <attempts timestamp="1487592738116"/>
        <attempts timestamp="1487592743728"/>
        <attempts timestamp="1487592745964"/>
        <attempts timestamp="1487592746924"/>
        <attempts timestamp="1487592750396"/>
        <attempts timestamp="1487593334190"/>
        <attempts timestamp="1487593341362"/>
        <attempts timestamp="1487593349498"/>
        <attempts timestamp="1487593379409"/>
        <attempts timestamp="1487593382473"/>
        <attempts timestamp="1487593384174"/>
        <attempts timestamp="1487593385149"/>
        <attempts timestamp="1487593386649"/>
        <attempts timestamp="1487593395509"/>
        <attempts timestamp="1487593397909"/>
        <attempts timestamp="1487593408637"/>
        <attempts timestamp="1487593410865"/>
        <attempts timestamp="1487593414657"/>
        <attempts timestamp="1487593417146"/>
        <attempts timestamp="1487593418536"/>
        <attempts timestamp="1487593421437"/>
        <attempts timestamp="1487593424693"/>
        <attempts timestamp="1487593428489"/>
        <attempts timestamp="1487593444961"/>
        <attempts timestamp="1487593459837"/>
        <attempts timestamp="1487593463261"/>
        <attempts timestamp="1487593544768"/>
        <attempts timestamp="1487593547391"/>
        <attempts timestamp="1487593548472"/>
        <attempts timestamp="1487593549040"/>
        <attempts timestamp="1487593551976"/>
        <attempts timestamp="1487593557963"/>
        <attempts timestamp="1487593559048"/>
        <attempts timestamp="1487593567659"/>
        <attempts timestamp="1487593583535"/>
        <attempts timestamp="1487593586767"/>
        <attempts timestamp="1487593587995"/>
        <attempts timestamp="1487593588635"/>
        <attempts timestamp="1487593605019"/>
        <attempts timestamp="1487593614471"/>
        <attempts timestamp="1487593615475"/>
        <attempts timestamp="1487593616523"/>
        <attempts timestamp="1487593618823"/>
        <attempts timestamp="1487593637687"/>
        <attempts timestamp="1487593642730"/>
        <attempts timestamp="1487593647302"/>
        <attempts timestamp="1487593649811"/>
        <attempts timestamp="1487593654186"/>
        <attempts timestamp="1487593656762"/>
        <attempts timestamp="1487593665110"/>
        <attempts timestamp="1487593666587"/>
        <attempts timestamp="1487593668350"/>
        <attempts timestamp="1487593669670"/>
        <attempts timestamp="1487593670231"/>
        <attempts timestamp="1487593691718"/>
        <attempts timestamp="1487593695270"/>
        <attempts timestamp="1487593697962"/>
        <attempts timestamp="1487593716714"/>
        <attempts timestamp="1487593725046"/>
        <attempts timestamp="1487593732290"/>
        <attempts timestamp="1487593740721"/>
        <attempts timestamp="1487593744498"/>
        <attempts timestamp="1487593754525"/>
        <attempts timestamp="1487593755826"/>
        <attempts timestamp="1487593757485"/>
        <attempts timestamp="1487593758717"/>
        <attempts timestamp="1487593760658"/>
        <attempts timestamp="1487594299796"/>
        <attempts timestamp="1487594311524"/>
        <attempts timestamp="1487594313624"/>
        <attempts timestamp="1487594314435"/>
        <attempts timestamp="1487594314923"/>
        <attempts timestamp="1487594903973"/>
        <attempts timestamp="1487594905610"/>
        <attempts timestamp="1487594913661"/>
        <attempts timestamp="1487594940265"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="2">
        <attempts timestamp="1487588809491"/>
        <attempts timestamp="1487589286034"/>
        <attempts timestamp="1487589378028"/>
        <attempts timestamp="1487589781010"/>
        <attempts timestamp="1487590006423"/>
        <attempts timestamp="1487590083342"/>
        <attempts timestamp="1487590484118"/>
        <attempts timestamp="1487592651071"/>
        <attempts timestamp="1487592730969"/>
        <attempts timestamp="1487593354550"/>
        <attempts timestamp="1487593535447"/>
        <attempts timestamp="1487594290251"/>
        <attempts timestamp="1487594911278"/>
        <attempts timestamp="1487594931554"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
