<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582281421" sizeMeasure="24" errorCount="4">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#x9;private String message;&#xA;&#x9;private  String owner;&#xA;&#x9;private TwitterAccount ownerAccount;&#xA;&#x9;private boolean isOriginal;&#xA;&#x9;int retweet=0;&#xA;&#x9;&#xA; public Tweet(TwitterAccount newone, String s){&#xA;&#x9; message=s;&#xA;&#x9; // owner=newone.user;&#xA;&#x9; ownerAccount=newone;&#xA;&#x9; isOriginal=true;&#xA;&#x9;}&#xA; &#xA; public Tweet(TwitterAccount account, Tweet s) {&#xA;&#x9; message=s.message;&#xA;&#x9; isOriginal=false;&#xA;&#x9; s.retweet++;&#xA;&#x9; &#xA;&#x9; &#xA; }&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582437037" sizeMeasure="24" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="430" end="-431"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582544125" sizeMeasure="30" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(account.user==tweet.owner){&#xA;&#x9;&#x9; throw new IllegalArgumentException(&quot;det går ikkje &quot;);&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; message=s.message;&#xA;&#x9;&#x9; isOriginal=false;&#xA;&#x9;&#x9; s.retweet++;&#xA;&#x9; }&#xA;&#x9; " edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="365" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583257083" sizeMeasure="50" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet original;&#xA; public Tweet(TwitterAccount newone, String s){&#xA;&#x9; message=s;&#xA;&#x9; // owner=newone.user;&#xA;&#x9; ownerAccount=newone;&#xA;&#x9; isOriginal=true;&#xA;&#x9;}&#xA; &#xA; public Tweet(TwitterAccount account, Tweet s) {&#xA;&#x9; if(account.user==s.owner){&#xA;&#x9;&#x9; throw new IllegalArgumentException(&quot;det går ikkje &quot;);&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; message=s.message;&#xA;&#x9;&#x9; isOriginal=false;&#xA;&#x9;&#x9; s.retweet++;&#xA;&#x9;&#x9; original=s;&#xA;&#x9; }&#xA;&#x9;&#xA;&#x9; &#xA; }&#xA; &#xA; String getText() {&#xA;&#x9; return message;&#xA; }&#xA; TwitterAccount getOwner(){&#xA;&#x9; return  getOwner();&#xA;&#x9; &#xA; }&#xA; Tweet getOriginalTweet(){&#xA;&#x9; if(isOriginal==false){&#xA;&#x9;&#x9; return original;&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; return null;&#xA;&#x9; }&#xA; }&#xA; &#xA; int getRetweetCount(){&#xA;&#x9; return retweet;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="181" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583427825" sizeMeasure="66" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA; &#xA; @Override&#xA;public String toString() {&#xA;&#x9;return &quot;Tweet [message=&quot; + message + &quot;, owner=&quot; + owner + &quot;, ownerAccount=&quot; + ownerAccount + &quot;, isOriginal=&quot;&#xA;&#x9;&#x9;&#x9;+ isOriginal + &quot;, retweet=&quot; + retweet + &quot;, original=&quot; + original + &quot;]&quot;;&#xA;}&#xA;&#xA;public static void main(String[] args) {&#xA;&#x9; TwitterAccount nahom=new TwitterAccount(&quot;nahom&quot;);&#xA;&#x9; TwitterAccount money=new TwitterAccount(&quot;money&quot;);&#xA;&#x9; Tweet one= new Tweet(nahom, &quot;No pain, No gain&quot;);&#xA;&#x9; System.out.println(one);&#xA;&#x9; &#xA;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="815" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583454718" sizeMeasure="66" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="260" end="-1016"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583491272" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="owner=newone.user;&#xA;&#x9; ownerAccount=newone;&#xA;&#x9; isOriginal=true;&#xA;&#x9;}&#xA; &#xA; public Tweet(TwitterAccount account, Tweet s) {&#xA;&#x9; if(account.user==s.owner){&#xA;&#x9;&#x9; throw new IllegalArgumentException(&quot;det går ikkje &quot;);&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; message=s.message;&#xA;&#x9;&#x9; isOriginal=false;&#xA;&#x9;&#x9; s.retweet++;&#xA;&#x9;&#x9; original=s;&#xA;&#x9; }&#xA;&#x9;&#xA;&#x9; &#xA; }&#xA; &#xA; String getText() {&#xA;&#x9; return message;&#xA; }&#xA; TwitterAccount getOwner(){&#xA;&#x9; return  getOwner();&#xA;&#x9; &#xA; }&#xA; Tweet getOriginalTweet(){&#xA;&#x9; if(isOriginal==false){&#xA;&#x9;&#x9; return original;&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; return null;&#xA;&#x9; }&#xA; }&#xA; &#xA; int getRetweetCount(){&#xA;&#x9; return retweet;&#xA; }&#xA; &#xA; &#xA; @Override&#xA;public String toString() {&#xA;&#x9;return &quot;Tweet [message=&quot; + message + &quot;, owner=&quot; + owner + &quot;, ownerAccount=&quot; + ownerAccount + &quot;, isOriginal=&quot;&#xA;&#x9;&#x9;&#x9;+ isOriginal + &quot;, retweet=&quot; + retweet + &quot;, original=&quot; + original + &quot;]&quot;;&#xA;}&#xA;&#xA;public static void main(String[] args) {&#xA;&#x9; TwitterAccount nahom=new TwitterAccount(&quot;nahom&quot;);&#xA;&#x9; TwitterAccount money=new TwitterAccount(&quot;money&quot;);&#xA;&#x9; Tweet one= new Tweet(nahom, &quot;No pain, No gain&quot;);&#xA;&#x9; System.out.println(one);&#xA;&#x9; Tweet two= new Tweet(money, one);&#xA;&#x9; System.out.println(two" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="260" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583783993" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1266" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583946560" sizeMeasure="67" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Name;&#xA;&#x9;private TwitterAccount ownerAccount;&#xA;&#x9;private boolean isOriginal;&#xA;&#x9;int retweet=0;&#xA;&#x9;Tweet original;&#xA; public Tweet(TwitterAccount newone, String s){&#xA;&#x9; message=s;&#xA;&#x9; ownerName=newone.user;&#xA;&#x9; ownerAccount=newone;&#xA;&#x9; isOriginal=true;&#xA;&#x9;}&#xA; &#xA; public Tweet(TwitterAccount account, Tweet s) {&#xA;&#x9; if(account.user==s.ownerName" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="95" end="-876"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583983423" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" Tweet two= new Tweet(money, &quot;bla bla pain, No gain&quot;);&#xA;&#x9; System.out.println(two);&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1278" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583998779" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Name" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="922" end="-451"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584075035" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9; Tweet three= new Tweet(nahom, one);&#xA;&#x9; System.out.println(three);&#xA;&#x9; System.out.println(one);&#xA;&#xA;&#x9; " edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1364" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584110302" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="money" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1389" end="-81"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584221390" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ownerAccount=account;" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="488" end="-991"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584351845" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9; Tweet four= new Tweet(money, three);&#xA;&#x9; System.out.println(four);&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1483" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487584523756" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//private  String ownerName;&#xA;&#x9;private TwitterAccount ownerAccount;&#xA;&#x9;private boolean isOriginal;&#xA;&#x9;int retweet=0;&#xA;&#x9;Tweet original;&#xA; public Tweet(TwitterAccount newone, String s){&#xA;&#x9; message=s;&#xA;&#x9;// ownerName=newone.user;&#xA;&#x9; ownerAccount=newone;&#xA;&#x9; isOriginal=true;&#xA;&#x9;}&#xA; &#xA; public Tweet(TwitterAccount account, Tweet s) {&#xA;&#x9; if(account==ownerAccount){&#xA;&#x9;&#x9; throw new IllegalArgumentException(&quot;det går ikkje &quot;);&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; ownerAccount=account;&#xA;&#x9;&#x9; message=s.message;&#xA;&#x9;&#x9; isOriginal=false;&#xA;&#x9;&#x9; s.retweet++;&#xA;&#x9;&#x9; original=s;&#xA;&#x9; }&#xA;&#x9;&#xA;&#x9; &#xA; }&#xA; &#xA; String getText() {&#xA;&#x9; return message;&#xA; }&#xA; TwitterAccount getOwner(){&#xA;&#x9; return  getOwner();&#xA;&#x9; &#xA; }&#xA; Tweet getOriginalTweet(){&#xA;&#x9; if(isOriginal==false){&#xA;&#x9;&#x9; return original;&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; return null;&#xA;&#x9; }&#xA; }&#xA; &#xA; int getRetweetCount(){&#xA;&#x9; return retweet;&#xA; }&#xA; &#xA; &#xA; @Override&#xA;public String toString() {&#xA;&#x9;return &quot;Tweet [message=&quot; + message + &quot;, owner=&quot; + &quot;ownerName&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="74" end="-617"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487585093513" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1569" end="-1570"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487597751821" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String thisname;&#xA;&#x9;private TwitterAccount ownerAccount;&#xA;&#x9;private boolean isOriginal;&#xA;&#x9;int retweet=0;&#xA;&#x9;Tweet original;&#xA;&#x9;&#xA;&#x9;&#xA; public Tweet(TwitterAccount newone, String s){&#xA;&#x9; thisname=newone.user;&#xA;&#x9; message=s;&#xA;&#x9; ownerAccount=newone;&#xA;&#x9; isOriginal=true;&#xA;&#x9;}&#xA; &#xA; public Tweet(TwitterAccount account, Tweet s) {&#xA;&#x9; if(account==s.ownerAccount){&#xA;&#x9;&#x9; throw new IllegalArgumentException(&quot;det går ikkje &quot;);&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; ownerAccount=account;&#xA;&#x9;&#x9; message=s.getOriginalTweet().message;&#xA;&#x9;&#x9; isOriginal=false;&#xA;&#x9;&#x9; s.retweet++;&#xA;&#x9;&#x9; original=s;&#xA;&#x9; }&#xA;&#x9;&#xA;&#x9; &#xA; }&#xA; &#xA; " edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="74" end="-975"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598313384" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9; System.out.println(one.message" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1574" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598329963" sizeMeasure="85" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="one.message);&#xA;&#xA;&#x9; System.out.println(three);&#xA;&#x9; System.out.println(one);&#xA;&#x9; Tweet four= new Tweet(money, three);&#xA;&#x9; System.out.println(four" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1472" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598340447" sizeMeasure="86" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(one.message);&#xA;&#xA;&#x9; Tweet three= new Tweet(money, on" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1415" end="-146"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692022652" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount ownerAccount;&#xA;&#x9;int retweet=0;&#xA;&#x9;private Tweet original;&#xA;&#x9;boolean Isorgianl;&#xA;&#x9;&#xA;&#x9;&#xA; public Tweet(TwitterAccount newone, String s){&#xA;&#x9; message=s;&#xA;&#x9; ownerAccount=newone;&#xA;&#x9; Isorgianl=true;&#xA;&#x9; original= null;&#xA;&#x9; }&#xA; &#xA; public Tweet(TwitterAccount account, Tweet s) {&#xA;&#x9; if(account==s.ownerAccount){&#xA;&#x9;&#x9; throw new IllegalArgumentException(&quot;det går ikkje &quot;);&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; ownerAccount=account;&#xA;&#x9;&#x9; message=s.getText();&#xA;&#x9;&#x9; Isorgianl=false;&#xA;&#x9;&#x9; original=s.getOriginalTweet();&#xA;&#x9;&#x9; s.getOriginalTweet().retweet++;&#xA;&#x9; }&#xA;&#x9;&#xA;&#x9; &#xA; }&#xA; &#xA; &#xA; &#xA; String getText() {&#xA;&#x9; return message;&#xA; }&#xA; TwitterAccount getOwner(){&#xA;&#x9; return ownerAccount;&#xA;&#x9; &#xA; }&#xA; Tweet getOriginalTweet(){&#xA;&#x9; &#xA;&#x9;&#x9; return original;&#xA;&#x9; &#xA;&#x9; &#xA;}&#xA; &#xA; int getRetweetCount(){&#xA;&#x9; return retweet;&#xA; }&#xA; &#xA; &#xA; &#xA;&#xA;/*@Override&#xA;public String toString() {&#xA;&#x9;return &quot;Tweet [message=&quot; + message + &quot;, ownerAccount=&quot; + ownerAccount + &quot;, retweet=&quot; + retweet + &quot;, original=&quot;&#xA;&#x9;&#x9;&#x9;+ original + &quot;, Isorgianl=&quot; + Isorgianl + &quot;]&quot;;&#xA;}*/" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="82" end="-524"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692034898" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="290" end="-1251"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692117091" sizeMeasure="90">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(Isorgianl==true){&#xA;&#x9;&#x9; return null;&#xA;&#x9; }&#xA;&#x9; else{&#xA;&#x9;&#x9; return original;&#xA;&#xA;&#x9; }" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="734" end="-791"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692145219" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9; return original;&#xA;&#x9;&#x9; " edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="734" end="-784"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692194328" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(original == this){&#xA;&#x9;&#x9; return null;&#xA;&#x9; }" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="734" end="-809"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692288631" sizeMeasure="88" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(s == null){&#xA;&#x9;&#x9;&#x9; original = this;&#xA;&#x9;&#x9; }" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="557" end="-1031"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692322119" sizeMeasure="89" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(s == null){&#xA;&#x9;&#x9;&#x9; original = this;&#xA;&#x9;&#x9; }else{&#xA;&#x9;&#x9;&#x9; original=s.getOriginalTweet();&#xA;&#x9;&#x9;&#x9; s.getOriginalTweet().retweet++;&#xA;&#x9;&#x9; }" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="523" end="-996"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692350845" sizeMeasure="89" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="original" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="608" end="-1012"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487692390136" sizeMeasure="89" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" s.original" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="582" end="-1026"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582514401" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487582545931" sizeMeasure="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;String user;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="57" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487583427787" sizeMeasure="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public TwitterAccount(String s){&#xA;&#x9;&#x9;user=s;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="72" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487585578018" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;String getUserName() {&#xA;&#x9;&#x9;return user" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="119" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487597986148" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;TwitterAccount [user=&quot; + user + &quot;]&quot;;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="58" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487598051392" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="58" end="-112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487706245655" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.*;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;String user;&#xA;&#xA;&#x9;&#xA;    ArrayList&lt;TwitterAccount> followedBy = new ArrayList&lt;TwitterAccount>();&#xA;    ArrayList&lt;TwitterAccount> Following = new ArrayList&lt;TwitterAccount>();&#xA;    ArrayList&lt;Tweet> twetts = new ArrayList&lt;Tweet>();&#xA;    ArrayList&lt;Tweet> retwetts = new ArrayList&lt;Tweet>();&#xA;&#xA;&#xA;    &#xA;    void follow(TwitterAccount account) {&#xA;    &#x9;this.Following.add(account);&#xA;    &#x9;account.followedBy.add(this);&#xA;    &#x9; }&#xA;    void unfollow(TwitterAccount account){&#xA;    &#x9;this.Following.remove(account);&#xA;    &#x9;account.followedBy.remove(this);&#xA;    }&#xA;    &#xA;    boolean isFollowing(TwitterAccount account){&#xA;    &#x9;return this.Following.contains(account);&#xA;    &#x9;&#xA;    }&#xA;    &#xA;    boolean isFollowedBy(TwitterAccount account){&#xA;    &#x9;return this.followedBy.contains(account);&#xA;    }&#xA;    void tweet(String s){&#xA;    &#x9;Tweet  newOne= new Tweet(this,s);&#xA;    &#x9;twetts.add(newOne);&#xA;    &#x9;&#xA;    &#x9;}&#xA;    void retweet(Tweet tweet){&#xA;    &#x9;Tweet newone= new Tweet(this,tweet);&#xA;    &#x9;retwetts.add(newone);&#xA;    }&#xA;    &#xA;    Tweet getTweet(int i) {&#xA;    &#x9;return twetts.get(twetts.size()-i);&#xA;    }&#xA;    int getTweetCount(){&#xA;    &#x9;return twetts.size();&#xA;    }&#xA;    int getRetweetCount(){&#xA;    &#x9;return retwetts.size();&#xA;    }&#xA;&#xA;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;public TwitterAccount(String s){&#xA;&#x9;&#x9;user=s;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="26" end="-51"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487706892148" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public static void main(String[] args) {&#xA;&#x9;TwitterAccount nahomA= new TwitterAccount(&quot;nahom&quot;);&#xA;&#x9;TwitterAccount nahomB= new TwitterAccount(&quot;nahomB&quot;);&#xA;&#x9;nahomA.tweet(&quot;halla bror&quot;);&#xA;&#x9;nahomB.retweet(nahomA.getTweet(1));&#xA;&#x9;System.out.println(nahomA.getRetweetCount());&#xA;&#x9;System.out.println(nahomB.getRetweetCount());&#xA;&#xA;&#x9;&#xA;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1340" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487706946022" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner()." edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1006" end="-650"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707067350" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" +&quot; from a&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1615" end="-58"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707119849" sizeMeasure="77">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1007" end="-662"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487707901716" sizeMeasure="79">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;    &#x9;}&#xA;    void retweet(Tweet tweet){&#xA;    &#x9;Tweet newone= new Tweet(this,tweet);&#xA;    &#x9;this.retwetts.add(newone);&#xA;    &#x9;this." edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="926" end="-659"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708143886" sizeMeasure="78" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ils= new TwitterAccount(&quot;nils&quot;);&#xA;&#x9;TwitterAccount ole= new TwitterAccount(&quot;ole&quot;);&#xA;&#x9;TwitterAccount kari = new TwitterAccount(&quot;Kari&quot;);&#xA;&#x9;nils.tweet(&quot;Kvitre!&quot;);&#xA;&#x9;System.out.println(nils.getT" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1439" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708229438" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;ole.retweet(nils.getTweet(1));&#xA;&#x9;System.out.println(nils.getTweetCount()+&quot;  tet count&quot;);&#xA;&#x9;System.out.println(nils.getRetweetCount()+&quot; retwer count&quot;);&#xA;&#x9;System.out.println(ole.getTweetCount());&#xA;&#x9;System.out.println(ole.getRetweetCount());&#xA;&#xA;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1638" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708267039" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nils retwer count&quot;);&#xA;&#x9;System.out.println(ole.getTweetCount()+ &quot;ole &quot;);&#xA;&#x9;System.out.println(ole.getRetweetCount() +&quot;ole&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1772" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708349747" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weet.getOwner()" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1013" end="-890"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708462956" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="riginalTweet()" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1022" end="-901"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708482440" sizeMeasure="87" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1018" end="-890"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708504452" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getOwner()" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1018" end="-890"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708782235" sizeMeasure="86" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;int count;&#xA;&#x9;&#xA;    ArrayList&lt;TwitterAccount> followedBy = new ArrayList&lt;TwitterAccount>();&#xA;    ArrayList&lt;TwitterAccount> Following = new ArrayList&lt;TwitterAccount>();&#xA;    ArrayList&lt;Tweet> twetts = new ArrayList&lt;Tweet>();&#xA;    ArrayList&lt;Tweet> retwetts = new ArrayList&lt;Tweet>();&#xA;&#xA;&#xA;    &#xA;    void follow(TwitterAccount account) {&#xA;    &#x9;this.Following.add(account);&#xA;    &#x9;account.followedBy.add(this);&#xA;    &#x9; }&#xA;    void unfollow(TwitterAccount account){&#xA;    &#x9;this.Following.remove(account);&#xA;    &#x9;account.followedBy.remove(this);&#xA;    }&#xA;    &#xA;    boolean isFollowing(TwitterAccount account){&#xA;    &#x9;return this.Following.contains(account);&#xA;    &#x9;&#xA;    }&#xA;    &#xA;    boolean isFollowedBy(TwitterAccount account){&#xA;    &#x9;return this.followedBy.contains(account);&#xA;    }&#xA;    void tweet(String s){&#xA;    &#x9;Tweet  newOne= new Tweet(this,s);&#xA;    &#x9;twetts.add(newOne);&#xA;    &#x9;&#xA;    &#x9;&#xA;    &#x9;}&#xA;    void retweet(Tweet tweet){&#xA;    &#x9;Tweet newone= new Tweet(this,tweet);&#xA;    &#x9;tweet.getOriginalTweet().getOwner().count++;&#xA;    &#x9;this.twetts.add(newone);&#xA;    }&#xA;    &#xA;    Tweet getTweet(int i) {&#xA;    &#x9;return twetts.get(twetts.size()-i);&#xA;    }&#xA;    int getTweetCount(){&#xA;    &#x9;return twetts.size();&#xA;    }&#xA;    int getRetweetCount(){&#xA;    &#x9;return count;&#xA;&#xA;&#xA;    }" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="91" end="-628"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708832642" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="wner().retwetts.add(newone);&#xA;    &#x9;this.twetts.add(newone);&#xA;    }&#xA;    &#xA;    Tweet getTweet(int i) {&#xA;    &#x9;return twetts.get(twetts.size()-i);&#xA;    }&#xA;    int getTweetCount(){&#xA;    &#x9;return twetts.size();&#xA;    }&#xA;    int getRetweetCount(){&#xA;    &#x9;return retwetts.size();&#xA;    }&#xA;&#xA;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="1033" end="-628"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487708891716" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;kari.retweet(ole.getTweet(1));&#xA;&#x9;System.out.println(nils.getTweetCount()+&quot; kkkkkkkkk tet count&quot;);&#xA;&#x9;System.out.println(nils.getRetweetCount()+&quot; nils retwer count&quot;);&#xA;&#x9;System.out.println(ole.getTweetCount()+ &quot;ole &quot;);&#xA;&#x9;System.out.println(ole.getRetweetCount() +&quot;ole&quot;);" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="1917" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709033081" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="riginalTweet()" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="1033" end="-1165"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709205377" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(tweet.getOriginalTweet()==null){&#xA;    &#x9;&#x9;this.retwetts.add(tweet);&#xA;    &#x9;}&#xA;    &#x9;else{&#xA;    &#x9;&#x9;tweet.getOriginalTweet().getOwner().retwetts.add(tweet);&#xA;    &#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="1023" end="-1132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709268920" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="newone);&#xA;    &#x9;}&#xA;    &#x9;else{&#xA;    &#x9;&#x9;tweet.getOriginalTweet().getOwner().retwetts.add(newone" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="1083" end="-1141"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709320764" sizeMeasure="91">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet.getOwner().retwetts.add(newone);" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="1023" end="-1132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709684107" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(tweet.getOriginalTweet()==null){&#xA;    &#x9;&#x9;tweet.getOwner().retwetts.add(newone);&#xA;    &#x9;&#x9;&#xA;    &#x9;}&#xA;    &#x9;else{&#xA;    &#x9;&#x9;tweet.getOriginalTweet().getOwner().retwetts.add(newone);&#xA;    &#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="1023" end="-1132"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487583426416" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487583453284" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487583489643" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487583782856" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487583945360" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487583981474" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487583997615" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487584023461" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487584073670" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487584084726" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487584109143" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487584112329" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487584350720" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487584353987" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487584522581" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487588912809" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487597749799" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487597992111" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487597998838" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487598011291" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487598050176" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487598057398" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487598260205" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487598311745" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487598328550" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487598338744" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487706890689" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487706944702" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487707065936" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487707075950" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487707118484" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487707153112" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487707926009" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708142597" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708149674" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708227873" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708233844" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708265746" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708270976" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708348408" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708355264" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708794577" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708831020" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487708890549" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709031445" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709038393" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709204056" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709208719" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709267352" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709318808" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709336002" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709682777" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487709689223" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487583556973" completion="0.5" successCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487584221993" completion="0.5" successCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487584534334" completion="0.5" successCount="2" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487691939443" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692023199" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692035466" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692117724" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692145747" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692194857" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692289113" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692322672" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692351339" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692390707" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487692441090" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487706274780" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487706967574" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487707082622" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487707128894" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487707902516" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487707912918" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708361749" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708463612" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708483050" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708505115" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708782922" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487708841377" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487709217389" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487709325865" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487709698929" completion="1.0" successCount="6"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
