<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709402717" sizeMeasure="7">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Person {&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709589902" sizeMeasure="16" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String name;&#xA;&#x9;private char gender;&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;if (gender != 'F' || gender != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kjønn må enten være mann 'M' eller kvinne 'F'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="52" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709611720" sizeMeasure="17" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// konstruktør som initialiserer et Person-objekt" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="98" end="-227"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709615487" sizeMeasure="19" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="370" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709720093" sizeMeasure="24" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collection;&#xA;&#xA;public class Person {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person mom;&#xA;&#x9;private Person dad;&#xA;&#x9;private Collection&lt;Person> children = new ListArray&lt;Person>()" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="27" end="-285"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709744084" sizeMeasure="25" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Collection;&#xA;&#xA;public class Person {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person mom;&#xA;&#x9;private Person dad;&#xA;&#x9;private Collection&lt;Person> children = new ArrayList" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="44" end="-295"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709794746" sizeMeasure="33" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// returnerer navnet til Person-objektet&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// &#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="537" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709884132" sizeMeasure="45" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ther;&#xA;&#x9;private Person father;&#xA;&#x9;private Collection&lt;Person> children = new ArrayList&lt;Person>();&#xA;&#x9;&#xA;&#x9;// konstruktør som initialiserer et Person-objekt&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;if (gender != 'F' || gender != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kjønn må enten være mann 'M' eller kvinne 'F'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer navnet til Person-objektet&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer kjønnet til Person-objektet&#xA;&#x9;public char getGender() {&#xA;&#x9;&#x9;return gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet mother&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet father&#xA;&#x9;public Person getFather() {&#xA;&#x9;&#x9;return father;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="171" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709920622" sizeMeasure="50" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// returnerer antall barn tilhørende dette Person-objektet&#xA;&#x9;public int getChildCount() {&#xA;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="902" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487709946085" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer barn nr. n (Person-objekt)" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1000" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710022316" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", utløser unntak ved for liten/stor n&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if (n &lt; 0 || n > children.size())&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1063" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710032933" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" - 1) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1168" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710044251" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1 || n > children.size()" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1144" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710080453" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new IllegalArgumentException(&quot;Må være et tall fra og med 1 til og med &quot; + children.size());" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1175" end="-16"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710158683" sizeMeasure="58" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="LinkedList;&#xA;&#xA;public class Person {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#x9;private LinkedList&lt;Person> children = new LinkedList&lt;Person>();&#xA;&#x9;&#xA;&#x9;// konstruktør som initialiserer et Person-objekt&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;if (gender != 'F' || gender != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kjønn må enten være mann 'M' eller kvinne 'F'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer navnet til Person-objektet&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer kjønnet til Person-objektet&#xA;&#x9;public char getGender() {&#xA;&#x9;&#x9;return gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet mother&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet father&#xA;&#x9;public Person getFather() {&#xA;&#x9;&#x9;return father;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer antall barn tilhørende dette Person-objektet&#xA;&#x9;public int getChildCount() {&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer barn nr. n (Person-objekt), utløser unntak ved for liten/stor n&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if (n &lt; 1 || n > children.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Må være et tall fra og med 1 til og med &quot; + children.size());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return children." edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="72" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710161865" sizeMeasure="57" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="44" end="-1254"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710171090" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="LinkedList;&#xA;&#xA;public class Person {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#x9;private LinkedList&lt;Person> children = new LinkedList&lt;Person>();&#xA;&#x9;&#xA;&#x9;// konstruktør som initialiserer et Person-objekt&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;if (gender != 'F' || gender != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kjønn må enten være mann 'M' eller kvinne 'F'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer navnet til Person-objektet&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer kjønnet til Person-objektet&#xA;&#x9;public char getGender() {&#xA;&#x9;&#x9;return gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet mother&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet father&#xA;&#x9;public Person getFather() {&#xA;&#x9;&#x9;return father;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer antall barn tilhørende dette Person-objektet&#xA;&#x9;public int getChildCount() {&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer barn nr. n (Person-objekt), utløser unntak ved for liten/stor n&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if (n &lt; 1 || n > children.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Må være et tall fra og med 1 til og med &quot; + children.size());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return children.get(n);" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="44" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710239252" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nyt" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="277" end="-1012"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710304347" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.mother == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="770" end="-525"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710319299" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.father == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="908" end="-436"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710369585" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" (vil this.mother returnere null by defualt?)&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;if (this.mother == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet father (vil this.father returnere null by defualt?)" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="738" end="-514"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710391476" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" - 1" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="1466" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710445879" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;[Name: &quot; + name + &quot;]&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1479" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710460357" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1556" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710471829" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;[Name: &quot; + name + &quot;]&quot;;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;//TODO" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1479" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710493501" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// toString-metode - returnerer navnet til Person-objektet&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;[Name: &quot; + name + &quot;]&quot;;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// main-metode" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1481" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710496482" sizeMeasure="76">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1481" end="-220"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710518787" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void addChild(Person person) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1479" end="-218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710615559" sizeMeasure="78">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.children.add(person);" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1519" end="-221"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710694617" sizeMeasure="81">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.getGender() == 'M') {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1519" end="-250"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710698965" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1557" end="-260"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710743272" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person.setFather(this);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.children.add(person);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setFather(Person person) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1553" end="-216"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710763679" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person.setMother(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.children.add(person);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private void setMother(Person person) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1591" end="-301"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710775120" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="1696" end="-308"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710951298" sizeMeasure="92">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;private void setMother(Person person) {&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.children.add(this);" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1620" end="-305"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487710994369" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Person-objektet som metoden kalles på " edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1479" end="-545"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711104744" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="settes til å være enten faren eller moren til Person-argumentet" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="1520" end="-545"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711150500" sizeMeasure="94">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Person-argumentet settes til å være moren til Person-objektet som metoden kaller på." edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1731" end="-399"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711170361" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" Legger så til &#xA;&#x9;// Person-objektet som metoden kalles på " edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="1818" end="-399"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711185021" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="i children-listen til Person-argumentet" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="1876" end="-399"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711199153" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Person-argumentet settes til å være faren til Person-objektet som metoden kaller på. Legger så til &#xA;&#x9;// Person-objektet som metoden kalles på i children-listen til Person-argumentet" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="2015" end="-301"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711223857" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.father = person;&#xA;&#x9;&#x9;person.children.add(this);" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="2243" end="-220"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711321504" sizeMeasure="101">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void removeChild(Person person) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="1731" end="-789"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711359420" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!this.children.contains(person)) {&#xA;&#x9;&#x9;&#x9;return; // evt. feilmelding?&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="1774" end="-792"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711407106" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.children.remove(person);" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="1851" end="-789"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711471723" sizeMeasure="105" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Person person1 = new Person(&quot;Bjørn&quot;, 'M');&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="2651" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711510720" sizeMeasure="107" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Person person2 = new Person(&quot;Reidun&quot;, 'F');&#xA;&#x9;&#x9;Person person3 = new Person(&quot;Gaute&quot;, 'M');&#xA;&#x9;&#x9;Person person4 = new Person(&quot;Vetle&quot;, 'M');" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="2696" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711546857" sizeMeasure="109" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;person1.addChild(person3);&#xA;&#x9;&#x9;person1.addChild(person4" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="2831" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711583430" sizeMeasure="110" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(person1 + &quot; er faren til &quot; + " edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="2889" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711635678" sizeMeasure="110" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;&quot; + person1 + &quot; er faren til &quot; + person1.getChild(1) &quot; og &quot; + person1.getChild(2)" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="2909" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711643905" sizeMeasure="110" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person1 + &quot; er faren til &quot; + person1.getChild(1) +" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="2909" end="-43"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711658431" sizeMeasure="110" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&amp;&amp;" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="379" end="-2621"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711672756" sizeMeasure="110" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot; + name" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="2563" end="-418"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487711731467" sizeMeasure="108" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="2981" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487713460615" sizeMeasure="110" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="person.mother = null;&#xA;&#x9;&#x9;person.father = null;&#xA;&#x9;&#x9;this.children.remove(person);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Person-argumentet settes til å være moren til Person-objektet som metoden kaller på. Legger så til &#xA;&#x9;// Person-objektet som metoden kalles på i children-listen til Person-argumentet&#xA;&#x9;private void setMother(Person person) {&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;person.children.add(this);&#xA;&#x9;}&#xA;&#xA;&#x9;// Person-argumentet settes til å være faren til Person-objektet som metoden kaller på. Legger så til &#xA;&#x9;// Person-objektet som metoden kalles på i children-listen til Person-argumentet&#xA;&#x9;private void setFather(Person person) {&#xA;&#x9;&#x9;this.father = person;&#xA;&#x9;&#x9;person.children.add(this);&#xA;&#x9;}&#xA;&#xA;&#x9;// toString-metode - returnerer navnet til Person-objektet&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;&quot; + name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// main-metode&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person person1 = new Person(&quot;Bjørn&quot;, 'M');&#xA;&#x9;&#x9;Person person2 = new Person(&quot;Reidun&quot;, 'F');&#xA;&#x9;&#x9;Person person3 = new Person(&quot;Gaute&quot;, 'M');&#xA;&#x9;&#x9;Person person4 = new Person(&quot;Vetle&quot;, 'M');&#xA;&#x9;&#x9;person1.addChild(person3);&#xA;&#x9;&#x9;person1.addChild(person4);&#xA;&#x9;&#x9;System.out.println(person1 + &quot; er faren til &quot; + person1.getChild(1) + &quot; og &quot; + person1.getChild(2));&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="1851" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488024968487" sizeMeasure="159">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Person {&#xA;&#x9;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#x9;private List&lt;Person> children = new ArrayList&lt;Person>();&#xA;&#x9;&#xA;&#x9;// konstruktør som initialiserer et nytt Person-objekt&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;if (gender != 'F' &amp;&amp; gender != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kjønn må enten være mann 'M' eller kvinne 'F'&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer navnet til Person-objektet&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer kjønnet til Person-objektet&#xA;&#x9;public char getGender() {&#xA;&#x9;&#x9;return gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet mother (vil this.mother returnere null by defualt?)&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;if (this.mother == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer Person-objektet father (vil this.father returnere null by defualt?)&#xA;&#x9;public Person getFather() {&#xA;&#x9;&#x9;if (this.father == null) {&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return father;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer antall barn tilhørende dette Person-objektet&#xA;&#x9;public int getChildCount() {&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// returnerer barn nr. n (Person-objekt), utløser unntak ved for liten/stor n&#xA;&#x9;public Person getChild(int n) {&#xA;&#x9;&#x9;if (n &lt; 1 || n > children.size()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Må være et tall fra og med 1 til og med &quot; + children.size());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return children.get(n - 1);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Person-objektet som metoden kalles på settes til å være enten faren eller moren til Person-argumentet&#xA;&#x9;public void addChild(Person person) {&#xA;&#x9;&#x9;if (this.children.contains(person)) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.children.add(person);&#xA;&#x9;&#x9;if (this.getGender() == 'M') {&#xA;&#x9;&#x9;&#x9;person.setFather(this);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;person.setMother(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeChild(Person person) {&#xA;&#x9;&#x9;// sjekker om person ikke er barnet til this&#xA;&#x9;&#x9;if (!this.children.contains(person)) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.children.remove(person);&#xA;&#x9;&#x9;// fjerner så koblingen tilbake - altså setter this (far/mor) til å være null&#xA;&#x9;&#x9;if (person.getMother() == this) {&#xA;&#x9;&#x9;&#x9;person.mother = null;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;person.father = null;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Person-argumentet settes til å være moren til Person-objektet som metoden kaller på. Legger så til &#xA;&#x9;// Person-objektet som metoden kalles på i children-listen til Person-argumentet&#xA;&#x9;private void setMother(Person person) {&#xA;&#x9;&#x9;if (this.getMother() == person) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.getMother() != null) {&#xA;&#x9;&#x9;&#x9;this.getMother().removeChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (person == null) {&#xA;&#x9;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;if (this.getMother() != null) {&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;// Person-argumentet settes til å være faren til Person-objektet som metoden kaller på. Legger så til &#xA;&#x9;// Person-objektet som metoden kalles på i children-listen til Person-argumentet&#xA;&#x9;private void setFather(Person person) {&#xA;&#x9;&#x9;if (this.getFather() == person) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.getFather() != null) {&#xA;&#x9;&#x9;&#x9;this.getFather().removeChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.father = person;&#xA;&#x9;&#x9;if (this.getFather() != null) {&#xA;&#x9;&#x9;&#x9;person.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;// toString-metode - returnerer navnet til Person-objektet&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String nameMother = &quot;&quot;;&#xA;&#x9;&#x9;String nameFather = &quot;&quot;;&#xA;&#x9;&#x9;if (this.getMother() != null) {&#xA;&#x9;&#x9;&#x9;nameMother = this.getMother().getName();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (this.getFather() != null) {&#xA;&#x9;&#x9;&#x9;nameFather = this.getFather().getName();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;String personString = &quot;Navn: &quot; + name + &quot;\nMor: &quot; + nameMother + &quot;\nFar: &quot; + nameFather + &quot;\nBarn: &quot;;&#xA;&#x9;&#x9;for (int i = 1; i &lt;= this.getChildCount(); i++) {&#xA;&#x9;&#x9;&#x9;personString += this.getChild(i).getName() + &quot; &quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return personString + &quot;\n&quot;;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// main-metode&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person person1 = new Person(&quot;Hallvard&quot;, 'M');&#xA;&#x9;&#x9;Person person2 = new Person(&quot;Marit&quot;, 'F');&#xA;&#x9;&#x9;Person person3 = new Person(&quot;Jens&quot;, 'M');&#xA;&#x9;&#x9;//person2.addChild(person3);&#xA;&#x9;&#x9;//person1.addChild(person3);&#xA;&#x9;&#x9;person3.setMother(person2);&#xA;&#x9;&#x9;person3.setFather(person1);&#xA;&#x9;&#x9;//person2.removeChild(person3);&#xA;&#x9;&#x9;//person1.removeChild(person3);&#xA;&#x9;&#x9;person3.setFather(null);&#xA;&#x9;&#x9;person3.setMother(null);&#xA;&#xA;&#x9;&#x9;System.out.println(person3);&#xA;&#x9;&#x9;System.out.println(person2);&#xA;&#x9;&#x9;System.out.println(person1" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="44" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025027095" sizeMeasure="161">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else if (person.getGender() != 'F') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Moren må være en kvinne.&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.mother = person;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="2599" end="-1608"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025061868" sizeMeasure="167">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (person == null) {&#xA;&#x9;&#x9;&#x9;this.father = person;&#xA;&#x9;&#x9;} else if (person.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Faren må være en mann.&quot;);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.father = person;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="3170" end="-1161"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025088643" sizeMeasure="163">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1);&#xA;&#x9;&#x9;person3.setFather(person2" edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="4267" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025098802" sizeMeasure="163">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2);&#xA;&#x9;&#x9;person3.setFather(person1" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="4267" end="-104"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025187273" sizeMeasure="163">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ublic" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="3001" end="-1395"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025194832" sizeMeasure="163">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ublic" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="2380" end="-2015"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025352220" sizeMeasure="167" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == person) {&#xA;&#x9;&#x9;&#x9;throw new IllegalAccessException(&quot;Kan ikke være sin egen mor.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="2428" end="-1983"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025361008" sizeMeasure="166">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rgumentException(&quot;Kan ikke være sin egen mor.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="2463" end="-1983"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488025369432" sizeMeasure="169">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == person) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke være sin egen far.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.63/@edit" start="3146" end="-1363"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487711645719" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487711660164" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487711674703" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487713461801" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487713625549" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488025089553" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488025100070" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488025375319" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="0.23076923076923078">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487711709394" completion="0.07692307692307693" successCount="1" errorCount="12"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487713631306" completion="0.07692307692307693" successCount="1" errorCount="12"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487764185695" completion="0.07692307692307693" successCount="1" errorCount="12"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488025161099" completion="0.07692307692307693" successCount="1" errorCount="12"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488025206401" completion="0.23076923076923078" successCount="3" failureCount="2" errorCount="8"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
