<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487509471296" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#x9;&#xA;&#x9;private TwitterAccount user1;&#xA;&#x9;private String text;&#xA;&#x9;private Tweet reTweet;&#xA;&#x9;private int reTweetCount;&#xA;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount user1, String text){&#xA;&#x9;&#x9;this.user1 = user1;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;reTweetCount = 0;&#xA;&#x9;&#x9;reTweet = null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount user1, Tweet reTweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.user1 = user1;&#xA;&#x9;&#x9;text = &quot;&quot;;&#xA;&#x9;&#x9;reTweetCount = 0;&#xA;&#x9;&#x9;this.reTweet = reTweet;&#xA;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;&#x9;if(user1 == reTweet.getOwner()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;if(reTweet != null){&#xA;&#x9;&#x9;&#x9;reTweet.getText();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return text;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return user1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount getRetweeter(){&#xA;&#x9;&#x9;return user1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return reTweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="569" charEnd="578" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487509505535" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if(reTweet != null){&#xA;&#x9;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="551" end="-240"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487509644325" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="void incrementReTweet(){&#xA;&#x9;&#x9;reTweetCount++;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="531" end="-308"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487509665907" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="reTweet.incrementReTweet();" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="430" end="-451"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487509742454" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="eet getOriginalTweet(){&#xA;&#x9;&#x9;return reTweet;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="738" end="-186"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487509938683" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public Tweet(TwitterAccount user1, String text){&#xA;&#x9;&#x9;this.user1 = user1;&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;reTweetCount = 0;&#xA;&#x9;&#x9;reTweet = null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount user1, Tweet reTweet){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.user1 = user1;&#xA;&#x9;&#x9;text = &quot;&quot;;&#xA;&#x9;&#x9;reTweetCount = 0;&#xA;&#x9;&#x9;this.reTweet = reTweet;&#xA;&#x9;&#x9;reTweet.incrementReTweet();&#xA;&#x9;&#xA;&#x9;&#x9;if(user1 == reTweet.getOwner()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot retweet your own Tweet :( &quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementReTweet(){&#xA;&#x9;&#x9;reTweetCount++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(reTweet != null){&#xA;&#x9;&#x9;&#x9;return reTweet.getText();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return text;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;return reTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwn" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="156" end="-89"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487510855638" sizeMeasure="53">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.user1 = user1;&#xA;&#x9;&#x9;text = &quot;&quot;;&#xA;&#x9;&#x9;reTweetCount = 0;&#xA;&#x9;&#x9;this.reTweet = reTweet;&#xA;&#x9;&#x9;reTweet.incrementReTweet();&#xA;&#x9;&#xA;&#x9;&#x9;if(user1 == reTweet.getOwner()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot retweet your own Tweet :( &quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementReTweet(){&#xA;&#x9;&#x9;reTweetCount++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;if(reTweet != null){&#xA;&#x9;&#x9;&#x9;return reTweet.getText();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return text;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;return reTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;return user1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;return reTweetCount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="344" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487513715063" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(reTweet != null){&#xA;&#x9;&#x9;&#x9;reTweet.incrementReTweet();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="610" end="-313"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487513728563" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else{&#xA;&#x9;&#x9;reTweetCount++;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="668" end="-295"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487513741360" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="676" end="-316"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487516197367" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if(user1 == reTweet.getOwner()){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot retweet your own Tweet :( &quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.user1 = user1;&#xA;&#x9;&#x9;text = &quot;&quot;;&#xA;&#x9;&#x9;reTweetCount = 0;&#xA;&#x9;&#x9;this.reTweet = reTweet.getOriginalTweet();&#xA;&#x9;&#x9;this.reTweet.incrementReTweet();&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void incrementReTweet(){&#xA;&#x9;&#x9;if(reTweet != null){&#xA;&#x9;&#x9;&#x9;reTweet.incrementReTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;reTweetCount++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText(){&#xA;&#x9;&#x9;if(reTweet != null){&#xA;&#x9;&#x9;&#x9;return reTweet.getText();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return text;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet(){&#xA;&#x9;&#x9;if(reTweet != null){&#xA;&#x9;&#x9;&#x9;return reTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return this;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="344" end="-122"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487516258728" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="947" end="-130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487516426761" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;this.reTweet = reTweet.getOriginalTweet();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.reTweet != null){&#xA;&#x9;&#x9;&#x9;this.reTweet.incrementReTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="517" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487517013706" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="543" end="-558"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487517969260" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner(){&#xA;&#x9;&#x9;if(reTweet != null){&#xA;&#x9;&#x9;&#x9;return reTweet.getOwner();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="978" end="-82"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487517980558" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1154" end="-1155"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487518024021" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1019" end="-82"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487510358800" sizeMeasure="25" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String Username;&#xA;&#x9;private List&lt;TwitterAccount> followList = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String Username){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.Username = Username;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return Username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="163" charEnd="172" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487510471777" sizeMeasure="24" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ull;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String Username){&#xA;&#x9;&#x9;this.Username = Username;&#xA;&#x9;&#x9;followList = new ArrayList&lt;TwitterAccount>();" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="153" end="-117"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="12" charStart="259" charEnd="268" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="146" charEnd="156" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487510830917" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String Username;&#xA;&#x9;private List&lt;TwitterAccount> followList = null;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String Username){&#xA;&#x9;&#x9;this.Username = Username;&#xA;&#x9;&#x9;followList = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return Username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;if(account != null){&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; followList.size(); i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (followList.get(i) == account){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;followList.add(account);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="44" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487510979096" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;if(account != null){&#xA;&#x9;&#x9;&#x9;for (int i = 0; i &lt; followList.size(); i++){&#xA;&#x9;&#x9;&#x9;&#x9;if (followList.get(i) == account){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;followList.remove(account);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="576" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487510992734" sizeMeasure="42">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="774" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487511611915" sizeMeasure="61" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private List&lt;Tweet> tweetList = null;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String Username){&#xA;&#x9;&#x9;this.Username = Username;&#xA;&#x9;&#x9;followList = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#x9;tweetList = new ArrayList&lt;Tweet>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName(){&#xA;&#x9;&#x9;return Username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;if(account != null){&#xA;&#x9;&#x9;&#x9;if(isFollowing(account)){&#xA;&#x9;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;followList.add(account);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account){&#xA;&#x9;&#x9;if(account != null){&#xA;&#x9;&#x9;&#x9;if (isFollowing(account)){&#xA;&#x9;&#x9;&#x9;&#x9;followList.remove(account);&#xA;&#x9;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFollower(TwitterAccount account){&#xA;&#x9;&#x9;for (int i = 0; i &lt; followList.size(); i++){&#xA;&#x9;&#x9;&#x9;if (followList.get(i) == account){&#xA;&#x9;&#x9;&#x9;&#x9;return i;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account){&#xA;&#x9;&#x9;return getFollower(account) > -1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account){&#xA;&#x9;&#x9;return account.isFollowing(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String text){&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="187" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="216" charEnd="225" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487511724283" sizeMeasure="62" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet t = new Tweet(this, text);" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1149" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="216" charEnd="225" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="58" charStart="1212" charEnd="1213" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487511867316" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetList.add(new Tweet(this, text));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet){&#xA;&#x9;&#x9;tweetList.add(new Tweet(this, tweet));" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1149" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487512674753" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public Tweet getTweet(int i){&#xA;&#x9;&#x9;int index = tweetList.size()-i;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(index >= 0 &amp;&amp; index &lt;= tweetList.size()){&#xA;&#x9;&#x9;&#x9;return tweetList.get(index);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return null;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1273" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487512677566" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1426" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487512775448" sizeMeasure="81" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount(){&#xA;&#x9;&#x9;return tweetList.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount(){&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1426" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1594" charEnd="1611" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487513014737" sizeMeasure="84" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int counter = 0;&#xA;&#x9;&#x9;for (int i = 0; i &lt; tweetList.size(); i++){&#xA;&#x9;&#x9;&#x9;counter += tweetList.get(i).getRetweetCount();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1538" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1594" charEnd="1611" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487513020483" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return counter;" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1656" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487513168136" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new IllegalArgumentException(&quot;No such tweet!&quot;)" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1426" end="-242"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487517857147" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="weet.getOwner()" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1254" end="-463"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487517871429" sizeMeasure="85">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1254" end="-463"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487518312887" sizeMeasure="95">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;Tweet t = tweetList.get(index);&#xA;&#x9;&#x9;&#x9;Tweet originalTweet = t.getOriginalTweet();&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(originalTweet != null){&#xA;&#x9;&#x9;&#x9;&#x9;return originalTweet;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;return t;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1391" end="-301"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487509687662" completion="0.75" successCount="3" errorCount="1">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
          <errorTests>testGetOriginalTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487509751487" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487513753837" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487516211426" completion="0.75" successCount="3" failureCount="1">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
          <failureTests>testGetOriginalTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487516264032" completion="0.25" successCount="1" errorCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <errorTests>testGetRetweetCount</errorTests>
          <errorTests>testGetOriginalTweet</errorTests>
          <errorTests>testConstructorRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487516433112" completion="0.25" successCount="1" failureCount="3">
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testGetRetweetCount</failureTests>
          <failureTests>testGetOriginalTweet</failureTests>
          <failureTests>testConstructorRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487517015052" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487517986284" completion="0.75" successCount="3" failureCount="1">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <failureTests>testConstructorRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487518027574" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487518322317" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="0.8333333333333334">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487510856826" completion="0.0" errorCount="6">
          <errorTests>testGetTweetIllegal</errorTests>
          <errorTests>testUnfollow</errorTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testFollow</errorTests>
          <errorTests>testConstructor</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487512680926" completion="0.3333333333333333" successCount="2" failureCount="1" errorCount="3">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testConstructor</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487513024919" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487513173660" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487513742414" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487513764429" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487513811247" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487513958134" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487517023708" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487517302534" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487517865966" completion="0.8333333333333334" successCount="5" errorCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <errorTests>testRetweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487517893243" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487518000305" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487518033539" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487518327879" completion="0.8333333333333334" successCount="5" failureCount="1">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
          <failureTests>testRetweet</failureTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="21">
        <attempts timestamp="1487513269424"/>
        <attempts timestamp="1487513272062"/>
        <attempts timestamp="1487513287818"/>
        <attempts timestamp="1487513289245"/>
        <attempts timestamp="1487513290095"/>
        <attempts timestamp="1487513293037"/>
        <attempts timestamp="1487513313158"/>
        <attempts timestamp="1487513334491"/>
        <attempts timestamp="1487513337836"/>
        <attempts timestamp="1487513353738"/>
        <attempts timestamp="1487513446330"/>
        <attempts timestamp="1487513447806"/>
        <attempts timestamp="1487513448534"/>
        <attempts timestamp="1487513844310"/>
        <attempts timestamp="1487513845654"/>
        <attempts timestamp="1487513846150"/>
        <attempts timestamp="1487513846482"/>
        <attempts timestamp="1487513846799"/>
        <attempts timestamp="1487513847926"/>
        <attempts timestamp="1487513857822"/>
        <attempts timestamp="1487513858722"/>
        <attempts timestamp="1487513868242"/>
        <attempts timestamp="1487513873282"/>
        <attempts timestamp="1487513873929"/>
        <attempts timestamp="1487513886456"/>
        <attempts timestamp="1487513888112"/>
        <attempts timestamp="1487513889152"/>
        <attempts timestamp="1487513890852"/>
        <attempts timestamp="1487513892725"/>
        <attempts timestamp="1487513893741"/>
        <attempts timestamp="1487513894400"/>
        <attempts timestamp="1487513894863"/>
        <attempts timestamp="1487513895051"/>
        <attempts timestamp="1487513910849"/>
        <attempts timestamp="1487513913243"/>
        <attempts timestamp="1487513913785"/>
        <attempts timestamp="1487513913998"/>
        <attempts timestamp="1487513914613"/>
        <attempts timestamp="1487513915504"/>
        <attempts timestamp="1487513924445"/>
        <attempts timestamp="1487513925036"/>
        <attempts timestamp="1487513991505"/>
        <attempts timestamp="1487514044230"/>
        <attempts timestamp="1487516481028"/>
        <attempts timestamp="1487516483400"/>
        <attempts timestamp="1487516496226"/>
        <attempts timestamp="1487516619352"/>
        <attempts timestamp="1487516620936"/>
        <attempts timestamp="1487516632625"/>
        <attempts timestamp="1487516634181"/>
        <attempts timestamp="1487516635457"/>
        <attempts timestamp="1487516816548"/>
        <attempts timestamp="1487516818753"/>
        <attempts timestamp="1487516821816"/>
        <attempts timestamp="1487516831660"/>
        <attempts timestamp="1487516837648"/>
        <attempts timestamp="1487516851310"/>
        <attempts timestamp="1487516855463"/>
        <attempts timestamp="1487517082550"/>
        <attempts timestamp="1487517172808"/>
        <attempts timestamp="1487517395850"/>
        <attempts timestamp="1487517403417"/>
        <attempts timestamp="1487517406326"/>
        <attempts timestamp="1487517417341"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="3">
        <attempts timestamp="1487513295763"/>
        <attempts timestamp="1487513302464"/>
        <attempts timestamp="1487513850249"/>
        <attempts timestamp="1487513861579"/>
        <attempts timestamp="1487513918664"/>
        <attempts timestamp="1487513928016"/>
        <attempts timestamp="1487513985159"/>
        <attempts timestamp="1487516720272"/>
        <attempts timestamp="1487516811028"/>
        <attempts timestamp="1487517345568"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="5">
        <attempts timestamp="1487513252323"/>
        <attempts timestamp="1487513273824"/>
        <attempts timestamp="1487513852009"/>
        <attempts timestamp="1487513946467"/>
        <attempts timestamp="1487516491459"/>
        <attempts timestamp="1487516637685"/>
        <attempts timestamp="1487516728965"/>
        <attempts timestamp="1487516863898"/>
        <attempts timestamp="1487517078230"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
