<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936942802" sizeMeasure="26" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#x9;&#xA;&#x9;private String tweet;&#xA;&#x9;private TwitterAccount account;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String tweet) {&#xA;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;&#x9;this.account = &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937414177" sizeMeasure="26" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nyTweet) {&#xA;&#x9;&#x9;this.tweet = nyTweet;&#xA;&#x9;&#x9;this.account = account;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="153" end="-74"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937450432" sizeMeasure="26" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="220" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937694399" sizeMeasure="30" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;if (account == this.account) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="220" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942530862" sizeMeasure="44" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet) {&#xA;&#x9;&#x9;if (account == this.account) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.tweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="263" end="-59"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487943351469" sizeMeasure="51" errorCount="2" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import javafx.geometry.Orientation;&#xA;&#xA;public class Tweet {&#xA;&#x9;&#xA;&#x9;private String tweet;&#xA;&#x9;private TwitterAccount account;&#xA;&#x9;private Tweet originalTweet;&#xA;&#x9;private int timesTweeted;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String nyTweet) {&#xA;&#x9;&#x9;this.tweet = nyTweet;&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;if (account == tweet.getOwner()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet&quot;);&#xA;&#x9;&#x9;} if (tweet.getOriginalTweet() == null) {&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.tweet = tweet.getText();&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;timesTweeted += 1;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="27" end="-262"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487944348191" sizeMeasure="50" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;public class Tweet {&#xA;&#x9;&#xA;&#x9;private String tweet;&#xA;&#x9;private TwitterAccount account;&#xA;&#x9;private Tweet originalTweet;&#xA;&#x9;private int timesTweeted;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String nyTweet) {&#xA;&#x9;&#x9;this.tweet = nyTweet;&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;if (account == tweet.getOwner()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet&quot;);&#xA;&#x9;&#x9;} if (tweet.getOriginalTweet() == null) {&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.tweet = tweet.getText();&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;timesTweeted += 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.tweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if ()" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="27" end="-102"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487944394122" sizeMeasure="53" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.originalTweet != null) {&#xA;&#x9;&#x9;&#x9;return this.originalTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="759" end="-102"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487944425479" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.timesTweeted;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="877" end="-54"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487944784275" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="108" end="-845"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487944864745" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private " edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="108" end="-845"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487945656400" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%s tweeted:\n\n'%s'&quot;, this.account, this.originalTweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount a1 = new TwitterAccount(&quot;POTUS&quot;);&#xA;&#x9;&#x9;TwitterAccount a2 = new TwitterAccount(&quot;FLOTUS&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet t1 = new Tweet(a1, &quot;Im gonna build a wall&quot;);&#xA;&#x9;&#x9;System.out.println(t1);&#xA;&#x9;&#x9;Tweet t2 = new Tweet(a2, t1);&#xA;&#x9;&#x9;System.out.println(t2);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="916" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487945740112" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="t" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1001" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283259225" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Retweeted;&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, String nyTweet) {&#xA;&#x9;&#x9;this.tweet = nyTweet;&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount account, Tweet tweet) {&#xA;&#x9;&#x9;if (account == tweet.getOwner()) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke retweete egen tweet&quot;);&#xA;&#x9;&#x9;} if (tweet.getOriginalTweet() == null) {&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.originalTweet = tweet.getOriginalTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;this.tweet = tweet.getText();&#xA;&#x9;&#x9;this.account = account;&#xA;&#x9;&#x9;timesRetweeted += 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;return this.tweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;return this.account;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;if (this.originalTweet != null) {&#xA;&#x9;&#x9;&#x9;return this.originalTweet;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;return this.timesRet" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="155" end="-417"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488283553448" sizeMeasure="69">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.getOriginalTweet() == null) {&#xA;&#x9;&#x9;&#x9;tweet.timesRetweeted += 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;tweet.originalTweet.timesRetweeted += 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="640" end="-719"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487854539242" sizeMeasure="10">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487854547396" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="57" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942540215" sizeMeasure="15" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String username;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="60" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487944786610" sizeMeasure="15" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return String.format(&quot;%s tweetet:\n\n'%s'&quot;, this.username, Tweet.originalTweet);" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="191" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487944863291" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%s&quot;, this.username" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="163" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487946213557" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="249" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487948127222" sizeMeasure="40" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;private ArrayList&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private ArrayList&lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private ArrayList&lt;Tweet> tweet = new ArrayList&lt;Tweet>();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public TwitterAccount(String username) {&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account) {&#xA;&#x9;&#x9;this.following.add(account);&#xA;&#x9;&#x9;account.followers.add(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="27" end="-107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487953733263" sizeMeasure="45" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;account.followers.remove(this);&#xA;&#x9;&#x9;this.following.remove(account" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="585" end="-118"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487960104719" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;if (this.following.contains(account)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account) {&#xA;&#x9;&#x9;if (account.following.contains(this)) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String newTweet) {&#xA;&#x9;&#x9;Tweet t1 = new Tweet(this, newTweet);&#xA;&#x9;&#x9;this.tweet.add(t1);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="706" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487960576222" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet t1 = new Tweet(this, tweet);" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1123" end="-115"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488281396805" sizeMeasure="89">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweet.add(t1);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;int length = getTweetCount();&#xA;&#x9;&#x9;if (i > length) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Ugyldig: Overskrider antall tweets&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this.tweet.get(length - i);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;return this.tweet.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;for (Tweet i : tweet) {&#xA;&#x9;&#x9;&#x9;if (i.getOriginalTweet() == null) {&#xA;&#x9;&#x9;&#x9;&#x9;count += getRetweetCount();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return count;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1160" end="-107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488281490872" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1725" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282225761" sizeMeasure="83">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1725" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282490276" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return count;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%s&quot;, this.username);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1582" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282513046" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1501" end="-205"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282529337" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1501" end="-205"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488282819934" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="i.getRetweetCount()" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1582" end="-124"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487945656344" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487945740053" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488281864000" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282226501" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282837649" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488283564263" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488281876502" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282336287" completion="0.8333333333333334" successCount="5" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282493743" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282515256" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282531460" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488282822523" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488283570729" completion="1.0" successCount="6"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
