<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935657768" sizeMeasure="89">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.List;&#xA;&#xA;public class Person {&#xA;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private List&lt;Person> children;&#xA;&#x9;private Person mother;&#xA;&#x9;private Person father;&#xA;&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;// TODO: validation&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;}&#xA;&#xA;&#x9;public void addChild(Person kid) {&#xA;&#x9;&#x9;// TODO: make sure you can't clone your kids&#xA;&#x9;&#x9;if (!children.contains(kid)) {&#xA;&#x9;&#x9;&#x9;children.add(kid);&#xA;&#x9;&#x9;&#x9;if (gender == 'F') {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(this);&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person mother) {&#xA;&#x9;&#x9;if (mother != null) {&#xA;&#x9;&#x9;&#x9;if (mother.gender == 'M'){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Males can't be mothers, yet&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (!mother.children.contains(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;} else if (this.mother != null){&#x9;// if there exists a mother to remove, do it&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You're trying to orphan an orphan&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// if you're trying to ADD a father...&#xA;&#x9;&#x9;if (father != null) {&#xA;&#x9;&#x9;&#x9;if (father.gender == 'F'){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Females can't be fathers, yet&quot;);&#xA;&#x9;&#x9;&#x9;};&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if the father DOES NOT know of this kid yet, let him know&#xA;&#x9;&#x9;&#x9;if (!father.children.contains(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// make this kid know about his father&#xA;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;} else if (this.father != null){  // if there exists a dad to remove, do it&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You're trying to orphan an orphan&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void removeChild(Person kid) {&#xA;&#x9;&#x9;if (children.contains(kid)) {&#xA;&#x9;&#x9;&#x9;children.remove(kid);&#xA;&#x9;&#x9;&#x9;if (gender == 'F') {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(null);&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setFather(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You can't remove a kid you don't own&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935685023" sizeMeasure="93">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return gender" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="2036" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935762872" sizeMeasure="100">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person mette = new Person(&quot;Mette&quot;, 'F');&#xA;&#x9;&#x9;mette.addChild(new Person(&quot;Vegard&quot;, 'M'));&#xA;&#x9;&#x9;Person kristin = new Person(&quot;Kristin&quot;, 'F');&#xA;&#x9;&#x9;kristin.setMother(mette)" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="2084" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935879019" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String outstring = &quot;&quot;;&#xA;&#x9;&#x9;outstring += name;&#xA;&#x9;&#x9;outstring += &quot;\nChildren:&quot;;&#xA;&#x9;&#x9;for (Person kid : children){&#xA;&#x9;&#x9;&#x9;outstring += kid.getName() + &quot;\n&quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;outstring += &quot;Father: &quot; + father;&#xA;&#x9;&#x9;outstring += &quot;Mother: &quot; + mother;&#xA;&#x9;&#x9;return outstring" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="2087" end="-219"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935884054" sizeMeasure="115">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="2580" end="-16"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935931230" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class Person {&#xA;&#xA;&#x9;private String name;&#xA;&#x9;private char gender;&#xA;&#x9;private List&lt;Person> children = new ArrayList&lt;Person>()" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="44" end="-2467"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935940415" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="  + &quot;\n&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="2365" end="-304"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935948226" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="\n" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="2252" end="-425"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935960161" sizeMeasure="118" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(kristin);&#xA;&#x9;&#x9;System.out.println(vegard" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="2673" end="-10"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="115" charStart="2838" charEnd="2844" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487935980651" sizeMeasure="119">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Person vegard = new Person(&quot;Vegard&quot;, 'M');&#xA;&#x9;&#x9;mette.addChild(vegard" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="2525" end="-175"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936026699" sizeMeasure="120">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="##########################&quot;;&#xA;&#x9;&#x9;outstring += name;&#xA;&#x9;&#x9;outstring += &quot;\nChildren:\n&quot;;&#xA;&#x9;&#x9;for (Person kid : children){&#xA;&#x9;&#x9;&#x9;outstring += kid.getName() + &quot;\n&quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;outstring += &quot;Father: &quot; + father  + &quot;\n&quot;;&#xA;&#x9;&#x9;outstring += &quot;Mother: &quot; + mother;&#xA;&#x9;&#x9;outstring += &quot;##########################&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="2201" end="-355"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936036552" sizeMeasure="120">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="\n&quot;;&#xA;&#x9;&#x9;outstring += name;&#xA;&#x9;&#x9;outstring += &quot;\nChildren:\n&quot;;&#xA;&#x9;&#x9;for (Person kid : children){&#xA;&#x9;&#x9;&#x9;outstring += kid.getName() + &quot;\n&quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;outstring += &quot;Father: &quot; + father  + &quot;\n&quot;;&#xA;&#x9;&#x9;outstring += &quot;Mother: &quot; + mother + &quot;\n&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="2227" end="-400"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936053287" sizeMeasure="119">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="2450" end="-356"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936080191" sizeMeasure="119">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getName()  + &quot;\n&quot;;&#xA;&#x9;&#x9;outstring += &quot;Mother: &quot; + mother.getName() + &quot;\n" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="2395" end="-356"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936118808" sizeMeasure="119">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (father != null){outstring += &quot;Father: &quot; + father.getName()  + &quot;\n&quot;;}&#xA;&#x9;&#x9;if (mother != null){outstring += &quot;Mother: &quot; + mother.getName() + &quot;\n&quot;;}" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="2363" end="-354"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936281280" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (children.get(0) != null) {&#xA;&#x9;&#x9;&#x9;outstring += &quot;\nChildren:\n&quot;;&#xA;&#x9;&#x9;&#x9;for (Person kid : children) {&#xA;&#x9;&#x9;&#x9;&#x9;outstring += kid.getName() + &quot;\n&quot;;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="2255" end="-510"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936298244" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="size() != 0" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="2268" end="-623"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936310722" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot;\n&quot;;&#xA;&#x9;&#x9;if (children.size() != 0) {&#xA;&#x9;&#x9;&#x9;outstring += &quot;" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="2251" end="-600"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487936327224" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;\t&quot; +" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="2371" end="-536"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937163431" sizeMeasure="126">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kid HAS an existing father, remove this kid from him&#xA;&#x9;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if the father DOES NOT know of this kid yet, let him know&#xA;&#x9;&#x9;&#x9;if (!father.children.contains(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// make this kid know about his father&#xA;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;} else if (this.father != null){  // if trying to orphan and has a father, remove" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1332" end="-1311"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937220523" sizeMeasure="135">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// if you're trying to ADD a mother...&#xA;&#x9;&#x9;if (mother != null) {&#xA;&#x9;&#x9;&#x9;if (mother.gender == 'M'){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Males can't be mothers, yet&quot;);&#xA;&#x9;&#x9;&#x9;};&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if kid HAS an existing mother, remove this kid from him&#xA;&#x9;&#x9;&#x9;if (this.mother != null){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if the mother DOES NOT know of this kid yet, let him know&#xA;&#x9;&#x9;&#x9;if (!mother.children.contains(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// make this kid know about his mother&#xA;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;} else if (this.mother != null){  // if trying to orphan and has a mother, remove" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="645" end="-2109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937322076" sizeMeasure="139">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Person kristin = new Person(&quot;Kristin&quot;, 'F');&#xA;&#x9;&#x9;Person odd = new Person(&quot;Odd&quot;, 'M');&#xA;&#x9;&#x9;mette.addChild(vegard);&#xA;&#x9;&#x9;kristin.setMother(mette);&#xA;&#x9;&#x9;odd.addChild(kristin);&#xA;&#x9;&#x9;vegard.setFather(odd);&#xA;&#x9;&#x9;System.out.println(mette);&#xA;&#x9;&#x9;System.out.println(kristin);&#xA;&#x9;&#x9;System.out.println(vegard);&#xA;&#x9;&#x9;System.out.println(od" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="3155" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937575625" sizeMeasure="147">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public Person getMother(){&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getFather(){&#xA;&#x9;&#x9;return father" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="3463" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937669740" sizeMeasure="156">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public Person getChild(int i){&#xA;&#x9;&#x9;if (children.size() != 0 &amp;&amp; i >= 0 &amp;&amp; i &lt; children.size()){&#xA;&#x9;&#x9;&#x9;return children.get(i);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;No such kid at index &quot; + i);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="3563" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937690840" sizeMeasure="160">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public int getChildCount(){&#xA;&#x9;&#x9;return children.size();" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="3773" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938377668" sizeMeasure="162">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*  you dont set a parent to null just because you removed a child.&#xA;&#x9;&#x9;&#x9;if (gender == 'F') {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(null);&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setFather(null);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;*/" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="2296" end="-1454"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938682284" sizeMeasure="162">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="mother){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if the mother DOES NOT know of this kid yet, let him know&#xA;&#x9;&#x9;&#x9;if (!mother.children.contains(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// make this kid know about his mother&#xA;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;} else if (this.mother != null){  // if trying to orphan and has a mother, remove it&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You're trying to orphan an orphan&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// if you're trying to ADD a father...&#xA;&#x9;&#x9;if (father != null) {&#xA;&#x9;&#x9;&#x9;if (father.gender == 'F'){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Females can't be fathers, yet&quot;);&#xA;&#x9;&#x9;&#x9;};&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if kid HAS an existing father, remove this kid from him&#xA;&#x9;&#x9;&#x9;if (this.father != father" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="903" end="-2209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938819840" sizeMeasure="162">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1703" end="-2209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938891031" sizeMeasure="166">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" (if it exists at him)&#xA;&#x9;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if the father DOES NOT know of this kid yet, let him know&#xA;&#x9;&#x9;&#x9;if (!father.children.contains(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// make this kid know about his father&#xA;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;} else if (this.father != null){  // if trying to orphan and has a father, remove it&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You're trying to orphan an orphan&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean hasChild(Person kid){&#xA;&#x9;&#x9;return children.contains(kid);" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1680" end="-1722"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939188731" sizeMeasure="193">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; this.mother.hasChild(this)){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if the mother DOES NOT know of this kid yet, let him know&#xA;&#x9;&#x9;&#x9;if (!mother.hasChild(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// make this kid know about his mother&#xA;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;} else if (this.mother != null){  // if trying to orphan and has a mother, remove it&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.mother = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You're trying to orphan an orphan&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO FATHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;/*&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// if you're trying to ADD a father...&#xA;&#x9;&#x9;if (father != null) {&#xA;&#x9;&#x9;&#x9;if (father.gender == 'F'){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Females can't be fathers, yet&quot;);&#xA;&#x9;&#x9;&#x9;};&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if kid HAS an existing father, remove this kid from him (if it exists at him)&#xA;&#x9;&#x9;&#x9;if (this.father != null &amp;&amp; this.father.hasChild(this)){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// if the father DOES NOT know of this kid yet, let him know&#xA;&#x9;&#x9;&#x9;if (!father.hasChild(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// make this kid know about his father&#xA;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;} else if (this.father != null){  // if trying to orphan and has a father, remove it&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;this.father = null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You're trying to orphan an orphan&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;*/" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="909" end="-1798"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939239058" sizeMeasure="193">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; kid.getMother() != this) {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(this);&#xA;&#x9;&#x9;&#x9;} else if (kid.getFather() != this)" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="524" end="-3989"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939288282" sizeMeasure="193">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="IF A MOTHER EXISTS.&#xA;&#x9;&#x9;if (this.mother != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING MOTHER&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="703" end="-3139"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939371626" sizeMeasure="193">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=") {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(this);&#xA;&#x9;&#x9;&#x9;} else " edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="524" end="-3697"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939379523" sizeMeasure="193">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; kid.getMother() != this) {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(this);&#xA;&#x9;&#x9;&#x9;} else if (kid.getFather() != this)" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="524" end="-3697"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939407912" sizeMeasure="167">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1708" end="-1798"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939414214" sizeMeasure="160">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1887" end="-1454"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939526666" sizeMeasure="160">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="gender == 'M' &amp; kid.getFather() != this){&#xA;&#x9;&#x9;&#x9;&#x9;kid.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person mother) {&#xA;&#x9;&#x9;// IF A MOTHER EXISTS.&#xA;&#x9;&#x9;if (this.mother != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING MOTHER&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO FATHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean hasChild(Person kid){&#xA;&#x9;&#x9;return children.contains(kid);&#xA;&#x9;}&#xA;&#xA;&#x9;public void removeChild(Person kid) {&#xA;&#x9;&#x9;if (children.contains(kid)) {&#xA;&#x9;&#x9;&#x9;children.remove(kid);" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="594" end="-1454"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939954608" sizeMeasure="160">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="MOTHERS&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.father.remove" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="894" end="-1867"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940292553" sizeMeasure="161">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// this causes the kid to be removed from the new mother..." edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="915" end="-2444"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940362647" sizeMeasure="161">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fix the duplicate run of setmothers and stuff..." edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="413" end="-2970"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940394877" sizeMeasure="161">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" if (mother != this.mother){&#xA;&#x9;&#x9;&#x9;&#x9;// this causes the kid to be removed from the new mother...&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else if (father != this.father)" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="922" end="-1918"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940675372" sizeMeasure="169" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;// IF PERSON DOES NOT HAVE KID ALREADY&#xA;&#x9;&#x9;if (!children.contains(kid)) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// ADD THE KID&#xA;&#x9;&#x9;&#x9;children.add(kid);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// IF FEMALE AND THIS PERSON ISNT THE MOTHER OF KID, SET THE MOTHER TO THIS&#xA;&#x9;&#x9;&#x9;if (gender == 'F' &amp;&amp;) {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(this);&#xA;&#x9;&#x9;&#x9;} else if (gender == 'M'){&#xA;&#x9;&#x9;&#x9;&#x9;kid.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person mother) {&#xA;&#x9;&#x9;// IF A MOTHER EXISTS.&#xA;&#x9;&#x9;if (this.mother != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING MOTHER&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING MOTHERS&#xA;&#x9;&#x9;&#x9;else if (mother != this.mother){&#xA;&#x9;&#x9;&#x9;&#x9;// this causes the kid to be removed from the new mother...&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;// add this child to input mother" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="464" end="-2471"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="716" charEnd="718" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940682642" sizeMeasure="169">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="686" end="-2938"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940688741" sizeMeasure="169">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; kid.getMother() != this) {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(this);&#xA;&#x9;&#x9;&#x9;} else if (gender == 'M' &amp; kid.getFather() != this" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="686" end="-2882"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940807888" sizeMeasure="168">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="IF PERSON DOES NOT HAVE KID ALREADY&#xA;&#x9;&#x9;if (!children.contains(kid)) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// ADD THE KID&#xA;&#x9;&#x9;&#x9;children.add(kid);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;// IF FEMALE AND THIS PERSON ISNT THE MOTHER OF KID, SET THE MOTHER TO THIS&#xA;&#x9;&#x9;&#x9;// TODO: THIS CAUSES A LOOOOOOOP, HOW2FIX??&#xA;&#x9;&#x9;&#x9;if (gender == 'F' &amp;&amp; kid.getMother() != this) {&#xA;&#x9;&#x9;&#x9;&#x9;kid.setMother(this);&#xA;&#x9;&#x9;&#x9;} else if (gender == 'M' &amp; kid.getFather() != this){&#xA;&#x9;&#x9;&#x9;&#x9;kid.setFather(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person mother) {&#xA;&#x9;&#x9;// IF A MOTHER EXISTS.&#xA;&#x9;&#x9;if (this.mother != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING MOTHER&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING MOTHERS&#xA;&#x9;&#x9;&#x9;else if (mother != this.mother){&#xA;&#x9;&#x9;&#x9;&#x9;// this causes the kid to be removed from the new mother...&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;// add this child to input mother&#xA;&#x9;&#x9;&#x9;&#x9;if (!mother.hasChild(this)){mother.addChild(this);}&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else if (father != this.father){&#xA;&#x9;&#x9;&#x9;&#x9;if (!father.hasChild(this)){father.addChild(this);}" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="407" end="-1890"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940844167" sizeMeasure="168">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!mother.hasChild(this)){mother.addChild(this);}&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else if (father != this.father){&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="1157" end="-1946"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115172506" sizeMeasure="168">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; father != this" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="1733" end="-1953"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115219383" sizeMeasure="171">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if (father == this){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot set yourself as your father&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else if (father != this.father" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="1676" end="-1953"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115268020" sizeMeasure="171">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (father == this){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot set yourself as your father&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="1676" end="-1978"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115365954" sizeMeasure="171">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING MOTHERS&#xA;&#x9;&#x9;&#x9;else if (mother != this.mother){&#xA;&#x9;&#x9;&#x9;&#x9;// this causes the kid to be removed from the new mother...&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;if (!mother.hasChild(this)){mother.addChild(this);}&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (father == this){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot set yourself as your father&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else if (father != this.father){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;if (!father.hasChild(this)){father.addChild(this);}&#xA;&#x9;&#x9;&#x9;&#x9;this.father.children.remove" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="978" end="-1862"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115444299" sizeMeasure="171">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="mother = this;&#xA;&#x9;&#x9;&#x9;} else if (gender == 'M' &amp; kid.getFather() != this){&#xA;&#x9;&#x9;&#x9;&#x9;kid.father = this" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="709" end="-3009"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115512795" sizeMeasure="177">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (kid.getMother() != null){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;kid.getMother().children.remove(kid);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;kid.mother = this;&#xA;&#x9;&#x9;&#x9;} else if (gender == 'M' &amp; kid.getFather() != this){&#xA;&#x9;&#x9;&#x9;&#x9;if (kid.getFather() != null){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;kid.getFather().children.remove(kid);&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="705" end="-3031"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115785226" sizeMeasure="185">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (mother != null) {&#xA;&#x9;&#x9;&#x9;if (mother.getGender() != 'F') {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Mothers must be females&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// IF A MOTHER EXISTS.&#xA;&#x9;&#x9;if (this.mother != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING MOTHER&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING MOTHERS&#xA;&#x9;&#x9;&#x9;else if (mother != this.mother){&#xA;&#x9;&#x9;&#x9;&#x9;// this causes the kid to be removed from the new mother...&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;if (!mother.hasChild(this)){mother.addChild(this);}&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="1024" end="-2401"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115791945" sizeMeasure="185">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// check gender" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="1024" end="-3099"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115821950" sizeMeasure="191">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="check gender&#xA;&#x9;&#x9;if (father != null) {&#xA;&#x9;&#x9;&#x9;if (father.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Fathers must be males&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="1849" end="-2295"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115869328" sizeMeasure="191">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (father == this){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot set yourself as your father&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="1994" end="-2024"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115886111" sizeMeasure="194">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (mother == this){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can't set yourself as mother" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="1174" end="-3122"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115953701" sizeMeasure="199">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;mother.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;//mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// check gender&#xA;&#x9;&#x9;if (father != null) {&#xA;&#x9;&#x9;&#x9;if (father.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Fathers must be males&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (father == this){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot set yourself as your father&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else if (father != this.father){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;if (!father.hasChild(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;father.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="1608" end="-1895"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118164250" sizeMeasure="197">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="527" end="-3802"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118174110" sizeMeasure="196">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (gender == 'F' &amp;&amp; kid.getMother() != this) {&#xA;&#x9;&#x9;&#x9;&#x9;if (kid.getMother() != null){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;kid.getMother().children.remove(kid);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;kid.mother = this;&#xA;&#x9;&#x9;&#x9;} else if (gender == 'M' &amp; kid.getFather() != this){&#xA;&#x9;&#x9;&#x9;&#x9;if (kid.getFather() != null){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;kid.getFather().children.remove(kid);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;kid.father = this;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person mother) {&#xA;&#x9;&#x9;// check gender&#xA;&#x9;&#x9;if (mother != null) {&#xA;&#x9;&#x9;&#x9;if (mother.getGender() != 'F') {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Mothers must be females&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (mother == this){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can't set yourself as mother&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// IF A MOTHER EXISTS.&#xA;&#x9;&#x9;if (this.mother != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING MOTHER&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING MOTHERS&#xA;&#x9;&#x9;&#x9;else if (mother != this.mother){&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="527" end="-2875"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118175329" sizeMeasure="195">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="1382" end="-2875"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118238976" sizeMeasure="195">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#x9;&#x9;if (!mother.hasChild(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;mother.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (mother == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;//mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// check gender&#xA;&#x9;&#x9;if (father != null) {&#xA;&#x9;&#x9;&#x9;if (father.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Fathers must be males&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (father == this){&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot set yourself as your father&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null){&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;this.father.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else if (father != this.father){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;if (!father.hasChild(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;father.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;this.father.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO FATHER EXISTS.&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;if (father == null){&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean hasChild(Person kid){&#xA;&#x9;&#x9;return children.contains(kid);&#xA;&#x9;}&#xA;&#xA;&#x9;public void removeChild(Person kid) {&#xA;&#x9;&#x9;if (children.contains(kid)) {&#xA;&#x9;&#x9;&#x9;children.remove(kid);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You can't remove a kid you don't own&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getName(){&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getGender(){&#xA;&#x9;&#x9;return gender;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String outstring = &quot;##########################\n&quot;;&#xA;&#x9;&#x9;outstring += name + &quot;\n&quot;;&#xA;&#x9;&#x9;if (children.size() != 0) {&#xA;&#x9;&#x9;&#x9;outstring += &quot;Children:\n&quot;;&#xA;&#x9;&#x9;&#x9;for (Person kid : children) {&#xA;&#x9;&#x9;&#x9;&#x9;outstring += &quot;\t&quot; +kid.getName() + &quot;\n&quot;;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (father != null){outstring += &quot;Father: &quot; + father.getName()  + &quot;\n&quot;;}&#xA;&#x9;&#x9;if (mother != null){outstring += &quot;Mother: &quot; + mother.getName() + &quot;\n&quot;;}&#xA;&#x9;&#x9;return outstring;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person stine = new Person(&quot;Mette&quot;, 'F');&#xA;&#x9;&#x9;Person vegard = new Person(&quot;Vegard&quot;, 'M');&#xA;&#x9;&#x9;Person kristin = new Person(&quot;Kristin&quot;, 'F');&#xA;&#x9;&#x9;Person odd = new Person(&quot;Odd&quot;, 'M');&#xA;&#x9;&#x9;stine.addChild(vegard);&#xA;&#x9;&#x9;kristin.setMother(stine);&#xA;&#x9;&#x9;odd.addChild(kristin);&#xA;&#x9;&#x9;vegard.setFather(odd);&#xA;&#x9;&#x9;System.out.println(stin" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="1382" end="-469"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118277465" sizeMeasure="195">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Stine&quot;, 'F');&#xA;&#x9;&#x9;Person jonas = new Person(&quot;Jonas&quot;, 'M');&#xA;&#x9;&#x9;Person sara = new Person(&quot;Sara&quot;, 'F');&#xA;&#x9;&#x9;Person kristoffer = new Person(&quot;Kristoffer&quot;, 'M');&#xA;&#x9;&#x9;stine.addChild(jonas);&#xA;&#x9;&#x9;sara.setMother(stine);&#xA;&#x9;&#x9;kristoffer.addChild(sara);&#xA;&#x9;&#x9;jonas.setFather(kristoffer);&#xA;&#x9;&#x9;System.out.println(stine);&#xA;&#x9;&#x9;System.out.println(sara);&#xA;&#x9;&#x9;System.out.println(jonas);&#xA;&#x9;&#x9;System.out.println(kristoffer" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="3513" end="-380"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118321362" sizeMeasure="195">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;// ADD THE KID&#xA;&#x9;&#x9;&#x9;children.add(kid);&#xA;&#xA;&#x9;&#x9;&#x9;if (gender == 'F' &amp;&amp; kid.getMother() != this) {&#xA;&#x9;&#x9;&#x9;&#x9;if (kid.getMother() != null) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;kid.getMother().children.remove(kid);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;kid.mother = this;&#xA;&#x9;&#x9;&#x9;} else if (gender == 'M' &amp; kid.getFather() != this) {&#xA;&#x9;&#x9;&#x9;&#x9;if (kid.getFather() != null) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;kid.getFather().children.remove(kid);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;kid.father = this;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person mother) {&#xA;&#x9;&#x9;// check gender&#xA;&#x9;&#x9;if (mother != null) {&#xA;&#x9;&#x9;&#x9;if (mother.getGender() != 'F') {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Mothers must be females&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (mother == this) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Can't set yourself as mother&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;// IF A MOTHER EXISTS.&#xA;&#x9;&#x9;if (this.mother != null) {&#xA;&#x9;&#x9;&#x9;// IF REMOVING MOTHER&#xA;&#x9;&#x9;&#x9;if (mother == null) {&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;mother = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING MOTHERS&#xA;&#x9;&#x9;&#x9;else if (mother != this.mother) {&#xA;&#x9;&#x9;&#x9;&#x9;if (!mother.hasChild(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;mother.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;this.mother.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO MOTHER EXISTS.&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (mother == null) {&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;this.mother = mother;&#xA;&#x9;&#x9;&#x9;&#x9;mother.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;// mother.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;// check gender&#xA;&#x9;&#x9;if (father != null) {&#xA;&#x9;&#x9;&#x9;if (father.getGender() != 'M') {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Fathers must be males&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (father == this) {&#xA;&#x9;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot set yourself as your father&quot;);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF A FATHER EXISTS.&#xA;&#x9;&#x9;if (this.father != null) {&#xA;&#x9;&#x9;&#x9;// IF REMOVING FATHER&#xA;&#x9;&#x9;&#x9;if (father == null) {&#xA;&#x9;&#x9;&#x9;&#x9;this.father.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;father = null;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;// IF SWITCHING FATHERs&#xA;&#x9;&#x9;&#x9;else if (father != this.father) {&#xA;&#xA;&#x9;&#x9;&#x9;&#x9;if (!father.hasChild(this)) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;father.children.add(this);&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;this.father.children.remove(this);&#xA;&#x9;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;// IF NO FATHER EXISTS.&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if (father == null) {&#xA;&#x9;&#x9;&#x9;&#x9;// do nothing: an orphan continues to be an orphan&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;this.father = father;&#xA;&#x9;&#x9;&#x9;&#x9;father.addChild(this);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;&#xA;&#x9;public boolean hasChild(Person kid) {&#xA;&#x9;&#x9;return children.contains(kid);&#xA;&#x9;}&#xA;&#xA;&#x9;public void removeChild(Person kid) {&#xA;&#x9;&#x9;if (children.contains(kid)) {&#xA;&#x9;&#x9;&#x9;children.remove(kid);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You can't remove a kid you don't own&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getGender() {&#xA;&#x9;&#x9;return gender;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String outstring = &quot;##########################\n&quot;;&#xA;&#x9;&#x9;outstring += name + &quot;\n&quot;;&#xA;&#x9;&#x9;if (children.size() != 0) {&#xA;&#x9;&#x9;&#x9;outstring += &quot;Children:\n&quot;;&#xA;&#x9;&#x9;&#x9;for (Person kid : children) {&#xA;&#x9;&#x9;&#x9;&#x9;outstring += &quot;\t&quot; + kid.getName() + &quot;\n&quot;;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;if (father != null) {&#xA;&#x9;&#x9;&#x9;outstring += &quot;Father: &quot; + father.getName() + &quot;\n&quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (mother != null) {&#xA;&#x9;&#x9;&#x9;outstring += &quot;Mother: &quot; + mother.getName() + &quot;\n&quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return outstring;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Person stine = new Person(&quot;Stine&quot;, 'F');&#xA;&#x9;&#x9;Person jonas = new Person(&quot;Jonas&quot;, 'M');&#xA;&#x9;&#x9;Person sara = new Person(&quot;Sara&quot;, 'F');&#xA;&#x9;&#x9;Person kristoffer = new Person(&quot;Kristoffer&quot;, 'M');&#xA;&#x9;&#x9;stine.addChild(jonas);&#xA;&#x9;&#x9;sara.setMother(stine);&#xA;&#x9;&#x9;kristoffer.addChild(sara);&#xA;&#x9;&#x9;jonas.setFather(kristoffer);&#xA;&#x9;&#x9;System.out.println(stine);&#xA;&#x9;&#x9;System.out.println(sara);&#xA;&#x9;&#x9;System.out.println(jonas);&#xA;&#x9;&#x9;System.out.println(kristoffer);&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getFather() {&#xA;&#x9;&#x9;return father;&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getChild(int i) {&#xA;&#x9;&#x9;if (children.size() != 0 &amp;&amp; i >= 0 &amp;&amp; i &lt; children.size()) {&#xA;&#x9;&#x9;&#x9;return children.get(i);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;No such kid at index &quot; + i);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public int getChildCount() " edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="476" end="-35"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487935887616" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487935932209" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487935940839" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487935948746" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487935981211" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936028064" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936037384" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936054184" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936080774" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936119194" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936282347" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936298569" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936311023" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487936327821" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487937223085" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487937322406" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118287325" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487937537592" completion="0.15384615384615385" successCount="2" failureCount="2" errorCount="9">
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487937578272" completion="0.15384615384615385" successCount="2" failureCount="2" errorCount="9">
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487937693247" completion="0.5384615384615384" successCount="7" failureCount="2" errorCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938101705" completion="0.5384615384615384" successCount="7" failureCount="2" errorCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938406625" completion="0.6923076923076923" successCount="9" failureCount="2" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938691755" completion="0.23076923076923078" successCount="3" failureCount="2" errorCount="8">
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939245875" completion="0.38461538461538464" successCount="5" failureCount="3" errorCount="5">
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939290029" completion="0.46153846153846156" successCount="6" failureCount="5" errorCount="2">
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorskapSetMother</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939373427" completion="0.38461538461538464" successCount="5" failureCount="2" errorCount="6">
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testSelvmorskapIllegalArgumentException</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testSelvfarskapIllegalArgumentException</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939380982" completion="0.46153846153846156" successCount="6" failureCount="5" errorCount="2">
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorskapSetMother</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939536975" completion="0.5384615384615384" successCount="7" failureCount="4" errorCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939958388" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940400635" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940676869" completion="0.07692307692307693" successCount="1" errorCount="12">
          <successTests>testConstructor</successTests>
          <errorTests>testMorskapSetMother</errorTests>
          <errorTests>testFarbytteAddChild</errorTests>
          <errorTests>testMorbytteAddChild</errorTests>
          <errorTests>testMorbytteSetFather</errorTests>
          <errorTests>testSelvmorskapIllegalArgumentException</errorTests>
          <errorTests>testMorskapIllegalArgumentException</errorTests>
          <errorTests>testFarbytteSetFather</errorTests>
          <errorTests>testMorskapAddChild</errorTests>
          <errorTests>testSelvfarskapIllegalArgumentException</errorTests>
          <errorTests>testFarskapIllegalArgumentException</errorTests>
          <errorTests>testFarskapAddChild</errorTests>
          <errorTests>testFarskapSetFather</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940683207" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940690375" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940809733" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115178066" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115224624" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115268772" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115367854" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115446209" completion="0.38461538461538464" successCount="5" failureCount="8">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testFarbytteAddChild</failureTests>
          <failureTests>testMorbytteAddChild</failureTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115514088" completion="0.5384615384615384" successCount="7" failureCount="6">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testMorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115801057" completion="0.6153846153846154" successCount="8" failureCount="5">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
          <failureTests>testFarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115824214" completion="0.6923076923076923" successCount="9" failureCount="4">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testSelvmorskapIllegalArgumentException</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
          <failureTests>testSelvfarskapIllegalArgumentException</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115889382" completion="0.8461538461538461" successCount="11" failureCount="2">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testMorbytteSetFather</failureTests>
          <failureTests>testFarbytteSetFather</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488115954856" completion="1.0" successCount="13">
          <successTests>testMorskapSetMother</successTests>
          <successTests>testFarbytteAddChild</successTests>
          <successTests>testMorbytteAddChild</successTests>
          <successTests>testMorbytteSetFather</successTests>
          <successTests>testSelvmorskapIllegalArgumentException</successTests>
          <successTests>testMorskapIllegalArgumentException</successTests>
          <successTests>testFarbytteSetFather</successTests>
          <successTests>testMorskapAddChild</successTests>
          <successTests>testSelvfarskapIllegalArgumentException</successTests>
          <successTests>testFarskapIllegalArgumentException</successTests>
          <successTests>testFarskapAddChild</successTests>
          <successTests>testFarskapSetFather</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="2">
        <attempts timestamp="1488117383062"/>
        <attempts timestamp="1488117383796"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="9">
        <attempts timestamp="1487938215495"/>
        <attempts timestamp="1487938276254"/>
        <attempts timestamp="1487938277003"/>
        <attempts timestamp="1487938279657"/>
        <attempts timestamp="1487938280512"/>
        <attempts timestamp="1487938311188"/>
        <attempts timestamp="1487938312857"/>
        <attempts timestamp="1487938332716"/>
        <attempts timestamp="1487938340982"/>
        <attempts timestamp="1487938499651"/>
        <attempts timestamp="1487938514005"/>
        <attempts timestamp="1487938515713"/>
        <attempts timestamp="1487938520797"/>
        <attempts timestamp="1487938523614"/>
        <attempts timestamp="1487938534435"/>
        <attempts timestamp="1487938535705"/>
        <attempts timestamp="1487938537006"/>
        <attempts timestamp="1487938539311"/>
        <attempts timestamp="1487938556182"/>
        <attempts timestamp="1487938557686"/>
        <attempts timestamp="1487938604294"/>
        <attempts timestamp="1487938606125"/>
        <attempts timestamp="1487938607514"/>
        <attempts timestamp="1487938608693"/>
        <attempts timestamp="1487938640589"/>
        <attempts timestamp="1487938645655"/>
        <attempts timestamp="1487939787821"/>
        <attempts timestamp="1487939793592"/>
        <attempts timestamp="1487939797489"/>
        <attempts timestamp="1487939824056"/>
        <attempts timestamp="1487939832309"/>
        <attempts timestamp="1487939832949"/>
        <attempts timestamp="1487939833748"/>
        <attempts timestamp="1487939834368"/>
        <attempts timestamp="1487939848325"/>
        <attempts timestamp="1487939851177"/>
        <attempts timestamp="1487939855753"/>
        <attempts timestamp="1487939858866"/>
        <attempts timestamp="1487939867189"/>
        <attempts timestamp="1487939883565"/>
        <attempts timestamp="1487939884834"/>
        <attempts timestamp="1487939896374"/>
        <attempts timestamp="1487939900872"/>
        <attempts timestamp="1487939902175"/>
        <attempts timestamp="1487939904098"/>
        <attempts timestamp="1487939904539"/>
        <attempts timestamp="1487940124434"/>
        <attempts timestamp="1487940134495"/>
        <attempts timestamp="1487940135477"/>
        <attempts timestamp="1487940137926"/>
        <attempts timestamp="1487940159817"/>
        <attempts timestamp="1487940162269"/>
        <attempts timestamp="1487940164191"/>
        <attempts timestamp="1487940167878"/>
        <attempts timestamp="1487940184572"/>
        <attempts timestamp="1487940185134"/>
        <attempts timestamp="1487940190183"/>
        <attempts timestamp="1487940194322"/>
        <attempts timestamp="1487940210708"/>
        <attempts timestamp="1487940212526"/>
        <attempts timestamp="1487940213206"/>
        <attempts timestamp="1487940223638"/>
        <attempts timestamp="1487940230358"/>
        <attempts timestamp="1487940231360"/>
        <attempts timestamp="1487940232449"/>
        <attempts timestamp="1487940233138"/>
        <attempts timestamp="1487940240078"/>
        <attempts timestamp="1487940245141"/>
        <attempts timestamp="1487940246199"/>
        <attempts timestamp="1487940250396"/>
        <attempts timestamp="1487940250962"/>
        <attempts timestamp="1487940265034"/>
        <attempts timestamp="1487940266564"/>
        <attempts timestamp="1487940267143"/>
        <attempts timestamp="1487940267643"/>
        <attempts timestamp="1487940268276"/>
        <attempts timestamp="1487940269912"/>
        <attempts timestamp="1487940270323"/>
        <attempts timestamp="1487940270844"/>
        <attempts timestamp="1487940272224"/>
        <attempts timestamp="1487940272805"/>
        <attempts timestamp="1488117296911"/>
        <attempts timestamp="1488117337198"/>
        <attempts timestamp="1488117349808"/>
        <attempts timestamp="1488117352668"/>
        <attempts timestamp="1488117376764"/>
        <attempts timestamp="1488117379170"/>
        <attempts timestamp="1488117380014"/>
        <attempts timestamp="1488117380671"/>
        <attempts timestamp="1488117381218"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="1">
        <attempts timestamp="1487938132851"/>
        <attempts timestamp="1487938205934"/>
        <attempts timestamp="1487938463360"/>
        <attempts timestamp="1487938591218"/>
        <attempts timestamp="1487939483193"/>
        <attempts timestamp="1487939713356"/>
        <attempts timestamp="1487939811403"/>
        <attempts timestamp="1487940065423"/>
        <attempts timestamp="1487940085983"/>
        <attempts timestamp="1488117288973"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
