<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488193130260" sizeMeasure="56">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#xA;&#x9;private String text;&#xA;&#x9;private Tweet originalTweet;&#xA;&#x9;private TwitterAccount tweetOwner;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;// Konstruktører&#xA;&#x9;// Ny orginal tweet&#xA;&#x9;public Tweet(TwitterAccount tweeter, String text)&#xA;&#x9;{&#xA;&#x9;&#x9;this.text = text;&#xA;&#x9;&#x9;tweetOwner = tweeter;&#xA;&#x9;&#x9;retweetCount = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//Retweet&#xA;&#x9;public Tweet(TwitterAccount tweeter, Tweet tweet)&#xA;&#x9;{&#xA;&#x9;&#x9;if (tweet.tweetOwner == tweeter)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;text = tweet.text;&#xA;&#x9;&#x9;tweet.retweetCount += 1;&#xA;&#x9;&#x9;this.originalTweet = tweet.originalTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// metoder&#xA;&#x9;public String getText()&#xA;&#x9;{&#xA;&#x9;&#x9;return text;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner()&#xA;&#x9;{&#xA;&#x9;&#x9;return tweetOwner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet()&#xA;&#x9;{&#xA;&#x9;&#x9;if (retweetCount == 0)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return null;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount()&#xA;&#x9;{&#xA;&#x9;&#x9;return retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194364774" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;tweetOwner = tweet.getOwner()" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="607" end="-308"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194386187" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetOwner" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="627" end="-308"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194479365" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="his." edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="609" end="-337"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194516604" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;if (tweet.tweetOwner == tweeter)&#xA;//&#x9;&#x9;{&#xA;//&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="393" end="-440"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194558236" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;if (tweet.tweetOwner == tweeter)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;text = tweet.text;&#xA;&#x9;&#x9;tweet.retweetCount += 1;&#xA;&#x9;&#x9;this.originalTweet = tweet.originalTweet;&#xA;&#x9;&#x9;this.tweetOwner = tweet.getOwner()" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="393" end="-308"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194615372" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(tweeter + &quot;;&quot; + tweet.tweetOwner);&#xA;&#x9;&#x9;if (tweet.tweetOwner == tweeter)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;text = tweet.text;&#xA;&#x9;&#x9;tweet.retweetCount += 1;&#xA;&#x9;&#x9;this.originalTweet = tweet.originalTweet;&#xA;&#x9;&#x9;this.tweetOwner = tweet.tweetOwner" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="395" end="-308"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194704291" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (tweet.tweetOwner == tweeter)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke retweete din egen tweet&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;text = tweet.text;&#xA;&#x9;&#x9;tweet.retweetCount += 1;&#xA;&#x9;&#x9;this.originalTweet = tweet.originalTweet;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="395" end="-337"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488192483970" sizeMeasure="22" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;&#xA;&#x9;//Konstruktør&#xA;&#x9;public TwitterAccount(String username)&#xA;&#x9;{&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Metoder&#xA;&#x9;public String getUsername()&#xA;&#x9;{&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public &#xA;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488192810524" sizeMeasure="36" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String username;&#xA;&#x9;private ArrayList&lt;TwitterAccount> followers;&#xA;&#x9;&#xA;&#x9;//Konstruktør&#xA;&#x9;public TwitterAccount(String username)&#xA;&#x9;{&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Metoder&#xA;&#x9;public String getUsername()&#xA;&#x9;{&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow (TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (! isFollowing(account))&#xA;&#x9;&#x9;followers.add(account);&#xA;&#x9;&#x9;account.followers.add(account);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="27" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488192828887" sizeMeasure="35" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // sjekker om allerede følger&#xA;&#x9;&#x9;followers.add(account);&#xA;&#x9;&#x9;account.followers.add(account);" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="398" end="-74"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488192929468" sizeMeasure="43" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (! isFollowing(account)) // sjekker om allerede følger&#xA;&#x9;&#x9;followers.add(account);&#xA;&#x9;&#x9;account.followers.add(account);&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (! isFollowing(account))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;followers.remove(account);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="340" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488192952756" sizeMeasure="44" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this);&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (! isFollowing(account))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;followers.remove(account);&#xA;&#x9;&#x9;&#x9;account.followers.remove(this)" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="478" end="-77"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488192956985" sizeMeasure="44" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="637" end="-77"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488193110764" sizeMeasure="57" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account.username.equals(username))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke følge deg selv&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (isFollowing(account))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;followers.remove(account);&#xA;&#x9;&#x9;&#x9;account.followers.remove(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (followers.contains(account))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public " edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="546" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488193222305" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean isFollowedBy(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (account.followers.contains(this))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String text)&#xA;&#x9;{&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="923" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488193354333" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private ArrayList&lt;Tweet> tweets;&#xA;&#x9;&#xA;&#x9;//Konstruktør&#xA;&#x9;public TwitterAccount(String username)&#xA;&#x9;{&#xA;&#x9;&#x9;this.username = username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Metoder&#xA;&#x9;public String getUsername()&#xA;&#x9;{&#xA;&#x9;&#x9;return username;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (! isFollowing(account)) // sjekker om allerede følger&#xA;&#x9;&#x9;followers.add(account);&#xA;&#x9;&#x9;account.followers.add(this);&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (account.username.equals(username))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikke følge deg selv&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (isFollowing(account))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;followers.remove(account);&#xA;&#x9;&#x9;&#x9;account.followers.remove(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (followers.contains(account))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account)&#xA;&#x9;{&#xA;&#x9;&#x9;if (account.followers.contains(this))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String text)&#xA;&#x9;{&#xA;&#x9;&#x9;tweets.add(new Tweet(this, text)) " edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="161" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488193380990" sizeMeasure="74" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="; &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet()" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1176" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194202889" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Tweet tweet)&#xA;&#x9;{&#xA;&#x9;&#x9;new Tweet(this, tweet);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i)&#xA;&#x9;{&#xA;&#x9;&#x9;return tweets.get(i+1);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount()&#xA;&#x9;{&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount()&#xA;&#x9;{&#xA;&#x9;&#x9;int tweetcount = 0;&#xA;&#x9;&#x9;for (int i = 0; i &lt; getTweetCount(); i++)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;tweetcount = tweetcount + tweets.get(i).getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return tweetcount;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1205" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488194822897" sizeMeasure="97">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="N" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="321" end="-1252"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="0.5">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194265436" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194367062" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194388103" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194481165" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194518555" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194563477" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194620841" completion="0.5" successCount="2" failureCount="2"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="0.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194767560" completion="0.0" errorCount="6"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488194829894" completion="0.0" errorCount="6"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
