<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487861790460">
          <edit xsi:type="exercise:StringEdit" storedString=""/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487862217572" sizeMeasure="36" errorCount="2">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import objectstructures.TwitterAccount;&#xA;&#xA;public class Tweet {&#xA;&#x9;private TwitterAccount owner;&#xA;&#x9;private Tweet original = null;&#xA;&#x9;private String content;&#xA;&#x9;private int retweetCount = 0;&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount owner, String content) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount owner, Tweet original) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;String getText() {//- returnerer teksten til en tweet&#xA;&#x9;&#x9;return this.content;&#xA;&#x9;}&#xA;&#xA;&#x9;TwitterAccount getOwner() {//- returnerer kontoen som tweeten kom fra&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;}&#xA;&#xA;&#x9;Tweet getOriginalTweet() {//- returnerer original-tweeten, hvis den er en retweet, ellers null&#xA;&#x9;&#x9;if () {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;int getRetweetCount() {//- returnerer antall ganger denne tweeten har blitt retweetet&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487862261525" sizeMeasure="39" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.original == null) {&#xA;&#x9;&#x9;&#x9;return this;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return this.original;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="600" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487862276741" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return this.retweetCount;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="777" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487862407773" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount oegly = new TwitterAccount(&quot;oegly&quot;);&#xA;&#x9;&#x9;Tweet t = new Tweet(oegly, &quot;Hello, World!&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(t.getText())" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="806" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487862465531" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.content = content;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount owner, Tweet original) {&#xA;&#x9;&#x9;this.original = original;&#xA;&#x9;&#x9;this.content = original.getText();" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="259" end="-681"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487862531249" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(t.getRetweetCoun" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1075" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487862604599" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="itterAccount sause = new TwitterAccount(&quot;sause&quot;);&#xA;&#x9;&#x9;Tweet t = new Tweet(oegly, &quot;Hello, World!&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(t.getText());&#xA;&#x9;&#x9;System.out.println(t.getRetweetCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet u = new Tweet(sause, t);&#xA;&#x9;&#x9;System.out.println(u.getTex" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="993" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487862661621" sizeMeasure="47">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return original;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="681" end="-481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487863220041" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;//original.increaserRetweetCoun" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="401" end="-783"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487863282522" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public void increaserRetweetCount() {&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="745" end="-476"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487863291384" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="405" end="-877"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487863896206" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rivate" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="744" end="-533"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487863985068" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.owner.equals(owner)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikkje omkvitre deg sjølv!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="337" end="-949"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487864007386" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" == owner" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="351" end="-1034"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487864152657" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Runtime" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="377" end="-1002"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487864663378" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="IllegalArgument" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="377" end="-1002"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487864709230" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;System.out.println(oegly == u.getOwner" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1389" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487864717704" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1412" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487864753786" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="owner = owner;&#xA;&#x9;&#x9;this.content = content;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;Tweet(TwitterAccount owner, Tweet original) {&#xA;&#x9;&#x9;if (this.owner == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Du kan ikkje omkvitre deg sjølv!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.owner = owner;" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="264" end="-988"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487864824894" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Runtime" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="399" end="-1063"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126112323" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".equals(owner)" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="373" end="-1087"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126195566" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getUserName().equals(owner.getUserName()" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="374" end="-1088"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488126238546" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getOwner() == owner" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="368" end="-1087"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210623527" sizeMeasure="64">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="original.getOriginalTweet() != null) {&#xA;&#x9;&#x9;&#x9;original = original.getOriginalTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (original.getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new RuntimeException(&quot;Du kan ikkje omkvitre deg sjølv!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.original = original;&#xA;&#x9;&#x9;this.content = original.getText();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;original.increaserRetweetCount();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;String getText() {//- returnerer teksten til en tweet&#xA;&#x9;&#x9;return this.content;&#xA;&#x9;}&#xA;&#xA;&#x9;TwitterAccount getOwner() {//- returnerer kontoen som tweeten kom fra&#xA;&#x9;&#x9;return this.owner;&#xA;&#x9;}&#xA;&#xA;&#x9;Tweet getOriginalTweet() {//- returnerer original-tweeten, hvis den er en retweet, ellers null&#xA;&#x9;&#x9;return original;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private void increaserRetweetCount() {&#xA;&#x9;&#x9;this.retweetCount++;&#xA;&#x9;}&#xA;&#x9;int getRetweetCount() {//- returnerer antall ganger denne tweeten har blitt retweetet&#xA;&#x9;&#x9;return this.retweetCount;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount egg = new TwitterAccount(&quot;egg&quot;);&#xA;&#x9;&#x9;TwitterAccount sau = new TwitterAccount(&quot;sau&quot;);&#xA;&#x9;&#x9;Tweet t = new Tweet(egg, &quot;Hello, World!&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(t.getText());&#xA;&#x9;&#x9;System.out.println(t.getRetweetCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Tweet u = new Tweet(sau" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="363" end="-86"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210734028" sizeMeasure="65" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Tweet v = new Tweet(egg, u" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1556" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210754168" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1557" end="-35"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487861647152">
          <edit xsi:type="exercise:StringEdit" storedString=""/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487861770618" sizeMeasure="13">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;private String handle;&#xA;&#x9;&#xA;&#x9;TwitterAccount(String handle) {&#xA;&#x9;&#x9;this.handle = handle;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.handle;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488114969558" sizeMeasure="60" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.*;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;private String handle;&#xA;&#x9;private List&lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;TwitterAccount(String handle) {&#xA;&#x9;&#x9;this.handle = handle;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.handle;&#xA;&#x9;}&#xA;&#xA;&#x9;void follow(TwitterAccount account) { //- denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;if (!this.following.contains(account)) {&#xA;&#x9;&#x9;&#x9;this.following.add(account);&#xA;&#x9;&#x9;&#x9;account.addFollower(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addFollower(TwitterAccount account) {&#xA;&#x9;&#x9;this.followers.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;    void unfollow(TwitterAccount account) { //- slutt å følge account&#xA;    &#x9;this.following.remove(this.following.indexOf(account));&#xA;    }&#xA;&#xA;    boolean isFollowing(TwitterAccount account) { //- returnerer om denne kontoen følger account&#xA;    &#x9;&#xA;    }&#xA;&#xA;    boolean isFollowedBy(TwitterAccount account) { // - returnerer om account følger denne kontoen&#xA;    &#x9;&#xA;    }&#xA;&#xA;    void tweet(String content) { // - lager en ny tweet for denne kontoen&#xA;    &#x9;&#xA;    }&#xA;&#xA;    void retweet(Tweet tweet) { // - retweeter tweet fra denne kontoen&#xA;    &#x9;&#xA;    }&#xA;&#xA;    Tweet getTweet(int i) { // - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;    &#x9;&#xA;    }&#xA;&#xA;    int getTweetCount() { // - returner antall tweets til kontoen&#xA;    &#x9;&#xA;    }&#xA;&#xA;    int getRetweetCount() { // - returner antall retweets av tweets fra denne kontoen&#xA;    &#x9;&#xA;    }&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="27" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115045952" sizeMeasure="65" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.following.contains(account)) {&#xA;    &#x9;&#x9;return true;&#xA;    &#x9;}&#xA;    &#x9;else {&#xA;    &#x9;&#x9;return false;&#xA;    &#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="893" end="-605"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115165234" sizeMeasure="73" errorCount="3" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int tweetCount;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;TwitterAccount(String handle) {&#xA;&#x9;&#x9;this.handle = handle;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.handle;&#xA;&#x9;}&#xA;&#xA;&#x9;void follow(TwitterAccount account) { //- denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;if (!this.following.contains(account)) {&#xA;&#x9;&#x9;&#x9;this.following.add(account);&#xA;&#x9;&#x9;&#x9;account.addFollower(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addFollower(TwitterAccount account) {&#xA;&#x9;&#x9;this.followers.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;    void unfollow(TwitterAccount account) { //- slutt å følge account&#xA;    &#x9;this.following.remove(this.following.indexOf(account));&#xA;    }&#xA;&#xA;    boolean isFollowing(TwitterAccount account) { //- returnerer om denne kontoen følger account&#xA;    &#x9;if (this.following.contains(account)) {&#xA;    &#x9;&#x9;return true;&#xA;    &#x9;}&#xA;    &#x9;else {&#xA;    &#x9;&#x9;return false;&#xA;    &#x9;}&#xA;    }&#xA;&#xA;    boolean isFollowedBy(TwitterAccount account) { // - returnerer om account følger denne kontoen&#xA;    &#x9;if (this.followers.contains(account)) {&#xA;    &#x9;&#x9;return true;&#xA;    &#x9;}&#xA;    &#x9;else {&#xA;    &#x9;&#x9;return false;&#xA;    &#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="253" end="-493"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115228621" sizeMeasure="74" errorCount="3" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="objectstructures.Tweet;" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="34" end="-1734"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115788804" sizeMeasure="83" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;&#xA;&#x9;private int retweetCount;&#xA;&#x9;&#xA;&#x9;TwitterAccount(String handle) {&#xA;&#x9;&#x9;this.handle = handle;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.handle;&#xA;&#x9;}&#xA;&#xA;&#x9;void follow(TwitterAccount account) { //- denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;if (!this.following.contains(account)) {&#xA;&#x9;&#x9;&#x9;this.following.add(account);&#xA;&#x9;&#x9;&#x9;account.addFollower(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addFollower(TwitterAccount account) {&#xA;&#x9;&#x9;this.followers.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;    void unfollow(TwitterAccount account) { //- slutt å følge account&#xA;    &#x9;this.following.remove(this.following.indexOf(account));&#xA;    }&#xA;&#xA;    boolean isFollowing(TwitterAccount account) { //- returnerer om denne kontoen følger account&#xA;    &#x9;if (this.following.contains(account)) {&#xA;    &#x9;&#x9;return true;&#xA;    &#x9;}&#xA;    &#x9;else {&#xA;    &#x9;&#x9;return false;&#xA;    &#x9;}&#xA;    }&#xA;&#xA;    boolean isFollowedBy(TwitterAccount account) { // - returnerer om account følger denne kontoen&#xA;    &#x9;if (this.followers.contains(account)) {&#xA;    &#x9;&#x9;return true;&#xA;    &#x9;}&#xA;    &#x9;else {&#xA;    &#x9;&#x9;return false;&#xA;    &#x9;}&#xA;    }&#xA;&#xA;    void tweet(String content) { // - lager en ny tweet for denne kontoen&#xA;    &#x9;this.tweets.add(new Tweet(this, content));&#xA;    }&#xA;&#xA;    void retweet(Tweet tweet) { // - retweeter tweet fra denne kontoen&#xA;    &#x9;this.tweets.add(new Tweet(this, tweet));&#xA;    }&#xA;&#xA;    Tweet getTweet(int i) { // - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;    &#x9;this.tweets.get(this.getTweetCount() - i - 1);&#xA;   &#x9;}&#xA;&#xA;    int getTweetCount() { // - returner antall tweets til kontoen&#xA;    &#x9;return this.tweets.size();&#xA;    }&#xA;&#xA;    int getRetweetCount() { // - returner antall retweets av tweets fra denne kontoen&#xA;    &#x9;int i = 0;&#xA;    &#x9;&#xA;    &#x9;for (int n = 0; n > this.getTweetCount(); n++) {&#xA;    &#x9;&#x9;if(this.tweets.get(n).getOriginalTweet() == null) {&#xA;    &#x9;&#x9;&#x9;i++;&#xA;     &#x9;&#x9;}&#xA;    &#x9;}&#xA;    &#x9;&#xA;    &#x9;return i;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="292" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488115801427" sizeMeasure="83" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return " edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1715" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116013169" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//private int retweetCount;&#xA;&#x9;&#xA;&#x9;TwitterAccount(String handle) {&#xA;&#x9;&#x9;this.handle = handle;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() {&#xA;&#x9;&#x9;return this.handle;&#xA;&#x9;}&#xA;&#xA;&#x9;void follow(TwitterAccount account) { //- denne (this) kontoen starter å følge account&#xA;&#x9;&#x9;if (!this.following.contains(account)) {&#xA;&#x9;&#x9;&#x9;this.following.add(account);&#xA;&#x9;&#x9;&#x9;account.addFollower(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addFollower(TwitterAccount account) {&#xA;&#x9;&#x9;this.followers.add(account);&#xA;&#x9;}&#xA;&#x9;&#xA;    void unfollow(TwitterAccount account) { //- slutt å følge account&#xA;    &#x9;this.following.remove(this.following.indexOf(account));&#xA;    }&#xA;&#xA;    boolean isFollowing(TwitterAccount account) { //- returnerer om denne kontoen følger account&#xA;    &#x9;if (this.following.contains(account)) {&#xA;    &#x9;&#x9;return true;&#xA;    &#x9;}&#xA;    &#x9;else {&#xA;    &#x9;&#x9;return false;&#xA;    &#x9;}&#xA;    }&#xA;&#xA;    boolean isFollowedBy(TwitterAccount account) { // - returnerer om account følger denne kontoen&#xA;    &#x9;if (this.followers.contains(account)) {&#xA;    &#x9;&#x9;return true;&#xA;    &#x9;}&#xA;    &#x9;else {&#xA;    &#x9;&#x9;return false;&#xA;    &#x9;}&#xA;    }&#xA;&#xA;    void tweet(String content) { // - lager en ny tweet for denne kontoen&#xA;    &#x9;this.tweets.add(new Tweet(this, content));&#xA;    }&#xA;&#xA;    void retweet(Tweet tweet) { // - retweeter tweet fra denne kontoen&#xA;    &#x9;this.tweets.add(new Tweet(this, tweet));&#xA;    }&#xA;&#xA;    Tweet getTweet(int i) { // - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;    &#x9;return this.tweets.get(this.getTweetCount() - i - 1);&#xA;   &#x9;}&#xA;&#xA;    int getTweetCount() { // - returner antall tweets til kontoen&#xA;    &#x9;return this.tweets.size();&#xA;    }&#xA;&#xA;    int getRetweetCount() { // - returner antall retweets av tweets fra denne kontoen&#xA;    &#x9;int i = 0;&#xA;    &#x9;&#xA;    &#x9;for (int n = 0; n > this.getTweetCount(); n++) {&#xA;    &#x9;&#x9;if(this.tweets.get(n).getOriginalTweet() == null) {&#xA;    &#x9;&#x9;&#x9;i++;&#xA;     &#x9;&#x9;}&#xA;    &#x9;}&#xA;    &#x9;&#xA;    &#x9;return i;&#xA;    }&#xA;    &#xA;    public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount oegly = new TwitterAccount(&quot;oegly&quot;);&#xA;&#x9;&#x9;TwitterAccount anjar = new TwitterAccount(&quot;anjar&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;oegly.tweet(&quot;Her bli' det liv, rai, rai!&quot;);&#xA;&#x9;&#x9;oegly.tweet(&quot;Her bli' det leave, rai, rai! #brexit&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;anjar.follow(oegly);&#xA;&#x9;&#x9;anjar.retweet(oegly.getTweet(1));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(anjar.getTweet(1));&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="340" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116040138" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1764" end="-766"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116053049" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getText(" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="2520" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116062309" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="2474" end="-65"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116335247" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="anjar.unfollow(oegly" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="2484" end="-64"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116340320" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="anjar" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="2499" end="-64"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116422467" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int index = this.following.indexOf(account);&#xA;    &#x9;&#xA;    &#x9;if (index > -1) {&#xA;    &#x9;&#x9;this.following.remove(this.following.indexOf(account));&#xA;    &#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="846" end="-1667"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116751398" sizeMeasure="100">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#x9;if (this.isFollowing(account)" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="845" end="-1739"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116878368" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(oegly.getRetweetCount());&#xA;&#x9;&#x9;System.out.println(anjar.getRetweetCoun" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="2609" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488116936624" sizeMeasure="103">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(this.tweets.get(n).getOriginalTweet());" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="2094" end="-622"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488117055185" sizeMeasure="108">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;    &#x9;for (int n = 0; n > anjar.getTweetCount(); n++) {&#xA;    &#x9;&#x9;System.out.println(anjar.tweets.get(n).getOriginalTweet());&#xA;    &#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="2675" end="-102"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488117078783" sizeMeasure="108">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="T" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="2884" end="-21"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488117135580" sizeMeasure="108">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getTwe" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="2762" end="-136"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488117203704" sizeMeasure="108">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="2200" end="-703"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118023344" sizeMeasure="107">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="2094" end="-752"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118036180" sizeMeasure="107">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(this.tweets.get(n).getOriginalTweet() != null) {&#xA;    &#x9;&#x9;&#x9;i++;&#xA;     &#x9;&#x9;}&#xA;    &#x9;}&#xA;    &#x9;&#xA;    &#x9;return i;&#xA;    }&#xA;    &#xA;    public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount oegly = new TwitterAccount(&quot;oegly&quot;);&#xA;&#x9;&#x9;TwitterAccount anjar = new TwitterAccount(&quot;anjar&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;oegly.tweet(&quot;Her bli' det liv, rai, rai!&quot;);&#xA;&#x9;&#x9;oegly.tweet(&quot;Her bli' det leave, rai, rai! #brexit&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;anjar.follow(oegly);&#xA;&#x9;&#x9;anjar.retweet(oegly.getTweet(2));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;anjar.unfollow(anjar);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(anjar.getTweet(1).getText());&#xA;&#x9;&#x9;&#xA;    &#x9;for (int n = 0; n > oegly.getTweetCount(); n++) {&#xA;    &#x9;&#x9;System.out.println(oegly" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="2094" end="-143"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118067152" sizeMeasure="107">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="OriginalTwee" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="2599" end="-237"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118084506" sizeMeasure="109">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(oegly.getTweet(1).getOriginalTweet());&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="2619" end="-232"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118101922" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(n" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="2805" end="-112"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118114623" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="T" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="2869" end="-66"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118146529" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="2704" end="-231"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118175660" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="2057" end="-878"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118234310" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" - 1" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="1811" end="-1125"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118281182" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".getTex" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="2618" end="-325"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118309200" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="2603" end="-333"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118371051" sizeMeasure="110">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=");&#xA;   &#x9;}&#xA;&#xA;    int getTweetCount() { // - returner antall tweets til kontoen&#xA;    &#x9;return this.tweets.size();&#xA;    }&#xA;&#xA;    int getRetweetCount() { // - returner antall retweets av tweets fra denne kontoen&#xA;    &#x9;int i = 0;&#xA;    &#x9;&#xA;    &#x9;for (int n = 0; n &lt; this.getTweetCount(); n++) {&#xA;    &#x9;&#x9;if(this.tweets.get(n).getOriginalTweet() != null) {&#xA;    &#x9;&#x9;&#x9;i++;&#xA;     &#x9;&#x9;}&#xA;    &#x9;}&#xA;    &#x9;&#xA;    &#x9;return i;&#xA;    }&#xA;    &#xA;    public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount oegly = new TwitterAccount(&quot;oegly&quot;);&#xA;&#x9;&#x9;TwitterAccount anjar = new TwitterAccount(&quot;anjar&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;oegly.tweet(&quot;Her bli' det liv, rai, rai!&quot;);&#xA;&#x9;&#x9;oegly.tweet(&quot;Her bli' det leave, rai, rai! #brexit&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;anjar.follow(oegly);&#xA;&#x9;&#x9;anjar.retweet(oegly.getTweet(2));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;anjar.unfollow(anjar);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(anjar.getTweet(1" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1811" end="-333"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118514170" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int tweetCount = this.getTweetCount();&#xA;    &#x9;if (i &lt;= tweetCount) {&#xA;    &#x9;&#x9;return this.tweets.get(tweetCount - i);&#xA;    &#x9;}&#xA;    &#x9;else {&#xA;    &#x9;&#x9;return this.tweets.get(tweetCount);&#xA;    &#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1764" end="-1114"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118587507" sizeMeasure="116">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="2849" end="-209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118776929" sizeMeasure="117">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1808" end="-1258"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488118884435" sizeMeasure="117">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; i > 0" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="1833" end="-1233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488119021816" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(oegly.getTweet(1).getText());&#xA;&#x9;&#x9;System.out.println(oegly.getTweet(3).getText());&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="2814" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488119124112" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="1940" end="-1067"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488119195470" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="OriginalTwee" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="2736" end="-269"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488119248709" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new RuntimeException(); //t" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="1917" end="-1100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488119691428" sizeMeasure="106">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(anjar.isFollowing(oegly));&#xA;&#x9;&#x9;System.out.println(anjar.isFollowedBy(oegly" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="2701" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488119707919" sizeMeasure="106">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="oegly.isFollowedBy(anjar" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="2768" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488119735726" sizeMeasure="106">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="anjar.isFollowedBy(oegly" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="2768" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488119917117" sizeMeasure="118">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*&#xA; * &#xA; * &#xA; * &#xA; * &#xA; * &#xA; * Hugs å opne Exercise view!!!@@@1!!&#xA; * &#xA; * &#xA; * &#xA; * &#xA; * &#xA; */" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="78" end="-2725"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488123599825" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#x9;if (account.isFollowedBy(this)) {&#xA;    &#x9;&#x9;account.followers" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="1037" end="-1903"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488123630086" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="1127" end="-1865"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488123648255" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="account" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="1104" end="-1888"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488123670442" sizeMeasure="121">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ers" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="1118" end="-1878"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488123946547" sizeMeasure="125">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(anjar.getRetweetCount());&#xA;&#xA;&#x9;&#x9;anjar.retweet(oegly.getTweet(1));&#xA;&#x9;&#x9;System.out.println(anjar.getRetweetCount(" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="2894" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488123989637" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweet(&quot;lolomg&quot;);&#xA;&#x9;&#x9;System.out.println(anjar.getTweetCount());&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="2948" end="-191"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488124005606" sizeMeasure="128">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="retweet(oegly.getTweet(1));&#xA;&#x9;&#x9;System.out.println(anjar.getRetweetCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;anjar.tweet(&quot;lolomg&quot;);&#xA;&#x9;&#x9;System.out.println(anjar.getT" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="2948" end="-121"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488124019333" sizeMeasure="125">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="3097" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210106753" sizeMeasure="125">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="egg = new TwitterAccount(&quot;egg&quot;);&#xA;&#x9;&#x9;TwitterAccount sau = new TwitterAccount(&quot;sau&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;egg.tweet(&quot;Her bli' det liv, rai, rai!&quot;);&#xA;&#x9;&#x9;egg.tweet(&quot;Her bli' det leave, rai, rai! #brexit&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;sau.follow(egg);&#xA;&#x9;&#x9;sau.retweet(egg.getTweet(2));&#xA;&#x9;&#x9;System.out.println(sau.getRetweetCount());&#xA;&#xA;&#x9;&#x9;sau.retweet(egg.getTweet(1));&#xA;&#x9;&#x9;System.out.println(sau.getRetweetCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;sau.tweet(&quot;lolomg&quot;);&#xA;&#x9;&#x9;System.out.println(sau.getTweetCount(" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="2634" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488210156149" sizeMeasure="126">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(sau.getTweetCount());" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="3000" end="-74"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488211402066" sizeMeasure="127">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*&#xA;    &#x9;&#x9;if(this.tweets.get(n).getOriginalTweet() != null) {&#xA;    &#x9;&#x9;&#x9;i++;&#xA;     &#x9;&#x9;}*/&#xA;    &#x9;&#x9;i += this.tweets.get(n).getRetweetCount();" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="2453" end="-582"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487862424332" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487862467134" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487862531856" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487862604419" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487862661460" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487863897383" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487864007234" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487864709969" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487864717522" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487864753613" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488210733864" mode="debug"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116019777" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116040735" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116052840" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116062135" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116334943" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116339928" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116366703" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116424100" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116750778" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116878230" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488116936153" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488117054683" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488117078098" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488117135127" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488117168963" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488117203378" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118023038" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118035844" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118066820" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118083985" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118101601" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118114295" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118146221" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118175630" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118193159" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118233684" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118280768" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118288336" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118308781" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118325548" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118370616" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118514138" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118540435" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118587075" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488118778639" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488119021751" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488119067178" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488119123694" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488119195033" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488119691231" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488119707598" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488119735350" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488123532264" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488123535720" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488123599524" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488123952999" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488123989386" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488124005405" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488124019037" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488125555547" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488125560564" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488125583032" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488125587963" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488210111659" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488210155559" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488210195710" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487862295339" completion="0.0" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487862485908" completion="0.0" failureCount="4"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487862668314" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487863297071" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487863904307" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487863990950" completion="0.0" failureCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487864013371" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487864156863" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487864763144" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487864828511" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488125877099" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488126087884" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488126119805" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488126210571" completion="0.25" successCount="1" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488126249258" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210216039" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210266771" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210354707" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210450154" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210630920" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210640657" completion="1.0" successCount="4"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488116089425" completion="0.6666666666666666" successCount="4" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488116442539" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488116762337" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488119213594" completion="0.5" successCount="3" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488119252465" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488119361281" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488123141731" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488123154559" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488123168237" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488123514087" completion="0.6666666666666666" successCount="4" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488123613262" completion="0.6666666666666666" successCount="4" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488123637672" completion="0.6666666666666666" successCount="4" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488123654248" completion="0.6666666666666666" successCount="4" failureCount="1" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488123675381" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488124106990" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488126268816" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210307926" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210652164" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488210930676" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488211410969" completion="0.8333333333333334" successCount="5" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488211421812" completion="1.0" successCount="6"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="9">
        <attempts timestamp="1488119355227"/>
        <attempts timestamp="1488119367019"/>
        <attempts timestamp="1488123237035"/>
        <attempts timestamp="1488123423357"/>
        <attempts timestamp="1488123729836"/>
        <attempts timestamp="1488123809179"/>
        <attempts timestamp="1488124198596"/>
        <attempts timestamp="1488125564003"/>
        <attempts timestamp="1488125603524"/>
        <attempts timestamp="1488125619413"/>
        <attempts timestamp="1488125685163"/>
        <attempts timestamp="1488125728511"/>
        <attempts timestamp="1488126002558"/>
        <attempts timestamp="1488210490435"/>
        <attempts timestamp="1488210772048"/>
        <attempts timestamp="1488210794916"/>
        <attempts timestamp="1488210822618"/>
        <attempts timestamp="1488210897587"/>
        <attempts timestamp="1488211006786"/>
        <attempts timestamp="1488211029684"/>
        <attempts timestamp="1488211082682"/>
        <attempts timestamp="1488211172270"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
