<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488873955423" sizeMeasure="44" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compareTo(Card card){&#xA;&#x9;&#x9;int check = card.compareTo(this);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="996" charEnd="1016" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875175033" sizeMeasure="58" errorCount="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1, Card card2){&#xA;&#x9;&#x9;//Spar høyere enn hjerter, hjerter høyere enn ruter og ruter høyere enn kløver&#xA;&#x9;&#x9;//'S', 'H', 'D' eller 'C'.&#xA;&#x9;&#x9;int check;&#xA;&#x9;&#x9;if (card1.getSuit() == card2.getSuit()){&#xA;&#x9;&#x9;&#x9;if(card1.getFace() > card2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;check = 1;&#xA;&#x9;&#x9;&#x9;}else{ check = -1;}&#xA;&#x9;&#x9;}else if (card1 == 'S' )&#xA;&#x9;&#x9;int check = card.&#xA;&#x9;&#x9;&#x9;&#x9;.compareTo(this);&#xA;&#x9;&#x9;if(check == 0)&#xA;&#x9;}&#xA;&#x9;String a = &quot;A12&quot;;&#xA;&#x9;String b = &quot;S11&quot;;&#xA;&#x9;int check = a.compareTo.b;&#xA;&#x9;return check;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="976" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1315" charEnd="1318" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1315" charEnd="1318" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1315" charEnd="1318" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1315" charEnd="1318" severity="2" problemCategory="20" problemType="1610612959"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1327" charEnd="1331" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1338" charEnd="1339" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1372" charEnd="1373" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="55" charStart="1434" charEnd="1443" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1449" charEnd="1455" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="40" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1297" charEnd="1309" severity="2" problemCategory="40" problemType="16777231"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875191791" sizeMeasure="58" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*&#x9;}else if (card1 == 'S' )&#xA;&#x9;&#x9;int check = card.&#xA;&#x9;&#x9;&#x9;&#x9;.compareTo(this);&#xA;&#x9;&#x9;if(check == 0)&#xA;&#x9;}&#xA;&#x9;String a = &quot;A12&quot;;&#xA;&#x9;String b = &quot;S11&quot;;&#xA;&#x9;int check = a.compareTo.b;&#xA;&#x9;return check;*/" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1239" end="-6"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="40" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="978" charEnd="979" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="58" charStart="1471" charEnd="1472" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="58" charStart="1471" charEnd="1472" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875204894" sizeMeasure="58" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1414" end="-3"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="978" charEnd="979" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1282" charEnd="1283" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1282" charEnd="1283" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1282" charEnd="1283" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="40" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875207922" sizeMeasure="58" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="941" end="-478"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="40" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="925" charEnd="926" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="974" charEnd="975" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1284" charEnd="1285" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1284" charEnd="1285" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1284" charEnd="1285" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875211558" sizeMeasure="58" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="941" end="-478"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="40" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="978" charEnd="979" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1282" charEnd="1283" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1282" charEnd="1283" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1282" charEnd="1283" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488875572344" sizeMeasure="48" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;//'S', 'H', 'D' eller 'C'.&#xA;&#x9;&#x9;int check = &#xA;&#x9;}&#xA;}&#xA;&#x9;&#xA;//}&#xA;*/" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1075" end="-2"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1163" charEnd="1164" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="40" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1158" charEnd="1159" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876338764" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="39" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="950" charEnd="951" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876494708" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="917" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876589762" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public int compareTo(Card c1){&#xA;&#x9;&#x9;int check = SUITS.indexOf(this.getSuit()) - SUITS.indexOf(c1.getSuit());&#xA;&#x9;&#x9;if(check == 0){&#xA;&#x9;&#x9;&#x9;check = this.getFace() - c1.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;}" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="915" end="-2"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876729685" sizeMeasure="56" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Arrays;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;public int compareTo(Card c1){&#xA;&#x9;&#x9;int check = SUITS.indexOf(this.getSuit()) - SUITS.indexOf(c1.getSuit());&#xA;&#x9;&#x9;if(check == 0){&#xA;&#x9;&#x9;&#x9;check = this.getFace() - c1.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 13)&#xA;&#x9;&#x9;&#x9;&#x9;))" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="21" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1226" charEnd="1230" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1249" charEnd="1258" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876740774" sizeMeasure="58" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.Arrays;&#xA;import java.util.List" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="43" end="-1267"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1290" charEnd="1295" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876799359" sizeMeasure="62" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.List;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;// the suit (farge), one of the values 'S' (spades), 'H' (hearts), 'D' (diamonds) and 'C' (clubs) &#xA;&#x9;private char suit;&#xA;&#x9;// the value, 1 for the ace, 2 - 10, 11 (knight), 12 (queen) and 13 (king). -1 is invalid&#xA;&#x9;private int face = -1;&#xA;&#xA;&#x9;// the set of suits in decreasing order&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * Returns suit and face as a string&#xA;&#x9; * E.g. Ace of spades is S1 and king of clubs is C13&#xA;&#x9; */&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;public int compareTo(Card c1){&#xA;&#x9;&#x9;int check = SUITS.indexOf(this.getSuit()) - SUITS.indexOf(c1.getSuit());&#xA;&#x9;&#x9;if(check == 0){&#xA;&#x9;&#x9;&#x9;check = this.getFace() - c1.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 13)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;System.out.println(&quot;Før sortering: &quot; + cards);&#xA;&#x9;&#x9;Collections.sort((List&lt;T>) cards);&#xA;&#x9;&#x9;System.out.println(&quot;Etter sort: &quot; + cards" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="91" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="59" charStart="1507" charEnd="1511" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="59" charStart="1518" charEnd="1519" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876856019" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1454" end="-60"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="59" charStart="1507" charEnd="1511" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488878595366" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="146" end="-1369"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880047541" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1541" end="-1542"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488876265527" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488877404892" sizeMeasure="22" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;&#xA;&#x9;boolean ace;&#xA;&#x9;char trumph;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2){&#xA;&#x9;&#x9;int check = c1.compareTo(c2);&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="326" charEnd="331" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488879225086" sizeMeasure="24" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Comparable,comarartor, iterator, iterable&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;&#xA;&#x9;boolean ace;&#xA;&#x9;char trumph;&#xA;&#x9;//public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2){&#xA;&#x9;&#x9;int check = SUITS.indexOf(c1.getSuit()) - SUITS.indexOf(c2.getSuit()" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="51" end="-24"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="381" charEnd="386" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="19" charStart="411" charEnd="416" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880025801" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index) + SUITS.substring(index + 1); &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2){&#xA;&#x9;&#x9;int check = SUITS.indexOf(c1.getSuit()) - SUITS.indexOf(c2.getSuit());&#xA;&#x9;&#x9;if((check == 0)){&#xA;&#x9;&#x9;&#x9;if(ace){&#xA;&#x9;&#x9;&#x9;&#x9;if(c1.getFace() == 1 &amp;&amp; c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;check = c1.getFace() - c2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="184" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880446555" sizeMeasure="53" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;//Comparable,comarartor, iterator, iterable&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;&#xA;&#x9;boolean ace;&#xA;&#x9;char trumph;&#xA;&#x9;public String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index) + SUITS.substring(index + 1); &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2){&#xA;&#x9;&#x9;int check = SUITS.indexOf(c1.getSuit()) - SUITS.indexOf(c2.getSuit());&#xA;&#x9;&#x9;if((check == 0)){&#xA;&#x9;&#x9;&#x9;if(ace){&#xA;&#x9;&#x9;&#x9;&#x9;if(c1.getFace() == 1 &amp;&amp; c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;check = c1.getFace() - c2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 13)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="38" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1069" charEnd="1074" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880508053" sizeMeasure="54" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;CardComparator C1 = new CardComparator(true, 'H'" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1187" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1069" charEnd="1074" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1203" charEnd="1205" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880569354" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="llections;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;//Comparable,comarartor, iterator, iterable&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#x9;&#xA;&#x9;boolean ace;&#xA;&#x9;char trumph;&#xA;&#x9;public String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public CardComparator(boolean ace, char trumph){&#xA;&#x9;&#x9;this.ace = ace;&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;String newSuits = &quot;&quot;;&#xA;&#x9;&#x9;int index = SUITS.indexOf(trumph);&#xA;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index);&#xA;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index) + SUITS.substring(index + 1); &#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card c1, Card c2){&#xA;&#x9;&#x9;int check = SUITS.indexOf(c1.getSuit()) - SUITS.indexOf(c2.getSuit());&#xA;&#x9;&#x9;if((check == 0)){&#xA;&#x9;&#x9;&#x9;if(ace){&#xA;&#x9;&#x9;&#x9;&#x9;if(c1.getFace() == 1 &amp;&amp; c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c1.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;check = c1.getFace() - c2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return check;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>(Arrays.asList(&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', 4),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('S', 1),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('C', 13)&#xA;&#x9;&#x9;&#x9;&#x9;));&#xA;&#x9;&#x9;CardComparator C1 = new CardComparator(true, 'H');&#xA;&#x9;&#x9;System.out.println(&quot;Før sortering: &quot; + cards);&#xA;&#x9;&#x9;Collections.sort(cards, C1);&#xA;&#x9;&#x9;System.out.println(&quot;Etter sort: &quot; + cards" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="93" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880587562" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1264" end="-136"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880606621" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1178" end="-222"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880709575" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;hei&quot;);" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="909" end="-498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880760682" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(c1" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="941" end="-500"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880793570" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(&quot;hei&quot;);" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1018" end="-450"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880833360" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1275" end="-218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880856336" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="6),&#xA;&#x9;&#x9;&#x9;&#x9;new Card('H', " edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1275" end="-196"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880894823" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;System.out.println(&quot;hei&quot;);&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;check = -(c1.getFace() - c2.getFace()" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="977" end="-384"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880915004" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1278" end="-217"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880929706" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="C" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1296" end="-199"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488880946262" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="909" end="-451"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881174580" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!(trumph == ' ')){&#xA;&#x9;&#x9;&#x9;if(trumph == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index);&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;&#x9;newSuits = trumph + SUITS.substring(0, index) + SUITS.substring(index + 1); &#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;SUITS = newSuits;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="480" end="-745"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881257200" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-(SUITS.indexOf(c1.getSuit()) - SUITS.indexOf(c2.getSuit()" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="751" end="-631"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881290155" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="953" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881319923" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="953" end="-438"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881338301" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="1027" end="-412"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881435394" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;&#x9;&#x9;}else if(c2.getFace() == 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="953" end="-437"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488878649783" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880570694" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880588873" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880609841" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880708189" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880759291" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880792022" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880831983" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880855101" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880897876" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880913333" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488880928225" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488880048094" completion="0.0" failureCount="1" errorCount="2">
          <failureTests>testDiamondIsTrumph</failureTests>
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488880959158" completion="0.0" failureCount="1" errorCount="2">
          <failureTests>testDiamondIsTrumph</failureTests>
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488880968511" completion="0.0" failureCount="1" errorCount="2">
          <failureTests>testDiamondIsTrumph</failureTests>
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488881179528" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488881263418" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488881290730" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testAceIsHighest</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488881320467" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488881338988" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488881442332" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
