<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringGridImpl">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Copy the source code for the StringGrid interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGrid"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridImpl class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridImpl class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StringGridIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StringGridTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.StringGridTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.StringGrid*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937583892" sizeMeasure="16">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;/*&#xA;An interface with methods for managing the content of a String grid.&#xA;The grid has a number of rows (the grid's height) and columns (the grid's width).&#xA;In each cell in the grid there is a String that can be set with the setElement method and read with the getElement method.&#xA;*/&#xA;public interface StringGrid extends Iterable&lt;String>{&#xA;    // Returns the number of rows in this StringGrid&#xA;    public int getRowCount();&#xA;    // Returns the number of columns in this StringGrid&#xA;    public int getColumnCount(); &#xA;    // Returns the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public String getElement(int row, int column);&#xA;    // Sets the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public void setElement(int row, int column, String element);&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937583912" sizeMeasure="35">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Iterator;&#xA;&#xA;public class StringGridImpl implements StringGrid{&#xA;&#x9;ArrayList&lt;String> strs;&#xA;&#x9;int numRows;&#xA;&#x9;int numCols;&#xA;&#x9;public StringGridImpl(int rows, int columnCount){&#xA;&#x9;&#x9;numRows= rows;&#xA;&#x9;&#x9;numCols = columnCount;&#xA;&#x9;&#x9;strs = new ArrayList&lt;String>(rows*columnCount);&#xA;&#x9;&#x9;for(int i = 0; i &lt; rows*columnCount; i++){&#xA;&#x9;&#x9;&#x9;strs.set(i, &quot;&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getRowCount(){&#xA;&#x9;&#x9;return numRows;&#xA;&#x9;}&#xA;&#x9;public int getColumnCount(){&#xA;&#x9;&#x9;return numCols;&#xA;&#x9;}&#xA;&#x9;public String getElement(int row, int column){&#xA;&#x9;&#x9;return strs.get(row*numCols + column);&#xA;&#x9;}&#xA;&#x9;public void setElement(int row, int column, String element){&#xA;&#x9;&#x9;strs.set(row*numCols + column, element);&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public Iterator&lt;String> iterator() {&#xA;&#x9;&#x9;return strs.iterator();&#xA;&#x9;}&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937963045" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(rows-1)*(columnCount-1); i++){&#xA;&#x9;&#x9;&#x9;strs.set(i, &quot;&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public int getRowCount(){&#xA;&#x9;&#x9;return numRows;&#xA;&#x9;}&#xA;&#x9;public int getColumnCount(){&#xA;&#x9;&#x9;return numCols;&#xA;&#x9;}&#xA;&#x9;public String getElement(int row, int column){&#xA;&#x9;&#x9;return strs.get(row*numCols + column);&#xA;&#x9;}&#xA;&#x9;public void setElement(int row, int column, String element){&#xA;&#x9;&#x9;strs.set(row*(numCols-1)" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="345" end="-107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937986422" sizeMeasure="35" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;&#x9;for(int i = 0; i &lt; (rows-1)*(columnCount-1); i++){&#xA;&#x9;&#x9;&#x9;strs.add" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="304" end="-402"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937995345" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="()" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="304" end="-468"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938023534" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="add" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="648" end="-123"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938059300" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=")*(columnCount" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="334" end="-422"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938076810" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="set(row*(numCols" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="644" end="-108"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939705255" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="numCols" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="652" end="-107"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487937895037" sizeMeasure="48">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import interfaces.StringGrid;&#xA;&#xA;public class StringGridIterator{&#xA;&#x9;StringGrid strGrid;&#xA;&#x9;boolean rowMajor;&#xA;&#x9;int posX = 0;&#xA;&#x9;int posY = 0;&#xA;&#x9;public StringGridIterator(StringGrid StringGrid, boolean rowMajor){&#xA;&#x9;&#x9;strGrid = StringGrid;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;}&#xA;&#x9;public boolean hasNext(){&#xA;&#x9;&#x9;if(posX == (strGrid.getColumnCount() - 1) &amp;&amp; posY == (strGrid.getRowCount() - 1)){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#x9;public String next(){&#xA;&#x9;&#x9;if(!hasNext()){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Ikke noe neste element&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(rowMajor){&#xA;&#x9;&#x9;&#x9;if(posX &lt; strGrid.getColumnCount() - 1){&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX-1);&#xA;&#x9;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posX = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, strGrid.getColumnCount());&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}else{&#xA;&#x9;&#x9;&#x9;if(posY &lt; strGrid.getRowCount() - 1){&#xA;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posX, posY-1);&#xA;&#x9;&#x9;&#x9;}else if(posX &lt; strGrid.getColumnCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posY=0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, strGrid.getColumnCount());&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;} &#xA;&#x9;&#x9;return &quot;&quot;;&#xA;&#x9;}&#xA;&#x9;public void remove(){&#xA;&#x9;&#x9;throw new UnsupportedOperationException(&quot;Kan ikke fjerne strenger&quot;);&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938225200" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="790" end="-385"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487938266555" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="strGrid.getRowCount()-1, posX-1" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="1014" end="-131"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939047163" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount() - 1){&#xA;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posX, posY-1);&#xA;&#x9;&#x9;}else if(posX &lt; strGrid.getColumnCount()-2){&#xA;&#x9;&#x9;&#x9;&#x9;posY = 0;&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(strGrid.getRowCount()-1, posX-1);&#xA;&#x9;&#x9;}else if(posX == strGrid.getColumnCount()-1 &amp;&amp; posY == strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posX,posY);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="798" end="-117"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939130101" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2){&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX-1);&#xA;&#x9;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-2){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posX = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, strGrid.getColumnCount()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount() - -2" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="593" end="-442"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487939237578" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1){&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX-1);&#xA;&#x9;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posX = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, strGrid.getColumnCount()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount() -1){&#xA;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posX, posY-1);&#xA;&#x9;&#x9;}else if(posX &lt; strGrid.getColumnCount()-1" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="593" end="-338"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940138488" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="){&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX-1);&#xA;&#x9;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posX = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, strGrid.getColumnCount()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="590" end="-442"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940454816" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1){&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX-1);&#xA;&#x9;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posX = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, strGrid.getColumnCount()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="590" end="-442"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940516574" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=") &amp;&amp; posY == (strGrid.getRowCount()" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="344" end="-894"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940614038" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1;&#xA;&#x9;int posY = 0;&#xA;&#x9;public StringGridIterator(StringGrid StringGrid, boolean rowMajor){&#xA;&#x9;&#x9;strGrid = StringGrid;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;}&#xA;&#x9;public boolean hasNext(){&#xA;&#x9;&#x9;if(posX == (strGrid.getColumnCount()-1) &amp;&amp; posY == (strGrid.getRowCount())-1" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="137" end="-893"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940639415" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="644" end="-632"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940658106" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0;&#xA;&#x9;int posY = 0;&#xA;&#x9;public StringGridIterator(StringGrid StringGrid, boolean rowMajor){&#xA;&#x9;&#x9;strGrid = StringGrid;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;}&#xA;&#x9;public boolean hasNext(){&#xA;&#x9;&#x9;if(posX == (strGrid.getColumnCount()-1) &amp;&amp; posY == (strGrid.getRowCount())-1){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#x9;public String next(){&#xA;&#x9;&#x9;if(!hasNext()){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Ikke noe neste element&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(rowMajor){&#xA;&#x9;&#x9;&#x9;if(posX &lt; strGrid.getColumnCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX-1" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="137" end="-632"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940674262" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="344" end="-931"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487940976448" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=">= (strGrid.getColumnCount()) &amp;&amp; posY >= (strGrid.getRowCount())){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return true;&#xA;&#x9;}&#xA;&#x9;public String next(){&#xA;&#x9;&#x9;if(!hasNext()){&#xA;&#x9;&#x9;&#x9;throw new IllegalStateException(&quot;Ikke noe neste element&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(posX == strGrid.getColumnCount() - 1 &amp;&amp; posY == strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="316" end="-751"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487941017798" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="posX++; posY++;" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="611" end="-791"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487941035495" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1, posX-1" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="660" end="-751"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942021100" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="||" edit="/1/@proposals.1/@proposals.0/@attempts.15/@edit" start="346" end="-1073"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942344072" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Y-1, posX" edit="/1/@proposals.1/@proposals.0/@attempts.16/@edit" start="1027" end="-385"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942719547" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.17/@edit" start="1179" end="-123"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942775172" sizeMeasure="49">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="rowMajor){&#xA;&#x9;&#x9;&#x9;if(posX &lt; strGrid.getColumnCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX-1);&#xA;&#x9;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posX = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, strGrid.getColumnCount()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, posX);&#xA;&#x9;&#x9;}else if(posX &lt; strGrid.getColumnCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;posY = 0;&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(strGrid.getRowCount()-1, posX-1);&#xA;&#x9;&#x9;}else if(posX == strGrid.getColumnCount() - 1 &amp;&amp; posY == strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;posX++; posY++;&#xA;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, posX-1" edit="/1/@proposals.1/@proposals.0/@attempts.18/@edit" start="534" end="-123"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487942792607" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="posX == strGrid.getColumnCount() - 1 &amp;&amp; posY == strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;posX++; posY++;&#xA;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, posX-1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if(rowMajor){&#xA;&#x9;&#x9;&#x9;if(posX &lt; strGrid.getColumnCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY, posX-1);&#xA;&#x9;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posX = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, strGrid.getColumnCount()-1);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}else if(posY &lt; strGrid.getRowCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;posY++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(posY-1, posX);&#xA;&#x9;&#x9;}else if(posX &lt; strGrid.getColumnCount()-1){&#xA;&#x9;&#x9;&#x9;&#x9;posY = 0;&#xA;&#x9;&#x9;&#x9;&#x9;posX++;&#xA;&#x9;&#x9;&#x9;&#x9;return strGrid.getElement(strGrid.getRowCount()" edit="/1/@proposals.1/@proposals.0/@attempts.19/@edit" start="534" end="-133"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487937585511" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487937903839" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487937964096" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487937987486" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487937996308" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938024488" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938060371" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938077987" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938082238" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938144850" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938226308" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938267541" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938391532" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938486076" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487938525093" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939048164" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939056702" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939060360" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939064485" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939131118" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487939238613" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940139562" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940614969" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940640492" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940659119" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940675179" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940707307" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487940977575" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487941018729" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487941036615" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487941040399" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942022161" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942032003" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942170223" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942345033" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942349356" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942720223" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942724132" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942776246" completion="0.0" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942793566" completion="1.0" successCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487942797236" completion="1.0" successCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a" performedCount="61">
        <attempts timestamp="1487938170521"/>
        <attempts timestamp="1487938171340"/>
        <attempts timestamp="1487938194459"/>
        <attempts timestamp="1487938199110"/>
        <attempts timestamp="1487938202255"/>
        <attempts timestamp="1487938204446"/>
        <attempts timestamp="1487938313365"/>
        <attempts timestamp="1487938340424"/>
        <attempts timestamp="1487938341758"/>
        <attempts timestamp="1487938342428"/>
        <attempts timestamp="1487938344621"/>
        <attempts timestamp="1487939174673"/>
        <attempts timestamp="1487939184095"/>
        <attempts timestamp="1487939211222"/>
        <attempts timestamp="1487939279003"/>
        <attempts timestamp="1487939772279"/>
        <attempts timestamp="1487939773585"/>
        <attempts timestamp="1487939774555"/>
        <attempts timestamp="1487939776982"/>
        <attempts timestamp="1487939814759"/>
        <attempts timestamp="1487939815412"/>
        <attempts timestamp="1487939817654"/>
        <attempts timestamp="1487939828881"/>
        <attempts timestamp="1487939842113"/>
        <attempts timestamp="1487939844501"/>
        <attempts timestamp="1487939845360"/>
        <attempts timestamp="1487939847765"/>
        <attempts timestamp="1487939849622"/>
        <attempts timestamp="1487939851549"/>
        <attempts timestamp="1487939921106"/>
        <attempts timestamp="1487939984140"/>
        <attempts timestamp="1487939993978"/>
        <attempts timestamp="1487940030590"/>
        <attempts timestamp="1487940033661"/>
        <attempts timestamp="1487940083141"/>
        <attempts timestamp="1487940083956"/>
        <attempts timestamp="1487940085486"/>
        <attempts timestamp="1487940545091"/>
        <attempts timestamp="1487940696974"/>
        <attempts timestamp="1487940698082"/>
        <attempts timestamp="1487940698485"/>
        <attempts timestamp="1487940698670"/>
        <attempts timestamp="1487940698847"/>
        <attempts timestamp="1487940699241"/>
        <attempts timestamp="1487940699758"/>
        <attempts timestamp="1487940700202"/>
        <attempts timestamp="1487940702148"/>
        <attempts timestamp="1487940725242"/>
        <attempts timestamp="1487940726962"/>
        <attempts timestamp="1487942077278"/>
        <attempts timestamp="1487942100267"/>
        <attempts timestamp="1487942101601"/>
        <attempts timestamp="1487942110700"/>
        <attempts timestamp="1487942127344"/>
        <attempts timestamp="1487942151131"/>
        <attempts timestamp="1487942153365"/>
        <attempts timestamp="1487942263176"/>
        <attempts timestamp="1487942264063"/>
        <attempts timestamp="1487942265404"/>
        <attempts timestamp="1487942270218"/>
        <attempts timestamp="1487942275509"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a" performedCount="46">
        <attempts timestamp="1487938163974"/>
        <attempts timestamp="1487938167232"/>
        <attempts timestamp="1487938288316"/>
        <attempts timestamp="1487938290653"/>
        <attempts timestamp="1487938292963"/>
        <attempts timestamp="1487939157438"/>
        <attempts timestamp="1487939159247"/>
        <attempts timestamp="1487939170306"/>
        <attempts timestamp="1487939171525"/>
        <attempts timestamp="1487939254045"/>
        <attempts timestamp="1487939256527"/>
        <attempts timestamp="1487939256643"/>
        <attempts timestamp="1487939272906"/>
        <attempts timestamp="1487939274823"/>
        <attempts timestamp="1487939276010"/>
        <attempts timestamp="1487939277514"/>
        <attempts timestamp="1487939436504"/>
        <attempts timestamp="1487939437920"/>
        <attempts timestamp="1487939439523"/>
        <attempts timestamp="1487939748780"/>
        <attempts timestamp="1487939756407"/>
        <attempts timestamp="1487939762383"/>
        <attempts timestamp="1487939801861"/>
        <attempts timestamp="1487939806655"/>
        <attempts timestamp="1487939917170"/>
        <attempts timestamp="1487939918733"/>
        <attempts timestamp="1487940080294"/>
        <attempts timestamp="1487940081567"/>
        <attempts timestamp="1487940248127"/>
        <attempts timestamp="1487940254980"/>
        <attempts timestamp="1487940461964"/>
        <attempts timestamp="1487940468670"/>
        <attempts timestamp="1487940480146"/>
        <attempts timestamp="1487940535765"/>
        <attempts timestamp="1487940542887"/>
        <attempts timestamp="1487940717473"/>
        <attempts timestamp="1487940719201"/>
        <attempts timestamp="1487942073040"/>
        <attempts timestamp="1487942075384"/>
        <attempts timestamp="1487942097407"/>
        <attempts timestamp="1487942099276"/>
        <attempts timestamp="1487942218665"/>
        <attempts timestamp="1487942220371"/>
        <attempts timestamp="1487942231584"/>
        <attempts timestamp="1487942241306"/>
        <attempts timestamp="1487942314741"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a" performedCount="18">
        <attempts timestamp="1487938174716"/>
        <attempts timestamp="1487938308517"/>
        <attempts timestamp="1487939178066"/>
        <attempts timestamp="1487939260169"/>
        <attempts timestamp="1487939324078"/>
        <attempts timestamp="1487939446889"/>
        <attempts timestamp="1487939765778"/>
        <attempts timestamp="1487939809225"/>
        <attempts timestamp="1487939887793"/>
        <attempts timestamp="1487939987825"/>
        <attempts timestamp="1487940069052"/>
        <attempts timestamp="1487940257103"/>
        <attempts timestamp="1487940400876"/>
        <attempts timestamp="1487940458279"/>
        <attempts timestamp="1487940546386"/>
        <attempts timestamp="1487940721830"/>
        <attempts timestamp="1487942080217"/>
        <attempts timestamp="1487942245201"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
