<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488296859686" sizeMeasure="42">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card &#xA;{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card (char suit, int face)&#xA;&#x9;{&#xA;&#x9;&#x9;if (suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid suit.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (face >= 1 &amp;&amp; face &lt;= 13)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid face.&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit()&#xA;&#x9;{&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace()&#xA;&#x9;{&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString()&#xA;&#x9;{&#xA;&#x9;&#x9;return suit + String.valueOf(face);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488296953692" sizeMeasure="42" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="39" end="-538"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="34" charEnd="38" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488296971519" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="597" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297441215" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="636" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297500642" sizeMeasure="48" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="656" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="649" charEnd="657" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297501489" sizeMeasure="48">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="656" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297642024" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.suit == card.suit)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.face > card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="646" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297645146" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="817" end="-33"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297798216" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// OBSOBS, ikke ferdig hva hvis suit er ulik" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="831" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369519582" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getSuit()" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="565" end="-329"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369785283" sizeMeasure="65" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Character> suits = new ArrayList('S', 'H', 'D', 'C');" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="647" end="-255"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="653" charEnd="657" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="681" charEnd="690" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369884614" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>&#xA;{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card (char suit, int face)&#xA;&#x9;{&#xA;&#x9;&#x9;if (suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid suit.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (face >= 1 &amp;&amp; face &lt;= 13)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid face.&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit()&#xA;&#x9;{&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace()&#xA;&#x9;{&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString()&#xA;&#x9;{&#xA;&#x9;&#x9;return getSuit() + String.valueOf(face);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C');&#xA;&#x9;&#x9;suits.update" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="21" end="-276"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="797" charEnd="803" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369913208" sizeMeasure="69" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="791" end="-276"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="746" charEnd="751" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488369937133" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.suit == card.suit)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.face > card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.getSuit())" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="791" end="-70"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="983" charEnd="997" severity="2" problemCategory="40" problemType="16777233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370001875" sizeMeasure="75" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getSuit() == card.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.face > card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (suits.indexOf(this.getFace()) &lt; suits.indexOf(card.getFace()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="800" end="-70"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370015900" sizeMeasure="75" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1137" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370037162" sizeMeasure="73" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //sortert i rekkefølge best-dårligst&#xA;&#x9;&#x9;if (this.getSuit() == card.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.face > card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (suits.indexOf(this.getFace()) &lt; suits.indexOf(card.getFace()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="788" end="-23"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370074257" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" Sortert i rekkefølge best-dårligst&#xA;&#x9;&#x9;if (this.getSuit() == card.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.face > card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Hvis face til this kommer før face til parameter i suits " edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="791" end="-114"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370092119" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Suit()) &lt; suits.indexOf(card.getSuit" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1116" end="-49"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370109568" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // returnerer -1 hvis this kommer før parameter" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1174" end="-27"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370114797" sizeMeasure="74" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="792" end="-456"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370121734" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="43" end="-1201"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370278167" sizeMeasure="85" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>&#xA;{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card (char suit, int face)&#xA;&#x9;{&#xA;&#x9;&#x9;if (suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid suit.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (face >= 1 &amp;&amp; face &lt;= 13)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid face.&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit()&#xA;&#x9;{&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace()&#xA;&#x9;{&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString()&#xA;&#x9;{&#xA;&#x9;&#x9;return getSuit() + String.valueOf(face);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C'); // sortert i rekkefølge best-dårligst&#xA;&#x9;&#x9;if (this.getSuit() == card.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.face > card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Hvis face til this kommer før face til parameter i suits &#xA;&#x9;&#x9;if (suits.indexOf(this.getSuit()) &lt; suits.indexOf(card.getSuit()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1; // returnerer -1 hvis this kommer før parameter&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) &#xA;&#x9;{&#xA;&#x9;&#x9;Card card1 = new Card('H', 10);&#xA;&#x9;&#x9;Card card2 = new Card('S', 2);&#xA;&#x9;&#x9;Card card3 = new Card('S', 3);&#xA;&#x9;&#x9;Card card4 = new Card('C', 10);&#xA;&#x9;&#x9;Card card5 = new Card('D', 2);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(card1.compareTo(card2));&#xA;&#x9;&#x9;System.out.println(card2.compareTo(card3))" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="43" end="-12"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1401" charEnd="1406" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="77" charStart="1367" charEnd="1372" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370304807" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(card4.compareTo(card5" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1523" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370329069" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="5.compareTo(card4" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1547" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370405228" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;-1&quot; + " edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1451" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370422586" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &quot; + card1.compareTo(card2));&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + " edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="1454" end="-81"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370451682" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;-1 &quot; + " edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1558" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370478902" sizeMeasure="87" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card card6" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1429" end="-195"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="79" charStart="1434" charEnd="1439" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370491247" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(&quot;0 &quot; + card5.compareTo(card6" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1625" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370588361" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="getFace() > card.getFace()" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="855" end="-816"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370648443" sizeMeasure="88">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1495" end="-201"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370730897" sizeMeasure="96" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.Arrays;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparable&lt;Card>&#xA;{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card (char suit, int face)&#xA;&#x9;{&#xA;&#x9;&#x9;if (suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid suit.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (face >= 1 &amp;&amp; face &lt;= 13)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid face.&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit()&#xA;&#x9;{&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace()&#xA;&#x9;{&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString()&#xA;&#x9;{&#xA;&#x9;&#x9;return getSuit() + String.valueOf(face);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C'); // sortert i rekkefølge best-dårligst&#xA;&#x9;&#x9;if (this.getSuit() == card.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Hvis face til this kommer før face til parameter i suits &#xA;&#x9;&#x9;if (suits.indexOf(this.getSuit()) &lt; suits.indexOf(card.getSuit()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1; // returnerer -1 hvis this kommer før parameter&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList();&#xA;&#x9;&#x9;Card card1 = new Card('H', 10);&#xA;&#x9;&#x9;cards.add(card1);&#xA;&#x9;&#x9;Card card2 = new Card('S', 2);&#xA;&#x9;&#x9;cards.add(card2);&#xA;&#x9;&#x9;Card card3 = new Card('S', 3);&#xA;&#x9;&#x9;cards.add(card3);&#xA;&#x9;&#x9;Card card4 = new Card('C', 10);&#xA;&#x9;&#x9;cards.add(card4);&#xA;&#x9;&#x9;Card card5 = new Card('D', 2);&#xA;&#x9;&#x9;cards.add(card5);&#xA;&#x9;&#x9;Card card6 = new Card('D', 2);&#xA;&#x9;&#x9;cards.add(card6" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="43" end="-229"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1323" charEnd="1332" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1319" charEnd="1334" severity="1" problemCategory="130" problemType="16777748"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370741118" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="1332" end="-550"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370831198" sizeMeasure="98" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards.sort" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1667" end="-227"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="89" charStart="1667" charEnd="1672" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="91" charStart="1689" charEnd="1690" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="91" charStart="1690" charEnd="1693" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370836045" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1667" end="-227"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370854650" sizeMeasure="98" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards.sort(CardComparator&lt;>);" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="1667" end="-227"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="89" charStart="1693" charEnd="1694" severity="2" problemCategory="20" problemType="1610612971"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488370952857" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// cards.sort??" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1667" end="-227"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375157246" sizeMeasure="98" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tor //" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="134" end="-1794"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="127" charEnd="137" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="728" charEnd="748" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375359162" sizeMeasure="111" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Comparator;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparator // implements Comparable&lt;Card>&#xA;{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card (char suit, int face)&#xA;&#x9;{&#xA;&#x9;&#x9;if (suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid suit.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (face >= 1 &amp;&amp; face &lt;= 13)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid face.&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit()&#xA;&#x9;{&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace()&#xA;&#x9;{&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString()&#xA;&#x9;{&#xA;&#x9;&#x9;return getSuit() + String.valueOf(face);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C'); // sortert i rekkefølge best-dårligst&#xA;&#x9;&#x9;if (this.getSuit() == card.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Hvis face til this kommer før face til parameter i suits &#xA;&#x9;&#x9;if (suits.indexOf(this.getSuit()) &lt; suits.indexOf(card.getSuit()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1; // returnerer -1 hvis this kommer før parameter&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;Card card1 = new Card('H', 10);&#xA;&#x9;&#x9;cards.add(card1);&#xA;&#x9;&#x9;Card card2 = new Card('S', 2);&#xA;&#x9;&#x9;cards.add(card2);&#xA;&#x9;&#x9;Card card3 = new Card('S', 3);&#xA;&#x9;&#x9;cards.add(card3);&#xA;&#x9;&#x9;Card card4 = new Card('C', 10);&#xA;&#x9;&#x9;cards.add(card4);&#xA;&#x9;&#x9;Card card5 = new Card('D', 2);&#xA;&#x9;&#x9;cards.add(card5);&#xA;&#x9;&#x9;Card card6 = new Card('D', 2);&#xA;&#x9;&#x9;cards.add(card6);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// cards.sort??&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + card1.compareTo(card2));&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + card2.compareTo(card3));&#xA;&#x9;&#x9;System.out.println(&quot;-1 &quot; + card5.compareTo(card4));&#xA;&#x9;&#x9;System.out.println(&quot;0 &quot; + card5.compareTo(card6));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator cardComp = new CardComparator(true, 'H');&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Object o1, Object o2) &#xA;&#x9;{&#xA;&#x9;&#x9;if (o1 instanceof Cards &amp;&amp; o2 instanceof Cards)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="91" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="166" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="757" charEnd="777" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="97" charStart="1973" charEnd="1981" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="101" charStart="2042" charEnd="2071" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375400873" sizeMeasure="111" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return compare((Card) o1, (Card) o2);" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="2133" end="-18"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="166" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="757" charEnd="777" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="97" charStart="1973" charEnd="1981" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="101" charStart="2042" charEnd="2071" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375447574" sizeMeasure="112" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return null;" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="2177" end="-14"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="166" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="757" charEnd="777" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="97" charStart="1973" charEnd="1981" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2184" charEnd="2188" severity="2" problemCategory="40" problemType="16777235"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375456480" sizeMeasure="112" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-10" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="2184" end="-15"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="97" charStart="1973" charEnd="1981" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="166" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="757" charEnd="777" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375475013" sizeMeasure="115" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Illegal argument.&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="2177" end="-14"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="166" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="757" charEnd="777" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="97" charStart="1973" charEnd="1981" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375497209" sizeMeasure="116" errorCount="5" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;cards.sort(Comparator&lt;Card>)" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="2016" end="-250"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="166" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="757" charEnd="777" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="2028" charEnd="2038" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="2039" charEnd="2043" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="2039" charEnd="2043" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="2039" charEnd="2043" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375535519" sizeMeasure="116" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="());" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="2044" end="-250"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="156" charEnd="166" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="757" charEnd="777" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="2044" charEnd="2045" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375642222" sizeMeasure="118" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="llections;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class Card implements Comparator // implements Comparable&lt;Card>&#xA;{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card (char suit, int face)&#xA;&#x9;{&#xA;&#x9;&#x9;if (suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid suit.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (face >= 1 &amp;&amp; face &lt;= 13)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid face.&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit()&#xA;&#x9;{&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace()&#xA;&#x9;{&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString()&#xA;&#x9;{&#xA;&#x9;&#x9;return getSuit() + String.valueOf(face);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C'); // sortert i rekkefølge best-dårligst&#xA;&#x9;&#x9;if (this.getSuit() == card.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Hvis face til this kommer før face til parameter i suits &#xA;&#x9;&#x9;if (suits.indexOf(this.getSuit()) &lt; suits.indexOf(card.getSuit()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1; // returnerer -1 hvis this kommer før parameter&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;Card card1 = new Card('H', 10);&#xA;&#x9;&#x9;cards.add(card1);&#xA;&#x9;&#x9;Card card2 = new Card('S', 2);&#xA;&#x9;&#x9;cards.add(card2);&#xA;&#x9;&#x9;Card card3 = new Card('S', 3);&#xA;&#x9;&#x9;cards.add(card3);&#xA;&#x9;&#x9;Card card4 = new Card('C', 10);&#xA;&#x9;&#x9;cards.add(card4);&#xA;&#x9;&#x9;Card card5 = new Card('D', 2);&#xA;&#x9;&#x9;cards.add(card5);&#xA;&#x9;&#x9;Card card6 = new Card('D', 2);&#xA;&#x9;&#x9;cards.add(card6);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// cards.sort??&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + card1.compareTo(card2));&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + card2.compareTo(card3));&#xA;&#x9;&#x9;System.out.println(&quot;-1 &quot; + card5.compareTo(card4));&#xA;&#x9;&#x9;System.out.println(&quot;0 &quot; + card5.compareTo(card6));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator cardComp = new CardComparator(true, 'H');&#xA;&#x9;&#x9;Collections.sort(cards, CardComparator);&#xA;&#x9;&#x9;System.out.println(cards" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="93" end="-252"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2071" charEnd="2085" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="186" charEnd="196" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="787" charEnd="807" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375658598" sizeMeasure="121" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Card card : cards)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="2090" end="-250"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="186" charEnd="196" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="787" charEnd="807" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2071" charEnd="2085" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375784601" sizeMeasure="121" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="2069" end="-315"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="787" charEnd="807" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2059" charEnd="2063" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="186" charEnd="196" severity="1" problemCategory="130" problemType="16777788"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375852967" sizeMeasure="121" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Cards>" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="196" end="-2188"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="170" charEnd="174" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="794" charEnd="814" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2066" charEnd="2070" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2169" charEnd="2198" severity="2" problemCategory="50" problemType="67109424"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2169" charEnd="2198" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375871116" sizeMeasure="121" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="204" end="-2185"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="204" charEnd="214" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="791" charEnd="811" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2063" charEnd="2067" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2166" charEnd="2195" severity="2" problemCategory="50" problemType="67109424"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2166" charEnd="2195" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="170" charEnd="174" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375930002" sizeMeasure="121" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card>&#xA;{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public Card (char suit, int face)&#xA;&#x9;{&#xA;&#x9;&#x9;if (suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid suit.&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (face >= 1 &amp;&amp; face &lt;= 13)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid face.&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public char getSuit()&#xA;&#x9;{&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace()&#xA;&#x9;{&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString()&#xA;&#x9;{&#xA;&#x9;&#x9;return getSuit() + String.valueOf(face);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Character> suits = Arrays.asList('S', 'H', 'D', 'C'); // sortert i rekkefølge best-dårligst&#xA;&#x9;&#x9;if (this.getSuit() == card.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (this.face == card.face)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// Hvis face til this kommer før face til parameter i suits &#xA;&#x9;&#x9;if (suits.indexOf(this.getSuit()) &lt; suits.indexOf(card.getSuit()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1; // returnerer -1 hvis this kommer før parameter&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) &#xA;&#x9;{&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;Card card1 = new Card('H', 10);&#xA;&#x9;&#x9;cards.add(card1);&#xA;&#x9;&#x9;Card card2 = new Card('S', 2);&#xA;&#x9;&#x9;cards.add(card2);&#xA;&#x9;&#x9;Card card3 = new Card('S', 3);&#xA;&#x9;&#x9;cards.add(card3);&#xA;&#x9;&#x9;Card card4 = new Card('C', 10);&#xA;&#x9;&#x9;cards.add(card4);&#xA;&#x9;&#x9;Card card5 = new Card('D', 2);&#xA;&#x9;&#x9;cards.add(card5);&#xA;&#x9;&#x9;Card card6 = new Card('D', 2);&#xA;&#x9;&#x9;cards.add(card6);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// cards.sort??&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + card1.compareTo(card2));&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + card2.compareTo(card3));&#xA;&#x9;&#x9;System.out.println(&quot;-1 &quot; + card5.compareTo(card4));&#xA;&#x9;&#x9;System.out.println(&quot;0 &quot; + card5.compareTo(card6));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator cardComp = new CardComparator(true, 'H');&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;for (Card card : cards)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="204" end="-197"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="170" charEnd="174" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="204" charEnd="214" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="791" charEnd="811" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2063" charEnd="2067" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2166" charEnd="2191" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375935380" sizeMeasure="121" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="201" end="-2182"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="203" charEnd="213" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="790" charEnd="810" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2062" charEnd="2066" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376087852" sizeMeasure="121" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="201" end="-2154"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2138" charEnd="2163" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="170" charEnd="174" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="763" charEnd="783" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2035" charEnd="2039" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376097161" sizeMeasure="121" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Object" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="197" end="-2154"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="170" charEnd="174" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="764" charEnd="784" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2036" charEnd="2040" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2139" charEnd="2164" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376100777" sizeMeasure="121" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="197" end="-2154"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2034" charEnd="2038" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="762" charEnd="782" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376213038" sizeMeasure="121" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (Card card : cards)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;car" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="2022" end="-279"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="762" charEnd="782" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="101" charStart="2053" charEnd="2056" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="102" charStart="2066" charEnd="2067" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="102" charStart="2067" charEnd="2070" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376521336" sizeMeasure="126" errorCount="9">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Arrays.sort(cards, CardComparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator cardComp = new CardComparator(true, 'H');&#xA;&#x9;&#x9;for (Card card : cards)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;car&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Comparator&#xA;/*&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) &#xA;&#x9;{&#xA;&#x9;&#x9;if (o1 instanceof Cards &amp;&amp; o2 instanceof Cards)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return compare((Card) o1, (Card) o2);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Illegal argument.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;*/" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="1963" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="108" charStart="2144" charEnd="2154" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="108" charStart="2144" charEnd="2154" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="170" charEnd="174" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="762" charEnd="782" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="1982" charEnd="1996" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="103" charStart="2094" charEnd="2097" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="104" charStart="2107" charEnd="2108" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="104" charStart="2108" charEnd="2111" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="108" charStart="2144" charEnd="2154" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376618185" sizeMeasure="123" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardComparator cardComp = new CardComparator(true, 'H');&#xA;&#x9;&#x9;for (Card card : cards)&#xA;&#x9;&#x9;{" edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="1963" end="-306"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="170" charEnd="174" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="762" charEnd="782" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="105" charStart="2096" charEnd="2106" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="105" charStart="2096" charEnd="2106" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="105" charStart="2096" charEnd="2106" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376626321" sizeMeasure="121" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) &#xA;&#x9;{&#xA;&#x9;&#x9;if (o1 instanceof Cards &amp;&amp; o2 instanceof Cards)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return compare((Card) o1, (Card) o2);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Illegal argument.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="2088" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="1978" charEnd="1986" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="109" charStart="2162" charEnd="2167" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="109" charStart="2185" charEnd="2190" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="762" charEnd="782" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376634879" sizeMeasure="121" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; o2 instanceof Card" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="2166" end="-140"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="762" charEnd="782" severity="2" problemCategory="50" problemType="67109498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="1978" charEnd="1986" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376656797" sizeMeasure="121" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ble" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="193" end="-2132"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="1978" charEnd="1986" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="107" charStart="2112" charEnd="2137" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376665863" sizeMeasure="119" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="2088" end="-229"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="81" charEnd="102" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="1978" charEnd="1986" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376849225" sizeMeasure="119" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections.sort(cards);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + card1.compareTo(card2));&#xA;&#x9;&#x9;System.out.println(&quot;1 &quot; + card2.compareTo(card3));&#xA;&#x9;&#x9;System.out.println(&quot;-1 &quot; + card5.compareTo(card4));&#xA;&#x9;&#x9;System.out.println(&quot;0 &quot; + card5.compareTo(card6));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;CardComparator cardComp = new CardComparator(true, 'H');&#xA;&#x9;&#x9;for (Card card : cards)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="1726" end="-229"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="98" charStart="1987" charEnd="1995" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376858993" sizeMeasure="120" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println" edit="/1/@proposals.0/@proposals.0/@attempts.63/@edit" start="1753" end="-583"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2016" charEnd="2024" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376915267" sizeMeasure="120" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // bruker compareTo" edit="/1/@proposals.0/@proposals.0/@attempts.64/@edit" start="1750" end="-604"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="99" charStart="2036" charEnd="2044" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376925027" sizeMeasure="109" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.65/@edit" start="1801" end="-234"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377011563" sizeMeasure="111" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;System.out.println(compare(card1, card2));" edit="/1/@proposals.0/@proposals.0/@attempts.66/@edit" start="1801" end="-234"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="1824" charEnd="1831" severity="2" problemCategory="50" problemType="603979977"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377027382" sizeMeasure="111" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardComparator." edit="/1/@proposals.0/@proposals.0/@attempts.67/@edit" start="1824" end="-257"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="1824" charEnd="1860" severity="2" problemCategory="50" problemType="603979977"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377039897" sizeMeasure="111" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.68/@edit" start="1824" end="-257"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="1824" charEnd="1831" severity="2" problemCategory="50" problemType="603979977"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377075437" sizeMeasure="109" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.69/@edit" start="1801" end="-236"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377108661" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;compare(card1, card2);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public stat" edit="/1/@proposals.0/@proposals.0/@attempts.70/@edit" start="1801" end="-223"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377162069" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(compare(card1, card2)" edit="/1/@proposals.0/@proposals.0/@attempts.71/@edit" start="1805" end="-243"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377175966" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.72/@edit" start="2087" end="-2088"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377259189" sizeMeasure="111" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="compare(card1, card2" edit="/1/@proposals.0/@proposals.0/@attempts.73/@edit" start="1805" end="-243"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377288663" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (compare(card1, card2) == 1)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;System.out.println(&quot;hei&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.74/@edit" start="1805" end="-241"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377386834" sizeMeasure="113" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardComparator cardComp = new CardComparator(true, 'D');&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;publ" edit="/1/@proposals.0/@proposals.0/@attempts.75/@edit" start="1805" end="-223"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="1820" charEnd="1828" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377403344" sizeMeasure="113" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// hvordan skal jeg kalle cardComp uten å bruke cardComp??" edit="/1/@proposals.0/@proposals.0/@attempts.76/@edit" start="1864" end="-237"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="1820" charEnd="1828" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488377424355" sizeMeasure="113" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// static??" edit="/1/@proposals.0/@proposals.0/@attempts.77/@edit" start="1969" end="-190"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="1820" charEnd="1828" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378935272" sizeMeasure="113" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ollections.sort(cards, new CardComparator(true, 'D'));&#xA;&#x9;&#x9;System.out.println(cards);" edit="/1/@proposals.0/@proposals.0/@attempts.78/@edit" start="1806" end="-248"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378940888" sizeMeasure="113" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Collections.sort(cards); // bruker compareTo&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.0/@attempts.79/@edit" start="1726" end="-364"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378977088" sizeMeasure="113" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections.sort(cards); // bruker compareTo&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.80/@edit" start="1726" end="-364"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379009800" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*&#xA;&#x9;public int compare(Card o1, Card o2) // static??&#xA;&#x9;{&#xA;&#x9;&#x9;if (o1 instanceof Card &amp;&amp; o2 instanceof Card)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return compare((Card) o1, (Card) o2);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Illegal argument.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;*/" edit="/1/@proposals.0/@proposals.0/@attempts.81/@edit" start="1897" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379017647" sizeMeasure="99" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.82/@edit" start="1889" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="111" charEnd="131" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379032360" sizeMeasure="98">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.83/@edit" start="121" end="-1770"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297247474" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297292652" sizeMeasure="6" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card>&#xA;{&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="49" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="34" charEnd="48" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297322414" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>&#xA;{&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="21" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297349412" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public int compare(Card o1, Card o2) &#xA;&#x9;{&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="109" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297411991" sizeMeasure="14" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if ()" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="153" end="-22"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="156" charEnd="157" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297415614" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="153" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297850671" sizeMeasure="17" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;CardComparator('')&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="110" end="-67"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="127" charEnd="129" severity="2" problemCategory="20" problemType="1610612989"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="127" charEnd="129" severity="2" problemCategory="20" problemType="1610612989"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488297941084" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean greatest, char trumph)&#xA;&#x9;{&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="127" end="-69"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298284366" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="boolean greatest;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;CardComparator(boolean greatest, char trumph)&#xA;&#x9;{&#xA;&#x9;&#x9;this.greatest = greatest;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="110" end="-72"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298349708" sizeMeasure="22">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char trumph = 'S'; // utgangspunkt: spades høyeste kort" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="129" end="-152"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298360811" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.trumph = trumph" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="266" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298403270" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" = true" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="126" end="-234"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298420767" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="126" end="-234"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298453141" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // true: ess størst, false: ess minst" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="264" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298539829" sizeMeasure="27" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (trumph != null)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="305" end="-72"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="309" charEnd="323" severity="2" problemCategory="60" problemType="536871072"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298560924" sizeMeasure="27" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="431" end="-432"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="13" charStart="309" charEnd="323" severity="2" problemCategory="60" problemType="536871072"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298595159" sizeMeasure="27">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="' '" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="319" end="-109"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298749440" sizeMeasure="28">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="361" end="-75"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298766142" sizeMeasure="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="358" end="-72"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298821408" sizeMeasure="26" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public int compare(Card card1, Card card2) &#xA;&#x9;{&#xA;&#x9;&#x9;if ()" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="358" end="-22"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="415" charEnd="416" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298860723" sizeMeasure="29" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card1.getSuit() == card2.getSuit())&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (card1.getFace() == )&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="416" end="-22"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="23" charStart="459" charEnd="483" severity="2" problemCategory="20" problemType="1610612969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298885459" sizeMeasure="32">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card2.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="482" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298941280" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (card1.getFace() > card2.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="525" end="-26"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298952954" sizeMeasure="41">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="609" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299147926" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (card1.getFace() == trumph)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (card2.getFace() == trumph)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="612" end="-31"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299201052" sizeMeasure="59" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (card1.getFace() == )&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;/*&#xA;&#x9; * S: Spades&#xA;&#x9; * H: Hearts&#xA;&#x9; * D: Diamonds&#xA;&#x9; * C: Clover&#xA;&#x9; */" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="727" end="-7"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="747" charEnd="749" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299305722" sizeMeasure="59" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trumph != 'S' &amp;&amp; " edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="731" end="-120"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="764" charEnd="766" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488299351805" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// if (trumph != 'S' &amp;&amp; card1.getFace() == )&#xA;&#x9;&#x9;// spades kan både være testet som trumf og ikke&#xA;&#x9;&#x9;&#x9;// hjelpemetode?" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="727" end="-97"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371007401" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="727" end="-218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371109374" sizeMeasure="64" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Arrays;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>&#xA;{&#xA;&#x9;boolean greatest;&#xA;&#x9;List&lt;Character> suits; // utgangspunkt: spades høyeste kort&#xA;&#x9;&#xA;&#x9;CardComparator(boolean greatest, char trumph)&#xA;&#x9;{&#xA;&#x9;&#x9;this.greatest = greatest; // true: ess størst, false: ess minst&#xA;&#x9;&#x9;if (trumph != ' ')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;suits = Arrays.asList('S', 'H', 'D', 'C')" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="38" end="-594"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="708" charEnd="714" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="41" charStart="766" charEnd="772" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371180966" sizeMeasure="69" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;else if (trumph == 'S' || trumph == 'H' || trumph == 'D' || trumph == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;suits.remove(trumph);&#xA;&#x9;&#x9;&#x9;suits.add(0, trumph" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="431" end="-595"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="41" charStart="843" charEnd="849" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="901" charEnd="907" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371213463" sizeMeasure="73" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;else&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Trumph must be S, H, D, C or null.&quot;)" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="566" end="-593"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="935" charEnd="941" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="993" charEnd="999" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="26" charStart="651" charEnd="652" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371214654" sizeMeasure="73" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="652" end="-593"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="936" charEnd="942" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="994" charEnd="1000" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371311335" sizeMeasure="68">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suits.indexOf(card1.getSuit()) &lt; suits.indexOf(card2.getSuit()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="917" end="-228"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371335752" sizeMeasure="69" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="989" end="-224"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="58" charStart="1151" charEnd="1160" severity="2" problemCategory="60" problemType="536871073"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371347513" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="1017" end="-80"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371408385" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1017" end="-80"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371530419" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &amp;&amp; card2.getFace() != 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (suits.indexOf(card1.getSuit()) &lt; suits.indexOf(card2.getSuit()))&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="864" end="-80"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371569875" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="greatest" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="868" end="-254"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371648884" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="368" end="-761"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371784321" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suits = Arrays.asList('S', 'H', 'D', 'C');&#xA;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="357" end="-693"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371797075" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" if (trumph != ' ')" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="537" end="-559"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488371872327" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suits.indexOf(trumph)" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="493" end="-616"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372113456" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H' || trumph == 'D' || trumph == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;suits.remove(suits.indexOf(trumph));&#xA;&#x9;&#x9;&#x9;suits.add(0, trumph);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (trumph != ' ' &amp;&amp; trumph != 'S" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="418" end="-561"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372194874" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="1129" end="-1130"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372371390" sizeMeasure="59" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;import java.util.Arrays;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>&#xA;{&#xA;&#x9;boolean greatest;&#xA;&#x9;List&lt;Character> suits; // utgangspunkt: spades høyeste kort&#xA;&#x9;&#xA;&#x9;CardComparator(boolean greatest, char trumph)&#xA;&#x9;{&#xA;&#x9;&#x9;this.greatest = greatest; // true: ess størst, false: ess minst&#xA;&#x9;&#x9;suits = new ArrayList&lt;Character> " edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="43" end="-752"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="393" charEnd="438" severity="2" problemCategory="50" problemType="134217858"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372431462" sizeMeasure="63" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="();&#xA;&#x9;&#x9;suits.add('C');&#xA;&#x9;&#x9;suits.add('D');&#xA;&#x9;&#x9;suits.add('S');&#xA;&#x9;&#x9;suits.add('H')" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="417" end="-743"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="483" charEnd="486" severity="2" problemCategory="50" problemType="67108979"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="490" charEnd="491" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372439610" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H');&#xA;&#x9;&#x9;suits.add('S" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="470" end="-734"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="56" charEnd="72" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372447951" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="66" end="-1151"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372507575" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>&#xA;{&#xA;&#x9;boolean greatest;&#xA;&#x9;List&lt;Character> suits; // utgangspunkt: spades høyeste kort&#xA;&#x9;&#xA;&#x9;CardComparator(boolean greatest, char trumph)&#xA;&#x9;{&#xA;&#x9;&#x9;this.greatest = greatest; // true: ess størst, false: ess minst&#xA;&#x9;&#x9;suits = new ArrayList&lt;Character>();&#xA;&#x9;&#x9;suits.add('C');&#xA;&#x9;&#x9;suits.add('D');&#xA;&#x9;&#x9;suits.add('H');&#xA;&#x9;&#x9;suits.add('S'); // S er best, får indeks 0" edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="66" end="-731"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372523798" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trumph" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="571" end="-633"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372539335" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suits.indexOf(trumph)" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="571" end="-633"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372572584" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="=" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="991" end="-233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372598878" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="991" end="-233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372643676" sizeMeasure="66" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=")&#xA;&#x9;&#x9;&#x9;&#x9;if (greatest &amp;&amp; card2.getFace() == 1)&#xA;&#x9;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="959" end="-229"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1058" charEnd="1067" severity="2" problemCategory="60" problemType="536871073"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372666437" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;&#x9;if (greatest &amp;&amp; card2.getFace() == 1)&#xA;&#x9;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="964" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372779574" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // hvis card1 har høyere verdi enn card2" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="960" end="-298"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372794626" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // hvis card2 er ess og ess er høyest" edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="1048" end="-251"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372872098" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" || card1.getFace() == 1" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="959" end="-378"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372943133" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="1035" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372973282" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(card1.getFace() > card2.getFace() || card1.getFace() == 1) &amp;&amp; card2.getFace() != 1) // hvis card1 har høyere verdi enn card2&#xA;&#x9;&#x9;&#x9;{" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="926" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488372997627" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(greatest &amp;&amp; card1.getFace() == 1)) &amp;&amp; (greatest &amp;&amp; card2.getFace() != 1)" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="964" end="-271"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373020112" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&amp;&amp; (greatest &amp;&amp; card2.getFace() != 1))" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="1000" end="-229"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373073408" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="greatest &amp;&amp; card1.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if (greatest &amp;&amp; card2.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="926" end="-355"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373090831" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if ((card1.getFace() > card2.getFace(" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="1053" end="-231"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1091" charEnd="1092" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373097474" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="1057" end="-264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373219037" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // kortene er helt like&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (greatest &amp;&amp; card1.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (greatest &amp;&amp; card2.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if " edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="913" end="-264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373518569" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0, 'C');&#xA;&#x9;&#x9;suits.add(0, 'D');&#xA;&#x9;&#x9;suits.add(0, 'H');&#xA;&#x9;&#x9;suits.add(0, " edit="/1/@proposals.0/@proposals.1/@attempts.66/@edit" start="408" end="-897"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373541134" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="'C');&#xA;&#x9;&#x9;suits.add('D');&#xA;&#x9;&#x9;suits.add('H');&#xA;&#x9;&#x9;suits.add(" edit="/1/@proposals.0/@proposals.1/@attempts.67/@edit" start="408" end="-897"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373612811" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*&#xA;&#x9;&#x9;else if (trumph != ' ' &amp;&amp; trumph != 'S')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Trumph must be S, H, D, C or null.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;*/" edit="/1/@proposals.0/@proposals.1/@attempts.68/@edit" start="626" end="-607"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373623837" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;else if (trumph != ' ' &amp;&amp; trumph != 'S')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Trumph must be S, H, D, C or null.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.69/@edit" start="626" end="-607"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373723938" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (greatest &amp;&amp; card2.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (card1.getFace() > card2.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.1/@attempts.70/@edit" start="1011" end="-211"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373800224" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.1/@attempts.71/@edit" start="1266" end="-81"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373842568" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Returnerer -1 hvis card1 skal før card2" edit="/1/@proposals.0/@proposals.1/@attempts.72/@edit" start="1266" end="-76"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488373954423" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // hvis sortering må skje på tall" edit="/1/@proposals.0/@proposals.1/@attempts.73/@edit" start="853" end="-557"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374259768" sizeMeasure="75">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;suits.add(0, 'S'); // S er best, får indeks 0&#xA;&#x9;&#x9;suits.add(1, 'H');&#xA;&#x9;&#x9;suits.add(2, 'D');&#xA;&#x9;&#x9;suits.add(3, 'C');" edit="/1/@proposals.0/@proposals.1/@attempts.74/@edit" start="398" end="-950"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374285456" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suits.add('C');&#xA;&#x9;&#x9;suits.add('D');&#xA;&#x9;&#x9;suits.add('H');&#xA;&#x9;&#x9;suits.add('S'); // S er best, får indeks 0" edit="/1/@proposals.0/@proposals.1/@attempts.75/@edit" start="398" end="-950"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374419514" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="'D'));&#xA;&#x9;&#x9;&#x9;suits.add(0, 'D'" edit="/1/@proposals.0/@proposals.1/@attempts.76/@edit" start="585" end="-827"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374443198" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trumph));&#xA;&#x9;&#x9;&#x9;suits.add(0, trumph" edit="/1/@proposals.0/@proposals.1/@attempts.77/@edit" start="585" end="-827"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374467688" sizeMeasure="74" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.78/@edit" start="509" end="-933"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="502" charEnd="529" severity="2" problemCategory="60" problemType="536871072"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="509" charEnd="512" severity="2" problemCategory="20" problemType="1610612968"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374476102" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="==" edit="/1/@proposals.0/@proposals.1/@attempts.79/@edit" start="509" end="-933"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374787781" sizeMeasure="84" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Arrays;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>&#xA;{&#xA;&#x9;boolean greatest;&#xA;&#x9;List&lt;Character> suits; // utgangspunkt: spades høyeste kort&#xA;&#x9;char trumph;&#xA;&#x9;&#xA;&#x9;CardComparator(boolean greatest, char trumph)&#xA;&#x9;{&#xA;&#x9;&#x9;this.greatest = greatest; // true: ess størst, false: ess minst&#xA;&#x9;&#x9;suits = Arrays.asList('S', 'H', 'D', 'C');&#xA;&#x9;&#x9;/*&#xA;&#x9;&#x9;suits = new ArrayList&lt;Character>();&#xA;&#x9;&#x9;suits.add('C');&#xA;&#x9;&#x9;suits.add('D');&#xA;&#x9;&#x9;suits.add('H');&#xA;&#x9;&#x9;suits.add('S'); // S er best, får indeks 0&#xA;&#x9;&#x9;*/&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;/*&#xA;&#xA;&#x9;&#x9;if (trumph == 'H' || trumph == 'D' || trumph == 'C')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;suits.remove(suits.indexOf(trumph));&#xA;&#x9;&#x9;&#x9;suits.add(0, trumph);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else if (trumph != ' ' &amp;&amp; trumph != 'S')&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException (&quot;Trumph must be S, H, D, C or null.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;*/&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card card1, Card card2) &#xA;&#x9;{&#xA;&#x9;&#x9;if (card1.getSuit() == card2.getSuit()) // hvis sortering må skje på tall&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (card1.getFace() == card2.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0; // kortene er helt like&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (greatest &amp;&amp; card1.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (greatest &amp;&amp; card2.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (card1.getFace() > card2.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//if (suits.indexOf(card1.getSuit()) &lt; suits.indexOf(card2.getSuit()))&#xA;&#x9;&#x9;if (" edit="/1/@proposals.0/@proposals.1/@attempts.80/@edit" start="66" end="-160"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="67" charStart="1425" charEnd="1426" severity="2" problemCategory="20" problemType="1610612967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374838562" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suits.indexOf(card1.getSuit()) &lt; suits.indexOf(card2.getSuit()) || card1.getSuit() == this.trumph" edit="/1/@proposals.0/@proposals.1/@attempts.81/@edit" start="1426" end="-160"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374961368" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.82/@edit" start="1539" end="-143"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374964298" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.83/@edit" start="1555" end="-127"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375038497" sizeMeasure="60">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>&#xA;{&#xA;&#x9;boolean greatest;&#xA;&#x9;List&lt;Character> suits; // utgangspunkt: spades høyeste kort&#xA;&#x9;char trumph;&#xA;&#x9;&#xA;&#x9;CardComparator(boolean greatest, char trumph)&#xA;&#x9;{&#xA;&#x9;&#x9;this.greatest = greatest; // true: ess størst, false: ess minst&#xA;&#x9;&#x9;suits = Arrays.asList('S', 'H', 'D', 'C');&#xA;&#x9;&#x9;this.trumph = trumph;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int compare(Card card1, Card card2) &#xA;&#x9;{&#xA;&#x9;&#x9;if (card1.getSuit() == card2.getSuit()) // hvis sortering må skje på tall&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;if (card1.getFace() == card2.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 0; // kortene er helt like&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (greatest &amp;&amp; card1.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (greatest &amp;&amp; card2.getFace() == 1)&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (card1.getFace() > card2.getFace())&#xA;&#x9;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (suits.indexOf(card1.getSuit()) &lt; suits.indexOf(card2.getSuit()) || card1.getSuit() == this.trumph)&#xA;&#x9;&#x9;{&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return -1;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;// Returnerer -1 hvis card1 skal før card2 - men er det noe feil i testkoden??" edit="/1/@proposals.0/@proposals.1/@attempts.84/@edit" start="43" end="-76"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488370279772" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488370306061" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488370330053" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488370452740" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488370492820" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488370617905" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488370659935" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488370954816" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488376891973" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488377164097" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488377289802" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488377409365" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488378943420" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488378978124" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488379010900" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488379020739" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488379033929" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488299025777" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488371363590" completion="0.0" failureCount="1" errorCount="2">
          <failureTests>testDiamondIsTrumph</failureTests>
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488371582582" completion="0.0" failureCount="1" errorCount="2">
          <failureTests>testDiamondIsTrumph</failureTests>
          <errorTests>testAceIsHighest</errorTests>
          <errorTests>testNormal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488371657768" completion="0.0" failureCount="2" errorCount="1">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testNormal</failureTests>
          <errorTests>testDiamondIsTrumph</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488371803844" completion="0.0" failureCount="2" errorCount="1">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testNormal</failureTests>
          <errorTests>testDiamondIsTrumph</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488371879733" completion="0.0" failureCount="2" errorCount="1">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testNormal</failureTests>
          <errorTests>testDiamondIsTrumph</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488372130204" completion="0.0" failureCount="2" errorCount="1">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testNormal</failureTests>
          <errorTests>testDiamondIsTrumph</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488372455075" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488372532705" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
          <errorTests>testDiamondIsTrumph</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488372545003" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488372704357" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488372880223" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488373004919" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testNormal</successTests>
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488373107210" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488373523974" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488373619415" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488373739068" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testAceIsHighest</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488373805686" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488373847947" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testAceIsHighest</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488374064763" completion="0.0" failureCount="1">
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488374078249" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testAceIsHighest</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488374269998" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488374295451" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testAceIsHighest</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488374426140" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testAceIsHighest</successTests>
          <successTests>testNormal</successTests>
          <failureTests>testDiamondIsTrumph</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488374845226" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488374970513" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a" performedCount="1">
        <attempts timestamp="1488373332704"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="3">
        <attempts timestamp="1488373341533"/>
        <attempts timestamp="1488373342881"/>
        <attempts timestamp="1488373344428"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="2">
        <attempts timestamp="1488373350629"/>
        <attempts timestamp="1488375067056"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
