<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739271708" sizeMeasure="50">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;final String lovlig = &quot;ADCS&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidType (char suit){&#xA;&#x9;&#x9;if ((suit=='D') || (suit =='H') || (suit =='C') || (suit == 'S')){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidFace(int face){&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (String.valueOf(getSuit())+ getFace());&#xA;&#x9;}&#xA;&#xA;}&#xA; &#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739307482" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="772" end="-773"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739329858" sizeMeasure="50" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="39" end="-735"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739358858" sizeMeasure="51" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import Comparable" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="20" end="-777"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739379945" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class Card implements Comparable {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;final String lovlig = &quot;ADCS&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidType (char suit){&#xA;&#x9;&#x9;if ((suit=='D') || (suit =='H') || (suit =='C') || (suit == 'S')){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidFace(int face){&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (String.valueOf(getSuit())+ getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Object arg0) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="20" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739393059" sizeMeasure="55" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="59" end="-836"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739408203" sizeMeasure="61" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;@Override&#xA;&#x9;public int compareTo(Card o" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="896" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739423156" sizeMeasure="55">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="828" end="-107"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739438592" sizeMeasure="55" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card o) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="828" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739475675" sizeMeasure="57" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="840" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739718341" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nt aFace = this.getFace();&#xA;&#x9;&#x9;int bFace = this.getFace();&#xA;&#x9;&#x9;if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;if(){&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="841" end="-17"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739743062" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" aFace &lt; bFace ? aFace : bFace" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="941" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739817365" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nt val = aFace &lt; bFace ? aFace : bFace;&#xA;&#x9;&#x9;if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;if(" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="901" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739853265" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="val == aFace" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="984" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488740149401" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return -1;" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1003" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488740305463" sizeMeasure="66" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else if (aFace == bFace){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return " edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1018" end="-24"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488740330933" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//HVis det er samme type&#xA;&#x9;&#x9;if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;if(val == aFace){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (aFace == bFace){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="943" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488740340544" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="v" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="952" end="-192"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488740731906" sizeMeasure="73" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.getFace() == 'S' &amp;&amp; o.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1132" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488740807415" sizeMeasure="79" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Hvis a er spar, og b ikke er spar&#xA;&#x9;&#x9;else if (this.getFace() == 'S' &amp;&amp; o.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er spar og a ikke er spar&#xA;&#x9;&#x9;else if (o.getFace() == 'S' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1132" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488740810068" sizeMeasure="79" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 1;" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1340" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488742771888" sizeMeasure="84" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Hvis a er hjerte&#xA;&#x9;&#x9;else if(this.getFace() == 'H' &amp;&amp; o.getFace() != 'S' ){&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="1359" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488799810999" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 1;" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1448" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488800044266" sizeMeasure="84" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1448" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488800117233" sizeMeasure="88" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" og b ikke er spar&#xA;&#x9;&#x9;else if(this.getFace() == 'H' &amp;&amp; o.getFace() != 'S' ){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else if(o.getFace() = 'H' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="1377" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488800138561" sizeMeasure="88" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="1497" end="-65"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488800388408" sizeMeasure="89" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;int aFace = this.getFace();&#xA;&#x9;&#x9;int bFace = this.getFace();&#xA;&#x9;&#x9;int val = aFace &lt; bFace ? aFace : bFace;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis det er samme type&#xA;&#x9;&#x9;if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;if(val == aFace){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (aFace == bFace){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er spar, og b ikke er spar&#xA;&#x9;&#x9;else if (this.getFace() == 'S' &amp;&amp; o.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er spar og a ikke er spar&#xA;&#x9;&#x9;else if (o.getFace() == 'S' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er hjerte og b ikke er spar&#xA;&#x9;&#x9;else if(this.getFace() == 'H' &amp;&amp; o.getFace() != 'S' ){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//b er hjerte og a ikke er spar" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="840" end="-89"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488800730347" sizeMeasure="58" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="948" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801296588" sizeMeasure="92" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;//Hvis det er samme type&#xA;&#x9;&#x9;if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;if(val == aFace){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (aFace == bFace){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er spar, og b ikke er spar&#xA;&#x9;&#x9;else if (this.getFace() == 'S' &amp;&amp; o.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er spar og a ikke er spar&#xA;&#x9;&#x9;else if (o.getFace() == 'S' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er hjerte og b ikke er spar&#xA;&#x9;&#x9;else if(this.getFace() == 'H' &amp;&amp; o.getFace() != 'S' ){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//b er hjerte og a ikke er spar&#xA;&#x9;&#x9;else if(o.getFace() == 'H' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis a er ruter og b ikke er spar eller hjerte&#xA;&#x9;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="948" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801499022" sizeMeasure="100" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if(this.getFace() == 'C' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis b er ruter og a ikke er spar eller hjerte&#xA;&#x9;&#x9;&#x9;&#x9;else if(o.getFace() == 'C' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1638" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801531203" sizeMeasure="100" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if(o.getFace() == 'C' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1791" end="-22"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801537049" sizeMeasure="102" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1900" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801771535" sizeMeasure="110" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis b er ruter og a ikke er spar eller hjerte&#xA;&#x9;&#x9;else if(o.getFace() == 'D' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er kløver og b ikke er spar, hjerte eller ruter&#xA;&#x9;&#x9;else if(this.getFace() == 'C' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H' || o.getFace() != 'D')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if(o.getFace() == 'C' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H' || this.getFace() != 'D')){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1665" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801812501" sizeMeasure="111" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Hvis b er kløver og a ikke er spar, hjerte eller ruter" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="2074" end="-150"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801818019" sizeMeasure="106" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="2257" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801900938" sizeMeasure="112" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="2257" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801978945" sizeMeasure="113" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="2310" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488801984799" sizeMeasure="116" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;import java.util.ArrayList;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="20" end="-2350"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802028678" sizeMeasure="117" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 5);" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="2389" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802088799" sizeMeasure="125" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;Card kort3 = new Card('C', 3);&#xA;&#x9;&#x9;Card kort4 = new  Card('H', 12);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort3);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="2454" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802150949" sizeMeasure="127" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Collections;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;final String lovlig = &quot;ADCS&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidType (char suit){&#xA;&#x9;&#x9;if ((suit=='D') || (suit =='H') || (suit =='C') || (suit == 'S')){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidFace(int face){&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (String.valueOf(getSuit())+ getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int aFace = this.getFace();&#xA;&#x9;&#x9;int bFace = this.getFace();&#xA;&#x9;&#x9;int val = aFace &lt; bFace ? aFace : bFace;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis det er samme type&#xA;&#x9;&#x9;if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;if(val == aFace){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (aFace == bFace){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er spar, og b ikke er spar&#xA;&#x9;&#x9;else if (this.getFace() == 'S' &amp;&amp; o.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er spar og a ikke er spar&#xA;&#x9;&#x9;else if (o.getFace() == 'S' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er hjerte og b ikke er spar&#xA;&#x9;&#x9;else if(this.getFace() == 'H' &amp;&amp; o.getFace() != 'S' ){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//b er hjerte og a ikke er spar&#xA;&#x9;&#x9;else if(o.getFace() == 'H' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis a er ruter og b ikke er spar eller hjerte&#xA;&#x9;&#x9;else if(this.getFace() == 'D' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis b er ruter og a ikke er spar eller hjerte&#xA;&#x9;&#x9;else if(o.getFace() == 'D' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er kløver og b ikke er spar, hjerte eller ruter&#xA;&#x9;&#x9;else if(this.getFace() == 'C' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H' || o.getFace() != 'D')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er kløver og a ikke er spar, hjerte eller ruter&#xA;&#x9;&#x9;else if(o.getFace() == 'C' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H' || this.getFace() != 'D')){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 5);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 3);&#xA;&#x9;&#x9;Card kort4 = new  Card('H', 12);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort3);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(kortstokk);" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="49" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802182144" sizeMeasure="129" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(kortstokk)" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="2685" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802202623" sizeMeasure="129" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="2689" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802270074" sizeMeasure="129" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="2655" end="-44"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802279768" sizeMeasure="129" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="2655" end="-44"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802322676" sizeMeasure="130">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Hvis det er samme type&#xA;&#x9;&#x9;if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;if(val == aFace){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (aFace == bFace){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er spar, og b ikke er spar&#xA;&#x9;&#x9;else if (this.getFace() == 'S' &amp;&amp; o.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er spar og a ikke er spar&#xA;&#x9;&#x9;else if (o.getFace() == 'S' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er hjerte og b ikke er spar&#xA;&#x9;&#x9;else if(this.getFace() == 'H' &amp;&amp; o.getFace() != 'S' ){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//b er hjerte og a ikke er spar&#xA;&#x9;&#x9;else if(o.getFace() == 'H' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis a er ruter og b ikke er spar eller hjerte&#xA;&#x9;&#x9;else if(this.getFace() == 'D' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis b er ruter og a ikke er spar eller hjerte&#xA;&#x9;&#x9;else if(o.getFace() == 'D' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er kløver og b ikke er spar, hjerte eller ruter&#xA;&#x9;&#x9;else if(this.getFace() == 'C' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H' || o.getFace() != 'D')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er kløver og a ikke er spar, hjerte eller ruter&#xA;&#x9;&#x9;else if(o.getFace() == 'C' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H' || this.getFace() != 'D')){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return 0" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="1009" end="-389"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802341386" sizeMeasure="131">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(String.valueOf(kortstokk)" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="2707" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802390477" sizeMeasure="132" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 12);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="2500" end="-220"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802398480" sizeMeasure="133">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kortstokk.add(kort5" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="2707" end="-101"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802439949" sizeMeasure="133">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="2534" end="-292"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802454799" sizeMeasure="134" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card kort6 = new Card('D', 5" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="2608" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802464195" sizeMeasure="135">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kortstokk.add(kort6" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="2764" end="-101"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802491007" sizeMeasure="136">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="6);&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort3);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="2662" end="-99"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802583627" sizeMeasure="136">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="2885" end="-2886"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802588729" sizeMeasure="136" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.53/@edit" start="2793" end="-93"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802599226" sizeMeasure="136">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.54/@edit" start="2793" end="-93"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802631500" sizeMeasure="136" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", Comparable" edit="/1/@proposals.0/@proposals.0/@attempts.55/@edit" start="2819" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802654396" sizeMeasure="136">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.56/@edit" start="2819" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802734455" sizeMeasure="136" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", new Comparator&lt;Card>" edit="/1/@proposals.0/@proposals.0/@attempts.57/@edit" start="2819" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802765743" sizeMeasure="137" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;final String lovlig = &quot;ADCS&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidType (char suit){&#xA;&#x9;&#x9;if ((suit=='D') || (suit =='H') || (suit =='C') || (suit == 'S')){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidFace(int face){&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (String.valueOf(getSuit())+ getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int aFace = this.getFace();&#xA;&#x9;&#x9;int bFace = this.getFace();&#xA;&#x9;&#x9;int val = aFace &lt; bFace ? aFace : bFace;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis det er samme type&#xA;&#x9;&#x9;if(this.getSuit() == o.getSuit()){&#xA;&#x9;&#x9;&#x9;if(val == aFace){&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (aFace == bFace){&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er spar, og b ikke er spar&#xA;&#x9;&#x9;else if (this.getFace() == 'S' &amp;&amp; o.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er spar og a ikke er spar&#xA;&#x9;&#x9;else if (o.getFace() == 'S' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er hjerte og b ikke er spar&#xA;&#x9;&#x9;else if(this.getFace() == 'H' &amp;&amp; o.getFace() != 'S' ){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//b er hjerte og a ikke er spar&#xA;&#x9;&#x9;else if(o.getFace() == 'H' &amp;&amp; this.getFace() != 'S'){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis a er ruter og b ikke er spar eller hjerte&#xA;&#x9;&#x9;else if(this.getFace() == 'D' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;///Hvis b er ruter og a ikke er spar eller hjerte&#xA;&#x9;&#x9;else if(o.getFace() == 'D' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Hvis a er kløver og b ikke er spar, hjerte eller ruter&#xA;&#x9;&#x9;else if(this.getFace() == 'C' &amp;&amp; (o.getFace() != 'S' || o.getFace() != 'H' || o.getFace() != 'D')){&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//Hvis b er kløver og a ikke er spar, hjerte eller ruter&#xA;&#x9;&#x9;else if(o.getFace() == 'C' &amp;&amp; (this.getFace() != 'S' || this.getFace() != 'H' || this.getFace() != 'D')){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 11);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5 = new  Card('H', 12);&#xA;&#x9;&#x9;Card kort6 = new Card('D', 5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort6);&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort3);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;Collections.sort(kortstokk, new Comparator&lt;Card>()" edit="/1/@proposals.0/@proposals.0/@attempts.58/@edit" start="79" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802786218" sizeMeasure="137" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.59/@edit" start="2848" end="-67"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802889278" sizeMeasure="135" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(kort6.compareTo(kort5" edit="/1/@proposals.0/@proposals.0/@attempts.60/@edit" start="2819" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802909990" sizeMeasure="133" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.61/@edit" start="2342" end="-513"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802936462" sizeMeasure="135" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.62/@edit" start="2342" end="-513"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802960752" sizeMeasure="135" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.0/@attempts.63/@edit" start="2843" end="-35"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802975242" sizeMeasure="133" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.64/@edit" start="2342" end="-513"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488802982595" sizeMeasure="132" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.65/@edit" start="2344" end="-510"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803026630" sizeMeasure="132" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 11);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5 = new  Card('H', 12);&#xA;&#x9;&#x9;Card kort6 = new Card('D', 5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort6);&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort3);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;&#xA;&#x9;&#x9;System.out.println(kort2.compareTo(kort3" edit="/1/@proposals.0/@proposals.0/@attempts.66/@edit" start="2344" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803040777" sizeMeasure="134" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else {&#xA;&#x9;&#x9;&#x9;return 11111;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.67/@edit" start="2342" end="-510"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803067967" sizeMeasure="134" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="6" edit="/1/@proposals.0/@proposals.0/@attempts.68/@edit" start="2859" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803176063" sizeMeasure="97" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.69/@edit" start="1221" end="-510"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803205193" sizeMeasure="113" errorCount="7">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//hvis det er samme sort&#xA;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == card.getSuit()){&#xA;&#x9;&#x9;&#x9;&#x9;//sjekker om hvem som har høyest tall&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getFace() == card.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort a er S og kort b ikke er S&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'S' &amp;&amp; card.getSuit() != 'S'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'H' &amp;&amp; (card.getSuit() != 'S' || card.getSuit() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'D' &amp;&amp; card.getSuit() == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.70/@edit" start="932" end="-513"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803211944" sizeMeasure="113" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card" edit="/1/@proposals.0/@proposals.0/@attempts.71/@edit" start="922" end="-1292"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803239257" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;Collections.sort(kortstokk);" edit="/1/@proposals.0/@proposals.0/@attempts.72/@edit" start="2156" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803246807" sizeMeasure="114" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String.valueOf(kortstok" edit="/1/@proposals.0/@proposals.0/@attempts.73/@edit" start="2210" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803250362" sizeMeasure="114" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.74/@edit" start="2233" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803450620" sizeMeasure="115" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort3);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;&#x9;kortstokk.add(kort6" edit="/1/@proposals.0/@proposals.0/@attempts.75/@edit" start="2013" end="-101"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803465224" sizeMeasure="116" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;&#x9;kortstokk.add(kort6);&#xA;&#x9;&#x9;kortstokk.add(kort3" edit="/1/@proposals.0/@proposals.0/@attempts.76/@edit" start="2062" end="-101"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803484910" sizeMeasure="116" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.77/@edit" start="2256" end="-2257"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803775932" sizeMeasure="118" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;System.out.println(String.valueOf(kortstokk));" edit="/1/@proposals.0/@proposals.0/@attempts.78/@edit" start="2164" end="-96"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488803983313" sizeMeasure="117" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.79/@edit" start="2298" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804085691" sizeMeasure="117" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.80/@edit" start="2298" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804150325" sizeMeasure="119" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/*if (this.getSuit() == 'S' &amp;&amp; card.getSuit() != 'S'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'H' &amp;&amp; (card.getSuit() != 'S' || card.getSuit() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'D' &amp;&amp; card.getSuit() == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;*/&#xA;&#x9;&#x9;&#x9;&#x9;return 4;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 11);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5 = new  Card('H', 12);&#xA;&#x9;&#x9;Card kort6 = new Card('D', 5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;&#x9;kortstokk.add(kort6);&#xA;&#x9;&#x9;kortstokk.add(kort3);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(kortstokk));&#xA;&#x9;&#x9;Collections.sort(kortstokk);&#xA;&#x9;&#x9;System.out.println(String.valueOf(kortstokk));" edit="/1/@proposals.0/@proposals.0/@attempts.81/@edit" start="1278" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804165381" sizeMeasure="117" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (this.getSuit() == 'S' &amp;&amp; card.getSuit() != 'S'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'H' &amp;&amp; (card.getSuit() != 'S' || card.getSuit() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'D' &amp;&amp; card.getSuit() == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.82/@edit" start="1278" end="-601"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804378404" sizeMeasure="116" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.83/@edit" start="160" end="-2148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804605216" sizeMeasure="118" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private char suit;&#xA;&#x9;private int face;&#xA;&#x9;final String lovlig = &quot;ADCS&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidType (char suit){&#xA;&#x9;&#x9;if ((suit=='D') || (suit =='H') || (suit =='C') || (suit == 'S')){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidFace(int face){&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (String.valueOf(getSuit())+ getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//hvis det er samme sort&#xA;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == card.getSuit()){&#xA;&#x9;&#x9;&#x9;&#x9;//sjekker om hvem som har høyest tall&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getFace() == card.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort a er S og kort b ikke er S&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'S' &amp;&amp; card.getSuit() != 'S'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (card.getFace() == 'S' &amp;&amp; this.getFace() != 'S')" edit="/1/@proposals.0/@proposals.0/@attempts.84/@edit" start="160" end="-953"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804610720" sizeMeasure="120" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="{&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.85/@edit" start="1414" end="-953"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804627467" sizeMeasure="124" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (o.getSuit() == 'H' &amp;&amp; (this.getSuit() != 'S' || this" edit="/1/@proposals.0/@proposals.0/@attempts.86/@edit" start="1632" end="-815"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804637711" sizeMeasure="125" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.87/@edit" start="1872" end="-637"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804646682" sizeMeasure="125" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card" edit="/1/@proposals.0/@proposals.0/@attempts.88/@edit" start="1636" end="-872"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488804893826" sizeMeasure="124" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.89/@edit" start="1911" end="-599"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805152106" sizeMeasure="123" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.90/@edit" start="2266" end="-244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488805989975" sizeMeasure="123" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Suit() == 'S' &amp;&amp; this.getSuit() != 'S'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'H' &amp;&amp; (card.getSuit() != 'S' || card.getSuit() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (card.getSuit() == 'H' &amp;&amp; (this.getSuit() != 'S' || this.getSuit() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'D' &amp;&amp; card.getSuit() == 'C'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 11);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5 = new  Card('H', 12);&#xA;&#x9;&#x9;Card kort6 = new Card('D', 5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);" edit="/1/@proposals.0/@proposals.0/@attempts.91/@edit" start="1375" end="-244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806005068" sizeMeasure="119" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'H' &amp;&amp; (card.getSuit() != 'S' || card.getSuit() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.92/@edit" start="1362" end="-775"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809184266" sizeMeasure="117" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.93/@edit" start="1355" end="-965"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809188982" sizeMeasure="115" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'H' &amp;&amp; (card.getSuit() != 'S' || card.getSuit() != 'H')){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.94/@edit" start="1355" end="-771"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809298439" sizeMeasure="115" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S', 6" edit="/1/@proposals.0/@proposals.0/@attempts.95/@edit" start="1963" end="-333"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809308981" sizeMeasure="115" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H" edit="/1/@proposals.0/@proposals.0/@attempts.96/@edit" start="1963" end="-337"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809330556" sizeMeasure="115" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.97/@edit" start="1479" end="-798"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810524090" sizeMeasure="116" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort a er S og kort b ikke er S&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'S' &amp;&amp; card.getSuit() != 'S'){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == 'H' &amp;&amp; (card.getSuit() != 'S" edit="/1/@proposals.0/@proposals.0/@attempts.98/@edit" start="1217" end="-798"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810943920" sizeMeasure="116" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char [] liste = new char[4];" edit="/1/@proposals.0/@proposals.0/@attempts.99/@edit" start="930" end="-1351"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811189497" sizeMeasure="117" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="liste[0] = 'S'" edit="/1/@proposals.0/@proposals.0/@attempts.100/@edit" start="961" end="-1352"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811236105" sizeMeasure="120" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="liste[1] = 'H';&#xA;&#x9;&#x9;liste[2] = 'D';&#xA;&#x9;&#x9;liste[3] = 'C" edit="/1/@proposals.0/@proposals.0/@attempts.101/@edit" start="979" end="-1353"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811251624" sizeMeasure="120" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="liste[0]" edit="/1/@proposals.0/@proposals.0/@attempts.102/@edit" start="1403" end="-975"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811256564" sizeMeasure="120" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="liste[0]" edit="/1/@proposals.0/@proposals.0/@attempts.103/@edit" start="1433" end="-950"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811279143" sizeMeasure="120" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="liste[1] &amp;&amp; (card.getSuit() != liste[0]" edit="/1/@proposals.0/@proposals.0/@attempts.104/@edit" start="1565" end="-797"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811306340" sizeMeasure="120" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="liste[2] &amp;&amp; card.getSuit() == liste[3]" edit="/1/@proposals.0/@proposals.0/@attempts.105/@edit" start="1709" end="-664"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811797032" sizeMeasure="119" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.106/@edit" start="2119" end="-295"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811879210" sizeMeasure="120" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="char [] liste = new char[4]{&#xA;&#x9;liste[0] = 'S';&#xA;&#x9;liste[1] = 'H';&#xA;&#x9;liste[2] = 'D';&#xA;&#x9;liste[3] = 'C';&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidType (char suit){&#xA;&#x9;&#x9;if ((suit=='D') || (suit =='H') || (suit =='C') || (suit == 'S')){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidFace(int face){&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (String.valueOf(getSuit())+ getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//hvis det er samme sort&#xA;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == card.getSuit()){&#xA;&#x9;&#x9;&#x9;&#x9;//sjekker om hvem som har høyest tall&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getFace() == card.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort a er S og kort b ikke er S&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == liste[0] &amp;&amp; card.getSuit() != liste[0]){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == liste[1] &amp;&amp; (card.getSuit() != liste[0])){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == liste[2] &amp;&amp; card.getSuit() == liste[3]){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 11);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5 = new  Card('H', 6);&#xA;&#x9;&#x9;Card kort6 = new Card('D', 5);" edit="/1/@proposals.0/@proposals.0/@attempts.107/@edit" start="199" end="-295"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811900242" sizeMeasure="116" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.108/@edit" start="199" end="-2080"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811930377" sizeMeasure="117" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Card> liste = new ArrayList&lt;>();" edit="/1/@proposals.0/@proposals.0/@attempts.109/@edit" start="201" end="-2082"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811956651" sizeMeasure="117" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="haracter" edit="/1/@proposals.0/@proposals.0/@attempts.110/@edit" start="212" end="-2110"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811967346" sizeMeasure="117" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.111/@edit" start="2329" end="-2330"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811982458" sizeMeasure="116" errorCount="6" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="();" edit="/1/@proposals.0/@proposals.0/@attempts.112/@edit" start="243" end="-2080"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488811994546" sizeMeasure="116" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;>" edit="/1/@proposals.0/@proposals.0/@attempts.113/@edit" start="243" end="-2083"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812004749" sizeMeasure="117" errorCount="10">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="liste.add(&quot;H&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.114/@edit" start="250" end="-2082"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812013634" sizeMeasure="116" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.115/@edit" start="250" end="-2082"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812018876" sizeMeasure="116" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.116/@edit" start="250" end="-2082"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812139860" sizeMeasure="118" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private char [] liste = new char[4];&#xA;&#x9;&#xA;&#x9;ArrayList&lt;Character> liste = new ArrayList&lt;>(" edit="/1/@proposals.0/@proposals.0/@attempts.117/@edit" start="201" end="-2082"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812148307" sizeMeasure="118" errorCount="6" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="s" edit="/1/@proposals.0/@proposals.0/@attempts.118/@edit" start="221" end="-2146"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812168475" sizeMeasure="119" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="lists[0] = 'S'" edit="/1/@proposals.0/@proposals.0/@attempts.119/@edit" start="239" end="-2132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812180088" sizeMeasure="116" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.120/@edit" start="201" end="-2132"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812236130" sizeMeasure="120" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Character> liste = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.121/@edit" start="201" end="-1889"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812266414" sizeMeasure="122" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="liste.add('D');&#xA;&#x9;&#x9;liste.add('C" edit="/1/@proposals.0/@proposals.0/@attempts.122/@edit" start="481" end="-1897"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812356841" sizeMeasure="122" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".get(0)" edit="/1/@proposals.0/@proposals.0/@attempts.123/@edit" start="1408" end="-997"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812362673" sizeMeasure="122" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".get(0)" edit="/1/@proposals.0/@proposals.0/@attempts.124/@edit" start="1442" end="-967"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812368329" sizeMeasure="122" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".get(1)" edit="/1/@proposals.0/@proposals.0/@attempts.125/@edit" start="1578" end="-835"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812418446" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".get(0))){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == liste.get(2) &amp;&amp; card.getSuit() == liste.get(3)" edit="/1/@proposals.0/@proposals.0/@attempts.126/@edit" start="1613" end="-661"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812438992" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + String.valueOf(liste" edit="/1/@proposals.0/@proposals.0/@attempts.127/@edit" start="975" end="-1458"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812459526" sizeMeasure="123" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(kort4.toString());" edit="/1/@proposals.0/@proposals.0/@attempts.128/@edit" start="2314" end="-145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812476566" sizeMeasure="121" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.129/@edit" start="2333" end="-147"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812526454" sizeMeasure="123" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.130/@edit" start="2312" end="-145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812532394" sizeMeasure="123" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.131/@edit" start="976" end="-1458"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488812549805" sizeMeasure="121" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.132/@edit" start="2289" end="-145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881414409" sizeMeasure="121" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", char trumf){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidType (char suit){&#xA;&#x9;&#x9;if ((suit=='D') || (suit =='H') || (suit =='C') || (suit == 'S')){&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isValidFace(int face){&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13){&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString(){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return (String.valueOf(getSuit())+ getFace() );&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//hvis det er samme sort&#xA;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == card.getSuit()){&#xA;&#x9;&#x9;&#x9;&#x9;//sjekker om hvem som har høyest tall&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getFace() == card.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort a er S og kort b ikke er S&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == liste.get(0) &amp;&amp; card.getSuit() != liste.get(0)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == liste.get(1) &amp;&amp; (card.getSuit() != liste.get(0))){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (this.getSuit() == liste.get(2) &amp;&amp; card.getSuit() == liste.get(3)){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 11);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5 = new  Card('H', 6);&#xA;&#x9;&#x9;Card kort6 = new Card('D', 5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;&#x9;kortstokk.add(kort6);&#xA;&#x9;&#x9;kortstokk.add(kort3);" edit="/1/@proposals.0/@proposals.0/@attempts.133/@edit" start="283" end="-145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881436668" sizeMeasure="121" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.134/@edit" start="2441" end="-2442"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881454326" sizeMeasure="124" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(trumf == 'S'){&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.135/@edit" start="457" end="-1916"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881488907" sizeMeasure="124" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="H'){&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('S" edit="/1/@proposals.0/@proposals.0/@attempts.136/@edit" start="470" end="-1964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881547058" sizeMeasure="134" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else if (trumf == 'D'){&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if ( trumf == 'C'){&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D" edit="/1/@proposals.0/@proposals.0/@attempts.137/@edit" start="554" end="-1926"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881562483" sizeMeasure="134" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.138/@edit" start="2681" end="-2682"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881566617" sizeMeasure="139" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C" edit="/1/@proposals.0/@proposals.0/@attempts.139/@edit" start="763" end="-1926"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881624708" sizeMeasure="153" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face){&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(isValidFace(face) &amp;&amp; isValidType(suit)){&#xA;&#x9;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;&#x9;this.face = face;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Error&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.140/@edit" start="852" end="-1906"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809871665" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488809878533" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="51" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810022838" sizeMeasure="6" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparator&lt;Card> {&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="49" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810029129" sizeMeasure="8" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="21" end="-68"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810040775" sizeMeasure="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card arg0, Card arg1) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="109" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810071393" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return arg0.compareTo(arg1)" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="167" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810083632" sizeMeasure="11">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="199" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810093766" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card arg0, Card arg1) {&#xA;&#x9;&#x9;return arg0.compareTo(arg1);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="111" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488810186614" sizeMeasure="17">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" public CardComparator(Boolean ess, char trumf) {&#xA;&#x9;&#x9;// TODO Auto-generated constructor stub&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="113" end="-97"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488881637687" sizeMeasure="17">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="165" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882507156" sizeMeasure="17" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="230" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882665762" sizeMeasure="20" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private boolean ess;&#xA;&#x9;private char trumf;&#xA;&#x9;&#xA;&#x9; public CardComparator(Boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="111" end="-72"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882726454" sizeMeasure="21" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#xA;&#x9;private boolean ess;&#xA;&#x9;private char trumf;&#xA;&#x9;&#xA;&#x9; public CardComparator(Boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card arg0, Card arg1) {&#xA;&#x9;&#x9;ArrayList&lt;Character> liste = new ArrayList&lt;>();" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="38" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882758117" sizeMeasure="23" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;liste.add(trumf);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="387" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882770935" sizeMeasure="22" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="388" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882797225" sizeMeasure="42" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(trumf == 'H'){&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if (trumf == 'D'){&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if ( trumf == 'C'){&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="388" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882817536" sizeMeasure="44" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="783" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882860523" sizeMeasure="42" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="783" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882893323" sizeMeasure="44" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;//Logikk for trumfkort&#xA;&#x9;&#x9;ArrayList&lt;Character> liste = new ArrayList&lt;>();&#xA;&#x9;&#x9;if(trumf == 'H'){&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if (trumf == 'D'){&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if ( trumf == 'C'){&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="338" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882912247" sizeMeasure="47" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="811" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882948124" sizeMeasure="67" errorCount="6" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;//Logikk for typesortering&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (this.getSuit() == liste.get(0) &amp;&amp; card.getSuit() != liste.get(0)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;if (this.getSuit() == liste.get(1) &amp;&amp; (card.getSuit() != liste.get(0))){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;if (this.getSuit() == liste.get(2) &amp;&amp; card.getSuit() == liste.get(3)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="820" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882995906" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kort1, Card kort2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Logikk for trumfkort&#xA;&#x9;&#x9;ArrayList&lt;Character> liste = new ArrayList&lt;>();&#xA;&#x9;&#x9;if(trumf == 'H'){&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if (trumf == 'D'){&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if ( trumf == 'C'){&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Logikk for typesortering&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(0) &amp;&amp; kort2.getSuit() != liste.get(0)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(1) &amp;&amp; (kort2.getSuit() != liste.get(0))){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(2) &amp;&amp; kort2" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="317" end="-85"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882998920" sizeMeasure="67" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="1280" end="-1281"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883065392" sizeMeasure="76" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Logikk hvis ess skal være høyest :&#xA;&#x9;&#x9;if(kort1.getFace() == kort2.getSuit()){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="820" end="-470"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883148347" sizeMeasure="80">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(ess == true){&#xA;&#x9;&#x9;&#x9;&#x9;if(kort1.getFace() == 1 &amp;&amp; kort2.getFace() != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="902" end="-483"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883199352" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="993" end="-494"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883213998" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (kort1.getFace() == kort2.getFace())" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="999" end="-501"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883246724" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 0;" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="1045" end="-494"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883280703" sizeMeasure="84">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else if (kort1.getFace() > kort2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="1060" end="-495"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883288490" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="1126" end="-496"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883306950" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Suit" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="871" end="-768"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883353394" sizeMeasure="95" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" else {&#xA;&#x9;&#x9;&#x9;&#x9;if (this.getFace() == card.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;if (this.getFace() > card.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="1160" end="-488"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883368866" sizeMeasure="95" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kort1.getFace() == kort2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;if (kort1.getFace() > kort2" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="1176" end="-549"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883405921" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="1334" end="-488"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883412150" sizeMeasure="96">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="1330" end="-488"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883428715" sizeMeasure="100">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#x9;if(ess == true){&#xA;&#x9;&#x9;&#x9;&#x9;if(kort1.getFace() == 1 &amp;&amp; kort2.getFace() != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (kort1.getFace() == kort2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (kort1.getFace() > kort2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;} &#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;//Hvis ess ikke er sann&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="902" end="-659"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883432567" sizeMeasure="100">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="høyest" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="1192" end="-663"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883450425" sizeMeasure="105">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="1858" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883465872" sizeMeasure="118">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 11);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5 = new  Card('H', 6);&#xA;&#x9;&#x9;Card kort6 = new Card('D', 5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;&#x9;kortstokk.add(kort6);&#xA;&#x9;&#x9;kortstokk.add(kort3);" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="1906" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883482281" sizeMeasure="120">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(kortstokk)" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="2301" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883509928" sizeMeasure="122" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="llections;&#xA;import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card> {&#xA;&#xA;&#x9;private boolean ess;&#xA;&#x9;private char trumf;&#xA;&#x9;&#xA;&#x9; public CardComparator(Boolean ess, char trumf) {&#xA;&#x9;&#x9;this.ess = ess;&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card kort1, Card kort2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Logikk for trumfkort&#xA;&#x9;&#x9;ArrayList&lt;Character> liste = new ArrayList&lt;>();&#xA;&#x9;&#x9;if(trumf == 'H'){&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if (trumf == 'D'){&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;} else if ( trumf == 'C'){&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;liste.add('S');&#xA;&#x9;&#x9;&#x9;liste.add('H');&#xA;&#x9;&#x9;&#x9;liste.add('D');&#xA;&#x9;&#x9;&#x9;liste.add('C');&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Logikk hvis ess skal være høyest :&#xA;&#x9;&#x9;if(kort1.getSuit() == kort2.getSuit()){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(ess == true){&#xA;&#x9;&#x9;&#x9;&#x9;if(kort1.getFace() == 1 &amp;&amp; kort2.getFace() != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (kort1.getFace() == kort2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (kort1.getFace() > kort2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;} &#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;//Hvis ess ikke er høyest&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (kort1.getFace() == kort2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;if (kort1.getFace() > kort2.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//Logikk for typesortering&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(0) &amp;&amp; kort2.getSuit() != liste.get(0)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(1) &amp;&amp; (kort2.getSuit() != liste.get(0))){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(2) &amp;&amp; kort2.getSuit() == liste.get(3)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;ArrayList&lt;Card> kortstokk = new ArrayList&lt;>();&#xA;&#x9;&#x9;Card kort1 = new Card('S', 2);&#xA;&#x9;&#x9;Card kort2 = new Card('C', 9);&#xA;&#x9;&#x9;Card kort3 = new Card('C', 11);&#xA;&#x9;&#x9;Card kort4 = new Card('C', 2);&#xA;&#x9;&#x9;Card kort5 = new  Card('H', 6);&#xA;&#x9;&#x9;Card kort6 = new Card('D', 5);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;kortstokk.add(kort1);&#xA;&#x9;&#x9;kortstokk.add(kort2);&#xA;&#x9;&#x9;kortstokk.add(kort4);&#xA;&#x9;&#x9;kortstokk.add(kort5);&#xA;&#x9;&#x9;kortstokk.add(kort6);&#xA;&#x9;&#x9;kortstokk.add(kort3);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(String.valueOf(kortstokk));&#xA;&#x9;&#x9;Collections.sort(kortstokk, new CardComparator(" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="68" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883523795" sizeMeasure="122" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="kort1, kort2" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="2431" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883537795" sizeMeasure="122" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="2384" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883976364" sizeMeasure="125" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(kort2.getFace() == 1 &amp;&amp; kort1.getFace() != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="1035" end="-1363"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884153181" sizeMeasure="115" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return kort1.getFace() - kort2.getFace();&#xA;&#x9;&#x9;&#x9;} &#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;//Hvis ess ikke er høyest&#xA;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;if (kort1.getFace() == kort2.getFace()){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;if (kort1.getFace() > kort2.getFace()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="1109" end="-961"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884200023" sizeMeasure="106" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#x9;&#x9;return kort1.getFace() - kort2.getFace();&#xA;&#x9;&#x9;&#x9; &#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;//Hvis ess ikke er høyest&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="1108" end="-969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884213990" sizeMeasure="102" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="1157" end="-969"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884306286" sizeMeasure="102" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;&#xA;&#xA;&#x9;&#x9;//Logikk for typesortering&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(0) &amp;&amp; kort2.getSuit() != liste.get(0)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er Hjerter og kort 2 ikke er spar eller hjerter&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(1) &amp;&amp; (kort2.getSuit() != liste.get(0))){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;if (kort1.getSuit() == liste.get(2) &amp;&amp; kort2.getSuit() == liste.get(3)){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else if(kort1.getSuit() == kort2.getSuit()){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(ess == true){&#xA;&#x9;&#x9;&#x9;&#x9;if(kort1.getFace() == 1 &amp;&amp; kort2.getFace() != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if(kort2.getFace() == 1 &amp;&amp; kort1.getFace() != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return kort1.getFace() - kort2.getFace()" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="889" end="-545"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884320407" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;else if " edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="1315" end="-807"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884341416" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else if (kort1.getSuit() == liste.get(1) &amp;&amp; (kort2.getSuit() != liste.get(0))){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;else " edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="1085" end="-908"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884354391" sizeMeasure="103" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (kort1.getSuit() == liste.get(1) &amp;&amp; (kort2.getSuit() != liste.get(0))){&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;//hvis kort 1 er ruter og kort 2 er kløver&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="1085" end="-908"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884493261" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nt i = (liste.indexOf(kort1.getSuit())-liste.indexOf(kort2.getSuit()));&#xA;&#x9;&#x9; &#xA;&#x9;&#x9;if (i ==0){&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if(ess == true){&#xA;&#x9;&#x9;&#x9;&#x9;if(kort1.getFace() == 1 &amp;&amp; kort2.getFace() != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;&#x9;} else if(kort2.getFace() == 1 &amp;&amp; kort1.getFace() != 1){&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;return kort1.getFace() - kort2.getFace();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;return i" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="929" end="-515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884503833" sizeMeasure="92" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="936" end="-851"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884546056" sizeMeasure="91" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="1004" end="-783"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884556101" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;&#xA;&#x9;&#x9;int i = -(liste.indexOf(kort1.getSuit())-liste.indexOf(kort2.getSuit()));" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="844" end="-783"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802185986" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802201852" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802272884" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802286658" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802329340" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802344654" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802358548" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802406657" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802431209" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802467583" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802494557" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802592820" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802602272" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802893195" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802908916" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802939364" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488802964224" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803030035" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803043717" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803070852" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803216494" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803253707" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803358996" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803454647" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803468667" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488803779712" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488804155276" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488804543591" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488804640163" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488804650806" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488804660656" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488805996039" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488808493667" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488809300731" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488809343223" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488809400955" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488811362270" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488812462663" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488812536544" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488812563964" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488881636759" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488883485673" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488883553869" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488883980271" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488884033108" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488884157109" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488884201980" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488884310328" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488884323010" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488884344722" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488884495237" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488884505237" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
