<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488279151361" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488279155215" sizeMeasure="65" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="encapsulation;&#xA;&#xA;import encapsulation.Card;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;}&#xA;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="8" end="-2"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="1" charStart="8" charEnd="21" severity="2" problemCategory="60" problemType="536871240"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="31" charEnd="49" severity="2" problemCategory="30" problemType="268435841"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488279171042" sizeMeasure="65">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="interfaces;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="8" end="-1148"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302708905" sizeMeasure="84" errorCount="11" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import encapsulation.Card;&#xA;import grensesnitt.Pet;&#xA;import grensesnitt.PetComparator;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;for(Pet pet: pets){&#xA;&#x9;&#x9;&#x9;&#x9;System.out.println(pet);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card en = new Card('S', 3);&#xA;&#x9;&#x9;Card to = new Card('C', 8);&#xA;&#x9;&#x9;Card tre = new Card('S', 3);&#xA;&#x9;&#x9;Card fire = new Card('D', 6);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="21" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="46" severity="2" problemCategory="30" problemType="268435841"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="55" charEnd="66" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="79" charEnd="90" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1255" charEnd="1259" severity="2" problemCategory="60" problemType="536870966"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1260" charEnd="1293" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1260" charEnd="1293" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1294" charEnd="1295" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1294" charEnd="1295" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="67" charStart="1359" charEnd="1363" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="69" charStart="1388" charEnd="1391" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="69" charStart="1397" charEnd="1401" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1494" charEnd="1496" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1524" charEnd="1526" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="77" charStart="1554" charEnd="1557" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1585" charEnd="1589" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302734846" sizeMeasure="84" errorCount="10" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card pet: card" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1388" end="-226"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="46" severity="2" problemCategory="30" problemType="268435841"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="55" charEnd="66" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="79" charEnd="90" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1255" charEnd="1259" severity="2" problemCategory="60" problemType="536870966"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1260" charEnd="1293" severity="2" problemCategory="20" problemType="1610612967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1260" charEnd="1293" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1294" charEnd="1295" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1294" charEnd="1295" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="67" charStart="1359" charEnd="1363" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="69" charStart="1398" charEnd="1403" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1496" charEnd="1498" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1526" charEnd="1528" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="77" charStart="1556" charEnd="1559" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1587" charEnd="1591" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302850174" sizeMeasure="87" errorCount="4" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;import grensesnitt.Pet;&#xA;import grensesnitt.PetComparator;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card pet: cards){&#xA;&#x9;&#x9;&#x9;System.out.println(pet);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="21" end="-182"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1467" charEnd="1469" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="79" charStart="1497" charEnd="1499" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1527" charEnd="1530" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="81" charStart="1558" charEnd="1562" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="29" charEnd="40" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="53" charEnd="64" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1336" charEnd="1340" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1373" charEnd="1378" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302858017" sizeMeasure="86" errorCount="2" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="22" end="-1520"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1316" charEnd="1321" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="77" charStart="1410" charEnd="1412" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1440" charEnd="1442" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="79" charStart="1470" charEnd="1473" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1501" charEnd="1505" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="69" charStart="1279" charEnd="1283" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302859505" sizeMeasure="84" errorCount="2" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="22" end="-1521"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1499" charEnd="1503" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="67" charStart="1277" charEnd="1281" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="69" charStart="1314" charEnd="1319" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1408" charEnd="1410" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1438" charEnd="1440" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="77" charStart="1468" charEnd="1471" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302875937" sizeMeasure="84" errorCount="2" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: cards){&#xA;&#x9;&#x9;&#x9;System.out.println(card" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="22" end="-193"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="67" charStart="1277" charEnd="1281" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="69" charStart="1315" charEnd="1320" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1410" charEnd="1412" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="76" charStart="1440" charEnd="1442" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="77" charStart="1470" charEnd="1473" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="78" charStart="1501" charEnd="1505" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302930718" sizeMeasure="88" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;import grensesnitt.Pet;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: cards){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card en = new Card('S', 3);&#xA;&#x9;&#x9;Card to = new Card('C', 8);&#xA;&#x9;&#x9;Card tre = new Card('S', 3);&#xA;&#x9;&#x9;Card fire = new Card('D', 6);&#xA;&#x9;&#x9;private List&lt;Card> cards = new ArrayList&lt;Card>();" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="21" end="-14"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1623" charEnd="1628" severity="2" problemCategory="50" problemType="67109220"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="80" charEnd="91" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1353" charEnd="1357" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1391" charEnd="1396" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302945507" sizeMeasure="89" errorCount="2" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: cards){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card en = new Card('S', 3);&#xA;&#x9;&#x9;Card to = new Card('C', 8);&#xA;&#x9;&#x9;Card tre = new Card('S', 3);&#xA;&#x9;&#x9;Card fire = new Card('D', 6);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="187" end="-14"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="80" charEnd="91" severity="2" problemCategory="30" problemType="268435846"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1404" charEnd="1408" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1537" charEnd="1539" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="81" charStart="1567" charEnd="1569" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="82" charStart="1597" charEnd="1600" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1628" charEnd="1632" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488302951830" sizeMeasure="89" errorCount="1" warningCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="73" end="-1573"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1381" charEnd="1385" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1514" charEnd="1516" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="81" charStart="1544" charEnd="1546" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="82" charStart="1574" charEnd="1577" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1605" charEnd="1609" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303004962" sizeMeasure="90" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="final private List&lt;Card> cards = new ArrayList&lt;Card>();" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="1509" end="-140"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1381" charEnd="1385" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1534" charEnd="1539" severity="2" problemCategory="50" problemType="67109220"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303026845" sizeMeasure="90" errorCount="2" warningCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: cards){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="164" end="-181"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1471" charEnd="1476" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="81" charStart="1509" charEnd="1511" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="82" charStart="1539" charEnd="1541" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="83" charStart="1569" charEnd="1572" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="84" charStart="1600" charEnd="1604" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1332" charEnd="1336" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303054092" sizeMeasure="93" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards.add(en);&#xA;&#x9;&#x9;cards.add(to);&#xA;&#x9;&#x9;cards.add(tre);&#xA;&#x9;&#x9;cards.add(fire);" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1630" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1332" charEnd="1336" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303082876" sizeMeasure="94" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards.printAndSortPetsByComparatorClass(" edit="/1/@proposals.0/@proposals.0/@attempts.14/@edit" start="1701" end="-13"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1707" charEnd="1740" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1332" charEnd="1336" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303106312" sizeMeasure="94" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="stat" edit="/1/@proposals.0/@proposals.0/@attempts.15/@edit" start="1230" end="-527"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1339" charEnd="1343" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1377" charEnd="1382" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1714" charEnd="1747" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303231271" sizeMeasure="94" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nCards){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: nCards){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;Card en = new Card('S', 3);&#xA;&#x9;&#x9;Card to = new Card('C', 8);&#xA;&#x9;&#x9;Card tre = new Card('S', 3);&#xA;&#x9;&#x9;Card fire = new Card('D', 6);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(en);&#xA;&#x9;&#x9;cards.add(to);&#xA;&#x9;&#x9;cards.add(tre);&#xA;&#x9;&#x9;cards.add(fire);&#xA;&#x9;&#x9;cards.printAndSortPetsByComparatorClass(cards" edit="/1/@proposals.0/@proposals.0/@attempts.16/@edit" start="1276" end="-13"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1721" charEnd="1754" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1276" charEnd="1282" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303244451" sizeMeasure="94" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List " edit="/1/@proposals.0/@proposals.0/@attempts.17/@edit" start="1276" end="-497"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1276" charEnd="1280" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1350" charEnd="1354" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1388" charEnd="1394" severity="2" problemCategory="40" problemType="16777796"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1726" charEnd="1759" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303250920" sizeMeasure="94" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Array" edit="/1/@proposals.0/@proposals.0/@attempts.18/@edit" start="1276" end="-502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1276" charEnd="1285" severity="1" problemCategory="130" problemType="16777788"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1355" charEnd="1359" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1393" charEnd="1399" severity="2" problemCategory="40" problemType="16777796"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1731" charEnd="1764" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303261587" sizeMeasure="94" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card" edit="/1/@proposals.0/@proposals.0/@attempts.19/@edit" start="1276" end="-498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1388" charEnd="1394" severity="2" problemCategory="60" problemType="536871493"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1726" charEnd="1759" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1350" charEnd="1354" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303274055" sizeMeasure="94" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.20/@edit" start="1276" end="-497"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1276" charEnd="1282" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1721" charEnd="1754" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303277394" sizeMeasure="94" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.21/@edit" start="1276" end="-491"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1377" charEnd="1383" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1715" charEnd="1748" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1339" charEnd="1343" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303288437" sizeMeasure="94" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.22/@edit" start="1230" end="-533"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1332" charEnd="1336" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1370" charEnd="1376" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1708" charEnd="1741" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303308744" sizeMeasure="94" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: nCards){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.23/@edit" start="164" end="-258"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1373" charEnd="1377" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1411" charEnd="1417" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="1631" charEnd="1636" severity="2" problemCategory="50" problemType="33554506"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="87" charStart="1648" charEnd="1653" severity="2" problemCategory="50" problemType="33554506"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="88" charStart="1665" charEnd="1670" severity="2" problemCategory="50" problemType="33554506"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="89" charStart="1683" charEnd="1688" severity="2" problemCategory="50" problemType="33554506"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1702" charEnd="1707" severity="2" problemCategory="50" problemType="33554506"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1742" charEnd="1747" severity="2" problemCategory="50" problemType="33554506"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303322908" sizeMeasure="94" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: nCards){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();" edit="/1/@proposals.0/@proposals.0/@attempts.24/@edit" start="164" end="-258"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="90" charStart="1708" charEnd="1741" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1332" charEnd="1336" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1370" charEnd="1376" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303444204" sizeMeasure="98" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.List;&#xA;&#xA;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: nCards){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;Card en = new Card('S', 3);&#xA;&#x9;&#x9;Card to = new Card('C', 8);&#xA;&#x9;&#x9;Card tre = new Card('S', 3);&#xA;&#x9;&#x9;Card fire = new Card('D', 6);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(en);&#xA;&#x9;&#x9;cards.add(to);&#xA;&#x9;&#x9;cards.add(tre);&#xA;&#x9;&#x9;cards.add(fire);&#xA;&#x9;&#x9;Collections.sort(cards);&#xA;&#x9;&#x9;//cards.printAndSortPetsByComparatorClass(cards);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.25/@edit" start="66" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1362" charEnd="1366" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1400" charEnd="1406" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303456650" sizeMeasure="98" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(cards);" edit="/1/@proposals.0/@proposals.0/@attempts.26/@edit" start="1811" end="-14"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1362" charEnd="1366" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1400" charEnd="1406" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303473014" sizeMeasure="98" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="4" edit="/1/@proposals.0/@proposals.0/@attempts.27/@edit" start="1559" end="-291"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1362" charEnd="1366" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1400" charEnd="1406" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303571679" sizeMeasure="98" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;Card en = new Card('S', 4);&#xA;&#x9;&#x9;Card to = new Card('C', 8);&#xA;&#x9;&#x9;Card tre = new Card('S', 3);&#xA;&#x9;&#x9;Card fire = new Card('D', 6);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(en);&#xA;&#x9;&#x9;cards.add(to);&#xA;&#x9;&#x9;cards.add(tre);&#xA;&#x9;&#x9;cards.add(fire);&#xA;&#x9;&#x9;// Collections.sort(cards);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.28/@edit" start="1400" end="-90"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1362" charEnd="1366" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1400" charEnd="1405" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1767" charEnd="1800" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303590972" sizeMeasure="98" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Card> nCard" edit="/1/@proposals.0/@proposals.0/@attempts.29/@edit" start="1299" end="-552"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1383" charEnd="1387" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1421" charEnd="1426" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1788" charEnd="1821" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303600204" sizeMeasure="98" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nCard" edit="/1/@proposals.0/@proposals.0/@attempts.30/@edit" start="1421" end="-446"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1383" charEnd="1387" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1788" charEnd="1821" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303623342" sizeMeasure="98" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.31/@edit" start="1299" end="-568"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1378" charEnd="1382" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1783" charEnd="1816" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303689641" sizeMeasure="97" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.32/@edit" start="49" end="-1766"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1247" charEnd="1251" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1326" charEnd="1330" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1454" charEnd="1458" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303702343" sizeMeasure="97" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;Card.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: nCard){&#xA;&#x9;&#x9;&#x9;System.out.println(card);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;List&lt;Card> cards = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;Card en = new Card('S', 4);&#xA;&#x9;&#x9;Card to = new Card('C', 8);&#xA;&#x9;&#x9;Card tre = new Card('S', 3);&#xA;&#x9;&#x9;Card fire = new Card('D', 6);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;cards.add(en);&#xA;&#x9;&#x9;cards.add(to);&#xA;&#x9;&#x9;cards.add(tre);&#xA;&#x9;&#x9;cards.add(fire);&#xA;&#x9;&#x9;// Collections.sort(cards);&#xA;&#x9;&#x9;cards.printAndSortPetsByComparatorClass(" edit="/1/@proposals.0/@proposals.0/@attempts.33/@edit" start="1247" end="-45"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1310" charEnd="1314" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1348" charEnd="1353" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1438" charEnd="1442" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303749807" sizeMeasure="97" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="cards.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card card: cards" edit="/1/@proposals.0/@proposals.0/@attempts.34/@edit" start="1305" end="-441"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1439" charEnd="1443" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1305" charEnd="1310" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1349" charEnd="1354" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303781169" sizeMeasure="97" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="il: cards){&#xA;&#x9;&#x9;&#x9;System.out.println(il" edit="/1/@proposals.0/@proposals.0/@attempts.35/@edit" start="1343" end="-412"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1305" charEnd="1310" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1347" charEnd="1352" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="80" charStart="1435" charEnd="1439" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303865692" sizeMeasure="97" errorCount="14">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;Card en = new Card('S', 4);&#xA;&#x9;&#x9;Card to = new Card('C', 8);&#xA;&#x9;&#x9;Card tre = new Card('S', 3);&#xA;&#x9;&#x9;Card fire = new Card('D', 6);&#xA;&#x9;&#x9;new List&lt;Card> cards = new ArraList&lt;Card>;" edit="/1/@proposals.0/@proposals.0/@attempts.36/@edit" start="1435" end="-189"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="89" charStart="1658" charEnd="1663" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="91" charStart="1707" charEnd="1712" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1771" charEnd="1776" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1305" charEnd="1310" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1347" charEnd="1352" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1565" charEnd="1569" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1574" charEnd="1575" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1574" charEnd="1575" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1576" charEnd="1581" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1588" charEnd="1596" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1601" charEnd="1602" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="1606" charEnd="1611" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="87" charStart="1623" charEnd="1628" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="88" charStart="1640" charEnd="1645" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303872554" sizeMeasure="97" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.37/@edit" start="1561" end="-227"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="72" charStart="1305" charEnd="1310" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="74" charStart="1347" charEnd="1352" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1561" charEnd="1565" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1584" charEnd="1592" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="85" charStart="1597" charEnd="1598" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303881616" sizeMeasure="98" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util." edit="/1/@proposals.0/@proposals.0/@attempts.38/@edit" start="49" end="-1745"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="1607" charEnd="1615" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="1620" charEnd="1621" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1732" charEnd="1765" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1328" charEnd="1333" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303886531" sizeMeasure="98" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="y" edit="/1/@proposals.0/@proposals.0/@attempts.39/@edit" start="1611" end="-200"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1328" charEnd="1333" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="1621" charEnd="1622" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1733" charEnd="1766" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303899971" sizeMeasure="98" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.40/@edit" start="1811" end="-1812"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1733" charEnd="1766" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1328" charEnd="1333" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="86" charStart="1621" charEnd="1622" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488303914755" sizeMeasure="98" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="()" edit="/1/@proposals.0/@proposals.0/@attempts.41/@edit" start="1622" end="-190"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1328" charEnd="1333" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="92" charStart="1735" charEnd="1768" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488317833704" sizeMeasure="82" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.42/@edit" start="1415" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1328" charEnd="1333" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318075582" sizeMeasure="82" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardDeck nCards){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;nCards.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card il: nC" edit="/1/@proposals.0/@proposals.0/@attempts.43/@edit" start="1270" end="-49"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1270" charEnd="1278" severity="2" problemCategory="40" problemType="16777218"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318081464" sizeMeasure="84" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import encapsulation.CardDeck" edit="/1/@proposals.0/@proposals.0/@attempts.44/@edit" start="73" end="-1367"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="77" charStart="1418" charEnd="1424" severity="2" problemCategory="60" problemType="536871493"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1382" charEnd="1386" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318101959" sizeMeasure="82" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%c%d&quot;, getSuit(), getFace());&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card o) {&#xA;&#x9;&#x9;String value = &quot;CDHS&quot;;&#xA;&#x9;&#x9;int i = value.indexOf(o.suit);&#xA;&#x9;&#x9;int j = value.indexOf(this.suit);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (i &lt; j) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (i > j) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (o.face &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (o.face > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#xA;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void printAndSortPetsByComparatorClass(){&#xA;&#x9;&#x9;CardComparator comparator = new CardComparator(); &#xA;&#x9;&#x9;cards.sort(comparator);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Card il: c" edit="/1/@proposals.0/@proposals.0/@attempts.45/@edit" start="73" end="-49"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="73" charStart="1328" charEnd="1333" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="75" charStart="1370" charEnd="1375" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318438882" sizeMeasure="75" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.46/@edit" start="1224" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="56" charEnd="70" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488318443578" sizeMeasure="74">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.47/@edit" start="21" end="-1162"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319557866" sizeMeasure="86" errorCount="5" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private String owner;&#xA;&#x9;&#xA;&#x9;public void setOwner(CardDeck nOwner) {&#xA;&#x9;&#x9;if (this.owner == nOwner) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;if (this.owner != null) {&#xA;&#x9;&#x9;&#x9;this.owner.addCard(this)&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private boolean isValidCard(char tSuit,int tFace) {&#xA;&#x9;&#x9;if (tSuit == 'C' || tSuit == 'D' || tSuit == 'H' || tSuit == 'S') {&#xA;&#x9;&#x9;&#x9;if (tFace > 0 &amp;&amp; tFace &lt; 14) {&#xA;&#x9;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card(char nSuit, int nFace) {&#xA;&#x9;&#x9;if (isValidCard(nSuit, nFace)) {&#xA;&#x9;&#x9;&#x9;this.suit = nSuit;&#xA;&#x9;&#x9;&#x9;this.face = nFace;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Type kort skal være en bokstav, du skrev&quot; + nSuit  + &quot;.Verdi må være 1-13, du skrev&quot; +  nFace);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public setOwner()" edit="/1/@proposals.0/@proposals.0/@attempts.48/@edit" start="115" end="-461"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="15" charStart="186" charEnd="206" severity="2" problemCategory="40" problemType="16777231"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="227" charEnd="245" severity="1" problemCategory="90" problemType="536871090"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="289" charEnd="296" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="301" charEnd="302" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="927" charEnd="937" severity="2" problemCategory="40" problemType="16777327"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="936" charEnd="937" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319569126" sizeMeasure="86" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CardDeck" edit="/1/@proposals.0/@proposals.0/@attempts.49/@edit" start="123" end="-1269"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="303" charEnd="304" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="929" charEnd="939" severity="2" problemCategory="40" problemType="16777327"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="938" charEnd="939" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="229" charEnd="247" severity="1" problemCategory="90" problemType="536871090"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319572478" sizeMeasure="86" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";" edit="/1/@proposals.0/@proposals.0/@attempts.50/@edit" start="304" end="-1096"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="18" charStart="229" charEnd="247" severity="1" problemCategory="90" problemType="536871090"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="930" charEnd="940" severity="2" problemCategory="40" problemType="16777327"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="939" charEnd="940" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319595541" sizeMeasure="86" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="nO" edit="/1/@proposals.0/@proposals.0/@attempts.51/@edit" start="242" end="-1158"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="940" charEnd="941" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="931" charEnd="941" severity="2" problemCategory="40" problemType="16777327"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488319613837" sizeMeasure="86">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.52/@edit" start="924" end="-461"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298679654" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298730820" sizeMeasure="17" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator {&#xA;&#x9;&#xA;&#xA;&#x9;public class CardComparator implements Comparator&lt;Card>{&#xA;&#xA;&#x9;&#x9;@Override&#xA;&#x9;&#x9;public int compare(Card o1, Dog o2) {&#xA;&#x9;&#x9;&#x9;return o1.getName().compareTo(o2.getName());&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-3"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="17" charStart="255" charEnd="256" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="98" charEnd="112" severity="2" problemCategory="40" problemType="16777534"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298773267" sizeMeasure="15" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="51" end="-173"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="66" charEnd="80" severity="2" problemCategory="50" problemType="67109264"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="153" charEnd="156" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="176" charEnd="183" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298803946" sizeMeasure="15" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Card" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="153" end="-70"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="177" charEnd="184" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="200" charEnd="207" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488298828761" sizeMeasure="15">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="compareTo(o2" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="177" end="-18"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488303461537" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488303474446" mode="run"/>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
