<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488882969253" sizeMeasure="40" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable{&#xA;&#x9;&#xA;&#x9;//Variables &#xA;&#x9;private char cardcolour;&#xA;&#x9;private int cardnr;&#xA;&#x9;&#xA;&#x9;//Constructor &#xA;&#x9;public Card(char cardcolour, int cardnr) {&#xA;&#x9;&#x9;if ((cardcolour == 'S' || cardcolour == 'H' || cardcolour == 'D' &#xA;&#x9;&#x9;&#x9;&#x9;|| cardcolour == 'C') &amp;&amp; (cardnr &lt;= 13 &amp;&amp; cardnr >= 1)) {&#xA;&#x9;&#x9;&#x9;this.cardcolour = cardcolour;&#xA;&#x9;&#x9;&#x9;this.cardnr = cardnr;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Feil med cardcolor i constr.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//Methods&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return cardcolour;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return cardnr;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.format(&quot;%s%d&quot;, this.cardcolour, this.cardnr);&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Object arg0) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892477453" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&lt;Object>" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="60" end="-726"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892854430" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="741" end="-19"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488898592243" sizeMeasure="44" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//@Override&#xA;&#x9;public int compareTo(Card o1, Card o2) {&#xA;&#x9;&#x9;Card c1 = (Card)o1;&#xA;&#x9;&#x9;Card c2 = (Card)o2;&#xA;&#x9;&#x9;if (c1.getSuit().equals(c2.getSuit())) {&#xA;&#x9;&#x9;&#x9;return c1.getFace().compareTo(c2.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return c1.getSuit().compareTo(c2.getSuit())" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="692" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488902315497" sizeMeasure="46" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=") {&#xA;&#x9;&#x9;Card c1 = (Card)o1;&#xA;&#x9;&#x9;if (getSuit().equals(c1.getSuit())) {&#xA;&#x9;&#x9;&#x9;return getFace().compareTo(c1.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return getSuit().compareTo(c1.getSuit());&#xA;&#x9;}&#xA;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="733" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488902791528" sizeMeasure="46" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;public int compareTo(Card o1) {&#xA;//&#x9;&#x9;Card c1 = (Card)o1;&#xA;//&#x9;&#x9;if (getSuit().equals(c1.getSuit())) {&#xA;//&#x9;&#x9;&#x9;return getFace().compareTo(c1.getFace());&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;return getSuit().compareTo(c1.getSuit());&#xA;//" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="704" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488902809109" sizeMeasure="46" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="911" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903961919" sizeMeasure="46" errorCount="6">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public int compareTo(Card o1) {&#xA;&#x9;&#x9;Card c1 = (Card)o1;&#xA;&#x9;&#x9;if (getSuit().equals(c1.getSuit())) {&#xA;&#x9;&#x9;&#x9;return getFace().compareTo(c1.getFace());&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return getSuit().compareTo(c1.getSuit());&#xA;&#x9;}&#xA;&#xA;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="692" end="-6"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903984927" sizeMeasure="44" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;@Override&#xA;//&#x9;public int compareTo(Card o1) {&#xA;//&#x9;&#x9;Card c1 = (Card)o1;&#xA;//&#x9;&#x9;if (getSuit().equals(c1.getSuit())) {&#xA;//&#x9;&#x9;&#x9;return getFace().compareTo(c1.getFace());&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;return getSuit().compareTo(c1.getSuit());&#xA;//&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="691" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488472871163" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892477487" sizeMeasure="13">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card arg0, Card arg1) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892854439" sizeMeasure="12">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="166" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488898592253" sizeMeasure="51" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList;&#xA;import java.util.Comparator;&#xA;import java.util.List;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#xA;&#x9;//Variables &#xA;&#x9;private char trumf;&#xA;&#x9;private boolean aceLargest; &#xA;&#x9;public final static char[] cardSuits = {'C', 'D', 'H', 'S'};&#xA;&#x9;List&lt;Integer> setFace = new ArrayList&lt;>();&#xA;&#x9;List&lt;Character> setSuits = new ArrayList&lt;>();&#xA;&#x9;&#xA;&#x9;//Constructor &#xA;&#x9;public CardComparator(boolean arg, char trumf) {&#xA;&#x9;&#x9;this.trumf = trumf;&#xA;&#x9;&#x9;this.aceLargest = arg;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//legge til verdiene 1-13 i setFace &#xA;&#x9;&#x9;for (int i = 1; i &lt; 14; i++) {&#xA;&#x9;&#x9;&#x9;setFace.add(i);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//hvis ace er størst, ta det ut og legg på slutten &#xA;&#x9;&#x9;if (aceLargest) {&#xA;&#x9;&#x9;&#x9;setFace.remove(setFace.indexOf(1));&#xA;&#x9;&#x9;&#x9;setFace.add(1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;// legge til alle i cardSuits til i setSuits &#xA;&#x9;&#x9;for (char suit : cardSuits) {&#xA;&#x9;&#x9;&#x9;setSuits.add(suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;//hvis trumf er i setSuits sp skal den fjernes og settes på slutten &#xA;&#x9;&#x9;if (setSuits.contains(trumf)) {&#xA;&#x9;&#x9;&#x9;setSuits.remove(setSuits.indexOf(trumf));&#xA;&#x9;&#x9;&#x9;setSuits.add(trumf);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;//Methods &#xA;&#x9;@Override&#xA;&#x9;public int compare(Card card1, Card card2) {" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="38" end="-20"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488902315515" sizeMeasure="70" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Sjekker om indeksen til verdiene er forskjellig/like&#xA;&#x9;&#x9;//trump of ace vil ev være i slutten av listen - &#xA;&#x9;&#x9;//leter etter objekt med størst index&#xA;&#x9;&#x9;if (setSuits.indexOf(card1.getSuit()) > setSuits.indexOf(card2.getSuit())) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setSuits.indexOf(card1.getSuit()) &lt; setSuits.indexOf(card2.getSuit())) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setSuits.indexOf(card1.getSuit()) == setSuits.indexOf(card2.getSuit())) {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="1101" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488902770248" sizeMeasure="68" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1546" end="-69"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903190248" sizeMeasure="81" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) > setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) &lt; setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) == setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="1549" end="-57"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903218090" sizeMeasure="82">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return trumf;" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="1842" end="-61"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903225601" sizeMeasure="82" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="1849" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903231956" sizeMeasure="82" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="1849" end="-62"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903240966" sizeMeasure="82" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0;&#xA;" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="1849" end="-59"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903313144" sizeMeasure="109" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (setFace.indexOf(card1.getFace()) > setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) &lt; setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) == setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setSuits.indexOf(card1.getSuit()) &lt; setSuits.indexOf(card2.getSuit())) {&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) > setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) &lt; setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) == setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setSuits.indexOf(card1.getSuit()) == setSuits.indexOf(card2.getSuit())) {&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) > setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) &lt; setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) == setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;//&#x9;&#x9;if (setFace.indexOf(card1.getFace()) > setFace.indexOf(card2.getFace())) {&#xA;//&#x9;&#x9;&#x9;return 1;&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;if (setFace.indexOf(card1.getFace()) &lt; setFace.indexOf(card2.getFace())) {&#xA;//&#x9;&#x9;&#x9;return -1;&#xA;//&#x9;&#x9;}&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;if (setFace.indexOf(card1.getFace()) == setFace.indexOf(card2.getFace())) {&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="1330" end="-88"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903337399" sizeMeasure="109" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="} }" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="2720" end="-60"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903404871" sizeMeasure="82" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setSuits.indexOf(card1.getSuit()) &lt; setSuits.indexOf(card2.getSuit())) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setSuits.indexOf(card1.getSuit()) == setSuits.indexOf(card2.getSuit())) {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) > setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) &lt; setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) == setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return 0;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1330" end="-59"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903631753" sizeMeasure="80" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (setFace.indexOf(card1.getFace()) > setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) &lt; setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;if (setFace.indexOf(card1.getFace()) == setFace.indexOf(card2.getFace())) {&#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1530" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488903961927" sizeMeasure="79" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="1834" end="-73"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488904506665" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return 0;&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card c1 = new Card('S', 3);&#xA;&#x9;&#x9;Card c2 = new Card('D', 4);&#xA;&#x9;&#x9;CardComparator cc = new CardComparator(true, 'D');&#xA;&#x9;&#x9;System.out.println(c1.getSuit());&#xA;&#x9;&#x9;System.out.println(cc.compare(c1, c2));" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1834" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488904525092" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1921" end="-173"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488904565106" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="D', 4);&#xA;&#x9;&#x9;Card c2 = new Card('S', 1);&#xA;&#x9;&#x9;CardComparator cc = new CardComparator(true, 'D');&#xA;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1917" end="-85"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488904581544" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="S', 1);&#xA;&#x9;&#x9;Card c2 = new Card('S', 4" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="1917" end="-145"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488904588681" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="fals" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="1996" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488904794444" sizeMeasure="84" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="2097" end="-2098"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488904506147" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488904530232" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488904564426" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488904580806" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488904587805" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488883076340" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488892854849" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488898592888" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488902316168" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488902774460" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488902792020" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488902809500" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903190651" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903218464" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903225995" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903232350" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903241352" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903313608" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903337815" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903405271" completion="0.6666666666666666" successCount="2" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903632114" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903962487" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488903985350" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
