<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883611179" sizeMeasure="46" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card {//implements Comparable&lt;Card>{&#xA;&#xA;&#x9;private char suit;&#xA;&#x9;private int face;&#xA;&#x9;&#xA;&#x9;public final static String SUITS = &quot;SHDC&quot;;&#xA;&#x9;&#xA;&#x9;public Card(char suit, int face) {&#xA;&#x9;&#x9;if (SUITS.indexOf(suit) &lt; 0) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal suit: &quot; + suit);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (face &lt; 1 || face > 13) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Illegal face: &quot; + face);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;&#x9;this.face = face;&#xA;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return this.suit;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return this.face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return String.valueOf(suit) + face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;int d = SUITS.indexOf(card.suit) - SUITS.indexOf(this.suit);&#xA;&#x9;&#x9;if (d == 0) {&#xA;&#x9;&#x9;&#x9;d = this.face - card.face;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return d;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card car = new Card('H', 7);&#xA;&#x9;&#x9;System.out.println(car);&#xA;&#x9;}&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="634" charEnd="654" severity="2" problemCategory="50" problemType="67109498"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883635489" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements Comparable&lt;Card> " edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="39" end="-824"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488894006459" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="890" end="-891"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883665642" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class CardComparator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488883666094" sizeMeasure="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="54" end="-55"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488884655403" sizeMeasure="18">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Comparator;&#xA;&#xA;public class CardComparator implements Comparator&lt;Card>{&#xA;&#xA;&#x9;public CardComparator(boolean ace, char suit) {&#xA;&#x9;&#x9;if (ace == true) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card o1, Card o2) {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="21" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892354711" sizeMeasure="20" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private boolean ace;&#xA;&#x9;private char suit;" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="108" end="-156"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="125" charEnd="128" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="144" charEnd="148" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892558644" sizeMeasure="22" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private String suits = &quot;SHDC&quot;;&#xA;&#xA;&#x9;public CardComparator(boolean ace, char suit) {&#xA;&#x9;&#x9;if (ace == true) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;int s1 = &#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return d" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="150" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="333" charEnd="339" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="340" charEnd="341" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892693855" sizeMeasure="22" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.ace = ace;&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;int s1 = suits.indexOf(c1.getSuit());&#xA;&#x9;&#x9;int s2 = suits.indexOf(c2.getSuit());" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="234" end="-22"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="125" charEnd="128" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="144" charEnd="148" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="417" charEnd="418" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893831835" sizeMeasure="27" errorCount="1" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (c1.getSuit() == suit) {&#xA;&#x9;&#x9;&#x9;s1 = suits.length();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c2.getSuit() == suit) {&#xA;&#x9;&#x9;&#x9;s2 = suits.length();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="407" end="-19"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="6" charStart="125" charEnd="128" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="530" charEnd="531" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893965822" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="High;&#xA;&#x9;private char suit;&#xA;&#x9;private String suits = &quot;SHDC&quot;;&#xA;&#xA;&#x9;public CardComparator(boolean ace, char suit) {&#xA;&#x9;&#x9;this.aceHigh = ace;&#xA;&#x9;&#x9;this.suit = suit;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;int s1 = suits.indexOf(c1.getSuit());&#xA;&#x9;&#x9;int s2 = suits.indexOf(c2.getSuit());&#xA;&#x9;&#x9;if (c1.getSuit() == suit) {&#xA;&#x9;&#x9;&#x9;s1 = suits.length();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c2.getSuit() == suit) {&#xA;&#x9;&#x9;&#x9;s2 = suits.length();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;int d = s1 - s2;&#xA;&#x9;&#x9;if (d == 0) {&#xA;&#x9;&#x9;&#x9;int f1 = c1.getFace();&#xA;&#x9;&#x9;&#x9;int f2 = c2.getFace();&#xA;&#x9;&#x9;&#x9;if (aceHigh) {&#xA;&#x9;&#x9;&#x9;&#x9;if (f1 == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;f1 = 14;&#xA;&#x9;&#x9;&#x9;&#x9;} if (f2 == 1) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;f2 = 14;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="128" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893978492" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;d = f1 - f2;" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="715" end="-23"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488894188349" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="trumf;&#xA;&#x9;private String suits = &quot;SHDC&quot;;&#xA;&#xA;&#x9;public CardComparator(boolean ace, char suit) {&#xA;&#x9;&#x9;this.aceHigh = ace;&#xA;&#x9;&#x9;this.trumf = suit;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compare(Card c1, Card c2) {&#xA;&#x9;&#x9;int s1 = suits.indexOf(c1.getSuit());&#xA;&#x9;&#x9;int s2 = suits.indexOf(c2.getSuit());&#xA;&#x9;&#x9;if (c1.getSuit() == trumf) {&#xA;&#x9;&#x9;&#x9;s1 = suits.length();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (c2.getSuit() == trumf" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="148" end="-254"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488894283850" sizeMeasure="40">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="CDHS" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="180" end="-571"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488894007376" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488894272746" completion="0.0" failureCount="3">
          <failureTests>testAceIsHighest</failureTests>
          <failureTests>testDiamondIsTrumph</failureTests>
          <failureTests>testNormal</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488894286182" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
