<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringGridImpl">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Copy the source code for the StringGrid interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGrid"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridImpl class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridImpl class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StringGridIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StringGridTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.StringGridTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.StringGrid*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374310123" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public interface StringGrid {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374344735" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA;/*&#xA;An interface with methods for managing the content of a String grid.&#xA;The grid has a number of rows (the grid's height) and columns (the grid's width).&#xA;In each cell in the grid there is a String that can be set with the setElement method and read with the getElement method.&#xA;*/&#xA; public interface StringGrid {&#xA; &#xA;    // Returns the number of rows in this StringGrid&#xA;    public int getRowCount();&#xA;    // Returns the number of columns in this StringGrid&#xA;    public int getColumnCount();&#xA; &#xA;    // Returns the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public String getElement(int row, int column);&#xA;    // Sets the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public void setElement(int row, int column, String element);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="21" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379293121" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends Iterable&lt;String>" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="332" end="-548"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374383606" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class StringGridImpl {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374408945" sizeMeasure="29">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="implements StringGrid{&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="49" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374668974" sizeMeasure="41" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class StringGridImpl implements StringGrid{&#xA;&#xA;&#x9;private int rows;&#xA;&#x9;private int cols;&#xA;&#x9;private ArrayList&lt;ArrayList&lt;String>> grid;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows, int cols) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.cols = cols;&#xA;&#x9;&#x9;grid = new  ArrayList&lt;ArrayList&lt;String>>();&#xA;&#x9;}&#xA;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="21" end="-425"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="115" charEnd="119" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="134" charEnd="138" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="178" charEnd="182" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488374812681" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="return rows;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return cols;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;return grid.get(row).get(column)" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="363" end="-127"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375726425" sizeMeasure="37" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String[][] grid;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows, int cols) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.cols = cols;&#xA;&#x9;&#x9;grid = new  String[rows][cols];&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;return rows;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return cols;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;return grid[row][column];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;grid[row][column] = element;" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="149" end="-8"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="28" charEnd="47" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488375734836" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="21" end="-568"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376006203" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public class StringGridImpl implements StringGrid{&#xA;&#xA;&#x9;private int rows;&#xA;&#x9;private int cols;&#xA;&#x9;private String[][] grid;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows, int cols) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.cols = cols;&#xA;&#x9;&#x9;grid = new  String[rows][cols];&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;return rows;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return cols;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;return grid[row][column];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;grid[row][column] = element;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String outString = &quot;&quot;;&#xA;&#x9;&#x9;for (int i = 0; i &lt; rows; i++) {&#xA;&#x9;&#x9;&#x9;for (int j = 0; j &lt; cols; j++) {&#xA;&#x9;&#x9;&#x9;&#x9;outString += grid[i][j] + &quot;\t&quot;;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;outString += &quot;\n&quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return outString" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="21" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376083745" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StringGridImpl test = new StringGridImpl(5,5);&#xA;&#x9;&#x9;test.setElement(2, 2, &quot;A&quot;);&#xA;&#x9;&#x9;System.out.println(test);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="799" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376124931" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="test.setElement(1, 3, &quot;B" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="922" end="-38"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379548892" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;&#xA;public class StringGridImpl implements StringGrid{&#xA;&#xA;&#x9;private int rows;&#xA;&#x9;private int cols;&#xA;&#x9;private String[][] grid;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows, int cols) {&#xA;&#x9;&#x9;this.rows = rows;&#xA;&#x9;&#x9;this.cols = cols;&#xA;&#x9;&#x9;grid = new  String[rows][cols];&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;return rows;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return cols;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;return grid[row][column];&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;grid[row][column] = element;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String outString = &quot;&quot;;&#xA;&#x9;&#x9;for (int i = 0; i &lt; rows; i++) {&#xA;&#x9;&#x9;&#x9;for (int j = 0; j &lt; cols; j++) {&#xA;&#x9;&#x9;&#x9;&#x9;outString += grid[i][j] + &quot;\t&quot;;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;outString += &quot;\n&quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return outString;&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StringGridImpl test = new StringGridImpl(5,5);&#xA;&#x9;&#x9;test.setElement(2, 2, &quot;A&quot;);&#xA;&#x9;&#x9;test.setElement(1, 3, &quot;B&quot;);&#xA;&#x9;&#x9;System.out.println(test);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public Iterator&lt;String> iterator() {&#xA;&#x9;&#x9;return new StringGridIterator(this, true" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="21" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488387017124" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String[] row : grid) {&#xA;&#x9;&#x9;&#x9;for (String s : row) {&#xA;&#x9;&#x9;&#x9;&#x9;outString += s + &quot;\t&quot;;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;// (int i = 0; i &lt; rows; i++) {&#xA;&#x9;&#x9;&#x9;//for (int j = 0; j &lt; cols; j++) {&#xA;&#x9;&#x9;&#x9;//&#x9;outString += grid[i][j] + &quot;\t&quot;;&#xA;&#x9;&#x9;&#x9;//" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="672" end="-335"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488387035912" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="755" end="-335"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488398548785" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="755" end="-337"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488376086598" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488376125954" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488387018336" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488387051780" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488387502356" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488387506714" mode="debug"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376200049" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class StringGridIterator {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488376660911" sizeMeasure="31" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;&#xA;public class StringGridIterator implements Iterator&lt;String>{&#xA;&#xA;&#x9;private StringGrid grid;&#xA;&#x9;private boolean rowMajor;&#xA;&#x9;&#xA;&#x9;public StringGridIterator(StringGrid grid, boolean rowMajor) {&#xA;&#x9;&#x9;this.grid = grid;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void remove() {&#xA;&#x9;&#x9;throw new UnsupportedOperationException(&quot;Remove is not allowed&quot;);&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="21" end="-5"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="7" charStart="131" charEnd="135" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="8" charStart="154" charEnd="162" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488378990402" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private int row;&#xA;&#x9;private int col;&#xA;&#x9;&#xA;&#x9;public StringGridIterator(StringGrid grid, boolean rowMajor) {&#xA;&#x9;&#x9;this.grid = grid;&#xA;&#x9;&#x9;this.rowMajor = rowMajor;&#xA;&#x9;&#x9;row = 0;&#xA;&#x9;&#x9;col = 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return row &lt; grid.getRowCount() || col &lt; grid.getColumnCount();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;String string = grid.getElement(row, col);&#xA;&#x9;&#x9;if (rowMajor) {&#xA;&#x9;&#x9;&#x9;if (col &lt; grid.getColumnCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { // rowMajor == false&#xA;&#x9;&#x9;&#x9;if (row &lt; grid.getRowCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;row++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;row = 0;&#xA;&#x9;&#x9;&#x9;&#x9;col ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return string" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="165" end="-106"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379457331" sizeMeasure="57" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StringGrid g1 = new StringGridImpl(4,3);&#xA;&#x9;&#x9;StringGridIterator sgi = new StringGridIterator(g1, true);&#xA;&#x9;&#x9;for (String s : g1) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="883" end="-4"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="989" charEnd="992" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1043" charEnd="1044" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379606251" sizeMeasure="57" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(s);" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="1056" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="989" charEnd="992" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379678563" sizeMeasure="57" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="row &lt; grid.getRowCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;row++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;row = 0;&#xA;&#x9;&#x9;&#x9;&#x9;col" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="555" end="-460"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="986" charEnd="989" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379714963" sizeMeasure="57" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="col &lt; grid.getColumnCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="677" end="-338"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="989" charEnd="992" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488379929368" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="970" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380039870" sizeMeasure="58">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (col &lt; grid.getColumnCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;row = 0;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;col ++;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { // rowMajor == false&#xA;&#x9;&#x9;&#x9;if (col &lt; grid.getColumnCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return string;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void remove() {&#xA;&#x9;&#x9;throw new UnsupportedOperationException(&quot;Remove is not allowed&quot;);&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StringGrid g1 = new StringGridImpl(4,3" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="610" end="-63"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380097655" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="row = 0;&#xA;&#x9;&#x9;&#x9;&#x9;col ++;" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="610" end="-398"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380176042" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="col &lt; grid.getColumnCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="555" end="-402"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488380412966" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="row &lt; grid.getRowCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;row++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;row = 0;&#xA;&#x9;&#x9;&#x9;&#x9;col" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="680" end="-277"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488386625266" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="3" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="962" end="-65"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488386701625" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { // rowMajor == false&#xA;&#x9;&#x9;&#x9;if (row &lt; grid.getRowCount()-1" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="582" end="-324"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488386746635" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1 || col &lt; grid.getColumnCount()-1" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="413" end="-588"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488387865920" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="1019" end="-15"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488387883713" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=") {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { // rowMajor == false&#xA;&#x9;&#x9;&#x9;if (row &lt; grid.getRowCount()" edit="/1/@proposals.1/@proposals.0/@attempts.15/@edit" start="586" end="-322"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488387913610" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { // rowMajor == false&#xA;&#x9;&#x9;&#x9;if (row &lt; grid.getRowCount()-1" edit="/1/@proposals.1/@proposals.0/@attempts.16/@edit" start="586" end="-322"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488388584594" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(row &lt; grid.getRowCount()-1) || (col &lt; grid.getColumnCount()-1)" edit="/1/@proposals.1/@proposals.0/@attempts.17/@edit" start="389" end="-586"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488389200834" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="g1.setElement(0, 0, &quot;0,0&quot;); g1.setElement(0, 1, &quot;0,1&quot;); g1.setElement(0, 2, &quot;0,2&quot;);&#xA;&#x9;&#x9;g1.setElement(1, 0, &quot;1,0&quot;); g1.setElement(1, 1, &quot;1,1&quot;); g1.setElement(1, 2, &quot;1,2&quot;);&#xA;&#x9;&#x9;g1.setElement(2, 0, &quot;2,0&quot;); g1.setElement(2, 1, &quot;2,1&quot;); g1.setElement(2, 2, &quot;2,2&quot;" edit="/1/@proposals.1/@proposals.0/@attempts.18/@edit" start="982" end="-61"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488396307167" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=") || (col &lt; grid.getColumnCount()" edit="/1/@proposals.1/@proposals.0/@attempts.19/@edit" start="414" end="-845"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488396524175" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(row+1) &lt; grid.getRowCount()) || ((col+1)" edit="/1/@proposals.1/@proposals.0/@attempts.20/@edit" start="390" end="-869"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488397409074" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot;\t&quot;" edit="/1/@proposals.1/@proposals.0/@attempts.21/@edit" start="1287" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488397423286" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.22/@edit" start="1306" end="-1307"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488397556481" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=") &lt; grid.getRowCount()) || ((col" edit="/1/@proposals.1/@proposals.0/@attempts.23/@edit" start="394" end="-877"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488397565936" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="row &lt; grid.getRowCount()) || (col" edit="/1/@proposals.1/@proposals.0/@attempts.24/@edit" start="390" end="-876"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488397668090" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!hasNext()) {&#xA;&#x9;&#x9;&#x9;return string;&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.25/@edit" start="540" end="-766"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488397738938" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(row+1) &lt; grid.getRowCount()) || ((col+1)" edit="/1/@proposals.1/@proposals.0/@attempts.26/@edit" start="390" end="-918"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488397873931" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (rowMajor) {&#xA;&#x9;&#x9;&#x9;if (col &lt; grid.getColumnCount()-1) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { // rowMajor == false&#xA;&#x9;&#x9;&#x9;if (row &lt; grid.getRowCount()-1) {&#xA;&#x9;&#x9;&#x9;&#x9;row++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;row = 0;&#xA;&#x9;&#x9;&#x9;&#x9;col ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;String string = grid.getElement(row, col);" edit="/1/@proposals.1/@proposals.0/@attempts.27/@edit" start="499" end="-527"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488398166249" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="row &lt; grid.getRowCount()) || (col" edit="/1/@proposals.1/@proposals.0/@attempts.28/@edit" start="390" end="-876"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488398213569" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String string = grid.getElement(row, col);&#xA;&#x9;&#x9;if (rowMajor) {&#xA;&#x9;&#x9;&#x9;if (col &lt; grid.getColumnCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { // rowMajor == false&#xA;&#x9;&#x9;&#x9;if (row &lt; grid.getRowCount()) {&#xA;&#x9;&#x9;&#x9;&#x9;row++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;row = 0;&#xA;&#x9;&#x9;&#x9;&#x9;col ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.29/@edit" start="491" end="-527"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488398223953" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="-1) {&#xA;&#x9;&#x9;&#x9;&#x9;col++;&#xA;&#x9;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;&#x9;col = 0;&#xA;&#x9;&#x9;&#x9;&#x9;row ++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else { // rowMajor == false&#xA;&#x9;&#x9;&#x9;if (row &lt; grid.getRowCount()-1" edit="/1/@proposals.1/@proposals.0/@attempts.30/@edit" start="586" end="-587"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488398332935" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (!hasNext()) {&#xA;&#x9;&#x9;&#x9;return &quot;&quot;;&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.31/@edit" start="491" end="-811"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488399144271" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&amp;&amp;" edit="/1/@proposals.1/@proposals.0/@attempts.32/@edit" start="416" end="-919"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488386607803" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488386626319" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488386704501" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488386747845" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488387630446" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488389030374" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488389204565" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488397141735" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488397353705" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488397425179" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488397568440" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488397669306" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488397739961" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488397875102" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488398036083" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488398214950" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488398225087" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488398336456" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488398993050" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488399146624" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488379608779" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testGrid</successTests>
          <errorTests>testGridIteratorColumnMajor</errorTests>
          <errorTests>testGridIteratorRowMajor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488379687766" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
          <errorTests>testGridIteratorColumnMajor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488379723706" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488380045562" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488380188119" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <errorTests>testGridIteratorRowMajor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488380448299" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testGrid</successTests>
          <errorTests>testGridIteratorColumnMajor</errorTests>
          <errorTests>testGridIteratorRowMajor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488387084922" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488387892032" completion="0.3333333333333333" successCount="1" errorCount="2">
          <successTests>testGrid</successTests>
          <errorTests>testGridIteratorColumnMajor</errorTests>
          <errorTests>testGridIteratorRowMajor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488387918734" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488388593375" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488396314152" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488396533014" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488397884350" completion="0.3333333333333333" successCount="1" failureCount="2">
          <successTests>testGrid</successTests>
          <failureTests>testGridIteratorColumnMajor</failureTests>
          <failureTests>testGridIteratorRowMajor</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488399165604" completion="1.0" successCount="3">
          <successTests>testGrid</successTests>
          <successTests>testGridIteratorColumnMajor</successTests>
          <successTests>testGridIteratorRowMajor</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a" performedCount="6">
        <attempts timestamp="1488387508633"/>
        <attempts timestamp="1488387631617"/>
        <attempts timestamp="1488389032609"/>
        <attempts timestamp="1488389206369"/>
        <attempts timestamp="1488397143171"/>
        <attempts timestamp="1488398995282"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a" performedCount="130">
        <attempts timestamp="1488385466917"/>
        <attempts timestamp="1488385502203"/>
        <attempts timestamp="1488385516279"/>
        <attempts timestamp="1488385520553"/>
        <attempts timestamp="1488385543640"/>
        <attempts timestamp="1488385545084"/>
        <attempts timestamp="1488385550757"/>
        <attempts timestamp="1488385551629"/>
        <attempts timestamp="1488385615819"/>
        <attempts timestamp="1488385617234"/>
        <attempts timestamp="1488385623927"/>
        <attempts timestamp="1488385626539"/>
        <attempts timestamp="1488385666379"/>
        <attempts timestamp="1488385671082"/>
        <attempts timestamp="1488385730061"/>
        <attempts timestamp="1488385741372"/>
        <attempts timestamp="1488385761334"/>
        <attempts timestamp="1488385765708"/>
        <attempts timestamp="1488385773221"/>
        <attempts timestamp="1488385784155"/>
        <attempts timestamp="1488385784977"/>
        <attempts timestamp="1488385786851"/>
        <attempts timestamp="1488385789321"/>
        <attempts timestamp="1488385790190"/>
        <attempts timestamp="1488385791307"/>
        <attempts timestamp="1488385792804"/>
        <attempts timestamp="1488385812813"/>
        <attempts timestamp="1488385822251"/>
        <attempts timestamp="1488385880128"/>
        <attempts timestamp="1488385882464"/>
        <attempts timestamp="1488385899546"/>
        <attempts timestamp="1488385901256"/>
        <attempts timestamp="1488385911352"/>
        <attempts timestamp="1488385912487"/>
        <attempts timestamp="1488385917305"/>
        <attempts timestamp="1488385918389"/>
        <attempts timestamp="1488385920691"/>
        <attempts timestamp="1488385921875"/>
        <attempts timestamp="1488385982596"/>
        <attempts timestamp="1488385983829"/>
        <attempts timestamp="1488385987742"/>
        <attempts timestamp="1488385990719"/>
        <attempts timestamp="1488385998610"/>
        <attempts timestamp="1488385999697"/>
        <attempts timestamp="1488386005138"/>
        <attempts timestamp="1488386006618"/>
        <attempts timestamp="1488386012160"/>
        <attempts timestamp="1488386091740"/>
        <attempts timestamp="1488386095407"/>
        <attempts timestamp="1488386106637"/>
        <attempts timestamp="1488386141939"/>
        <attempts timestamp="1488386150174"/>
        <attempts timestamp="1488386150931"/>
        <attempts timestamp="1488386151671"/>
        <attempts timestamp="1488386152411"/>
        <attempts timestamp="1488386153563"/>
        <attempts timestamp="1488387538046"/>
        <attempts timestamp="1488387549441"/>
        <attempts timestamp="1488387550789"/>
        <attempts timestamp="1488387552269"/>
        <attempts timestamp="1488387566131"/>
        <attempts timestamp="1488387567416"/>
        <attempts timestamp="1488387568859"/>
        <attempts timestamp="1488387570060"/>
        <attempts timestamp="1488387570799"/>
        <attempts timestamp="1488387571572"/>
        <attempts timestamp="1488387573004"/>
        <attempts timestamp="1488387574055"/>
        <attempts timestamp="1488387575666"/>
        <attempts timestamp="1488387576636"/>
        <attempts timestamp="1488387580254"/>
        <attempts timestamp="1488387581536"/>
        <attempts timestamp="1488387596613"/>
        <attempts timestamp="1488387673086"/>
        <attempts timestamp="1488387678216"/>
        <attempts timestamp="1488387718928"/>
        <attempts timestamp="1488387721952"/>
        <attempts timestamp="1488387729746"/>
        <attempts timestamp="1488387734136"/>
        <attempts timestamp="1488387754164"/>
        <attempts timestamp="1488387756992"/>
        <attempts timestamp="1488387779353"/>
        <attempts timestamp="1488387781407"/>
        <attempts timestamp="1488389228671"/>
        <attempts timestamp="1488389230576"/>
        <attempts timestamp="1488389241298"/>
        <attempts timestamp="1488389249320"/>
        <attempts timestamp="1488389252790"/>
        <attempts timestamp="1488389254945"/>
        <attempts timestamp="1488397150041"/>
        <attempts timestamp="1488397212981"/>
        <attempts timestamp="1488397247954"/>
        <attempts timestamp="1488397250388"/>
        <attempts timestamp="1488397258757"/>
        <attempts timestamp="1488397267701"/>
        <attempts timestamp="1488397269429"/>
        <attempts timestamp="1488397271992"/>
        <attempts timestamp="1488397273423"/>
        <attempts timestamp="1488397280871"/>
        <attempts timestamp="1488397289537"/>
        <attempts timestamp="1488397293055"/>
        <attempts timestamp="1488397294898"/>
        <attempts timestamp="1488397297527"/>
        <attempts timestamp="1488397298844"/>
        <attempts timestamp="1488397300685"/>
        <attempts timestamp="1488397302147"/>
        <attempts timestamp="1488397303546"/>
        <attempts timestamp="1488397304433"/>
        <attempts timestamp="1488397305454"/>
        <attempts timestamp="1488397306241"/>
        <attempts timestamp="1488399000908"/>
        <attempts timestamp="1488399006596"/>
        <attempts timestamp="1488399012025"/>
        <attempts timestamp="1488399013387"/>
        <attempts timestamp="1488399015082"/>
        <attempts timestamp="1488399016003"/>
        <attempts timestamp="1488399017350"/>
        <attempts timestamp="1488399018223"/>
        <attempts timestamp="1488399019668"/>
        <attempts timestamp="1488399020623"/>
        <attempts timestamp="1488399022974"/>
        <attempts timestamp="1488399023927"/>
        <attempts timestamp="1488399026049"/>
        <attempts timestamp="1488399027184"/>
        <attempts timestamp="1488399029501"/>
        <attempts timestamp="1488399031213"/>
        <attempts timestamp="1488399033052"/>
        <attempts timestamp="1488399107832"/>
        <attempts timestamp="1488399113094"/>
        <attempts timestamp="1488399116629"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a" performedCount="21">
        <attempts timestamp="1488385612349"/>
        <attempts timestamp="1488385628973"/>
        <attempts timestamp="1488385636027"/>
        <attempts timestamp="1488385648111"/>
        <attempts timestamp="1488385652929"/>
        <attempts timestamp="1488385655182"/>
        <attempts timestamp="1488385673876"/>
        <attempts timestamp="1488385780160"/>
        <attempts timestamp="1488386015200"/>
        <attempts timestamp="1488386059464"/>
        <attempts timestamp="1488386146985"/>
        <attempts timestamp="1488387542487"/>
        <attempts timestamp="1488387559767"/>
        <attempts timestamp="1488387562250"/>
        <attempts timestamp="1488387562941"/>
        <attempts timestamp="1488387708568"/>
        <attempts timestamp="1488397207852"/>
        <attempts timestamp="1488397217749"/>
        <attempts timestamp="1488397242792"/>
        <attempts timestamp="1488399035059"/>
        <attempts timestamp="1488399118241"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a" performedCount="10">
        <attempts timestamp="1488385441315"/>
        <attempts timestamp="1488385690177"/>
        <attempts timestamp="1488385892618"/>
        <attempts timestamp="1488385992346"/>
        <attempts timestamp="1488387521277"/>
        <attempts timestamp="1488387637306"/>
        <attempts timestamp="1488389038689"/>
        <attempts timestamp="1488389211013"/>
        <attempts timestamp="1488397154748"/>
        <attempts timestamp="1488399041681"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
