<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringGridImpl">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Copy the source code for the StringGrid interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGrid"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridImpl class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridImpl class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridImpl"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StringGridIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StringGridIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringGridIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.StringGridIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StringGridTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.StringGridTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.StringGrid*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928045605" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public interface StringGrid {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928254211" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" &#xA;/*&#xA;An interface with methods for managing the content of a String grid.&#xA;The grid has a number of rows (the grid's height) and columns (the grid's width).&#xA;In each cell in the grid there is a String that can be set with the setElement method and read with the getElement method.&#xA;*/&#xA; public interface StringGrid {&#xA; &#xA;    // Returns the number of rows in this StringGrid&#xA;    public int getRowCount();&#xA;    // Returns the number of columns in this StringGrid&#xA;    public int getColumnCount();&#xA; &#xA;    // Returns the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public String getElement(int row, int column);&#xA;    // Sets the String at the given row and column. Throws an IllegalArgumentException if the row or column is out of range&#xA;    public void setElement(int row, int column, String element);" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="20" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488931054754" sizeMeasure="19">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends Iterable&lt;String>" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="331" end="-548"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488928029410" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class StringGridImpl {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929514384" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class StringGridImpl implements StringGrid{&#xA;&#x9;int rowcount, columncount;&#xA;&#x9;ArrayList&lt;String> list;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows,int cols){&#xA;&#x9;&#x9;this.rowcount=rows;&#xA;&#x9;&#x9;this.columncount=cols;&#xA;&#x9;&#x9;for (int i = 0; i &lt; rows*cols; i++) {//adds the correct amount of empty slots to the list&#xA;&#x9;&#x9;&#x9;list.add(&quot;&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;return this.rowcount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return this.columncount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;return this.list.get(column+row*this.columncount);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;this.list.set(column+row*this.columncount,element);&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="21" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930666063" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="list=new ArrayList&lt;String>()" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="248" end="-517"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488931204669" sizeMeasure="44">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Iterator;&#xA;&#xA;public class StringGridImpl implements StringGrid{&#xA;&#x9;int rowcount, columncount;&#xA;&#x9;ArrayList&lt;String> list;&#xA;&#x9;&#xA;&#x9;public StringGridImpl(int rows,int cols){&#xA;&#x9;&#x9;this.rowcount=rows;&#xA;&#x9;&#x9;this.columncount=cols;&#xA;&#x9;&#x9;list=new ArrayList&lt;String>();&#xA;&#x9;&#x9;for (int i = 0; i &lt; rows*cols; i++) {//adds the correct amount of empty slots to the list&#xA;&#x9;&#x9;&#x9;list.add(&quot;&quot;);&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public int getRowCount() {&#xA;&#x9;&#x9;return this.rowcount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int getColumnCount() {&#xA;&#x9;&#x9;return this.columncount;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String getElement(int row, int column) {&#xA;&#x9;&#x9;return this.list.get(column+row*this.columncount);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void setElement(int row, int column, String element) {&#xA;&#x9;&#x9;this.list.set(column+row*this.columncount,element);&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;@Override&#xA;&#x9;public Iterator&lt;String> iterator() {&#xA;&#x9;&#x9;return new StringGridIterator(this,true);" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="49" end="-8"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488929571375" sizeMeasure="19">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;import java.util.Iterator;&#xA;&#xA;public class StringGridIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930139939" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;private boolean rowMajor;&#xA;&#x9;private int position;&#xA;&#x9;private int rowCount;&#xA;&#x9;private int colCount;&#xA;&#x9;private StringGrid grid;&#xA;&#x9;&#xA;&#x9;public StringGridIterator(StringGrid g, boolean rowMajor) {&#xA;&#x9;&#x9;position=0;&#xA;&#x9;&#x9;this.rowMajor=rowMajor;&#xA;&#x9;&#x9;this.rowCount=g.getRowCount();&#xA;&#x9;&#x9;this.colCount=g.getColumnCount();&#xA;&#x9;&#x9;this.grid=g;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return position&lt;this.colCount*this.rowCount-1;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;if (this.rowMajor){&#xA;&#x9;&#x9;&#x9;return this.grid.getElement(Math.floorDiv(this.position, this.colCount), this.position % this.colCount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return this.grid.getElement(this.position % this.rowCount, Math.floorDiv(this.position, this.rowCount))" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="111" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930219212" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;public void remove(){&#xA;&#x9;&#x9;throw new UnsupportedOperationException(" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="796" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930344814" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="870" end="-871"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930545504" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="static void main(String[] args) {&#xA;&#x9;&#x9;StringGrid g= new StringGridImpl(2,3);&#xA;&#x9;&#x9;g.setElement(0, 0, &quot;ge&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StringGridIterator i = new StringGridIterator(g,true);&#xA;&#x9;&#x9;while (i.hasNext()){&#xA;&#x9;&#x9;&#x9;System.out.println(i.next());&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="243" end="-639"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930672437" sizeMeasure="46">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="291" end="-816"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930764250" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="String value;&#xA;&#x9;&#x9;if (this.rowMajor){&#xA;&#x9;&#x9;&#x9;value=this.grid.getElement(Math.floorDiv(this.position, this.colCount), this.position % this.colCount);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;value=this.grid.getElement(this.position % this.rowCount, Math.floorDiv(this.position, this.rowCount));&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.position++;&#xA;&#x9;&#x9;return value" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="791" end="-80"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930797901" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="!" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="811" end="-359"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930803953" sizeMeasure="51">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="811" end="-359"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930849960" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="0, 0&quot;);&#xA;&#x9;&#x9;g.setElement(1, 0, &quot;1, 0&quot;);&#xA;&#x9;&#x9;g.setElement(0, 1, &quot;0, 1&quot;);&#xA;&#x9;&#x9;g.setElement(1, 1, &quot;1, 1&quot;);&#xA;&#x9;&#x9;g.setElement(0, 2, &quot;0, 2&quot;);&#xA;&#x9;&#x9;g.setElement(1, 2, &quot;1, 2&quot;);&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="341" end="-824"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488930880003" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="901" end="-422"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488931096353" sizeMeasure="61" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="extends Iterable&lt;String> {&#xA;&#x9;private boolean rowMajor;&#xA;&#x9;private int position;&#xA;&#x9;private int rowCount;&#xA;&#x9;private int colCount;&#xA;&#x9;private StringGrid grid;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;StringGrid g = new StringGridImpl(2,3);&#xA;&#x9;&#x9;g.setElement(0, 0, &quot;0, 0&quot;);&#xA;&#x9;&#x9;g.setElement(1, 0, &quot;1, 0&quot;);&#xA;&#x9;&#x9;g.setElement(0, 1, &quot;0, 1&quot;);&#xA;&#x9;&#x9;g.setElement(1, 1, &quot;1, 1&quot;);&#xA;&#x9;&#x9;g.setElement(0, 2, &quot;0, 2&quot;);&#xA;&#x9;&#x9;g.setElement(1, 2, &quot;1, 2&quot;);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (String s: g){&#xA;&#x9;&#x9;&#x9;System.out.println(s);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="109" end="-822"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488931353746" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="108" end="-1268"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488931368014" sizeMeasure="57">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="559" end="-702"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488930545311" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488930672074" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488930763933" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488930849490" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488930879659" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488931096002" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488931209595" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488931332935" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488931355071" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488931369711" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488929515866" completion="0.0" errorCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488930280872" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488930303709" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488930352643" completion="0.0" errorCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488930773928" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488930799049" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488930805129" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488930896131" completion="1.0" successCount="3"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
