<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringMergingIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Modify the code for the StringMergingIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIteratorProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIteratorProgram"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="debugging.StringMergingIterator*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488806680616" sizeMeasure="52">
          <edit xsi:type="exercise:StringEdit" storedString="package debugging;&#xA;&#xA;import java.util.Iterator;&#xA;import java.util.NoSuchElementException;&#xA;&#xA;public class StringMergingIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;private Iterator&lt;String> first;&#xA;&#x9;private Iterator&lt;String> second;&#xA;&#x9;private boolean turnSwitch;&#xA;&#xA;&#x9;public StringMergingIterator(Iterator&lt;String> first, Iterator&lt;String> second){&#xA;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;this.turnSwitch = true;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! hasNext()){ throw new NoSuchElementException(); }&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(first.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if(turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(!turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return result;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807399315" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //a,b&#xA;&#x9;&#x9;this.second = second; //c,d,e&#xA;&#x9;&#x9;this.turnSwitch = false;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! hasNext()){ throw new NoSuchElementException(); }&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! first.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! " edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="353" end="-249"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807509371" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tru" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="412" end="-536"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488807651258" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else " edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="840" end="-111"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808044715" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="null;&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = null" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="671" end="-210"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808353983" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(second.hasNext()){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;if(first.hasNext()){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="662" end="-209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808530601" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//Må her, dersom første liste er tom, først sjekke om liste to ikke er tom for å så legge til et element herfra&#xA;&#x9;&#x9;&#x9;if(second.hasNext()){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;//Må her, dersom andre liste er tom, først sjekke om liste en ikke er tom for å så legge til et element herfra&#xA;&#x9;&#x9;&#x9;if(first.hasNext()){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if(turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;//Må ha en else if så ikke den går rett inn i denne (!turnSwitch)" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="662" end="-120"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488808621154" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="first" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1019" end="-291"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488805474133" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488805798877" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488805825291" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488806106715" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488806220850" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488806616239" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488806726355" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807428435" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807531608" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807656506" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807686751" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488807823417" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488808052780" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488808371695" mode="debug"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="75">
        <attempts timestamp="1488805475275"/>
        <attempts timestamp="1488805475275"/>
        <attempts timestamp="1488805498299"/>
        <attempts timestamp="1488805499674"/>
        <attempts timestamp="1488805520087"/>
        <attempts timestamp="1488805521536"/>
        <attempts timestamp="1488805522478"/>
        <attempts timestamp="1488805534001"/>
        <attempts timestamp="1488805534894"/>
        <attempts timestamp="1488805535394"/>
        <attempts timestamp="1488805536654"/>
        <attempts timestamp="1488805537744"/>
        <attempts timestamp="1488805538259"/>
        <attempts timestamp="1488805799964"/>
        <attempts timestamp="1488805826647"/>
        <attempts timestamp="1488805882430"/>
        <attempts timestamp="1488805941898"/>
        <attempts timestamp="1488805979584"/>
        <attempts timestamp="1488805987759"/>
        <attempts timestamp="1488806107782"/>
        <attempts timestamp="1488806117282"/>
        <attempts timestamp="1488806119239"/>
        <attempts timestamp="1488806121823"/>
        <attempts timestamp="1488806124455"/>
        <attempts timestamp="1488806221946"/>
        <attempts timestamp="1488806240003"/>
        <attempts timestamp="1488806498472"/>
        <attempts timestamp="1488806517379"/>
        <attempts timestamp="1488806584151"/>
        <attempts timestamp="1488806617657"/>
        <attempts timestamp="1488806684362"/>
        <attempts timestamp="1488806685962"/>
        <attempts timestamp="1488806691250"/>
        <attempts timestamp="1488806693751"/>
        <attempts timestamp="1488806694583"/>
        <attempts timestamp="1488806695298"/>
        <attempts timestamp="1488806700391"/>
        <attempts timestamp="1488806727457"/>
        <attempts timestamp="1488807404482"/>
        <attempts timestamp="1488807409247"/>
        <attempts timestamp="1488807413297"/>
        <attempts timestamp="1488807414179"/>
        <attempts timestamp="1488807429414"/>
        <attempts timestamp="1488807474227"/>
        <attempts timestamp="1488807532540"/>
        <attempts timestamp="1488807537403"/>
        <attempts timestamp="1488807657625"/>
        <attempts timestamp="1488807687839"/>
        <attempts timestamp="1488807690358"/>
        <attempts timestamp="1488807707143"/>
        <attempts timestamp="1488807736364"/>
        <attempts timestamp="1488807753166"/>
        <attempts timestamp="1488807764961"/>
        <attempts timestamp="1488807824283"/>
        <attempts timestamp="1488807826254"/>
        <attempts timestamp="1488807834400"/>
        <attempts timestamp="1488807838767"/>
        <attempts timestamp="1488807856403"/>
        <attempts timestamp="1488807898828"/>
        <attempts timestamp="1488808053814"/>
        <attempts timestamp="1488808056555"/>
        <attempts timestamp="1488808060776"/>
        <attempts timestamp="1488808065142"/>
        <attempts timestamp="1488808081204"/>
        <attempts timestamp="1488808097774"/>
        <attempts timestamp="1488808112129"/>
        <attempts timestamp="1488808116471"/>
        <attempts timestamp="1488808119236"/>
        <attempts timestamp="1488808373850"/>
        <attempts timestamp="1488808378821"/>
        <attempts timestamp="1488808382020"/>
        <attempts timestamp="1488808384754"/>
        <attempts timestamp="1488808388345"/>
        <attempts timestamp="1488808390819"/>
        <attempts timestamp="1488808402418"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="420">
        <attempts timestamp="1488805808594"/>
        <attempts timestamp="1488805882424"/>
        <attempts timestamp="1488805884028"/>
        <attempts timestamp="1488805888565"/>
        <attempts timestamp="1488805890383"/>
        <attempts timestamp="1488805901764"/>
        <attempts timestamp="1488805909000"/>
        <attempts timestamp="1488805913224"/>
        <attempts timestamp="1488805914234"/>
        <attempts timestamp="1488805915644"/>
        <attempts timestamp="1488805918189"/>
        <attempts timestamp="1488805921319"/>
        <attempts timestamp="1488805922339"/>
        <attempts timestamp="1488805923099"/>
        <attempts timestamp="1488805924014"/>
        <attempts timestamp="1488805929572"/>
        <attempts timestamp="1488805931801"/>
        <attempts timestamp="1488805934019"/>
        <attempts timestamp="1488805934935"/>
        <attempts timestamp="1488805941894"/>
        <attempts timestamp="1488805958808"/>
        <attempts timestamp="1488805960425"/>
        <attempts timestamp="1488805961749"/>
        <attempts timestamp="1488805964716"/>
        <attempts timestamp="1488805969454"/>
        <attempts timestamp="1488805970071"/>
        <attempts timestamp="1488805970691"/>
        <attempts timestamp="1488805971194"/>
        <attempts timestamp="1488805971536"/>
        <attempts timestamp="1488805971671"/>
        <attempts timestamp="1488805971848"/>
        <attempts timestamp="1488805972299"/>
        <attempts timestamp="1488805973074"/>
        <attempts timestamp="1488805973506"/>
        <attempts timestamp="1488805973935"/>
        <attempts timestamp="1488805974391"/>
        <attempts timestamp="1488805974862"/>
        <attempts timestamp="1488805979579"/>
        <attempts timestamp="1488805984929"/>
        <attempts timestamp="1488805985591"/>
        <attempts timestamp="1488805985903"/>
        <attempts timestamp="1488805986096"/>
        <attempts timestamp="1488805986577"/>
        <attempts timestamp="1488805986747"/>
        <attempts timestamp="1488805987236"/>
        <attempts timestamp="1488805987410"/>
        <attempts timestamp="1488805987582"/>
        <attempts timestamp="1488805987746"/>
        <attempts timestamp="1488805988086"/>
        <attempts timestamp="1488805989495"/>
        <attempts timestamp="1488807474224"/>
        <attempts timestamp="1488807475313"/>
        <attempts timestamp="1488807479688"/>
        <attempts timestamp="1488807481565"/>
        <attempts timestamp="1488807483936"/>
        <attempts timestamp="1488807513250"/>
        <attempts timestamp="1488807537394"/>
        <attempts timestamp="1488807538065"/>
        <attempts timestamp="1488807539668"/>
        <attempts timestamp="1488807540765"/>
        <attempts timestamp="1488807543241"/>
        <attempts timestamp="1488807547407"/>
        <attempts timestamp="1488807567747"/>
        <attempts timestamp="1488807568882"/>
        <attempts timestamp="1488807570182"/>
        <attempts timestamp="1488807586172"/>
        <attempts timestamp="1488807591769"/>
        <attempts timestamp="1488807595317"/>
        <attempts timestamp="1488807600980"/>
        <attempts timestamp="1488807609294"/>
        <attempts timestamp="1488807611048"/>
        <attempts timestamp="1488807613654"/>
        <attempts timestamp="1488807661200"/>
        <attempts timestamp="1488807661775"/>
        <attempts timestamp="1488807662536"/>
        <attempts timestamp="1488807663018"/>
        <attempts timestamp="1488807663410"/>
        <attempts timestamp="1488807663798"/>
        <attempts timestamp="1488807664023"/>
        <attempts timestamp="1488807671123"/>
        <attempts timestamp="1488807671725"/>
        <attempts timestamp="1488807672633"/>
        <attempts timestamp="1488807673435"/>
        <attempts timestamp="1488807692008"/>
        <attempts timestamp="1488807693196"/>
        <attempts timestamp="1488807693861"/>
        <attempts timestamp="1488807694332"/>
        <attempts timestamp="1488807694898"/>
        <attempts timestamp="1488807695376"/>
        <attempts timestamp="1488807695566"/>
        <attempts timestamp="1488807695739"/>
        <attempts timestamp="1488807696008"/>
        <attempts timestamp="1488807696255"/>
        <attempts timestamp="1488807697493"/>
        <attempts timestamp="1488807698320"/>
        <attempts timestamp="1488807699121"/>
        <attempts timestamp="1488807699936"/>
        <attempts timestamp="1488807703110"/>
        <attempts timestamp="1488807707132"/>
        <attempts timestamp="1488807712096"/>
        <attempts timestamp="1488807713169"/>
        <attempts timestamp="1488807714841"/>
        <attempts timestamp="1488807715352"/>
        <attempts timestamp="1488807721320"/>
        <attempts timestamp="1488807722976"/>
        <attempts timestamp="1488807724121"/>
        <attempts timestamp="1488807724807"/>
        <attempts timestamp="1488807725540"/>
        <attempts timestamp="1488807726040"/>
        <attempts timestamp="1488807727399"/>
        <attempts timestamp="1488807728049"/>
        <attempts timestamp="1488807728511"/>
        <attempts timestamp="1488807731855"/>
        <attempts timestamp="1488807732312"/>
        <attempts timestamp="1488807736359"/>
        <attempts timestamp="1488807739877"/>
        <attempts timestamp="1488807741281"/>
        <attempts timestamp="1488807742342"/>
        <attempts timestamp="1488807742800"/>
        <attempts timestamp="1488807744097"/>
        <attempts timestamp="1488807745530"/>
        <attempts timestamp="1488807745934"/>
        <attempts timestamp="1488807746306"/>
        <attempts timestamp="1488807746592"/>
        <attempts timestamp="1488807746869"/>
        <attempts timestamp="1488807747260"/>
        <attempts timestamp="1488807747694"/>
        <attempts timestamp="1488807748109"/>
        <attempts timestamp="1488807748566"/>
        <attempts timestamp="1488807749023"/>
        <attempts timestamp="1488807753159"/>
        <attempts timestamp="1488807758416"/>
        <attempts timestamp="1488807759498"/>
        <attempts timestamp="1488807760206"/>
        <attempts timestamp="1488807760620"/>
        <attempts timestamp="1488807761125"/>
        <attempts timestamp="1488807761839"/>
        <attempts timestamp="1488807763925"/>
        <attempts timestamp="1488807764539"/>
        <attempts timestamp="1488807764742"/>
        <attempts timestamp="1488807764947"/>
        <attempts timestamp="1488807765171"/>
        <attempts timestamp="1488807769695"/>
        <attempts timestamp="1488807826248"/>
        <attempts timestamp="1488807826382"/>
        <attempts timestamp="1488807826534"/>
        <attempts timestamp="1488807826839"/>
        <attempts timestamp="1488807826992"/>
        <attempts timestamp="1488807827166"/>
        <attempts timestamp="1488807827302"/>
        <attempts timestamp="1488807827455"/>
        <attempts timestamp="1488807828382"/>
        <attempts timestamp="1488807828666"/>
        <attempts timestamp="1488807828802"/>
        <attempts timestamp="1488807828961"/>
        <attempts timestamp="1488807829119"/>
        <attempts timestamp="1488807829287"/>
        <attempts timestamp="1488807829593"/>
        <attempts timestamp="1488807830073"/>
        <attempts timestamp="1488807834396"/>
        <attempts timestamp="1488807834958"/>
        <attempts timestamp="1488807835654"/>
        <attempts timestamp="1488807835955"/>
        <attempts timestamp="1488807836145"/>
        <attempts timestamp="1488807836438"/>
        <attempts timestamp="1488807836603"/>
        <attempts timestamp="1488807836763"/>
        <attempts timestamp="1488807836930"/>
        <attempts timestamp="1488807837380"/>
        <attempts timestamp="1488807837566"/>
        <attempts timestamp="1488807837732"/>
        <attempts timestamp="1488807837893"/>
        <attempts timestamp="1488807838084"/>
        <attempts timestamp="1488807838275"/>
        <attempts timestamp="1488807838497"/>
        <attempts timestamp="1488807838762"/>
        <attempts timestamp="1488807839071"/>
        <attempts timestamp="1488807839603"/>
        <attempts timestamp="1488807847859"/>
        <attempts timestamp="1488807848274"/>
        <attempts timestamp="1488807848961"/>
        <attempts timestamp="1488807850399"/>
        <attempts timestamp="1488807850559"/>
        <attempts timestamp="1488807850719"/>
        <attempts timestamp="1488807850890"/>
        <attempts timestamp="1488807851070"/>
        <attempts timestamp="1488807851334"/>
        <attempts timestamp="1488807851856"/>
        <attempts timestamp="1488807852224"/>
        <attempts timestamp="1488807853039"/>
        <attempts timestamp="1488807853468"/>
        <attempts timestamp="1488807856390"/>
        <attempts timestamp="1488807862805"/>
        <attempts timestamp="1488807876613"/>
        <attempts timestamp="1488807877699"/>
        <attempts timestamp="1488807878283"/>
        <attempts timestamp="1488807879314"/>
        <attempts timestamp="1488807879970"/>
        <attempts timestamp="1488807880545"/>
        <attempts timestamp="1488807881181"/>
        <attempts timestamp="1488807889929"/>
        <attempts timestamp="1488807898820"/>
        <attempts timestamp="1488807905170"/>
        <attempts timestamp="1488807906567"/>
        <attempts timestamp="1488808056543"/>
        <attempts timestamp="1488808056704"/>
        <attempts timestamp="1488808057170"/>
        <attempts timestamp="1488808057642"/>
        <attempts timestamp="1488808057794"/>
        <attempts timestamp="1488808058167"/>
        <attempts timestamp="1488808058318"/>
        <attempts timestamp="1488808058924"/>
        <attempts timestamp="1488808059103"/>
        <attempts timestamp="1488808059274"/>
        <attempts timestamp="1488808059432"/>
        <attempts timestamp="1488808059584"/>
        <attempts timestamp="1488808059758"/>
        <attempts timestamp="1488808059930"/>
        <attempts timestamp="1488808060081"/>
        <attempts timestamp="1488808060266"/>
        <attempts timestamp="1488808060770"/>
        <attempts timestamp="1488808060949"/>
        <attempts timestamp="1488808061412"/>
        <attempts timestamp="1488808061883"/>
        <attempts timestamp="1488808062515"/>
        <attempts timestamp="1488808063069"/>
        <attempts timestamp="1488808063217"/>
        <attempts timestamp="1488808063376"/>
        <attempts timestamp="1488808063538"/>
        <attempts timestamp="1488808063686"/>
        <attempts timestamp="1488808063844"/>
        <attempts timestamp="1488808064009"/>
        <attempts timestamp="1488808064182"/>
        <attempts timestamp="1488808064355"/>
        <attempts timestamp="1488808064506"/>
        <attempts timestamp="1488808064668"/>
        <attempts timestamp="1488808065139"/>
        <attempts timestamp="1488808071337"/>
        <attempts timestamp="1488808071866"/>
        <attempts timestamp="1488808072166"/>
        <attempts timestamp="1488808072709"/>
        <attempts timestamp="1488808073646"/>
        <attempts timestamp="1488808074520"/>
        <attempts timestamp="1488808074913"/>
        <attempts timestamp="1488808075243"/>
        <attempts timestamp="1488808075745"/>
        <attempts timestamp="1488808076158"/>
        <attempts timestamp="1488808076602"/>
        <attempts timestamp="1488808077022"/>
        <attempts timestamp="1488808077389"/>
        <attempts timestamp="1488808077799"/>
        <attempts timestamp="1488808078195"/>
        <attempts timestamp="1488808081195"/>
        <attempts timestamp="1488808081681"/>
        <attempts timestamp="1488808082321"/>
        <attempts timestamp="1488808083583"/>
        <attempts timestamp="1488808087979"/>
        <attempts timestamp="1488808088431"/>
        <attempts timestamp="1488808088951"/>
        <attempts timestamp="1488808089422"/>
        <attempts timestamp="1488808089829"/>
        <attempts timestamp="1488808090246"/>
        <attempts timestamp="1488808090841"/>
        <attempts timestamp="1488808091473"/>
        <attempts timestamp="1488808094869"/>
        <attempts timestamp="1488808097761"/>
        <attempts timestamp="1488808103419"/>
        <attempts timestamp="1488808104247"/>
        <attempts timestamp="1488808104960"/>
        <attempts timestamp="1488808105426"/>
        <attempts timestamp="1488808106075"/>
        <attempts timestamp="1488808106433"/>
        <attempts timestamp="1488808106612"/>
        <attempts timestamp="1488808106776"/>
        <attempts timestamp="1488808106928"/>
        <attempts timestamp="1488808107101"/>
        <attempts timestamp="1488808107251"/>
        <attempts timestamp="1488808107422"/>
        <attempts timestamp="1488808112123"/>
        <attempts timestamp="1488808112570"/>
        <attempts timestamp="1488808113003"/>
        <attempts timestamp="1488808113311"/>
        <attempts timestamp="1488808113513"/>
        <attempts timestamp="1488808113703"/>
        <attempts timestamp="1488808113896"/>
        <attempts timestamp="1488808114212"/>
        <attempts timestamp="1488808114364"/>
        <attempts timestamp="1488808114559"/>
        <attempts timestamp="1488808115054"/>
        <attempts timestamp="1488808115473"/>
        <attempts timestamp="1488808115815"/>
        <attempts timestamp="1488808116461"/>
        <attempts timestamp="1488808116905"/>
        <attempts timestamp="1488808117389"/>
        <attempts timestamp="1488808117567"/>
        <attempts timestamp="1488808117720"/>
        <attempts timestamp="1488808117886"/>
        <attempts timestamp="1488808118044"/>
        <attempts timestamp="1488808118195"/>
        <attempts timestamp="1488808118360"/>
        <attempts timestamp="1488808118516"/>
        <attempts timestamp="1488808118677"/>
        <attempts timestamp="1488808118875"/>
        <attempts timestamp="1488808119026"/>
        <attempts timestamp="1488808119232"/>
        <attempts timestamp="1488808119390"/>
        <attempts timestamp="1488808378814"/>
        <attempts timestamp="1488808379130"/>
        <attempts timestamp="1488808379445"/>
        <attempts timestamp="1488808379756"/>
        <attempts timestamp="1488808379906"/>
        <attempts timestamp="1488808380211"/>
        <attempts timestamp="1488808380378"/>
        <attempts timestamp="1488808380537"/>
        <attempts timestamp="1488808380688"/>
        <attempts timestamp="1488808380825"/>
        <attempts timestamp="1488808380982"/>
        <attempts timestamp="1488808381122"/>
        <attempts timestamp="1488808381258"/>
        <attempts timestamp="1488808381411"/>
        <attempts timestamp="1488808381556"/>
        <attempts timestamp="1488808381703"/>
        <attempts timestamp="1488808382015"/>
        <attempts timestamp="1488808382169"/>
        <attempts timestamp="1488808382348"/>
        <attempts timestamp="1488808382641"/>
        <attempts timestamp="1488808382778"/>
        <attempts timestamp="1488808382942"/>
        <attempts timestamp="1488808383137"/>
        <attempts timestamp="1488808383399"/>
        <attempts timestamp="1488808383538"/>
        <attempts timestamp="1488808383691"/>
        <attempts timestamp="1488808383843"/>
        <attempts timestamp="1488808383999"/>
        <attempts timestamp="1488808384122"/>
        <attempts timestamp="1488808384291"/>
        <attempts timestamp="1488808384431"/>
        <attempts timestamp="1488808384586"/>
        <attempts timestamp="1488808384754"/>
        <attempts timestamp="1488808384921"/>
        <attempts timestamp="1488808385227"/>
        <attempts timestamp="1488808385539"/>
        <attempts timestamp="1488808385697"/>
        <attempts timestamp="1488808385848"/>
        <attempts timestamp="1488808386009"/>
        <attempts timestamp="1488808386174"/>
        <attempts timestamp="1488808386326"/>
        <attempts timestamp="1488808386480"/>
        <attempts timestamp="1488808386647"/>
        <attempts timestamp="1488808386800"/>
        <attempts timestamp="1488808386956"/>
        <attempts timestamp="1488808387285"/>
        <attempts timestamp="1488808388030"/>
        <attempts timestamp="1488808388189"/>
        <attempts timestamp="1488808388335"/>
        <attempts timestamp="1488808388513"/>
        <attempts timestamp="1488808388829"/>
        <attempts timestamp="1488808389010"/>
        <attempts timestamp="1488808389154"/>
        <attempts timestamp="1488808389328"/>
        <attempts timestamp="1488808389496"/>
        <attempts timestamp="1488808389646"/>
        <attempts timestamp="1488808389810"/>
        <attempts timestamp="1488808389968"/>
        <attempts timestamp="1488808390139"/>
        <attempts timestamp="1488808390298"/>
        <attempts timestamp="1488808390466"/>
        <attempts timestamp="1488808390638"/>
        <attempts timestamp="1488808390813"/>
        <attempts timestamp="1488808390979"/>
        <attempts timestamp="1488808391158"/>
        <attempts timestamp="1488808397652"/>
        <attempts timestamp="1488808398077"/>
        <attempts timestamp="1488808398402"/>
        <attempts timestamp="1488808398566"/>
        <attempts timestamp="1488808399081"/>
        <attempts timestamp="1488808399406"/>
        <attempts timestamp="1488808399771"/>
        <attempts timestamp="1488808400183"/>
        <attempts timestamp="1488808400718"/>
        <attempts timestamp="1488808401083"/>
        <attempts timestamp="1488808401502"/>
        <attempts timestamp="1488808402410"/>
        <attempts timestamp="1488808402826"/>
        <attempts timestamp="1488808403406"/>
        <attempts timestamp="1488808403894"/>
        <attempts timestamp="1488808404369"/>
        <attempts timestamp="1488808404941"/>
        <attempts timestamp="1488808406030"/>
        <attempts timestamp="1488808406619"/>
        <attempts timestamp="1488808407778"/>
        <attempts timestamp="1488808408337"/>
        <attempts timestamp="1488808409014"/>
        <attempts timestamp="1488808409673"/>
        <attempts timestamp="1488808410311"/>
        <attempts timestamp="1488808410926"/>
        <attempts timestamp="1488808411100"/>
        <attempts timestamp="1488808411437"/>
        <attempts timestamp="1488808411879"/>
        <attempts timestamp="1488808412077"/>
        <attempts timestamp="1488808412319"/>
        <attempts timestamp="1488808412653"/>
        <attempts timestamp="1488808412844"/>
        <attempts timestamp="1488808412982"/>
        <attempts timestamp="1488808413179"/>
        <attempts timestamp="1488808413375"/>
        <attempts timestamp="1488808413747"/>
        <attempts timestamp="1488808414469"/>
        <attempts timestamp="1488808414888"/>
        <attempts timestamp="1488808415265"/>
        <attempts timestamp="1488808415698"/>
        <attempts timestamp="1488808415975"/>
        <attempts timestamp="1488808416111"/>
        <attempts timestamp="1488808416275"/>
        <attempts timestamp="1488808416453"/>
        <attempts timestamp="1488808416640"/>
        <attempts timestamp="1488808416818"/>
        <attempts timestamp="1488808416996"/>
        <attempts timestamp="1488808417168"/>
        <attempts timestamp="1488808417354"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="20">
        <attempts timestamp="1488805476155"/>
        <attempts timestamp="1488805839679"/>
        <attempts timestamp="1488806109172"/>
        <attempts timestamp="1488806228356"/>
        <attempts timestamp="1488806285674"/>
        <attempts timestamp="1488806399291"/>
        <attempts timestamp="1488806501721"/>
        <attempts timestamp="1488806589528"/>
        <attempts timestamp="1488806621279"/>
        <attempts timestamp="1488806687509"/>
        <attempts timestamp="1488806727821"/>
        <attempts timestamp="1488807406798"/>
        <attempts timestamp="1488807460055"/>
        <attempts timestamp="1488807518094"/>
        <attempts timestamp="1488807532877"/>
        <attempts timestamp="1488807667999"/>
        <attempts timestamp="1488807688200"/>
        <attempts timestamp="1488807832786"/>
        <attempts timestamp="1488808067002"/>
        <attempts timestamp="1488808393258"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
