<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="StringMergingIterator">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Modify the code for the StringMergingIterator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIterator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIterator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StringMergingIteratorProgram class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="debugging.StringMergingIteratorProgram"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="debugging.StringMergingIterator*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488890484026" sizeMeasure="52">
          <edit xsi:type="exercise:StringEdit" storedString="package debugging;&#xA;&#xA;import java.util.Iterator;&#xA;import java.util.NoSuchElementException;&#xA;&#xA;public class StringMergingIterator implements Iterator&lt;String> {&#xA;&#xA;&#x9;private Iterator&lt;String> first;&#xA;&#x9;private Iterator&lt;String> second;&#xA;&#x9;private boolean turnSwitch;&#xA;&#xA;&#x9;public StringMergingIterator(Iterator&lt;String> first, Iterator&lt;String> second){&#xA;&#x9;&#x9;this.first = first;&#xA;&#x9;&#x9;this.second = second;&#xA;&#x9;&#x9;this.turnSwitch = true;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public boolean hasNext() {&#xA;&#x9;&#x9;return first.hasNext() || second.hasNext();&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public String next() {&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! hasNext()){ throw new NoSuchElementException(); }&#xA;&#xA;&#x9;&#x9;String result = null;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if(! first.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else {&#xA;&#x9;&#x9;&#x9;if(turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = first.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = false;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;if(!turnSwitch){&#xA;&#x9;&#x9;&#x9;&#x9;result = second.next();&#xA;&#x9;&#x9;&#x9;&#x9;turnSwitch = true;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return result;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488892268188" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="second.next();&#xA;&#x9;&#x9;} &#xA;&#x9;&#x9;else if(! second.hasNext()){&#xA;&#x9;&#x9;&#x9;result = first" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="657" end="-212"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488893467509" sizeMeasure="52">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="else " edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="826" end="-111"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890667867" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890678811" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890754996" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488890949439" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891044118" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488891774015" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488892266986" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488892300338" mode="debug"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488892323076" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1488892334329" mode="run"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="30">
        <attempts timestamp="1488890680099"/>
        <attempts timestamp="1488890756335"/>
        <attempts timestamp="1488890785100"/>
        <attempts timestamp="1488890914458"/>
        <attempts timestamp="1488890937935"/>
        <attempts timestamp="1488890939507"/>
        <attempts timestamp="1488890940449"/>
        <attempts timestamp="1488890951260"/>
        <attempts timestamp="1488890961122"/>
        <attempts timestamp="1488890984850"/>
        <attempts timestamp="1488890986652"/>
        <attempts timestamp="1488891000438"/>
        <attempts timestamp="1488891003462"/>
        <attempts timestamp="1488891004583"/>
        <attempts timestamp="1488891005224"/>
        <attempts timestamp="1488891045141"/>
        <attempts timestamp="1488891086089"/>
        <attempts timestamp="1488891114872"/>
        <attempts timestamp="1488891118844"/>
        <attempts timestamp="1488891360090"/>
        <attempts timestamp="1488891368047"/>
        <attempts timestamp="1488891370660"/>
        <attempts timestamp="1488891371702"/>
        <attempts timestamp="1488891775176"/>
        <attempts timestamp="1488891846906"/>
        <attempts timestamp="1488892028348"/>
        <attempts timestamp="1488892250877"/>
        <attempts timestamp="1488892269739"/>
        <attempts timestamp="1488892301553"/>
        <attempts timestamp="1488892679982"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="66">
        <attempts timestamp="1488890799688"/>
        <attempts timestamp="1488890800968"/>
        <attempts timestamp="1488890803132"/>
        <attempts timestamp="1488890803903"/>
        <attempts timestamp="1488890804563"/>
        <attempts timestamp="1488890805204"/>
        <attempts timestamp="1488890805804"/>
        <attempts timestamp="1488890806406"/>
        <attempts timestamp="1488890807056"/>
        <attempts timestamp="1488890807736"/>
        <attempts timestamp="1488890959159"/>
        <attempts timestamp="1488890961121"/>
        <attempts timestamp="1488890963624"/>
        <attempts timestamp="1488890968100"/>
        <attempts timestamp="1488890970412"/>
        <attempts timestamp="1488890971073"/>
        <attempts timestamp="1488890981915"/>
        <attempts timestamp="1488890983136"/>
        <attempts timestamp="1488890983976"/>
        <attempts timestamp="1488890984849"/>
        <attempts timestamp="1488890985589"/>
        <attempts timestamp="1488890986651"/>
        <attempts timestamp="1488890987682"/>
        <attempts timestamp="1488890989064"/>
        <attempts timestamp="1488890989515"/>
        <attempts timestamp="1488890989705"/>
        <attempts timestamp="1488890990015"/>
        <attempts timestamp="1488890990206"/>
        <attempts timestamp="1488890991396"/>
        <attempts timestamp="1488890992878"/>
        <attempts timestamp="1488890993850"/>
        <attempts timestamp="1488890998084"/>
        <attempts timestamp="1488890999526"/>
        <attempts timestamp="1488891000437"/>
        <attempts timestamp="1488891002750"/>
        <attempts timestamp="1488891003461"/>
        <attempts timestamp="1488891004582"/>
        <attempts timestamp="1488891005223"/>
        <attempts timestamp="1488891007052"/>
        <attempts timestamp="1488891008077"/>
        <attempts timestamp="1488891352568"/>
        <attempts timestamp="1488891353861"/>
        <attempts timestamp="1488891354111"/>
        <attempts timestamp="1488891359207"/>
        <attempts timestamp="1488891360089"/>
        <attempts timestamp="1488891794612"/>
        <attempts timestamp="1488891845761"/>
        <attempts timestamp="1488891846905"/>
        <attempts timestamp="1488892028347"/>
        <attempts timestamp="1488892034522"/>
        <attempts timestamp="1488892037955"/>
        <attempts timestamp="1488892038997"/>
        <attempts timestamp="1488892086736"/>
        <attempts timestamp="1488892091881"/>
        <attempts timestamp="1488892095865"/>
        <attempts timestamp="1488892108328"/>
        <attempts timestamp="1488892109669"/>
        <attempts timestamp="1488892747361"/>
        <attempts timestamp="1488892756468"/>
        <attempts timestamp="1488892821401"/>
        <attempts timestamp="1488892897265"/>
        <attempts timestamp="1488892903520"/>
        <attempts timestamp="1488892907574"/>
        <attempts timestamp="1488893650725"/>
        <attempts timestamp="1488893651636"/>
        <attempts timestamp="1488893655988"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="41">
        <attempts timestamp="1488890933879"/>
        <attempts timestamp="1488890935722"/>
        <attempts timestamp="1488890936943"/>
        <attempts timestamp="1488890937934"/>
        <attempts timestamp="1488890939506"/>
        <attempts timestamp="1488890940447"/>
        <attempts timestamp="1488890941968"/>
        <attempts timestamp="1488890943040"/>
        <attempts timestamp="1488891077703"/>
        <attempts timestamp="1488891081097"/>
        <attempts timestamp="1488891085218"/>
        <attempts timestamp="1488891086087"/>
        <attempts timestamp="1488891087521"/>
        <attempts timestamp="1488891088044"/>
        <attempts timestamp="1488891088440"/>
        <attempts timestamp="1488891088923"/>
        <attempts timestamp="1488891089464"/>
        <attempts timestamp="1488891089875"/>
        <attempts timestamp="1488891090309"/>
        <attempts timestamp="1488891100985"/>
        <attempts timestamp="1488891102530"/>
        <attempts timestamp="1488891111172"/>
        <attempts timestamp="1488891111743"/>
        <attempts timestamp="1488891113360"/>
        <attempts timestamp="1488891114167"/>
        <attempts timestamp="1488891114870"/>
        <attempts timestamp="1488891116252"/>
        <attempts timestamp="1488891117179"/>
        <attempts timestamp="1488891118108"/>
        <attempts timestamp="1488891118843"/>
        <attempts timestamp="1488891119813"/>
        <attempts timestamp="1488891120440"/>
        <attempts timestamp="1488891120648"/>
        <attempts timestamp="1488891121359"/>
        <attempts timestamp="1488891124798"/>
        <attempts timestamp="1488891125757"/>
        <attempts timestamp="1488891126279"/>
        <attempts timestamp="1488891370659"/>
        <attempts timestamp="1488891371701"/>
        <attempts timestamp="1488891373109"/>
        <attempts timestamp="1488891781307"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a" performedCount="23">
        <attempts timestamp="1488890769712"/>
        <attempts timestamp="1488890769712"/>
        <attempts timestamp="1488890919704"/>
        <attempts timestamp="1488891094650"/>
        <attempts timestamp="1488891376032"/>
        <attempts timestamp="1488891784092"/>
        <attempts timestamp="1488891797763"/>
        <attempts timestamp="1488891848794"/>
        <attempts timestamp="1488891876860"/>
        <attempts timestamp="1488892758395"/>
        <attempts timestamp="1488892785893"/>
        <attempts timestamp="1488892791794"/>
        <attempts timestamp="1488892793795"/>
        <attempts timestamp="1488892797903"/>
        <attempts timestamp="1488892798532"/>
        <attempts timestamp="1488892799240"/>
        <attempts timestamp="1488892800793"/>
        <attempts timestamp="1488892800972"/>
        <attempts timestamp="1488892801315"/>
        <attempts timestamp="1488892804342"/>
        <attempts timestamp="1488892806129"/>
        <attempts timestamp="1488892807364"/>
        <attempts timestamp="1488892826078"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
