<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="CardContainer">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardComparator class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Card class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardComparator class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="interfaces.CardComparator"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardComparatorTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="interfaces.CardComparatorTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="interfaces.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488736919605" sizeMeasure="49" errorCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package interfaces;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private int face;&#xA;&#x9;private char suit;&#xA;&#x9;&#xA;&#x9;public Card(char newSuit, int newFace) {&#xA;&#x9;&#x9;if (checkFace(newFace)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Face must be between 1 and 13.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (checkSuit(newSuit)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Suit must be either 'S', 'H', 'D' or 'C'.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.face = newFace;&#xA;&#x9;&#x9;this.suit = Character.toUpperCase(newSuit);&#xA;&#x9;}&#xA;&#xA;&#x9;public static boolean checkFace(int face) {&#xA;&#x9;&#x9;return !(face>=1 &amp;&amp; face&lt;=13);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static boolean checkSuit(char suit) {&#xA;&#x9;&#x9;suit = Character.toUpperCase(suit);&#xA;&#x9;&#x9;return !(suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C');&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;public char getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;&#x9;/* (non-Javadoc)&#xA;&#x9; * @see java.lang.Object#toString()&#xA;&#x9; */&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(suit) + Integer.toString(face);&#xA;&#x9;}&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('c',10);&#xA;&#x9;&#x9;System.out.println(card.toString());&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="3" charStart="36" charEnd="40" severity="2" problemCategory="50" problemType="67109264"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488736970004" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@Override&#xA;&#x9;public int compareTo(Card arg0) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;return 0;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;/* (non-Javadoc)&#xA; * @see java.lang.Object#toString()&#xA; */&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(suit) + Integer.toString(face);&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card = new Card('c',10);&#xA;&#x9;&#x9;System.out.println(card.toString());&#xA;&#x9;}&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="783" end="-5"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488736973462" sizeMeasure="59">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9; * @see java.lang.Object#toString()&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="901" end="-231"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488737235845" sizeMeasure="56">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;/* (non-Javadoc)&#xA;&#x9; * @see java.lang.Object#toString()&#xA;&#x9; */&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return Character.toString(suit) + Integer.toString(face);&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="880" end="-124"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488738041907" sizeMeasure="71" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card) {&#xA;&#x9;&#x9;char[] suitOrder = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#x9;if (card.getSuit() == 'S' &amp;&amp; this.suit != 'S') {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (card.getSuit() == 'H' &amp;&amp; this.suit != 'H') {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (card.getSuit() == 'D' &amp;&amp; this.suit != 'D') {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (card.getSuit())&#xA;&#x9;&#x9;if (card.getSuit() == this.suit) {&#xA;&#x9;&#x9;&#x9;if (card.getFace() > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (card.getFace() &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;} " edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="820" end="-287"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1137" charEnd="1151" severity="2" problemCategory="40" problemType="16777233"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488738185110" sizeMeasure="65" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;char> suitOrder = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="830" end="-493"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="877" charEnd="881" severity="2" problemCategory="20" problemType="1610612976"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488738459261" sizeMeasure="65" errorCount="4">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Suit" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="99" end="-1272"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="16" charStart="432" charEnd="462" severity="2" problemCategory="40" problemType="16777233"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="804" charEnd="808" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="877" charEnd="881" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1263" charEnd="1271" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488738614367" sizeMeasure="65" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="new Suit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="417" end="-937"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="791" charEnd="795" severity="2" problemCategory="40" problemType="16777235"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="864" charEnd="868" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1250" charEnd="1258" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488738627468" sizeMeasure="65" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Suit" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="733" end="-625"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="38" charStart="864" charEnd="868" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1250" charEnd="1258" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488738747227" sizeMeasure="74" errorCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="int cardSuitWeight = card.getSuit().getWeight();&#xA;&#x9;&#x9;int thisCardSuitWeight = this.suit.getWeight();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (card.getSuit() == this.suit) {&#xA;&#x9;&#x9;&#x9;if (card.getFace() > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (card.getFace() &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (cardSuitWeight > thisCardSuitWeight) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (cardSuitWeight &lt; thisCardSuitWeight) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;return 0;&#xA;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="817" end="-298"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="828" charEnd="848" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="50" charStart="1152" charEnd="1307" severity="2" problemCategory="60" problemType="536871073"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="65" charStart="1444" charEnd="1452" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488738800721" sizeMeasure="70" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="SuitWeight > thisCardSuitWeight) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (cardSuitWeight &lt; thisCardSuitWeight) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (card.getFace() > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (card.getFace() &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="929" end="-298"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="61" charStart="1383" charEnd="1391" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488738921513" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suit.toString() + &quot; | Face: &quot; + face" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1313" end="-128"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739174401" sizeMeasure="75" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class Card implements Comparable&lt;Card> {&#xA;&#x9;&#xA;&#x9;private int face;&#xA;&#x9;private Suit suit;&#xA;&#x9;&#xA;&#x9;public Card(char newSuit, int newFace) {&#xA;&#x9;&#x9;if (checkFace(newFace)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Face must be between 1 and 13.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else if (checkSuit(newSuit)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Suit must be either 'S', 'H', 'D' or 'C'.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.face = newFace;&#xA;&#x9;&#x9;this.suit = new Suit(newSuit);&#xA;&#x9;}&#xA;&#xA;&#x9;public static boolean checkFace(int face) {&#xA;&#x9;&#x9;return !(face>=1 &amp;&amp; face&lt;=13);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static boolean checkSuit(char suit) {&#xA;&#x9;&#x9;suit = Character.toUpperCase(suit);&#xA;&#x9;&#x9;return !(suit == 'S' || suit == 'H' || suit == 'D' || suit == 'C');&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getFace() {&#xA;&#x9;&#x9;return face;&#xA;&#x9;}&#xA;&#xA;&#x9;public Suit getSuit() {&#xA;&#x9;&#x9;return suit;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public int compareTo(Card card) {&#xA;&#x9;&#x9;int cardSuitWeight = card.getSuit().getWeight();&#xA;&#x9;&#x9;int thisCardSuitWeight = this.suit.getWeight();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;if (cardSuitWeight > thisCardSuitWeight) {&#xA;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;} else if (cardSuitWeight &lt; thisCardSuitWeight) {&#xA;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;if (card.getFace() > this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return -1;&#xA;&#x9;&#x9;&#x9;} else if (card.getFace() &lt; this.face) {&#xA;&#x9;&#x9;&#x9;&#x9;return 1;&#xA;&#x9;&#x9;&#x9;} else { &#xA;&#x9;&#x9;&#x9;&#x9;return 0;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;} &#xA;&#xA;&#x9;/* (non-Javadoc)&#xA;&#x9; * @see java.lang.Object#toString()&#xA;&#x9; */&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return suit.toString() + &quot; | Face: &quot; + face;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Card card1 = new Card('C',10);&#xA;&#x9;&#x9;Card card2 = new Card('S', 2);&#xA;&#x9;&#x9;ArrayList&lt;Card> cardList = new ArrayList&lt;>();&#xA;&#x9;&#x9;cardList.sort(" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="21" end="-50"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1651" charEnd="1655" severity="2" problemCategory="50" problemType="570425394"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1621" charEnd="1625" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739192031" sizeMeasure="75" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="1557" end="-50"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1626" charEnd="1630" severity="2" problemCategory="60" problemType="536871112"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1655" charEnd="1659" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488739199228" sizeMeasure="75" errorCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="card1" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1557" end="-50"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="70" charStart="1631" charEnd="1631" severity="2" problemCategory="60" problemType="536871112"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="71" charStart="1656" charEnd="1660" severity="2" problemCategory="50" problemType="570425394"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488805978607" completion="1.0" successCount="3">
          <successTests>testAceIsHighest</successTests>
          <successTests>testDiamondIsTrumph</successTests>
          <successTests>testNormal</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
